//-------------------------------------------------------------------
//
//   This file is automatically generated by VHDL to Verilog Translator.
//               www.sugawara-systems.com   
//                  Ver.1.01 Build Jan.30.2004
//                    tech-support@sugawara-systems.com
//        See Original Copyright Notice for property of the file .( somewhere in this file.)
//
//--------------------------------------------------------------------


//
// Z80 compatible microprocessor core, asynchronous top level
//
// Version : 0247
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0208 : First complete release
//
//	0211 : Fixed interrupt cycle
//
//	0235 : Updated for T80 interface change
//
//	0238 : Updated for T80 interface change
//
//	0240 : Updated for T80 interface change
//
//	0242 : Updated for T80 interface change
//
//	0247 : Fixed bus req/ack cycle
//

`timescale 1ns/1ns
`define ns 1
`define us (1000*`ns)
`define ms (1000*`us)
`define sec (1000*`ms)

module  t80a ( reset_n, clk_n, wait_n, int_n, nmi_n, busrq_n, m1_n, mreq_n, iorq_n, rd_n, wr_n, rfsh_n, halt_n, busak_n, a, d );
    parameter  [31:0]  mode =0;
    
    input reset_n;
    input clk_n;
    input wait_n;
    input int_n;
    input nmi_n;
    input busrq_n;
    output m1_n;
    output mreq_n;
    output iorq_n;
    output rd_n;
    output wr_n;
    output rfsh_n;
    output halt_n;
    output busak_n;
    output [15:0]  a ;
    inout [7:0]  d ;


    wire cen;
    reg reset_s;
    wire intcycle_n;
    wire iorq;
    wire noread;
    wire write;
    reg mreq;
    reg mreq_inhibit;
    reg req_inhibit;
    reg rd;
    wire mreq_n_i;
    reg iorq_n_i;
    wire rd_n_i;
    reg wr_n_i;
    wire rfsh_n_i;
    wire busak_n_i;
    wire [15:0] a_i;
    wire [7:0] do;
    reg [7:0] di_reg;
    reg wait_s;
    wire [2:0] mcycle;
    wire [2:0] tstate;
    wire m1_n;
    wire mreq_n;
    wire iorq_n;
    wire rd_n;
    wire wr_n;
    wire rfsh_n;
    wire halt_n;
    wire busak_n;
    wire [15:0] a;
    wire [7:0] d;


    
   assign {cen}=1'b1;
   
   assign {busak_n}=busak_n_i;
   
   assign {mreq_n_i}=(~ (mreq) | (req_inhibit & mreq_inhibit));
   
   assign {rd_n_i}=(~ (rd) | req_inhibit);
   
   assign {mreq_n}=(busak_n_i === 1'b1) ? 
                       mreq_n_i
                    :  1'bz;
   
   assign {iorq_n}=(busak_n_i === 1'b1) ? 
                       iorq_n_i
                    :  1'bz;
   
   assign {rd_n}=(busak_n_i === 1'b1) ? 
                     rd_n_i
                  :  1'bz;
   
   assign {wr_n}=(busak_n_i === 1'b1) ? 
                     wr_n_i
                  :  1'bz;
   
   assign {rfsh_n}=(busak_n_i === 1'b1) ? 
                       rfsh_n_i
                    :  1'bz;
   
   assign {a}=(busak_n_i === 1'b1) ? 
                  a_i
               :  {(15-0+1- 0){1'bz}};
   
   assign {d}=((write === 1'b1) & (busak_n_i === 1'b1)) ? 
                  do
               :  {(7-0+1- 0){1'bz}};
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               reset_s <= 1'b0;
               
           else 
               reset_s <= 1'b1;
               
           
   end //always
   
   t80  #(mode,1,0,1,2,3,4,5,6,7) u0(.reset_n(reset_s), .clk_n(clk_n), .cen(cen), .wait_n(wait_s), .int_n(int_n), .nmi_n(nmi_n), .busrq_n(busrq_n), .m1_n(m1_n), .iorq(iorq), .noread(noread), .write(write), .rfsh_n(rfsh_n_i), .halt_n(halt_n), .busak_n(busak_n_i), .a(a_i), .dinst(d), .di(di_reg), .do(do), .mc(mcycle), .ts(tstate), .intcycle_n(intcycle_n), .inte(/*open */), .stop(/*open */));
   //Parameter Order: mode,iowait,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s 

       
   always @ (negedge clk_n ) begin
               begin 
                   wait_s <= wait_n;
                   if (((tstate === 'b011) & (busak_n_i === 1'b1))) 
                       di_reg <= d;
                       
                   
                   
               end
               
           
   end //always
   
       
   always @ (negedge reset_s or posedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               wr_n_i <= 1'b1;
               
           else 
               begin 
                   wr_n_i <= 1'b1;
                   if ((tstate === 'b001)) 
                       wr_n_i <= ~ (write);
                       
                   
                   
               end
               
           
   end //always
   
       
   always @ (negedge reset_s or posedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               req_inhibit <= 1'b0;
               
           else 
               begin 
                   if (((mcycle === 'b001) & (tstate === 'b010))) 
                       req_inhibit <= 1'b1;
                       
                   else 
                       req_inhibit <= 1'b0;
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_s or negedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               mreq_inhibit <= 1'b0;
               
           else 
               begin 
                   if (((mcycle === 'b001) & (tstate === 'b010))) 
                       mreq_inhibit <= 1'b1;
                       
                   else 
                       mreq_inhibit <= 1'b0;
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_s or negedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               begin 
                   rd <= 1'b0;
                   iorq_n_i <= 1'b1;
                   mreq <= 1'b0;
               end
               
           else 
               begin 
                   if ((mcycle === 'b001)) 
                       begin 
                           begin 
                               if ((tstate === 'b001)) 
                                   begin 
                                       rd <= intcycle_n;
                                       mreq <= intcycle_n;
                                       iorq_n_i <= intcycle_n;
                                   end

                               if ((tstate === 'b011)) 
                                   begin 
                                       rd <= 1'b0;
                                       iorq_n_i <= 1'b1;
                                       mreq <= 1'b1;
                                   end

                               if ((tstate === 'b100)) 
                                       mreq <= 1'b0;

                               
                           end
                       end 
                   else 
                       begin 
                           begin 
                               if (((tstate === 'b001) & (noread === 1'b0))) 
                                   begin 
                                       rd <= ~ (write);
                                       iorq_n_i <= ~ (iorq);
                                       mreq <= ~ (iorq);
                                   end

                               if ((tstate === 'b011)) 
                                   begin 
                                       rd <= 1'b0;
                                       iorq_n_i <= 1'b1;
                                       mreq <= 1'b0;
                                   end

                               
                           end
                       end 
                   
                   
               end 
           
   end //always
    

endmodule
//
// T80 Registers, technology independent
//
// Version : 0244
//
// Copyright (c) 2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//
//	0242 : Initial release
//
//	0244 : Changed to single register file
//


module  t80_reg ( clk, cen, weh, wel, addra, addrb, addrc, dih, dil, doah, doal, dobh, dobl, doch, docl );
    
    input clk;
    input cen;
    input weh;
    input wel;
    input [2:0]  addra ;
    input [2:0]  addrb ;
    input [2:0]  addrc ;
    input [7:0]  dih ;
    input [7:0]  dil ;
    output [7:0]  doah ;
    output [7:0]  doal ;
    output [7:0]  dobh ;
    output [7:0]  dobl ;
    output [7:0]  doch ;
    output [7:0]  docl ;


//type register_image

reg [7:0] regsh [0:7];
reg [7:0] regsl [0:7];
    wire [7:0] doah;
    wire [7:0] doal;
    wire [7:0] dobh;
    wire [7:0] dobl;
    wire [7:0] doch;
    wire [7:0] docl;


    
       
   always @ (posedge clk ) begin
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                           begin 
                               if ((weh === 1'b1)) 
                                       regsh[$unsigned(addra)] <= dih;

                               if ((wel === 1'b1)) 
                                       regsl[$unsigned(addra)] <= dil;

                               
                           end
                       end 
                   
                   
               end 
           
   end //always
   
   assign {doah}=regsh[$unsigned(addra)];
   
   assign {doal}=regsl[$unsigned(addra)];
   
   assign {dobh}=regsh[$unsigned(addrb)];
   
   assign {dobl}=regsl[$unsigned(addrb)];
   
   assign {doch}=regsh[$unsigned(addrc)];
   
   assign {docl}=regsl[$unsigned(addrc)];
    

endmodule
//
// Z80 compatible microprocessor core
//
// Version : 0242
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//

//
// Z80 compatible microprocessor core
//
// Version : 0242
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0208 : First complete release
//
//	0211 : Fixed IM 1
//
//	0214 : Fixed mostly flags, only the block instructions now fail the zex regression test
//
//	0235 : Added IM 2 fix by Mike Johnson
//
//	0238 : Added NoRead signal
//
//	0238b: Fixed instruction timing for POP and DJNZ
//
//	0240 : Added (IX/IY+d) states, removed op-codes from mode 2 and added all remaining mode 3 op-codes
//
//	0242 : Fixed I/O instruction timing, cleanup
//


module  t80_mcode ( ir, iset, mcycle, f, nmicycle, intcycle, mcycles, tstates, prefix, inc_pc, inc_wz, incdec_16, read_to_reg, read_to_acc, set_busa_to, set_busb_to, alu_op, save_alu, preservec, arith16, set_addr_to, iorq, jump, jumpe, jumpxy, call, rstp, ldz, ldw, ldsphl, special_ld, exchangedh, exchangerp, exchangeaf, exchangers, i_djnz, i_cpl, i_ccf, i_scf, i_retn, i_bt, i_bc, i_btr, i_rld, i_rrd, i_inrc, setdi, setei, imode, halt, noread, write );
    parameter  [31:0]  mode =0;
    parameter  [31:0]  flag_c =0;
    parameter  [31:0]  flag_n =1;
    parameter  [31:0]  flag_p =2;
    parameter  [31:0]  flag_x =3;
    parameter  [31:0]  flag_h =4;
    parameter  [31:0]  flag_y =5;
    parameter  [31:0]  flag_z =6;
    parameter  [31:0]  flag_s =7;
    
    input [7:0]  ir ;
    input [1:0]  iset ;
    input [2:0]  mcycle ;
    input [7:0]  f ;
    input nmicycle;
    input intcycle;
    output [2:0]  mcycles ;
    output [2:0]  tstates ;
    output [1:0]  prefix ;
    output inc_pc;
    output inc_wz;
    output [3:0]  incdec_16 ;
    output read_to_reg;
    output read_to_acc;
    output [3:0]  set_busa_to ;
    output [3:0]  set_busb_to ;
    output [3:0]  alu_op ;
    output save_alu;
    output preservec;
    output arith16;
    output [2:0]  set_addr_to ;
    output iorq;
    output jump;
    output jumpe;
    output jumpxy;
    output call;
    output rstp;
    output ldz;
    output ldw;
    output ldsphl;
    output [2:0]  special_ld ;
    output exchangedh;
    output exchangerp;
    output exchangeaf;
    output exchangers;
    output i_djnz;
    output i_cpl;
    output i_ccf;
    output i_scf;
    output i_retn;
    output i_bt;
    output i_bc;
    output i_btr;
    output i_rld;
    output i_rrd;
    output i_inrc;
    output setdi;
    output setei;
    output [1:0]  imode ;
    output halt;
    output noread;
    output write;


    reg [2:0] Process1__ddd;
    reg [2:0] Process2__sss;
    reg [1:0] Process3__dpair;
    reg [7:0] Process4__irb=0;
    parameter [2:0] anone='b111;
    parameter [2:0] abc='b000;
    parameter [2:0] ade='b001;
    parameter [2:0] axy='b010;
    parameter [2:0] aioa='b100;
    parameter [2:0] asp='b101;
    parameter [2:0] azi='b110;
    reg [2:0] mcycles;
    reg [2:0] tstates;
    reg [1:0] prefix;
    reg inc_pc;
    reg inc_wz;
    reg [3:0] incdec_16;
    reg read_to_reg;
    reg read_to_acc;
    reg [3:0] set_busa_to;
    reg [3:0] set_busb_to;
    reg [3:0] alu_op;
    reg save_alu;
    reg preservec;
    reg arith16;
    reg [2:0] set_addr_to;
    reg iorq;
    reg jump;
    reg jumpe;
    reg jumpxy;
    reg call;
    reg rstp;
    reg ldz;
    reg ldw;
    reg ldsphl;
    reg [2:0] special_ld;
    reg exchangedh;
    reg exchangerp;
    reg exchangeaf;
    reg exchangers;
    reg i_djnz;
    reg i_cpl;
    reg i_ccf;
    reg i_scf;
    reg i_retn;
    reg i_bt;
    reg i_bc;
    reg i_btr;
    reg i_rld;
    reg i_rrd;
    reg i_inrc;
    reg setdi;
    reg setei;
    reg [1:0] imode;
    reg halt;
    reg noread;
    reg write;


    
       
   always @ (ir or iset or mcycle or f or nmicycle or intcycle ) begin
           Process1__ddd = ir[5:3];
           Process2__sss = ir[2:0];
           Process3__dpair = ir[5:4];
           Process4__irb = ir;
           mcycles <= 'b001;
           if ((mcycle === 'b001)) 
               tstates <= 'b100;
               
           else 
               tstates <= 'b011;
               
           prefix <= 'b00;
           inc_pc <= 1'b0;
           inc_wz <= 1'b0;
           incdec_16 <= 'b0000;
           read_to_acc <= 1'b0;
           read_to_reg <= 1'b0;
           set_busb_to <= 'b0000;
           set_busa_to <= 'b0000;
           alu_op <= {'b0,ir[5:3]};
           save_alu <= 1'b0;
           preservec <= 1'b0;
           arith16 <= 1'b0;
           iorq <= 1'b0;
           set_addr_to <= 'b111;
           jump <= 1'b0;
           jumpe <= 1'b0;
           jumpxy <= 1'b0;
           call <= 1'b0;
           rstp <= 1'b0;
           ldz <= 1'b0;
           ldw <= 1'b0;
           ldsphl <= 1'b0;
           special_ld <= 'b000;
           exchangedh <= 1'b0;
           exchangerp <= 1'b0;
           exchangeaf <= 1'b0;
           exchangers <= 1'b0;
           i_djnz <= 1'b0;
           i_cpl <= 1'b0;
           i_ccf <= 1'b0;
           i_scf <= 1'b0;
           i_retn <= 1'b0;
           i_bt <= 1'b0;
           i_bc <= 1'b0;
           i_btr <= 1'b0;
           i_rld <= 1'b0;
           i_rrd <= 1'b0;
           i_inrc <= 1'b0;
           setdi <= 1'b0;
           setei <= 1'b0;
           imode <= 'b11;
           halt <= 1'b0;
           noread <= 1'b0;
           write <= 1'b0;
           case (iset)
               'b00 : 
                       case (Process4__irb)
                           'b01000000,'b01000001,'b01000010,'b01000011,'b01000100,'b01000101,'b01000111,'b01001000,'b01001001,'b01001010,'b01001011,'b01001100,'b01001101,'b01001111,'b01010000,'b01010001,'b01010010,'b01010011,'b01010100,'b01010101,'b01010111,'b01011000,'b01011001,'b01011010,'b01011011,'b01011100,'b01011101,'b01011111,'b01100000,'b01100001,'b01100010,'b01100011,'b01100100,'b01100101,'b01100111,'b01101000,'b01101001,'b01101010,'b01101011,'b01101100,'b01101101,'b01101111,'b01111000,'b01111001,'b01111010,'b01111011,'b01111100,'b01111101,'b01111111 : 
                               begin 
                                   set_busb_to[2:0] <= Process2__sss;
                                   exchangerp <= 1'b1;
                                   set_busa_to[2:0] <= Process1__ddd;
                                   read_to_reg <= 1'b1;
                               end
                           'b00000110,'b00001110,'b00010110,'b00011110,'b00100110,'b00101110,'b00111110 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               set_busa_to[2:0] <= Process1__ddd;
                                               read_to_reg <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b01000110,'b01001110,'b01010110,'b01011110,'b01100110,'b01101110,'b01111110 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b010;
                                       2 : begin 
                                               set_busa_to[2:0] <= Process1__ddd;
                                               read_to_reg <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b01110000,'b01110001,'b01110010,'b01110011,'b01110100,'b01110101,'b01110111 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b010;
                                               set_busb_to[2:0] <= Process2__sss;
                                               set_busb_to[3] <= 1'b0;
                                           end
                                       2 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00110110 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               set_addr_to <= 'b010;
                                               set_busb_to[2:0] <= Process2__sss;
                                               set_busb_to[3] <= 1'b0;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00001010 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b000;
                                       2 :     read_to_acc <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00011010 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b001;
                                       2 :     read_to_acc <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00111010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 'b010;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 'b010;
                                               2 : begin 
                                                       read_to_acc <= 1'b1;
                                                       incdec_16 <= 'b1110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 'b100;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 'b110;
                                                       inc_pc <= 1'b1;
                                                   end
                                               4 :     read_to_acc <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00000010 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b000;
                                               set_busb_to <= 'b0111;
                                           end
                                       2 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00010010 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b001;
                                               set_busb_to <= 'b0111;
                                           end
                                       2 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00110010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 'b010;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       set_addr_to <= 'b010;
                                                       set_busb_to <= 'b0111;
                                                   end
                                               2 : begin 
                                                       write <= 1'b1;
                                                       incdec_16 <= 'b1110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 'b100;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 'b110;
                                                       inc_pc <= 1'b1;
                                                       set_busb_to <= 'b0111;
                                                   end
                                               4 :     write <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00000001,'b00010001,'b00100001,'b00110001 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 'b11)) 
                                                       set_busa_to[3:0] <= 'b1000;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b1;
                                                   end

                                               
                                           end
                                       3 : begin 
                                               inc_pc <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 'b11)) 
                                                       set_busa_to[3:0] <= 'b1001;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b0;
                                                   end

                                               
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00101010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 'b010;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 'b010;
                                               2 : begin 
                                                       read_to_acc <= 1'b1;
                                                       incdec_16 <= 'b0110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 'b110;
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                   end
                                               4 : begin 
                                                       set_busa_to[2:0] <= 'b101;
                                                       read_to_reg <= 1'b1;
                                                       inc_wz <= 1'b1;
                                                       set_addr_to <= 'b110;
                                                   end
                                               5 : begin 
                                                       set_busa_to[2:0] <= 'b100;
                                                       read_to_reg <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00100010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 'b010;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       set_addr_to <= 'b010;
                                                       set_busb_to <= 'b0111;
                                                   end
                                               2 : begin 
                                                       write <= 1'b1;
                                                       incdec_16 <= 'b0110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 'b110;
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                       set_busb_to <= 'b0101;
                                                   end
                                               4 : begin 
                                                       inc_wz <= 1'b1;
                                                       set_addr_to <= 'b110;
                                                       write <= 1'b1;
                                                       set_busb_to <= 'b0100;
                                                   end
                                               5 :     write <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11111001 : 
                               begin 
                                   tstates <= 'b110;
                                   ldsphl <= 1'b1;
                               end
                           'b11000101,'b11010101,'b11100101,'b11110101 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 'b101;
                                               incdec_16 <= 'b1111;
                                               set_addr_to <= 'b101;
                                               if ((Process3__dpair === 'b11)) 
                                                       set_busb_to <= 'b0111;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= Process3__dpair;
                                                       set_busb_to[0] <= 1'b0;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               
                                           end
                                       2 : begin 
                                               incdec_16 <= 'b1111;
                                               set_addr_to <= 'b101;
                                               if ((Process3__dpair === 'b11)) 
                                                       set_busb_to <= 'b1011;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= Process3__dpair;
                                                       set_busb_to[0] <= 1'b1;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               write <= 1'b1;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11000001,'b11010001,'b11100001,'b11110001 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b101;
                                       2 : begin 
                                               incdec_16 <= 'b0111;
                                               set_addr_to <= 'b101;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 'b11)) 
                                                       set_busa_to[3:0] <= 'b1011;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b1;
                                                   end

                                               
                                           end
                                       3 : begin 
                                               incdec_16 <= 'b0111;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 'b11)) 
                                                       set_busa_to[3:0] <= 'b0111;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b0;
                                                   end

                                               
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11101011 : 
                                   if ((!(mode===3))) 
                                           exchangedh <= 1'b1;

                                   
                           'b00001000 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 'b110;
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                       set_busb_to <= 'b1000;
                                                   end
                                               4 : begin 
                                                       inc_wz <= 1'b1;
                                                       set_addr_to <= 'b110;
                                                       write <= 1'b1;
                                                       set_busb_to <= 'b1001;
                                                   end
                                               5 :     write <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else if ((mode < 2)) 
                                           exchangeaf <= 1'b1;

                                   
                           'b11011001 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 'b101;
                                               2 : begin 
                                                       incdec_16 <= 'b0111;
                                                       set_addr_to <= 'b101;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       jump <= 1'b1;
                                                       incdec_16 <= 'b0111;
                                                       i_retn <= 1'b1;
                                                       setei <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else if ((mode < 2)) 
                                           exchangers <= 1'b1;

                                   
                           'b11100011 : 
                                   if ((!(mode===3))) 
                                       begin 
                                           mcycles <= 'b101;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 'b101;
                                               2 : begin 
                                                       read_to_reg <= 1'b1;
                                                       set_busa_to <= 'b0101;
                                                       set_busb_to <= 'b0101;
                                                       set_addr_to <= 'b101;
                                                   end
                                               3 : begin 
                                                       incdec_16 <= 'b0111;
                                                       set_addr_to <= 'b101;
                                                       tstates <= 'b100;
                                                       write <= 1'b1;
                                                   end
                                               4 : begin 
                                                       read_to_reg <= 1'b1;
                                                       set_busa_to <= 'b0100;
                                                       set_busb_to <= 'b0100;
                                                       set_addr_to <= 'b101;
                                                   end
                                               5 : begin 
                                                       incdec_16 <= 'b1111;
                                                       tstates <= 'b101;
                                                       write <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b10000000,'b10000001,'b10000010,'b10000011,'b10000100,'b10000101,'b10000111,'b10001000,'b10001001,'b10001010,'b10001011,'b10001100,'b10001101,'b10001111,'b10010000,'b10010001,'b10010010,'b10010011,'b10010100,'b10010101,'b10010111,'b10011000,'b10011001,'b10011010,'b10011011,'b10011100,'b10011101,'b10011111,'b10100000,'b10100001,'b10100010,'b10100011,'b10100100,'b10100101,'b10100111,'b10101000,'b10101001,'b10101010,'b10101011,'b10101100,'b10101101,'b10101111,'b10110000,'b10110001,'b10110010,'b10110011,'b10110100,'b10110101,'b10110111,'b10111000,'b10111001,'b10111010,'b10111011,'b10111100,'b10111101,'b10111111 : 
                               begin 
                                   set_busb_to[2:0] <= Process2__sss;
                                   set_busa_to[2:0] <= 'b111;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                               end
                           'b10000110,'b10001110,'b10010110,'b10011110,'b10100110,'b10101110,'b10110110,'b10111110 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b010;
                                       2 : begin 
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busb_to[2:0] <= Process2__sss;
                                               set_busa_to[2:0] <= 'b111;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11000110,'b11001110,'b11010110,'b11011110,'b11100110,'b11101110,'b11110110,'b11111110 : 
                               begin 
                                   mcycles <= 'b010;
                                   if ((mcycle === 'b010)) 
                                       begin 
                                           inc_pc <= 1'b1;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                           set_busb_to[2:0] <= Process2__sss;
                                           set_busa_to[2:0] <= 'b111;
                                       end

                                   
                               end
                           'b00000100,'b00001100,'b00010100,'b00011100,'b00100100,'b00101100,'b00111100 : 
                               begin 
                                   set_busb_to <= 'b1010;
                                   set_busa_to[2:0] <= Process1__ddd;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                                   preservec <= 1'b1;
                                   alu_op <= 'b0000;
                               end
                           'b00110100 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b010;
                                       2 : begin 
                                               tstates <= 'b100;
                                               set_addr_to <= 'b010;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               preservec <= 1'b1;
                                               alu_op <= 'b0000;
                                               set_busb_to <= 'b1010;
                                               set_busa_to[2:0] <= Process1__ddd;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00000101,'b00001101,'b00010101,'b00011101,'b00100101,'b00101101,'b00111101 : 
                               begin 
                                   set_busb_to <= 'b1010;
                                   set_busa_to[2:0] <= Process1__ddd;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                                   preservec <= 1'b1;
                                   alu_op <= 'b0010;
                               end
                           'b00110101 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b010;
                                       2 : begin 
                                               tstates <= 'b100;
                                               set_addr_to <= 'b010;
                                               alu_op <= 'b0010;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               preservec <= 1'b1;
                                               set_busb_to <= 'b1010;
                                               set_busa_to[2:0] <= Process1__ddd;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b00100111 : 
                               begin 
                                   set_busa_to[2:0] <= 'b111;
                                   read_to_reg <= 1'b1;
                                   alu_op <= 'b1100;
                                   save_alu <= 1'b1;
                               end
                           'b00101111 : 
                                   i_cpl <= 1'b1;
                           'b00111111 : 
                                   i_ccf <= 1'b1;
                           'b00110111 : 
                                   i_scf <= 1'b1;
                           'b00000000 : 
                                   if ((nmicycle === 1'b1)) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       tstates <= 'b101;
                                                       incdec_16 <= 'b1111;
                                                       set_addr_to <= 'b101;
                                                       set_busb_to <= 'b1101;
                                                   end
                                               2 : begin 
                                                       tstates <= 'b100;
                                                       write <= 1'b1;
                                                       incdec_16 <= 'b1111;
                                                       set_addr_to <= 'b101;
                                                       set_busb_to <= 'b1100;
                                                   end
                                               3 : begin 
                                                       tstates <= 'b100;
                                                       write <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else if ((intcycle === 1'b1)) 
                                       begin 
                                           mcycles <= 'b101;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       ldz <= 1'b1;
                                                       tstates <= 'b101;
                                                       incdec_16 <= 'b1111;
                                                       set_addr_to <= 'b101;
                                                       set_busb_to <= 'b1101;
                                                   end
                                               2 : begin 
                                                       tstates <= 'b100;
                                                       write <= 1'b1;
                                                       incdec_16 <= 'b1111;
                                                       set_addr_to <= 'b101;
                                                       set_busb_to <= 'b1100;
                                                   end
                                               3 : begin 
                                                       tstates <= 'b100;
                                                       write <= 1'b1;
                                                   end
                                               4 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               5 :     jump <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       ;//Null

                                   
                           'b01110110 : 
                                   halt <= 1'b1;
                           'b11110011 : 
                                   setdi <= 1'b1;
                           'b11111011 : 
                                   setei <= 1'b1;
                           'b00001001,'b00011001,'b00101001,'b00111001 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 'b0000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 'b101;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b1;
                                                       end
                                                   default : 
                                                           set_busb_to <= 'b1000;
                                               endcase
                                               tstates <= 'b100;
                                               arith16 <= 1'b1;
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 'b0001;
                                               set_busa_to[2:0] <= 'b100;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                   default : 
                                                           set_busb_to <= 'b1001;
                                               endcase
                                               arith16 <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b00000011,'b00010011,'b00100011,'b00110011 : 
                               begin 
                                   tstates <= 'b110;
                                   incdec_16[3:2] <= 'b01;
                                   incdec_16[1:0] <= Process3__dpair;
                               end
                           'b00001011,'b00011011,'b00101011,'b00111011 : 
                               begin 
                                   tstates <= 'b110;
                                   incdec_16[3:2] <= 'b11;
                                   incdec_16[1:0] <= Process3__dpair;
                               end
                           'b00000111,'b00010111,'b00001111,'b00011111 : 
                               begin 
                                   set_busa_to[2:0] <= 'b111;
                                   alu_op <= 'b1000;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                               end
                           'b11000011 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               inc_pc <= 1'b1;
                                               jump <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11000010,'b11001010,'b11010010,'b11011010,'b11100010,'b11101010,'b11110010,'b11111010 : 
                                   if (((ir[5] === 1'b1) & (mode === 3))) 
                                           case (Process4__irb[4:3])
                                               'b00 : 
                                                   begin 
                                                       mcycles <= 'b010;
                                                       case ($unsigned(mcycle))
                                                           1 : begin 
                                                                   set_addr_to <= 'b000;
                                                                   set_busb_to <= 'b0111;
                                                               end
                                                           2 : begin 
                                                                   write <= 1'b1;
                                                                   iorq <= 1'b1;
                                                               end
                                                           default : 
                                                               ;
                                                       endcase
                                                   end
                                               'b01 : 
                                                   begin 
                                                       mcycles <= 'b100;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   ldz <= 1'b1;
                                                               end
                                                           3 : begin 
                                                                   set_addr_to <= 'b110;
                                                                   inc_pc <= 1'b1;
                                                                   set_busb_to <= 'b0111;
                                                               end
                                                           4 :     write <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                               'b10 : 
                                                   begin 
                                                       mcycles <= 'b010;
                                                       case ($unsigned(mcycle))
                                                           1 :     set_addr_to <= 'b000;
                                                           2 : begin 
                                                                   read_to_acc <= 1'b1;
                                                                   iorq <= 1'b1;
                                                               end
                                                           default : 
                                                               ;
                                                       endcase
                                                   end
                                               'b11 : 
                                                   begin 
                                                       mcycles <= 'b100;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   ldz <= 1'b1;
                                                               end
                                                           3 : begin 
                                                                   set_addr_to <= 'b110;
                                                                   inc_pc <= 1'b1;
                                                               end
                                                           4 :     read_to_acc <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                           endcase
                                   else 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       inc_pc <= 1'b1;
                                                       if (is_cc_true__0(f, ir[5:3])) 
                                                               jump <= 1'b1;

                                                       
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00011000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 :     inc_pc <= 1'b1;
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00111000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_c] === 1'b0)) 
                                                               mcycles <= 'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00110000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_c] === 1'b1)) 
                                                               mcycles <= 'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00101000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_z] === 1'b0)) 
                                                               mcycles <= 'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b00100000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_z] === 1'b1)) 
                                                               mcycles <= 'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11101001 : 
                                   jumpxy <= 1'b1;
                           'b00010000 : 
                                   if ((mode === 3)) 
                                           i_djnz <= 1'b1;
                                   else if ((mode < 2)) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       tstates <= 'b101;
                                                       i_djnz <= 1'b1;
                                                       set_busb_to <= 'b1010;
                                                       set_busa_to[2:0] <= 'b000;
                                                       read_to_reg <= 1'b1;
                                                       save_alu <= 1'b1;
                                                       alu_op <= 'b0010;
                                                   end
                                               2 : begin 
                                                       i_djnz <= 1'b1;
                                                       inc_pc <= 1'b1;
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11001101 : 
                               begin 
                                   mcycles <= 'b101;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               incdec_16 <= 'b1111;
                                               inc_pc <= 1'b1;
                                               tstates <= 'b100;
                                               set_addr_to <= 'b101;
                                               ldw <= 1'b1;
                                               set_busb_to <= 'b1101;
                                           end
                                       4 : begin 
                                               write <= 1'b1;
                                               incdec_16 <= 'b1111;
                                               set_addr_to <= 'b101;
                                               set_busb_to <= 'b1100;
                                           end
                                       5 : begin 
                                               write <= 1'b1;
                                               call <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11000100,'b11001100,'b11010100,'b11011100,'b11100100,'b11101100,'b11110100,'b11111100 : 
                                   if (((ir[5] === 1'b0) | (!(mode===3)))) 
                                       begin 
                                           mcycles <= 'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                       if (is_cc_true__0(f, ir[5:3])) 
                                                           begin 
                                                               incdec_16 <= 'b1111;
                                                               set_addr_to <= 'b101;
                                                               tstates <= 'b100;
                                                               set_busb_to <= 'b1101;
                                                           end
                                                       else 
                                                               mcycles <= 'b011;

                                                       
                                                   end
                                               4 : begin 
                                                       write <= 1'b1;
                                                       incdec_16 <= 'b1111;
                                                       set_addr_to <= 'b101;
                                                       set_busb_to <= 'b1100;
                                                   end
                                               5 : begin 
                                                       write <= 1'b1;
                                                       call <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11001001 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 'b101;
                                               set_addr_to <= 'b101;
                                           end
                                       2 : begin 
                                               incdec_16 <= 'b0111;
                                               set_addr_to <= 'b101;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               jump <= 1'b1;
                                               incdec_16 <= 'b0111;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11000000,'b11001000,'b11010000,'b11011000,'b11100000,'b11101000,'b11110000,'b11111000 : 
                                   if (((ir[5] === 1'b1) & (mode === 3))) 
                                           case (Process4__irb[4:3])
                                               'b00 : 
                                                   begin 
                                                       mcycles <= 'b011;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   set_addr_to <= 'b100;
                                                                   set_busb_to <= 'b0111;
                                                               end
                                                           3 :     write <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                               'b01 : 
                                                   begin 
                                                       mcycles <= 'b011;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   alu_op <= 'b0000;
                                                                   inc_pc <= 1'b1;
                                                                   read_to_reg <= 1'b1;
                                                                   save_alu <= 1'b1;
                                                                   set_busa_to <= 'b1000;
                                                                   set_busb_to <= 'b0110;
                                                               end
                                                           3 : begin 
                                                                   noread <= 1'b1;
                                                                   read_to_reg <= 1'b1;
                                                                   save_alu <= 1'b1;
                                                                   alu_op <= 'b0001;
                                                                   set_busa_to <= 'b1001;
                                                                   set_busb_to <= 'b1110;
                                                               end
                                                           default : 
                                                               ;
                                                       endcase
                                                   end
                                               'b10 : 
                                                   begin 
                                                       mcycles <= 'b011;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   set_addr_to <= 'b100;
                                                               end
                                                           3 :     read_to_acc <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                               'b11 : 
                                                   begin 
                                                       mcycles <= 'b101;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   ldz <= 1'b1;
                                                               end
                                                           3 : begin 
                                                                   set_addr_to <= 'b110;
                                                                   inc_pc <= 1'b1;
                                                                   ldw <= 1'b1;
                                                               end
                                                           4 : begin 
                                                                   set_busa_to[2:0] <= 'b101;
                                                                   read_to_reg <= 1'b1;
                                                                   inc_wz <= 1'b1;
                                                                   set_addr_to <= 'b110;
                                                               end
                                                           5 : begin 
                                                                   set_busa_to[2:0] <= 'b100;
                                                                   read_to_reg <= 1'b1;
                                                               end
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                           endcase
                                   else 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       if (is_cc_true__0(f, ir[5:3])) 
                                                               set_addr_to <= 'b101;
                                                       else 
                                                               mcycles <= 'b001;

                                                       tstates <= 'b101;
                                                   end
                                               2 : begin 
                                                       incdec_16 <= 'b0111;
                                                       set_addr_to <= 'b101;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       jump <= 1'b1;
                                                       incdec_16 <= 'b0111;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11000111,'b11001111,'b11010111,'b11011111,'b11100111,'b11101111,'b11110111,'b11111111 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 'b101;
                                               incdec_16 <= 'b1111;
                                               set_addr_to <= 'b101;
                                               set_busb_to <= 'b1101;
                                           end
                                       2 : begin 
                                               write <= 1'b1;
                                               incdec_16 <= 'b1111;
                                               set_addr_to <= 'b101;
                                               set_busb_to <= 'b1100;
                                           end
                                       3 : begin 
                                               write <= 1'b1;
                                               rstp <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b11011011 : 
                                   if ((!(mode===3))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       set_addr_to <= 'b100;
                                                   end
                                               3 : begin 
                                                       read_to_acc <= 1'b1;
                                                       iorq <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11010011 : 
                                   if ((!(mode===3))) 
                                       begin 
                                           mcycles <= 'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       set_addr_to <= 'b100;
                                                       set_busb_to <= 'b0111;
                                                   end
                                               3 : begin 
                                                       write <= 1'b1;
                                                       iorq <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           'b11001011 : 
                                   if ((!(mode===2))) 
                                           prefix <= 'b01;

                                   
                           'b11101101 : 
                                   if ((mode < 2)) 
                                           prefix <= 'b10;

                                   
                           'b11011101,'b11111101 : 
                                   if ((mode < 2)) 
                                           prefix <= 'b11;

                                   
                       endcase
               'b01 : 
                   begin 
                       set_busa_to[2:0] <= ir[2:0];
                       set_busb_to[2:0] <= ir[2:0];
                       case (Process4__irb)
                           'b00000000,'b00000001,'b00000010,'b00000011,'b00000100,'b00000101,'b00000111,'b00010000,'b00010001,'b00010010,'b00010011,'b00010100,'b00010101,'b00010111,'b00001000,'b00001001,'b00001010,'b00001011,'b00001100,'b00001101,'b00001111,'b00011000,'b00011001,'b00011010,'b00011011,'b00011100,'b00011101,'b00011111,'b00100000,'b00100001,'b00100010,'b00100011,'b00100100,'b00100101,'b00100111,'b00101000,'b00101001,'b00101010,'b00101011,'b00101100,'b00101101,'b00101111,'b00110000,'b00110001,'b00110010,'b00110011,'b00110100,'b00110101,'b00110111,'b00111000,'b00111001,'b00111010,'b00111011,'b00111100,'b00111101,'b00111111 : 
                                   if ((mcycle === 'b001)) 
                                       begin 
                                           alu_op <= 'b1000;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                       end

                                   
                           'b00000110,'b00010110,'b00001110,'b00011110,'b00101110,'b00111110,'b00100110,'b00110110 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 'b010;
                                       2 : begin 
                                               alu_op <= 'b1000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_addr_to <= 'b010;
                                               tstates <= 'b100;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                           ;
                                   endcase
                               end
                           'b01000000,'b01000001,'b01000010,'b01000011,'b01000100,'b01000101,'b01000111,'b01001000,'b01001001,'b01001010,'b01001011,'b01001100,'b01001101,'b01001111,'b01010000,'b01010001,'b01010010,'b01010011,'b01010100,'b01010101,'b01010111,'b01011000,'b01011001,'b01011010,'b01011011,'b01011100,'b01011101,'b01011111,'b01100000,'b01100001,'b01100010,'b01100011,'b01100100,'b01100101,'b01100111,'b01101000,'b01101001,'b01101010,'b01101011,'b01101100,'b01101101,'b01101111,'b01110000,'b01110001,'b01110010,'b01110011,'b01110100,'b01110101,'b01110111,'b01111000,'b01111001,'b01111010,'b01111011,'b01111100,'b01111101,'b01111111 : 
                                   if ((mcycle === 'b001)) 
                                       begin 
                                           set_busb_to[2:0] <= ir[2:0];
                                           alu_op <= 'b1001;
                                       end

                                   
                           'b01000110,'b01001110,'b01010110,'b01011110,'b01100110,'b01101110,'b01110110,'b01111110 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 'b010;
                                       2 : begin 
                                               alu_op <= 'b1001;
                                               tstates <= 'b100;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b11000000,'b11000001,'b11000010,'b11000011,'b11000100,'b11000101,'b11000111,'b11001000,'b11001001,'b11001010,'b11001011,'b11001100,'b11001101,'b11001111,'b11010000,'b11010001,'b11010010,'b11010011,'b11010100,'b11010101,'b11010111,'b11011000,'b11011001,'b11011010,'b11011011,'b11011100,'b11011101,'b11011111,'b11100000,'b11100001,'b11100010,'b11100011,'b11100100,'b11100101,'b11100111,'b11101000,'b11101001,'b11101010,'b11101011,'b11101100,'b11101101,'b11101111,'b11110000,'b11110001,'b11110010,'b11110011,'b11110100,'b11110101,'b11110111,'b11111000,'b11111001,'b11111010,'b11111011,'b11111100,'b11111101,'b11111111 : 
                                   if ((mcycle === 'b001)) 
                                       begin 
                                           alu_op <= 'b1010;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                       end

                                   
                           'b11000110,'b11001110,'b11010110,'b11011110,'b11100110,'b11101110,'b11110110,'b11111110 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 'b010;
                                       2 : begin 
                                               alu_op <= 'b1010;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_addr_to <= 'b010;
                                               tstates <= 'b100;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                           ;
                                   endcase
                               end
                           'b10000000,'b10000001,'b10000010,'b10000011,'b10000100,'b10000101,'b10000111,'b10001000,'b10001001,'b10001010,'b10001011,'b10001100,'b10001101,'b10001111,'b10010000,'b10010001,'b10010010,'b10010011,'b10010100,'b10010101,'b10010111,'b10011000,'b10011001,'b10011010,'b10011011,'b10011100,'b10011101,'b10011111,'b10100000,'b10100001,'b10100010,'b10100011,'b10100100,'b10100101,'b10100111,'b10101000,'b10101001,'b10101010,'b10101011,'b10101100,'b10101101,'b10101111,'b10110000,'b10110001,'b10110010,'b10110011,'b10110100,'b10110101,'b10110111,'b10111000,'b10111001,'b10111010,'b10111011,'b10111100,'b10111101,'b10111111 : 
                                   if ((mcycle === 'b001)) 
                                       begin 
                                           alu_op <= 'b1011;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                       end

                                   
                           'b10000110,'b10001110,'b10010110,'b10011110,'b10100110,'b10101110,'b10110110,'b10111110 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 'b010;
                                       2 : begin 
                                               alu_op <= 'b1011;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_addr_to <= 'b010;
                                               tstates <= 'b100;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                           ;
                                   endcase
                               end
                       endcase
                   end
               default : 
                       case (Process4__irb)
                           'b00000000,'b00000001,'b00000010,'b00000011,'b00000100,'b00000101,'b00000110,'b00000111,'b00001000,'b00001001,'b00001010,'b00001011,'b00001100,'b00001101,'b00001110,'b00001111,'b00010000,'b00010001,'b00010010,'b00010011,'b00010100,'b00010101,'b00010110,'b00010111,'b00011000,'b00011001,'b00011010,'b00011011,'b00011100,'b00011101,'b00011110,'b00011111,'b00100000,'b00100001,'b00100010,'b00100011,'b00100100,'b00100101,'b00100110,'b00100111,'b00101000,'b00101001,'b00101010,'b00101011,'b00101100,'b00101101,'b00101110,'b00101111,'b00110000,'b00110001,'b00110010,'b00110011,'b00110100,'b00110101,'b00110110,'b00110111,'b00111000,'b00111001,'b00111010,'b00111011,'b00111100,'b00111101,'b00111110,'b00111111,'b10000000,'b10000001,'b10000010,'b10000011,'b10000100,'b10000101,'b10000110,'b10000111,'b10001000,'b10001001,'b10001010,'b10001011,'b10001100,'b10001101,'b10001110,'b10001111,'b10010000,'b10010001,'b10010010,'b10010011,'b10010100,'b10010101,'b10010110,'b10010111,'b10011000,'b10011001,'b10011010,'b10011011,'b10011100,'b10011101,'b10011110,'b10011111,'b10100100,'b10100101,'b10100110,'b10100111,'b10101100,'b10101101,'b10101110,'b10101111,'b10110100,'b10110101,'b10110110,'b10110111,'b10111100,'b10111101,'b10111110,'b10111111,'b11000000,'b11000001,'b11000010,'b11000011,'b11000100,'b11000101,'b11000110,'b11000111,'b11001000,'b11001001,'b11001010,'b11001011,'b11001100,'b11001101,'b11001110,'b11001111,'b11010000,'b11010001,'b11010010,'b11010011,'b11010100,'b11010101,'b11010110,'b11010111,'b11011000,'b11011001,'b11011010,'b11011011,'b11011100,'b11011101,'b11011110,'b11011111,'b11100000,'b11100001,'b11100010,'b11100011,'b11100100,'b11100101,'b11100110,'b11100111,'b11101000,'b11101001,'b11101010,'b11101011,'b11101100,'b11101101,'b11101110,'b11101111,'b11110000,'b11110001,'b11110010,'b11110011,'b11110100,'b11110101,'b11110110,'b11110111,'b11111000,'b11111001,'b11111010,'b11111011,'b11111100,'b11111101,'b11111110,'b11111111 : 
                                   ;//null
                           'b01111110,'b01111111 : 
                                   ;//null
                           'b01010111 : 
                               begin 
                                   special_ld <= 'b100;
                                   tstates <= 'b101;
                               end
                           'b01011111 : 
                               begin 
                                   special_ld <= 'b101;
                                   tstates <= 'b101;
                               end
                           'b01000111 : 
                               begin 
                                   special_ld <= 'b110;
                                   tstates <= 'b101;
                               end
                           'b01001111 : 
                               begin 
                                   special_ld <= 'b111;
                                   tstates <= 'b101;
                               end
                           'b01001011,'b01011011,'b01101011,'b01111011 : 
                               begin 
                                   mcycles <= 'b101;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               set_addr_to <= 'b110;
                                               inc_pc <= 1'b1;
                                               ldw <= 1'b1;
                                           end
                                       4 : begin 
                                               read_to_reg <= 1'b1;
                                               if ((ir[5:4] === 'b11)) 
                                                       set_busa_to <= 'b1000;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= ir[5:4];
                                                       set_busa_to[0] <= 1'b1;
                                                   end

                                               inc_wz <= 1'b1;
                                               set_addr_to <= 'b110;
                                           end
                                       5 : begin 
                                               read_to_reg <= 1'b1;
                                               if ((ir[5:4] === 'b11)) 
                                                       set_busa_to <= 'b1001;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= ir[5:4];
                                                       set_busa_to[0] <= 1'b0;
                                                   end

                                               
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b01000011,'b01010011,'b01100011,'b01110011 : 
                               begin 
                                   mcycles <= 'b101;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               set_addr_to <= 'b110;
                                               inc_pc <= 1'b1;
                                               ldw <= 1'b1;
                                               if ((ir[5:4] === 'b11)) 
                                                       set_busb_to <= 'b1000;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= ir[5:4];
                                                       set_busb_to[0] <= 1'b1;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               
                                           end
                                       4 : begin 
                                               inc_wz <= 1'b1;
                                               set_addr_to <= 'b110;
                                               write <= 1'b1;
                                               if ((ir[5:4] === 'b11)) 
                                                       set_busb_to <= 'b1001;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= ir[5:4];
                                                       set_busb_to[0] <= 1'b0;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               
                                           end
                                       5 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b10100000,'b10101000,'b10110000,'b10111000 : 
                               begin 
                                   mcycles <= 'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b010;
                                               incdec_16 <= 'b1100;
                                           end
                                       2 : begin 
                                               set_busb_to <= 'b0110;
                                               set_busa_to[2:0] <= 'b111;
                                               alu_op <= 'b0000;
                                               set_addr_to <= 'b001;
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 'b0110;
                                               else 
                                                       incdec_16 <= 'b1110;

                                               
                                           end
                                       3 : begin 
                                               i_bt <= 1'b1;
                                               tstates <= 'b101;
                                               write <= 1'b1;
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 'b0101;
                                               else 
                                                       incdec_16 <= 'b1101;

                                               
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b10100001,'b10101001,'b10110001,'b10111001 : 
                               begin 
                                   mcycles <= 'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b010;
                                               incdec_16 <= 'b1100;
                                           end
                                       2 : begin 
                                               set_busb_to <= 'b0110;
                                               set_busa_to[2:0] <= 'b111;
                                               alu_op <= 'b0111;
                                               save_alu <= 1'b1;
                                               preservec <= 1'b1;
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 'b0110;
                                               else 
                                                       incdec_16 <= 'b1110;

                                               
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               i_bc <= 1'b1;
                                               tstates <= 'b101;
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b01000100,'b01001100,'b01010100,'b01011100,'b01100100,'b01101100,'b01110100,'b01111100 : 
                               begin 
                                   alu_op <= 'b0010;
                                   set_busb_to <= 'b0111;
                                   set_busa_to <= 'b1010;
                                   read_to_acc <= 1'b1;
                                   save_alu <= 1'b1;
                               end
                           'b01000110,'b01001110,'b01100110,'b01101110 : 
                                   imode <= 'b00;
                           'b01010110,'b01110110 : 
                                   imode <= 'b01;
                           'b01011110,'b01110111 : 
                                   imode <= 'b10;
                           'b01001010,'b01011010,'b01101010,'b01111010 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 'b0001;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 'b101;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b1;
                                                       end
                                                   default : 
                                                           set_busb_to <= 'b1000;
                                               endcase
                                               tstates <= 'b100;
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 'b0001;
                                               set_busa_to[2:0] <= 'b100;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b0;
                                                       end
                                                   default : 
                                                           set_busb_to <= 'b1001;
                                               endcase
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b01000010,'b01010010,'b01100010,'b01110010 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 'b0011;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 'b101;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b1;
                                                       end
                                                   default : 
                                                           set_busb_to <= 'b1000;
                                               endcase
                                               tstates <= 'b100;
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 'b0011;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 'b100;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                   default : 
                                                           set_busb_to <= 'b1001;
                                               endcase
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b01101111 : 
                               begin 
                                   mcycles <= 'b100;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               set_addr_to <= 'b010;
                                           end
                                       3 : begin 
                                               read_to_reg <= 1'b1;
                                               set_busb_to[2:0] <= 'b110;
                                               set_busa_to[2:0] <= 'b111;
                                               alu_op <= 'b1101;
                                               tstates <= 'b100;
                                               set_addr_to <= 'b010;
                                               save_alu <= 1'b1;
                                           end
                                       4 : begin 
                                               i_rld <= 1'b1;
                                               write <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b01100111 : 
                               begin 
                                   mcycles <= 'b100;
                                   case ($unsigned(mcycle))
                                       2 :     set_addr_to <= 'b010;
                                       3 : begin 
                                               read_to_reg <= 1'b1;
                                               set_busb_to[2:0] <= 'b110;
                                               set_busa_to[2:0] <= 'b111;
                                               alu_op <= 'b1110;
                                               tstates <= 'b100;
                                               set_addr_to <= 'b010;
                                               save_alu <= 1'b1;
                                           end
                                       4 : begin 
                                               i_rrd <= 1'b1;
                                               write <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b01000101,'b01001101,'b01010101,'b01011101,'b01100101,'b01101101,'b01110101,'b01111101 : 
                               begin 
                                   mcycles <= 'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b101;
                                       2 : begin 
                                               incdec_16 <= 'b0111;
                                               set_addr_to <= 'b101;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               jump <= 1'b1;
                                               incdec_16 <= 'b0111;
                                               i_retn <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b01000000,'b01001000,'b01010000,'b01011000,'b01100000,'b01101000,'b01110000,'b01111000 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 'b000;
                                       2 : begin 
                                               iorq <= 1'b1;
                                               if ((!(ir[5:3]==='b110))) 
                                                   begin 
                                                       read_to_reg <= 1'b1;
                                                       set_busa_to[2:0] <= ir[5:3];
                                                   end

                                               i_inrc <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b01000001,'b01001001,'b01010001,'b01011001,'b01100001,'b01101001,'b01110001,'b01111001 : 
                               begin 
                                   mcycles <= 'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b000;
                                               set_busb_to[2:0] <= ir[5:3];
                                               if ((ir[5:3] === 'b110)) 
                                                       set_busb_to[3] <= 1'b1;

                                               
                                           end
                                       2 : begin 
                                               write <= 1'b1;
                                               iorq <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           'b10100010,'b10101010,'b10110010,'b10111010 : 
                               begin 
                                   mcycles <= 'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 'b000;
                                               set_busb_to <= 'b1010;
                                               set_busa_to <= 'b0000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 'b0010;
                                           end
                                       2 : begin 
                                               iorq <= 1'b1;
                                               set_busb_to <= 'b0110;
                                               set_addr_to <= 'b010;
                                           end
                                       3 : begin 
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 'b0010;
                                               else 
                                                       incdec_16 <= 'b1010;

                                               tstates <= 'b100;
                                               write <= 1'b1;
                                               i_btr <= 1'b1;
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           'b10100011,'b10101011,'b10110011,'b10111011 : 
                               begin 
                                   mcycles <= 'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 'b101;
                                               set_addr_to <= 'b010;
                                               set_busb_to <= 'b1010;
                                               set_busa_to <= 'b0000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 'b0010;
                                           end
                                       2 : begin 
                                               set_busb_to <= 'b0110;
                                               set_addr_to <= 'b000;
                                           end
                                       3 : begin 
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 'b0010;
                                               else 
                                                       incdec_16 <= 'b1010;

                                               iorq <= 1'b1;
                                               write <= 1'b1;
                                               i_btr <= 1'b1;
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                       endcase
           endcase
           if ((mode === 1)) 
               begin 
                   if ((mcycle === 'b001)) 
                       ;//Null
                   else 
                       tstates <= 'b011;
                       
                   
                   
               end 
           if ((mode === 3)) 
               begin 
                   if ((mcycle === 'b001)) 
                       ;//Null
                   else 
                       tstates <= 'b100;
                       
                   
                   
               end 
           if ((mode < 2)) 
               begin 
                   begin 
                       if ((mcycle === 'b110)) 
                           begin 
                               inc_pc <= 1'b1;
                               if ((mode === 1)) 
                                   begin 
                                       set_addr_to <= 'b010;
                                       tstates <= 'b100;
                                       set_busb_to[2:0] <= Process2__sss;
                                       set_busb_to[3] <= 1'b0;
                                   end
                                   
                               
                               if (((Process4__irb === 'b00110110) | (Process4__irb === 'b11001011))) 
                                   set_addr_to <= 'b111;
                                   
                               
                               
                           end
                           
                       
                       if ((mcycle === 'b111)) 
                           begin 
                               begin 
                                   if ((mode === 0)) 
                                           tstates <= 'b101;

                                   if ((!(iset==='b01))) 
                                           set_addr_to <= 'b010;

                                   set_busb_to[2:0] <= Process2__sss;
                                   set_busb_to[3] <= 1'b0;
                                   if (((Process4__irb === 'b00110110) | (iset === 'b01))) 
                                           inc_pc <= 1'b1;
                                   else 
                                           noread <= 1'b1;

                                   
                               end
                           end 
                       
                       
                   end
                   
               end 
           
   end //always
    
    function [0:0] is_cc_true__0;
        input [7:0]  f ;
input [2:0]  cc ;
        begin : Function
                if ((mode === 3)) 
                        case (cc)
                            'b000 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b0);
                                        disable Function;
                                    end
                            'b001 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b1);
                                        disable Function;
                                    end
                            'b010 : 
                                    begin 
                                        is_cc_true__0=(f[4] === 1'b0);
                                        disable Function;
                                    end
                            'b011 : 
                                    begin 
                                        is_cc_true__0=(f[4] === 1'b1);
                                        disable Function;
                                    end
                            'b100 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                            'b101 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                            'b110 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                            'b111 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                        endcase
                else 
                        case (cc)
                            'b000 : 
                                    begin 
                                        is_cc_true__0=(f[6] === 1'b0);
                                        disable Function;
                                    end
                            'b001 : 
                                    begin 
                                        is_cc_true__0=(f[6] === 1'b1);
                                        disable Function;
                                    end
                            'b010 : 
                                    begin 
                                        is_cc_true__0=(f[0] === 1'b0);
                                        disable Function;
                                    end
                            'b011 : 
                                    begin 
                                        is_cc_true__0=(f[0] === 1'b1);
                                        disable Function;
                                    end
                            'b100 : 
                                    begin 
                                        is_cc_true__0=(f[2] === 1'b0);
                                        disable Function;
                                    end
                            'b101 : 
                                    begin 
                                        is_cc_true__0=(f[2] === 1'b1);
                                        disable Function;
                                    end
                            'b110 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b0);
                                        disable Function;
                                    end
                            'b111 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b1);
                                        disable Function;
                                    end
                        endcase

                
        end // Function
    endfunction

    

endmodule
//
// Z80 compatible microprocessor core
//
// Version : 0247
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0214 : Fixed mostly flags, only the block instructions now fail the zex regression test
//
//	0238 : Fixed zero flag for 16 bit SBC and ADC
//
//	0240 : Added GB operations
//
//	0242 : Cleanup
//
//	0247 : Cleanup
//


module  t80_alu ( arith16, z16, alu_op, ir, iset, busa, busb, f_in, q, f_out );
    parameter  [31:0]  mode =0;
    parameter  [31:0]  flag_c =0;
    parameter  [31:0]  flag_n =1;
    parameter  [31:0]  flag_p =2;
    parameter  [31:0]  flag_x =3;
    parameter  [31:0]  flag_h =4;
    parameter  [31:0]  flag_y =5;
    parameter  [31:0]  flag_z =6;
    parameter  [31:0]  flag_s =7;
    
    input arith16;
    input z16;
    input [3:0]  alu_op ;
    input [5:0]  ir ;
    input [1:0]  iset ;
    input [7:0]  busa ;
    input [7:0]  busb ;
    input [7:0]  f_in ;
    output [7:0]  q ;
    output [7:0]  f_out ;


    reg [7:0] Process1__q_t;
    reg [8:0] Process2__daa_q;
    wire usecarry;
    reg carry7_v;
    wire overflow_v;
    reg halfcarry_v;
    reg carry_v;
    reg [7:0] q_v;
    wire [7:0] bitmask;
    reg [7:0] q;
    reg [7:0] f_out;


    
   assign bitmask=ir[5:3]==='b000 ? 'b00000001 : 
           ir[5:3]==='b001 ? 'b00000010 : 
           ir[5:3]==='b010 ? 'b00000100 : 
           ir[5:3]==='b011 ? 'b00001000 : 
           ir[5:3]==='b100 ? 'b00010000 : 
           ir[5:3]==='b101 ? 'b00100000 : 
           ir[5:3]==='b110 ? 'b01000000 : 
           'b10000000;
   
   assign {usecarry}=(~ (alu_op[2]) & alu_op[0]);
   
       
   always @ (busa[3:0] or busb[3:0] or alu_op[1] or alu_op[1] or usecarry or f_in[flag_c] or q_v[3:0] or halfcarry_v ) begin
           addsub__0(busa[3:0], busb[3:0], alu_op[1], (alu_op[1] ^ (usecarry & f_in[flag_c])));
   end //always
   
       
   always @ (busa[6:4] or busb[6:4] or alu_op[1] or halfcarry_v or q_v[6:4] or carry7_v ) begin
           addsub__1(busa[6:4], busb[6:4], alu_op[1], halfcarry_v);
   end //always
   
       
   always @ (busa[7:7] or busb[7:7] or alu_op[1] or carry7_v or q_v[7:7] or carry_v ) begin
           addsub__2(busa[7:7], busb[7:7], alu_op[1], carry7_v);
   end //always
   
   assign {overflow_v}=(carry_v ^ carry7_v);
   
       
   always @ (arith16 or alu_op or f_in or busa or busb or ir or q_v or carry_v or halfcarry_v or overflow_v or bitmask or iset or z16 ) begin
           Process1__q_t = 'bxxxxxxxx;
           f_out <= f_in;
           Process2__daa_q = 'bxxxxxxxxx;
           case (alu_op)
               'b0000,'b0001,'b0010,'b0011,'b0100,'b0101,'b0110,'b0111 : 
                   begin 
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_c] <= 1'b0;
                       case (alu_op[2:0])
                           'b000,'b001 : 
                               begin 
                                   Process1__q_t = q_v;
                                   f_out[flag_c] <= carry_v;
                                   f_out[flag_h] <= halfcarry_v;
                                   f_out[flag_p] <= overflow_v;
                               end
                           'b010,'b011,'b111 : 
                               begin 
                                   Process1__q_t = q_v;
                                   f_out[flag_n] <= 1'b1;
                                   f_out[flag_c] <= ~ (carry_v);
                                   f_out[flag_h] <= ~ (halfcarry_v);
                                   f_out[flag_p] <= overflow_v;
                               end
                           'b100 : 
                               begin 
                                   Process1__q_t[7:0] = (busa & busb);
                                   f_out[flag_h] <= 1'b1;
                               end
                           'b101 : 
                               begin 
                                   Process1__q_t[7:0] = (busa ^ busb);
                                   f_out[flag_h] <= 1'b0;
                               end
                           default : 
                               begin 
                                   Process1__q_t[7:0] = (busa | busb);
                                   f_out[flag_h] <= 1'b0;
                               end
                       endcase
                       if ((alu_op[2:0] === 'b111)) 
                           begin 
                               f_out[flag_x] <= busb[3];
                               f_out[flag_y] <= busb[5];
                           end
                       else 
                           begin 
                               f_out[flag_x] <= Process1__q_t[3];
                               f_out[flag_y] <= Process1__q_t[5];
                           end

                       if ((Process1__q_t[7:0] === 'b00000000)) 
                           begin 
                               f_out[flag_z] <= 1'b1;
                               if ((z16 === 1'b1)) 
                                       f_out[flag_z] <= f_in[flag_z];

                               
                           end
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_s] <= Process1__q_t[7];
                       case (alu_op[2:0])
                           'b000,'b001,'b010,'b011,'b111 : 
                               ;
                           default : 
                                   f_out[flag_p] <= ~ ((((((((Process1__q_t[0] ^ Process1__q_t[1]) ^ Process1__q_t[2]) ^ Process1__q_t[3]) ^ Process1__q_t[4]) ^ Process1__q_t[5]) ^ Process1__q_t[6]) ^ Process1__q_t[7]));
                       endcase
                       if ((arith16 === 1'b1)) 
                           begin 
                               f_out[flag_s] <= f_in[flag_s];
                               f_out[flag_z] <= f_in[flag_z];
                               f_out[flag_p] <= f_in[flag_p];
                           end

                       
                   end
               'b1100 : 
                   begin 
                       f_out[flag_h] <= f_in[flag_h];
                       f_out[flag_c] <= f_in[flag_c];
                       Process2__daa_q[7:0] = $unsigned(busa);
                       Process2__daa_q[8] = 1'b0;
                       if ((f_in[flag_n] === 1'b0)) 
                           begin 
                               begin 
                                   if (((Process2__daa_q[3:0] > 9) | (f_in[flag_h] === 1'b1))) 
                                       begin 
                                           begin 
                                               if ((Process2__daa_q[3:0] > 9)) 
                                                       f_out[flag_h] <= 1'b1;
                                               else 
                                                       f_out[flag_h] <= 1'b0;

                                               Process2__daa_q = (Process2__daa_q + 6);
                                           end
                                       end 

                                   if (((Process2__daa_q[8:4] > 9) | (f_in[flag_c] === 1'b1))) 
                                           Process2__daa_q = (Process2__daa_q + 96);

                                   
                               end
                           end 
                       else 
                           begin 
                               begin 
                                   if (((Process2__daa_q[3:0] > 9) | (f_in[flag_h] === 1'b1))) 
                                       begin 
                                           begin 
                                               if ((Process2__daa_q[3:0] > 5)) 
                                                       f_out[flag_h] <= 1'b0;

                                               Process2__daa_q[7:0] = (Process2__daa_q[7:0] - 6);
                                           end
                                       end 

                                   if ((($unsigned(busa) > 153) | (f_in[flag_c] === 1'b1))) 
                                           Process2__daa_q = (Process2__daa_q - 352);

                                   
                               end
                           end 

                       f_out[flag_x] <= Process2__daa_q[3];
                       f_out[flag_y] <= Process2__daa_q[5];
                       f_out[flag_c] <= (f_in[flag_c] | Process2__daa_q[8]);
                       Process1__q_t = Process2__daa_q[7:0];
                       if ((Process2__daa_q[7:0] === 'b00000000)) 
                               f_out[flag_z] <= 1'b1;
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_s] <= Process2__daa_q[7];
                       f_out[flag_p] <= ~ ((((((((Process2__daa_q[0] ^ Process2__daa_q[1]) ^ Process2__daa_q[2]) ^ Process2__daa_q[3]) ^ Process2__daa_q[4]) ^ Process2__daa_q[5]) ^ Process2__daa_q[6]) ^ Process2__daa_q[7]));
                   end
               'b1101,'b1110 : 
                   begin 
                       Process1__q_t[7:4] = busa[7:4];
                       if ((alu_op[0] === 1'b1)) 
                               Process1__q_t[3:0] = busb[7:4];
                       else 
                               Process1__q_t[3:0] = busb[3:0];

                       f_out[flag_h] <= 1'b0;
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_x] <= Process1__q_t[3];
                       f_out[flag_y] <= Process1__q_t[5];
                       if ((Process1__q_t[7:0] === 'b00000000)) 
                               f_out[flag_z] <= 1'b1;
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_s] <= Process1__q_t[7];
                       f_out[flag_p] <= ~ ((((((((Process1__q_t[0] ^ Process1__q_t[1]) ^ Process1__q_t[2]) ^ Process1__q_t[3]) ^ Process1__q_t[4]) ^ Process1__q_t[5]) ^ Process1__q_t[6]) ^ Process1__q_t[7]));
                   end
               'b1001 : 
                   begin 
                       Process1__q_t[7:0] = (busb & bitmask);
                       f_out[flag_s] <= Process1__q_t[7];
                       if ((Process1__q_t[7:0] === 'b00000000)) 
                           begin 
                               f_out[flag_z] <= 1'b1;
                               f_out[flag_p] <= 1'b1;
                           end
                       else 
                           begin 
                               f_out[flag_z] <= 1'b0;
                               f_out[flag_p] <= 1'b0;
                           end

                       f_out[flag_h] <= 1'b1;
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_x] <= 1'b0;
                       f_out[flag_y] <= 1'b0;
                       if ((!(ir[2:0]==='b110))) 
                           begin 
                               f_out[flag_x] <= busb[3];
                               f_out[flag_y] <= busb[5];
                           end

                       
                   end
               'b1010 : 
                       Process1__q_t[7:0] = (busb | bitmask);
               'b1011 : 
                       Process1__q_t[7:0] = (busb & ~ (bitmask));
               'b1000 : 
                   begin 
                       case (ir[5:3])
                           'b000 : 
                               begin 
                                   Process1__q_t[7:1] = busa[6:0];
                                   Process1__q_t[0] = busa[7];
                                   f_out[flag_c] <= busa[7];
                               end
                           'b010 : 
                               begin 
                                   Process1__q_t[7:1] = busa[6:0];
                                   Process1__q_t[0] = f_in[flag_c];
                                   f_out[flag_c] <= busa[7];
                               end
                           'b001 : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = busa[0];
                                   f_out[flag_c] <= busa[0];
                               end
                           'b011 : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = f_in[flag_c];
                                   f_out[flag_c] <= busa[0];
                               end
                           'b100 : 
                               begin 
                                   Process1__q_t[7:1] = busa[6:0];
                                   Process1__q_t[0] = 1'b0;
                                   f_out[flag_c] <= busa[7];
                               end
                           'b110 : 
                                   if ((mode === 3)) 
                                       begin 
                                           Process1__q_t[7:4] = busa[3:0];
                                           Process1__q_t[3:0] = busa[7:4];
                                           f_out[flag_c] <= 1'b0;
                                       end
                                   else 
                                       begin 
                                           Process1__q_t[7:1] = busa[6:0];
                                           Process1__q_t[0] = 1'b1;
                                           f_out[flag_c] <= busa[7];
                                       end

                                   
                           'b101 : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = busa[7];
                                   f_out[flag_c] <= busa[0];
                               end
                           default : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = 1'b0;
                                   f_out[flag_c] <= busa[0];
                               end
                       endcase
                       f_out[flag_h] <= 1'b0;
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_x] <= Process1__q_t[3];
                       f_out[flag_y] <= Process1__q_t[5];
                       f_out[flag_s] <= Process1__q_t[7];
                       if ((Process1__q_t[7:0] === 'b00000000)) 
                               f_out[flag_z] <= 1'b1;
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_p] <= ~ ((((((((Process1__q_t[0] ^ Process1__q_t[1]) ^ Process1__q_t[2]) ^ Process1__q_t[3]) ^ Process1__q_t[4]) ^ Process1__q_t[5]) ^ Process1__q_t[6]) ^ Process1__q_t[7]));
                       if ((iset === 'b00)) 
                           begin 
                               f_out[flag_p] <= f_in[flag_p];
                               f_out[flag_s] <= f_in[flag_s];
                               f_out[flag_z] <= f_in[flag_z];
                           end

                       
                   end
               default : 
                       ;//null
           endcase
           q <= Process1__q_t;
   end //always
               task addsub__0;
                   input  [3:0] a;
                   input  [3:0] b;
                   input  sub ;
                   input  carry_in ;
                       reg [((3-0+1) - 1):0] b_i;
                       reg [((3-0+1) + 1):0] res_i;

                   begin 
                       if ((sub === 1'b1)) 
                               b_i = ~ ($unsigned(b));
                       else 
                               b_i = $unsigned(b);

                       res_i = ($unsigned({{'b0,a},carry_in}) + $unsigned({{'b0,b_i},'b1}));
                       halfcarry_v <= res_i[((3-0+1) + 1)];
                       q_v[3:0] <= res_i[(3-0+1):1];
                   end
               endtask
                   

               task addsub__1;
                   input  [6:4] a;
                   input  [6:4] b;
                   input  sub ;
                   input  carry_in ;
                       reg [((6-4+1) - 1):0] b_i;
                       reg [((6-4+1) + 1):0] res_i;

                   begin 
                       if ((sub === 1'b1)) 
                               b_i = ~ ($unsigned(b));
                       else 
                               b_i = $unsigned(b);

                       res_i = ($unsigned({{'b0,a},carry_in}) + $unsigned({{'b0,b_i},'b1}));
                       carry7_v <= res_i[((6-4+1) + 1)];
                       q_v[6:4] <= res_i[(6-4+1):1];
                   end
               endtask
                   

               task addsub__2;
                   input  [7:7] a;
                   input  [7:7] b;
                   input  sub ;
                   input  carry_in ;
                       reg [((7-7+1) - 1):0] b_i;
                       reg [((7-7+1) + 1):0] res_i;

                   begin 
                       if ((sub === 1'b1)) 
                               b_i = ~ ($unsigned(b));
                       else 
                               b_i = $unsigned(b);

                       res_i = ($unsigned({{'b0,a},carry_in}) + $unsigned({{'b0,b_i},'b1}));
                       carry_v <= res_i[((7-7+1) + 1)];
                       q_v[7:7] <= res_i[(7-7+1):1];
                   end
               endtask
                   

               
           
endmodule
//
// Z80 compatible microprocessor core
//
// Version : 0247
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0208 : First complete release
//
//	0210 : Fixed wait and halt
//
//	0211 : Fixed Refresh addition and IM 1
//
//	0214 : Fixed mostly flags, only the block instructions now fail the zex regression test
//
//	0232 : Removed refresh address output for Mode > 1 and added DJNZ M1_n fix by Mike Johnson
//
//	0235 : Added clock enable and IM 2 fix by Mike Johnson
//
//	0237 : Changed 8080 I/O address output, added IntE output
//
//	0238 : Fixed (IX/IY+d) timing and 16 bit ADC and SBC zero flag
//
//	0240 : Added interrupt ack fix by Mike Johnson, changed (IX/IY+d) timing and changed flags in GB mode
//
//	0242 : Added I/O wait, fixed refresh address, moved some registers to RAM
//
//	0247 : Fixed bus req/ack cycle
//


module  t80 ( reset_n, clk_n, cen, wait_n, int_n, nmi_n, busrq_n, m1_n, iorq, noread, write, rfsh_n, halt_n, busak_n, a, dinst, di, do, mc, ts, intcycle_n, inte, stop );
    parameter  [31:0]  mode =0;
    parameter  [31:0]  iowait =0;
    parameter  [31:0]  flag_c =0;
    parameter  [31:0]  flag_n =1;
    parameter  [31:0]  flag_p =2;
    parameter  [31:0]  flag_x =3;
    parameter  [31:0]  flag_h =4;
    parameter  [31:0]  flag_y =5;
    parameter  [31:0]  flag_z =6;
    parameter  [31:0]  flag_s =7;
    
    input reset_n;
    input clk_n;
    input cen;
    input wait_n;
    input int_n;
    input nmi_n;
    input busrq_n;
    output m1_n;
    output iorq;
    output noread;
    output write;
    output rfsh_n;
    output halt_n;
    output busak_n;
    output [15:0]  a ;
    input [7:0]  dinst ;
    input [7:0]  di ;
    output [7:0]  do ;
    output [2:0]  mc ;
    output [2:0]  ts ;
    output intcycle_n;
    output inte;
    output stop;


    reg Process1__oldnmi_n;
    parameter [2:0] anone='b111;
    parameter [2:0] abc='b000;
    parameter [2:0] ade='b001;
    parameter [2:0] axy='b010;
    parameter [2:0] aioa='b100;
    parameter [2:0] asp='b101;
    parameter [2:0] azi='b110;
    reg [7:0] acc;
    reg [7:0] f;
    reg [7:0] ap;
    reg [7:0] fp;
    reg [7:0] i;
    reg [7:0] r;
    reg [15:0] sp;
    reg [15:0] pc;
    reg [7:0] regdih;
    reg [7:0] regdil;
    wire [15:0] regbusa;
    wire [15:0] regbusb;
    wire [15:0] regbusc;
    reg [2:0] regaddra_r;
    wire [2:0] regaddra;
    reg [2:0] regaddrb_r;
    wire [2:0] regaddrb;
    reg [2:0] regaddrc;
    reg regweh;
    reg regwel;
    reg alternate;
    reg [15:0] tmpaddr;
    reg [7:0] ir;
    reg [1:0] iset;
    reg [15:0] regbusa_r;
    wire [15:0] id16;
    wire [7:0] save_mux;
    reg [2:0] tstate;
    reg [2:0] mcycle;
    reg inte_ff1;
    reg inte_ff2;
    reg halt_ff;
    reg busreq_s;
    reg busack;
    wire clken;
    reg nmi_s;
    reg int_s;
    reg [1:0] istatus;
    wire [7:0] di_reg;
    wire t_res;
    reg [1:0] xy_state;
    reg [2:0] pre_xy_f_m;
    wire nextis_xy_fetch;
    reg xy_ind;
    reg no_btr;
    reg btr_r;
    reg auto_wait;
    reg auto_wait_t1;
    reg auto_wait_t2;
    reg incdecz;
    reg [7:0] busb;
    reg [7:0] busa;
    wire [7:0] alu_q;
    wire [7:0] f_out;
    reg [4:0] read_to_reg_r;
    reg arith16_r;
    reg z16_r;
    reg [3:0] alu_op_r;
    reg save_alu_r;
    reg preservec_r;
    reg [2:0] mcycles;
    wire [2:0] mcycles_d;
    wire [2:0] tstates;
    reg intcycle;
    reg nmicycle;
    wire inc_pc;
    wire inc_wz;
    wire [3:0] incdec_16;
    wire [1:0] prefix;
    wire read_to_acc;
    wire read_to_reg;
    wire [3:0] set_busb_to;
    wire [3:0] set_busa_to;
    wire [3:0] alu_op;
    wire save_alu;
    wire preservec;
    wire arith16;
    wire [2:0] set_addr_to;
    wire jump;
    wire jumpe;
    wire jumpxy;
    wire call;
    wire rstp;
    wire ldz;
    wire ldw;
    wire ldsphl;
    wire iorq_i;
    wire [2:0] special_ld;
    wire exchangedh;
    wire exchangerp;
    wire exchangeaf;
    wire exchangers;
    wire i_djnz;
    wire i_cpl;
    wire i_ccf;
    wire i_scf;
    wire i_retn;
    wire i_bt;
    wire i_bc;
    wire i_btr;
    wire i_rld;
    wire i_rrd;
    wire i_inrc;
    wire setdi;
    wire setei;
    wire [1:0] imode;
    wire halt;
    reg m1_n;
    wire iorq;
    wire noread;
    wire write;
    reg rfsh_n;
    wire halt_n;
    wire busak_n;
    reg [15:0] a;
    reg [7:0] do;
    wire [2:0] mc;
    wire [2:0] ts;
    wire intcycle_n;
    wire inte;
    wire stop;


    
   t80_mcode  #(mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s) mcode(.ir(ir), .iset(iset), .mcycle(mcycle), .f(f), .nmicycle(nmicycle), .intcycle(intcycle), .mcycles(mcycles_d), .tstates(tstates), .prefix(prefix), .inc_pc(inc_pc), .inc_wz(inc_wz), .incdec_16(incdec_16), .read_to_reg(read_to_reg), .read_to_acc(read_to_acc), .set_busa_to(set_busa_to), .set_busb_to(set_busb_to), .alu_op(alu_op), .save_alu(save_alu), .preservec(preservec), .arith16(arith16), .set_addr_to(set_addr_to), .iorq(iorq_i), .jump(jump), .jumpe(jumpe), .jumpxy(jumpxy), .call(call), .rstp(rstp), .ldz(ldz), .ldw(ldw), .ldsphl(ldsphl), .special_ld(special_ld), .exchangedh(exchangedh), .exchangerp(exchangerp), .exchangeaf(exchangeaf), .exchangers(exchangers), .i_djnz(i_djnz), .i_cpl(i_cpl), .i_ccf(i_ccf), .i_scf(i_scf), .i_retn(i_retn), .i_bt(i_bt), .i_bc(i_bc), .i_btr(i_btr), .i_rld(i_rld), .i_rrd(i_rrd), .i_inrc(i_inrc), .setdi(setdi), .setei(setei), .imode(imode), .halt(halt), .noread(noread), .write(write));
   //Parameter Order: mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s 

   t80_alu  #(mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s) alu(.arith16(arith16_r), .z16(z16_r), .alu_op(alu_op_r), .ir(ir[5:0]), .iset(iset), .busa(busa), .busb(busb), .f_in(f), .q(alu_q), .f_out(f_out));
   //Parameter Order: mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s 

   assign {clken}=(cen & ~ (busack));
   
   assign {t_res}=(tstate === $unsigned(tstates)) ? 
                      1'b1
                   :  1'b0;
   
   assign {nextis_xy_fetch}=(((!(xy_state==='b00)) & (xy_ind === 1'b0)) & (((set_addr_to === axy) | ((mcycle === 'b001) & (ir === 'b11001011))) | ((mcycle === 'b001) & (ir === 'b00110110)))) ? 
                                1'b1
                             :  1'b0;
   
   assign {save_mux}=(exchangerp === 1'b1) ? 
                         busb
                      : (save_alu_r === 1'b0) ? 
                         di_reg
                      :  alu_q;
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               begin 
                   pc <= {(15-0+1- 0){1'b0}};
                   a <= {(15-0+1- 0){1'b0}};
                   tmpaddr <= {(15-0+1- 0){1'b0}};
                   ir <= 'b00000000;
                   iset <= 'b00;
                   xy_state <= 'b00;
                   istatus <= 'b00;
                   mcycles <= 'b000;
                   do <= 'b00000000;
                   acc <= {(7-0+1- 0){1'b1}};
                   f <= {(7-0+1- 0){1'b1}};
                   ap <= {(7-0+1- 0){1'b1}};
                   fp <= {(7-0+1- 0){1'b1}};
                   i <= {(7-0+1- 0){1'b0}};
                   r <= {(7-0+1- 0){1'b0}};
                   sp <= {(15-0+1- 0){1'b1}};
                   alternate <= 1'b0;
                   read_to_reg_r <= 'b00000;
                   f <= {(7-0+1- 0){1'b1}};
                   arith16_r <= 1'b0;
                   btr_r <= 1'b0;
                   z16_r <= 1'b0;
                   alu_op_r <= 'b0000;
                   save_alu_r <= 1'b0;
                   preservec_r <= 1'b0;
                   xy_ind <= 1'b0;
               end
               
           else 
               begin 
                   if ((clken === 1'b1)) 
                       begin 
                           alu_op_r <= 'b0000;
                           save_alu_r <= 1'b0;
                           read_to_reg_r <= 'b00000;
                           mcycles <= mcycles_d;
                           if ((!(imode==='b11))) 
                               istatus <= imode;
                               
                           
                           arith16_r <= arith16;
                           preservec_r <= preservec;
                           if (((((iset === 'b10) & (alu_op[2] === 1'b0)) & (alu_op[0] === 1'b1)) & (mcycle === 'b011))) 
                               z16_r <= 1'b1;
                               
                           else 
                               z16_r <= 1'b0;
                               
                           
                           if (((mcycle === 'b001) & (tstate[2] === 1'b0))) 
                               begin 
                                       if (((tstate === 2) & (wait_n === 1'b1))) 
                                           begin 
                                               begin 
                                                   if ((mode < 2)) 
                                                       begin 
                                                           a[7:0] <= r;
                                                           a[15:8] <= i;
                                                           r[6:0] <= (r[6:0] + 1);
                                                       end

                                                   if ((((((jump === 1'b0) & (call === 1'b0)) & (nmicycle === 1'b0)) & (intcycle === 1'b0)) & ~ (((halt_ff === 1'b1) | (halt === 1'b1))))) 
                                                           pc <= (pc + 1);

                                                   if (((intcycle === 1'b1) & (istatus === 'b01))) 
                                                           ir <= 'b11111111;
                                                   else if ((((halt_ff === 1'b1) | ((intcycle === 1'b1) & (istatus === 'b10))) | (nmicycle === 1'b1))) 
                                                           ir <= 'b00000000;
                                                   else 
                                                           ir <= dinst;

                                                   iset <= 'b00;
                                                   if ((!(prefix==='b00))) 
                                                       begin 
                                                               if ((prefix === 'b11)) 
                                                                   begin 
                                                                           if ((ir[5] === 1'b1)) 
                                                                                   xy_state <= 'b10;
                                                                           else 
                                                                                   xy_state <= 'b01;

                                                                           
                                                                   end 
                                                               else 
                                                                   begin 
                                                                       begin 
                                                                           if ((prefix === 'b10)) 
                                                                               begin 
                                                                                   xy_state <= 'b00;
                                                                                   xy_ind <= 1'b0;
                                                                               end

                                                                           iset <= prefix;
                                                                       end
                                                                   end 

                                                               
                                                       end 
                                                   else 
                                                       begin 
                                                           xy_state <= 'b00;
                                                           xy_ind <= 1'b0;
                                                       end

                                                   
                                               end
                                           end 

                                       
                               end 
                           else 
                               begin 
                                   begin 
                                       if ((mcycle === 'b110)) 
                                           begin 
                                               xy_ind <= 1'b1;
                                               if ((prefix === 'b01)) 
                                                       iset <= 'b01;

                                               
                                           end

                                       if ((t_res === 1'b1)) 
                                           begin 
                                               btr_r <= (((i_bt | i_bc) | i_btr) & ~ (no_btr));
                                               if ((jump === 1'b1)) 
                                                   begin 
                                                       a[15:8] <= di_reg;
                                                       a[7:0] <= tmpaddr[7:0];
                                                       pc[15:8] <= $unsigned(di_reg);
                                                       pc[7:0] <= $unsigned(tmpaddr[7:0]);
                                                   end
                                               else if ((jumpxy === 1'b1)) 
                                                   begin 
                                                       a <= regbusc;
                                                       pc <= $unsigned(regbusc);
                                                   end
                                               else if (((call === 1'b1) | (rstp === 1'b1))) 
                                                   begin 
                                                       a <= tmpaddr;
                                                       pc <= $unsigned(tmpaddr);
                                                   end
                                               else if (((mcycle === mcycles) & (nmicycle === 1'b1))) 
                                                   begin 
                                                       a <= 'b0000000001100110;
                                                       pc <= 'b0000000001100110;
                                                   end
                                               else if ((((mcycle === 'b011) & (intcycle === 1'b1)) & (istatus === 'b10))) 
                                                   begin 
                                                       a[15:8] <= i;
                                                       a[7:0] <= tmpaddr[7:0];
                                                       pc[15:8] <= $unsigned(i);
                                                       pc[7:0] <= $unsigned(tmpaddr[7:0]);
                                                   end
                                               else 
                                                       case (set_addr_to)
                                                           'b010 : 
                                                                   if ((xy_state === 'b00)) 
                                                                           a <= regbusc;
                                                                   else 
                                                                       begin 
                                                                               if ((nextis_xy_fetch === 1'b1)) 
                                                                                       a <= pc;
                                                                               else 
                                                                                       a <= tmpaddr;

                                                                               
                                                                       end 

                                                                   
                                                           'b100 : 
                                                               begin 
                                                                   if ((mode === 3)) 
                                                                           a[15:8] <= {(15-8+1- 0){1'b1}};
                                                                   else if ((mode === 2)) 
                                                                           a[15:8] <= di_reg;
                                                                   else 
                                                                           a[15:8] <= acc;

                                                                   a[7:0] <= di_reg;
                                                               end
                                                           'b101 : 
                                                                   a <= sp;
                                                           'b000 : 
                                                                   if (((mode === 3) & (iorq_i === 1'b1))) 
                                                                       begin 
                                                                           a[15:8] <= {(15-8+1- 0){1'b1}};
                                                                           a[7:0] <= regbusc[7:0];
                                                                       end
                                                                   else 
                                                                           a <= regbusc;

                                                                   
                                                           'b001 : 
                                                                   a <= regbusc;
                                                           'b110 : 
                                                                   if ((inc_wz === 1'b1)) 
                                                                           a <= ($unsigned(tmpaddr) + 1);
                                                                   else 
                                                                       begin 
                                                                           a[15:8] <= di_reg;
                                                                           a[7:0] <= tmpaddr[7:0];
                                                                       end

                                                                   
                                                           default : 
                                                                   a <= pc;
                                                       endcase

                                               save_alu_r <= save_alu;
                                               alu_op_r <= alu_op;
                                               if ((i_cpl === 1'b1)) 
                                                   begin 
                                                       acc <= ~ (acc);
                                                       f[flag_y] <= ~ (acc[5]);
                                                       f[flag_h] <= 1'b1;
                                                       f[flag_x] <= ~ (acc[3]);
                                                       f[flag_n] <= 1'b1;
                                                   end

                                               if ((i_ccf === 1'b1)) 
                                                   begin 
                                                       f[flag_c] <= ~ (f[flag_c]);
                                                       f[flag_y] <= acc[5];
                                                       f[flag_h] <= f[flag_c];
                                                       f[flag_x] <= acc[3];
                                                       f[flag_n] <= 1'b0;
                                                   end

                                               if ((i_scf === 1'b1)) 
                                                   begin 
                                                       f[flag_c] <= 1'b1;
                                                       f[flag_y] <= acc[5];
                                                       f[flag_h] <= 1'b0;
                                                       f[flag_x] <= acc[3];
                                                       f[flag_n] <= 1'b0;
                                                   end

                                               
                                           end

                                       if (((tstate === 2) & (wait_n === 1'b1))) 
                                           begin 
                                               begin 
                                                   if (((iset === 'b01) & (mcycle === 'b111))) 
                                                           ir <= dinst;

                                                   if ((jumpe === 1'b1)) 
                                                           pc <= $unsigned(($signed(pc) + $signed(di_reg)));
                                                   else if ((inc_pc === 1'b1)) 
                                                           pc <= (pc + 1);

                                                   if ((btr_r === 1'b1)) 
                                                           pc <= (pc - 2);

                                                   if ((rstp === 1'b1)) 
                                                       begin 
                                                           tmpaddr <= {(15-0+1- 0){1'b0}};
                                                           tmpaddr[5:3] <= ir[5:3];
                                                       end

                                                   
                                               end
                                           end 

                                       if (((tstate === 3) & (mcycle === 'b110))) 
                                               tmpaddr <= ($signed(regbusc) + $signed(di_reg));

                                       if ((((tstate === 2) & (wait_n === 1'b1)) | ((tstate === 4) & (mcycle === 'b001)))) 
                                           begin 
                                                   if ((incdec_16[2:0] === 'b111)) 
                                                       begin 
                                                               if ((incdec_16[3] === 1'b1)) 
                                                                       sp <= (sp - 1);
                                                               else 
                                                                       sp <= (sp + 1);

                                                               
                                                       end 

                                                   
                                           end 

                                       if ((ldsphl === 1'b1)) 
                                               sp <= $unsigned(regbusc);

                                       if ((exchangeaf === 1'b1)) 
                                           begin 
                                               ap <= acc;
                                               acc <= ap;
                                               fp <= f;
                                               f <= fp;
                                           end

                                       if ((exchangers === 1'b1)) 
                                               alternate <= ~ (alternate);

                                       
                                   end
                               end 
                           
                           if ((tstate === 3)) 
                               begin 
                                   begin 
                                       if ((ldz === 1'b1)) 
                                               tmpaddr[7:0] <= di_reg;

                                       if ((ldw === 1'b1)) 
                                               tmpaddr[15:8] <= di_reg;

                                       if ((special_ld[2] === 1'b1)) 
                                               case (special_ld[1:0])
                                                   'b00 : 
                                                       begin 
                                                           acc <= i;
                                                           f[flag_p] <= inte_ff2;
                                                       end
                                                   'b01 : 
                                                       begin 
                                                           acc <= r;
                                                           f[flag_p] <= inte_ff2;
                                                       end
                                                   'b10 : 
                                                           i <= acc;
                                                   default : 
                                                           r <= $unsigned(acc);
                                               endcase

                                       
                                   end
                               end 
                           
                           if ((((i_djnz === 1'b0) & (save_alu_r === 1'b1)) | (alu_op_r === 'b1001))) 
                               begin 
                                       if ((mode === 3)) 
                                           begin 
                                               f[6] <= f_out[6];
                                               f[5] <= f_out[5];
                                               f[7] <= f_out[7];
                                               if ((preservec_r === 1'b0)) 
                                                       f[4] <= f_out[4];

                                               
                                           end
                                       else 
                                           begin 
                                               f[7:1] <= f_out[7:1];
                                               if ((preservec_r === 1'b0)) 
                                                       f[flag_c] <= f_out[0];

                                               
                                           end

                                       
                               end 
                           
                           if (((t_res === 1'b1) & (i_inrc === 1'b1))) 
                               begin 
                                   f[flag_h] <= 1'b0;
                                   f[flag_n] <= 1'b0;
                                   if ((di_reg[7:0] === 'b00000000)) 
                                       f[flag_z] <= 1'b1;
                                       
                                   else 
                                       f[flag_z] <= 1'b0;
                                       
                                   
                                   f[flag_s] <= di_reg[7];
                                   f[flag_p] <= ~ ((((((((di_reg[0] ^ di_reg[1]) ^ di_reg[2]) ^ di_reg[3]) ^ di_reg[4]) ^ di_reg[5]) ^ di_reg[6]) ^ di_reg[7]));
                               end
                               
                           
                           if (((tstate === 1) & (auto_wait_t1 === 1'b0))) 
                               begin 
                                   do <= busb;
                                   if ((i_rld === 1'b1)) 
                                       begin 
                                           do[3:0] <= busa[3:0];
                                           do[7:4] <= busb[3:0];
                                       end
                                       
                                   
                                   if ((i_rrd === 1'b1)) 
                                       begin 
                                           do[3:0] <= busb[7:4];
                                           do[7:4] <= busa[3:0];
                                       end
                                       
                                   
                                   
                               end
                               
                           
                           if ((t_res === 1'b1)) 
                               begin 
                                   read_to_reg_r[3:0] <= set_busa_to;
                                   read_to_reg_r[4] <= read_to_reg;
                                   if ((read_to_acc === 1'b1)) 
                                       begin 
                                           read_to_reg_r[3:0] <= 'b0111;
                                           read_to_reg_r[4] <= 1'b1;
                                       end
                                       
                                   
                                   
                               end
                               
                           
                           if (((tstate === 1) & (i_bt === 1'b1))) 
                               begin 
                                   f[flag_x] <= alu_q[3];
                                   f[flag_y] <= alu_q[1];
                                   f[flag_h] <= 1'b0;
                                   f[flag_n] <= 1'b0;
                               end
                               
                           
                           if (((i_bc === 1'b1) | (i_bt === 1'b1))) 
                               f[flag_p] <= incdecz;
                               
                           
                           if (((((tstate === 1) & (save_alu_r === 1'b0)) & (auto_wait_t1 === 1'b0)) | ((save_alu_r === 1'b1) & (!(alu_op_r==='b0111))))) 
                               case (read_to_reg_r)
                                   'b10111 : 
                                           acc <= save_mux;
                                   'b10110 : 
                                           do <= save_mux;
                                   'b11000 : 
                                           sp[7:0] <= $unsigned(save_mux);
                                   'b11001 : 
                                           sp[15:8] <= $unsigned(save_mux);
                                   'b11011 : 
                                           f <= save_mux;
                                   default : 
                                       ;
                               endcase
                               
                           
                           
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (posedge clk_n ) begin
               begin 
                   if ((clken === 1'b1)) 
                       begin 
                           regaddra_r <= {alternate,set_busa_to[2:1]};
                           if ((((xy_ind === 1'b0) & (!(xy_state==='b00))) & (set_busa_to[2:1] === 'b10))) 
                               regaddra_r <= {xy_state[1],'b11};
                               
                           
                           regaddrb_r <= {alternate,set_busb_to[2:1]};
                           if ((((xy_ind === 1'b0) & (!(xy_state==='b00))) & (set_busb_to[2:1] === 'b10))) 
                               regaddrb_r <= {xy_state[1],'b11};
                               
                           
                           regaddrc <= {alternate,set_addr_to[1:0]};
                           if (((jumpxy === 1'b1) | (ldsphl === 1'b1))) 
                               regaddrc <= {alternate,'b10};
                               
                           
                           if (((((jumpxy === 1'b1) | (ldsphl === 1'b1)) & (!(xy_state==='b00))) | (mcycle === 'b110))) 
                               regaddrc <= {xy_state[1],'b11};
                               
                           
                           if ((((i_djnz === 1'b1) & (save_alu_r === 1'b1)) & (mode < 2))) 
                               incdecz <= f_out[flag_z];
                               
                           
                           if ((((tstate === 2) | ((tstate === 3) & (mcycle === 'b001))) & (incdec_16[2:0] === 'b100))) 
                               begin 
                                       if ((id16 === 0)) 
                                               incdecz <= 1'b0;
                                       else 
                                               incdecz <= 1'b1;

                                       
                               end 
                           
                           regbusa_r <= regbusa;
                       end
                       
                   
                   
               end 
           
   end //always
   
   assign {regaddra}=(((tstate === 2) | (((tstate === 3) & (mcycle === 'b001)) & (incdec_16[2] === 1'b1))) & (xy_state === 'b00)) ? 
                         {alternate,incdec_16[1:0]}
                      : (((tstate === 2) | (((tstate === 3) & (mcycle === 'b001)) & (incdec_16[2] === 1'b1))) & (incdec_16[1:0] === 'b10)) ? 
                         {xy_state[1],'b11}
                      : ((exchangedh === 1'b1) & (tstate === 3)) ? 
                         {alternate,'b10}
                      : ((exchangedh === 1'b1) & (tstate === 4)) ? 
                         {alternate,'b01}
                      :  regaddra_r;
   
   assign {regaddrb}=((exchangedh === 1'b1) & (tstate === 3)) ? 
                         {alternate,'b01}
                      :  regaddrb_r;
   
   assign {id16}=(incdec_16[3] === 1'b1) ? 
                     ($signed(regbusa) - 1)
                  :  ($signed(regbusa) + 1);
   
       
   always @ (save_alu_r or auto_wait_t1 or alu_op_r or read_to_reg_r or exchangedh or incdec_16 or mcycle or tstate or wait_n ) begin
           regweh <= 1'b0;
           regwel <= 1'b0;
           if (((((tstate === 1) & (save_alu_r === 1'b0)) & (auto_wait_t1 === 1'b0)) | ((save_alu_r === 1'b1) & (!(alu_op_r==='b0111))))) 
               case (read_to_reg_r)
                   'b10000,'b10001,'b10010,'b10011,'b10100,'b10101 : 
                       begin 
                           regweh <= ~ (read_to_reg_r[0]);
                           regwel <= read_to_reg_r[0];
                       end
                   default : 
                       ;
               endcase
               
           if (((exchangedh === 1'b1) & ((tstate === 3) | (tstate === 4)))) 
               begin 
                   regweh <= 1'b1;
                   regwel <= 1'b1;
               end
               
           if (((incdec_16[2] === 1'b1) & ((((tstate === 2) & (wait_n === 1'b1)) & (!(mcycle==='b001))) | ((tstate === 3) & (mcycle === 'b001))))) 
               case (incdec_16[1:0])
                   'b00,'b01,'b10 : 
                       begin 
                           regweh <= 1'b1;
                           regwel <= 1'b1;
                       end
                   default : 
                       ;
               endcase
               
           
   end //always
   
       
   always @ (save_mux or regbusb or regbusa_r or id16 or exchangedh or incdec_16 or mcycle or tstate or wait_n ) begin
           regdih <= save_mux;
           regdil <= save_mux;
           if (((exchangedh === 1'b1) & (tstate === 3))) 
               begin 
                   regdih <= regbusb[15:8];
                   regdil <= regbusb[7:0];
               end
               
           if (((exchangedh === 1'b1) & (tstate === 4))) 
               begin 
                   regdih <= regbusa_r[15:8];
                   regdil <= regbusa_r[7:0];
               end
               
           if (((incdec_16[2] === 1'b1) & (((tstate === 2) & (!(mcycle==='b001))) | ((tstate === 3) & (mcycle === 'b001))))) 
               begin 
                   regdih <= id16[15:8];
                   regdil <= id16[7:0];
               end
               
           
   end //always
   
   t80_reg regs(.clk(clk_n), .cen(clken), .weh(regweh), .wel(regwel), .addra(regaddra), .addrb(regaddrb), .addrc(regaddrc), .dih(regdih), .dil(regdil), .doah(regbusa[15:8]), .doal(regbusa[7:0]), .dobh(regbusb[15:8]), .dobl(regbusb[7:0]), .doch(regbusc[15:8]), .docl(regbusc[7:0]));
   
       
   always @ (posedge clk_n ) begin
               begin 
                   if ((clken === 1'b1)) 
                       begin 
                           case (set_busb_to)
                               'b0111 : 
                                       busb <= acc;
                               'b0000,'b0001,'b0010,'b0011,'b0100,'b0101 : 
                                       if ((set_busb_to[0] === 1'b1)) 
                                               busb <= regbusb[7:0];
                                       else 
                                               busb <= regbusb[15:8];

                                       
                               'b0110 : 
                                       busb <= di_reg;
                               'b1000 : 
                                       busb <= sp[7:0];
                               'b1001 : 
                                       busb <= sp[15:8];
                               'b1010 : 
                                       busb <= 'b00000001;
                               'b1011 : 
                                       busb <= f;
                               'b1100 : 
                                       busb <= pc[7:0];
                               'b1101 : 
                                       busb <= pc[15:8];
                               'b1110 : 
                                       busb <= 'b00000000;
                               default : 
                                       busb <= 'bxxxxxxxx;
                           endcase
                           case (set_busa_to)
                               'b0111 : 
                                       busa <= acc;
                               'b0000,'b0001,'b0010,'b0011,'b0100,'b0101 : 
                                       if ((set_busa_to[0] === 1'b1)) 
                                               busa <= regbusa[7:0];
                                       else 
                                               busa <= regbusa[15:8];

                                       
                               'b0110 : 
                                       busa <= di_reg;
                               'b1000 : 
                                       busa <= sp[7:0];
                               'b1001 : 
                                       busa <= sp[15:8];
                               'b1010 : 
                                       busa <= 'b00000000;
                               default : 
                                       busb <= 'bxxxxxxxx;
                           endcase
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               rfsh_n <= 1'b1;
               
           else 
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                               if (((mcycle === 'b001) & (((tstate === 2) & (wait_n === 1'b1)) | (tstate === 3)))) 
                                       rfsh_n <= 1'b0;
                               else 
                                       rfsh_n <= 1'b1;

                               
                       end 
                   
                   
               end 
           
   end //always
   
   assign {mc}=mcycle;
   
   assign {ts}=tstate;
   
   assign {di_reg}=di;
   
   assign {halt_n}=~ (halt_ff);
   
   assign {busak_n}=~ (busack);
   
   assign {intcycle_n}=~ (intcycle);
   
   assign {inte}=inte_ff1;
   
   assign {iorq}=iorq_i;
   
   assign {stop}=i_djnz;
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               begin 
                   busreq_s <= 1'b0;
                   int_s <= 1'b0;
                   nmi_s <= 1'b0;
                   Process1__oldnmi_n = 1'b0;
               end
               
           else 
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                           busreq_s <= ~ (busrq_n);
                           int_s <= ~ (int_n);
                           if ((nmicycle === 1'b1)) 
                               nmi_s <= 1'b0;
                               
                           else if (((nmi_n === 1'b0) & (Process1__oldnmi_n === 1'b1))) 
                               nmi_s <= 1'b1;
                               
                           
                           Process1__oldnmi_n = nmi_n;
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               begin 
                   mcycle <= 'b001;
                   tstate <= 'b000;
                   pre_xy_f_m <= 'b000;
                   halt_ff <= 1'b0;
                   busack <= 1'b0;
                   nmicycle <= 1'b0;
                   intcycle <= 1'b0;
                   inte_ff1 <= 1'b0;
                   inte_ff2 <= 1'b0;
                   no_btr <= 1'b0;
                   auto_wait_t1 <= 1'b0;
                   auto_wait_t2 <= 1'b0;
                   m1_n <= 1'b1;
               end
               
           else 
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                           begin 
                               if ((t_res === 1'b1)) 
                                       auto_wait_t1 <= 1'b0;
                               else 
                                       auto_wait_t1 <= (auto_wait | iorq_i);

                               auto_wait_t2 <= auto_wait_t1;
                               no_btr <= (((i_bt & (~ (ir[4]) | ~ (f[flag_p]))) | (i_bc & ((~ (ir[4]) | f[flag_z]) | ~ (f[flag_p])))) | (i_btr & (~ (ir[4]) | f[flag_z])));
                               if ((tstate === 2)) 
                                   begin 
                                       begin 
                                           if ((setei === 1'b1)) 
                                               begin 
                                                   inte_ff1 <= 1'b1;
                                                   inte_ff2 <= 1'b1;
                                               end

                                           if ((i_retn === 1'b1)) 
                                                   inte_ff1 <= inte_ff2;

                                           
                                       end
                                   end 

                               if ((tstate === 3)) 
                                   begin 
                                           if ((setdi === 1'b1)) 
                                               begin 
                                                   inte_ff1 <= 1'b0;
                                                   inte_ff2 <= 1'b0;
                                               end

                                           
                                   end 

                               if (((intcycle === 1'b1) | (nmicycle === 1'b1))) 
                                       halt_ff <= 1'b0;

                               if ((((mcycle === 'b001) & (tstate === 2)) & (wait_n === 1'b1))) 
                                       m1_n <= 1'b1;

                               if (((busreq_s === 1'b1) & (busack === 1'b1))) 
                                   ;//Null
                               else 
                                   begin 
                                       busack <= 1'b0;
                                       if (((tstate === 2) & (wait_n === 1'b0))) 
                                           ;//Null
                                       else if ((t_res === 1'b1)) 
                                           begin 
                                               begin 
                                                   if ((halt === 1'b1)) 
                                                           halt_ff <= 1'b1;

                                                   if ((busreq_s === 1'b1)) 
                                                           busack <= 1'b1;
                                                   else 
                                                       begin 
                                                           tstate <= 'b001;
                                                           if ((nextis_xy_fetch === 1'b1)) 
                                                               begin 
                                                                   mcycle <= 'b110;
                                                                   pre_xy_f_m <= mcycle;
                                                                   if (((ir === 'b00110110) & (mode === 0))) 
                                                                           pre_xy_f_m <= 'b010;

                                                                   
                                                               end
                                                           else if (((mcycle === 'b111) | (((mcycle === 'b110) & (mode === 1)) & (!(iset==='b01))))) 
                                                                   mcycle <= ($unsigned(pre_xy_f_m) + 1);
                                                           else if ((((mcycle === mcycles) | (no_btr === 1'b1)) | (((mcycle === 'b010) & (i_djnz === 1'b1)) & (incdecz === 1'b1)))) 
                                                               begin 
                                                                   m1_n <= 1'b0;
                                                                   mcycle <= 'b001;
                                                                   intcycle <= 1'b0;
                                                                   nmicycle <= 1'b0;
                                                                   if (((nmi_s === 1'b1) & (prefix === 'b00))) 
                                                                       begin 
                                                                           nmicycle <= 1'b1;
                                                                           inte_ff1 <= 1'b0;
                                                                       end
                                                                   else if (((((inte_ff1 === 1'b1) & (int_s === 1'b1)) & (prefix === 'b00)) & (setei === 1'b0))) 
                                                                       begin 
                                                                           intcycle <= 1'b1;
                                                                           inte_ff1 <= 1'b0;
                                                                           inte_ff2 <= 1'b0;
                                                                       end

                                                                   
                                                               end
                                                           else 
                                                                   mcycle <= ($unsigned(mcycle) + 1);

                                                           
                                                       end

                                                   
                                               end
                                           end 
                                       else 
                                           begin 
                                                   if ((~(((auto_wait === 1'b1) & (auto_wait_t2 === 1'b0)) | (((iowait === 1) & (iorq_i === 1'b1)) & (auto_wait_t1 === 1'b0))))) 
                                                           tstate <= (tstate + 1);

                                                   
                                           end 

                                       
                                   end

                               if ((tstate === 0)) 
                                       m1_n <= 1'b0;

                               
                           end
                       end 
                   
                   
               end 
           
   end //always
   
       
   always @ (intcycle or nmicycle or mcycle ) begin
           auto_wait <= 1'b0;
           if (((intcycle === 1'b1) | (nmicycle === 1'b1))) 
               begin 
                   if ((mcycle === 'b001)) 
                       auto_wait <= 1'b1;
                       
                   
                   
               end 
           
   end //always
    

endmodule
//
// Inferrable Synchronous SRAM for XST synthesis
//
// Version : 0220
//
// Copyright (c) 2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//	0208 : Initial release
//	0218 : Fixed data out at write
//	0220 : Added support for XST


module  ssram ( clk, ce_n, we_n, a, din, dout );
    parameter  [31:0]  addrwidth =11;
    parameter  [31:0]  datawidth =8;
    
    input clk;
    input ce_n;
    input we_n;
    input [(addrwidth - 1):0]  a ;
    input [(datawidth - 1):0]  din ;
    output [(datawidth - 1):0]  dout ;


//type memory_image

reg [(datawidth - 1):0] ram [0:((2<< (addrwidth-1)) - 1)];
    reg [(addrwidth - 1):0] a_r;
    reg [(addrwidth - 1):0] b;
    wire [(datawidth - 1):0] dout;


    
       
   always @ (posedge clk ) begin
               begin 
                   begin 
                       if (((~(ce_n | we_n)) === 1'b1)) 
                           ram[$unsigned(b)] <= din;
                           
                       
                       a_r <= a;
                       b <= a;
                   end
                   
               end 
           
   end //always
   
   assign {dout}=~ (is_x__0(a_r)) ? 
                     ram[$unsigned(a_r)]
                  :  {((datawidth - 1)-0+1- 0){1'bx}};
    
    function [0:0] is_x__0;
        input  [(addrwidth - 1):0] s;
        begin : Function
            begin 
                begin :Block_Name_1
                    integer i;
                    for (i=(addrwidth - 1);i>=0;i=i-1) begin 
                        case (s[i])
                            1'bx,1'bx,1'bz,1'bx,1'bx : 
                                    begin 
                                        is_x__0=1'b1;
                                        disable Function;
                                    end
                            default : 
                                    ;//null
                        endcase
                        
                    end //for
                end //end Block
                begin 
                    is_x__0=1'b0;
                    disable Function;
                end
            end
        end // Function
    endfunction

    

endmodule
//
// 16450 compatible UART with synchronous bus interface
// RClk/BaudOut is XIn enable instead of actual clock
//
// Version : 0249b
//
// Copyright (c) 2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
// 0208 : First release
//
// 0249 : Fixed interrupt and baud rate bugs found by Andy Dyer
//        Added modem status and break detection
//        Added support for 1.5 and 2 stop bits
//
// 0249b : Fixed loopback break generation bugs found by Andy Dyer
//


module  t16450 ( mr_n, xin, rclk, cs_n, rd_n, wr_n, a, d_in, d_out, sin, cts_n, dsr_n, ri_n, dcd_n, sout, rts_n, dtr_n, out1_n, out2_n, baudout, intr );
    
    input mr_n;
    input xin;
    input rclk;
    input cs_n;
    input rd_n;
    input wr_n;
    input [2:0]  a ;
    input [7:0]  d_in ;
    output [7:0]  d_out ;
    input sin;
    input cts_n;
    input dsr_n;
    input ri_n;
    input dcd_n;
    output sout;
    output rts_n;
    output dtr_n;
    output out1_n;
    output out2_n;
    output baudout;
    output intr;


    reg [15:0] Process1__baud_cnt;
    reg [1:0] Process2__samples;
    reg [4:0] Process3__tx_cnt;
    reg [7:0] rbr;
    reg [7:0] thr;
    reg [7:0] ier;
    wire [7:0] iir;
    reg [7:0] lcr;
    reg [7:0] mcr;
    reg [7:0] lsr;
    reg [7:0] msr;
    reg [7:0] scr;
    reg [7:0] dll;
    reg [7:0] dlm;
    wire [7:0] dm0;
    wire [7:0] dm1;
    reg [3:0] msr_in;
    reg [3:0] bit_phase;
    reg [3:0] brk_cnt;
    reg rx_filtered;
    reg [7:0] rx_shiftreg;
    integer rx_bit_cnt;
    reg rx_parity;
    wire rxd;
    reg tx_tick;
    reg [7:0] tx_shiftreg;
    integer tx_bit_cnt;
    reg tx_parity;
    reg tx_next_is_stop;
    reg tx_stop_bit;
    reg txd;
    wire [7:0] d_out;
    wire sout;
    wire rts_n;
    wire dtr_n;
    wire out1_n;
    wire out2_n;
    reg baudout;
    wire intr;


    
   assign {dtr_n}=(mcr[4] | ~ (mcr[0]));
   
   assign {rts_n}=(mcr[4] | ~ (mcr[1]));
   
   assign {out1_n}=(mcr[4] | ~ (mcr[2]));
   
   assign {out2_n}=(mcr[4] | ~ (mcr[3]));
   
   assign {sout}=(mcr[4] | (txd & ~ (lcr[6])));
   
   assign {rxd}=(mcr[4] === 1'b0) ? 
                    sin
                 :  (txd & ~ (lcr[6]));
   
   assign {intr}=~ (iir[0]);
   
   assign {dm0}=(lcr[7] === 1'b1) ? 
                    dll
                 :  rbr;
   
   assign {dm1}=(lcr[7] === 1'b1) ? 
                    dlm
                 :  ier;
   
   assign d_out=a==='b000 ? dm0 : 
           a==='b001 ? dm1 : 
           a==='b010 ? iir : 
           a==='b011 ? lcr : 
           a==='b100 ? mcr : 
           a==='b101 ? lsr : 
           a==='b110 ? msr : 
           scr;
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   thr <= 'b00000000;
                   ier <= 'b00000000;
                   lcr <= 'b00000000;
                   mcr <= 'b00000000;
                   msr[3:0] <= 'b0000;
                   scr <= 'b00000000;
                   dll <= 'b00000000;
                   dlm <= 'b00000000;
               end
               
           else 
               begin 
                   begin 
                       if (((wr_n === 1'b0) & (cs_n === 1'b0))) 
                           case (a)
                               'b000 : 
                                       if ((lcr[7] === 1'b1)) 
                                               dll <= d_in;
                                       else 
                                               thr <= d_in;

                                       
                               'b001 : 
                                       if ((lcr[7] === 1'b1)) 
                                               dlm <= d_in;
                                       else 
                                               ier[3:0] <= d_in[3:0];

                                       
                               'b011 : 
                                       lcr <= d_in;
                               'b100 : 
                                       mcr <= d_in;
                               'b111 : 
                                       scr <= d_in;
                               default : 
                                   ;
                           endcase
                           
                       
                       if ((((rd_n === 1'b0) & (cs_n === 1'b0)) & (a === 'b110))) 
                           msr[3:0] <= 'b0000;
                           
                       
                       if ((!(msr[4]===msr_in[0]))) 
                           msr[0] <= 1'b1;
                           
                       
                       if ((!(msr[5]===msr_in[1]))) 
                           msr[1] <= 1'b1;
                           
                       
                       if (((msr[6] === 1'b0) & (msr_in[2] === 1'b1))) 
                           msr[2] <= 1'b1;
                           
                       
                       if ((!(msr[7]===msr_in[3]))) 
                           msr[3] <= 1'b1;
                           
                       
                       
                   end
                   
               end 
           
   end //always
   
       
   always @ (posedge xin ) begin
               begin 
                   begin 
                       if ((mcr[4] === 1'b0)) 
                           begin 
                               msr[4] <= msr_in[0];
                               msr[5] <= msr_in[1];
                               msr[6] <= msr_in[2];
                               msr[7] <= msr_in[3];
                           end
                           
                       else 
                           begin 
                               msr[4] <= mcr[1];
                               msr[5] <= mcr[0];
                               msr[6] <= mcr[2];
                               msr[7] <= mcr[3];
                           end
                           
                       
                       msr_in[0] <= cts_n;
                       msr_in[1] <= dsr_n;
                       msr_in[2] <= ri_n;
                       msr_in[3] <= dcd_n;
                   end
                   
               end 
           
   end //always
   
   assign {iir[7:3]}='b00000;
   
   assign {iir[2:0]}=((ier[2] === 1'b1) & (!(lsr[4:1]==='b0000))) ? 
                         'b110
                      : ((ier[0] & lsr[0]) === 1'b1) ? 
                         'b100
                      : ((ier[1] & lsr[5]) === 1'b1) ? 
                         'b010
                      : ((ier[3] === 1'b1) & (((mcr[4] === 1'b0) & (!(msr[3:0]==='b0000))) | ((mcr[4] === 1'b1) & (!(mcr[3:0]==='b0000))))) ? 
                         'b000
                      :  'b001;
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   Process1__baud_cnt = 'b0000000000000000;
                   baudout <= 1'b0;
               end
               
           else 
               begin 
                   if (((Process1__baud_cnt[15:1] === 'b000000000000000) | ((((wr_n === 1'b0) & (cs_n === 1'b0)) & (a[2:1] === 'b00)) & (lcr[7] === 1'b1)))) 
                       begin 
                           Process1__baud_cnt[15:8] = $unsigned(dlm);
                           Process1__baud_cnt[7:0] = $unsigned(dll);
                           baudout <= 1'b1;
                       end
                       
                   else 
                       begin 
                           Process1__baud_cnt = (Process1__baud_cnt - 1);
                           baudout <= 1'b0;
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   Process2__samples = 'b11;
                   rx_filtered <= 1'b1;
               end
               
           else 
               begin 
                   begin 
                       if ((rclk === 1'b1)) 
                           begin 
                               Process2__samples[1] = Process2__samples[0];
                               Process2__samples[0] = rxd;
                           end
                           
                       
                       if ((Process2__samples === 'b00)) 
                           rx_filtered <= 1'b0;
                           
                       
                       if ((Process2__samples === 'b11)) 
                           rx_filtered <= 1'b1;
                           
                       
                       
                   end
                   
               end 
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   rbr <= 'b00000000;
                   lsr[4:0] <= 'b00000;
                   bit_phase <= 'b0000;
                   brk_cnt <= 'b0000;
                   rx_shiftreg[7:0] <= 'b00000000;
                   rx_bit_cnt <= 0;
                   rx_parity <= 1'b0;
               end
               
           else 
               begin 
                   begin 
                       if (((((a === 'b000) & (lcr[7] === 1'b0)) & (rd_n === 1'b0)) & (cs_n === 1'b0))) 
                           lsr[0] <= 1'b0;
                           
                       
                       if ((((a === 'b101) & (rd_n === 1'b0)) & (cs_n === 1'b0))) 
                           begin 
                               lsr[4] <= 1'b0;
                               lsr[3] <= 1'b0;
                               lsr[2] <= 1'b0;
                               lsr[1] <= 1'b0;
                           end
                           
                       
                       if ((rclk === 1'b1)) 
                           begin 
                               begin 
                                   if (((rx_bit_cnt === 0) & ((rx_filtered === 1'b1) | (bit_phase === 'b0111)))) 
                                           bit_phase <= 'b0000;
                                   else 
                                           bit_phase <= (bit_phase + 1);

                                   if ((bit_phase === 'b1111)) 
                                       begin 
                                           begin 
                                               if ((rx_filtered === 1'b1)) 
                                                       brk_cnt <= 'b0000;
                                               else 
                                                       brk_cnt <= (brk_cnt + 1);

                                               if ((brk_cnt === 'b1100)) 
                                                       lsr[4] <= 1'b1;

                                               
                                           end
                                       end 

                                   if ((rx_bit_cnt === 0)) 
                                       begin 
                                               if ((bit_phase === 'b0111)) 
                                                   begin 
                                                       rx_bit_cnt <= (rx_bit_cnt + 1);
                                                       rx_parity <= ~ (lcr[4]);
                                                   end

                                               
                                       end 
                                   else if ((bit_phase === 'b1111)) 
                                       begin 
                                           rx_bit_cnt <= (rx_bit_cnt + 1);
                                           if ((rx_bit_cnt === 10)) 
                                               begin 
                                                   rx_bit_cnt <= 0;
                                                   lsr[0] <= 1'b1;
                                                   lsr[3] <= ~ (rx_filtered);
                                               end
                                           else if ((((((rx_bit_cnt === 9) & (lcr[1:0] === 'b11)) | ((rx_bit_cnt === 8) & (lcr[1:0] === 'b10))) | ((rx_bit_cnt === 7) & (lcr[1:0] === 'b01))) | ((rx_bit_cnt === 6) & (lcr[1:0] === 'b00)))) 
                                               begin 
                                                   rx_bit_cnt <= 0;
                                                   if ((lcr[3] === 1'b1)) 
                                                       begin 
                                                           rx_bit_cnt <= 10;
                                                           if ((lcr[5] === 1'b1)) 
                                                               begin 
                                                                       if ((rx_filtered === lcr[4])) 
                                                                               lsr[2] <= 1'b1;

                                                                       
                                                               end 
                                                           else 
                                                               begin 
                                                                       if ((!(rx_filtered===rx_parity))) 
                                                                               lsr[2] <= 1'b1;

                                                                       
                                                               end 

                                                           
                                                       end
                                                   else 
                                                       begin 
                                                           lsr[0] <= 1'b1;
                                                           lsr[3] <= ~ (rx_filtered);
                                                       end

                                                   rbr <= rx_shiftreg[7:0];
                                                   lsr[1] <= lsr[0];
                                                   if ((((a === 'b101) & (rd_n === 1'b0)) & (cs_n === 1'b0))) 
                                                           lsr[1] <= 1'b0;

                                                   
                                               end
                                           else 
                                               begin 
                                                   rx_shiftreg[6:0] <= rx_shiftreg[7:1];
                                                   rx_shiftreg[7] <= rx_filtered;
                                                   if ((lcr[1:0] === 'b10)) 
                                                       begin 
                                                           rx_shiftreg[7] <= 1'b0;
                                                           rx_shiftreg[6] <= rx_filtered;
                                                       end

                                                   if ((lcr[1:0] === 'b01)) 
                                                       begin 
                                                           rx_shiftreg[7] <= 1'b0;
                                                           rx_shiftreg[6] <= 1'b0;
                                                           rx_shiftreg[5] <= rx_filtered;
                                                       end

                                                   if ((lcr[1:0] === 'b00)) 
                                                       begin 
                                                           rx_shiftreg[7] <= 1'b0;
                                                           rx_shiftreg[6] <= 1'b0;
                                                           rx_shiftreg[5] <= 1'b0;
                                                           rx_shiftreg[4] <= rx_filtered;
                                                       end

                                                   rx_parity <= (rx_filtered ^ rx_parity);
                                               end

                                           
                                       end

                                   
                               end
                           end 
                       
                       
                   end
                   
               end 
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   Process3__tx_cnt = 'b00000;
                   tx_tick <= 1'b0;
               end
               
           else 
               begin 
                   tx_tick <= 1'b0;
                   if ((rclk === 1'b1)) 
                       begin 
                           Process3__tx_cnt = (Process3__tx_cnt + 1);
                           if (((lcr[2] === 1'b1) & (tx_stop_bit === 1'b1))) 
                               begin 
                                       if ((lcr[1:0] === 'b00)) 
                                           begin 
                                                   if ((Process3__tx_cnt === 'b10111)) 
                                                       begin 
                                                           tx_tick <= 1'b1;
                                                           Process3__tx_cnt[3:0] = 'b0000;
                                                       end

                                                   
                                           end 
                                       else 
                                           begin 
                                                   if ((Process3__tx_cnt === 'b11111)) 
                                                       begin 
                                                           tx_tick <= 1'b1;
                                                           Process3__tx_cnt[3:0] = 'b0000;
                                                       end

                                                   
                                           end 

                                       
                               end 
                           else 
                               begin 
                                   Process3__tx_cnt[4] = 1'b1;
                                   if ((Process3__tx_cnt[3:0] === 'b1111)) 
                                       tx_tick <= 1'b1;
                                       
                                   
                                   
                               end
                               
                           
                           
                       end
                       
                   
                   
               end
               
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   lsr[7:5] <= 'b011;
                   tx_bit_cnt <= 0;
                   tx_shiftreg <= {(7-0+1- 0){1'b0}};
                   txd <= 1'b1;
                   tx_parity <= 1'b0;
                   tx_next_is_stop <= 1'b0;
                   tx_stop_bit <= 1'b0;
               end
               
           else 
               begin 
                   begin 
                       if ((tx_tick === 1'b1)) 
                           begin 
                               tx_next_is_stop <= 1'b0;
                               tx_stop_bit <= tx_next_is_stop;
                               case (tx_bit_cnt)
                                   0 : begin 
                                           if ((lsr[5] <= 1'b0)) 
                                                   tx_bit_cnt <= 1;

                                           txd <= 1'b1;
                                       end
                                   1 : begin 
                                           tx_shiftreg[7:0] <= thr;
                                           lsr[5] <= 1'b1;
                                           txd <= 1'b0;
                                           tx_parity <= ~ (lcr[4]);
                                           tx_bit_cnt <= (tx_bit_cnt + 1);
                                       end
                                   10 : 
                                       begin 
                                           txd <= tx_parity;
                                           if ((lcr[5] === 1'b1)) 
                                                   txd <= ~ (lcr[4]);

                                           tx_bit_cnt <= 0;
                                           tx_next_is_stop <= 1'b1;
                                       end
                                   default : 
                                       begin 
                                           tx_bit_cnt <= (tx_bit_cnt + 1);
                                           if ((((((tx_bit_cnt === 9) & (lcr[1:0] === 'b11)) | ((tx_bit_cnt === 8) & (lcr[1:0] === 'b10))) | ((tx_bit_cnt === 7) & (lcr[1:0] === 'b01))) | ((tx_bit_cnt === 6) & (lcr[1:0] === 'b00)))) 
                                               begin 
                                                   tx_bit_cnt <= 0;
                                                   if ((lcr[3] === 1'b1)) 
                                                           tx_bit_cnt <= 10;
                                                   else 
                                                           tx_next_is_stop <= 1'b1;

                                                   lsr[6] <= 1'b1;
                                               end

                                           txd <= tx_shiftreg[0];
                                           tx_shiftreg[6:0] <= tx_shiftreg[7:1];
                                           tx_parity <= (tx_shiftreg[0] ^ tx_parity);
                                       end
                               endcase
                           end
                           
                       
                       if (((((wr_n === 1'b0) & (cs_n === 1'b0)) & (a === 'b000)) & (lcr[7] === 1'b0))) 
                           begin 
                               lsr[5] <= 1'b0;
                               lsr[6] <= 1'b0;
                           end
                           
                       
                       
                   end
                   
               end 
           
   end //always
    

endmodule
//
// File I/O test-bench utilities
//
// Version : 0146
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//

//
// Simple SRAM model without timing
//
// Version : 0247
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//


module  sram ( ce_n, oe_n, we_n, a, d );
    parameter  [31:0]  addrwidth =16;
    parameter  [31:0]  datawidth =8;
    
    input ce_n;
    input oe_n;
    input we_n;
    input [(addrwidth - 1):0]  a ;
    inout [(datawidth - 1):0]  d ;


//type memory_image

reg [(datawidth - 1):0] ram [0:((2<< (addrwidth-1)) - 1)];
    wire write;
    reg [7:0] d_del;
    wire [(datawidth - 1):0] d;

      `define Print_Port_Address 12'h3e8  //got z80_test.map file
      `define Print_CAHR_Port_Address 12'h3e9
      `define Print_INT_Port_Address 12'h3eb  // LAST ADDRESS
      `define Print_LONG_Port_Address 12'h3ef  // LAST ADDRESS

	task Cprint;// String OUT until the byte 00 or xx detected with least Byte first and justified.
		integer i;
		begin :Block
			i=0;
			while (1) begin
				if (char_buffer[i*8 +:8] ===8'h00 || char_buffer[i*8 +:8]===8'hxx) begin
						disable Block;
				end	
				$write("%c",char_buffer[i*8 +:8]);
				i=i+1;  
			end
		end
	endtask

   reg [0:639] char_buffer;
   integer  counter=0;    
   always @ (negedge write ) begin
             //  ram[$unsigned(a)] <= d_del;
                     //	if (a >=0 && a<10000 && a !=`Print_Port_Address) $display("%h %h",a,d_del);
           	   if (a==`Print_Port_Address) begin
				if (d_del===8'h00) begin
					
				      char_buffer[counter*8 +:8]=d_del;
					if (char_buffer[0  +:8*7]==="$finish") begin
							$stop;				
							
					end else if (char_buffer[0  +:8*5]==="$time") begin
							$display("Current Time on Simulation=%d",$time);				
							
					end else  Cprint;//$write("%s",char_buffer);

					for (counter=0; counter< 80; counter=counter+1) begin
						char_buffer[counter*8 +:8]=8'h00;
					end
					counter=0;
				end else begin
					char_buffer[counter*8 +:8]=d_del;
					counter=counter+1;
				end
		   end
       	   else if (a==`Print_CAHR_Port_Address) begin
				$write("%h ",d_del);
		   end else if (a==`Print_INT_Port_Address) begin
				#10 $write("%h ",{ram[a],ram[a-1]});
		   end else if (a==`Print_LONG_Port_Address) begin
				#10 $write("%h ",{ram[a],ram[a-1],ram[a-2],ram[a-3]});
		   end 
   end //always
    
   assign {write}=((ce_n === 1'b0) & (we_n === 1'b0)) ? 
                      1'b1
                   :  1'b0;
   
   always #(1* `ns) {d_del}<=d;
   
       
   always @ (negedge write ) begin
               ram[$unsigned(a)] <= d_del;
               
           
   end //always
   
   assign {d}=((((oe_n === 1'b0) & (ce_n === 1'b0)) & (we_n === 1'b1)) & ~ (is_x__0(a))) ? 
                  ram[$unsigned(a)]
               :  {((datawidth - 1)-0+1- 0){1'bz}};
    
    function [0:0] is_x__0;
        input  [(addrwidth - 1):0] s;
        begin : Function
            begin 
                begin :Block_Name_1
                    integer i;
                    for (i=(addrwidth - 1);i>=0;i=i-1) begin 
                        case (s[i])
                            1'bx,1'bx,1'bz,1'bx,1'bx : 
                                    begin 
                                        is_x__0=1'b1;
                                        disable Function;
                                    end
                            default : 
                                    ;//null
                        endcase
                        
                    end //for
                end //end Block
                begin 
                    is_x__0=1'b0;
                    disable Function;
                end
            end
        end // Function
    endfunction

    

endmodule
// This file was generated with hex2rom written by Daniel Wallner


module  rom80 ( ce_n, oe_n, a, d );
    
    input ce_n;
    input oe_n;
    input [14:0]  a ;
    output [7:0]  d ;


        reg [7:0] rom [0:16383];
   initial begin
           rom[ 0+ 0] ='b11000011;
           rom[ 0+ 1] ='b00000000;
           rom[ 0+ 2] ='b00000001;
           rom[ 0+ 3] ='bxxxxxxxx;
           rom[ 0+ 4] ='bxxxxxxxx;
           rom[ 0+ 5] ='bxxxxxxxx;
           rom[ 0+ 6] ='bxxxxxxxx;
           rom[ 0+ 7] ='bxxxxxxxx;
           rom[ 0+ 8] ='b11101101;
           rom[ 0+ 9] ='b01001101;
           rom[ 0+10] ='bxxxxxxxx;
           rom[ 0+11] ='bxxxxxxxx;
           rom[ 0+12] ='bxxxxxxxx;
           rom[ 0+13] ='bxxxxxxxx;
           rom[ 0+14] ='bxxxxxxxx;
           rom[ 0+15] ='bxxxxxxxx;
           rom[ 0+16] ='b11101101;
           rom[ 0+17] ='b01001101;
           rom[ 0+18] ='bxxxxxxxx;
           rom[ 0+19] ='bxxxxxxxx;
           rom[ 0+20] ='bxxxxxxxx;
           rom[ 0+21] ='bxxxxxxxx;
           rom[ 0+22] ='bxxxxxxxx;
           rom[ 0+23] ='bxxxxxxxx;
           rom[ 0+24] ='b11101101;
           rom[ 0+25] ='b01001101;
           rom[ 0+26] ='bxxxxxxxx;
           rom[ 0+27] ='bxxxxxxxx;
           rom[ 0+28] ='bxxxxxxxx;
           rom[ 0+29] ='bxxxxxxxx;
           rom[ 0+30] ='bxxxxxxxx;
           rom[ 0+31] ='bxxxxxxxx;
           rom[ 0+32] ='b11101101;
           rom[ 0+33] ='b01001101;
           rom[ 0+34] ='bxxxxxxxx;
           rom[ 0+35] ='bxxxxxxxx;
           rom[ 0+36] ='bxxxxxxxx;
           rom[ 0+37] ='bxxxxxxxx;
           rom[ 0+38] ='bxxxxxxxx;
           rom[ 0+39] ='bxxxxxxxx;
           rom[ 0+40] ='b11101101;
           rom[ 0+41] ='b01001101;
           rom[ 0+42] ='bxxxxxxxx;
           rom[ 0+43] ='bxxxxxxxx;
           rom[ 0+44] ='bxxxxxxxx;
           rom[ 0+45] ='bxxxxxxxx;
           rom[ 0+46] ='bxxxxxxxx;
           rom[ 0+47] ='bxxxxxxxx;
           rom[ 0+48] ='b11101101;
           rom[ 0+49] ='b01001101;
           rom[ 0+50] ='bxxxxxxxx;
           rom[ 0+51] ='bxxxxxxxx;
           rom[ 0+52] ='bxxxxxxxx;
           rom[ 0+53] ='bxxxxxxxx;
           rom[ 0+54] ='bxxxxxxxx;
           rom[ 0+55] ='bxxxxxxxx;
           rom[ 0+56] ='b11101101;
           rom[ 0+57] ='b01001101;
           rom[ 0+58] ='bxxxxxxxx;
           rom[ 0+59] ='bxxxxxxxx;
           rom[ 0+60] ='bxxxxxxxx;
           rom[ 0+61] ='bxxxxxxxx;
           rom[ 0+62] ='bxxxxxxxx;
           rom[ 0+63] ='bxxxxxxxx;
           rom[ 0+64] ='bxxxxxxxx;
           rom[ 0+65] ='bxxxxxxxx;
           rom[ 0+66] ='bxxxxxxxx;
           rom[ 0+67] ='bxxxxxxxx;
           rom[ 0+68] ='bxxxxxxxx;
           rom[ 0+69] ='bxxxxxxxx;
           rom[ 0+70] ='bxxxxxxxx;
           rom[ 0+71] ='bxxxxxxxx;
           rom[ 0+72] ='bxxxxxxxx;
           rom[ 0+73] ='bxxxxxxxx;
           rom[ 0+74] ='bxxxxxxxx;
           rom[ 0+75] ='bxxxxxxxx;
           rom[ 0+76] ='bxxxxxxxx;
           rom[ 0+77] ='bxxxxxxxx;
           rom[ 0+78] ='bxxxxxxxx;
           rom[ 0+79] ='bxxxxxxxx;
           rom[ 0+80] ='bxxxxxxxx;
           rom[ 0+81] ='bxxxxxxxx;
           rom[ 0+82] ='bxxxxxxxx;
           rom[ 0+83] ='bxxxxxxxx;
           rom[ 0+84] ='bxxxxxxxx;
           rom[ 0+85] ='bxxxxxxxx;
           rom[ 0+86] ='bxxxxxxxx;
           rom[ 0+87] ='bxxxxxxxx;
           rom[ 0+88] ='bxxxxxxxx;
           rom[ 0+89] ='bxxxxxxxx;
           rom[ 0+90] ='bxxxxxxxx;
           rom[ 0+91] ='bxxxxxxxx;
           rom[ 0+92] ='bxxxxxxxx;
           rom[ 0+93] ='bxxxxxxxx;
           rom[ 0+94] ='bxxxxxxxx;
           rom[ 0+95] ='bxxxxxxxx;
           rom[ 0+96] ='bxxxxxxxx;
           rom[ 0+97] ='bxxxxxxxx;
           rom[ 0+98] ='bxxxxxxxx;
           rom[ 0+99] ='bxxxxxxxx;
           rom[ 0+100] ='bxxxxxxxx;
           rom[ 0+101] ='bxxxxxxxx;
           rom[ 0+102] ='bxxxxxxxx;
           rom[ 0+103] ='bxxxxxxxx;
           rom[ 0+104] ='bxxxxxxxx;
           rom[ 0+105] ='bxxxxxxxx;
           rom[ 0+106] ='bxxxxxxxx;
           rom[ 0+107] ='bxxxxxxxx;
           rom[ 0+108] ='bxxxxxxxx;
           rom[ 0+109] ='bxxxxxxxx;
           rom[ 0+110] ='bxxxxxxxx;
           rom[ 0+111] ='bxxxxxxxx;
           rom[ 0+112] ='bxxxxxxxx;
           rom[ 0+113] ='bxxxxxxxx;
           rom[ 0+114] ='bxxxxxxxx;
           rom[ 0+115] ='bxxxxxxxx;
           rom[ 0+116] ='bxxxxxxxx;
           rom[ 0+117] ='bxxxxxxxx;
           rom[ 0+118] ='bxxxxxxxx;
           rom[ 0+119] ='bxxxxxxxx;
           rom[ 0+120] ='bxxxxxxxx;
           rom[ 0+121] ='bxxxxxxxx;
           rom[ 0+122] ='bxxxxxxxx;
           rom[ 0+123] ='bxxxxxxxx;
           rom[ 0+124] ='bxxxxxxxx;
           rom[ 0+125] ='bxxxxxxxx;
           rom[ 0+126] ='bxxxxxxxx;
           rom[ 0+127] ='bxxxxxxxx;
           rom[ 0+128] ='bxxxxxxxx;
           rom[ 0+129] ='bxxxxxxxx;
           rom[ 0+130] ='bxxxxxxxx;
           rom[ 0+131] ='bxxxxxxxx;
           rom[ 0+132] ='bxxxxxxxx;
           rom[ 0+133] ='bxxxxxxxx;
           rom[ 0+134] ='bxxxxxxxx;
           rom[ 0+135] ='bxxxxxxxx;
           rom[ 0+136] ='bxxxxxxxx;
           rom[ 0+137] ='bxxxxxxxx;
           rom[ 0+138] ='bxxxxxxxx;
           rom[ 0+139] ='bxxxxxxxx;
           rom[ 0+140] ='bxxxxxxxx;
           rom[ 0+141] ='bxxxxxxxx;
           rom[ 0+142] ='bxxxxxxxx;
           rom[ 0+143] ='bxxxxxxxx;
           rom[ 0+144] ='bxxxxxxxx;
           rom[ 0+145] ='bxxxxxxxx;
           rom[ 0+146] ='bxxxxxxxx;
           rom[ 0+147] ='bxxxxxxxx;
           rom[ 0+148] ='bxxxxxxxx;
           rom[ 0+149] ='bxxxxxxxx;
           rom[ 0+150] ='bxxxxxxxx;
           rom[ 0+151] ='bxxxxxxxx;
           rom[ 0+152] ='bxxxxxxxx;
           rom[ 0+153] ='bxxxxxxxx;
           rom[ 0+154] ='bxxxxxxxx;
           rom[ 0+155] ='bxxxxxxxx;
           rom[ 0+156] ='bxxxxxxxx;
           rom[ 0+157] ='bxxxxxxxx;
           rom[ 0+158] ='bxxxxxxxx;
           rom[ 0+159] ='bxxxxxxxx;
           rom[ 0+160] ='bxxxxxxxx;
           rom[ 0+161] ='bxxxxxxxx;
           rom[ 0+162] ='bxxxxxxxx;
           rom[ 0+163] ='bxxxxxxxx;
           rom[ 0+164] ='bxxxxxxxx;
           rom[ 0+165] ='bxxxxxxxx;
           rom[ 0+166] ='bxxxxxxxx;
           rom[ 0+167] ='bxxxxxxxx;
           rom[ 0+168] ='bxxxxxxxx;
           rom[ 0+169] ='bxxxxxxxx;
           rom[ 0+170] ='bxxxxxxxx;
           rom[ 0+171] ='bxxxxxxxx;
           rom[ 0+172] ='bxxxxxxxx;
           rom[ 0+173] ='bxxxxxxxx;
           rom[ 0+174] ='bxxxxxxxx;
           rom[ 0+175] ='bxxxxxxxx;
           rom[ 0+176] ='bxxxxxxxx;
           rom[ 0+177] ='bxxxxxxxx;
           rom[ 0+178] ='bxxxxxxxx;
           rom[ 0+179] ='bxxxxxxxx;
           rom[ 0+180] ='bxxxxxxxx;
           rom[ 0+181] ='bxxxxxxxx;
           rom[ 0+182] ='bxxxxxxxx;
           rom[ 0+183] ='bxxxxxxxx;
           rom[ 0+184] ='bxxxxxxxx;
           rom[ 0+185] ='bxxxxxxxx;
           rom[ 0+186] ='bxxxxxxxx;
           rom[ 0+187] ='bxxxxxxxx;
           rom[ 0+188] ='bxxxxxxxx;
           rom[ 0+189] ='bxxxxxxxx;
           rom[ 0+190] ='bxxxxxxxx;
           rom[ 0+191] ='bxxxxxxxx;
           rom[ 0+192] ='bxxxxxxxx;
           rom[ 0+193] ='bxxxxxxxx;
           rom[ 0+194] ='bxxxxxxxx;
           rom[ 0+195] ='bxxxxxxxx;
           rom[ 0+196] ='bxxxxxxxx;
           rom[ 0+197] ='bxxxxxxxx;
           rom[ 0+198] ='bxxxxxxxx;
           rom[ 0+199] ='bxxxxxxxx;
           rom[ 0+200] ='bxxxxxxxx;
           rom[ 0+201] ='bxxxxxxxx;
           rom[ 0+202] ='bxxxxxxxx;
           rom[ 0+203] ='bxxxxxxxx;
           rom[ 0+204] ='bxxxxxxxx;
           rom[ 0+205] ='bxxxxxxxx;
           rom[ 0+206] ='bxxxxxxxx;
           rom[ 0+207] ='bxxxxxxxx;
           rom[ 0+208] ='bxxxxxxxx;
           rom[ 0+209] ='bxxxxxxxx;
           rom[ 0+210] ='bxxxxxxxx;
           rom[ 0+211] ='bxxxxxxxx;
           rom[ 0+212] ='bxxxxxxxx;
           rom[ 0+213] ='bxxxxxxxx;
           rom[ 0+214] ='bxxxxxxxx;
           rom[ 0+215] ='bxxxxxxxx;
           rom[ 0+216] ='bxxxxxxxx;
           rom[ 0+217] ='bxxxxxxxx;
           rom[ 0+218] ='bxxxxxxxx;
           rom[ 0+219] ='bxxxxxxxx;
           rom[ 0+220] ='bxxxxxxxx;
           rom[ 0+221] ='bxxxxxxxx;
           rom[ 0+222] ='bxxxxxxxx;
           rom[ 0+223] ='bxxxxxxxx;
           rom[ 0+224] ='bxxxxxxxx;
           rom[ 0+225] ='bxxxxxxxx;
           rom[ 0+226] ='bxxxxxxxx;
           rom[ 0+227] ='bxxxxxxxx;
           rom[ 0+228] ='bxxxxxxxx;
           rom[ 0+229] ='bxxxxxxxx;
           rom[ 0+230] ='bxxxxxxxx;
           rom[ 0+231] ='bxxxxxxxx;
           rom[ 0+232] ='bxxxxxxxx;
           rom[ 0+233] ='bxxxxxxxx;
           rom[ 0+234] ='bxxxxxxxx;
           rom[ 0+235] ='bxxxxxxxx;
           rom[ 0+236] ='bxxxxxxxx;
           rom[ 0+237] ='bxxxxxxxx;
           rom[ 0+238] ='bxxxxxxxx;
           rom[ 0+239] ='bxxxxxxxx;
           rom[ 0+240] ='bxxxxxxxx;
           rom[ 0+241] ='bxxxxxxxx;
           rom[ 0+242] ='bxxxxxxxx;
           rom[ 0+243] ='bxxxxxxxx;
           rom[ 0+244] ='bxxxxxxxx;
           rom[ 0+245] ='bxxxxxxxx;
           rom[ 0+246] ='bxxxxxxxx;
           rom[ 0+247] ='bxxxxxxxx;
           rom[ 0+248] ='bxxxxxxxx;
           rom[ 0+249] ='bxxxxxxxx;
           rom[ 0+250] ='bxxxxxxxx;
           rom[ 0+251] ='bxxxxxxxx;
           rom[ 0+252] ='bxxxxxxxx;
           rom[ 0+253] ='bxxxxxxxx;
           rom[ 0+254] ='bxxxxxxxx;
           rom[ 0+255] ='bxxxxxxxx;
           rom[ 0+256] ='b00110001;
           rom[ 0+257] ='b11111111;
           rom[ 0+258] ='b11111111;
           rom[ 0+259] ='b11001101;
           rom[ 0+260] ='b01111111;
           rom[ 0+261] ='b00111111;
           rom[ 0+262] ='b11001101;
           rom[ 0+263] ='b11110111;
           rom[ 0+264] ='b00100000;
           rom[ 0+265] ='b11000011;
           rom[ 0+266] ='b00000100;
           rom[ 0+267] ='b00000010;
           rom[ 0+268] ='bxxxxxxxx;
           rom[ 0+269] ='bxxxxxxxx;
           rom[ 0+270] ='bxxxxxxxx;
           rom[ 0+271] ='bxxxxxxxx;
           rom[ 0+272] ='bxxxxxxxx;
           rom[ 0+273] ='bxxxxxxxx;
           rom[ 0+274] ='bxxxxxxxx;
           rom[ 0+275] ='bxxxxxxxx;
           rom[ 0+276] ='bxxxxxxxx;
           rom[ 0+277] ='bxxxxxxxx;
           rom[ 0+278] ='bxxxxxxxx;
           rom[ 0+279] ='bxxxxxxxx;
           rom[ 0+280] ='bxxxxxxxx;
           rom[ 0+281] ='bxxxxxxxx;
           rom[ 0+282] ='bxxxxxxxx;
           rom[ 0+283] ='bxxxxxxxx;
           rom[ 0+284] ='bxxxxxxxx;
           rom[ 0+285] ='bxxxxxxxx;
           rom[ 0+286] ='bxxxxxxxx;
           rom[ 0+287] ='bxxxxxxxx;
           rom[ 0+288] ='bxxxxxxxx;
           rom[ 0+289] ='bxxxxxxxx;
           rom[ 0+290] ='bxxxxxxxx;
           rom[ 0+291] ='bxxxxxxxx;
           rom[ 0+292] ='bxxxxxxxx;
           rom[ 0+293] ='bxxxxxxxx;
           rom[ 0+294] ='bxxxxxxxx;
           rom[ 0+295] ='bxxxxxxxx;
           rom[ 0+296] ='bxxxxxxxx;
           rom[ 0+297] ='bxxxxxxxx;
           rom[ 0+298] ='bxxxxxxxx;
           rom[ 0+299] ='bxxxxxxxx;
           rom[ 0+300] ='bxxxxxxxx;
           rom[ 0+301] ='bxxxxxxxx;
           rom[ 0+302] ='bxxxxxxxx;
           rom[ 0+303] ='bxxxxxxxx;
           rom[ 0+304] ='bxxxxxxxx;
           rom[ 0+305] ='bxxxxxxxx;
           rom[ 0+306] ='bxxxxxxxx;
           rom[ 0+307] ='bxxxxxxxx;
           rom[ 0+308] ='bxxxxxxxx;
           rom[ 0+309] ='bxxxxxxxx;
           rom[ 0+310] ='bxxxxxxxx;
           rom[ 0+311] ='bxxxxxxxx;
           rom[ 0+312] ='bxxxxxxxx;
           rom[ 0+313] ='bxxxxxxxx;
           rom[ 0+314] ='bxxxxxxxx;
           rom[ 0+315] ='bxxxxxxxx;
           rom[ 0+316] ='bxxxxxxxx;
           rom[ 0+317] ='bxxxxxxxx;
           rom[ 0+318] ='bxxxxxxxx;
           rom[ 0+319] ='bxxxxxxxx;
           rom[ 0+320] ='bxxxxxxxx;
           rom[ 0+321] ='bxxxxxxxx;
           rom[ 0+322] ='bxxxxxxxx;
           rom[ 0+323] ='bxxxxxxxx;
           rom[ 0+324] ='bxxxxxxxx;
           rom[ 0+325] ='bxxxxxxxx;
           rom[ 0+326] ='bxxxxxxxx;
           rom[ 0+327] ='bxxxxxxxx;
           rom[ 0+328] ='bxxxxxxxx;
           rom[ 0+329] ='bxxxxxxxx;
           rom[ 0+330] ='bxxxxxxxx;
           rom[ 0+331] ='bxxxxxxxx;
           rom[ 0+332] ='bxxxxxxxx;
           rom[ 0+333] ='bxxxxxxxx;
           rom[ 0+334] ='bxxxxxxxx;
           rom[ 0+335] ='bxxxxxxxx;
           rom[ 0+336] ='bxxxxxxxx;
           rom[ 0+337] ='bxxxxxxxx;
           rom[ 0+338] ='bxxxxxxxx;
           rom[ 0+339] ='bxxxxxxxx;
           rom[ 0+340] ='bxxxxxxxx;
           rom[ 0+341] ='bxxxxxxxx;
           rom[ 0+342] ='bxxxxxxxx;
           rom[ 0+343] ='bxxxxxxxx;
           rom[ 0+344] ='bxxxxxxxx;
           rom[ 0+345] ='bxxxxxxxx;
           rom[ 0+346] ='bxxxxxxxx;
           rom[ 0+347] ='bxxxxxxxx;
           rom[ 0+348] ='bxxxxxxxx;
           rom[ 0+349] ='bxxxxxxxx;
           rom[ 0+350] ='bxxxxxxxx;
           rom[ 0+351] ='bxxxxxxxx;
           rom[ 0+352] ='bxxxxxxxx;
           rom[ 0+353] ='bxxxxxxxx;
           rom[ 0+354] ='bxxxxxxxx;
           rom[ 0+355] ='bxxxxxxxx;
           rom[ 0+356] ='bxxxxxxxx;
           rom[ 0+357] ='bxxxxxxxx;
           rom[ 0+358] ='bxxxxxxxx;
           rom[ 0+359] ='bxxxxxxxx;
           rom[ 0+360] ='bxxxxxxxx;
           rom[ 0+361] ='bxxxxxxxx;
           rom[ 0+362] ='bxxxxxxxx;
           rom[ 0+363] ='bxxxxxxxx;
           rom[ 0+364] ='bxxxxxxxx;
           rom[ 0+365] ='bxxxxxxxx;
           rom[ 0+366] ='bxxxxxxxx;
           rom[ 0+367] ='bxxxxxxxx;
           rom[ 0+368] ='bxxxxxxxx;
           rom[ 0+369] ='bxxxxxxxx;
           rom[ 0+370] ='bxxxxxxxx;
           rom[ 0+371] ='bxxxxxxxx;
           rom[ 0+372] ='bxxxxxxxx;
           rom[ 0+373] ='bxxxxxxxx;
           rom[ 0+374] ='bxxxxxxxx;
           rom[ 0+375] ='bxxxxxxxx;
           rom[ 0+376] ='bxxxxxxxx;
           rom[ 0+377] ='bxxxxxxxx;
           rom[ 0+378] ='bxxxxxxxx;
           rom[ 0+379] ='bxxxxxxxx;
           rom[ 0+380] ='bxxxxxxxx;
           rom[ 0+381] ='bxxxxxxxx;
           rom[ 0+382] ='bxxxxxxxx;
           rom[ 0+383] ='bxxxxxxxx;
           rom[ 0+384] ='bxxxxxxxx;
           rom[ 0+385] ='bxxxxxxxx;
           rom[ 0+386] ='bxxxxxxxx;
           rom[ 0+387] ='bxxxxxxxx;
           rom[ 0+388] ='bxxxxxxxx;
           rom[ 0+389] ='bxxxxxxxx;
           rom[ 0+390] ='bxxxxxxxx;
           rom[ 0+391] ='bxxxxxxxx;
           rom[ 0+392] ='bxxxxxxxx;
           rom[ 0+393] ='bxxxxxxxx;
           rom[ 0+394] ='bxxxxxxxx;
           rom[ 0+395] ='bxxxxxxxx;
           rom[ 0+396] ='bxxxxxxxx;
           rom[ 0+397] ='bxxxxxxxx;
           rom[ 0+398] ='bxxxxxxxx;
           rom[ 0+399] ='bxxxxxxxx;
           rom[ 0+400] ='bxxxxxxxx;
           rom[ 0+401] ='bxxxxxxxx;
           rom[ 0+402] ='bxxxxxxxx;
           rom[ 0+403] ='bxxxxxxxx;
           rom[ 0+404] ='bxxxxxxxx;
           rom[ 0+405] ='bxxxxxxxx;
           rom[ 0+406] ='bxxxxxxxx;
           rom[ 0+407] ='bxxxxxxxx;
           rom[ 0+408] ='bxxxxxxxx;
           rom[ 0+409] ='bxxxxxxxx;
           rom[ 0+410] ='bxxxxxxxx;
           rom[ 0+411] ='bxxxxxxxx;
           rom[ 0+412] ='bxxxxxxxx;
           rom[ 0+413] ='bxxxxxxxx;
           rom[ 0+414] ='bxxxxxxxx;
           rom[ 0+415] ='bxxxxxxxx;
           rom[ 0+416] ='bxxxxxxxx;
           rom[ 0+417] ='bxxxxxxxx;
           rom[ 0+418] ='bxxxxxxxx;
           rom[ 0+419] ='bxxxxxxxx;
           rom[ 0+420] ='bxxxxxxxx;
           rom[ 0+421] ='bxxxxxxxx;
           rom[ 0+422] ='bxxxxxxxx;
           rom[ 0+423] ='bxxxxxxxx;
           rom[ 0+424] ='bxxxxxxxx;
           rom[ 0+425] ='bxxxxxxxx;
           rom[ 0+426] ='bxxxxxxxx;
           rom[ 0+427] ='bxxxxxxxx;
           rom[ 0+428] ='bxxxxxxxx;
           rom[ 0+429] ='bxxxxxxxx;
           rom[ 0+430] ='bxxxxxxxx;
           rom[ 0+431] ='bxxxxxxxx;
           rom[ 0+432] ='bxxxxxxxx;
           rom[ 0+433] ='bxxxxxxxx;
           rom[ 0+434] ='bxxxxxxxx;
           rom[ 0+435] ='bxxxxxxxx;
           rom[ 0+436] ='bxxxxxxxx;
           rom[ 0+437] ='bxxxxxxxx;
           rom[ 0+438] ='bxxxxxxxx;
           rom[ 0+439] ='bxxxxxxxx;
           rom[ 0+440] ='bxxxxxxxx;
           rom[ 0+441] ='bxxxxxxxx;
           rom[ 0+442] ='bxxxxxxxx;
           rom[ 0+443] ='bxxxxxxxx;
           rom[ 0+444] ='bxxxxxxxx;
           rom[ 0+445] ='bxxxxxxxx;
           rom[ 0+446] ='bxxxxxxxx;
           rom[ 0+447] ='bxxxxxxxx;
           rom[ 0+448] ='bxxxxxxxx;
           rom[ 0+449] ='bxxxxxxxx;
           rom[ 0+450] ='bxxxxxxxx;
           rom[ 0+451] ='bxxxxxxxx;
           rom[ 0+452] ='bxxxxxxxx;
           rom[ 0+453] ='bxxxxxxxx;
           rom[ 0+454] ='bxxxxxxxx;
           rom[ 0+455] ='bxxxxxxxx;
           rom[ 0+456] ='bxxxxxxxx;
           rom[ 0+457] ='bxxxxxxxx;
           rom[ 0+458] ='bxxxxxxxx;
           rom[ 0+459] ='bxxxxxxxx;
           rom[ 0+460] ='bxxxxxxxx;
           rom[ 0+461] ='bxxxxxxxx;
           rom[ 0+462] ='bxxxxxxxx;
           rom[ 0+463] ='bxxxxxxxx;
           rom[ 0+464] ='bxxxxxxxx;
           rom[ 0+465] ='bxxxxxxxx;
           rom[ 0+466] ='bxxxxxxxx;
           rom[ 0+467] ='bxxxxxxxx;
           rom[ 0+468] ='bxxxxxxxx;
           rom[ 0+469] ='bxxxxxxxx;
           rom[ 0+470] ='bxxxxxxxx;
           rom[ 0+471] ='bxxxxxxxx;
           rom[ 0+472] ='bxxxxxxxx;
           rom[ 0+473] ='bxxxxxxxx;
           rom[ 0+474] ='bxxxxxxxx;
           rom[ 0+475] ='bxxxxxxxx;
           rom[ 0+476] ='bxxxxxxxx;
           rom[ 0+477] ='bxxxxxxxx;
           rom[ 0+478] ='bxxxxxxxx;
           rom[ 0+479] ='bxxxxxxxx;
           rom[ 0+480] ='bxxxxxxxx;
           rom[ 0+481] ='bxxxxxxxx;
           rom[ 0+482] ='bxxxxxxxx;
           rom[ 0+483] ='bxxxxxxxx;
           rom[ 0+484] ='bxxxxxxxx;
           rom[ 0+485] ='bxxxxxxxx;
           rom[ 0+486] ='bxxxxxxxx;
           rom[ 0+487] ='bxxxxxxxx;
           rom[ 0+488] ='bxxxxxxxx;
           rom[ 0+489] ='bxxxxxxxx;
           rom[ 0+490] ='bxxxxxxxx;
           rom[ 0+491] ='bxxxxxxxx;
           rom[ 0+492] ='bxxxxxxxx;
           rom[ 0+493] ='bxxxxxxxx;
           rom[ 0+494] ='bxxxxxxxx;
           rom[ 0+495] ='bxxxxxxxx;
           rom[ 0+496] ='bxxxxxxxx;
           rom[ 0+497] ='bxxxxxxxx;
           rom[ 0+498] ='bxxxxxxxx;
           rom[ 0+499] ='bxxxxxxxx;
           rom[ 0+500] ='bxxxxxxxx;
           rom[ 0+501] ='bxxxxxxxx;
           rom[ 0+502] ='bxxxxxxxx;
           rom[ 0+503] ='bxxxxxxxx;
           rom[ 0+504] ='bxxxxxxxx;
           rom[ 0+505] ='bxxxxxxxx;
           rom[ 0+506] ='bxxxxxxxx;
           rom[ 0+507] ='bxxxxxxxx;
           rom[ 0+508] ='bxxxxxxxx;
           rom[ 0+509] ='bxxxxxxxx;
           rom[ 0+510] ='bxxxxxxxx;
           rom[ 0+511] ='bxxxxxxxx;
           rom[ 0+512] ='b00111110;
           rom[ 0+513] ='b00000010;
           rom[ 0+514] ='b11001111;
           rom[ 0+515] ='b11001001;
           rom[ 0+516] ='b00111110;
           rom[ 0+517] ='b00000000;
           rom[ 0+518] ='b11001111;
           rom[ 0+519] ='b01110110;
           rom[ 0+520] ='b00011000;
           rom[ 0+521] ='b11111101;
           rom[ 0+522] ='b11011101;
           rom[ 0+523] ='b11100101;
           rom[ 0+524] ='b11011101;
           rom[ 0+525] ='b00100001;
           rom[ 0+526] ='b00000000;
           rom[ 0+527] ='b00000000;
           rom[ 0+528] ='b11011101;
           rom[ 0+529] ='b00111001;
           rom[ 0+530] ='b11011101;
           rom[ 0+531] ='b01001110;
           rom[ 0+532] ='b00000100;
           rom[ 0+533] ='b11011101;
           rom[ 0+534] ='b01000110;
           rom[ 0+535] ='b00000101;
           rom[ 0+536] ='b00001010;
           rom[ 0+537] ='b01011111;
           rom[ 0+538] ='b10110111;
           rom[ 0+539] ='b11001010;
           rom[ 0+540] ='b00101001;
           rom[ 0+541] ='b00000010;
           rom[ 0+542] ='b11111101;
           rom[ 0+543] ='b00100001;
           rom[ 0+544] ='b11101000;
           rom[ 0+545] ='b10000011;
           rom[ 0+546] ='b11111101;
           rom[ 0+547] ='b01110011;
           rom[ 0+548] ='b00000000;
           rom[ 0+549] ='b00000011;
           rom[ 0+550] ='b11000011;
           rom[ 0+551] ='b00011000;
           rom[ 0+552] ='b00000010;
           rom[ 0+553] ='b11111101;
           rom[ 0+554] ='b00100001;
           rom[ 0+555] ='b11101000;
           rom[ 0+556] ='b10000011;
           rom[ 0+557] ='b11111101;
           rom[ 0+558] ='b00110110;
           rom[ 0+559] ='b00000000;
           rom[ 0+560] ='b00000000;
           rom[ 0+561] ='b11011101;
           rom[ 0+562] ='b11100001;
           rom[ 0+563] ='b11001001;
           rom[ 0+564] ='b00011101;
           rom[ 0+565] ='b00111010;
           rom[ 0+566] ='b01101001;
           rom[ 0+567] ='b11001110;
           rom[ 0+568] ='b10000001;
           rom[ 0+569] ='b00000011;
           rom[ 0+570] ='b00000111;
           rom[ 0+571] ='b00001110;
           rom[ 0+572] ='b10000100;
           rom[ 0+573] ='b00001000;
           rom[ 0+574] ='b10010101;
           rom[ 0+575] ='b10101110;
           rom[ 0+576] ='b11011000;
           rom[ 0+577] ='b10110000;
           rom[ 0+578] ='b01100001;
           rom[ 0+579] ='b11000010;
           rom[ 0+580] ='b10100001;
           rom[ 0+581] ='b01000011;
           rom[ 0+582] ='b00100110;
           rom[ 0+583] ='b11101101;
           rom[ 0+584] ='b01111010;
           rom[ 0+585] ='b11110100;
           rom[ 0+586] ='b11101000;
           rom[ 0+587] ='b11010000;
           rom[ 0+588] ='b00101010;
           rom[ 0+589] ='b01010100;
           rom[ 0+590] ='b10000011;
           rom[ 0+591] ='b00101100;
           rom[ 0+592] ='b01110010;
           rom[ 0+593] ='b11100101;
           rom[ 0+594] ='b11001010;
           rom[ 0+595] ='b10010101;
           rom[ 0+596] ='b01010010;
           rom[ 0+597] ='b10100101;
           rom[ 0+598] ='b00011000;
           rom[ 0+599] ='b01100011;
           rom[ 0+600] ='b10010101;
           rom[ 0+601] ='b00101010;
           rom[ 0+602] ='b01010100;
           rom[ 0+603] ='b10101001;
           rom[ 0+604] ='b11111100;
           rom[ 0+605] ='b11111001;
           rom[ 0+606] ='b00001110;
           rom[ 0+607] ='b11100001;
           rom[ 0+608] ='b00111111;
           rom[ 0+609] ='b01111111;
           rom[ 0+610] ='b11111111;
           rom[ 0+611] ='b11111110;
           rom[ 0+612] ='b10111101;
           rom[ 0+613] ='b01111011;
           rom[ 0+614] ='b01001011;
           rom[ 0+615] ='b00101011;
           rom[ 0+616] ='b11101011;
           rom[ 0+617] ='b11010111;
           rom[ 0+618] ='b10101111;
           rom[ 0+619] ='b01011110;
           rom[ 0+620] ='b10000000;
           rom[ 0+621] ='b00000001;
           rom[ 0+622] ='b10000010;
           rom[ 0+623] ='b10000100;
           rom[ 0+624] ='b10001000;
           rom[ 0+625] ='b00010000;
           rom[ 0+626] ='b00100000;
           rom[ 0+627] ='b01000000;
           rom[ 0+628] ='b01000000;
           rom[ 0+629] ='b10000000;
           rom[ 0+630] ='b01000001;
           rom[ 0+631] ='b11000010;
           rom[ 0+632] ='b11000100;
           rom[ 0+633] ='b10001000;
           rom[ 0+634] ='b00010000;
           rom[ 0+635] ='b00100000;
           rom[ 0+636] ='b00100000;
           rom[ 0+637] ='b01000000;
           rom[ 0+638] ='b10100000;
           rom[ 0+639] ='b01100001;
           rom[ 0+640] ='b11100010;
           rom[ 0+641] ='b11000100;
           rom[ 0+642] ='b10001000;
           rom[ 0+643] ='b00010000;
           rom[ 0+644] ='b00010000;
           rom[ 0+645] ='b00100000;
           rom[ 0+646] ='b01010000;
           rom[ 0+647] ='b10110000;
           rom[ 0+648] ='b01110001;
           rom[ 0+649] ='b11100010;
           rom[ 0+650] ='b11000100;
           rom[ 0+651] ='b10001000;
           rom[ 0+652] ='b10001000;
           rom[ 0+653] ='b00010000;
           rom[ 0+654] ='b10101000;
           rom[ 0+655] ='b11011000;
           rom[ 0+656] ='b00111000;
           rom[ 0+657] ='b01110001;
           rom[ 0+658] ='b11100010;
           rom[ 0+659] ='b11000100;
           rom[ 0+660] ='b11000100;
           rom[ 0+661] ='b10001000;
           rom[ 0+662] ='b11010100;
           rom[ 0+663] ='b01101100;
           rom[ 0+664] ='b00011100;
           rom[ 0+665] ='b00111000;
           rom[ 0+666] ='b01110001;
           rom[ 0+667] ='b11100010;
           rom[ 0+668] ='b00000000;
           rom[ 0+669] ='b00000000;
           rom[ 0+670] ='b00000001;
           rom[ 0+671] ='b00011001;
           rom[ 0+672] ='b00000010;
           rom[ 0+673] ='b00110010;
           rom[ 0+674] ='b00011010;
           rom[ 0+675] ='b11000110;
           rom[ 0+676] ='b00000011;
           rom[ 0+677] ='b11011111;
           rom[ 0+678] ='b00110011;
           rom[ 0+679] ='b11101110;
           rom[ 0+680] ='b00011011;
           rom[ 0+681] ='b01101000;
           rom[ 0+682] ='b11000111;
           rom[ 0+683] ='b01001011;
           rom[ 0+684] ='b00000100;
           rom[ 0+685] ='b01100100;
           rom[ 0+686] ='b11100000;
           rom[ 0+687] ='b00001110;
           rom[ 0+688] ='b00110100;
           rom[ 0+689] ='b10001101;
           rom[ 0+690] ='b11101111;
           rom[ 0+691] ='b10000001;
           rom[ 0+692] ='b00011100;
           rom[ 0+693] ='b11000001;
           rom[ 0+694] ='b01101001;
           rom[ 0+695] ='b11111000;
           rom[ 0+696] ='b11001000;
           rom[ 0+697] ='b00001000;
           rom[ 0+698] ='b01001100;
           rom[ 0+699] ='b01110001;
           rom[ 0+700] ='b00000101;
           rom[ 0+701] ='b10001010;
           rom[ 0+702] ='b01100101;
           rom[ 0+703] ='b00101111;
           rom[ 0+704] ='b11100001;
           rom[ 0+705] ='b00100100;
           rom[ 0+706] ='b00001111;
           rom[ 0+707] ='b00100001;
           rom[ 0+708] ='b00110101;
           rom[ 0+709] ='b10010011;
           rom[ 0+710] ='b10001110;
           rom[ 0+711] ='b11011010;
           rom[ 0+712] ='b11110000;
           rom[ 0+713] ='b00010010;
           rom[ 0+714] ='b10000010;
           rom[ 0+715] ='b01000101;
           rom[ 0+716] ='b00011101;
           rom[ 0+717] ='b10110101;
           rom[ 0+718] ='b11000010;
           rom[ 0+719] ='b01111101;
           rom[ 0+720] ='b01101010;
           rom[ 0+721] ='b00100111;
           rom[ 0+722] ='b11111001;
           rom[ 0+723] ='b10111001;
           rom[ 0+724] ='b11001001;
           rom[ 0+725] ='b10011010;
           rom[ 0+726] ='b00001001;
           rom[ 0+727] ='b01111000;
           rom[ 0+728] ='b01001101;
           rom[ 0+729] ='b11100100;
           rom[ 0+730] ='b01110010;
           rom[ 0+731] ='b10100110;
           rom[ 0+732] ='b00000110;
           rom[ 0+733] ='b10111111;
           rom[ 0+734] ='b10001011;
           rom[ 0+735] ='b01100010;
           rom[ 0+736] ='b01100110;
           rom[ 0+737] ='b11011101;
           rom[ 0+738] ='b00110000;
           rom[ 0+739] ='b11111101;
           rom[ 0+740] ='b11100010;
           rom[ 0+741] ='b10011000;
           rom[ 0+742] ='b00100101;
           rom[ 0+743] ='b10110011;
           rom[ 0+744] ='b00010000;
           rom[ 0+745] ='b10010001;
           rom[ 0+746] ='b00100010;
           rom[ 0+747] ='b10001000;
           rom[ 0+748] ='b00110110;
           rom[ 0+749] ='b11010000;
           rom[ 0+750] ='b10010100;
           rom[ 0+751] ='b11001110;
           rom[ 0+752] ='b10001111;
           rom[ 0+753] ='b10010110;
           rom[ 0+754] ='b11011011;
           rom[ 0+755] ='b10111101;
           rom[ 0+756] ='b11110001;
           rom[ 0+757] ='b11010010;
           rom[ 0+758] ='b00010011;
           rom[ 0+759] ='b01011100;
           rom[ 0+760] ='b10000011;
           rom[ 0+761] ='b00111000;
           rom[ 0+762] ='b01000110;
           rom[ 0+763] ='b01000000;
           rom[ 0+764] ='b00011110;
           rom[ 0+765] ='b01000010;
           rom[ 0+766] ='b10110110;
           rom[ 0+767] ='b10100011;
           rom[ 0+768] ='b11000011;
           rom[ 0+769] ='b01001000;
           rom[ 0+770] ='b01111110;
           rom[ 0+771] ='b01101110;
           rom[ 0+772] ='b01101011;
           rom[ 0+773] ='b00111010;
           rom[ 0+774] ='b00101000;
           rom[ 0+775] ='b01010100;
           rom[ 0+776] ='b11111010;
           rom[ 0+777] ='b10000101;
           rom[ 0+778] ='b10111010;
           rom[ 0+779] ='b00111101;
           rom[ 0+780] ='b11001010;
           rom[ 0+781] ='b01011110;
           rom[ 0+782] ='b10011011;
           rom[ 0+783] ='b10011111;
           rom[ 0+784] ='b00001010;
           rom[ 0+785] ='b00010101;
           rom[ 0+786] ='b01111001;
           rom[ 0+787] ='b00101011;
           rom[ 0+788] ='b01001110;
           rom[ 0+789] ='b11010100;
           rom[ 0+790] ='b11100101;
           rom[ 0+791] ='b10101100;
           rom[ 0+792] ='b01110011;
           rom[ 0+793] ='b11110011;
           rom[ 0+794] ='b10100111;
           rom[ 0+795] ='b01010111;
           rom[ 0+796] ='b00000111;
           rom[ 0+797] ='b01110000;
           rom[ 0+798] ='b11000000;
           rom[ 0+799] ='b11110111;
           rom[ 0+800] ='b10001100;
           rom[ 0+801] ='b10000000;
           rom[ 0+802] ='b01100011;
           rom[ 0+803] ='b00001101;
           rom[ 0+804] ='b01100111;
           rom[ 0+805] ='b01001010;
           rom[ 0+806] ='b11011110;
           rom[ 0+807] ='b11101101;
           rom[ 0+808] ='b00110001;
           rom[ 0+809] ='b11000101;
           rom[ 0+810] ='b11111110;
           rom[ 0+811] ='b00011000;
           rom[ 0+812] ='b11100011;
           rom[ 0+813] ='b10100101;
           rom[ 0+814] ='b10011001;
           rom[ 0+815] ='b01110111;
           rom[ 0+816] ='b00100110;
           rom[ 0+817] ='b10111000;
           rom[ 0+818] ='b10110100;
           rom[ 0+819] ='b01111100;
           rom[ 0+820] ='b00010001;
           rom[ 0+821] ='b01000100;
           rom[ 0+822] ='b10010010;
           rom[ 0+823] ='b11011001;
           rom[ 0+824] ='b00100011;
           rom[ 0+825] ='b00100000;
           rom[ 0+826] ='b10001001;
           rom[ 0+827] ='b00101110;
           rom[ 0+828] ='b00110111;
           rom[ 0+829] ='b00111111;
           rom[ 0+830] ='b11010001;
           rom[ 0+831] ='b01011011;
           rom[ 0+832] ='b10010101;
           rom[ 0+833] ='b10111100;
           rom[ 0+834] ='b11001111;
           rom[ 0+835] ='b11001101;
           rom[ 0+836] ='b10010000;
           rom[ 0+837] ='b10000111;
           rom[ 0+838] ='b10010111;
           rom[ 0+839] ='b10110010;
           rom[ 0+840] ='b11011100;
           rom[ 0+841] ='b11111100;
           rom[ 0+842] ='b10111110;
           rom[ 0+843] ='b01100001;
           rom[ 0+844] ='b11110010;
           rom[ 0+845] ='b01010110;
           rom[ 0+846] ='b11010011;
           rom[ 0+847] ='b10101011;
           rom[ 0+848] ='b00010100;
           rom[ 0+849] ='b00101010;
           rom[ 0+850] ='b01011101;
           rom[ 0+851] ='b10011110;
           rom[ 0+852] ='b10000100;
           rom[ 0+853] ='b00111100;
           rom[ 0+854] ='b00111001;
           rom[ 0+855] ='b01010011;
           rom[ 0+856] ='b01000111;
           rom[ 0+857] ='b01101101;
           rom[ 0+858] ='b01000001;
           rom[ 0+859] ='b10100010;
           rom[ 0+860] ='b00011111;
           rom[ 0+861] ='b00101101;
           rom[ 0+862] ='b01000011;
           rom[ 0+863] ='b11011000;
           rom[ 0+864] ='b10110111;
           rom[ 0+865] ='b01111011;
           rom[ 0+866] ='b10100100;
           rom[ 0+867] ='b01110110;
           rom[ 0+868] ='b11000100;
           rom[ 0+869] ='b00010111;
           rom[ 0+870] ='b01001001;
           rom[ 0+871] ='b11101100;
           rom[ 0+872] ='b01111111;
           rom[ 0+873] ='b00001100;
           rom[ 0+874] ='b01101111;
           rom[ 0+875] ='b11110110;
           rom[ 0+876] ='b01101100;
           rom[ 0+877] ='b10100001;
           rom[ 0+878] ='b00111011;
           rom[ 0+879] ='b01010010;
           rom[ 0+880] ='b00101001;
           rom[ 0+881] ='b10011101;
           rom[ 0+882] ='b01010101;
           rom[ 0+883] ='b10101010;
           rom[ 0+884] ='b11111011;
           rom[ 0+885] ='b01100000;
           rom[ 0+886] ='b10000110;
           rom[ 0+887] ='b10110001;
           rom[ 0+888] ='b10111011;
           rom[ 0+889] ='b11001100;
           rom[ 0+890] ='b00111110;
           rom[ 0+891] ='b01011010;
           rom[ 0+892] ='b11001011;
           rom[ 0+893] ='b01011001;
           rom[ 0+894] ='b01011111;
           rom[ 0+895] ='b10110000;
           rom[ 0+896] ='b10011100;
           rom[ 0+897] ='b10101001;
           rom[ 0+898] ='b10100000;
           rom[ 0+899] ='b01010001;
           rom[ 0+900] ='b00001011;
           rom[ 0+901] ='b11110101;
           rom[ 0+902] ='b00010110;
           rom[ 0+903] ='b11101011;
           rom[ 0+904] ='b01111010;
           rom[ 0+905] ='b01110101;
           rom[ 0+906] ='b00101100;
           rom[ 0+907] ='b11010111;
           rom[ 0+908] ='b01001111;
           rom[ 0+909] ='b10101110;
           rom[ 0+910] ='b11010101;
           rom[ 0+911] ='b11101001;
           rom[ 0+912] ='b11100110;
           rom[ 0+913] ='b11100111;
           rom[ 0+914] ='b10101101;
           rom[ 0+915] ='b11101000;
           rom[ 0+916] ='b01110100;
           rom[ 0+917] ='b11010110;
           rom[ 0+918] ='b11110100;
           rom[ 0+919] ='b11101010;
           rom[ 0+920] ='b10101000;
           rom[ 0+921] ='b01010000;
           rom[ 0+922] ='b01011000;
           rom[ 0+923] ='b10101111;
           rom[ 0+924] ='b00000001;
           rom[ 0+925] ='b00000010;
           rom[ 0+926] ='b00000100;
           rom[ 0+927] ='b00001000;
           rom[ 0+928] ='b00010000;
           rom[ 0+929] ='b00100000;
           rom[ 0+930] ='b01000000;
           rom[ 0+931] ='b10000000;
           rom[ 0+932] ='b00011101;
           rom[ 0+933] ='b00111010;
           rom[ 0+934] ='b01110100;
           rom[ 0+935] ='b11101000;
           rom[ 0+936] ='b11001101;
           rom[ 0+937] ='b10000111;
           rom[ 0+938] ='b00010011;
           rom[ 0+939] ='b00100110;
           rom[ 0+940] ='b01001100;
           rom[ 0+941] ='b10011000;
           rom[ 0+942] ='b00101101;
           rom[ 0+943] ='b01011010;
           rom[ 0+944] ='b10110100;
           rom[ 0+945] ='b01110101;
           rom[ 0+946] ='b11101010;
           rom[ 0+947] ='b11001001;
           rom[ 0+948] ='b10001111;
           rom[ 0+949] ='b00000011;
           rom[ 0+950] ='b00000110;
           rom[ 0+951] ='b00001100;
           rom[ 0+952] ='b00011000;
           rom[ 0+953] ='b00110000;
           rom[ 0+954] ='b01100000;
           rom[ 0+955] ='b11000000;
           rom[ 0+956] ='b10011101;
           rom[ 0+957] ='b00100111;
           rom[ 0+958] ='b01001110;
           rom[ 0+959] ='b10011100;
           rom[ 0+960] ='b00100101;
           rom[ 0+961] ='b01001010;
           rom[ 0+962] ='b10010100;
           rom[ 0+963] ='b00110101;
           rom[ 0+964] ='b01101010;
           rom[ 0+965] ='b11010100;
           rom[ 0+966] ='b10110101;
           rom[ 0+967] ='b01110111;
           rom[ 0+968] ='b11101110;
           rom[ 0+969] ='b11000001;
           rom[ 0+970] ='b10011111;
           rom[ 0+971] ='b00100011;
           rom[ 0+972] ='b01000110;
           rom[ 0+973] ='b10001100;
           rom[ 0+974] ='b00000101;
           rom[ 0+975] ='b00001010;
           rom[ 0+976] ='b00010100;
           rom[ 0+977] ='b00101000;
           rom[ 0+978] ='b01010000;
           rom[ 0+979] ='b10100000;
           rom[ 0+980] ='b01011101;
           rom[ 0+981] ='b10111010;
           rom[ 0+982] ='b01101001;
           rom[ 0+983] ='b11010010;
           rom[ 0+984] ='b10111001;
           rom[ 0+985] ='b01101111;
           rom[ 0+986] ='b11011110;
           rom[ 0+987] ='b10100001;
           rom[ 0+988] ='b01011111;
           rom[ 0+989] ='b10111110;
           rom[ 0+990] ='b01100001;
           rom[ 0+991] ='b11000010;
           rom[ 0+992] ='b10011001;
           rom[ 0+993] ='b00101111;
           rom[ 0+994] ='b01011110;
           rom[ 0+995] ='b10111100;
           rom[ 0+996] ='b01100101;
           rom[ 0+997] ='b11001010;
           rom[ 0+998] ='b10001001;
           rom[ 0+999] ='b00001111;
           rom[ 0+1000] ='b00011110;
           rom[ 0+1001] ='b00111100;
           rom[ 0+1002] ='b01111000;
           rom[ 0+1003] ='b11110000;
           rom[ 0+1004] ='b11111101;
           rom[ 0+1005] ='b11100111;
           rom[ 0+1006] ='b11010011;
           rom[ 0+1007] ='b10111011;
           rom[ 0+1008] ='b01101011;
           rom[ 0+1009] ='b11010110;
           rom[ 0+1010] ='b10110001;
           rom[ 0+1011] ='b01111111;
           rom[ 0+1012] ='b11111110;
           rom[ 0+1013] ='b11100001;
           rom[ 0+1014] ='b11011111;
           rom[ 0+1015] ='b10100011;
           rom[ 0+1016] ='b01011011;
           rom[ 0+1017] ='b10110110;
           rom[ 0+1018] ='b01110001;
           rom[ 0+1019] ='b11100010;
           rom[ 0+1020] ='b11011001;
           rom[ 0+1021] ='b10101111;
           rom[ 0+1022] ='b01000011;
           rom[ 0+1023] ='b10000110;
           rom[ 0+1024] ='b00010001;
           rom[ 0+1025] ='b00100010;
           rom[ 0+1026] ='b01000100;
           rom[ 0+1027] ='b10001000;
           rom[ 0+1028] ='b00001101;
           rom[ 0+1029] ='b00011010;
           rom[ 0+1030] ='b00110100;
           rom[ 0+1031] ='b01101000;
           rom[ 0+1032] ='b11010000;
           rom[ 0+1033] ='b10111101;
           rom[ 0+1034] ='b01100111;
           rom[ 0+1035] ='b11001110;
           rom[ 0+1036] ='b10000001;
           rom[ 0+1037] ='b00011111;
           rom[ 0+1038] ='b00111110;
           rom[ 0+1039] ='b01111100;
           rom[ 0+1040] ='b11111000;
           rom[ 0+1041] ='b11101101;
           rom[ 0+1042] ='b11000111;
           rom[ 0+1043] ='b10010011;
           rom[ 0+1044] ='b00111011;
           rom[ 0+1045] ='b01110110;
           rom[ 0+1046] ='b11101100;
           rom[ 0+1047] ='b11000101;
           rom[ 0+1048] ='b10010111;
           rom[ 0+1049] ='b00110011;
           rom[ 0+1050] ='b01100110;
           rom[ 0+1051] ='b11001100;
           rom[ 0+1052] ='b10000101;
           rom[ 0+1053] ='b00010111;
           rom[ 0+1054] ='b00101110;
           rom[ 0+1055] ='b01011100;
           rom[ 0+1056] ='b10111000;
           rom[ 0+1057] ='b01101101;
           rom[ 0+1058] ='b11011010;
           rom[ 0+1059] ='b10101001;
           rom[ 0+1060] ='b01001111;
           rom[ 0+1061] ='b10011110;
           rom[ 0+1062] ='b00100001;
           rom[ 0+1063] ='b01000010;
           rom[ 0+1064] ='b10000100;
           rom[ 0+1065] ='b00010101;
           rom[ 0+1066] ='b00101010;
           rom[ 0+1067] ='b01010100;
           rom[ 0+1068] ='b10101000;
           rom[ 0+1069] ='b01001101;
           rom[ 0+1070] ='b10011010;
           rom[ 0+1071] ='b00101001;
           rom[ 0+1072] ='b01010010;
           rom[ 0+1073] ='b10100100;
           rom[ 0+1074] ='b01010101;
           rom[ 0+1075] ='b10101010;
           rom[ 0+1076] ='b01001001;
           rom[ 0+1077] ='b10010010;
           rom[ 0+1078] ='b00111001;
           rom[ 0+1079] ='b01110010;
           rom[ 0+1080] ='b11100100;
           rom[ 0+1081] ='b11010101;
           rom[ 0+1082] ='b10110111;
           rom[ 0+1083] ='b01110011;
           rom[ 0+1084] ='b11100110;
           rom[ 0+1085] ='b11010001;
           rom[ 0+1086] ='b10111111;
           rom[ 0+1087] ='b01100011;
           rom[ 0+1088] ='b11000110;
           rom[ 0+1089] ='b10010001;
           rom[ 0+1090] ='b00111111;
           rom[ 0+1091] ='b01111110;
           rom[ 0+1092] ='b11111100;
           rom[ 0+1093] ='b11100101;
           rom[ 0+1094] ='b11010111;
           rom[ 0+1095] ='b10110011;
           rom[ 0+1096] ='b01111011;
           rom[ 0+1097] ='b11110110;
           rom[ 0+1098] ='b11110001;
           rom[ 0+1099] ='b11111111;
           rom[ 0+1100] ='b11100011;
           rom[ 0+1101] ='b11011011;
           rom[ 0+1102] ='b10101011;
           rom[ 0+1103] ='b01001011;
           rom[ 0+1104] ='b10010110;
           rom[ 0+1105] ='b00110001;
           rom[ 0+1106] ='b01100010;
           rom[ 0+1107] ='b11000100;
           rom[ 0+1108] ='b10010101;
           rom[ 0+1109] ='b00110111;
           rom[ 0+1110] ='b01101110;
           rom[ 0+1111] ='b11011100;
           rom[ 0+1112] ='b10100101;
           rom[ 0+1113] ='b01010111;
           rom[ 0+1114] ='b10101110;
           rom[ 0+1115] ='b01000001;
           rom[ 0+1116] ='b10000010;
           rom[ 0+1117] ='b00011001;
           rom[ 0+1118] ='b00110010;
           rom[ 0+1119] ='b01100100;
           rom[ 0+1120] ='b11001000;
           rom[ 0+1121] ='b10001101;
           rom[ 0+1122] ='b00000111;
           rom[ 0+1123] ='b00001110;
           rom[ 0+1124] ='b00011100;
           rom[ 0+1125] ='b00111000;
           rom[ 0+1126] ='b01110000;
           rom[ 0+1127] ='b11100000;
           rom[ 0+1128] ='b11011101;
           rom[ 0+1129] ='b10100111;
           rom[ 0+1130] ='b01010011;
           rom[ 0+1131] ='b10100110;
           rom[ 0+1132] ='b01010001;
           rom[ 0+1133] ='b10100010;
           rom[ 0+1134] ='b01011001;
           rom[ 0+1135] ='b10110010;
           rom[ 0+1136] ='b01111001;
           rom[ 0+1137] ='b11110010;
           rom[ 0+1138] ='b11111001;
           rom[ 0+1139] ='b11101111;
           rom[ 0+1140] ='b11000011;
           rom[ 0+1141] ='b10011011;
           rom[ 0+1142] ='b00101011;
           rom[ 0+1143] ='b01010110;
           rom[ 0+1144] ='b10101100;
           rom[ 0+1145] ='b01000101;
           rom[ 0+1146] ='b10001010;
           rom[ 0+1147] ='b00001001;
           rom[ 0+1148] ='b00010010;
           rom[ 0+1149] ='b00100100;
           rom[ 0+1150] ='b01001000;
           rom[ 0+1151] ='b10010000;
           rom[ 0+1152] ='b00111101;
           rom[ 0+1153] ='b01111010;
           rom[ 0+1154] ='b11110100;
           rom[ 0+1155] ='b11110101;
           rom[ 0+1156] ='b11110111;
           rom[ 0+1157] ='b11110011;
           rom[ 0+1158] ='b11111011;
           rom[ 0+1159] ='b11101011;
           rom[ 0+1160] ='b11001011;
           rom[ 0+1161] ='b10001011;
           rom[ 0+1162] ='b00001011;
           rom[ 0+1163] ='b00010110;
           rom[ 0+1164] ='b00101100;
           rom[ 0+1165] ='b01011000;
           rom[ 0+1166] ='b10110000;
           rom[ 0+1167] ='b01111101;
           rom[ 0+1168] ='b11111010;
           rom[ 0+1169] ='b11101001;
           rom[ 0+1170] ='b11001111;
           rom[ 0+1171] ='b10000011;
           rom[ 0+1172] ='b00011011;
           rom[ 0+1173] ='b00110110;
           rom[ 0+1174] ='b01101100;
           rom[ 0+1175] ='b11011000;
           rom[ 0+1176] ='b10101101;
           rom[ 0+1177] ='b01000111;
           rom[ 0+1178] ='b10001110;
           rom[ 0+1179] ='b00000001;
           rom[ 0+1180] ='b00000000;
           rom[ 0+1181] ='b00000001;
           rom[ 0+1182] ='b00000100;
           rom[ 0+1183] ='b00000101;
           rom[ 0+1184] ='b00010000;
           rom[ 0+1185] ='b00010001;
           rom[ 0+1186] ='b00010100;
           rom[ 0+1187] ='b00010101;
           rom[ 0+1188] ='b01000000;
           rom[ 0+1189] ='b01000001;
           rom[ 0+1190] ='b01000100;
           rom[ 0+1191] ='b01000101;
           rom[ 0+1192] ='b01010000;
           rom[ 0+1193] ='b01010001;
           rom[ 0+1194] ='b01010100;
           rom[ 0+1195] ='b01010101;
           rom[ 0+1196] ='b00011101;
           rom[ 0+1197] ='b00011100;
           rom[ 0+1198] ='b00011001;
           rom[ 0+1199] ='b00011000;
           rom[ 0+1200] ='b00001101;
           rom[ 0+1201] ='b00001100;
           rom[ 0+1202] ='b00001001;
           rom[ 0+1203] ='b00001000;
           rom[ 0+1204] ='b01011101;
           rom[ 0+1205] ='b01011100;
           rom[ 0+1206] ='b01011001;
           rom[ 0+1207] ='b01011000;
           rom[ 0+1208] ='b01001101;
           rom[ 0+1209] ='b01001100;
           rom[ 0+1210] ='b01001001;
           rom[ 0+1211] ='b01001000;
           rom[ 0+1212] ='b01110100;
           rom[ 0+1213] ='b01110101;
           rom[ 0+1214] ='b01110000;
           rom[ 0+1215] ='b01110001;
           rom[ 0+1216] ='b01100100;
           rom[ 0+1217] ='b01100101;
           rom[ 0+1218] ='b01100000;
           rom[ 0+1219] ='b01100001;
           rom[ 0+1220] ='b00110100;
           rom[ 0+1221] ='b00110101;
           rom[ 0+1222] ='b00110000;
           rom[ 0+1223] ='b00110001;
           rom[ 0+1224] ='b00100100;
           rom[ 0+1225] ='b00100101;
           rom[ 0+1226] ='b00100000;
           rom[ 0+1227] ='b00100001;
           rom[ 0+1228] ='b01101001;
           rom[ 0+1229] ='b01101000;
           rom[ 0+1230] ='b01101101;
           rom[ 0+1231] ='b01101100;
           rom[ 0+1232] ='b01111001;
           rom[ 0+1233] ='b01111000;
           rom[ 0+1234] ='b01111101;
           rom[ 0+1235] ='b01111100;
           rom[ 0+1236] ='b00101001;
           rom[ 0+1237] ='b00101000;
           rom[ 0+1238] ='b00101101;
           rom[ 0+1239] ='b00101100;
           rom[ 0+1240] ='b00111001;
           rom[ 0+1241] ='b00111000;
           rom[ 0+1242] ='b00111101;
           rom[ 0+1243] ='b00111100;
           rom[ 0+1244] ='b11001101;
           rom[ 0+1245] ='b11001100;
           rom[ 0+1246] ='b11001001;
           rom[ 0+1247] ='b11001000;
           rom[ 0+1248] ='b11011101;
           rom[ 0+1249] ='b11011100;
           rom[ 0+1250] ='b11011001;
           rom[ 0+1251] ='b11011000;
           rom[ 0+1252] ='b10001101;
           rom[ 0+1253] ='b10001100;
           rom[ 0+1254] ='b10001001;
           rom[ 0+1255] ='b10001000;
           rom[ 0+1256] ='b10011101;
           rom[ 0+1257] ='b10011100;
           rom[ 0+1258] ='b10011001;
           rom[ 0+1259] ='b10011000;
           rom[ 0+1260] ='b11010000;
           rom[ 0+1261] ='b11010001;
           rom[ 0+1262] ='b11010100;
           rom[ 0+1263] ='b11010101;
           rom[ 0+1264] ='b11000000;
           rom[ 0+1265] ='b11000001;
           rom[ 0+1266] ='b11000100;
           rom[ 0+1267] ='b11000101;
           rom[ 0+1268] ='b10010000;
           rom[ 0+1269] ='b10010001;
           rom[ 0+1270] ='b10010100;
           rom[ 0+1271] ='b10010101;
           rom[ 0+1272] ='b10000000;
           rom[ 0+1273] ='b10000001;
           rom[ 0+1274] ='b10000100;
           rom[ 0+1275] ='b10000101;
           rom[ 0+1276] ='b10111001;
           rom[ 0+1277] ='b10111000;
           rom[ 0+1278] ='b10111101;
           rom[ 0+1279] ='b10111100;
           rom[ 0+1280] ='b10101001;
           rom[ 0+1281] ='b10101000;
           rom[ 0+1282] ='b10101101;
           rom[ 0+1283] ='b10101100;
           rom[ 0+1284] ='b11111001;
           rom[ 0+1285] ='b11111000;
           rom[ 0+1286] ='b11111101;
           rom[ 0+1287] ='b11111100;
           rom[ 0+1288] ='b11101001;
           rom[ 0+1289] ='b11101000;
           rom[ 0+1290] ='b11101101;
           rom[ 0+1291] ='b11101100;
           rom[ 0+1292] ='b10100100;
           rom[ 0+1293] ='b10100101;
           rom[ 0+1294] ='b10100000;
           rom[ 0+1295] ='b10100001;
           rom[ 0+1296] ='b10110100;
           rom[ 0+1297] ='b10110101;
           rom[ 0+1298] ='b10110000;
           rom[ 0+1299] ='b10110001;
           rom[ 0+1300] ='b11100100;
           rom[ 0+1301] ='b11100101;
           rom[ 0+1302] ='b11100000;
           rom[ 0+1303] ='b11100001;
           rom[ 0+1304] ='b11110100;
           rom[ 0+1305] ='b11110101;
           rom[ 0+1306] ='b11110000;
           rom[ 0+1307] ='b11110001;
           rom[ 0+1308] ='b00010011;
           rom[ 0+1309] ='b00010010;
           rom[ 0+1310] ='b00010111;
           rom[ 0+1311] ='b00010110;
           rom[ 0+1312] ='b00000011;
           rom[ 0+1313] ='b00000010;
           rom[ 0+1314] ='b00000111;
           rom[ 0+1315] ='b00000110;
           rom[ 0+1316] ='b01010011;
           rom[ 0+1317] ='b01010010;
           rom[ 0+1318] ='b01010111;
           rom[ 0+1319] ='b01010110;
           rom[ 0+1320] ='b01000011;
           rom[ 0+1321] ='b01000010;
           rom[ 0+1322] ='b01000111;
           rom[ 0+1323] ='b01000110;
           rom[ 0+1324] ='b00001110;
           rom[ 0+1325] ='b00001111;
           rom[ 0+1326] ='b00001010;
           rom[ 0+1327] ='b00001011;
           rom[ 0+1328] ='b00011110;
           rom[ 0+1329] ='b00011111;
           rom[ 0+1330] ='b00011010;
           rom[ 0+1331] ='b00011011;
           rom[ 0+1332] ='b01001110;
           rom[ 0+1333] ='b01001111;
           rom[ 0+1334] ='b01001010;
           rom[ 0+1335] ='b01001011;
           rom[ 0+1336] ='b01011110;
           rom[ 0+1337] ='b01011111;
           rom[ 0+1338] ='b01011010;
           rom[ 0+1339] ='b01011011;
           rom[ 0+1340] ='b01100111;
           rom[ 0+1341] ='b01100110;
           rom[ 0+1342] ='b01100011;
           rom[ 0+1343] ='b01100010;
           rom[ 0+1344] ='b01110111;
           rom[ 0+1345] ='b01110110;
           rom[ 0+1346] ='b01110011;
           rom[ 0+1347] ='b01110010;
           rom[ 0+1348] ='b00100111;
           rom[ 0+1349] ='b00100110;
           rom[ 0+1350] ='b00100011;
           rom[ 0+1351] ='b00100010;
           rom[ 0+1352] ='b00110111;
           rom[ 0+1353] ='b00110110;
           rom[ 0+1354] ='b00110011;
           rom[ 0+1355] ='b00110010;
           rom[ 0+1356] ='b01111010;
           rom[ 0+1357] ='b01111011;
           rom[ 0+1358] ='b01111110;
           rom[ 0+1359] ='b01111111;
           rom[ 0+1360] ='b01101010;
           rom[ 0+1361] ='b01101011;
           rom[ 0+1362] ='b01101110;
           rom[ 0+1363] ='b01101111;
           rom[ 0+1364] ='b00111010;
           rom[ 0+1365] ='b00111011;
           rom[ 0+1366] ='b00111110;
           rom[ 0+1367] ='b00111111;
           rom[ 0+1368] ='b00101010;
           rom[ 0+1369] ='b00101011;
           rom[ 0+1370] ='b00101110;
           rom[ 0+1371] ='b00101111;
           rom[ 0+1372] ='b11011110;
           rom[ 0+1373] ='b11011111;
           rom[ 0+1374] ='b11011010;
           rom[ 0+1375] ='b11011011;
           rom[ 0+1376] ='b11001110;
           rom[ 0+1377] ='b11001111;
           rom[ 0+1378] ='b11001010;
           rom[ 0+1379] ='b11001011;
           rom[ 0+1380] ='b10011110;
           rom[ 0+1381] ='b10011111;
           rom[ 0+1382] ='b10011010;
           rom[ 0+1383] ='b10011011;
           rom[ 0+1384] ='b10001110;
           rom[ 0+1385] ='b10001111;
           rom[ 0+1386] ='b10001010;
           rom[ 0+1387] ='b10001011;
           rom[ 0+1388] ='b11000011;
           rom[ 0+1389] ='b11000010;
           rom[ 0+1390] ='b11000111;
           rom[ 0+1391] ='b11000110;
           rom[ 0+1392] ='b11010011;
           rom[ 0+1393] ='b11010010;
           rom[ 0+1394] ='b11010111;
           rom[ 0+1395] ='b11010110;
           rom[ 0+1396] ='b10000011;
           rom[ 0+1397] ='b10000010;
           rom[ 0+1398] ='b10000111;
           rom[ 0+1399] ='b10000110;
           rom[ 0+1400] ='b10010011;
           rom[ 0+1401] ='b10010010;
           rom[ 0+1402] ='b10010111;
           rom[ 0+1403] ='b10010110;
           rom[ 0+1404] ='b10101010;
           rom[ 0+1405] ='b10101011;
           rom[ 0+1406] ='b10101110;
           rom[ 0+1407] ='b10101111;
           rom[ 0+1408] ='b10111010;
           rom[ 0+1409] ='b10111011;
           rom[ 0+1410] ='b10111110;
           rom[ 0+1411] ='b10111111;
           rom[ 0+1412] ='b11101010;
           rom[ 0+1413] ='b11101011;
           rom[ 0+1414] ='b11101110;
           rom[ 0+1415] ='b11101111;
           rom[ 0+1416] ='b11111010;
           rom[ 0+1417] ='b11111011;
           rom[ 0+1418] ='b11111110;
           rom[ 0+1419] ='b11111111;
           rom[ 0+1420] ='b10110111;
           rom[ 0+1421] ='b10110110;
           rom[ 0+1422] ='b10110011;
           rom[ 0+1423] ='b10110010;
           rom[ 0+1424] ='b10100111;
           rom[ 0+1425] ='b10100110;
           rom[ 0+1426] ='b10100011;
           rom[ 0+1427] ='b10100010;
           rom[ 0+1428] ='b11110111;
           rom[ 0+1429] ='b11110110;
           rom[ 0+1430] ='b11110011;
           rom[ 0+1431] ='b11110010;
           rom[ 0+1432] ='b11100111;
           rom[ 0+1433] ='b11100110;
           rom[ 0+1434] ='b11100011;
           rom[ 0+1435] ='b11100010;
           rom[ 0+1436] ='b00000000;
           rom[ 0+1437] ='b11010110;
           rom[ 0+1438] ='b11101000;
           rom[ 0+1439] ='b00111110;
           rom[ 0+1440] ='b11101010;
           rom[ 0+1441] ='b00111100;
           rom[ 0+1442] ='b00000010;
           rom[ 0+1443] ='b11010100;
           rom[ 0+1444] ='b00101100;
           rom[ 0+1445] ='b11111010;
           rom[ 0+1446] ='b11000100;
           rom[ 0+1447] ='b00010010;
           rom[ 0+1448] ='b11000110;
           rom[ 0+1449] ='b00010000;
           rom[ 0+1450] ='b00101110;
           rom[ 0+1451] ='b11111000;
           rom[ 0+1452] ='b11101110;
           rom[ 0+1453] ='b00111000;
           rom[ 0+1454] ='b00000110;
           rom[ 0+1455] ='b11010000;
           rom[ 0+1456] ='b00000100;
           rom[ 0+1457] ='b11010010;
           rom[ 0+1458] ='b11101100;
           rom[ 0+1459] ='b00111010;
           rom[ 0+1460] ='b11000010;
           rom[ 0+1461] ='b00010100;
           rom[ 0+1462] ='b00101010;
           rom[ 0+1463] ='b11111100;
           rom[ 0+1464] ='b00101000;
           rom[ 0+1465] ='b11111110;
           rom[ 0+1466] ='b11000000;
           rom[ 0+1467] ='b00010110;
           rom[ 0+1468] ='b00000000;
           rom[ 0+1469] ='b00000000;
           rom[ 0+1470] ='b00000000;
           rom[ 0+1471] ='b00000000;
           rom[ 0+1472] ='b00000000;
           rom[ 0+1473] ='b00000000;
           rom[ 0+1474] ='b00000000;
           rom[ 0+1475] ='b00000000;
           rom[ 0+1476] ='b00000000;
           rom[ 0+1477] ='b00000000;
           rom[ 0+1478] ='b00000000;
           rom[ 0+1479] ='b00000000;
           rom[ 0+1480] ='b00000000;
           rom[ 0+1481] ='b00000000;
           rom[ 0+1482] ='b00000000;
           rom[ 0+1483] ='b00000000;
           rom[ 0+1484] ='b00000000;
           rom[ 0+1485] ='b00000000;
           rom[ 0+1486] ='b00000000;
           rom[ 0+1487] ='b00000000;
           rom[ 0+1488] ='b00000000;
           rom[ 0+1489] ='b00000000;
           rom[ 0+1490] ='b00000000;
           rom[ 0+1491] ='b00000000;
           rom[ 0+1492] ='b00000000;
           rom[ 0+1493] ='b00000000;
           rom[ 0+1494] ='b00000000;
           rom[ 0+1495] ='b00000000;
           rom[ 0+1496] ='b00000000;
           rom[ 0+1497] ='b00000000;
           rom[ 0+1498] ='b00000000;
           rom[ 0+1499] ='b00000000;
           rom[ 0+1500] ='b00100100;
           rom[ 0+1501] ='b11110010;
           rom[ 0+1502] ='b11001100;
           rom[ 0+1503] ='b00011010;
           rom[ 0+1504] ='b11001110;
           rom[ 0+1505] ='b00011000;
           rom[ 0+1506] ='b00100110;
           rom[ 0+1507] ='b11110000;
           rom[ 0+1508] ='b00001000;
           rom[ 0+1509] ='b11011110;
           rom[ 0+1510] ='b11100000;
           rom[ 0+1511] ='b00110110;
           rom[ 0+1512] ='b11100010;
           rom[ 0+1513] ='b00110100;
           rom[ 0+1514] ='b00001010;
           rom[ 0+1515] ='b11011100;
           rom[ 0+1516] ='b11001010;
           rom[ 0+1517] ='b00011100;
           rom[ 0+1518] ='b00100010;
           rom[ 0+1519] ='b11110100;
           rom[ 0+1520] ='b00100000;
           rom[ 0+1521] ='b11110110;
           rom[ 0+1522] ='b11001000;
           rom[ 0+1523] ='b00011110;
           rom[ 0+1524] ='b11100110;
           rom[ 0+1525] ='b00110000;
           rom[ 0+1526] ='b00001110;
           rom[ 0+1527] ='b11011000;
           rom[ 0+1528] ='b00001100;
           rom[ 0+1529] ='b11011010;
           rom[ 0+1530] ='b11100100;
           rom[ 0+1531] ='b00110010;
           rom[ 0+1532] ='b00000000;
           rom[ 0+1533] ='b00000000;
           rom[ 0+1534] ='b00000000;
           rom[ 0+1535] ='b00000000;
           rom[ 0+1536] ='b00000000;
           rom[ 0+1537] ='b00000000;
           rom[ 0+1538] ='b00000000;
           rom[ 0+1539] ='b00000000;
           rom[ 0+1540] ='b00000000;
           rom[ 0+1541] ='b00000000;
           rom[ 0+1542] ='b00000000;
           rom[ 0+1543] ='b00000000;
           rom[ 0+1544] ='b00000000;
           rom[ 0+1545] ='b00000000;
           rom[ 0+1546] ='b00000000;
           rom[ 0+1547] ='b00000000;
           rom[ 0+1548] ='b00000000;
           rom[ 0+1549] ='b00000000;
           rom[ 0+1550] ='b00000000;
           rom[ 0+1551] ='b00000000;
           rom[ 0+1552] ='b00000000;
           rom[ 0+1553] ='b00000000;
           rom[ 0+1554] ='b00000000;
           rom[ 0+1555] ='b00000000;
           rom[ 0+1556] ='b00000000;
           rom[ 0+1557] ='b00000000;
           rom[ 0+1558] ='b00000000;
           rom[ 0+1559] ='b00000000;
           rom[ 0+1560] ='b00000000;
           rom[ 0+1561] ='b00000000;
           rom[ 0+1562] ='b00000000;
           rom[ 0+1563] ='b00000000;
           rom[ 0+1564] ='b01010000;
           rom[ 0+1565] ='b10000110;
           rom[ 0+1566] ='b10111000;
           rom[ 0+1567] ='b01101110;
           rom[ 0+1568] ='b10111010;
           rom[ 0+1569] ='b01101100;
           rom[ 0+1570] ='b01010010;
           rom[ 0+1571] ='b10000100;
           rom[ 0+1572] ='b01111100;
           rom[ 0+1573] ='b10101010;
           rom[ 0+1574] ='b10010100;
           rom[ 0+1575] ='b01000010;
           rom[ 0+1576] ='b10010110;
           rom[ 0+1577] ='b01000000;
           rom[ 0+1578] ='b01111110;
           rom[ 0+1579] ='b10101000;
           rom[ 0+1580] ='b10111110;
           rom[ 0+1581] ='b01101000;
           rom[ 0+1582] ='b01010110;
           rom[ 0+1583] ='b10000000;
           rom[ 0+1584] ='b01010100;
           rom[ 0+1585] ='b10000010;
           rom[ 0+1586] ='b10111100;
           rom[ 0+1587] ='b01101010;
           rom[ 0+1588] ='b10010010;
           rom[ 0+1589] ='b01000100;
           rom[ 0+1590] ='b01111010;
           rom[ 0+1591] ='b10101100;
           rom[ 0+1592] ='b01111000;
           rom[ 0+1593] ='b10101110;
           rom[ 0+1594] ='b10010000;
           rom[ 0+1595] ='b01000110;
           rom[ 0+1596] ='b00000000;
           rom[ 0+1597] ='b00000000;
           rom[ 0+1598] ='b00000000;
           rom[ 0+1599] ='b00000000;
           rom[ 0+1600] ='b00000000;
           rom[ 0+1601] ='b00000000;
           rom[ 0+1602] ='b00000000;
           rom[ 0+1603] ='b00000000;
           rom[ 0+1604] ='b00000000;
           rom[ 0+1605] ='b00000000;
           rom[ 0+1606] ='b00000000;
           rom[ 0+1607] ='b00000000;
           rom[ 0+1608] ='b00000000;
           rom[ 0+1609] ='b00000000;
           rom[ 0+1610] ='b00000000;
           rom[ 0+1611] ='b00000000;
           rom[ 0+1612] ='b00000000;
           rom[ 0+1613] ='b00000000;
           rom[ 0+1614] ='b00000000;
           rom[ 0+1615] ='b00000000;
           rom[ 0+1616] ='b00000000;
           rom[ 0+1617] ='b00000000;
           rom[ 0+1618] ='b00000000;
           rom[ 0+1619] ='b00000000;
           rom[ 0+1620] ='b00000000;
           rom[ 0+1621] ='b00000000;
           rom[ 0+1622] ='b00000000;
           rom[ 0+1623] ='b00000000;
           rom[ 0+1624] ='b00000000;
           rom[ 0+1625] ='b00000000;
           rom[ 0+1626] ='b00000000;
           rom[ 0+1627] ='b00000000;
           rom[ 0+1628] ='b01110100;
           rom[ 0+1629] ='b10100010;
           rom[ 0+1630] ='b10011100;
           rom[ 0+1631] ='b01001010;
           rom[ 0+1632] ='b10011110;
           rom[ 0+1633] ='b01001000;
           rom[ 0+1634] ='b01110110;
           rom[ 0+1635] ='b10100000;
           rom[ 0+1636] ='b01011000;
           rom[ 0+1637] ='b10001110;
           rom[ 0+1638] ='b10110000;
           rom[ 0+1639] ='b01100110;
           rom[ 0+1640] ='b10110010;
           rom[ 0+1641] ='b01100100;
           rom[ 0+1642] ='b01011010;
           rom[ 0+1643] ='b10001100;
           rom[ 0+1644] ='b10011010;
           rom[ 0+1645] ='b01001100;
           rom[ 0+1646] ='b01110010;
           rom[ 0+1647] ='b10100100;
           rom[ 0+1648] ='b01110000;
           rom[ 0+1649] ='b10100110;
           rom[ 0+1650] ='b10011000;
           rom[ 0+1651] ='b01001110;
           rom[ 0+1652] ='b10110110;
           rom[ 0+1653] ='b01100000;
           rom[ 0+1654] ='b01011110;
           rom[ 0+1655] ='b10001000;
           rom[ 0+1656] ='b01011100;
           rom[ 0+1657] ='b10001010;
           rom[ 0+1658] ='b10110100;
           rom[ 0+1659] ='b01100010;
           rom[ 0+1660] ='b00000000;
           rom[ 0+1661] ='b00000000;
           rom[ 0+1662] ='b00000000;
           rom[ 0+1663] ='b00000000;
           rom[ 0+1664] ='b00000000;
           rom[ 0+1665] ='b00000000;
           rom[ 0+1666] ='b00000000;
           rom[ 0+1667] ='b00000000;
           rom[ 0+1668] ='b00000000;
           rom[ 0+1669] ='b00000000;
           rom[ 0+1670] ='b00000000;
           rom[ 0+1671] ='b00000000;
           rom[ 0+1672] ='b00000000;
           rom[ 0+1673] ='b00000000;
           rom[ 0+1674] ='b00000000;
           rom[ 0+1675] ='b00000000;
           rom[ 0+1676] ='b00000000;
           rom[ 0+1677] ='b00000000;
           rom[ 0+1678] ='b00000000;
           rom[ 0+1679] ='b00000000;
           rom[ 0+1680] ='b00000000;
           rom[ 0+1681] ='b00000000;
           rom[ 0+1682] ='b00000000;
           rom[ 0+1683] ='b00000000;
           rom[ 0+1684] ='b00000000;
           rom[ 0+1685] ='b00000000;
           rom[ 0+1686] ='b00000000;
           rom[ 0+1687] ='b00000000;
           rom[ 0+1688] ='b00000000;
           rom[ 0+1689] ='b00000000;
           rom[ 0+1690] ='b00000000;
           rom[ 0+1691] ='b00000000;
           rom[ 0+1692] ='b00000000;
           rom[ 0+1693] ='b11010111;
           rom[ 0+1694] ='b00000000;
           rom[ 0+1695] ='b00000000;
           rom[ 0+1696] ='b00000000;
           rom[ 0+1697] ='b00000000;
           rom[ 0+1698] ='b00000000;
           rom[ 0+1699] ='b11001011;
           rom[ 0+1700] ='b10110011;
           rom[ 0+1701] ='b00000000;
           rom[ 0+1702] ='b11011100;
           rom[ 0+1703] ='b00000000;
           rom[ 0+1704] ='b01110001;
           rom[ 0+1705] ='b00000000;
           rom[ 0+1706] ='b00000000;
           rom[ 0+1707] ='b01100111;
           rom[ 0+1708] ='b00000000;
           rom[ 0+1709] ='b00000000;
           rom[ 0+1710] ='b00000000;
           rom[ 0+1711] ='b00000000;
           rom[ 0+1712] ='b00000000;
           rom[ 0+1713] ='b10111000;
           rom[ 0+1714] ='b00000000;
           rom[ 0+1715] ='b11110010;
           rom[ 0+1716] ='b00000000;
           rom[ 0+1717] ='b00000000;
           rom[ 0+1718] ='b10100111;
           rom[ 0+1719] ='b00000000;
           rom[ 0+1720] ='b00000000;
           rom[ 0+1721] ='b00000000;
           rom[ 0+1722] ='b00000000;
           rom[ 0+1723] ='b00000000;
           rom[ 0+1724] ='b00000000;
           rom[ 0+1725] ='b11000011;
           rom[ 0+1726] ='b00000000;
           rom[ 0+1727] ='b00000000;
           rom[ 0+1728] ='b11101001;
           rom[ 0+1729] ='b11001101;
           rom[ 0+1730] ='b11111111;
           rom[ 0+1731] ='b11101000;
           rom[ 0+1732] ='b00000000;
           rom[ 0+1733] ='b11011010;
           rom[ 0+1734] ='b00000000;
           rom[ 0+1735] ='b00000000;
           rom[ 0+1736] ='b11111101;
           rom[ 0+1737] ='b11100011;
           rom[ 0+1738] ='b00000000;
           rom[ 0+1739] ='b11010000;
           rom[ 0+1740] ='b00000000;
           rom[ 0+1741] ='b00000000;
           rom[ 0+1742] ='b00000000;
           rom[ 0+1743] ='b00000000;
           rom[ 0+1744] ='b00000000;
           rom[ 0+1745] ='b11000100;
           rom[ 0+1746] ='b11111100;
           rom[ 0+1747] ='b00000000;
           rom[ 0+1748] ='b11000010;
           rom[ 0+1749] ='b00000000;
           rom[ 0+1750] ='b11111110;
           rom[ 0+1751] ='b01101010;
           rom[ 0+1752] ='b00000000;
           rom[ 0+1753] ='b11010001;
           rom[ 0+1754] ='b11000101;
           rom[ 0+1755] ='b00000000;
           rom[ 0+1756] ='b01111111;
           rom[ 0+1757] ='b00000000;
           rom[ 0+1758] ='b00000000;
           rom[ 0+1759] ='b00000000;
           rom[ 0+1760] ='b11011101;
           rom[ 0+1761] ='b00000000;
           rom[ 0+1762] ='b01101110;
           rom[ 0+1763] ='b00000000;
           rom[ 0+1764] ='b00000000;
           rom[ 0+1765] ='b00000000;
           rom[ 0+1766] ='b00000000;
           rom[ 0+1767] ='b00000000;
           rom[ 0+1768] ='b00000000;
           rom[ 0+1769] ='b00000000;
           rom[ 0+1770] ='b00000000;
           rom[ 0+1771] ='b00000000;
           rom[ 0+1772] ='b10100101;
           rom[ 0+1773] ='b00000000;
           rom[ 0+1774] ='b00000000;
           rom[ 0+1775] ='b00000000;
           rom[ 0+1776] ='b00000000;
           rom[ 0+1777] ='b10101100;
           rom[ 0+1778] ='b11001010;
           rom[ 0+1779] ='b11110011;
           rom[ 0+1780] ='b00000000;
           rom[ 0+1781] ='b01110010;
           rom[ 0+1782] ='b00000000;
           rom[ 0+1783] ='b00000000;
           rom[ 0+1784] ='b00000000;
           rom[ 0+1785] ='b00000000;
           rom[ 0+1786] ='b00000000;
           rom[ 0+1787] ='b00000000;
           rom[ 0+1788] ='b11100010;
           rom[ 0+1789] ='b11101010;
           rom[ 0+1790] ='b00000000;
           rom[ 0+1791] ='b00000000;
           rom[ 0+1792] ='b11101011;
           rom[ 0+1793] ='b10111101;
           rom[ 0+1794] ='b11001100;
           rom[ 0+1795] ='b00000000;
           rom[ 0+1796] ='b00000000;
           rom[ 0+1797] ='b00000000;
           rom[ 0+1798] ='b00000000;
           rom[ 0+1799] ='b00000000;
           rom[ 0+1800] ='b00000000;
           rom[ 0+1801] ='b00000000;
           rom[ 0+1802] ='b11110111;
           rom[ 0+1803] ='b00000000;
           rom[ 0+1804] ='b00000000;
           rom[ 0+1805] ='b00000000;
           rom[ 0+1806] ='b00000000;
           rom[ 0+1807] ='b00000000;
           rom[ 0+1808] ='b00000000;
           rom[ 0+1809] ='b11011011;
           rom[ 0+1810] ='b00000000;
           rom[ 0+1811] ='b00000000;
           rom[ 0+1812] ='b11001110;
           rom[ 0+1813] ='b00000000;
           rom[ 0+1814] ='b00000000;
           rom[ 0+1815] ='b00000000;
           rom[ 0+1816] ='b00000000;
           rom[ 0+1817] ='b11100111;
           rom[ 0+1818] ='b00000000;
           rom[ 0+1819] ='b00000000;
           rom[ 0+1820] ='b00000000;
           rom[ 0+1821] ='b00000000;
           rom[ 0+1822] ='b11111011;
           rom[ 0+1823] ='b00000000;
           rom[ 0+1824] ='b00000000;
           rom[ 0+1825] ='b00000000;
           rom[ 0+1826] ='b11100000;
           rom[ 0+1827] ='b00000000;
           rom[ 0+1828] ='b00000000;
           rom[ 0+1829] ='b00000000;
           rom[ 0+1830] ='b11111010;
           rom[ 0+1831] ='b11110000;
           rom[ 0+1832] ='b00000000;
           rom[ 0+1833] ='b00000000;
           rom[ 0+1834] ='b00000000;
           rom[ 0+1835] ='b10110110;
           rom[ 0+1836] ='b00000000;
           rom[ 0+1837] ='b10100000;
           rom[ 0+1838] ='b00000000;
           rom[ 0+1839] ='b00000000;
           rom[ 0+1840] ='b00000000;
           rom[ 0+1841] ='b00000000;
           rom[ 0+1842] ='b11110100;
           rom[ 0+1843] ='b00000000;
           rom[ 0+1844] ='b00000000;
           rom[ 0+1845] ='b00000000;
           rom[ 0+1846] ='b00000000;
           rom[ 0+1847] ='b00000000;
           rom[ 0+1848] ='b00000000;
           rom[ 0+1849] ='b00000000;
           rom[ 0+1850] ='b00000000;
           rom[ 0+1851] ='b00000000;
           rom[ 0+1852] ='b00000000;
           rom[ 0+1853] ='b00000000;
           rom[ 0+1854] ='b00000000;
           rom[ 0+1855] ='b00000000;
           rom[ 0+1856] ='b00000000;
           rom[ 0+1857] ='b00000000;
           rom[ 0+1858] ='b00000000;
           rom[ 0+1859] ='b00000000;
           rom[ 0+1860] ='b00000000;
           rom[ 0+1861] ='b11101111;
           rom[ 0+1862] ='b00000000;
           rom[ 0+1863] ='b00000000;
           rom[ 0+1864] ='b00000000;
           rom[ 0+1865] ='b11100101;
           rom[ 0+1866] ='b00000000;
           rom[ 0+1867] ='b00000000;
           rom[ 0+1868] ='b00000000;
           rom[ 0+1869] ='b00000000;
           rom[ 0+1870] ='b00000000;
           rom[ 0+1871] ='b10111010;
           rom[ 0+1872] ='b00000000;
           rom[ 0+1873] ='b00000000;
           rom[ 0+1874] ='b11111000;
           rom[ 0+1875] ='b00000000;
           rom[ 0+1876] ='b11111001;
           rom[ 0+1877] ='b00000000;
           rom[ 0+1878] ='b00000000;
           rom[ 0+1879] ='b00000000;
           rom[ 0+1880] ='b00000000;
           rom[ 0+1881] ='b00000000;
           rom[ 0+1882] ='b00000000;
           rom[ 0+1883] ='b00000000;
           rom[ 0+1884] ='b00000000;
           rom[ 0+1885] ='b00000000;
           rom[ 0+1886] ='b00000000;
           rom[ 0+1887] ='b11010101;
           rom[ 0+1888] ='b11110101;
           rom[ 0+1889] ='b11010100;
           rom[ 0+1890] ='b00000000;
           rom[ 0+1891] ='b00000000;
           rom[ 0+1892] ='b00000000;
           rom[ 0+1893] ='b00000000;
           rom[ 0+1894] ='b00000000;
           rom[ 0+1895] ='b00000000;
           rom[ 0+1896] ='b00000000;
           rom[ 0+1897] ='b11110001;
           rom[ 0+1898] ='b11101100;
           rom[ 0+1899] ='b11010011;
           rom[ 0+1900] ='b00000000;
           rom[ 0+1901] ='b00000000;
           rom[ 0+1902] ='b00000000;
           rom[ 0+1903] ='b00000000;
           rom[ 0+1904] ='b00000000;
           rom[ 0+1905] ='b00000000;
           rom[ 0+1906] ='b00000000;
           rom[ 0+1907] ='b00000000;
           rom[ 0+1908] ='b00000000;
           rom[ 0+1909] ='b11101101;
           rom[ 0+1910] ='b00000000;
           rom[ 0+1911] ='b00000000;
           rom[ 0+1912] ='b00000000;
           rom[ 0+1913] ='b00000000;
           rom[ 0+1914] ='b00000000;
           rom[ 0+1915] ='b00000000;
           rom[ 0+1916] ='b00000000;
           rom[ 0+1917] ='b00000000;
           rom[ 0+1918] ='b00000000;
           rom[ 0+1919] ='b00000000;
           rom[ 0+1920] ='b00000000;
           rom[ 0+1921] ='b00000000;
           rom[ 0+1922] ='b00000000;
           rom[ 0+1923] ='b00000000;
           rom[ 0+1924] ='b00000000;
           rom[ 0+1925] ='b00000000;
           rom[ 0+1926] ='b00000000;
           rom[ 0+1927] ='b00000000;
           rom[ 0+1928] ='b00000000;
           rom[ 0+1929] ='b00000000;
           rom[ 0+1930] ='b00000000;
           rom[ 0+1931] ='b00000000;
           rom[ 0+1932] ='b00000000;
           rom[ 0+1933] ='b00000000;
           rom[ 0+1934] ='b00000000;
           rom[ 0+1935] ='b00000000;
           rom[ 0+1936] ='b00000000;
           rom[ 0+1937] ='b00000000;
           rom[ 0+1938] ='b00000000;
           rom[ 0+1939] ='b00000000;
           rom[ 0+1940] ='b00000000;
           rom[ 0+1941] ='b00000000;
           rom[ 0+1942] ='b00000000;
           rom[ 0+1943] ='b00000000;
           rom[ 0+1944] ='b00000000;
           rom[ 0+1945] ='b00000000;
           rom[ 0+1946] ='b00000000;
           rom[ 0+1947] ='b00000000;
           rom[ 0+1948] ='b00000000;
           rom[ 0+1949] ='b01110101;
           rom[ 0+1950] ='b11101010;
           rom[ 0+1951] ='b10011111;
           rom[ 0+1952] ='b11001001;
           rom[ 0+1953] ='b10111100;
           rom[ 0+1954] ='b00100011;
           rom[ 0+1955] ='b01010110;
           rom[ 0+1956] ='b10001111;
           rom[ 0+1957] ='b11111010;
           rom[ 0+1958] ='b01100101;
           rom[ 0+1959] ='b00010000;
           rom[ 0+1960] ='b01000110;
           rom[ 0+1961] ='b00110011;
           rom[ 0+1962] ='b10101100;
           rom[ 0+1963] ='b11011001;
           rom[ 0+1964] ='b00000011;
           rom[ 0+1965] ='b01110110;
           rom[ 0+1966] ='b11101001;
           rom[ 0+1967] ='b10011100;
           rom[ 0+1968] ='b11001010;
           rom[ 0+1969] ='b10111111;
           rom[ 0+1970] ='b00100000;
           rom[ 0+1971] ='b01010101;
           rom[ 0+1972] ='b10001100;
           rom[ 0+1973] ='b11111001;
           rom[ 0+1974] ='b01100110;
           rom[ 0+1975] ='b00010011;
           rom[ 0+1976] ='b01000101;
           rom[ 0+1977] ='b00110000;
           rom[ 0+1978] ='b10101111;
           rom[ 0+1979] ='b11011010;
           rom[ 0+1980] ='b00000110;
           rom[ 0+1981] ='b01110011;
           rom[ 0+1982] ='b11101100;
           rom[ 0+1983] ='b10011001;
           rom[ 0+1984] ='b11001111;
           rom[ 0+1985] ='b10111010;
           rom[ 0+1986] ='b00100101;
           rom[ 0+1987] ='b01010000;
           rom[ 0+1988] ='b10001001;
           rom[ 0+1989] ='b11111100;
           rom[ 0+1990] ='b01100011;
           rom[ 0+1991] ='b00010110;
           rom[ 0+1992] ='b01000000;
           rom[ 0+1993] ='b00110101;
           rom[ 0+1994] ='b10101010;
           rom[ 0+1995] ='b11011111;
           rom[ 0+1996] ='b00000101;
           rom[ 0+1997] ='b01110000;
           rom[ 0+1998] ='b11101111;
           rom[ 0+1999] ='b10011010;
           rom[ 0+2000] ='b11001100;
           rom[ 0+2001] ='b10111001;
           rom[ 0+2002] ='b00100110;
           rom[ 0+2003] ='b01010011;
           rom[ 0+2004] ='b10001010;
           rom[ 0+2005] ='b11111111;
           rom[ 0+2006] ='b01100000;
           rom[ 0+2007] ='b00010101;
           rom[ 0+2008] ='b01000011;
           rom[ 0+2009] ='b00110110;
           rom[ 0+2010] ='b10101001;
           rom[ 0+2011] ='b11011100;
           rom[ 0+2012] ='b00001100;
           rom[ 0+2013] ='b01111001;
           rom[ 0+2014] ='b11100110;
           rom[ 0+2015] ='b10010011;
           rom[ 0+2016] ='b11000101;
           rom[ 0+2017] ='b10110000;
           rom[ 0+2018] ='b00101111;
           rom[ 0+2019] ='b01011010;
           rom[ 0+2020] ='b10000011;
           rom[ 0+2021] ='b11110110;
           rom[ 0+2022] ='b01101001;
           rom[ 0+2023] ='b00011100;
           rom[ 0+2024] ='b01001010;
           rom[ 0+2025] ='b00111111;
           rom[ 0+2026] ='b10100000;
           rom[ 0+2027] ='b11010101;
           rom[ 0+2028] ='b00001111;
           rom[ 0+2029] ='b01111010;
           rom[ 0+2030] ='b11100101;
           rom[ 0+2031] ='b10010000;
           rom[ 0+2032] ='b11000110;
           rom[ 0+2033] ='b10110011;
           rom[ 0+2034] ='b00101100;
           rom[ 0+2035] ='b01011001;
           rom[ 0+2036] ='b10000000;
           rom[ 0+2037] ='b11110101;
           rom[ 0+2038] ='b01101010;
           rom[ 0+2039] ='b00011111;
           rom[ 0+2040] ='b01001001;
           rom[ 0+2041] ='b00111100;
           rom[ 0+2042] ='b10100011;
           rom[ 0+2043] ='b11010110;
           rom[ 0+2044] ='b00001010;
           rom[ 0+2045] ='b01111111;
           rom[ 0+2046] ='b11100000;
           rom[ 0+2047] ='b10010101;
           rom[ 0+2048] ='b11000011;
           rom[ 0+2049] ='b10110110;
           rom[ 0+2050] ='b00101001;
           rom[ 0+2051] ='b01011100;
           rom[ 0+2052] ='b10000101;
           rom[ 0+2053] ='b11110000;
           rom[ 0+2054] ='b01101111;
           rom[ 0+2055] ='b00011010;
           rom[ 0+2056] ='b01001100;
           rom[ 0+2057] ='b00111001;
           rom[ 0+2058] ='b10100110;
           rom[ 0+2059] ='b11010011;
           rom[ 0+2060] ='b00001001;
           rom[ 0+2061] ='b01111100;
           rom[ 0+2062] ='b11100011;
           rom[ 0+2063] ='b10010110;
           rom[ 0+2064] ='b11000000;
           rom[ 0+2065] ='b10110101;
           rom[ 0+2066] ='b00101010;
           rom[ 0+2067] ='b01011111;
           rom[ 0+2068] ='b10000110;
           rom[ 0+2069] ='b11110011;
           rom[ 0+2070] ='b01101100;
           rom[ 0+2071] ='b00011001;
           rom[ 0+2072] ='b01001111;
           rom[ 0+2073] ='b00111010;
           rom[ 0+2074] ='b10100101;
           rom[ 0+2075] ='b11010000;
           rom[ 0+2076] ='b00011000;
           rom[ 0+2077] ='b01101101;
           rom[ 0+2078] ='b11110010;
           rom[ 0+2079] ='b10000111;
           rom[ 0+2080] ='b11010001;
           rom[ 0+2081] ='b10100100;
           rom[ 0+2082] ='b00111011;
           rom[ 0+2083] ='b01001110;
           rom[ 0+2084] ='b10010111;
           rom[ 0+2085] ='b11100010;
           rom[ 0+2086] ='b01111101;
           rom[ 0+2087] ='b00001000;
           rom[ 0+2088] ='b01011110;
           rom[ 0+2089] ='b00101011;
           rom[ 0+2090] ='b10110100;
           rom[ 0+2091] ='b11000001;
           rom[ 0+2092] ='b00011011;
           rom[ 0+2093] ='b01101110;
           rom[ 0+2094] ='b11110001;
           rom[ 0+2095] ='b10000100;
           rom[ 0+2096] ='b11010010;
           rom[ 0+2097] ='b10100111;
           rom[ 0+2098] ='b00111000;
           rom[ 0+2099] ='b01001101;
           rom[ 0+2100] ='b10010100;
           rom[ 0+2101] ='b11100001;
           rom[ 0+2102] ='b01111110;
           rom[ 0+2103] ='b00001011;
           rom[ 0+2104] ='b01011101;
           rom[ 0+2105] ='b00101000;
           rom[ 0+2106] ='b10110111;
           rom[ 0+2107] ='b11000010;
           rom[ 0+2108] ='b00011110;
           rom[ 0+2109] ='b01101011;
           rom[ 0+2110] ='b11110100;
           rom[ 0+2111] ='b10000001;
           rom[ 0+2112] ='b11010111;
           rom[ 0+2113] ='b10100010;
           rom[ 0+2114] ='b00111101;
           rom[ 0+2115] ='b01001000;
           rom[ 0+2116] ='b10010001;
           rom[ 0+2117] ='b11100100;
           rom[ 0+2118] ='b01111011;
           rom[ 0+2119] ='b00001110;
           rom[ 0+2120] ='b01011000;
           rom[ 0+2121] ='b00101101;
           rom[ 0+2122] ='b10110010;
           rom[ 0+2123] ='b11000111;
           rom[ 0+2124] ='b00011101;
           rom[ 0+2125] ='b01101000;
           rom[ 0+2126] ='b11110111;
           rom[ 0+2127] ='b10000010;
           rom[ 0+2128] ='b11010100;
           rom[ 0+2129] ='b10100001;
           rom[ 0+2130] ='b00111110;
           rom[ 0+2131] ='b01001011;
           rom[ 0+2132] ='b10010010;
           rom[ 0+2133] ='b11100111;
           rom[ 0+2134] ='b01111000;
           rom[ 0+2135] ='b00001101;
           rom[ 0+2136] ='b01011011;
           rom[ 0+2137] ='b00101110;
           rom[ 0+2138] ='b10110001;
           rom[ 0+2139] ='b11000100;
           rom[ 0+2140] ='b00010100;
           rom[ 0+2141] ='b01100001;
           rom[ 0+2142] ='b11111110;
           rom[ 0+2143] ='b10001011;
           rom[ 0+2144] ='b11011101;
           rom[ 0+2145] ='b10101000;
           rom[ 0+2146] ='b00110111;
           rom[ 0+2147] ='b01000010;
           rom[ 0+2148] ='b10011011;
           rom[ 0+2149] ='b11101110;
           rom[ 0+2150] ='b01110001;
           rom[ 0+2151] ='b00000100;
           rom[ 0+2152] ='b01010010;
           rom[ 0+2153] ='b00100111;
           rom[ 0+2154] ='b10111000;
           rom[ 0+2155] ='b11001101;
           rom[ 0+2156] ='b00010111;
           rom[ 0+2157] ='b01100010;
           rom[ 0+2158] ='b11111101;
           rom[ 0+2159] ='b10001000;
           rom[ 0+2160] ='b11011110;
           rom[ 0+2161] ='b10101011;
           rom[ 0+2162] ='b00110100;
           rom[ 0+2163] ='b01000001;
           rom[ 0+2164] ='b10011000;
           rom[ 0+2165] ='b11101101;
           rom[ 0+2166] ='b01110010;
           rom[ 0+2167] ='b00000111;
           rom[ 0+2168] ='b01010001;
           rom[ 0+2169] ='b00100100;
           rom[ 0+2170] ='b10111011;
           rom[ 0+2171] ='b11001110;
           rom[ 0+2172] ='b00010010;
           rom[ 0+2173] ='b01100111;
           rom[ 0+2174] ='b11111000;
           rom[ 0+2175] ='b10001101;
           rom[ 0+2176] ='b11011011;
           rom[ 0+2177] ='b10101110;
           rom[ 0+2178] ='b00110001;
           rom[ 0+2179] ='b01000100;
           rom[ 0+2180] ='b10011101;
           rom[ 0+2181] ='b11101000;
           rom[ 0+2182] ='b01110111;
           rom[ 0+2183] ='b00000010;
           rom[ 0+2184] ='b01010100;
           rom[ 0+2185] ='b00100001;
           rom[ 0+2186] ='b10111110;
           rom[ 0+2187] ='b11001011;
           rom[ 0+2188] ='b00010001;
           rom[ 0+2189] ='b01100100;
           rom[ 0+2190] ='b11111011;
           rom[ 0+2191] ='b10001110;
           rom[ 0+2192] ='b11011000;
           rom[ 0+2193] ='b10101101;
           rom[ 0+2194] ='b00110010;
           rom[ 0+2195] ='b01000111;
           rom[ 0+2196] ='b10011110;
           rom[ 0+2197] ='b11101011;
           rom[ 0+2198] ='b01110100;
           rom[ 0+2199] ='b00000001;
           rom[ 0+2200] ='b01010111;
           rom[ 0+2201] ='b00100010;
           rom[ 0+2202] ='b10111101;
           rom[ 0+2203] ='b11001000;
           rom[ 0+2204] ='b00000000;
           rom[ 0+2205] ='b01000100;
           rom[ 0+2206] ='b10001000;
           rom[ 0+2207] ='b11001100;
           rom[ 0+2208] ='b00001101;
           rom[ 0+2209] ='b01001001;
           rom[ 0+2210] ='b10000101;
           rom[ 0+2211] ='b11000001;
           rom[ 0+2212] ='b00011010;
           rom[ 0+2213] ='b01011110;
           rom[ 0+2214] ='b10010010;
           rom[ 0+2215] ='b11010110;
           rom[ 0+2216] ='b00010111;
           rom[ 0+2217] ='b01010011;
           rom[ 0+2218] ='b10011111;
           rom[ 0+2219] ='b11011011;
           rom[ 0+2220] ='b00110100;
           rom[ 0+2221] ='b01110000;
           rom[ 0+2222] ='b10111100;
           rom[ 0+2223] ='b11111000;
           rom[ 0+2224] ='b00111001;
           rom[ 0+2225] ='b01111101;
           rom[ 0+2226] ='b10110001;
           rom[ 0+2227] ='b11110101;
           rom[ 0+2228] ='b00101110;
           rom[ 0+2229] ='b01101010;
           rom[ 0+2230] ='b10100110;
           rom[ 0+2231] ='b11100010;
           rom[ 0+2232] ='b00100011;
           rom[ 0+2233] ='b01100111;
           rom[ 0+2234] ='b10101011;
           rom[ 0+2235] ='b11101111;
           rom[ 0+2236] ='b01101000;
           rom[ 0+2237] ='b00101100;
           rom[ 0+2238] ='b11100000;
           rom[ 0+2239] ='b10100100;
           rom[ 0+2240] ='b01100101;
           rom[ 0+2241] ='b00100001;
           rom[ 0+2242] ='b11101101;
           rom[ 0+2243] ='b10101001;
           rom[ 0+2244] ='b01110010;
           rom[ 0+2245] ='b00110110;
           rom[ 0+2246] ='b11111010;
           rom[ 0+2247] ='b10111110;
           rom[ 0+2248] ='b01111111;
           rom[ 0+2249] ='b00111011;
           rom[ 0+2250] ='b11110111;
           rom[ 0+2251] ='b10110011;
           rom[ 0+2252] ='b01011100;
           rom[ 0+2253] ='b00011000;
           rom[ 0+2254] ='b11010100;
           rom[ 0+2255] ='b10010000;
           rom[ 0+2256] ='b01010001;
           rom[ 0+2257] ='b00010101;
           rom[ 0+2258] ='b11011001;
           rom[ 0+2259] ='b10011101;
           rom[ 0+2260] ='b01000110;
           rom[ 0+2261] ='b00000010;
           rom[ 0+2262] ='b11001110;
           rom[ 0+2263] ='b10001010;
           rom[ 0+2264] ='b01001011;
           rom[ 0+2265] ='b00001111;
           rom[ 0+2266] ='b11000011;
           rom[ 0+2267] ='b10000111;
           rom[ 0+2268] ='b11010000;
           rom[ 0+2269] ='b10010100;
           rom[ 0+2270] ='b01011000;
           rom[ 0+2271] ='b00011100;
           rom[ 0+2272] ='b11011101;
           rom[ 0+2273] ='b10011001;
           rom[ 0+2274] ='b01010101;
           rom[ 0+2275] ='b00010001;
           rom[ 0+2276] ='b11001010;
           rom[ 0+2277] ='b10001110;
           rom[ 0+2278] ='b01000010;
           rom[ 0+2279] ='b00000110;
           rom[ 0+2280] ='b11000111;
           rom[ 0+2281] ='b10000011;
           rom[ 0+2282] ='b01001111;
           rom[ 0+2283] ='b00001011;
           rom[ 0+2284] ='b11100100;
           rom[ 0+2285] ='b10100000;
           rom[ 0+2286] ='b01101100;
           rom[ 0+2287] ='b00101000;
           rom[ 0+2288] ='b11101001;
           rom[ 0+2289] ='b10101101;
           rom[ 0+2290] ='b01100001;
           rom[ 0+2291] ='b00100101;
           rom[ 0+2292] ='b11111110;
           rom[ 0+2293] ='b10111010;
           rom[ 0+2294] ='b01110110;
           rom[ 0+2295] ='b00110010;
           rom[ 0+2296] ='b11110011;
           rom[ 0+2297] ='b10110111;
           rom[ 0+2298] ='b01111011;
           rom[ 0+2299] ='b00111111;
           rom[ 0+2300] ='b10111000;
           rom[ 0+2301] ='b11111100;
           rom[ 0+2302] ='b00110000;
           rom[ 0+2303] ='b01110100;
           rom[ 0+2304] ='b10110101;
           rom[ 0+2305] ='b11110001;
           rom[ 0+2306] ='b00111101;
           rom[ 0+2307] ='b01111001;
           rom[ 0+2308] ='b10100010;
           rom[ 0+2309] ='b11100110;
           rom[ 0+2310] ='b00101010;
           rom[ 0+2311] ='b01101110;
           rom[ 0+2312] ='b10101111;
           rom[ 0+2313] ='b11101011;
           rom[ 0+2314] ='b00100111;
           rom[ 0+2315] ='b01100011;
           rom[ 0+2316] ='b10001100;
           rom[ 0+2317] ='b11001000;
           rom[ 0+2318] ='b00000100;
           rom[ 0+2319] ='b01000000;
           rom[ 0+2320] ='b10000001;
           rom[ 0+2321] ='b11000101;
           rom[ 0+2322] ='b00001001;
           rom[ 0+2323] ='b01001101;
           rom[ 0+2324] ='b10010110;
           rom[ 0+2325] ='b11010010;
           rom[ 0+2326] ='b00011110;
           rom[ 0+2327] ='b01011010;
           rom[ 0+2328] ='b10011011;
           rom[ 0+2329] ='b11011111;
           rom[ 0+2330] ='b00010011;
           rom[ 0+2331] ='b01010111;
           rom[ 0+2332] ='b10111101;
           rom[ 0+2333] ='b11111001;
           rom[ 0+2334] ='b00110101;
           rom[ 0+2335] ='b01110001;
           rom[ 0+2336] ='b10110000;
           rom[ 0+2337] ='b11110100;
           rom[ 0+2338] ='b00111000;
           rom[ 0+2339] ='b01111100;
           rom[ 0+2340] ='b10100111;
           rom[ 0+2341] ='b11100011;
           rom[ 0+2342] ='b00101111;
           rom[ 0+2343] ='b01101011;
           rom[ 0+2344] ='b10101010;
           rom[ 0+2345] ='b11101110;
           rom[ 0+2346] ='b00100010;
           rom[ 0+2347] ='b01100110;
           rom[ 0+2348] ='b10001001;
           rom[ 0+2349] ='b11001101;
           rom[ 0+2350] ='b00000001;
           rom[ 0+2351] ='b01000101;
           rom[ 0+2352] ='b10000100;
           rom[ 0+2353] ='b11000000;
           rom[ 0+2354] ='b00001100;
           rom[ 0+2355] ='b01001000;
           rom[ 0+2356] ='b10010011;
           rom[ 0+2357] ='b11010111;
           rom[ 0+2358] ='b00011011;
           rom[ 0+2359] ='b01011111;
           rom[ 0+2360] ='b10011110;
           rom[ 0+2361] ='b11011010;
           rom[ 0+2362] ='b00010110;
           rom[ 0+2363] ='b01010010;
           rom[ 0+2364] ='b11010101;
           rom[ 0+2365] ='b10010001;
           rom[ 0+2366] ='b01011101;
           rom[ 0+2367] ='b00011001;
           rom[ 0+2368] ='b11011000;
           rom[ 0+2369] ='b10011100;
           rom[ 0+2370] ='b01010000;
           rom[ 0+2371] ='b00010100;
           rom[ 0+2372] ='b11001111;
           rom[ 0+2373] ='b10001011;
           rom[ 0+2374] ='b01000111;
           rom[ 0+2375] ='b00000011;
           rom[ 0+2376] ='b11000010;
           rom[ 0+2377] ='b10000110;
           rom[ 0+2378] ='b01001010;
           rom[ 0+2379] ='b00001110;
           rom[ 0+2380] ='b11100001;
           rom[ 0+2381] ='b10100101;
           rom[ 0+2382] ='b01101001;
           rom[ 0+2383] ='b00101101;
           rom[ 0+2384] ='b11101100;
           rom[ 0+2385] ='b10101000;
           rom[ 0+2386] ='b01100100;
           rom[ 0+2387] ='b00100000;
           rom[ 0+2388] ='b11111011;
           rom[ 0+2389] ='b10111111;
           rom[ 0+2390] ='b01110011;
           rom[ 0+2391] ='b00110111;
           rom[ 0+2392] ='b11110110;
           rom[ 0+2393] ='b10110010;
           rom[ 0+2394] ='b01111110;
           rom[ 0+2395] ='b00111010;
           rom[ 0+2396] ='b01101101;
           rom[ 0+2397] ='b00101001;
           rom[ 0+2398] ='b11100101;
           rom[ 0+2399] ='b10100001;
           rom[ 0+2400] ='b01100000;
           rom[ 0+2401] ='b00100100;
           rom[ 0+2402] ='b11101000;
           rom[ 0+2403] ='b10101100;
           rom[ 0+2404] ='b01110111;
           rom[ 0+2405] ='b00110011;
           rom[ 0+2406] ='b11111111;
           rom[ 0+2407] ='b10111011;
           rom[ 0+2408] ='b01111010;
           rom[ 0+2409] ='b00111110;
           rom[ 0+2410] ='b11110010;
           rom[ 0+2411] ='b10110110;
           rom[ 0+2412] ='b01011001;
           rom[ 0+2413] ='b00011101;
           rom[ 0+2414] ='b11010001;
           rom[ 0+2415] ='b10010101;
           rom[ 0+2416] ='b01010100;
           rom[ 0+2417] ='b00010000;
           rom[ 0+2418] ='b11011100;
           rom[ 0+2419] ='b10011000;
           rom[ 0+2420] ='b01000011;
           rom[ 0+2421] ='b00000111;
           rom[ 0+2422] ='b11001011;
           rom[ 0+2423] ='b10001111;
           rom[ 0+2424] ='b01001110;
           rom[ 0+2425] ='b00001010;
           rom[ 0+2426] ='b11000110;
           rom[ 0+2427] ='b10000010;
           rom[ 0+2428] ='b00000101;
           rom[ 0+2429] ='b01000001;
           rom[ 0+2430] ='b10001101;
           rom[ 0+2431] ='b11001001;
           rom[ 0+2432] ='b00001000;
           rom[ 0+2433] ='b01001100;
           rom[ 0+2434] ='b10000000;
           rom[ 0+2435] ='b11000100;
           rom[ 0+2436] ='b00011111;
           rom[ 0+2437] ='b01011011;
           rom[ 0+2438] ='b10010111;
           rom[ 0+2439] ='b11010011;
           rom[ 0+2440] ='b00010010;
           rom[ 0+2441] ='b01010110;
           rom[ 0+2442] ='b10011010;
           rom[ 0+2443] ='b11011110;
           rom[ 0+2444] ='b00110001;
           rom[ 0+2445] ='b01110101;
           rom[ 0+2446] ='b10111001;
           rom[ 0+2447] ='b11111101;
           rom[ 0+2448] ='b00111100;
           rom[ 0+2449] ='b01111000;
           rom[ 0+2450] ='b10110100;
           rom[ 0+2451] ='b11110000;
           rom[ 0+2452] ='b00101011;
           rom[ 0+2453] ='b01101111;
           rom[ 0+2454] ='b10100011;
           rom[ 0+2455] ='b11100111;
           rom[ 0+2456] ='b00100110;
           rom[ 0+2457] ='b01100010;
           rom[ 0+2458] ='b10101110;
           rom[ 0+2459] ='b11101010;
           rom[ 0+2460] ='b00000000;
           rom[ 0+2461] ='b00001011;
           rom[ 0+2462] ='b00010110;
           rom[ 0+2463] ='b00011101;
           rom[ 0+2464] ='b00101100;
           rom[ 0+2465] ='b00100111;
           rom[ 0+2466] ='b00111010;
           rom[ 0+2467] ='b00110001;
           rom[ 0+2468] ='b01011000;
           rom[ 0+2469] ='b01010011;
           rom[ 0+2470] ='b01001110;
           rom[ 0+2471] ='b01000101;
           rom[ 0+2472] ='b01110100;
           rom[ 0+2473] ='b01111111;
           rom[ 0+2474] ='b01100010;
           rom[ 0+2475] ='b01101001;
           rom[ 0+2476] ='b10110000;
           rom[ 0+2477] ='b10111011;
           rom[ 0+2478] ='b10100110;
           rom[ 0+2479] ='b10101101;
           rom[ 0+2480] ='b10011100;
           rom[ 0+2481] ='b10010111;
           rom[ 0+2482] ='b10001010;
           rom[ 0+2483] ='b10000001;
           rom[ 0+2484] ='b11101000;
           rom[ 0+2485] ='b11100011;
           rom[ 0+2486] ='b11111110;
           rom[ 0+2487] ='b11110101;
           rom[ 0+2488] ='b11000100;
           rom[ 0+2489] ='b11001111;
           rom[ 0+2490] ='b11010010;
           rom[ 0+2491] ='b11011001;
           rom[ 0+2492] ='b01111101;
           rom[ 0+2493] ='b01110110;
           rom[ 0+2494] ='b01101011;
           rom[ 0+2495] ='b01100000;
           rom[ 0+2496] ='b01010001;
           rom[ 0+2497] ='b01011010;
           rom[ 0+2498] ='b01000111;
           rom[ 0+2499] ='b01001100;
           rom[ 0+2500] ='b00100101;
           rom[ 0+2501] ='b00101110;
           rom[ 0+2502] ='b00110011;
           rom[ 0+2503] ='b00111000;
           rom[ 0+2504] ='b00001001;
           rom[ 0+2505] ='b00000010;
           rom[ 0+2506] ='b00011111;
           rom[ 0+2507] ='b00010100;
           rom[ 0+2508] ='b11001101;
           rom[ 0+2509] ='b11000110;
           rom[ 0+2510] ='b11011011;
           rom[ 0+2511] ='b11010000;
           rom[ 0+2512] ='b11100001;
           rom[ 0+2513] ='b11101010;
           rom[ 0+2514] ='b11110111;
           rom[ 0+2515] ='b11111100;
           rom[ 0+2516] ='b10010101;
           rom[ 0+2517] ='b10011110;
           rom[ 0+2518] ='b10000011;
           rom[ 0+2519] ='b10001000;
           rom[ 0+2520] ='b10111001;
           rom[ 0+2521] ='b10110010;
           rom[ 0+2522] ='b10101111;
           rom[ 0+2523] ='b10100100;
           rom[ 0+2524] ='b11111010;
           rom[ 0+2525] ='b11110001;
           rom[ 0+2526] ='b11101100;
           rom[ 0+2527] ='b11100111;
           rom[ 0+2528] ='b11010110;
           rom[ 0+2529] ='b11011101;
           rom[ 0+2530] ='b11000000;
           rom[ 0+2531] ='b11001011;
           rom[ 0+2532] ='b10100010;
           rom[ 0+2533] ='b10101001;
           rom[ 0+2534] ='b10110100;
           rom[ 0+2535] ='b10111111;
           rom[ 0+2536] ='b10001110;
           rom[ 0+2537] ='b10000101;
           rom[ 0+2538] ='b10011000;
           rom[ 0+2539] ='b10010011;
           rom[ 0+2540] ='b01001010;
           rom[ 0+2541] ='b01000001;
           rom[ 0+2542] ='b01011100;
           rom[ 0+2543] ='b01010111;
           rom[ 0+2544] ='b01100110;
           rom[ 0+2545] ='b01101101;
           rom[ 0+2546] ='b01110000;
           rom[ 0+2547] ='b01111011;
           rom[ 0+2548] ='b00010010;
           rom[ 0+2549] ='b00011001;
           rom[ 0+2550] ='b00000100;
           rom[ 0+2551] ='b00001111;
           rom[ 0+2552] ='b00111110;
           rom[ 0+2553] ='b00110101;
           rom[ 0+2554] ='b00101000;
           rom[ 0+2555] ='b00100011;
           rom[ 0+2556] ='b10000111;
           rom[ 0+2557] ='b10001100;
           rom[ 0+2558] ='b10010001;
           rom[ 0+2559] ='b10011010;
           rom[ 0+2560] ='b10101011;
           rom[ 0+2561] ='b10100000;
           rom[ 0+2562] ='b10111101;
           rom[ 0+2563] ='b10110110;
           rom[ 0+2564] ='b11011111;
           rom[ 0+2565] ='b11010100;
           rom[ 0+2566] ='b11001001;
           rom[ 0+2567] ='b11000010;
           rom[ 0+2568] ='b11110011;
           rom[ 0+2569] ='b11111000;
           rom[ 0+2570] ='b11100101;
           rom[ 0+2571] ='b11101110;
           rom[ 0+2572] ='b00110111;
           rom[ 0+2573] ='b00111100;
           rom[ 0+2574] ='b00100001;
           rom[ 0+2575] ='b00101010;
           rom[ 0+2576] ='b00011011;
           rom[ 0+2577] ='b00010000;
           rom[ 0+2578] ='b00001101;
           rom[ 0+2579] ='b00000110;
           rom[ 0+2580] ='b01101111;
           rom[ 0+2581] ='b01100100;
           rom[ 0+2582] ='b01111001;
           rom[ 0+2583] ='b01110010;
           rom[ 0+2584] ='b01000011;
           rom[ 0+2585] ='b01001000;
           rom[ 0+2586] ='b01010101;
           rom[ 0+2587] ='b01011110;
           rom[ 0+2588] ='b11101001;
           rom[ 0+2589] ='b11100010;
           rom[ 0+2590] ='b11111111;
           rom[ 0+2591] ='b11110100;
           rom[ 0+2592] ='b11000101;
           rom[ 0+2593] ='b11001110;
           rom[ 0+2594] ='b11010011;
           rom[ 0+2595] ='b11011000;
           rom[ 0+2596] ='b10110001;
           rom[ 0+2597] ='b10111010;
           rom[ 0+2598] ='b10100111;
           rom[ 0+2599] ='b10101100;
           rom[ 0+2600] ='b10011101;
           rom[ 0+2601] ='b10010110;
           rom[ 0+2602] ='b10001011;
           rom[ 0+2603] ='b10000000;
           rom[ 0+2604] ='b01011001;
           rom[ 0+2605] ='b01010010;
           rom[ 0+2606] ='b01001111;
           rom[ 0+2607] ='b01000100;
           rom[ 0+2608] ='b01110101;
           rom[ 0+2609] ='b01111110;
           rom[ 0+2610] ='b01100011;
           rom[ 0+2611] ='b01101000;
           rom[ 0+2612] ='b00000001;
           rom[ 0+2613] ='b00001010;
           rom[ 0+2614] ='b00010111;
           rom[ 0+2615] ='b00011100;
           rom[ 0+2616] ='b00101101;
           rom[ 0+2617] ='b00100110;
           rom[ 0+2618] ='b00111011;
           rom[ 0+2619] ='b00110000;
           rom[ 0+2620] ='b10010100;
           rom[ 0+2621] ='b10011111;
           rom[ 0+2622] ='b10000010;
           rom[ 0+2623] ='b10001001;
           rom[ 0+2624] ='b10111000;
           rom[ 0+2625] ='b10110011;
           rom[ 0+2626] ='b10101110;
           rom[ 0+2627] ='b10100101;
           rom[ 0+2628] ='b11001100;
           rom[ 0+2629] ='b11000111;
           rom[ 0+2630] ='b11011010;
           rom[ 0+2631] ='b11010001;
           rom[ 0+2632] ='b11100000;
           rom[ 0+2633] ='b11101011;
           rom[ 0+2634] ='b11110110;
           rom[ 0+2635] ='b11111101;
           rom[ 0+2636] ='b00100100;
           rom[ 0+2637] ='b00101111;
           rom[ 0+2638] ='b00110010;
           rom[ 0+2639] ='b00111001;
           rom[ 0+2640] ='b00001000;
           rom[ 0+2641] ='b00000011;
           rom[ 0+2642] ='b00011110;
           rom[ 0+2643] ='b00010101;
           rom[ 0+2644] ='b01111100;
           rom[ 0+2645] ='b01110111;
           rom[ 0+2646] ='b01101010;
           rom[ 0+2647] ='b01100001;
           rom[ 0+2648] ='b01010000;
           rom[ 0+2649] ='b01011011;
           rom[ 0+2650] ='b01000110;
           rom[ 0+2651] ='b01001101;
           rom[ 0+2652] ='b00010011;
           rom[ 0+2653] ='b00011000;
           rom[ 0+2654] ='b00000101;
           rom[ 0+2655] ='b00001110;
           rom[ 0+2656] ='b00111111;
           rom[ 0+2657] ='b00110100;
           rom[ 0+2658] ='b00101001;
           rom[ 0+2659] ='b00100010;
           rom[ 0+2660] ='b01001011;
           rom[ 0+2661] ='b01000000;
           rom[ 0+2662] ='b01011101;
           rom[ 0+2663] ='b01010110;
           rom[ 0+2664] ='b01100111;
           rom[ 0+2665] ='b01101100;
           rom[ 0+2666] ='b01110001;
           rom[ 0+2667] ='b01111010;
           rom[ 0+2668] ='b10100011;
           rom[ 0+2669] ='b10101000;
           rom[ 0+2670] ='b10110101;
           rom[ 0+2671] ='b10111110;
           rom[ 0+2672] ='b10001111;
           rom[ 0+2673] ='b10000100;
           rom[ 0+2674] ='b10011001;
           rom[ 0+2675] ='b10010010;
           rom[ 0+2676] ='b11111011;
           rom[ 0+2677] ='b11110000;
           rom[ 0+2678] ='b11101101;
           rom[ 0+2679] ='b11100110;
           rom[ 0+2680] ='b11010111;
           rom[ 0+2681] ='b11011100;
           rom[ 0+2682] ='b11000001;
           rom[ 0+2683] ='b11001010;
           rom[ 0+2684] ='b01101110;
           rom[ 0+2685] ='b01100101;
           rom[ 0+2686] ='b01111000;
           rom[ 0+2687] ='b01110011;
           rom[ 0+2688] ='b01000010;
           rom[ 0+2689] ='b01001001;
           rom[ 0+2690] ='b01010100;
           rom[ 0+2691] ='b01011111;
           rom[ 0+2692] ='b00110110;
           rom[ 0+2693] ='b00111101;
           rom[ 0+2694] ='b00100000;
           rom[ 0+2695] ='b00101011;
           rom[ 0+2696] ='b00011010;
           rom[ 0+2697] ='b00010001;
           rom[ 0+2698] ='b00001100;
           rom[ 0+2699] ='b00000111;
           rom[ 0+2700] ='b11011110;
           rom[ 0+2701] ='b11010101;
           rom[ 0+2702] ='b11001000;
           rom[ 0+2703] ='b11000011;
           rom[ 0+2704] ='b11110010;
           rom[ 0+2705] ='b11111001;
           rom[ 0+2706] ='b11100100;
           rom[ 0+2707] ='b11101111;
           rom[ 0+2708] ='b10000110;
           rom[ 0+2709] ='b10001101;
           rom[ 0+2710] ='b10010000;
           rom[ 0+2711] ='b10011011;
           rom[ 0+2712] ='b10101010;
           rom[ 0+2713] ='b10100001;
           rom[ 0+2714] ='b10111100;
           rom[ 0+2715] ='b10110111;
           rom[ 0+2716] ='b00000000;
           rom[ 0+2717] ='b10100100;
           rom[ 0+2718] ='b01010101;
           rom[ 0+2719] ='b11110001;
           rom[ 0+2720] ='b10101010;
           rom[ 0+2721] ='b00001110;
           rom[ 0+2722] ='b11111111;
           rom[ 0+2723] ='b01011011;
           rom[ 0+2724] ='b01001001;
           rom[ 0+2725] ='b11101101;
           rom[ 0+2726] ='b00011100;
           rom[ 0+2727] ='b10111000;
           rom[ 0+2728] ='b11100011;
           rom[ 0+2729] ='b01000111;
           rom[ 0+2730] ='b10110110;
           rom[ 0+2731] ='b00010010;
           rom[ 0+2732] ='b10010010;
           rom[ 0+2733] ='b00110110;
           rom[ 0+2734] ='b11000111;
           rom[ 0+2735] ='b01100011;
           rom[ 0+2736] ='b00111000;
           rom[ 0+2737] ='b10011100;
           rom[ 0+2738] ='b01101101;
           rom[ 0+2739] ='b11001001;
           rom[ 0+2740] ='b11011011;
           rom[ 0+2741] ='b01111111;
           rom[ 0+2742] ='b10001110;
           rom[ 0+2743] ='b00101010;
           rom[ 0+2744] ='b01110001;
           rom[ 0+2745] ='b11010101;
           rom[ 0+2746] ='b00100100;
           rom[ 0+2747] ='b10000000;
           rom[ 0+2748] ='b00111001;
           rom[ 0+2749] ='b10011101;
           rom[ 0+2750] ='b01101100;
           rom[ 0+2751] ='b11001000;
           rom[ 0+2752] ='b10010011;
           rom[ 0+2753] ='b00110111;
           rom[ 0+2754] ='b11000110;
           rom[ 0+2755] ='b01100010;
           rom[ 0+2756] ='b01110000;
           rom[ 0+2757] ='b11010100;
           rom[ 0+2758] ='b00100101;
           rom[ 0+2759] ='b10000001;
           rom[ 0+2760] ='b11011010;
           rom[ 0+2761] ='b01111110;
           rom[ 0+2762] ='b10001111;
           rom[ 0+2763] ='b00101011;
           rom[ 0+2764] ='b10101011;
           rom[ 0+2765] ='b00001111;
           rom[ 0+2766] ='b11111110;
           rom[ 0+2767] ='b01011010;
           rom[ 0+2768] ='b00000001;
           rom[ 0+2769] ='b10100101;
           rom[ 0+2770] ='b01010100;
           rom[ 0+2771] ='b11110000;
           rom[ 0+2772] ='b11100010;
           rom[ 0+2773] ='b01000110;
           rom[ 0+2774] ='b10110111;
           rom[ 0+2775] ='b00010011;
           rom[ 0+2776] ='b01001000;
           rom[ 0+2777] ='b11101100;
           rom[ 0+2778] ='b00011101;
           rom[ 0+2779] ='b10111001;
           rom[ 0+2780] ='b01110010;
           rom[ 0+2781] ='b11010110;
           rom[ 0+2782] ='b00100111;
           rom[ 0+2783] ='b10000011;
           rom[ 0+2784] ='b11011000;
           rom[ 0+2785] ='b01111100;
           rom[ 0+2786] ='b10001101;
           rom[ 0+2787] ='b00101001;
           rom[ 0+2788] ='b00111011;
           rom[ 0+2789] ='b10011111;
           rom[ 0+2790] ='b01101110;
           rom[ 0+2791] ='b11001010;
           rom[ 0+2792] ='b10010001;
           rom[ 0+2793] ='b00110101;
           rom[ 0+2794] ='b11000100;
           rom[ 0+2795] ='b01100000;
           rom[ 0+2796] ='b11100000;
           rom[ 0+2797] ='b01000100;
           rom[ 0+2798] ='b10110101;
           rom[ 0+2799] ='b00010001;
           rom[ 0+2800] ='b01001010;
           rom[ 0+2801] ='b11101110;
           rom[ 0+2802] ='b00011111;
           rom[ 0+2803] ='b10111011;
           rom[ 0+2804] ='b10101001;
           rom[ 0+2805] ='b00001101;
           rom[ 0+2806] ='b11111100;
           rom[ 0+2807] ='b01011000;
           rom[ 0+2808] ='b00000011;
           rom[ 0+2809] ='b10100111;
           rom[ 0+2810] ='b01010110;
           rom[ 0+2811] ='b11110010;
           rom[ 0+2812] ='b01001011;
           rom[ 0+2813] ='b11101111;
           rom[ 0+2814] ='b00011110;
           rom[ 0+2815] ='b10111010;
           rom[ 0+2816] ='b11100001;
           rom[ 0+2817] ='b01000101;
           rom[ 0+2818] ='b10110100;
           rom[ 0+2819] ='b00010000;
           rom[ 0+2820] ='b00000010;
           rom[ 0+2821] ='b10100110;
           rom[ 0+2822] ='b01010111;
           rom[ 0+2823] ='b11110011;
           rom[ 0+2824] ='b10101000;
           rom[ 0+2825] ='b00001100;
           rom[ 0+2826] ='b11111101;
           rom[ 0+2827] ='b01011001;
           rom[ 0+2828] ='b11011001;
           rom[ 0+2829] ='b01111101;
           rom[ 0+2830] ='b10001100;
           rom[ 0+2831] ='b00101000;
           rom[ 0+2832] ='b01110011;
           rom[ 0+2833] ='b11010111;
           rom[ 0+2834] ='b00100110;
           rom[ 0+2835] ='b10000010;
           rom[ 0+2836] ='b10010000;
           rom[ 0+2837] ='b00110100;
           rom[ 0+2838] ='b11000101;
           rom[ 0+2839] ='b01100001;
           rom[ 0+2840] ='b00111010;
           rom[ 0+2841] ='b10011110;
           rom[ 0+2842] ='b01101111;
           rom[ 0+2843] ='b11001011;
           rom[ 0+2844] ='b11100100;
           rom[ 0+2845] ='b01000000;
           rom[ 0+2846] ='b10110001;
           rom[ 0+2847] ='b00010101;
           rom[ 0+2848] ='b01001110;
           rom[ 0+2849] ='b11101010;
           rom[ 0+2850] ='b00011011;
           rom[ 0+2851] ='b10111111;
           rom[ 0+2852] ='b10101101;
           rom[ 0+2853] ='b00001001;
           rom[ 0+2854] ='b11111000;
           rom[ 0+2855] ='b01011100;
           rom[ 0+2856] ='b00000111;
           rom[ 0+2857] ='b10100011;
           rom[ 0+2858] ='b01010010;
           rom[ 0+2859] ='b11110110;
           rom[ 0+2860] ='b01110110;
           rom[ 0+2861] ='b11010010;
           rom[ 0+2862] ='b00100011;
           rom[ 0+2863] ='b10000111;
           rom[ 0+2864] ='b11011100;
           rom[ 0+2865] ='b01111000;
           rom[ 0+2866] ='b10001001;
           rom[ 0+2867] ='b00101101;
           rom[ 0+2868] ='b00111111;
           rom[ 0+2869] ='b10011011;
           rom[ 0+2870] ='b01101010;
           rom[ 0+2871] ='b11001110;
           rom[ 0+2872] ='b10010101;
           rom[ 0+2873] ='b00110001;
           rom[ 0+2874] ='b11000000;
           rom[ 0+2875] ='b01100100;
           rom[ 0+2876] ='b11011101;
           rom[ 0+2877] ='b01111001;
           rom[ 0+2878] ='b10001000;
           rom[ 0+2879] ='b00101100;
           rom[ 0+2880] ='b01110111;
           rom[ 0+2881] ='b11010011;
           rom[ 0+2882] ='b00100010;
           rom[ 0+2883] ='b10000110;
           rom[ 0+2884] ='b10010100;
           rom[ 0+2885] ='b00110000;
           rom[ 0+2886] ='b11000001;
           rom[ 0+2887] ='b01100101;
           rom[ 0+2888] ='b00111110;
           rom[ 0+2889] ='b10011010;
           rom[ 0+2890] ='b01101011;
           rom[ 0+2891] ='b11001111;
           rom[ 0+2892] ='b01001111;
           rom[ 0+2893] ='b11101011;
           rom[ 0+2894] ='b00011010;
           rom[ 0+2895] ='b10111110;
           rom[ 0+2896] ='b11100101;
           rom[ 0+2897] ='b01000001;
           rom[ 0+2898] ='b10110000;
           rom[ 0+2899] ='b00010100;
           rom[ 0+2900] ='b00000110;
           rom[ 0+2901] ='b10100010;
           rom[ 0+2902] ='b01010011;
           rom[ 0+2903] ='b11110111;
           rom[ 0+2904] ='b10101100;
           rom[ 0+2905] ='b00001000;
           rom[ 0+2906] ='b11111001;
           rom[ 0+2907] ='b01011101;
           rom[ 0+2908] ='b10010110;
           rom[ 0+2909] ='b00110010;
           rom[ 0+2910] ='b11000011;
           rom[ 0+2911] ='b01100111;
           rom[ 0+2912] ='b00111100;
           rom[ 0+2913] ='b10011000;
           rom[ 0+2914] ='b01101001;
           rom[ 0+2915] ='b11001101;
           rom[ 0+2916] ='b11011111;
           rom[ 0+2917] ='b01111011;
           rom[ 0+2918] ='b10001010;
           rom[ 0+2919] ='b00101110;
           rom[ 0+2920] ='b01110101;
           rom[ 0+2921] ='b11010001;
           rom[ 0+2922] ='b00100000;
           rom[ 0+2923] ='b10000100;
           rom[ 0+2924] ='b00000100;
           rom[ 0+2925] ='b10100000;
           rom[ 0+2926] ='b01010001;
           rom[ 0+2927] ='b11110101;
           rom[ 0+2928] ='b10101110;
           rom[ 0+2929] ='b00001010;
           rom[ 0+2930] ='b11111011;
           rom[ 0+2931] ='b01011111;
           rom[ 0+2932] ='b01001101;
           rom[ 0+2933] ='b11101001;
           rom[ 0+2934] ='b00011000;
           rom[ 0+2935] ='b10111100;
           rom[ 0+2936] ='b11100111;
           rom[ 0+2937] ='b01000011;
           rom[ 0+2938] ='b10110010;
           rom[ 0+2939] ='b00010110;
           rom[ 0+2940] ='b10101111;
           rom[ 0+2941] ='b00001011;
           rom[ 0+2942] ='b11111010;
           rom[ 0+2943] ='b01011110;
           rom[ 0+2944] ='b00000101;
           rom[ 0+2945] ='b10100001;
           rom[ 0+2946] ='b01010000;
           rom[ 0+2947] ='b11110100;
           rom[ 0+2948] ='b11100110;
           rom[ 0+2949] ='b01000010;
           rom[ 0+2950] ='b10110011;
           rom[ 0+2951] ='b00010111;
           rom[ 0+2952] ='b01001100;
           rom[ 0+2953] ='b11101000;
           rom[ 0+2954] ='b00011001;
           rom[ 0+2955] ='b10111101;
           rom[ 0+2956] ='b00111101;
           rom[ 0+2957] ='b10011001;
           rom[ 0+2958] ='b01101000;
           rom[ 0+2959] ='b11001100;
           rom[ 0+2960] ='b10010111;
           rom[ 0+2961] ='b00110011;
           rom[ 0+2962] ='b11000010;
           rom[ 0+2963] ='b01100110;
           rom[ 0+2964] ='b01110100;
           rom[ 0+2965] ='b11010000;
           rom[ 0+2966] ='b00100001;
           rom[ 0+2967] ='b10000101;
           rom[ 0+2968] ='b11011110;
           rom[ 0+2969] ='b01111010;
           rom[ 0+2970] ='b10001011;
           rom[ 0+2971] ='b00101111;
           rom[ 0+2972] ='b00000000;
           rom[ 0+2973] ='b10011010;
           rom[ 0+2974] ='b00101001;
           rom[ 0+2975] ='b10110011;
           rom[ 0+2976] ='b01010010;
           rom[ 0+2977] ='b11001000;
           rom[ 0+2978] ='b01111011;
           rom[ 0+2979] ='b11100001;
           rom[ 0+2980] ='b10100100;
           rom[ 0+2981] ='b00111110;
           rom[ 0+2982] ='b10001101;
           rom[ 0+2983] ='b00010111;
           rom[ 0+2984] ='b11110110;
           rom[ 0+2985] ='b01101100;
           rom[ 0+2986] ='b11011111;
           rom[ 0+2987] ='b01000101;
           rom[ 0+2988] ='b01010101;
           rom[ 0+2989] ='b11001111;
           rom[ 0+2990] ='b01111100;
           rom[ 0+2991] ='b11100110;
           rom[ 0+2992] ='b00000111;
           rom[ 0+2993] ='b10011101;
           rom[ 0+2994] ='b00101110;
           rom[ 0+2995] ='b10110100;
           rom[ 0+2996] ='b11110001;
           rom[ 0+2997] ='b01101011;
           rom[ 0+2998] ='b11011000;
           rom[ 0+2999] ='b01000010;
           rom[ 0+3000] ='b10100011;
           rom[ 0+3001] ='b00111001;
           rom[ 0+3002] ='b10001010;
           rom[ 0+3003] ='b00010000;
           rom[ 0+3004] ='b10101010;
           rom[ 0+3005] ='b00110000;
           rom[ 0+3006] ='b10000011;
           rom[ 0+3007] ='b00011001;
           rom[ 0+3008] ='b11111000;
           rom[ 0+3009] ='b01100010;
           rom[ 0+3010] ='b11010001;
           rom[ 0+3011] ='b01001011;
           rom[ 0+3012] ='b00001110;
           rom[ 0+3013] ='b10010100;
           rom[ 0+3014] ='b00100111;
           rom[ 0+3015] ='b10111101;
           rom[ 0+3016] ='b01011100;
           rom[ 0+3017] ='b11000110;
           rom[ 0+3018] ='b01110101;
           rom[ 0+3019] ='b11101111;
           rom[ 0+3020] ='b11111111;
           rom[ 0+3021] ='b01100101;
           rom[ 0+3022] ='b11010110;
           rom[ 0+3023] ='b01001100;
           rom[ 0+3024] ='b10101101;
           rom[ 0+3025] ='b00110111;
           rom[ 0+3026] ='b10000100;
           rom[ 0+3027] ='b00011110;
           rom[ 0+3028] ='b01011011;
           rom[ 0+3029] ='b11000001;
           rom[ 0+3030] ='b01110010;
           rom[ 0+3031] ='b11101000;
           rom[ 0+3032] ='b00001001;
           rom[ 0+3033] ='b10010011;
           rom[ 0+3034] ='b00100000;
           rom[ 0+3035] ='b10111010;
           rom[ 0+3036] ='b01001001;
           rom[ 0+3037] ='b11010011;
           rom[ 0+3038] ='b01100000;
           rom[ 0+3039] ='b11111010;
           rom[ 0+3040] ='b00011011;
           rom[ 0+3041] ='b10000001;
           rom[ 0+3042] ='b00110010;
           rom[ 0+3043] ='b10101000;
           rom[ 0+3044] ='b11101101;
           rom[ 0+3045] ='b01110111;
           rom[ 0+3046] ='b11000100;
           rom[ 0+3047] ='b01011110;
           rom[ 0+3048] ='b10111111;
           rom[ 0+3049] ='b00100101;
           rom[ 0+3050] ='b10010110;
           rom[ 0+3051] ='b00001100;
           rom[ 0+3052] ='b00011100;
           rom[ 0+3053] ='b10000110;
           rom[ 0+3054] ='b00110101;
           rom[ 0+3055] ='b10101111;
           rom[ 0+3056] ='b01001110;
           rom[ 0+3057] ='b11010100;
           rom[ 0+3058] ='b01100111;
           rom[ 0+3059] ='b11111101;
           rom[ 0+3060] ='b10111000;
           rom[ 0+3061] ='b00100010;
           rom[ 0+3062] ='b10010001;
           rom[ 0+3063] ='b00001011;
           rom[ 0+3064] ='b11101010;
           rom[ 0+3065] ='b01110000;
           rom[ 0+3066] ='b11000011;
           rom[ 0+3067] ='b01011001;
           rom[ 0+3068] ='b11100011;
           rom[ 0+3069] ='b01111001;
           rom[ 0+3070] ='b11001010;
           rom[ 0+3071] ='b01010000;
           rom[ 0+3072] ='b10110001;
           rom[ 0+3073] ='b00101011;
           rom[ 0+3074] ='b10011000;
           rom[ 0+3075] ='b00000010;
           rom[ 0+3076] ='b01000111;
           rom[ 0+3077] ='b11011101;
           rom[ 0+3078] ='b01101110;
           rom[ 0+3079] ='b11110100;
           rom[ 0+3080] ='b00010101;
           rom[ 0+3081] ='b10001111;
           rom[ 0+3082] ='b00111100;
           rom[ 0+3083] ='b10100110;
           rom[ 0+3084] ='b10110110;
           rom[ 0+3085] ='b00101100;
           rom[ 0+3086] ='b10011111;
           rom[ 0+3087] ='b00000101;
           rom[ 0+3088] ='b11100100;
           rom[ 0+3089] ='b01111110;
           rom[ 0+3090] ='b11001101;
           rom[ 0+3091] ='b01010111;
           rom[ 0+3092] ='b00010010;
           rom[ 0+3093] ='b10001000;
           rom[ 0+3094] ='b00111011;
           rom[ 0+3095] ='b10100001;
           rom[ 0+3096] ='b01000000;
           rom[ 0+3097] ='b11011010;
           rom[ 0+3098] ='b01101001;
           rom[ 0+3099] ='b11110011;
           rom[ 0+3100] ='b10010010;
           rom[ 0+3101] ='b00001000;
           rom[ 0+3102] ='b10111011;
           rom[ 0+3103] ='b00100001;
           rom[ 0+3104] ='b11000000;
           rom[ 0+3105] ='b01011010;
           rom[ 0+3106] ='b11101001;
           rom[ 0+3107] ='b01110011;
           rom[ 0+3108] ='b00110110;
           rom[ 0+3109] ='b10101100;
           rom[ 0+3110] ='b00011111;
           rom[ 0+3111] ='b10000101;
           rom[ 0+3112] ='b01100100;
           rom[ 0+3113] ='b11111110;
           rom[ 0+3114] ='b01001101;
           rom[ 0+3115] ='b11010111;
           rom[ 0+3116] ='b11000111;
           rom[ 0+3117] ='b01011101;
           rom[ 0+3118] ='b11101110;
           rom[ 0+3119] ='b01110100;
           rom[ 0+3120] ='b10010101;
           rom[ 0+3121] ='b00001111;
           rom[ 0+3122] ='b10111100;
           rom[ 0+3123] ='b00100110;
           rom[ 0+3124] ='b01100011;
           rom[ 0+3125] ='b11111001;
           rom[ 0+3126] ='b01001010;
           rom[ 0+3127] ='b11010000;
           rom[ 0+3128] ='b00110001;
           rom[ 0+3129] ='b10101011;
           rom[ 0+3130] ='b00011000;
           rom[ 0+3131] ='b10000010;
           rom[ 0+3132] ='b00111000;
           rom[ 0+3133] ='b10100010;
           rom[ 0+3134] ='b00010001;
           rom[ 0+3135] ='b10001011;
           rom[ 0+3136] ='b01101010;
           rom[ 0+3137] ='b11110000;
           rom[ 0+3138] ='b01000011;
           rom[ 0+3139] ='b11011001;
           rom[ 0+3140] ='b10011100;
           rom[ 0+3141] ='b00000110;
           rom[ 0+3142] ='b10110101;
           rom[ 0+3143] ='b00101111;
           rom[ 0+3144] ='b11001110;
           rom[ 0+3145] ='b01010100;
           rom[ 0+3146] ='b11100111;
           rom[ 0+3147] ='b01111101;
           rom[ 0+3148] ='b01101101;
           rom[ 0+3149] ='b11110111;
           rom[ 0+3150] ='b01000100;
           rom[ 0+3151] ='b11011110;
           rom[ 0+3152] ='b00111111;
           rom[ 0+3153] ='b10100101;
           rom[ 0+3154] ='b00010110;
           rom[ 0+3155] ='b10001100;
           rom[ 0+3156] ='b11001001;
           rom[ 0+3157] ='b01010011;
           rom[ 0+3158] ='b11100000;
           rom[ 0+3159] ='b01111010;
           rom[ 0+3160] ='b10011011;
           rom[ 0+3161] ='b00000001;
           rom[ 0+3162] ='b10110010;
           rom[ 0+3163] ='b00101000;
           rom[ 0+3164] ='b11011011;
           rom[ 0+3165] ='b01000001;
           rom[ 0+3166] ='b11110010;
           rom[ 0+3167] ='b01101000;
           rom[ 0+3168] ='b10001001;
           rom[ 0+3169] ='b00010011;
           rom[ 0+3170] ='b10100000;
           rom[ 0+3171] ='b00111010;
           rom[ 0+3172] ='b01111111;
           rom[ 0+3173] ='b11100101;
           rom[ 0+3174] ='b01010110;
           rom[ 0+3175] ='b11001100;
           rom[ 0+3176] ='b00101101;
           rom[ 0+3177] ='b10110111;
           rom[ 0+3178] ='b00000100;
           rom[ 0+3179] ='b10011110;
           rom[ 0+3180] ='b10001110;
           rom[ 0+3181] ='b00010100;
           rom[ 0+3182] ='b10100111;
           rom[ 0+3183] ='b00111101;
           rom[ 0+3184] ='b11011100;
           rom[ 0+3185] ='b01000110;
           rom[ 0+3186] ='b11110101;
           rom[ 0+3187] ='b01101111;
           rom[ 0+3188] ='b00101010;
           rom[ 0+3189] ='b10110000;
           rom[ 0+3190] ='b00000011;
           rom[ 0+3191] ='b10011001;
           rom[ 0+3192] ='b01111000;
           rom[ 0+3193] ='b11100010;
           rom[ 0+3194] ='b01010001;
           rom[ 0+3195] ='b11001011;
           rom[ 0+3196] ='b01110001;
           rom[ 0+3197] ='b11101011;
           rom[ 0+3198] ='b01011000;
           rom[ 0+3199] ='b11000010;
           rom[ 0+3200] ='b00100011;
           rom[ 0+3201] ='b10111001;
           rom[ 0+3202] ='b00001010;
           rom[ 0+3203] ='b10010000;
           rom[ 0+3204] ='b11010101;
           rom[ 0+3205] ='b01001111;
           rom[ 0+3206] ='b11111100;
           rom[ 0+3207] ='b01100110;
           rom[ 0+3208] ='b10000111;
           rom[ 0+3209] ='b00011101;
           rom[ 0+3210] ='b10101110;
           rom[ 0+3211] ='b00110100;
           rom[ 0+3212] ='b00100100;
           rom[ 0+3213] ='b10111110;
           rom[ 0+3214] ='b00001101;
           rom[ 0+3215] ='b10010111;
           rom[ 0+3216] ='b01110110;
           rom[ 0+3217] ='b11101100;
           rom[ 0+3218] ='b01011111;
           rom[ 0+3219] ='b11000101;
           rom[ 0+3220] ='b10000000;
           rom[ 0+3221] ='b00011010;
           rom[ 0+3222] ='b10101001;
           rom[ 0+3223] ='b00110011;
           rom[ 0+3224] ='b11010010;
           rom[ 0+3225] ='b01001000;
           rom[ 0+3226] ='b11111011;
           rom[ 0+3227] ='b01100001;
           rom[ 0+3228] ='b00000000;
           rom[ 0+3229] ='b01111010;
           rom[ 0+3230] ='b11110100;
           rom[ 0+3231] ='b10001110;
           rom[ 0+3232] ='b11110101;
           rom[ 0+3233] ='b10001111;
           rom[ 0+3234] ='b00000001;
           rom[ 0+3235] ='b01111011;
           rom[ 0+3236] ='b11110111;
           rom[ 0+3237] ='b10001101;
           rom[ 0+3238] ='b00000011;
           rom[ 0+3239] ='b01111001;
           rom[ 0+3240] ='b00000010;
           rom[ 0+3241] ='b01111000;
           rom[ 0+3242] ='b11110110;
           rom[ 0+3243] ='b10001100;
           rom[ 0+3244] ='b11110011;
           rom[ 0+3245] ='b10001001;
           rom[ 0+3246] ='b00000111;
           rom[ 0+3247] ='b01111101;
           rom[ 0+3248] ='b00000110;
           rom[ 0+3249] ='b01111100;
           rom[ 0+3250] ='b11110010;
           rom[ 0+3251] ='b10001000;
           rom[ 0+3252] ='b00000100;
           rom[ 0+3253] ='b01111110;
           rom[ 0+3254] ='b11110000;
           rom[ 0+3255] ='b10001010;
           rom[ 0+3256] ='b11110001;
           rom[ 0+3257] ='b10001011;
           rom[ 0+3258] ='b00000101;
           rom[ 0+3259] ='b01111111;
           rom[ 0+3260] ='b11111011;
           rom[ 0+3261] ='b10000001;
           rom[ 0+3262] ='b00001111;
           rom[ 0+3263] ='b01110101;
           rom[ 0+3264] ='b00001110;
           rom[ 0+3265] ='b01110100;
           rom[ 0+3266] ='b11111010;
           rom[ 0+3267] ='b10000000;
           rom[ 0+3268] ='b00001100;
           rom[ 0+3269] ='b01110110;
           rom[ 0+3270] ='b11111000;
           rom[ 0+3271] ='b10000010;
           rom[ 0+3272] ='b11111001;
           rom[ 0+3273] ='b10000011;
           rom[ 0+3274] ='b00001101;
           rom[ 0+3275] ='b01110111;
           rom[ 0+3276] ='b00001000;
           rom[ 0+3277] ='b01110010;
           rom[ 0+3278] ='b11111100;
           rom[ 0+3279] ='b10000110;
           rom[ 0+3280] ='b11111101;
           rom[ 0+3281] ='b10000111;
           rom[ 0+3282] ='b00001001;
           rom[ 0+3283] ='b01110011;
           rom[ 0+3284] ='b11111111;
           rom[ 0+3285] ='b10000101;
           rom[ 0+3286] ='b00001011;
           rom[ 0+3287] ='b01110001;
           rom[ 0+3288] ='b00001010;
           rom[ 0+3289] ='b01110000;
           rom[ 0+3290] ='b11111110;
           rom[ 0+3291] ='b10000100;
           rom[ 0+3292] ='b11101011;
           rom[ 0+3293] ='b10010001;
           rom[ 0+3294] ='b00011111;
           rom[ 0+3295] ='b01100101;
           rom[ 0+3296] ='b00011110;
           rom[ 0+3297] ='b01100100;
           rom[ 0+3298] ='b11101010;
           rom[ 0+3299] ='b10010000;
           rom[ 0+3300] ='b00011100;
           rom[ 0+3301] ='b01100110;
           rom[ 0+3302] ='b11101000;
           rom[ 0+3303] ='b10010010;
           rom[ 0+3304] ='b11101001;
           rom[ 0+3305] ='b10010011;
           rom[ 0+3306] ='b00011101;
           rom[ 0+3307] ='b01100111;
           rom[ 0+3308] ='b00011000;
           rom[ 0+3309] ='b01100010;
           rom[ 0+3310] ='b11101100;
           rom[ 0+3311] ='b10010110;
           rom[ 0+3312] ='b11101101;
           rom[ 0+3313] ='b10010111;
           rom[ 0+3314] ='b00011001;
           rom[ 0+3315] ='b01100011;
           rom[ 0+3316] ='b11101111;
           rom[ 0+3317] ='b10010101;
           rom[ 0+3318] ='b00011011;
           rom[ 0+3319] ='b01100001;
           rom[ 0+3320] ='b00011010;
           rom[ 0+3321] ='b01100000;
           rom[ 0+3322] ='b11101110;
           rom[ 0+3323] ='b10010100;
           rom[ 0+3324] ='b00010000;
           rom[ 0+3325] ='b01101010;
           rom[ 0+3326] ='b11100100;
           rom[ 0+3327] ='b10011110;
           rom[ 0+3328] ='b11100101;
           rom[ 0+3329] ='b10011111;
           rom[ 0+3330] ='b00010001;
           rom[ 0+3331] ='b01101011;
           rom[ 0+3332] ='b11100111;
           rom[ 0+3333] ='b10011101;
           rom[ 0+3334] ='b00010011;
           rom[ 0+3335] ='b01101001;
           rom[ 0+3336] ='b00010010;
           rom[ 0+3337] ='b01101000;
           rom[ 0+3338] ='b11100110;
           rom[ 0+3339] ='b10011100;
           rom[ 0+3340] ='b11100011;
           rom[ 0+3341] ='b10011001;
           rom[ 0+3342] ='b00010111;
           rom[ 0+3343] ='b01101101;
           rom[ 0+3344] ='b00010110;
           rom[ 0+3345] ='b01101100;
           rom[ 0+3346] ='b11100010;
           rom[ 0+3347] ='b10011000;
           rom[ 0+3348] ='b00010100;
           rom[ 0+3349] ='b01101110;
           rom[ 0+3350] ='b11100000;
           rom[ 0+3351] ='b10011010;
           rom[ 0+3352] ='b11100001;
           rom[ 0+3353] ='b10011011;
           rom[ 0+3354] ='b00010101;
           rom[ 0+3355] ='b01101111;
           rom[ 0+3356] ='b11001011;
           rom[ 0+3357] ='b10110001;
           rom[ 0+3358] ='b00111111;
           rom[ 0+3359] ='b01000101;
           rom[ 0+3360] ='b00111110;
           rom[ 0+3361] ='b01000100;
           rom[ 0+3362] ='b11001010;
           rom[ 0+3363] ='b10110000;
           rom[ 0+3364] ='b00111100;
           rom[ 0+3365] ='b01000110;
           rom[ 0+3366] ='b11001000;
           rom[ 0+3367] ='b10110010;
           rom[ 0+3368] ='b11001001;
           rom[ 0+3369] ='b10110011;
           rom[ 0+3370] ='b00111101;
           rom[ 0+3371] ='b01000111;
           rom[ 0+3372] ='b00111000;
           rom[ 0+3373] ='b01000010;
           rom[ 0+3374] ='b11001100;
           rom[ 0+3375] ='b10110110;
           rom[ 0+3376] ='b11001101;
           rom[ 0+3377] ='b10110111;
           rom[ 0+3378] ='b00111001;
           rom[ 0+3379] ='b01000011;
           rom[ 0+3380] ='b11001111;
           rom[ 0+3381] ='b10110101;
           rom[ 0+3382] ='b00111011;
           rom[ 0+3383] ='b01000001;
           rom[ 0+3384] ='b00111010;
           rom[ 0+3385] ='b01000000;
           rom[ 0+3386] ='b11001110;
           rom[ 0+3387] ='b10110100;
           rom[ 0+3388] ='b00110000;
           rom[ 0+3389] ='b01001010;
           rom[ 0+3390] ='b11000100;
           rom[ 0+3391] ='b10111110;
           rom[ 0+3392] ='b11000101;
           rom[ 0+3393] ='b10111111;
           rom[ 0+3394] ='b00110001;
           rom[ 0+3395] ='b01001011;
           rom[ 0+3396] ='b11000111;
           rom[ 0+3397] ='b10111101;
           rom[ 0+3398] ='b00110011;
           rom[ 0+3399] ='b01001001;
           rom[ 0+3400] ='b00110010;
           rom[ 0+3401] ='b01001000;
           rom[ 0+3402] ='b11000110;
           rom[ 0+3403] ='b10111100;
           rom[ 0+3404] ='b11000011;
           rom[ 0+3405] ='b10111001;
           rom[ 0+3406] ='b00110111;
           rom[ 0+3407] ='b01001101;
           rom[ 0+3408] ='b00110110;
           rom[ 0+3409] ='b01001100;
           rom[ 0+3410] ='b11000010;
           rom[ 0+3411] ='b10111000;
           rom[ 0+3412] ='b00110100;
           rom[ 0+3413] ='b01001110;
           rom[ 0+3414] ='b11000000;
           rom[ 0+3415] ='b10111010;
           rom[ 0+3416] ='b11000001;
           rom[ 0+3417] ='b10111011;
           rom[ 0+3418] ='b00110101;
           rom[ 0+3419] ='b01001111;
           rom[ 0+3420] ='b00100000;
           rom[ 0+3421] ='b01011010;
           rom[ 0+3422] ='b11010100;
           rom[ 0+3423] ='b10101110;
           rom[ 0+3424] ='b11010101;
           rom[ 0+3425] ='b10101111;
           rom[ 0+3426] ='b00100001;
           rom[ 0+3427] ='b01011011;
           rom[ 0+3428] ='b11010111;
           rom[ 0+3429] ='b10101101;
           rom[ 0+3430] ='b00100011;
           rom[ 0+3431] ='b01011001;
           rom[ 0+3432] ='b00100010;
           rom[ 0+3433] ='b01011000;
           rom[ 0+3434] ='b11010110;
           rom[ 0+3435] ='b10101100;
           rom[ 0+3436] ='b11010011;
           rom[ 0+3437] ='b10101001;
           rom[ 0+3438] ='b00100111;
           rom[ 0+3439] ='b01011101;
           rom[ 0+3440] ='b00100110;
           rom[ 0+3441] ='b01011100;
           rom[ 0+3442] ='b11010010;
           rom[ 0+3443] ='b10101000;
           rom[ 0+3444] ='b00100100;
           rom[ 0+3445] ='b01011110;
           rom[ 0+3446] ='b11010000;
           rom[ 0+3447] ='b10101010;
           rom[ 0+3448] ='b11010001;
           rom[ 0+3449] ='b10101011;
           rom[ 0+3450] ='b00100101;
           rom[ 0+3451] ='b01011111;
           rom[ 0+3452] ='b11011011;
           rom[ 0+3453] ='b10100001;
           rom[ 0+3454] ='b00101111;
           rom[ 0+3455] ='b01010101;
           rom[ 0+3456] ='b00101110;
           rom[ 0+3457] ='b01010100;
           rom[ 0+3458] ='b11011010;
           rom[ 0+3459] ='b10100000;
           rom[ 0+3460] ='b00101100;
           rom[ 0+3461] ='b01010110;
           rom[ 0+3462] ='b11011000;
           rom[ 0+3463] ='b10100010;
           rom[ 0+3464] ='b11011001;
           rom[ 0+3465] ='b10100011;
           rom[ 0+3466] ='b00101101;
           rom[ 0+3467] ='b01010111;
           rom[ 0+3468] ='b00101000;
           rom[ 0+3469] ='b01010010;
           rom[ 0+3470] ='b11011100;
           rom[ 0+3471] ='b10100110;
           rom[ 0+3472] ='b11011101;
           rom[ 0+3473] ='b10100111;
           rom[ 0+3474] ='b00101001;
           rom[ 0+3475] ='b01010011;
           rom[ 0+3476] ='b11011111;
           rom[ 0+3477] ='b10100101;
           rom[ 0+3478] ='b00101011;
           rom[ 0+3479] ='b01010001;
           rom[ 0+3480] ='b00101010;
           rom[ 0+3481] ='b01010000;
           rom[ 0+3482] ='b11011110;
           rom[ 0+3483] ='b10100100;
           rom[ 0+3484] ='b00000000;
           rom[ 0+3485] ='b01111111;
           rom[ 0+3486] ='b11111110;
           rom[ 0+3487] ='b10000001;
           rom[ 0+3488] ='b11100001;
           rom[ 0+3489] ='b10011110;
           rom[ 0+3490] ='b00011111;
           rom[ 0+3491] ='b01100000;
           rom[ 0+3492] ='b11011111;
           rom[ 0+3493] ='b10100000;
           rom[ 0+3494] ='b00100001;
           rom[ 0+3495] ='b01011110;
           rom[ 0+3496] ='b00111110;
           rom[ 0+3497] ='b01000001;
           rom[ 0+3498] ='b11000000;
           rom[ 0+3499] ='b10111111;
           rom[ 0+3500] ='b10100011;
           rom[ 0+3501] ='b11011100;
           rom[ 0+3502] ='b01011101;
           rom[ 0+3503] ='b00100010;
           rom[ 0+3504] ='b01000010;
           rom[ 0+3505] ='b00111101;
           rom[ 0+3506] ='b10111100;
           rom[ 0+3507] ='b11000011;
           rom[ 0+3508] ='b01111100;
           rom[ 0+3509] ='b00000011;
           rom[ 0+3510] ='b10000010;
           rom[ 0+3511] ='b11111101;
           rom[ 0+3512] ='b10011101;
           rom[ 0+3513] ='b11100010;
           rom[ 0+3514] ='b01100011;
           rom[ 0+3515] ='b00011100;
           rom[ 0+3516] ='b01011011;
           rom[ 0+3517] ='b00100100;
           rom[ 0+3518] ='b10100101;
           rom[ 0+3519] ='b11011010;
           rom[ 0+3520] ='b10111010;
           rom[ 0+3521] ='b11000101;
           rom[ 0+3522] ='b01000100;
           rom[ 0+3523] ='b00111011;
           rom[ 0+3524] ='b10000100;
           rom[ 0+3525] ='b11111011;
           rom[ 0+3526] ='b01111010;
           rom[ 0+3527] ='b00000101;
           rom[ 0+3528] ='b01100101;
           rom[ 0+3529] ='b00011010;
           rom[ 0+3530] ='b10011011;
           rom[ 0+3531] ='b11100100;
           rom[ 0+3532] ='b11111000;
           rom[ 0+3533] ='b10000111;
           rom[ 0+3534] ='b00000110;
           rom[ 0+3535] ='b01111001;
           rom[ 0+3536] ='b00011001;
           rom[ 0+3537] ='b01100110;
           rom[ 0+3538] ='b11100111;
           rom[ 0+3539] ='b10011000;
           rom[ 0+3540] ='b00100111;
           rom[ 0+3541] ='b01011000;
           rom[ 0+3542] ='b11011001;
           rom[ 0+3543] ='b10100110;
           rom[ 0+3544] ='b11000110;
           rom[ 0+3545] ='b10111001;
           rom[ 0+3546] ='b00111000;
           rom[ 0+3547] ='b01000111;
           rom[ 0+3548] ='b10110110;
           rom[ 0+3549] ='b11001001;
           rom[ 0+3550] ='b01001000;
           rom[ 0+3551] ='b00110111;
           rom[ 0+3552] ='b01010111;
           rom[ 0+3553] ='b00101000;
           rom[ 0+3554] ='b10101001;
           rom[ 0+3555] ='b11010110;
           rom[ 0+3556] ='b01101001;
           rom[ 0+3557] ='b00010110;
           rom[ 0+3558] ='b10010111;
           rom[ 0+3559] ='b11101000;
           rom[ 0+3560] ='b10001000;
           rom[ 0+3561] ='b11110111;
           rom[ 0+3562] ='b01110110;
           rom[ 0+3563] ='b00001001;
           rom[ 0+3564] ='b00010101;
           rom[ 0+3565] ='b01101010;
           rom[ 0+3566] ='b11101011;
           rom[ 0+3567] ='b10010100;
           rom[ 0+3568] ='b11110100;
           rom[ 0+3569] ='b10001011;
           rom[ 0+3570] ='b00001010;
           rom[ 0+3571] ='b01110101;
           rom[ 0+3572] ='b11001010;
           rom[ 0+3573] ='b10110101;
           rom[ 0+3574] ='b00110100;
           rom[ 0+3575] ='b01001011;
           rom[ 0+3576] ='b00101011;
           rom[ 0+3577] ='b01010100;
           rom[ 0+3578] ='b11010101;
           rom[ 0+3579] ='b10101010;
           rom[ 0+3580] ='b11101101;
           rom[ 0+3581] ='b10010010;
           rom[ 0+3582] ='b00010011;
           rom[ 0+3583] ='b01101100;
           rom[ 0+3584] ='b00001100;
           rom[ 0+3585] ='b01110011;
           rom[ 0+3586] ='b11110010;
           rom[ 0+3587] ='b10001101;
           rom[ 0+3588] ='b00110010;
           rom[ 0+3589] ='b01001101;
           rom[ 0+3590] ='b11001100;
           rom[ 0+3591] ='b10110011;
           rom[ 0+3592] ='b11010011;
           rom[ 0+3593] ='b10101100;
           rom[ 0+3594] ='b00101101;
           rom[ 0+3595] ='b01010010;
           rom[ 0+3596] ='b01001110;
           rom[ 0+3597] ='b00110001;
           rom[ 0+3598] ='b10110000;
           rom[ 0+3599] ='b11001111;
           rom[ 0+3600] ='b10101111;
           rom[ 0+3601] ='b11010000;
           rom[ 0+3602] ='b01010001;
           rom[ 0+3603] ='b00101110;
           rom[ 0+3604] ='b10010001;
           rom[ 0+3605] ='b11101110;
           rom[ 0+3606] ='b01101111;
           rom[ 0+3607] ='b00010000;
           rom[ 0+3608] ='b01110000;
           rom[ 0+3609] ='b00001111;
           rom[ 0+3610] ='b10001110;
           rom[ 0+3611] ='b11110001;
           rom[ 0+3612] ='b01110001;
           rom[ 0+3613] ='b00001110;
           rom[ 0+3614] ='b10001111;
           rom[ 0+3615] ='b11110000;
           rom[ 0+3616] ='b10010000;
           rom[ 0+3617] ='b11101111;
           rom[ 0+3618] ='b01101110;
           rom[ 0+3619] ='b00010001;
           rom[ 0+3620] ='b10101110;
           rom[ 0+3621] ='b11010001;
           rom[ 0+3622] ='b01010000;
           rom[ 0+3623] ='b00101111;
           rom[ 0+3624] ='b01001111;
           rom[ 0+3625] ='b00110000;
           rom[ 0+3626] ='b10110001;
           rom[ 0+3627] ='b11001110;
           rom[ 0+3628] ='b11010010;
           rom[ 0+3629] ='b10101101;
           rom[ 0+3630] ='b00101100;
           rom[ 0+3631] ='b01010011;
           rom[ 0+3632] ='b00110011;
           rom[ 0+3633] ='b01001100;
           rom[ 0+3634] ='b11001101;
           rom[ 0+3635] ='b10110010;
           rom[ 0+3636] ='b00001101;
           rom[ 0+3637] ='b01110010;
           rom[ 0+3638] ='b11110011;
           rom[ 0+3639] ='b10001100;
           rom[ 0+3640] ='b11101100;
           rom[ 0+3641] ='b10010011;
           rom[ 0+3642] ='b00010010;
           rom[ 0+3643] ='b01101101;
           rom[ 0+3644] ='b00101010;
           rom[ 0+3645] ='b01010101;
           rom[ 0+3646] ='b11010100;
           rom[ 0+3647] ='b10101011;
           rom[ 0+3648] ='b11001011;
           rom[ 0+3649] ='b10110100;
           rom[ 0+3650] ='b00110101;
           rom[ 0+3651] ='b01001010;
           rom[ 0+3652] ='b11110101;
           rom[ 0+3653] ='b10001010;
           rom[ 0+3654] ='b00001011;
           rom[ 0+3655] ='b01110100;
           rom[ 0+3656] ='b00010100;
           rom[ 0+3657] ='b01101011;
           rom[ 0+3658] ='b11101010;
           rom[ 0+3659] ='b10010101;
           rom[ 0+3660] ='b10001001;
           rom[ 0+3661] ='b11110110;
           rom[ 0+3662] ='b01110111;
           rom[ 0+3663] ='b00001000;
           rom[ 0+3664] ='b01101000;
           rom[ 0+3665] ='b00010111;
           rom[ 0+3666] ='b10010110;
           rom[ 0+3667] ='b11101001;
           rom[ 0+3668] ='b01010110;
           rom[ 0+3669] ='b00101001;
           rom[ 0+3670] ='b10101000;
           rom[ 0+3671] ='b11010111;
           rom[ 0+3672] ='b10110111;
           rom[ 0+3673] ='b11001000;
           rom[ 0+3674] ='b01001001;
           rom[ 0+3675] ='b00110110;
           rom[ 0+3676] ='b11000111;
           rom[ 0+3677] ='b10111000;
           rom[ 0+3678] ='b00111001;
           rom[ 0+3679] ='b01000110;
           rom[ 0+3680] ='b00100110;
           rom[ 0+3681] ='b01011001;
           rom[ 0+3682] ='b11011000;
           rom[ 0+3683] ='b10100111;
           rom[ 0+3684] ='b00011000;
           rom[ 0+3685] ='b01100111;
           rom[ 0+3686] ='b11100110;
           rom[ 0+3687] ='b10011001;
           rom[ 0+3688] ='b11111001;
           rom[ 0+3689] ='b10000110;
           rom[ 0+3690] ='b00000111;
           rom[ 0+3691] ='b01111000;
           rom[ 0+3692] ='b01100100;
           rom[ 0+3693] ='b00011011;
           rom[ 0+3694] ='b10011010;
           rom[ 0+3695] ='b11100101;
           rom[ 0+3696] ='b10000101;
           rom[ 0+3697] ='b11111010;
           rom[ 0+3698] ='b01111011;
           rom[ 0+3699] ='b00000100;
           rom[ 0+3700] ='b10111011;
           rom[ 0+3701] ='b11000100;
           rom[ 0+3702] ='b01000101;
           rom[ 0+3703] ='b00111010;
           rom[ 0+3704] ='b01011010;
           rom[ 0+3705] ='b00100101;
           rom[ 0+3706] ='b10100100;
           rom[ 0+3707] ='b11011011;
           rom[ 0+3708] ='b10011100;
           rom[ 0+3709] ='b11100011;
           rom[ 0+3710] ='b01100010;
           rom[ 0+3711] ='b00011101;
           rom[ 0+3712] ='b01111101;
           rom[ 0+3713] ='b00000010;
           rom[ 0+3714] ='b10000011;
           rom[ 0+3715] ='b11111100;
           rom[ 0+3716] ='b01000011;
           rom[ 0+3717] ='b00111100;
           rom[ 0+3718] ='b10111101;
           rom[ 0+3719] ='b11000010;
           rom[ 0+3720] ='b10100010;
           rom[ 0+3721] ='b11011101;
           rom[ 0+3722] ='b01011100;
           rom[ 0+3723] ='b00100011;
           rom[ 0+3724] ='b00111111;
           rom[ 0+3725] ='b01000000;
           rom[ 0+3726] ='b11000001;
           rom[ 0+3727] ='b10111110;
           rom[ 0+3728] ='b11011110;
           rom[ 0+3729] ='b10100001;
           rom[ 0+3730] ='b00100000;
           rom[ 0+3731] ='b01011111;
           rom[ 0+3732] ='b11100000;
           rom[ 0+3733] ='b10011111;
           rom[ 0+3734] ='b00011110;
           rom[ 0+3735] ='b01100001;
           rom[ 0+3736] ='b00000001;
           rom[ 0+3737] ='b01111110;
           rom[ 0+3738] ='b11111111;
           rom[ 0+3739] ='b10000000;
           rom[ 0+3740] ='b00000000;
           rom[ 0+3741] ='b00000010;
           rom[ 0+3742] ='b00000100;
           rom[ 0+3743] ='b00000110;
           rom[ 0+3744] ='b00001000;
           rom[ 0+3745] ='b00001010;
           rom[ 0+3746] ='b00001100;
           rom[ 0+3747] ='b00001110;
           rom[ 0+3748] ='b00010000;
           rom[ 0+3749] ='b00010010;
           rom[ 0+3750] ='b00010100;
           rom[ 0+3751] ='b00010110;
           rom[ 0+3752] ='b00011000;
           rom[ 0+3753] ='b00011010;
           rom[ 0+3754] ='b00011100;
           rom[ 0+3755] ='b00011110;
           rom[ 0+3756] ='b00100000;
           rom[ 0+3757] ='b00100010;
           rom[ 0+3758] ='b00100100;
           rom[ 0+3759] ='b00100110;
           rom[ 0+3760] ='b00101000;
           rom[ 0+3761] ='b00101010;
           rom[ 0+3762] ='b00101100;
           rom[ 0+3763] ='b00101110;
           rom[ 0+3764] ='b00110000;
           rom[ 0+3765] ='b00110010;
           rom[ 0+3766] ='b00110100;
           rom[ 0+3767] ='b00110110;
           rom[ 0+3768] ='b00111000;
           rom[ 0+3769] ='b00111010;
           rom[ 0+3770] ='b00111100;
           rom[ 0+3771] ='b00111110;
           rom[ 0+3772] ='b01000000;
           rom[ 0+3773] ='b01000010;
           rom[ 0+3774] ='b01000100;
           rom[ 0+3775] ='b01000110;
           rom[ 0+3776] ='b01001000;
           rom[ 0+3777] ='b01001010;
           rom[ 0+3778] ='b01001100;
           rom[ 0+3779] ='b01001110;
           rom[ 0+3780] ='b01010000;
           rom[ 0+3781] ='b01010010;
           rom[ 0+3782] ='b01010100;
           rom[ 0+3783] ='b01010110;
           rom[ 0+3784] ='b01011000;
           rom[ 0+3785] ='b01011010;
           rom[ 0+3786] ='b01011100;
           rom[ 0+3787] ='b01011110;
           rom[ 0+3788] ='b01100000;
           rom[ 0+3789] ='b01100010;
           rom[ 0+3790] ='b01100100;
           rom[ 0+3791] ='b01100110;
           rom[ 0+3792] ='b01101000;
           rom[ 0+3793] ='b01101010;
           rom[ 0+3794] ='b01101100;
           rom[ 0+3795] ='b01101110;
           rom[ 0+3796] ='b01110000;
           rom[ 0+3797] ='b01110010;
           rom[ 0+3798] ='b01110100;
           rom[ 0+3799] ='b01110110;
           rom[ 0+3800] ='b01111000;
           rom[ 0+3801] ='b01111010;
           rom[ 0+3802] ='b01111100;
           rom[ 0+3803] ='b01111110;
           rom[ 0+3804] ='b10000000;
           rom[ 0+3805] ='b10000010;
           rom[ 0+3806] ='b10000100;
           rom[ 0+3807] ='b10000110;
           rom[ 0+3808] ='b10001000;
           rom[ 0+3809] ='b10001010;
           rom[ 0+3810] ='b10001100;
           rom[ 0+3811] ='b10001110;
           rom[ 0+3812] ='b10010000;
           rom[ 0+3813] ='b10010010;
           rom[ 0+3814] ='b10010100;
           rom[ 0+3815] ='b10010110;
           rom[ 0+3816] ='b10011000;
           rom[ 0+3817] ='b10011010;
           rom[ 0+3818] ='b10011100;
           rom[ 0+3819] ='b10011110;
           rom[ 0+3820] ='b10100000;
           rom[ 0+3821] ='b10100010;
           rom[ 0+3822] ='b10100100;
           rom[ 0+3823] ='b10100110;
           rom[ 0+3824] ='b10101000;
           rom[ 0+3825] ='b10101010;
           rom[ 0+3826] ='b10101100;
           rom[ 0+3827] ='b10101110;
           rom[ 0+3828] ='b10110000;
           rom[ 0+3829] ='b10110010;
           rom[ 0+3830] ='b10110100;
           rom[ 0+3831] ='b10110110;
           rom[ 0+3832] ='b10111000;
           rom[ 0+3833] ='b10111010;
           rom[ 0+3834] ='b10111100;
           rom[ 0+3835] ='b10111110;
           rom[ 0+3836] ='b11000000;
           rom[ 0+3837] ='b11000010;
           rom[ 0+3838] ='b11000100;
           rom[ 0+3839] ='b11000110;
           rom[ 0+3840] ='b11001000;
           rom[ 0+3841] ='b11001010;
           rom[ 0+3842] ='b11001100;
           rom[ 0+3843] ='b11001110;
           rom[ 0+3844] ='b11010000;
           rom[ 0+3845] ='b11010010;
           rom[ 0+3846] ='b11010100;
           rom[ 0+3847] ='b11010110;
           rom[ 0+3848] ='b11011000;
           rom[ 0+3849] ='b11011010;
           rom[ 0+3850] ='b11011100;
           rom[ 0+3851] ='b11011110;
           rom[ 0+3852] ='b11100000;
           rom[ 0+3853] ='b11100010;
           rom[ 0+3854] ='b11100100;
           rom[ 0+3855] ='b11100110;
           rom[ 0+3856] ='b11101000;
           rom[ 0+3857] ='b11101010;
           rom[ 0+3858] ='b11101100;
           rom[ 0+3859] ='b11101110;
           rom[ 0+3860] ='b11110000;
           rom[ 0+3861] ='b11110010;
           rom[ 0+3862] ='b11110100;
           rom[ 0+3863] ='b11110110;
           rom[ 0+3864] ='b11111000;
           rom[ 0+3865] ='b11111010;
           rom[ 0+3866] ='b11111100;
           rom[ 0+3867] ='b11111110;
           rom[ 0+3868] ='b00011101;
           rom[ 0+3869] ='b00011111;
           rom[ 0+3870] ='b00011001;
           rom[ 0+3871] ='b00011011;
           rom[ 0+3872] ='b00010101;
           rom[ 0+3873] ='b00010111;
           rom[ 0+3874] ='b00010001;
           rom[ 0+3875] ='b00010011;
           rom[ 0+3876] ='b00001101;
           rom[ 0+3877] ='b00001111;
           rom[ 0+3878] ='b00001001;
           rom[ 0+3879] ='b00001011;
           rom[ 0+3880] ='b00000101;
           rom[ 0+3881] ='b00000111;
           rom[ 0+3882] ='b00000001;
           rom[ 0+3883] ='b00000011;
           rom[ 0+3884] ='b00111101;
           rom[ 0+3885] ='b00111111;
           rom[ 0+3886] ='b00111001;
           rom[ 0+3887] ='b00111011;
           rom[ 0+3888] ='b00110101;
           rom[ 0+3889] ='b00110111;
           rom[ 0+3890] ='b00110001;
           rom[ 0+3891] ='b00110011;
           rom[ 0+3892] ='b00101101;
           rom[ 0+3893] ='b00101111;
           rom[ 0+3894] ='b00101001;
           rom[ 0+3895] ='b00101011;
           rom[ 0+3896] ='b00100101;
           rom[ 0+3897] ='b00100111;
           rom[ 0+3898] ='b00100001;
           rom[ 0+3899] ='b00100011;
           rom[ 0+3900] ='b01011101;
           rom[ 0+3901] ='b01011111;
           rom[ 0+3902] ='b01011001;
           rom[ 0+3903] ='b01011011;
           rom[ 0+3904] ='b01010101;
           rom[ 0+3905] ='b01010111;
           rom[ 0+3906] ='b01010001;
           rom[ 0+3907] ='b01010011;
           rom[ 0+3908] ='b01001101;
           rom[ 0+3909] ='b01001111;
           rom[ 0+3910] ='b01001001;
           rom[ 0+3911] ='b01001011;
           rom[ 0+3912] ='b01000101;
           rom[ 0+3913] ='b01000111;
           rom[ 0+3914] ='b01000001;
           rom[ 0+3915] ='b01000011;
           rom[ 0+3916] ='b01111101;
           rom[ 0+3917] ='b01111111;
           rom[ 0+3918] ='b01111001;
           rom[ 0+3919] ='b01111011;
           rom[ 0+3920] ='b01110101;
           rom[ 0+3921] ='b01110111;
           rom[ 0+3922] ='b01110001;
           rom[ 0+3923] ='b01110011;
           rom[ 0+3924] ='b01101101;
           rom[ 0+3925] ='b01101111;
           rom[ 0+3926] ='b01101001;
           rom[ 0+3927] ='b01101011;
           rom[ 0+3928] ='b01100101;
           rom[ 0+3929] ='b01100111;
           rom[ 0+3930] ='b01100001;
           rom[ 0+3931] ='b01100011;
           rom[ 0+3932] ='b10011101;
           rom[ 0+3933] ='b10011111;
           rom[ 0+3934] ='b10011001;
           rom[ 0+3935] ='b10011011;
           rom[ 0+3936] ='b10010101;
           rom[ 0+3937] ='b10010111;
           rom[ 0+3938] ='b10010001;
           rom[ 0+3939] ='b10010011;
           rom[ 0+3940] ='b10001101;
           rom[ 0+3941] ='b10001111;
           rom[ 0+3942] ='b10001001;
           rom[ 0+3943] ='b10001011;
           rom[ 0+3944] ='b10000101;
           rom[ 0+3945] ='b10000111;
           rom[ 0+3946] ='b10000001;
           rom[ 0+3947] ='b10000011;
           rom[ 0+3948] ='b10111101;
           rom[ 0+3949] ='b10111111;
           rom[ 0+3950] ='b10111001;
           rom[ 0+3951] ='b10111011;
           rom[ 0+3952] ='b10110101;
           rom[ 0+3953] ='b10110111;
           rom[ 0+3954] ='b10110001;
           rom[ 0+3955] ='b10110011;
           rom[ 0+3956] ='b10101101;
           rom[ 0+3957] ='b10101111;
           rom[ 0+3958] ='b10101001;
           rom[ 0+3959] ='b10101011;
           rom[ 0+3960] ='b10100101;
           rom[ 0+3961] ='b10100111;
           rom[ 0+3962] ='b10100001;
           rom[ 0+3963] ='b10100011;
           rom[ 0+3964] ='b11011101;
           rom[ 0+3965] ='b11011111;
           rom[ 0+3966] ='b11011001;
           rom[ 0+3967] ='b11011011;
           rom[ 0+3968] ='b11010101;
           rom[ 0+3969] ='b11010111;
           rom[ 0+3970] ='b11010001;
           rom[ 0+3971] ='b11010011;
           rom[ 0+3972] ='b11001101;
           rom[ 0+3973] ='b11001111;
           rom[ 0+3974] ='b11001001;
           rom[ 0+3975] ='b11001011;
           rom[ 0+3976] ='b11000101;
           rom[ 0+3977] ='b11000111;
           rom[ 0+3978] ='b11000001;
           rom[ 0+3979] ='b11000011;
           rom[ 0+3980] ='b11111101;
           rom[ 0+3981] ='b11111111;
           rom[ 0+3982] ='b11111001;
           rom[ 0+3983] ='b11111011;
           rom[ 0+3984] ='b11110101;
           rom[ 0+3985] ='b11110111;
           rom[ 0+3986] ='b11110001;
           rom[ 0+3987] ='b11110011;
           rom[ 0+3988] ='b11101101;
           rom[ 0+3989] ='b11101111;
           rom[ 0+3990] ='b11101001;
           rom[ 0+3991] ='b11101011;
           rom[ 0+3992] ='b11100101;
           rom[ 0+3993] ='b11100111;
           rom[ 0+3994] ='b11100001;
           rom[ 0+3995] ='b11100011;
           rom[ 0+3996] ='b00000000;
           rom[ 0+3997] ='b00000100;
           rom[ 0+3998] ='b00001000;
           rom[ 0+3999] ='b00001100;
           rom[ 0+4000] ='b00010000;
           rom[ 0+4001] ='b00010100;
           rom[ 0+4002] ='b00011000;
           rom[ 0+4003] ='b00011100;
           rom[ 0+4004] ='b00100000;
           rom[ 0+4005] ='b00100100;
           rom[ 0+4006] ='b00101000;
           rom[ 0+4007] ='b00101100;
           rom[ 0+4008] ='b00110000;
           rom[ 0+4009] ='b00110100;
           rom[ 0+4010] ='b00111000;
           rom[ 0+4011] ='b00111100;
           rom[ 0+4012] ='b01000000;
           rom[ 0+4013] ='b01000100;
           rom[ 0+4014] ='b01001000;
           rom[ 0+4015] ='b01001100;
           rom[ 0+4016] ='b01010000;
           rom[ 0+4017] ='b01010100;
           rom[ 0+4018] ='b01011000;
           rom[ 0+4019] ='b01011100;
           rom[ 0+4020] ='b01100000;
           rom[ 0+4021] ='b01100100;
           rom[ 0+4022] ='b01101000;
           rom[ 0+4023] ='b01101100;
           rom[ 0+4024] ='b01110000;
           rom[ 0+4025] ='b01110100;
           rom[ 0+4026] ='b01111000;
           rom[ 0+4027] ='b01111100;
           rom[ 0+4028] ='b10000000;
           rom[ 0+4029] ='b10000100;
           rom[ 0+4030] ='b10001000;
           rom[ 0+4031] ='b10001100;
           rom[ 0+4032] ='b10010000;
           rom[ 0+4033] ='b10010100;
           rom[ 0+4034] ='b10011000;
           rom[ 0+4035] ='b10011100;
           rom[ 0+4036] ='b10100000;
           rom[ 0+4037] ='b10100100;
           rom[ 0+4038] ='b10101000;
           rom[ 0+4039] ='b10101100;
           rom[ 0+4040] ='b10110000;
           rom[ 0+4041] ='b10110100;
           rom[ 0+4042] ='b10111000;
           rom[ 0+4043] ='b10111100;
           rom[ 0+4044] ='b11000000;
           rom[ 0+4045] ='b11000100;
           rom[ 0+4046] ='b11001000;
           rom[ 0+4047] ='b11001100;
           rom[ 0+4048] ='b11010000;
           rom[ 0+4049] ='b11010100;
           rom[ 0+4050] ='b11011000;
           rom[ 0+4051] ='b11011100;
           rom[ 0+4052] ='b11100000;
           rom[ 0+4053] ='b11100100;
           rom[ 0+4054] ='b11101000;
           rom[ 0+4055] ='b11101100;
           rom[ 0+4056] ='b11110000;
           rom[ 0+4057] ='b11110100;
           rom[ 0+4058] ='b11111000;
           rom[ 0+4059] ='b11111100;
           rom[ 0+4060] ='b00011101;
           rom[ 0+4061] ='b00011001;
           rom[ 0+4062] ='b00010101;
           rom[ 0+4063] ='b00010001;
           rom[ 0+4064] ='b00001101;
           rom[ 0+4065] ='b00001001;
           rom[ 0+4066] ='b00000101;
           rom[ 0+4067] ='b00000001;
           rom[ 0+4068] ='b00111101;
           rom[ 0+4069] ='b00111001;
           rom[ 0+4070] ='b00110101;
           rom[ 0+4071] ='b00110001;
           rom[ 0+4072] ='b00101101;
           rom[ 0+4073] ='b00101001;
           rom[ 0+4074] ='b00100101;
           rom[ 0+4075] ='b00100001;
           rom[ 0+4076] ='b01011101;
           rom[ 0+4077] ='b01011001;
           rom[ 0+4078] ='b01010101;
           rom[ 0+4079] ='b01010001;
           rom[ 0+4080] ='b01001101;
           rom[ 0+4081] ='b01001001;
           rom[ 0+4082] ='b01000101;
           rom[ 0+4083] ='b01000001;
           rom[ 0+4084] ='b01111101;
           rom[ 0+4085] ='b01111001;
           rom[ 0+4086] ='b01110101;
           rom[ 0+4087] ='b01110001;
           rom[ 0+4088] ='b01101101;
           rom[ 0+4089] ='b01101001;
           rom[ 0+4090] ='b01100101;
           rom[ 0+4091] ='b01100001;
           rom[ 0+4092] ='b10011101;
           rom[ 0+4093] ='b10011001;
           rom[ 0+4094] ='b10010101;
           rom[ 0+4095] ='b10010001;
           rom[ 0+4096] ='b10001101;
           rom[ 0+4097] ='b10001001;
           rom[ 0+4098] ='b10000101;
           rom[ 0+4099] ='b10000001;
           rom[ 0+4100] ='b10111101;
           rom[ 0+4101] ='b10111001;
           rom[ 0+4102] ='b10110101;
           rom[ 0+4103] ='b10110001;
           rom[ 0+4104] ='b10101101;
           rom[ 0+4105] ='b10101001;
           rom[ 0+4106] ='b10100101;
           rom[ 0+4107] ='b10100001;
           rom[ 0+4108] ='b11011101;
           rom[ 0+4109] ='b11011001;
           rom[ 0+4110] ='b11010101;
           rom[ 0+4111] ='b11010001;
           rom[ 0+4112] ='b11001101;
           rom[ 0+4113] ='b11001001;
           rom[ 0+4114] ='b11000101;
           rom[ 0+4115] ='b11000001;
           rom[ 0+4116] ='b11111101;
           rom[ 0+4117] ='b11111001;
           rom[ 0+4118] ='b11110101;
           rom[ 0+4119] ='b11110001;
           rom[ 0+4120] ='b11101101;
           rom[ 0+4121] ='b11101001;
           rom[ 0+4122] ='b11100101;
           rom[ 0+4123] ='b11100001;
           rom[ 0+4124] ='b00111010;
           rom[ 0+4125] ='b00111110;
           rom[ 0+4126] ='b00110010;
           rom[ 0+4127] ='b00110110;
           rom[ 0+4128] ='b00101010;
           rom[ 0+4129] ='b00101110;
           rom[ 0+4130] ='b00100010;
           rom[ 0+4131] ='b00100110;
           rom[ 0+4132] ='b00011010;
           rom[ 0+4133] ='b00011110;
           rom[ 0+4134] ='b00010010;
           rom[ 0+4135] ='b00010110;
           rom[ 0+4136] ='b00001010;
           rom[ 0+4137] ='b00001110;
           rom[ 0+4138] ='b00000010;
           rom[ 0+4139] ='b00000110;
           rom[ 0+4140] ='b01111010;
           rom[ 0+4141] ='b01111110;
           rom[ 0+4142] ='b01110010;
           rom[ 0+4143] ='b01110110;
           rom[ 0+4144] ='b01101010;
           rom[ 0+4145] ='b01101110;
           rom[ 0+4146] ='b01100010;
           rom[ 0+4147] ='b01100110;
           rom[ 0+4148] ='b01011010;
           rom[ 0+4149] ='b01011110;
           rom[ 0+4150] ='b01010010;
           rom[ 0+4151] ='b01010110;
           rom[ 0+4152] ='b01001010;
           rom[ 0+4153] ='b01001110;
           rom[ 0+4154] ='b01000010;
           rom[ 0+4155] ='b01000110;
           rom[ 0+4156] ='b10111010;
           rom[ 0+4157] ='b10111110;
           rom[ 0+4158] ='b10110010;
           rom[ 0+4159] ='b10110110;
           rom[ 0+4160] ='b10101010;
           rom[ 0+4161] ='b10101110;
           rom[ 0+4162] ='b10100010;
           rom[ 0+4163] ='b10100110;
           rom[ 0+4164] ='b10011010;
           rom[ 0+4165] ='b10011110;
           rom[ 0+4166] ='b10010010;
           rom[ 0+4167] ='b10010110;
           rom[ 0+4168] ='b10001010;
           rom[ 0+4169] ='b10001110;
           rom[ 0+4170] ='b10000010;
           rom[ 0+4171] ='b10000110;
           rom[ 0+4172] ='b11111010;
           rom[ 0+4173] ='b11111110;
           rom[ 0+4174] ='b11110010;
           rom[ 0+4175] ='b11110110;
           rom[ 0+4176] ='b11101010;
           rom[ 0+4177] ='b11101110;
           rom[ 0+4178] ='b11100010;
           rom[ 0+4179] ='b11100110;
           rom[ 0+4180] ='b11011010;
           rom[ 0+4181] ='b11011110;
           rom[ 0+4182] ='b11010010;
           rom[ 0+4183] ='b11010110;
           rom[ 0+4184] ='b11001010;
           rom[ 0+4185] ='b11001110;
           rom[ 0+4186] ='b11000010;
           rom[ 0+4187] ='b11000110;
           rom[ 0+4188] ='b00100111;
           rom[ 0+4189] ='b00100011;
           rom[ 0+4190] ='b00101111;
           rom[ 0+4191] ='b00101011;
           rom[ 0+4192] ='b00110111;
           rom[ 0+4193] ='b00110011;
           rom[ 0+4194] ='b00111111;
           rom[ 0+4195] ='b00111011;
           rom[ 0+4196] ='b00000111;
           rom[ 0+4197] ='b00000011;
           rom[ 0+4198] ='b00001111;
           rom[ 0+4199] ='b00001011;
           rom[ 0+4200] ='b00010111;
           rom[ 0+4201] ='b00010011;
           rom[ 0+4202] ='b00011111;
           rom[ 0+4203] ='b00011011;
           rom[ 0+4204] ='b01100111;
           rom[ 0+4205] ='b01100011;
           rom[ 0+4206] ='b01101111;
           rom[ 0+4207] ='b01101011;
           rom[ 0+4208] ='b01110111;
           rom[ 0+4209] ='b01110011;
           rom[ 0+4210] ='b01111111;
           rom[ 0+4211] ='b01111011;
           rom[ 0+4212] ='b01000111;
           rom[ 0+4213] ='b01000011;
           rom[ 0+4214] ='b01001111;
           rom[ 0+4215] ='b01001011;
           rom[ 0+4216] ='b01010111;
           rom[ 0+4217] ='b01010011;
           rom[ 0+4218] ='b01011111;
           rom[ 0+4219] ='b01011011;
           rom[ 0+4220] ='b10100111;
           rom[ 0+4221] ='b10100011;
           rom[ 0+4222] ='b10101111;
           rom[ 0+4223] ='b10101011;
           rom[ 0+4224] ='b10110111;
           rom[ 0+4225] ='b10110011;
           rom[ 0+4226] ='b10111111;
           rom[ 0+4227] ='b10111011;
           rom[ 0+4228] ='b10000111;
           rom[ 0+4229] ='b10000011;
           rom[ 0+4230] ='b10001111;
           rom[ 0+4231] ='b10001011;
           rom[ 0+4232] ='b10010111;
           rom[ 0+4233] ='b10010011;
           rom[ 0+4234] ='b10011111;
           rom[ 0+4235] ='b10011011;
           rom[ 0+4236] ='b11100111;
           rom[ 0+4237] ='b11100011;
           rom[ 0+4238] ='b11101111;
           rom[ 0+4239] ='b11101011;
           rom[ 0+4240] ='b11110111;
           rom[ 0+4241] ='b11110011;
           rom[ 0+4242] ='b11111111;
           rom[ 0+4243] ='b11111011;
           rom[ 0+4244] ='b11000111;
           rom[ 0+4245] ='b11000011;
           rom[ 0+4246] ='b11001111;
           rom[ 0+4247] ='b11001011;
           rom[ 0+4248] ='b11010111;
           rom[ 0+4249] ='b11010011;
           rom[ 0+4250] ='b11011111;
           rom[ 0+4251] ='b11011011;
           rom[ 0+4252] ='b00000000;
           rom[ 0+4253] ='b00001000;
           rom[ 0+4254] ='b00010000;
           rom[ 0+4255] ='b00011000;
           rom[ 0+4256] ='b00100000;
           rom[ 0+4257] ='b00101000;
           rom[ 0+4258] ='b00110000;
           rom[ 0+4259] ='b00111000;
           rom[ 0+4260] ='b01000000;
           rom[ 0+4261] ='b01001000;
           rom[ 0+4262] ='b01010000;
           rom[ 0+4263] ='b01011000;
           rom[ 0+4264] ='b01100000;
           rom[ 0+4265] ='b01101000;
           rom[ 0+4266] ='b01110000;
           rom[ 0+4267] ='b01111000;
           rom[ 0+4268] ='b10000000;
           rom[ 0+4269] ='b10001000;
           rom[ 0+4270] ='b10010000;
           rom[ 0+4271] ='b10011000;
           rom[ 0+4272] ='b10100000;
           rom[ 0+4273] ='b10101000;
           rom[ 0+4274] ='b10110000;
           rom[ 0+4275] ='b10111000;
           rom[ 0+4276] ='b11000000;
           rom[ 0+4277] ='b11001000;
           rom[ 0+4278] ='b11010000;
           rom[ 0+4279] ='b11011000;
           rom[ 0+4280] ='b11100000;
           rom[ 0+4281] ='b11101000;
           rom[ 0+4282] ='b11110000;
           rom[ 0+4283] ='b11111000;
           rom[ 0+4284] ='b00011101;
           rom[ 0+4285] ='b00010101;
           rom[ 0+4286] ='b00001101;
           rom[ 0+4287] ='b00000101;
           rom[ 0+4288] ='b00111101;
           rom[ 0+4289] ='b00110101;
           rom[ 0+4290] ='b00101101;
           rom[ 0+4291] ='b00100101;
           rom[ 0+4292] ='b01011101;
           rom[ 0+4293] ='b01010101;
           rom[ 0+4294] ='b01001101;
           rom[ 0+4295] ='b01000101;
           rom[ 0+4296] ='b01111101;
           rom[ 0+4297] ='b01110101;
           rom[ 0+4298] ='b01101101;
           rom[ 0+4299] ='b01100101;
           rom[ 0+4300] ='b10011101;
           rom[ 0+4301] ='b10010101;
           rom[ 0+4302] ='b10001101;
           rom[ 0+4303] ='b10000101;
           rom[ 0+4304] ='b10111101;
           rom[ 0+4305] ='b10110101;
           rom[ 0+4306] ='b10101101;
           rom[ 0+4307] ='b10100101;
           rom[ 0+4308] ='b11011101;
           rom[ 0+4309] ='b11010101;
           rom[ 0+4310] ='b11001101;
           rom[ 0+4311] ='b11000101;
           rom[ 0+4312] ='b11111101;
           rom[ 0+4313] ='b11110101;
           rom[ 0+4314] ='b11101101;
           rom[ 0+4315] ='b11100101;
           rom[ 0+4316] ='b00111010;
           rom[ 0+4317] ='b00110010;
           rom[ 0+4318] ='b00101010;
           rom[ 0+4319] ='b00100010;
           rom[ 0+4320] ='b00011010;
           rom[ 0+4321] ='b00010010;
           rom[ 0+4322] ='b00001010;
           rom[ 0+4323] ='b00000010;
           rom[ 0+4324] ='b01111010;
           rom[ 0+4325] ='b01110010;
           rom[ 0+4326] ='b01101010;
           rom[ 0+4327] ='b01100010;
           rom[ 0+4328] ='b01011010;
           rom[ 0+4329] ='b01010010;
           rom[ 0+4330] ='b01001010;
           rom[ 0+4331] ='b01000010;
           rom[ 0+4332] ='b10111010;
           rom[ 0+4333] ='b10110010;
           rom[ 0+4334] ='b10101010;
           rom[ 0+4335] ='b10100010;
           rom[ 0+4336] ='b10011010;
           rom[ 0+4337] ='b10010010;
           rom[ 0+4338] ='b10001010;
           rom[ 0+4339] ='b10000010;
           rom[ 0+4340] ='b11111010;
           rom[ 0+4341] ='b11110010;
           rom[ 0+4342] ='b11101010;
           rom[ 0+4343] ='b11100010;
           rom[ 0+4344] ='b11011010;
           rom[ 0+4345] ='b11010010;
           rom[ 0+4346] ='b11001010;
           rom[ 0+4347] ='b11000010;
           rom[ 0+4348] ='b00100111;
           rom[ 0+4349] ='b00101111;
           rom[ 0+4350] ='b00110111;
           rom[ 0+4351] ='b00111111;
           rom[ 0+4352] ='b00000111;
           rom[ 0+4353] ='b00001111;
           rom[ 0+4354] ='b00010111;
           rom[ 0+4355] ='b00011111;
           rom[ 0+4356] ='b01100111;
           rom[ 0+4357] ='b01101111;
           rom[ 0+4358] ='b01110111;
           rom[ 0+4359] ='b01111111;
           rom[ 0+4360] ='b01000111;
           rom[ 0+4361] ='b01001111;
           rom[ 0+4362] ='b01010111;
           rom[ 0+4363] ='b01011111;
           rom[ 0+4364] ='b10100111;
           rom[ 0+4365] ='b10101111;
           rom[ 0+4366] ='b10110111;
           rom[ 0+4367] ='b10111111;
           rom[ 0+4368] ='b10000111;
           rom[ 0+4369] ='b10001111;
           rom[ 0+4370] ='b10010111;
           rom[ 0+4371] ='b10011111;
           rom[ 0+4372] ='b11100111;
           rom[ 0+4373] ='b11101111;
           rom[ 0+4374] ='b11110111;
           rom[ 0+4375] ='b11111111;
           rom[ 0+4376] ='b11000111;
           rom[ 0+4377] ='b11001111;
           rom[ 0+4378] ='b11010111;
           rom[ 0+4379] ='b11011111;
           rom[ 0+4380] ='b01110100;
           rom[ 0+4381] ='b01111100;
           rom[ 0+4382] ='b01100100;
           rom[ 0+4383] ='b01101100;
           rom[ 0+4384] ='b01010100;
           rom[ 0+4385] ='b01011100;
           rom[ 0+4386] ='b01000100;
           rom[ 0+4387] ='b01001100;
           rom[ 0+4388] ='b00110100;
           rom[ 0+4389] ='b00111100;
           rom[ 0+4390] ='b00100100;
           rom[ 0+4391] ='b00101100;
           rom[ 0+4392] ='b00010100;
           rom[ 0+4393] ='b00011100;
           rom[ 0+4394] ='b00000100;
           rom[ 0+4395] ='b00001100;
           rom[ 0+4396] ='b11110100;
           rom[ 0+4397] ='b11111100;
           rom[ 0+4398] ='b11100100;
           rom[ 0+4399] ='b11101100;
           rom[ 0+4400] ='b11010100;
           rom[ 0+4401] ='b11011100;
           rom[ 0+4402] ='b11000100;
           rom[ 0+4403] ='b11001100;
           rom[ 0+4404] ='b10110100;
           rom[ 0+4405] ='b10111100;
           rom[ 0+4406] ='b10100100;
           rom[ 0+4407] ='b10101100;
           rom[ 0+4408] ='b10010100;
           rom[ 0+4409] ='b10011100;
           rom[ 0+4410] ='b10000100;
           rom[ 0+4411] ='b10001100;
           rom[ 0+4412] ='b01101001;
           rom[ 0+4413] ='b01100001;
           rom[ 0+4414] ='b01111001;
           rom[ 0+4415] ='b01110001;
           rom[ 0+4416] ='b01001001;
           rom[ 0+4417] ='b01000001;
           rom[ 0+4418] ='b01011001;
           rom[ 0+4419] ='b01010001;
           rom[ 0+4420] ='b00101001;
           rom[ 0+4421] ='b00100001;
           rom[ 0+4422] ='b00111001;
           rom[ 0+4423] ='b00110001;
           rom[ 0+4424] ='b00001001;
           rom[ 0+4425] ='b00000001;
           rom[ 0+4426] ='b00011001;
           rom[ 0+4427] ='b00010001;
           rom[ 0+4428] ='b11101001;
           rom[ 0+4429] ='b11100001;
           rom[ 0+4430] ='b11111001;
           rom[ 0+4431] ='b11110001;
           rom[ 0+4432] ='b11001001;
           rom[ 0+4433] ='b11000001;
           rom[ 0+4434] ='b11011001;
           rom[ 0+4435] ='b11010001;
           rom[ 0+4436] ='b10101001;
           rom[ 0+4437] ='b10100001;
           rom[ 0+4438] ='b10111001;
           rom[ 0+4439] ='b10110001;
           rom[ 0+4440] ='b10001001;
           rom[ 0+4441] ='b10000001;
           rom[ 0+4442] ='b10011001;
           rom[ 0+4443] ='b10010001;
           rom[ 0+4444] ='b01001110;
           rom[ 0+4445] ='b01000110;
           rom[ 0+4446] ='b01011110;
           rom[ 0+4447] ='b01010110;
           rom[ 0+4448] ='b01101110;
           rom[ 0+4449] ='b01100110;
           rom[ 0+4450] ='b01111110;
           rom[ 0+4451] ='b01110110;
           rom[ 0+4452] ='b00001110;
           rom[ 0+4453] ='b00000110;
           rom[ 0+4454] ='b00011110;
           rom[ 0+4455] ='b00010110;
           rom[ 0+4456] ='b00101110;
           rom[ 0+4457] ='b00100110;
           rom[ 0+4458] ='b00111110;
           rom[ 0+4459] ='b00110110;
           rom[ 0+4460] ='b11001110;
           rom[ 0+4461] ='b11000110;
           rom[ 0+4462] ='b11011110;
           rom[ 0+4463] ='b11010110;
           rom[ 0+4464] ='b11101110;
           rom[ 0+4465] ='b11100110;
           rom[ 0+4466] ='b11111110;
           rom[ 0+4467] ='b11110110;
           rom[ 0+4468] ='b10001110;
           rom[ 0+4469] ='b10000110;
           rom[ 0+4470] ='b10011110;
           rom[ 0+4471] ='b10010110;
           rom[ 0+4472] ='b10101110;
           rom[ 0+4473] ='b10100110;
           rom[ 0+4474] ='b10111110;
           rom[ 0+4475] ='b10110110;
           rom[ 0+4476] ='b01010011;
           rom[ 0+4477] ='b01011011;
           rom[ 0+4478] ='b01000011;
           rom[ 0+4479] ='b01001011;
           rom[ 0+4480] ='b01110011;
           rom[ 0+4481] ='b01111011;
           rom[ 0+4482] ='b01100011;
           rom[ 0+4483] ='b01101011;
           rom[ 0+4484] ='b00010011;
           rom[ 0+4485] ='b00011011;
           rom[ 0+4486] ='b00000011;
           rom[ 0+4487] ='b00001011;
           rom[ 0+4488] ='b00110011;
           rom[ 0+4489] ='b00111011;
           rom[ 0+4490] ='b00100011;
           rom[ 0+4491] ='b00101011;
           rom[ 0+4492] ='b11010011;
           rom[ 0+4493] ='b11011011;
           rom[ 0+4494] ='b11000011;
           rom[ 0+4495] ='b11001011;
           rom[ 0+4496] ='b11110011;
           rom[ 0+4497] ='b11111011;
           rom[ 0+4498] ='b11100011;
           rom[ 0+4499] ='b11101011;
           rom[ 0+4500] ='b10010011;
           rom[ 0+4501] ='b10011011;
           rom[ 0+4502] ='b10000011;
           rom[ 0+4503] ='b10001011;
           rom[ 0+4504] ='b10110011;
           rom[ 0+4505] ='b10111011;
           rom[ 0+4506] ='b10100011;
           rom[ 0+4507] ='b10101011;
           rom[ 0+4508] ='b00000000;
           rom[ 0+4509] ='b00010000;
           rom[ 0+4510] ='b00100000;
           rom[ 0+4511] ='b00110000;
           rom[ 0+4512] ='b01000000;
           rom[ 0+4513] ='b01010000;
           rom[ 0+4514] ='b01100000;
           rom[ 0+4515] ='b01110000;
           rom[ 0+4516] ='b10000000;
           rom[ 0+4517] ='b10010000;
           rom[ 0+4518] ='b10100000;
           rom[ 0+4519] ='b10110000;
           rom[ 0+4520] ='b11000000;
           rom[ 0+4521] ='b11010000;
           rom[ 0+4522] ='b11100000;
           rom[ 0+4523] ='b11110000;
           rom[ 0+4524] ='b00011101;
           rom[ 0+4525] ='b00001101;
           rom[ 0+4526] ='b00111101;
           rom[ 0+4527] ='b00101101;
           rom[ 0+4528] ='b01011101;
           rom[ 0+4529] ='b01001101;
           rom[ 0+4530] ='b01111101;
           rom[ 0+4531] ='b01101101;
           rom[ 0+4532] ='b10011101;
           rom[ 0+4533] ='b10001101;
           rom[ 0+4534] ='b10111101;
           rom[ 0+4535] ='b10101101;
           rom[ 0+4536] ='b11011101;
           rom[ 0+4537] ='b11001101;
           rom[ 0+4538] ='b11111101;
           rom[ 0+4539] ='b11101101;
           rom[ 0+4540] ='b00111010;
           rom[ 0+4541] ='b00101010;
           rom[ 0+4542] ='b00011010;
           rom[ 0+4543] ='b00001010;
           rom[ 0+4544] ='b01111010;
           rom[ 0+4545] ='b01101010;
           rom[ 0+4546] ='b01011010;
           rom[ 0+4547] ='b01001010;
           rom[ 0+4548] ='b10111010;
           rom[ 0+4549] ='b10101010;
           rom[ 0+4550] ='b10011010;
           rom[ 0+4551] ='b10001010;
           rom[ 0+4552] ='b11111010;
           rom[ 0+4553] ='b11101010;
           rom[ 0+4554] ='b11011010;
           rom[ 0+4555] ='b11001010;
           rom[ 0+4556] ='b00100111;
           rom[ 0+4557] ='b00110111;
           rom[ 0+4558] ='b00000111;
           rom[ 0+4559] ='b00010111;
           rom[ 0+4560] ='b01100111;
           rom[ 0+4561] ='b01110111;
           rom[ 0+4562] ='b01000111;
           rom[ 0+4563] ='b01010111;
           rom[ 0+4564] ='b10100111;
           rom[ 0+4565] ='b10110111;
           rom[ 0+4566] ='b10000111;
           rom[ 0+4567] ='b10010111;
           rom[ 0+4568] ='b11100111;
           rom[ 0+4569] ='b11110111;
           rom[ 0+4570] ='b11000111;
           rom[ 0+4571] ='b11010111;
           rom[ 0+4572] ='b01110100;
           rom[ 0+4573] ='b01100100;
           rom[ 0+4574] ='b01010100;
           rom[ 0+4575] ='b01000100;
           rom[ 0+4576] ='b00110100;
           rom[ 0+4577] ='b00100100;
           rom[ 0+4578] ='b00010100;
           rom[ 0+4579] ='b00000100;
           rom[ 0+4580] ='b11110100;
           rom[ 0+4581] ='b11100100;
           rom[ 0+4582] ='b11010100;
           rom[ 0+4583] ='b11000100;
           rom[ 0+4584] ='b10110100;
           rom[ 0+4585] ='b10100100;
           rom[ 0+4586] ='b10010100;
           rom[ 0+4587] ='b10000100;
           rom[ 0+4588] ='b01101001;
           rom[ 0+4589] ='b01111001;
           rom[ 0+4590] ='b01001001;
           rom[ 0+4591] ='b01011001;
           rom[ 0+4592] ='b00101001;
           rom[ 0+4593] ='b00111001;
           rom[ 0+4594] ='b00001001;
           rom[ 0+4595] ='b00011001;
           rom[ 0+4596] ='b11101001;
           rom[ 0+4597] ='b11111001;
           rom[ 0+4598] ='b11001001;
           rom[ 0+4599] ='b11011001;
           rom[ 0+4600] ='b10101001;
           rom[ 0+4601] ='b10111001;
           rom[ 0+4602] ='b10001001;
           rom[ 0+4603] ='b10011001;
           rom[ 0+4604] ='b01001110;
           rom[ 0+4605] ='b01011110;
           rom[ 0+4606] ='b01101110;
           rom[ 0+4607] ='b01111110;
           rom[ 0+4608] ='b00001110;
           rom[ 0+4609] ='b00011110;
           rom[ 0+4610] ='b00101110;
           rom[ 0+4611] ='b00111110;
           rom[ 0+4612] ='b11001110;
           rom[ 0+4613] ='b11011110;
           rom[ 0+4614] ='b11101110;
           rom[ 0+4615] ='b11111110;
           rom[ 0+4616] ='b10001110;
           rom[ 0+4617] ='b10011110;
           rom[ 0+4618] ='b10101110;
           rom[ 0+4619] ='b10111110;
           rom[ 0+4620] ='b01010011;
           rom[ 0+4621] ='b01000011;
           rom[ 0+4622] ='b01110011;
           rom[ 0+4623] ='b01100011;
           rom[ 0+4624] ='b00010011;
           rom[ 0+4625] ='b00000011;
           rom[ 0+4626] ='b00110011;
           rom[ 0+4627] ='b00100011;
           rom[ 0+4628] ='b11010011;
           rom[ 0+4629] ='b11000011;
           rom[ 0+4630] ='b11110011;
           rom[ 0+4631] ='b11100011;
           rom[ 0+4632] ='b10010011;
           rom[ 0+4633] ='b10000011;
           rom[ 0+4634] ='b10110011;
           rom[ 0+4635] ='b10100011;
           rom[ 0+4636] ='b11101000;
           rom[ 0+4637] ='b11111000;
           rom[ 0+4638] ='b11001000;
           rom[ 0+4639] ='b11011000;
           rom[ 0+4640] ='b10101000;
           rom[ 0+4641] ='b10111000;
           rom[ 0+4642] ='b10001000;
           rom[ 0+4643] ='b10011000;
           rom[ 0+4644] ='b01101000;
           rom[ 0+4645] ='b01111000;
           rom[ 0+4646] ='b01001000;
           rom[ 0+4647] ='b01011000;
           rom[ 0+4648] ='b00101000;
           rom[ 0+4649] ='b00111000;
           rom[ 0+4650] ='b00001000;
           rom[ 0+4651] ='b00011000;
           rom[ 0+4652] ='b11110101;
           rom[ 0+4653] ='b11100101;
           rom[ 0+4654] ='b11010101;
           rom[ 0+4655] ='b11000101;
           rom[ 0+4656] ='b10110101;
           rom[ 0+4657] ='b10100101;
           rom[ 0+4658] ='b10010101;
           rom[ 0+4659] ='b10000101;
           rom[ 0+4660] ='b01110101;
           rom[ 0+4661] ='b01100101;
           rom[ 0+4662] ='b01010101;
           rom[ 0+4663] ='b01000101;
           rom[ 0+4664] ='b00110101;
           rom[ 0+4665] ='b00100101;
           rom[ 0+4666] ='b00010101;
           rom[ 0+4667] ='b00000101;
           rom[ 0+4668] ='b11010010;
           rom[ 0+4669] ='b11000010;
           rom[ 0+4670] ='b11110010;
           rom[ 0+4671] ='b11100010;
           rom[ 0+4672] ='b10010010;
           rom[ 0+4673] ='b10000010;
           rom[ 0+4674] ='b10110010;
           rom[ 0+4675] ='b10100010;
           rom[ 0+4676] ='b01010010;
           rom[ 0+4677] ='b01000010;
           rom[ 0+4678] ='b01110010;
           rom[ 0+4679] ='b01100010;
           rom[ 0+4680] ='b00010010;
           rom[ 0+4681] ='b00000010;
           rom[ 0+4682] ='b00110010;
           rom[ 0+4683] ='b00100010;
           rom[ 0+4684] ='b11001111;
           rom[ 0+4685] ='b11011111;
           rom[ 0+4686] ='b11101111;
           rom[ 0+4687] ='b11111111;
           rom[ 0+4688] ='b10001111;
           rom[ 0+4689] ='b10011111;
           rom[ 0+4690] ='b10101111;
           rom[ 0+4691] ='b10111111;
           rom[ 0+4692] ='b01001111;
           rom[ 0+4693] ='b01011111;
           rom[ 0+4694] ='b01101111;
           rom[ 0+4695] ='b01111111;
           rom[ 0+4696] ='b00001111;
           rom[ 0+4697] ='b00011111;
           rom[ 0+4698] ='b00101111;
           rom[ 0+4699] ='b00111111;
           rom[ 0+4700] ='b10011100;
           rom[ 0+4701] ='b10001100;
           rom[ 0+4702] ='b10111100;
           rom[ 0+4703] ='b10101100;
           rom[ 0+4704] ='b11011100;
           rom[ 0+4705] ='b11001100;
           rom[ 0+4706] ='b11111100;
           rom[ 0+4707] ='b11101100;
           rom[ 0+4708] ='b00011100;
           rom[ 0+4709] ='b00001100;
           rom[ 0+4710] ='b00111100;
           rom[ 0+4711] ='b00101100;
           rom[ 0+4712] ='b01011100;
           rom[ 0+4713] ='b01001100;
           rom[ 0+4714] ='b01111100;
           rom[ 0+4715] ='b01101100;
           rom[ 0+4716] ='b10000001;
           rom[ 0+4717] ='b10010001;
           rom[ 0+4718] ='b10100001;
           rom[ 0+4719] ='b10110001;
           rom[ 0+4720] ='b11000001;
           rom[ 0+4721] ='b11010001;
           rom[ 0+4722] ='b11100001;
           rom[ 0+4723] ='b11110001;
           rom[ 0+4724] ='b00000001;
           rom[ 0+4725] ='b00010001;
           rom[ 0+4726] ='b00100001;
           rom[ 0+4727] ='b00110001;
           rom[ 0+4728] ='b01000001;
           rom[ 0+4729] ='b01010001;
           rom[ 0+4730] ='b01100001;
           rom[ 0+4731] ='b01110001;
           rom[ 0+4732] ='b10100110;
           rom[ 0+4733] ='b10110110;
           rom[ 0+4734] ='b10000110;
           rom[ 0+4735] ='b10010110;
           rom[ 0+4736] ='b11100110;
           rom[ 0+4737] ='b11110110;
           rom[ 0+4738] ='b11000110;
           rom[ 0+4739] ='b11010110;
           rom[ 0+4740] ='b00100110;
           rom[ 0+4741] ='b00110110;
           rom[ 0+4742] ='b00000110;
           rom[ 0+4743] ='b00010110;
           rom[ 0+4744] ='b01100110;
           rom[ 0+4745] ='b01110110;
           rom[ 0+4746] ='b01000110;
           rom[ 0+4747] ='b01010110;
           rom[ 0+4748] ='b10111011;
           rom[ 0+4749] ='b10101011;
           rom[ 0+4750] ='b10011011;
           rom[ 0+4751] ='b10001011;
           rom[ 0+4752] ='b11111011;
           rom[ 0+4753] ='b11101011;
           rom[ 0+4754] ='b11011011;
           rom[ 0+4755] ='b11001011;
           rom[ 0+4756] ='b00111011;
           rom[ 0+4757] ='b00101011;
           rom[ 0+4758] ='b00011011;
           rom[ 0+4759] ='b00001011;
           rom[ 0+4760] ='b01111011;
           rom[ 0+4761] ='b01101011;
           rom[ 0+4762] ='b01011011;
           rom[ 0+4763] ='b01001011;
           rom[ 0+4764] ='b00000000;
           rom[ 0+4765] ='b00100000;
           rom[ 0+4766] ='b01000000;
           rom[ 0+4767] ='b01100000;
           rom[ 0+4768] ='b10000000;
           rom[ 0+4769] ='b10100000;
           rom[ 0+4770] ='b11000000;
           rom[ 0+4771] ='b11100000;
           rom[ 0+4772] ='b00011101;
           rom[ 0+4773] ='b00111101;
           rom[ 0+4774] ='b01011101;
           rom[ 0+4775] ='b01111101;
           rom[ 0+4776] ='b10011101;
           rom[ 0+4777] ='b10111101;
           rom[ 0+4778] ='b11011101;
           rom[ 0+4779] ='b11111101;
           rom[ 0+4780] ='b00111010;
           rom[ 0+4781] ='b00011010;
           rom[ 0+4782] ='b01111010;
           rom[ 0+4783] ='b01011010;
           rom[ 0+4784] ='b10111010;
           rom[ 0+4785] ='b10011010;
           rom[ 0+4786] ='b11111010;
           rom[ 0+4787] ='b11011010;
           rom[ 0+4788] ='b00100111;
           rom[ 0+4789] ='b00000111;
           rom[ 0+4790] ='b01100111;
           rom[ 0+4791] ='b01000111;
           rom[ 0+4792] ='b10100111;
           rom[ 0+4793] ='b10000111;
           rom[ 0+4794] ='b11100111;
           rom[ 0+4795] ='b11000111;
           rom[ 0+4796] ='b01110100;
           rom[ 0+4797] ='b01010100;
           rom[ 0+4798] ='b00110100;
           rom[ 0+4799] ='b00010100;
           rom[ 0+4800] ='b11110100;
           rom[ 0+4801] ='b11010100;
           rom[ 0+4802] ='b10110100;
           rom[ 0+4803] ='b10010100;
           rom[ 0+4804] ='b01101001;
           rom[ 0+4805] ='b01001001;
           rom[ 0+4806] ='b00101001;
           rom[ 0+4807] ='b00001001;
           rom[ 0+4808] ='b11101001;
           rom[ 0+4809] ='b11001001;
           rom[ 0+4810] ='b10101001;
           rom[ 0+4811] ='b10001001;
           rom[ 0+4812] ='b01001110;
           rom[ 0+4813] ='b01101110;
           rom[ 0+4814] ='b00001110;
           rom[ 0+4815] ='b00101110;
           rom[ 0+4816] ='b11001110;
           rom[ 0+4817] ='b11101110;
           rom[ 0+4818] ='b10001110;
           rom[ 0+4819] ='b10101110;
           rom[ 0+4820] ='b01010011;
           rom[ 0+4821] ='b01110011;
           rom[ 0+4822] ='b00010011;
           rom[ 0+4823] ='b00110011;
           rom[ 0+4824] ='b11010011;
           rom[ 0+4825] ='b11110011;
           rom[ 0+4826] ='b10010011;
           rom[ 0+4827] ='b10110011;
           rom[ 0+4828] ='b11101000;
           rom[ 0+4829] ='b11001000;
           rom[ 0+4830] ='b10101000;
           rom[ 0+4831] ='b10001000;
           rom[ 0+4832] ='b01101000;
           rom[ 0+4833] ='b01001000;
           rom[ 0+4834] ='b00101000;
           rom[ 0+4835] ='b00001000;
           rom[ 0+4836] ='b11110101;
           rom[ 0+4837] ='b11010101;
           rom[ 0+4838] ='b10110101;
           rom[ 0+4839] ='b10010101;
           rom[ 0+4840] ='b01110101;
           rom[ 0+4841] ='b01010101;
           rom[ 0+4842] ='b00110101;
           rom[ 0+4843] ='b00010101;
           rom[ 0+4844] ='b11010010;
           rom[ 0+4845] ='b11110010;
           rom[ 0+4846] ='b10010010;
           rom[ 0+4847] ='b10110010;
           rom[ 0+4848] ='b01010010;
           rom[ 0+4849] ='b01110010;
           rom[ 0+4850] ='b00010010;
           rom[ 0+4851] ='b00110010;
           rom[ 0+4852] ='b11001111;
           rom[ 0+4853] ='b11101111;
           rom[ 0+4854] ='b10001111;
           rom[ 0+4855] ='b10101111;
           rom[ 0+4856] ='b01001111;
           rom[ 0+4857] ='b01101111;
           rom[ 0+4858] ='b00001111;
           rom[ 0+4859] ='b00101111;
           rom[ 0+4860] ='b10011100;
           rom[ 0+4861] ='b10111100;
           rom[ 0+4862] ='b11011100;
           rom[ 0+4863] ='b11111100;
           rom[ 0+4864] ='b00011100;
           rom[ 0+4865] ='b00111100;
           rom[ 0+4866] ='b01011100;
           rom[ 0+4867] ='b01111100;
           rom[ 0+4868] ='b10000001;
           rom[ 0+4869] ='b10100001;
           rom[ 0+4870] ='b11000001;
           rom[ 0+4871] ='b11100001;
           rom[ 0+4872] ='b00000001;
           rom[ 0+4873] ='b00100001;
           rom[ 0+4874] ='b01000001;
           rom[ 0+4875] ='b01100001;
           rom[ 0+4876] ='b10100110;
           rom[ 0+4877] ='b10000110;
           rom[ 0+4878] ='b11100110;
           rom[ 0+4879] ='b11000110;
           rom[ 0+4880] ='b00100110;
           rom[ 0+4881] ='b00000110;
           rom[ 0+4882] ='b01100110;
           rom[ 0+4883] ='b01000110;
           rom[ 0+4884] ='b10111011;
           rom[ 0+4885] ='b10011011;
           rom[ 0+4886] ='b11111011;
           rom[ 0+4887] ='b11011011;
           rom[ 0+4888] ='b00111011;
           rom[ 0+4889] ='b00011011;
           rom[ 0+4890] ='b01111011;
           rom[ 0+4891] ='b01011011;
           rom[ 0+4892] ='b11001101;
           rom[ 0+4893] ='b11101101;
           rom[ 0+4894] ='b10001101;
           rom[ 0+4895] ='b10101101;
           rom[ 0+4896] ='b01001101;
           rom[ 0+4897] ='b01101101;
           rom[ 0+4898] ='b00001101;
           rom[ 0+4899] ='b00101101;
           rom[ 0+4900] ='b11010000;
           rom[ 0+4901] ='b11110000;
           rom[ 0+4902] ='b10010000;
           rom[ 0+4903] ='b10110000;
           rom[ 0+4904] ='b01010000;
           rom[ 0+4905] ='b01110000;
           rom[ 0+4906] ='b00010000;
           rom[ 0+4907] ='b00110000;
           rom[ 0+4908] ='b11110111;
           rom[ 0+4909] ='b11010111;
           rom[ 0+4910] ='b10110111;
           rom[ 0+4911] ='b10010111;
           rom[ 0+4912] ='b01110111;
           rom[ 0+4913] ='b01010111;
           rom[ 0+4914] ='b00110111;
           rom[ 0+4915] ='b00010111;
           rom[ 0+4916] ='b11101010;
           rom[ 0+4917] ='b11001010;
           rom[ 0+4918] ='b10101010;
           rom[ 0+4919] ='b10001010;
           rom[ 0+4920] ='b01101010;
           rom[ 0+4921] ='b01001010;
           rom[ 0+4922] ='b00101010;
           rom[ 0+4923] ='b00001010;
           rom[ 0+4924] ='b10111001;
           rom[ 0+4925] ='b10011001;
           rom[ 0+4926] ='b11111001;
           rom[ 0+4927] ='b11011001;
           rom[ 0+4928] ='b00111001;
           rom[ 0+4929] ='b00011001;
           rom[ 0+4930] ='b01111001;
           rom[ 0+4931] ='b01011001;
           rom[ 0+4932] ='b10100100;
           rom[ 0+4933] ='b10000100;
           rom[ 0+4934] ='b11100100;
           rom[ 0+4935] ='b11000100;
           rom[ 0+4936] ='b00100100;
           rom[ 0+4937] ='b00000100;
           rom[ 0+4938] ='b01100100;
           rom[ 0+4939] ='b01000100;
           rom[ 0+4940] ='b10000011;
           rom[ 0+4941] ='b10100011;
           rom[ 0+4942] ='b11000011;
           rom[ 0+4943] ='b11100011;
           rom[ 0+4944] ='b00000011;
           rom[ 0+4945] ='b00100011;
           rom[ 0+4946] ='b01000011;
           rom[ 0+4947] ='b01100011;
           rom[ 0+4948] ='b10011110;
           rom[ 0+4949] ='b10111110;
           rom[ 0+4950] ='b11011110;
           rom[ 0+4951] ='b11111110;
           rom[ 0+4952] ='b00011110;
           rom[ 0+4953] ='b00111110;
           rom[ 0+4954] ='b01011110;
           rom[ 0+4955] ='b01111110;
           rom[ 0+4956] ='b00100101;
           rom[ 0+4957] ='b00000101;
           rom[ 0+4958] ='b01100101;
           rom[ 0+4959] ='b01000101;
           rom[ 0+4960] ='b10100101;
           rom[ 0+4961] ='b10000101;
           rom[ 0+4962] ='b11100101;
           rom[ 0+4963] ='b11000101;
           rom[ 0+4964] ='b00111000;
           rom[ 0+4965] ='b00011000;
           rom[ 0+4966] ='b01111000;
           rom[ 0+4967] ='b01011000;
           rom[ 0+4968] ='b10111000;
           rom[ 0+4969] ='b10011000;
           rom[ 0+4970] ='b11111000;
           rom[ 0+4971] ='b11011000;
           rom[ 0+4972] ='b00011111;
           rom[ 0+4973] ='b00111111;
           rom[ 0+4974] ='b01011111;
           rom[ 0+4975] ='b01111111;
           rom[ 0+4976] ='b10011111;
           rom[ 0+4977] ='b10111111;
           rom[ 0+4978] ='b11011111;
           rom[ 0+4979] ='b11111111;
           rom[ 0+4980] ='b00000010;
           rom[ 0+4981] ='b00100010;
           rom[ 0+4982] ='b01000010;
           rom[ 0+4983] ='b01100010;
           rom[ 0+4984] ='b10000010;
           rom[ 0+4985] ='b10100010;
           rom[ 0+4986] ='b11000010;
           rom[ 0+4987] ='b11100010;
           rom[ 0+4988] ='b01010001;
           rom[ 0+4989] ='b01110001;
           rom[ 0+4990] ='b00010001;
           rom[ 0+4991] ='b00110001;
           rom[ 0+4992] ='b11010001;
           rom[ 0+4993] ='b11110001;
           rom[ 0+4994] ='b10010001;
           rom[ 0+4995] ='b10110001;
           rom[ 0+4996] ='b01001100;
           rom[ 0+4997] ='b01101100;
           rom[ 0+4998] ='b00001100;
           rom[ 0+4999] ='b00101100;
           rom[ 0+5000] ='b11001100;
           rom[ 0+5001] ='b11101100;
           rom[ 0+5002] ='b10001100;
           rom[ 0+5003] ='b10101100;
           rom[ 0+5004] ='b01101011;
           rom[ 0+5005] ='b01001011;
           rom[ 0+5006] ='b00101011;
           rom[ 0+5007] ='b00001011;
           rom[ 0+5008] ='b11101011;
           rom[ 0+5009] ='b11001011;
           rom[ 0+5010] ='b10101011;
           rom[ 0+5011] ='b10001011;
           rom[ 0+5012] ='b01110110;
           rom[ 0+5013] ='b01010110;
           rom[ 0+5014] ='b00110110;
           rom[ 0+5015] ='b00010110;
           rom[ 0+5016] ='b11110110;
           rom[ 0+5017] ='b11010110;
           rom[ 0+5018] ='b10110110;
           rom[ 0+5019] ='b10010110;
           rom[ 0+5020] ='b00000000;
           rom[ 0+5021] ='b01000000;
           rom[ 0+5022] ='b10000000;
           rom[ 0+5023] ='b11000000;
           rom[ 0+5024] ='b00011101;
           rom[ 0+5025] ='b01011101;
           rom[ 0+5026] ='b10011101;
           rom[ 0+5027] ='b11011101;
           rom[ 0+5028] ='b00111010;
           rom[ 0+5029] ='b01111010;
           rom[ 0+5030] ='b10111010;
           rom[ 0+5031] ='b11111010;
           rom[ 0+5032] ='b00100111;
           rom[ 0+5033] ='b01100111;
           rom[ 0+5034] ='b10100111;
           rom[ 0+5035] ='b11100111;
           rom[ 0+5036] ='b01110100;
           rom[ 0+5037] ='b00110100;
           rom[ 0+5038] ='b11110100;
           rom[ 0+5039] ='b10110100;
           rom[ 0+5040] ='b01101001;
           rom[ 0+5041] ='b00101001;
           rom[ 0+5042] ='b11101001;
           rom[ 0+5043] ='b10101001;
           rom[ 0+5044] ='b01001110;
           rom[ 0+5045] ='b00001110;
           rom[ 0+5046] ='b11001110;
           rom[ 0+5047] ='b10001110;
           rom[ 0+5048] ='b01010011;
           rom[ 0+5049] ='b00010011;
           rom[ 0+5050] ='b11010011;
           rom[ 0+5051] ='b10010011;
           rom[ 0+5052] ='b11101000;
           rom[ 0+5053] ='b10101000;
           rom[ 0+5054] ='b01101000;
           rom[ 0+5055] ='b00101000;
           rom[ 0+5056] ='b11110101;
           rom[ 0+5057] ='b10110101;
           rom[ 0+5058] ='b01110101;
           rom[ 0+5059] ='b00110101;
           rom[ 0+5060] ='b11010010;
           rom[ 0+5061] ='b10010010;
           rom[ 0+5062] ='b01010010;
           rom[ 0+5063] ='b00010010;
           rom[ 0+5064] ='b11001111;
           rom[ 0+5065] ='b10001111;
           rom[ 0+5066] ='b01001111;
           rom[ 0+5067] ='b00001111;
           rom[ 0+5068] ='b10011100;
           rom[ 0+5069] ='b11011100;
           rom[ 0+5070] ='b00011100;
           rom[ 0+5071] ='b01011100;
           rom[ 0+5072] ='b10000001;
           rom[ 0+5073] ='b11000001;
           rom[ 0+5074] ='b00000001;
           rom[ 0+5075] ='b01000001;
           rom[ 0+5076] ='b10100110;
           rom[ 0+5077] ='b11100110;
           rom[ 0+5078] ='b00100110;
           rom[ 0+5079] ='b01100110;
           rom[ 0+5080] ='b10111011;
           rom[ 0+5081] ='b11111011;
           rom[ 0+5082] ='b00111011;
           rom[ 0+5083] ='b01111011;
           rom[ 0+5084] ='b11001101;
           rom[ 0+5085] ='b10001101;
           rom[ 0+5086] ='b01001101;
           rom[ 0+5087] ='b00001101;
           rom[ 0+5088] ='b11010000;
           rom[ 0+5089] ='b10010000;
           rom[ 0+5090] ='b01010000;
           rom[ 0+5091] ='b00010000;
           rom[ 0+5092] ='b11110111;
           rom[ 0+5093] ='b10110111;
           rom[ 0+5094] ='b01110111;
           rom[ 0+5095] ='b00110111;
           rom[ 0+5096] ='b11101010;
           rom[ 0+5097] ='b10101010;
           rom[ 0+5098] ='b01101010;
           rom[ 0+5099] ='b00101010;
           rom[ 0+5100] ='b10111001;
           rom[ 0+5101] ='b11111001;
           rom[ 0+5102] ='b00111001;
           rom[ 0+5103] ='b01111001;
           rom[ 0+5104] ='b10100100;
           rom[ 0+5105] ='b11100100;
           rom[ 0+5106] ='b00100100;
           rom[ 0+5107] ='b01100100;
           rom[ 0+5108] ='b10000011;
           rom[ 0+5109] ='b11000011;
           rom[ 0+5110] ='b00000011;
           rom[ 0+5111] ='b01000011;
           rom[ 0+5112] ='b10011110;
           rom[ 0+5113] ='b11011110;
           rom[ 0+5114] ='b00011110;
           rom[ 0+5115] ='b01011110;
           rom[ 0+5116] ='b00100101;
           rom[ 0+5117] ='b01100101;
           rom[ 0+5118] ='b10100101;
           rom[ 0+5119] ='b11100101;
           rom[ 0+5120] ='b00111000;
           rom[ 0+5121] ='b01111000;
           rom[ 0+5122] ='b10111000;
           rom[ 0+5123] ='b11111000;
           rom[ 0+5124] ='b00011111;
           rom[ 0+5125] ='b01011111;
           rom[ 0+5126] ='b10011111;
           rom[ 0+5127] ='b11011111;
           rom[ 0+5128] ='b00000010;
           rom[ 0+5129] ='b01000010;
           rom[ 0+5130] ='b10000010;
           rom[ 0+5131] ='b11000010;
           rom[ 0+5132] ='b01010001;
           rom[ 0+5133] ='b00010001;
           rom[ 0+5134] ='b11010001;
           rom[ 0+5135] ='b10010001;
           rom[ 0+5136] ='b01001100;
           rom[ 0+5137] ='b00001100;
           rom[ 0+5138] ='b11001100;
           rom[ 0+5139] ='b10001100;
           rom[ 0+5140] ='b01101011;
           rom[ 0+5141] ='b00101011;
           rom[ 0+5142] ='b11101011;
           rom[ 0+5143] ='b10101011;
           rom[ 0+5144] ='b01110110;
           rom[ 0+5145] ='b00110110;
           rom[ 0+5146] ='b11110110;
           rom[ 0+5147] ='b10110110;
           rom[ 0+5148] ='b10000111;
           rom[ 0+5149] ='b11000111;
           rom[ 0+5150] ='b00000111;
           rom[ 0+5151] ='b01000111;
           rom[ 0+5152] ='b10011010;
           rom[ 0+5153] ='b11011010;
           rom[ 0+5154] ='b00011010;
           rom[ 0+5155] ='b01011010;
           rom[ 0+5156] ='b10111101;
           rom[ 0+5157] ='b11111101;
           rom[ 0+5158] ='b00111101;
           rom[ 0+5159] ='b01111101;
           rom[ 0+5160] ='b10100000;
           rom[ 0+5161] ='b11100000;
           rom[ 0+5162] ='b00100000;
           rom[ 0+5163] ='b01100000;
           rom[ 0+5164] ='b11110011;
           rom[ 0+5165] ='b10110011;
           rom[ 0+5166] ='b01110011;
           rom[ 0+5167] ='b00110011;
           rom[ 0+5168] ='b11101110;
           rom[ 0+5169] ='b10101110;
           rom[ 0+5170] ='b01101110;
           rom[ 0+5171] ='b00101110;
           rom[ 0+5172] ='b11001001;
           rom[ 0+5173] ='b10001001;
           rom[ 0+5174] ='b01001001;
           rom[ 0+5175] ='b00001001;
           rom[ 0+5176] ='b11010100;
           rom[ 0+5177] ='b10010100;
           rom[ 0+5178] ='b01010100;
           rom[ 0+5179] ='b00010100;
           rom[ 0+5180] ='b01101111;
           rom[ 0+5181] ='b00101111;
           rom[ 0+5182] ='b11101111;
           rom[ 0+5183] ='b10101111;
           rom[ 0+5184] ='b01110010;
           rom[ 0+5185] ='b00110010;
           rom[ 0+5186] ='b11110010;
           rom[ 0+5187] ='b10110010;
           rom[ 0+5188] ='b01010101;
           rom[ 0+5189] ='b00010101;
           rom[ 0+5190] ='b11010101;
           rom[ 0+5191] ='b10010101;
           rom[ 0+5192] ='b01001000;
           rom[ 0+5193] ='b00001000;
           rom[ 0+5194] ='b11001000;
           rom[ 0+5195] ='b10001000;
           rom[ 0+5196] ='b00011011;
           rom[ 0+5197] ='b01011011;
           rom[ 0+5198] ='b10011011;
           rom[ 0+5199] ='b11011011;
           rom[ 0+5200] ='b00000110;
           rom[ 0+5201] ='b01000110;
           rom[ 0+5202] ='b10000110;
           rom[ 0+5203] ='b11000110;
           rom[ 0+5204] ='b00100001;
           rom[ 0+5205] ='b01100001;
           rom[ 0+5206] ='b10100001;
           rom[ 0+5207] ='b11100001;
           rom[ 0+5208] ='b00111100;
           rom[ 0+5209] ='b01111100;
           rom[ 0+5210] ='b10111100;
           rom[ 0+5211] ='b11111100;
           rom[ 0+5212] ='b01001010;
           rom[ 0+5213] ='b00001010;
           rom[ 0+5214] ='b11001010;
           rom[ 0+5215] ='b10001010;
           rom[ 0+5216] ='b01010111;
           rom[ 0+5217] ='b00010111;
           rom[ 0+5218] ='b11010111;
           rom[ 0+5219] ='b10010111;
           rom[ 0+5220] ='b01110000;
           rom[ 0+5221] ='b00110000;
           rom[ 0+5222] ='b11110000;
           rom[ 0+5223] ='b10110000;
           rom[ 0+5224] ='b01101101;
           rom[ 0+5225] ='b00101101;
           rom[ 0+5226] ='b11101101;
           rom[ 0+5227] ='b10101101;
           rom[ 0+5228] ='b00111110;
           rom[ 0+5229] ='b01111110;
           rom[ 0+5230] ='b10111110;
           rom[ 0+5231] ='b11111110;
           rom[ 0+5232] ='b00100011;
           rom[ 0+5233] ='b01100011;
           rom[ 0+5234] ='b10100011;
           rom[ 0+5235] ='b11100011;
           rom[ 0+5236] ='b00000100;
           rom[ 0+5237] ='b01000100;
           rom[ 0+5238] ='b10000100;
           rom[ 0+5239] ='b11000100;
           rom[ 0+5240] ='b00011001;
           rom[ 0+5241] ='b01011001;
           rom[ 0+5242] ='b10011001;
           rom[ 0+5243] ='b11011001;
           rom[ 0+5244] ='b10100010;
           rom[ 0+5245] ='b11100010;
           rom[ 0+5246] ='b00100010;
           rom[ 0+5247] ='b01100010;
           rom[ 0+5248] ='b10111111;
           rom[ 0+5249] ='b11111111;
           rom[ 0+5250] ='b00111111;
           rom[ 0+5251] ='b01111111;
           rom[ 0+5252] ='b10011000;
           rom[ 0+5253] ='b11011000;
           rom[ 0+5254] ='b00011000;
           rom[ 0+5255] ='b01011000;
           rom[ 0+5256] ='b10000101;
           rom[ 0+5257] ='b11000101;
           rom[ 0+5258] ='b00000101;
           rom[ 0+5259] ='b01000101;
           rom[ 0+5260] ='b11010110;
           rom[ 0+5261] ='b10010110;
           rom[ 0+5262] ='b01010110;
           rom[ 0+5263] ='b00010110;
           rom[ 0+5264] ='b11001011;
           rom[ 0+5265] ='b10001011;
           rom[ 0+5266] ='b01001011;
           rom[ 0+5267] ='b00001011;
           rom[ 0+5268] ='b11101100;
           rom[ 0+5269] ='b10101100;
           rom[ 0+5270] ='b01101100;
           rom[ 0+5271] ='b00101100;
           rom[ 0+5272] ='b11110001;
           rom[ 0+5273] ='b10110001;
           rom[ 0+5274] ='b01110001;
           rom[ 0+5275] ='b00110001;
           rom[ 0+5276] ='b11011101;
           rom[ 0+5277] ='b11100101;
           rom[ 0+5278] ='b11011101;
           rom[ 0+5279] ='b00100001;
           rom[ 0+5280] ='b00000000;
           rom[ 0+5281] ='b00000000;
           rom[ 0+5282] ='b11011101;
           rom[ 0+5283] ='b00111001;
           rom[ 0+5284] ='b11011101;
           rom[ 0+5285] ='b01111110;
           rom[ 0+5286] ='b00000100;
           rom[ 0+5287] ='b11111101;
           rom[ 0+5288] ='b00100001;
           rom[ 0+5289] ='b11101001;
           rom[ 0+5290] ='b10000011;
           rom[ 0+5291] ='b11111101;
           rom[ 0+5292] ='b01110111;
           rom[ 0+5293] ='b00000000;
           rom[ 0+5294] ='b11011101;
           rom[ 0+5295] ='b11100001;
           rom[ 0+5296] ='b11001001;
           rom[ 0+5297] ='b11011101;
           rom[ 0+5298] ='b11100101;
           rom[ 0+5299] ='b11011101;
           rom[ 0+5300] ='b00100001;
           rom[ 0+5301] ='b00000000;
           rom[ 0+5302] ='b00000000;
           rom[ 0+5303] ='b11011101;
           rom[ 0+5304] ='b00111001;
           rom[ 0+5305] ='b11011101;
           rom[ 0+5306] ='b01111110;
           rom[ 0+5307] ='b00000100;
           rom[ 0+5308] ='b11111101;
           rom[ 0+5309] ='b00100001;
           rom[ 0+5310] ='b11101010;
           rom[ 0+5311] ='b10000011;
           rom[ 0+5312] ='b11111101;
           rom[ 0+5313] ='b01110111;
           rom[ 0+5314] ='b00000000;
           rom[ 0+5315] ='b11011101;
           rom[ 0+5316] ='b01111110;
           rom[ 0+5317] ='b00000101;
           rom[ 0+5318] ='b11111101;
           rom[ 0+5319] ='b01110111;
           rom[ 0+5320] ='b00000001;
           rom[ 0+5321] ='b11011101;
           rom[ 0+5322] ='b11100001;
           rom[ 0+5323] ='b11001001;
           rom[ 0+5324] ='b11011101;
           rom[ 0+5325] ='b11100101;
           rom[ 0+5326] ='b11011101;
           rom[ 0+5327] ='b00100001;
           rom[ 0+5328] ='b00000000;
           rom[ 0+5329] ='b00000000;
           rom[ 0+5330] ='b11011101;
           rom[ 0+5331] ='b00111001;
           rom[ 0+5332] ='b11011101;
           rom[ 0+5333] ='b01111110;
           rom[ 0+5334] ='b00000100;
           rom[ 0+5335] ='b11111101;
           rom[ 0+5336] ='b00100001;
           rom[ 0+5337] ='b11101100;
           rom[ 0+5338] ='b10000011;
           rom[ 0+5339] ='b11111101;
           rom[ 0+5340] ='b01110111;
           rom[ 0+5341] ='b00000000;
           rom[ 0+5342] ='b11011101;
           rom[ 0+5343] ='b01111110;
           rom[ 0+5344] ='b00000101;
           rom[ 0+5345] ='b11111101;
           rom[ 0+5346] ='b01110111;
           rom[ 0+5347] ='b00000001;
           rom[ 0+5348] ='b11011101;
           rom[ 0+5349] ='b01111110;
           rom[ 0+5350] ='b00000110;
           rom[ 0+5351] ='b11111101;
           rom[ 0+5352] ='b01110111;
           rom[ 0+5353] ='b00000010;
           rom[ 0+5354] ='b11011101;
           rom[ 0+5355] ='b01111110;
           rom[ 0+5356] ='b00000111;
           rom[ 0+5357] ='b11111101;
           rom[ 0+5358] ='b01110111;
           rom[ 0+5359] ='b00000011;
           rom[ 0+5360] ='b11011101;
           rom[ 0+5361] ='b11100001;
           rom[ 0+5362] ='b11001001;
           rom[ 0+5363] ='b11011101;
           rom[ 0+5364] ='b11100101;
           rom[ 0+5365] ='b11011101;
           rom[ 0+5366] ='b00100001;
           rom[ 0+5367] ='b00000000;
           rom[ 0+5368] ='b00000000;
           rom[ 0+5369] ='b11011101;
           rom[ 0+5370] ='b00111001;
           rom[ 0+5371] ='b00100001;
           rom[ 0+5372] ='b11100110;
           rom[ 0+5373] ='b11111111;
           rom[ 0+5374] ='b00111001;
           rom[ 0+5375] ='b11111001;
           rom[ 0+5376] ='b00100001;
           rom[ 0+5377] ='b00001110;
           rom[ 0+5378] ='b00000000;
           rom[ 0+5379] ='b00111001;
           rom[ 0+5380] ='b11011101;
           rom[ 0+5381] ='b01110101;
           rom[ 0+5382] ='b11101010;
           rom[ 0+5383] ='b11011101;
           rom[ 0+5384] ='b01110100;
           rom[ 0+5385] ='b11101011;
           rom[ 0+5386] ='b00100001;
           rom[ 0+5387] ='b00000110;
           rom[ 0+5388] ='b00000000;
           rom[ 0+5389] ='b00111001;
           rom[ 0+5390] ='b11011101;
           rom[ 0+5391] ='b01110101;
           rom[ 0+5392] ='b11100110;
           rom[ 0+5393] ='b11011101;
           rom[ 0+5394] ='b01110100;
           rom[ 0+5395] ='b11100111;
           rom[ 0+5396] ='b11011101;
           rom[ 0+5397] ='b00110110;
           rom[ 0+5398] ='b11111110;
           rom[ 0+5399] ='b00000000;
           rom[ 0+5400] ='b11011101;
           rom[ 0+5401] ='b00110110;
           rom[ 0+5402] ='b11111111;
           rom[ 0+5403] ='b00000000;
           rom[ 0+5404] ='b11011101;
           rom[ 0+5405] ='b01111110;
           rom[ 0+5406] ='b11111110;
           rom[ 0+5407] ='b11010110;
           rom[ 0+5408] ='b00001000;
           rom[ 0+5409] ='b11011101;
           rom[ 0+5410] ='b01111110;
           rom[ 0+5411] ='b11111111;
           rom[ 0+5412] ='b11011110;
           rom[ 0+5413] ='b00000000;
           rom[ 0+5414] ='b11110010;
           rom[ 0+5415] ='b10101100;
           rom[ 0+5416] ='b00010101;
           rom[ 0+5417] ='b11011101;
           rom[ 0+5418] ='b01111110;
           rom[ 0+5419] ='b11101010;
           rom[ 0+5420] ='b11011101;
           rom[ 0+5421] ='b10000110;
           rom[ 0+5422] ='b11111110;
           rom[ 0+5423] ='b01011111;
           rom[ 0+5424] ='b11011101;
           rom[ 0+5425] ='b01111110;
           rom[ 0+5426] ='b11101011;
           rom[ 0+5427] ='b11011101;
           rom[ 0+5428] ='b10001110;
           rom[ 0+5429] ='b11111111;
           rom[ 0+5430] ='b01010111;
           rom[ 0+5431] ='b11011101;
           rom[ 0+5432] ='b01111110;
           rom[ 0+5433] ='b00000100;
           rom[ 0+5434] ='b11011101;
           rom[ 0+5435] ='b10000110;
           rom[ 0+5436] ='b11111110;
           rom[ 0+5437] ='b01001111;
           rom[ 0+5438] ='b11011101;
           rom[ 0+5439] ='b01111110;
           rom[ 0+5440] ='b00000101;
           rom[ 0+5441] ='b11011101;
           rom[ 0+5442] ='b10001110;
           rom[ 0+5443] ='b11111111;
           rom[ 0+5444] ='b01000111;
           rom[ 0+5445] ='b00001010;
           rom[ 0+5446] ='b01001111;
           rom[ 0+5447] ='b11011101;
           rom[ 0+5448] ='b10100110;
           rom[ 0+5449] ='b00000110;
           rom[ 0+5450] ='b00010010;
           rom[ 0+5451] ='b11011101;
           rom[ 0+5452] ='b01111110;
           rom[ 0+5453] ='b11100110;
           rom[ 0+5454] ='b11011101;
           rom[ 0+5455] ='b10000110;
           rom[ 0+5456] ='b11111110;
           rom[ 0+5457] ='b01001111;
           rom[ 0+5458] ='b11011101;
           rom[ 0+5459] ='b01111110;
           rom[ 0+5460] ='b11100111;
           rom[ 0+5461] ='b11011101;
           rom[ 0+5462] ='b10001110;
           rom[ 0+5463] ='b11111111;
           rom[ 0+5464] ='b01000111;
           rom[ 0+5465] ='b00111110;
           rom[ 0+5466] ='b00000000;
           rom[ 0+5467] ='b00000010;
           rom[ 0+5468] ='b11011101;
           rom[ 0+5469] ='b01110011;
           rom[ 0+5470] ='b11101000;
           rom[ 0+5471] ='b11011101;
           rom[ 0+5472] ='b01110010;
           rom[ 0+5473] ='b11101001;
           rom[ 0+5474] ='b11011101;
           rom[ 0+5475] ='b00110110;
           rom[ 0+5476] ='b11111100;
           rom[ 0+5477] ='b00000000;
           rom[ 0+5478] ='b11011101;
           rom[ 0+5479] ='b00110110;
           rom[ 0+5480] ='b11111101;
           rom[ 0+5481] ='b00000000;
           rom[ 0+5482] ='b11011101;
           rom[ 0+5483] ='b01111110;
           rom[ 0+5484] ='b11111100;
           rom[ 0+5485] ='b11010110;
           rom[ 0+5486] ='b00001000;
           rom[ 0+5487] ='b11011101;
           rom[ 0+5488] ='b01111110;
           rom[ 0+5489] ='b11111101;
           rom[ 0+5490] ='b11011110;
           rom[ 0+5491] ='b00000000;
           rom[ 0+5492] ='b11110010;
           rom[ 0+5493] ='b10100000;
           rom[ 0+5494] ='b00010101;
           rom[ 0+5495] ='b00001010;
           rom[ 0+5496] ='b01011111;
           rom[ 0+5497] ='b11011101;
           rom[ 0+5498] ='b01101110;
           rom[ 0+5499] ='b11101000;
           rom[ 0+5500] ='b11011101;
           rom[ 0+5501] ='b01100110;
           rom[ 0+5502] ='b11101001;
           rom[ 0+5503] ='b01010110;
           rom[ 0+5504] ='b11011101;
           rom[ 0+5505] ='b01111110;
           rom[ 0+5506] ='b11111100;
           rom[ 0+5507] ='b00111100;
           rom[ 0+5508] ='b11000011;
           rom[ 0+5509] ='b10001001;
           rom[ 0+5510] ='b00010101;
           rom[ 0+5511] ='b11001011;
           rom[ 0+5512] ='b00111010;
           rom[ 0+5513] ='b00111101;
           rom[ 0+5514] ='b11000010;
           rom[ 0+5515] ='b10000111;
           rom[ 0+5516] ='b00010101;
           rom[ 0+5517] ='b01111010;
           rom[ 0+5518] ='b11100110;
           rom[ 0+5519] ='b00000001;
           rom[ 0+5520] ='b01010111;
           rom[ 0+5521] ='b01111011;
           rom[ 0+5522] ='b10101010;
           rom[ 0+5523] ='b00000010;
           rom[ 0+5524] ='b11011101;
           rom[ 0+5525] ='b00110100;
           rom[ 0+5526] ='b11111100;
           rom[ 0+5527] ='b11000010;
           rom[ 0+5528] ='b10011101;
           rom[ 0+5529] ='b00010101;
           rom[ 0+5530] ='b11011101;
           rom[ 0+5531] ='b00110100;
           rom[ 0+5532] ='b11111101;
           rom[ 0+5533] ='b11000011;
           rom[ 0+5534] ='b01101010;
           rom[ 0+5535] ='b00010101;
           rom[ 0+5536] ='b11011101;
           rom[ 0+5537] ='b00110100;
           rom[ 0+5538] ='b11111110;
           rom[ 0+5539] ='b11000010;
           rom[ 0+5540] ='b10101001;
           rom[ 0+5541] ='b00010101;
           rom[ 0+5542] ='b11011101;
           rom[ 0+5543] ='b00110100;
           rom[ 0+5544] ='b11111111;
           rom[ 0+5545] ='b11000011;
           rom[ 0+5546] ='b00011100;
           rom[ 0+5547] ='b00010101;
           rom[ 0+5548] ='b00011110;
           rom[ 0+5549] ='b00000000;
           rom[ 0+5550] ='b11011101;
           rom[ 0+5551] ='b00110110;
           rom[ 0+5552] ='b11111110;
           rom[ 0+5553] ='b00000000;
           rom[ 0+5554] ='b11011101;
           rom[ 0+5555] ='b00110110;
           rom[ 0+5556] ='b11111111;
           rom[ 0+5557] ='b00000000;
           rom[ 0+5558] ='b11011101;
           rom[ 0+5559] ='b01111110;
           rom[ 0+5560] ='b11111110;
           rom[ 0+5561] ='b11010110;
           rom[ 0+5562] ='b00001000;
           rom[ 0+5563] ='b11011101;
           rom[ 0+5564] ='b01111110;
           rom[ 0+5565] ='b11111111;
           rom[ 0+5566] ='b11011110;
           rom[ 0+5567] ='b00000000;
           rom[ 0+5568] ='b11110010;
           rom[ 0+5569] ='b11111010;
           rom[ 0+5570] ='b00010101;
           rom[ 0+5571] ='b11011101;
           rom[ 0+5572] ='b01111110;
           rom[ 0+5573] ='b11100110;
           rom[ 0+5574] ='b11011101;
           rom[ 0+5575] ='b10000110;
           rom[ 0+5576] ='b11111110;
           rom[ 0+5577] ='b01000111;
           rom[ 0+5578] ='b11011101;
           rom[ 0+5579] ='b01111110;
           rom[ 0+5580] ='b11100111;
           rom[ 0+5581] ='b11011101;
           rom[ 0+5582] ='b10001110;
           rom[ 0+5583] ='b11111111;
           rom[ 0+5584] ='b01001111;
           rom[ 0+5585] ='b01101000;
           rom[ 0+5586] ='b01100001;
           rom[ 0+5587] ='b01000110;
           rom[ 0+5588] ='b00001110;
           rom[ 0+5589] ='b00000000;
           rom[ 0+5590] ='b11011101;
           rom[ 0+5591] ='b01111110;
           rom[ 0+5592] ='b11111110;
           rom[ 0+5593] ='b00111100;
           rom[ 0+5594] ='b11000011;
           rom[ 0+5595] ='b11100001;
           rom[ 0+5596] ='b00010101;
           rom[ 0+5597] ='b11001011;
           rom[ 0+5598] ='b00100000;
           rom[ 0+5599] ='b11001011;
           rom[ 0+5600] ='b00010001;
           rom[ 0+5601] ='b00111101;
           rom[ 0+5602] ='b11000010;
           rom[ 0+5603] ='b11011101;
           rom[ 0+5604] ='b00010101;
           rom[ 0+5605] ='b00010110;
           rom[ 0+5606] ='b00000000;
           rom[ 0+5607] ='b01111000;
           rom[ 0+5608] ='b10110011;
           rom[ 0+5609] ='b01000111;
           rom[ 0+5610] ='b01111001;
           rom[ 0+5611] ='b10110010;
           rom[ 0+5612] ='b01001111;
           rom[ 0+5613] ='b01011000;
           rom[ 0+5614] ='b11011101;
           rom[ 0+5615] ='b00110100;
           rom[ 0+5616] ='b11111110;
           rom[ 0+5617] ='b11000010;
           rom[ 0+5618] ='b11110111;
           rom[ 0+5619] ='b00010101;
           rom[ 0+5620] ='b11011101;
           rom[ 0+5621] ='b00110100;
           rom[ 0+5622] ='b11111111;
           rom[ 0+5623] ='b11000011;
           rom[ 0+5624] ='b10110110;
           rom[ 0+5625] ='b00010101;
           rom[ 0+5626] ='b01101011;
           rom[ 0+5627] ='b11011101;
           rom[ 0+5628] ='b11111001;
           rom[ 0+5629] ='b11011101;
           rom[ 0+5630] ='b11100001;
           rom[ 0+5631] ='b11001001;
           rom[ 0+5632] ='b11011101;
           rom[ 0+5633] ='b11100101;
           rom[ 0+5634] ='b11011101;
           rom[ 0+5635] ='b00100001;
           rom[ 0+5636] ='b00000000;
           rom[ 0+5637] ='b00000000;
           rom[ 0+5638] ='b11011101;
           rom[ 0+5639] ='b00111001;
           rom[ 0+5640] ='b00100001;
           rom[ 0+5641] ='b11111110;
           rom[ 0+5642] ='b11111111;
           rom[ 0+5643] ='b00111001;
           rom[ 0+5644] ='b11111001;
           rom[ 0+5645] ='b00000001;
           rom[ 0+5646] ='b00000101;
           rom[ 0+5647] ='b00000000;
           rom[ 0+5648] ='b00001011;
           rom[ 0+5649] ='b01011001;
           rom[ 0+5650] ='b01010000;
           rom[ 0+5651] ='b01101011;
           rom[ 0+5652] ='b01100010;
           rom[ 0+5653] ='b00101001;
           rom[ 0+5654] ='b00011001;
           rom[ 0+5655] ='b00101001;
           rom[ 0+5656] ='b00011001;
           rom[ 0+5657] ='b01011101;
           rom[ 0+5658] ='b01010100;
           rom[ 0+5659] ='b00100001;
           rom[ 0+5660] ='b00000110;
           rom[ 0+5661] ='b10010000;
           rom[ 0+5662] ='b00011001;
           rom[ 0+5663] ='b11011101;
           rom[ 0+5664] ='b01110101;
           rom[ 0+5665] ='b11111110;
           rom[ 0+5666] ='b11011101;
           rom[ 0+5667] ='b01110100;
           rom[ 0+5668] ='b11111111;
           rom[ 0+5669] ='b11011101;
           rom[ 0+5670] ='b01111110;
           rom[ 0+5671] ='b11111110;
           rom[ 0+5672] ='b11000110;
           rom[ 0+5673] ='b00000110;
           rom[ 0+5674] ='b01011111;
           rom[ 0+5675] ='b11011101;
           rom[ 0+5676] ='b01111110;
           rom[ 0+5677] ='b11111111;
           rom[ 0+5678] ='b11001110;
           rom[ 0+5679] ='b00000000;
           rom[ 0+5680] ='b01010111;
           rom[ 0+5681] ='b00111110;
           rom[ 0+5682] ='b00000000;
           rom[ 0+5683] ='b00010010;
           rom[ 0+5684] ='b11011101;
           rom[ 0+5685] ='b01111110;
           rom[ 0+5686] ='b11111110;
           rom[ 0+5687] ='b11000110;
           rom[ 0+5688] ='b00000101;
           rom[ 0+5689] ='b01011111;
           rom[ 0+5690] ='b11011101;
           rom[ 0+5691] ='b01111110;
           rom[ 0+5692] ='b11111111;
           rom[ 0+5693] ='b11001110;
           rom[ 0+5694] ='b00000000;
           rom[ 0+5695] ='b01010111;
           rom[ 0+5696] ='b00111110;
           rom[ 0+5697] ='b00000000;
           rom[ 0+5698] ='b00010010;
           rom[ 0+5699] ='b11011101;
           rom[ 0+5700] ='b01111110;
           rom[ 0+5701] ='b11111110;
           rom[ 0+5702] ='b11000110;
           rom[ 0+5703] ='b00000100;
           rom[ 0+5704] ='b01011111;
           rom[ 0+5705] ='b11011101;
           rom[ 0+5706] ='b01111110;
           rom[ 0+5707] ='b11111111;
           rom[ 0+5708] ='b11001110;
           rom[ 0+5709] ='b00000000;
           rom[ 0+5710] ='b01010111;
           rom[ 0+5711] ='b00111110;
           rom[ 0+5712] ='b00000000;
           rom[ 0+5713] ='b00010010;
           rom[ 0+5714] ='b11011101;
           rom[ 0+5715] ='b01111110;
           rom[ 0+5716] ='b11111110;
           rom[ 0+5717] ='b11000110;
           rom[ 0+5718] ='b00000011;
           rom[ 0+5719] ='b01011111;
           rom[ 0+5720] ='b11011101;
           rom[ 0+5721] ='b01111110;
           rom[ 0+5722] ='b11111111;
           rom[ 0+5723] ='b11001110;
           rom[ 0+5724] ='b00000000;
           rom[ 0+5725] ='b01010111;
           rom[ 0+5726] ='b00111110;
           rom[ 0+5727] ='b00000000;
           rom[ 0+5728] ='b00010010;
           rom[ 0+5729] ='b11011101;
           rom[ 0+5730] ='b01011110;
           rom[ 0+5731] ='b11111110;
           rom[ 0+5732] ='b11011101;
           rom[ 0+5733] ='b01010110;
           rom[ 0+5734] ='b11111111;
           rom[ 0+5735] ='b00010011;
           rom[ 0+5736] ='b00010011;
           rom[ 0+5737] ='b00111110;
           rom[ 0+5738] ='b00000000;
           rom[ 0+5739] ='b00010010;
           rom[ 0+5740] ='b11011101;
           rom[ 0+5741] ='b01011110;
           rom[ 0+5742] ='b11111110;
           rom[ 0+5743] ='b11011101;
           rom[ 0+5744] ='b01010110;
           rom[ 0+5745] ='b11111111;
           rom[ 0+5746] ='b00010011;
           rom[ 0+5747] ='b00111110;
           rom[ 0+5748] ='b00000000;
           rom[ 0+5749] ='b00010010;
           rom[ 0+5750] ='b11011101;
           rom[ 0+5751] ='b01101110;
           rom[ 0+5752] ='b11111110;
           rom[ 0+5753] ='b11011101;
           rom[ 0+5754] ='b01100110;
           rom[ 0+5755] ='b11111111;
           rom[ 0+5756] ='b00110110;
           rom[ 0+5757] ='b00000000;
           rom[ 0+5758] ='b01011001;
           rom[ 0+5759] ='b01010000;
           rom[ 0+5760] ='b01111001;
           rom[ 0+5761] ='b10110000;
           rom[ 0+5762] ='b11000010;
           rom[ 0+5763] ='b00010000;
           rom[ 0+5764] ='b00010110;
           rom[ 0+5765] ='b11011101;
           rom[ 0+5766] ='b11111001;
           rom[ 0+5767] ='b11011101;
           rom[ 0+5768] ='b11100001;
           rom[ 0+5769] ='b11001001;
           rom[ 0+5770] ='b11011101;
           rom[ 0+5771] ='b11100101;
           rom[ 0+5772] ='b11011101;
           rom[ 0+5773] ='b00100001;
           rom[ 0+5774] ='b00000000;
           rom[ 0+5775] ='b00000000;
           rom[ 0+5776] ='b11011101;
           rom[ 0+5777] ='b00111001;
           rom[ 0+5778] ='b00100001;
           rom[ 0+5779] ='b11111100;
           rom[ 0+5780] ='b11111111;
           rom[ 0+5781] ='b00111001;
           rom[ 0+5782] ='b11111001;
           rom[ 0+5783] ='b11011101;
           rom[ 0+5784] ='b00110110;
           rom[ 0+5785] ='b11111110;
           rom[ 0+5786] ='b00000000;
           rom[ 0+5787] ='b11011101;
           rom[ 0+5788] ='b00110110;
           rom[ 0+5789] ='b11111111;
           rom[ 0+5790] ='b00000000;
           rom[ 0+5791] ='b11011101;
           rom[ 0+5792] ='b00110110;
           rom[ 0+5793] ='b11111100;
           rom[ 0+5794] ='b00000000;
           rom[ 0+5795] ='b11011101;
           rom[ 0+5796] ='b00110110;
           rom[ 0+5797] ='b11111101;
           rom[ 0+5798] ='b00000000;
           rom[ 0+5799] ='b11011101;
           rom[ 0+5800] ='b01111110;
           rom[ 0+5801] ='b11111100;
           rom[ 0+5802] ='b11010110;
           rom[ 0+5803] ='b00101111;
           rom[ 0+5804] ='b11011101;
           rom[ 0+5805] ='b01111110;
           rom[ 0+5806] ='b11111101;
           rom[ 0+5807] ='b11011110;
           rom[ 0+5808] ='b00000000;
           rom[ 0+5809] ='b11110010;
           rom[ 0+5810] ='b11110010;
           rom[ 0+5811] ='b00010110;
           rom[ 0+5812] ='b00111110;
           rom[ 0+5813] ='b00011110;
           rom[ 0+5814] ='b11011101;
           rom[ 0+5815] ='b10000110;
           rom[ 0+5816] ='b11111100;
           rom[ 0+5817] ='b01001111;
           rom[ 0+5818] ='b00111110;
           rom[ 0+5819] ='b10001100;
           rom[ 0+5820] ='b11011101;
           rom[ 0+5821] ='b10001110;
           rom[ 0+5822] ='b11111101;
           rom[ 0+5823] ='b01000111;
           rom[ 0+5824] ='b00001010;
           rom[ 0+5825] ='b01001111;
           rom[ 0+5826] ='b00111110;
           rom[ 0+5827] ='b00110110;
           rom[ 0+5828] ='b11011101;
           rom[ 0+5829] ='b10000110;
           rom[ 0+5830] ='b11111100;
           rom[ 0+5831] ='b01000111;
           rom[ 0+5832] ='b00111110;
           rom[ 0+5833] ='b10001000;
           rom[ 0+5834] ='b11011101;
           rom[ 0+5835] ='b10001110;
           rom[ 0+5836] ='b11111101;
           rom[ 0+5837] ='b01011111;
           rom[ 0+5838] ='b01101000;
           rom[ 0+5839] ='b01100011;
           rom[ 0+5840] ='b01000110;
           rom[ 0+5841] ='b01111001;
           rom[ 0+5842] ='b10111000;
           rom[ 0+5843] ='b11001010;
           rom[ 0+5844] ='b11100110;
           rom[ 0+5845] ='b00010110;
           rom[ 0+5846] ='b00100001;
           rom[ 0+5847] ='b00001000;
           rom[ 0+5848] ='b00010111;
           rom[ 0+5849] ='b11100101;
           rom[ 0+5850] ='b11001101;
           rom[ 0+5851] ='b00001010;
           rom[ 0+5852] ='b00000010;
           rom[ 0+5853] ='b11110001;
           rom[ 0+5854] ='b11011101;
           rom[ 0+5855] ='b00110110;
           rom[ 0+5856] ='b11111110;
           rom[ 0+5857] ='b00000001;
           rom[ 0+5858] ='b11011101;
           rom[ 0+5859] ='b00110110;
           rom[ 0+5860] ='b11111111;
           rom[ 0+5861] ='b00000000;
           rom[ 0+5862] ='b11011101;
           rom[ 0+5863] ='b00110100;
           rom[ 0+5864] ='b11111100;
           rom[ 0+5865] ='b11000010;
           rom[ 0+5866] ='b11101111;
           rom[ 0+5867] ='b00010110;
           rom[ 0+5868] ='b11011101;
           rom[ 0+5869] ='b00110100;
           rom[ 0+5870] ='b11111101;
           rom[ 0+5871] ='b11000011;
           rom[ 0+5872] ='b10100111;
           rom[ 0+5873] ='b00010110;
           rom[ 0+5874] ='b11011101;
           rom[ 0+5875] ='b01111110;
           rom[ 0+5876] ='b11111110;
           rom[ 0+5877] ='b11011101;
           rom[ 0+5878] ='b10110110;
           rom[ 0+5879] ='b11111111;
           rom[ 0+5880] ='b11000010;
           rom[ 0+5881] ='b00000011;
           rom[ 0+5882] ='b00010111;
           rom[ 0+5883] ='b00100001;
           rom[ 0+5884] ='b00100001;
           rom[ 0+5885] ='b00010111;
           rom[ 0+5886] ='b11100101;
           rom[ 0+5887] ='b11001101;
           rom[ 0+5888] ='b00001010;
           rom[ 0+5889] ='b00000010;
           rom[ 0+5890] ='b11110001;
           rom[ 0+5891] ='b11011101;
           rom[ 0+5892] ='b11111001;
           rom[ 0+5893] ='b11011101;
           rom[ 0+5894] ='b11100001;
           rom[ 0+5895] ='b11001001;
           rom[ 0+5896] ='b01000011;
           rom[ 0+5897] ='b01101111;
           rom[ 0+5898] ='b01101101;
           rom[ 0+5899] ='b01110000;
           rom[ 0+5900] ='b01100001;
           rom[ 0+5901] ='b01110010;
           rom[ 0+5902] ='b01100101;
           rom[ 0+5903] ='b00100000;
           rom[ 0+5904] ='b01000101;
           rom[ 0+5905] ='b01110010;
           rom[ 0+5906] ='b01110010;
           rom[ 0+5907] ='b01101111;
           rom[ 0+5908] ='b01110010;
           rom[ 0+5909] ='b00100000;
           rom[ 0+5910] ='b01001111;
           rom[ 0+5911] ='b01100011;
           rom[ 0+5912] ='b01100011;
           rom[ 0+5913] ='b01110101;
           rom[ 0+5914] ='b01110010;
           rom[ 0+5915] ='b01110010;
           rom[ 0+5916] ='b01100101;
           rom[ 0+5917] ='b01100100;
           rom[ 0+5918] ='b00101110;
           rom[ 0+5919] ='b00001010;
           rom[ 0+5920] ='b00000000;
           rom[ 0+5921] ='b01000011;
           rom[ 0+5922] ='b01101111;
           rom[ 0+5923] ='b01101101;
           rom[ 0+5924] ='b01110000;
           rom[ 0+5925] ='b01100001;
           rom[ 0+5926] ='b01110010;
           rom[ 0+5927] ='b01100101;
           rom[ 0+5928] ='b00100000;
           rom[ 0+5929] ='b01000100;
           rom[ 0+5930] ='b01101111;
           rom[ 0+5931] ='b01101110;
           rom[ 0+5932] ='b01100101;
           rom[ 0+5933] ='b00100000;
           rom[ 0+5934] ='b01110011;
           rom[ 0+5935] ='b01110101;
           rom[ 0+5936] ='b01100011;
           rom[ 0+5937] ='b01100011;
           rom[ 0+5938] ='b01100101;
           rom[ 0+5939] ='b01110011;
           rom[ 0+5940] ='b01110011;
           rom[ 0+5941] ='b01100110;
           rom[ 0+5942] ='b01110101;
           rom[ 0+5943] ='b01101100;
           rom[ 0+5944] ='b01101100;
           rom[ 0+5945] ='b01111001;
           rom[ 0+5946] ='b00001010;
           rom[ 0+5947] ='b00000000;
           rom[ 0+5948] ='b11011101;
           rom[ 0+5949] ='b11100101;
           rom[ 0+5950] ='b11011101;
           rom[ 0+5951] ='b00100001;
           rom[ 0+5952] ='b00000000;
           rom[ 0+5953] ='b00000000;
           rom[ 0+5954] ='b11011101;
           rom[ 0+5955] ='b00111001;
           rom[ 0+5956] ='b00100001;
           rom[ 0+5957] ='b11111001;
           rom[ 0+5958] ='b11111111;
           rom[ 0+5959] ='b00111001;
           rom[ 0+5960] ='b11111001;
           rom[ 0+5961] ='b11011101;
           rom[ 0+5962] ='b01011110;
           rom[ 0+5963] ='b00000100;
           rom[ 0+5964] ='b11011101;
           rom[ 0+5965] ='b01010110;
           rom[ 0+5966] ='b00000101;
           rom[ 0+5967] ='b01101011;
           rom[ 0+5968] ='b01100010;
           rom[ 0+5969] ='b00101001;
           rom[ 0+5970] ='b00011001;
           rom[ 0+5971] ='b00101001;
           rom[ 0+5972] ='b00011001;
           rom[ 0+5973] ='b01001101;
           rom[ 0+5974] ='b01000100;
           rom[ 0+5975] ='b00100001;
           rom[ 0+5976] ='b00000110;
           rom[ 0+5977] ='b10010000;
           rom[ 0+5978] ='b00001001;
           rom[ 0+5979] ='b01001101;
           rom[ 0+5980] ='b01000100;
           rom[ 0+5981] ='b01111001;
           rom[ 0+5982] ='b11000110;
           rom[ 0+5983] ='b00000110;
           rom[ 0+5984] ='b11011101;
           rom[ 0+5985] ='b01110111;
           rom[ 0+5986] ='b11111101;
           rom[ 0+5987] ='b01111000;
           rom[ 0+5988] ='b11001110;
           rom[ 0+5989] ='b00000000;
           rom[ 0+5990] ='b11011101;
           rom[ 0+5991] ='b01110111;
           rom[ 0+5992] ='b11111110;
           rom[ 0+5993] ='b11011101;
           rom[ 0+5994] ='b01101110;
           rom[ 0+5995] ='b11111101;
           rom[ 0+5996] ='b11011101;
           rom[ 0+5997] ='b01100110;
           rom[ 0+5998] ='b11111110;
           rom[ 0+5999] ='b01011110;
           rom[ 0+6000] ='b01111011;
           rom[ 0+6001] ='b11011101;
           rom[ 0+6002] ='b10101110;
           rom[ 0+6003] ='b00000110;
           rom[ 0+6004] ='b01011111;
           rom[ 0+6005] ='b11011101;
           rom[ 0+6006] ='b01110011;
           rom[ 0+6007] ='b11111111;
           rom[ 0+6008] ='b00111110;
           rom[ 0+6009] ='b10011100;
           rom[ 0+6010] ='b11011101;
           rom[ 0+6011] ='b10000110;
           rom[ 0+6012] ='b11111111;
           rom[ 0+6013] ='b01010111;
           rom[ 0+6014] ='b00111110;
           rom[ 0+6015] ='b00001101;
           rom[ 0+6016] ='b11001110;
           rom[ 0+6017] ='b00000000;
           rom[ 0+6018] ='b01011111;
           rom[ 0+6019] ='b01101010;
           rom[ 0+6020] ='b01100011;
           rom[ 0+6021] ='b01010110;
           rom[ 0+6022] ='b01111001;
           rom[ 0+6023] ='b11000110;
           rom[ 0+6024] ='b00000101;
           rom[ 0+6025] ='b11011101;
           rom[ 0+6026] ='b01110111;
           rom[ 0+6027] ='b11111011;
           rom[ 0+6028] ='b01111000;
           rom[ 0+6029] ='b11001110;
           rom[ 0+6030] ='b00000000;
           rom[ 0+6031] ='b11011101;
           rom[ 0+6032] ='b01110111;
           rom[ 0+6033] ='b11111100;
           rom[ 0+6034] ='b11011101;
           rom[ 0+6035] ='b01101110;
           rom[ 0+6036] ='b11111011;
           rom[ 0+6037] ='b11011101;
           rom[ 0+6038] ='b01100110;
           rom[ 0+6039] ='b11111100;
           rom[ 0+6040] ='b01011110;
           rom[ 0+6041] ='b01111010;
           rom[ 0+6042] ='b10101011;
           rom[ 0+6043] ='b11011101;
           rom[ 0+6044] ='b01101110;
           rom[ 0+6045] ='b11111101;
           rom[ 0+6046] ='b11011101;
           rom[ 0+6047] ='b01100110;
           rom[ 0+6048] ='b11111110;
           rom[ 0+6049] ='b01110111;
           rom[ 0+6050] ='b00111110;
           rom[ 0+6051] ='b10011100;
           rom[ 0+6052] ='b11011101;
           rom[ 0+6053] ='b10000110;
           rom[ 0+6054] ='b11111111;
           rom[ 0+6055] ='b01011111;
           rom[ 0+6056] ='b00111110;
           rom[ 0+6057] ='b00001100;
           rom[ 0+6058] ='b11001110;
           rom[ 0+6059] ='b00000000;
           rom[ 0+6060] ='b01010111;
           rom[ 0+6061] ='b00011010;
           rom[ 0+6062] ='b01010111;
           rom[ 0+6063] ='b01111001;
           rom[ 0+6064] ='b11000110;
           rom[ 0+6065] ='b00000100;
           rom[ 0+6066] ='b11011101;
           rom[ 0+6067] ='b01110111;
           rom[ 0+6068] ='b11111101;
           rom[ 0+6069] ='b01111000;
           rom[ 0+6070] ='b11001110;
           rom[ 0+6071] ='b00000000;
           rom[ 0+6072] ='b11011101;
           rom[ 0+6073] ='b01110111;
           rom[ 0+6074] ='b11111110;
           rom[ 0+6075] ='b11011101;
           rom[ 0+6076] ='b01101110;
           rom[ 0+6077] ='b11111101;
           rom[ 0+6078] ='b11011101;
           rom[ 0+6079] ='b01100110;
           rom[ 0+6080] ='b11111110;
           rom[ 0+6081] ='b01011110;
           rom[ 0+6082] ='b01111010;
           rom[ 0+6083] ='b10101011;
           rom[ 0+6084] ='b11011101;
           rom[ 0+6085] ='b01101110;
           rom[ 0+6086] ='b11111011;
           rom[ 0+6087] ='b11011101;
           rom[ 0+6088] ='b01100110;
           rom[ 0+6089] ='b11111100;
           rom[ 0+6090] ='b01110111;
           rom[ 0+6091] ='b00111110;
           rom[ 0+6092] ='b10011100;
           rom[ 0+6093] ='b11011101;
           rom[ 0+6094] ='b10000110;
           rom[ 0+6095] ='b11111111;
           rom[ 0+6096] ='b01011111;
           rom[ 0+6097] ='b00111110;
           rom[ 0+6098] ='b00001011;
           rom[ 0+6099] ='b11001110;
           rom[ 0+6100] ='b00000000;
           rom[ 0+6101] ='b01010111;
           rom[ 0+6102] ='b00011010;
           rom[ 0+6103] ='b01010111;
           rom[ 0+6104] ='b01111001;
           rom[ 0+6105] ='b11000110;
           rom[ 0+6106] ='b00000011;
           rom[ 0+6107] ='b11011101;
           rom[ 0+6108] ='b01110111;
           rom[ 0+6109] ='b11111001;
           rom[ 0+6110] ='b01111000;
           rom[ 0+6111] ='b11001110;
           rom[ 0+6112] ='b00000000;
           rom[ 0+6113] ='b11011101;
           rom[ 0+6114] ='b01110111;
           rom[ 0+6115] ='b11111010;
           rom[ 0+6116] ='b11011101;
           rom[ 0+6117] ='b01101110;
           rom[ 0+6118] ='b11111001;
           rom[ 0+6119] ='b11011101;
           rom[ 0+6120] ='b01100110;
           rom[ 0+6121] ='b11111010;
           rom[ 0+6122] ='b01011110;
           rom[ 0+6123] ='b01111010;
           rom[ 0+6124] ='b10101011;
           rom[ 0+6125] ='b11011101;
           rom[ 0+6126] ='b01101110;
           rom[ 0+6127] ='b11111101;
           rom[ 0+6128] ='b11011101;
           rom[ 0+6129] ='b01100110;
           rom[ 0+6130] ='b11111110;
           rom[ 0+6131] ='b01110111;
           rom[ 0+6132] ='b00111110;
           rom[ 0+6133] ='b10011100;
           rom[ 0+6134] ='b11011101;
           rom[ 0+6135] ='b10000110;
           rom[ 0+6136] ='b11111111;
           rom[ 0+6137] ='b01011111;
           rom[ 0+6138] ='b00111110;
           rom[ 0+6139] ='b00001010;
           rom[ 0+6140] ='b11001110;
           rom[ 0+6141] ='b00000000;
           rom[ 0+6142] ='b01010111;
           rom[ 0+6143] ='b00011010;
           rom[ 0+6144] ='b01010111;
           rom[ 0+6145] ='b01111001;
           rom[ 0+6146] ='b11000110;
           rom[ 0+6147] ='b00000010;
           rom[ 0+6148] ='b11011101;
           rom[ 0+6149] ='b01110111;
           rom[ 0+6150] ='b11111101;
           rom[ 0+6151] ='b01111000;
           rom[ 0+6152] ='b11001110;
           rom[ 0+6153] ='b00000000;
           rom[ 0+6154] ='b11011101;
           rom[ 0+6155] ='b01110111;
           rom[ 0+6156] ='b11111110;
           rom[ 0+6157] ='b11011101;
           rom[ 0+6158] ='b01101110;
           rom[ 0+6159] ='b11111101;
           rom[ 0+6160] ='b11011101;
           rom[ 0+6161] ='b01100110;
           rom[ 0+6162] ='b11111110;
           rom[ 0+6163] ='b01011110;
           rom[ 0+6164] ='b01111010;
           rom[ 0+6165] ='b10101011;
           rom[ 0+6166] ='b11011101;
           rom[ 0+6167] ='b01101110;
           rom[ 0+6168] ='b11111001;
           rom[ 0+6169] ='b11011101;
           rom[ 0+6170] ='b01100110;
           rom[ 0+6171] ='b11111010;
           rom[ 0+6172] ='b01110111;
           rom[ 0+6173] ='b00111110;
           rom[ 0+6174] ='b10011100;
           rom[ 0+6175] ='b11011101;
           rom[ 0+6176] ='b10000110;
           rom[ 0+6177] ='b11111111;
           rom[ 0+6178] ='b01011111;
           rom[ 0+6179] ='b00111110;
           rom[ 0+6180] ='b00001001;
           rom[ 0+6181] ='b11001110;
           rom[ 0+6182] ='b00000000;
           rom[ 0+6183] ='b01010111;
           rom[ 0+6184] ='b00011010;
           rom[ 0+6185] ='b01010111;
           rom[ 0+6186] ='b01111001;
           rom[ 0+6187] ='b11000110;
           rom[ 0+6188] ='b00000001;
           rom[ 0+6189] ='b11011101;
           rom[ 0+6190] ='b01110111;
           rom[ 0+6191] ='b11111011;
           rom[ 0+6192] ='b01111000;
           rom[ 0+6193] ='b11001110;
           rom[ 0+6194] ='b00000000;
           rom[ 0+6195] ='b11011101;
           rom[ 0+6196] ='b01110111;
           rom[ 0+6197] ='b11111100;
           rom[ 0+6198] ='b11011101;
           rom[ 0+6199] ='b01101110;
           rom[ 0+6200] ='b11111011;
           rom[ 0+6201] ='b11011101;
           rom[ 0+6202] ='b01100110;
           rom[ 0+6203] ='b11111100;
           rom[ 0+6204] ='b01011110;
           rom[ 0+6205] ='b01111010;
           rom[ 0+6206] ='b10101011;
           rom[ 0+6207] ='b11011101;
           rom[ 0+6208] ='b01101110;
           rom[ 0+6209] ='b11111101;
           rom[ 0+6210] ='b11011101;
           rom[ 0+6211] ='b01100110;
           rom[ 0+6212] ='b11111110;
           rom[ 0+6213] ='b01110111;
           rom[ 0+6214] ='b00111110;
           rom[ 0+6215] ='b10011100;
           rom[ 0+6216] ='b11011101;
           rom[ 0+6217] ='b10000110;
           rom[ 0+6218] ='b11111111;
           rom[ 0+6219] ='b01011111;
           rom[ 0+6220] ='b00111110;
           rom[ 0+6221] ='b00001000;
           rom[ 0+6222] ='b11001110;
           rom[ 0+6223] ='b00000000;
           rom[ 0+6224] ='b01010111;
           rom[ 0+6225] ='b00011010;
           rom[ 0+6226] ='b01011111;
           rom[ 0+6227] ='b00001010;
           rom[ 0+6228] ='b01010111;
           rom[ 0+6229] ='b01111011;
           rom[ 0+6230] ='b10101010;
           rom[ 0+6231] ='b11011101;
           rom[ 0+6232] ='b01101110;
           rom[ 0+6233] ='b11111011;
           rom[ 0+6234] ='b11011101;
           rom[ 0+6235] ='b01100110;
           rom[ 0+6236] ='b11111100;
           rom[ 0+6237] ='b01110111;
           rom[ 0+6238] ='b00111110;
           rom[ 0+6239] ='b10011100;
           rom[ 0+6240] ='b11011101;
           rom[ 0+6241] ='b10000110;
           rom[ 0+6242] ='b11111111;
           rom[ 0+6243] ='b01011111;
           rom[ 0+6244] ='b00111110;
           rom[ 0+6245] ='b00000111;
           rom[ 0+6246] ='b11001110;
           rom[ 0+6247] ='b00000000;
           rom[ 0+6248] ='b01010111;
           rom[ 0+6249] ='b00011010;
           rom[ 0+6250] ='b00000010;
           rom[ 0+6251] ='b11011101;
           rom[ 0+6252] ='b11111001;
           rom[ 0+6253] ='b11011101;
           rom[ 0+6254] ='b11100001;
           rom[ 0+6255] ='b11001001;
           rom[ 0+6256] ='b11011101;
           rom[ 0+6257] ='b11100101;
           rom[ 0+6258] ='b11011101;
           rom[ 0+6259] ='b00100001;
           rom[ 0+6260] ='b00000000;
           rom[ 0+6261] ='b00000000;
           rom[ 0+6262] ='b11011101;
           rom[ 0+6263] ='b00111001;
           rom[ 0+6264] ='b00100001;
           rom[ 0+6265] ='b11111110;
           rom[ 0+6266] ='b11111111;
           rom[ 0+6267] ='b00111001;
           rom[ 0+6268] ='b11111001;
           rom[ 0+6269] ='b11011101;
           rom[ 0+6270] ='b01011110;
           rom[ 0+6271] ='b00000100;
           rom[ 0+6272] ='b11011101;
           rom[ 0+6273] ='b01010110;
           rom[ 0+6274] ='b00000101;
           rom[ 0+6275] ='b01101011;
           rom[ 0+6276] ='b01100010;
           rom[ 0+6277] ='b00101001;
           rom[ 0+6278] ='b00011001;
           rom[ 0+6279] ='b00101001;
           rom[ 0+6280] ='b00011001;
           rom[ 0+6281] ='b01001101;
           rom[ 0+6282] ='b01000100;
           rom[ 0+6283] ='b00100001;
           rom[ 0+6284] ='b00000110;
           rom[ 0+6285] ='b10010000;
           rom[ 0+6286] ='b00001001;
           rom[ 0+6287] ='b01001101;
           rom[ 0+6288] ='b01000100;
           rom[ 0+6289] ='b00001010;
           rom[ 0+6290] ='b01011111;
           rom[ 0+6291] ='b11011101;
           rom[ 0+6292] ='b01111110;
           rom[ 0+6293] ='b00000110;
           rom[ 0+6294] ='b10101011;
           rom[ 0+6295] ='b00000010;
           rom[ 0+6296] ='b01111001;
           rom[ 0+6297] ='b11000110;
           rom[ 0+6298] ='b00000001;
           rom[ 0+6299] ='b11011101;
           rom[ 0+6300] ='b01110111;
           rom[ 0+6301] ='b11111110;
           rom[ 0+6302] ='b01111000;
           rom[ 0+6303] ='b11001110;
           rom[ 0+6304] ='b00000000;
           rom[ 0+6305] ='b11011101;
           rom[ 0+6306] ='b01110111;
           rom[ 0+6307] ='b11111111;
           rom[ 0+6308] ='b11011101;
           rom[ 0+6309] ='b01101110;
           rom[ 0+6310] ='b11111110;
           rom[ 0+6311] ='b11011101;
           rom[ 0+6312] ='b01100110;
           rom[ 0+6313] ='b11111111;
           rom[ 0+6314] ='b01011110;
           rom[ 0+6315] ='b00111110;
           rom[ 0+6316] ='b10011100;
           rom[ 0+6317] ='b10000011;
           rom[ 0+6318] ='b01011111;
           rom[ 0+6319] ='b00111110;
           rom[ 0+6320] ='b00001110;
           rom[ 0+6321] ='b11001110;
           rom[ 0+6322] ='b00000000;
           rom[ 0+6323] ='b01010111;
           rom[ 0+6324] ='b00011010;
           rom[ 0+6325] ='b01011111;
           rom[ 0+6326] ='b11011101;
           rom[ 0+6327] ='b01111110;
           rom[ 0+6328] ='b00000110;
           rom[ 0+6329] ='b10101011;
           rom[ 0+6330] ='b11011101;
           rom[ 0+6331] ='b01101110;
           rom[ 0+6332] ='b11111110;
           rom[ 0+6333] ='b11011101;
           rom[ 0+6334] ='b01100110;
           rom[ 0+6335] ='b11111111;
           rom[ 0+6336] ='b01110111;
           rom[ 0+6337] ='b01111001;
           rom[ 0+6338] ='b11000110;
           rom[ 0+6339] ='b00000010;
           rom[ 0+6340] ='b11011101;
           rom[ 0+6341] ='b01110111;
           rom[ 0+6342] ='b11111110;
           rom[ 0+6343] ='b01111000;
           rom[ 0+6344] ='b11001110;
           rom[ 0+6345] ='b00000000;
           rom[ 0+6346] ='b11011101;
           rom[ 0+6347] ='b01110111;
           rom[ 0+6348] ='b11111111;
           rom[ 0+6349] ='b11011101;
           rom[ 0+6350] ='b01101110;
           rom[ 0+6351] ='b11111110;
           rom[ 0+6352] ='b11011101;
           rom[ 0+6353] ='b01100110;
           rom[ 0+6354] ='b11111111;
           rom[ 0+6355] ='b01011110;
           rom[ 0+6356] ='b00111110;
           rom[ 0+6357] ='b10011100;
           rom[ 0+6358] ='b10000011;
           rom[ 0+6359] ='b01011111;
           rom[ 0+6360] ='b00111110;
           rom[ 0+6361] ='b00001111;
           rom[ 0+6362] ='b11001110;
           rom[ 0+6363] ='b00000000;
           rom[ 0+6364] ='b01010111;
           rom[ 0+6365] ='b00011010;
           rom[ 0+6366] ='b01011111;
           rom[ 0+6367] ='b11011101;
           rom[ 0+6368] ='b01111110;
           rom[ 0+6369] ='b00000110;
           rom[ 0+6370] ='b10101011;
           rom[ 0+6371] ='b11011101;
           rom[ 0+6372] ='b01101110;
           rom[ 0+6373] ='b11111110;
           rom[ 0+6374] ='b11011101;
           rom[ 0+6375] ='b01100110;
           rom[ 0+6376] ='b11111111;
           rom[ 0+6377] ='b01110111;
           rom[ 0+6378] ='b01111001;
           rom[ 0+6379] ='b11000110;
           rom[ 0+6380] ='b00000011;
           rom[ 0+6381] ='b11011101;
           rom[ 0+6382] ='b01110111;
           rom[ 0+6383] ='b11111110;
           rom[ 0+6384] ='b01111000;
           rom[ 0+6385] ='b11001110;
           rom[ 0+6386] ='b00000000;
           rom[ 0+6387] ='b11011101;
           rom[ 0+6388] ='b01110111;
           rom[ 0+6389] ='b11111111;
           rom[ 0+6390] ='b11011101;
           rom[ 0+6391] ='b01101110;
           rom[ 0+6392] ='b11111110;
           rom[ 0+6393] ='b11011101;
           rom[ 0+6394] ='b01100110;
           rom[ 0+6395] ='b11111111;
           rom[ 0+6396] ='b01011110;
           rom[ 0+6397] ='b00111110;
           rom[ 0+6398] ='b10011100;
           rom[ 0+6399] ='b10000011;
           rom[ 0+6400] ='b01011111;
           rom[ 0+6401] ='b00111110;
           rom[ 0+6402] ='b00010000;
           rom[ 0+6403] ='b11001110;
           rom[ 0+6404] ='b00000000;
           rom[ 0+6405] ='b01010111;
           rom[ 0+6406] ='b00011010;
           rom[ 0+6407] ='b01011111;
           rom[ 0+6408] ='b11011101;
           rom[ 0+6409] ='b01111110;
           rom[ 0+6410] ='b00000110;
           rom[ 0+6411] ='b10101011;
           rom[ 0+6412] ='b11011101;
           rom[ 0+6413] ='b01101110;
           rom[ 0+6414] ='b11111110;
           rom[ 0+6415] ='b11011101;
           rom[ 0+6416] ='b01100110;
           rom[ 0+6417] ='b11111111;
           rom[ 0+6418] ='b01110111;
           rom[ 0+6419] ='b01111001;
           rom[ 0+6420] ='b11000110;
           rom[ 0+6421] ='b00000100;
           rom[ 0+6422] ='b11011101;
           rom[ 0+6423] ='b01110111;
           rom[ 0+6424] ='b11111110;
           rom[ 0+6425] ='b01111000;
           rom[ 0+6426] ='b11001110;
           rom[ 0+6427] ='b00000000;
           rom[ 0+6428] ='b11011101;
           rom[ 0+6429] ='b01110111;
           rom[ 0+6430] ='b11111111;
           rom[ 0+6431] ='b11011101;
           rom[ 0+6432] ='b01101110;
           rom[ 0+6433] ='b11111110;
           rom[ 0+6434] ='b11011101;
           rom[ 0+6435] ='b01100110;
           rom[ 0+6436] ='b11111111;
           rom[ 0+6437] ='b01011110;
           rom[ 0+6438] ='b00111110;
           rom[ 0+6439] ='b10011100;
           rom[ 0+6440] ='b10000011;
           rom[ 0+6441] ='b01011111;
           rom[ 0+6442] ='b00111110;
           rom[ 0+6443] ='b00010001;
           rom[ 0+6444] ='b11001110;
           rom[ 0+6445] ='b00000000;
           rom[ 0+6446] ='b01010111;
           rom[ 0+6447] ='b00011010;
           rom[ 0+6448] ='b01011111;
           rom[ 0+6449] ='b11011101;
           rom[ 0+6450] ='b01111110;
           rom[ 0+6451] ='b00000110;
           rom[ 0+6452] ='b10101011;
           rom[ 0+6453] ='b11011101;
           rom[ 0+6454] ='b01101110;
           rom[ 0+6455] ='b11111110;
           rom[ 0+6456] ='b11011101;
           rom[ 0+6457] ='b01100110;
           rom[ 0+6458] ='b11111111;
           rom[ 0+6459] ='b01110111;
           rom[ 0+6460] ='b01111001;
           rom[ 0+6461] ='b11000110;
           rom[ 0+6462] ='b00000101;
           rom[ 0+6463] ='b11011101;
           rom[ 0+6464] ='b01110111;
           rom[ 0+6465] ='b11111110;
           rom[ 0+6466] ='b01111000;
           rom[ 0+6467] ='b11001110;
           rom[ 0+6468] ='b00000000;
           rom[ 0+6469] ='b11011101;
           rom[ 0+6470] ='b01110111;
           rom[ 0+6471] ='b11111111;
           rom[ 0+6472] ='b11011101;
           rom[ 0+6473] ='b01101110;
           rom[ 0+6474] ='b11111110;
           rom[ 0+6475] ='b11011101;
           rom[ 0+6476] ='b01100110;
           rom[ 0+6477] ='b11111111;
           rom[ 0+6478] ='b01011110;
           rom[ 0+6479] ='b00111110;
           rom[ 0+6480] ='b10011100;
           rom[ 0+6481] ='b10000011;
           rom[ 0+6482] ='b01011111;
           rom[ 0+6483] ='b00111110;
           rom[ 0+6484] ='b00010010;
           rom[ 0+6485] ='b11001110;
           rom[ 0+6486] ='b00000000;
           rom[ 0+6487] ='b01010111;
           rom[ 0+6488] ='b00011010;
           rom[ 0+6489] ='b01011111;
           rom[ 0+6490] ='b11011101;
           rom[ 0+6491] ='b01111110;
           rom[ 0+6492] ='b00000110;
           rom[ 0+6493] ='b10101011;
           rom[ 0+6494] ='b11011101;
           rom[ 0+6495] ='b01101110;
           rom[ 0+6496] ='b11111110;
           rom[ 0+6497] ='b11011101;
           rom[ 0+6498] ='b01100110;
           rom[ 0+6499] ='b11111111;
           rom[ 0+6500] ='b01110111;
           rom[ 0+6501] ='b01111001;
           rom[ 0+6502] ='b11000110;
           rom[ 0+6503] ='b00000110;
           rom[ 0+6504] ='b01001111;
           rom[ 0+6505] ='b01111000;
           rom[ 0+6506] ='b11001110;
           rom[ 0+6507] ='b00000000;
           rom[ 0+6508] ='b01000111;
           rom[ 0+6509] ='b00001010;
           rom[ 0+6510] ='b01011111;
           rom[ 0+6511] ='b00111110;
           rom[ 0+6512] ='b10011100;
           rom[ 0+6513] ='b10000011;
           rom[ 0+6514] ='b01011111;
           rom[ 0+6515] ='b00111110;
           rom[ 0+6516] ='b00010011;
           rom[ 0+6517] ='b11001110;
           rom[ 0+6518] ='b00000000;
           rom[ 0+6519] ='b01010111;
           rom[ 0+6520] ='b00011010;
           rom[ 0+6521] ='b01011111;
           rom[ 0+6522] ='b11011101;
           rom[ 0+6523] ='b01111110;
           rom[ 0+6524] ='b00000110;
           rom[ 0+6525] ='b10101011;
           rom[ 0+6526] ='b00000010;
           rom[ 0+6527] ='b11011101;
           rom[ 0+6528] ='b11111001;
           rom[ 0+6529] ='b11011101;
           rom[ 0+6530] ='b11100001;
           rom[ 0+6531] ='b11001001;
           rom[ 0+6532] ='b11011101;
           rom[ 0+6533] ='b11100101;
           rom[ 0+6534] ='b11011101;
           rom[ 0+6535] ='b00100001;
           rom[ 0+6536] ='b00000000;
           rom[ 0+6537] ='b00000000;
           rom[ 0+6538] ='b11011101;
           rom[ 0+6539] ='b00111001;
           rom[ 0+6540] ='b11011101;
           rom[ 0+6541] ='b01001110;
           rom[ 0+6542] ='b00000110;
           rom[ 0+6543] ='b01111001;
           rom[ 0+6544] ='b11110101;
           rom[ 0+6545] ='b00110011;
           rom[ 0+6546] ='b01111001;
           rom[ 0+6547] ='b11110101;
           rom[ 0+6548] ='b00110011;
           rom[ 0+6549] ='b11001101;
           rom[ 0+6550] ='b10111100;
           rom[ 0+6551] ='b00011001;
           rom[ 0+6552] ='b01001101;
           rom[ 0+6553] ='b11110001;
           rom[ 0+6554] ='b11011101;
           rom[ 0+6555] ='b01111110;
           rom[ 0+6556] ='b00000100;
           rom[ 0+6557] ='b11011101;
           rom[ 0+6558] ='b10111110;
           rom[ 0+6559] ='b00000110;
           rom[ 0+6560] ='b11000010;
           rom[ 0+6561] ='b10110001;
           rom[ 0+6562] ='b00011001;
           rom[ 0+6563] ='b11011101;
           rom[ 0+6564] ='b01111110;
           rom[ 0+6565] ='b00000101;
           rom[ 0+6566] ='b11011101;
           rom[ 0+6567] ='b10111110;
           rom[ 0+6568] ='b00000111;
           rom[ 0+6569] ='b11000010;
           rom[ 0+6570] ='b10110001;
           rom[ 0+6571] ='b00011001;
           rom[ 0+6572] ='b00111110;
           rom[ 0+6573] ='b00000001;
           rom[ 0+6574] ='b11000011;
           rom[ 0+6575] ='b10110010;
           rom[ 0+6576] ='b00011001;
           rom[ 0+6577] ='b10101111;
           rom[ 0+6578] ='b01000111;
           rom[ 0+6579] ='b01111001;
           rom[ 0+6580] ='b10101000;
           rom[ 0+6581] ='b01001111;
           rom[ 0+6582] ='b01101001;
           rom[ 0+6583] ='b00100110;
           rom[ 0+6584] ='b00000000;
           rom[ 0+6585] ='b11011101;
           rom[ 0+6586] ='b11100001;
           rom[ 0+6587] ='b11001001;
           rom[ 0+6588] ='b11011101;
           rom[ 0+6589] ='b11100101;
           rom[ 0+6590] ='b11011101;
           rom[ 0+6591] ='b00100001;
           rom[ 0+6592] ='b00000000;
           rom[ 0+6593] ='b00000000;
           rom[ 0+6594] ='b11011101;
           rom[ 0+6595] ='b00111001;
           rom[ 0+6596] ='b00100001;
           rom[ 0+6597] ='b11001111;
           rom[ 0+6598] ='b11111111;
           rom[ 0+6599] ='b00111001;
           rom[ 0+6600] ='b11111001;
           rom[ 0+6601] ='b11011101;
           rom[ 0+6602] ='b01111110;
           rom[ 0+6603] ='b00000100;
           rom[ 0+6604] ='b11100110;
           rom[ 0+6605] ='b00000001;
           rom[ 0+6606] ='b11011101;
           rom[ 0+6607] ='b01110111;
           rom[ 0+6608] ='b11111111;
           rom[ 0+6609] ='b11011101;
           rom[ 0+6610] ='b01000110;
           rom[ 0+6611] ='b00000100;
           rom[ 0+6612] ='b11001011;
           rom[ 0+6613] ='b00111000;
           rom[ 0+6614] ='b01111000;
           rom[ 0+6615] ='b11100110;
           rom[ 0+6616] ='b00000001;
           rom[ 0+6617] ='b11011101;
           rom[ 0+6618] ='b01110111;
           rom[ 0+6619] ='b11111110;
           rom[ 0+6620] ='b11011101;
           rom[ 0+6621] ='b01011110;
           rom[ 0+6622] ='b00000100;
           rom[ 0+6623] ='b11001011;
           rom[ 0+6624] ='b00111011;
           rom[ 0+6625] ='b11001011;
           rom[ 0+6626] ='b00111011;
           rom[ 0+6627] ='b01111011;
           rom[ 0+6628] ='b11100110;
           rom[ 0+6629] ='b00000001;
           rom[ 0+6630] ='b11011101;
           rom[ 0+6631] ='b01110111;
           rom[ 0+6632] ='b11111101;
           rom[ 0+6633] ='b11011101;
           rom[ 0+6634] ='b01010110;
           rom[ 0+6635] ='b00000100;
           rom[ 0+6636] ='b11001011;
           rom[ 0+6637] ='b00111010;
           rom[ 0+6638] ='b11001011;
           rom[ 0+6639] ='b00111010;
           rom[ 0+6640] ='b11001011;
           rom[ 0+6641] ='b00111010;
           rom[ 0+6642] ='b01111010;
           rom[ 0+6643] ='b11100110;
           rom[ 0+6644] ='b00000001;
           rom[ 0+6645] ='b11011101;
           rom[ 0+6646] ='b01110111;
           rom[ 0+6647] ='b11111100;
           rom[ 0+6648] ='b11011101;
           rom[ 0+6649] ='b01010110;
           rom[ 0+6650] ='b00000100;
           rom[ 0+6651] ='b11001011;
           rom[ 0+6652] ='b00111010;
           rom[ 0+6653] ='b11001011;
           rom[ 0+6654] ='b00111010;
           rom[ 0+6655] ='b11001011;
           rom[ 0+6656] ='b00111010;
           rom[ 0+6657] ='b11001011;
           rom[ 0+6658] ='b00111010;
           rom[ 0+6659] ='b01111010;
           rom[ 0+6660] ='b11100110;
           rom[ 0+6661] ='b00000001;
           rom[ 0+6662] ='b11011101;
           rom[ 0+6663] ='b01110111;
           rom[ 0+6664] ='b11111011;
           rom[ 0+6665] ='b11011101;
           rom[ 0+6666] ='b01010110;
           rom[ 0+6667] ='b00000100;
           rom[ 0+6668] ='b11001011;
           rom[ 0+6669] ='b00111010;
           rom[ 0+6670] ='b11001011;
           rom[ 0+6671] ='b00111010;
           rom[ 0+6672] ='b11001011;
           rom[ 0+6673] ='b00111010;
           rom[ 0+6674] ='b11001011;
           rom[ 0+6675] ='b00111010;
           rom[ 0+6676] ='b11001011;
           rom[ 0+6677] ='b00111010;
           rom[ 0+6678] ='b01111010;
           rom[ 0+6679] ='b11100110;
           rom[ 0+6680] ='b00000001;
           rom[ 0+6681] ='b11011101;
           rom[ 0+6682] ='b01110111;
           rom[ 0+6683] ='b11111010;
           rom[ 0+6684] ='b11011101;
           rom[ 0+6685] ='b01010110;
           rom[ 0+6686] ='b00000100;
           rom[ 0+6687] ='b11001011;
           rom[ 0+6688] ='b00111010;
           rom[ 0+6689] ='b11001011;
           rom[ 0+6690] ='b00111010;
           rom[ 0+6691] ='b11001011;
           rom[ 0+6692] ='b00111010;
           rom[ 0+6693] ='b11001011;
           rom[ 0+6694] ='b00111010;
           rom[ 0+6695] ='b11001011;
           rom[ 0+6696] ='b00111010;
           rom[ 0+6697] ='b11001011;
           rom[ 0+6698] ='b00111010;
           rom[ 0+6699] ='b01111010;
           rom[ 0+6700] ='b11100110;
           rom[ 0+6701] ='b00000001;
           rom[ 0+6702] ='b11011101;
           rom[ 0+6703] ='b01110111;
           rom[ 0+6704] ='b11111001;
           rom[ 0+6705] ='b11011101;
           rom[ 0+6706] ='b01111110;
           rom[ 0+6707] ='b00000100;
           rom[ 0+6708] ='b11001011;
           rom[ 0+6709] ='b00000111;
           rom[ 0+6710] ='b11100110;
           rom[ 0+6711] ='b00000001;
           rom[ 0+6712] ='b01001111;
           rom[ 0+6713] ='b11011101;
           rom[ 0+6714] ='b01110001;
           rom[ 0+6715] ='b11111000;
           rom[ 0+6716] ='b11011101;
           rom[ 0+6717] ='b01111110;
           rom[ 0+6718] ='b00000101;
           rom[ 0+6719] ='b11100110;
           rom[ 0+6720] ='b00000001;
           rom[ 0+6721] ='b11011101;
           rom[ 0+6722] ='b01110111;
           rom[ 0+6723] ='b11110111;
           rom[ 0+6724] ='b11011101;
           rom[ 0+6725] ='b01010110;
           rom[ 0+6726] ='b00000101;
           rom[ 0+6727] ='b11001011;
           rom[ 0+6728] ='b00111010;
           rom[ 0+6729] ='b01111010;
           rom[ 0+6730] ='b11100110;
           rom[ 0+6731] ='b00000001;
           rom[ 0+6732] ='b11011101;
           rom[ 0+6733] ='b01110111;
           rom[ 0+6734] ='b11110110;
           rom[ 0+6735] ='b11011101;
           rom[ 0+6736] ='b01010110;
           rom[ 0+6737] ='b00000101;
           rom[ 0+6738] ='b11001011;
           rom[ 0+6739] ='b00111010;
           rom[ 0+6740] ='b11001011;
           rom[ 0+6741] ='b00111010;
           rom[ 0+6742] ='b01111010;
           rom[ 0+6743] ='b11100110;
           rom[ 0+6744] ='b00000001;
           rom[ 0+6745] ='b11011101;
           rom[ 0+6746] ='b01110111;
           rom[ 0+6747] ='b11110101;
           rom[ 0+6748] ='b11011101;
           rom[ 0+6749] ='b01010110;
           rom[ 0+6750] ='b00000101;
           rom[ 0+6751] ='b11001011;
           rom[ 0+6752] ='b00111010;
           rom[ 0+6753] ='b11001011;
           rom[ 0+6754] ='b00111010;
           rom[ 0+6755] ='b11001011;
           rom[ 0+6756] ='b00111010;
           rom[ 0+6757] ='b01111010;
           rom[ 0+6758] ='b11100110;
           rom[ 0+6759] ='b00000001;
           rom[ 0+6760] ='b11011101;
           rom[ 0+6761] ='b01110111;
           rom[ 0+6762] ='b11110100;
           rom[ 0+6763] ='b11011101;
           rom[ 0+6764] ='b01010110;
           rom[ 0+6765] ='b00000101;
           rom[ 0+6766] ='b11001011;
           rom[ 0+6767] ='b00111010;
           rom[ 0+6768] ='b11001011;
           rom[ 0+6769] ='b00111010;
           rom[ 0+6770] ='b11001011;
           rom[ 0+6771] ='b00111010;
           rom[ 0+6772] ='b11001011;
           rom[ 0+6773] ='b00111010;
           rom[ 0+6774] ='b01111010;
           rom[ 0+6775] ='b11100110;
           rom[ 0+6776] ='b00000001;
           rom[ 0+6777] ='b11011101;
           rom[ 0+6778] ='b01110111;
           rom[ 0+6779] ='b11110011;
           rom[ 0+6780] ='b11011101;
           rom[ 0+6781] ='b01010110;
           rom[ 0+6782] ='b00000101;
           rom[ 0+6783] ='b11001011;
           rom[ 0+6784] ='b00111010;
           rom[ 0+6785] ='b11001011;
           rom[ 0+6786] ='b00111010;
           rom[ 0+6787] ='b11001011;
           rom[ 0+6788] ='b00111010;
           rom[ 0+6789] ='b11001011;
           rom[ 0+6790] ='b00111010;
           rom[ 0+6791] ='b11001011;
           rom[ 0+6792] ='b00111010;
           rom[ 0+6793] ='b01111010;
           rom[ 0+6794] ='b11100110;
           rom[ 0+6795] ='b00000001;
           rom[ 0+6796] ='b11011101;
           rom[ 0+6797] ='b01110111;
           rom[ 0+6798] ='b11110010;
           rom[ 0+6799] ='b11011101;
           rom[ 0+6800] ='b01010110;
           rom[ 0+6801] ='b00000101;
           rom[ 0+6802] ='b11001011;
           rom[ 0+6803] ='b00111010;
           rom[ 0+6804] ='b11001011;
           rom[ 0+6805] ='b00111010;
           rom[ 0+6806] ='b11001011;
           rom[ 0+6807] ='b00111010;
           rom[ 0+6808] ='b11001011;
           rom[ 0+6809] ='b00111010;
           rom[ 0+6810] ='b11001011;
           rom[ 0+6811] ='b00111010;
           rom[ 0+6812] ='b11001011;
           rom[ 0+6813] ='b00111010;
           rom[ 0+6814] ='b01111010;
           rom[ 0+6815] ='b11100110;
           rom[ 0+6816] ='b00000001;
           rom[ 0+6817] ='b11011101;
           rom[ 0+6818] ='b01110111;
           rom[ 0+6819] ='b11110001;
           rom[ 0+6820] ='b11011101;
           rom[ 0+6821] ='b01111110;
           rom[ 0+6822] ='b00000101;
           rom[ 0+6823] ='b11001011;
           rom[ 0+6824] ='b00000111;
           rom[ 0+6825] ='b11100110;
           rom[ 0+6826] ='b00000001;
           rom[ 0+6827] ='b01001111;
           rom[ 0+6828] ='b11011101;
           rom[ 0+6829] ='b01110001;
           rom[ 0+6830] ='b11110000;
           rom[ 0+6831] ='b11011101;
           rom[ 0+6832] ='b01111110;
           rom[ 0+6833] ='b11111111;
           rom[ 0+6834] ='b11011101;
           rom[ 0+6835] ='b10100110;
           rom[ 0+6836] ='b11110111;
           rom[ 0+6837] ='b01010111;
           rom[ 0+6838] ='b11011101;
           rom[ 0+6839] ='b01111110;
           rom[ 0+6840] ='b11111000;
           rom[ 0+6841] ='b11011101;
           rom[ 0+6842] ='b10100110;
           rom[ 0+6843] ='b11110110;
           rom[ 0+6844] ='b11011101;
           rom[ 0+6845] ='b01110111;
           rom[ 0+6846] ='b11100001;
           rom[ 0+6847] ='b01111010;
           rom[ 0+6848] ='b11011101;
           rom[ 0+6849] ='b10000110;
           rom[ 0+6850] ='b11100001;
           rom[ 0+6851] ='b01010111;
           rom[ 0+6852] ='b11011101;
           rom[ 0+6853] ='b01111110;
           rom[ 0+6854] ='b11111001;
           rom[ 0+6855] ='b11011101;
           rom[ 0+6856] ='b10100110;
           rom[ 0+6857] ='b11110101;
           rom[ 0+6858] ='b11011101;
           rom[ 0+6859] ='b01110111;
           rom[ 0+6860] ='b11100100;
           rom[ 0+6861] ='b01111010;
           rom[ 0+6862] ='b11011101;
           rom[ 0+6863] ='b10000110;
           rom[ 0+6864] ='b11100100;
           rom[ 0+6865] ='b01010111;
           rom[ 0+6866] ='b11011101;
           rom[ 0+6867] ='b01111110;
           rom[ 0+6868] ='b11111010;
           rom[ 0+6869] ='b11011101;
           rom[ 0+6870] ='b10100110;
           rom[ 0+6871] ='b11110100;
           rom[ 0+6872] ='b11011101;
           rom[ 0+6873] ='b01110111;
           rom[ 0+6874] ='b11100110;
           rom[ 0+6875] ='b01111010;
           rom[ 0+6876] ='b11011101;
           rom[ 0+6877] ='b10000110;
           rom[ 0+6878] ='b11100110;
           rom[ 0+6879] ='b01001111;
           rom[ 0+6880] ='b11011101;
           rom[ 0+6881] ='b01111110;
           rom[ 0+6882] ='b11111011;
           rom[ 0+6883] ='b11011101;
           rom[ 0+6884] ='b10100110;
           rom[ 0+6885] ='b11110011;
           rom[ 0+6886] ='b11011101;
           rom[ 0+6887] ='b01110111;
           rom[ 0+6888] ='b11101000;
           rom[ 0+6889] ='b01111001;
           rom[ 0+6890] ='b11011101;
           rom[ 0+6891] ='b10000110;
           rom[ 0+6892] ='b11101000;
           rom[ 0+6893] ='b01001111;
           rom[ 0+6894] ='b11011101;
           rom[ 0+6895] ='b01111110;
           rom[ 0+6896] ='b11111100;
           rom[ 0+6897] ='b11011101;
           rom[ 0+6898] ='b10100110;
           rom[ 0+6899] ='b11110010;
           rom[ 0+6900] ='b11011101;
           rom[ 0+6901] ='b01110111;
           rom[ 0+6902] ='b11100111;
           rom[ 0+6903] ='b01111001;
           rom[ 0+6904] ='b11011101;
           rom[ 0+6905] ='b10000110;
           rom[ 0+6906] ='b11100111;
           rom[ 0+6907] ='b01001111;
           rom[ 0+6908] ='b11011101;
           rom[ 0+6909] ='b01111110;
           rom[ 0+6910] ='b11111000;
           rom[ 0+6911] ='b11011101;
           rom[ 0+6912] ='b10100110;
           rom[ 0+6913] ='b11110010;
           rom[ 0+6914] ='b01010111;
           rom[ 0+6915] ='b01111001;
           rom[ 0+6916] ='b10000010;
           rom[ 0+6917] ='b01001111;
           rom[ 0+6918] ='b11011101;
           rom[ 0+6919] ='b01111110;
           rom[ 0+6920] ='b11111101;
           rom[ 0+6921] ='b11011101;
           rom[ 0+6922] ='b10100110;
           rom[ 0+6923] ='b11110001;
           rom[ 0+6924] ='b11011101;
           rom[ 0+6925] ='b01110111;
           rom[ 0+6926] ='b11100101;
           rom[ 0+6927] ='b01111001;
           rom[ 0+6928] ='b11011101;
           rom[ 0+6929] ='b10000110;
           rom[ 0+6930] ='b11100101;
           rom[ 0+6931] ='b01000111;
           rom[ 0+6932] ='b11011101;
           rom[ 0+6933] ='b01111110;
           rom[ 0+6934] ='b11111001;
           rom[ 0+6935] ='b11011101;
           rom[ 0+6936] ='b10100110;
           rom[ 0+6937] ='b11110001;
           rom[ 0+6938] ='b01001111;
           rom[ 0+6939] ='b01111000;
           rom[ 0+6940] ='b10000001;
           rom[ 0+6941] ='b01000111;
           rom[ 0+6942] ='b11011101;
           rom[ 0+6943] ='b01111110;
           rom[ 0+6944] ='b11111000;
           rom[ 0+6945] ='b11011101;
           rom[ 0+6946] ='b10100110;
           rom[ 0+6947] ='b11110001;
           rom[ 0+6948] ='b11011101;
           rom[ 0+6949] ='b01110111;
           rom[ 0+6950] ='b11100011;
           rom[ 0+6951] ='b01111000;
           rom[ 0+6952] ='b11011101;
           rom[ 0+6953] ='b10000110;
           rom[ 0+6954] ='b11100011;
           rom[ 0+6955] ='b01000111;
           rom[ 0+6956] ='b11011101;
           rom[ 0+6957] ='b01111110;
           rom[ 0+6958] ='b11111110;
           rom[ 0+6959] ='b11011101;
           rom[ 0+6960] ='b10100110;
           rom[ 0+6961] ='b11110000;
           rom[ 0+6962] ='b11011101;
           rom[ 0+6963] ='b01110111;
           rom[ 0+6964] ='b11100010;
           rom[ 0+6965] ='b01111000;
           rom[ 0+6966] ='b11011101;
           rom[ 0+6967] ='b10000110;
           rom[ 0+6968] ='b11100010;
           rom[ 0+6969] ='b01000111;
           rom[ 0+6970] ='b11011101;
           rom[ 0+6971] ='b01111110;
           rom[ 0+6972] ='b11111010;
           rom[ 0+6973] ='b11011101;
           rom[ 0+6974] ='b10100110;
           rom[ 0+6975] ='b11110000;
           rom[ 0+6976] ='b11011101;
           rom[ 0+6977] ='b01110111;
           rom[ 0+6978] ='b11011110;
           rom[ 0+6979] ='b01111000;
           rom[ 0+6980] ='b11011101;
           rom[ 0+6981] ='b10000110;
           rom[ 0+6982] ='b11011110;
           rom[ 0+6983] ='b01000111;
           rom[ 0+6984] ='b11011101;
           rom[ 0+6985] ='b01111110;
           rom[ 0+6986] ='b11111001;
           rom[ 0+6987] ='b11011101;
           rom[ 0+6988] ='b10100110;
           rom[ 0+6989] ='b11110000;
           rom[ 0+6990] ='b11011101;
           rom[ 0+6991] ='b01110111;
           rom[ 0+6992] ='b11100000;
           rom[ 0+6993] ='b01111000;
           rom[ 0+6994] ='b11011101;
           rom[ 0+6995] ='b10000110;
           rom[ 0+6996] ='b11100000;
           rom[ 0+6997] ='b01000111;
           rom[ 0+6998] ='b11011101;
           rom[ 0+6999] ='b01111110;
           rom[ 0+7000] ='b11111000;
           rom[ 0+7001] ='b11011101;
           rom[ 0+7002] ='b10100110;
           rom[ 0+7003] ='b11110000;
           rom[ 0+7004] ='b11011101;
           rom[ 0+7005] ='b01110111;
           rom[ 0+7006] ='b11011111;
           rom[ 0+7007] ='b01111000;
           rom[ 0+7008] ='b11011101;
           rom[ 0+7009] ='b10000110;
           rom[ 0+7010] ='b11011111;
           rom[ 0+7011] ='b01011111;
           rom[ 0+7012] ='b00000110;
           rom[ 0+7013] ='b00000000;
           rom[ 0+7014] ='b01111011;
           rom[ 0+7015] ='b11100110;
           rom[ 0+7016] ='b00000001;
           rom[ 0+7017] ='b01011111;
           rom[ 0+7018] ='b00000110;
           rom[ 0+7019] ='b00000000;
           rom[ 0+7020] ='b11011101;
           rom[ 0+7021] ='b01110011;
           rom[ 0+7022] ='b11101111;
           rom[ 0+7023] ='b11011101;
           rom[ 0+7024] ='b01111110;
           rom[ 0+7025] ='b11111110;
           rom[ 0+7026] ='b11011101;
           rom[ 0+7027] ='b10100110;
           rom[ 0+7028] ='b11110111;
           rom[ 0+7029] ='b01000111;
           rom[ 0+7030] ='b11011101;
           rom[ 0+7031] ='b01111110;
           rom[ 0+7032] ='b11111111;
           rom[ 0+7033] ='b11011101;
           rom[ 0+7034] ='b10100110;
           rom[ 0+7035] ='b11110110;
           rom[ 0+7036] ='b01011111;
           rom[ 0+7037] ='b01111000;
           rom[ 0+7038] ='b10000011;
           rom[ 0+7039] ='b01000111;
           rom[ 0+7040] ='b11011101;
           rom[ 0+7041] ='b01111110;
           rom[ 0+7042] ='b11111000;
           rom[ 0+7043] ='b11011101;
           rom[ 0+7044] ='b10100110;
           rom[ 0+7045] ='b11110101;
           rom[ 0+7046] ='b11011101;
           rom[ 0+7047] ='b01110111;
           rom[ 0+7048] ='b11011000;
           rom[ 0+7049] ='b01111000;
           rom[ 0+7050] ='b11011101;
           rom[ 0+7051] ='b10000110;
           rom[ 0+7052] ='b11011000;
           rom[ 0+7053] ='b01000111;
           rom[ 0+7054] ='b11011101;
           rom[ 0+7055] ='b01111110;
           rom[ 0+7056] ='b11111001;
           rom[ 0+7057] ='b11011101;
           rom[ 0+7058] ='b10100110;
           rom[ 0+7059] ='b11110100;
           rom[ 0+7060] ='b11011101;
           rom[ 0+7061] ='b01110111;
           rom[ 0+7062] ='b11011101;
           rom[ 0+7063] ='b01111000;
           rom[ 0+7064] ='b11011101;
           rom[ 0+7065] ='b10000110;
           rom[ 0+7066] ='b11011101;
           rom[ 0+7067] ='b01000111;
           rom[ 0+7068] ='b11011101;
           rom[ 0+7069] ='b01111110;
           rom[ 0+7070] ='b11111010;
           rom[ 0+7071] ='b11011101;
           rom[ 0+7072] ='b10100110;
           rom[ 0+7073] ='b11110011;
           rom[ 0+7074] ='b11011101;
           rom[ 0+7075] ='b01110111;
           rom[ 0+7076] ='b11011100;
           rom[ 0+7077] ='b01111000;
           rom[ 0+7078] ='b11011101;
           rom[ 0+7079] ='b10000110;
           rom[ 0+7080] ='b11011100;
           rom[ 0+7081] ='b01000111;
           rom[ 0+7082] ='b11011101;
           rom[ 0+7083] ='b01111110;
           rom[ 0+7084] ='b11111011;
           rom[ 0+7085] ='b11011101;
           rom[ 0+7086] ='b10100110;
           rom[ 0+7087] ='b11110010;
           rom[ 0+7088] ='b11011101;
           rom[ 0+7089] ='b01110111;
           rom[ 0+7090] ='b11011011;
           rom[ 0+7091] ='b01111000;
           rom[ 0+7092] ='b11011101;
           rom[ 0+7093] ='b10000110;
           rom[ 0+7094] ='b11011011;
           rom[ 0+7095] ='b01000111;
           rom[ 0+7096] ='b11011101;
           rom[ 0+7097] ='b01111110;
           rom[ 0+7098] ='b11111100;
           rom[ 0+7099] ='b11011101;
           rom[ 0+7100] ='b10100110;
           rom[ 0+7101] ='b11110001;
           rom[ 0+7102] ='b11011101;
           rom[ 0+7103] ='b01110111;
           rom[ 0+7104] ='b11011010;
           rom[ 0+7105] ='b01111000;
           rom[ 0+7106] ='b11011101;
           rom[ 0+7107] ='b10000110;
           rom[ 0+7108] ='b11011010;
           rom[ 0+7109] ='b01000111;
           rom[ 0+7110] ='b11011101;
           rom[ 0+7111] ='b10000110;
           rom[ 0+7112] ='b11100011;
           rom[ 0+7113] ='b01000111;
           rom[ 0+7114] ='b11011101;
           rom[ 0+7115] ='b01111110;
           rom[ 0+7116] ='b11111101;
           rom[ 0+7117] ='b11011101;
           rom[ 0+7118] ='b10100110;
           rom[ 0+7119] ='b11110000;
           rom[ 0+7120] ='b11011101;
           rom[ 0+7121] ='b01110111;
           rom[ 0+7122] ='b11011001;
           rom[ 0+7123] ='b01111000;
           rom[ 0+7124] ='b11011101;
           rom[ 0+7125] ='b10000110;
           rom[ 0+7126] ='b11011001;
           rom[ 0+7127] ='b01000111;
           rom[ 0+7128] ='b11011101;
           rom[ 0+7129] ='b10000110;
           rom[ 0+7130] ='b11100000;
           rom[ 0+7131] ='b01000111;
           rom[ 0+7132] ='b11011101;
           rom[ 0+7133] ='b10000110;
           rom[ 0+7134] ='b11011111;
           rom[ 0+7135] ='b01000111;
           rom[ 0+7136] ='b00011110;
           rom[ 0+7137] ='b00000000;
           rom[ 0+7138] ='b01111000;
           rom[ 0+7139] ='b11100110;
           rom[ 0+7140] ='b00000001;
           rom[ 0+7141] ='b01000111;
           rom[ 0+7142] ='b00011110;
           rom[ 0+7143] ='b00000000;
           rom[ 0+7144] ='b11011101;
           rom[ 0+7145] ='b01110000;
           rom[ 0+7146] ='b11101110;
           rom[ 0+7147] ='b11011101;
           rom[ 0+7148] ='b01111110;
           rom[ 0+7149] ='b11111101;
           rom[ 0+7150] ='b11011101;
           rom[ 0+7151] ='b10100110;
           rom[ 0+7152] ='b11110111;
           rom[ 0+7153] ='b01011111;
           rom[ 0+7154] ='b11011101;
           rom[ 0+7155] ='b01111110;
           rom[ 0+7156] ='b11111110;
           rom[ 0+7157] ='b11011101;
           rom[ 0+7158] ='b10100110;
           rom[ 0+7159] ='b11110110;
           rom[ 0+7160] ='b01000111;
           rom[ 0+7161] ='b01111011;
           rom[ 0+7162] ='b10000000;
           rom[ 0+7163] ='b01011111;
           rom[ 0+7164] ='b11011101;
           rom[ 0+7165] ='b10000110;
           rom[ 0+7166] ='b11100001;
           rom[ 0+7167] ='b01011111;
           rom[ 0+7168] ='b11011101;
           rom[ 0+7169] ='b01111110;
           rom[ 0+7170] ='b11111111;
           rom[ 0+7171] ='b11011101;
           rom[ 0+7172] ='b10100110;
           rom[ 0+7173] ='b11110101;
           rom[ 0+7174] ='b01000111;
           rom[ 0+7175] ='b01111011;
           rom[ 0+7176] ='b10000000;
           rom[ 0+7177] ='b01011111;
           rom[ 0+7178] ='b11011101;
           rom[ 0+7179] ='b10000110;
           rom[ 0+7180] ='b11100100;
           rom[ 0+7181] ='b01011111;
           rom[ 0+7182] ='b11011101;
           rom[ 0+7183] ='b10000110;
           rom[ 0+7184] ='b11100110;
           rom[ 0+7185] ='b01011111;
           rom[ 0+7186] ='b11011101;
           rom[ 0+7187] ='b01111110;
           rom[ 0+7188] ='b11111000;
           rom[ 0+7189] ='b11011101;
           rom[ 0+7190] ='b10100110;
           rom[ 0+7191] ='b11110100;
           rom[ 0+7192] ='b11011101;
           rom[ 0+7193] ='b01110111;
           rom[ 0+7194] ='b11010011;
           rom[ 0+7195] ='b01111011;
           rom[ 0+7196] ='b11011101;
           rom[ 0+7197] ='b10000110;
           rom[ 0+7198] ='b11010011;
           rom[ 0+7199] ='b01011111;
           rom[ 0+7200] ='b11011101;
           rom[ 0+7201] ='b10000110;
           rom[ 0+7202] ='b11101000;
           rom[ 0+7203] ='b01000111;
           rom[ 0+7204] ='b11011101;
           rom[ 0+7205] ='b01111110;
           rom[ 0+7206] ='b11111001;
           rom[ 0+7207] ='b11011101;
           rom[ 0+7208] ='b10100110;
           rom[ 0+7209] ='b11110011;
           rom[ 0+7210] ='b11011101;
           rom[ 0+7211] ='b01110111;
           rom[ 0+7212] ='b11010111;
           rom[ 0+7213] ='b01111000;
           rom[ 0+7214] ='b11011101;
           rom[ 0+7215] ='b10000110;
           rom[ 0+7216] ='b11010111;
           rom[ 0+7217] ='b01011111;
           rom[ 0+7218] ='b11011101;
           rom[ 0+7219] ='b10000110;
           rom[ 0+7220] ='b11100111;
           rom[ 0+7221] ='b01000111;
           rom[ 0+7222] ='b11011101;
           rom[ 0+7223] ='b01111110;
           rom[ 0+7224] ='b11111010;
           rom[ 0+7225] ='b11011101;
           rom[ 0+7226] ='b10100110;
           rom[ 0+7227] ='b11110010;
           rom[ 0+7228] ='b11011101;
           rom[ 0+7229] ='b01110111;
           rom[ 0+7230] ='b11010110;
           rom[ 0+7231] ='b01111000;
           rom[ 0+7232] ='b11011101;
           rom[ 0+7233] ='b10000110;
           rom[ 0+7234] ='b11010110;
           rom[ 0+7235] ='b01011111;
           rom[ 0+7236] ='b10000010;
           rom[ 0+7237] ='b01011111;
           rom[ 0+7238] ='b11011101;
           rom[ 0+7239] ='b10000110;
           rom[ 0+7240] ='b11100101;
           rom[ 0+7241] ='b01000111;
           rom[ 0+7242] ='b11011101;
           rom[ 0+7243] ='b01111110;
           rom[ 0+7244] ='b11111011;
           rom[ 0+7245] ='b11011101;
           rom[ 0+7246] ='b10100110;
           rom[ 0+7247] ='b11110001;
           rom[ 0+7248] ='b11011101;
           rom[ 0+7249] ='b01110111;
           rom[ 0+7250] ='b11010101;
           rom[ 0+7251] ='b01111000;
           rom[ 0+7252] ='b11011101;
           rom[ 0+7253] ='b10000110;
           rom[ 0+7254] ='b11010101;
           rom[ 0+7255] ='b01011111;
           rom[ 0+7256] ='b10000001;
           rom[ 0+7257] ='b01011111;
           rom[ 0+7258] ='b11011101;
           rom[ 0+7259] ='b10000110;
           rom[ 0+7260] ='b11100011;
           rom[ 0+7261] ='b01011111;
           rom[ 0+7262] ='b11011101;
           rom[ 0+7263] ='b10000110;
           rom[ 0+7264] ='b11100010;
           rom[ 0+7265] ='b01000111;
           rom[ 0+7266] ='b11011101;
           rom[ 0+7267] ='b01111110;
           rom[ 0+7268] ='b11111100;
           rom[ 0+7269] ='b11011101;
           rom[ 0+7270] ='b10100110;
           rom[ 0+7271] ='b11110000;
           rom[ 0+7272] ='b11011101;
           rom[ 0+7273] ='b01110111;
           rom[ 0+7274] ='b11010100;
           rom[ 0+7275] ='b01111000;
           rom[ 0+7276] ='b11011101;
           rom[ 0+7277] ='b10000110;
           rom[ 0+7278] ='b11010100;
           rom[ 0+7279] ='b01011111;
           rom[ 0+7280] ='b11011101;
           rom[ 0+7281] ='b10000110;
           rom[ 0+7282] ='b11011110;
           rom[ 0+7283] ='b01011111;
           rom[ 0+7284] ='b11011101;
           rom[ 0+7285] ='b10000110;
           rom[ 0+7286] ='b11100000;
           rom[ 0+7287] ='b01011111;
           rom[ 0+7288] ='b00000110;
           rom[ 0+7289] ='b00000000;
           rom[ 0+7290] ='b01111011;
           rom[ 0+7291] ='b11100110;
           rom[ 0+7292] ='b00000001;
           rom[ 0+7293] ='b01011111;
           rom[ 0+7294] ='b00000110;
           rom[ 0+7295] ='b00000000;
           rom[ 0+7296] ='b11011101;
           rom[ 0+7297] ='b01110011;
           rom[ 0+7298] ='b11101101;
           rom[ 0+7299] ='b11011101;
           rom[ 0+7300] ='b01111110;
           rom[ 0+7301] ='b11111100;
           rom[ 0+7302] ='b11011101;
           rom[ 0+7303] ='b10100110;
           rom[ 0+7304] ='b11110111;
           rom[ 0+7305] ='b01000111;
           rom[ 0+7306] ='b11011101;
           rom[ 0+7307] ='b01111110;
           rom[ 0+7308] ='b11111101;
           rom[ 0+7309] ='b11011101;
           rom[ 0+7310] ='b10100110;
           rom[ 0+7311] ='b11110110;
           rom[ 0+7312] ='b01011111;
           rom[ 0+7313] ='b01111000;
           rom[ 0+7314] ='b10000011;
           rom[ 0+7315] ='b01000111;
           rom[ 0+7316] ='b11011101;
           rom[ 0+7317] ='b10000110;
           rom[ 0+7318] ='b11100001;
           rom[ 0+7319] ='b01000111;
           rom[ 0+7320] ='b11011101;
           rom[ 0+7321] ='b01111110;
           rom[ 0+7322] ='b11111110;
           rom[ 0+7323] ='b11011101;
           rom[ 0+7324] ='b10100110;
           rom[ 0+7325] ='b11110101;
           rom[ 0+7326] ='b01011111;
           rom[ 0+7327] ='b01111000;
           rom[ 0+7328] ='b10000011;
           rom[ 0+7329] ='b01000111;
           rom[ 0+7330] ='b11011101;
           rom[ 0+7331] ='b10000110;
           rom[ 0+7332] ='b11100100;
           rom[ 0+7333] ='b01000111;
           rom[ 0+7334] ='b11011101;
           rom[ 0+7335] ='b10000110;
           rom[ 0+7336] ='b11011000;
           rom[ 0+7337] ='b01000111;
           rom[ 0+7338] ='b11011101;
           rom[ 0+7339] ='b01111110;
           rom[ 0+7340] ='b11111111;
           rom[ 0+7341] ='b11011101;
           rom[ 0+7342] ='b10100110;
           rom[ 0+7343] ='b11110100;
           rom[ 0+7344] ='b01011111;
           rom[ 0+7345] ='b01111000;
           rom[ 0+7346] ='b10000011;
           rom[ 0+7347] ='b01000111;
           rom[ 0+7348] ='b11011101;
           rom[ 0+7349] ='b10000110;
           rom[ 0+7350] ='b11100110;
           rom[ 0+7351] ='b01000111;
           rom[ 0+7352] ='b11011101;
           rom[ 0+7353] ='b10000110;
           rom[ 0+7354] ='b11011101;
           rom[ 0+7355] ='b01000111;
           rom[ 0+7356] ='b11011101;
           rom[ 0+7357] ='b10000110;
           rom[ 0+7358] ='b11101000;
           rom[ 0+7359] ='b01000111;
           rom[ 0+7360] ='b11011101;
           rom[ 0+7361] ='b10000110;
           rom[ 0+7362] ='b11011100;
           rom[ 0+7363] ='b01000111;
           rom[ 0+7364] ='b11011101;
           rom[ 0+7365] ='b01111110;
           rom[ 0+7366] ='b11111000;
           rom[ 0+7367] ='b11011101;
           rom[ 0+7368] ='b10100110;
           rom[ 0+7369] ='b11110011;
           rom[ 0+7370] ='b11011101;
           rom[ 0+7371] ='b01110111;
           rom[ 0+7372] ='b11001111;
           rom[ 0+7373] ='b01111000;
           rom[ 0+7374] ='b11011101;
           rom[ 0+7375] ='b10000110;
           rom[ 0+7376] ='b11001111;
           rom[ 0+7377] ='b01000111;
           rom[ 0+7378] ='b11011101;
           rom[ 0+7379] ='b10000110;
           rom[ 0+7380] ='b11100111;
           rom[ 0+7381] ='b01000111;
           rom[ 0+7382] ='b11011101;
           rom[ 0+7383] ='b10000110;
           rom[ 0+7384] ='b11011011;
           rom[ 0+7385] ='b01000111;
           rom[ 0+7386] ='b11011101;
           rom[ 0+7387] ='b01111110;
           rom[ 0+7388] ='b11111001;
           rom[ 0+7389] ='b11011101;
           rom[ 0+7390] ='b10100110;
           rom[ 0+7391] ='b11110010;
           rom[ 0+7392] ='b11011101;
           rom[ 0+7393] ='b01110111;
           rom[ 0+7394] ='b11010010;
           rom[ 0+7395] ='b01111000;
           rom[ 0+7396] ='b11011101;
           rom[ 0+7397] ='b10000110;
           rom[ 0+7398] ='b11010010;
           rom[ 0+7399] ='b01000111;
           rom[ 0+7400] ='b10000010;
           rom[ 0+7401] ='b01000111;
           rom[ 0+7402] ='b11011101;
           rom[ 0+7403] ='b10000110;
           rom[ 0+7404] ='b11100101;
           rom[ 0+7405] ='b01000111;
           rom[ 0+7406] ='b11011101;
           rom[ 0+7407] ='b10000110;
           rom[ 0+7408] ='b11011010;
           rom[ 0+7409] ='b01000111;
           rom[ 0+7410] ='b11011101;
           rom[ 0+7411] ='b01111110;
           rom[ 0+7412] ='b11111010;
           rom[ 0+7413] ='b11011101;
           rom[ 0+7414] ='b10100110;
           rom[ 0+7415] ='b11110001;
           rom[ 0+7416] ='b11011101;
           rom[ 0+7417] ='b01110111;
           rom[ 0+7418] ='b11010001;
           rom[ 0+7419] ='b01111000;
           rom[ 0+7420] ='b11011101;
           rom[ 0+7421] ='b10000110;
           rom[ 0+7422] ='b11010001;
           rom[ 0+7423] ='b01000111;
           rom[ 0+7424] ='b10000001;
           rom[ 0+7425] ='b01000111;
           rom[ 0+7426] ='b11011101;
           rom[ 0+7427] ='b10000110;
           rom[ 0+7428] ='b11100010;
           rom[ 0+7429] ='b01000111;
           rom[ 0+7430] ='b11011101;
           rom[ 0+7431] ='b10000110;
           rom[ 0+7432] ='b11011001;
           rom[ 0+7433] ='b01000111;
           rom[ 0+7434] ='b11011101;
           rom[ 0+7435] ='b01111110;
           rom[ 0+7436] ='b11111011;
           rom[ 0+7437] ='b11011101;
           rom[ 0+7438] ='b10100110;
           rom[ 0+7439] ='b11110000;
           rom[ 0+7440] ='b11011101;
           rom[ 0+7441] ='b01110111;
           rom[ 0+7442] ='b11010000;
           rom[ 0+7443] ='b01111000;
           rom[ 0+7444] ='b11011101;
           rom[ 0+7445] ='b10000110;
           rom[ 0+7446] ='b11010000;
           rom[ 0+7447] ='b01000111;
           rom[ 0+7448] ='b11011101;
           rom[ 0+7449] ='b10000110;
           rom[ 0+7450] ='b11011110;
           rom[ 0+7451] ='b01000111;
           rom[ 0+7452] ='b00011110;
           rom[ 0+7453] ='b00000000;
           rom[ 0+7454] ='b01111000;
           rom[ 0+7455] ='b11100110;
           rom[ 0+7456] ='b00000001;
           rom[ 0+7457] ='b01000111;
           rom[ 0+7458] ='b00011110;
           rom[ 0+7459] ='b00000000;
           rom[ 0+7460] ='b11011101;
           rom[ 0+7461] ='b01110000;
           rom[ 0+7462] ='b11101100;
           rom[ 0+7463] ='b11011101;
           rom[ 0+7464] ='b01111110;
           rom[ 0+7465] ='b11111011;
           rom[ 0+7466] ='b11011101;
           rom[ 0+7467] ='b10100110;
           rom[ 0+7468] ='b11110111;
           rom[ 0+7469] ='b01011111;
           rom[ 0+7470] ='b11011101;
           rom[ 0+7471] ='b01111110;
           rom[ 0+7472] ='b11111100;
           rom[ 0+7473] ='b11011101;
           rom[ 0+7474] ='b10100110;
           rom[ 0+7475] ='b11110110;
           rom[ 0+7476] ='b01000111;
           rom[ 0+7477] ='b01111011;
           rom[ 0+7478] ='b10000000;
           rom[ 0+7479] ='b01011111;
           rom[ 0+7480] ='b11011101;
           rom[ 0+7481] ='b10000110;
           rom[ 0+7482] ='b11100001;
           rom[ 0+7483] ='b01011111;
           rom[ 0+7484] ='b11011101;
           rom[ 0+7485] ='b01111110;
           rom[ 0+7486] ='b11111101;
           rom[ 0+7487] ='b11011101;
           rom[ 0+7488] ='b10100110;
           rom[ 0+7489] ='b11110101;
           rom[ 0+7490] ='b01000111;
           rom[ 0+7491] ='b01111011;
           rom[ 0+7492] ='b10000000;
           rom[ 0+7493] ='b01011111;
           rom[ 0+7494] ='b11011101;
           rom[ 0+7495] ='b10000110;
           rom[ 0+7496] ='b11100100;
           rom[ 0+7497] ='b01011111;
           rom[ 0+7498] ='b11011101;
           rom[ 0+7499] ='b10000110;
           rom[ 0+7500] ='b11011000;
           rom[ 0+7501] ='b01011111;
           rom[ 0+7502] ='b11011101;
           rom[ 0+7503] ='b01111110;
           rom[ 0+7504] ='b11111110;
           rom[ 0+7505] ='b11011101;
           rom[ 0+7506] ='b10100110;
           rom[ 0+7507] ='b11110100;
           rom[ 0+7508] ='b01000111;
           rom[ 0+7509] ='b01111011;
           rom[ 0+7510] ='b10000000;
           rom[ 0+7511] ='b01011111;
           rom[ 0+7512] ='b11011101;
           rom[ 0+7513] ='b10000110;
           rom[ 0+7514] ='b11100110;
           rom[ 0+7515] ='b01011111;
           rom[ 0+7516] ='b11011101;
           rom[ 0+7517] ='b10000110;
           rom[ 0+7518] ='b11011101;
           rom[ 0+7519] ='b01011111;
           rom[ 0+7520] ='b11011101;
           rom[ 0+7521] ='b10000110;
           rom[ 0+7522] ='b11010011;
           rom[ 0+7523] ='b01011111;
           rom[ 0+7524] ='b11011101;
           rom[ 0+7525] ='b01111110;
           rom[ 0+7526] ='b11111111;
           rom[ 0+7527] ='b11011101;
           rom[ 0+7528] ='b10100110;
           rom[ 0+7529] ='b11110011;
           rom[ 0+7530] ='b01000111;
           rom[ 0+7531] ='b01111011;
           rom[ 0+7532] ='b10000000;
           rom[ 0+7533] ='b01011111;
           rom[ 0+7534] ='b11011101;
           rom[ 0+7535] ='b10000110;
           rom[ 0+7536] ='b11101000;
           rom[ 0+7537] ='b01011111;
           rom[ 0+7538] ='b11011101;
           rom[ 0+7539] ='b10000110;
           rom[ 0+7540] ='b11011100;
           rom[ 0+7541] ='b01011111;
           rom[ 0+7542] ='b11011101;
           rom[ 0+7543] ='b10000110;
           rom[ 0+7544] ='b11010111;
           rom[ 0+7545] ='b01011111;
           rom[ 0+7546] ='b11011101;
           rom[ 0+7547] ='b10000110;
           rom[ 0+7548] ='b11100111;
           rom[ 0+7549] ='b01011111;
           rom[ 0+7550] ='b11011101;
           rom[ 0+7551] ='b10000110;
           rom[ 0+7552] ='b11011011;
           rom[ 0+7553] ='b01011111;
           rom[ 0+7554] ='b11011101;
           rom[ 0+7555] ='b10000110;
           rom[ 0+7556] ='b11010110;
           rom[ 0+7557] ='b01011111;
           rom[ 0+7558] ='b11011101;
           rom[ 0+7559] ='b10000110;
           rom[ 0+7560] ='b11100101;
           rom[ 0+7561] ='b01011111;
           rom[ 0+7562] ='b11011101;
           rom[ 0+7563] ='b10000110;
           rom[ 0+7564] ='b11011010;
           rom[ 0+7565] ='b01011111;
           rom[ 0+7566] ='b11011101;
           rom[ 0+7567] ='b10000110;
           rom[ 0+7568] ='b11010101;
           rom[ 0+7569] ='b01011111;
           rom[ 0+7570] ='b11011101;
           rom[ 0+7571] ='b10000110;
           rom[ 0+7572] ='b11100010;
           rom[ 0+7573] ='b01011111;
           rom[ 0+7574] ='b11011101;
           rom[ 0+7575] ='b10000110;
           rom[ 0+7576] ='b11011001;
           rom[ 0+7577] ='b01011111;
           rom[ 0+7578] ='b11011101;
           rom[ 0+7579] ='b10000110;
           rom[ 0+7580] ='b11010100;
           rom[ 0+7581] ='b01011111;
           rom[ 0+7582] ='b11011101;
           rom[ 0+7583] ='b10000110;
           rom[ 0+7584] ='b11011111;
           rom[ 0+7585] ='b01011111;
           rom[ 0+7586] ='b00000110;
           rom[ 0+7587] ='b00000000;
           rom[ 0+7588] ='b01111011;
           rom[ 0+7589] ='b11100110;
           rom[ 0+7590] ='b00000001;
           rom[ 0+7591] ='b01011111;
           rom[ 0+7592] ='b00000110;
           rom[ 0+7593] ='b00000000;
           rom[ 0+7594] ='b11011101;
           rom[ 0+7595] ='b01110011;
           rom[ 0+7596] ='b11101011;
           rom[ 0+7597] ='b11011101;
           rom[ 0+7598] ='b01111110;
           rom[ 0+7599] ='b11111010;
           rom[ 0+7600] ='b11011101;
           rom[ 0+7601] ='b10100110;
           rom[ 0+7602] ='b11110111;
           rom[ 0+7603] ='b01000111;
           rom[ 0+7604] ='b11011101;
           rom[ 0+7605] ='b01111110;
           rom[ 0+7606] ='b11111011;
           rom[ 0+7607] ='b11011101;
           rom[ 0+7608] ='b10100110;
           rom[ 0+7609] ='b11110110;
           rom[ 0+7610] ='b01011111;
           rom[ 0+7611] ='b01111000;
           rom[ 0+7612] ='b10000011;
           rom[ 0+7613] ='b01000111;
           rom[ 0+7614] ='b11011101;
           rom[ 0+7615] ='b01111110;
           rom[ 0+7616] ='b11111100;
           rom[ 0+7617] ='b11011101;
           rom[ 0+7618] ='b10100110;
           rom[ 0+7619] ='b11110101;
           rom[ 0+7620] ='b01011111;
           rom[ 0+7621] ='b01111000;
           rom[ 0+7622] ='b10000011;
           rom[ 0+7623] ='b01000111;
           rom[ 0+7624] ='b11011101;
           rom[ 0+7625] ='b10000110;
           rom[ 0+7626] ='b11011000;
           rom[ 0+7627] ='b01000111;
           rom[ 0+7628] ='b11011101;
           rom[ 0+7629] ='b01111110;
           rom[ 0+7630] ='b11111101;
           rom[ 0+7631] ='b11011101;
           rom[ 0+7632] ='b10100110;
           rom[ 0+7633] ='b11110100;
           rom[ 0+7634] ='b01011111;
           rom[ 0+7635] ='b01111000;
           rom[ 0+7636] ='b10000011;
           rom[ 0+7637] ='b01000111;
           rom[ 0+7638] ='b11011101;
           rom[ 0+7639] ='b10000110;
           rom[ 0+7640] ='b11011101;
           rom[ 0+7641] ='b01000111;
           rom[ 0+7642] ='b11011101;
           rom[ 0+7643] ='b10000110;
           rom[ 0+7644] ='b11010011;
           rom[ 0+7645] ='b01000111;
           rom[ 0+7646] ='b11011101;
           rom[ 0+7647] ='b01111110;
           rom[ 0+7648] ='b11111110;
           rom[ 0+7649] ='b11011101;
           rom[ 0+7650] ='b10100110;
           rom[ 0+7651] ='b11110011;
           rom[ 0+7652] ='b01011111;
           rom[ 0+7653] ='b01111000;
           rom[ 0+7654] ='b10000011;
           rom[ 0+7655] ='b01000111;
           rom[ 0+7656] ='b11011101;
           rom[ 0+7657] ='b10000110;
           rom[ 0+7658] ='b11011100;
           rom[ 0+7659] ='b01000111;
           rom[ 0+7660] ='b11011101;
           rom[ 0+7661] ='b10000110;
           rom[ 0+7662] ='b11010111;
           rom[ 0+7663] ='b01000111;
           rom[ 0+7664] ='b11011101;
           rom[ 0+7665] ='b10000110;
           rom[ 0+7666] ='b11001111;
           rom[ 0+7667] ='b01000111;
           rom[ 0+7668] ='b11011101;
           rom[ 0+7669] ='b01111110;
           rom[ 0+7670] ='b11111111;
           rom[ 0+7671] ='b11011101;
           rom[ 0+7672] ='b10100110;
           rom[ 0+7673] ='b11110010;
           rom[ 0+7674] ='b01011111;
           rom[ 0+7675] ='b01111000;
           rom[ 0+7676] ='b10000011;
           rom[ 0+7677] ='b01000111;
           rom[ 0+7678] ='b11011101;
           rom[ 0+7679] ='b10000110;
           rom[ 0+7680] ='b11011011;
           rom[ 0+7681] ='b01000111;
           rom[ 0+7682] ='b11011101;
           rom[ 0+7683] ='b10000110;
           rom[ 0+7684] ='b11010110;
           rom[ 0+7685] ='b01000111;
           rom[ 0+7686] ='b11011101;
           rom[ 0+7687] ='b10000110;
           rom[ 0+7688] ='b11010010;
           rom[ 0+7689] ='b01000111;
           rom[ 0+7690] ='b11011101;
           rom[ 0+7691] ='b10000110;
           rom[ 0+7692] ='b11011010;
           rom[ 0+7693] ='b01000111;
           rom[ 0+7694] ='b11011101;
           rom[ 0+7695] ='b10000110;
           rom[ 0+7696] ='b11010101;
           rom[ 0+7697] ='b01000111;
           rom[ 0+7698] ='b11011101;
           rom[ 0+7699] ='b10000110;
           rom[ 0+7700] ='b11010001;
           rom[ 0+7701] ='b01000111;
           rom[ 0+7702] ='b11011101;
           rom[ 0+7703] ='b10000110;
           rom[ 0+7704] ='b11011001;
           rom[ 0+7705] ='b01000111;
           rom[ 0+7706] ='b11011101;
           rom[ 0+7707] ='b10000110;
           rom[ 0+7708] ='b11010100;
           rom[ 0+7709] ='b01000111;
           rom[ 0+7710] ='b11011101;
           rom[ 0+7711] ='b10000110;
           rom[ 0+7712] ='b11010000;
           rom[ 0+7713] ='b01000111;
           rom[ 0+7714] ='b00011110;
           rom[ 0+7715] ='b00000000;
           rom[ 0+7716] ='b01111000;
           rom[ 0+7717] ='b11100110;
           rom[ 0+7718] ='b00000001;
           rom[ 0+7719] ='b01000111;
           rom[ 0+7720] ='b00011110;
           rom[ 0+7721] ='b00000000;
           rom[ 0+7722] ='b11011101;
           rom[ 0+7723] ='b01110000;
           rom[ 0+7724] ='b11101010;
           rom[ 0+7725] ='b11011101;
           rom[ 0+7726] ='b01111110;
           rom[ 0+7727] ='b11111001;
           rom[ 0+7728] ='b11011101;
           rom[ 0+7729] ='b10100110;
           rom[ 0+7730] ='b11110111;
           rom[ 0+7731] ='b01011111;
           rom[ 0+7732] ='b11011101;
           rom[ 0+7733] ='b01111110;
           rom[ 0+7734] ='b11111010;
           rom[ 0+7735] ='b11011101;
           rom[ 0+7736] ='b10100110;
           rom[ 0+7737] ='b11110110;
           rom[ 0+7738] ='b01000111;
           rom[ 0+7739] ='b01111011;
           rom[ 0+7740] ='b10000000;
           rom[ 0+7741] ='b01011111;
           rom[ 0+7742] ='b11011101;
           rom[ 0+7743] ='b01111110;
           rom[ 0+7744] ='b11111011;
           rom[ 0+7745] ='b11011101;
           rom[ 0+7746] ='b10100110;
           rom[ 0+7747] ='b11110101;
           rom[ 0+7748] ='b01000111;
           rom[ 0+7749] ='b01111011;
           rom[ 0+7750] ='b10000000;
           rom[ 0+7751] ='b01011111;
           rom[ 0+7752] ='b11011101;
           rom[ 0+7753] ='b01111110;
           rom[ 0+7754] ='b11111100;
           rom[ 0+7755] ='b11011101;
           rom[ 0+7756] ='b10100110;
           rom[ 0+7757] ='b11110100;
           rom[ 0+7758] ='b01000111;
           rom[ 0+7759] ='b01111011;
           rom[ 0+7760] ='b10000000;
           rom[ 0+7761] ='b01011111;
           rom[ 0+7762] ='b11011101;
           rom[ 0+7763] ='b10000110;
           rom[ 0+7764] ='b11010011;
           rom[ 0+7765] ='b01011111;
           rom[ 0+7766] ='b11011101;
           rom[ 0+7767] ='b01111110;
           rom[ 0+7768] ='b11111101;
           rom[ 0+7769] ='b11011101;
           rom[ 0+7770] ='b10100110;
           rom[ 0+7771] ='b11110011;
           rom[ 0+7772] ='b01000111;
           rom[ 0+7773] ='b01111011;
           rom[ 0+7774] ='b10000000;
           rom[ 0+7775] ='b01011111;
           rom[ 0+7776] ='b11011101;
           rom[ 0+7777] ='b10000110;
           rom[ 0+7778] ='b11010111;
           rom[ 0+7779] ='b01011111;
           rom[ 0+7780] ='b11011101;
           rom[ 0+7781] ='b10000110;
           rom[ 0+7782] ='b11001111;
           rom[ 0+7783] ='b01011111;
           rom[ 0+7784] ='b11011101;
           rom[ 0+7785] ='b01111110;
           rom[ 0+7786] ='b11111110;
           rom[ 0+7787] ='b11011101;
           rom[ 0+7788] ='b10100110;
           rom[ 0+7789] ='b11110010;
           rom[ 0+7790] ='b01000111;
           rom[ 0+7791] ='b01111011;
           rom[ 0+7792] ='b10000000;
           rom[ 0+7793] ='b01011111;
           rom[ 0+7794] ='b11011101;
           rom[ 0+7795] ='b10000110;
           rom[ 0+7796] ='b11010110;
           rom[ 0+7797] ='b01011111;
           rom[ 0+7798] ='b11011101;
           rom[ 0+7799] ='b10000110;
           rom[ 0+7800] ='b11010010;
           rom[ 0+7801] ='b01011111;
           rom[ 0+7802] ='b10000010;
           rom[ 0+7803] ='b01011111;
           rom[ 0+7804] ='b11011101;
           rom[ 0+7805] ='b01111110;
           rom[ 0+7806] ='b11111111;
           rom[ 0+7807] ='b11011101;
           rom[ 0+7808] ='b10100110;
           rom[ 0+7809] ='b11110001;
           rom[ 0+7810] ='b01000111;
           rom[ 0+7811] ='b01111011;
           rom[ 0+7812] ='b10000000;
           rom[ 0+7813] ='b01011111;
           rom[ 0+7814] ='b11011101;
           rom[ 0+7815] ='b10000110;
           rom[ 0+7816] ='b11010101;
           rom[ 0+7817] ='b01011111;
           rom[ 0+7818] ='b11011101;
           rom[ 0+7819] ='b10000110;
           rom[ 0+7820] ='b11010001;
           rom[ 0+7821] ='b01011111;
           rom[ 0+7822] ='b10000001;
           rom[ 0+7823] ='b01011111;
           rom[ 0+7824] ='b11011101;
           rom[ 0+7825] ='b10000110;
           rom[ 0+7826] ='b11010100;
           rom[ 0+7827] ='b01011111;
           rom[ 0+7828] ='b11011101;
           rom[ 0+7829] ='b10000110;
           rom[ 0+7830] ='b11010000;
           rom[ 0+7831] ='b01011111;
           rom[ 0+7832] ='b11011101;
           rom[ 0+7833] ='b10000110;
           rom[ 0+7834] ='b11011110;
           rom[ 0+7835] ='b01011111;
           rom[ 0+7836] ='b00000110;
           rom[ 0+7837] ='b00000000;
           rom[ 0+7838] ='b01111011;
           rom[ 0+7839] ='b11100110;
           rom[ 0+7840] ='b00000001;
           rom[ 0+7841] ='b01011111;
           rom[ 0+7842] ='b00000110;
           rom[ 0+7843] ='b00000000;
           rom[ 0+7844] ='b11011101;
           rom[ 0+7845] ='b01110011;
           rom[ 0+7846] ='b11101001;
           rom[ 0+7847] ='b11011101;
           rom[ 0+7848] ='b01111110;
           rom[ 0+7849] ='b11111000;
           rom[ 0+7850] ='b11011101;
           rom[ 0+7851] ='b10100110;
           rom[ 0+7852] ='b11110111;
           rom[ 0+7853] ='b01000111;
           rom[ 0+7854] ='b11011101;
           rom[ 0+7855] ='b01111110;
           rom[ 0+7856] ='b11111001;
           rom[ 0+7857] ='b11011101;
           rom[ 0+7858] ='b10100110;
           rom[ 0+7859] ='b11110110;
           rom[ 0+7860] ='b01011111;
           rom[ 0+7861] ='b01111000;
           rom[ 0+7862] ='b10000011;
           rom[ 0+7863] ='b01000111;
           rom[ 0+7864] ='b11011101;
           rom[ 0+7865] ='b01111110;
           rom[ 0+7866] ='b11111010;
           rom[ 0+7867] ='b11011101;
           rom[ 0+7868] ='b10100110;
           rom[ 0+7869] ='b11110101;
           rom[ 0+7870] ='b01011111;
           rom[ 0+7871] ='b01111000;
           rom[ 0+7872] ='b10000011;
           rom[ 0+7873] ='b01000111;
           rom[ 0+7874] ='b11011101;
           rom[ 0+7875] ='b01111110;
           rom[ 0+7876] ='b11111011;
           rom[ 0+7877] ='b11011101;
           rom[ 0+7878] ='b10100110;
           rom[ 0+7879] ='b11110100;
           rom[ 0+7880] ='b01011111;
           rom[ 0+7881] ='b01111000;
           rom[ 0+7882] ='b10000011;
           rom[ 0+7883] ='b01000111;
           rom[ 0+7884] ='b11011101;
           rom[ 0+7885] ='b01111110;
           rom[ 0+7886] ='b11111100;
           rom[ 0+7887] ='b11011101;
           rom[ 0+7888] ='b10100110;
           rom[ 0+7889] ='b11110011;
           rom[ 0+7890] ='b01011111;
           rom[ 0+7891] ='b01111000;
           rom[ 0+7892] ='b10000011;
           rom[ 0+7893] ='b01000111;
           rom[ 0+7894] ='b11011101;
           rom[ 0+7895] ='b10000110;
           rom[ 0+7896] ='b11001111;
           rom[ 0+7897] ='b01000111;
           rom[ 0+7898] ='b11011101;
           rom[ 0+7899] ='b01111110;
           rom[ 0+7900] ='b11111101;
           rom[ 0+7901] ='b11011101;
           rom[ 0+7902] ='b10100110;
           rom[ 0+7903] ='b11110010;
           rom[ 0+7904] ='b01011111;
           rom[ 0+7905] ='b01111000;
           rom[ 0+7906] ='b10000011;
           rom[ 0+7907] ='b01000111;
           rom[ 0+7908] ='b11011101;
           rom[ 0+7909] ='b10000110;
           rom[ 0+7910] ='b11010010;
           rom[ 0+7911] ='b01000111;
           rom[ 0+7912] ='b10000010;
           rom[ 0+7913] ='b01010111;
           rom[ 0+7914] ='b11011101;
           rom[ 0+7915] ='b01111110;
           rom[ 0+7916] ='b11111110;
           rom[ 0+7917] ='b11011101;
           rom[ 0+7918] ='b10100110;
           rom[ 0+7919] ='b11110001;
           rom[ 0+7920] ='b01000111;
           rom[ 0+7921] ='b01111010;
           rom[ 0+7922] ='b10000000;
           rom[ 0+7923] ='b01010111;
           rom[ 0+7924] ='b11011101;
           rom[ 0+7925] ='b10000110;
           rom[ 0+7926] ='b11010001;
           rom[ 0+7927] ='b01010111;
           rom[ 0+7928] ='b10000001;
           rom[ 0+7929] ='b01001111;
           rom[ 0+7930] ='b11011101;
           rom[ 0+7931] ='b10000110;
           rom[ 0+7932] ='b11100011;
           rom[ 0+7933] ='b01001111;
           rom[ 0+7934] ='b11011101;
           rom[ 0+7935] ='b01111110;
           rom[ 0+7936] ='b11111111;
           rom[ 0+7937] ='b11011101;
           rom[ 0+7938] ='b10100110;
           rom[ 0+7939] ='b11110000;
           rom[ 0+7940] ='b01000111;
           rom[ 0+7941] ='b01111001;
           rom[ 0+7942] ='b10000000;
           rom[ 0+7943] ='b01001111;
           rom[ 0+7944] ='b11011101;
           rom[ 0+7945] ='b10000110;
           rom[ 0+7946] ='b11010000;
           rom[ 0+7947] ='b01001111;
           rom[ 0+7948] ='b11011101;
           rom[ 0+7949] ='b10000110;
           rom[ 0+7950] ='b11011110;
           rom[ 0+7951] ='b01001111;
           rom[ 0+7952] ='b11011101;
           rom[ 0+7953] ='b10000110;
           rom[ 0+7954] ='b11100000;
           rom[ 0+7955] ='b01001111;
           rom[ 0+7956] ='b00000110;
           rom[ 0+7957] ='b00000000;
           rom[ 0+7958] ='b01111001;
           rom[ 0+7959] ='b11100110;
           rom[ 0+7960] ='b00000001;
           rom[ 0+7961] ='b01001111;
           rom[ 0+7962] ='b00000110;
           rom[ 0+7963] ='b00000000;
           rom[ 0+7964] ='b00000110;
           rom[ 0+7965] ='b00000000;
           rom[ 0+7966] ='b11001011;
           rom[ 0+7967] ='b00100001;
           rom[ 0+7968] ='b11001011;
           rom[ 0+7969] ='b00010000;
           rom[ 0+7970] ='b11001011;
           rom[ 0+7971] ='b00100001;
           rom[ 0+7972] ='b11001011;
           rom[ 0+7973] ='b00010000;
           rom[ 0+7974] ='b11001011;
           rom[ 0+7975] ='b00100001;
           rom[ 0+7976] ='b11001011;
           rom[ 0+7977] ='b00010000;
           rom[ 0+7978] ='b11001011;
           rom[ 0+7979] ='b00100001;
           rom[ 0+7980] ='b11001011;
           rom[ 0+7981] ='b00010000;
           rom[ 0+7982] ='b11001011;
           rom[ 0+7983] ='b00100001;
           rom[ 0+7984] ='b11001011;
           rom[ 0+7985] ='b00010000;
           rom[ 0+7986] ='b11001011;
           rom[ 0+7987] ='b00100001;
           rom[ 0+7988] ='b11001011;
           rom[ 0+7989] ='b00010000;
           rom[ 0+7990] ='b11001011;
           rom[ 0+7991] ='b00100001;
           rom[ 0+7992] ='b11001011;
           rom[ 0+7993] ='b00010000;
           rom[ 0+7994] ='b01111001;
           rom[ 0+7995] ='b11100110;
           rom[ 0+7996] ='b10000000;
           rom[ 0+7997] ='b01001111;
           rom[ 0+7998] ='b00000110;
           rom[ 0+7999] ='b00000000;
           rom[ 0+8000] ='b11011101;
           rom[ 0+8001] ='b01011110;
           rom[ 0+8002] ='b11101001;
           rom[ 0+8003] ='b00010110;
           rom[ 0+8004] ='b00000000;
           rom[ 0+8005] ='b11001011;
           rom[ 0+8006] ='b00100011;
           rom[ 0+8007] ='b11001011;
           rom[ 0+8008] ='b00010010;
           rom[ 0+8009] ='b11001011;
           rom[ 0+8010] ='b00100011;
           rom[ 0+8011] ='b11001011;
           rom[ 0+8012] ='b00010010;
           rom[ 0+8013] ='b11001011;
           rom[ 0+8014] ='b00100011;
           rom[ 0+8015] ='b11001011;
           rom[ 0+8016] ='b00010010;
           rom[ 0+8017] ='b11001011;
           rom[ 0+8018] ='b00100011;
           rom[ 0+8019] ='b11001011;
           rom[ 0+8020] ='b00010010;
           rom[ 0+8021] ='b11001011;
           rom[ 0+8022] ='b00100011;
           rom[ 0+8023] ='b11001011;
           rom[ 0+8024] ='b00010010;
           rom[ 0+8025] ='b11001011;
           rom[ 0+8026] ='b00100011;
           rom[ 0+8027] ='b11001011;
           rom[ 0+8028] ='b00010010;
           rom[ 0+8029] ='b01111011;
           rom[ 0+8030] ='b11100110;
           rom[ 0+8031] ='b01000000;
           rom[ 0+8032] ='b01011111;
           rom[ 0+8033] ='b00010110;
           rom[ 0+8034] ='b00000000;
           rom[ 0+8035] ='b01111001;
           rom[ 0+8036] ='b10110011;
           rom[ 0+8037] ='b01001111;
           rom[ 0+8038] ='b01111000;
           rom[ 0+8039] ='b10110010;
           rom[ 0+8040] ='b01000111;
           rom[ 0+8041] ='b11011101;
           rom[ 0+8042] ='b01011110;
           rom[ 0+8043] ='b11101010;
           rom[ 0+8044] ='b00010110;
           rom[ 0+8045] ='b00000000;
           rom[ 0+8046] ='b11001011;
           rom[ 0+8047] ='b00100011;
           rom[ 0+8048] ='b11001011;
           rom[ 0+8049] ='b00010010;
           rom[ 0+8050] ='b11001011;
           rom[ 0+8051] ='b00100011;
           rom[ 0+8052] ='b11001011;
           rom[ 0+8053] ='b00010010;
           rom[ 0+8054] ='b11001011;
           rom[ 0+8055] ='b00100011;
           rom[ 0+8056] ='b11001011;
           rom[ 0+8057] ='b00010010;
           rom[ 0+8058] ='b11001011;
           rom[ 0+8059] ='b00100011;
           rom[ 0+8060] ='b11001011;
           rom[ 0+8061] ='b00010010;
           rom[ 0+8062] ='b11001011;
           rom[ 0+8063] ='b00100011;
           rom[ 0+8064] ='b11001011;
           rom[ 0+8065] ='b00010010;
           rom[ 0+8066] ='b01111011;
           rom[ 0+8067] ='b11100110;
           rom[ 0+8068] ='b00100000;
           rom[ 0+8069] ='b01011111;
           rom[ 0+8070] ='b00010110;
           rom[ 0+8071] ='b00000000;
           rom[ 0+8072] ='b01111001;
           rom[ 0+8073] ='b10110011;
           rom[ 0+8074] ='b01001111;
           rom[ 0+8075] ='b01111000;
           rom[ 0+8076] ='b10110010;
           rom[ 0+8077] ='b01000111;
           rom[ 0+8078] ='b11011101;
           rom[ 0+8079] ='b01011110;
           rom[ 0+8080] ='b11101011;
           rom[ 0+8081] ='b00010110;
           rom[ 0+8082] ='b00000000;
           rom[ 0+8083] ='b11001011;
           rom[ 0+8084] ='b00100011;
           rom[ 0+8085] ='b11001011;
           rom[ 0+8086] ='b00010010;
           rom[ 0+8087] ='b11001011;
           rom[ 0+8088] ='b00100011;
           rom[ 0+8089] ='b11001011;
           rom[ 0+8090] ='b00010010;
           rom[ 0+8091] ='b11001011;
           rom[ 0+8092] ='b00100011;
           rom[ 0+8093] ='b11001011;
           rom[ 0+8094] ='b00010010;
           rom[ 0+8095] ='b11001011;
           rom[ 0+8096] ='b00100011;
           rom[ 0+8097] ='b11001011;
           rom[ 0+8098] ='b00010010;
           rom[ 0+8099] ='b01111011;
           rom[ 0+8100] ='b11100110;
           rom[ 0+8101] ='b00010000;
           rom[ 0+8102] ='b01011111;
           rom[ 0+8103] ='b00010110;
           rom[ 0+8104] ='b00000000;
           rom[ 0+8105] ='b01111001;
           rom[ 0+8106] ='b10110011;
           rom[ 0+8107] ='b01001111;
           rom[ 0+8108] ='b01111000;
           rom[ 0+8109] ='b10110010;
           rom[ 0+8110] ='b01000111;
           rom[ 0+8111] ='b11011101;
           rom[ 0+8112] ='b01011110;
           rom[ 0+8113] ='b11101100;
           rom[ 0+8114] ='b00010110;
           rom[ 0+8115] ='b00000000;
           rom[ 0+8116] ='b11001011;
           rom[ 0+8117] ='b00100011;
           rom[ 0+8118] ='b11001011;
           rom[ 0+8119] ='b00010010;
           rom[ 0+8120] ='b11001011;
           rom[ 0+8121] ='b00100011;
           rom[ 0+8122] ='b11001011;
           rom[ 0+8123] ='b00010010;
           rom[ 0+8124] ='b11001011;
           rom[ 0+8125] ='b00100011;
           rom[ 0+8126] ='b11001011;
           rom[ 0+8127] ='b00010010;
           rom[ 0+8128] ='b01111011;
           rom[ 0+8129] ='b11100110;
           rom[ 0+8130] ='b00001000;
           rom[ 0+8131] ='b01011111;
           rom[ 0+8132] ='b00010110;
           rom[ 0+8133] ='b00000000;
           rom[ 0+8134] ='b01111001;
           rom[ 0+8135] ='b10110011;
           rom[ 0+8136] ='b01001111;
           rom[ 0+8137] ='b01111000;
           rom[ 0+8138] ='b10110010;
           rom[ 0+8139] ='b01000111;
           rom[ 0+8140] ='b11011101;
           rom[ 0+8141] ='b01011110;
           rom[ 0+8142] ='b11101101;
           rom[ 0+8143] ='b00010110;
           rom[ 0+8144] ='b00000000;
           rom[ 0+8145] ='b11001011;
           rom[ 0+8146] ='b00100011;
           rom[ 0+8147] ='b11001011;
           rom[ 0+8148] ='b00010010;
           rom[ 0+8149] ='b11001011;
           rom[ 0+8150] ='b00100011;
           rom[ 0+8151] ='b11001011;
           rom[ 0+8152] ='b00010010;
           rom[ 0+8153] ='b01111011;
           rom[ 0+8154] ='b11100110;
           rom[ 0+8155] ='b00000100;
           rom[ 0+8156] ='b01011111;
           rom[ 0+8157] ='b00010110;
           rom[ 0+8158] ='b00000000;
           rom[ 0+8159] ='b01111001;
           rom[ 0+8160] ='b10110011;
           rom[ 0+8161] ='b01001111;
           rom[ 0+8162] ='b01111000;
           rom[ 0+8163] ='b10110010;
           rom[ 0+8164] ='b01000111;
           rom[ 0+8165] ='b11011101;
           rom[ 0+8166] ='b01011110;
           rom[ 0+8167] ='b11101110;
           rom[ 0+8168] ='b00010110;
           rom[ 0+8169] ='b00000000;
           rom[ 0+8170] ='b11001011;
           rom[ 0+8171] ='b00100011;
           rom[ 0+8172] ='b11001011;
           rom[ 0+8173] ='b00010010;
           rom[ 0+8174] ='b01111011;
           rom[ 0+8175] ='b11100110;
           rom[ 0+8176] ='b00000010;
           rom[ 0+8177] ='b01011111;
           rom[ 0+8178] ='b00010110;
           rom[ 0+8179] ='b00000000;
           rom[ 0+8180] ='b01111001;
           rom[ 0+8181] ='b10110011;
           rom[ 0+8182] ='b01001111;
           rom[ 0+8183] ='b01111000;
           rom[ 0+8184] ='b10110010;
           rom[ 0+8185] ='b01000111;
           rom[ 0+8186] ='b11011101;
           rom[ 0+8187] ='b01111110;
           rom[ 0+8188] ='b11101111;
           rom[ 0+8189] ='b11100110;
           rom[ 0+8190] ='b00000001;
           rom[ 0+8191] ='b01011111;
           rom[ 0+8192] ='b00010110;
           rom[ 0+8193] ='b00000000;
           rom[ 0+8194] ='b01111001;
           rom[ 0+8195] ='b10110011;
           rom[ 0+8196] ='b01001111;
           rom[ 0+8197] ='b01111000;
           rom[ 0+8198] ='b10110010;
           rom[ 0+8199] ='b01000111;
           rom[ 0+8200] ='b01101001;
           rom[ 0+8201] ='b11011101;
           rom[ 0+8202] ='b11111001;
           rom[ 0+8203] ='b11011101;
           rom[ 0+8204] ='b11100001;
           rom[ 0+8205] ='b11001001;
           rom[ 0+8206] ='b11011101;
           rom[ 0+8207] ='b11100101;
           rom[ 0+8208] ='b11011101;
           rom[ 0+8209] ='b00100001;
           rom[ 0+8210] ='b00000000;
           rom[ 0+8211] ='b00000000;
           rom[ 0+8212] ='b11011101;
           rom[ 0+8213] ='b00111001;
           rom[ 0+8214] ='b11011101;
           rom[ 0+8215] ='b01111110;
           rom[ 0+8216] ='b00000100;
           rom[ 0+8217] ='b10110111;
           rom[ 0+8218] ='b11001010;
           rom[ 0+8219] ='b00100111;
           rom[ 0+8220] ='b00100000;
           rom[ 0+8221] ='b11011101;
           rom[ 0+8222] ='b01111110;
           rom[ 0+8223] ='b00000101;
           rom[ 0+8224] ='b10110111;
           rom[ 0+8225] ='b11001010;
           rom[ 0+8226] ='b00100111;
           rom[ 0+8227] ='b00100000;
           rom[ 0+8228] ='b11000011;
           rom[ 0+8229] ='b00101100;
           rom[ 0+8230] ='b00100000;
           rom[ 0+8231] ='b00101110;
           rom[ 0+8232] ='b00000000;
           rom[ 0+8233] ='b11000011;
           rom[ 0+8234] ='b01101100;
           rom[ 0+8235] ='b00100000;
           rom[ 0+8236] ='b00111110;
           rom[ 0+8237] ='b10011100;
           rom[ 0+8238] ='b11011101;
           rom[ 0+8239] ='b10000110;
           rom[ 0+8240] ='b00000100;
           rom[ 0+8241] ='b01001111;
           rom[ 0+8242] ='b00111110;
           rom[ 0+8243] ='b00000010;
           rom[ 0+8244] ='b11001110;
           rom[ 0+8245] ='b00000000;
           rom[ 0+8246] ='b01000111;
           rom[ 0+8247] ='b00001010;
           rom[ 0+8248] ='b01001111;
           rom[ 0+8249] ='b00000110;
           rom[ 0+8250] ='b00000000;
           rom[ 0+8251] ='b00111110;
           rom[ 0+8252] ='b10011100;
           rom[ 0+8253] ='b11011101;
           rom[ 0+8254] ='b10000110;
           rom[ 0+8255] ='b00000101;
           rom[ 0+8256] ='b01011111;
           rom[ 0+8257] ='b00111110;
           rom[ 0+8258] ='b00000010;
           rom[ 0+8259] ='b11001110;
           rom[ 0+8260] ='b00000000;
           rom[ 0+8261] ='b01010111;
           rom[ 0+8262] ='b00011010;
           rom[ 0+8263] ='b01011111;
           rom[ 0+8264] ='b00010110;
           rom[ 0+8265] ='b00000000;
           rom[ 0+8266] ='b01111001;
           rom[ 0+8267] ='b10000011;
           rom[ 0+8268] ='b01001111;
           rom[ 0+8269] ='b01111000;
           rom[ 0+8270] ='b10001010;
           rom[ 0+8271] ='b01000111;
           rom[ 0+8272] ='b11000101;
           rom[ 0+8273] ='b11111101;
           rom[ 0+8274] ='b11100001;
           rom[ 0+8275] ='b00100001;
           rom[ 0+8276] ='b11111111;
           rom[ 0+8277] ='b00000000;
           rom[ 0+8278] ='b11100101;
           rom[ 0+8279] ='b11111101;
           rom[ 0+8280] ='b11100101;
           rom[ 0+8281] ='b11001101;
           rom[ 0+8282] ='b01010011;
           rom[ 0+8283] ='b00111110;
           rom[ 0+8284] ='b01000100;
           rom[ 0+8285] ='b01001101;
           rom[ 0+8286] ='b11110001;
           rom[ 0+8287] ='b11110001;
           rom[ 0+8288] ='b00111110;
           rom[ 0+8289] ='b10011100;
           rom[ 0+8290] ='b10000001;
           rom[ 0+8291] ='b01001111;
           rom[ 0+8292] ='b00111110;
           rom[ 0+8293] ='b00000011;
           rom[ 0+8294] ='b11001110;
           rom[ 0+8295] ='b00000000;
           rom[ 0+8296] ='b01000111;
           rom[ 0+8297] ='b00001010;
           rom[ 0+8298] ='b01001111;
           rom[ 0+8299] ='b01101001;
           rom[ 0+8300] ='b11011101;
           rom[ 0+8301] ='b11100001;
           rom[ 0+8302] ='b11001001;
           rom[ 0+8303] ='b11011101;
           rom[ 0+8304] ='b11100101;
           rom[ 0+8305] ='b11011101;
           rom[ 0+8306] ='b00100001;
           rom[ 0+8307] ='b00000000;
           rom[ 0+8308] ='b00000000;
           rom[ 0+8309] ='b11011101;
           rom[ 0+8310] ='b00111001;
           rom[ 0+8311] ='b11011101;
           rom[ 0+8312] ='b01111110;
           rom[ 0+8313] ='b00000100;
           rom[ 0+8314] ='b10110111;
           rom[ 0+8315] ='b11001010;
           rom[ 0+8316] ='b10001000;
           rom[ 0+8317] ='b00100000;
           rom[ 0+8318] ='b11011101;
           rom[ 0+8319] ='b01111110;
           rom[ 0+8320] ='b00000101;
           rom[ 0+8321] ='b10110111;
           rom[ 0+8322] ='b11001010;
           rom[ 0+8323] ='b10001000;
           rom[ 0+8324] ='b00100000;
           rom[ 0+8325] ='b11000011;
           rom[ 0+8326] ='b10001101;
           rom[ 0+8327] ='b00100000;
           rom[ 0+8328] ='b00101110;
           rom[ 0+8329] ='b00000000;
           rom[ 0+8330] ='b11000011;
           rom[ 0+8331] ='b11011010;
           rom[ 0+8332] ='b00100000;
           rom[ 0+8333] ='b00111110;
           rom[ 0+8334] ='b10011100;
           rom[ 0+8335] ='b11011101;
           rom[ 0+8336] ='b10000110;
           rom[ 0+8337] ='b00000100;
           rom[ 0+8338] ='b01001111;
           rom[ 0+8339] ='b00111110;
           rom[ 0+8340] ='b00000010;
           rom[ 0+8341] ='b11001110;
           rom[ 0+8342] ='b00000000;
           rom[ 0+8343] ='b01000111;
           rom[ 0+8344] ='b00001010;
           rom[ 0+8345] ='b01001111;
           rom[ 0+8346] ='b00000110;
           rom[ 0+8347] ='b00000000;
           rom[ 0+8348] ='b00111110;
           rom[ 0+8349] ='b10011100;
           rom[ 0+8350] ='b11011101;
           rom[ 0+8351] ='b10000110;
           rom[ 0+8352] ='b00000101;
           rom[ 0+8353] ='b01011111;
           rom[ 0+8354] ='b00111110;
           rom[ 0+8355] ='b00000010;
           rom[ 0+8356] ='b11001110;
           rom[ 0+8357] ='b00000000;
           rom[ 0+8358] ='b01010111;
           rom[ 0+8359] ='b00011010;
           rom[ 0+8360] ='b01011111;
           rom[ 0+8361] ='b00010110;
           rom[ 0+8362] ='b00000000;
           rom[ 0+8363] ='b01111001;
           rom[ 0+8364] ='b10010011;
           rom[ 0+8365] ='b01001111;
           rom[ 0+8366] ='b01111000;
           rom[ 0+8367] ='b10011010;
           rom[ 0+8368] ='b01000111;
           rom[ 0+8369] ='b00111110;
           rom[ 0+8370] ='b00000000;
           rom[ 0+8371] ='b10010001;
           rom[ 0+8372] ='b00111110;
           rom[ 0+8373] ='b00000000;
           rom[ 0+8374] ='b10011000;
           rom[ 0+8375] ='b11111010;
           rom[ 0+8376] ='b11000010;
           rom[ 0+8377] ='b00100000;
           rom[ 0+8378] ='b01111001;
           rom[ 0+8379] ='b11000110;
           rom[ 0+8380] ='b11111111;
           rom[ 0+8381] ='b01001111;
           rom[ 0+8382] ='b01111000;
           rom[ 0+8383] ='b11001110;
           rom[ 0+8384] ='b00000000;
           rom[ 0+8385] ='b01000111;
           rom[ 0+8386] ='b00100001;
           rom[ 0+8387] ='b11111111;
           rom[ 0+8388] ='b00000000;
           rom[ 0+8389] ='b11100101;
           rom[ 0+8390] ='b11000101;
           rom[ 0+8391] ='b11001101;
           rom[ 0+8392] ='b01010011;
           rom[ 0+8393] ='b00111110;
           rom[ 0+8394] ='b01000100;
           rom[ 0+8395] ='b01001101;
           rom[ 0+8396] ='b11110001;
           rom[ 0+8397] ='b11110001;
           rom[ 0+8398] ='b00111110;
           rom[ 0+8399] ='b10011100;
           rom[ 0+8400] ='b10000001;
           rom[ 0+8401] ='b01001111;
           rom[ 0+8402] ='b00111110;
           rom[ 0+8403] ='b00000011;
           rom[ 0+8404] ='b11001110;
           rom[ 0+8405] ='b00000000;
           rom[ 0+8406] ='b01000111;
           rom[ 0+8407] ='b00001010;
           rom[ 0+8408] ='b01001111;
           rom[ 0+8409] ='b01101001;
           rom[ 0+8410] ='b11011101;
           rom[ 0+8411] ='b11100001;
           rom[ 0+8412] ='b11001001;
           rom[ 0+8413] ='b00000001;
           rom[ 0+8414] ='b00000000;
           rom[ 0+8415] ='b00000000;
           rom[ 0+8416] ='b01111001;
           rom[ 0+8417] ='b11010110;
           rom[ 0+8418] ='b00001000;
           rom[ 0+8419] ='b01111000;
           rom[ 0+8420] ='b11011110;
           rom[ 0+8421] ='b00000000;
           rom[ 0+8422] ='b11110010;
           rom[ 0+8423] ='b11110110;
           rom[ 0+8424] ='b00100000;
           rom[ 0+8425] ='b00100001;
           rom[ 0+8426] ='b11110100;
           rom[ 0+8427] ='b10000011;
           rom[ 0+8428] ='b00001001;
           rom[ 0+8429] ='b01011101;
           rom[ 0+8430] ='b01010100;
           rom[ 0+8431] ='b00111110;
           rom[ 0+8432] ='b00000000;
           rom[ 0+8433] ='b00010010;
           rom[ 0+8434] ='b00000011;
           rom[ 0+8435] ='b11000011;
           rom[ 0+8436] ='b11100000;
           rom[ 0+8437] ='b00100000;
           rom[ 0+8438] ='b11001001;
           rom[ 0+8439] ='b11001101;
           rom[ 0+8440] ='b11010111;
           rom[ 0+8441] ='b00110001;
           rom[ 0+8442] ='b00100001;
           rom[ 0+8443] ='b00000011;
           rom[ 0+8444] ='b00100001;
           rom[ 0+8445] ='b11100101;
           rom[ 0+8446] ='b11001101;
           rom[ 0+8447] ='b00001010;
           rom[ 0+8448] ='b00000010;
           rom[ 0+8449] ='b11110001;
           rom[ 0+8450] ='b11001001;
           rom[ 0+8451] ='b00100100;
           rom[ 0+8452] ='b01100110;
           rom[ 0+8453] ='b01101001;
           rom[ 0+8454] ='b01101110;
           rom[ 0+8455] ='b01101001;
           rom[ 0+8456] ='b01110011;
           rom[ 0+8457] ='b01101000;
           rom[ 0+8458] ='b00000000;
           rom[ 0+8459] ='b11011101;
           rom[ 0+8460] ='b11100101;
           rom[ 0+8461] ='b11011101;
           rom[ 0+8462] ='b00100001;
           rom[ 0+8463] ='b00000000;
           rom[ 0+8464] ='b00000000;
           rom[ 0+8465] ='b11011101;
           rom[ 0+8466] ='b00111001;
           rom[ 0+8467] ='b11011101;
           rom[ 0+8468] ='b01101110;
           rom[ 0+8469] ='b00000100;
           rom[ 0+8470] ='b11011101;
           rom[ 0+8471] ='b01100110;
           rom[ 0+8472] ='b00000101;
           rom[ 0+8473] ='b00101001;
           rom[ 0+8474] ='b11011101;
           rom[ 0+8475] ='b11100001;
           rom[ 0+8476] ='b11001001;
           rom[ 0+8477] ='b11011101;
           rom[ 0+8478] ='b11100101;
           rom[ 0+8479] ='b11011101;
           rom[ 0+8480] ='b00100001;
           rom[ 0+8481] ='b00000000;
           rom[ 0+8482] ='b00000000;
           rom[ 0+8483] ='b11011101;
           rom[ 0+8484] ='b00111001;
           rom[ 0+8485] ='b00100001;
           rom[ 0+8486] ='b11111101;
           rom[ 0+8487] ='b11111111;
           rom[ 0+8488] ='b00111001;
           rom[ 0+8489] ='b11111001;
           rom[ 0+8490] ='b11011101;
           rom[ 0+8491] ='b00110110;
           rom[ 0+8492] ='b11111110;
           rom[ 0+8493] ='b00000000;
           rom[ 0+8494] ='b11011101;
           rom[ 0+8495] ='b00110110;
           rom[ 0+8496] ='b11111111;
           rom[ 0+8497] ='b00000000;
           rom[ 0+8498] ='b00111110;
           rom[ 0+8499] ='b00000111;
           rom[ 0+8500] ='b11011101;
           rom[ 0+8501] ='b10010110;
           rom[ 0+8502] ='b11111110;
           rom[ 0+8503] ='b00111110;
           rom[ 0+8504] ='b00000000;
           rom[ 0+8505] ='b11011101;
           rom[ 0+8506] ='b10011110;
           rom[ 0+8507] ='b11111111;
           rom[ 0+8508] ='b11111010;
           rom[ 0+8509] ='b11101000;
           rom[ 0+8510] ='b00100001;
           rom[ 0+8511] ='b11011101;
           rom[ 0+8512] ='b01011110;
           rom[ 0+8513] ='b00000100;
           rom[ 0+8514] ='b00010110;
           rom[ 0+8515] ='b00000000;
           rom[ 0+8516] ='b11011101;
           rom[ 0+8517] ='b01111110;
           rom[ 0+8518] ='b11111110;
           rom[ 0+8519] ='b00111100;
           rom[ 0+8520] ='b11000011;
           rom[ 0+8521] ='b01001111;
           rom[ 0+8522] ='b00100001;
           rom[ 0+8523] ='b11001011;
           rom[ 0+8524] ='b00100011;
           rom[ 0+8525] ='b11001011;
           rom[ 0+8526] ='b00010010;
           rom[ 0+8527] ='b00111101;
           rom[ 0+8528] ='b11000010;
           rom[ 0+8529] ='b01001011;
           rom[ 0+8530] ='b00100001;
           rom[ 0+8531] ='b01111011;
           rom[ 0+8532] ='b11100110;
           rom[ 0+8533] ='b10000000;
           rom[ 0+8534] ='b01011111;
           rom[ 0+8535] ='b00010110;
           rom[ 0+8536] ='b00000000;
           rom[ 0+8537] ='b11011101;
           rom[ 0+8538] ='b01110011;
           rom[ 0+8539] ='b11111101;
           rom[ 0+8540] ='b00111110;
           rom[ 0+8541] ='b00010000;
           rom[ 0+8542] ='b11110101;
           rom[ 0+8543] ='b00110011;
           rom[ 0+8544] ='b00101010;
           rom[ 0+8545] ='b00110000;
           rom[ 0+8546] ='b10010000;
           rom[ 0+8547] ='b11100101;
           rom[ 0+8548] ='b00101010;
           rom[ 0+8549] ='b00101110;
           rom[ 0+8550] ='b10010000;
           rom[ 0+8551] ='b11100101;
           rom[ 0+8552] ='b11001101;
           rom[ 0+8553] ='b00101000;
           rom[ 0+8554] ='b00111111;
           rom[ 0+8555] ='b01000010;
           rom[ 0+8556] ='b01001011;
           rom[ 0+8557] ='b01011100;
           rom[ 0+8558] ='b01010101;
           rom[ 0+8559] ='b11110001;
           rom[ 0+8560] ='b11110001;
           rom[ 0+8561] ='b00110011;
           rom[ 0+8562] ='b01111010;
           rom[ 0+8563] ='b11100110;
           rom[ 0+8564] ='b10000000;
           rom[ 0+8565] ='b01010111;
           rom[ 0+8566] ='b00011110;
           rom[ 0+8567] ='b00000000;
           rom[ 0+8568] ='b00000001;
           rom[ 0+8569] ='b00000000;
           rom[ 0+8570] ='b00000000;
           rom[ 0+8571] ='b11011101;
           rom[ 0+8572] ='b01111110;
           rom[ 0+8573] ='b11111101;
           rom[ 0+8574] ='b10101010;
           rom[ 0+8575] ='b10110111;
           rom[ 0+8576] ='b11001010;
           rom[ 0+8577] ='b10110111;
           rom[ 0+8578] ='b00100001;
           rom[ 0+8579] ='b00111110;
           rom[ 0+8580] ='b00000001;
           rom[ 0+8581] ='b11110101;
           rom[ 0+8582] ='b00110011;
           rom[ 0+8583] ='b00101010;
           rom[ 0+8584] ='b00110000;
           rom[ 0+8585] ='b10010000;
           rom[ 0+8586] ='b11100101;
           rom[ 0+8587] ='b00101010;
           rom[ 0+8588] ='b00101110;
           rom[ 0+8589] ='b10010000;
           rom[ 0+8590] ='b11100101;
           rom[ 0+8591] ='b11001101;
           rom[ 0+8592] ='b01100010;
           rom[ 0+8593] ='b00111111;
           rom[ 0+8594] ='b01000100;
           rom[ 0+8595] ='b01001101;
           rom[ 0+8596] ='b11110001;
           rom[ 0+8597] ='b11110001;
           rom[ 0+8598] ='b00110011;
           rom[ 0+8599] ='b01111001;
           rom[ 0+8600] ='b11101110;
           rom[ 0+8601] ='b11001101;
           rom[ 0+8602] ='b01001111;
           rom[ 0+8603] ='b01111000;
           rom[ 0+8604] ='b11101110;
           rom[ 0+8605] ='b00101000;
           rom[ 0+8606] ='b01000111;
           rom[ 0+8607] ='b01111011;
           rom[ 0+8608] ='b11101110;
           rom[ 0+8609] ='b01101001;
           rom[ 0+8610] ='b01011111;
           rom[ 0+8611] ='b11111101;
           rom[ 0+8612] ='b00100001;
           rom[ 0+8613] ='b00101110;
           rom[ 0+8614] ='b10010000;
           rom[ 0+8615] ='b11111101;
           rom[ 0+8616] ='b01110001;
           rom[ 0+8617] ='b00000000;
           rom[ 0+8618] ='b11111101;
           rom[ 0+8619] ='b01110000;
           rom[ 0+8620] ='b00000001;
           rom[ 0+8621] ='b11111101;
           rom[ 0+8622] ='b01110011;
           rom[ 0+8623] ='b00000010;
           rom[ 0+8624] ='b11111101;
           rom[ 0+8625] ='b00110110;
           rom[ 0+8626] ='b00000011;
           rom[ 0+8627] ='b00000000;
           rom[ 0+8628] ='b11000011;
           rom[ 0+8629] ='b11011100;
           rom[ 0+8630] ='b00100001;
           rom[ 0+8631] ='b00111110;
           rom[ 0+8632] ='b00000001;
           rom[ 0+8633] ='b11110101;
           rom[ 0+8634] ='b00110011;
           rom[ 0+8635] ='b00101010;
           rom[ 0+8636] ='b00110000;
           rom[ 0+8637] ='b10010000;
           rom[ 0+8638] ='b11100101;
           rom[ 0+8639] ='b00101010;
           rom[ 0+8640] ='b00101110;
           rom[ 0+8641] ='b10010000;
           rom[ 0+8642] ='b11100101;
           rom[ 0+8643] ='b11001101;
           rom[ 0+8644] ='b01100010;
           rom[ 0+8645] ='b00111111;
           rom[ 0+8646] ='b01000100;
           rom[ 0+8647] ='b01001101;
           rom[ 0+8648] ='b11110001;
           rom[ 0+8649] ='b11110001;
           rom[ 0+8650] ='b00110011;
           rom[ 0+8651] ='b11111101;
           rom[ 0+8652] ='b00100001;
           rom[ 0+8653] ='b00101110;
           rom[ 0+8654] ='b10010000;
           rom[ 0+8655] ='b11111101;
           rom[ 0+8656] ='b01110001;
           rom[ 0+8657] ='b00000000;
           rom[ 0+8658] ='b11111101;
           rom[ 0+8659] ='b01110000;
           rom[ 0+8660] ='b00000001;
           rom[ 0+8661] ='b11111101;
           rom[ 0+8662] ='b01110011;
           rom[ 0+8663] ='b00000010;
           rom[ 0+8664] ='b11111101;
           rom[ 0+8665] ='b00110110;
           rom[ 0+8666] ='b00000011;
           rom[ 0+8667] ='b00000000;
           rom[ 0+8668] ='b11011101;
           rom[ 0+8669] ='b00110100;
           rom[ 0+8670] ='b11111110;
           rom[ 0+8671] ='b11000010;
           rom[ 0+8672] ='b11100101;
           rom[ 0+8673] ='b00100001;
           rom[ 0+8674] ='b11011101;
           rom[ 0+8675] ='b00110100;
           rom[ 0+8676] ='b11111111;
           rom[ 0+8677] ='b11000011;
           rom[ 0+8678] ='b00110010;
           rom[ 0+8679] ='b00100001;
           rom[ 0+8680] ='b11011101;
           rom[ 0+8681] ='b11111001;
           rom[ 0+8682] ='b11011101;
           rom[ 0+8683] ='b11100001;
           rom[ 0+8684] ='b11001001;
           rom[ 0+8685] ='b11011101;
           rom[ 0+8686] ='b11100101;
           rom[ 0+8687] ='b11011101;
           rom[ 0+8688] ='b00100001;
           rom[ 0+8689] ='b00000000;
           rom[ 0+8690] ='b00000000;
           rom[ 0+8691] ='b11011101;
           rom[ 0+8692] ='b00111001;
           rom[ 0+8693] ='b00100001;
           rom[ 0+8694] ='b11111100;
           rom[ 0+8695] ='b11111111;
           rom[ 0+8696] ='b00111001;
           rom[ 0+8697] ='b11111001;
           rom[ 0+8698] ='b11011101;
           rom[ 0+8699] ='b01011110;
           rom[ 0+8700] ='b00000111;
           rom[ 0+8701] ='b11011101;
           rom[ 0+8702] ='b01010110;
           rom[ 0+8703] ='b00001000;
           rom[ 0+8704] ='b01101011;
           rom[ 0+8705] ='b01100010;
           rom[ 0+8706] ='b00101001;
           rom[ 0+8707] ='b00011001;
           rom[ 0+8708] ='b00101001;
           rom[ 0+8709] ='b00101001;
           rom[ 0+8710] ='b00011001;
           rom[ 0+8711] ='b01001101;
           rom[ 0+8712] ='b01000100;
           rom[ 0+8713] ='b00100001;
           rom[ 0+8714] ='b00000011;
           rom[ 0+8715] ='b10000100;
           rom[ 0+8716] ='b00001001;
           rom[ 0+8717] ='b01001101;
           rom[ 0+8718] ='b01000100;
           rom[ 0+8719] ='b01111001;
           rom[ 0+8720] ='b11000110;
           rom[ 0+8721] ='b00000100;
           rom[ 0+8722] ='b11011101;
           rom[ 0+8723] ='b01110111;
           rom[ 0+8724] ='b11111110;
           rom[ 0+8725] ='b01111000;
           rom[ 0+8726] ='b11001110;
           rom[ 0+8727] ='b00000000;
           rom[ 0+8728] ='b11011101;
           rom[ 0+8729] ='b01110111;
           rom[ 0+8730] ='b11111111;
           rom[ 0+8731] ='b11011101;
           rom[ 0+8732] ='b01111110;
           rom[ 0+8733] ='b00000101;
           rom[ 0+8734] ='b11000110;
           rom[ 0+8735] ='b11111111;
           rom[ 0+8736] ='b11011101;
           rom[ 0+8737] ='b01110111;
           rom[ 0+8738] ='b11111100;
           rom[ 0+8739] ='b11011101;
           rom[ 0+8740] ='b01111110;
           rom[ 0+8741] ='b00000110;
           rom[ 0+8742] ='b11001110;
           rom[ 0+8743] ='b11111111;
           rom[ 0+8744] ='b11011101;
           rom[ 0+8745] ='b01110111;
           rom[ 0+8746] ='b11111101;
           rom[ 0+8747] ='b11011101;
           rom[ 0+8748] ='b01011110;
           rom[ 0+8749] ='b00000100;
           rom[ 0+8750] ='b00010110;
           rom[ 0+8751] ='b00000000;
           rom[ 0+8752] ='b11011101;
           rom[ 0+8753] ='b01111110;
           rom[ 0+8754] ='b11111100;
           rom[ 0+8755] ='b10010011;
           rom[ 0+8756] ='b01011111;
           rom[ 0+8757] ='b11011101;
           rom[ 0+8758] ='b01111110;
           rom[ 0+8759] ='b11111101;
           rom[ 0+8760] ='b10011010;
           rom[ 0+8761] ='b01010111;
           rom[ 0+8762] ='b11011101;
           rom[ 0+8763] ='b01101110;
           rom[ 0+8764] ='b11111110;
           rom[ 0+8765] ='b11011101;
           rom[ 0+8766] ='b01100110;
           rom[ 0+8767] ='b11111111;
           rom[ 0+8768] ='b01110011;
           rom[ 0+8769] ='b00100011;
           rom[ 0+8770] ='b01110010;
           rom[ 0+8771] ='b01111001;
           rom[ 0+8772] ='b11000110;
           rom[ 0+8773] ='b00001010;
           rom[ 0+8774] ='b01001111;
           rom[ 0+8775] ='b01111000;
           rom[ 0+8776] ='b11001110;
           rom[ 0+8777] ='b00000000;
           rom[ 0+8778] ='b01000111;
           rom[ 0+8779] ='b11011101;
           rom[ 0+8780] ='b01011110;
           rom[ 0+8781] ='b00000111;
           rom[ 0+8782] ='b11011101;
           rom[ 0+8783] ='b01010110;
           rom[ 0+8784] ='b00001000;
           rom[ 0+8785] ='b01101011;
           rom[ 0+8786] ='b01100010;
           rom[ 0+8787] ='b00101001;
           rom[ 0+8788] ='b00011001;
           rom[ 0+8789] ='b00101001;
           rom[ 0+8790] ='b00011001;
           rom[ 0+8791] ='b01011101;
           rom[ 0+8792] ='b01010100;
           rom[ 0+8793] ='b00100001;
           rom[ 0+8794] ='b00000110;
           rom[ 0+8795] ='b10010000;
           rom[ 0+8796] ='b00011001;
           rom[ 0+8797] ='b01011101;
           rom[ 0+8798] ='b01010100;
           rom[ 0+8799] ='b00011010;
           rom[ 0+8800] ='b00000010;
           rom[ 0+8801] ='b11011101;
           rom[ 0+8802] ='b11111001;
           rom[ 0+8803] ='b11011101;
           rom[ 0+8804] ='b11100001;
           rom[ 0+8805] ='b11001001;
           rom[ 0+8806] ='b11011101;
           rom[ 0+8807] ='b11100101;
           rom[ 0+8808] ='b11011101;
           rom[ 0+8809] ='b00100001;
           rom[ 0+8810] ='b00000000;
           rom[ 0+8811] ='b00000000;
           rom[ 0+8812] ='b11011101;
           rom[ 0+8813] ='b00111001;
           rom[ 0+8814] ='b00100001;
           rom[ 0+8815] ='b11100110;
           rom[ 0+8816] ='b11111111;
           rom[ 0+8817] ='b00111001;
           rom[ 0+8818] ='b11111001;
           rom[ 0+8819] ='b11011101;
           rom[ 0+8820] ='b01011110;
           rom[ 0+8821] ='b00000110;
           rom[ 0+8822] ='b11011101;
           rom[ 0+8823] ='b01010110;
           rom[ 0+8824] ='b00000111;
           rom[ 0+8825] ='b01101011;
           rom[ 0+8826] ='b01100010;
           rom[ 0+8827] ='b00101001;
           rom[ 0+8828] ='b00011001;
           rom[ 0+8829] ='b00101001;
           rom[ 0+8830] ='b00011001;
           rom[ 0+8831] ='b11011101;
           rom[ 0+8832] ='b01110101;
           rom[ 0+8833] ='b11100110;
           rom[ 0+8834] ='b11011101;
           rom[ 0+8835] ='b01110100;
           rom[ 0+8836] ='b11100111;
           rom[ 0+8837] ='b00111110;
           rom[ 0+8838] ='b00000110;
           rom[ 0+8839] ='b11011101;
           rom[ 0+8840] ='b10000110;
           rom[ 0+8841] ='b11100110;
           rom[ 0+8842] ='b01001111;
           rom[ 0+8843] ='b00111110;
           rom[ 0+8844] ='b10010000;
           rom[ 0+8845] ='b11011101;
           rom[ 0+8846] ='b10001110;
           rom[ 0+8847] ='b11100111;
           rom[ 0+8848] ='b01000111;
           rom[ 0+8849] ='b01111001;
           rom[ 0+8850] ='b11000110;
           rom[ 0+8851] ='b00000011;
           rom[ 0+8852] ='b01011111;
           rom[ 0+8853] ='b01111000;
           rom[ 0+8854] ='b11001110;
           rom[ 0+8855] ='b00000000;
           rom[ 0+8856] ='b01010111;
           rom[ 0+8857] ='b00011010;
           rom[ 0+8858] ='b01011111;
           rom[ 0+8859] ='b00001010;
           rom[ 0+8860] ='b01010111;
           rom[ 0+8861] ='b01111011;
           rom[ 0+8862] ='b11110101;
           rom[ 0+8863] ='b00110011;
           rom[ 0+8864] ='b11010101;
           rom[ 0+8865] ='b00110011;
           rom[ 0+8866] ='b11001101;
           rom[ 0+8867] ='b00001110;
           rom[ 0+8868] ='b00100000;
           rom[ 0+8869] ='b01011101;
           rom[ 0+8870] ='b11110001;
           rom[ 0+8871] ='b01001011;
           rom[ 0+8872] ='b00111110;
           rom[ 0+8873] ='b00000110;
           rom[ 0+8874] ='b11011101;
           rom[ 0+8875] ='b10000110;
           rom[ 0+8876] ='b11100110;
           rom[ 0+8877] ='b11011101;
           rom[ 0+8878] ='b01110111;
           rom[ 0+8879] ='b11101001;
           rom[ 0+8880] ='b00111110;
           rom[ 0+8881] ='b10010000;
           rom[ 0+8882] ='b11011101;
           rom[ 0+8883] ='b10001110;
           rom[ 0+8884] ='b11100111;
           rom[ 0+8885] ='b11011101;
           rom[ 0+8886] ='b01110111;
           rom[ 0+8887] ='b11101010;
           rom[ 0+8888] ='b11011101;
           rom[ 0+8889] ='b01011110;
           rom[ 0+8890] ='b11101001;
           rom[ 0+8891] ='b11011101;
           rom[ 0+8892] ='b01010110;
           rom[ 0+8893] ='b11101010;
           rom[ 0+8894] ='b00010011;
           rom[ 0+8895] ='b00010011;
           rom[ 0+8896] ='b00011010;
           rom[ 0+8897] ='b01011111;
           rom[ 0+8898] ='b11011101;
           rom[ 0+8899] ='b01101110;
           rom[ 0+8900] ='b11101001;
           rom[ 0+8901] ='b11011101;
           rom[ 0+8902] ='b01100110;
           rom[ 0+8903] ='b11101010;
           rom[ 0+8904] ='b01010110;
           rom[ 0+8905] ='b11000101;
           rom[ 0+8906] ='b01111011;
           rom[ 0+8907] ='b11110101;
           rom[ 0+8908] ='b00110011;
           rom[ 0+8909] ='b11010101;
           rom[ 0+8910] ='b00110011;
           rom[ 0+8911] ='b11001101;
           rom[ 0+8912] ='b00001110;
           rom[ 0+8913] ='b00100000;
           rom[ 0+8914] ='b01011101;
           rom[ 0+8915] ='b11110001;
           rom[ 0+8916] ='b11000001;
           rom[ 0+8917] ='b01000011;
           rom[ 0+8918] ='b00111110;
           rom[ 0+8919] ='b00000110;
           rom[ 0+8920] ='b11011101;
           rom[ 0+8921] ='b10000110;
           rom[ 0+8922] ='b11100110;
           rom[ 0+8923] ='b01010111;
           rom[ 0+8924] ='b00111110;
           rom[ 0+8925] ='b10010000;
           rom[ 0+8926] ='b11011101;
           rom[ 0+8927] ='b10001110;
           rom[ 0+8928] ='b11100111;
           rom[ 0+8929] ='b01011111;
           rom[ 0+8930] ='b00010100;
           rom[ 0+8931] ='b11000010;
           rom[ 0+8932] ='b11100111;
           rom[ 0+8933] ='b00100010;
           rom[ 0+8934] ='b00011100;
           rom[ 0+8935] ='b01101010;
           rom[ 0+8936] ='b01100011;
           rom[ 0+8937] ='b01010110;
           rom[ 0+8938] ='b11000101;
           rom[ 0+8939] ='b11010101;
           rom[ 0+8940] ='b00110011;
           rom[ 0+8941] ='b11010101;
           rom[ 0+8942] ='b00110011;
           rom[ 0+8943] ='b11001101;
           rom[ 0+8944] ='b00001110;
           rom[ 0+8945] ='b00100000;
           rom[ 0+8946] ='b01011101;
           rom[ 0+8947] ='b11110001;
           rom[ 0+8948] ='b11000001;
           rom[ 0+8949] ='b11011101;
           rom[ 0+8950] ='b01110011;
           rom[ 0+8951] ='b11111111;
           rom[ 0+8952] ='b00111110;
           rom[ 0+8953] ='b00000110;
           rom[ 0+8954] ='b11011101;
           rom[ 0+8955] ='b10000110;
           rom[ 0+8956] ='b11100110;
           rom[ 0+8957] ='b11011101;
           rom[ 0+8958] ='b01110111;
           rom[ 0+8959] ='b11101001;
           rom[ 0+8960] ='b00111110;
           rom[ 0+8961] ='b10010000;
           rom[ 0+8962] ='b11011101;
           rom[ 0+8963] ='b10001110;
           rom[ 0+8964] ='b11100111;
           rom[ 0+8965] ='b11011101;
           rom[ 0+8966] ='b01110111;
           rom[ 0+8967] ='b11101010;
           rom[ 0+8968] ='b11011101;
           rom[ 0+8969] ='b01111110;
           rom[ 0+8970] ='b11101001;
           rom[ 0+8971] ='b11000110;
           rom[ 0+8972] ='b00000011;
           rom[ 0+8973] ='b01011111;
           rom[ 0+8974] ='b11011101;
           rom[ 0+8975] ='b01111110;
           rom[ 0+8976] ='b11101010;
           rom[ 0+8977] ='b11001110;
           rom[ 0+8978] ='b00000000;
           rom[ 0+8979] ='b01010111;
           rom[ 0+8980] ='b00011010;
           rom[ 0+8981] ='b11011101;
           rom[ 0+8982] ='b01110111;
           rom[ 0+8983] ='b11101000;
           rom[ 0+8984] ='b11011101;
           rom[ 0+8985] ='b01111110;
           rom[ 0+8986] ='b11101001;
           rom[ 0+8987] ='b11000110;
           rom[ 0+8988] ='b00000001;
           rom[ 0+8989] ='b01010111;
           rom[ 0+8990] ='b11011101;
           rom[ 0+8991] ='b01111110;
           rom[ 0+8992] ='b11101010;
           rom[ 0+8993] ='b11001110;
           rom[ 0+8994] ='b00000000;
           rom[ 0+8995] ='b01011111;
           rom[ 0+8996] ='b01101010;
           rom[ 0+8997] ='b01100011;
           rom[ 0+8998] ='b01010110;
           rom[ 0+8999] ='b11000101;
           rom[ 0+9000] ='b11011101;
           rom[ 0+9001] ='b01111110;
           rom[ 0+9002] ='b11101000;
           rom[ 0+9003] ='b11110101;
           rom[ 0+9004] ='b00110011;
           rom[ 0+9005] ='b11010101;
           rom[ 0+9006] ='b00110011;
           rom[ 0+9007] ='b11001101;
           rom[ 0+9008] ='b00001110;
           rom[ 0+9009] ='b00100000;
           rom[ 0+9010] ='b01011101;
           rom[ 0+9011] ='b11110001;
           rom[ 0+9012] ='b11000001;
           rom[ 0+9013] ='b11011101;
           rom[ 0+9014] ='b01110011;
           rom[ 0+9015] ='b11111110;
           rom[ 0+9016] ='b00111110;
           rom[ 0+9017] ='b00000110;
           rom[ 0+9018] ='b11011101;
           rom[ 0+9019] ='b10000110;
           rom[ 0+9020] ='b11100110;
           rom[ 0+9021] ='b11011101;
           rom[ 0+9022] ='b01110111;
           rom[ 0+9023] ='b11101001;
           rom[ 0+9024] ='b00111110;
           rom[ 0+9025] ='b10010000;
           rom[ 0+9026] ='b11011101;
           rom[ 0+9027] ='b10001110;
           rom[ 0+9028] ='b11100111;
           rom[ 0+9029] ='b11011101;
           rom[ 0+9030] ='b01110111;
           rom[ 0+9031] ='b11101010;
           rom[ 0+9032] ='b11011101;
           rom[ 0+9033] ='b01011110;
           rom[ 0+9034] ='b11101001;
           rom[ 0+9035] ='b11011101;
           rom[ 0+9036] ='b01010110;
           rom[ 0+9037] ='b11101010;
           rom[ 0+9038] ='b00010011;
           rom[ 0+9039] ='b00010011;
           rom[ 0+9040] ='b00011010;
           rom[ 0+9041] ='b11011101;
           rom[ 0+9042] ='b01110111;
           rom[ 0+9043] ='b11101000;
           rom[ 0+9044] ='b11011101;
           rom[ 0+9045] ='b01111110;
           rom[ 0+9046] ='b11101001;
           rom[ 0+9047] ='b11000110;
           rom[ 0+9048] ='b00000001;
           rom[ 0+9049] ='b01010111;
           rom[ 0+9050] ='b11011101;
           rom[ 0+9051] ='b01111110;
           rom[ 0+9052] ='b11101010;
           rom[ 0+9053] ='b11001110;
           rom[ 0+9054] ='b00000000;
           rom[ 0+9055] ='b01011111;
           rom[ 0+9056] ='b01101010;
           rom[ 0+9057] ='b01100011;
           rom[ 0+9058] ='b01010110;
           rom[ 0+9059] ='b11000101;
           rom[ 0+9060] ='b11011101;
           rom[ 0+9061] ='b01111110;
           rom[ 0+9062] ='b11101000;
           rom[ 0+9063] ='b11110101;
           rom[ 0+9064] ='b00110011;
           rom[ 0+9065] ='b11010101;
           rom[ 0+9066] ='b00110011;
           rom[ 0+9067] ='b11001101;
           rom[ 0+9068] ='b00001110;
           rom[ 0+9069] ='b00100000;
           rom[ 0+9070] ='b01011101;
           rom[ 0+9071] ='b11110001;
           rom[ 0+9072] ='b11000001;
           rom[ 0+9073] ='b11011101;
           rom[ 0+9074] ='b01110011;
           rom[ 0+9075] ='b11111101;
           rom[ 0+9076] ='b00111110;
           rom[ 0+9077] ='b00000110;
           rom[ 0+9078] ='b11011101;
           rom[ 0+9079] ='b10000110;
           rom[ 0+9080] ='b11100110;
           rom[ 0+9081] ='b01010111;
           rom[ 0+9082] ='b00111110;
           rom[ 0+9083] ='b10010000;
           rom[ 0+9084] ='b11011101;
           rom[ 0+9085] ='b10001110;
           rom[ 0+9086] ='b11100111;
           rom[ 0+9087] ='b01011111;
           rom[ 0+9088] ='b01111010;
           rom[ 0+9089] ='b11000110;
           rom[ 0+9090] ='b00000010;
           rom[ 0+9091] ='b01010111;
           rom[ 0+9092] ='b01111011;
           rom[ 0+9093] ='b11001110;
           rom[ 0+9094] ='b00000000;
           rom[ 0+9095] ='b01011111;
           rom[ 0+9096] ='b01101010;
           rom[ 0+9097] ='b01100011;
           rom[ 0+9098] ='b01010110;
           rom[ 0+9099] ='b11000101;
           rom[ 0+9100] ='b11010101;
           rom[ 0+9101] ='b00110011;
           rom[ 0+9102] ='b11010101;
           rom[ 0+9103] ='b00110011;
           rom[ 0+9104] ='b11001101;
           rom[ 0+9105] ='b00001110;
           rom[ 0+9106] ='b00100000;
           rom[ 0+9107] ='b01011101;
           rom[ 0+9108] ='b11110001;
           rom[ 0+9109] ='b11000001;
           rom[ 0+9110] ='b01111001;
           rom[ 0+9111] ='b11011101;
           rom[ 0+9112] ='b10101110;
           rom[ 0+9113] ='b11111101;
           rom[ 0+9114] ='b01010111;
           rom[ 0+9115] ='b01111011;
           rom[ 0+9116] ='b11011101;
           rom[ 0+9117] ='b10101110;
           rom[ 0+9118] ='b11111110;
           rom[ 0+9119] ='b01011111;
           rom[ 0+9120] ='b11011101;
           rom[ 0+9121] ='b01110011;
           rom[ 0+9122] ='b11111001;
           rom[ 0+9123] ='b01111000;
           rom[ 0+9124] ='b11011101;
           rom[ 0+9125] ='b10101110;
           rom[ 0+9126] ='b11111111;
           rom[ 0+9127] ='b01001111;
           rom[ 0+9128] ='b11011101;
           rom[ 0+9129] ='b01110001;
           rom[ 0+9130] ='b11111010;
           rom[ 0+9131] ='b01111010;
           rom[ 0+9132] ='b10110111;
           rom[ 0+9133] ='b11001010;
           rom[ 0+9134] ='b10110011;
           rom[ 0+9135] ='b00100011;
           rom[ 0+9136] ='b11000011;
           rom[ 0+9137] ='b11010100;
           rom[ 0+9138] ='b00100011;
           rom[ 0+9139] ='b11011101;
           rom[ 0+9140] ='b01011110;
           rom[ 0+9141] ='b00000110;
           rom[ 0+9142] ='b11011101;
           rom[ 0+9143] ='b01010110;
           rom[ 0+9144] ='b00000111;
           rom[ 0+9145] ='b01101011;
           rom[ 0+9146] ='b01100010;
           rom[ 0+9147] ='b00101001;
           rom[ 0+9148] ='b00011001;
           rom[ 0+9149] ='b00101001;
           rom[ 0+9150] ='b00101001;
           rom[ 0+9151] ='b00011001;
           rom[ 0+9152] ='b01001101;
           rom[ 0+9153] ='b01000100;
           rom[ 0+9154] ='b00100001;
           rom[ 0+9155] ='b00000011;
           rom[ 0+9156] ='b10000100;
           rom[ 0+9157] ='b00001001;
           rom[ 0+9158] ='b11011101;
           rom[ 0+9159] ='b01110101;
           rom[ 0+9160] ='b11101001;
           rom[ 0+9161] ='b11011101;
           rom[ 0+9162] ='b01110100;
           rom[ 0+9163] ='b11101010;
           rom[ 0+9164] ='b00110110;
           rom[ 0+9165] ='b00000011;
           rom[ 0+9166] ='b00100011;
           rom[ 0+9167] ='b00110110;
           rom[ 0+9168] ='b00000000;
           rom[ 0+9169] ='b11000011;
           rom[ 0+9170] ='b10100011;
           rom[ 0+9171] ='b00100111;
           rom[ 0+9172] ='b11011101;
           rom[ 0+9173] ='b01111110;
           rom[ 0+9174] ='b11111001;
           rom[ 0+9175] ='b10110111;
           rom[ 0+9176] ='b11001010;
           rom[ 0+9177] ='b11011110;
           rom[ 0+9178] ='b00100011;
           rom[ 0+9179] ='b11000011;
           rom[ 0+9180] ='b11111111;
           rom[ 0+9181] ='b00100011;
           rom[ 0+9182] ='b11011101;
           rom[ 0+9183] ='b01011110;
           rom[ 0+9184] ='b00000110;
           rom[ 0+9185] ='b11011101;
           rom[ 0+9186] ='b01010110;
           rom[ 0+9187] ='b00000111;
           rom[ 0+9188] ='b01101011;
           rom[ 0+9189] ='b01100010;
           rom[ 0+9190] ='b00101001;
           rom[ 0+9191] ='b00011001;
           rom[ 0+9192] ='b00101001;
           rom[ 0+9193] ='b00101001;
           rom[ 0+9194] ='b00011001;
           rom[ 0+9195] ='b01001101;
           rom[ 0+9196] ='b01000100;
           rom[ 0+9197] ='b00100001;
           rom[ 0+9198] ='b00000011;
           rom[ 0+9199] ='b10000100;
           rom[ 0+9200] ='b00001001;
           rom[ 0+9201] ='b11011101;
           rom[ 0+9202] ='b01110101;
           rom[ 0+9203] ='b11101001;
           rom[ 0+9204] ='b11011101;
           rom[ 0+9205] ='b01110100;
           rom[ 0+9206] ='b11101010;
           rom[ 0+9207] ='b00110110;
           rom[ 0+9208] ='b00000011;
           rom[ 0+9209] ='b00100011;
           rom[ 0+9210] ='b00110110;
           rom[ 0+9211] ='b00000000;
           rom[ 0+9212] ='b11000011;
           rom[ 0+9213] ='b10100011;
           rom[ 0+9214] ='b00100111;
           rom[ 0+9215] ='b11011101;
           rom[ 0+9216] ='b01111110;
           rom[ 0+9217] ='b11111010;
           rom[ 0+9218] ='b10110111;
           rom[ 0+9219] ='b11001010;
           rom[ 0+9220] ='b00001001;
           rom[ 0+9221] ='b00100100;
           rom[ 0+9222] ='b11000011;
           rom[ 0+9223] ='b00101010;
           rom[ 0+9224] ='b00100100;
           rom[ 0+9225] ='b11011101;
           rom[ 0+9226] ='b01011110;
           rom[ 0+9227] ='b00000110;
           rom[ 0+9228] ='b11011101;
           rom[ 0+9229] ='b01010110;
           rom[ 0+9230] ='b00000111;
           rom[ 0+9231] ='b01101011;
           rom[ 0+9232] ='b01100010;
           rom[ 0+9233] ='b00101001;
           rom[ 0+9234] ='b00011001;
           rom[ 0+9235] ='b00101001;
           rom[ 0+9236] ='b00101001;
           rom[ 0+9237] ='b00011001;
           rom[ 0+9238] ='b01001101;
           rom[ 0+9239] ='b01000100;
           rom[ 0+9240] ='b00100001;
           rom[ 0+9241] ='b00000011;
           rom[ 0+9242] ='b10000100;
           rom[ 0+9243] ='b00001001;
           rom[ 0+9244] ='b11011101;
           rom[ 0+9245] ='b01110101;
           rom[ 0+9246] ='b11101001;
           rom[ 0+9247] ='b11011101;
           rom[ 0+9248] ='b01110100;
           rom[ 0+9249] ='b11101010;
           rom[ 0+9250] ='b00110110;
           rom[ 0+9251] ='b00000011;
           rom[ 0+9252] ='b00100011;
           rom[ 0+9253] ='b00110110;
           rom[ 0+9254] ='b00000000;
           rom[ 0+9255] ='b11000011;
           rom[ 0+9256] ='b10100011;
           rom[ 0+9257] ='b00100111;
           rom[ 0+9258] ='b11011101;
           rom[ 0+9259] ='b01111110;
           rom[ 0+9260] ='b11111010;
           rom[ 0+9261] ='b11110101;
           rom[ 0+9262] ='b00110011;
           rom[ 0+9263] ='b11010101;
           rom[ 0+9264] ='b00110011;
           rom[ 0+9265] ='b11001101;
           rom[ 0+9266] ='b01101111;
           rom[ 0+9267] ='b00100000;
           rom[ 0+9268] ='b01001101;
           rom[ 0+9269] ='b11110001;
           rom[ 0+9270] ='b11011101;
           rom[ 0+9271] ='b01110001;
           rom[ 0+9272] ='b11111100;
           rom[ 0+9273] ='b11011101;
           rom[ 0+9274] ='b01111110;
           rom[ 0+9275] ='b11111010;
           rom[ 0+9276] ='b11110101;
           rom[ 0+9277] ='b00110011;
           rom[ 0+9278] ='b11011101;
           rom[ 0+9279] ='b01111110;
           rom[ 0+9280] ='b11111001;
           rom[ 0+9281] ='b11110101;
           rom[ 0+9282] ='b00110011;
           rom[ 0+9283] ='b11001101;
           rom[ 0+9284] ='b01101111;
           rom[ 0+9285] ='b00100000;
           rom[ 0+9286] ='b01001101;
           rom[ 0+9287] ='b11110001;
           rom[ 0+9288] ='b11011101;
           rom[ 0+9289] ='b01110001;
           rom[ 0+9290] ='b11111011;
           rom[ 0+9291] ='b00111110;
           rom[ 0+9292] ='b00000110;
           rom[ 0+9293] ='b11011101;
           rom[ 0+9294] ='b10000110;
           rom[ 0+9295] ='b11100110;
           rom[ 0+9296] ='b01011111;
           rom[ 0+9297] ='b00111110;
           rom[ 0+9298] ='b10010000;
           rom[ 0+9299] ='b11011101;
           rom[ 0+9300] ='b10001110;
           rom[ 0+9301] ='b11100111;
           rom[ 0+9302] ='b01001111;
           rom[ 0+9303] ='b01111011;
           rom[ 0+9304] ='b11000110;
           rom[ 0+9305] ='b00000010;
           rom[ 0+9306] ='b01011111;
           rom[ 0+9307] ='b01111001;
           rom[ 0+9308] ='b11001110;
           rom[ 0+9309] ='b00000000;
           rom[ 0+9310] ='b01001111;
           rom[ 0+9311] ='b01101011;
           rom[ 0+9312] ='b01100001;
           rom[ 0+9313] ='b01011110;
           rom[ 0+9314] ='b01111011;
           rom[ 0+9315] ='b11110101;
           rom[ 0+9316] ='b00110011;
           rom[ 0+9317] ='b11011101;
           rom[ 0+9318] ='b01111110;
           rom[ 0+9319] ='b11111011;
           rom[ 0+9320] ='b11110101;
           rom[ 0+9321] ='b00110011;
           rom[ 0+9322] ='b11001101;
           rom[ 0+9323] ='b00001110;
           rom[ 0+9324] ='b00100000;
           rom[ 0+9325] ='b01001101;
           rom[ 0+9326] ='b11110001;
           rom[ 0+9327] ='b01010001;
           rom[ 0+9328] ='b00111110;
           rom[ 0+9329] ='b00000110;
           rom[ 0+9330] ='b11011101;
           rom[ 0+9331] ='b10000110;
           rom[ 0+9332] ='b11100110;
           rom[ 0+9333] ='b01001111;
           rom[ 0+9334] ='b00111110;
           rom[ 0+9335] ='b10010000;
           rom[ 0+9336] ='b11011101;
           rom[ 0+9337] ='b10001110;
           rom[ 0+9338] ='b11100111;
           rom[ 0+9339] ='b01000111;
           rom[ 0+9340] ='b00000011;
           rom[ 0+9341] ='b00000011;
           rom[ 0+9342] ='b00000011;
           rom[ 0+9343] ='b00001010;
           rom[ 0+9344] ='b01001111;
           rom[ 0+9345] ='b11010101;
           rom[ 0+9346] ='b01111001;
           rom[ 0+9347] ='b11110101;
           rom[ 0+9348] ='b00110011;
           rom[ 0+9349] ='b11011101;
           rom[ 0+9350] ='b01111110;
           rom[ 0+9351] ='b11111100;
           rom[ 0+9352] ='b11110101;
           rom[ 0+9353] ='b00110011;
           rom[ 0+9354] ='b11001101;
           rom[ 0+9355] ='b00001110;
           rom[ 0+9356] ='b00100000;
           rom[ 0+9357] ='b01001101;
           rom[ 0+9358] ='b11110001;
           rom[ 0+9359] ='b11010001;
           rom[ 0+9360] ='b11011101;
           rom[ 0+9361] ='b01110001;
           rom[ 0+9362] ='b11111001;
           rom[ 0+9363] ='b00111110;
           rom[ 0+9364] ='b00000110;
           rom[ 0+9365] ='b11011101;
           rom[ 0+9366] ='b10000110;
           rom[ 0+9367] ='b11100110;
           rom[ 0+9368] ='b01001111;
           rom[ 0+9369] ='b00111110;
           rom[ 0+9370] ='b10010000;
           rom[ 0+9371] ='b11011101;
           rom[ 0+9372] ='b10001110;
           rom[ 0+9373] ='b11100111;
           rom[ 0+9374] ='b01000111;
           rom[ 0+9375] ='b00000011;
           rom[ 0+9376] ='b00000011;
           rom[ 0+9377] ='b00000011;
           rom[ 0+9378] ='b00001010;
           rom[ 0+9379] ='b01001111;
           rom[ 0+9380] ='b11010101;
           rom[ 0+9381] ='b01111001;
           rom[ 0+9382] ='b11110101;
           rom[ 0+9383] ='b00110011;
           rom[ 0+9384] ='b11011101;
           rom[ 0+9385] ='b01111110;
           rom[ 0+9386] ='b11111011;
           rom[ 0+9387] ='b11110101;
           rom[ 0+9388] ='b00110011;
           rom[ 0+9389] ='b11001101;
           rom[ 0+9390] ='b00001110;
           rom[ 0+9391] ='b00100000;
           rom[ 0+9392] ='b01001101;
           rom[ 0+9393] ='b11110001;
           rom[ 0+9394] ='b11010001;
           rom[ 0+9395] ='b11011101;
           rom[ 0+9396] ='b01110001;
           rom[ 0+9397] ='b11111010;
           rom[ 0+9398] ='b00111110;
           rom[ 0+9399] ='b00000110;
           rom[ 0+9400] ='b11011101;
           rom[ 0+9401] ='b10000110;
           rom[ 0+9402] ='b11100110;
           rom[ 0+9403] ='b01001111;
           rom[ 0+9404] ='b00111110;
           rom[ 0+9405] ='b10010000;
           rom[ 0+9406] ='b11011101;
           rom[ 0+9407] ='b10001110;
           rom[ 0+9408] ='b11100111;
           rom[ 0+9409] ='b01000111;
           rom[ 0+9410] ='b00000011;
           rom[ 0+9411] ='b00000011;
           rom[ 0+9412] ='b00000011;
           rom[ 0+9413] ='b00000011;
           rom[ 0+9414] ='b00001010;
           rom[ 0+9415] ='b01001111;
           rom[ 0+9416] ='b11010101;
           rom[ 0+9417] ='b01111001;
           rom[ 0+9418] ='b11110101;
           rom[ 0+9419] ='b00110011;
           rom[ 0+9420] ='b11011101;
           rom[ 0+9421] ='b01111110;
           rom[ 0+9422] ='b11111100;
           rom[ 0+9423] ='b11110101;
           rom[ 0+9424] ='b00110011;
           rom[ 0+9425] ='b11001101;
           rom[ 0+9426] ='b00001110;
           rom[ 0+9427] ='b00100000;
           rom[ 0+9428] ='b01001101;
           rom[ 0+9429] ='b11110001;
           rom[ 0+9430] ='b11010001;
           rom[ 0+9431] ='b00111110;
           rom[ 0+9432] ='b00000110;
           rom[ 0+9433] ='b11011101;
           rom[ 0+9434] ='b10000110;
           rom[ 0+9435] ='b11100110;
           rom[ 0+9436] ='b01000111;
           rom[ 0+9437] ='b00111110;
           rom[ 0+9438] ='b10010000;
           rom[ 0+9439] ='b11011101;
           rom[ 0+9440] ='b10001110;
           rom[ 0+9441] ='b11100111;
           rom[ 0+9442] ='b01011111;
           rom[ 0+9443] ='b01111000;
           rom[ 0+9444] ='b11000110;
           rom[ 0+9445] ='b00000100;
           rom[ 0+9446] ='b01000111;
           rom[ 0+9447] ='b01111011;
           rom[ 0+9448] ='b11001110;
           rom[ 0+9449] ='b00000000;
           rom[ 0+9450] ='b01011111;
           rom[ 0+9451] ='b01101000;
           rom[ 0+9452] ='b01100011;
           rom[ 0+9453] ='b01000110;
           rom[ 0+9454] ='b11000101;
           rom[ 0+9455] ='b11010101;
           rom[ 0+9456] ='b11000101;
           rom[ 0+9457] ='b00110011;
           rom[ 0+9458] ='b11011101;
           rom[ 0+9459] ='b01111110;
           rom[ 0+9460] ='b11111011;
           rom[ 0+9461] ='b11110101;
           rom[ 0+9462] ='b00110011;
           rom[ 0+9463] ='b11001101;
           rom[ 0+9464] ='b00001110;
           rom[ 0+9465] ='b00100000;
           rom[ 0+9466] ='b01000101;
           rom[ 0+9467] ='b11110001;
           rom[ 0+9468] ='b11010001;
           rom[ 0+9469] ='b01111000;
           rom[ 0+9470] ='b11000001;
           rom[ 0+9471] ='b01000111;
           rom[ 0+9472] ='b11011101;
           rom[ 0+9473] ='b01110000;
           rom[ 0+9474] ='b11111000;
           rom[ 0+9475] ='b00111110;
           rom[ 0+9476] ='b00000110;
           rom[ 0+9477] ='b11011101;
           rom[ 0+9478] ='b10000110;
           rom[ 0+9479] ='b11100110;
           rom[ 0+9480] ='b01011111;
           rom[ 0+9481] ='b00111110;
           rom[ 0+9482] ='b10010000;
           rom[ 0+9483] ='b11011101;
           rom[ 0+9484] ='b10001110;
           rom[ 0+9485] ='b11100111;
           rom[ 0+9486] ='b01000111;
           rom[ 0+9487] ='b01111011;
           rom[ 0+9488] ='b11000110;
           rom[ 0+9489] ='b00000101;
           rom[ 0+9490] ='b01011111;
           rom[ 0+9491] ='b01111000;
           rom[ 0+9492] ='b11001110;
           rom[ 0+9493] ='b00000000;
           rom[ 0+9494] ='b01000111;
           rom[ 0+9495] ='b01101011;
           rom[ 0+9496] ='b01100000;
           rom[ 0+9497] ='b01011110;
           rom[ 0+9498] ='b11000101;
           rom[ 0+9499] ='b11010101;
           rom[ 0+9500] ='b01111011;
           rom[ 0+9501] ='b11110101;
           rom[ 0+9502] ='b00110011;
           rom[ 0+9503] ='b11011101;
           rom[ 0+9504] ='b01111110;
           rom[ 0+9505] ='b11111100;
           rom[ 0+9506] ='b11110101;
           rom[ 0+9507] ='b00110011;
           rom[ 0+9508] ='b11001101;
           rom[ 0+9509] ='b00001110;
           rom[ 0+9510] ='b00100000;
           rom[ 0+9511] ='b01000101;
           rom[ 0+9512] ='b11110001;
           rom[ 0+9513] ='b11010001;
           rom[ 0+9514] ='b01111000;
           rom[ 0+9515] ='b11000001;
           rom[ 0+9516] ='b01000111;
           rom[ 0+9517] ='b11011101;
           rom[ 0+9518] ='b01110000;
           rom[ 0+9519] ='b11110111;
           rom[ 0+9520] ='b01111010;
           rom[ 0+9521] ='b11011101;
           rom[ 0+9522] ='b10101110;
           rom[ 0+9523] ='b11111001;
           rom[ 0+9524] ='b01010111;
           rom[ 0+9525] ='b00111110;
           rom[ 0+9526] ='b00000110;
           rom[ 0+9527] ='b11011101;
           rom[ 0+9528] ='b10000110;
           rom[ 0+9529] ='b11100110;
           rom[ 0+9530] ='b11011101;
           rom[ 0+9531] ='b01110111;
           rom[ 0+9532] ='b11101001;
           rom[ 0+9533] ='b00111110;
           rom[ 0+9534] ='b10010000;
           rom[ 0+9535] ='b11011101;
           rom[ 0+9536] ='b10001110;
           rom[ 0+9537] ='b11100111;
           rom[ 0+9538] ='b11011101;
           rom[ 0+9539] ='b01110111;
           rom[ 0+9540] ='b11101010;
           rom[ 0+9541] ='b11011101;
           rom[ 0+9542] ='b01111110;
           rom[ 0+9543] ='b11101001;
           rom[ 0+9544] ='b11000110;
           rom[ 0+9545] ='b00000100;
           rom[ 0+9546] ='b01011111;
           rom[ 0+9547] ='b11011101;
           rom[ 0+9548] ='b01111110;
           rom[ 0+9549] ='b11101010;
           rom[ 0+9550] ='b11001110;
           rom[ 0+9551] ='b00000000;
           rom[ 0+9552] ='b01000111;
           rom[ 0+9553] ='b01101011;
           rom[ 0+9554] ='b01100000;
           rom[ 0+9555] ='b01011110;
           rom[ 0+9556] ='b01111010;
           rom[ 0+9557] ='b10111011;
           rom[ 0+9558] ='b11001010;
           rom[ 0+9559] ='b01011100;
           rom[ 0+9560] ='b00100101;
           rom[ 0+9561] ='b11000011;
           rom[ 0+9562] ='b11101110;
           rom[ 0+9563] ='b00100101;
           rom[ 0+9564] ='b01111001;
           rom[ 0+9565] ='b11011101;
           rom[ 0+9566] ='b10101110;
           rom[ 0+9567] ='b11111010;
           rom[ 0+9568] ='b01001111;
           rom[ 0+9569] ='b11011101;
           rom[ 0+9570] ='b01111110;
           rom[ 0+9571] ='b11101001;
           rom[ 0+9572] ='b11000110;
           rom[ 0+9573] ='b00000101;
           rom[ 0+9574] ='b01011111;
           rom[ 0+9575] ='b11011101;
           rom[ 0+9576] ='b01111110;
           rom[ 0+9577] ='b11101010;
           rom[ 0+9578] ='b11001110;
           rom[ 0+9579] ='b00000000;
           rom[ 0+9580] ='b01010111;
           rom[ 0+9581] ='b00011010;
           rom[ 0+9582] ='b01000111;
           rom[ 0+9583] ='b01111001;
           rom[ 0+9584] ='b10111000;
           rom[ 0+9585] ='b11001010;
           rom[ 0+9586] ='b10100100;
           rom[ 0+9587] ='b00100101;
           rom[ 0+9588] ='b11011101;
           rom[ 0+9589] ='b01011110;
           rom[ 0+9590] ='b00000110;
           rom[ 0+9591] ='b11011101;
           rom[ 0+9592] ='b01010110;
           rom[ 0+9593] ='b00000111;
           rom[ 0+9594] ='b01101011;
           rom[ 0+9595] ='b01100010;
           rom[ 0+9596] ='b00101001;
           rom[ 0+9597] ='b00011001;
           rom[ 0+9598] ='b00101001;
           rom[ 0+9599] ='b00101001;
           rom[ 0+9600] ='b00011001;
           rom[ 0+9601] ='b01001101;
           rom[ 0+9602] ='b01000100;
           rom[ 0+9603] ='b00100001;
           rom[ 0+9604] ='b00000011;
           rom[ 0+9605] ='b10000100;
           rom[ 0+9606] ='b00001001;
           rom[ 0+9607] ='b01001101;
           rom[ 0+9608] ='b01000100;
           rom[ 0+9609] ='b00110110;
           rom[ 0+9610] ='b00000100;
           rom[ 0+9611] ='b00100011;
           rom[ 0+9612] ='b00110110;
           rom[ 0+9613] ='b00000000;
           rom[ 0+9614] ='b11011101;
           rom[ 0+9615] ='b01101110;
           rom[ 0+9616] ='b00000110;
           rom[ 0+9617] ='b11011101;
           rom[ 0+9618] ='b01100110;
           rom[ 0+9619] ='b00000111;
           rom[ 0+9620] ='b11100101;
           rom[ 0+9621] ='b11011101;
           rom[ 0+9622] ='b01101110;
           rom[ 0+9623] ='b00000100;
           rom[ 0+9624] ='b11011101;
           rom[ 0+9625] ='b01100110;
           rom[ 0+9626] ='b00000101;
           rom[ 0+9627] ='b11100101;
           rom[ 0+9628] ='b11001101;
           rom[ 0+9629] ='b10101000;
           rom[ 0+9630] ='b00100111;
           rom[ 0+9631] ='b11110001;
           rom[ 0+9632] ='b11110001;
           rom[ 0+9633] ='b11000011;
           rom[ 0+9634] ='b10100011;
           rom[ 0+9635] ='b00100111;
           rom[ 0+9636] ='b11011101;
           rom[ 0+9637] ='b01111110;
           rom[ 0+9638] ='b11111000;
           rom[ 0+9639] ='b11011101;
           rom[ 0+9640] ='b10101110;
           rom[ 0+9641] ='b11110111;
           rom[ 0+9642] ='b01001111;
           rom[ 0+9643] ='b11011101;
           rom[ 0+9644] ='b01111110;
           rom[ 0+9645] ='b11101001;
           rom[ 0+9646] ='b11000110;
           rom[ 0+9647] ='b00000110;
           rom[ 0+9648] ='b01011111;
           rom[ 0+9649] ='b11011101;
           rom[ 0+9650] ='b01111110;
           rom[ 0+9651] ='b11101010;
           rom[ 0+9652] ='b11001110;
           rom[ 0+9653] ='b00000000;
           rom[ 0+9654] ='b01010111;
           rom[ 0+9655] ='b00011010;
           rom[ 0+9656] ='b01000111;
           rom[ 0+9657] ='b01111001;
           rom[ 0+9658] ='b10111000;
           rom[ 0+9659] ='b11001010;
           rom[ 0+9660] ='b00011110;
           rom[ 0+9661] ='b00100110;
           rom[ 0+9662] ='b11011101;
           rom[ 0+9663] ='b01011110;
           rom[ 0+9664] ='b00000110;
           rom[ 0+9665] ='b11011101;
           rom[ 0+9666] ='b01010110;
           rom[ 0+9667] ='b00000111;
           rom[ 0+9668] ='b01101011;
           rom[ 0+9669] ='b01100010;
           rom[ 0+9670] ='b00101001;
           rom[ 0+9671] ='b00011001;
           rom[ 0+9672] ='b00101001;
           rom[ 0+9673] ='b00101001;
           rom[ 0+9674] ='b00011001;
           rom[ 0+9675] ='b01001101;
           rom[ 0+9676] ='b01000100;
           rom[ 0+9677] ='b00100001;
           rom[ 0+9678] ='b00000011;
           rom[ 0+9679] ='b10000100;
           rom[ 0+9680] ='b00001001;
           rom[ 0+9681] ='b01001101;
           rom[ 0+9682] ='b01000100;
           rom[ 0+9683] ='b00110110;
           rom[ 0+9684] ='b00000100;
           rom[ 0+9685] ='b00100011;
           rom[ 0+9686] ='b00110110;
           rom[ 0+9687] ='b00000000;
           rom[ 0+9688] ='b11011101;
           rom[ 0+9689] ='b01101110;
           rom[ 0+9690] ='b00000110;
           rom[ 0+9691] ='b11011101;
           rom[ 0+9692] ='b01100110;
           rom[ 0+9693] ='b00000111;
           rom[ 0+9694] ='b11100101;
           rom[ 0+9695] ='b11011101;
           rom[ 0+9696] ='b01101110;
           rom[ 0+9697] ='b00000100;
           rom[ 0+9698] ='b11011101;
           rom[ 0+9699] ='b01100110;
           rom[ 0+9700] ='b00000101;
           rom[ 0+9701] ='b11100101;
           rom[ 0+9702] ='b11001101;
           rom[ 0+9703] ='b10101000;
           rom[ 0+9704] ='b00100111;
           rom[ 0+9705] ='b11110001;
           rom[ 0+9706] ='b11110001;
           rom[ 0+9707] ='b11000011;
           rom[ 0+9708] ='b10100011;
           rom[ 0+9709] ='b00100111;
           rom[ 0+9710] ='b11011101;
           rom[ 0+9711] ='b01011110;
           rom[ 0+9712] ='b00000110;
           rom[ 0+9713] ='b11011101;
           rom[ 0+9714] ='b01010110;
           rom[ 0+9715] ='b00000111;
           rom[ 0+9716] ='b01101011;
           rom[ 0+9717] ='b01100010;
           rom[ 0+9718] ='b00101001;
           rom[ 0+9719] ='b00011001;
           rom[ 0+9720] ='b00101001;
           rom[ 0+9721] ='b00101001;
           rom[ 0+9722] ='b00011001;
           rom[ 0+9723] ='b01001101;
           rom[ 0+9724] ='b01000100;
           rom[ 0+9725] ='b00100001;
           rom[ 0+9726] ='b00000011;
           rom[ 0+9727] ='b10000100;
           rom[ 0+9728] ='b00001001;
           rom[ 0+9729] ='b01001101;
           rom[ 0+9730] ='b01000100;
           rom[ 0+9731] ='b00110110;
           rom[ 0+9732] ='b00000100;
           rom[ 0+9733] ='b00100011;
           rom[ 0+9734] ='b00110110;
           rom[ 0+9735] ='b00000000;
           rom[ 0+9736] ='b11011101;
           rom[ 0+9737] ='b01101110;
           rom[ 0+9738] ='b00000110;
           rom[ 0+9739] ='b11011101;
           rom[ 0+9740] ='b01100110;
           rom[ 0+9741] ='b00000111;
           rom[ 0+9742] ='b11100101;
           rom[ 0+9743] ='b11011101;
           rom[ 0+9744] ='b01101110;
           rom[ 0+9745] ='b00000100;
           rom[ 0+9746] ='b11011101;
           rom[ 0+9747] ='b01100110;
           rom[ 0+9748] ='b00000101;
           rom[ 0+9749] ='b11100101;
           rom[ 0+9750] ='b11001101;
           rom[ 0+9751] ='b10101000;
           rom[ 0+9752] ='b00100111;
           rom[ 0+9753] ='b11110001;
           rom[ 0+9754] ='b11110001;
           rom[ 0+9755] ='b11000011;
           rom[ 0+9756] ='b10100011;
           rom[ 0+9757] ='b00100111;
           rom[ 0+9758] ='b11011101;
           rom[ 0+9759] ='b01111110;
           rom[ 0+9760] ='b11111100;
           rom[ 0+9761] ='b11110101;
           rom[ 0+9762] ='b00110011;
           rom[ 0+9763] ='b11011101;
           rom[ 0+9764] ='b01111110;
           rom[ 0+9765] ='b11111100;
           rom[ 0+9766] ='b11110101;
           rom[ 0+9767] ='b00110011;
           rom[ 0+9768] ='b11001101;
           rom[ 0+9769] ='b00001110;
           rom[ 0+9770] ='b00100000;
           rom[ 0+9771] ='b01001101;
           rom[ 0+9772] ='b11110001;
           rom[ 0+9773] ='b01111001;
           rom[ 0+9774] ='b11110101;
           rom[ 0+9775] ='b00110011;
           rom[ 0+9776] ='b11011101;
           rom[ 0+9777] ='b01111110;
           rom[ 0+9778] ='b11111011;
           rom[ 0+9779] ='b11110101;
           rom[ 0+9780] ='b00110011;
           rom[ 0+9781] ='b11001101;
           rom[ 0+9782] ='b01101111;
           rom[ 0+9783] ='b00100000;
           rom[ 0+9784] ='b01001101;
           rom[ 0+9785] ='b11110001;
           rom[ 0+9786] ='b11011101;
           rom[ 0+9787] ='b01110001;
           rom[ 0+9788] ='b11111010;
           rom[ 0+9789] ='b00111110;
           rom[ 0+9790] ='b10011100;
           rom[ 0+9791] ='b11011101;
           rom[ 0+9792] ='b10000110;
           rom[ 0+9793] ='b11111010;
           rom[ 0+9794] ='b01001111;
           rom[ 0+9795] ='b00111110;
           rom[ 0+9796] ='b00000101;
           rom[ 0+9797] ='b11001110;
           rom[ 0+9798] ='b00000000;
           rom[ 0+9799] ='b01000111;
           rom[ 0+9800] ='b00001010;
           rom[ 0+9801] ='b01001111;
           rom[ 0+9802] ='b11110101;
           rom[ 0+9803] ='b00110011;
           rom[ 0+9804] ='b11011101;
           rom[ 0+9805] ='b01111110;
           rom[ 0+9806] ='b11111100;
           rom[ 0+9807] ='b11110101;
           rom[ 0+9808] ='b00110011;
           rom[ 0+9809] ='b11001101;
           rom[ 0+9810] ='b00001110;
           rom[ 0+9811] ='b00100000;
           rom[ 0+9812] ='b01001101;
           rom[ 0+9813] ='b11110001;
           rom[ 0+9814] ='b11011101;
           rom[ 0+9815] ='b01110001;
           rom[ 0+9816] ='b11110101;
           rom[ 0+9817] ='b11011101;
           rom[ 0+9818] ='b00110110;
           rom[ 0+9819] ='b11110110;
           rom[ 0+9820] ='b00000000;
           rom[ 0+9821] ='b00111110;
           rom[ 0+9822] ='b10011100;
           rom[ 0+9823] ='b11011101;
           rom[ 0+9824] ='b10000110;
           rom[ 0+9825] ='b11111010;
           rom[ 0+9826] ='b01011111;
           rom[ 0+9827] ='b00111110;
           rom[ 0+9828] ='b00000101;
           rom[ 0+9829] ='b11001110;
           rom[ 0+9830] ='b00000000;
           rom[ 0+9831] ='b01010111;
           rom[ 0+9832] ='b00011010;
           rom[ 0+9833] ='b01011111;
           rom[ 0+9834] ='b11101110;
           rom[ 0+9835] ='b00000001;
           rom[ 0+9836] ='b01011111;
           rom[ 0+9837] ='b11110101;
           rom[ 0+9838] ='b00110011;
           rom[ 0+9839] ='b11011101;
           rom[ 0+9840] ='b01111110;
           rom[ 0+9841] ='b11111100;
           rom[ 0+9842] ='b11110101;
           rom[ 0+9843] ='b00110011;
           rom[ 0+9844] ='b11001101;
           rom[ 0+9845] ='b00001110;
           rom[ 0+9846] ='b00100000;
           rom[ 0+9847] ='b01011101;
           rom[ 0+9848] ='b11110001;
           rom[ 0+9849] ='b11011101;
           rom[ 0+9850] ='b01110011;
           rom[ 0+9851] ='b11110011;
           rom[ 0+9852] ='b11011101;
           rom[ 0+9853] ='b00110110;
           rom[ 0+9854] ='b11110100;
           rom[ 0+9855] ='b00000000;
           rom[ 0+9856] ='b00111110;
           rom[ 0+9857] ='b10011100;
           rom[ 0+9858] ='b11011101;
           rom[ 0+9859] ='b10000110;
           rom[ 0+9860] ='b11110011;
           rom[ 0+9861] ='b01001111;
           rom[ 0+9862] ='b00111110;
           rom[ 0+9863] ='b00000010;
           rom[ 0+9864] ='b11011101;
           rom[ 0+9865] ='b10001110;
           rom[ 0+9866] ='b11110100;
           rom[ 0+9867] ='b01000111;
           rom[ 0+9868] ='b00001010;
           rom[ 0+9869] ='b01001111;
           rom[ 0+9870] ='b11011101;
           rom[ 0+9871] ='b01110001;
           rom[ 0+9872] ='b11101111;
           rom[ 0+9873] ='b11011101;
           rom[ 0+9874] ='b00110110;
           rom[ 0+9875] ='b11110000;
           rom[ 0+9876] ='b00000000;
           rom[ 0+9877] ='b00111110;
           rom[ 0+9878] ='b10011100;
           rom[ 0+9879] ='b11011101;
           rom[ 0+9880] ='b10000110;
           rom[ 0+9881] ='b11110101;
           rom[ 0+9882] ='b01001111;
           rom[ 0+9883] ='b00111110;
           rom[ 0+9884] ='b00000010;
           rom[ 0+9885] ='b11011101;
           rom[ 0+9886] ='b10001110;
           rom[ 0+9887] ='b11110110;
           rom[ 0+9888] ='b01000111;
           rom[ 0+9889] ='b00001010;
           rom[ 0+9890] ='b01001111;
           rom[ 0+9891] ='b11011101;
           rom[ 0+9892] ='b01110001;
           rom[ 0+9893] ='b11110001;
           rom[ 0+9894] ='b11011101;
           rom[ 0+9895] ='b00110110;
           rom[ 0+9896] ='b11110010;
           rom[ 0+9897] ='b00000000;
           rom[ 0+9898] ='b11011101;
           rom[ 0+9899] ='b01111110;
           rom[ 0+9900] ='b11110101;
           rom[ 0+9901] ='b11011101;
           rom[ 0+9902] ='b10101110;
           rom[ 0+9903] ='b11110011;
           rom[ 0+9904] ='b01001111;
           rom[ 0+9905] ='b11011101;
           rom[ 0+9906] ='b01111110;
           rom[ 0+9907] ='b11110110;
           rom[ 0+9908] ='b11011101;
           rom[ 0+9909] ='b10101110;
           rom[ 0+9910] ='b11110100;
           rom[ 0+9911] ='b01000111;
           rom[ 0+9912] ='b00111110;
           rom[ 0+9913] ='b00000110;
           rom[ 0+9914] ='b11011101;
           rom[ 0+9915] ='b10000110;
           rom[ 0+9916] ='b11100110;
           rom[ 0+9917] ='b01000111;
           rom[ 0+9918] ='b00111110;
           rom[ 0+9919] ='b10010000;
           rom[ 0+9920] ='b11011101;
           rom[ 0+9921] ='b10001110;
           rom[ 0+9922] ='b11100111;
           rom[ 0+9923] ='b01011111;
           rom[ 0+9924] ='b01101000;
           rom[ 0+9925] ='b01100011;
           rom[ 0+9926] ='b01000110;
           rom[ 0+9927] ='b11011101;
           rom[ 0+9928] ='b01011110;
           rom[ 0+9929] ='b11110011;
           rom[ 0+9930] ='b11000101;
           rom[ 0+9931] ='b11000101;
           rom[ 0+9932] ='b00110011;
           rom[ 0+9933] ='b01111011;
           rom[ 0+9934] ='b11110101;
           rom[ 0+9935] ='b00110011;
           rom[ 0+9936] ='b11001101;
           rom[ 0+9937] ='b00001110;
           rom[ 0+9938] ='b00100000;
           rom[ 0+9939] ='b01000101;
           rom[ 0+9940] ='b11110001;
           rom[ 0+9941] ='b01111000;
           rom[ 0+9942] ='b11000001;
           rom[ 0+9943] ='b01000111;
           rom[ 0+9944] ='b00111110;
           rom[ 0+9945] ='b00000110;
           rom[ 0+9946] ='b11011101;
           rom[ 0+9947] ='b10000110;
           rom[ 0+9948] ='b11100110;
           rom[ 0+9949] ='b01011111;
           rom[ 0+9950] ='b00111110;
           rom[ 0+9951] ='b10010000;
           rom[ 0+9952] ='b11011101;
           rom[ 0+9953] ='b10001110;
           rom[ 0+9954] ='b11100111;
           rom[ 0+9955] ='b01010111;
           rom[ 0+9956] ='b00010011;
           rom[ 0+9957] ='b00011010;
           rom[ 0+9958] ='b01011111;
           rom[ 0+9959] ='b01111000;
           rom[ 0+9960] ='b10101011;
           rom[ 0+9961] ='b01000111;
           rom[ 0+9962] ='b01111001;
           rom[ 0+9963] ='b11110101;
           rom[ 0+9964] ='b00110011;
           rom[ 0+9965] ='b11000101;
           rom[ 0+9966] ='b00110011;
           rom[ 0+9967] ='b11001101;
           rom[ 0+9968] ='b01101111;
           rom[ 0+9969] ='b00100000;
           rom[ 0+9970] ='b01001101;
           rom[ 0+9971] ='b11110001;
           rom[ 0+9972] ='b11011101;
           rom[ 0+9973] ='b01110001;
           rom[ 0+9974] ='b11101101;
           rom[ 0+9975] ='b11011101;
           rom[ 0+9976] ='b00110110;
           rom[ 0+9977] ='b11101110;
           rom[ 0+9978] ='b00000000;
           rom[ 0+9979] ='b00111110;
           rom[ 0+9980] ='b00000110;
           rom[ 0+9981] ='b11011101;
           rom[ 0+9982] ='b10000110;
           rom[ 0+9983] ='b11100110;
           rom[ 0+9984] ='b01011111;
           rom[ 0+9985] ='b00111110;
           rom[ 0+9986] ='b10010000;
           rom[ 0+9987] ='b11011101;
           rom[ 0+9988] ='b10001110;
           rom[ 0+9989] ='b11100111;
           rom[ 0+9990] ='b01010111;
           rom[ 0+9991] ='b00011010;
           rom[ 0+9992] ='b01011111;
           rom[ 0+9993] ='b00010110;
           rom[ 0+9994] ='b00000000;
           rom[ 0+9995] ='b01111011;
           rom[ 0+9996] ='b11011101;
           rom[ 0+9997] ='b10101110;
           rom[ 0+9998] ='b11101101;
           rom[ 0+9999] ='b01011111;
           rom[ 0+10000] ='b01111010;
           rom[ 0+10001] ='b11011101;
           rom[ 0+10002] ='b10101110;
           rom[ 0+10003] ='b11101110;
           rom[ 0+10004] ='b01010111;
           rom[ 0+10005] ='b11011101;
           rom[ 0+10006] ='b01110011;
           rom[ 0+10007] ='b11101011;
           rom[ 0+10008] ='b11011101;
           rom[ 0+10009] ='b01110010;
           rom[ 0+10010] ='b11101100;
           rom[ 0+10011] ='b11011101;
           rom[ 0+10012] ='b01011110;
           rom[ 0+10013] ='b00000110;
           rom[ 0+10014] ='b11011101;
           rom[ 0+10015] ='b01010110;
           rom[ 0+10016] ='b00000111;
           rom[ 0+10017] ='b01101011;
           rom[ 0+10018] ='b01100010;
           rom[ 0+10019] ='b00101001;
           rom[ 0+10020] ='b00011001;
           rom[ 0+10021] ='b00101001;
           rom[ 0+10022] ='b00101001;
           rom[ 0+10023] ='b00011001;
           rom[ 0+10024] ='b01011101;
           rom[ 0+10025] ='b01010100;
           rom[ 0+10026] ='b00100001;
           rom[ 0+10027] ='b00000011;
           rom[ 0+10028] ='b10000100;
           rom[ 0+10029] ='b00011001;
           rom[ 0+10030] ='b01011101;
           rom[ 0+10031] ='b01010100;
           rom[ 0+10032] ='b00110110;
           rom[ 0+10033] ='b00000010;
           rom[ 0+10034] ='b00100011;
           rom[ 0+10035] ='b00110110;
           rom[ 0+10036] ='b00000000;
           rom[ 0+10037] ='b01111011;
           rom[ 0+10038] ='b11000110;
           rom[ 0+10039] ='b00000100;
           rom[ 0+10040] ='b11011101;
           rom[ 0+10041] ='b01110111;
           rom[ 0+10042] ='b11100110;
           rom[ 0+10043] ='b01111010;
           rom[ 0+10044] ='b11001110;
           rom[ 0+10045] ='b00000000;
           rom[ 0+10046] ='b11011101;
           rom[ 0+10047] ='b01110111;
           rom[ 0+10048] ='b11100111;
           rom[ 0+10049] ='b11011101;
           rom[ 0+10050] ='b01111110;
           rom[ 0+10051] ='b00000100;
           rom[ 0+10052] ='b11000110;
           rom[ 0+10053] ='b11111111;
           rom[ 0+10054] ='b11011101;
           rom[ 0+10055] ='b01110111;
           rom[ 0+10056] ='b11101001;
           rom[ 0+10057] ='b11011101;
           rom[ 0+10058] ='b01111110;
           rom[ 0+10059] ='b00000101;
           rom[ 0+10060] ='b11001110;
           rom[ 0+10061] ='b11111111;
           rom[ 0+10062] ='b11011101;
           rom[ 0+10063] ='b01110111;
           rom[ 0+10064] ='b11101010;
           rom[ 0+10065] ='b11011101;
           rom[ 0+10066] ='b01111110;
           rom[ 0+10067] ='b11101001;
           rom[ 0+10068] ='b11011101;
           rom[ 0+10069] ='b10010110;
           rom[ 0+10070] ='b11110001;
           rom[ 0+10071] ='b01001111;
           rom[ 0+10072] ='b11011101;
           rom[ 0+10073] ='b01111110;
           rom[ 0+10074] ='b11101010;
           rom[ 0+10075] ='b11011101;
           rom[ 0+10076] ='b10011110;
           rom[ 0+10077] ='b11110010;
           rom[ 0+10078] ='b01000111;
           rom[ 0+10079] ='b11011101;
           rom[ 0+10080] ='b01101110;
           rom[ 0+10081] ='b11100110;
           rom[ 0+10082] ='b11011101;
           rom[ 0+10083] ='b01100110;
           rom[ 0+10084] ='b11100111;
           rom[ 0+10085] ='b01110001;
           rom[ 0+10086] ='b00100011;
           rom[ 0+10087] ='b01110000;
           rom[ 0+10088] ='b01111011;
           rom[ 0+10089] ='b11000110;
           rom[ 0+10090] ='b00001010;
           rom[ 0+10091] ='b01001111;
           rom[ 0+10092] ='b01111010;
           rom[ 0+10093] ='b11001110;
           rom[ 0+10094] ='b00000000;
           rom[ 0+10095] ='b01000111;
           rom[ 0+10096] ='b11011101;
           rom[ 0+10097] ='b01111110;
           rom[ 0+10098] ='b11101101;
           rom[ 0+10099] ='b00000010;
           rom[ 0+10100] ='b01111011;
           rom[ 0+10101] ='b11000110;
           rom[ 0+10102] ='b00000110;
           rom[ 0+10103] ='b11011101;
           rom[ 0+10104] ='b01110111;
           rom[ 0+10105] ='b11100110;
           rom[ 0+10106] ='b01111010;
           rom[ 0+10107] ='b11001110;
           rom[ 0+10108] ='b00000000;
           rom[ 0+10109] ='b11011101;
           rom[ 0+10110] ='b01110111;
           rom[ 0+10111] ='b11100111;
           rom[ 0+10112] ='b11011101;
           rom[ 0+10113] ='b01111110;
           rom[ 0+10114] ='b11101001;
           rom[ 0+10115] ='b11011101;
           rom[ 0+10116] ='b10010110;
           rom[ 0+10117] ='b11101111;
           rom[ 0+10118] ='b01001111;
           rom[ 0+10119] ='b11011101;
           rom[ 0+10120] ='b01111110;
           rom[ 0+10121] ='b11101010;
           rom[ 0+10122] ='b11011101;
           rom[ 0+10123] ='b10011110;
           rom[ 0+10124] ='b11110000;
           rom[ 0+10125] ='b01000111;
           rom[ 0+10126] ='b11011101;
           rom[ 0+10127] ='b01101110;
           rom[ 0+10128] ='b11100110;
           rom[ 0+10129] ='b11011101;
           rom[ 0+10130] ='b01100110;
           rom[ 0+10131] ='b11100111;
           rom[ 0+10132] ='b01110001;
           rom[ 0+10133] ='b00100011;
           rom[ 0+10134] ='b01110000;
           rom[ 0+10135] ='b01111011;
           rom[ 0+10136] ='b11000110;
           rom[ 0+10137] ='b00001011;
           rom[ 0+10138] ='b01011111;
           rom[ 0+10139] ='b01111010;
           rom[ 0+10140] ='b11001110;
           rom[ 0+10141] ='b00000000;
           rom[ 0+10142] ='b01010111;
           rom[ 0+10143] ='b11011101;
           rom[ 0+10144] ='b01111110;
           rom[ 0+10145] ='b11101011;
           rom[ 0+10146] ='b00010010;
           rom[ 0+10147] ='b11011101;
           rom[ 0+10148] ='b11111001;
           rom[ 0+10149] ='b11011101;
           rom[ 0+10150] ='b11100001;
           rom[ 0+10151] ='b11001001;
           rom[ 0+10152] ='b11011101;
           rom[ 0+10153] ='b11100101;
           rom[ 0+10154] ='b11011101;
           rom[ 0+10155] ='b00100001;
           rom[ 0+10156] ='b00000000;
           rom[ 0+10157] ='b00000000;
           rom[ 0+10158] ='b11011101;
           rom[ 0+10159] ='b00111001;
           rom[ 0+10160] ='b00100001;
           rom[ 0+10161] ='b11001011;
           rom[ 0+10162] ='b11111111;
           rom[ 0+10163] ='b00111001;
           rom[ 0+10164] ='b11111001;
           rom[ 0+10165] ='b11011101;
           rom[ 0+10166] ='b01011110;
           rom[ 0+10167] ='b00000110;
           rom[ 0+10168] ='b11011101;
           rom[ 0+10169] ='b01010110;
           rom[ 0+10170] ='b00000111;
           rom[ 0+10171] ='b01101011;
           rom[ 0+10172] ='b01100010;
           rom[ 0+10173] ='b00101001;
           rom[ 0+10174] ='b00011001;
           rom[ 0+10175] ='b00101001;
           rom[ 0+10176] ='b00011001;
           rom[ 0+10177] ='b01001101;
           rom[ 0+10178] ='b01000100;
           rom[ 0+10179] ='b00100001;
           rom[ 0+10180] ='b00000110;
           rom[ 0+10181] ='b10010000;
           rom[ 0+10182] ='b00001001;
           rom[ 0+10183] ='b11011101;
           rom[ 0+10184] ='b01110101;
           rom[ 0+10185] ='b11010001;
           rom[ 0+10186] ='b11011101;
           rom[ 0+10187] ='b01110100;
           rom[ 0+10188] ='b11010010;
           rom[ 0+10189] ='b11011101;
           rom[ 0+10190] ='b01111110;
           rom[ 0+10191] ='b11010001;
           rom[ 0+10192] ='b11000110;
           rom[ 0+10193] ='b00000011;
           rom[ 0+10194] ='b01011111;
           rom[ 0+10195] ='b11011101;
           rom[ 0+10196] ='b01111110;
           rom[ 0+10197] ='b11010010;
           rom[ 0+10198] ='b11001110;
           rom[ 0+10199] ='b00000000;
           rom[ 0+10200] ='b01010111;
           rom[ 0+10201] ='b00011010;
           rom[ 0+10202] ='b01011111;
           rom[ 0+10203] ='b11011101;
           rom[ 0+10204] ='b01101110;
           rom[ 0+10205] ='b11010001;
           rom[ 0+10206] ='b11011101;
           rom[ 0+10207] ='b01100110;
           rom[ 0+10208] ='b11010010;
           rom[ 0+10209] ='b01010110;
           rom[ 0+10210] ='b11000101;
           rom[ 0+10211] ='b01111011;
           rom[ 0+10212] ='b11110101;
           rom[ 0+10213] ='b00110011;
           rom[ 0+10214] ='b11010101;
           rom[ 0+10215] ='b00110011;
           rom[ 0+10216] ='b11001101;
           rom[ 0+10217] ='b00001110;
           rom[ 0+10218] ='b00100000;
           rom[ 0+10219] ='b01011101;
           rom[ 0+10220] ='b11110001;
           rom[ 0+10221] ='b11000001;
           rom[ 0+10222] ='b11011101;
           rom[ 0+10223] ='b01110011;
           rom[ 0+10224] ='b11111111;
           rom[ 0+10225] ='b00100001;
           rom[ 0+10226] ='b00000110;
           rom[ 0+10227] ='b10010000;
           rom[ 0+10228] ='b00001001;
           rom[ 0+10229] ='b11011101;
           rom[ 0+10230] ='b01110101;
           rom[ 0+10231] ='b11010001;
           rom[ 0+10232] ='b11011101;
           rom[ 0+10233] ='b01110100;
           rom[ 0+10234] ='b11010010;
           rom[ 0+10235] ='b11011101;
           rom[ 0+10236] ='b01011110;
           rom[ 0+10237] ='b11010001;
           rom[ 0+10238] ='b11011101;
           rom[ 0+10239] ='b01010110;
           rom[ 0+10240] ='b11010010;
           rom[ 0+10241] ='b00010011;
           rom[ 0+10242] ='b00010011;
           rom[ 0+10243] ='b00011010;
           rom[ 0+10244] ='b01011111;
           rom[ 0+10245] ='b11011101;
           rom[ 0+10246] ='b01101110;
           rom[ 0+10247] ='b11010001;
           rom[ 0+10248] ='b11011101;
           rom[ 0+10249] ='b01100110;
           rom[ 0+10250] ='b11010010;
           rom[ 0+10251] ='b01010110;
           rom[ 0+10252] ='b11000101;
           rom[ 0+10253] ='b01111011;
           rom[ 0+10254] ='b11110101;
           rom[ 0+10255] ='b00110011;
           rom[ 0+10256] ='b11010101;
           rom[ 0+10257] ='b00110011;
           rom[ 0+10258] ='b11001101;
           rom[ 0+10259] ='b00001110;
           rom[ 0+10260] ='b00100000;
           rom[ 0+10261] ='b01011101;
           rom[ 0+10262] ='b11110001;
           rom[ 0+10263] ='b11000001;
           rom[ 0+10264] ='b11011101;
           rom[ 0+10265] ='b01110011;
           rom[ 0+10266] ='b11111110;
           rom[ 0+10267] ='b00100001;
           rom[ 0+10268] ='b00000110;
           rom[ 0+10269] ='b10010000;
           rom[ 0+10270] ='b00001001;
           rom[ 0+10271] ='b01010101;
           rom[ 0+10272] ='b01011100;
           rom[ 0+10273] ='b00010100;
           rom[ 0+10274] ='b11000010;
           rom[ 0+10275] ='b00100110;
           rom[ 0+10276] ='b00101000;
           rom[ 0+10277] ='b00011100;
           rom[ 0+10278] ='b01101010;
           rom[ 0+10279] ='b01100011;
           rom[ 0+10280] ='b01010110;
           rom[ 0+10281] ='b11000101;
           rom[ 0+10282] ='b11010101;
           rom[ 0+10283] ='b00110011;
           rom[ 0+10284] ='b11010101;
           rom[ 0+10285] ='b00110011;
           rom[ 0+10286] ='b11001101;
           rom[ 0+10287] ='b00001110;
           rom[ 0+10288] ='b00100000;
           rom[ 0+10289] ='b01011101;
           rom[ 0+10290] ='b11110001;
           rom[ 0+10291] ='b11000001;
           rom[ 0+10292] ='b11011101;
           rom[ 0+10293] ='b01110011;
           rom[ 0+10294] ='b11111101;
           rom[ 0+10295] ='b00100001;
           rom[ 0+10296] ='b00000110;
           rom[ 0+10297] ='b10010000;
           rom[ 0+10298] ='b00001001;
           rom[ 0+10299] ='b11011101;
           rom[ 0+10300] ='b01110101;
           rom[ 0+10301] ='b11010001;
           rom[ 0+10302] ='b11011101;
           rom[ 0+10303] ='b01110100;
           rom[ 0+10304] ='b11010010;
           rom[ 0+10305] ='b11011101;
           rom[ 0+10306] ='b01111110;
           rom[ 0+10307] ='b11010001;
           rom[ 0+10308] ='b11000110;
           rom[ 0+10309] ='b00000011;
           rom[ 0+10310] ='b01011111;
           rom[ 0+10311] ='b11011101;
           rom[ 0+10312] ='b01111110;
           rom[ 0+10313] ='b11010010;
           rom[ 0+10314] ='b11001110;
           rom[ 0+10315] ='b00000000;
           rom[ 0+10316] ='b01010111;
           rom[ 0+10317] ='b00011010;
           rom[ 0+10318] ='b11011101;
           rom[ 0+10319] ='b01110111;
           rom[ 0+10320] ='b11010000;
           rom[ 0+10321] ='b11011101;
           rom[ 0+10322] ='b01111110;
           rom[ 0+10323] ='b11010001;
           rom[ 0+10324] ='b11000110;
           rom[ 0+10325] ='b00000001;
           rom[ 0+10326] ='b01010111;
           rom[ 0+10327] ='b11011101;
           rom[ 0+10328] ='b01111110;
           rom[ 0+10329] ='b11010010;
           rom[ 0+10330] ='b11001110;
           rom[ 0+10331] ='b00000000;
           rom[ 0+10332] ='b01011111;
           rom[ 0+10333] ='b01101010;
           rom[ 0+10334] ='b01100011;
           rom[ 0+10335] ='b01010110;
           rom[ 0+10336] ='b11000101;
           rom[ 0+10337] ='b11011101;
           rom[ 0+10338] ='b01111110;
           rom[ 0+10339] ='b11010000;
           rom[ 0+10340] ='b11110101;
           rom[ 0+10341] ='b00110011;
           rom[ 0+10342] ='b11010101;
           rom[ 0+10343] ='b00110011;
           rom[ 0+10344] ='b11001101;
           rom[ 0+10345] ='b00001110;
           rom[ 0+10346] ='b00100000;
           rom[ 0+10347] ='b01011101;
           rom[ 0+10348] ='b11110001;
           rom[ 0+10349] ='b11000001;
           rom[ 0+10350] ='b11011101;
           rom[ 0+10351] ='b01110011;
           rom[ 0+10352] ='b11111100;
           rom[ 0+10353] ='b00100001;
           rom[ 0+10354] ='b00000110;
           rom[ 0+10355] ='b10010000;
           rom[ 0+10356] ='b00001001;
           rom[ 0+10357] ='b11011101;
           rom[ 0+10358] ='b01110101;
           rom[ 0+10359] ='b11010001;
           rom[ 0+10360] ='b11011101;
           rom[ 0+10361] ='b01110100;
           rom[ 0+10362] ='b11010010;
           rom[ 0+10363] ='b11011101;
           rom[ 0+10364] ='b01011110;
           rom[ 0+10365] ='b11010001;
           rom[ 0+10366] ='b11011101;
           rom[ 0+10367] ='b01010110;
           rom[ 0+10368] ='b11010010;
           rom[ 0+10369] ='b00010011;
           rom[ 0+10370] ='b00010011;
           rom[ 0+10371] ='b00011010;
           rom[ 0+10372] ='b11011101;
           rom[ 0+10373] ='b01110111;
           rom[ 0+10374] ='b11010000;
           rom[ 0+10375] ='b11011101;
           rom[ 0+10376] ='b01111110;
           rom[ 0+10377] ='b11010001;
           rom[ 0+10378] ='b11000110;
           rom[ 0+10379] ='b00000001;
           rom[ 0+10380] ='b01010111;
           rom[ 0+10381] ='b11011101;
           rom[ 0+10382] ='b01111110;
           rom[ 0+10383] ='b11010010;
           rom[ 0+10384] ='b11001110;
           rom[ 0+10385] ='b00000000;
           rom[ 0+10386] ='b01011111;
           rom[ 0+10387] ='b01101010;
           rom[ 0+10388] ='b01100011;
           rom[ 0+10389] ='b01010110;
           rom[ 0+10390] ='b11000101;
           rom[ 0+10391] ='b11011101;
           rom[ 0+10392] ='b01111110;
           rom[ 0+10393] ='b11010000;
           rom[ 0+10394] ='b11110101;
           rom[ 0+10395] ='b00110011;
           rom[ 0+10396] ='b11010101;
           rom[ 0+10397] ='b00110011;
           rom[ 0+10398] ='b11001101;
           rom[ 0+10399] ='b00001110;
           rom[ 0+10400] ='b00100000;
           rom[ 0+10401] ='b01011101;
           rom[ 0+10402] ='b11110001;
           rom[ 0+10403] ='b11000001;
           rom[ 0+10404] ='b11011101;
           rom[ 0+10405] ='b01110011;
           rom[ 0+10406] ='b11111011;
           rom[ 0+10407] ='b00100001;
           rom[ 0+10408] ='b00000110;
           rom[ 0+10409] ='b10010000;
           rom[ 0+10410] ='b00001001;
           rom[ 0+10411] ='b01010101;
           rom[ 0+10412] ='b01011100;
           rom[ 0+10413] ='b01111010;
           rom[ 0+10414] ='b11000110;
           rom[ 0+10415] ='b00000010;
           rom[ 0+10416] ='b01010111;
           rom[ 0+10417] ='b01111011;
           rom[ 0+10418] ='b11001110;
           rom[ 0+10419] ='b00000000;
           rom[ 0+10420] ='b01011111;
           rom[ 0+10421] ='b01101010;
           rom[ 0+10422] ='b01100011;
           rom[ 0+10423] ='b01010110;
           rom[ 0+10424] ='b11000101;
           rom[ 0+10425] ='b11010101;
           rom[ 0+10426] ='b00110011;
           rom[ 0+10427] ='b11010101;
           rom[ 0+10428] ='b00110011;
           rom[ 0+10429] ='b11001101;
           rom[ 0+10430] ='b00001110;
           rom[ 0+10431] ='b00100000;
           rom[ 0+10432] ='b01011101;
           rom[ 0+10433] ='b11110001;
           rom[ 0+10434] ='b11000001;
           rom[ 0+10435] ='b11011101;
           rom[ 0+10436] ='b01110011;
           rom[ 0+10437] ='b11111010;
           rom[ 0+10438] ='b00100001;
           rom[ 0+10439] ='b00000110;
           rom[ 0+10440] ='b10010000;
           rom[ 0+10441] ='b00001001;
           rom[ 0+10442] ='b11011101;
           rom[ 0+10443] ='b01110101;
           rom[ 0+10444] ='b11010001;
           rom[ 0+10445] ='b11011101;
           rom[ 0+10446] ='b01110100;
           rom[ 0+10447] ='b11010010;
           rom[ 0+10448] ='b11011101;
           rom[ 0+10449] ='b01111110;
           rom[ 0+10450] ='b11010001;
           rom[ 0+10451] ='b11000110;
           rom[ 0+10452] ='b00000100;
           rom[ 0+10453] ='b01011111;
           rom[ 0+10454] ='b11011101;
           rom[ 0+10455] ='b01111110;
           rom[ 0+10456] ='b11010010;
           rom[ 0+10457] ='b11001110;
           rom[ 0+10458] ='b00000000;
           rom[ 0+10459] ='b01010111;
           rom[ 0+10460] ='b00011010;
           rom[ 0+10461] ='b01011111;
           rom[ 0+10462] ='b11011101;
           rom[ 0+10463] ='b01101110;
           rom[ 0+10464] ='b11010001;
           rom[ 0+10465] ='b11011101;
           rom[ 0+10466] ='b01100110;
           rom[ 0+10467] ='b11010010;
           rom[ 0+10468] ='b01010110;
           rom[ 0+10469] ='b11000101;
           rom[ 0+10470] ='b01111011;
           rom[ 0+10471] ='b11110101;
           rom[ 0+10472] ='b00110011;
           rom[ 0+10473] ='b11010101;
           rom[ 0+10474] ='b00110011;
           rom[ 0+10475] ='b11001101;
           rom[ 0+10476] ='b00001110;
           rom[ 0+10477] ='b00100000;
           rom[ 0+10478] ='b01011101;
           rom[ 0+10479] ='b11110001;
           rom[ 0+10480] ='b11000001;
           rom[ 0+10481] ='b11011101;
           rom[ 0+10482] ='b01110011;
           rom[ 0+10483] ='b11111001;
           rom[ 0+10484] ='b00100001;
           rom[ 0+10485] ='b00000110;
           rom[ 0+10486] ='b10010000;
           rom[ 0+10487] ='b00001001;
           rom[ 0+10488] ='b11011101;
           rom[ 0+10489] ='b01110101;
           rom[ 0+10490] ='b11010001;
           rom[ 0+10491] ='b11011101;
           rom[ 0+10492] ='b01110100;
           rom[ 0+10493] ='b11010010;
           rom[ 0+10494] ='b11011101;
           rom[ 0+10495] ='b01111110;
           rom[ 0+10496] ='b11010001;
           rom[ 0+10497] ='b11000110;
           rom[ 0+10498] ='b00000101;
           rom[ 0+10499] ='b01011111;
           rom[ 0+10500] ='b11011101;
           rom[ 0+10501] ='b01111110;
           rom[ 0+10502] ='b11010010;
           rom[ 0+10503] ='b11001110;
           rom[ 0+10504] ='b00000000;
           rom[ 0+10505] ='b01010111;
           rom[ 0+10506] ='b00011010;
           rom[ 0+10507] ='b01011111;
           rom[ 0+10508] ='b11011101;
           rom[ 0+10509] ='b01101110;
           rom[ 0+10510] ='b11010001;
           rom[ 0+10511] ='b11011101;
           rom[ 0+10512] ='b01100110;
           rom[ 0+10513] ='b11010010;
           rom[ 0+10514] ='b01010110;
           rom[ 0+10515] ='b11000101;
           rom[ 0+10516] ='b01111011;
           rom[ 0+10517] ='b11110101;
           rom[ 0+10518] ='b00110011;
           rom[ 0+10519] ='b11010101;
           rom[ 0+10520] ='b00110011;
           rom[ 0+10521] ='b11001101;
           rom[ 0+10522] ='b00001110;
           rom[ 0+10523] ='b00100000;
           rom[ 0+10524] ='b01011101;
           rom[ 0+10525] ='b11110001;
           rom[ 0+10526] ='b11000001;
           rom[ 0+10527] ='b11011101;
           rom[ 0+10528] ='b01110011;
           rom[ 0+10529] ='b11111000;
           rom[ 0+10530] ='b00100001;
           rom[ 0+10531] ='b00000110;
           rom[ 0+10532] ='b10010000;
           rom[ 0+10533] ='b00001001;
           rom[ 0+10534] ='b11011101;
           rom[ 0+10535] ='b01110101;
           rom[ 0+10536] ='b11010001;
           rom[ 0+10537] ='b11011101;
           rom[ 0+10538] ='b01110100;
           rom[ 0+10539] ='b11010010;
           rom[ 0+10540] ='b11011101;
           rom[ 0+10541] ='b01111110;
           rom[ 0+10542] ='b11010001;
           rom[ 0+10543] ='b11000110;
           rom[ 0+10544] ='b00000011;
           rom[ 0+10545] ='b01011111;
           rom[ 0+10546] ='b11011101;
           rom[ 0+10547] ='b01111110;
           rom[ 0+10548] ='b11010010;
           rom[ 0+10549] ='b11001110;
           rom[ 0+10550] ='b00000000;
           rom[ 0+10551] ='b01010111;
           rom[ 0+10552] ='b00011010;
           rom[ 0+10553] ='b11011101;
           rom[ 0+10554] ='b01110111;
           rom[ 0+10555] ='b11010000;
           rom[ 0+10556] ='b11011101;
           rom[ 0+10557] ='b01111110;
           rom[ 0+10558] ='b11010001;
           rom[ 0+10559] ='b11000110;
           rom[ 0+10560] ='b00000010;
           rom[ 0+10561] ='b01010111;
           rom[ 0+10562] ='b11011101;
           rom[ 0+10563] ='b01111110;
           rom[ 0+10564] ='b11010010;
           rom[ 0+10565] ='b11001110;
           rom[ 0+10566] ='b00000000;
           rom[ 0+10567] ='b01011111;
           rom[ 0+10568] ='b01101010;
           rom[ 0+10569] ='b01100011;
           rom[ 0+10570] ='b01010110;
           rom[ 0+10571] ='b11000101;
           rom[ 0+10572] ='b11011101;
           rom[ 0+10573] ='b01111110;
           rom[ 0+10574] ='b11010000;
           rom[ 0+10575] ='b11110101;
           rom[ 0+10576] ='b00110011;
           rom[ 0+10577] ='b11010101;
           rom[ 0+10578] ='b00110011;
           rom[ 0+10579] ='b11001101;
           rom[ 0+10580] ='b00001110;
           rom[ 0+10581] ='b00100000;
           rom[ 0+10582] ='b01011101;
           rom[ 0+10583] ='b11110001;
           rom[ 0+10584] ='b11000001;
           rom[ 0+10585] ='b11011101;
           rom[ 0+10586] ='b01110011;
           rom[ 0+10587] ='b11110110;
           rom[ 0+10588] ='b11011101;
           rom[ 0+10589] ='b01111110;
           rom[ 0+10590] ='b11111111;
           rom[ 0+10591] ='b11011101;
           rom[ 0+10592] ='b10101110;
           rom[ 0+10593] ='b11111011;
           rom[ 0+10594] ='b01010111;
           rom[ 0+10595] ='b11011101;
           rom[ 0+10596] ='b01110010;
           rom[ 0+10597] ='b11101111;
           rom[ 0+10598] ='b11011101;
           rom[ 0+10599] ='b01111110;
           rom[ 0+10600] ='b11111010;
           rom[ 0+10601] ='b11011101;
           rom[ 0+10602] ='b10101110;
           rom[ 0+10603] ='b11111100;
           rom[ 0+10604] ='b01011111;
           rom[ 0+10605] ='b11011101;
           rom[ 0+10606] ='b01110011;
           rom[ 0+10607] ='b11101110;
           rom[ 0+10608] ='b11011101;
           rom[ 0+10609] ='b01111110;
           rom[ 0+10610] ='b11111110;
           rom[ 0+10611] ='b11011101;
           rom[ 0+10612] ='b10101110;
           rom[ 0+10613] ='b11111101;
           rom[ 0+10614] ='b01011111;
           rom[ 0+10615] ='b11011101;
           rom[ 0+10616] ='b01110011;
           rom[ 0+10617] ='b11110000;
           rom[ 0+10618] ='b11011101;
           rom[ 0+10619] ='b01111110;
           rom[ 0+10620] ='b11111100;
           rom[ 0+10621] ='b11011101;
           rom[ 0+10622] ='b10101110;
           rom[ 0+10623] ='b11111001;
           rom[ 0+10624] ='b01011111;
           rom[ 0+10625] ='b11000101;
           rom[ 0+10626] ='b01111011;
           rom[ 0+10627] ='b11110101;
           rom[ 0+10628] ='b00110011;
           rom[ 0+10629] ='b11011101;
           rom[ 0+10630] ='b01111110;
           rom[ 0+10631] ='b11101111;
           rom[ 0+10632] ='b11110101;
           rom[ 0+10633] ='b00110011;
           rom[ 0+10634] ='b11001101;
           rom[ 0+10635] ='b00001110;
           rom[ 0+10636] ='b00100000;
           rom[ 0+10637] ='b01011101;
           rom[ 0+10638] ='b11110001;
           rom[ 0+10639] ='b11000001;
           rom[ 0+10640] ='b11011101;
           rom[ 0+10641] ='b01111110;
           rom[ 0+10642] ='b11110110;
           rom[ 0+10643] ='b11011101;
           rom[ 0+10644] ='b10101110;
           rom[ 0+10645] ='b11111000;
           rom[ 0+10646] ='b01010111;
           rom[ 0+10647] ='b11000101;
           rom[ 0+10648] ='b11010101;
           rom[ 0+10649] ='b11010101;
           rom[ 0+10650] ='b00110011;
           rom[ 0+10651] ='b11011101;
           rom[ 0+10652] ='b01111110;
           rom[ 0+10653] ='b11110000;
           rom[ 0+10654] ='b11110101;
           rom[ 0+10655] ='b00110011;
           rom[ 0+10656] ='b11001101;
           rom[ 0+10657] ='b00001110;
           rom[ 0+10658] ='b00100000;
           rom[ 0+10659] ='b01010101;
           rom[ 0+10660] ='b11110001;
           rom[ 0+10661] ='b01111010;
           rom[ 0+10662] ='b11010001;
           rom[ 0+10663] ='b01010111;
           rom[ 0+10664] ='b11000001;
           rom[ 0+10665] ='b01111011;
           rom[ 0+10666] ='b10101010;
           rom[ 0+10667] ='b01011111;
           rom[ 0+10668] ='b11011101;
           rom[ 0+10669] ='b01110011;
           rom[ 0+10670] ='b11110100;
           rom[ 0+10671] ='b11000101;
           rom[ 0+10672] ='b11011101;
           rom[ 0+10673] ='b01111110;
           rom[ 0+10674] ='b11101111;
           rom[ 0+10675] ='b11110101;
           rom[ 0+10676] ='b00110011;
           rom[ 0+10677] ='b11011101;
           rom[ 0+10678] ='b01111110;
           rom[ 0+10679] ='b11101111;
           rom[ 0+10680] ='b11110101;
           rom[ 0+10681] ='b00110011;
           rom[ 0+10682] ='b11001101;
           rom[ 0+10683] ='b00001110;
           rom[ 0+10684] ='b00100000;
           rom[ 0+10685] ='b01010101;
           rom[ 0+10686] ='b11110001;
           rom[ 0+10687] ='b11000001;
           rom[ 0+10688] ='b11011101;
           rom[ 0+10689] ='b01111110;
           rom[ 0+10690] ='b11111010;
           rom[ 0+10691] ='b11011101;
           rom[ 0+10692] ='b10101110;
           rom[ 0+10693] ='b11111001;
           rom[ 0+10694] ='b01011111;
           rom[ 0+10695] ='b11000101;
           rom[ 0+10696] ='b11010101;
           rom[ 0+10697] ='b01111011;
           rom[ 0+10698] ='b11110101;
           rom[ 0+10699] ='b00110011;
           rom[ 0+10700] ='b11011101;
           rom[ 0+10701] ='b01111110;
           rom[ 0+10702] ='b11110000;
           rom[ 0+10703] ='b11110101;
           rom[ 0+10704] ='b00110011;
           rom[ 0+10705] ='b11001101;
           rom[ 0+10706] ='b00001110;
           rom[ 0+10707] ='b00100000;
           rom[ 0+10708] ='b01011101;
           rom[ 0+10709] ='b11110001;
           rom[ 0+10710] ='b11110001;
           rom[ 0+10711] ='b01010111;
           rom[ 0+10712] ='b11000001;
           rom[ 0+10713] ='b01111010;
           rom[ 0+10714] ='b10101011;
           rom[ 0+10715] ='b01010111;
           rom[ 0+10716] ='b11000101;
           rom[ 0+10717] ='b11010101;
           rom[ 0+10718] ='b00110011;
           rom[ 0+10719] ='b11011101;
           rom[ 0+10720] ='b01111110;
           rom[ 0+10721] ='b11110100;
           rom[ 0+10722] ='b11110101;
           rom[ 0+10723] ='b00110011;
           rom[ 0+10724] ='b11001101;
           rom[ 0+10725] ='b01101111;
           rom[ 0+10726] ='b00100000;
           rom[ 0+10727] ='b01011101;
           rom[ 0+10728] ='b11110001;
           rom[ 0+10729] ='b11000001;
           rom[ 0+10730] ='b11011101;
           rom[ 0+10731] ='b01110011;
           rom[ 0+10732] ='b11110010;
           rom[ 0+10733] ='b00100001;
           rom[ 0+10734] ='b00000110;
           rom[ 0+10735] ='b10010000;
           rom[ 0+10736] ='b00001001;
           rom[ 0+10737] ='b11011101;
           rom[ 0+10738] ='b01110101;
           rom[ 0+10739] ='b11010001;
           rom[ 0+10740] ='b11011101;
           rom[ 0+10741] ='b01110100;
           rom[ 0+10742] ='b11010010;
           rom[ 0+10743] ='b11011101;
           rom[ 0+10744] ='b01111110;
           rom[ 0+10745] ='b11010001;
           rom[ 0+10746] ='b11000110;
           rom[ 0+10747] ='b00000100;
           rom[ 0+10748] ='b01011111;
           rom[ 0+10749] ='b11011101;
           rom[ 0+10750] ='b01111110;
           rom[ 0+10751] ='b11010010;
           rom[ 0+10752] ='b11001110;
           rom[ 0+10753] ='b00000000;
           rom[ 0+10754] ='b01010111;
           rom[ 0+10755] ='b00011010;
           rom[ 0+10756] ='b11011101;
           rom[ 0+10757] ='b01110111;
           rom[ 0+10758] ='b11010000;
           rom[ 0+10759] ='b11011101;
           rom[ 0+10760] ='b01111110;
           rom[ 0+10761] ='b11010001;
           rom[ 0+10762] ='b11000110;
           rom[ 0+10763] ='b00000010;
           rom[ 0+10764] ='b01010111;
           rom[ 0+10765] ='b11011101;
           rom[ 0+10766] ='b01111110;
           rom[ 0+10767] ='b11010010;
           rom[ 0+10768] ='b11001110;
           rom[ 0+10769] ='b00000000;
           rom[ 0+10770] ='b01011111;
           rom[ 0+10771] ='b01101010;
           rom[ 0+10772] ='b01100011;
           rom[ 0+10773] ='b01010110;
           rom[ 0+10774] ='b11000101;
           rom[ 0+10775] ='b11011101;
           rom[ 0+10776] ='b01111110;
           rom[ 0+10777] ='b11010000;
           rom[ 0+10778] ='b11110101;
           rom[ 0+10779] ='b00110011;
           rom[ 0+10780] ='b11010101;
           rom[ 0+10781] ='b00110011;
           rom[ 0+10782] ='b11001101;
           rom[ 0+10783] ='b00001110;
           rom[ 0+10784] ='b00100000;
           rom[ 0+10785] ='b01011101;
           rom[ 0+10786] ='b11110001;
           rom[ 0+10787] ='b11000001;
           rom[ 0+10788] ='b11011101;
           rom[ 0+10789] ='b01110011;
           rom[ 0+10790] ='b11110101;
           rom[ 0+10791] ='b00100001;
           rom[ 0+10792] ='b00000110;
           rom[ 0+10793] ='b10010000;
           rom[ 0+10794] ='b00001001;
           rom[ 0+10795] ='b11011101;
           rom[ 0+10796] ='b01110101;
           rom[ 0+10797] ='b11010001;
           rom[ 0+10798] ='b11011101;
           rom[ 0+10799] ='b01110100;
           rom[ 0+10800] ='b11010010;
           rom[ 0+10801] ='b11011101;
           rom[ 0+10802] ='b01111110;
           rom[ 0+10803] ='b11010001;
           rom[ 0+10804] ='b11000110;
           rom[ 0+10805] ='b00000100;
           rom[ 0+10806] ='b01011111;
           rom[ 0+10807] ='b11011101;
           rom[ 0+10808] ='b01111110;
           rom[ 0+10809] ='b11010010;
           rom[ 0+10810] ='b11001110;
           rom[ 0+10811] ='b00000000;
           rom[ 0+10812] ='b01010111;
           rom[ 0+10813] ='b00011010;
           rom[ 0+10814] ='b11011101;
           rom[ 0+10815] ='b01110111;
           rom[ 0+10816] ='b11010000;
           rom[ 0+10817] ='b11011101;
           rom[ 0+10818] ='b01111110;
           rom[ 0+10819] ='b11010001;
           rom[ 0+10820] ='b11000110;
           rom[ 0+10821] ='b00000001;
           rom[ 0+10822] ='b01010111;
           rom[ 0+10823] ='b11011101;
           rom[ 0+10824] ='b01111110;
           rom[ 0+10825] ='b11010010;
           rom[ 0+10826] ='b11001110;
           rom[ 0+10827] ='b00000000;
           rom[ 0+10828] ='b01011111;
           rom[ 0+10829] ='b01101010;
           rom[ 0+10830] ='b01100011;
           rom[ 0+10831] ='b01010110;
           rom[ 0+10832] ='b11000101;
           rom[ 0+10833] ='b11011101;
           rom[ 0+10834] ='b01111110;
           rom[ 0+10835] ='b11010000;
           rom[ 0+10836] ='b11110101;
           rom[ 0+10837] ='b00110011;
           rom[ 0+10838] ='b11010101;
           rom[ 0+10839] ='b00110011;
           rom[ 0+10840] ='b11001101;
           rom[ 0+10841] ='b00001110;
           rom[ 0+10842] ='b00100000;
           rom[ 0+10843] ='b01011101;
           rom[ 0+10844] ='b11110001;
           rom[ 0+10845] ='b11000001;
           rom[ 0+10846] ='b11011101;
           rom[ 0+10847] ='b01110011;
           rom[ 0+10848] ='b11110111;
           rom[ 0+10849] ='b00100001;
           rom[ 0+10850] ='b00000110;
           rom[ 0+10851] ='b10010000;
           rom[ 0+10852] ='b00001001;
           rom[ 0+10853] ='b11011101;
           rom[ 0+10854] ='b01110101;
           rom[ 0+10855] ='b11010001;
           rom[ 0+10856] ='b11011101;
           rom[ 0+10857] ='b01110100;
           rom[ 0+10858] ='b11010010;
           rom[ 0+10859] ='b11011101;
           rom[ 0+10860] ='b01111110;
           rom[ 0+10861] ='b11010001;
           rom[ 0+10862] ='b11000110;
           rom[ 0+10863] ='b00000101;
           rom[ 0+10864] ='b01011111;
           rom[ 0+10865] ='b11011101;
           rom[ 0+10866] ='b01111110;
           rom[ 0+10867] ='b11010010;
           rom[ 0+10868] ='b11001110;
           rom[ 0+10869] ='b00000000;
           rom[ 0+10870] ='b01010111;
           rom[ 0+10871] ='b00011010;
           rom[ 0+10872] ='b11011101;
           rom[ 0+10873] ='b01110111;
           rom[ 0+10874] ='b11010000;
           rom[ 0+10875] ='b11011101;
           rom[ 0+10876] ='b01111110;
           rom[ 0+10877] ='b11010001;
           rom[ 0+10878] ='b11000110;
           rom[ 0+10879] ='b00000001;
           rom[ 0+10880] ='b01010111;
           rom[ 0+10881] ='b11011101;
           rom[ 0+10882] ='b01111110;
           rom[ 0+10883] ='b11010010;
           rom[ 0+10884] ='b11001110;
           rom[ 0+10885] ='b00000000;
           rom[ 0+10886] ='b01011111;
           rom[ 0+10887] ='b01101010;
           rom[ 0+10888] ='b01100011;
           rom[ 0+10889] ='b01010110;
           rom[ 0+10890] ='b11000101;
           rom[ 0+10891] ='b11011101;
           rom[ 0+10892] ='b01111110;
           rom[ 0+10893] ='b11010000;
           rom[ 0+10894] ='b11110101;
           rom[ 0+10895] ='b00110011;
           rom[ 0+10896] ='b11010101;
           rom[ 0+10897] ='b00110011;
           rom[ 0+10898] ='b11001101;
           rom[ 0+10899] ='b00001110;
           rom[ 0+10900] ='b00100000;
           rom[ 0+10901] ='b01011101;
           rom[ 0+10902] ='b11110001;
           rom[ 0+10903] ='b11000001;
           rom[ 0+10904] ='b01111011;
           rom[ 0+10905] ='b11011101;
           rom[ 0+10906] ='b10101110;
           rom[ 0+10907] ='b11110101;
           rom[ 0+10908] ='b01011111;
           rom[ 0+10909] ='b11011101;
           rom[ 0+10910] ='b01111110;
           rom[ 0+10911] ='b11110110;
           rom[ 0+10912] ='b11011101;
           rom[ 0+10913] ='b10101110;
           rom[ 0+10914] ='b11110111;
           rom[ 0+10915] ='b01010111;
           rom[ 0+10916] ='b11000101;
           rom[ 0+10917] ='b11010101;
           rom[ 0+10918] ='b11011101;
           rom[ 0+10919] ='b01111110;
           rom[ 0+10920] ='b11110010;
           rom[ 0+10921] ='b11110101;
           rom[ 0+10922] ='b00110011;
           rom[ 0+10923] ='b11010101;
           rom[ 0+10924] ='b00110011;
           rom[ 0+10925] ='b11001101;
           rom[ 0+10926] ='b00001110;
           rom[ 0+10927] ='b00100000;
           rom[ 0+10928] ='b01010101;
           rom[ 0+10929] ='b11110001;
           rom[ 0+10930] ='b01111010;
           rom[ 0+10931] ='b11010001;
           rom[ 0+10932] ='b01010111;
           rom[ 0+10933] ='b11000001;
           rom[ 0+10934] ='b01111011;
           rom[ 0+10935] ='b10101010;
           rom[ 0+10936] ='b01011111;
           rom[ 0+10937] ='b11000101;
           rom[ 0+10938] ='b11011101;
           rom[ 0+10939] ='b01111110;
           rom[ 0+10940] ='b11101110;
           rom[ 0+10941] ='b11110101;
           rom[ 0+10942] ='b00110011;
           rom[ 0+10943] ='b01111011;
           rom[ 0+10944] ='b11110101;
           rom[ 0+10945] ='b00110011;
           rom[ 0+10946] ='b11001101;
           rom[ 0+10947] ='b01101111;
           rom[ 0+10948] ='b00100000;
           rom[ 0+10949] ='b01011101;
           rom[ 0+10950] ='b11110001;
           rom[ 0+10951] ='b11000001;
           rom[ 0+10952] ='b11011101;
           rom[ 0+10953] ='b01110011;
           rom[ 0+10954] ='b11110001;
           rom[ 0+10955] ='b00100001;
           rom[ 0+10956] ='b00000110;
           rom[ 0+10957] ='b10010000;
           rom[ 0+10958] ='b00001001;
           rom[ 0+10959] ='b11011101;
           rom[ 0+10960] ='b01110101;
           rom[ 0+10961] ='b11010001;
           rom[ 0+10962] ='b11011101;
           rom[ 0+10963] ='b01110100;
           rom[ 0+10964] ='b11010010;
           rom[ 0+10965] ='b11011101;
           rom[ 0+10966] ='b01111110;
           rom[ 0+10967] ='b11010001;
           rom[ 0+10968] ='b11000110;
           rom[ 0+10969] ='b00000011;
           rom[ 0+10970] ='b01011111;
           rom[ 0+10971] ='b11011101;
           rom[ 0+10972] ='b01111110;
           rom[ 0+10973] ='b11010010;
           rom[ 0+10974] ='b11001110;
           rom[ 0+10975] ='b00000000;
           rom[ 0+10976] ='b01010111;
           rom[ 0+10977] ='b00011010;
           rom[ 0+10978] ='b11011101;
           rom[ 0+10979] ='b01110111;
           rom[ 0+10980] ='b11010000;
           rom[ 0+10981] ='b11011101;
           rom[ 0+10982] ='b01111110;
           rom[ 0+10983] ='b11010001;
           rom[ 0+10984] ='b11000110;
           rom[ 0+10985] ='b00000001;
           rom[ 0+10986] ='b01010111;
           rom[ 0+10987] ='b11011101;
           rom[ 0+10988] ='b01111110;
           rom[ 0+10989] ='b11010010;
           rom[ 0+10990] ='b11001110;
           rom[ 0+10991] ='b00000000;
           rom[ 0+10992] ='b01011111;
           rom[ 0+10993] ='b01101010;
           rom[ 0+10994] ='b01100011;
           rom[ 0+10995] ='b01010110;
           rom[ 0+10996] ='b11000101;
           rom[ 0+10997] ='b11011101;
           rom[ 0+10998] ='b01111110;
           rom[ 0+10999] ='b11110001;
           rom[ 0+11000] ='b11110101;
           rom[ 0+11001] ='b00110011;
           rom[ 0+11002] ='b11010101;
           rom[ 0+11003] ='b00110011;
           rom[ 0+11004] ='b11001101;
           rom[ 0+11005] ='b00001110;
           rom[ 0+11006] ='b00100000;
           rom[ 0+11007] ='b01011101;
           rom[ 0+11008] ='b11110001;
           rom[ 0+11009] ='b11000001;
           rom[ 0+11010] ='b11011101;
           rom[ 0+11011] ='b01111110;
           rom[ 0+11012] ='b11010000;
           rom[ 0+11013] ='b10101011;
           rom[ 0+11014] ='b11011101;
           rom[ 0+11015] ='b01110111;
           rom[ 0+11016] ='b11010000;
           rom[ 0+11017] ='b00100001;
           rom[ 0+11018] ='b00000110;
           rom[ 0+11019] ='b10010000;
           rom[ 0+11020] ='b00001001;
           rom[ 0+11021] ='b01010101;
           rom[ 0+11022] ='b01011100;
           rom[ 0+11023] ='b01111010;
           rom[ 0+11024] ='b11000110;
           rom[ 0+11025] ='b00000010;
           rom[ 0+11026] ='b01010111;
           rom[ 0+11027] ='b01111011;
           rom[ 0+11028] ='b11001110;
           rom[ 0+11029] ='b00000000;
           rom[ 0+11030] ='b01011111;
           rom[ 0+11031] ='b01101010;
           rom[ 0+11032] ='b01100011;
           rom[ 0+11033] ='b01010110;
           rom[ 0+11034] ='b11000101;
           rom[ 0+11035] ='b11011101;
           rom[ 0+11036] ='b01111110;
           rom[ 0+11037] ='b11110010;
           rom[ 0+11038] ='b11110101;
           rom[ 0+11039] ='b00110011;
           rom[ 0+11040] ='b11010101;
           rom[ 0+11041] ='b00110011;
           rom[ 0+11042] ='b11001101;
           rom[ 0+11043] ='b00001110;
           rom[ 0+11044] ='b00100000;
           rom[ 0+11045] ='b01011101;
           rom[ 0+11046] ='b11110001;
           rom[ 0+11047] ='b11000001;
           rom[ 0+11048] ='b01111011;
           rom[ 0+11049] ='b11011101;
           rom[ 0+11050] ='b10101110;
           rom[ 0+11051] ='b11010000;
           rom[ 0+11052] ='b01011111;
           rom[ 0+11053] ='b11011101;
           rom[ 0+11054] ='b01110011;
           rom[ 0+11055] ='b11110011;
           rom[ 0+11056] ='b00100001;
           rom[ 0+11057] ='b00000110;
           rom[ 0+11058] ='b10010000;
           rom[ 0+11059] ='b00001001;
           rom[ 0+11060] ='b01010101;
           rom[ 0+11061] ='b01011100;
           rom[ 0+11062] ='b01010110;
           rom[ 0+11063] ='b11000101;
           rom[ 0+11064] ='b11010101;
           rom[ 0+11065] ='b00110011;
           rom[ 0+11066] ='b11011101;
           rom[ 0+11067] ='b01111110;
           rom[ 0+11068] ='b11110011;
           rom[ 0+11069] ='b11110101;
           rom[ 0+11070] ='b00110011;
           rom[ 0+11071] ='b11001101;
           rom[ 0+11072] ='b01101111;
           rom[ 0+11073] ='b00100000;
           rom[ 0+11074] ='b01011101;
           rom[ 0+11075] ='b11110001;
           rom[ 0+11076] ='b11000001;
           rom[ 0+11077] ='b11011101;
           rom[ 0+11078] ='b01110011;
           rom[ 0+11079] ='b11101101;
           rom[ 0+11080] ='b11000101;
           rom[ 0+11081] ='b11011101;
           rom[ 0+11082] ='b01111110;
           rom[ 0+11083] ='b11110010;
           rom[ 0+11084] ='b11110101;
           rom[ 0+11085] ='b00110011;
           rom[ 0+11086] ='b11011101;
           rom[ 0+11087] ='b01111110;
           rom[ 0+11088] ='b11110010;
           rom[ 0+11089] ='b11110101;
           rom[ 0+11090] ='b00110011;
           rom[ 0+11091] ='b11001101;
           rom[ 0+11092] ='b00001110;
           rom[ 0+11093] ='b00100000;
           rom[ 0+11094] ='b01010101;
           rom[ 0+11095] ='b11110001;
           rom[ 0+11096] ='b11000001;
           rom[ 0+11097] ='b01111010;
           rom[ 0+11098] ='b11011101;
           rom[ 0+11099] ='b10101110;
           rom[ 0+11100] ='b11110001;
           rom[ 0+11101] ='b01010111;
           rom[ 0+11102] ='b00011110;
           rom[ 0+11103] ='b00000000;
           rom[ 0+11104] ='b11011101;
           rom[ 0+11105] ='b01110010;
           rom[ 0+11106] ='b11001111;
           rom[ 0+11107] ='b11000101;
           rom[ 0+11108] ='b11011101;
           rom[ 0+11109] ='b01111110;
           rom[ 0+11110] ='b11001111;
           rom[ 0+11111] ='b11110101;
           rom[ 0+11112] ='b00110011;
           rom[ 0+11113] ='b11011101;
           rom[ 0+11114] ='b01111110;
           rom[ 0+11115] ='b11001111;
           rom[ 0+11116] ='b11110101;
           rom[ 0+11117] ='b00110011;
           rom[ 0+11118] ='b11001101;
           rom[ 0+11119] ='b00001110;
           rom[ 0+11120] ='b00100000;
           rom[ 0+11121] ='b01011101;
           rom[ 0+11122] ='b11110001;
           rom[ 0+11123] ='b11000001;
           rom[ 0+11124] ='b11000101;
           rom[ 0+11125] ='b11011101;
           rom[ 0+11126] ='b01111110;
           rom[ 0+11127] ='b11001111;
           rom[ 0+11128] ='b11110101;
           rom[ 0+11129] ='b00110011;
           rom[ 0+11130] ='b01111011;
           rom[ 0+11131] ='b11110101;
           rom[ 0+11132] ='b00110011;
           rom[ 0+11133] ='b11001101;
           rom[ 0+11134] ='b00001110;
           rom[ 0+11135] ='b00100000;
           rom[ 0+11136] ='b01011101;
           rom[ 0+11137] ='b11110001;
           rom[ 0+11138] ='b11000001;
           rom[ 0+11139] ='b11011101;
           rom[ 0+11140] ='b01110011;
           rom[ 0+11141] ='b11100101;
           rom[ 0+11142] ='b11011101;
           rom[ 0+11143] ='b00110110;
           rom[ 0+11144] ='b11100110;
           rom[ 0+11145] ='b00000000;
           rom[ 0+11146] ='b11000101;
           rom[ 0+11147] ='b11011101;
           rom[ 0+11148] ='b01111110;
           rom[ 0+11149] ='b11110001;
           rom[ 0+11150] ='b11110101;
           rom[ 0+11151] ='b00110011;
           rom[ 0+11152] ='b11011101;
           rom[ 0+11153] ='b01111110;
           rom[ 0+11154] ='b11110010;
           rom[ 0+11155] ='b11110101;
           rom[ 0+11156] ='b00110011;
           rom[ 0+11157] ='b11001101;
           rom[ 0+11158] ='b00001110;
           rom[ 0+11159] ='b00100000;
           rom[ 0+11160] ='b01011101;
           rom[ 0+11161] ='b11110001;
           rom[ 0+11162] ='b11000001;
           rom[ 0+11163] ='b01111011;
           rom[ 0+11164] ='b11011101;
           rom[ 0+11165] ='b10101110;
           rom[ 0+11166] ='b11101101;
           rom[ 0+11167] ='b01011111;
           rom[ 0+11168] ='b00010110;
           rom[ 0+11169] ='b00000000;
           rom[ 0+11170] ='b11011101;
           rom[ 0+11171] ='b01110011;
           rom[ 0+11172] ='b11010000;
           rom[ 0+11173] ='b11000101;
           rom[ 0+11174] ='b11011101;
           rom[ 0+11175] ='b01111110;
           rom[ 0+11176] ='b11010000;
           rom[ 0+11177] ='b11110101;
           rom[ 0+11178] ='b00110011;
           rom[ 0+11179] ='b11011101;
           rom[ 0+11180] ='b01111110;
           rom[ 0+11181] ='b11010000;
           rom[ 0+11182] ='b11110101;
           rom[ 0+11183] ='b00110011;
           rom[ 0+11184] ='b11001101;
           rom[ 0+11185] ='b00001110;
           rom[ 0+11186] ='b00100000;
           rom[ 0+11187] ='b01011101;
           rom[ 0+11188] ='b11110001;
           rom[ 0+11189] ='b11000001;
           rom[ 0+11190] ='b00010110;
           rom[ 0+11191] ='b00000000;
           rom[ 0+11192] ='b01010011;
           rom[ 0+11193] ='b11011101;
           rom[ 0+11194] ='b01011110;
           rom[ 0+11195] ='b11100101;
           rom[ 0+11196] ='b11000101;
           rom[ 0+11197] ='b11010101;
           rom[ 0+11198] ='b00110011;
           rom[ 0+11199] ='b01111011;
           rom[ 0+11200] ='b11110101;
           rom[ 0+11201] ='b00110011;
           rom[ 0+11202] ='b11001101;
           rom[ 0+11203] ='b01101111;
           rom[ 0+11204] ='b00100000;
           rom[ 0+11205] ='b01011101;
           rom[ 0+11206] ='b11110001;
           rom[ 0+11207] ='b11000001;
           rom[ 0+11208] ='b11011101;
           rom[ 0+11209] ='b01110011;
           rom[ 0+11210] ='b11110000;
           rom[ 0+11211] ='b00111110;
           rom[ 0+11212] ='b10011100;
           rom[ 0+11213] ='b11011101;
           rom[ 0+11214] ='b10000110;
           rom[ 0+11215] ='b11110000;
           rom[ 0+11216] ='b01011111;
           rom[ 0+11217] ='b00111110;
           rom[ 0+11218] ='b00000101;
           rom[ 0+11219] ='b11001110;
           rom[ 0+11220] ='b00000000;
           rom[ 0+11221] ='b01010111;
           rom[ 0+11222] ='b00011010;
           rom[ 0+11223] ='b01011111;
           rom[ 0+11224] ='b00010110;
           rom[ 0+11225] ='b00000000;
           rom[ 0+11226] ='b11000101;
           rom[ 0+11227] ='b11011101;
           rom[ 0+11228] ='b01111110;
           rom[ 0+11229] ='b11010000;
           rom[ 0+11230] ='b11110101;
           rom[ 0+11231] ='b00110011;
           rom[ 0+11232] ='b01111011;
           rom[ 0+11233] ='b11110101;
           rom[ 0+11234] ='b00110011;
           rom[ 0+11235] ='b11001101;
           rom[ 0+11236] ='b00001110;
           rom[ 0+11237] ='b00100000;
           rom[ 0+11238] ='b01011101;
           rom[ 0+11239] ='b11110001;
           rom[ 0+11240] ='b11000001;
           rom[ 0+11241] ='b00010110;
           rom[ 0+11242] ='b00000000;
           rom[ 0+11243] ='b00100001;
           rom[ 0+11244] ='b10011100;
           rom[ 0+11245] ='b00000110;
           rom[ 0+11246] ='b00011001;
           rom[ 0+11247] ='b01011101;
           rom[ 0+11248] ='b01010100;
           rom[ 0+11249] ='b00011010;
           rom[ 0+11250] ='b01011111;
           rom[ 0+11251] ='b11011101;
           rom[ 0+11252] ='b01110011;
           rom[ 0+11253] ='b11100011;
           rom[ 0+11254] ='b11011101;
           rom[ 0+11255] ='b00110110;
           rom[ 0+11256] ='b11100100;
           rom[ 0+11257] ='b00000000;
           rom[ 0+11258] ='b11011101;
           rom[ 0+11259] ='b01111110;
           rom[ 0+11260] ='b11110010;
           rom[ 0+11261] ='b11011101;
           rom[ 0+11262] ='b01110111;
           rom[ 0+11263] ='b11010001;
           rom[ 0+11264] ='b11011101;
           rom[ 0+11265] ='b00110110;
           rom[ 0+11266] ='b11010010;
           rom[ 0+11267] ='b00000000;
           rom[ 0+11268] ='b11011101;
           rom[ 0+11269] ='b01111110;
           rom[ 0+11270] ='b11010001;
           rom[ 0+11271] ='b11011101;
           rom[ 0+11272] ='b10101110;
           rom[ 0+11273] ='b11100011;
           rom[ 0+11274] ='b11011101;
           rom[ 0+11275] ='b01110111;
           rom[ 0+11276] ='b11001101;
           rom[ 0+11277] ='b11011101;
           rom[ 0+11278] ='b01111110;
           rom[ 0+11279] ='b11010010;
           rom[ 0+11280] ='b11011101;
           rom[ 0+11281] ='b10101110;
           rom[ 0+11282] ='b11100100;
           rom[ 0+11283] ='b11011101;
           rom[ 0+11284] ='b01110111;
           rom[ 0+11285] ='b11001110;
           rom[ 0+11286] ='b11011101;
           rom[ 0+11287] ='b01011110;
           rom[ 0+11288] ='b11100011;
           rom[ 0+11289] ='b11000101;
           rom[ 0+11290] ='b01111011;
           rom[ 0+11291] ='b11110101;
           rom[ 0+11292] ='b00110011;
           rom[ 0+11293] ='b11011101;
           rom[ 0+11294] ='b01111110;
           rom[ 0+11295] ='b11001111;
           rom[ 0+11296] ='b11110101;
           rom[ 0+11297] ='b00110011;
           rom[ 0+11298] ='b11001101;
           rom[ 0+11299] ='b01101111;
           rom[ 0+11300] ='b00100000;
           rom[ 0+11301] ='b01011101;
           rom[ 0+11302] ='b11110001;
           rom[ 0+11303] ='b11000001;
           rom[ 0+11304] ='b00010110;
           rom[ 0+11305] ='b00000000;
           rom[ 0+11306] ='b01111011;
           rom[ 0+11307] ='b11011101;
           rom[ 0+11308] ='b10101110;
           rom[ 0+11309] ='b11001101;
           rom[ 0+11310] ='b01011111;
           rom[ 0+11311] ='b01111010;
           rom[ 0+11312] ='b11011101;
           rom[ 0+11313] ='b10101110;
           rom[ 0+11314] ='b11001110;
           rom[ 0+11315] ='b01010111;
           rom[ 0+11316] ='b11011101;
           rom[ 0+11317] ='b01110011;
           rom[ 0+11318] ='b11011101;
           rom[ 0+11319] ='b11011101;
           rom[ 0+11320] ='b01110010;
           rom[ 0+11321] ='b11011110;
           rom[ 0+11322] ='b00111110;
           rom[ 0+11323] ='b10011100;
           rom[ 0+11324] ='b11011101;
           rom[ 0+11325] ='b10000110;
           rom[ 0+11326] ='b11011101;
           rom[ 0+11327] ='b01011111;
           rom[ 0+11328] ='b00111110;
           rom[ 0+11329] ='b00000010;
           rom[ 0+11330] ='b11011101;
           rom[ 0+11331] ='b10001110;
           rom[ 0+11332] ='b11011110;
           rom[ 0+11333] ='b01010111;
           rom[ 0+11334] ='b00011010;
           rom[ 0+11335] ='b01011111;
           rom[ 0+11336] ='b11011101;
           rom[ 0+11337] ='b01110011;
           rom[ 0+11338] ='b11010111;
           rom[ 0+11339] ='b11011101;
           rom[ 0+11340] ='b00110110;
           rom[ 0+11341] ='b11011000;
           rom[ 0+11342] ='b00000000;
           rom[ 0+11343] ='b00010001;
           rom[ 0+11344] ='b11110001;
           rom[ 0+11345] ='b00000011;
           rom[ 0+11346] ='b00011010;
           rom[ 0+11347] ='b01011111;
           rom[ 0+11348] ='b11011101;
           rom[ 0+11349] ='b01010110;
           rom[ 0+11350] ='b11100011;
           rom[ 0+11351] ='b11000101;
           rom[ 0+11352] ='b11010101;
           rom[ 0+11353] ='b01111011;
           rom[ 0+11354] ='b11110101;
           rom[ 0+11355] ='b00110011;
           rom[ 0+11356] ='b11010101;
           rom[ 0+11357] ='b00110011;
           rom[ 0+11358] ='b11001101;
           rom[ 0+11359] ='b00001110;
           rom[ 0+11360] ='b00100000;
           rom[ 0+11361] ='b01010101;
           rom[ 0+11362] ='b11110001;
           rom[ 0+11363] ='b01111010;
           rom[ 0+11364] ='b11010001;
           rom[ 0+11365] ='b01010111;
           rom[ 0+11366] ='b11000001;
           rom[ 0+11367] ='b11011101;
           rom[ 0+11368] ='b01110010;
           rom[ 0+11369] ='b11100001;
           rom[ 0+11370] ='b11011101;
           rom[ 0+11371] ='b00110110;
           rom[ 0+11372] ='b11100010;
           rom[ 0+11373] ='b00000000;
           rom[ 0+11374] ='b11011101;
           rom[ 0+11375] ='b01111110;
           rom[ 0+11376] ='b11100001;
           rom[ 0+11377] ='b11011101;
           rom[ 0+11378] ='b01110111;
           rom[ 0+11379] ='b11001101;
           rom[ 0+11380] ='b11000101;
           rom[ 0+11381] ='b01111011;
           rom[ 0+11382] ='b11110101;
           rom[ 0+11383] ='b00110011;
           rom[ 0+11384] ='b11011101;
           rom[ 0+11385] ='b01111110;
           rom[ 0+11386] ='b11001101;
           rom[ 0+11387] ='b11110101;
           rom[ 0+11388] ='b00110011;
           rom[ 0+11389] ='b11001101;
           rom[ 0+11390] ='b00001110;
           rom[ 0+11391] ='b00100000;
           rom[ 0+11392] ='b01010101;
           rom[ 0+11393] ='b11110001;
           rom[ 0+11394] ='b11000001;
           rom[ 0+11395] ='b11011101;
           rom[ 0+11396] ='b01110010;
           rom[ 0+11397] ='b11011111;
           rom[ 0+11398] ='b11011101;
           rom[ 0+11399] ='b00110110;
           rom[ 0+11400] ='b11100000;
           rom[ 0+11401] ='b00000000;
           rom[ 0+11402] ='b11011101;
           rom[ 0+11403] ='b01111110;
           rom[ 0+11404] ='b11010001;
           rom[ 0+11405] ='b11011101;
           rom[ 0+11406] ='b10101110;
           rom[ 0+11407] ='b11100001;
           rom[ 0+11408] ='b11011101;
           rom[ 0+11409] ='b01110111;
           rom[ 0+11410] ='b11001011;
           rom[ 0+11411] ='b11011101;
           rom[ 0+11412] ='b01111110;
           rom[ 0+11413] ='b11010010;
           rom[ 0+11414] ='b11011101;
           rom[ 0+11415] ='b10101110;
           rom[ 0+11416] ='b11100010;
           rom[ 0+11417] ='b11011101;
           rom[ 0+11418] ='b01110111;
           rom[ 0+11419] ='b11001100;
           rom[ 0+11420] ='b11000101;
           rom[ 0+11421] ='b11011101;
           rom[ 0+11422] ='b01111110;
           rom[ 0+11423] ='b11001101;
           rom[ 0+11424] ='b11110101;
           rom[ 0+11425] ='b00110011;
           rom[ 0+11426] ='b11011101;
           rom[ 0+11427] ='b01111110;
           rom[ 0+11428] ='b11001111;
           rom[ 0+11429] ='b11110101;
           rom[ 0+11430] ='b00110011;
           rom[ 0+11431] ='b11001101;
           rom[ 0+11432] ='b01101111;
           rom[ 0+11433] ='b00100000;
           rom[ 0+11434] ='b01011101;
           rom[ 0+11435] ='b11110001;
           rom[ 0+11436] ='b11000001;
           rom[ 0+11437] ='b00010110;
           rom[ 0+11438] ='b00000000;
           rom[ 0+11439] ='b01111011;
           rom[ 0+11440] ='b11011101;
           rom[ 0+11441] ='b10101110;
           rom[ 0+11442] ='b11001011;
           rom[ 0+11443] ='b01011111;
           rom[ 0+11444] ='b01111010;
           rom[ 0+11445] ='b11011101;
           rom[ 0+11446] ='b10101110;
           rom[ 0+11447] ='b11001100;
           rom[ 0+11448] ='b01010111;
           rom[ 0+11449] ='b11011101;
           rom[ 0+11450] ='b01110011;
           rom[ 0+11451] ='b11011011;
           rom[ 0+11452] ='b11011101;
           rom[ 0+11453] ='b01110010;
           rom[ 0+11454] ='b11011100;
           rom[ 0+11455] ='b11011101;
           rom[ 0+11456] ='b01111110;
           rom[ 0+11457] ='b11010001;
           rom[ 0+11458] ='b11011101;
           rom[ 0+11459] ='b10101110;
           rom[ 0+11460] ='b11011111;
           rom[ 0+11461] ='b11011101;
           rom[ 0+11462] ='b01110111;
           rom[ 0+11463] ='b11001011;
           rom[ 0+11464] ='b11011101;
           rom[ 0+11465] ='b01111110;
           rom[ 0+11466] ='b11010010;
           rom[ 0+11467] ='b11011101;
           rom[ 0+11468] ='b10101110;
           rom[ 0+11469] ='b11100000;
           rom[ 0+11470] ='b11011101;
           rom[ 0+11471] ='b01110111;
           rom[ 0+11472] ='b11001100;
           rom[ 0+11473] ='b11011101;
           rom[ 0+11474] ='b01011110;
           rom[ 0+11475] ='b11011111;
           rom[ 0+11476] ='b11000101;
           rom[ 0+11477] ='b01111011;
           rom[ 0+11478] ='b11110101;
           rom[ 0+11479] ='b00110011;
           rom[ 0+11480] ='b11011101;
           rom[ 0+11481] ='b01111110;
           rom[ 0+11482] ='b11001111;
           rom[ 0+11483] ='b11110101;
           rom[ 0+11484] ='b00110011;
           rom[ 0+11485] ='b11001101;
           rom[ 0+11486] ='b01101111;
           rom[ 0+11487] ='b00100000;
           rom[ 0+11488] ='b01011101;
           rom[ 0+11489] ='b11110001;
           rom[ 0+11490] ='b11000001;
           rom[ 0+11491] ='b00010110;
           rom[ 0+11492] ='b00000000;
           rom[ 0+11493] ='b01111011;
           rom[ 0+11494] ='b11011101;
           rom[ 0+11495] ='b10101110;
           rom[ 0+11496] ='b11001011;
           rom[ 0+11497] ='b01011111;
           rom[ 0+11498] ='b01111010;
           rom[ 0+11499] ='b11011101;
           rom[ 0+11500] ='b10101110;
           rom[ 0+11501] ='b11001100;
           rom[ 0+11502] ='b01010111;
           rom[ 0+11503] ='b11011101;
           rom[ 0+11504] ='b01110011;
           rom[ 0+11505] ='b11011001;
           rom[ 0+11506] ='b11011101;
           rom[ 0+11507] ='b01110010;
           rom[ 0+11508] ='b11011010;
           rom[ 0+11509] ='b00111110;
           rom[ 0+11510] ='b10011100;
           rom[ 0+11511] ='b11011101;
           rom[ 0+11512] ='b10000110;
           rom[ 0+11513] ='b11011011;
           rom[ 0+11514] ='b01011111;
           rom[ 0+11515] ='b00111110;
           rom[ 0+11516] ='b00000010;
           rom[ 0+11517] ='b11011101;
           rom[ 0+11518] ='b10001110;
           rom[ 0+11519] ='b11011100;
           rom[ 0+11520] ='b01010111;
           rom[ 0+11521] ='b00011010;
           rom[ 0+11522] ='b01011111;
           rom[ 0+11523] ='b11011101;
           rom[ 0+11524] ='b01110011;
           rom[ 0+11525] ='b11010101;
           rom[ 0+11526] ='b11011101;
           rom[ 0+11527] ='b00110110;
           rom[ 0+11528] ='b11010110;
           rom[ 0+11529] ='b00000000;
           rom[ 0+11530] ='b00111110;
           rom[ 0+11531] ='b10011100;
           rom[ 0+11532] ='b11011101;
           rom[ 0+11533] ='b10000110;
           rom[ 0+11534] ='b11011001;
           rom[ 0+11535] ='b01011111;
           rom[ 0+11536] ='b00111110;
           rom[ 0+11537] ='b00000010;
           rom[ 0+11538] ='b11011101;
           rom[ 0+11539] ='b10001110;
           rom[ 0+11540] ='b11011010;
           rom[ 0+11541] ='b01010111;
           rom[ 0+11542] ='b00011010;
           rom[ 0+11543] ='b01011111;
           rom[ 0+11544] ='b11011101;
           rom[ 0+11545] ='b01110011;
           rom[ 0+11546] ='b11010011;
           rom[ 0+11547] ='b11011101;
           rom[ 0+11548] ='b00110110;
           rom[ 0+11549] ='b11010100;
           rom[ 0+11550] ='b00000000;
           rom[ 0+11551] ='b11011101;
           rom[ 0+11552] ='b01111110;
           rom[ 0+11553] ='b11011011;
           rom[ 0+11554] ='b11011101;
           rom[ 0+11555] ='b10101110;
           rom[ 0+11556] ='b11011001;
           rom[ 0+11557] ='b01011111;
           rom[ 0+11558] ='b11011101;
           rom[ 0+11559] ='b01111110;
           rom[ 0+11560] ='b11011100;
           rom[ 0+11561] ='b11011101;
           rom[ 0+11562] ='b10101110;
           rom[ 0+11563] ='b11011010;
           rom[ 0+11564] ='b01010111;
           rom[ 0+11565] ='b11011101;
           rom[ 0+11566] ='b01110011;
           rom[ 0+11567] ='b11001011;
           rom[ 0+11568] ='b11011101;
           rom[ 0+11569] ='b01111110;
           rom[ 0+11570] ='b11011101;
           rom[ 0+11571] ='b11011101;
           rom[ 0+11572] ='b10101110;
           rom[ 0+11573] ='b11011001;
           rom[ 0+11574] ='b01010111;
           rom[ 0+11575] ='b11011101;
           rom[ 0+11576] ='b01111110;
           rom[ 0+11577] ='b11011110;
           rom[ 0+11578] ='b11011101;
           rom[ 0+11579] ='b10101110;
           rom[ 0+11580] ='b11011010;
           rom[ 0+11581] ='b01011111;
           rom[ 0+11582] ='b11000101;
           rom[ 0+11583] ='b11011101;
           rom[ 0+11584] ='b01111110;
           rom[ 0+11585] ='b11001011;
           rom[ 0+11586] ='b11110101;
           rom[ 0+11587] ='b00110011;
           rom[ 0+11588] ='b11010101;
           rom[ 0+11589] ='b00110011;
           rom[ 0+11590] ='b11001101;
           rom[ 0+11591] ='b00001110;
           rom[ 0+11592] ='b00100000;
           rom[ 0+11593] ='b11011101;
           rom[ 0+11594] ='b01110101;
           rom[ 0+11595] ='b11001011;
           rom[ 0+11596] ='b11110001;
           rom[ 0+11597] ='b11000001;
           rom[ 0+11598] ='b00100001;
           rom[ 0+11599] ='b00000110;
           rom[ 0+11600] ='b10010000;
           rom[ 0+11601] ='b00001001;
           rom[ 0+11602] ='b01010101;
           rom[ 0+11603] ='b01011100;
           rom[ 0+11604] ='b01011110;
           rom[ 0+11605] ='b11011101;
           rom[ 0+11606] ='b01010110;
           rom[ 0+11607] ='b11011011;
           rom[ 0+11608] ='b11011101;
           rom[ 0+11609] ='b01111110;
           rom[ 0+11610] ='b11011101;
           rom[ 0+11611] ='b11011101;
           rom[ 0+11612] ='b01110111;
           rom[ 0+11613] ='b11010000;
           rom[ 0+11614] ='b11000101;
           rom[ 0+11615] ='b11010101;
           rom[ 0+11616] ='b11010101;
           rom[ 0+11617] ='b00110011;
           rom[ 0+11618] ='b11011101;
           rom[ 0+11619] ='b01111110;
           rom[ 0+11620] ='b11010000;
           rom[ 0+11621] ='b11110101;
           rom[ 0+11622] ='b00110011;
           rom[ 0+11623] ='b11001101;
           rom[ 0+11624] ='b00001110;
           rom[ 0+11625] ='b00100000;
           rom[ 0+11626] ='b01010101;
           rom[ 0+11627] ='b11110001;
           rom[ 0+11628] ='b01111010;
           rom[ 0+11629] ='b11010001;
           rom[ 0+11630] ='b01010111;
           rom[ 0+11631] ='b11000001;
           rom[ 0+11632] ='b11000101;
           rom[ 0+11633] ='b01111011;
           rom[ 0+11634] ='b11110101;
           rom[ 0+11635] ='b00110011;
           rom[ 0+11636] ='b11010101;
           rom[ 0+11637] ='b00110011;
           rom[ 0+11638] ='b11001101;
           rom[ 0+11639] ='b00001110;
           rom[ 0+11640] ='b00100000;
           rom[ 0+11641] ='b11011101;
           rom[ 0+11642] ='b01110101;
           rom[ 0+11643] ='b11001101;
           rom[ 0+11644] ='b11110001;
           rom[ 0+11645] ='b11000001;
           rom[ 0+11646] ='b00100001;
           rom[ 0+11647] ='b00000110;
           rom[ 0+11648] ='b10010000;
           rom[ 0+11649] ='b00001001;
           rom[ 0+11650] ='b01010101;
           rom[ 0+11651] ='b01011100;
           rom[ 0+11652] ='b00010100;
           rom[ 0+11653] ='b11000010;
           rom[ 0+11654] ='b10001001;
           rom[ 0+11655] ='b00101101;
           rom[ 0+11656] ='b00011100;
           rom[ 0+11657] ='b01101010;
           rom[ 0+11658] ='b01100011;
           rom[ 0+11659] ='b01111110;
           rom[ 0+11660] ='b11011101;
           rom[ 0+11661] ='b01110111;
           rom[ 0+11662] ='b11001111;
           rom[ 0+11663] ='b11011101;
           rom[ 0+11664] ='b01111110;
           rom[ 0+11665] ='b11011101;
           rom[ 0+11666] ='b11011101;
           rom[ 0+11667] ='b10101110;
           rom[ 0+11668] ='b11011011;
           rom[ 0+11669] ='b01011111;
           rom[ 0+11670] ='b11011101;
           rom[ 0+11671] ='b01111110;
           rom[ 0+11672] ='b11011110;
           rom[ 0+11673] ='b11011101;
           rom[ 0+11674] ='b10101110;
           rom[ 0+11675] ='b11011100;
           rom[ 0+11676] ='b01010111;
           rom[ 0+11677] ='b11011101;
           rom[ 0+11678] ='b01110011;
           rom[ 0+11679] ='b11010001;
           rom[ 0+11680] ='b11000101;
           rom[ 0+11681] ='b11011101;
           rom[ 0+11682] ='b01111110;
           rom[ 0+11683] ='b11001111;
           rom[ 0+11684] ='b11110101;
           rom[ 0+11685] ='b00110011;
           rom[ 0+11686] ='b11011101;
           rom[ 0+11687] ='b01111110;
           rom[ 0+11688] ='b11010001;
           rom[ 0+11689] ='b11110101;
           rom[ 0+11690] ='b00110011;
           rom[ 0+11691] ='b11001101;
           rom[ 0+11692] ='b00001110;
           rom[ 0+11693] ='b00100000;
           rom[ 0+11694] ='b01010101;
           rom[ 0+11695] ='b11110001;
           rom[ 0+11696] ='b11000001;
           rom[ 0+11697] ='b11011101;
           rom[ 0+11698] ='b01111110;
           rom[ 0+11699] ='b11001101;
           rom[ 0+11700] ='b10101010;
           rom[ 0+11701] ='b11011101;
           rom[ 0+11702] ='b01110111;
           rom[ 0+11703] ='b11001101;
           rom[ 0+11704] ='b00100001;
           rom[ 0+11705] ='b00000110;
           rom[ 0+11706] ='b10010000;
           rom[ 0+11707] ='b00001001;
           rom[ 0+11708] ='b01010101;
           rom[ 0+11709] ='b01011100;
           rom[ 0+11710] ='b01111010;
           rom[ 0+11711] ='b11000110;
           rom[ 0+11712] ='b00000010;
           rom[ 0+11713] ='b01010111;
           rom[ 0+11714] ='b01111011;
           rom[ 0+11715] ='b11001110;
           rom[ 0+11716] ='b00000000;
           rom[ 0+11717] ='b01011111;
           rom[ 0+11718] ='b01101010;
           rom[ 0+11719] ='b01100011;
           rom[ 0+11720] ='b01010110;
           rom[ 0+11721] ='b01111010;
           rom[ 0+11722] ='b11011101;
           rom[ 0+11723] ='b10101110;
           rom[ 0+11724] ='b11001101;
           rom[ 0+11725] ='b01010111;
           rom[ 0+11726] ='b11000101;
           rom[ 0+11727] ='b11011101;
           rom[ 0+11728] ='b01111110;
           rom[ 0+11729] ='b11001011;
           rom[ 0+11730] ='b11110101;
           rom[ 0+11731] ='b00110011;
           rom[ 0+11732] ='b11010101;
           rom[ 0+11733] ='b00110011;
           rom[ 0+11734] ='b11001101;
           rom[ 0+11735] ='b01101111;
           rom[ 0+11736] ='b00100000;
           rom[ 0+11737] ='b01011101;
           rom[ 0+11738] ='b11110001;
           rom[ 0+11739] ='b11000001;
           rom[ 0+11740] ='b11011101;
           rom[ 0+11741] ='b01110011;
           rom[ 0+11742] ='b11100111;
           rom[ 0+11743] ='b11011101;
           rom[ 0+11744] ='b00110110;
           rom[ 0+11745] ='b11101000;
           rom[ 0+11746] ='b00000000;
           rom[ 0+11747] ='b11011101;
           rom[ 0+11748] ='b01111110;
           rom[ 0+11749] ='b11100111;
           rom[ 0+11750] ='b11011101;
           rom[ 0+11751] ='b01110111;
           rom[ 0+11752] ='b11001101;
           rom[ 0+11753] ='b11011101;
           rom[ 0+11754] ='b01010110;
           rom[ 0+11755] ='b11011001;
           rom[ 0+11756] ='b11000101;
           rom[ 0+11757] ='b11011101;
           rom[ 0+11758] ='b01111110;
           rom[ 0+11759] ='b11001101;
           rom[ 0+11760] ='b11110101;
           rom[ 0+11761] ='b00110011;
           rom[ 0+11762] ='b11010101;
           rom[ 0+11763] ='b00110011;
           rom[ 0+11764] ='b11001101;
           rom[ 0+11765] ='b00001110;
           rom[ 0+11766] ='b00100000;
           rom[ 0+11767] ='b11011101;
           rom[ 0+11768] ='b01110101;
           rom[ 0+11769] ='b11001011;
           rom[ 0+11770] ='b11110001;
           rom[ 0+11771] ='b11000001;
           rom[ 0+11772] ='b00100001;
           rom[ 0+11773] ='b00000110;
           rom[ 0+11774] ='b10010000;
           rom[ 0+11775] ='b00001001;
           rom[ 0+11776] ='b01010101;
           rom[ 0+11777] ='b01011100;
           rom[ 0+11778] ='b01010110;
           rom[ 0+11779] ='b00011110;
           rom[ 0+11780] ='b00000000;
           rom[ 0+11781] ='b01111010;
           rom[ 0+11782] ='b11011101;
           rom[ 0+11783] ='b10101110;
           rom[ 0+11784] ='b11100111;
           rom[ 0+11785] ='b01010111;
           rom[ 0+11786] ='b01111011;
           rom[ 0+11787] ='b11011101;
           rom[ 0+11788] ='b10101110;
           rom[ 0+11789] ='b11101000;
           rom[ 0+11790] ='b01011111;
           rom[ 0+11791] ='b11000101;
           rom[ 0+11792] ='b11010101;
           rom[ 0+11793] ='b00110011;
           rom[ 0+11794] ='b11011101;
           rom[ 0+11795] ='b01111110;
           rom[ 0+11796] ='b11010000;
           rom[ 0+11797] ='b11110101;
           rom[ 0+11798] ='b00110011;
           rom[ 0+11799] ='b11001101;
           rom[ 0+11800] ='b00001110;
           rom[ 0+11801] ='b00100000;
           rom[ 0+11802] ='b01011101;
           rom[ 0+11803] ='b11110001;
           rom[ 0+11804] ='b11000001;
           rom[ 0+11805] ='b11011101;
           rom[ 0+11806] ='b01111110;
           rom[ 0+11807] ='b11001011;
           rom[ 0+11808] ='b10101011;
           rom[ 0+11809] ='b11011101;
           rom[ 0+11810] ='b01110111;
           rom[ 0+11811] ='b11001011;
           rom[ 0+11812] ='b00100001;
           rom[ 0+11813] ='b00000110;
           rom[ 0+11814] ='b10010000;
           rom[ 0+11815] ='b00001001;
           rom[ 0+11816] ='b01010101;
           rom[ 0+11817] ='b01011100;
           rom[ 0+11818] ='b00010100;
           rom[ 0+11819] ='b11000010;
           rom[ 0+11820] ='b00101111;
           rom[ 0+11821] ='b00101110;
           rom[ 0+11822] ='b00011100;
           rom[ 0+11823] ='b01101010;
           rom[ 0+11824] ='b01100011;
           rom[ 0+11825] ='b01010110;
           rom[ 0+11826] ='b01111010;
           rom[ 0+11827] ='b11011101;
           rom[ 0+11828] ='b10101110;
           rom[ 0+11829] ='b11001011;
           rom[ 0+11830] ='b01010111;
           rom[ 0+11831] ='b11000101;
           rom[ 0+11832] ='b11011101;
           rom[ 0+11833] ='b01111110;
           rom[ 0+11834] ='b11010001;
           rom[ 0+11835] ='b11110101;
           rom[ 0+11836] ='b00110011;
           rom[ 0+11837] ='b11010101;
           rom[ 0+11838] ='b00110011;
           rom[ 0+11839] ='b11001101;
           rom[ 0+11840] ='b01101111;
           rom[ 0+11841] ='b00100000;
           rom[ 0+11842] ='b01011101;
           rom[ 0+11843] ='b11110001;
           rom[ 0+11844] ='b11000001;
           rom[ 0+11845] ='b11011101;
           rom[ 0+11846] ='b01110011;
           rom[ 0+11847] ='b11101001;
           rom[ 0+11848] ='b11011101;
           rom[ 0+11849] ='b00110110;
           rom[ 0+11850] ='b11101010;
           rom[ 0+11851] ='b00000000;
           rom[ 0+11852] ='b11011101;
           rom[ 0+11853] ='b01111110;
           rom[ 0+11854] ='b11101001;
           rom[ 0+11855] ='b11011101;
           rom[ 0+11856] ='b10101110;
           rom[ 0+11857] ='b11100111;
           rom[ 0+11858] ='b01011111;
           rom[ 0+11859] ='b11011101;
           rom[ 0+11860] ='b01111110;
           rom[ 0+11861] ='b11101010;
           rom[ 0+11862] ='b11011101;
           rom[ 0+11863] ='b10101110;
           rom[ 0+11864] ='b11101000;
           rom[ 0+11865] ='b01010111;
           rom[ 0+11866] ='b00100001;
           rom[ 0+11867] ='b00000110;
           rom[ 0+11868] ='b10010000;
           rom[ 0+11869] ='b00001001;
           rom[ 0+11870] ='b01001101;
           rom[ 0+11871] ='b01000100;
           rom[ 0+11872] ='b00001010;
           rom[ 0+11873] ='b01001111;
           rom[ 0+11874] ='b00000110;
           rom[ 0+11875] ='b00000000;
           rom[ 0+11876] ='b01111011;
           rom[ 0+11877] ='b10101001;
           rom[ 0+11878] ='b01011111;
           rom[ 0+11879] ='b01111010;
           rom[ 0+11880] ='b10101000;
           rom[ 0+11881] ='b01010111;
           rom[ 0+11882] ='b11011101;
           rom[ 0+11883] ='b01110011;
           rom[ 0+11884] ='b11101011;
           rom[ 0+11885] ='b11011101;
           rom[ 0+11886] ='b01110010;
           rom[ 0+11887] ='b11101100;
           rom[ 0+11888] ='b11011101;
           rom[ 0+11889] ='b01011110;
           rom[ 0+11890] ='b00000110;
           rom[ 0+11891] ='b11011101;
           rom[ 0+11892] ='b01010110;
           rom[ 0+11893] ='b00000111;
           rom[ 0+11894] ='b01101011;
           rom[ 0+11895] ='b01100010;
           rom[ 0+11896] ='b00101001;
           rom[ 0+11897] ='b00011001;
           rom[ 0+11898] ='b00101001;
           rom[ 0+11899] ='b00101001;
           rom[ 0+11900] ='b00011001;
           rom[ 0+11901] ='b01001101;
           rom[ 0+11902] ='b01000100;
           rom[ 0+11903] ='b00100001;
           rom[ 0+11904] ='b00000011;
           rom[ 0+11905] ='b10000100;
           rom[ 0+11906] ='b00001001;
           rom[ 0+11907] ='b01001101;
           rom[ 0+11908] ='b01000100;
           rom[ 0+11909] ='b00110110;
           rom[ 0+11910] ='b00000100;
           rom[ 0+11911] ='b00100011;
           rom[ 0+11912] ='b00110110;
           rom[ 0+11913] ='b00000000;
           rom[ 0+11914] ='b01111001;
           rom[ 0+11915] ='b11000110;
           rom[ 0+11916] ='b00000100;
           rom[ 0+11917] ='b11011101;
           rom[ 0+11918] ='b01110111;
           rom[ 0+11919] ='b11001011;
           rom[ 0+11920] ='b01111000;
           rom[ 0+11921] ='b11001110;
           rom[ 0+11922] ='b00000000;
           rom[ 0+11923] ='b11011101;
           rom[ 0+11924] ='b01110111;
           rom[ 0+11925] ='b11001100;
           rom[ 0+11926] ='b11011101;
           rom[ 0+11927] ='b01111110;
           rom[ 0+11928] ='b00000100;
           rom[ 0+11929] ='b11000110;
           rom[ 0+11930] ='b11111111;
           rom[ 0+11931] ='b11011101;
           rom[ 0+11932] ='b01110111;
           rom[ 0+11933] ='b11010001;
           rom[ 0+11934] ='b11011101;
           rom[ 0+11935] ='b01111110;
           rom[ 0+11936] ='b00000101;
           rom[ 0+11937] ='b11001110;
           rom[ 0+11938] ='b11111111;
           rom[ 0+11939] ='b11011101;
           rom[ 0+11940] ='b01110111;
           rom[ 0+11941] ='b11010010;
           rom[ 0+11942] ='b11011101;
           rom[ 0+11943] ='b01111110;
           rom[ 0+11944] ='b11010001;
           rom[ 0+11945] ='b11011101;
           rom[ 0+11946] ='b10010110;
           rom[ 0+11947] ='b11010111;
           rom[ 0+11948] ='b01011111;
           rom[ 0+11949] ='b11011101;
           rom[ 0+11950] ='b01111110;
           rom[ 0+11951] ='b11010010;
           rom[ 0+11952] ='b11011101;
           rom[ 0+11953] ='b10011110;
           rom[ 0+11954] ='b11011000;
           rom[ 0+11955] ='b01010111;
           rom[ 0+11956] ='b11011101;
           rom[ 0+11957] ='b01101110;
           rom[ 0+11958] ='b11001011;
           rom[ 0+11959] ='b11011101;
           rom[ 0+11960] ='b01100110;
           rom[ 0+11961] ='b11001100;
           rom[ 0+11962] ='b01110011;
           rom[ 0+11963] ='b00100011;
           rom[ 0+11964] ='b01110010;
           rom[ 0+11965] ='b01111001;
           rom[ 0+11966] ='b11000110;
           rom[ 0+11967] ='b00001010;
           rom[ 0+11968] ='b01011111;
           rom[ 0+11969] ='b01111000;
           rom[ 0+11970] ='b11001110;
           rom[ 0+11971] ='b00000000;
           rom[ 0+11972] ='b01010111;
           rom[ 0+11973] ='b11011101;
           rom[ 0+11974] ='b01111110;
           rom[ 0+11975] ='b11101011;
           rom[ 0+11976] ='b00010010;
           rom[ 0+11977] ='b01111001;
           rom[ 0+11978] ='b11000110;
           rom[ 0+11979] ='b00000110;
           rom[ 0+11980] ='b11011101;
           rom[ 0+11981] ='b01110111;
           rom[ 0+11982] ='b11001011;
           rom[ 0+11983] ='b01111000;
           rom[ 0+11984] ='b11001110;
           rom[ 0+11985] ='b00000000;
           rom[ 0+11986] ='b11011101;
           rom[ 0+11987] ='b01110111;
           rom[ 0+11988] ='b11001100;
           rom[ 0+11989] ='b11011101;
           rom[ 0+11990] ='b01111110;
           rom[ 0+11991] ='b11010001;
           rom[ 0+11992] ='b11011101;
           rom[ 0+11993] ='b10010110;
           rom[ 0+11994] ='b11010101;
           rom[ 0+11995] ='b01011111;
           rom[ 0+11996] ='b11011101;
           rom[ 0+11997] ='b01111110;
           rom[ 0+11998] ='b11010010;
           rom[ 0+11999] ='b11011101;
           rom[ 0+12000] ='b10011110;
           rom[ 0+12001] ='b11010110;
           rom[ 0+12002] ='b01010111;
           rom[ 0+12003] ='b11011101;
           rom[ 0+12004] ='b01101110;
           rom[ 0+12005] ='b11001011;
           rom[ 0+12006] ='b11011101;
           rom[ 0+12007] ='b01100110;
           rom[ 0+12008] ='b11001100;
           rom[ 0+12009] ='b01110011;
           rom[ 0+12010] ='b00100011;
           rom[ 0+12011] ='b01110010;
           rom[ 0+12012] ='b01111001;
           rom[ 0+12013] ='b11000110;
           rom[ 0+12014] ='b00001011;
           rom[ 0+12015] ='b01011111;
           rom[ 0+12016] ='b01111000;
           rom[ 0+12017] ='b11001110;
           rom[ 0+12018] ='b00000000;
           rom[ 0+12019] ='b01010111;
           rom[ 0+12020] ='b11011101;
           rom[ 0+12021] ='b01111110;
           rom[ 0+12022] ='b11101001;
           rom[ 0+12023] ='b00010010;
           rom[ 0+12024] ='b01111001;
           rom[ 0+12025] ='b11000110;
           rom[ 0+12026] ='b00001000;
           rom[ 0+12027] ='b11011101;
           rom[ 0+12028] ='b01110111;
           rom[ 0+12029] ='b11001011;
           rom[ 0+12030] ='b01111000;
           rom[ 0+12031] ='b11001110;
           rom[ 0+12032] ='b00000000;
           rom[ 0+12033] ='b11011101;
           rom[ 0+12034] ='b01110111;
           rom[ 0+12035] ='b11001100;
           rom[ 0+12036] ='b11011101;
           rom[ 0+12037] ='b01111110;
           rom[ 0+12038] ='b11010001;
           rom[ 0+12039] ='b11011101;
           rom[ 0+12040] ='b10010110;
           rom[ 0+12041] ='b11010011;
           rom[ 0+12042] ='b01011111;
           rom[ 0+12043] ='b11011101;
           rom[ 0+12044] ='b01111110;
           rom[ 0+12045] ='b11010010;
           rom[ 0+12046] ='b11011101;
           rom[ 0+12047] ='b10011110;
           rom[ 0+12048] ='b11010100;
           rom[ 0+12049] ='b01010111;
           rom[ 0+12050] ='b11011101;
           rom[ 0+12051] ='b01101110;
           rom[ 0+12052] ='b11001011;
           rom[ 0+12053] ='b11011101;
           rom[ 0+12054] ='b01100110;
           rom[ 0+12055] ='b11001100;
           rom[ 0+12056] ='b01110011;
           rom[ 0+12057] ='b00100011;
           rom[ 0+12058] ='b01110010;
           rom[ 0+12059] ='b01111001;
           rom[ 0+12060] ='b11000110;
           rom[ 0+12061] ='b00001100;
           rom[ 0+12062] ='b01001111;
           rom[ 0+12063] ='b01111000;
           rom[ 0+12064] ='b11001110;
           rom[ 0+12065] ='b00000000;
           rom[ 0+12066] ='b01000111;
           rom[ 0+12067] ='b11011101;
           rom[ 0+12068] ='b01111110;
           rom[ 0+12069] ='b11001101;
           rom[ 0+12070] ='b00000010;
           rom[ 0+12071] ='b11011101;
           rom[ 0+12072] ='b11111001;
           rom[ 0+12073] ='b11011101;
           rom[ 0+12074] ='b11100001;
           rom[ 0+12075] ='b11001001;
           rom[ 0+12076] ='b11011101;
           rom[ 0+12077] ='b11100101;
           rom[ 0+12078] ='b11011101;
           rom[ 0+12079] ='b00100001;
           rom[ 0+12080] ='b00000000;
           rom[ 0+12081] ='b00000000;
           rom[ 0+12082] ='b11011101;
           rom[ 0+12083] ='b00111001;
           rom[ 0+12084] ='b00100001;
           rom[ 0+12085] ='b11111100;
           rom[ 0+12086] ='b11111111;
           rom[ 0+12087] ='b00111001;
           rom[ 0+12088] ='b11111001;
           rom[ 0+12089] ='b11011101;
           rom[ 0+12090] ='b01011110;
           rom[ 0+12091] ='b00001000;
           rom[ 0+12092] ='b11011101;
           rom[ 0+12093] ='b01010110;
           rom[ 0+12094] ='b00001001;
           rom[ 0+12095] ='b01101011;
           rom[ 0+12096] ='b01100010;
           rom[ 0+12097] ='b00101001;
           rom[ 0+12098] ='b00011001;
           rom[ 0+12099] ='b00101001;
           rom[ 0+12100] ='b00011001;
           rom[ 0+12101] ='b11011101;
           rom[ 0+12102] ='b01110101;
           rom[ 0+12103] ='b11111100;
           rom[ 0+12104] ='b11011101;
           rom[ 0+12105] ='b01110100;
           rom[ 0+12106] ='b11111101;
           rom[ 0+12107] ='b00111110;
           rom[ 0+12108] ='b00000110;
           rom[ 0+12109] ='b11011101;
           rom[ 0+12110] ='b10000110;
           rom[ 0+12111] ='b11111100;
           rom[ 0+12112] ='b01011111;
           rom[ 0+12113] ='b00111110;
           rom[ 0+12114] ='b10010000;
           rom[ 0+12115] ='b11011101;
           rom[ 0+12116] ='b10001110;
           rom[ 0+12117] ='b11111101;
           rom[ 0+12118] ='b01010111;
           rom[ 0+12119] ='b00011010;
           rom[ 0+12120] ='b11011101;
           rom[ 0+12121] ='b01110111;
           rom[ 0+12122] ='b11111111;
           rom[ 0+12123] ='b11011101;
           rom[ 0+12124] ='b01111110;
           rom[ 0+12125] ='b11111111;
           rom[ 0+12126] ='b10110111;
           rom[ 0+12127] ='b11000010;
           rom[ 0+12128] ='b01100111;
           rom[ 0+12129] ='b00101111;
           rom[ 0+12130] ='b00111110;
           rom[ 0+12131] ='b00000001;
           rom[ 0+12132] ='b11000011;
           rom[ 0+12133] ='b01101000;
           rom[ 0+12134] ='b00101111;
           rom[ 0+12135] ='b10101111;
           rom[ 0+12136] ='b11011101;
           rom[ 0+12137] ='b01110111;
           rom[ 0+12138] ='b11111110;
           rom[ 0+12139] ='b10110111;
           rom[ 0+12140] ='b11001010;
           rom[ 0+12141] ='b11101001;
           rom[ 0+12142] ='b00101111;
           rom[ 0+12143] ='b01001011;
           rom[ 0+12144] ='b01000010;
           rom[ 0+12145] ='b00000011;
           rom[ 0+12146] ='b00001010;
           rom[ 0+12147] ='b01001111;
           rom[ 0+12148] ='b10110111;
           rom[ 0+12149] ='b11001010;
           rom[ 0+12150] ='b01111011;
           rom[ 0+12151] ='b00101111;
           rom[ 0+12152] ='b11000011;
           rom[ 0+12153] ='b11101001;
           rom[ 0+12154] ='b00101111;
           rom[ 0+12155] ='b01001011;
           rom[ 0+12156] ='b01000010;
           rom[ 0+12157] ='b00000011;
           rom[ 0+12158] ='b00000011;
           rom[ 0+12159] ='b00001010;
           rom[ 0+12160] ='b01001111;
           rom[ 0+12161] ='b10110111;
           rom[ 0+12162] ='b11001010;
           rom[ 0+12163] ='b10001000;
           rom[ 0+12164] ='b00101111;
           rom[ 0+12165] ='b11000011;
           rom[ 0+12166] ='b11101001;
           rom[ 0+12167] ='b00101111;
           rom[ 0+12168] ='b01111011;
           rom[ 0+12169] ='b11000110;
           rom[ 0+12170] ='b00000011;
           rom[ 0+12171] ='b01001111;
           rom[ 0+12172] ='b01111010;
           rom[ 0+12173] ='b11001110;
           rom[ 0+12174] ='b00000000;
           rom[ 0+12175] ='b01000111;
           rom[ 0+12176] ='b00001010;
           rom[ 0+12177] ='b01001111;
           rom[ 0+12178] ='b10110111;
           rom[ 0+12179] ='b11001010;
           rom[ 0+12180] ='b10011001;
           rom[ 0+12181] ='b00101111;
           rom[ 0+12182] ='b11000011;
           rom[ 0+12183] ='b11101001;
           rom[ 0+12184] ='b00101111;
           rom[ 0+12185] ='b01111011;
           rom[ 0+12186] ='b11000110;
           rom[ 0+12187] ='b00000100;
           rom[ 0+12188] ='b01001111;
           rom[ 0+12189] ='b01111010;
           rom[ 0+12190] ='b11001110;
           rom[ 0+12191] ='b00000000;
           rom[ 0+12192] ='b01000111;
           rom[ 0+12193] ='b00001010;
           rom[ 0+12194] ='b01001111;
           rom[ 0+12195] ='b10110111;
           rom[ 0+12196] ='b11001010;
           rom[ 0+12197] ='b10101010;
           rom[ 0+12198] ='b00101111;
           rom[ 0+12199] ='b11000011;
           rom[ 0+12200] ='b11101001;
           rom[ 0+12201] ='b00101111;
           rom[ 0+12202] ='b01111011;
           rom[ 0+12203] ='b11000110;
           rom[ 0+12204] ='b00000101;
           rom[ 0+12205] ='b01001111;
           rom[ 0+12206] ='b01111010;
           rom[ 0+12207] ='b11001110;
           rom[ 0+12208] ='b00000000;
           rom[ 0+12209] ='b01000111;
           rom[ 0+12210] ='b00001010;
           rom[ 0+12211] ='b01001111;
           rom[ 0+12212] ='b10110111;
           rom[ 0+12213] ='b11001010;
           rom[ 0+12214] ='b10111011;
           rom[ 0+12215] ='b00101111;
           rom[ 0+12216] ='b11000011;
           rom[ 0+12217] ='b11101001;
           rom[ 0+12218] ='b00101111;
           rom[ 0+12219] ='b01111011;
           rom[ 0+12220] ='b11000110;
           rom[ 0+12221] ='b00000110;
           rom[ 0+12222] ='b01001111;
           rom[ 0+12223] ='b01111010;
           rom[ 0+12224] ='b11001110;
           rom[ 0+12225] ='b00000000;
           rom[ 0+12226] ='b01000111;
           rom[ 0+12227] ='b00001010;
           rom[ 0+12228] ='b01001111;
           rom[ 0+12229] ='b10110111;
           rom[ 0+12230] ='b11001010;
           rom[ 0+12231] ='b11001100;
           rom[ 0+12232] ='b00101111;
           rom[ 0+12233] ='b11000011;
           rom[ 0+12234] ='b11101001;
           rom[ 0+12235] ='b00101111;
           rom[ 0+12236] ='b11011101;
           rom[ 0+12237] ='b01011110;
           rom[ 0+12238] ='b00001000;
           rom[ 0+12239] ='b11011101;
           rom[ 0+12240] ='b01010110;
           rom[ 0+12241] ='b00001001;
           rom[ 0+12242] ='b01101011;
           rom[ 0+12243] ='b01100010;
           rom[ 0+12244] ='b00101001;
           rom[ 0+12245] ='b00011001;
           rom[ 0+12246] ='b00101001;
           rom[ 0+12247] ='b00101001;
           rom[ 0+12248] ='b00011001;
           rom[ 0+12249] ='b01001101;
           rom[ 0+12250] ='b01000100;
           rom[ 0+12251] ='b00100001;
           rom[ 0+12252] ='b00000011;
           rom[ 0+12253] ='b10000100;
           rom[ 0+12254] ='b00001001;
           rom[ 0+12255] ='b01001101;
           rom[ 0+12256] ='b01000100;
           rom[ 0+12257] ='b00110110;
           rom[ 0+12258] ='b00000000;
           rom[ 0+12259] ='b00100011;
           rom[ 0+12260] ='b00110110;
           rom[ 0+12261] ='b00000000;
           rom[ 0+12262] ='b11000011;
           rom[ 0+12263] ='b01100100;
           rom[ 0+12264] ='b00110001;
           rom[ 0+12265] ='b10101111;
           rom[ 0+12266] ='b11011101;
           rom[ 0+12267] ='b10110110;
           rom[ 0+12268] ='b11111110;
           rom[ 0+12269] ='b11000010;
           rom[ 0+12270] ='b11111100;
           rom[ 0+12271] ='b00101111;
           rom[ 0+12272] ='b01001011;
           rom[ 0+12273] ='b01000010;
           rom[ 0+12274] ='b00000011;
           rom[ 0+12275] ='b00001010;
           rom[ 0+12276] ='b01001111;
           rom[ 0+12277] ='b10110111;
           rom[ 0+12278] ='b11001010;
           rom[ 0+12279] ='b11111100;
           rom[ 0+12280] ='b00101111;
           rom[ 0+12281] ='b11000011;
           rom[ 0+12282] ='b00011001;
           rom[ 0+12283] ='b00110000;
           rom[ 0+12284] ='b11011101;
           rom[ 0+12285] ='b01011110;
           rom[ 0+12286] ='b00001000;
           rom[ 0+12287] ='b11011101;
           rom[ 0+12288] ='b01010110;
           rom[ 0+12289] ='b00001001;
           rom[ 0+12290] ='b01101011;
           rom[ 0+12291] ='b01100010;
           rom[ 0+12292] ='b00101001;
           rom[ 0+12293] ='b00011001;
           rom[ 0+12294] ='b00101001;
           rom[ 0+12295] ='b00101001;
           rom[ 0+12296] ='b00011001;
           rom[ 0+12297] ='b01011101;
           rom[ 0+12298] ='b01010100;
           rom[ 0+12299] ='b00100001;
           rom[ 0+12300] ='b00000011;
           rom[ 0+12301] ='b10000100;
           rom[ 0+12302] ='b00011001;
           rom[ 0+12303] ='b01011101;
           rom[ 0+12304] ='b01010100;
           rom[ 0+12305] ='b00110110;
           rom[ 0+12306] ='b00000010;
           rom[ 0+12307] ='b00100011;
           rom[ 0+12308] ='b00110110;
           rom[ 0+12309] ='b00000000;
           rom[ 0+12310] ='b11000011;
           rom[ 0+12311] ='b01100100;
           rom[ 0+12312] ='b00110001;
           rom[ 0+12313] ='b11011101;
           rom[ 0+12314] ='b01111110;
           rom[ 0+12315] ='b11111111;
           rom[ 0+12316] ='b11110101;
           rom[ 0+12317] ='b00110011;
           rom[ 0+12318] ='b01111001;
           rom[ 0+12319] ='b11110101;
           rom[ 0+12320] ='b00110011;
           rom[ 0+12321] ='b11001101;
           rom[ 0+12322] ='b01101111;
           rom[ 0+12323] ='b00100000;
           rom[ 0+12324] ='b01001101;
           rom[ 0+12325] ='b11110001;
           rom[ 0+12326] ='b00111110;
           rom[ 0+12327] ='b00000110;
           rom[ 0+12328] ='b11011101;
           rom[ 0+12329] ='b10000110;
           rom[ 0+12330] ='b11111100;
           rom[ 0+12331] ='b01011111;
           rom[ 0+12332] ='b00111110;
           rom[ 0+12333] ='b10010000;
           rom[ 0+12334] ='b11011101;
           rom[ 0+12335] ='b10001110;
           rom[ 0+12336] ='b11111101;
           rom[ 0+12337] ='b01010111;
           rom[ 0+12338] ='b00010011;
           rom[ 0+12339] ='b00011010;
           rom[ 0+12340] ='b01000111;
           rom[ 0+12341] ='b11000101;
           rom[ 0+12342] ='b11000101;
           rom[ 0+12343] ='b00110011;
           rom[ 0+12344] ='b01111001;
           rom[ 0+12345] ='b11110101;
           rom[ 0+12346] ='b00110011;
           rom[ 0+12347] ='b11001101;
           rom[ 0+12348] ='b00001110;
           rom[ 0+12349] ='b00100000;
           rom[ 0+12350] ='b01000101;
           rom[ 0+12351] ='b11110001;
           rom[ 0+12352] ='b01111000;
           rom[ 0+12353] ='b11000001;
           rom[ 0+12354] ='b01000111;
           rom[ 0+12355] ='b00111110;
           rom[ 0+12356] ='b00000110;
           rom[ 0+12357] ='b11011101;
           rom[ 0+12358] ='b10000110;
           rom[ 0+12359] ='b11111100;
           rom[ 0+12360] ='b01011111;
           rom[ 0+12361] ='b00111110;
           rom[ 0+12362] ='b10010000;
           rom[ 0+12363] ='b11011101;
           rom[ 0+12364] ='b10001110;
           rom[ 0+12365] ='b11111101;
           rom[ 0+12366] ='b01010111;
           rom[ 0+12367] ='b00010011;
           rom[ 0+12368] ='b00010011;
           rom[ 0+12369] ='b00011010;
           rom[ 0+12370] ='b01011111;
           rom[ 0+12371] ='b01111000;
           rom[ 0+12372] ='b10111011;
           rom[ 0+12373] ='b11001010;
           rom[ 0+12374] ='b01111001;
           rom[ 0+12375] ='b00110000;
           rom[ 0+12376] ='b11011101;
           rom[ 0+12377] ='b01011110;
           rom[ 0+12378] ='b00001000;
           rom[ 0+12379] ='b11011101;
           rom[ 0+12380] ='b01010110;
           rom[ 0+12381] ='b00001001;
           rom[ 0+12382] ='b01101011;
           rom[ 0+12383] ='b01100010;
           rom[ 0+12384] ='b00101001;
           rom[ 0+12385] ='b00011001;
           rom[ 0+12386] ='b00101001;
           rom[ 0+12387] ='b00101001;
           rom[ 0+12388] ='b00011001;
           rom[ 0+12389] ='b01000101;
           rom[ 0+12390] ='b01010100;
           rom[ 0+12391] ='b00111110;
           rom[ 0+12392] ='b00000011;
           rom[ 0+12393] ='b10000000;
           rom[ 0+12394] ='b01000111;
           rom[ 0+12395] ='b00111110;
           rom[ 0+12396] ='b10000100;
           rom[ 0+12397] ='b10001010;
           rom[ 0+12398] ='b01010111;
           rom[ 0+12399] ='b01101000;
           rom[ 0+12400] ='b01100010;
           rom[ 0+12401] ='b00110110;
           rom[ 0+12402] ='b00000010;
           rom[ 0+12403] ='b00100011;
           rom[ 0+12404] ='b00110110;
           rom[ 0+12405] ='b00000000;
           rom[ 0+12406] ='b11000011;
           rom[ 0+12407] ='b01100100;
           rom[ 0+12408] ='b00110001;
           rom[ 0+12409] ='b11000101;
           rom[ 0+12410] ='b01111011;
           rom[ 0+12411] ='b11110101;
           rom[ 0+12412] ='b00110011;
           rom[ 0+12413] ='b01111001;
           rom[ 0+12414] ='b11110101;
           rom[ 0+12415] ='b00110011;
           rom[ 0+12416] ='b11001101;
           rom[ 0+12417] ='b00001110;
           rom[ 0+12418] ='b00100000;
           rom[ 0+12419] ='b01000101;
           rom[ 0+12420] ='b11110001;
           rom[ 0+12421] ='b01111000;
           rom[ 0+12422] ='b11000001;
           rom[ 0+12423] ='b01000111;
           rom[ 0+12424] ='b00111110;
           rom[ 0+12425] ='b00000110;
           rom[ 0+12426] ='b11011101;
           rom[ 0+12427] ='b10000110;
           rom[ 0+12428] ='b11111100;
           rom[ 0+12429] ='b01011111;
           rom[ 0+12430] ='b00111110;
           rom[ 0+12431] ='b10010000;
           rom[ 0+12432] ='b11011101;
           rom[ 0+12433] ='b10001110;
           rom[ 0+12434] ='b11111101;
           rom[ 0+12435] ='b01010111;
           rom[ 0+12436] ='b00010011;
           rom[ 0+12437] ='b00010011;
           rom[ 0+12438] ='b00010011;
           rom[ 0+12439] ='b00011010;
           rom[ 0+12440] ='b01011111;
           rom[ 0+12441] ='b01111000;
           rom[ 0+12442] ='b10111011;
           rom[ 0+12443] ='b11001010;
           rom[ 0+12444] ='b10111111;
           rom[ 0+12445] ='b00110000;
           rom[ 0+12446] ='b11011101;
           rom[ 0+12447] ='b01011110;
           rom[ 0+12448] ='b00001000;
           rom[ 0+12449] ='b11011101;
           rom[ 0+12450] ='b01010110;
           rom[ 0+12451] ='b00001001;
           rom[ 0+12452] ='b01101011;
           rom[ 0+12453] ='b01100010;
           rom[ 0+12454] ='b00101001;
           rom[ 0+12455] ='b00011001;
           rom[ 0+12456] ='b00101001;
           rom[ 0+12457] ='b00101001;
           rom[ 0+12458] ='b00011001;
           rom[ 0+12459] ='b01000101;
           rom[ 0+12460] ='b01010100;
           rom[ 0+12461] ='b00111110;
           rom[ 0+12462] ='b00000011;
           rom[ 0+12463] ='b10000000;
           rom[ 0+12464] ='b01000111;
           rom[ 0+12465] ='b00111110;
           rom[ 0+12466] ='b10000100;
           rom[ 0+12467] ='b10001010;
           rom[ 0+12468] ='b01010111;
           rom[ 0+12469] ='b01101000;
           rom[ 0+12470] ='b01100010;
           rom[ 0+12471] ='b00110110;
           rom[ 0+12472] ='b00000010;
           rom[ 0+12473] ='b00100011;
           rom[ 0+12474] ='b00110110;
           rom[ 0+12475] ='b00000000;
           rom[ 0+12476] ='b11000011;
           rom[ 0+12477] ='b01100100;
           rom[ 0+12478] ='b00110001;
           rom[ 0+12479] ='b11000101;
           rom[ 0+12480] ='b01111011;
           rom[ 0+12481] ='b11110101;
           rom[ 0+12482] ='b00110011;
           rom[ 0+12483] ='b01111001;
           rom[ 0+12484] ='b11110101;
           rom[ 0+12485] ='b00110011;
           rom[ 0+12486] ='b11001101;
           rom[ 0+12487] ='b00001110;
           rom[ 0+12488] ='b00100000;
           rom[ 0+12489] ='b01000101;
           rom[ 0+12490] ='b11110001;
           rom[ 0+12491] ='b01111000;
           rom[ 0+12492] ='b11000001;
           rom[ 0+12493] ='b01000111;
           rom[ 0+12494] ='b00111110;
           rom[ 0+12495] ='b00000110;
           rom[ 0+12496] ='b11011101;
           rom[ 0+12497] ='b10000110;
           rom[ 0+12498] ='b11111100;
           rom[ 0+12499] ='b01011111;
           rom[ 0+12500] ='b00111110;
           rom[ 0+12501] ='b10010000;
           rom[ 0+12502] ='b11011101;
           rom[ 0+12503] ='b10001110;
           rom[ 0+12504] ='b11111101;
           rom[ 0+12505] ='b01010111;
           rom[ 0+12506] ='b00010011;
           rom[ 0+12507] ='b00010011;
           rom[ 0+12508] ='b00010011;
           rom[ 0+12509] ='b00010011;
           rom[ 0+12510] ='b00011010;
           rom[ 0+12511] ='b01011111;
           rom[ 0+12512] ='b01111000;
           rom[ 0+12513] ='b10111011;
           rom[ 0+12514] ='b11001010;
           rom[ 0+12515] ='b00000110;
           rom[ 0+12516] ='b00110001;
           rom[ 0+12517] ='b11011101;
           rom[ 0+12518] ='b01011110;
           rom[ 0+12519] ='b00001000;
           rom[ 0+12520] ='b11011101;
           rom[ 0+12521] ='b01010110;
           rom[ 0+12522] ='b00001001;
           rom[ 0+12523] ='b01101011;
           rom[ 0+12524] ='b01100010;
           rom[ 0+12525] ='b00101001;
           rom[ 0+12526] ='b00011001;
           rom[ 0+12527] ='b00101001;
           rom[ 0+12528] ='b00101001;
           rom[ 0+12529] ='b00011001;
           rom[ 0+12530] ='b01000101;
           rom[ 0+12531] ='b01010100;
           rom[ 0+12532] ='b00111110;
           rom[ 0+12533] ='b00000011;
           rom[ 0+12534] ='b10000000;
           rom[ 0+12535] ='b01000111;
           rom[ 0+12536] ='b00111110;
           rom[ 0+12537] ='b10000100;
           rom[ 0+12538] ='b10001010;
           rom[ 0+12539] ='b01010111;
           rom[ 0+12540] ='b01101000;
           rom[ 0+12541] ='b01100010;
           rom[ 0+12542] ='b00110110;
           rom[ 0+12543] ='b00000010;
           rom[ 0+12544] ='b00100011;
           rom[ 0+12545] ='b00110110;
           rom[ 0+12546] ='b00000000;
           rom[ 0+12547] ='b11000011;
           rom[ 0+12548] ='b01100100;
           rom[ 0+12549] ='b00110001;
           rom[ 0+12550] ='b11000101;
           rom[ 0+12551] ='b01111011;
           rom[ 0+12552] ='b11110101;
           rom[ 0+12553] ='b00110011;
           rom[ 0+12554] ='b01111001;
           rom[ 0+12555] ='b11110101;
           rom[ 0+12556] ='b00110011;
           rom[ 0+12557] ='b11001101;
           rom[ 0+12558] ='b00001110;
           rom[ 0+12559] ='b00100000;
           rom[ 0+12560] ='b01000101;
           rom[ 0+12561] ='b11110001;
           rom[ 0+12562] ='b01111000;
           rom[ 0+12563] ='b11000001;
           rom[ 0+12564] ='b01000111;
           rom[ 0+12565] ='b00111110;
           rom[ 0+12566] ='b00000110;
           rom[ 0+12567] ='b11011101;
           rom[ 0+12568] ='b10000110;
           rom[ 0+12569] ='b11111100;
           rom[ 0+12570] ='b01011111;
           rom[ 0+12571] ='b00111110;
           rom[ 0+12572] ='b10010000;
           rom[ 0+12573] ='b11011101;
           rom[ 0+12574] ='b10001110;
           rom[ 0+12575] ='b11111101;
           rom[ 0+12576] ='b01010111;
           rom[ 0+12577] ='b00010011;
           rom[ 0+12578] ='b00010011;
           rom[ 0+12579] ='b00010011;
           rom[ 0+12580] ='b00010011;
           rom[ 0+12581] ='b00010011;
           rom[ 0+12582] ='b00011010;
           rom[ 0+12583] ='b01011111;
           rom[ 0+12584] ='b01111000;
           rom[ 0+12585] ='b10111011;
           rom[ 0+12586] ='b11001010;
           rom[ 0+12587] ='b01001010;
           rom[ 0+12588] ='b00110001;
           rom[ 0+12589] ='b11011101;
           rom[ 0+12590] ='b01011110;
           rom[ 0+12591] ='b00001000;
           rom[ 0+12592] ='b11011101;
           rom[ 0+12593] ='b01010110;
           rom[ 0+12594] ='b00001001;
           rom[ 0+12595] ='b01101011;
           rom[ 0+12596] ='b01100010;
           rom[ 0+12597] ='b00101001;
           rom[ 0+12598] ='b00011001;
           rom[ 0+12599] ='b00101001;
           rom[ 0+12600] ='b00101001;
           rom[ 0+12601] ='b00011001;
           rom[ 0+12602] ='b01011101;
           rom[ 0+12603] ='b01010100;
           rom[ 0+12604] ='b00100001;
           rom[ 0+12605] ='b00000011;
           rom[ 0+12606] ='b10000100;
           rom[ 0+12607] ='b00011001;
           rom[ 0+12608] ='b01011101;
           rom[ 0+12609] ='b01010100;
           rom[ 0+12610] ='b00110110;
           rom[ 0+12611] ='b00000010;
           rom[ 0+12612] ='b00100011;
           rom[ 0+12613] ='b00110110;
           rom[ 0+12614] ='b00000000;
           rom[ 0+12615] ='b11000011;
           rom[ 0+12616] ='b01100100;
           rom[ 0+12617] ='b00110001;
           rom[ 0+12618] ='b11011101;
           rom[ 0+12619] ='b01011110;
           rom[ 0+12620] ='b00001000;
           rom[ 0+12621] ='b11011101;
           rom[ 0+12622] ='b01010110;
           rom[ 0+12623] ='b00001001;
           rom[ 0+12624] ='b01101011;
           rom[ 0+12625] ='b01100010;
           rom[ 0+12626] ='b00101001;
           rom[ 0+12627] ='b00011001;
           rom[ 0+12628] ='b00101001;
           rom[ 0+12629] ='b00101001;
           rom[ 0+12630] ='b00011001;
           rom[ 0+12631] ='b01011101;
           rom[ 0+12632] ='b01010100;
           rom[ 0+12633] ='b00100001;
           rom[ 0+12634] ='b00000011;
           rom[ 0+12635] ='b10000100;
           rom[ 0+12636] ='b00011001;
           rom[ 0+12637] ='b01011101;
           rom[ 0+12638] ='b01010100;
           rom[ 0+12639] ='b00110110;
           rom[ 0+12640] ='b00000001;
           rom[ 0+12641] ='b00100011;
           rom[ 0+12642] ='b00110110;
           rom[ 0+12643] ='b00000000;
           rom[ 0+12644] ='b11011101;
           rom[ 0+12645] ='b01011110;
           rom[ 0+12646] ='b00001000;
           rom[ 0+12647] ='b11011101;
           rom[ 0+12648] ='b01010110;
           rom[ 0+12649] ='b00001001;
           rom[ 0+12650] ='b01101011;
           rom[ 0+12651] ='b01100010;
           rom[ 0+12652] ='b00101001;
           rom[ 0+12653] ='b00011001;
           rom[ 0+12654] ='b00101001;
           rom[ 0+12655] ='b00101001;
           rom[ 0+12656] ='b00011001;
           rom[ 0+12657] ='b01011101;
           rom[ 0+12658] ='b01010100;
           rom[ 0+12659] ='b00100001;
           rom[ 0+12660] ='b00000011;
           rom[ 0+12661] ='b10000100;
           rom[ 0+12662] ='b00011001;
           rom[ 0+12663] ='b01011101;
           rom[ 0+12664] ='b01010100;
           rom[ 0+12665] ='b01011110;
           rom[ 0+12666] ='b00100011;
           rom[ 0+12667] ='b01010110;
           rom[ 0+12668] ='b01111011;
           rom[ 0+12669] ='b10110010;
           rom[ 0+12670] ='b11001010;
           rom[ 0+12671] ='b11010010;
           rom[ 0+12672] ='b00110001;
           rom[ 0+12673] ='b01111011;
           rom[ 0+12674] ='b11111110;
           rom[ 0+12675] ='b00000001;
           rom[ 0+12676] ='b11000010;
           rom[ 0+12677] ='b10001100;
           rom[ 0+12678] ='b00110001;
           rom[ 0+12679] ='b01111010;
           rom[ 0+12680] ='b10110111;
           rom[ 0+12681] ='b11001010;
           rom[ 0+12682] ='b10011010;
           rom[ 0+12683] ='b00110001;
           rom[ 0+12684] ='b01111011;
           rom[ 0+12685] ='b11111110;
           rom[ 0+12686] ='b00000010;
           rom[ 0+12687] ='b11000010;
           rom[ 0+12688] ='b10010111;
           rom[ 0+12689] ='b00110001;
           rom[ 0+12690] ='b01111010;
           rom[ 0+12691] ='b10110111;
           rom[ 0+12692] ='b11001010;
           rom[ 0+12693] ='b10111111;
           rom[ 0+12694] ='b00110001;
           rom[ 0+12695] ='b11000011;
           rom[ 0+12696] ='b11010010;
           rom[ 0+12697] ='b00110001;
           rom[ 0+12698] ='b00111110;
           rom[ 0+12699] ='b10011100;
           rom[ 0+12700] ='b10000001;
           rom[ 0+12701] ='b01001111;
           rom[ 0+12702] ='b00111110;
           rom[ 0+12703] ='b00000010;
           rom[ 0+12704] ='b11001110;
           rom[ 0+12705] ='b00000000;
           rom[ 0+12706] ='b01000111;
           rom[ 0+12707] ='b00001010;
           rom[ 0+12708] ='b01001111;
           rom[ 0+12709] ='b11011101;
           rom[ 0+12710] ='b01101110;
           rom[ 0+12711] ='b00001000;
           rom[ 0+12712] ='b11011101;
           rom[ 0+12713] ='b01100110;
           rom[ 0+12714] ='b00001001;
           rom[ 0+12715] ='b11100101;
           rom[ 0+12716] ='b11011101;
           rom[ 0+12717] ='b01101110;
           rom[ 0+12718] ='b00000100;
           rom[ 0+12719] ='b11011101;
           rom[ 0+12720] ='b01100110;
           rom[ 0+12721] ='b00000101;
           rom[ 0+12722] ='b11100101;
           rom[ 0+12723] ='b01111001;
           rom[ 0+12724] ='b11110101;
           rom[ 0+12725] ='b00110011;
           rom[ 0+12726] ='b11001101;
           rom[ 0+12727] ='b11101101;
           rom[ 0+12728] ='b00100001;
           rom[ 0+12729] ='b11110001;
           rom[ 0+12730] ='b11110001;
           rom[ 0+12731] ='b00110011;
           rom[ 0+12732] ='b11000011;
           rom[ 0+12733] ='b11010010;
           rom[ 0+12734] ='b00110001;
           rom[ 0+12735] ='b11011101;
           rom[ 0+12736] ='b01101110;
           rom[ 0+12737] ='b00001000;
           rom[ 0+12738] ='b11011101;
           rom[ 0+12739] ='b01100110;
           rom[ 0+12740] ='b00001001;
           rom[ 0+12741] ='b11100101;
           rom[ 0+12742] ='b11011101;
           rom[ 0+12743] ='b01101110;
           rom[ 0+12744] ='b00000100;
           rom[ 0+12745] ='b11011101;
           rom[ 0+12746] ='b01100110;
           rom[ 0+12747] ='b00000101;
           rom[ 0+12748] ='b11100101;
           rom[ 0+12749] ='b11001101;
           rom[ 0+12750] ='b01100110;
           rom[ 0+12751] ='b00100010;
           rom[ 0+12752] ='b11110001;
           rom[ 0+12753] ='b11110001;
           rom[ 0+12754] ='b11011101;
           rom[ 0+12755] ='b11111001;
           rom[ 0+12756] ='b11011101;
           rom[ 0+12757] ='b11100001;
           rom[ 0+12758] ='b11001001;
           rom[ 0+12759] ='b11011101;
           rom[ 0+12760] ='b11100101;
           rom[ 0+12761] ='b11011101;
           rom[ 0+12762] ='b00100001;
           rom[ 0+12763] ='b00000000;
           rom[ 0+12764] ='b00000000;
           rom[ 0+12765] ='b11011101;
           rom[ 0+12766] ='b00111001;
           rom[ 0+12767] ='b00100001;
           rom[ 0+12768] ='b11110010;
           rom[ 0+12769] ='b11111111;
           rom[ 0+12770] ='b00111001;
           rom[ 0+12771] ='b11111001;
           rom[ 0+12772] ='b00100001;
           rom[ 0+12773] ='b01011100;
           rom[ 0+12774] ='b00111100;
           rom[ 0+12775] ='b11100101;
           rom[ 0+12776] ='b11001101;
           rom[ 0+12777] ='b00001010;
           rom[ 0+12778] ='b00000010;
           rom[ 0+12779] ='b11110001;
           rom[ 0+12780] ='b00100001;
           rom[ 0+12781] ='b10001001;
           rom[ 0+12782] ='b00111100;
           rom[ 0+12783] ='b11100101;
           rom[ 0+12784] ='b11001101;
           rom[ 0+12785] ='b00001010;
           rom[ 0+12786] ='b00000010;
           rom[ 0+12787] ='b11110001;
           rom[ 0+12788] ='b00100001;
           rom[ 0+12789] ='b10101000;
           rom[ 0+12790] ='b00111100;
           rom[ 0+12791] ='b11100101;
           rom[ 0+12792] ='b11001101;
           rom[ 0+12793] ='b00001010;
           rom[ 0+12794] ='b00000010;
           rom[ 0+12795] ='b11110001;
           rom[ 0+12796] ='b00100001;
           rom[ 0+12797] ='b10111101;
           rom[ 0+12798] ='b00111100;
           rom[ 0+12799] ='b11100101;
           rom[ 0+12800] ='b11001101;
           rom[ 0+12801] ='b00001010;
           rom[ 0+12802] ='b00000010;
           rom[ 0+12803] ='b11110001;
           rom[ 0+12804] ='b00100001;
           rom[ 0+12805] ='b00101001;
           rom[ 0+12806] ='b10010000;
           rom[ 0+12807] ='b00110110;
           rom[ 0+12808] ='b00000000;
           rom[ 0+12809] ='b00000001;
           rom[ 0+12810] ='b00101010;
           rom[ 0+12811] ='b10010000;
           rom[ 0+12812] ='b00111110;
           rom[ 0+12813] ='b00000000;
           rom[ 0+12814] ='b00000010;
           rom[ 0+12815] ='b00000001;
           rom[ 0+12816] ='b00101011;
           rom[ 0+12817] ='b10010000;
           rom[ 0+12818] ='b00111110;
           rom[ 0+12819] ='b00000000;
           rom[ 0+12820] ='b00000010;
           rom[ 0+12821] ='b00000001;
           rom[ 0+12822] ='b00101100;
           rom[ 0+12823] ='b10010000;
           rom[ 0+12824] ='b00111110;
           rom[ 0+12825] ='b00000000;
           rom[ 0+12826] ='b00000010;
           rom[ 0+12827] ='b00000001;
           rom[ 0+12828] ='b00101101;
           rom[ 0+12829] ='b10010000;
           rom[ 0+12830] ='b00111110;
           rom[ 0+12831] ='b00000000;
           rom[ 0+12832] ='b00000010;
           rom[ 0+12833] ='b11011101;
           rom[ 0+12834] ='b00110110;
           rom[ 0+12835] ='b11111110;
           rom[ 0+12836] ='b00000000;
           rom[ 0+12837] ='b11011101;
           rom[ 0+12838] ='b00110110;
           rom[ 0+12839] ='b11111111;
           rom[ 0+12840] ='b00000000;
           rom[ 0+12841] ='b11011101;
           rom[ 0+12842] ='b01111110;
           rom[ 0+12843] ='b11111110;
           rom[ 0+12844] ='b11010110;
           rom[ 0+12845] ='b00101111;
           rom[ 0+12846] ='b11011101;
           rom[ 0+12847] ='b01111110;
           rom[ 0+12848] ='b11111111;
           rom[ 0+12849] ='b11011110;
           rom[ 0+12850] ='b00000000;
           rom[ 0+12851] ='b11110010;
           rom[ 0+12852] ='b01010111;
           rom[ 0+12853] ='b00110010;
           rom[ 0+12854] ='b00111110;
           rom[ 0+12855] ='b01001110;
           rom[ 0+12856] ='b11011101;
           rom[ 0+12857] ='b10000110;
           rom[ 0+12858] ='b11111110;
           rom[ 0+12859] ='b01011111;
           rom[ 0+12860] ='b00111110;
           rom[ 0+12861] ='b10000100;
           rom[ 0+12862] ='b11011101;
           rom[ 0+12863] ='b10001110;
           rom[ 0+12864] ='b11111111;
           rom[ 0+12865] ='b01010111;
           rom[ 0+12866] ='b11011101;
           rom[ 0+12867] ='b01001110;
           rom[ 0+12868] ='b11111110;
           rom[ 0+12869] ='b00000110;
           rom[ 0+12870] ='b00000000;
           rom[ 0+12871] ='b00000110;
           rom[ 0+12872] ='b00000000;
           rom[ 0+12873] ='b01111001;
           rom[ 0+12874] ='b00010010;
           rom[ 0+12875] ='b11011101;
           rom[ 0+12876] ='b00110100;
           rom[ 0+12877] ='b11111110;
           rom[ 0+12878] ='b11000010;
           rom[ 0+12879] ='b01010100;
           rom[ 0+12880] ='b00110010;
           rom[ 0+12881] ='b11011101;
           rom[ 0+12882] ='b00110100;
           rom[ 0+12883] ='b11111111;
           rom[ 0+12884] ='b11000011;
           rom[ 0+12885] ='b00101001;
           rom[ 0+12886] ='b00110010;
           rom[ 0+12887] ='b11001101;
           rom[ 0+12888] ='b00000000;
           rom[ 0+12889] ='b00010110;
           rom[ 0+12890] ='b10101111;
           rom[ 0+12891] ='b11111101;
           rom[ 0+12892] ='b00100001;
           rom[ 0+12893] ='b00101110;
           rom[ 0+12894] ='b10010000;
           rom[ 0+12895] ='b11111101;
           rom[ 0+12896] ='b01110111;
           rom[ 0+12897] ='b00000000;
           rom[ 0+12898] ='b11111101;
           rom[ 0+12899] ='b01110111;
           rom[ 0+12900] ='b00000001;
           rom[ 0+12901] ='b11111101;
           rom[ 0+12902] ='b01110111;
           rom[ 0+12903] ='b00000010;
           rom[ 0+12904] ='b11111101;
           rom[ 0+12905] ='b01110111;
           rom[ 0+12906] ='b00000011;
           rom[ 0+12907] ='b00100001;
           rom[ 0+12908] ='b00101110;
           rom[ 0+12909] ='b10010000;
           rom[ 0+12910] ='b00100010;
           rom[ 0+12911] ='b00110010;
           rom[ 0+12912] ='b10010000;
           rom[ 0+12913] ='b00100001;
           rom[ 0+12914] ='b00110010;
           rom[ 0+12915] ='b10010000;
           rom[ 0+12916] ='b01111110;
           rom[ 0+12917] ='b11000110;
           rom[ 0+12918] ='b00000010;
           rom[ 0+12919] ='b01110111;
           rom[ 0+12920] ='b00100011;
           rom[ 0+12921] ='b01111110;
           rom[ 0+12922] ='b11001110;
           rom[ 0+12923] ='b00000000;
           rom[ 0+12924] ='b01110111;
           rom[ 0+12925] ='b11011101;
           rom[ 0+12926] ='b00110110;
           rom[ 0+12927] ='b11111110;
           rom[ 0+12928] ='b00000000;
           rom[ 0+12929] ='b11011101;
           rom[ 0+12930] ='b00110110;
           rom[ 0+12931] ='b11111111;
           rom[ 0+12932] ='b00000000;
           rom[ 0+12933] ='b11011101;
           rom[ 0+12934] ='b01111110;
           rom[ 0+12935] ='b11111110;
           rom[ 0+12936] ='b11010110;
           rom[ 0+12937] ='b00000101;
           rom[ 0+12938] ='b11011101;
           rom[ 0+12939] ='b01111110;
           rom[ 0+12940] ='b11111111;
           rom[ 0+12941] ='b11011110;
           rom[ 0+12942] ='b00000000;
           rom[ 0+12943] ='b11110010;
           rom[ 0+12944] ='b11011101;
           rom[ 0+12945] ='b00110010;
           rom[ 0+12946] ='b00111110;
           rom[ 0+12947] ='b00101001;
           rom[ 0+12948] ='b11011101;
           rom[ 0+12949] ='b10000110;
           rom[ 0+12950] ='b11111110;
           rom[ 0+12951] ='b01011111;
           rom[ 0+12952] ='b00111110;
           rom[ 0+12953] ='b10010000;
           rom[ 0+12954] ='b11011101;
           rom[ 0+12955] ='b10001110;
           rom[ 0+12956] ='b11111111;
           rom[ 0+12957] ='b01010111;
           rom[ 0+12958] ='b00011010;
           rom[ 0+12959] ='b01011111;
           rom[ 0+12960] ='b11010101;
           rom[ 0+12961] ='b00100001;
           rom[ 0+12962] ='b00000101;
           rom[ 0+12963] ='b00000000;
           rom[ 0+12964] ='b11100101;
           rom[ 0+12965] ='b11011101;
           rom[ 0+12966] ='b01101110;
           rom[ 0+12967] ='b11111110;
           rom[ 0+12968] ='b11011101;
           rom[ 0+12969] ='b01100110;
           rom[ 0+12970] ='b11111111;
           rom[ 0+12971] ='b11100101;
           rom[ 0+12972] ='b11001101;
           rom[ 0+12973] ='b01010011;
           rom[ 0+12974] ='b00111110;
           rom[ 0+12975] ='b01001100;
           rom[ 0+12976] ='b01010101;
           rom[ 0+12977] ='b11110001;
           rom[ 0+12978] ='b11110001;
           rom[ 0+12979] ='b01111010;
           rom[ 0+12980] ='b11010001;
           rom[ 0+12981] ='b01010111;
           rom[ 0+12982] ='b00111110;
           rom[ 0+12983] ='b00000100;
           rom[ 0+12984] ='b10010010;
           rom[ 0+12985] ='b11011101;
           rom[ 0+12986] ='b01110111;
           rom[ 0+12987] ='b11111100;
           rom[ 0+12988] ='b00111110;
           rom[ 0+12989] ='b00000000;
           rom[ 0+12990] ='b10011001;
           rom[ 0+12991] ='b11011101;
           rom[ 0+12992] ='b01110111;
           rom[ 0+12993] ='b11111101;
           rom[ 0+12994] ='b01111011;
           rom[ 0+12995] ='b11110101;
           rom[ 0+12996] ='b00110011;
           rom[ 0+12997] ='b11011101;
           rom[ 0+12998] ='b01101110;
           rom[ 0+12999] ='b11111100;
           rom[ 0+13000] ='b11011101;
           rom[ 0+13001] ='b01100110;
           rom[ 0+13002] ='b11111101;
           rom[ 0+13003] ='b11100101;
           rom[ 0+13004] ='b11001101;
           rom[ 0+13005] ='b00111100;
           rom[ 0+13006] ='b00010111;
           rom[ 0+13007] ='b11110001;
           rom[ 0+13008] ='b00110011;
           rom[ 0+13009] ='b11011101;
           rom[ 0+13010] ='b00110100;
           rom[ 0+13011] ='b11111110;
           rom[ 0+13012] ='b11000010;
           rom[ 0+13013] ='b11011010;
           rom[ 0+13014] ='b00110010;
           rom[ 0+13015] ='b11011101;
           rom[ 0+13016] ='b00110100;
           rom[ 0+13017] ='b11111111;
           rom[ 0+13018] ='b11000011;
           rom[ 0+13019] ='b10000101;
           rom[ 0+13020] ='b00110010;
           rom[ 0+13021] ='b00100001;
           rom[ 0+13022] ='b11000011;
           rom[ 0+13023] ='b00111100;
           rom[ 0+13024] ='b11100101;
           rom[ 0+13025] ='b11001101;
           rom[ 0+13026] ='b00001010;
           rom[ 0+13027] ='b00000010;
           rom[ 0+13028] ='b11110001;
           rom[ 0+13029] ='b00100001;
           rom[ 0+13030] ='b11011000;
           rom[ 0+13031] ='b00111100;
           rom[ 0+13032] ='b11100101;
           rom[ 0+13033] ='b11001101;
           rom[ 0+13034] ='b00001010;
           rom[ 0+13035] ='b00000010;
           rom[ 0+13036] ='b11110001;
           rom[ 0+13037] ='b11011101;
           rom[ 0+13038] ='b00110110;
           rom[ 0+13039] ='b11111010;
           rom[ 0+13040] ='b00000000;
           rom[ 0+13041] ='b11011101;
           rom[ 0+13042] ='b00110110;
           rom[ 0+13043] ='b11111011;
           rom[ 0+13044] ='b00000000;
           rom[ 0+13045] ='b11011101;
           rom[ 0+13046] ='b00110110;
           rom[ 0+13047] ='b11111110;
           rom[ 0+13048] ='b00000000;
           rom[ 0+13049] ='b11011101;
           rom[ 0+13050] ='b00110110;
           rom[ 0+13051] ='b11111111;
           rom[ 0+13052] ='b00000000;
           rom[ 0+13053] ='b11011101;
           rom[ 0+13054] ='b01111110;
           rom[ 0+13055] ='b11111110;
           rom[ 0+13056] ='b11010110;
           rom[ 0+13057] ='b00110010;
           rom[ 0+13058] ='b11011101;
           rom[ 0+13059] ='b01111110;
           rom[ 0+13060] ='b11111111;
           rom[ 0+13061] ='b11011110;
           rom[ 0+13062] ='b00000000;
           rom[ 0+13063] ='b11110010;
           rom[ 0+13064] ='b10011111;
           rom[ 0+13065] ='b00110011;
           rom[ 0+13066] ='b00100001;
           rom[ 0+13067] ='b00000101;
           rom[ 0+13068] ='b00000000;
           rom[ 0+13069] ='b11100101;
           rom[ 0+13070] ='b11011101;
           rom[ 0+13071] ='b01101110;
           rom[ 0+13072] ='b11111110;
           rom[ 0+13073] ='b11011101;
           rom[ 0+13074] ='b01100110;
           rom[ 0+13075] ='b11111111;
           rom[ 0+13076] ='b11100101;
           rom[ 0+13077] ='b11001101;
           rom[ 0+13078] ='b01010011;
           rom[ 0+13079] ='b00111110;
           rom[ 0+13080] ='b01000100;
           rom[ 0+13081] ='b01001101;
           rom[ 0+13082] ='b11110001;
           rom[ 0+13083] ='b11110001;
           rom[ 0+13084] ='b00111110;
           rom[ 0+13085] ='b00000100;
           rom[ 0+13086] ='b10010001;
           rom[ 0+13087] ='b11011101;
           rom[ 0+13088] ='b01110111;
           rom[ 0+13089] ='b11111100;
           rom[ 0+13090] ='b00111110;
           rom[ 0+13091] ='b00000000;
           rom[ 0+13092] ='b10011000;
           rom[ 0+13093] ='b11011101;
           rom[ 0+13094] ='b01110111;
           rom[ 0+13095] ='b11111101;
           rom[ 0+13096] ='b11011101;
           rom[ 0+13097] ='b01111110;
           rom[ 0+13098] ='b11111110;
           rom[ 0+13099] ='b11010110;
           rom[ 0+13100] ='b00101111;
           rom[ 0+13101] ='b11011101;
           rom[ 0+13102] ='b01111110;
           rom[ 0+13103] ='b11111111;
           rom[ 0+13104] ='b11011110;
           rom[ 0+13105] ='b00000000;
           rom[ 0+13106] ='b11110010;
           rom[ 0+13107] ='b01001000;
           rom[ 0+13108] ='b00110011;
           rom[ 0+13109] ='b00111110;
           rom[ 0+13110] ='b01001110;
           rom[ 0+13111] ='b11011101;
           rom[ 0+13112] ='b10000110;
           rom[ 0+13113] ='b11111110;
           rom[ 0+13114] ='b01010111;
           rom[ 0+13115] ='b00111110;
           rom[ 0+13116] ='b10000100;
           rom[ 0+13117] ='b11011101;
           rom[ 0+13118] ='b10001110;
           rom[ 0+13119] ='b11111111;
           rom[ 0+13120] ='b01001111;
           rom[ 0+13121] ='b01101010;
           rom[ 0+13122] ='b01100001;
           rom[ 0+13123] ='b01010110;
           rom[ 0+13124] ='b01011010;
           rom[ 0+13125] ='b11000011;
           rom[ 0+13126] ='b01010110;
           rom[ 0+13127] ='b00110011;
           rom[ 0+13128] ='b11101101;
           rom[ 0+13129] ='b01001011;
           rom[ 0+13130] ='b00110010;
           rom[ 0+13131] ='b10010000;
           rom[ 0+13132] ='b00001010;
           rom[ 0+13133] ='b01001111;
           rom[ 0+13134] ='b00101010;
           rom[ 0+13135] ='b00110010;
           rom[ 0+13136] ='b10010000;
           rom[ 0+13137] ='b00101011;
           rom[ 0+13138] ='b00100010;
           rom[ 0+13139] ='b00110010;
           rom[ 0+13140] ='b10010000;
           rom[ 0+13141] ='b01011001;
           rom[ 0+13142] ='b11010101;
           rom[ 0+13143] ='b01111011;
           rom[ 0+13144] ='b11110101;
           rom[ 0+13145] ='b00110011;
           rom[ 0+13146] ='b11011101;
           rom[ 0+13147] ='b01101110;
           rom[ 0+13148] ='b11111100;
           rom[ 0+13149] ='b11011101;
           rom[ 0+13150] ='b01100110;
           rom[ 0+13151] ='b11111101;
           rom[ 0+13152] ='b11100101;
           rom[ 0+13153] ='b11001101;
           rom[ 0+13154] ='b00111100;
           rom[ 0+13155] ='b00010111;
           rom[ 0+13156] ='b11110001;
           rom[ 0+13157] ='b00110011;
           rom[ 0+13158] ='b11010001;
           rom[ 0+13159] ='b00111110;
           rom[ 0+13160] ='b00011110;
           rom[ 0+13161] ='b11011101;
           rom[ 0+13162] ='b10000110;
           rom[ 0+13163] ='b11111010;
           rom[ 0+13164] ='b01001111;
           rom[ 0+13165] ='b00111110;
           rom[ 0+13166] ='b10001100;
           rom[ 0+13167] ='b11011101;
           rom[ 0+13168] ='b10001110;
           rom[ 0+13169] ='b11111011;
           rom[ 0+13170] ='b01000111;
           rom[ 0+13171] ='b01111011;
           rom[ 0+13172] ='b00000010;
           rom[ 0+13173] ='b11011101;
           rom[ 0+13174] ='b01001110;
           rom[ 0+13175] ='b11111010;
           rom[ 0+13176] ='b11011101;
           rom[ 0+13177] ='b01000110;
           rom[ 0+13178] ='b11111011;
           rom[ 0+13179] ='b11011101;
           rom[ 0+13180] ='b00110100;
           rom[ 0+13181] ='b11111010;
           rom[ 0+13182] ='b11000010;
           rom[ 0+13183] ='b10000100;
           rom[ 0+13184] ='b00110011;
           rom[ 0+13185] ='b11011101;
           rom[ 0+13186] ='b00110100;
           rom[ 0+13187] ='b11111011;
           rom[ 0+13188] ='b00100001;
           rom[ 0+13189] ='b00110110;
           rom[ 0+13190] ='b10001000;
           rom[ 0+13191] ='b00001001;
           rom[ 0+13192] ='b01001101;
           rom[ 0+13193] ='b01000100;
           rom[ 0+13194] ='b01111011;
           rom[ 0+13195] ='b00000010;
           rom[ 0+13196] ='b01111011;
           rom[ 0+13197] ='b11110101;
           rom[ 0+13198] ='b00110011;
           rom[ 0+13199] ='b11001101;
           rom[ 0+13200] ='b10011100;
           rom[ 0+13201] ='b00010100;
           rom[ 0+13202] ='b00110011;
           rom[ 0+13203] ='b11011101;
           rom[ 0+13204] ='b00110100;
           rom[ 0+13205] ='b11111110;
           rom[ 0+13206] ='b11000010;
           rom[ 0+13207] ='b10011100;
           rom[ 0+13208] ='b00110011;
           rom[ 0+13209] ='b11011101;
           rom[ 0+13210] ='b00110100;
           rom[ 0+13211] ='b11111111;
           rom[ 0+13212] ='b11000011;
           rom[ 0+13213] ='b11111101;
           rom[ 0+13214] ='b00110010;
           rom[ 0+13215] ='b00100001;
           rom[ 0+13216] ='b00000100;
           rom[ 0+13217] ='b00111101;
           rom[ 0+13218] ='b11100101;
           rom[ 0+13219] ='b11001101;
           rom[ 0+13220] ='b00001010;
           rom[ 0+13221] ='b00000010;
           rom[ 0+13222] ='b11110001;
           rom[ 0+13223] ='b11011101;
           rom[ 0+13224] ='b00110110;
           rom[ 0+13225] ='b11111110;
           rom[ 0+13226] ='b00000000;
           rom[ 0+13227] ='b11011101;
           rom[ 0+13228] ='b00110110;
           rom[ 0+13229] ='b11111111;
           rom[ 0+13230] ='b00000000;
           rom[ 0+13231] ='b11011101;
           rom[ 0+13232] ='b01111110;
           rom[ 0+13233] ='b11111110;
           rom[ 0+13234] ='b11010110;
           rom[ 0+13235] ='b00000101;
           rom[ 0+13236] ='b11011101;
           rom[ 0+13237] ='b01111110;
           rom[ 0+13238] ='b11111111;
           rom[ 0+13239] ='b11011110;
           rom[ 0+13240] ='b00000000;
           rom[ 0+13241] ='b11110010;
           rom[ 0+13242] ='b00010001;
           rom[ 0+13243] ='b00110100;
           rom[ 0+13244] ='b11011101;
           rom[ 0+13245] ='b01001110;
           rom[ 0+13246] ='b11111010;
           rom[ 0+13247] ='b11011101;
           rom[ 0+13248] ='b01000110;
           rom[ 0+13249] ='b11111011;
           rom[ 0+13250] ='b11011101;
           rom[ 0+13251] ='b00110100;
           rom[ 0+13252] ='b11111010;
           rom[ 0+13253] ='b11000010;
           rom[ 0+13254] ='b11001011;
           rom[ 0+13255] ='b00110011;
           rom[ 0+13256] ='b11011101;
           rom[ 0+13257] ='b00110100;
           rom[ 0+13258] ='b11111011;
           rom[ 0+13259] ='b00100001;
           rom[ 0+13260] ='b00110110;
           rom[ 0+13261] ='b10001000;
           rom[ 0+13262] ='b00001001;
           rom[ 0+13263] ='b01001101;
           rom[ 0+13264] ='b01000100;
           rom[ 0+13265] ='b11000101;
           rom[ 0+13266] ='b00100001;
           rom[ 0+13267] ='b00000101;
           rom[ 0+13268] ='b00000000;
           rom[ 0+13269] ='b11100101;
           rom[ 0+13270] ='b11011101;
           rom[ 0+13271] ='b01101110;
           rom[ 0+13272] ='b11111110;
           rom[ 0+13273] ='b11011101;
           rom[ 0+13274] ='b01100110;
           rom[ 0+13275] ='b11111111;
           rom[ 0+13276] ='b11100101;
           rom[ 0+13277] ='b11001101;
           rom[ 0+13278] ='b01010011;
           rom[ 0+13279] ='b00111110;
           rom[ 0+13280] ='b01010100;
           rom[ 0+13281] ='b01011101;
           rom[ 0+13282] ='b11110001;
           rom[ 0+13283] ='b11110001;
           rom[ 0+13284] ='b11000001;
           rom[ 0+13285] ='b00111110;
           rom[ 0+13286] ='b00000100;
           rom[ 0+13287] ='b10010011;
           rom[ 0+13288] ='b01011111;
           rom[ 0+13289] ='b00111110;
           rom[ 0+13290] ='b00000000;
           rom[ 0+13291] ='b10011010;
           rom[ 0+13292] ='b01010111;
           rom[ 0+13293] ='b01101011;
           rom[ 0+13294] ='b01100010;
           rom[ 0+13295] ='b00101001;
           rom[ 0+13296] ='b00011001;
           rom[ 0+13297] ='b00101001;
           rom[ 0+13298] ='b00011001;
           rom[ 0+13299] ='b01011101;
           rom[ 0+13300] ='b01010100;
           rom[ 0+13301] ='b00100001;
           rom[ 0+13302] ='b00000110;
           rom[ 0+13303] ='b10010000;
           rom[ 0+13304] ='b00011001;
           rom[ 0+13305] ='b01011101;
           rom[ 0+13306] ='b01010100;
           rom[ 0+13307] ='b01111011;
           rom[ 0+13308] ='b11000110;
           rom[ 0+13309] ='b00000110;
           rom[ 0+13310] ='b01011111;
           rom[ 0+13311] ='b01111010;
           rom[ 0+13312] ='b11001110;
           rom[ 0+13313] ='b00000000;
           rom[ 0+13314] ='b01010111;
           rom[ 0+13315] ='b00011010;
           rom[ 0+13316] ='b00000010;
           rom[ 0+13317] ='b11011101;
           rom[ 0+13318] ='b00110100;
           rom[ 0+13319] ='b11111110;
           rom[ 0+13320] ='b11000010;
           rom[ 0+13321] ='b00001110;
           rom[ 0+13322] ='b00110100;
           rom[ 0+13323] ='b11011101;
           rom[ 0+13324] ='b00110100;
           rom[ 0+13325] ='b11111111;
           rom[ 0+13326] ='b11000011;
           rom[ 0+13327] ='b10101111;
           rom[ 0+13328] ='b00110011;
           rom[ 0+13329] ='b11011101;
           rom[ 0+13330] ='b00110110;
           rom[ 0+13331] ='b11111110;
           rom[ 0+13332] ='b00000000;
           rom[ 0+13333] ='b11011101;
           rom[ 0+13334] ='b00110110;
           rom[ 0+13335] ='b11111111;
           rom[ 0+13336] ='b00000000;
           rom[ 0+13337] ='b11011101;
           rom[ 0+13338] ='b01111110;
           rom[ 0+13339] ='b11111110;
           rom[ 0+13340] ='b11010110;
           rom[ 0+13341] ='b00000101;
           rom[ 0+13342] ='b11011101;
           rom[ 0+13343] ='b01111110;
           rom[ 0+13344] ='b11111111;
           rom[ 0+13345] ='b11011110;
           rom[ 0+13346] ='b00000000;
           rom[ 0+13347] ='b11110010;
           rom[ 0+13348] ='b01111000;
           rom[ 0+13349] ='b00110100;
           rom[ 0+13350] ='b11011101;
           rom[ 0+13351] ='b01001110;
           rom[ 0+13352] ='b11111010;
           rom[ 0+13353] ='b11011101;
           rom[ 0+13354] ='b01000110;
           rom[ 0+13355] ='b11111011;
           rom[ 0+13356] ='b11011101;
           rom[ 0+13357] ='b00110100;
           rom[ 0+13358] ='b11111010;
           rom[ 0+13359] ='b11000010;
           rom[ 0+13360] ='b00110101;
           rom[ 0+13361] ='b00110100;
           rom[ 0+13362] ='b11011101;
           rom[ 0+13363] ='b00110100;
           rom[ 0+13364] ='b11111011;
           rom[ 0+13365] ='b00100001;
           rom[ 0+13366] ='b00110110;
           rom[ 0+13367] ='b10001000;
           rom[ 0+13368] ='b00001001;
           rom[ 0+13369] ='b01001101;
           rom[ 0+13370] ='b01000100;
           rom[ 0+13371] ='b11000101;
           rom[ 0+13372] ='b00100001;
           rom[ 0+13373] ='b00000101;
           rom[ 0+13374] ='b00000000;
           rom[ 0+13375] ='b11100101;
           rom[ 0+13376] ='b11011101;
           rom[ 0+13377] ='b01101110;
           rom[ 0+13378] ='b11111110;
           rom[ 0+13379] ='b11011101;
           rom[ 0+13380] ='b01100110;
           rom[ 0+13381] ='b11111111;
           rom[ 0+13382] ='b11100101;
           rom[ 0+13383] ='b11001101;
           rom[ 0+13384] ='b01010011;
           rom[ 0+13385] ='b00111110;
           rom[ 0+13386] ='b01010100;
           rom[ 0+13387] ='b01011101;
           rom[ 0+13388] ='b11110001;
           rom[ 0+13389] ='b11110001;
           rom[ 0+13390] ='b11000001;
           rom[ 0+13391] ='b00111110;
           rom[ 0+13392] ='b00000100;
           rom[ 0+13393] ='b10010011;
           rom[ 0+13394] ='b01011111;
           rom[ 0+13395] ='b00111110;
           rom[ 0+13396] ='b00000000;
           rom[ 0+13397] ='b10011010;
           rom[ 0+13398] ='b01010111;
           rom[ 0+13399] ='b01101011;
           rom[ 0+13400] ='b01100010;
           rom[ 0+13401] ='b00101001;
           rom[ 0+13402] ='b00011001;
           rom[ 0+13403] ='b00101001;
           rom[ 0+13404] ='b00011001;
           rom[ 0+13405] ='b01011101;
           rom[ 0+13406] ='b01010100;
           rom[ 0+13407] ='b00100001;
           rom[ 0+13408] ='b00000110;
           rom[ 0+13409] ='b10010000;
           rom[ 0+13410] ='b00011001;
           rom[ 0+13411] ='b01011101;
           rom[ 0+13412] ='b01010100;
           rom[ 0+13413] ='b00010011;
           rom[ 0+13414] ='b00010011;
           rom[ 0+13415] ='b00010011;
           rom[ 0+13416] ='b00010011;
           rom[ 0+13417] ='b00010011;
           rom[ 0+13418] ='b00011010;
           rom[ 0+13419] ='b00000010;
           rom[ 0+13420] ='b11011101;
           rom[ 0+13421] ='b00110100;
           rom[ 0+13422] ='b11111110;
           rom[ 0+13423] ='b11000010;
           rom[ 0+13424] ='b01110101;
           rom[ 0+13425] ='b00110100;
           rom[ 0+13426] ='b11011101;
           rom[ 0+13427] ='b00110100;
           rom[ 0+13428] ='b11111111;
           rom[ 0+13429] ='b11000011;
           rom[ 0+13430] ='b00011001;
           rom[ 0+13431] ='b00110100;
           rom[ 0+13432] ='b11011101;
           rom[ 0+13433] ='b00110110;
           rom[ 0+13434] ='b11111110;
           rom[ 0+13435] ='b00000000;
           rom[ 0+13436] ='b11011101;
           rom[ 0+13437] ='b00110110;
           rom[ 0+13438] ='b11111111;
           rom[ 0+13439] ='b00000000;
           rom[ 0+13440] ='b11011101;
           rom[ 0+13441] ='b01111110;
           rom[ 0+13442] ='b11111110;
           rom[ 0+13443] ='b11010110;
           rom[ 0+13444] ='b00000101;
           rom[ 0+13445] ='b11011101;
           rom[ 0+13446] ='b01111110;
           rom[ 0+13447] ='b11111111;
           rom[ 0+13448] ='b11011110;
           rom[ 0+13449] ='b00000000;
           rom[ 0+13450] ='b11110010;
           rom[ 0+13451] ='b11011110;
           rom[ 0+13452] ='b00110100;
           rom[ 0+13453] ='b11011101;
           rom[ 0+13454] ='b01001110;
           rom[ 0+13455] ='b11111010;
           rom[ 0+13456] ='b11011101;
           rom[ 0+13457] ='b01000110;
           rom[ 0+13458] ='b11111011;
           rom[ 0+13459] ='b11011101;
           rom[ 0+13460] ='b00110100;
           rom[ 0+13461] ='b11111010;
           rom[ 0+13462] ='b11000010;
           rom[ 0+13463] ='b10011100;
           rom[ 0+13464] ='b00110100;
           rom[ 0+13465] ='b11011101;
           rom[ 0+13466] ='b00110100;
           rom[ 0+13467] ='b11111011;
           rom[ 0+13468] ='b00100001;
           rom[ 0+13469] ='b00110110;
           rom[ 0+13470] ='b10001000;
           rom[ 0+13471] ='b00001001;
           rom[ 0+13472] ='b01001101;
           rom[ 0+13473] ='b01000100;
           rom[ 0+13474] ='b11000101;
           rom[ 0+13475] ='b00100001;
           rom[ 0+13476] ='b00000101;
           rom[ 0+13477] ='b00000000;
           rom[ 0+13478] ='b11100101;
           rom[ 0+13479] ='b11011101;
           rom[ 0+13480] ='b01101110;
           rom[ 0+13481] ='b11111110;
           rom[ 0+13482] ='b11011101;
           rom[ 0+13483] ='b01100110;
           rom[ 0+13484] ='b11111111;
           rom[ 0+13485] ='b11100101;
           rom[ 0+13486] ='b11001101;
           rom[ 0+13487] ='b01010011;
           rom[ 0+13488] ='b00111110;
           rom[ 0+13489] ='b01010100;
           rom[ 0+13490] ='b01011101;
           rom[ 0+13491] ='b11110001;
           rom[ 0+13492] ='b11110001;
           rom[ 0+13493] ='b11000001;
           rom[ 0+13494] ='b00111110;
           rom[ 0+13495] ='b00000100;
           rom[ 0+13496] ='b10010011;
           rom[ 0+13497] ='b01011111;
           rom[ 0+13498] ='b00111110;
           rom[ 0+13499] ='b00000000;
           rom[ 0+13500] ='b10011010;
           rom[ 0+13501] ='b01010111;
           rom[ 0+13502] ='b01101011;
           rom[ 0+13503] ='b01100010;
           rom[ 0+13504] ='b00101001;
           rom[ 0+13505] ='b00011001;
           rom[ 0+13506] ='b00101001;
           rom[ 0+13507] ='b00011001;
           rom[ 0+13508] ='b01011101;
           rom[ 0+13509] ='b01010100;
           rom[ 0+13510] ='b00100001;
           rom[ 0+13511] ='b00000110;
           rom[ 0+13512] ='b10010000;
           rom[ 0+13513] ='b00011001;
           rom[ 0+13514] ='b01011101;
           rom[ 0+13515] ='b01010100;
           rom[ 0+13516] ='b00010011;
           rom[ 0+13517] ='b00010011;
           rom[ 0+13518] ='b00010011;
           rom[ 0+13519] ='b00010011;
           rom[ 0+13520] ='b00011010;
           rom[ 0+13521] ='b00000010;
           rom[ 0+13522] ='b11011101;
           rom[ 0+13523] ='b00110100;
           rom[ 0+13524] ='b11111110;
           rom[ 0+13525] ='b11000010;
           rom[ 0+13526] ='b11011011;
           rom[ 0+13527] ='b00110100;
           rom[ 0+13528] ='b11011101;
           rom[ 0+13529] ='b00110100;
           rom[ 0+13530] ='b11111111;
           rom[ 0+13531] ='b11000011;
           rom[ 0+13532] ='b10000000;
           rom[ 0+13533] ='b00110100;
           rom[ 0+13534] ='b11011101;
           rom[ 0+13535] ='b00110110;
           rom[ 0+13536] ='b11111110;
           rom[ 0+13537] ='b00000000;
           rom[ 0+13538] ='b11011101;
           rom[ 0+13539] ='b00110110;
           rom[ 0+13540] ='b11111111;
           rom[ 0+13541] ='b00000000;
           rom[ 0+13542] ='b11011101;
           rom[ 0+13543] ='b01111110;
           rom[ 0+13544] ='b11111110;
           rom[ 0+13545] ='b11010110;
           rom[ 0+13546] ='b00000101;
           rom[ 0+13547] ='b11011101;
           rom[ 0+13548] ='b01111110;
           rom[ 0+13549] ='b11111111;
           rom[ 0+13550] ='b11011110;
           rom[ 0+13551] ='b00000000;
           rom[ 0+13552] ='b11110010;
           rom[ 0+13553] ='b01000011;
           rom[ 0+13554] ='b00110101;
           rom[ 0+13555] ='b11011101;
           rom[ 0+13556] ='b01001110;
           rom[ 0+13557] ='b11111010;
           rom[ 0+13558] ='b11011101;
           rom[ 0+13559] ='b01000110;
           rom[ 0+13560] ='b11111011;
           rom[ 0+13561] ='b11011101;
           rom[ 0+13562] ='b00110100;
           rom[ 0+13563] ='b11111010;
           rom[ 0+13564] ='b11000010;
           rom[ 0+13565] ='b00000010;
           rom[ 0+13566] ='b00110101;
           rom[ 0+13567] ='b11011101;
           rom[ 0+13568] ='b00110100;
           rom[ 0+13569] ='b11111011;
           rom[ 0+13570] ='b00100001;
           rom[ 0+13571] ='b00110110;
           rom[ 0+13572] ='b10001000;
           rom[ 0+13573] ='b00001001;
           rom[ 0+13574] ='b01001101;
           rom[ 0+13575] ='b01000100;
           rom[ 0+13576] ='b11000101;
           rom[ 0+13577] ='b00100001;
           rom[ 0+13578] ='b00000101;
           rom[ 0+13579] ='b00000000;
           rom[ 0+13580] ='b11100101;
           rom[ 0+13581] ='b11011101;
           rom[ 0+13582] ='b01101110;
           rom[ 0+13583] ='b11111110;
           rom[ 0+13584] ='b11011101;
           rom[ 0+13585] ='b01100110;
           rom[ 0+13586] ='b11111111;
           rom[ 0+13587] ='b11100101;
           rom[ 0+13588] ='b11001101;
           rom[ 0+13589] ='b01010011;
           rom[ 0+13590] ='b00111110;
           rom[ 0+13591] ='b01010100;
           rom[ 0+13592] ='b01011101;
           rom[ 0+13593] ='b11110001;
           rom[ 0+13594] ='b11110001;
           rom[ 0+13595] ='b11000001;
           rom[ 0+13596] ='b00111110;
           rom[ 0+13597] ='b00000100;
           rom[ 0+13598] ='b10010011;
           rom[ 0+13599] ='b01011111;
           rom[ 0+13600] ='b00111110;
           rom[ 0+13601] ='b00000000;
           rom[ 0+13602] ='b10011010;
           rom[ 0+13603] ='b01010111;
           rom[ 0+13604] ='b01101011;
           rom[ 0+13605] ='b01100010;
           rom[ 0+13606] ='b00101001;
           rom[ 0+13607] ='b00011001;
           rom[ 0+13608] ='b00101001;
           rom[ 0+13609] ='b00011001;
           rom[ 0+13610] ='b01011101;
           rom[ 0+13611] ='b01010100;
           rom[ 0+13612] ='b00100001;
           rom[ 0+13613] ='b00000110;
           rom[ 0+13614] ='b10010000;
           rom[ 0+13615] ='b00011001;
           rom[ 0+13616] ='b01011101;
           rom[ 0+13617] ='b01010100;
           rom[ 0+13618] ='b00010011;
           rom[ 0+13619] ='b00010011;
           rom[ 0+13620] ='b00010011;
           rom[ 0+13621] ='b00011010;
           rom[ 0+13622] ='b00000010;
           rom[ 0+13623] ='b11011101;
           rom[ 0+13624] ='b00110100;
           rom[ 0+13625] ='b11111110;
           rom[ 0+13626] ='b11000010;
           rom[ 0+13627] ='b01000000;
           rom[ 0+13628] ='b00110101;
           rom[ 0+13629] ='b11011101;
           rom[ 0+13630] ='b00110100;
           rom[ 0+13631] ='b11111111;
           rom[ 0+13632] ='b11000011;
           rom[ 0+13633] ='b11100110;
           rom[ 0+13634] ='b00110100;
           rom[ 0+13635] ='b11011101;
           rom[ 0+13636] ='b00110110;
           rom[ 0+13637] ='b11111110;
           rom[ 0+13638] ='b00000000;
           rom[ 0+13639] ='b11011101;
           rom[ 0+13640] ='b00110110;
           rom[ 0+13641] ='b11111111;
           rom[ 0+13642] ='b00000000;
           rom[ 0+13643] ='b11011101;
           rom[ 0+13644] ='b01111110;
           rom[ 0+13645] ='b11111110;
           rom[ 0+13646] ='b11010110;
           rom[ 0+13647] ='b00000101;
           rom[ 0+13648] ='b11011101;
           rom[ 0+13649] ='b01111110;
           rom[ 0+13650] ='b11111111;
           rom[ 0+13651] ='b11011110;
           rom[ 0+13652] ='b00000000;
           rom[ 0+13653] ='b11110010;
           rom[ 0+13654] ='b10100111;
           rom[ 0+13655] ='b00110101;
           rom[ 0+13656] ='b11011101;
           rom[ 0+13657] ='b01001110;
           rom[ 0+13658] ='b11111010;
           rom[ 0+13659] ='b11011101;
           rom[ 0+13660] ='b01000110;
           rom[ 0+13661] ='b11111011;
           rom[ 0+13662] ='b11011101;
           rom[ 0+13663] ='b00110100;
           rom[ 0+13664] ='b11111010;
           rom[ 0+13665] ='b11000010;
           rom[ 0+13666] ='b01100111;
           rom[ 0+13667] ='b00110101;
           rom[ 0+13668] ='b11011101;
           rom[ 0+13669] ='b00110100;
           rom[ 0+13670] ='b11111011;
           rom[ 0+13671] ='b00100001;
           rom[ 0+13672] ='b00110110;
           rom[ 0+13673] ='b10001000;
           rom[ 0+13674] ='b00001001;
           rom[ 0+13675] ='b01001101;
           rom[ 0+13676] ='b01000100;
           rom[ 0+13677] ='b11000101;
           rom[ 0+13678] ='b00100001;
           rom[ 0+13679] ='b00000101;
           rom[ 0+13680] ='b00000000;
           rom[ 0+13681] ='b11100101;
           rom[ 0+13682] ='b11011101;
           rom[ 0+13683] ='b01101110;
           rom[ 0+13684] ='b11111110;
           rom[ 0+13685] ='b11011101;
           rom[ 0+13686] ='b01100110;
           rom[ 0+13687] ='b11111111;
           rom[ 0+13688] ='b11100101;
           rom[ 0+13689] ='b11001101;
           rom[ 0+13690] ='b01010011;
           rom[ 0+13691] ='b00111110;
           rom[ 0+13692] ='b01010100;
           rom[ 0+13693] ='b01011101;
           rom[ 0+13694] ='b11110001;
           rom[ 0+13695] ='b11110001;
           rom[ 0+13696] ='b11000001;
           rom[ 0+13697] ='b00111110;
           rom[ 0+13698] ='b00000100;
           rom[ 0+13699] ='b10010011;
           rom[ 0+13700] ='b01011111;
           rom[ 0+13701] ='b00111110;
           rom[ 0+13702] ='b00000000;
           rom[ 0+13703] ='b10011010;
           rom[ 0+13704] ='b01010111;
           rom[ 0+13705] ='b01101011;
           rom[ 0+13706] ='b01100010;
           rom[ 0+13707] ='b00101001;
           rom[ 0+13708] ='b00011001;
           rom[ 0+13709] ='b00101001;
           rom[ 0+13710] ='b00011001;
           rom[ 0+13711] ='b01011101;
           rom[ 0+13712] ='b01010100;
           rom[ 0+13713] ='b00100001;
           rom[ 0+13714] ='b00000110;
           rom[ 0+13715] ='b10010000;
           rom[ 0+13716] ='b00011001;
           rom[ 0+13717] ='b01011101;
           rom[ 0+13718] ='b01010100;
           rom[ 0+13719] ='b00010011;
           rom[ 0+13720] ='b00010011;
           rom[ 0+13721] ='b00011010;
           rom[ 0+13722] ='b00000010;
           rom[ 0+13723] ='b11011101;
           rom[ 0+13724] ='b00110100;
           rom[ 0+13725] ='b11111110;
           rom[ 0+13726] ='b11000010;
           rom[ 0+13727] ='b10100100;
           rom[ 0+13728] ='b00110101;
           rom[ 0+13729] ='b11011101;
           rom[ 0+13730] ='b00110100;
           rom[ 0+13731] ='b11111111;
           rom[ 0+13732] ='b11000011;
           rom[ 0+13733] ='b01001011;
           rom[ 0+13734] ='b00110101;
           rom[ 0+13735] ='b11011101;
           rom[ 0+13736] ='b00110110;
           rom[ 0+13737] ='b11111110;
           rom[ 0+13738] ='b00000000;
           rom[ 0+13739] ='b11011101;
           rom[ 0+13740] ='b00110110;
           rom[ 0+13741] ='b11111111;
           rom[ 0+13742] ='b00000000;
           rom[ 0+13743] ='b11011101;
           rom[ 0+13744] ='b01111110;
           rom[ 0+13745] ='b11111110;
           rom[ 0+13746] ='b11010110;
           rom[ 0+13747] ='b00000101;
           rom[ 0+13748] ='b11011101;
           rom[ 0+13749] ='b01111110;
           rom[ 0+13750] ='b11111111;
           rom[ 0+13751] ='b11011110;
           rom[ 0+13752] ='b00000000;
           rom[ 0+13753] ='b11110010;
           rom[ 0+13754] ='b00001010;
           rom[ 0+13755] ='b00110110;
           rom[ 0+13756] ='b11011101;
           rom[ 0+13757] ='b01001110;
           rom[ 0+13758] ='b11111010;
           rom[ 0+13759] ='b11011101;
           rom[ 0+13760] ='b01000110;
           rom[ 0+13761] ='b11111011;
           rom[ 0+13762] ='b11011101;
           rom[ 0+13763] ='b00110100;
           rom[ 0+13764] ='b11111010;
           rom[ 0+13765] ='b11000010;
           rom[ 0+13766] ='b11001011;
           rom[ 0+13767] ='b00110101;
           rom[ 0+13768] ='b11011101;
           rom[ 0+13769] ='b00110100;
           rom[ 0+13770] ='b11111011;
           rom[ 0+13771] ='b00100001;
           rom[ 0+13772] ='b00110110;
           rom[ 0+13773] ='b10001000;
           rom[ 0+13774] ='b00001001;
           rom[ 0+13775] ='b01001101;
           rom[ 0+13776] ='b01000100;
           rom[ 0+13777] ='b11000101;
           rom[ 0+13778] ='b00100001;
           rom[ 0+13779] ='b00000101;
           rom[ 0+13780] ='b00000000;
           rom[ 0+13781] ='b11100101;
           rom[ 0+13782] ='b11011101;
           rom[ 0+13783] ='b01101110;
           rom[ 0+13784] ='b11111110;
           rom[ 0+13785] ='b11011101;
           rom[ 0+13786] ='b01100110;
           rom[ 0+13787] ='b11111111;
           rom[ 0+13788] ='b11100101;
           rom[ 0+13789] ='b11001101;
           rom[ 0+13790] ='b01010011;
           rom[ 0+13791] ='b00111110;
           rom[ 0+13792] ='b01010100;
           rom[ 0+13793] ='b01011101;
           rom[ 0+13794] ='b11110001;
           rom[ 0+13795] ='b11110001;
           rom[ 0+13796] ='b11000001;
           rom[ 0+13797] ='b00111110;
           rom[ 0+13798] ='b00000100;
           rom[ 0+13799] ='b10010011;
           rom[ 0+13800] ='b01011111;
           rom[ 0+13801] ='b00111110;
           rom[ 0+13802] ='b00000000;
           rom[ 0+13803] ='b10011010;
           rom[ 0+13804] ='b01010111;
           rom[ 0+13805] ='b01101011;
           rom[ 0+13806] ='b01100010;
           rom[ 0+13807] ='b00101001;
           rom[ 0+13808] ='b00011001;
           rom[ 0+13809] ='b00101001;
           rom[ 0+13810] ='b00011001;
           rom[ 0+13811] ='b01011101;
           rom[ 0+13812] ='b01010100;
           rom[ 0+13813] ='b00100001;
           rom[ 0+13814] ='b00000110;
           rom[ 0+13815] ='b10010000;
           rom[ 0+13816] ='b00011001;
           rom[ 0+13817] ='b01011101;
           rom[ 0+13818] ='b01010100;
           rom[ 0+13819] ='b00010011;
           rom[ 0+13820] ='b00011010;
           rom[ 0+13821] ='b00000010;
           rom[ 0+13822] ='b11011101;
           rom[ 0+13823] ='b00110100;
           rom[ 0+13824] ='b11111110;
           rom[ 0+13825] ='b11000010;
           rom[ 0+13826] ='b00000111;
           rom[ 0+13827] ='b00110110;
           rom[ 0+13828] ='b11011101;
           rom[ 0+13829] ='b00110100;
           rom[ 0+13830] ='b11111111;
           rom[ 0+13831] ='b11000011;
           rom[ 0+13832] ='b10101111;
           rom[ 0+13833] ='b00110101;
           rom[ 0+13834] ='b11011101;
           rom[ 0+13835] ='b00110110;
           rom[ 0+13836] ='b11111110;
           rom[ 0+13837] ='b00000000;
           rom[ 0+13838] ='b11011101;
           rom[ 0+13839] ='b00110110;
           rom[ 0+13840] ='b11111111;
           rom[ 0+13841] ='b00000000;
           rom[ 0+13842] ='b11011101;
           rom[ 0+13843] ='b01111110;
           rom[ 0+13844] ='b11111110;
           rom[ 0+13845] ='b11010110;
           rom[ 0+13846] ='b00000101;
           rom[ 0+13847] ='b11011101;
           rom[ 0+13848] ='b01111110;
           rom[ 0+13849] ='b11111111;
           rom[ 0+13850] ='b11011110;
           rom[ 0+13851] ='b00000000;
           rom[ 0+13852] ='b11110010;
           rom[ 0+13853] ='b01101100;
           rom[ 0+13854] ='b00110110;
           rom[ 0+13855] ='b11011101;
           rom[ 0+13856] ='b01001110;
           rom[ 0+13857] ='b11111010;
           rom[ 0+13858] ='b11011101;
           rom[ 0+13859] ='b01000110;
           rom[ 0+13860] ='b11111011;
           rom[ 0+13861] ='b11011101;
           rom[ 0+13862] ='b00110100;
           rom[ 0+13863] ='b11111010;
           rom[ 0+13864] ='b11000010;
           rom[ 0+13865] ='b00101110;
           rom[ 0+13866] ='b00110110;
           rom[ 0+13867] ='b11011101;
           rom[ 0+13868] ='b00110100;
           rom[ 0+13869] ='b11111011;
           rom[ 0+13870] ='b00100001;
           rom[ 0+13871] ='b00110110;
           rom[ 0+13872] ='b10001000;
           rom[ 0+13873] ='b00001001;
           rom[ 0+13874] ='b01001101;
           rom[ 0+13875] ='b01000100;
           rom[ 0+13876] ='b11000101;
           rom[ 0+13877] ='b00100001;
           rom[ 0+13878] ='b00000101;
           rom[ 0+13879] ='b00000000;
           rom[ 0+13880] ='b11100101;
           rom[ 0+13881] ='b11011101;
           rom[ 0+13882] ='b01101110;
           rom[ 0+13883] ='b11111110;
           rom[ 0+13884] ='b11011101;
           rom[ 0+13885] ='b01100110;
           rom[ 0+13886] ='b11111111;
           rom[ 0+13887] ='b11100101;
           rom[ 0+13888] ='b11001101;
           rom[ 0+13889] ='b01010011;
           rom[ 0+13890] ='b00111110;
           rom[ 0+13891] ='b01010100;
           rom[ 0+13892] ='b01011101;
           rom[ 0+13893] ='b11110001;
           rom[ 0+13894] ='b11110001;
           rom[ 0+13895] ='b11000001;
           rom[ 0+13896] ='b00111110;
           rom[ 0+13897] ='b00000100;
           rom[ 0+13898] ='b10010011;
           rom[ 0+13899] ='b01011111;
           rom[ 0+13900] ='b00111110;
           rom[ 0+13901] ='b00000000;
           rom[ 0+13902] ='b10011010;
           rom[ 0+13903] ='b01010111;
           rom[ 0+13904] ='b01101011;
           rom[ 0+13905] ='b01100010;
           rom[ 0+13906] ='b00101001;
           rom[ 0+13907] ='b00011001;
           rom[ 0+13908] ='b00101001;
           rom[ 0+13909] ='b00011001;
           rom[ 0+13910] ='b01011101;
           rom[ 0+13911] ='b01010100;
           rom[ 0+13912] ='b00100001;
           rom[ 0+13913] ='b00000110;
           rom[ 0+13914] ='b10010000;
           rom[ 0+13915] ='b00011001;
           rom[ 0+13916] ='b01011101;
           rom[ 0+13917] ='b01010100;
           rom[ 0+13918] ='b00011010;
           rom[ 0+13919] ='b00000010;
           rom[ 0+13920] ='b11011101;
           rom[ 0+13921] ='b00110100;
           rom[ 0+13922] ='b11111110;
           rom[ 0+13923] ='b11000010;
           rom[ 0+13924] ='b01101001;
           rom[ 0+13925] ='b00110110;
           rom[ 0+13926] ='b11011101;
           rom[ 0+13927] ='b00110100;
           rom[ 0+13928] ='b11111111;
           rom[ 0+13929] ='b11000011;
           rom[ 0+13930] ='b00010010;
           rom[ 0+13931] ='b00110110;
           rom[ 0+13932] ='b11001101;
           rom[ 0+13933] ='b00000000;
           rom[ 0+13934] ='b00010110;
           rom[ 0+13935] ='b10101111;
           rom[ 0+13936] ='b11111101;
           rom[ 0+13937] ='b00100001;
           rom[ 0+13938] ='b00101110;
           rom[ 0+13939] ='b10010000;
           rom[ 0+13940] ='b11111101;
           rom[ 0+13941] ='b01110111;
           rom[ 0+13942] ='b00000000;
           rom[ 0+13943] ='b11111101;
           rom[ 0+13944] ='b01110111;
           rom[ 0+13945] ='b00000001;
           rom[ 0+13946] ='b11111101;
           rom[ 0+13947] ='b01110111;
           rom[ 0+13948] ='b00000010;
           rom[ 0+13949] ='b11111101;
           rom[ 0+13950] ='b01110111;
           rom[ 0+13951] ='b00000011;
           rom[ 0+13952] ='b00000001;
           rom[ 0+13953] ='b00000000;
           rom[ 0+13954] ='b00000000;
           rom[ 0+13955] ='b01111001;
           rom[ 0+13956] ='b11010110;
           rom[ 0+13957] ='b00000101;
           rom[ 0+13958] ='b01111000;
           rom[ 0+13959] ='b11011110;
           rom[ 0+13960] ='b00000000;
           rom[ 0+13961] ='b11110010;
           rom[ 0+13962] ='b11000000;
           rom[ 0+13963] ='b00110110;
           rom[ 0+13964] ='b00100001;
           rom[ 0+13965] ='b00101001;
           rom[ 0+13966] ='b10010000;
           rom[ 0+13967] ='b00001001;
           rom[ 0+13968] ='b01011101;
           rom[ 0+13969] ='b01010100;
           rom[ 0+13970] ='b00011010;
           rom[ 0+13971] ='b01011111;
           rom[ 0+13972] ='b11011101;
           rom[ 0+13973] ='b01110011;
           rom[ 0+13974] ='b11111001;
           rom[ 0+13975] ='b11000101;
           rom[ 0+13976] ='b00100001;
           rom[ 0+13977] ='b00000101;
           rom[ 0+13978] ='b00000000;
           rom[ 0+13979] ='b11100101;
           rom[ 0+13980] ='b11000101;
           rom[ 0+13981] ='b11001101;
           rom[ 0+13982] ='b01010011;
           rom[ 0+13983] ='b00111110;
           rom[ 0+13984] ='b01011100;
           rom[ 0+13985] ='b01010101;
           rom[ 0+13986] ='b11110001;
           rom[ 0+13987] ='b11110001;
           rom[ 0+13988] ='b11000001;
           rom[ 0+13989] ='b00111110;
           rom[ 0+13990] ='b00000100;
           rom[ 0+13991] ='b10010010;
           rom[ 0+13992] ='b01010111;
           rom[ 0+13993] ='b00111110;
           rom[ 0+13994] ='b00000000;
           rom[ 0+13995] ='b10011011;
           rom[ 0+13996] ='b01011111;
           rom[ 0+13997] ='b11000101;
           rom[ 0+13998] ='b11011101;
           rom[ 0+13999] ='b01111110;
           rom[ 0+14000] ='b11111001;
           rom[ 0+14001] ='b11110101;
           rom[ 0+14002] ='b00110011;
           rom[ 0+14003] ='b01101010;
           rom[ 0+14004] ='b01100011;
           rom[ 0+14005] ='b11100101;
           rom[ 0+14006] ='b11001101;
           rom[ 0+14007] ='b01110000;
           rom[ 0+14008] ='b00011000;
           rom[ 0+14009] ='b11110001;
           rom[ 0+14010] ='b00110011;
           rom[ 0+14011] ='b11000001;
           rom[ 0+14012] ='b00000011;
           rom[ 0+14013] ='b11000011;
           rom[ 0+14014] ='b10000011;
           rom[ 0+14015] ='b00110110;
           rom[ 0+14016] ='b00000001;
           rom[ 0+14017] ='b00110111;
           rom[ 0+14018] ='b10001000;
           rom[ 0+14019] ='b00001010;
           rom[ 0+14020] ='b01011111;
           rom[ 0+14021] ='b11101110;
           rom[ 0+14022] ='b11111111;
           rom[ 0+14023] ='b00000010;
           rom[ 0+14024] ='b00000001;
           rom[ 0+14025] ='b00111100;
           rom[ 0+14026] ='b10001000;
           rom[ 0+14027] ='b00001010;
           rom[ 0+14028] ='b01011111;
           rom[ 0+14029] ='b11101110;
           rom[ 0+14030] ='b10101010;
           rom[ 0+14031] ='b00000010;
           rom[ 0+14032] ='b00000001;
           rom[ 0+14033] ='b01000001;
           rom[ 0+14034] ='b10001000;
           rom[ 0+14035] ='b00001010;
           rom[ 0+14036] ='b01011111;
           rom[ 0+14037] ='b11101110;
           rom[ 0+14038] ='b11001100;
           rom[ 0+14039] ='b00000010;
           rom[ 0+14040] ='b00000001;
           rom[ 0+14041] ='b00111000;
           rom[ 0+14042] ='b10001000;
           rom[ 0+14043] ='b00001010;
           rom[ 0+14044] ='b01011111;
           rom[ 0+14045] ='b11101110;
           rom[ 0+14046] ='b10111011;
           rom[ 0+14047] ='b00000010;
           rom[ 0+14048] ='b00000001;
           rom[ 0+14049] ='b00111101;
           rom[ 0+14050] ='b10001000;
           rom[ 0+14051] ='b00001010;
           rom[ 0+14052] ='b01011111;
           rom[ 0+14053] ='b11101110;
           rom[ 0+14054] ='b11011101;
           rom[ 0+14055] ='b00000010;
           rom[ 0+14056] ='b00000001;
           rom[ 0+14057] ='b00111001;
           rom[ 0+14058] ='b10001000;
           rom[ 0+14059] ='b00001010;
           rom[ 0+14060] ='b01011111;
           rom[ 0+14061] ='b11101110;
           rom[ 0+14062] ='b11101110;
           rom[ 0+14063] ='b00000010;
           rom[ 0+14064] ='b00100001;
           rom[ 0+14065] ='b00000110;
           rom[ 0+14066] ='b00111101;
           rom[ 0+14067] ='b11100101;
           rom[ 0+14068] ='b11001101;
           rom[ 0+14069] ='b00001010;
           rom[ 0+14070] ='b00000010;
           rom[ 0+14071] ='b11110001;
           rom[ 0+14072] ='b00000001;
           rom[ 0+14073] ='b00000000;
           rom[ 0+14074] ='b00000000;
           rom[ 0+14075] ='b01111001;
           rom[ 0+14076] ='b11010110;
           rom[ 0+14077] ='b01010101;
           rom[ 0+14078] ='b01111000;
           rom[ 0+14079] ='b11011110;
           rom[ 0+14080] ='b00000000;
           rom[ 0+14081] ='b11110010;
           rom[ 0+14082] ='b01000001;
           rom[ 0+14083] ='b00110111;
           rom[ 0+14084] ='b00100001;
           rom[ 0+14085] ='b00110110;
           rom[ 0+14086] ='b10001000;
           rom[ 0+14087] ='b00001001;
           rom[ 0+14088] ='b01011101;
           rom[ 0+14089] ='b01010100;
           rom[ 0+14090] ='b00011010;
           rom[ 0+14091] ='b01011111;
           rom[ 0+14092] ='b11011101;
           rom[ 0+14093] ='b01110011;
           rom[ 0+14094] ='b11111001;
           rom[ 0+14095] ='b11000101;
           rom[ 0+14096] ='b00100001;
           rom[ 0+14097] ='b00000101;
           rom[ 0+14098] ='b00000000;
           rom[ 0+14099] ='b11100101;
           rom[ 0+14100] ='b11000101;
           rom[ 0+14101] ='b11001101;
           rom[ 0+14102] ='b01010011;
           rom[ 0+14103] ='b00111110;
           rom[ 0+14104] ='b01010100;
           rom[ 0+14105] ='b01011101;
           rom[ 0+14106] ='b11110001;
           rom[ 0+14107] ='b11110001;
           rom[ 0+14108] ='b11000001;
           rom[ 0+14109] ='b00111110;
           rom[ 0+14110] ='b00000100;
           rom[ 0+14111] ='b10010011;
           rom[ 0+14112] ='b01011111;
           rom[ 0+14113] ='b00111110;
           rom[ 0+14114] ='b00000000;
           rom[ 0+14115] ='b10011010;
           rom[ 0+14116] ='b01010111;
           rom[ 0+14117] ='b11000101;
           rom[ 0+14118] ='b11011101;
           rom[ 0+14119] ='b01111110;
           rom[ 0+14120] ='b11111001;
           rom[ 0+14121] ='b11110101;
           rom[ 0+14122] ='b00110011;
           rom[ 0+14123] ='b11010101;
           rom[ 0+14124] ='b11001101;
           rom[ 0+14125] ='b01110000;
           rom[ 0+14126] ='b00011000;
           rom[ 0+14127] ='b11110001;
           rom[ 0+14128] ='b00110011;
           rom[ 0+14129] ='b11000001;
           rom[ 0+14130] ='b11000101;
           rom[ 0+14131] ='b11011101;
           rom[ 0+14132] ='b01111110;
           rom[ 0+14133] ='b11111001;
           rom[ 0+14134] ='b11110101;
           rom[ 0+14135] ='b00110011;
           rom[ 0+14136] ='b11001101;
           rom[ 0+14137] ='b10011100;
           rom[ 0+14138] ='b00010100;
           rom[ 0+14139] ='b00110011;
           rom[ 0+14140] ='b11000001;
           rom[ 0+14141] ='b00000011;
           rom[ 0+14142] ='b11000011;
           rom[ 0+14143] ='b11111011;
           rom[ 0+14144] ='b00110110;
           rom[ 0+14145] ='b00100001;
           rom[ 0+14146] ='b00010001;
           rom[ 0+14147] ='b00111101;
           rom[ 0+14148] ='b11100101;
           rom[ 0+14149] ='b11001101;
           rom[ 0+14150] ='b00001010;
           rom[ 0+14151] ='b00000010;
           rom[ 0+14152] ='b11110001;
           rom[ 0+14153] ='b00000001;
           rom[ 0+14154] ='b00000000;
           rom[ 0+14155] ='b00000000;
           rom[ 0+14156] ='b01111001;
           rom[ 0+14157] ='b11010110;
           rom[ 0+14158] ='b00000101;
           rom[ 0+14159] ='b01111000;
           rom[ 0+14160] ='b11011110;
           rom[ 0+14161] ='b00000000;
           rom[ 0+14162] ='b11110010;
           rom[ 0+14163] ='b01101010;
           rom[ 0+14164] ='b00110111;
           rom[ 0+14165] ='b11000101;
           rom[ 0+14166] ='b11000101;
           rom[ 0+14167] ='b00100001;
           rom[ 0+14168] ='b00000111;
           rom[ 0+14169] ='b00000000;
           rom[ 0+14170] ='b11100101;
           rom[ 0+14171] ='b00100001;
           rom[ 0+14172] ='b00010010;
           rom[ 0+14173] ='b00000000;
           rom[ 0+14174] ='b11100101;
           rom[ 0+14175] ='b11001101;
           rom[ 0+14176] ='b00101100;
           rom[ 0+14177] ='b00101111;
           rom[ 0+14178] ='b11110001;
           rom[ 0+14179] ='b11110001;
           rom[ 0+14180] ='b11110001;
           rom[ 0+14181] ='b11000001;
           rom[ 0+14182] ='b00000011;
           rom[ 0+14183] ='b11000011;
           rom[ 0+14184] ='b01001100;
           rom[ 0+14185] ='b00110111;
           rom[ 0+14186] ='b00100001;
           rom[ 0+14187] ='b00101110;
           rom[ 0+14188] ='b00111101;
           rom[ 0+14189] ='b11100101;
           rom[ 0+14190] ='b11001101;
           rom[ 0+14191] ='b00001010;
           rom[ 0+14192] ='b00000010;
           rom[ 0+14193] ='b11110001;
           rom[ 0+14194] ='b11011101;
           rom[ 0+14195] ='b00110110;
           rom[ 0+14196] ='b11111100;
           rom[ 0+14197] ='b00000000;
           rom[ 0+14198] ='b11011101;
           rom[ 0+14199] ='b00110110;
           rom[ 0+14200] ='b11111101;
           rom[ 0+14201] ='b00000000;
           rom[ 0+14202] ='b00010001;
           rom[ 0+14203] ='b11110011;
           rom[ 0+14204] ='b11111111;
           rom[ 0+14205] ='b11011101;
           rom[ 0+14206] ='b01111110;
           rom[ 0+14207] ='b11111100;
           rom[ 0+14208] ='b11010110;
           rom[ 0+14209] ='b00000101;
           rom[ 0+14210] ='b11011101;
           rom[ 0+14211] ='b01111110;
           rom[ 0+14212] ='b11111101;
           rom[ 0+14213] ='b11011110;
           rom[ 0+14214] ='b00000000;
           rom[ 0+14215] ='b11110010;
           rom[ 0+14216] ='b00010011;
           rom[ 0+14217] ='b00111100;
           rom[ 0+14218] ='b11010101;
           rom[ 0+14219] ='b00100001;
           rom[ 0+14220] ='b01000100;
           rom[ 0+14221] ='b00111101;
           rom[ 0+14222] ='b11100101;
           rom[ 0+14223] ='b11001101;
           rom[ 0+14224] ='b00001010;
           rom[ 0+14225] ='b00000010;
           rom[ 0+14226] ='b11110001;
           rom[ 0+14227] ='b11010001;
           rom[ 0+14228] ='b11010101;
           rom[ 0+14229] ='b11011101;
           rom[ 0+14230] ='b01101110;
           rom[ 0+14231] ='b11111100;
           rom[ 0+14232] ='b11011101;
           rom[ 0+14233] ='b01100110;
           rom[ 0+14234] ='b11111101;
           rom[ 0+14235] ='b11100101;
           rom[ 0+14236] ='b11001101;
           rom[ 0+14237] ='b10110001;
           rom[ 0+14238] ='b00010100;
           rom[ 0+14239] ='b11110001;
           rom[ 0+14240] ='b11010001;
           rom[ 0+14241] ='b11010101;
           rom[ 0+14242] ='b00100001;
           rom[ 0+14243] ='b01010100;
           rom[ 0+14244] ='b00111101;
           rom[ 0+14245] ='b11100101;
           rom[ 0+14246] ='b11001101;
           rom[ 0+14247] ='b00001010;
           rom[ 0+14248] ='b00000010;
           rom[ 0+14249] ='b11110001;
           rom[ 0+14250] ='b11010001;
           rom[ 0+14251] ='b01111011;
           rom[ 0+14252] ='b11000110;
           rom[ 0+14253] ='b00001101;
           rom[ 0+14254] ='b01011111;
           rom[ 0+14255] ='b01111010;
           rom[ 0+14256] ='b11001110;
           rom[ 0+14257] ='b00000000;
           rom[ 0+14258] ='b01010111;
           rom[ 0+14259] ='b00100001;
           rom[ 0+14260] ='b00000011;
           rom[ 0+14261] ='b10000100;
           rom[ 0+14262] ='b00011001;
           rom[ 0+14263] ='b01001101;
           rom[ 0+14264] ='b01000100;
           rom[ 0+14265] ='b01001110;
           rom[ 0+14266] ='b00100011;
           rom[ 0+14267] ='b01000110;
           rom[ 0+14268] ='b01111001;
           rom[ 0+14269] ='b10110000;
           rom[ 0+14270] ='b11001010;
           rom[ 0+14271] ='b11100101;
           rom[ 0+14272] ='b00110111;
           rom[ 0+14273] ='b01111001;
           rom[ 0+14274] ='b11111110;
           rom[ 0+14275] ='b00000001;
           rom[ 0+14276] ='b11000010;
           rom[ 0+14277] ='b11001100;
           rom[ 0+14278] ='b00110111;
           rom[ 0+14279] ='b01111000;
           rom[ 0+14280] ='b10110111;
           rom[ 0+14281] ='b11001010;
           rom[ 0+14282] ='b11110010;
           rom[ 0+14283] ='b00110111;
           rom[ 0+14284] ='b01111001;
           rom[ 0+14285] ='b11111110;
           rom[ 0+14286] ='b00000010;
           rom[ 0+14287] ='b11000010;
           rom[ 0+14288] ='b11010111;
           rom[ 0+14289] ='b00110111;
           rom[ 0+14290] ='b01111000;
           rom[ 0+14291] ='b10110111;
           rom[ 0+14292] ='b11001010;
           rom[ 0+14293] ='b10110101;
           rom[ 0+14294] ='b00111000;
           rom[ 0+14295] ='b01111001;
           rom[ 0+14296] ='b11111110;
           rom[ 0+14297] ='b00000100;
           rom[ 0+14298] ='b11000010;
           rom[ 0+14299] ='b11100010;
           rom[ 0+14300] ='b00110111;
           rom[ 0+14301] ='b01111000;
           rom[ 0+14302] ='b10110111;
           rom[ 0+14303] ='b11001010;
           rom[ 0+14304] ='b00001110;
           rom[ 0+14305] ='b00111010;
           rom[ 0+14306] ='b11000011;
           rom[ 0+14307] ='b11111101;
           rom[ 0+14308] ='b00111011;
           rom[ 0+14309] ='b11010101;
           rom[ 0+14310] ='b00100001;
           rom[ 0+14311] ='b01010110;
           rom[ 0+14312] ='b00111101;
           rom[ 0+14313] ='b11100101;
           rom[ 0+14314] ='b11001101;
           rom[ 0+14315] ='b00001010;
           rom[ 0+14316] ='b00000010;
           rom[ 0+14317] ='b11110001;
           rom[ 0+14318] ='b11010001;
           rom[ 0+14319] ='b11000011;
           rom[ 0+14320] ='b00000111;
           rom[ 0+14321] ='b00111100;
           rom[ 0+14322] ='b11010101;
           rom[ 0+14323] ='b00100001;
           rom[ 0+14324] ='b01101010;
           rom[ 0+14325] ='b00111101;
           rom[ 0+14326] ='b11100101;
           rom[ 0+14327] ='b11001101;
           rom[ 0+14328] ='b00001010;
           rom[ 0+14329] ='b00000010;
           rom[ 0+14330] ='b11110001;
           rom[ 0+14331] ='b11010001;
           rom[ 0+14332] ='b11010101;
           rom[ 0+14333] ='b00100001;
           rom[ 0+14334] ='b10000010;
           rom[ 0+14335] ='b00111101;
           rom[ 0+14336] ='b11100101;
           rom[ 0+14337] ='b11001101;
           rom[ 0+14338] ='b00001010;
           rom[ 0+14339] ='b00000010;
           rom[ 0+14340] ='b11110001;
           rom[ 0+14341] ='b11010001;
           rom[ 0+14342] ='b00100001;
           rom[ 0+14343] ='b00000011;
           rom[ 0+14344] ='b10000100;
           rom[ 0+14345] ='b00011001;
           rom[ 0+14346] ='b01001101;
           rom[ 0+14347] ='b01000100;
           rom[ 0+14348] ='b00000011;
           rom[ 0+14349] ='b00000011;
           rom[ 0+14350] ='b00000011;
           rom[ 0+14351] ='b00000011;
           rom[ 0+14352] ='b01101001;
           rom[ 0+14353] ='b01100000;
           rom[ 0+14354] ='b01001110;
           rom[ 0+14355] ='b00100011;
           rom[ 0+14356] ='b01000110;
           rom[ 0+14357] ='b11010101;
           rom[ 0+14358] ='b11000101;
           rom[ 0+14359] ='b11001101;
           rom[ 0+14360] ='b10110001;
           rom[ 0+14361] ='b00010100;
           rom[ 0+14362] ='b11110001;
           rom[ 0+14363] ='b11010001;
           rom[ 0+14364] ='b11010101;
           rom[ 0+14365] ='b00100001;
           rom[ 0+14366] ='b10010101;
           rom[ 0+14367] ='b00111101;
           rom[ 0+14368] ='b11100101;
           rom[ 0+14369] ='b11001101;
           rom[ 0+14370] ='b00001010;
           rom[ 0+14371] ='b00000010;
           rom[ 0+14372] ='b11110001;
           rom[ 0+14373] ='b11010001;
           rom[ 0+14374] ='b00100001;
           rom[ 0+14375] ='b00000011;
           rom[ 0+14376] ='b10000100;
           rom[ 0+14377] ='b00011001;
           rom[ 0+14378] ='b01001101;
           rom[ 0+14379] ='b01000100;
           rom[ 0+14380] ='b01111001;
           rom[ 0+14381] ='b11000110;
           rom[ 0+14382] ='b00001010;
           rom[ 0+14383] ='b01001111;
           rom[ 0+14384] ='b01111000;
           rom[ 0+14385] ='b11001110;
           rom[ 0+14386] ='b00000000;
           rom[ 0+14387] ='b01000111;
           rom[ 0+14388] ='b00001010;
           rom[ 0+14389] ='b01001111;
           rom[ 0+14390] ='b11010101;
           rom[ 0+14391] ='b01111001;
           rom[ 0+14392] ='b11110101;
           rom[ 0+14393] ='b00110011;
           rom[ 0+14394] ='b11001101;
           rom[ 0+14395] ='b10011100;
           rom[ 0+14396] ='b00010100;
           rom[ 0+14397] ='b00110011;
           rom[ 0+14398] ='b11010001;
           rom[ 0+14399] ='b11010101;
           rom[ 0+14400] ='b00100001;
           rom[ 0+14401] ='b00000100;
           rom[ 0+14402] ='b00111101;
           rom[ 0+14403] ='b11100101;
           rom[ 0+14404] ='b11001101;
           rom[ 0+14405] ='b00001010;
           rom[ 0+14406] ='b00000010;
           rom[ 0+14407] ='b11110001;
           rom[ 0+14408] ='b11010001;
           rom[ 0+14409] ='b00100001;
           rom[ 0+14410] ='b00000011;
           rom[ 0+14411] ='b10000100;
           rom[ 0+14412] ='b00011001;
           rom[ 0+14413] ='b11011101;
           rom[ 0+14414] ='b01110101;
           rom[ 0+14415] ='b11110111;
           rom[ 0+14416] ='b11011101;
           rom[ 0+14417] ='b01110100;
           rom[ 0+14418] ='b11111000;
           rom[ 0+14419] ='b11011101;
           rom[ 0+14420] ='b01111110;
           rom[ 0+14421] ='b11110111;
           rom[ 0+14422] ='b11000110;
           rom[ 0+14423] ='b00000100;
           rom[ 0+14424] ='b01001111;
           rom[ 0+14425] ='b11011101;
           rom[ 0+14426] ='b01111110;
           rom[ 0+14427] ='b11111000;
           rom[ 0+14428] ='b11001110;
           rom[ 0+14429] ='b00000000;
           rom[ 0+14430] ='b01000111;
           rom[ 0+14431] ='b01101001;
           rom[ 0+14432] ='b01100000;
           rom[ 0+14433] ='b01001110;
           rom[ 0+14434] ='b00100011;
           rom[ 0+14435] ='b01000110;
           rom[ 0+14436] ='b00001011;
           rom[ 0+14437] ='b11010101;
           rom[ 0+14438] ='b01011001;
           rom[ 0+14439] ='b01010000;
           rom[ 0+14440] ='b01101011;
           rom[ 0+14441] ='b01100010;
           rom[ 0+14442] ='b00101001;
           rom[ 0+14443] ='b00101001;
           rom[ 0+14444] ='b00011001;
           rom[ 0+14445] ='b11010001;
           rom[ 0+14446] ='b11011101;
           rom[ 0+14447] ='b01110101;
           rom[ 0+14448] ='b11110101;
           rom[ 0+14449] ='b11011101;
           rom[ 0+14450] ='b01110100;
           rom[ 0+14451] ='b11110110;
           rom[ 0+14452] ='b00111110;
           rom[ 0+14453] ='b00000100;
           rom[ 0+14454] ='b11011101;
           rom[ 0+14455] ='b10010110;
           rom[ 0+14456] ='b11111100;
           rom[ 0+14457] ='b01001111;
           rom[ 0+14458] ='b00111110;
           rom[ 0+14459] ='b00000000;
           rom[ 0+14460] ='b11011101;
           rom[ 0+14461] ='b10011110;
           rom[ 0+14462] ='b11111101;
           rom[ 0+14463] ='b01000111;
           rom[ 0+14464] ='b11011101;
           rom[ 0+14465] ='b01111110;
           rom[ 0+14466] ='b11110101;
           rom[ 0+14467] ='b10000001;
           rom[ 0+14468] ='b01001111;
           rom[ 0+14469] ='b11011101;
           rom[ 0+14470] ='b01111110;
           rom[ 0+14471] ='b11110110;
           rom[ 0+14472] ='b10001000;
           rom[ 0+14473] ='b01000111;
           rom[ 0+14474] ='b00100001;
           rom[ 0+14475] ='b00110110;
           rom[ 0+14476] ='b10001000;
           rom[ 0+14477] ='b00001001;
           rom[ 0+14478] ='b11011101;
           rom[ 0+14479] ='b01110101;
           rom[ 0+14480] ='b11110101;
           rom[ 0+14481] ='b11011101;
           rom[ 0+14482] ='b01110100;
           rom[ 0+14483] ='b11110110;
           rom[ 0+14484] ='b01111110;
           rom[ 0+14485] ='b11011101;
           rom[ 0+14486] ='b01110111;
           rom[ 0+14487] ='b11110100;
           rom[ 0+14488] ='b11011101;
           rom[ 0+14489] ='b01111110;
           rom[ 0+14490] ='b11110111;
           rom[ 0+14491] ='b11000110;
           rom[ 0+14492] ='b00001010;
           rom[ 0+14493] ='b01000111;
           rom[ 0+14494] ='b11011101;
           rom[ 0+14495] ='b01111110;
           rom[ 0+14496] ='b11111000;
           rom[ 0+14497] ='b11001110;
           rom[ 0+14498] ='b00000000;
           rom[ 0+14499] ='b01001111;
           rom[ 0+14500] ='b01101000;
           rom[ 0+14501] ='b01100001;
           rom[ 0+14502] ='b01000110;
           rom[ 0+14503] ='b11011101;
           rom[ 0+14504] ='b01111110;
           rom[ 0+14505] ='b11110100;
           rom[ 0+14506] ='b10101000;
           rom[ 0+14507] ='b11011101;
           rom[ 0+14508] ='b01101110;
           rom[ 0+14509] ='b11110101;
           rom[ 0+14510] ='b11011101;
           rom[ 0+14511] ='b01100110;
           rom[ 0+14512] ='b11110110;
           rom[ 0+14513] ='b01110111;
           rom[ 0+14514] ='b11000011;
           rom[ 0+14515] ='b00000111;
           rom[ 0+14516] ='b00111100;
           rom[ 0+14517] ='b11010101;
           rom[ 0+14518] ='b00100001;
           rom[ 0+14519] ='b10101001;
           rom[ 0+14520] ='b00111101;
           rom[ 0+14521] ='b11100101;
           rom[ 0+14522] ='b11001101;
           rom[ 0+14523] ='b00001010;
           rom[ 0+14524] ='b00000010;
           rom[ 0+14525] ='b11110001;
           rom[ 0+14526] ='b11010001;
           rom[ 0+14527] ='b11010101;
           rom[ 0+14528] ='b00100001;
           rom[ 0+14529] ='b10000010;
           rom[ 0+14530] ='b00111101;
           rom[ 0+14531] ='b11100101;
           rom[ 0+14532] ='b11001101;
           rom[ 0+14533] ='b00001010;
           rom[ 0+14534] ='b00000010;
           rom[ 0+14535] ='b11110001;
           rom[ 0+14536] ='b11010001;
           rom[ 0+14537] ='b00100001;
           rom[ 0+14538] ='b00000011;
           rom[ 0+14539] ='b10000100;
           rom[ 0+14540] ='b00011001;
           rom[ 0+14541] ='b01001101;
           rom[ 0+14542] ='b01000100;
           rom[ 0+14543] ='b00000011;
           rom[ 0+14544] ='b00000011;
           rom[ 0+14545] ='b00000011;
           rom[ 0+14546] ='b00000011;
           rom[ 0+14547] ='b01101001;
           rom[ 0+14548] ='b01100000;
           rom[ 0+14549] ='b01001110;
           rom[ 0+14550] ='b00100011;
           rom[ 0+14551] ='b01000110;
           rom[ 0+14552] ='b11010101;
           rom[ 0+14553] ='b11000101;
           rom[ 0+14554] ='b11001101;
           rom[ 0+14555] ='b10110001;
           rom[ 0+14556] ='b00010100;
           rom[ 0+14557] ='b11110001;
           rom[ 0+14558] ='b11010001;
           rom[ 0+14559] ='b11010101;
           rom[ 0+14560] ='b00100001;
           rom[ 0+14561] ='b10010101;
           rom[ 0+14562] ='b00111101;
           rom[ 0+14563] ='b11100101;
           rom[ 0+14564] ='b11001101;
           rom[ 0+14565] ='b00001010;
           rom[ 0+14566] ='b00000010;
           rom[ 0+14567] ='b11110001;
           rom[ 0+14568] ='b11010001;
           rom[ 0+14569] ='b00100001;
           rom[ 0+14570] ='b00000011;
           rom[ 0+14571] ='b10000100;
           rom[ 0+14572] ='b00011001;
           rom[ 0+14573] ='b01001101;
           rom[ 0+14574] ='b01000100;
           rom[ 0+14575] ='b01111001;
           rom[ 0+14576] ='b11000110;
           rom[ 0+14577] ='b00001010;
           rom[ 0+14578] ='b01001111;
           rom[ 0+14579] ='b01111000;
           rom[ 0+14580] ='b11001110;
           rom[ 0+14581] ='b00000000;
           rom[ 0+14582] ='b01000111;
           rom[ 0+14583] ='b00001010;
           rom[ 0+14584] ='b01001111;
           rom[ 0+14585] ='b11010101;
           rom[ 0+14586] ='b01111001;
           rom[ 0+14587] ='b11110101;
           rom[ 0+14588] ='b00110011;
           rom[ 0+14589] ='b11001101;
           rom[ 0+14590] ='b10011100;
           rom[ 0+14591] ='b00010100;
           rom[ 0+14592] ='b00110011;
           rom[ 0+14593] ='b11010001;
           rom[ 0+14594] ='b11010101;
           rom[ 0+14595] ='b00100001;
           rom[ 0+14596] ='b11000001;
           rom[ 0+14597] ='b00111101;
           rom[ 0+14598] ='b11100101;
           rom[ 0+14599] ='b11001101;
           rom[ 0+14600] ='b00001010;
           rom[ 0+14601] ='b00000010;
           rom[ 0+14602] ='b11110001;
           rom[ 0+14603] ='b11010001;
           rom[ 0+14604] ='b00100001;
           rom[ 0+14605] ='b00000011;
           rom[ 0+14606] ='b10000100;
           rom[ 0+14607] ='b00011001;
           rom[ 0+14608] ='b01001101;
           rom[ 0+14609] ='b01000100;
           rom[ 0+14610] ='b01111001;
           rom[ 0+14611] ='b11000110;
           rom[ 0+14612] ='b00000110;
           rom[ 0+14613] ='b01001111;
           rom[ 0+14614] ='b01111000;
           rom[ 0+14615] ='b11001110;
           rom[ 0+14616] ='b00000000;
           rom[ 0+14617] ='b01000111;
           rom[ 0+14618] ='b01101001;
           rom[ 0+14619] ='b01100000;
           rom[ 0+14620] ='b01001110;
           rom[ 0+14621] ='b00100011;
           rom[ 0+14622] ='b01000110;
           rom[ 0+14623] ='b11010101;
           rom[ 0+14624] ='b11000101;
           rom[ 0+14625] ='b11001101;
           rom[ 0+14626] ='b10110001;
           rom[ 0+14627] ='b00010100;
           rom[ 0+14628] ='b11110001;
           rom[ 0+14629] ='b11010001;
           rom[ 0+14630] ='b11010101;
           rom[ 0+14631] ='b00100001;
           rom[ 0+14632] ='b10010101;
           rom[ 0+14633] ='b00111101;
           rom[ 0+14634] ='b11100101;
           rom[ 0+14635] ='b11001101;
           rom[ 0+14636] ='b00001010;
           rom[ 0+14637] ='b00000010;
           rom[ 0+14638] ='b11110001;
           rom[ 0+14639] ='b11010001;
           rom[ 0+14640] ='b00100001;
           rom[ 0+14641] ='b00000011;
           rom[ 0+14642] ='b10000100;
           rom[ 0+14643] ='b00011001;
           rom[ 0+14644] ='b01001101;
           rom[ 0+14645] ='b01000100;
           rom[ 0+14646] ='b01111001;
           rom[ 0+14647] ='b11000110;
           rom[ 0+14648] ='b00001011;
           rom[ 0+14649] ='b01001111;
           rom[ 0+14650] ='b01111000;
           rom[ 0+14651] ='b11001110;
           rom[ 0+14652] ='b00000000;
           rom[ 0+14653] ='b01000111;
           rom[ 0+14654] ='b00001010;
           rom[ 0+14655] ='b01001111;
           rom[ 0+14656] ='b11010101;
           rom[ 0+14657] ='b01111001;
           rom[ 0+14658] ='b11110101;
           rom[ 0+14659] ='b00110011;
           rom[ 0+14660] ='b11001101;
           rom[ 0+14661] ='b10011100;
           rom[ 0+14662] ='b00010100;
           rom[ 0+14663] ='b00110011;
           rom[ 0+14664] ='b11010001;
           rom[ 0+14665] ='b11010101;
           rom[ 0+14666] ='b00100001;
           rom[ 0+14667] ='b00000100;
           rom[ 0+14668] ='b00111101;
           rom[ 0+14669] ='b11100101;
           rom[ 0+14670] ='b11001101;
           rom[ 0+14671] ='b00001010;
           rom[ 0+14672] ='b00000010;
           rom[ 0+14673] ='b11110001;
           rom[ 0+14674] ='b11010001;
           rom[ 0+14675] ='b00100001;
           rom[ 0+14676] ='b00000011;
           rom[ 0+14677] ='b10000100;
           rom[ 0+14678] ='b00011001;
           rom[ 0+14679] ='b11011101;
           rom[ 0+14680] ='b01110101;
           rom[ 0+14681] ='b11110101;
           rom[ 0+14682] ='b11011101;
           rom[ 0+14683] ='b01110100;
           rom[ 0+14684] ='b11110110;
           rom[ 0+14685] ='b11011101;
           rom[ 0+14686] ='b01111110;
           rom[ 0+14687] ='b11110101;
           rom[ 0+14688] ='b11000110;
           rom[ 0+14689] ='b00000100;
           rom[ 0+14690] ='b01001111;
           rom[ 0+14691] ='b11011101;
           rom[ 0+14692] ='b01111110;
           rom[ 0+14693] ='b11110110;
           rom[ 0+14694] ='b11001110;
           rom[ 0+14695] ='b00000000;
           rom[ 0+14696] ='b01000111;
           rom[ 0+14697] ='b01101001;
           rom[ 0+14698] ='b01100000;
           rom[ 0+14699] ='b01001110;
           rom[ 0+14700] ='b00100011;
           rom[ 0+14701] ='b01000110;
           rom[ 0+14702] ='b00001011;
           rom[ 0+14703] ='b11010101;
           rom[ 0+14704] ='b01011001;
           rom[ 0+14705] ='b01010000;
           rom[ 0+14706] ='b01101011;
           rom[ 0+14707] ='b01100010;
           rom[ 0+14708] ='b00101001;
           rom[ 0+14709] ='b00101001;
           rom[ 0+14710] ='b00011001;
           rom[ 0+14711] ='b11010001;
           rom[ 0+14712] ='b01001101;
           rom[ 0+14713] ='b01000100;
           rom[ 0+14714] ='b00111110;
           rom[ 0+14715] ='b00000100;
           rom[ 0+14716] ='b11011101;
           rom[ 0+14717] ='b10010110;
           rom[ 0+14718] ='b11111100;
           rom[ 0+14719] ='b11011101;
           rom[ 0+14720] ='b01110111;
           rom[ 0+14721] ='b11110010;
           rom[ 0+14722] ='b00111110;
           rom[ 0+14723] ='b00000000;
           rom[ 0+14724] ='b11011101;
           rom[ 0+14725] ='b10011110;
           rom[ 0+14726] ='b11111101;
           rom[ 0+14727] ='b11011101;
           rom[ 0+14728] ='b01110111;
           rom[ 0+14729] ='b11110011;
           rom[ 0+14730] ='b01111001;
           rom[ 0+14731] ='b11011101;
           rom[ 0+14732] ='b10000110;
           rom[ 0+14733] ='b11110010;
           rom[ 0+14734] ='b01001111;
           rom[ 0+14735] ='b01111000;
           rom[ 0+14736] ='b11011101;
           rom[ 0+14737] ='b10001110;
           rom[ 0+14738] ='b11110011;
           rom[ 0+14739] ='b01000111;
           rom[ 0+14740] ='b00100001;
           rom[ 0+14741] ='b00110110;
           rom[ 0+14742] ='b10001000;
           rom[ 0+14743] ='b00001001;
           rom[ 0+14744] ='b11011101;
           rom[ 0+14745] ='b01110101;
           rom[ 0+14746] ='b11110111;
           rom[ 0+14747] ='b11011101;
           rom[ 0+14748] ='b01110100;
           rom[ 0+14749] ='b11111000;
           rom[ 0+14750] ='b01111110;
           rom[ 0+14751] ='b11011101;
           rom[ 0+14752] ='b01110111;
           rom[ 0+14753] ='b11110100;
           rom[ 0+14754] ='b11011101;
           rom[ 0+14755] ='b01111110;
           rom[ 0+14756] ='b11110101;
           rom[ 0+14757] ='b11000110;
           rom[ 0+14758] ='b00001010;
           rom[ 0+14759] ='b01000111;
           rom[ 0+14760] ='b11011101;
           rom[ 0+14761] ='b01111110;
           rom[ 0+14762] ='b11110110;
           rom[ 0+14763] ='b11001110;
           rom[ 0+14764] ='b00000000;
           rom[ 0+14765] ='b01001111;
           rom[ 0+14766] ='b01101000;
           rom[ 0+14767] ='b01100001;
           rom[ 0+14768] ='b01000110;
           rom[ 0+14769] ='b11011101;
           rom[ 0+14770] ='b01111110;
           rom[ 0+14771] ='b11110100;
           rom[ 0+14772] ='b10101000;
           rom[ 0+14773] ='b11011101;
           rom[ 0+14774] ='b01101110;
           rom[ 0+14775] ='b11110111;
           rom[ 0+14776] ='b11011101;
           rom[ 0+14777] ='b01100110;
           rom[ 0+14778] ='b11111000;
           rom[ 0+14779] ='b01110111;
           rom[ 0+14780] ='b11011101;
           rom[ 0+14781] ='b01111110;
           rom[ 0+14782] ='b11110101;
           rom[ 0+14783] ='b11000110;
           rom[ 0+14784] ='b00000110;
           rom[ 0+14785] ='b01001111;
           rom[ 0+14786] ='b11011101;
           rom[ 0+14787] ='b01111110;
           rom[ 0+14788] ='b11110110;
           rom[ 0+14789] ='b11001110;
           rom[ 0+14790] ='b00000000;
           rom[ 0+14791] ='b01000111;
           rom[ 0+14792] ='b01101001;
           rom[ 0+14793] ='b01100000;
           rom[ 0+14794] ='b01001110;
           rom[ 0+14795] ='b00100011;
           rom[ 0+14796] ='b01000110;
           rom[ 0+14797] ='b00001011;
           rom[ 0+14798] ='b11010101;
           rom[ 0+14799] ='b01011001;
           rom[ 0+14800] ='b01010000;
           rom[ 0+14801] ='b01101011;
           rom[ 0+14802] ='b01100010;
           rom[ 0+14803] ='b00101001;
           rom[ 0+14804] ='b00101001;
           rom[ 0+14805] ='b00011001;
           rom[ 0+14806] ='b11010001;
           rom[ 0+14807] ='b01001101;
           rom[ 0+14808] ='b01000100;
           rom[ 0+14809] ='b01111001;
           rom[ 0+14810] ='b11011101;
           rom[ 0+14811] ='b10000110;
           rom[ 0+14812] ='b11110010;
           rom[ 0+14813] ='b01001111;
           rom[ 0+14814] ='b01111000;
           rom[ 0+14815] ='b11011101;
           rom[ 0+14816] ='b10001110;
           rom[ 0+14817] ='b11110011;
           rom[ 0+14818] ='b01000111;
           rom[ 0+14819] ='b00100001;
           rom[ 0+14820] ='b00110110;
           rom[ 0+14821] ='b10001000;
           rom[ 0+14822] ='b00001001;
           rom[ 0+14823] ='b11011101;
           rom[ 0+14824] ='b01110101;
           rom[ 0+14825] ='b11110010;
           rom[ 0+14826] ='b11011101;
           rom[ 0+14827] ='b01110100;
           rom[ 0+14828] ='b11110011;
           rom[ 0+14829] ='b01111110;
           rom[ 0+14830] ='b11011101;
           rom[ 0+14831] ='b01110111;
           rom[ 0+14832] ='b11110100;
           rom[ 0+14833] ='b11011101;
           rom[ 0+14834] ='b01111110;
           rom[ 0+14835] ='b11110101;
           rom[ 0+14836] ='b11000110;
           rom[ 0+14837] ='b00001011;
           rom[ 0+14838] ='b01000111;
           rom[ 0+14839] ='b11011101;
           rom[ 0+14840] ='b01111110;
           rom[ 0+14841] ='b11110110;
           rom[ 0+14842] ='b11001110;
           rom[ 0+14843] ='b00000000;
           rom[ 0+14844] ='b01001111;
           rom[ 0+14845] ='b01101000;
           rom[ 0+14846] ='b01100001;
           rom[ 0+14847] ='b01000110;
           rom[ 0+14848] ='b11011101;
           rom[ 0+14849] ='b01111110;
           rom[ 0+14850] ='b11110100;
           rom[ 0+14851] ='b10101000;
           rom[ 0+14852] ='b11011101;
           rom[ 0+14853] ='b01101110;
           rom[ 0+14854] ='b11110010;
           rom[ 0+14855] ='b11011101;
           rom[ 0+14856] ='b01100110;
           rom[ 0+14857] ='b11110011;
           rom[ 0+14858] ='b01110111;
           rom[ 0+14859] ='b11000011;
           rom[ 0+14860] ='b00000111;
           rom[ 0+14861] ='b00111100;
           rom[ 0+14862] ='b11010101;
           rom[ 0+14863] ='b00100001;
           rom[ 0+14864] ='b11010101;
           rom[ 0+14865] ='b00111101;
           rom[ 0+14866] ='b11100101;
           rom[ 0+14867] ='b11001101;
           rom[ 0+14868] ='b00001010;
           rom[ 0+14869] ='b00000010;
           rom[ 0+14870] ='b11110001;
           rom[ 0+14871] ='b11010001;
           rom[ 0+14872] ='b11010101;
           rom[ 0+14873] ='b00100001;
           rom[ 0+14874] ='b10000010;
           rom[ 0+14875] ='b00111101;
           rom[ 0+14876] ='b11100101;
           rom[ 0+14877] ='b11001101;
           rom[ 0+14878] ='b00001010;
           rom[ 0+14879] ='b00000010;
           rom[ 0+14880] ='b11110001;
           rom[ 0+14881] ='b11010001;
           rom[ 0+14882] ='b00100001;
           rom[ 0+14883] ='b00000011;
           rom[ 0+14884] ='b10000100;
           rom[ 0+14885] ='b00011001;
           rom[ 0+14886] ='b01001101;
           rom[ 0+14887] ='b01000100;
           rom[ 0+14888] ='b00000011;
           rom[ 0+14889] ='b00000011;
           rom[ 0+14890] ='b00000011;
           rom[ 0+14891] ='b00000011;
           rom[ 0+14892] ='b01101001;
           rom[ 0+14893] ='b01100000;
           rom[ 0+14894] ='b01001110;
           rom[ 0+14895] ='b00100011;
           rom[ 0+14896] ='b01000110;
           rom[ 0+14897] ='b11010101;
           rom[ 0+14898] ='b11000101;
           rom[ 0+14899] ='b11001101;
           rom[ 0+14900] ='b10110001;
           rom[ 0+14901] ='b00010100;
           rom[ 0+14902] ='b11110001;
           rom[ 0+14903] ='b11010001;
           rom[ 0+14904] ='b11010101;
           rom[ 0+14905] ='b00100001;
           rom[ 0+14906] ='b10010101;
           rom[ 0+14907] ='b00111101;
           rom[ 0+14908] ='b11100101;
           rom[ 0+14909] ='b11001101;
           rom[ 0+14910] ='b00001010;
           rom[ 0+14911] ='b00000010;
           rom[ 0+14912] ='b11110001;
           rom[ 0+14913] ='b11010001;
           rom[ 0+14914] ='b00100001;
           rom[ 0+14915] ='b00000011;
           rom[ 0+14916] ='b10000100;
           rom[ 0+14917] ='b00011001;
           rom[ 0+14918] ='b01001101;
           rom[ 0+14919] ='b01000100;
           rom[ 0+14920] ='b01111001;
           rom[ 0+14921] ='b11000110;
           rom[ 0+14922] ='b00001010;
           rom[ 0+14923] ='b01001111;
           rom[ 0+14924] ='b01111000;
           rom[ 0+14925] ='b11001110;
           rom[ 0+14926] ='b00000000;
           rom[ 0+14927] ='b01000111;
           rom[ 0+14928] ='b00001010;
           rom[ 0+14929] ='b01001111;
           rom[ 0+14930] ='b11010101;
           rom[ 0+14931] ='b01111001;
           rom[ 0+14932] ='b11110101;
           rom[ 0+14933] ='b00110011;
           rom[ 0+14934] ='b11001101;
           rom[ 0+14935] ='b10011100;
           rom[ 0+14936] ='b00010100;
           rom[ 0+14937] ='b00110011;
           rom[ 0+14938] ='b11010001;
           rom[ 0+14939] ='b11010101;
           rom[ 0+14940] ='b00100001;
           rom[ 0+14941] ='b11000001;
           rom[ 0+14942] ='b00111101;
           rom[ 0+14943] ='b11100101;
           rom[ 0+14944] ='b11001101;
           rom[ 0+14945] ='b00001010;
           rom[ 0+14946] ='b00000010;
           rom[ 0+14947] ='b11110001;
           rom[ 0+14948] ='b11010001;
           rom[ 0+14949] ='b00100001;
           rom[ 0+14950] ='b00000011;
           rom[ 0+14951] ='b10000100;
           rom[ 0+14952] ='b00011001;
           rom[ 0+14953] ='b01001101;
           rom[ 0+14954] ='b01000100;
           rom[ 0+14955] ='b01111001;
           rom[ 0+14956] ='b11000110;
           rom[ 0+14957] ='b00000110;
           rom[ 0+14958] ='b01001111;
           rom[ 0+14959] ='b01111000;
           rom[ 0+14960] ='b11001110;
           rom[ 0+14961] ='b00000000;
           rom[ 0+14962] ='b01000111;
           rom[ 0+14963] ='b01101001;
           rom[ 0+14964] ='b01100000;
           rom[ 0+14965] ='b01001110;
           rom[ 0+14966] ='b00100011;
           rom[ 0+14967] ='b01000110;
           rom[ 0+14968] ='b11010101;
           rom[ 0+14969] ='b11000101;
           rom[ 0+14970] ='b11001101;
           rom[ 0+14971] ='b10110001;
           rom[ 0+14972] ='b00010100;
           rom[ 0+14973] ='b11110001;
           rom[ 0+14974] ='b11010001;
           rom[ 0+14975] ='b11010101;
           rom[ 0+14976] ='b00100001;
           rom[ 0+14977] ='b10010101;
           rom[ 0+14978] ='b00111101;
           rom[ 0+14979] ='b11100101;
           rom[ 0+14980] ='b11001101;
           rom[ 0+14981] ='b00001010;
           rom[ 0+14982] ='b00000010;
           rom[ 0+14983] ='b11110001;
           rom[ 0+14984] ='b11010001;
           rom[ 0+14985] ='b00100001;
           rom[ 0+14986] ='b00000011;
           rom[ 0+14987] ='b10000100;
           rom[ 0+14988] ='b00011001;
           rom[ 0+14989] ='b01001101;
           rom[ 0+14990] ='b01000100;
           rom[ 0+14991] ='b01111001;
           rom[ 0+14992] ='b11000110;
           rom[ 0+14993] ='b00001011;
           rom[ 0+14994] ='b01001111;
           rom[ 0+14995] ='b01111000;
           rom[ 0+14996] ='b11001110;
           rom[ 0+14997] ='b00000000;
           rom[ 0+14998] ='b01000111;
           rom[ 0+14999] ='b00001010;
           rom[ 0+15000] ='b01001111;
           rom[ 0+15001] ='b11010101;
           rom[ 0+15002] ='b01111001;
           rom[ 0+15003] ='b11110101;
           rom[ 0+15004] ='b00110011;
           rom[ 0+15005] ='b11001101;
           rom[ 0+15006] ='b10011100;
           rom[ 0+15007] ='b00010100;
           rom[ 0+15008] ='b00110011;
           rom[ 0+15009] ='b11010001;
           rom[ 0+15010] ='b11010101;
           rom[ 0+15011] ='b00100001;
           rom[ 0+15012] ='b11000001;
           rom[ 0+15013] ='b00111101;
           rom[ 0+15014] ='b11100101;
           rom[ 0+15015] ='b11001101;
           rom[ 0+15016] ='b00001010;
           rom[ 0+15017] ='b00000010;
           rom[ 0+15018] ='b11110001;
           rom[ 0+15019] ='b11010001;
           rom[ 0+15020] ='b00100001;
           rom[ 0+15021] ='b00000011;
           rom[ 0+15022] ='b10000100;
           rom[ 0+15023] ='b00011001;
           rom[ 0+15024] ='b01001101;
           rom[ 0+15025] ='b01000100;
           rom[ 0+15026] ='b01111001;
           rom[ 0+15027] ='b11000110;
           rom[ 0+15028] ='b00001000;
           rom[ 0+15029] ='b01001111;
           rom[ 0+15030] ='b01111000;
           rom[ 0+15031] ='b11001110;
           rom[ 0+15032] ='b00000000;
           rom[ 0+15033] ='b01000111;
           rom[ 0+15034] ='b01101001;
           rom[ 0+15035] ='b01100000;
           rom[ 0+15036] ='b01001110;
           rom[ 0+15037] ='b00100011;
           rom[ 0+15038] ='b01000110;
           rom[ 0+15039] ='b11010101;
           rom[ 0+15040] ='b11000101;
           rom[ 0+15041] ='b11001101;
           rom[ 0+15042] ='b10110001;
           rom[ 0+15043] ='b00010100;
           rom[ 0+15044] ='b11110001;
           rom[ 0+15045] ='b11010001;
           rom[ 0+15046] ='b11010101;
           rom[ 0+15047] ='b00100001;
           rom[ 0+15048] ='b10010101;
           rom[ 0+15049] ='b00111101;
           rom[ 0+15050] ='b11100101;
           rom[ 0+15051] ='b11001101;
           rom[ 0+15052] ='b00001010;
           rom[ 0+15053] ='b00000010;
           rom[ 0+15054] ='b11110001;
           rom[ 0+15055] ='b11010001;
           rom[ 0+15056] ='b00100001;
           rom[ 0+15057] ='b00000011;
           rom[ 0+15058] ='b10000100;
           rom[ 0+15059] ='b00011001;
           rom[ 0+15060] ='b01001101;
           rom[ 0+15061] ='b01000100;
           rom[ 0+15062] ='b01111001;
           rom[ 0+15063] ='b11000110;
           rom[ 0+15064] ='b00001100;
           rom[ 0+15065] ='b01001111;
           rom[ 0+15066] ='b01111000;
           rom[ 0+15067] ='b11001110;
           rom[ 0+15068] ='b00000000;
           rom[ 0+15069] ='b01000111;
           rom[ 0+15070] ='b00001010;
           rom[ 0+15071] ='b01001111;
           rom[ 0+15072] ='b11010101;
           rom[ 0+15073] ='b01111001;
           rom[ 0+15074] ='b11110101;
           rom[ 0+15075] ='b00110011;
           rom[ 0+15076] ='b11001101;
           rom[ 0+15077] ='b10011100;
           rom[ 0+15078] ='b00010100;
           rom[ 0+15079] ='b00110011;
           rom[ 0+15080] ='b11010001;
           rom[ 0+15081] ='b11010101;
           rom[ 0+15082] ='b00100001;
           rom[ 0+15083] ='b00000100;
           rom[ 0+15084] ='b00111101;
           rom[ 0+15085] ='b11100101;
           rom[ 0+15086] ='b11001101;
           rom[ 0+15087] ='b00001010;
           rom[ 0+15088] ='b00000010;
           rom[ 0+15089] ='b11110001;
           rom[ 0+15090] ='b11010001;
           rom[ 0+15091] ='b00100001;
           rom[ 0+15092] ='b00000011;
           rom[ 0+15093] ='b10000100;
           rom[ 0+15094] ='b00011001;
           rom[ 0+15095] ='b11011101;
           rom[ 0+15096] ='b01110101;
           rom[ 0+15097] ='b11110010;
           rom[ 0+15098] ='b11011101;
           rom[ 0+15099] ='b01110100;
           rom[ 0+15100] ='b11110011;
           rom[ 0+15101] ='b11011101;
           rom[ 0+15102] ='b01111110;
           rom[ 0+15103] ='b11110010;
           rom[ 0+15104] ='b11000110;
           rom[ 0+15105] ='b00000100;
           rom[ 0+15106] ='b01001111;
           rom[ 0+15107] ='b11011101;
           rom[ 0+15108] ='b01111110;
           rom[ 0+15109] ='b11110011;
           rom[ 0+15110] ='b11001110;
           rom[ 0+15111] ='b00000000;
           rom[ 0+15112] ='b01000111;
           rom[ 0+15113] ='b01101001;
           rom[ 0+15114] ='b01100000;
           rom[ 0+15115] ='b01001110;
           rom[ 0+15116] ='b00100011;
           rom[ 0+15117] ='b01000110;
           rom[ 0+15118] ='b00001011;
           rom[ 0+15119] ='b11010101;
           rom[ 0+15120] ='b01011001;
           rom[ 0+15121] ='b01010000;
           rom[ 0+15122] ='b01101011;
           rom[ 0+15123] ='b01100010;
           rom[ 0+15124] ='b00101001;
           rom[ 0+15125] ='b00101001;
           rom[ 0+15126] ='b00011001;
           rom[ 0+15127] ='b11010001;
           rom[ 0+15128] ='b01001101;
           rom[ 0+15129] ='b01000100;
           rom[ 0+15130] ='b00111110;
           rom[ 0+15131] ='b00000100;
           rom[ 0+15132] ='b11011101;
           rom[ 0+15133] ='b10010110;
           rom[ 0+15134] ='b11111100;
           rom[ 0+15135] ='b11011101;
           rom[ 0+15136] ='b01110111;
           rom[ 0+15137] ='b11110111;
           rom[ 0+15138] ='b00111110;
           rom[ 0+15139] ='b00000000;
           rom[ 0+15140] ='b11011101;
           rom[ 0+15141] ='b10011110;
           rom[ 0+15142] ='b11111101;
           rom[ 0+15143] ='b11011101;
           rom[ 0+15144] ='b01110111;
           rom[ 0+15145] ='b11111000;
           rom[ 0+15146] ='b01111001;
           rom[ 0+15147] ='b11011101;
           rom[ 0+15148] ='b10000110;
           rom[ 0+15149] ='b11110111;
           rom[ 0+15150] ='b01001111;
           rom[ 0+15151] ='b01111000;
           rom[ 0+15152] ='b11011101;
           rom[ 0+15153] ='b10001110;
           rom[ 0+15154] ='b11111000;
           rom[ 0+15155] ='b01000111;
           rom[ 0+15156] ='b00100001;
           rom[ 0+15157] ='b00110110;
           rom[ 0+15158] ='b10001000;
           rom[ 0+15159] ='b00001001;
           rom[ 0+15160] ='b11011101;
           rom[ 0+15161] ='b01110101;
           rom[ 0+15162] ='b11110101;
           rom[ 0+15163] ='b11011101;
           rom[ 0+15164] ='b01110100;
           rom[ 0+15165] ='b11110110;
           rom[ 0+15166] ='b01111110;
           rom[ 0+15167] ='b11011101;
           rom[ 0+15168] ='b01110111;
           rom[ 0+15169] ='b11110100;
           rom[ 0+15170] ='b11011101;
           rom[ 0+15171] ='b01111110;
           rom[ 0+15172] ='b11110010;
           rom[ 0+15173] ='b11000110;
           rom[ 0+15174] ='b00001010;
           rom[ 0+15175] ='b01000111;
           rom[ 0+15176] ='b11011101;
           rom[ 0+15177] ='b01111110;
           rom[ 0+15178] ='b11110011;
           rom[ 0+15179] ='b11001110;
           rom[ 0+15180] ='b00000000;
           rom[ 0+15181] ='b01001111;
           rom[ 0+15182] ='b01101000;
           rom[ 0+15183] ='b01100001;
           rom[ 0+15184] ='b01000110;
           rom[ 0+15185] ='b11011101;
           rom[ 0+15186] ='b01111110;
           rom[ 0+15187] ='b11110100;
           rom[ 0+15188] ='b10101000;
           rom[ 0+15189] ='b11011101;
           rom[ 0+15190] ='b01101110;
           rom[ 0+15191] ='b11110101;
           rom[ 0+15192] ='b11011101;
           rom[ 0+15193] ='b01100110;
           rom[ 0+15194] ='b11110110;
           rom[ 0+15195] ='b01110111;
           rom[ 0+15196] ='b11011101;
           rom[ 0+15197] ='b01111110;
           rom[ 0+15198] ='b11110010;
           rom[ 0+15199] ='b11000110;
           rom[ 0+15200] ='b00000110;
           rom[ 0+15201] ='b01001111;
           rom[ 0+15202] ='b11011101;
           rom[ 0+15203] ='b01111110;
           rom[ 0+15204] ='b11110011;
           rom[ 0+15205] ='b11001110;
           rom[ 0+15206] ='b00000000;
           rom[ 0+15207] ='b01000111;
           rom[ 0+15208] ='b01101001;
           rom[ 0+15209] ='b01100000;
           rom[ 0+15210] ='b01001110;
           rom[ 0+15211] ='b00100011;
           rom[ 0+15212] ='b01000110;
           rom[ 0+15213] ='b00001011;
           rom[ 0+15214] ='b11010101;
           rom[ 0+15215] ='b01011001;
           rom[ 0+15216] ='b01010000;
           rom[ 0+15217] ='b01101011;
           rom[ 0+15218] ='b01100010;
           rom[ 0+15219] ='b00101001;
           rom[ 0+15220] ='b00101001;
           rom[ 0+15221] ='b00011001;
           rom[ 0+15222] ='b11010001;
           rom[ 0+15223] ='b01001101;
           rom[ 0+15224] ='b01000100;
           rom[ 0+15225] ='b01111001;
           rom[ 0+15226] ='b11011101;
           rom[ 0+15227] ='b10000110;
           rom[ 0+15228] ='b11110111;
           rom[ 0+15229] ='b01001111;
           rom[ 0+15230] ='b01111000;
           rom[ 0+15231] ='b11011101;
           rom[ 0+15232] ='b10001110;
           rom[ 0+15233] ='b11111000;
           rom[ 0+15234] ='b01000111;
           rom[ 0+15235] ='b00100001;
           rom[ 0+15236] ='b00110110;
           rom[ 0+15237] ='b10001000;
           rom[ 0+15238] ='b00001001;
           rom[ 0+15239] ='b11011101;
           rom[ 0+15240] ='b01110101;
           rom[ 0+15241] ='b11110101;
           rom[ 0+15242] ='b11011101;
           rom[ 0+15243] ='b01110100;
           rom[ 0+15244] ='b11110110;
           rom[ 0+15245] ='b01111110;
           rom[ 0+15246] ='b11011101;
           rom[ 0+15247] ='b01110111;
           rom[ 0+15248] ='b11110100;
           rom[ 0+15249] ='b11011101;
           rom[ 0+15250] ='b01111110;
           rom[ 0+15251] ='b11110010;
           rom[ 0+15252] ='b11000110;
           rom[ 0+15253] ='b00001011;
           rom[ 0+15254] ='b01000111;
           rom[ 0+15255] ='b11011101;
           rom[ 0+15256] ='b01111110;
           rom[ 0+15257] ='b11110011;
           rom[ 0+15258] ='b11001110;
           rom[ 0+15259] ='b00000000;
           rom[ 0+15260] ='b01001111;
           rom[ 0+15261] ='b01101000;
           rom[ 0+15262] ='b01100001;
           rom[ 0+15263] ='b01000110;
           rom[ 0+15264] ='b11011101;
           rom[ 0+15265] ='b01111110;
           rom[ 0+15266] ='b11110100;
           rom[ 0+15267] ='b10101000;
           rom[ 0+15268] ='b11011101;
           rom[ 0+15269] ='b01101110;
           rom[ 0+15270] ='b11110101;
           rom[ 0+15271] ='b11011101;
           rom[ 0+15272] ='b01100110;
           rom[ 0+15273] ='b11110110;
           rom[ 0+15274] ='b01110111;
           rom[ 0+15275] ='b11011101;
           rom[ 0+15276] ='b01111110;
           rom[ 0+15277] ='b11110010;
           rom[ 0+15278] ='b11000110;
           rom[ 0+15279] ='b00001000;
           rom[ 0+15280] ='b01001111;
           rom[ 0+15281] ='b11011101;
           rom[ 0+15282] ='b01111110;
           rom[ 0+15283] ='b11110011;
           rom[ 0+15284] ='b11001110;
           rom[ 0+15285] ='b00000000;
           rom[ 0+15286] ='b01000111;
           rom[ 0+15287] ='b01101001;
           rom[ 0+15288] ='b01100000;
           rom[ 0+15289] ='b01001110;
           rom[ 0+15290] ='b00100011;
           rom[ 0+15291] ='b01000110;
           rom[ 0+15292] ='b00001011;
           rom[ 0+15293] ='b11010101;
           rom[ 0+15294] ='b01011001;
           rom[ 0+15295] ='b01010000;
           rom[ 0+15296] ='b01101011;
           rom[ 0+15297] ='b01100010;
           rom[ 0+15298] ='b00101001;
           rom[ 0+15299] ='b00101001;
           rom[ 0+15300] ='b00011001;
           rom[ 0+15301] ='b11010001;
           rom[ 0+15302] ='b01001101;
           rom[ 0+15303] ='b01000100;
           rom[ 0+15304] ='b01111001;
           rom[ 0+15305] ='b11011101;
           rom[ 0+15306] ='b10000110;
           rom[ 0+15307] ='b11110111;
           rom[ 0+15308] ='b01001111;
           rom[ 0+15309] ='b01111000;
           rom[ 0+15310] ='b11011101;
           rom[ 0+15311] ='b10001110;
           rom[ 0+15312] ='b11111000;
           rom[ 0+15313] ='b01000111;
           rom[ 0+15314] ='b00100001;
           rom[ 0+15315] ='b00110110;
           rom[ 0+15316] ='b10001000;
           rom[ 0+15317] ='b00001001;
           rom[ 0+15318] ='b11011101;
           rom[ 0+15319] ='b01110101;
           rom[ 0+15320] ='b11110101;
           rom[ 0+15321] ='b11011101;
           rom[ 0+15322] ='b01110100;
           rom[ 0+15323] ='b11110110;
           rom[ 0+15324] ='b01111110;
           rom[ 0+15325] ='b11011101;
           rom[ 0+15326] ='b01110111;
           rom[ 0+15327] ='b11110100;
           rom[ 0+15328] ='b11011101;
           rom[ 0+15329] ='b01111110;
           rom[ 0+15330] ='b11110010;
           rom[ 0+15331] ='b11000110;
           rom[ 0+15332] ='b00001100;
           rom[ 0+15333] ='b01000111;
           rom[ 0+15334] ='b11011101;
           rom[ 0+15335] ='b01111110;
           rom[ 0+15336] ='b11110011;
           rom[ 0+15337] ='b11001110;
           rom[ 0+15338] ='b00000000;
           rom[ 0+15339] ='b01001111;
           rom[ 0+15340] ='b01101000;
           rom[ 0+15341] ='b01100001;
           rom[ 0+15342] ='b01000110;
           rom[ 0+15343] ='b11011101;
           rom[ 0+15344] ='b01111110;
           rom[ 0+15345] ='b11110100;
           rom[ 0+15346] ='b10101000;
           rom[ 0+15347] ='b11011101;
           rom[ 0+15348] ='b01101110;
           rom[ 0+15349] ='b11110101;
           rom[ 0+15350] ='b11011101;
           rom[ 0+15351] ='b01100110;
           rom[ 0+15352] ='b11110110;
           rom[ 0+15353] ='b01110111;
           rom[ 0+15354] ='b11000011;
           rom[ 0+15355] ='b00000111;
           rom[ 0+15356] ='b00111100;
           rom[ 0+15357] ='b11010101;
           rom[ 0+15358] ='b00100001;
           rom[ 0+15359] ='b11101110;
           rom[ 0+15360] ='b00111101;
           rom[ 0+15361] ='b11100101;
           rom[ 0+15362] ='b11001101;
           rom[ 0+15363] ='b00001010;
           rom[ 0+15364] ='b00000010;
           rom[ 0+15365] ='b11110001;
           rom[ 0+15366] ='b11010001;
           rom[ 0+15367] ='b11011101;
           rom[ 0+15368] ='b00110100;
           rom[ 0+15369] ='b11111100;
           rom[ 0+15370] ='b11000010;
           rom[ 0+15371] ='b00010000;
           rom[ 0+15372] ='b00111100;
           rom[ 0+15373] ='b11011101;
           rom[ 0+15374] ='b00110100;
           rom[ 0+15375] ='b11111101;
           rom[ 0+15376] ='b11000011;
           rom[ 0+15377] ='b01111101;
           rom[ 0+15378] ='b00110111;
           rom[ 0+15379] ='b00100001;
           rom[ 0+15380] ='b00000010;
           rom[ 0+15381] ='b00111110;
           rom[ 0+15382] ='b11100101;
           rom[ 0+15383] ='b11001101;
           rom[ 0+15384] ='b00001010;
           rom[ 0+15385] ='b00000010;
           rom[ 0+15386] ='b11110001;
           rom[ 0+15387] ='b00000001;
           rom[ 0+15388] ='b00000000;
           rom[ 0+15389] ='b00000000;
           rom[ 0+15390] ='b01111001;
           rom[ 0+15391] ='b11010110;
           rom[ 0+15392] ='b00101111;
           rom[ 0+15393] ='b01111000;
           rom[ 0+15394] ='b11011110;
           rom[ 0+15395] ='b00000000;
           rom[ 0+15396] ='b11110010;
           rom[ 0+15397] ='b00111100;
           rom[ 0+15398] ='b00111100;
           rom[ 0+15399] ='b00100001;
           rom[ 0+15400] ='b00110110;
           rom[ 0+15401] ='b10001000;
           rom[ 0+15402] ='b00001001;
           rom[ 0+15403] ='b01011101;
           rom[ 0+15404] ='b01010100;
           rom[ 0+15405] ='b00011010;
           rom[ 0+15406] ='b01011111;
           rom[ 0+15407] ='b11000101;
           rom[ 0+15408] ='b01111011;
           rom[ 0+15409] ='b11110101;
           rom[ 0+15410] ='b00110011;
           rom[ 0+15411] ='b11001101;
           rom[ 0+15412] ='b10011100;
           rom[ 0+15413] ='b00010100;
           rom[ 0+15414] ='b00110011;
           rom[ 0+15415] ='b11000001;
           rom[ 0+15416] ='b00000011;
           rom[ 0+15417] ='b11000011;
           rom[ 0+15418] ='b00011110;
           rom[ 0+15419] ='b00111100;
           rom[ 0+15420] ='b00100001;
           rom[ 0+15421] ='b00000100;
           rom[ 0+15422] ='b00111101;
           rom[ 0+15423] ='b11100101;
           rom[ 0+15424] ='b11001101;
           rom[ 0+15425] ='b00001010;
           rom[ 0+15426] ='b00000010;
           rom[ 0+15427] ='b11110001;
           rom[ 0+15428] ='b11001101;
           rom[ 0+15429] ='b10001010;
           rom[ 0+15430] ='b00010110;
           rom[ 0+15431] ='b00100001;
           rom[ 0+15432] ='b10111101;
           rom[ 0+15433] ='b00111100;
           rom[ 0+15434] ='b11100101;
           rom[ 0+15435] ='b11001101;
           rom[ 0+15436] ='b00001010;
           rom[ 0+15437] ='b00000010;
           rom[ 0+15438] ='b11110001;
           rom[ 0+15439] ='b00100001;
           rom[ 0+15440] ='b00011011;
           rom[ 0+15441] ='b00111110;
           rom[ 0+15442] ='b11100101;
           rom[ 0+15443] ='b11001101;
           rom[ 0+15444] ='b00001010;
           rom[ 0+15445] ='b00000010;
           rom[ 0+15446] ='b11110001;
           rom[ 0+15447] ='b11011101;
           rom[ 0+15448] ='b11111001;
           rom[ 0+15449] ='b11011101;
           rom[ 0+15450] ='b11100001;
           rom[ 0+15451] ='b11001001;
           rom[ 0+15452] ='b01010011;
           rom[ 0+15453] ='b01110100;
           rom[ 0+15454] ='b01100001;
           rom[ 0+15455] ='b01110010;
           rom[ 0+15456] ='b01110100;
           rom[ 0+15457] ='b00100000;
           rom[ 0+15458] ='b01010011;
           rom[ 0+15459] ='b01101001;
           rom[ 0+15460] ='b01101101;
           rom[ 0+15461] ='b01110000;
           rom[ 0+15462] ='b01101100;
           rom[ 0+15463] ='b01100101;
           rom[ 0+15464] ='b00100000;
           rom[ 0+15465] ='b01010010;
           rom[ 0+15466] ='b01100101;
           rom[ 0+15467] ='b01100101;
           rom[ 0+15468] ='b01100100;
           rom[ 0+15469] ='b00100000;
           rom[ 0+15470] ='b01010011;
           rom[ 0+15471] ='b01101111;
           rom[ 0+15472] ='b01101100;
           rom[ 0+15473] ='b01101111;
           rom[ 0+15474] ='b01101101;
           rom[ 0+15475] ='b01101111;
           rom[ 0+15476] ='b01101110;
           rom[ 0+15477] ='b00100000;
           rom[ 0+15478] ='b01010100;
           rom[ 0+15479] ='b01100101;
           rom[ 0+15480] ='b01110011;
           rom[ 0+15481] ='b01110100;
           rom[ 0+15482] ='b00100000;
           rom[ 0+15483] ='b01000010;
           rom[ 0+15484] ='b01100101;
           rom[ 0+15485] ='b01101110;
           rom[ 0+15486] ='b01100011;
           rom[ 0+15487] ='b01101000;
           rom[ 0+15488] ='b00100000;
           rom[ 0+15489] ='b01101111;
           rom[ 0+15490] ='b01101110;
           rom[ 0+15491] ='b00100000;
           rom[ 0+15492] ='b01111010;
           rom[ 0+15493] ='b00111000;
           rom[ 0+15494] ='b00110000;
           rom[ 0+15495] ='b00101110;
           rom[ 0+15496] ='b00000000;
           rom[ 0+15497] ='b00100000;
           rom[ 0+15498] ='b00101000;
           rom[ 0+15499] ='b01000011;
           rom[ 0+15500] ='b00101001;
           rom[ 0+15501] ='b00100000;
           rom[ 0+15502] ='b01110111;
           rom[ 0+15503] ='b01110111;
           rom[ 0+15504] ='b01110111;
           rom[ 0+15505] ='b00101110;
           rom[ 0+15506] ='b01110011;
           rom[ 0+15507] ='b01110101;
           rom[ 0+15508] ='b01100111;
           rom[ 0+15509] ='b01100001;
           rom[ 0+15510] ='b01110111;
           rom[ 0+15511] ='b01100001;
           rom[ 0+15512] ='b01110010;
           rom[ 0+15513] ='b01100001;
           rom[ 0+15514] ='b00101101;
           rom[ 0+15515] ='b01110011;
           rom[ 0+15516] ='b01111001;
           rom[ 0+15517] ='b01110011;
           rom[ 0+15518] ='b01110100;
           rom[ 0+15519] ='b01100101;
           rom[ 0+15520] ='b01101101;
           rom[ 0+15521] ='b01110011;
           rom[ 0+15522] ='b00101110;
           rom[ 0+15523] ='b01100011;
           rom[ 0+15524] ='b01101111;
           rom[ 0+15525] ='b01101101;
           rom[ 0+15526] ='b00001010;
           rom[ 0+15527] ='b00000000;
           rom[ 0+15528] ='b00100000;
           rom[ 0+15529] ='b01000010;
           rom[ 0+15530] ='b01110101;
           rom[ 0+15531] ='b01101001;
           rom[ 0+15532] ='b01101100;
           rom[ 0+15533] ='b01100100;
           rom[ 0+15534] ='b00100000;
           rom[ 0+15535] ='b01001010;
           rom[ 0+15536] ='b01100001;
           rom[ 0+15537] ='b01101110;
           rom[ 0+15538] ='b00101110;
           rom[ 0+15539] ='b00110010;
           rom[ 0+15540] ='b00110011;
           rom[ 0+15541] ='b00101110;
           rom[ 0+15542] ='b00110010;
           rom[ 0+15543] ='b00110000;
           rom[ 0+15544] ='b00110000;
           rom[ 0+15545] ='b00110100;
           rom[ 0+15546] ='b00100000;
           rom[ 0+15547] ='b00001010;
           rom[ 0+15548] ='b00000000;
           rom[ 0+15549] ='b00100100;
           rom[ 0+15550] ='b01110100;
           rom[ 0+15551] ='b01101001;
           rom[ 0+15552] ='b01101101;
           rom[ 0+15553] ='b01100101;
           rom[ 0+15554] ='b00000000;
           rom[ 0+15555] ='b01010011;
           rom[ 0+15556] ='b01100101;
           rom[ 0+15557] ='b01100101;
           rom[ 0+15558] ='b01100100;
           rom[ 0+15559] ='b00100000;
           rom[ 0+15560] ='b01000010;
           rom[ 0+15561] ='b01111001;
           rom[ 0+15562] ='b01110100;
           rom[ 0+15563] ='b01100101;
           rom[ 0+15564] ='b01110011;
           rom[ 0+15565] ='b00100000;
           rom[ 0+15566] ='b01001111;
           rom[ 0+15567] ='b01110101;
           rom[ 0+15568] ='b01110100;
           rom[ 0+15569] ='b00100000;
           rom[ 0+15570] ='b01000100;
           rom[ 0+15571] ='b01101111;
           rom[ 0+15572] ='b01101110;
           rom[ 0+15573] ='b01100101;
           rom[ 0+15574] ='b00001010;
           rom[ 0+15575] ='b00000000;
           rom[ 0+15576] ='b01001111;
           rom[ 0+15577] ='b01110010;
           rom[ 0+15578] ='b01101001;
           rom[ 0+15579] ='b01100111;
           rom[ 0+15580] ='b01101001;
           rom[ 0+15581] ='b01101110;
           rom[ 0+15582] ='b01100001;
           rom[ 0+15583] ='b01101100;
           rom[ 0+15584] ='b00100000;
           rom[ 0+15585] ='b01000100;
           rom[ 0+15586] ='b01100001;
           rom[ 0+15587] ='b01110100;
           rom[ 0+15588] ='b01100001;
           rom[ 0+15589] ='b00100000;
           rom[ 0+15590] ='b01100010;
           rom[ 0+15591] ='b01100101;
           rom[ 0+15592] ='b01100110;
           rom[ 0+15593] ='b01101111;
           rom[ 0+15594] ='b01110010;
           rom[ 0+15595] ='b01100101;
           rom[ 0+15596] ='b00100000;
           rom[ 0+15597] ='b01000101;
           rom[ 0+15598] ='b01110010;
           rom[ 0+15599] ='b01110010;
           rom[ 0+15600] ='b01101111;
           rom[ 0+15601] ='b01110010;
           rom[ 0+15602] ='b00100000;
           rom[ 0+15603] ='b01100101;
           rom[ 0+15604] ='b01110010;
           rom[ 0+15605] ='b01110010;
           rom[ 0+15606] ='b01101111;
           rom[ 0+15607] ='b01110010;
           rom[ 0+15608] ='b00100000;
           rom[ 0+15609] ='b01100001;
           rom[ 0+15610] ='b01100100;
           rom[ 0+15611] ='b01100100;
           rom[ 0+15612] ='b01101001;
           rom[ 0+15613] ='b01110100;
           rom[ 0+15614] ='b01101001;
           rom[ 0+15615] ='b01101111;
           rom[ 0+15616] ='b01101110;
           rom[ 0+15617] ='b00100000;
           rom[ 0+15618] ='b00001010;
           rom[ 0+15619] ='b00000000;
           rom[ 0+15620] ='b00001010;
           rom[ 0+15621] ='b00000000;
           rom[ 0+15622] ='b01000100;
           rom[ 0+15623] ='b01100101;
           rom[ 0+15624] ='b01100011;
           rom[ 0+15625] ='b01101111;
           rom[ 0+15626] ='b01100100;
           rom[ 0+15627] ='b01101001;
           rom[ 0+15628] ='b01101110;
           rom[ 0+15629] ='b01100111;
           rom[ 0+15630] ='b00100000;
           rom[ 0+15631] ='b00001010;
           rom[ 0+15632] ='b00000000;
           rom[ 0+15633] ='b00001010;
           rom[ 0+15634] ='b00100000;
           rom[ 0+15635] ='b01010011;
           rom[ 0+15636] ='b01111001;
           rom[ 0+15637] ='b01101110;
           rom[ 0+15638] ='b01100100;
           rom[ 0+15639] ='b01110010;
           rom[ 0+15640] ='b01101111;
           rom[ 0+15641] ='b01101101;
           rom[ 0+15642] ='b01100101;
           rom[ 0+15643] ='b00100000;
           rom[ 0+15644] ='b01000001;
           rom[ 0+15645] ='b01101110;
           rom[ 0+15646] ='b01100001;
           rom[ 0+15647] ='b01101100;
           rom[ 0+15648] ='b01111001;
           rom[ 0+15649] ='b01110011;
           rom[ 0+15650] ='b01101001;
           rom[ 0+15651] ='b01110011;
           rom[ 0+15652] ='b00100000;
           rom[ 0+15653] ='b01100010;
           rom[ 0+15654] ='b01100101;
           rom[ 0+15655] ='b01100111;
           rom[ 0+15656] ='b01101001;
           rom[ 0+15657] ='b01101110;
           rom[ 0+15658] ='b01110011;
           rom[ 0+15659] ='b00101110;
           rom[ 0+15660] ='b00101110;
           rom[ 0+15661] ='b00000000;
           rom[ 0+15662] ='b01000011;
           rom[ 0+15663] ='b00110001;
           rom[ 0+15664] ='b00100000;
           rom[ 0+15665] ='b01000011;
           rom[ 0+15666] ='b01101111;
           rom[ 0+15667] ='b01110010;
           rom[ 0+15668] ='b01110010;
           rom[ 0+15669] ='b01100101;
           rom[ 0+15670] ='b01100011;
           rom[ 0+15671] ='b01110100;
           rom[ 0+15672] ='b01101001;
           rom[ 0+15673] ='b01101111;
           rom[ 0+15674] ='b01101110;
           rom[ 0+15675] ='b00100000;
           rom[ 0+15676] ='b01010010;
           rom[ 0+15677] ='b01100101;
           rom[ 0+15678] ='b01110011;
           rom[ 0+15679] ='b01110101;
           rom[ 0+15680] ='b01101100;
           rom[ 0+15681] ='b01110100;
           rom[ 0+15682] ='b00001010;
           rom[ 0+15683] ='b00000000;
           rom[ 0+15684] ='b01001001;
           rom[ 0+15685] ='b01101110;
           rom[ 0+15686] ='b01110100;
           rom[ 0+15687] ='b01100101;
           rom[ 0+15688] ='b01110010;
           rom[ 0+15689] ='b01101100;
           rom[ 0+15690] ='b01100101;
           rom[ 0+15691] ='b01100001;
           rom[ 0+15692] ='b01110110;
           rom[ 0+15693] ='b01100101;
           rom[ 0+15694] ='b00111101;
           rom[ 0+15695] ='b00100000;
           rom[ 0+15696] ='b00111010;
           rom[ 0+15697] ='b00100000;
           rom[ 0+15698] ='b00100000;
           rom[ 0+15699] ='b00000000;
           rom[ 0+15700] ='b00001001;
           rom[ 0+15701] ='b00000000;
           rom[ 0+15702] ='b01001110;
           rom[ 0+15703] ='b01101111;
           rom[ 0+15704] ='b00100000;
           rom[ 0+15705] ='b01000101;
           rom[ 0+15706] ='b01110010;
           rom[ 0+15707] ='b01110010;
           rom[ 0+15708] ='b01101111;
           rom[ 0+15709] ='b01110010;
           rom[ 0+15710] ='b00100000;
           rom[ 0+15711] ='b01000100;
           rom[ 0+15712] ='b01100101;
           rom[ 0+15713] ='b01110100;
           rom[ 0+15714] ='b01100101;
           rom[ 0+15715] ='b01100011;
           rom[ 0+15716] ='b01110100;
           rom[ 0+15717] ='b01100101;
           rom[ 0+15718] ='b01100100;
           rom[ 0+15719] ='b00101110;
           rom[ 0+15720] ='b00001010;
           rom[ 0+15721] ='b00000000;
           rom[ 0+15722] ='b01010011;
           rom[ 0+15723] ='b01101001;
           rom[ 0+15724] ='b01101110;
           rom[ 0+15725] ='b01100111;
           rom[ 0+15726] ='b01101100;
           rom[ 0+15727] ='b01100101;
           rom[ 0+15728] ='b00100000;
           rom[ 0+15729] ='b01000101;
           rom[ 0+15730] ='b01110010;
           rom[ 0+15731] ='b01110010;
           rom[ 0+15732] ='b01101111;
           rom[ 0+15733] ='b01110010;
           rom[ 0+15734] ='b00100000;
           rom[ 0+15735] ='b01000100;
           rom[ 0+15736] ='b01100101;
           rom[ 0+15737] ='b01110100;
           rom[ 0+15738] ='b01100101;
           rom[ 0+15739] ='b01100011;
           rom[ 0+15740] ='b01110100;
           rom[ 0+15741] ='b01100101;
           rom[ 0+15742] ='b01100100;
           rom[ 0+15743] ='b00101110;
           rom[ 0+15744] ='b00001010;
           rom[ 0+15745] ='b00000000;
           rom[ 0+15746] ='b00001001;
           rom[ 0+15747] ='b00001001;
           rom[ 0+15748] ='b00001001;
           rom[ 0+15749] ='b01000101;
           rom[ 0+15750] ='b01110010;
           rom[ 0+15751] ='b01110010;
           rom[ 0+15752] ='b01101111;
           rom[ 0+15753] ='b01110010;
           rom[ 0+15754] ='b00100000;
           rom[ 0+15755] ='b01010000;
           rom[ 0+15756] ='b01101111;
           rom[ 0+15757] ='b01110011;
           rom[ 0+15758] ='b01101001;
           rom[ 0+15759] ='b01110100;
           rom[ 0+15760] ='b01101001;
           rom[ 0+15761] ='b01101111;
           rom[ 0+15762] ='b01101110;
           rom[ 0+15763] ='b00111101;
           rom[ 0+15764] ='b00000000;
           rom[ 0+15765] ='b00001010;
           rom[ 0+15766] ='b00001001;
           rom[ 0+15767] ='b00001001;
           rom[ 0+15768] ='b00001001;
           rom[ 0+15769] ='b01000101;
           rom[ 0+15770] ='b01110010;
           rom[ 0+15771] ='b01110010;
           rom[ 0+15772] ='b01101111;
           rom[ 0+15773] ='b01110010;
           rom[ 0+15774] ='b00100000;
           rom[ 0+15775] ='b01010110;
           rom[ 0+15776] ='b01100001;
           rom[ 0+15777] ='b01101100;
           rom[ 0+15778] ='b01110101;
           rom[ 0+15779] ='b01100101;
           rom[ 0+15780] ='b00100000;
           rom[ 0+15781] ='b00100000;
           rom[ 0+15782] ='b00100000;
           rom[ 0+15783] ='b00111101;
           rom[ 0+15784] ='b00000000;
           rom[ 0+15785] ='b01000100;
           rom[ 0+15786] ='b01101111;
           rom[ 0+15787] ='b01110101;
           rom[ 0+15788] ='b01100010;
           rom[ 0+15789] ='b01101100;
           rom[ 0+15790] ='b01100101;
           rom[ 0+15791] ='b00100000;
           rom[ 0+15792] ='b01000101;
           rom[ 0+15793] ='b01110010;
           rom[ 0+15794] ='b01110010;
           rom[ 0+15795] ='b01101111;
           rom[ 0+15796] ='b01110010;
           rom[ 0+15797] ='b00100000;
           rom[ 0+15798] ='b01000100;
           rom[ 0+15799] ='b01100101;
           rom[ 0+15800] ='b01110100;
           rom[ 0+15801] ='b01100101;
           rom[ 0+15802] ='b01100011;
           rom[ 0+15803] ='b01110100;
           rom[ 0+15804] ='b01100101;
           rom[ 0+15805] ='b01100100;
           rom[ 0+15806] ='b00101110;
           rom[ 0+15807] ='b00001010;
           rom[ 0+15808] ='b00000000;
           rom[ 0+15809] ='b00001010;
           rom[ 0+15810] ='b00001001;
           rom[ 0+15811] ='b00001001;
           rom[ 0+15812] ='b00001001;
           rom[ 0+15813] ='b01000101;
           rom[ 0+15814] ='b01110010;
           rom[ 0+15815] ='b01110010;
           rom[ 0+15816] ='b01101111;
           rom[ 0+15817] ='b01110010;
           rom[ 0+15818] ='b00100000;
           rom[ 0+15819] ='b01010000;
           rom[ 0+15820] ='b01101111;
           rom[ 0+15821] ='b01110011;
           rom[ 0+15822] ='b01101001;
           rom[ 0+15823] ='b01110100;
           rom[ 0+15824] ='b01101001;
           rom[ 0+15825] ='b01101111;
           rom[ 0+15826] ='b01101110;
           rom[ 0+15827] ='b00111101;
           rom[ 0+15828] ='b00000000;
           rom[ 0+15829] ='b01010100;
           rom[ 0+15830] ='b01110010;
           rom[ 0+15831] ='b01101001;
           rom[ 0+15832] ='b01110000;
           rom[ 0+15833] ='b01110000;
           rom[ 0+15834] ='b01101100;
           rom[ 0+15835] ='b01100101;
           rom[ 0+15836] ='b00100000;
           rom[ 0+15837] ='b01000101;
           rom[ 0+15838] ='b01110010;
           rom[ 0+15839] ='b01110010;
           rom[ 0+15840] ='b01101111;
           rom[ 0+15841] ='b01110010;
           rom[ 0+15842] ='b00100000;
           rom[ 0+15843] ='b01000100;
           rom[ 0+15844] ='b01100101;
           rom[ 0+15845] ='b01110100;
           rom[ 0+15846] ='b01100101;
           rom[ 0+15847] ='b01100011;
           rom[ 0+15848] ='b01110100;
           rom[ 0+15849] ='b01100101;
           rom[ 0+15850] ='b01100100;
           rom[ 0+15851] ='b00101110;
           rom[ 0+15852] ='b00001010;
           rom[ 0+15853] ='b00000000;
           rom[ 0+15854] ='b01010101;
           rom[ 0+15855] ='b01101110;
           rom[ 0+15856] ='b01100011;
           rom[ 0+15857] ='b01101111;
           rom[ 0+15858] ='b01110010;
           rom[ 0+15859] ='b01110010;
           rom[ 0+15860] ='b01100101;
           rom[ 0+15861] ='b01100011;
           rom[ 0+15862] ='b01110100;
           rom[ 0+15863] ='b01100001;
           rom[ 0+15864] ='b01100010;
           rom[ 0+15865] ='b01101100;
           rom[ 0+15866] ='b01100101;
           rom[ 0+15867] ='b00100000;
           rom[ 0+15868] ='b01000101;
           rom[ 0+15869] ='b01110010;
           rom[ 0+15870] ='b01110010;
           rom[ 0+15871] ='b01101111;
           rom[ 0+15872] ='b01110010;
           rom[ 0+15873] ='b00000000;
           rom[ 0+15874] ='b01000001;
           rom[ 0+15875] ='b01100110;
           rom[ 0+15876] ='b01110100;
           rom[ 0+15877] ='b01100101;
           rom[ 0+15878] ='b01110010;
           rom[ 0+15879] ='b00100000;
           rom[ 0+15880] ='b01000011;
           rom[ 0+15881] ='b01101111;
           rom[ 0+15882] ='b01110010;
           rom[ 0+15883] ='b01110010;
           rom[ 0+15884] ='b01100101;
           rom[ 0+15885] ='b01100011;
           rom[ 0+15886] ='b01110100;
           rom[ 0+15887] ='b01101001;
           rom[ 0+15888] ='b01101110;
           rom[ 0+15889] ='b01100111;
           rom[ 0+15890] ='b00100000;
           rom[ 0+15891] ='b01000101;
           rom[ 0+15892] ='b01110010;
           rom[ 0+15893] ='b01110010;
           rom[ 0+15894] ='b01101111;
           rom[ 0+15895] ='b01110010;
           rom[ 0+15896] ='b01110011;
           rom[ 0+15897] ='b00001010;
           rom[ 0+15898] ='b00000000;
           rom[ 0+15899] ='b00100100;
           rom[ 0+15900] ='b01100110;
           rom[ 0+15901] ='b01101001;
           rom[ 0+15902] ='b01101110;
           rom[ 0+15903] ='b01101001;
           rom[ 0+15904] ='b01110011;
           rom[ 0+15905] ='b01101000;
           rom[ 0+15906] ='b00000000;
           rom[ 0+15907] ='b00100001;
           rom[ 0+15908] ='b00000011;
           rom[ 0+15909] ='b00000000;
           rom[ 0+15910] ='b00111001;
           rom[ 0+15911] ='b01011110;
           rom[ 0+15912] ='b00101011;
           rom[ 0+15913] ='b01101110;
           rom[ 0+15914] ='b01001101;
           rom[ 0+15915] ='b11001101;
           rom[ 0+15916] ='b10101011;
           rom[ 0+15917] ='b00111110;
           rom[ 0+15918] ='b01101001;
           rom[ 0+15919] ='b01100000;
           rom[ 0+15920] ='b11001001;
           rom[ 0+15921] ='b00100001;
           rom[ 0+15922] ='b00000011;
           rom[ 0+15923] ='b00000000;
           rom[ 0+15924] ='b00111001;
           rom[ 0+15925] ='b01011110;
           rom[ 0+15926] ='b00101011;
           rom[ 0+15927] ='b01101110;
           rom[ 0+15928] ='b01001101;
           rom[ 0+15929] ='b11001101;
           rom[ 0+15930] ='b10101011;
           rom[ 0+15931] ='b00111110;
           rom[ 0+15932] ='b01101011;
           rom[ 0+15933] ='b01100010;
           rom[ 0+15934] ='b11001001;
           rom[ 0+15935] ='b00100001;
           rom[ 0+15936] ='b00000101;
           rom[ 0+15937] ='b00000000;
           rom[ 0+15938] ='b00111001;
           rom[ 0+15939] ='b01010110;
           rom[ 0+15940] ='b00101011;
           rom[ 0+15941] ='b01011110;
           rom[ 0+15942] ='b00101011;
           rom[ 0+15943] ='b01111110;
           rom[ 0+15944] ='b00101011;
           rom[ 0+15945] ='b01101110;
           rom[ 0+15946] ='b01100111;
           rom[ 0+15947] ='b01000100;
           rom[ 0+15948] ='b01001101;
           rom[ 0+15949] ='b11001101;
           rom[ 0+15950] ='b10110011;
           rom[ 0+15951] ='b00111110;
           rom[ 0+15952] ='b01101001;
           rom[ 0+15953] ='b01100000;
           rom[ 0+15954] ='b11001001;
           rom[ 0+15955] ='b00100001;
           rom[ 0+15956] ='b00000101;
           rom[ 0+15957] ='b00000000;
           rom[ 0+15958] ='b00111001;
           rom[ 0+15959] ='b01010110;
           rom[ 0+15960] ='b00101011;
           rom[ 0+15961] ='b01011110;
           rom[ 0+15962] ='b00101011;
           rom[ 0+15963] ='b01111110;
           rom[ 0+15964] ='b00101011;
           rom[ 0+15965] ='b01101110;
           rom[ 0+15966] ='b01100111;
           rom[ 0+15967] ='b01000100;
           rom[ 0+15968] ='b01001101;
           rom[ 0+15969] ='b11001101;
           rom[ 0+15970] ='b10110011;
           rom[ 0+15971] ='b00111110;
           rom[ 0+15972] ='b01101011;
           rom[ 0+15973] ='b01100010;
           rom[ 0+15974] ='b11001001;
           rom[ 0+15975] ='b00100001;
           rom[ 0+15976] ='b00000011;
           rom[ 0+15977] ='b00000000;
           rom[ 0+15978] ='b00111001;
           rom[ 0+15979] ='b01011110;
           rom[ 0+15980] ='b00101011;
           rom[ 0+15981] ='b01101110;
           rom[ 0+15982] ='b01001101;
           rom[ 0+15983] ='b11001101;
           rom[ 0+15984] ='b11110000;
           rom[ 0+15985] ='b00111110;
           rom[ 0+15986] ='b01101001;
           rom[ 0+15987] ='b01100000;
           rom[ 0+15988] ='b11001001;
           rom[ 0+15989] ='b00100001;
           rom[ 0+15990] ='b00000011;
           rom[ 0+15991] ='b00000000;
           rom[ 0+15992] ='b00111001;
           rom[ 0+15993] ='b01011110;
           rom[ 0+15994] ='b00101011;
           rom[ 0+15995] ='b01101110;
           rom[ 0+15996] ='b01001101;
           rom[ 0+15997] ='b11001101;
           rom[ 0+15998] ='b11110000;
           rom[ 0+15999] ='b00111110;
           rom[ 0+16000] ='b01101011;
           rom[ 0+16001] ='b01100010;
           rom[ 0+16002] ='b11001001;
           rom[ 0+16003] ='b00100001;
           rom[ 0+16004] ='b00000101;
           rom[ 0+16005] ='b00000000;
           rom[ 0+16006] ='b00111001;
           rom[ 0+16007] ='b01010110;
           rom[ 0+16008] ='b00101011;
           rom[ 0+16009] ='b01011110;
           rom[ 0+16010] ='b00101011;
           rom[ 0+16011] ='b01111110;
           rom[ 0+16012] ='b00101011;
           rom[ 0+16013] ='b01101110;
           rom[ 0+16014] ='b01100111;
           rom[ 0+16015] ='b01000100;
           rom[ 0+16016] ='b01001101;
           rom[ 0+16017] ='b11001101;
           rom[ 0+16018] ='b11110011;
           rom[ 0+16019] ='b00111110;
           rom[ 0+16020] ='b01101001;
           rom[ 0+16021] ='b01100000;
           rom[ 0+16022] ='b11001001;
           rom[ 0+16023] ='b00100001;
           rom[ 0+16024] ='b00000101;
           rom[ 0+16025] ='b00000000;
           rom[ 0+16026] ='b00111001;
           rom[ 0+16027] ='b01010110;
           rom[ 0+16028] ='b00101011;
           rom[ 0+16029] ='b01011110;
           rom[ 0+16030] ='b00101011;
           rom[ 0+16031] ='b01111110;
           rom[ 0+16032] ='b00101011;
           rom[ 0+16033] ='b01101110;
           rom[ 0+16034] ='b01100111;
           rom[ 0+16035] ='b01000100;
           rom[ 0+16036] ='b01001101;
           rom[ 0+16037] ='b11001101;
           rom[ 0+16038] ='b11110011;
           rom[ 0+16039] ='b00111110;
           rom[ 0+16040] ='b01101011;
           rom[ 0+16041] ='b01100010;
           rom[ 0+16042] ='b11001001;
           rom[ 0+16043] ='b01111001;
           rom[ 0+16044] ='b00000111;
           rom[ 0+16045] ='b10011111;
           rom[ 0+16046] ='b01000111;
           rom[ 0+16047] ='b01111011;
           rom[ 0+16048] ='b00000111;
           rom[ 0+16049] ='b10011111;
           rom[ 0+16050] ='b01010111;
           rom[ 0+16051] ='b01111000;
           rom[ 0+16052] ='b00110010;
           rom[ 0+16053] ='b00110100;
           rom[ 0+16054] ='b10010000;
           rom[ 0+16055] ='b10101010;
           rom[ 0+16056] ='b00110010;
           rom[ 0+16057] ='b00110101;
           rom[ 0+16058] ='b10010000;
           rom[ 0+16059] ='b11001011;
           rom[ 0+16060] ='b01111010;
           rom[ 0+16061] ='b11001010;
           rom[ 0+16062] ='b11000110;
           rom[ 0+16063] ='b00111110;
           rom[ 0+16064] ='b10010111;
           rom[ 0+16065] ='b10010011;
           rom[ 0+16066] ='b01011111;
           rom[ 0+16067] ='b10011111;
           rom[ 0+16068] ='b10010010;
           rom[ 0+16069] ='b01010111;
           rom[ 0+16070] ='b11001011;
           rom[ 0+16071] ='b01111000;
           rom[ 0+16072] ='b11001010;
           rom[ 0+16073] ='b11010001;
           rom[ 0+16074] ='b00111110;
           rom[ 0+16075] ='b10010111;
           rom[ 0+16076] ='b10010001;
           rom[ 0+16077] ='b01001111;
           rom[ 0+16078] ='b10011111;
           rom[ 0+16079] ='b10010000;
           rom[ 0+16080] ='b01000111;
           rom[ 0+16081] ='b11001101;
           rom[ 0+16082] ='b11110011;
           rom[ 0+16083] ='b00111110;
           rom[ 0+16084] ='b11011000;
           rom[ 0+16085] ='b00111010;
           rom[ 0+16086] ='b00110101;
           rom[ 0+16087] ='b10010000;
           rom[ 0+16088] ='b11100110;
           rom[ 0+16089] ='b10000000;
           rom[ 0+16090] ='b11001010;
           rom[ 0+16091] ='b11100011;
           rom[ 0+16092] ='b00111110;
           rom[ 0+16093] ='b10010111;
           rom[ 0+16094] ='b10010001;
           rom[ 0+16095] ='b01001111;
           rom[ 0+16096] ='b10011111;
           rom[ 0+16097] ='b10010000;
           rom[ 0+16098] ='b01000111;
           rom[ 0+16099] ='b00111010;
           rom[ 0+16100] ='b00110100;
           rom[ 0+16101] ='b10010000;
           rom[ 0+16102] ='b11100110;
           rom[ 0+16103] ='b10000000;
           rom[ 0+16104] ='b11001000;
           rom[ 0+16105] ='b10010111;
           rom[ 0+16106] ='b10010011;
           rom[ 0+16107] ='b01011111;
           rom[ 0+16108] ='b10011111;
           rom[ 0+16109] ='b10010010;
           rom[ 0+16110] ='b01010111;
           rom[ 0+16111] ='b11001001;
           rom[ 0+16112] ='b00000110;
           rom[ 0+16113] ='b00000000;
           rom[ 0+16114] ='b01010000;
           rom[ 0+16115] ='b01111011;
           rom[ 0+16116] ='b10110010;
           rom[ 0+16117] ='b11000010;
           rom[ 0+16118] ='b11111111;
           rom[ 0+16119] ='b00111110;
           rom[ 0+16120] ='b00000001;
           rom[ 0+16121] ='b00000000;
           rom[ 0+16122] ='b00000000;
           rom[ 0+16123] ='b01010000;
           rom[ 0+16124] ='b01011001;
           rom[ 0+16125] ='b00110111;
           rom[ 0+16126] ='b11001001;
           rom[ 0+16127] ='b00100001;
           rom[ 0+16128] ='b00000000;
           rom[ 0+16129] ='b00000000;
           rom[ 0+16130] ='b10110111;
           rom[ 0+16131] ='b00001000;
           rom[ 0+16132] ='b00111110;
           rom[ 0+16133] ='b00010000;
           rom[ 0+16134] ='b00001000;
           rom[ 0+16135] ='b11001011;
           rom[ 0+16136] ='b00010001;
           rom[ 0+16137] ='b11001011;
           rom[ 0+16138] ='b00010000;
           rom[ 0+16139] ='b11101101;
           rom[ 0+16140] ='b01101010;
           rom[ 0+16141] ='b11100101;
           rom[ 0+16142] ='b11101101;
           rom[ 0+16143] ='b01010010;
           rom[ 0+16144] ='b00111111;
           rom[ 0+16145] ='b11011010;
           rom[ 0+16146] ='b00011000;
           rom[ 0+16147] ='b00111111;
           rom[ 0+16148] ='b11100001;
           rom[ 0+16149] ='b11000011;
           rom[ 0+16150] ='b00011010;
           rom[ 0+16151] ='b00111111;
           rom[ 0+16152] ='b00110011;
           rom[ 0+16153] ='b00110011;
           rom[ 0+16154] ='b00001000;
           rom[ 0+16155] ='b00111101;
           rom[ 0+16156] ='b11000010;
           rom[ 0+16157] ='b00000110;
           rom[ 0+16158] ='b00111111;
           rom[ 0+16159] ='b00001000;
           rom[ 0+16160] ='b01010100;
           rom[ 0+16161] ='b01011101;
           rom[ 0+16162] ='b11001011;
           rom[ 0+16163] ='b00010001;
           rom[ 0+16164] ='b11001011;
           rom[ 0+16165] ='b00010000;
           rom[ 0+16166] ='b10110111;
           rom[ 0+16167] ='b11001001;
           rom[ 0+16168] ='b00100001;
           rom[ 0+16169] ='b00000110;
           rom[ 0+16170] ='b00000000;
           rom[ 0+16171] ='b00111001;
           rom[ 0+16172] ='b01001110;
           rom[ 0+16173] ='b00101011;
           rom[ 0+16174] ='b01010110;
           rom[ 0+16175] ='b00101011;
           rom[ 0+16176] ='b01011110;
           rom[ 0+16177] ='b00101011;
           rom[ 0+16178] ='b01111110;
           rom[ 0+16179] ='b00101011;
           rom[ 0+16180] ='b01101110;
           rom[ 0+16181] ='b01100111;
           rom[ 0+16182] ='b01111001;
           rom[ 0+16183] ='b10110111;
           rom[ 0+16184] ='b11001000;
           rom[ 0+16185] ='b11001011;
           rom[ 0+16186] ='b00011010;
           rom[ 0+16187] ='b11001011;
           rom[ 0+16188] ='b00011011;
           rom[ 0+16189] ='b11001011;
           rom[ 0+16190] ='b00011100;
           rom[ 0+16191] ='b11001011;
           rom[ 0+16192] ='b00011101;
           rom[ 0+16193] ='b00111101;
           rom[ 0+16194] ='b11000011;
           rom[ 0+16195] ='b00110111;
           rom[ 0+16196] ='b00111111;
           rom[ 0+16197] ='b00100001;
           rom[ 0+16198] ='b00000110;
           rom[ 0+16199] ='b00000000;
           rom[ 0+16200] ='b00111001;
           rom[ 0+16201] ='b01001110;
           rom[ 0+16202] ='b00101011;
           rom[ 0+16203] ='b01010110;
           rom[ 0+16204] ='b00101011;
           rom[ 0+16205] ='b01011110;
           rom[ 0+16206] ='b00101011;
           rom[ 0+16207] ='b01111110;
           rom[ 0+16208] ='b00101011;
           rom[ 0+16209] ='b01101110;
           rom[ 0+16210] ='b01100111;
           rom[ 0+16211] ='b01111001;
           rom[ 0+16212] ='b10110111;
           rom[ 0+16213] ='b11001000;
           rom[ 0+16214] ='b11001011;
           rom[ 0+16215] ='b00101010;
           rom[ 0+16216] ='b11001011;
           rom[ 0+16217] ='b00011011;
           rom[ 0+16218] ='b11001011;
           rom[ 0+16219] ='b00011100;
           rom[ 0+16220] ='b11001011;
           rom[ 0+16221] ='b00011101;
           rom[ 0+16222] ='b00111101;
           rom[ 0+16223] ='b11000011;
           rom[ 0+16224] ='b01010100;
           rom[ 0+16225] ='b00111111;
           rom[ 0+16226] ='b00100001;
           rom[ 0+16227] ='b00000110;
           rom[ 0+16228] ='b00000000;
           rom[ 0+16229] ='b00111001;
           rom[ 0+16230] ='b01001110;
           rom[ 0+16231] ='b00101011;
           rom[ 0+16232] ='b01010110;
           rom[ 0+16233] ='b00101011;
           rom[ 0+16234] ='b01011110;
           rom[ 0+16235] ='b00101011;
           rom[ 0+16236] ='b01111110;
           rom[ 0+16237] ='b00101011;
           rom[ 0+16238] ='b01101110;
           rom[ 0+16239] ='b01100111;
           rom[ 0+16240] ='b01111001;
           rom[ 0+16241] ='b10110111;
           rom[ 0+16242] ='b11001000;
           rom[ 0+16243] ='b11001011;
           rom[ 0+16244] ='b00010101;
           rom[ 0+16245] ='b11001011;
           rom[ 0+16246] ='b00010100;
           rom[ 0+16247] ='b11001011;
           rom[ 0+16248] ='b00010011;
           rom[ 0+16249] ='b11001011;
           rom[ 0+16250] ='b00010010;
           rom[ 0+16251] ='b00111101;
           rom[ 0+16252] ='b11000011;
           rom[ 0+16253] ='b01110001;
           rom[ 0+16254] ='b00111111;
           rom[ 0+16255] ='b10101111;
           rom[ 0+16256] ='b11111101;
           rom[ 0+16257] ='b00100001;
           rom[ 0+16258] ='b00101110;
           rom[ 0+16259] ='b10010000;
           rom[ 0+16260] ='b11111101;
           rom[ 0+16261] ='b01110111;
           rom[ 0+16262] ='b00000000;
           rom[ 0+16263] ='b11111101;
           rom[ 0+16264] ='b01110111;
           rom[ 0+16265] ='b00000001;
           rom[ 0+16266] ='b11111101;
           rom[ 0+16267] ='b01110111;
           rom[ 0+16268] ='b00000010;
           rom[ 0+16269] ='b11111101;
           rom[ 0+16270] ='b01110111;
           rom[ 0+16271] ='b00000011;
           rom[ 0+16272] ='b11001001;
           rom[ 0+16273] ='bxxxxxxxx;
           rom[ 0+16274] ='bxxxxxxxx;
           rom[ 0+16275] ='bxxxxxxxx;
           rom[ 0+16276] ='bxxxxxxxx;
           rom[ 0+16277] ='bxxxxxxxx;
           rom[ 0+16278] ='bxxxxxxxx;
           rom[ 0+16279] ='bxxxxxxxx;
           rom[ 0+16280] ='bxxxxxxxx;
           rom[ 0+16281] ='bxxxxxxxx;
           rom[ 0+16282] ='bxxxxxxxx;
           rom[ 0+16283] ='bxxxxxxxx;
           rom[ 0+16284] ='bxxxxxxxx;
           rom[ 0+16285] ='bxxxxxxxx;
           rom[ 0+16286] ='bxxxxxxxx;
           rom[ 0+16287] ='bxxxxxxxx;
           rom[ 0+16288] ='bxxxxxxxx;
           rom[ 0+16289] ='bxxxxxxxx;
           rom[ 0+16290] ='bxxxxxxxx;
           rom[ 0+16291] ='bxxxxxxxx;
           rom[ 0+16292] ='bxxxxxxxx;
           rom[ 0+16293] ='bxxxxxxxx;
           rom[ 0+16294] ='bxxxxxxxx;
           rom[ 0+16295] ='bxxxxxxxx;
           rom[ 0+16296] ='bxxxxxxxx;
           rom[ 0+16297] ='bxxxxxxxx;
           rom[ 0+16298] ='bxxxxxxxx;
           rom[ 0+16299] ='bxxxxxxxx;
           rom[ 0+16300] ='bxxxxxxxx;
           rom[ 0+16301] ='bxxxxxxxx;
           rom[ 0+16302] ='bxxxxxxxx;
           rom[ 0+16303] ='bxxxxxxxx;
           rom[ 0+16304] ='bxxxxxxxx;
           rom[ 0+16305] ='bxxxxxxxx;
           rom[ 0+16306] ='bxxxxxxxx;
           rom[ 0+16307] ='bxxxxxxxx;
           rom[ 0+16308] ='bxxxxxxxx;
           rom[ 0+16309] ='bxxxxxxxx;
           rom[ 0+16310] ='bxxxxxxxx;
           rom[ 0+16311] ='bxxxxxxxx;
           rom[ 0+16312] ='bxxxxxxxx;
           rom[ 0+16313] ='bxxxxxxxx;
           rom[ 0+16314] ='bxxxxxxxx;
           rom[ 0+16315] ='bxxxxxxxx;
           rom[ 0+16316] ='bxxxxxxxx;
           rom[ 0+16317] ='bxxxxxxxx;
           rom[ 0+16318] ='bxxxxxxxx;
           rom[ 0+16319] ='bxxxxxxxx;
           rom[ 0+16320] ='bxxxxxxxx;
           rom[ 0+16321] ='bxxxxxxxx;
           rom[ 0+16322] ='bxxxxxxxx;
           rom[ 0+16323] ='bxxxxxxxx;
           rom[ 0+16324] ='bxxxxxxxx;
           rom[ 0+16325] ='bxxxxxxxx;
           rom[ 0+16326] ='bxxxxxxxx;
           rom[ 0+16327] ='bxxxxxxxx;
           rom[ 0+16328] ='bxxxxxxxx;
           rom[ 0+16329] ='bxxxxxxxx;
           rom[ 0+16330] ='bxxxxxxxx;
           rom[ 0+16331] ='bxxxxxxxx;
           rom[ 0+16332] ='bxxxxxxxx;
           rom[ 0+16333] ='bxxxxxxxx;
           rom[ 0+16334] ='bxxxxxxxx;
           rom[ 0+16335] ='bxxxxxxxx;
           rom[ 0+16336] ='bxxxxxxxx;
           rom[ 0+16337] ='bxxxxxxxx;
           rom[ 0+16338] ='bxxxxxxxx;
           rom[ 0+16339] ='bxxxxxxxx;
           rom[ 0+16340] ='bxxxxxxxx;
           rom[ 0+16341] ='bxxxxxxxx;
           rom[ 0+16342] ='bxxxxxxxx;
           rom[ 0+16343] ='bxxxxxxxx;
           rom[ 0+16344] ='bxxxxxxxx;
           rom[ 0+16345] ='bxxxxxxxx;
           rom[ 0+16346] ='bxxxxxxxx;
           rom[ 0+16347] ='bxxxxxxxx;
           rom[ 0+16348] ='bxxxxxxxx;
           rom[ 0+16349] ='bxxxxxxxx;
           rom[ 0+16350] ='bxxxxxxxx;
           rom[ 0+16351] ='bxxxxxxxx;
           rom[ 0+16352] ='bxxxxxxxx;
           rom[ 0+16353] ='bxxxxxxxx;
           rom[ 0+16354] ='bxxxxxxxx;
           rom[ 0+16355] ='bxxxxxxxx;
           rom[ 0+16356] ='bxxxxxxxx;
           rom[ 0+16357] ='bxxxxxxxx;
           rom[ 0+16358] ='bxxxxxxxx;
           rom[ 0+16359] ='bxxxxxxxx;
           rom[ 0+16360] ='bxxxxxxxx;
           rom[ 0+16361] ='bxxxxxxxx;
           rom[ 0+16362] ='bxxxxxxxx;
           rom[ 0+16363] ='bxxxxxxxx;
           rom[ 0+16364] ='bxxxxxxxx;
           rom[ 0+16365] ='bxxxxxxxx;
           rom[ 0+16366] ='bxxxxxxxx;
           rom[ 0+16367] ='bxxxxxxxx;
           rom[ 0+16368] ='bxxxxxxxx;
           rom[ 0+16369] ='bxxxxxxxx;
           rom[ 0+16370] ='bxxxxxxxx;
           rom[ 0+16371] ='bxxxxxxxx;
           rom[ 0+16372] ='bxxxxxxxx;
           rom[ 0+16373] ='bxxxxxxxx;
           rom[ 0+16374] ='bxxxxxxxx;
           rom[ 0+16375] ='bxxxxxxxx;
           rom[ 0+16376] ='bxxxxxxxx;
           rom[ 0+16377] ='bxxxxxxxx;
           rom[ 0+16378] ='bxxxxxxxx;
           rom[ 0+16379] ='bxxxxxxxx;
           rom[ 0+16380] ='bxxxxxxxx;
           rom[ 0+16381] ='bxxxxxxxx;
           rom[ 0+16382] ='bxxxxxxxx;
           rom[ 0+16383] ='bxxxxxxxx;

   end//initial

   
    wire [7:0] d;


    
   assign {d}=((ce_n === 1'b0) & (oe_n === 1'b0)) ? 
                  rom[$unsigned(a)]
               :  {(7-0+1- 0){1'bz}};
    

endmodule
//
// Asynchronous serial generator with input from binary file
//
// Version : 0146
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//


module  asyncstim ( txd );
    parameter filename=0;
    parameter  [31:0]  baud =0;
    parameter interchardelay=0* `ns;
    parameter  [31:0]  bits =8;
    parameter  parity =1'b0;
    parameter  p_odd_even_n =1'b0;
    
    output txd;


integer Process1__infile;
   initial begin
           Process1__infile=$fopen(filename,"r+");
   end
reg [0:0] Process2__inited = 1'b0;
reg [7:0] Process3__chartmp;
    integer Process4__inttmp;
    reg [(bits - 1):0] tx_shiftreg;
    integer tx_bit_cnt = 0;
reg [0:0] partmp;
    reg txd;


    
   always begin
       begin 
           if (~ (Process2__inited)) 
               begin 
                   Process2__inited = 1'b1;
                   txd <= 1'b1;
               end

           #((1000000000* `ns / baud));
           tx_bit_cnt <= (tx_bit_cnt + 1);
           case (tx_bit_cnt)
               0 : begin 
                       txd <= 1'b1;
                       #(interchardelay);
                   end
               1 : begin 
                       
                       Process4__inttmp = Process3__chartmp;
                       tx_shiftreg[(bits - 1):0] <= $conv_unsigned(Process4__inttmp,bits);
                       txd <= 1'b0;
                       partmp <= p_odd_even_n;
                   end
               default : 
                   begin 
                       txd <= tx_shiftreg[0];
                       partmp <= (partmp ^ (tx_shiftreg[0] === 1'b1));
                       tx_shiftreg[(bits - 2):0] <= tx_shiftreg[(bits - 1):1];
                       if ((((tx_bit_cnt === (bits + 1)) & ~ (parity)) | ((tx_bit_cnt === (bits + 2)) & parity))) 
                               tx_bit_cnt <= 0;

                       if ((parity & (tx_bit_cnt === (bits + 2)))) 
                           begin 
                                   if (partmp) 
                                           txd <= 1'b1;
                                   else 
                                           txd <= 1'b0;

                                   
                           end 

                       
                   end
           endcase
       end
   end
                           
                       
endmodule
//
// Asynchronous serial input with binary file log
//
// Version : 0146
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//


module  asynclog ( rxd );
    parameter filename=0;
    parameter  [31:0]  baud =0;
    parameter  [31:0]  bits =8;
    parameter  parity =1'b0;
    parameter  p_odd_even_n =1'b0;
    
    input rxd;


integer Process1__outfile;
   initial begin
           Process1__outfile=$fopen(filename,"w");
   end
    reg baud16;
   initial baud16 = 1'b0;
    reg [3:0] bit_phase = 'b0000;
    reg [(bits - 1):0] rx_shiftreg = {((bits - 1)-0+1- 0){1'b0}};
    integer rx_bit_cnt = 0;
reg [0:0] partmp;


       
   always #(((1000000000* `ns / 32) / baud)) {baud16}<=~ (baud16);
   
       
   always @ (posedge baud16 ) begin
               begin 
                   begin 
                       if (((rx_bit_cnt === 0) & ((rxd === 1'b1) | (bit_phase === 'b0111)))) 
                           bit_phase <= 'b0000;
                           
                       else 
                           bit_phase <= (bit_phase + 1);
                           
                       
                       if ((rx_bit_cnt === 0)) 
                           begin 
                               begin 
                                   if ((bit_phase === 'b0111)) 
                                           rx_bit_cnt <= (rx_bit_cnt + 1);

                                   partmp <= 1'b0;
                               end
                           end 
                       else if ((bit_phase === 'b1111)) 
                           begin 
                               rx_bit_cnt <= (rx_bit_cnt + 1);
                               if ((((rx_bit_cnt === (bits + 1)) & ~ (parity)) | ((rx_bit_cnt === (bits + 2)) & parity))) 
                                   begin 
                                       rx_bit_cnt <= 0;
                                       begin 
                                            if (!((rxd === 1'b1)) ) $display(" Framing error time=%d",$time);
                                       end 
                                       $fdisplay(Process1__outfile,"%b ",to_char__0(rx_shiftreg[7:0]));
                                       
                                   end
                                   
                               else if (((rx_bit_cnt === (bits + 1)) & parity)) 
                                   begin 
                                        if (!((partmp ^ ((rxd === 1'b1) === p_odd_even_n))) ) $display(" Parity error time=%d",$time);
                                   end 
                                   
                               else 
                                   begin 
                                       partmp <= (partmp ^ (rxd === 1'b1));
                                       rx_shiftreg[(bits - 2):0] <= rx_shiftreg[(bits - 1):1];
                                       rx_shiftreg[(bits - 1)] <= rxd;
                                   end
                                   
                               
                               
                           end
                           
                       
                       
                   end
                   
               end 
           
   end //always
                                           
                                           function [7:0] to_char__0;
                                               input [7:0]  byte ;
                                               begin : Function
                                                       begin 
                                                           to_char__0=$unsigned(byte);
                                                           disable Function;
                                                       end
                                               end // Function
                                           endfunction

                                           
                                       
endmodule
// 16 MHz clock
//TAK Jan.23.2004 31.25 ns;



module  testbench; // Null Port List
    

    wire m1_n;
    wire mreq_n;
    wire iorq_n;
    wire rd_n;
    wire wr_n;
    wire rfsh_n;
    wire halt_n;
    reg wait_n;
   initial wait_n = 1'b1;
    reg /* conflict */int_n_=1'bz;
    wire /* conflict */int_n;//Veritak Note: Ignored default expression.
    reg /* conflict */nmi_n_=1'bz;
    wire /* conflict */nmi_n;//Veritak Note: Ignored default expression.
    reg reset_n;
    reg busrq_n;
   initial busrq_n = 1'b1;
    wire busak_n;
    reg clk_n;
   initial clk_n = 1'b0;
    wire [15:0] a;
    wire [7:0] d;
    wire [7:0] uart_d;
    wire baudout;
    wire txd;
    wire rxd;
    reg cts;
   initial cts = 1'b0;
    reg dsr;
   initial dsr = 1'b0;
    reg ri;
   initial ri = 1'b1;
    reg dcd;
   initial dcd = 1'b0;
    wire iowr_n;
    wire romcs_n;
    wire ramcs_n;
    wire uartcs_n;

       
       initial begin 
                   {reset_n}<=1'b0;
        #(1* `us) {reset_n}<=1'b1;
       end//end initial
   
   always #(10 * `ns) {clk_n}<=~ (clk_n);
   
   assign {iowr_n}=(wr_n | iorq_n);
   
   assign {romcs_n}=(a[15] | mreq_n);
   
   assign {ramcs_n}=(~ (a[15]) | mreq_n);
   
   assign {uartcs_n}=((iorq_n === 1'b0) & (a[7:3] === 'b00000)) ? 
                         1'b0
                      :  1'b1;
   
   assign {nmi_n}=1'b1;
   
   assign {int_n}=1'b1;
   
   asynclog  #("RX_Log.txt",1000000,8,1'b0,1'b0) al(.rxd(txd));
   //Parameter Order: filename,baud,bits,parity,p_odd_even_n 

   t80a  #(/*open */) u0(.reset_n(reset_n), .clk_n(clk_n), .wait_n(wait_n), .int_n(int_n), .nmi_n(nmi_n), .busrq_n(busrq_n), .m1_n(m1_n), .mreq_n(mreq_n), .iorq_n(iorq_n), .rd_n(rd_n), .wr_n(wr_n), .rfsh_n(rfsh_n), .halt_n(halt_n), .busak_n(busak_n), .a(a), .d(d));
   //Parameter Order: mode 

   rom80 u1(.ce_n(romcs_n), .oe_n(rd_n), .a(a[14:0]), .d(d));
   
   sram  #(15,/*open */) u2(.ce_n(ramcs_n), .oe_n(rd_n), .we_n(wr_n), .a(a[14:0]), .d(d));
   //Parameter Order: addrwidth,datawidth 

   assign {d}=((uartcs_n === 1'b0) & (rd_n === 1'b0)) ? 
                  uart_d
               :  'bZZZZZZZZ;
   
   t16450 u3(.mr_n(reset_n), .xin(clk_n), .rclk(baudout), .cs_n(uartcs_n), .rd_n(rd_n), .wr_n(iowr_n), .a(a[2:0]), .d_in(d), .d_out(uart_d), .sin(rxd), .cts_n(cts), .dsr_n(dsr), .ri_n(ri), .dcd_n(dcd), .sout(txd), .rts_n(/*open */), .dtr_n(/*open */), .out1_n(/*open */), .out2_n(/*open */), .baudout(baudout), .intr(/*open */));
           assign int_n = int_n_;//Added for Conflict reslover.
    assign nmi_n = nmi_n_;//Added for Conflict reslover.
       
   
endmodule

