//-------------------------------------------------------------------
//
//   This file is automatically generated by VHDL to Verilog Translator.
//         Ver.1.08 Build Mar.6.2004
//               www.sugawara-systems.com   
//                    tech-support@sugawara-systems.com
//        See Original Copyright Notice for property of the file .( somewhere in this file.)
//
//--------------------------------------------------------------------


//
// Z80 compatible microprocessor core, asynchronous top level
//
// Version : 0247
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0208 : First complete release
//
//	0211 : Fixed interrupt cycle
//
//	0235 : Updated for T80 interface change
//
//	0238 : Updated for T80 interface change
//
//	0240 : Updated for T80 interface change
//
//	0242 : Updated for T80 interface change
//
//	0247 : Fixed bus req/ack cycle
//

`timescale 1ns/1ns
`define ns 1
`define us (1000*`ns)
`define ms (1000*`us)
`define sec (1000*`ms)

module  t80a ( reset_n, clk_n, wait_n, int_n, nmi_n, busrq_n, m1_n, mreq_n, iorq_n, rd_n, wr_n, rfsh_n, halt_n, busak_n, a, d );
    parameter  [31:0]  mode =0;
    
    input reset_n;
    input clk_n;
    input wait_n;
    input int_n;
    input nmi_n;
    input busrq_n;
    output m1_n;
    output mreq_n;
    output iorq_n;
    output rd_n;
    output wr_n;
    output rfsh_n;
    output halt_n;
    output busak_n;
    output [15:0]  a ;
    inout [7:0]  d ;


    wire cen;
    reg reset_s;
    wire intcycle_n;
    wire iorq;
    wire noread;
    wire write;
    reg mreq;
    reg mreq_inhibit;
    reg req_inhibit;
    reg rd;
    wire mreq_n_i;
    reg iorq_n_i;
    wire rd_n_i;
    reg wr_n_i;
    wire rfsh_n_i;
    wire busak_n_i;
    wire [15:0] a_i;
    wire [7:0] do;
    reg [7:0] di_reg;
    reg wait_s;
    wire [2:0] mcycle;
    wire [2:0] tstate;
    wire m1_n;
    wire mreq_n;
    wire iorq_n;
    wire rd_n;
    wire wr_n;
    wire rfsh_n;
    wire halt_n;
    wire busak_n;
    wire [15:0] a;
    wire [7:0] d;


    
   assign {cen}=1'b1;
   
   assign {busak_n}=busak_n_i;
   
   assign {mreq_n_i}=(~ (mreq) | (req_inhibit & mreq_inhibit));
   
   assign {rd_n_i}=(~ (rd) | req_inhibit);
   
   assign {mreq_n}=(busak_n_i === 1'b1) ? 
                       mreq_n_i
                    :  1'bz;
   
   assign {iorq_n}=(busak_n_i === 1'b1) ? 
                       iorq_n_i
                    :  1'bz;
   
   assign {rd_n}=(busak_n_i === 1'b1) ? 
                     rd_n_i
                  :  1'bz;
   
   assign {wr_n}=(busak_n_i === 1'b1) ? 
                     wr_n_i
                  :  1'bz;
   
   assign {rfsh_n}=(busak_n_i === 1'b1) ? 
                       rfsh_n_i
                    :  1'bz;
   
   assign {a}=(busak_n_i === 1'b1) ? 
                  a_i
               :  {(15-0+1- 0){1'bz}};
   
   assign {d}=((write === 1'b1) & (busak_n_i === 1'b1)) ? 
                  do
               :  {(7-0+1- 0){1'bz}};
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               reset_s <= 1'b0;
               
           else 
               reset_s <= 1'b1;
               
           
   end //always
   
   t80  #(mode,1,0,1,2,3,4,5,6,7) u0(.reset_n(reset_s), .clk_n(clk_n), .cen(cen), .wait_n(wait_s), .int_n(int_n), .nmi_n(nmi_n), .busrq_n(busrq_n), .m1_n(m1_n), .iorq(iorq), .noread(noread), .write(write), .rfsh_n(rfsh_n_i), .halt_n(halt_n), .busak_n(busak_n_i), .a(a_i), .dinst(d), .di(di_reg), .do(do), .mc(mcycle), .ts(tstate), .intcycle_n(intcycle_n), .inte(/*open */), .stop(/*open */));
   //Parameter Order: mode,iowait,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s 

       
   always @ (negedge clk_n ) begin
               begin 
                   wait_s <= wait_n;
                   if (((tstate === 3'b011) & (busak_n_i === 1'b1))) 
                       di_reg <= d;
                       
                   
                   
               end
               
           
   end //always
   
       
   always @ (negedge reset_s or posedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               wr_n_i <= 1'b1;
               
           else 
               begin 
                   wr_n_i <= 1'b1;
                   if ((tstate === 3'b001)) 
                       wr_n_i <= ~ (write);
                       
                   
                   
               end
               
           
   end //always
   
       
   always @ (negedge reset_s or posedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               req_inhibit <= 1'b0;
               
           else 
               begin 
                   if (((mcycle === 3'b001) & (tstate === 3'b010))) 
                       req_inhibit <= 1'b1;
                       
                   else 
                       req_inhibit <= 1'b0;
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_s or negedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               mreq_inhibit <= 1'b0;
               
           else 
               begin 
                   if (((mcycle === 3'b001) & (tstate === 3'b010))) 
                       mreq_inhibit <= 1'b1;
                       
                   else 
                       mreq_inhibit <= 1'b0;
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_s or negedge clk_n ) begin
           if ((reset_s === 1'b0)) 
               begin 
                   rd <= 1'b0;
                   iorq_n_i <= 1'b1;
                   mreq <= 1'b0;
               end
               
           else 
               begin 
                   if ((mcycle === 3'b001)) 
                       begin 
                           begin 
                               if ((tstate === 3'b001)) 
                                   begin 
                                       rd <= intcycle_n;
                                       mreq <= intcycle_n;
                                       iorq_n_i <= intcycle_n;
                                   end

                               if ((tstate === 3'b011)) 
                                   begin 
                                       rd <= 1'b0;
                                       iorq_n_i <= 1'b1;
                                       mreq <= 1'b1;
                                   end

                               if ((tstate === 3'b100)) 
                                       mreq <= 1'b0;

                               
                           end
                       end 
                   else 
                       begin 
                           begin 
                               if (((tstate === 3'b001) & (noread === 1'b0))) 
                                   begin 
                                       rd <= ~ (write);
                                       iorq_n_i <= ~ (iorq);
                                       mreq <= ~ (iorq);
                                   end

                               if ((tstate === 3'b011)) 
                                   begin 
                                       rd <= 1'b0;
                                       iorq_n_i <= 1'b1;
                                       mreq <= 1'b0;
                                   end

                               
                           end
                       end 
                   
                   
               end 
           
   end //always
    

endmodule
//
// T80 Registers, technology independent
//
// Version : 0244
//
// Copyright (c) 2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//
//	0242 : Initial release
//
//	0244 : Changed to single register file
//


module  t80_reg ( clk, cen, weh, wel, addra, addrb, addrc, dih, dil, doah, doal, dobh, dobl, doch, docl );
    
    input clk;
    input cen;
    input weh;
    input wel;
    input [2:0]  addra ;
    input [2:0]  addrb ;
    input [2:0]  addrc ;
    input [7:0]  dih ;
    input [7:0]  dil ;
    output [7:0]  doah ;
    output [7:0]  doal ;
    output [7:0]  dobh ;
    output [7:0]  dobl ;
    output [7:0]  doch ;
    output [7:0]  docl ;


//type register_image

reg [7:0] regsh [0:7];
reg [7:0] regsl [0:7];
    wire [7:0] doah;
    wire [7:0] doal;
    wire [7:0] dobh;
    wire [7:0] dobl;
    wire [7:0] doch;
    wire [7:0] docl;


    
       
   always @ (posedge clk ) begin
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                           begin 
                               if ((weh === 1'b1)) 
                                       regsh[$unsigned(addra)] <= dih;

                               if ((wel === 1'b1)) 
                                       regsl[$unsigned(addra)] <= dil;

                               
                           end
                       end 
                   
                   
               end 
           
   end //always
   
   assign {doah}=regsh[$unsigned(addra)];
   
   assign {doal}=regsl[$unsigned(addra)];
   
   assign {dobh}=regsh[$unsigned(addrb)];
   
   assign {dobl}=regsl[$unsigned(addrb)];
   
   assign {doch}=regsh[$unsigned(addrc)];
   
   assign {docl}=regsl[$unsigned(addrc)];
    

endmodule
//
// Z80 compatible microprocessor core
//
// Version : 0242
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//

//
// Z80 compatible microprocessor core
//
// Version : 0242
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0208 : First complete release
//
//	0211 : Fixed IM 1
//
//	0214 : Fixed mostly flags, only the block instructions now fail the zex regression test
//
//	0235 : Added IM 2 fix by Mike Johnson
//
//	0238 : Added NoRead signal
//
//	0238b: Fixed instruction timing for POP and DJNZ
//
//	0240 : Added (IX/IY+d) states, removed op-codes from mode 2 and added all remaining mode 3 op-codes
//
//	0242 : Fixed I/O instruction timing, cleanup
//


module  t80_mcode ( ir, iset, mcycle, f, nmicycle, intcycle, mcycles, tstates, prefix, inc_pc, inc_wz, incdec_16, read_to_reg, read_to_acc, set_busa_to, set_busb_to, alu_op, save_alu, preservec, arith16, set_addr_to, iorq, jump, jumpe, jumpxy, call, rstp, ldz, ldw, ldsphl, special_ld, exchangedh, exchangerp, exchangeaf, exchangers, i_djnz, i_cpl, i_ccf, i_scf, i_retn, i_bt, i_bc, i_btr, i_rld, i_rrd, i_inrc, setdi, setei, imode, halt, noread, write );
    parameter  [31:0]  mode =0;
    parameter  [31:0]  flag_c =0;
    parameter  [31:0]  flag_n =1;
    parameter  [31:0]  flag_p =2;
    parameter  [31:0]  flag_x =3;
    parameter  [31:0]  flag_h =4;
    parameter  [31:0]  flag_y =5;
    parameter  [31:0]  flag_z =6;
    parameter  [31:0]  flag_s =7;
    
    input [7:0]  ir ;
    input [1:0]  iset ;
    input [2:0]  mcycle ;
    input [7:0]  f ;
    input nmicycle;
    input intcycle;
    output [2:0]  mcycles ;
    output [2:0]  tstates ;
    output [1:0]  prefix ;
    output inc_pc;
    output inc_wz;
    output [3:0]  incdec_16 ;
    output read_to_reg;
    output read_to_acc;
    output [3:0]  set_busa_to ;
    output [3:0]  set_busb_to ;
    output [3:0]  alu_op ;
    output save_alu;
    output preservec;
    output arith16;
    output [2:0]  set_addr_to ;
    output iorq;
    output jump;
    output jumpe;
    output jumpxy;
    output call;
    output rstp;
    output ldz;
    output ldw;
    output ldsphl;
    output [2:0]  special_ld ;
    output exchangedh;
    output exchangerp;
    output exchangeaf;
    output exchangers;
    output i_djnz;
    output i_cpl;
    output i_ccf;
    output i_scf;
    output i_retn;
    output i_bt;
    output i_bc;
    output i_btr;
    output i_rld;
    output i_rrd;
    output i_inrc;
    output setdi;
    output setei;
    output [1:0]  imode ;
    output halt;
    output noread;
    output write;


    reg [2:0] Process1__ddd;
    reg [2:0] Process2__sss;
    reg [1:0] Process3__dpair;
    reg [7:0] Process4__irb=0;
    parameter [2:0] anone=3'b111;
    parameter [2:0] abc=3'b000;
    parameter [2:0] ade=3'b001;
    parameter [2:0] axy=3'b010;
    parameter [2:0] aioa=3'b100;
    parameter [2:0] asp=3'b101;
    parameter [2:0] azi=3'b110;
    reg [2:0] mcycles;
    reg [2:0] tstates;
    reg [1:0] prefix;
    reg inc_pc;
    reg inc_wz;
    reg [3:0] incdec_16;
    reg read_to_reg;
    reg read_to_acc;
    reg [3:0] set_busa_to;
    reg [3:0] set_busb_to;
    reg [3:0] alu_op;
    reg save_alu;
    reg preservec;
    reg arith16;
    reg [2:0] set_addr_to;
    reg iorq;
    reg jump;
    reg jumpe;
    reg jumpxy;
    reg call;
    reg rstp;
    reg ldz;
    reg ldw;
    reg ldsphl;
    reg [2:0] special_ld;
    reg exchangedh;
    reg exchangerp;
    reg exchangeaf;
    reg exchangers;
    reg i_djnz;
    reg i_cpl;
    reg i_ccf;
    reg i_scf;
    reg i_retn;
    reg i_bt;
    reg i_bc;
    reg i_btr;
    reg i_rld;
    reg i_rrd;
    reg i_inrc;
    reg setdi;
    reg setei;
    reg [1:0] imode;
    reg halt;
    reg noread;
    reg write;


    
       
   always @ (ir or iset or mcycle or f or nmicycle or intcycle ) begin
           Process1__ddd = ir[5:3];
           Process2__sss = ir[2:0];
           Process3__dpair = ir[5:4];
           Process4__irb = ir;
           mcycles <= 3'b001;
           if ((mcycle === 3'b001)) 
               tstates <= 3'b100;
               
           else 
               tstates <= 3'b011;
               
           prefix <= 2'b00;
           inc_pc <= 1'b0;
           inc_wz <= 1'b0;
           incdec_16 <= 4'b0000;
           read_to_acc <= 1'b0;
           read_to_reg <= 1'b0;
           set_busb_to <= 4'b0000;
           set_busa_to <= 4'b0000;
           alu_op <= {1'b0,ir[5:3]};
           save_alu <= 1'b0;
           preservec <= 1'b0;
           arith16 <= 1'b0;
           iorq <= 1'b0;
           set_addr_to <= 3'b111;
           jump <= 1'b0;
           jumpe <= 1'b0;
           jumpxy <= 1'b0;
           call <= 1'b0;
           rstp <= 1'b0;
           ldz <= 1'b0;
           ldw <= 1'b0;
           ldsphl <= 1'b0;
           special_ld <= 3'b000;
           exchangedh <= 1'b0;
           exchangerp <= 1'b0;
           exchangeaf <= 1'b0;
           exchangers <= 1'b0;
           i_djnz <= 1'b0;
           i_cpl <= 1'b0;
           i_ccf <= 1'b0;
           i_scf <= 1'b0;
           i_retn <= 1'b0;
           i_bt <= 1'b0;
           i_bc <= 1'b0;
           i_btr <= 1'b0;
           i_rld <= 1'b0;
           i_rrd <= 1'b0;
           i_inrc <= 1'b0;
           setdi <= 1'b0;
           setei <= 1'b0;
           imode <= 2'b11;
           halt <= 1'b0;
           noread <= 1'b0;
           write <= 1'b0;
           case (iset)
               2'b00 : 
                       case (Process4__irb)
                           8'b01000000,8'b01000001,8'b01000010,8'b01000011,8'b01000100,8'b01000101,8'b01000111,8'b01001000,8'b01001001,8'b01001010,8'b01001011,8'b01001100,8'b01001101,8'b01001111,8'b01010000,8'b01010001,8'b01010010,8'b01010011,8'b01010100,8'b01010101,8'b01010111,8'b01011000,8'b01011001,8'b01011010,8'b01011011,8'b01011100,8'b01011101,8'b01011111,8'b01100000,8'b01100001,8'b01100010,8'b01100011,8'b01100100,8'b01100101,8'b01100111,8'b01101000,8'b01101001,8'b01101010,8'b01101011,8'b01101100,8'b01101101,8'b01101111,8'b01111000,8'b01111001,8'b01111010,8'b01111011,8'b01111100,8'b01111101,8'b01111111 : 
                               begin 
                                   set_busb_to[2:0] <= Process2__sss;
                                   exchangerp <= 1'b1;
                                   set_busa_to[2:0] <= Process1__ddd;
                                   read_to_reg <= 1'b1;
                               end
                           8'b00000110,8'b00001110,8'b00010110,8'b00011110,8'b00100110,8'b00101110,8'b00111110 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               set_busa_to[2:0] <= Process1__ddd;
                                               read_to_reg <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b01000110,8'b01001110,8'b01010110,8'b01011110,8'b01100110,8'b01101110,8'b01111110 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b010;
                                       2 : begin 
                                               set_busa_to[2:0] <= Process1__ddd;
                                               read_to_reg <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b01110000,8'b01110001,8'b01110010,8'b01110011,8'b01110100,8'b01110101,8'b01110111 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b010;
                                               set_busb_to[2:0] <= Process2__sss;
                                               set_busb_to[3] <= 1'b0;
                                           end
                                       2 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00110110 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               set_addr_to <= 3'b010;
                                               set_busb_to[2:0] <= Process2__sss;
                                               set_busb_to[3] <= 1'b0;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00001010 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b000;
                                       2 :     read_to_acc <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00011010 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b001;
                                       2 :     read_to_acc <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00111010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 3'b010;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 3'b010;
                                               2 : begin 
                                                       read_to_acc <= 1'b1;
                                                       incdec_16 <= 4'b1110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 3'b100;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 3'b110;
                                                       inc_pc <= 1'b1;
                                                   end
                                               4 :     read_to_acc <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00000010 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b000;
                                               set_busb_to <= 4'b0111;
                                           end
                                       2 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00010010 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b001;
                                               set_busb_to <= 4'b0111;
                                           end
                                       2 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00110010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 3'b010;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       set_addr_to <= 3'b010;
                                                       set_busb_to <= 4'b0111;
                                                   end
                                               2 : begin 
                                                       write <= 1'b1;
                                                       incdec_16 <= 4'b1110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 3'b100;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 3'b110;
                                                       inc_pc <= 1'b1;
                                                       set_busb_to <= 4'b0111;
                                                   end
                                               4 :     write <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00000001,8'b00010001,8'b00100001,8'b00110001 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 2'b11)) 
                                                       set_busa_to[3:0] <= 4'b1000;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b1;
                                                   end

                                               
                                           end
                                       3 : begin 
                                               inc_pc <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 2'b11)) 
                                                       set_busa_to[3:0] <= 4'b1001;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b0;
                                                   end

                                               
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00101010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 3'b010;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 3'b010;
                                               2 : begin 
                                                       read_to_acc <= 1'b1;
                                                       incdec_16 <= 4'b0110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 3'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 3'b110;
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                   end
                                               4 : begin 
                                                       set_busa_to[2:0] <= 3'b101;
                                                       read_to_reg <= 1'b1;
                                                       inc_wz <= 1'b1;
                                                       set_addr_to <= 3'b110;
                                                   end
                                               5 : begin 
                                                       set_busa_to[2:0] <= 3'b100;
                                                       read_to_reg <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00100010 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 3'b010;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       set_addr_to <= 3'b010;
                                                       set_busb_to <= 4'b0111;
                                                   end
                                               2 : begin 
                                                       write <= 1'b1;
                                                       incdec_16 <= 4'b0110;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       begin 
                                           mcycles <= 3'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 3'b110;
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                       set_busb_to <= 4'b0101;
                                                   end
                                               4 : begin 
                                                       inc_wz <= 1'b1;
                                                       set_addr_to <= 3'b110;
                                                       write <= 1'b1;
                                                       set_busb_to <= 4'b0100;
                                                   end
                                               5 :     write <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11111001 : 
                               begin 
                                   tstates <= 3'b110;
                                   ldsphl <= 1'b1;
                               end
                           8'b11000101,8'b11010101,8'b11100101,8'b11110101 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 3'b101;
                                               incdec_16 <= 4'b1111;
                                               set_addr_to <= 3'b101;
                                               if ((Process3__dpair === 2'b11)) 
                                                       set_busb_to <= 4'b0111;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= Process3__dpair;
                                                       set_busb_to[0] <= 1'b0;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               
                                           end
                                       2 : begin 
                                               incdec_16 <= 4'b1111;
                                               set_addr_to <= 3'b101;
                                               if ((Process3__dpair === 2'b11)) 
                                                       set_busb_to <= 4'b1011;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= Process3__dpair;
                                                       set_busb_to[0] <= 1'b1;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               write <= 1'b1;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11000001,8'b11010001,8'b11100001,8'b11110001 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b101;
                                       2 : begin 
                                               incdec_16 <= 4'b0111;
                                               set_addr_to <= 3'b101;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 2'b11)) 
                                                       set_busa_to[3:0] <= 4'b1011;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b1;
                                                   end

                                               
                                           end
                                       3 : begin 
                                               incdec_16 <= 4'b0111;
                                               read_to_reg <= 1'b1;
                                               if ((Process3__dpair === 2'b11)) 
                                                       set_busa_to[3:0] <= 4'b0111;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= Process3__dpair;
                                                       set_busa_to[0] <= 1'b0;
                                                   end

                                               
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11101011 : 
                                   if ((!(mode===3))) 
                                           exchangedh <= 1'b1;

                                   
                           8'b00001000 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 3'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       set_addr_to <= 3'b110;
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                       set_busb_to <= 4'b1000;
                                                   end
                                               4 : begin 
                                                       inc_wz <= 1'b1;
                                                       set_addr_to <= 3'b110;
                                                       write <= 1'b1;
                                                       set_busb_to <= 4'b1001;
                                                   end
                                               5 :     write <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else if ((mode < 2)) 
                                           exchangeaf <= 1'b1;

                                   
                           8'b11011001 : 
                                   if ((mode === 3)) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 3'b101;
                                               2 : begin 
                                                       incdec_16 <= 4'b0111;
                                                       set_addr_to <= 3'b101;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       jump <= 1'b1;
                                                       incdec_16 <= 4'b0111;
                                                       i_retn <= 1'b1;
                                                       setei <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else if ((mode < 2)) 
                                           exchangers <= 1'b1;

                                   
                           8'b11100011 : 
                                   if ((!(mode===3))) 
                                       begin 
                                           mcycles <= 3'b101;
                                           case ($unsigned(mcycle))
                                               1 :     set_addr_to <= 3'b101;
                                               2 : begin 
                                                       read_to_reg <= 1'b1;
                                                       set_busa_to <= 4'b0101;
                                                       set_busb_to <= 4'b0101;
                                                       set_addr_to <= 3'b101;
                                                   end
                                               3 : begin 
                                                       incdec_16 <= 4'b0111;
                                                       set_addr_to <= 3'b101;
                                                       tstates <= 3'b100;
                                                       write <= 1'b1;
                                                   end
                                               4 : begin 
                                                       read_to_reg <= 1'b1;
                                                       set_busa_to <= 4'b0100;
                                                       set_busb_to <= 4'b0100;
                                                       set_addr_to <= 3'b101;
                                                   end
                                               5 : begin 
                                                       incdec_16 <= 4'b1111;
                                                       tstates <= 3'b101;
                                                       write <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b10000000,8'b10000001,8'b10000010,8'b10000011,8'b10000100,8'b10000101,8'b10000111,8'b10001000,8'b10001001,8'b10001010,8'b10001011,8'b10001100,8'b10001101,8'b10001111,8'b10010000,8'b10010001,8'b10010010,8'b10010011,8'b10010100,8'b10010101,8'b10010111,8'b10011000,8'b10011001,8'b10011010,8'b10011011,8'b10011100,8'b10011101,8'b10011111,8'b10100000,8'b10100001,8'b10100010,8'b10100011,8'b10100100,8'b10100101,8'b10100111,8'b10101000,8'b10101001,8'b10101010,8'b10101011,8'b10101100,8'b10101101,8'b10101111,8'b10110000,8'b10110001,8'b10110010,8'b10110011,8'b10110100,8'b10110101,8'b10110111,8'b10111000,8'b10111001,8'b10111010,8'b10111011,8'b10111100,8'b10111101,8'b10111111 : 
                               begin 
                                   set_busb_to[2:0] <= Process2__sss;
                                   set_busa_to[2:0] <= 3'b111;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                               end
                           8'b10000110,8'b10001110,8'b10010110,8'b10011110,8'b10100110,8'b10101110,8'b10110110,8'b10111110 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b010;
                                       2 : begin 
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busb_to[2:0] <= Process2__sss;
                                               set_busa_to[2:0] <= 3'b111;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11000110,8'b11001110,8'b11010110,8'b11011110,8'b11100110,8'b11101110,8'b11110110,8'b11111110 : 
                               begin 
                                   mcycles <= 3'b010;
                                   if ((mcycle === 3'b010)) 
                                       begin 
                                           inc_pc <= 1'b1;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                           set_busb_to[2:0] <= Process2__sss;
                                           set_busa_to[2:0] <= 3'b111;
                                       end

                                   
                               end
                           8'b00000100,8'b00001100,8'b00010100,8'b00011100,8'b00100100,8'b00101100,8'b00111100 : 
                               begin 
                                   set_busb_to <= 4'b1010;
                                   set_busa_to[2:0] <= Process1__ddd;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                                   preservec <= 1'b1;
                                   alu_op <= 4'b0000;
                               end
                           8'b00110100 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b010;
                                       2 : begin 
                                               tstates <= 3'b100;
                                               set_addr_to <= 3'b010;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               preservec <= 1'b1;
                                               alu_op <= 4'b0000;
                                               set_busb_to <= 4'b1010;
                                               set_busa_to[2:0] <= Process1__ddd;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00000101,8'b00001101,8'b00010101,8'b00011101,8'b00100101,8'b00101101,8'b00111101 : 
                               begin 
                                   set_busb_to <= 4'b1010;
                                   set_busa_to[2:0] <= Process1__ddd;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                                   preservec <= 1'b1;
                                   alu_op <= 4'b0010;
                               end
                           8'b00110101 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b010;
                                       2 : begin 
                                               tstates <= 3'b100;
                                               set_addr_to <= 3'b010;
                                               alu_op <= 4'b0010;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               preservec <= 1'b1;
                                               set_busb_to <= 4'b1010;
                                               set_busa_to[2:0] <= Process1__ddd;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b00100111 : 
                               begin 
                                   set_busa_to[2:0] <= 3'b111;
                                   read_to_reg <= 1'b1;
                                   alu_op <= 4'b1100;
                                   save_alu <= 1'b1;
                               end
                           8'b00101111 : 
                                   i_cpl <= 1'b1;
                           8'b00111111 : 
                                   i_ccf <= 1'b1;
                           8'b00110111 : 
                                   i_scf <= 1'b1;
                           8'b00000000 : 
                                   if ((nmicycle === 1'b1)) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       tstates <= 3'b101;
                                                       incdec_16 <= 4'b1111;
                                                       set_addr_to <= 3'b101;
                                                       set_busb_to <= 4'b1101;
                                                   end
                                               2 : begin 
                                                       tstates <= 3'b100;
                                                       write <= 1'b1;
                                                       incdec_16 <= 4'b1111;
                                                       set_addr_to <= 3'b101;
                                                       set_busb_to <= 4'b1100;
                                                   end
                                               3 : begin 
                                                       tstates <= 3'b100;
                                                       write <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else if ((intcycle === 1'b1)) 
                                       begin 
                                           mcycles <= 3'b101;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       ldz <= 1'b1;
                                                       tstates <= 3'b101;
                                                       incdec_16 <= 4'b1111;
                                                       set_addr_to <= 3'b101;
                                                       set_busb_to <= 4'b1101;
                                                   end
                                               2 : begin 
                                                       tstates <= 3'b100;
                                                       write <= 1'b1;
                                                       incdec_16 <= 4'b1111;
                                                       set_addr_to <= 3'b101;
                                                       set_busb_to <= 4'b1100;
                                                   end
                                               3 : begin 
                                                       tstates <= 3'b100;
                                                       write <= 1'b1;
                                                   end
                                               4 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               5 :     jump <= 1'b1;
                                               default : 
                                                       ;//null
                                           endcase
                                       end
                                   else 
                                       ;//Null

                                   
                           8'b01110110 : 
                                   halt <= 1'b1;
                           8'b11110011 : 
                                   setdi <= 1'b1;
                           8'b11111011 : 
                                   setei <= 1'b1;
                           8'b00001001,8'b00011001,8'b00101001,8'b00111001 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 4'b0000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 3'b101;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b1;
                                                       end
                                                   default : 
                                                           set_busb_to <= 4'b1000;
                                               endcase
                                               tstates <= 3'b100;
                                               arith16 <= 1'b1;
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 4'b0001;
                                               set_busa_to[2:0] <= 3'b100;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                   default : 
                                                           set_busb_to <= 4'b1001;
                                               endcase
                                               arith16 <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b00000011,8'b00010011,8'b00100011,8'b00110011 : 
                               begin 
                                   tstates <= 3'b110;
                                   incdec_16[3:2] <= 2'b01;
                                   incdec_16[1:0] <= Process3__dpair;
                               end
                           8'b00001011,8'b00011011,8'b00101011,8'b00111011 : 
                               begin 
                                   tstates <= 3'b110;
                                   incdec_16[3:2] <= 2'b11;
                                   incdec_16[1:0] <= Process3__dpair;
                               end
                           8'b00000111,8'b00010111,8'b00001111,8'b00011111 : 
                               begin 
                                   set_busa_to[2:0] <= 3'b111;
                                   alu_op <= 4'b1000;
                                   read_to_reg <= 1'b1;
                                   save_alu <= 1'b1;
                               end
                           8'b11000011 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               inc_pc <= 1'b1;
                                               jump <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11000010,8'b11001010,8'b11010010,8'b11011010,8'b11100010,8'b11101010,8'b11110010,8'b11111010 : 
                                   if (((ir[5] === 1'b1) & (mode === 3))) 
                                           case (Process4__irb[4:3])
                                               2'b00 : 
                                                   begin 
                                                       mcycles <= 3'b010;
                                                       case ($unsigned(mcycle))
                                                           1 : begin 
                                                                   set_addr_to <= 3'b000;
                                                                   set_busb_to <= 4'b0111;
                                                               end
                                                           2 : begin 
                                                                   write <= 1'b1;
                                                                   iorq <= 1'b1;
                                                               end
                                                           default : 
                                                               ;
                                                       endcase
                                                   end
                                               2'b01 : 
                                                   begin 
                                                       mcycles <= 3'b100;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   ldz <= 1'b1;
                                                               end
                                                           3 : begin 
                                                                   set_addr_to <= 3'b110;
                                                                   inc_pc <= 1'b1;
                                                                   set_busb_to <= 4'b0111;
                                                               end
                                                           4 :     write <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                               2'b10 : 
                                                   begin 
                                                       mcycles <= 3'b010;
                                                       case ($unsigned(mcycle))
                                                           1 :     set_addr_to <= 3'b000;
                                                           2 : begin 
                                                                   read_to_acc <= 1'b1;
                                                                   iorq <= 1'b1;
                                                               end
                                                           default : 
                                                               ;
                                                       endcase
                                                   end
                                               2'b11 : 
                                                   begin 
                                                       mcycles <= 3'b100;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   ldz <= 1'b1;
                                                               end
                                                           3 : begin 
                                                                   set_addr_to <= 3'b110;
                                                                   inc_pc <= 1'b1;
                                                               end
                                                           4 :     read_to_acc <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                           endcase
                                   else 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       inc_pc <= 1'b1;
                                                       if (is_cc_true__0(f, ir[5:3])) 
                                                               jump <= 1'b1;

                                                       
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00011000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 :     inc_pc <= 1'b1;
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 3'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00111000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_c] === 1'b0)) 
                                                               mcycles <= 3'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 3'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00110000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_c] === 1'b1)) 
                                                               mcycles <= 3'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 3'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00101000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_z] === 1'b0)) 
                                                               mcycles <= 3'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 3'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b00100000 : 
                                   if ((!(mode===2))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       if ((f[flag_z] === 1'b1)) 
                                                               mcycles <= 3'b010;

                                                       
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 3'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11101001 : 
                                   jumpxy <= 1'b1;
                           8'b00010000 : 
                                   if ((mode === 3)) 
                                           i_djnz <= 1'b1;
                                   else if ((mode < 2)) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       tstates <= 3'b101;
                                                       i_djnz <= 1'b1;
                                                       set_busb_to <= 4'b1010;
                                                       set_busa_to[2:0] <= 3'b000;
                                                       read_to_reg <= 1'b1;
                                                       save_alu <= 1'b1;
                                                       alu_op <= 4'b0010;
                                                   end
                                               2 : begin 
                                                       i_djnz <= 1'b1;
                                                       inc_pc <= 1'b1;
                                                   end
                                               3 : begin 
                                                       noread <= 1'b1;
                                                       jumpe <= 1'b1;
                                                       tstates <= 3'b101;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11001101 : 
                               begin 
                                   mcycles <= 3'b101;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               incdec_16 <= 4'b1111;
                                               inc_pc <= 1'b1;
                                               tstates <= 3'b100;
                                               set_addr_to <= 3'b101;
                                               ldw <= 1'b1;
                                               set_busb_to <= 4'b1101;
                                           end
                                       4 : begin 
                                               write <= 1'b1;
                                               incdec_16 <= 4'b1111;
                                               set_addr_to <= 3'b101;
                                               set_busb_to <= 4'b1100;
                                           end
                                       5 : begin 
                                               write <= 1'b1;
                                               call <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11000100,8'b11001100,8'b11010100,8'b11011100,8'b11100100,8'b11101100,8'b11110100,8'b11111100 : 
                                   if (((ir[5] === 1'b0) | (!(mode===3)))) 
                                       begin 
                                           mcycles <= 3'b101;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       inc_pc <= 1'b1;
                                                       ldw <= 1'b1;
                                                       if (is_cc_true__0(f, ir[5:3])) 
                                                           begin 
                                                               incdec_16 <= 4'b1111;
                                                               set_addr_to <= 3'b101;
                                                               tstates <= 3'b100;
                                                               set_busb_to <= 4'b1101;
                                                           end
                                                       else 
                                                               mcycles <= 3'b011;

                                                       
                                                   end
                                               4 : begin 
                                                       write <= 1'b1;
                                                       incdec_16 <= 4'b1111;
                                                       set_addr_to <= 3'b101;
                                                       set_busb_to <= 4'b1100;
                                                   end
                                               5 : begin 
                                                       write <= 1'b1;
                                                       call <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11001001 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 3'b101;
                                               set_addr_to <= 3'b101;
                                           end
                                       2 : begin 
                                               incdec_16 <= 4'b0111;
                                               set_addr_to <= 3'b101;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               jump <= 1'b1;
                                               incdec_16 <= 4'b0111;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11000000,8'b11001000,8'b11010000,8'b11011000,8'b11100000,8'b11101000,8'b11110000,8'b11111000 : 
                                   if (((ir[5] === 1'b1) & (mode === 3))) 
                                           case (Process4__irb[4:3])
                                               2'b00 : 
                                                   begin 
                                                       mcycles <= 3'b011;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   set_addr_to <= 3'b100;
                                                                   set_busb_to <= 4'b0111;
                                                               end
                                                           3 :     write <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                               2'b01 : 
                                                   begin 
                                                       mcycles <= 3'b011;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   alu_op <= 4'b0000;
                                                                   inc_pc <= 1'b1;
                                                                   read_to_reg <= 1'b1;
                                                                   save_alu <= 1'b1;
                                                                   set_busa_to <= 4'b1000;
                                                                   set_busb_to <= 4'b0110;
                                                               end
                                                           3 : begin 
                                                                   noread <= 1'b1;
                                                                   read_to_reg <= 1'b1;
                                                                   save_alu <= 1'b1;
                                                                   alu_op <= 4'b0001;
                                                                   set_busa_to <= 4'b1001;
                                                                   set_busb_to <= 4'b1110;
                                                               end
                                                           default : 
                                                               ;
                                                       endcase
                                                   end
                                               2'b10 : 
                                                   begin 
                                                       mcycles <= 3'b011;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   set_addr_to <= 3'b100;
                                                               end
                                                           3 :     read_to_acc <= 1'b1;
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                               2'b11 : 
                                                   begin 
                                                       mcycles <= 3'b101;
                                                       case ($unsigned(mcycle))
                                                           2 : begin 
                                                                   inc_pc <= 1'b1;
                                                                   ldz <= 1'b1;
                                                               end
                                                           3 : begin 
                                                                   set_addr_to <= 3'b110;
                                                                   inc_pc <= 1'b1;
                                                                   ldw <= 1'b1;
                                                               end
                                                           4 : begin 
                                                                   set_busa_to[2:0] <= 3'b101;
                                                                   read_to_reg <= 1'b1;
                                                                   inc_wz <= 1'b1;
                                                                   set_addr_to <= 3'b110;
                                                               end
                                                           5 : begin 
                                                                   set_busa_to[2:0] <= 3'b100;
                                                                   read_to_reg <= 1'b1;
                                                               end
                                                           default : 
                                                                   ;//null
                                                       endcase
                                                   end
                                           endcase
                                   else 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               1 : begin 
                                                       if (is_cc_true__0(f, ir[5:3])) 
                                                               set_addr_to <= 3'b101;
                                                       else 
                                                               mcycles <= 3'b001;

                                                       tstates <= 3'b101;
                                                   end
                                               2 : begin 
                                                       incdec_16 <= 4'b0111;
                                                       set_addr_to <= 3'b101;
                                                       ldz <= 1'b1;
                                                   end
                                               3 : begin 
                                                       jump <= 1'b1;
                                                       incdec_16 <= 4'b0111;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11000111,8'b11001111,8'b11010111,8'b11011111,8'b11100111,8'b11101111,8'b11110111,8'b11111111 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 3'b101;
                                               incdec_16 <= 4'b1111;
                                               set_addr_to <= 3'b101;
                                               set_busb_to <= 4'b1101;
                                           end
                                       2 : begin 
                                               write <= 1'b1;
                                               incdec_16 <= 4'b1111;
                                               set_addr_to <= 3'b101;
                                               set_busb_to <= 4'b1100;
                                           end
                                       3 : begin 
                                               write <= 1'b1;
                                               rstp <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b11011011 : 
                                   if ((!(mode===3))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       set_addr_to <= 3'b100;
                                                   end
                                               3 : begin 
                                                       read_to_acc <= 1'b1;
                                                       iorq <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11010011 : 
                                   if ((!(mode===3))) 
                                       begin 
                                           mcycles <= 3'b011;
                                           case ($unsigned(mcycle))
                                               2 : begin 
                                                       inc_pc <= 1'b1;
                                                       set_addr_to <= 3'b100;
                                                       set_busb_to <= 4'b0111;
                                                   end
                                               3 : begin 
                                                       write <= 1'b1;
                                                       iorq <= 1'b1;
                                                   end
                                               default : 
                                                       ;//null
                                           endcase
                                       end

                                   
                           8'b11001011 : 
                                   if ((!(mode===2))) 
                                           prefix <= 2'b01;

                                   
                           8'b11101101 : 
                                   if ((mode < 2)) 
                                           prefix <= 2'b10;

                                   
                           8'b11011101,8'b11111101 : 
                                   if ((mode < 2)) 
                                           prefix <= 2'b11;

                                   
                       endcase
               2'b01 : 
                   begin 
                       set_busa_to[2:0] <= ir[2:0];
                       set_busb_to[2:0] <= ir[2:0];
                       case (Process4__irb)
                           8'b00000000,8'b00000001,8'b00000010,8'b00000011,8'b00000100,8'b00000101,8'b00000111,8'b00010000,8'b00010001,8'b00010010,8'b00010011,8'b00010100,8'b00010101,8'b00010111,8'b00001000,8'b00001001,8'b00001010,8'b00001011,8'b00001100,8'b00001101,8'b00001111,8'b00011000,8'b00011001,8'b00011010,8'b00011011,8'b00011100,8'b00011101,8'b00011111,8'b00100000,8'b00100001,8'b00100010,8'b00100011,8'b00100100,8'b00100101,8'b00100111,8'b00101000,8'b00101001,8'b00101010,8'b00101011,8'b00101100,8'b00101101,8'b00101111,8'b00110000,8'b00110001,8'b00110010,8'b00110011,8'b00110100,8'b00110101,8'b00110111,8'b00111000,8'b00111001,8'b00111010,8'b00111011,8'b00111100,8'b00111101,8'b00111111 : 
                                   if ((mcycle === 3'b001)) 
                                       begin 
                                           alu_op <= 4'b1000;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                       end

                                   
                           8'b00000110,8'b00010110,8'b00001110,8'b00011110,8'b00101110,8'b00111110,8'b00100110,8'b00110110 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 3'b010;
                                       2 : begin 
                                               alu_op <= 4'b1000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_addr_to <= 3'b010;
                                               tstates <= 3'b100;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b01000000,8'b01000001,8'b01000010,8'b01000011,8'b01000100,8'b01000101,8'b01000111,8'b01001000,8'b01001001,8'b01001010,8'b01001011,8'b01001100,8'b01001101,8'b01001111,8'b01010000,8'b01010001,8'b01010010,8'b01010011,8'b01010100,8'b01010101,8'b01010111,8'b01011000,8'b01011001,8'b01011010,8'b01011011,8'b01011100,8'b01011101,8'b01011111,8'b01100000,8'b01100001,8'b01100010,8'b01100011,8'b01100100,8'b01100101,8'b01100111,8'b01101000,8'b01101001,8'b01101010,8'b01101011,8'b01101100,8'b01101101,8'b01101111,8'b01110000,8'b01110001,8'b01110010,8'b01110011,8'b01110100,8'b01110101,8'b01110111,8'b01111000,8'b01111001,8'b01111010,8'b01111011,8'b01111100,8'b01111101,8'b01111111 : 
                                   if ((mcycle === 3'b001)) 
                                       begin 
                                           set_busb_to[2:0] <= ir[2:0];
                                           alu_op <= 4'b1001;
                                       end

                                   
                           8'b01000110,8'b01001110,8'b01010110,8'b01011110,8'b01100110,8'b01101110,8'b01110110,8'b01111110 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 3'b010;
                                       2 : begin 
                                               alu_op <= 4'b1001;
                                               tstates <= 3'b100;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b11000000,8'b11000001,8'b11000010,8'b11000011,8'b11000100,8'b11000101,8'b11000111,8'b11001000,8'b11001001,8'b11001010,8'b11001011,8'b11001100,8'b11001101,8'b11001111,8'b11010000,8'b11010001,8'b11010010,8'b11010011,8'b11010100,8'b11010101,8'b11010111,8'b11011000,8'b11011001,8'b11011010,8'b11011011,8'b11011100,8'b11011101,8'b11011111,8'b11100000,8'b11100001,8'b11100010,8'b11100011,8'b11100100,8'b11100101,8'b11100111,8'b11101000,8'b11101001,8'b11101010,8'b11101011,8'b11101100,8'b11101101,8'b11101111,8'b11110000,8'b11110001,8'b11110010,8'b11110011,8'b11110100,8'b11110101,8'b11110111,8'b11111000,8'b11111001,8'b11111010,8'b11111011,8'b11111100,8'b11111101,8'b11111111 : 
                                   if ((mcycle === 3'b001)) 
                                       begin 
                                           alu_op <= 4'b1010;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                       end

                                   
                           8'b11000110,8'b11001110,8'b11010110,8'b11011110,8'b11100110,8'b11101110,8'b11110110,8'b11111110 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 3'b010;
                                       2 : begin 
                                               alu_op <= 4'b1010;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_addr_to <= 3'b010;
                                               tstates <= 3'b100;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b10000000,8'b10000001,8'b10000010,8'b10000011,8'b10000100,8'b10000101,8'b10000111,8'b10001000,8'b10001001,8'b10001010,8'b10001011,8'b10001100,8'b10001101,8'b10001111,8'b10010000,8'b10010001,8'b10010010,8'b10010011,8'b10010100,8'b10010101,8'b10010111,8'b10011000,8'b10011001,8'b10011010,8'b10011011,8'b10011100,8'b10011101,8'b10011111,8'b10100000,8'b10100001,8'b10100010,8'b10100011,8'b10100100,8'b10100101,8'b10100111,8'b10101000,8'b10101001,8'b10101010,8'b10101011,8'b10101100,8'b10101101,8'b10101111,8'b10110000,8'b10110001,8'b10110010,8'b10110011,8'b10110100,8'b10110101,8'b10110111,8'b10111000,8'b10111001,8'b10111010,8'b10111011,8'b10111100,8'b10111101,8'b10111111 : 
                                   if ((mcycle === 3'b001)) 
                                       begin 
                                           alu_op <= 4'b1011;
                                           read_to_reg <= 1'b1;
                                           save_alu <= 1'b1;
                                       end

                                   
                           8'b10000110,8'b10001110,8'b10010110,8'b10011110,8'b10100110,8'b10101110,8'b10110110,8'b10111110 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1,7 : 
                                               set_addr_to <= 3'b010;
                                       2 : begin 
                                               alu_op <= 4'b1011;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_addr_to <= 3'b010;
                                               tstates <= 3'b100;
                                           end
                                       3 :     write <= 1'b1;
                                       default : 
                                           ;
                                   endcase
                               end
                       endcase
                   end
               default : 
                       case (Process4__irb)
                           8'b00000000,8'b00000001,8'b00000010,8'b00000011,8'b00000100,8'b00000101,8'b00000110,8'b00000111,8'b00001000,8'b00001001,8'b00001010,8'b00001011,8'b00001100,8'b00001101,8'b00001110,8'b00001111,8'b00010000,8'b00010001,8'b00010010,8'b00010011,8'b00010100,8'b00010101,8'b00010110,8'b00010111,8'b00011000,8'b00011001,8'b00011010,8'b00011011,8'b00011100,8'b00011101,8'b00011110,8'b00011111,8'b00100000,8'b00100001,8'b00100010,8'b00100011,8'b00100100,8'b00100101,8'b00100110,8'b00100111,8'b00101000,8'b00101001,8'b00101010,8'b00101011,8'b00101100,8'b00101101,8'b00101110,8'b00101111,8'b00110000,8'b00110001,8'b00110010,8'b00110011,8'b00110100,8'b00110101,8'b00110110,8'b00110111,8'b00111000,8'b00111001,8'b00111010,8'b00111011,8'b00111100,8'b00111101,8'b00111110,8'b00111111,8'b10000000,8'b10000001,8'b10000010,8'b10000011,8'b10000100,8'b10000101,8'b10000110,8'b10000111,8'b10001000,8'b10001001,8'b10001010,8'b10001011,8'b10001100,8'b10001101,8'b10001110,8'b10001111,8'b10010000,8'b10010001,8'b10010010,8'b10010011,8'b10010100,8'b10010101,8'b10010110,8'b10010111,8'b10011000,8'b10011001,8'b10011010,8'b10011011,8'b10011100,8'b10011101,8'b10011110,8'b10011111,8'b10100100,8'b10100101,8'b10100110,8'b10100111,8'b10101100,8'b10101101,8'b10101110,8'b10101111,8'b10110100,8'b10110101,8'b10110110,8'b10110111,8'b10111100,8'b10111101,8'b10111110,8'b10111111,8'b11000000,8'b11000001,8'b11000010,8'b11000011,8'b11000100,8'b11000101,8'b11000110,8'b11000111,8'b11001000,8'b11001001,8'b11001010,8'b11001011,8'b11001100,8'b11001101,8'b11001110,8'b11001111,8'b11010000,8'b11010001,8'b11010010,8'b11010011,8'b11010100,8'b11010101,8'b11010110,8'b11010111,8'b11011000,8'b11011001,8'b11011010,8'b11011011,8'b11011100,8'b11011101,8'b11011110,8'b11011111,8'b11100000,8'b11100001,8'b11100010,8'b11100011,8'b11100100,8'b11100101,8'b11100110,8'b11100111,8'b11101000,8'b11101001,8'b11101010,8'b11101011,8'b11101100,8'b11101101,8'b11101110,8'b11101111,8'b11110000,8'b11110001,8'b11110010,8'b11110011,8'b11110100,8'b11110101,8'b11110110,8'b11110111,8'b11111000,8'b11111001,8'b11111010,8'b11111011,8'b11111100,8'b11111101,8'b11111110,8'b11111111 : 
                                   ;//null
                           8'b01111110,8'b01111111 : 
                                   ;//null
                           8'b01010111 : 
                               begin 
                                   special_ld <= 3'b100;
                                   tstates <= 3'b101;
                               end
                           8'b01011111 : 
                               begin 
                                   special_ld <= 3'b101;
                                   tstates <= 3'b101;
                               end
                           8'b01000111 : 
                               begin 
                                   special_ld <= 3'b110;
                                   tstates <= 3'b101;
                               end
                           8'b01001111 : 
                               begin 
                                   special_ld <= 3'b111;
                                   tstates <= 3'b101;
                               end
                           8'b01001011,8'b01011011,8'b01101011,8'b01111011 : 
                               begin 
                                   mcycles <= 3'b101;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               set_addr_to <= 3'b110;
                                               inc_pc <= 1'b1;
                                               ldw <= 1'b1;
                                           end
                                       4 : begin 
                                               read_to_reg <= 1'b1;
                                               if ((ir[5:4] === 2'b11)) 
                                                       set_busa_to <= 4'b1000;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= ir[5:4];
                                                       set_busa_to[0] <= 1'b1;
                                                   end

                                               inc_wz <= 1'b1;
                                               set_addr_to <= 3'b110;
                                           end
                                       5 : begin 
                                               read_to_reg <= 1'b1;
                                               if ((ir[5:4] === 2'b11)) 
                                                       set_busa_to <= 4'b1001;
                                               else 
                                                   begin 
                                                       set_busa_to[2:1] <= ir[5:4];
                                                       set_busa_to[0] <= 1'b0;
                                                   end

                                               
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b01000011,8'b01010011,8'b01100011,8'b01110011 : 
                               begin 
                                   mcycles <= 3'b101;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               inc_pc <= 1'b1;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               set_addr_to <= 3'b110;
                                               inc_pc <= 1'b1;
                                               ldw <= 1'b1;
                                               if ((ir[5:4] === 2'b11)) 
                                                       set_busb_to <= 4'b1000;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= ir[5:4];
                                                       set_busb_to[0] <= 1'b1;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               
                                           end
                                       4 : begin 
                                               inc_wz <= 1'b1;
                                               set_addr_to <= 3'b110;
                                               write <= 1'b1;
                                               if ((ir[5:4] === 2'b11)) 
                                                       set_busb_to <= 4'b1001;
                                               else 
                                                   begin 
                                                       set_busb_to[2:1] <= ir[5:4];
                                                       set_busb_to[0] <= 1'b0;
                                                       set_busb_to[3] <= 1'b0;
                                                   end

                                               
                                           end
                                       5 :     write <= 1'b1;
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b10100000,8'b10101000,8'b10110000,8'b10111000 : 
                               begin 
                                   mcycles <= 3'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b010;
                                               incdec_16 <= 4'b1100;
                                           end
                                       2 : begin 
                                               set_busb_to <= 4'b0110;
                                               set_busa_to[2:0] <= 3'b111;
                                               alu_op <= 4'b0000;
                                               set_addr_to <= 3'b001;
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 4'b0110;
                                               else 
                                                       incdec_16 <= 4'b1110;

                                               
                                           end
                                       3 : begin 
                                               i_bt <= 1'b1;
                                               tstates <= 3'b101;
                                               write <= 1'b1;
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 4'b0101;
                                               else 
                                                       incdec_16 <= 4'b1101;

                                               
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 3'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b10100001,8'b10101001,8'b10110001,8'b10111001 : 
                               begin 
                                   mcycles <= 3'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b010;
                                               incdec_16 <= 4'b1100;
                                           end
                                       2 : begin 
                                               set_busb_to <= 4'b0110;
                                               set_busa_to[2:0] <= 3'b111;
                                               alu_op <= 4'b0111;
                                               save_alu <= 1'b1;
                                               preservec <= 1'b1;
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 4'b0110;
                                               else 
                                                       incdec_16 <= 4'b1110;

                                               
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               i_bc <= 1'b1;
                                               tstates <= 3'b101;
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 3'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b01000100,8'b01001100,8'b01010100,8'b01011100,8'b01100100,8'b01101100,8'b01110100,8'b01111100 : 
                               begin 
                                   alu_op <= 4'b0010;
                                   set_busb_to <= 4'b0111;
                                   set_busa_to <= 4'b1010;
                                   read_to_acc <= 1'b1;
                                   save_alu <= 1'b1;
                               end
                           8'b01000110,8'b01001110,8'b01100110,8'b01101110 : 
                                   imode <= 2'b00;
                           8'b01010110,8'b01110110 : 
                                   imode <= 2'b01;
                           8'b01011110,8'b01110111 : 
                                   imode <= 2'b10;
                           8'b01001010,8'b01011010,8'b01101010,8'b01111010 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 4'b0001;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 3'b101;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b1;
                                                       end
                                                   default : 
                                                           set_busb_to <= 4'b1000;
                                               endcase
                                               tstates <= 3'b100;
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 4'b0001;
                                               set_busa_to[2:0] <= 3'b100;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b0;
                                                       end
                                                   default : 
                                                           set_busb_to <= 4'b1001;
                                               endcase
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b01000010,8'b01010010,8'b01100010,8'b01110010 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 4'b0011;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 3'b101;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                       begin 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                           set_busb_to[0] <= 1'b1;
                                                       end
                                                   default : 
                                                           set_busb_to <= 4'b1000;
                                               endcase
                                               tstates <= 3'b100;
                                           end
                                       3 : begin 
                                               noread <= 1'b1;
                                               alu_op <= 4'b0011;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               set_busa_to[2:0] <= 3'b100;
                                               case ($unsigned(ir[5:4]))
                                                   0,1,2 : 
                                                           set_busb_to[2:1] <= ir[5:4];
                                                   default : 
                                                           set_busb_to <= 4'b1001;
                                               endcase
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b01101111 : 
                               begin 
                                   mcycles <= 3'b100;
                                   case ($unsigned(mcycle))
                                       2 : begin 
                                               noread <= 1'b1;
                                               set_addr_to <= 3'b010;
                                           end
                                       3 : begin 
                                               read_to_reg <= 1'b1;
                                               set_busb_to[2:0] <= 3'b110;
                                               set_busa_to[2:0] <= 3'b111;
                                               alu_op <= 4'b1101;
                                               tstates <= 3'b100;
                                               set_addr_to <= 3'b010;
                                               save_alu <= 1'b1;
                                           end
                                       4 : begin 
                                               i_rld <= 1'b1;
                                               write <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b01100111 : 
                               begin 
                                   mcycles <= 3'b100;
                                   case ($unsigned(mcycle))
                                       2 :     set_addr_to <= 3'b010;
                                       3 : begin 
                                               read_to_reg <= 1'b1;
                                               set_busb_to[2:0] <= 3'b110;
                                               set_busa_to[2:0] <= 3'b111;
                                               alu_op <= 4'b1110;
                                               tstates <= 3'b100;
                                               set_addr_to <= 3'b010;
                                               save_alu <= 1'b1;
                                           end
                                       4 : begin 
                                               i_rrd <= 1'b1;
                                               write <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b01000101,8'b01001101,8'b01010101,8'b01011101,8'b01100101,8'b01101101,8'b01110101,8'b01111101 : 
                               begin 
                                   mcycles <= 3'b011;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b101;
                                       2 : begin 
                                               incdec_16 <= 4'b0111;
                                               set_addr_to <= 3'b101;
                                               ldz <= 1'b1;
                                           end
                                       3 : begin 
                                               jump <= 1'b1;
                                               incdec_16 <= 4'b0111;
                                               i_retn <= 1'b1;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b01000000,8'b01001000,8'b01010000,8'b01011000,8'b01100000,8'b01101000,8'b01110000,8'b01111000 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 :     set_addr_to <= 3'b000;
                                       2 : begin 
                                               iorq <= 1'b1;
                                               if ((!(ir[5:3]===3'b110))) 
                                                   begin 
                                                       read_to_reg <= 1'b1;
                                                       set_busa_to[2:0] <= ir[5:3];
                                                   end

                                               i_inrc <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b01000001,8'b01001001,8'b01010001,8'b01011001,8'b01100001,8'b01101001,8'b01110001,8'b01111001 : 
                               begin 
                                   mcycles <= 3'b010;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b000;
                                               set_busb_to[2:0] <= ir[5:3];
                                               if ((ir[5:3] === 3'b110)) 
                                                       set_busb_to[3] <= 1'b1;

                                               
                                           end
                                       2 : begin 
                                               write <= 1'b1;
                                               iorq <= 1'b1;
                                           end
                                       default : 
                                           ;
                                   endcase
                               end
                           8'b10100010,8'b10101010,8'b10110010,8'b10111010 : 
                               begin 
                                   mcycles <= 3'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               set_addr_to <= 3'b000;
                                               set_busb_to <= 4'b1010;
                                               set_busa_to <= 4'b0000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 4'b0010;
                                           end
                                       2 : begin 
                                               iorq <= 1'b1;
                                               set_busb_to <= 4'b0110;
                                               set_addr_to <= 3'b010;
                                           end
                                       3 : begin 
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 4'b0010;
                                               else 
                                                       incdec_16 <= 4'b1010;

                                               tstates <= 3'b100;
                                               write <= 1'b1;
                                               i_btr <= 1'b1;
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 3'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                           8'b10100011,8'b10101011,8'b10110011,8'b10111011 : 
                               begin 
                                   mcycles <= 3'b100;
                                   case ($unsigned(mcycle))
                                       1 : begin 
                                               tstates <= 3'b101;
                                               set_addr_to <= 3'b010;
                                               set_busb_to <= 4'b1010;
                                               set_busa_to <= 4'b0000;
                                               read_to_reg <= 1'b1;
                                               save_alu <= 1'b1;
                                               alu_op <= 4'b0010;
                                           end
                                       2 : begin 
                                               set_busb_to <= 4'b0110;
                                               set_addr_to <= 3'b000;
                                           end
                                       3 : begin 
                                               if ((ir[3] === 1'b0)) 
                                                       incdec_16 <= 4'b0010;
                                               else 
                                                       incdec_16 <= 4'b1010;

                                               iorq <= 1'b1;
                                               write <= 1'b1;
                                               i_btr <= 1'b1;
                                           end
                                       4 : begin 
                                               noread <= 1'b1;
                                               tstates <= 3'b101;
                                           end
                                       default : 
                                               ;//null
                                   endcase
                               end
                       endcase
           endcase
           if ((mode === 1)) 
               begin 
                   if ((mcycle === 3'b001)) 
                       ;//Null
                   else 
                       tstates <= 3'b011;
                       
                   
                   
               end 
           if ((mode === 3)) 
               begin 
                   if ((mcycle === 3'b001)) 
                       ;//Null
                   else 
                       tstates <= 3'b100;
                       
                   
                   
               end 
           if ((mode < 2)) 
               begin 
                   begin 
                       if ((mcycle === 3'b110)) 
                           begin 
                               inc_pc <= 1'b1;
                               if ((mode === 1)) 
                                   begin 
                                       set_addr_to <= 3'b010;
                                       tstates <= 3'b100;
                                       set_busb_to[2:0] <= Process2__sss;
                                       set_busb_to[3] <= 1'b0;
                                   end
                                   
                               
                               if (((Process4__irb === 8'b00110110) | (Process4__irb === 8'b11001011))) 
                                   set_addr_to <= 3'b111;
                                   
                               
                               
                           end
                           
                       
                       if ((mcycle === 3'b111)) 
                           begin 
                               begin 
                                   if ((mode === 0)) 
                                           tstates <= 3'b101;

                                   if ((!(iset===2'b01))) 
                                           set_addr_to <= 3'b010;

                                   set_busb_to[2:0] <= Process2__sss;
                                   set_busb_to[3] <= 1'b0;
                                   if (((Process4__irb === 8'b00110110) | (iset === 2'b01))) 
                                           inc_pc <= 1'b1;
                                   else 
                                           noread <= 1'b1;

                                   
                               end
                           end 
                       
                       
                   end
                   
               end 
           
   end //always
    
    function [0:0] is_cc_true__0;
        input [7:0]  f ;
input [2:0]  cc ;
        begin : Function
                if ((mode === 3)) 
                        case (cc)
                            3'b000 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b0);
                                        disable Function;
                                    end
                            3'b001 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b1);
                                        disable Function;
                                    end
                            3'b010 : 
                                    begin 
                                        is_cc_true__0=(f[4] === 1'b0);
                                        disable Function;
                                    end
                            3'b011 : 
                                    begin 
                                        is_cc_true__0=(f[4] === 1'b1);
                                        disable Function;
                                    end
                            3'b100 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                            3'b101 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                            3'b110 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                            3'b111 : 
                                    begin 
                                        is_cc_true__0=1'b0;
                                        disable Function;
                                    end
                        endcase
                else 
                        case (cc)
                            3'b000 : 
                                    begin 
                                        is_cc_true__0=(f[6] === 1'b0);
                                        disable Function;
                                    end
                            3'b001 : 
                                    begin 
                                        is_cc_true__0=(f[6] === 1'b1);
                                        disable Function;
                                    end
                            3'b010 : 
                                    begin 
                                        is_cc_true__0=(f[0] === 1'b0);
                                        disable Function;
                                    end
                            3'b011 : 
                                    begin 
                                        is_cc_true__0=(f[0] === 1'b1);
                                        disable Function;
                                    end
                            3'b100 : 
                                    begin 
                                        is_cc_true__0=(f[2] === 1'b0);
                                        disable Function;
                                    end
                            3'b101 : 
                                    begin 
                                        is_cc_true__0=(f[2] === 1'b1);
                                        disable Function;
                                    end
                            3'b110 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b0);
                                        disable Function;
                                    end
                            3'b111 : 
                                    begin 
                                        is_cc_true__0=(f[7] === 1'b1);
                                        disable Function;
                                    end
                        endcase

                
        end // Function
    endfunction

    

endmodule
//
// Z80 compatible microprocessor core
//
// Version : 0247
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0214 : Fixed mostly flags, only the block instructions now fail the zex regression test
//
//	0238 : Fixed zero flag for 16 bit SBC and ADC
//
//	0240 : Added GB operations
//
//	0242 : Cleanup
//
//	0247 : Cleanup
//


module  t80_alu ( arith16, z16, alu_op, ir, iset, busa, busb, f_in, q, f_out );
    parameter  [31:0]  mode =0;
    parameter  [31:0]  flag_c =0;
    parameter  [31:0]  flag_n =1;
    parameter  [31:0]  flag_p =2;
    parameter  [31:0]  flag_x =3;
    parameter  [31:0]  flag_h =4;
    parameter  [31:0]  flag_y =5;
    parameter  [31:0]  flag_z =6;
    parameter  [31:0]  flag_s =7;
    
    input arith16;
    input z16;
    input [3:0]  alu_op ;
    input [5:0]  ir ;
    input [1:0]  iset ;
    input [7:0]  busa ;
    input [7:0]  busb ;
    input [7:0]  f_in ;
    output [7:0]  q ;
    output [7:0]  f_out ;


    reg [7:0] Process1__q_t;
    reg [8:0] Process2__daa_q;
    wire usecarry;
    reg carry7_v;
    wire overflow_v;
    reg halfcarry_v;
    reg carry_v;
    reg [7:0] q_v;
    wire [7:0] bitmask;
    reg [7:0] q;
    reg [7:0] f_out;


    
   assign bitmask=ir[5:3]===3'b000 ? 8'b00000001 : 
           ir[5:3]===3'b001 ? 8'b00000010 : 
           ir[5:3]===3'b010 ? 8'b00000100 : 
           ir[5:3]===3'b011 ? 8'b00001000 : 
           ir[5:3]===3'b100 ? 8'b00010000 : 
           ir[5:3]===3'b101 ? 8'b00100000 : 
           ir[5:3]===3'b110 ? 8'b01000000 : 
           8'b10000000;
   
   assign {usecarry}=(~ (alu_op[2]) & alu_op[0]);
   
       
   always @ (busa[3:0] or busb[3:0] or alu_op[1] or alu_op[1] or usecarry or f_in[flag_c] or q_v[3:0] or halfcarry_v ) begin
           addsub__0(busa[3:0], busb[3:0], alu_op[1], (alu_op[1] ^ (usecarry & f_in[flag_c])));
   end //always
   
       
   always @ (busa[6:4] or busb[6:4] or alu_op[1] or halfcarry_v or q_v[6:4] or carry7_v ) begin
           addsub__1(busa[6:4], busb[6:4], alu_op[1], halfcarry_v);
   end //always
   
       
   always @ (busa[7:7] or busb[7:7] or alu_op[1] or carry7_v or q_v[7:7] or carry_v ) begin
           addsub__2(busa[7:7], busb[7:7], alu_op[1], carry7_v);
   end //always
   
   assign {overflow_v}=(carry_v ^ carry7_v);
   
       
   always @ (arith16 or alu_op or f_in or busa or busb or ir or q_v or carry_v or halfcarry_v or overflow_v or bitmask or iset or z16 ) begin
           Process1__q_t = 8'bxxxxxxxx;
           f_out <= f_in;
           Process2__daa_q = 9'bxxxxxxxxx;
           case (alu_op)
               4'b0000,4'b0001,4'b0010,4'b0011,4'b0100,4'b0101,4'b0110,4'b0111 : 
                   begin 
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_c] <= 1'b0;
                       case (alu_op[2:0])
                           3'b000,3'b001 : 
                               begin 
                                   Process1__q_t = q_v;
                                   f_out[flag_c] <= carry_v;
                                   f_out[flag_h] <= halfcarry_v;
                                   f_out[flag_p] <= overflow_v;
                               end
                           3'b010,3'b011,3'b111 : 
                               begin 
                                   Process1__q_t = q_v;
                                   f_out[flag_n] <= 1'b1;
                                   f_out[flag_c] <= ~ (carry_v);
                                   f_out[flag_h] <= ~ (halfcarry_v);
                                   f_out[flag_p] <= overflow_v;
                               end
                           3'b100 : 
                               begin 
                                   Process1__q_t[7:0] = (busa & busb);
                                   f_out[flag_h] <= 1'b1;
                               end
                           3'b101 : 
                               begin 
                                   Process1__q_t[7:0] = (busa ^ busb);
                                   f_out[flag_h] <= 1'b0;
                               end
                           default : 
                               begin 
                                   Process1__q_t[7:0] = (busa | busb);
                                   f_out[flag_h] <= 1'b0;
                               end
                       endcase
                       if ((alu_op[2:0] === 3'b111)) 
                           begin 
                               f_out[flag_x] <= busb[3];
                               f_out[flag_y] <= busb[5];
                           end
                       else 
                           begin 
                               f_out[flag_x] <= Process1__q_t[3];
                               f_out[flag_y] <= Process1__q_t[5];
                           end

                       if ((Process1__q_t[7:0] === 8'b00000000)) 
                           begin 
                               f_out[flag_z] <= 1'b1;
                               if ((z16 === 1'b1)) 
                                       f_out[flag_z] <= f_in[flag_z];

                               
                           end
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_s] <= Process1__q_t[7];
                       case (alu_op[2:0])
                           3'b000,3'b001,3'b010,3'b011,3'b111 : 
                               ;
                           default : 
                                   f_out[flag_p] <= ~ ((((((((Process1__q_t[0] ^ Process1__q_t[1]) ^ Process1__q_t[2]) ^ Process1__q_t[3]) ^ Process1__q_t[4]) ^ Process1__q_t[5]) ^ Process1__q_t[6]) ^ Process1__q_t[7]));
                       endcase
                       if ((arith16 === 1'b1)) 
                           begin 
                               f_out[flag_s] <= f_in[flag_s];
                               f_out[flag_z] <= f_in[flag_z];
                               f_out[flag_p] <= f_in[flag_p];
                           end

                       
                   end
               4'b1100 : 
                   begin 
                       f_out[flag_h] <= f_in[flag_h];
                       f_out[flag_c] <= f_in[flag_c];
                       Process2__daa_q[7:0] = $unsigned(busa);
                       Process2__daa_q[8] = 1'b0;
                       if ((f_in[flag_n] === 1'b0)) 
                           begin 
                               begin 
                                   if (((Process2__daa_q[3:0] > 9) | (f_in[flag_h] === 1'b1))) 
                                       begin 
                                           begin 
                                               if ((Process2__daa_q[3:0] > 9)) 
                                                       f_out[flag_h] <= 1'b1;
                                               else 
                                                       f_out[flag_h] <= 1'b0;

                                               Process2__daa_q = (Process2__daa_q + 6);
                                           end
                                       end 

                                   if (((Process2__daa_q[8:4] > 9) | (f_in[flag_c] === 1'b1))) 
                                           Process2__daa_q = (Process2__daa_q + 96);

                                   
                               end
                           end 
                       else 
                           begin 
                               begin 
                                   if (((Process2__daa_q[3:0] > 9) | (f_in[flag_h] === 1'b1))) 
                                       begin 
                                           begin 
                                               if ((Process2__daa_q[3:0] > 5)) 
                                                       f_out[flag_h] <= 1'b0;

                                               Process2__daa_q[7:0] = (Process2__daa_q[7:0] - 6);
                                           end
                                       end 

                                   if ((($unsigned(busa) > 153) | (f_in[flag_c] === 1'b1))) 
                                           Process2__daa_q = (Process2__daa_q - 352);

                                   
                               end
                           end 

                       f_out[flag_x] <= Process2__daa_q[3];
                       f_out[flag_y] <= Process2__daa_q[5];
                       f_out[flag_c] <= (f_in[flag_c] | Process2__daa_q[8]);
                       Process1__q_t = Process2__daa_q[7:0];
                       if ((Process2__daa_q[7:0] === 8'b00000000)) 
                               f_out[flag_z] <= 1'b1;
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_s] <= Process2__daa_q[7];
                       f_out[flag_p] <= ~ ((((((((Process2__daa_q[0] ^ Process2__daa_q[1]) ^ Process2__daa_q[2]) ^ Process2__daa_q[3]) ^ Process2__daa_q[4]) ^ Process2__daa_q[5]) ^ Process2__daa_q[6]) ^ Process2__daa_q[7]));
                   end
               4'b1101,4'b1110 : 
                   begin 
                       Process1__q_t[7:4] = busa[7:4];
                       if ((alu_op[0] === 1'b1)) 
                               Process1__q_t[3:0] = busb[7:4];
                       else 
                               Process1__q_t[3:0] = busb[3:0];

                       f_out[flag_h] <= 1'b0;
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_x] <= Process1__q_t[3];
                       f_out[flag_y] <= Process1__q_t[5];
                       if ((Process1__q_t[7:0] === 8'b00000000)) 
                               f_out[flag_z] <= 1'b1;
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_s] <= Process1__q_t[7];
                       f_out[flag_p] <= ~ ((((((((Process1__q_t[0] ^ Process1__q_t[1]) ^ Process1__q_t[2]) ^ Process1__q_t[3]) ^ Process1__q_t[4]) ^ Process1__q_t[5]) ^ Process1__q_t[6]) ^ Process1__q_t[7]));
                   end
               4'b1001 : 
                   begin 
                       Process1__q_t[7:0] = (busb & bitmask);
                       f_out[flag_s] <= Process1__q_t[7];
                       if ((Process1__q_t[7:0] === 8'b00000000)) 
                           begin 
                               f_out[flag_z] <= 1'b1;
                               f_out[flag_p] <= 1'b1;
                           end
                       else 
                           begin 
                               f_out[flag_z] <= 1'b0;
                               f_out[flag_p] <= 1'b0;
                           end

                       f_out[flag_h] <= 1'b1;
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_x] <= 1'b0;
                       f_out[flag_y] <= 1'b0;
                       if ((!(ir[2:0]===3'b110))) 
                           begin 
                               f_out[flag_x] <= busb[3];
                               f_out[flag_y] <= busb[5];
                           end

                       
                   end
               4'b1010 : 
                       Process1__q_t[7:0] = (busb | bitmask);
               4'b1011 : 
                       Process1__q_t[7:0] = (busb & ~ (bitmask));
               4'b1000 : 
                   begin 
                       case (ir[5:3])
                           3'b000 : 
                               begin 
                                   Process1__q_t[7:1] = busa[6:0];
                                   Process1__q_t[0] = busa[7];
                                   f_out[flag_c] <= busa[7];
                               end
                           3'b010 : 
                               begin 
                                   Process1__q_t[7:1] = busa[6:0];
                                   Process1__q_t[0] = f_in[flag_c];
                                   f_out[flag_c] <= busa[7];
                               end
                           3'b001 : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = busa[0];
                                   f_out[flag_c] <= busa[0];
                               end
                           3'b011 : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = f_in[flag_c];
                                   f_out[flag_c] <= busa[0];
                               end
                           3'b100 : 
                               begin 
                                   Process1__q_t[7:1] = busa[6:0];
                                   Process1__q_t[0] = 1'b0;
                                   f_out[flag_c] <= busa[7];
                               end
                           3'b110 : 
                                   if ((mode === 3)) 
                                       begin 
                                           Process1__q_t[7:4] = busa[3:0];
                                           Process1__q_t[3:0] = busa[7:4];
                                           f_out[flag_c] <= 1'b0;
                                       end
                                   else 
                                       begin 
                                           Process1__q_t[7:1] = busa[6:0];
                                           Process1__q_t[0] = 1'b1;
                                           f_out[flag_c] <= busa[7];
                                       end

                                   
                           3'b101 : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = busa[7];
                                   f_out[flag_c] <= busa[0];
                               end
                           default : 
                               begin 
                                   Process1__q_t[6:0] = busa[7:1];
                                   Process1__q_t[7] = 1'b0;
                                   f_out[flag_c] <= busa[0];
                               end
                       endcase
                       f_out[flag_h] <= 1'b0;
                       f_out[flag_n] <= 1'b0;
                       f_out[flag_x] <= Process1__q_t[3];
                       f_out[flag_y] <= Process1__q_t[5];
                       f_out[flag_s] <= Process1__q_t[7];
                       if ((Process1__q_t[7:0] === 8'b00000000)) 
                               f_out[flag_z] <= 1'b1;
                       else 
                               f_out[flag_z] <= 1'b0;

                       f_out[flag_p] <= ~ ((((((((Process1__q_t[0] ^ Process1__q_t[1]) ^ Process1__q_t[2]) ^ Process1__q_t[3]) ^ Process1__q_t[4]) ^ Process1__q_t[5]) ^ Process1__q_t[6]) ^ Process1__q_t[7]));
                       if ((iset === 2'b00)) 
                           begin 
                               f_out[flag_p] <= f_in[flag_p];
                               f_out[flag_s] <= f_in[flag_s];
                               f_out[flag_z] <= f_in[flag_z];
                           end

                       
                   end
               default : 
                       ;//null
           endcase
           q <= Process1__q_t;
   end //always
               task addsub__0;
                   input  [3:0] a;
                   input  [3:0] b;
                   input  sub ;
                   input  carry_in ;
                       reg [((3-0+1) - 1):0] b_i;
                       reg [((3-0+1) + 1):0] res_i;

                   begin 
                       if ((sub === 1'b1)) 
                               b_i = ~ ($unsigned(b));
                       else 
                               b_i = $unsigned(b);

                       res_i = ($unsigned({{1'b0,a},carry_in}) + $unsigned({{1'b0,b_i},1'b1}));
                       halfcarry_v <= res_i[((3-0+1) + 1)];
                       q_v[3:0] <= res_i[(3-0+1):1];
                   end
               endtask
                   

               task addsub__1;
                   input  [6:4] a;
                   input  [6:4] b;
                   input  sub ;
                   input  carry_in ;
                       reg [((6-4+1) - 1):0] b_i;
                       reg [((6-4+1) + 1):0] res_i;

                   begin 
                       if ((sub === 1'b1)) 
                               b_i = ~ ($unsigned(b));
                       else 
                               b_i = $unsigned(b);

                       res_i = ($unsigned({{1'b0,a},carry_in}) + $unsigned({{1'b0,b_i},1'b1}));
                       carry7_v <= res_i[((6-4+1) + 1)];
                       q_v[6:4] <= res_i[(6-4+1):1];
                   end
               endtask
                   

               task addsub__2;
                   input  [7:7] a;
                   input  [7:7] b;
                   input  sub ;
                   input  carry_in ;
                       reg [((7-7+1) - 1):0] b_i;
                       reg [((7-7+1) + 1):0] res_i;

                   begin 
                       if ((sub === 1'b1)) 
                               b_i = ~ ($unsigned(b));
                       else 
                               b_i = $unsigned(b);

                       res_i = ($unsigned({{1'b0,a},carry_in}) + $unsigned({{1'b0,b_i},1'b1}));
                       carry_v <= res_i[((7-7+1) + 1)];
                       q_v[7:7] <= res_i[(7-7+1):1];
                   end
               endtask
                   

               
           
endmodule
//
// Z80 compatible microprocessor core
//
// Version : 0247
//
// Copyright (c) 2001-2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
//	0208 : First complete release
//
//	0210 : Fixed wait and halt
//
//	0211 : Fixed Refresh addition and IM 1
//
//	0214 : Fixed mostly flags, only the block instructions now fail the zex regression test
//
//	0232 : Removed refresh address output for Mode > 1 and added DJNZ M1_n fix by Mike Johnson
//
//	0235 : Added clock enable and IM 2 fix by Mike Johnson
//
//	0237 : Changed 8080 I/O address output, added IntE output
//
//	0238 : Fixed (IX/IY+d) timing and 16 bit ADC and SBC zero flag
//
//	0240 : Added interrupt ack fix by Mike Johnson, changed (IX/IY+d) timing and changed flags in GB mode
//
//	0242 : Added I/O wait, fixed refresh address, moved some registers to RAM
//
//	0247 : Fixed bus req/ack cycle
//


module  t80 ( reset_n, clk_n, cen, wait_n, int_n, nmi_n, busrq_n, m1_n, iorq, noread, write, rfsh_n, halt_n, busak_n, a, dinst, di, do, mc, ts, intcycle_n, inte, stop );
    parameter  [31:0]  mode =0;
    parameter  [31:0]  iowait =0;
    parameter  [31:0]  flag_c =0;
    parameter  [31:0]  flag_n =1;
    parameter  [31:0]  flag_p =2;
    parameter  [31:0]  flag_x =3;
    parameter  [31:0]  flag_h =4;
    parameter  [31:0]  flag_y =5;
    parameter  [31:0]  flag_z =6;
    parameter  [31:0]  flag_s =7;
    
    input reset_n;
    input clk_n;
    input cen;
    input wait_n;
    input int_n;
    input nmi_n;
    input busrq_n;
    output m1_n;
    output iorq;
    output noread;
    output write;
    output rfsh_n;
    output halt_n;
    output busak_n;
    output [15:0]  a ;
    input [7:0]  dinst ;
    input [7:0]  di ;
    output [7:0]  do ;
    output [2:0]  mc ;
    output [2:0]  ts ;
    output intcycle_n;
    output inte;
    output stop;


    reg Process1__oldnmi_n;
    parameter [2:0] anone=3'b111;
    parameter [2:0] abc=3'b000;
    parameter [2:0] ade=3'b001;
    parameter [2:0] axy=3'b010;
    parameter [2:0] aioa=3'b100;
    parameter [2:0] asp=3'b101;
    parameter [2:0] azi=3'b110;
    reg [7:0] acc;
    reg [7:0] f;
    reg [7:0] ap;
    reg [7:0] fp;
    reg [7:0] i;
    reg [7:0] r;
    reg [15:0] sp;
    reg [15:0] pc;
    reg [7:0] regdih;
    reg [7:0] regdil;
    wire [15:0] regbusa;
    wire [15:0] regbusb;
    wire [15:0] regbusc;
    reg [2:0] regaddra_r;
    wire [2:0] regaddra;
    reg [2:0] regaddrb_r;
    wire [2:0] regaddrb;
    reg [2:0] regaddrc;
    reg regweh;
    reg regwel;
    reg alternate;
    reg [15:0] tmpaddr;
    reg [7:0] ir;
    reg [1:0] iset;
    reg [15:0] regbusa_r;
    wire [15:0] id16;
    wire [7:0] save_mux;
    reg [2:0] tstate;
    reg [2:0] mcycle;
    reg inte_ff1;
    reg inte_ff2;
    reg halt_ff;
    reg busreq_s;
    reg busack;
    wire clken;
    reg nmi_s;
    reg int_s;
    reg [1:0] istatus;
    wire [7:0] di_reg;
    wire t_res;
    reg [1:0] xy_state;
    reg [2:0] pre_xy_f_m;
    wire nextis_xy_fetch;
    reg xy_ind;
    reg no_btr;
    reg btr_r;
    reg auto_wait;
    reg auto_wait_t1;
    reg auto_wait_t2;
    reg incdecz;
    reg [7:0] busb;
    reg [7:0] busa;
    wire [7:0] alu_q;
    wire [7:0] f_out;
    reg [4:0] read_to_reg_r;
    reg arith16_r;
    reg z16_r;
    reg [3:0] alu_op_r;
    reg save_alu_r;
    reg preservec_r;
    reg [2:0] mcycles;
    wire [2:0] mcycles_d;
    wire [2:0] tstates;
    reg intcycle;
    reg nmicycle;
    wire inc_pc;
    wire inc_wz;
    wire [3:0] incdec_16;
    wire [1:0] prefix;
    wire read_to_acc;
    wire read_to_reg;
    wire [3:0] set_busb_to;
    wire [3:0] set_busa_to;
    wire [3:0] alu_op;
    wire save_alu;
    wire preservec;
    wire arith16;
    wire [2:0] set_addr_to;
    wire jump;
    wire jumpe;
    wire jumpxy;
    wire call;
    wire rstp;
    wire ldz;
    wire ldw;
    wire ldsphl;
    wire iorq_i;
    wire [2:0] special_ld;
    wire exchangedh;
    wire exchangerp;
    wire exchangeaf;
    wire exchangers;
    wire i_djnz;
    wire i_cpl;
    wire i_ccf;
    wire i_scf;
    wire i_retn;
    wire i_bt;
    wire i_bc;
    wire i_btr;
    wire i_rld;
    wire i_rrd;
    wire i_inrc;
    wire setdi;
    wire setei;
    wire [1:0] imode;
    wire halt;
    reg m1_n;
    wire iorq;
    wire noread;
    wire write;
    reg rfsh_n;
    wire halt_n;
    wire busak_n;
    reg [15:0] a;
    reg [7:0] do;
    wire [2:0] mc;
    wire [2:0] ts;
    wire intcycle_n;
    wire inte;
    wire stop;


    
   t80_mcode  #(mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s) mcode(.ir(ir), .iset(iset), .mcycle(mcycle), .f(f), .nmicycle(nmicycle), .intcycle(intcycle), .mcycles(mcycles_d), .tstates(tstates), .prefix(prefix), .inc_pc(inc_pc), .inc_wz(inc_wz), .incdec_16(incdec_16), .read_to_reg(read_to_reg), .read_to_acc(read_to_acc), .set_busa_to(set_busa_to), .set_busb_to(set_busb_to), .alu_op(alu_op), .save_alu(save_alu), .preservec(preservec), .arith16(arith16), .set_addr_to(set_addr_to), .iorq(iorq_i), .jump(jump), .jumpe(jumpe), .jumpxy(jumpxy), .call(call), .rstp(rstp), .ldz(ldz), .ldw(ldw), .ldsphl(ldsphl), .special_ld(special_ld), .exchangedh(exchangedh), .exchangerp(exchangerp), .exchangeaf(exchangeaf), .exchangers(exchangers), .i_djnz(i_djnz), .i_cpl(i_cpl), .i_ccf(i_ccf), .i_scf(i_scf), .i_retn(i_retn), .i_bt(i_bt), .i_bc(i_bc), .i_btr(i_btr), .i_rld(i_rld), .i_rrd(i_rrd), .i_inrc(i_inrc), .setdi(setdi), .setei(setei), .imode(imode), .halt(halt), .noread(noread), .write(write));
   //Parameter Order: mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s 

   t80_alu  #(mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s) alu(.arith16(arith16_r), .z16(z16_r), .alu_op(alu_op_r), .ir(ir[5:0]), .iset(iset), .busa(busa), .busb(busb), .f_in(f), .q(alu_q), .f_out(f_out));
   //Parameter Order: mode,flag_c,flag_n,flag_p,flag_x,flag_h,flag_y,flag_z,flag_s 

   assign {clken}=(cen & ~ (busack));
   
   assign {t_res}=(tstate === $unsigned(tstates)) ? 
                      1'b1
                   :  1'b0;
   
   assign {nextis_xy_fetch}=(((!(xy_state===2'b00)) & (xy_ind === 1'b0)) & (((set_addr_to === axy) | ((mcycle === 3'b001) & (ir === 8'b11001011))) | ((mcycle === 3'b001) & (ir === 8'b00110110)))) ? 
                                1'b1
                             :  1'b0;
   
   assign {save_mux}=(exchangerp === 1'b1) ? 
                         busb
                      : (save_alu_r === 1'b0) ? 
                         di_reg
                      :  alu_q;
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               begin 
                   pc <= {(15-0+1- 0){1'b0}};
                   a <= {(15-0+1- 0){1'b0}};
                   tmpaddr <= {(15-0+1- 0){1'b0}};
                   ir <= 8'b00000000;
                   iset <= 2'b00;
                   xy_state <= 2'b00;
                   istatus <= 2'b00;
                   mcycles <= 3'b000;
                   do <= 8'b00000000;
                   acc <= {(7-0+1- 0){1'b1}};
                   f <= {(7-0+1- 0){1'b1}};
                   ap <= {(7-0+1- 0){1'b1}};
                   fp <= {(7-0+1- 0){1'b1}};
                   i <= {(7-0+1- 0){1'b0}};
                   r <= {(7-0+1- 0){1'b0}};
                   sp <= {(15-0+1- 0){1'b1}};
                   alternate <= 1'b0;
                   read_to_reg_r <= 5'b00000;
                   f <= {(7-0+1- 0){1'b1}};
                   arith16_r <= 1'b0;
                   btr_r <= 1'b0;
                   z16_r <= 1'b0;
                   alu_op_r <= 4'b0000;
                   save_alu_r <= 1'b0;
                   preservec_r <= 1'b0;
                   xy_ind <= 1'b0;
               end
               
           else 
               begin 
                   if ((clken === 1'b1)) 
                       begin 
                           alu_op_r <= 4'b0000;
                           save_alu_r <= 1'b0;
                           read_to_reg_r <= 5'b00000;
                           mcycles <= mcycles_d;
                           if ((!(imode===2'b11))) 
                               istatus <= imode;
                               
                           
                           arith16_r <= arith16;
                           preservec_r <= preservec;
                           if (((((iset === 2'b10) & (alu_op[2] === 1'b0)) & (alu_op[0] === 1'b1)) & (mcycle === 3'b011))) 
                               z16_r <= 1'b1;
                               
                           else 
                               z16_r <= 1'b0;
                               
                           
                           if (((mcycle === 3'b001) & (tstate[2] === 1'b0))) 
                               begin 
                                       if (((tstate === 2) & (wait_n === 1'b1))) 
                                           begin 
                                               begin 
                                                   if ((mode < 2)) 
                                                       begin 
                                                           a[7:0] <= r;
                                                           a[15:8] <= i;
                                                           r[6:0] <= (r[6:0] + 1);
                                                       end

                                                   if ((((((jump === 1'b0) & (call === 1'b0)) & (nmicycle === 1'b0)) & (intcycle === 1'b0)) & ~ (((halt_ff === 1'b1) | (halt === 1'b1))))) 
                                                           pc <= (pc + 1);

                                                   if (((intcycle === 1'b1) & (istatus === 2'b01))) 
                                                           ir <= 8'b11111111;
                                                   else if ((((halt_ff === 1'b1) | ((intcycle === 1'b1) & (istatus === 2'b10))) | (nmicycle === 1'b1))) 
                                                           ir <= 8'b00000000;
                                                   else 
                                                           ir <= dinst;

                                                   iset <= 2'b00;
                                                   if ((!(prefix===2'b00))) 
                                                       begin 
                                                               if ((prefix === 2'b11)) 
                                                                   begin 
                                                                           if ((ir[5] === 1'b1)) 
                                                                                   xy_state <= 2'b10;
                                                                           else 
                                                                                   xy_state <= 2'b01;

                                                                           
                                                                   end 
                                                               else 
                                                                   begin 
                                                                       begin 
                                                                           if ((prefix === 2'b10)) 
                                                                               begin 
                                                                                   xy_state <= 2'b00;
                                                                                   xy_ind <= 1'b0;
                                                                               end

                                                                           iset <= prefix;
                                                                       end
                                                                   end 

                                                               
                                                       end 
                                                   else 
                                                       begin 
                                                           xy_state <= 2'b00;
                                                           xy_ind <= 1'b0;
                                                       end

                                                   
                                               end
                                           end 

                                       
                               end 
                           else 
                               begin 
                                   begin 
                                       if ((mcycle === 3'b110)) 
                                           begin 
                                               xy_ind <= 1'b1;
                                               if ((prefix === 2'b01)) 
                                                       iset <= 2'b01;

                                               
                                           end

                                       if ((t_res === 1'b1)) 
                                           begin 
                                               btr_r <= (((i_bt | i_bc) | i_btr) & ~ (no_btr));
                                               if ((jump === 1'b1)) 
                                                   begin 
                                                       a[15:8] <= di_reg;
                                                       a[7:0] <= tmpaddr[7:0];
                                                       pc[15:8] <= $unsigned(di_reg);
                                                       pc[7:0] <= $unsigned(tmpaddr[7:0]);
                                                   end
                                               else if ((jumpxy === 1'b1)) 
                                                   begin 
                                                       a <= regbusc;
                                                       pc <= $unsigned(regbusc);
                                                   end
                                               else if (((call === 1'b1) | (rstp === 1'b1))) 
                                                   begin 
                                                       a <= tmpaddr;
                                                       pc <= $unsigned(tmpaddr);
                                                   end
                                               else if (((mcycle === mcycles) & (nmicycle === 1'b1))) 
                                                   begin 
                                                       a <= 16'b0000000001100110;
                                                       pc <= 16'b0000000001100110;
                                                   end
                                               else if ((((mcycle === 3'b011) & (intcycle === 1'b1)) & (istatus === 2'b10))) 
                                                   begin 
                                                       a[15:8] <= i;
                                                       a[7:0] <= tmpaddr[7:0];
                                                       pc[15:8] <= $unsigned(i);
                                                       pc[7:0] <= $unsigned(tmpaddr[7:0]);
                                                   end
                                               else 
                                                       case (set_addr_to)
                                                           3'b010 : 
                                                                   if ((xy_state === 2'b00)) 
                                                                           a <= regbusc;
                                                                   else 
                                                                       begin 
                                                                               if ((nextis_xy_fetch === 1'b1)) 
                                                                                       a <= pc;
                                                                               else 
                                                                                       a <= tmpaddr;

                                                                               
                                                                       end 

                                                                   
                                                           3'b100 : 
                                                               begin 
                                                                   if ((mode === 3)) 
                                                                           a[15:8] <= {(15-8+1- 0){1'b1}};
                                                                   else if ((mode === 2)) 
                                                                           a[15:8] <= di_reg;
                                                                   else 
                                                                           a[15:8] <= acc;

                                                                   a[7:0] <= di_reg;
                                                               end
                                                           3'b101 : 
                                                                   a <= sp;
                                                           3'b000 : 
                                                                   if (((mode === 3) & (iorq_i === 1'b1))) 
                                                                       begin 
                                                                           a[15:8] <= {(15-8+1- 0){1'b1}};
                                                                           a[7:0] <= regbusc[7:0];
                                                                       end
                                                                   else 
                                                                           a <= regbusc;

                                                                   
                                                           3'b001 : 
                                                                   a <= regbusc;
                                                           3'b110 : 
                                                                   if ((inc_wz === 1'b1)) 
                                                                           a <= ($unsigned(tmpaddr) + 1);
                                                                   else 
                                                                       begin 
                                                                           a[15:8] <= di_reg;
                                                                           a[7:0] <= tmpaddr[7:0];
                                                                       end

                                                                   
                                                           default : 
                                                                   a <= pc;
                                                       endcase

                                               save_alu_r <= save_alu;
                                               alu_op_r <= alu_op;
                                               if ((i_cpl === 1'b1)) 
                                                   begin 
                                                       acc <= ~ (acc);
                                                       f[flag_y] <= ~ (acc[5]);
                                                       f[flag_h] <= 1'b1;
                                                       f[flag_x] <= ~ (acc[3]);
                                                       f[flag_n] <= 1'b1;
                                                   end

                                               if ((i_ccf === 1'b1)) 
                                                   begin 
                                                       f[flag_c] <= ~ (f[flag_c]);
                                                       f[flag_y] <= acc[5];
                                                       f[flag_h] <= f[flag_c];
                                                       f[flag_x] <= acc[3];
                                                       f[flag_n] <= 1'b0;
                                                   end

                                               if ((i_scf === 1'b1)) 
                                                   begin 
                                                       f[flag_c] <= 1'b1;
                                                       f[flag_y] <= acc[5];
                                                       f[flag_h] <= 1'b0;
                                                       f[flag_x] <= acc[3];
                                                       f[flag_n] <= 1'b0;
                                                   end

                                               
                                           end

                                       if (((tstate === 2) & (wait_n === 1'b1))) 
                                           begin 
                                               begin 
                                                   if (((iset === 2'b01) & (mcycle === 3'b111))) 
                                                           ir <= dinst;

                                                   if ((jumpe === 1'b1)) 
                                                           pc <= $unsigned(($signed(pc) + $signed(di_reg)));
                                                   else if ((inc_pc === 1'b1)) 
                                                           pc <= (pc + 1);

                                                   if ((btr_r === 1'b1)) 
                                                           pc <= (pc - 2);

                                                   if ((rstp === 1'b1)) 
                                                       begin 
                                                           tmpaddr <= {(15-0+1- 0){1'b0}};
                                                           tmpaddr[5:3] <= ir[5:3];
                                                       end

                                                   
                                               end
                                           end 

                                       if (((tstate === 3) & (mcycle === 3'b110))) 
                                               tmpaddr <= ($signed(regbusc) + $signed(di_reg));

                                       if ((((tstate === 2) & (wait_n === 1'b1)) | ((tstate === 4) & (mcycle === 3'b001)))) 
                                           begin 
                                                   if ((incdec_16[2:0] === 3'b111)) 
                                                       begin 
                                                               if ((incdec_16[3] === 1'b1)) 
                                                                       sp <= (sp - 1);
                                                               else 
                                                                       sp <= (sp + 1);

                                                               
                                                       end 

                                                   
                                           end 

                                       if ((ldsphl === 1'b1)) 
                                               sp <= $unsigned(regbusc);

                                       if ((exchangeaf === 1'b1)) 
                                           begin 
                                               ap <= acc;
                                               acc <= ap;
                                               fp <= f;
                                               f <= fp;
                                           end

                                       if ((exchangers === 1'b1)) 
                                               alternate <= ~ (alternate);

                                       
                                   end
                               end 
                           
                           if ((tstate === 3)) 
                               begin 
                                   begin 
                                       if ((ldz === 1'b1)) 
                                               tmpaddr[7:0] <= di_reg;

                                       if ((ldw === 1'b1)) 
                                               tmpaddr[15:8] <= di_reg;

                                       if ((special_ld[2] === 1'b1)) 
                                               case (special_ld[1:0])
                                                   2'b00 : 
                                                       begin 
                                                           acc <= i;
                                                           f[flag_p] <= inte_ff2;
                                                       end
                                                   2'b01 : 
                                                       begin 
                                                           acc <= r;
                                                           f[flag_p] <= inte_ff2;
                                                       end
                                                   2'b10 : 
                                                           i <= acc;
                                                   default : 
                                                           r <= $unsigned(acc);
                                               endcase

                                       
                                   end
                               end 
                           
                           if ((((i_djnz === 1'b0) & (save_alu_r === 1'b1)) | (alu_op_r === 4'b1001))) 
                               begin 
                                       if ((mode === 3)) 
                                           begin 
                                               f[6] <= f_out[6];
                                               f[5] <= f_out[5];
                                               f[7] <= f_out[7];
                                               if ((preservec_r === 1'b0)) 
                                                       f[4] <= f_out[4];

                                               
                                           end
                                       else 
                                           begin 
                                               f[7:1] <= f_out[7:1];
                                               if ((preservec_r === 1'b0)) 
                                                       f[flag_c] <= f_out[0];

                                               
                                           end

                                       
                               end 
                           
                           if (((t_res === 1'b1) & (i_inrc === 1'b1))) 
                               begin 
                                   f[flag_h] <= 1'b0;
                                   f[flag_n] <= 1'b0;
                                   if ((di_reg[7:0] === 8'b00000000)) 
                                       f[flag_z] <= 1'b1;
                                       
                                   else 
                                       f[flag_z] <= 1'b0;
                                       
                                   
                                   f[flag_s] <= di_reg[7];
                                   f[flag_p] <= ~ ((((((((di_reg[0] ^ di_reg[1]) ^ di_reg[2]) ^ di_reg[3]) ^ di_reg[4]) ^ di_reg[5]) ^ di_reg[6]) ^ di_reg[7]));
                               end
                               
                           
                           if (((tstate === 1) & (auto_wait_t1 === 1'b0))) 
                               begin 
                                   do <= busb;
                                   if ((i_rld === 1'b1)) 
                                       begin 
                                           do[3:0] <= busa[3:0];
                                           do[7:4] <= busb[3:0];
                                       end
                                       
                                   
                                   if ((i_rrd === 1'b1)) 
                                       begin 
                                           do[3:0] <= busb[7:4];
                                           do[7:4] <= busa[3:0];
                                       end
                                       
                                   
                                   
                               end
                               
                           
                           if ((t_res === 1'b1)) 
                               begin 
                                   read_to_reg_r[3:0] <= set_busa_to;
                                   read_to_reg_r[4] <= read_to_reg;
                                   if ((read_to_acc === 1'b1)) 
                                       begin 
                                           read_to_reg_r[3:0] <= 4'b0111;
                                           read_to_reg_r[4] <= 1'b1;
                                       end
                                       
                                   
                                   
                               end
                               
                           
                           if (((tstate === 1) & (i_bt === 1'b1))) 
                               begin 
                                   f[flag_x] <= alu_q[3];
                                   f[flag_y] <= alu_q[1];
                                   f[flag_h] <= 1'b0;
                                   f[flag_n] <= 1'b0;
                               end
                               
                           
                           if (((i_bc === 1'b1) | (i_bt === 1'b1))) 
                               f[flag_p] <= incdecz;
                               
                           
                           if (((((tstate === 1) & (save_alu_r === 1'b0)) & (auto_wait_t1 === 1'b0)) | ((save_alu_r === 1'b1) & (!(alu_op_r===4'b0111))))) 
                               case (read_to_reg_r)
                                   5'b10111 : 
                                           acc <= save_mux;
                                   5'b10110 : 
                                           do <= save_mux;
                                   5'b11000 : 
                                           sp[7:0] <= $unsigned(save_mux);
                                   5'b11001 : 
                                           sp[15:8] <= $unsigned(save_mux);
                                   5'b11011 : 
                                           f <= save_mux;
                                   default : 
                                       ;
                               endcase
                               
                           
                           
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (posedge clk_n ) begin
               begin 
                   if ((clken === 1'b1)) 
                       begin 
                           regaddra_r <= {alternate,set_busa_to[2:1]};
                           if ((((xy_ind === 1'b0) & (!(xy_state===2'b00))) & (set_busa_to[2:1] === 2'b10))) 
                               regaddra_r <= {xy_state[1],2'b11};
                               
                           
                           regaddrb_r <= {alternate,set_busb_to[2:1]};
                           if ((((xy_ind === 1'b0) & (!(xy_state===2'b00))) & (set_busb_to[2:1] === 2'b10))) 
                               regaddrb_r <= {xy_state[1],2'b11};
                               
                           
                           regaddrc <= {alternate,set_addr_to[1:0]};
                           if (((jumpxy === 1'b1) | (ldsphl === 1'b1))) 
                               regaddrc <= {alternate,2'b10};
                               
                           
                           if (((((jumpxy === 1'b1) | (ldsphl === 1'b1)) & (!(xy_state===2'b00))) | (mcycle === 3'b110))) 
                               regaddrc <= {xy_state[1],2'b11};
                               
                           
                           if ((((i_djnz === 1'b1) & (save_alu_r === 1'b1)) & (mode < 2))) 
                               incdecz <= f_out[flag_z];
                               
                           
                           if ((((tstate === 2) | ((tstate === 3) & (mcycle === 3'b001))) & (incdec_16[2:0] === 3'b100))) 
                               begin 
                                       if ((id16 === 0)) 
                                               incdecz <= 1'b0;
                                       else 
                                               incdecz <= 1'b1;

                                       
                               end 
                           
                           regbusa_r <= regbusa;
                       end
                       
                   
                   
               end 
           
   end //always
   
   assign {regaddra}=(((tstate === 2) | (((tstate === 3) & (mcycle === 3'b001)) & (incdec_16[2] === 1'b1))) & (xy_state === 2'b00)) ? 
                         {alternate,incdec_16[1:0]}
                      : (((tstate === 2) | (((tstate === 3) & (mcycle === 3'b001)) & (incdec_16[2] === 1'b1))) & (incdec_16[1:0] === 2'b10)) ? 
                         {xy_state[1],2'b11}
                      : ((exchangedh === 1'b1) & (tstate === 3)) ? 
                         {alternate,2'b10}
                      : ((exchangedh === 1'b1) & (tstate === 4)) ? 
                         {alternate,2'b01}
                      :  regaddra_r;
   
   assign {regaddrb}=((exchangedh === 1'b1) & (tstate === 3)) ? 
                         {alternate,2'b01}
                      :  regaddrb_r;
   
   assign {id16}=(incdec_16[3] === 1'b1) ? 
                     ($signed(regbusa) - 1)
                  :  ($signed(regbusa) + 1);
   
       
   always @ (save_alu_r or auto_wait_t1 or alu_op_r or read_to_reg_r or exchangedh or incdec_16 or mcycle or tstate or wait_n ) begin
           regweh <= 1'b0;
           regwel <= 1'b0;
           if (((((tstate === 1) & (save_alu_r === 1'b0)) & (auto_wait_t1 === 1'b0)) | ((save_alu_r === 1'b1) & (!(alu_op_r===4'b0111))))) 
               case (read_to_reg_r)
                   5'b10000,5'b10001,5'b10010,5'b10011,5'b10100,5'b10101 : 
                       begin 
                           regweh <= ~ (read_to_reg_r[0]);
                           regwel <= read_to_reg_r[0];
                       end
                   default : 
                       ;
               endcase
               
           if (((exchangedh === 1'b1) & ((tstate === 3) | (tstate === 4)))) 
               begin 
                   regweh <= 1'b1;
                   regwel <= 1'b1;
               end
               
           if (((incdec_16[2] === 1'b1) & ((((tstate === 2) & (wait_n === 1'b1)) & (!(mcycle===3'b001))) | ((tstate === 3) & (mcycle === 3'b001))))) 
               case (incdec_16[1:0])
                   2'b00,2'b01,2'b10 : 
                       begin 
                           regweh <= 1'b1;
                           regwel <= 1'b1;
                       end
                   default : 
                       ;
               endcase
               
           
   end //always
   
       
   always @ (save_mux or regbusb or regbusa_r or id16 or exchangedh or incdec_16 or mcycle or tstate or wait_n ) begin
           regdih <= save_mux;
           regdil <= save_mux;
           if (((exchangedh === 1'b1) & (tstate === 3))) 
               begin 
                   regdih <= regbusb[15:8];
                   regdil <= regbusb[7:0];
               end
               
           if (((exchangedh === 1'b1) & (tstate === 4))) 
               begin 
                   regdih <= regbusa_r[15:8];
                   regdil <= regbusa_r[7:0];
               end
               
           if (((incdec_16[2] === 1'b1) & (((tstate === 2) & (!(mcycle===3'b001))) | ((tstate === 3) & (mcycle === 3'b001))))) 
               begin 
                   regdih <= id16[15:8];
                   regdil <= id16[7:0];
               end
               
           
   end //always
   
   t80_reg regs(.clk(clk_n), .cen(clken), .weh(regweh), .wel(regwel), .addra(regaddra), .addrb(regaddrb), .addrc(regaddrc), .dih(regdih), .dil(regdil), .doah(regbusa[15:8]), .doal(regbusa[7:0]), .dobh(regbusb[15:8]), .dobl(regbusb[7:0]), .doch(regbusc[15:8]), .docl(regbusc[7:0]));
   
       
   always @ (posedge clk_n ) begin
               begin 
                   if ((clken === 1'b1)) 
                       begin 
                           case (set_busb_to)
                               4'b0111 : 
                                       busb <= acc;
                               4'b0000,4'b0001,4'b0010,4'b0011,4'b0100,4'b0101 : 
                                       if ((set_busb_to[0] === 1'b1)) 
                                               busb <= regbusb[7:0];
                                       else 
                                               busb <= regbusb[15:8];

                                       
                               4'b0110 : 
                                       busb <= di_reg;
                               4'b1000 : 
                                       busb <= sp[7:0];
                               4'b1001 : 
                                       busb <= sp[15:8];
                               4'b1010 : 
                                       busb <= 8'b00000001;
                               4'b1011 : 
                                       busb <= f;
                               4'b1100 : 
                                       busb <= pc[7:0];
                               4'b1101 : 
                                       busb <= pc[15:8];
                               4'b1110 : 
                                       busb <= 8'b00000000;
                               default : 
                                       busb <= 8'bxxxxxxxx;
                           endcase
                           case (set_busa_to)
                               4'b0111 : 
                                       busa <= acc;
                               4'b0000,4'b0001,4'b0010,4'b0011,4'b0100,4'b0101 : 
                                       if ((set_busa_to[0] === 1'b1)) 
                                               busa <= regbusa[7:0];
                                       else 
                                               busa <= regbusa[15:8];

                                       
                               4'b0110 : 
                                       busa <= di_reg;
                               4'b1000 : 
                                       busa <= sp[7:0];
                               4'b1001 : 
                                       busa <= sp[15:8];
                               4'b1010 : 
                                       busa <= 8'b00000000;
                               default : 
                                       busb <= 8'bxxxxxxxx;
                           endcase
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               rfsh_n <= 1'b1;
               
           else 
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                               if (((mcycle === 3'b001) & (((tstate === 2) & (wait_n === 1'b1)) | (tstate === 3)))) 
                                       rfsh_n <= 1'b0;
                               else 
                                       rfsh_n <= 1'b1;

                               
                       end 
                   
                   
               end 
           
   end //always
   
   assign {mc}=mcycle;
   
   assign {ts}=tstate;
   
   assign {di_reg}=di;
   
   assign {halt_n}=~ (halt_ff);
   
   assign {busak_n}=~ (busack);
   
   assign {intcycle_n}=~ (intcycle);
   
   assign {inte}=inte_ff1;
   
   assign {iorq}=iorq_i;
   
   assign {stop}=i_djnz;
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               begin 
                   busreq_s <= 1'b0;
                   int_s <= 1'b0;
                   nmi_s <= 1'b0;
                   Process1__oldnmi_n = 1'b0;
               end
               
           else 
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                           busreq_s <= ~ (busrq_n);
                           int_s <= ~ (int_n);
                           if ((nmicycle === 1'b1)) 
                               nmi_s <= 1'b0;
                               
                           else if (((nmi_n === 1'b0) & (Process1__oldnmi_n === 1'b1))) 
                               nmi_s <= 1'b1;
                               
                           
                           Process1__oldnmi_n = nmi_n;
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge reset_n or posedge clk_n ) begin
           if ((reset_n === 1'b0)) 
               begin 
                   mcycle <= 3'b001;
                   tstate <= 3'b000;
                   pre_xy_f_m <= 3'b000;
                   halt_ff <= 1'b0;
                   busack <= 1'b0;
                   nmicycle <= 1'b0;
                   intcycle <= 1'b0;
                   inte_ff1 <= 1'b0;
                   inte_ff2 <= 1'b0;
                   no_btr <= 1'b0;
                   auto_wait_t1 <= 1'b0;
                   auto_wait_t2 <= 1'b0;
                   m1_n <= 1'b1;
               end
               
           else 
               begin 
                   if ((cen === 1'b1)) 
                       begin 
                           begin 
                               if ((t_res === 1'b1)) 
                                       auto_wait_t1 <= 1'b0;
                               else 
                                       auto_wait_t1 <= (auto_wait | iorq_i);

                               auto_wait_t2 <= auto_wait_t1;
                               no_btr <= (((i_bt & (~ (ir[4]) | ~ (f[flag_p]))) | (i_bc & ((~ (ir[4]) | f[flag_z]) | ~ (f[flag_p])))) | (i_btr & (~ (ir[4]) | f[flag_z])));
                               if ((tstate === 2)) 
                                   begin 
                                       begin 
                                           if ((setei === 1'b1)) 
                                               begin 
                                                   inte_ff1 <= 1'b1;
                                                   inte_ff2 <= 1'b1;
                                               end

                                           if ((i_retn === 1'b1)) 
                                                   inte_ff1 <= inte_ff2;

                                           
                                       end
                                   end 

                               if ((tstate === 3)) 
                                   begin 
                                           if ((setdi === 1'b1)) 
                                               begin 
                                                   inte_ff1 <= 1'b0;
                                                   inte_ff2 <= 1'b0;
                                               end

                                           
                                   end 

                               if (((intcycle === 1'b1) | (nmicycle === 1'b1))) 
                                       halt_ff <= 1'b0;

                               if ((((mcycle === 3'b001) & (tstate === 2)) & (wait_n === 1'b1))) 
                                       m1_n <= 1'b1;

                               if (((busreq_s === 1'b1) & (busack === 1'b1))) 
                                   ;//Null
                               else 
                                   begin 
                                       busack <= 1'b0;
                                       if (((tstate === 2) & (wait_n === 1'b0))) 
                                           ;//Null
                                       else if ((t_res === 1'b1)) 
                                           begin 
                                               begin 
                                                   if ((halt === 1'b1)) 
                                                           halt_ff <= 1'b1;

                                                   if ((busreq_s === 1'b1)) 
                                                           busack <= 1'b1;
                                                   else 
                                                       begin 
                                                           tstate <= 3'b001;
                                                           if ((nextis_xy_fetch === 1'b1)) 
                                                               begin 
                                                                   mcycle <= 3'b110;
                                                                   pre_xy_f_m <= mcycle;
                                                                   if (((ir === 8'b00110110) & (mode === 0))) 
                                                                           pre_xy_f_m <= 3'b010;

                                                                   
                                                               end
                                                           else if (((mcycle === 3'b111) | (((mcycle === 3'b110) & (mode === 1)) & (!(iset===2'b01))))) 
                                                                   mcycle <= ($unsigned(pre_xy_f_m) + 1);
                                                           else if ((((mcycle === mcycles) | (no_btr === 1'b1)) | (((mcycle === 3'b010) & (i_djnz === 1'b1)) & (incdecz === 1'b1)))) 
                                                               begin 
                                                                   m1_n <= 1'b0;
                                                                   mcycle <= 3'b001;
                                                                   intcycle <= 1'b0;
                                                                   nmicycle <= 1'b0;
                                                                   if (((nmi_s === 1'b1) & (prefix === 2'b00))) 
                                                                       begin 
                                                                           nmicycle <= 1'b1;
                                                                           inte_ff1 <= 1'b0;
                                                                       end
                                                                   else if (((((inte_ff1 === 1'b1) & (int_s === 1'b1)) & (prefix === 2'b00)) & (setei === 1'b0))) 
                                                                       begin 
                                                                           intcycle <= 1'b1;
                                                                           inte_ff1 <= 1'b0;
                                                                           inte_ff2 <= 1'b0;
                                                                       end

                                                                   
                                                               end
                                                           else 
                                                                   mcycle <= ($unsigned(mcycle) + 1);

                                                           
                                                       end

                                                   
                                               end
                                           end 
                                       else 
                                           begin 
                                                   if ((~(((auto_wait === 1'b1) & (auto_wait_t2 === 1'b0)) | (((iowait === 1) & (iorq_i === 1'b1)) & (auto_wait_t1 === 1'b0))))) 
                                                           tstate <= (tstate + 1);

                                                   
                                           end 

                                       
                                   end

                               if ((tstate === 0)) 
                                       m1_n <= 1'b0;

                               
                           end
                       end 
                   
                   
               end 
           
   end //always
   
       
   always @ (intcycle or nmicycle or mcycle ) begin
           auto_wait <= 1'b0;
           if (((intcycle === 1'b1) | (nmicycle === 1'b1))) 
               begin 
                   if ((mcycle === 3'b001)) 
                       auto_wait <= 1'b1;
                       
                   
                   
               end 
           
   end //always
    

endmodule
//
// 16450 compatible UART with synchronous bus interface
// RClk/BaudOut is XIn enable instead of actual clock
//
// Version : 0249b
//
// Copyright (c) 2002 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//
// 0208 : First release
//
// 0249 : Fixed interrupt and baud rate bugs found by Andy Dyer
//        Added modem status and break detection
//        Added support for 1.5 and 2 stop bits
//
// 0249b : Fixed loopback break generation bugs found by Andy Dyer
//


module  t16450 ( mr_n, xin, rclk, cs_n, rd_n, wr_n, a, d_in, d_out, sin, cts_n, dsr_n, ri_n, dcd_n, sout, rts_n, dtr_n, out1_n, out2_n, baudout, intr );
    
    input mr_n;
    input xin;
    input rclk;
    input cs_n;
    input rd_n;
    input wr_n;
    input [2:0]  a ;
    input [7:0]  d_in ;
    output [7:0]  d_out ;
    input sin;
    input cts_n;
    input dsr_n;
    input ri_n;
    input dcd_n;
    output sout;
    output rts_n;
    output dtr_n;
    output out1_n;
    output out2_n;
    output baudout;
    output intr;


    reg [15:0] Process1__baud_cnt;
    reg [1:0] Process2__samples;
    reg [4:0] Process3__tx_cnt;
    reg [7:0] rbr;
    reg [7:0] thr;
    reg [7:0] ier;
    wire [7:0] iir;
    reg [7:0] lcr;
    reg [7:0] mcr;
    reg [7:0] lsr;
    reg [7:0] msr;
    reg [7:0] scr;
    reg [7:0] dll;
    reg [7:0] dlm;
    wire [7:0] dm0;
    wire [7:0] dm1;
    reg [3:0] msr_in;
    reg [3:0] bit_phase;
    reg [3:0] brk_cnt;
    reg rx_filtered;
    reg [7:0] rx_shiftreg;
    integer rx_bit_cnt;
    reg rx_parity;
    wire rxd;
    reg tx_tick;
    reg [7:0] tx_shiftreg;
    integer tx_bit_cnt;
    reg tx_parity;
    reg tx_next_is_stop;
    reg tx_stop_bit;
    reg txd;
    wire [7:0] d_out;
    wire sout;
    wire rts_n;
    wire dtr_n;
    wire out1_n;
    wire out2_n;
    reg baudout;
    wire intr;


    
   assign {dtr_n}=(mcr[4] | ~ (mcr[0]));
   
   assign {rts_n}=(mcr[4] | ~ (mcr[1]));
   
   assign {out1_n}=(mcr[4] | ~ (mcr[2]));
   
   assign {out2_n}=(mcr[4] | ~ (mcr[3]));
   
   assign {sout}=(mcr[4] | (txd & ~ (lcr[6])));
   
   assign {rxd}=(mcr[4] === 1'b0) ? 
                    sin
                 :  (txd & ~ (lcr[6]));
   
   assign {intr}=~ (iir[0]);
   
   assign {dm0}=(lcr[7] === 1'b1) ? 
                    dll
                 :  rbr;
   
   assign {dm1}=(lcr[7] === 1'b1) ? 
                    dlm
                 :  ier;
   
   assign d_out=a===3'b000 ? dm0 : 
           a===3'b001 ? dm1 : 
           a===3'b010 ? iir : 
           a===3'b011 ? lcr : 
           a===3'b100 ? mcr : 
           a===3'b101 ? lsr : 
           a===3'b110 ? msr : 
           scr;
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   thr <= 8'b00000000;
                   ier <= 8'b00000000;
                   lcr <= 8'b00000000;
                   mcr <= 8'b00000000;
                   msr[3:0] <= 4'b0000;
                   scr <= 8'b00000000;
                   dll <= 8'b00000000;
                   dlm <= 8'b00000000;
               end
               
           else 
               begin 
                   begin 
                       if (((wr_n === 1'b0) & (cs_n === 1'b0))) 
                           case (a)
                               3'b000 : 
                                       if ((lcr[7] === 1'b1)) 
                                               dll <= d_in;
                                       else 
                                               thr <= d_in;

                                       
                               3'b001 : 
                                       if ((lcr[7] === 1'b1)) 
                                               dlm <= d_in;
                                       else 
                                               ier[3:0] <= d_in[3:0];

                                       
                               3'b011 : 
                                       lcr <= d_in;
                               3'b100 : 
                                       mcr <= d_in;
                               3'b111 : 
                                       scr <= d_in;
                               default : 
                                   ;
                           endcase
                           
                       
                       if ((((rd_n === 1'b0) & (cs_n === 1'b0)) & (a === 3'b110))) 
                           msr[3:0] <= 4'b0000;
                           
                       
                       if ((!(msr[4]===msr_in[0]))) 
                           msr[0] <= 1'b1;
                           
                       
                       if ((!(msr[5]===msr_in[1]))) 
                           msr[1] <= 1'b1;
                           
                       
                       if (((msr[6] === 1'b0) & (msr_in[2] === 1'b1))) 
                           msr[2] <= 1'b1;
                           
                       
                       if ((!(msr[7]===msr_in[3]))) 
                           msr[3] <= 1'b1;
                           
                       
                       
                   end
                   
               end 
           
   end //always
   
       
   always @ (posedge xin ) begin
               begin 
                   begin 
                       if ((mcr[4] === 1'b0)) 
                           begin 
                               msr[4] <= msr_in[0];
                               msr[5] <= msr_in[1];
                               msr[6] <= msr_in[2];
                               msr[7] <= msr_in[3];
                           end
                           
                       else 
                           begin 
                               msr[4] <= mcr[1];
                               msr[5] <= mcr[0];
                               msr[6] <= mcr[2];
                               msr[7] <= mcr[3];
                           end
                           
                       
                       msr_in[0] <= cts_n;
                       msr_in[1] <= dsr_n;
                       msr_in[2] <= ri_n;
                       msr_in[3] <= dcd_n;
                   end
                   
               end 
           
   end //always
   
   assign {iir[7:3]}=5'b00000;
   
   assign {iir[2:0]}=((ier[2] === 1'b1) & (!(lsr[4:1]===4'b0000))) ? 
                         3'b110
                      : ((ier[0] & lsr[0]) === 1'b1) ? 
                         3'b100
                      : ((ier[1] & lsr[5]) === 1'b1) ? 
                         3'b010
                      : ((ier[3] === 1'b1) & (((mcr[4] === 1'b0) & (!(msr[3:0]===4'b0000))) | ((mcr[4] === 1'b1) & (!(mcr[3:0]===4'b0000))))) ? 
                         3'b000
                      :  3'b001;
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   Process1__baud_cnt = 16'b0000000000000000;
                   baudout <= 1'b0;
               end
               
           else 
               begin 
                   if (((Process1__baud_cnt[15:1] === 15'b000000000000000) | ((((wr_n === 1'b0) & (cs_n === 1'b0)) & (a[2:1] === 2'b00)) & (lcr[7] === 1'b1)))) 
                       begin 
                           Process1__baud_cnt[15:8] = $unsigned(dlm);
                           Process1__baud_cnt[7:0] = $unsigned(dll);
                           baudout <= 1'b1;
                       end
                       
                   else 
                       begin 
                           Process1__baud_cnt = (Process1__baud_cnt - 1);
                           baudout <= 1'b0;
                       end
                       
                   
                   
               end 
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   Process2__samples = 2'b11;
                   rx_filtered <= 1'b1;
               end
               
           else 
               begin 
                   begin 
                       if ((rclk === 1'b1)) 
                           begin 
                               Process2__samples[1] = Process2__samples[0];
                               Process2__samples[0] = rxd;
                           end
                           
                       
                       if ((Process2__samples === 2'b00)) 
                           rx_filtered <= 1'b0;
                           
                       
                       if ((Process2__samples === 2'b11)) 
                           rx_filtered <= 1'b1;
                           
                       
                       
                   end
                   
               end 
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   rbr <= 8'b00000000;
                   lsr[4:0] <= 5'b00000;
                   bit_phase <= 4'b0000;
                   brk_cnt <= 4'b0000;
                   rx_shiftreg[7:0] <= 8'b00000000;
                   rx_bit_cnt <= 0;
                   rx_parity <= 1'b0;
               end
               
           else 
               begin 
                   begin 
                       if (((((a === 3'b000) & (lcr[7] === 1'b0)) & (rd_n === 1'b0)) & (cs_n === 1'b0))) 
                           lsr[0] <= 1'b0;
                           
                       
                       if ((((a === 3'b101) & (rd_n === 1'b0)) & (cs_n === 1'b0))) 
                           begin 
                               lsr[4] <= 1'b0;
                               lsr[3] <= 1'b0;
                               lsr[2] <= 1'b0;
                               lsr[1] <= 1'b0;
                           end
                           
                       
                       if ((rclk === 1'b1)) 
                           begin 
                               begin 
                                   if (((rx_bit_cnt === 0) & ((rx_filtered === 1'b1) | (bit_phase === 4'b0111)))) 
                                           bit_phase <= 4'b0000;
                                   else 
                                           bit_phase <= (bit_phase + 1);

                                   if ((bit_phase === 4'b1111)) 
                                       begin 
                                           begin 
                                               if ((rx_filtered === 1'b1)) 
                                                       brk_cnt <= 4'b0000;
                                               else 
                                                       brk_cnt <= (brk_cnt + 1);

                                               if ((brk_cnt === 4'b1100)) 
                                                       lsr[4] <= 1'b1;

                                               
                                           end
                                       end 

                                   if ((rx_bit_cnt === 0)) 
                                       begin 
                                               if ((bit_phase === 4'b0111)) 
                                                   begin 
                                                       rx_bit_cnt <= (rx_bit_cnt + 1);
                                                       rx_parity <= ~ (lcr[4]);
                                                   end

                                               
                                       end 
                                   else if ((bit_phase === 4'b1111)) 
                                       begin 
                                           rx_bit_cnt <= (rx_bit_cnt + 1);
                                           if ((rx_bit_cnt === 10)) 
                                               begin 
                                                   rx_bit_cnt <= 0;
                                                   lsr[0] <= 1'b1;
                                                   lsr[3] <= ~ (rx_filtered);
                                               end
                                           else if ((((((rx_bit_cnt === 9) & (lcr[1:0] === 2'b11)) | ((rx_bit_cnt === 8) & (lcr[1:0] === 2'b10))) | ((rx_bit_cnt === 7) & (lcr[1:0] === 2'b01))) | ((rx_bit_cnt === 6) & (lcr[1:0] === 2'b00)))) 
                                               begin 
                                                   rx_bit_cnt <= 0;
                                                   if ((lcr[3] === 1'b1)) 
                                                       begin 
                                                           rx_bit_cnt <= 10;
                                                           if ((lcr[5] === 1'b1)) 
                                                               begin 
                                                                       if ((rx_filtered === lcr[4])) 
                                                                               lsr[2] <= 1'b1;

                                                                       
                                                               end 
                                                           else 
                                                               begin 
                                                                       if ((!(rx_filtered===rx_parity))) 
                                                                               lsr[2] <= 1'b1;

                                                                       
                                                               end 

                                                           
                                                       end
                                                   else 
                                                       begin 
                                                           lsr[0] <= 1'b1;
                                                           lsr[3] <= ~ (rx_filtered);
                                                       end

                                                   rbr <= rx_shiftreg[7:0];
                                                   lsr[1] <= lsr[0];
                                                   if ((((a === 3'b101) & (rd_n === 1'b0)) & (cs_n === 1'b0))) 
                                                           lsr[1] <= 1'b0;

                                                   
                                               end
                                           else 
                                               begin 
                                                   rx_shiftreg[6:0] <= rx_shiftreg[7:1];
                                                   rx_shiftreg[7] <= rx_filtered;
                                                   if ((lcr[1:0] === 2'b10)) 
                                                       begin 
                                                           rx_shiftreg[7] <= 1'b0;
                                                           rx_shiftreg[6] <= rx_filtered;
                                                       end

                                                   if ((lcr[1:0] === 2'b01)) 
                                                       begin 
                                                           rx_shiftreg[7] <= 1'b0;
                                                           rx_shiftreg[6] <= 1'b0;
                                                           rx_shiftreg[5] <= rx_filtered;
                                                       end

                                                   if ((lcr[1:0] === 2'b00)) 
                                                       begin 
                                                           rx_shiftreg[7] <= 1'b0;
                                                           rx_shiftreg[6] <= 1'b0;
                                                           rx_shiftreg[5] <= 1'b0;
                                                           rx_shiftreg[4] <= rx_filtered;
                                                       end

                                                   rx_parity <= (rx_filtered ^ rx_parity);
                                               end

                                           
                                       end

                                   
                               end
                           end 
                       
                       
                   end
                   
               end 
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   Process3__tx_cnt = 5'b00000;
                   tx_tick <= 1'b0;
               end
               
           else 
               begin 
                   tx_tick <= 1'b0;
                   if ((rclk === 1'b1)) 
                       begin 
                           Process3__tx_cnt = (Process3__tx_cnt + 1);
                           if (((lcr[2] === 1'b1) & (tx_stop_bit === 1'b1))) 
                               begin 
                                       if ((lcr[1:0] === 2'b00)) 
                                           begin 
                                                   if ((Process3__tx_cnt === 5'b10111)) 
                                                       begin 
                                                           tx_tick <= 1'b1;
                                                           Process3__tx_cnt[3:0] = 4'b0000;
                                                       end

                                                   
                                           end 
                                       else 
                                           begin 
                                                   if ((Process3__tx_cnt === 5'b11111)) 
                                                       begin 
                                                           tx_tick <= 1'b1;
                                                           Process3__tx_cnt[3:0] = 4'b0000;
                                                       end

                                                   
                                           end 

                                       
                               end 
                           else 
                               begin 
                                   Process3__tx_cnt[4] = 1'b1;
                                   if ((Process3__tx_cnt[3:0] === 4'b1111)) 
                                       tx_tick <= 1'b1;
                                       
                                   
                                   
                               end
                               
                           
                           
                       end
                       
                   
                   
               end
               
           
   end //always
   
       
   always @ (negedge mr_n or posedge xin ) begin
           if ((mr_n === 1'b0)) 
               begin 
                   lsr[7:5] <= 3'b011;
                   tx_bit_cnt <= 0;
                   tx_shiftreg <= {(7-0+1- 0){1'b0}};
                   txd <= 1'b1;
                   tx_parity <= 1'b0;
                   tx_next_is_stop <= 1'b0;
                   tx_stop_bit <= 1'b0;
               end
               
           else 
               begin 
                   begin 
                       if ((tx_tick === 1'b1)) 
                           begin 
                               tx_next_is_stop <= 1'b0;
                               tx_stop_bit <= tx_next_is_stop;
                               case (tx_bit_cnt)
                                   0 : begin 
                                           if ((lsr[5] <= 1'b0)) 
                                                   tx_bit_cnt <= 1;

                                           txd <= 1'b1;
                                       end
                                   1 : begin 
                                           tx_shiftreg[7:0] <= thr;
                                           lsr[5] <= 1'b1;
                                           txd <= 1'b0;
                                           tx_parity <= ~ (lcr[4]);
                                           tx_bit_cnt <= (tx_bit_cnt + 1);
                                       end
                                   10 : 
                                       begin 
                                           txd <= tx_parity;
                                           if ((lcr[5] === 1'b1)) 
                                                   txd <= ~ (lcr[4]);

                                           tx_bit_cnt <= 0;
                                           tx_next_is_stop <= 1'b1;
                                       end
                                   default : 
                                       begin 
                                           tx_bit_cnt <= (tx_bit_cnt + 1);
                                           if ((((((tx_bit_cnt === 9) & (lcr[1:0] === 2'b11)) | ((tx_bit_cnt === 8) & (lcr[1:0] === 2'b10))) | ((tx_bit_cnt === 7) & (lcr[1:0] === 2'b01))) | ((tx_bit_cnt === 6) & (lcr[1:0] === 2'b00)))) 
                                               begin 
                                                   tx_bit_cnt <= 0;
                                                   if ((lcr[3] === 1'b1)) 
                                                           tx_bit_cnt <= 10;
                                                   else 
                                                           tx_next_is_stop <= 1'b1;

                                                   lsr[6] <= 1'b1;
                                               end

                                           txd <= tx_shiftreg[0];
                                           tx_shiftreg[6:0] <= tx_shiftreg[7:1];
                                           tx_parity <= (tx_shiftreg[0] ^ tx_parity);
                                       end
                               endcase
                           end
                           
                       
                       if (((((wr_n === 1'b0) & (cs_n === 1'b0)) & (a === 3'b000)) & (lcr[7] === 1'b0))) 
                           begin 
                               lsr[5] <= 1'b0;
                               lsr[6] <= 1'b0;
                           end
                           
                       
                       
                   end
                   
               end 
           
   end //always
    

endmodule
//
// File I/O test-bench utilities
//
// Version : 0146
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//

//
// Simple SRAM model without timing
//
// Version : 0247
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t80/
//
// Limitations :
//
// File history :
//


module  sram ( ce_n, oe_n, we_n, a, d );
    parameter  [31:0]  addrwidth =16;
    parameter  [31:0]  datawidth =8;
    
    input ce_n;
    input oe_n;
    input we_n;
    input [(addrwidth - 1):0]  a ;
    inout [(datawidth - 1):0]  d ;


//type memory_image

reg [(datawidth - 1):0] ram [0:((2<< (addrwidth-1)) - 1)];
    wire write;
    reg [7:0] d_del;
    wire [(datawidth - 1):0] d;


    
   assign {write}=((ce_n === 1'b0) & (we_n === 1'b0)) ? 
                      1'b1
                   :  1'b0;
   
   always #(1* `ns) {d_del}<=d;
   
       
   always @ (negedge write ) begin
               ram[$unsigned(a)] <= d_del;
               
           
   end //always
   
   assign {d}=((((oe_n === 1'b0) & (ce_n === 1'b0)) & (we_n === 1'b1)) & ~ (is_x__0(a))) ? 
                  ram[$unsigned(a)]
               :  {((datawidth - 1)-0+1- 0){1'bz}};
    
    function [0:0] is_x__0;
        input  [(addrwidth - 1):0] s;
        begin : Function
            begin 
                begin :Block_Name_1
                    integer i;
                    for (i=(addrwidth - 1);i>=0;i=i-1) begin 
                        case (s[i])
                            1'bx,1'bx,1'bz,1'bx,1'bx : 
                                    begin 
                                        is_x__0=1'b1;
                                        disable Function;
                                    end
                            default : 
                                    ;//null
                        endcase
                        
                    end //for
                end //end Block
                begin 
                    is_x__0=1'b0;
                    disable Function;
                end
            end
        end // Function
    endfunction

    

endmodule
// This file was generated with hex2rom written by Daniel Wallner


module  rom80 ( ce_n, oe_n, a, d );
    
    input ce_n;
    input oe_n;
    input [14:0]  a ;
    output [7:0]  d ;


        reg [7:0] rom [0:16383];
   initial begin// memory type aggregate
           rom[ 0+ 0] =8'b11000011;
           rom[ 0+ 1] =8'b00000000;
           rom[ 0+ 2] =8'b00000001;
           rom[ 0+ 3] =8'bxxxxxxxx;
           rom[ 0+ 4] =8'bxxxxxxxx;
           rom[ 0+ 5] =8'bxxxxxxxx;
           rom[ 0+ 6] =8'bxxxxxxxx;
           rom[ 0+ 7] =8'bxxxxxxxx;
           rom[ 0+ 8] =8'b11101101;
           rom[ 0+ 9] =8'b01001101;
           rom[ 0+10] =8'bxxxxxxxx;
           rom[ 0+11] =8'bxxxxxxxx;
           rom[ 0+12] =8'bxxxxxxxx;
           rom[ 0+13] =8'bxxxxxxxx;
           rom[ 0+14] =8'bxxxxxxxx;
           rom[ 0+15] =8'bxxxxxxxx;
           rom[ 0+16] =8'b11101101;
           rom[ 0+17] =8'b01001101;
           rom[ 0+18] =8'bxxxxxxxx;
           rom[ 0+19] =8'bxxxxxxxx;
           rom[ 0+20] =8'bxxxxxxxx;
           rom[ 0+21] =8'bxxxxxxxx;
           rom[ 0+22] =8'bxxxxxxxx;
           rom[ 0+23] =8'bxxxxxxxx;
           rom[ 0+24] =8'b11101101;
           rom[ 0+25] =8'b01001101;
           rom[ 0+26] =8'bxxxxxxxx;
           rom[ 0+27] =8'bxxxxxxxx;
           rom[ 0+28] =8'bxxxxxxxx;
           rom[ 0+29] =8'bxxxxxxxx;
           rom[ 0+30] =8'bxxxxxxxx;
           rom[ 0+31] =8'bxxxxxxxx;
           rom[ 0+32] =8'b11101101;
           rom[ 0+33] =8'b01001101;
           rom[ 0+34] =8'bxxxxxxxx;
           rom[ 0+35] =8'bxxxxxxxx;
           rom[ 0+36] =8'bxxxxxxxx;
           rom[ 0+37] =8'bxxxxxxxx;
           rom[ 0+38] =8'bxxxxxxxx;
           rom[ 0+39] =8'bxxxxxxxx;
           rom[ 0+40] =8'b11101101;
           rom[ 0+41] =8'b01001101;
           rom[ 0+42] =8'bxxxxxxxx;
           rom[ 0+43] =8'bxxxxxxxx;
           rom[ 0+44] =8'bxxxxxxxx;
           rom[ 0+45] =8'bxxxxxxxx;
           rom[ 0+46] =8'bxxxxxxxx;
           rom[ 0+47] =8'bxxxxxxxx;
           rom[ 0+48] =8'b11101101;
           rom[ 0+49] =8'b01001101;
           rom[ 0+50] =8'bxxxxxxxx;
           rom[ 0+51] =8'bxxxxxxxx;
           rom[ 0+52] =8'bxxxxxxxx;
           rom[ 0+53] =8'bxxxxxxxx;
           rom[ 0+54] =8'bxxxxxxxx;
           rom[ 0+55] =8'bxxxxxxxx;
           rom[ 0+56] =8'b11101101;
           rom[ 0+57] =8'b01001101;
           rom[ 0+58] =8'bxxxxxxxx;
           rom[ 0+59] =8'bxxxxxxxx;
           rom[ 0+60] =8'bxxxxxxxx;
           rom[ 0+61] =8'bxxxxxxxx;
           rom[ 0+62] =8'bxxxxxxxx;
           rom[ 0+63] =8'bxxxxxxxx;
           rom[ 0+64] =8'bxxxxxxxx;
           rom[ 0+65] =8'bxxxxxxxx;
           rom[ 0+66] =8'bxxxxxxxx;
           rom[ 0+67] =8'bxxxxxxxx;
           rom[ 0+68] =8'bxxxxxxxx;
           rom[ 0+69] =8'bxxxxxxxx;
           rom[ 0+70] =8'bxxxxxxxx;
           rom[ 0+71] =8'bxxxxxxxx;
           rom[ 0+72] =8'bxxxxxxxx;
           rom[ 0+73] =8'bxxxxxxxx;
           rom[ 0+74] =8'bxxxxxxxx;
           rom[ 0+75] =8'bxxxxxxxx;
           rom[ 0+76] =8'bxxxxxxxx;
           rom[ 0+77] =8'bxxxxxxxx;
           rom[ 0+78] =8'bxxxxxxxx;
           rom[ 0+79] =8'bxxxxxxxx;
           rom[ 0+80] =8'bxxxxxxxx;
           rom[ 0+81] =8'bxxxxxxxx;
           rom[ 0+82] =8'bxxxxxxxx;
           rom[ 0+83] =8'bxxxxxxxx;
           rom[ 0+84] =8'bxxxxxxxx;
           rom[ 0+85] =8'bxxxxxxxx;
           rom[ 0+86] =8'bxxxxxxxx;
           rom[ 0+87] =8'bxxxxxxxx;
           rom[ 0+88] =8'bxxxxxxxx;
           rom[ 0+89] =8'bxxxxxxxx;
           rom[ 0+90] =8'bxxxxxxxx;
           rom[ 0+91] =8'bxxxxxxxx;
           rom[ 0+92] =8'bxxxxxxxx;
           rom[ 0+93] =8'bxxxxxxxx;
           rom[ 0+94] =8'bxxxxxxxx;
           rom[ 0+95] =8'bxxxxxxxx;
           rom[ 0+96] =8'bxxxxxxxx;
           rom[ 0+97] =8'bxxxxxxxx;
           rom[ 0+98] =8'bxxxxxxxx;
           rom[ 0+99] =8'bxxxxxxxx;
           rom[ 0+100] =8'bxxxxxxxx;
           rom[ 0+101] =8'bxxxxxxxx;
           rom[ 0+102] =8'bxxxxxxxx;
           rom[ 0+103] =8'bxxxxxxxx;
           rom[ 0+104] =8'bxxxxxxxx;
           rom[ 0+105] =8'bxxxxxxxx;
           rom[ 0+106] =8'bxxxxxxxx;
           rom[ 0+107] =8'bxxxxxxxx;
           rom[ 0+108] =8'bxxxxxxxx;
           rom[ 0+109] =8'bxxxxxxxx;
           rom[ 0+110] =8'bxxxxxxxx;
           rom[ 0+111] =8'bxxxxxxxx;
           rom[ 0+112] =8'bxxxxxxxx;
           rom[ 0+113] =8'bxxxxxxxx;
           rom[ 0+114] =8'bxxxxxxxx;
           rom[ 0+115] =8'bxxxxxxxx;
           rom[ 0+116] =8'bxxxxxxxx;
           rom[ 0+117] =8'bxxxxxxxx;
           rom[ 0+118] =8'bxxxxxxxx;
           rom[ 0+119] =8'bxxxxxxxx;
           rom[ 0+120] =8'bxxxxxxxx;
           rom[ 0+121] =8'bxxxxxxxx;
           rom[ 0+122] =8'bxxxxxxxx;
           rom[ 0+123] =8'bxxxxxxxx;
           rom[ 0+124] =8'bxxxxxxxx;
           rom[ 0+125] =8'bxxxxxxxx;
           rom[ 0+126] =8'bxxxxxxxx;
           rom[ 0+127] =8'bxxxxxxxx;
           rom[ 0+128] =8'bxxxxxxxx;
           rom[ 0+129] =8'bxxxxxxxx;
           rom[ 0+130] =8'bxxxxxxxx;
           rom[ 0+131] =8'bxxxxxxxx;
           rom[ 0+132] =8'bxxxxxxxx;
           rom[ 0+133] =8'bxxxxxxxx;
           rom[ 0+134] =8'bxxxxxxxx;
           rom[ 0+135] =8'bxxxxxxxx;
           rom[ 0+136] =8'bxxxxxxxx;
           rom[ 0+137] =8'bxxxxxxxx;
           rom[ 0+138] =8'bxxxxxxxx;
           rom[ 0+139] =8'bxxxxxxxx;
           rom[ 0+140] =8'bxxxxxxxx;
           rom[ 0+141] =8'bxxxxxxxx;
           rom[ 0+142] =8'bxxxxxxxx;
           rom[ 0+143] =8'bxxxxxxxx;
           rom[ 0+144] =8'bxxxxxxxx;
           rom[ 0+145] =8'bxxxxxxxx;
           rom[ 0+146] =8'bxxxxxxxx;
           rom[ 0+147] =8'bxxxxxxxx;
           rom[ 0+148] =8'bxxxxxxxx;
           rom[ 0+149] =8'bxxxxxxxx;
           rom[ 0+150] =8'bxxxxxxxx;
           rom[ 0+151] =8'bxxxxxxxx;
           rom[ 0+152] =8'bxxxxxxxx;
           rom[ 0+153] =8'bxxxxxxxx;
           rom[ 0+154] =8'bxxxxxxxx;
           rom[ 0+155] =8'bxxxxxxxx;
           rom[ 0+156] =8'bxxxxxxxx;
           rom[ 0+157] =8'bxxxxxxxx;
           rom[ 0+158] =8'bxxxxxxxx;
           rom[ 0+159] =8'bxxxxxxxx;
           rom[ 0+160] =8'bxxxxxxxx;
           rom[ 0+161] =8'bxxxxxxxx;
           rom[ 0+162] =8'bxxxxxxxx;
           rom[ 0+163] =8'bxxxxxxxx;
           rom[ 0+164] =8'bxxxxxxxx;
           rom[ 0+165] =8'bxxxxxxxx;
           rom[ 0+166] =8'bxxxxxxxx;
           rom[ 0+167] =8'bxxxxxxxx;
           rom[ 0+168] =8'bxxxxxxxx;
           rom[ 0+169] =8'bxxxxxxxx;
           rom[ 0+170] =8'bxxxxxxxx;
           rom[ 0+171] =8'bxxxxxxxx;
           rom[ 0+172] =8'bxxxxxxxx;
           rom[ 0+173] =8'bxxxxxxxx;
           rom[ 0+174] =8'bxxxxxxxx;
           rom[ 0+175] =8'bxxxxxxxx;
           rom[ 0+176] =8'bxxxxxxxx;
           rom[ 0+177] =8'bxxxxxxxx;
           rom[ 0+178] =8'bxxxxxxxx;
           rom[ 0+179] =8'bxxxxxxxx;
           rom[ 0+180] =8'bxxxxxxxx;
           rom[ 0+181] =8'bxxxxxxxx;
           rom[ 0+182] =8'bxxxxxxxx;
           rom[ 0+183] =8'bxxxxxxxx;
           rom[ 0+184] =8'bxxxxxxxx;
           rom[ 0+185] =8'bxxxxxxxx;
           rom[ 0+186] =8'bxxxxxxxx;
           rom[ 0+187] =8'bxxxxxxxx;
           rom[ 0+188] =8'bxxxxxxxx;
           rom[ 0+189] =8'bxxxxxxxx;
           rom[ 0+190] =8'bxxxxxxxx;
           rom[ 0+191] =8'bxxxxxxxx;
           rom[ 0+192] =8'bxxxxxxxx;
           rom[ 0+193] =8'bxxxxxxxx;
           rom[ 0+194] =8'bxxxxxxxx;
           rom[ 0+195] =8'bxxxxxxxx;
           rom[ 0+196] =8'bxxxxxxxx;
           rom[ 0+197] =8'bxxxxxxxx;
           rom[ 0+198] =8'bxxxxxxxx;
           rom[ 0+199] =8'bxxxxxxxx;
           rom[ 0+200] =8'bxxxxxxxx;
           rom[ 0+201] =8'bxxxxxxxx;
           rom[ 0+202] =8'bxxxxxxxx;
           rom[ 0+203] =8'bxxxxxxxx;
           rom[ 0+204] =8'bxxxxxxxx;
           rom[ 0+205] =8'bxxxxxxxx;
           rom[ 0+206] =8'bxxxxxxxx;
           rom[ 0+207] =8'bxxxxxxxx;
           rom[ 0+208] =8'bxxxxxxxx;
           rom[ 0+209] =8'bxxxxxxxx;
           rom[ 0+210] =8'bxxxxxxxx;
           rom[ 0+211] =8'bxxxxxxxx;
           rom[ 0+212] =8'bxxxxxxxx;
           rom[ 0+213] =8'bxxxxxxxx;
           rom[ 0+214] =8'bxxxxxxxx;
           rom[ 0+215] =8'bxxxxxxxx;
           rom[ 0+216] =8'bxxxxxxxx;
           rom[ 0+217] =8'bxxxxxxxx;
           rom[ 0+218] =8'bxxxxxxxx;
           rom[ 0+219] =8'bxxxxxxxx;
           rom[ 0+220] =8'bxxxxxxxx;
           rom[ 0+221] =8'bxxxxxxxx;
           rom[ 0+222] =8'bxxxxxxxx;
           rom[ 0+223] =8'bxxxxxxxx;
           rom[ 0+224] =8'bxxxxxxxx;
           rom[ 0+225] =8'bxxxxxxxx;
           rom[ 0+226] =8'bxxxxxxxx;
           rom[ 0+227] =8'bxxxxxxxx;
           rom[ 0+228] =8'bxxxxxxxx;
           rom[ 0+229] =8'bxxxxxxxx;
           rom[ 0+230] =8'bxxxxxxxx;
           rom[ 0+231] =8'bxxxxxxxx;
           rom[ 0+232] =8'bxxxxxxxx;
           rom[ 0+233] =8'bxxxxxxxx;
           rom[ 0+234] =8'bxxxxxxxx;
           rom[ 0+235] =8'bxxxxxxxx;
           rom[ 0+236] =8'bxxxxxxxx;
           rom[ 0+237] =8'bxxxxxxxx;
           rom[ 0+238] =8'bxxxxxxxx;
           rom[ 0+239] =8'bxxxxxxxx;
           rom[ 0+240] =8'bxxxxxxxx;
           rom[ 0+241] =8'bxxxxxxxx;
           rom[ 0+242] =8'bxxxxxxxx;
           rom[ 0+243] =8'bxxxxxxxx;
           rom[ 0+244] =8'bxxxxxxxx;
           rom[ 0+245] =8'bxxxxxxxx;
           rom[ 0+246] =8'bxxxxxxxx;
           rom[ 0+247] =8'bxxxxxxxx;
           rom[ 0+248] =8'bxxxxxxxx;
           rom[ 0+249] =8'bxxxxxxxx;
           rom[ 0+250] =8'bxxxxxxxx;
           rom[ 0+251] =8'bxxxxxxxx;
           rom[ 0+252] =8'bxxxxxxxx;
           rom[ 0+253] =8'bxxxxxxxx;
           rom[ 0+254] =8'bxxxxxxxx;
           rom[ 0+255] =8'bxxxxxxxx;
           rom[ 0+256] =8'b00110001;
           rom[ 0+257] =8'b11111111;
           rom[ 0+258] =8'b11111111;
           rom[ 0+259] =8'b11001101;
           rom[ 0+260] =8'b01111111;
           rom[ 0+261] =8'b00111111;
           rom[ 0+262] =8'b11001101;
           rom[ 0+263] =8'b11110111;
           rom[ 0+264] =8'b00100000;
           rom[ 0+265] =8'b11000011;
           rom[ 0+266] =8'b00000100;
           rom[ 0+267] =8'b00000010;
           rom[ 0+268] =8'bxxxxxxxx;
           rom[ 0+269] =8'bxxxxxxxx;
           rom[ 0+270] =8'bxxxxxxxx;
           rom[ 0+271] =8'bxxxxxxxx;
           rom[ 0+272] =8'bxxxxxxxx;
           rom[ 0+273] =8'bxxxxxxxx;
           rom[ 0+274] =8'bxxxxxxxx;
           rom[ 0+275] =8'bxxxxxxxx;
           rom[ 0+276] =8'bxxxxxxxx;
           rom[ 0+277] =8'bxxxxxxxx;
           rom[ 0+278] =8'bxxxxxxxx;
           rom[ 0+279] =8'bxxxxxxxx;
           rom[ 0+280] =8'bxxxxxxxx;
           rom[ 0+281] =8'bxxxxxxxx;
           rom[ 0+282] =8'bxxxxxxxx;
           rom[ 0+283] =8'bxxxxxxxx;
           rom[ 0+284] =8'bxxxxxxxx;
           rom[ 0+285] =8'bxxxxxxxx;
           rom[ 0+286] =8'bxxxxxxxx;
           rom[ 0+287] =8'bxxxxxxxx;
           rom[ 0+288] =8'bxxxxxxxx;
           rom[ 0+289] =8'bxxxxxxxx;
           rom[ 0+290] =8'bxxxxxxxx;
           rom[ 0+291] =8'bxxxxxxxx;
           rom[ 0+292] =8'bxxxxxxxx;
           rom[ 0+293] =8'bxxxxxxxx;
           rom[ 0+294] =8'bxxxxxxxx;
           rom[ 0+295] =8'bxxxxxxxx;
           rom[ 0+296] =8'bxxxxxxxx;
           rom[ 0+297] =8'bxxxxxxxx;
           rom[ 0+298] =8'bxxxxxxxx;
           rom[ 0+299] =8'bxxxxxxxx;
           rom[ 0+300] =8'bxxxxxxxx;
           rom[ 0+301] =8'bxxxxxxxx;
           rom[ 0+302] =8'bxxxxxxxx;
           rom[ 0+303] =8'bxxxxxxxx;
           rom[ 0+304] =8'bxxxxxxxx;
           rom[ 0+305] =8'bxxxxxxxx;
           rom[ 0+306] =8'bxxxxxxxx;
           rom[ 0+307] =8'bxxxxxxxx;
           rom[ 0+308] =8'bxxxxxxxx;
           rom[ 0+309] =8'bxxxxxxxx;
           rom[ 0+310] =8'bxxxxxxxx;
           rom[ 0+311] =8'bxxxxxxxx;
           rom[ 0+312] =8'bxxxxxxxx;
           rom[ 0+313] =8'bxxxxxxxx;
           rom[ 0+314] =8'bxxxxxxxx;
           rom[ 0+315] =8'bxxxxxxxx;
           rom[ 0+316] =8'bxxxxxxxx;
           rom[ 0+317] =8'bxxxxxxxx;
           rom[ 0+318] =8'bxxxxxxxx;
           rom[ 0+319] =8'bxxxxxxxx;
           rom[ 0+320] =8'bxxxxxxxx;
           rom[ 0+321] =8'bxxxxxxxx;
           rom[ 0+322] =8'bxxxxxxxx;
           rom[ 0+323] =8'bxxxxxxxx;
           rom[ 0+324] =8'bxxxxxxxx;
           rom[ 0+325] =8'bxxxxxxxx;
           rom[ 0+326] =8'bxxxxxxxx;
           rom[ 0+327] =8'bxxxxxxxx;
           rom[ 0+328] =8'bxxxxxxxx;
           rom[ 0+329] =8'bxxxxxxxx;
           rom[ 0+330] =8'bxxxxxxxx;
           rom[ 0+331] =8'bxxxxxxxx;
           rom[ 0+332] =8'bxxxxxxxx;
           rom[ 0+333] =8'bxxxxxxxx;
           rom[ 0+334] =8'bxxxxxxxx;
           rom[ 0+335] =8'bxxxxxxxx;
           rom[ 0+336] =8'bxxxxxxxx;
           rom[ 0+337] =8'bxxxxxxxx;
           rom[ 0+338] =8'bxxxxxxxx;
           rom[ 0+339] =8'bxxxxxxxx;
           rom[ 0+340] =8'bxxxxxxxx;
           rom[ 0+341] =8'bxxxxxxxx;
           rom[ 0+342] =8'bxxxxxxxx;
           rom[ 0+343] =8'bxxxxxxxx;
           rom[ 0+344] =8'bxxxxxxxx;
           rom[ 0+345] =8'bxxxxxxxx;
           rom[ 0+346] =8'bxxxxxxxx;
           rom[ 0+347] =8'bxxxxxxxx;
           rom[ 0+348] =8'bxxxxxxxx;
           rom[ 0+349] =8'bxxxxxxxx;
           rom[ 0+350] =8'bxxxxxxxx;
           rom[ 0+351] =8'bxxxxxxxx;
           rom[ 0+352] =8'bxxxxxxxx;
           rom[ 0+353] =8'bxxxxxxxx;
           rom[ 0+354] =8'bxxxxxxxx;
           rom[ 0+355] =8'bxxxxxxxx;
           rom[ 0+356] =8'bxxxxxxxx;
           rom[ 0+357] =8'bxxxxxxxx;
           rom[ 0+358] =8'bxxxxxxxx;
           rom[ 0+359] =8'bxxxxxxxx;
           rom[ 0+360] =8'bxxxxxxxx;
           rom[ 0+361] =8'bxxxxxxxx;
           rom[ 0+362] =8'bxxxxxxxx;
           rom[ 0+363] =8'bxxxxxxxx;
           rom[ 0+364] =8'bxxxxxxxx;
           rom[ 0+365] =8'bxxxxxxxx;
           rom[ 0+366] =8'bxxxxxxxx;
           rom[ 0+367] =8'bxxxxxxxx;
           rom[ 0+368] =8'bxxxxxxxx;
           rom[ 0+369] =8'bxxxxxxxx;
           rom[ 0+370] =8'bxxxxxxxx;
           rom[ 0+371] =8'bxxxxxxxx;
           rom[ 0+372] =8'bxxxxxxxx;
           rom[ 0+373] =8'bxxxxxxxx;
           rom[ 0+374] =8'bxxxxxxxx;
           rom[ 0+375] =8'bxxxxxxxx;
           rom[ 0+376] =8'bxxxxxxxx;
           rom[ 0+377] =8'bxxxxxxxx;
           rom[ 0+378] =8'bxxxxxxxx;
           rom[ 0+379] =8'bxxxxxxxx;
           rom[ 0+380] =8'bxxxxxxxx;
           rom[ 0+381] =8'bxxxxxxxx;
           rom[ 0+382] =8'bxxxxxxxx;
           rom[ 0+383] =8'bxxxxxxxx;
           rom[ 0+384] =8'bxxxxxxxx;
           rom[ 0+385] =8'bxxxxxxxx;
           rom[ 0+386] =8'bxxxxxxxx;
           rom[ 0+387] =8'bxxxxxxxx;
           rom[ 0+388] =8'bxxxxxxxx;
           rom[ 0+389] =8'bxxxxxxxx;
           rom[ 0+390] =8'bxxxxxxxx;
           rom[ 0+391] =8'bxxxxxxxx;
           rom[ 0+392] =8'bxxxxxxxx;
           rom[ 0+393] =8'bxxxxxxxx;
           rom[ 0+394] =8'bxxxxxxxx;
           rom[ 0+395] =8'bxxxxxxxx;
           rom[ 0+396] =8'bxxxxxxxx;
           rom[ 0+397] =8'bxxxxxxxx;
           rom[ 0+398] =8'bxxxxxxxx;
           rom[ 0+399] =8'bxxxxxxxx;
           rom[ 0+400] =8'bxxxxxxxx;
           rom[ 0+401] =8'bxxxxxxxx;
           rom[ 0+402] =8'bxxxxxxxx;
           rom[ 0+403] =8'bxxxxxxxx;
           rom[ 0+404] =8'bxxxxxxxx;
           rom[ 0+405] =8'bxxxxxxxx;
           rom[ 0+406] =8'bxxxxxxxx;
           rom[ 0+407] =8'bxxxxxxxx;
           rom[ 0+408] =8'bxxxxxxxx;
           rom[ 0+409] =8'bxxxxxxxx;
           rom[ 0+410] =8'bxxxxxxxx;
           rom[ 0+411] =8'bxxxxxxxx;
           rom[ 0+412] =8'bxxxxxxxx;
           rom[ 0+413] =8'bxxxxxxxx;
           rom[ 0+414] =8'bxxxxxxxx;
           rom[ 0+415] =8'bxxxxxxxx;
           rom[ 0+416] =8'bxxxxxxxx;
           rom[ 0+417] =8'bxxxxxxxx;
           rom[ 0+418] =8'bxxxxxxxx;
           rom[ 0+419] =8'bxxxxxxxx;
           rom[ 0+420] =8'bxxxxxxxx;
           rom[ 0+421] =8'bxxxxxxxx;
           rom[ 0+422] =8'bxxxxxxxx;
           rom[ 0+423] =8'bxxxxxxxx;
           rom[ 0+424] =8'bxxxxxxxx;
           rom[ 0+425] =8'bxxxxxxxx;
           rom[ 0+426] =8'bxxxxxxxx;
           rom[ 0+427] =8'bxxxxxxxx;
           rom[ 0+428] =8'bxxxxxxxx;
           rom[ 0+429] =8'bxxxxxxxx;
           rom[ 0+430] =8'bxxxxxxxx;
           rom[ 0+431] =8'bxxxxxxxx;
           rom[ 0+432] =8'bxxxxxxxx;
           rom[ 0+433] =8'bxxxxxxxx;
           rom[ 0+434] =8'bxxxxxxxx;
           rom[ 0+435] =8'bxxxxxxxx;
           rom[ 0+436] =8'bxxxxxxxx;
           rom[ 0+437] =8'bxxxxxxxx;
           rom[ 0+438] =8'bxxxxxxxx;
           rom[ 0+439] =8'bxxxxxxxx;
           rom[ 0+440] =8'bxxxxxxxx;
           rom[ 0+441] =8'bxxxxxxxx;
           rom[ 0+442] =8'bxxxxxxxx;
           rom[ 0+443] =8'bxxxxxxxx;
           rom[ 0+444] =8'bxxxxxxxx;
           rom[ 0+445] =8'bxxxxxxxx;
           rom[ 0+446] =8'bxxxxxxxx;
           rom[ 0+447] =8'bxxxxxxxx;
           rom[ 0+448] =8'bxxxxxxxx;
           rom[ 0+449] =8'bxxxxxxxx;
           rom[ 0+450] =8'bxxxxxxxx;
           rom[ 0+451] =8'bxxxxxxxx;
           rom[ 0+452] =8'bxxxxxxxx;
           rom[ 0+453] =8'bxxxxxxxx;
           rom[ 0+454] =8'bxxxxxxxx;
           rom[ 0+455] =8'bxxxxxxxx;
           rom[ 0+456] =8'bxxxxxxxx;
           rom[ 0+457] =8'bxxxxxxxx;
           rom[ 0+458] =8'bxxxxxxxx;
           rom[ 0+459] =8'bxxxxxxxx;
           rom[ 0+460] =8'bxxxxxxxx;
           rom[ 0+461] =8'bxxxxxxxx;
           rom[ 0+462] =8'bxxxxxxxx;
           rom[ 0+463] =8'bxxxxxxxx;
           rom[ 0+464] =8'bxxxxxxxx;
           rom[ 0+465] =8'bxxxxxxxx;
           rom[ 0+466] =8'bxxxxxxxx;
           rom[ 0+467] =8'bxxxxxxxx;
           rom[ 0+468] =8'bxxxxxxxx;
           rom[ 0+469] =8'bxxxxxxxx;
           rom[ 0+470] =8'bxxxxxxxx;
           rom[ 0+471] =8'bxxxxxxxx;
           rom[ 0+472] =8'bxxxxxxxx;
           rom[ 0+473] =8'bxxxxxxxx;
           rom[ 0+474] =8'bxxxxxxxx;
           rom[ 0+475] =8'bxxxxxxxx;
           rom[ 0+476] =8'bxxxxxxxx;
           rom[ 0+477] =8'bxxxxxxxx;
           rom[ 0+478] =8'bxxxxxxxx;
           rom[ 0+479] =8'bxxxxxxxx;
           rom[ 0+480] =8'bxxxxxxxx;
           rom[ 0+481] =8'bxxxxxxxx;
           rom[ 0+482] =8'bxxxxxxxx;
           rom[ 0+483] =8'bxxxxxxxx;
           rom[ 0+484] =8'bxxxxxxxx;
           rom[ 0+485] =8'bxxxxxxxx;
           rom[ 0+486] =8'bxxxxxxxx;
           rom[ 0+487] =8'bxxxxxxxx;
           rom[ 0+488] =8'bxxxxxxxx;
           rom[ 0+489] =8'bxxxxxxxx;
           rom[ 0+490] =8'bxxxxxxxx;
           rom[ 0+491] =8'bxxxxxxxx;
           rom[ 0+492] =8'bxxxxxxxx;
           rom[ 0+493] =8'bxxxxxxxx;
           rom[ 0+494] =8'bxxxxxxxx;
           rom[ 0+495] =8'bxxxxxxxx;
           rom[ 0+496] =8'bxxxxxxxx;
           rom[ 0+497] =8'bxxxxxxxx;
           rom[ 0+498] =8'bxxxxxxxx;
           rom[ 0+499] =8'bxxxxxxxx;
           rom[ 0+500] =8'bxxxxxxxx;
           rom[ 0+501] =8'bxxxxxxxx;
           rom[ 0+502] =8'bxxxxxxxx;
           rom[ 0+503] =8'bxxxxxxxx;
           rom[ 0+504] =8'bxxxxxxxx;
           rom[ 0+505] =8'bxxxxxxxx;
           rom[ 0+506] =8'bxxxxxxxx;
           rom[ 0+507] =8'bxxxxxxxx;
           rom[ 0+508] =8'bxxxxxxxx;
           rom[ 0+509] =8'bxxxxxxxx;
           rom[ 0+510] =8'bxxxxxxxx;
           rom[ 0+511] =8'bxxxxxxxx;
           rom[ 0+512] =8'b00111110;
           rom[ 0+513] =8'b00000010;
           rom[ 0+514] =8'b11001111;
           rom[ 0+515] =8'b11001001;
           rom[ 0+516] =8'b00111110;
           rom[ 0+517] =8'b00000000;
           rom[ 0+518] =8'b11001111;
           rom[ 0+519] =8'b01110110;
           rom[ 0+520] =8'b00011000;
           rom[ 0+521] =8'b11111101;
           rom[ 0+522] =8'b11011101;
           rom[ 0+523] =8'b11100101;
           rom[ 0+524] =8'b11011101;
           rom[ 0+525] =8'b00100001;
           rom[ 0+526] =8'b00000000;
           rom[ 0+527] =8'b00000000;
           rom[ 0+528] =8'b11011101;
           rom[ 0+529] =8'b00111001;
           rom[ 0+530] =8'b11011101;
           rom[ 0+531] =8'b01001110;
           rom[ 0+532] =8'b00000100;
           rom[ 0+533] =8'b11011101;
           rom[ 0+534] =8'b01000110;
           rom[ 0+535] =8'b00000101;
           rom[ 0+536] =8'b00001010;
           rom[ 0+537] =8'b01011111;
           rom[ 0+538] =8'b10110111;
           rom[ 0+539] =8'b11001010;
           rom[ 0+540] =8'b00101001;
           rom[ 0+541] =8'b00000010;
           rom[ 0+542] =8'b11111101;
           rom[ 0+543] =8'b00100001;
           rom[ 0+544] =8'b11101000;
           rom[ 0+545] =8'b10000011;
           rom[ 0+546] =8'b11111101;
           rom[ 0+547] =8'b01110011;
           rom[ 0+548] =8'b00000000;
           rom[ 0+549] =8'b00000011;
           rom[ 0+550] =8'b11000011;
           rom[ 0+551] =8'b00011000;
           rom[ 0+552] =8'b00000010;
           rom[ 0+553] =8'b11111101;
           rom[ 0+554] =8'b00100001;
           rom[ 0+555] =8'b11101000;
           rom[ 0+556] =8'b10000011;
           rom[ 0+557] =8'b11111101;
           rom[ 0+558] =8'b00110110;
           rom[ 0+559] =8'b00000000;
           rom[ 0+560] =8'b00000000;
           rom[ 0+561] =8'b11011101;
           rom[ 0+562] =8'b11100001;
           rom[ 0+563] =8'b11001001;
           rom[ 0+564] =8'b00011101;
           rom[ 0+565] =8'b00111010;
           rom[ 0+566] =8'b01101001;
           rom[ 0+567] =8'b11001110;
           rom[ 0+568] =8'b10000001;
           rom[ 0+569] =8'b00000011;
           rom[ 0+570] =8'b00000111;
           rom[ 0+571] =8'b00001110;
           rom[ 0+572] =8'b10000100;
           rom[ 0+573] =8'b00001000;
           rom[ 0+574] =8'b10010101;
           rom[ 0+575] =8'b10101110;
           rom[ 0+576] =8'b11011000;
           rom[ 0+577] =8'b10110000;
           rom[ 0+578] =8'b01100001;
           rom[ 0+579] =8'b11000010;
           rom[ 0+580] =8'b10100001;
           rom[ 0+581] =8'b01000011;
           rom[ 0+582] =8'b00100110;
           rom[ 0+583] =8'b11101101;
           rom[ 0+584] =8'b01111010;
           rom[ 0+585] =8'b11110100;
           rom[ 0+586] =8'b11101000;
           rom[ 0+587] =8'b11010000;
           rom[ 0+588] =8'b00101010;
           rom[ 0+589] =8'b01010100;
           rom[ 0+590] =8'b10000011;
           rom[ 0+591] =8'b00101100;
           rom[ 0+592] =8'b01110010;
           rom[ 0+593] =8'b11100101;
           rom[ 0+594] =8'b11001010;
           rom[ 0+595] =8'b10010101;
           rom[ 0+596] =8'b01010010;
           rom[ 0+597] =8'b10100101;
           rom[ 0+598] =8'b00011000;
           rom[ 0+599] =8'b01100011;
           rom[ 0+600] =8'b10010101;
           rom[ 0+601] =8'b00101010;
           rom[ 0+602] =8'b01010100;
           rom[ 0+603] =8'b10101001;
           rom[ 0+604] =8'b11111100;
           rom[ 0+605] =8'b11111001;
           rom[ 0+606] =8'b00001110;
           rom[ 0+607] =8'b11100001;
           rom[ 0+608] =8'b00111111;
           rom[ 0+609] =8'b01111111;
           rom[ 0+610] =8'b11111111;
           rom[ 0+611] =8'b11111110;
           rom[ 0+612] =8'b10111101;
           rom[ 0+613] =8'b01111011;
           rom[ 0+614] =8'b01001011;
           rom[ 0+615] =8'b00101011;
           rom[ 0+616] =8'b11101011;
           rom[ 0+617] =8'b11010111;
           rom[ 0+618] =8'b10101111;
           rom[ 0+619] =8'b01011110;
           rom[ 0+620] =8'b10000000;
           rom[ 0+621] =8'b00000001;
           rom[ 0+622] =8'b10000010;
           rom[ 0+623] =8'b10000100;
           rom[ 0+624] =8'b10001000;
           rom[ 0+625] =8'b00010000;
           rom[ 0+626] =8'b00100000;
           rom[ 0+627] =8'b01000000;
           rom[ 0+628] =8'b01000000;
           rom[ 0+629] =8'b10000000;
           rom[ 0+630] =8'b01000001;
           rom[ 0+631] =8'b11000010;
           rom[ 0+632] =8'b11000100;
           rom[ 0+633] =8'b10001000;
           rom[ 0+634] =8'b00010000;
           rom[ 0+635] =8'b00100000;
           rom[ 0+636] =8'b00100000;
           rom[ 0+637] =8'b01000000;
           rom[ 0+638] =8'b10100000;
           rom[ 0+639] =8'b01100001;
           rom[ 0+640] =8'b11100010;
           rom[ 0+641] =8'b11000100;
           rom[ 0+642] =8'b10001000;
           rom[ 0+643] =8'b00010000;
           rom[ 0+644] =8'b00010000;
           rom[ 0+645] =8'b00100000;
           rom[ 0+646] =8'b01010000;
           rom[ 0+647] =8'b10110000;
           rom[ 0+648] =8'b01110001;
           rom[ 0+649] =8'b11100010;
           rom[ 0+650] =8'b11000100;
           rom[ 0+651] =8'b10001000;
           rom[ 0+652] =8'b10001000;
           rom[ 0+653] =8'b00010000;
           rom[ 0+654] =8'b10101000;
           rom[ 0+655] =8'b11011000;
           rom[ 0+656] =8'b00111000;
           rom[ 0+657] =8'b01110001;
           rom[ 0+658] =8'b11100010;
           rom[ 0+659] =8'b11000100;
           rom[ 0+660] =8'b11000100;
           rom[ 0+661] =8'b10001000;
           rom[ 0+662] =8'b11010100;
           rom[ 0+663] =8'b01101100;
           rom[ 0+664] =8'b00011100;
           rom[ 0+665] =8'b00111000;
           rom[ 0+666] =8'b01110001;
           rom[ 0+667] =8'b11100010;
           rom[ 0+668] =8'b00000000;
           rom[ 0+669] =8'b00000000;
           rom[ 0+670] =8'b00000001;
           rom[ 0+671] =8'b00011001;
           rom[ 0+672] =8'b00000010;
           rom[ 0+673] =8'b00110010;
           rom[ 0+674] =8'b00011010;
           rom[ 0+675] =8'b11000110;
           rom[ 0+676] =8'b00000011;
           rom[ 0+677] =8'b11011111;
           rom[ 0+678] =8'b00110011;
           rom[ 0+679] =8'b11101110;
           rom[ 0+680] =8'b00011011;
           rom[ 0+681] =8'b01101000;
           rom[ 0+682] =8'b11000111;
           rom[ 0+683] =8'b01001011;
           rom[ 0+684] =8'b00000100;
           rom[ 0+685] =8'b01100100;
           rom[ 0+686] =8'b11100000;
           rom[ 0+687] =8'b00001110;
           rom[ 0+688] =8'b00110100;
           rom[ 0+689] =8'b10001101;
           rom[ 0+690] =8'b11101111;
           rom[ 0+691] =8'b10000001;
           rom[ 0+692] =8'b00011100;
           rom[ 0+693] =8'b11000001;
           rom[ 0+694] =8'b01101001;
           rom[ 0+695] =8'b11111000;
           rom[ 0+696] =8'b11001000;
           rom[ 0+697] =8'b00001000;
           rom[ 0+698] =8'b01001100;
           rom[ 0+699] =8'b01110001;
           rom[ 0+700] =8'b00000101;
           rom[ 0+701] =8'b10001010;
           rom[ 0+702] =8'b01100101;
           rom[ 0+703] =8'b00101111;
           rom[ 0+704] =8'b11100001;
           rom[ 0+705] =8'b00100100;
           rom[ 0+706] =8'b00001111;
           rom[ 0+707] =8'b00100001;
           rom[ 0+708] =8'b00110101;
           rom[ 0+709] =8'b10010011;
           rom[ 0+710] =8'b10001110;
           rom[ 0+711] =8'b11011010;
           rom[ 0+712] =8'b11110000;
           rom[ 0+713] =8'b00010010;
           rom[ 0+714] =8'b10000010;
           rom[ 0+715] =8'b01000101;
           rom[ 0+716] =8'b00011101;
           rom[ 0+717] =8'b10110101;
           rom[ 0+718] =8'b11000010;
           rom[ 0+719] =8'b01111101;
           rom[ 0+720] =8'b01101010;
           rom[ 0+721] =8'b00100111;
           rom[ 0+722] =8'b11111001;
           rom[ 0+723] =8'b10111001;
           rom[ 0+724] =8'b11001001;
           rom[ 0+725] =8'b10011010;
           rom[ 0+726] =8'b00001001;
           rom[ 0+727] =8'b01111000;
           rom[ 0+728] =8'b01001101;
           rom[ 0+729] =8'b11100100;
           rom[ 0+730] =8'b01110010;
           rom[ 0+731] =8'b10100110;
           rom[ 0+732] =8'b00000110;
           rom[ 0+733] =8'b10111111;
           rom[ 0+734] =8'b10001011;
           rom[ 0+735] =8'b01100010;
           rom[ 0+736] =8'b01100110;
           rom[ 0+737] =8'b11011101;
           rom[ 0+738] =8'b00110000;
           rom[ 0+739] =8'b11111101;
           rom[ 0+740] =8'b11100010;
           rom[ 0+741] =8'b10011000;
           rom[ 0+742] =8'b00100101;
           rom[ 0+743] =8'b10110011;
           rom[ 0+744] =8'b00010000;
           rom[ 0+745] =8'b10010001;
           rom[ 0+746] =8'b00100010;
           rom[ 0+747] =8'b10001000;
           rom[ 0+748] =8'b00110110;
           rom[ 0+749] =8'b11010000;
           rom[ 0+750] =8'b10010100;
           rom[ 0+751] =8'b11001110;
           rom[ 0+752] =8'b10001111;
           rom[ 0+753] =8'b10010110;
           rom[ 0+754] =8'b11011011;
           rom[ 0+755] =8'b10111101;
           rom[ 0+756] =8'b11110001;
           rom[ 0+757] =8'b11010010;
           rom[ 0+758] =8'b00010011;
           rom[ 0+759] =8'b01011100;
           rom[ 0+760] =8'b10000011;
           rom[ 0+761] =8'b00111000;
           rom[ 0+762] =8'b01000110;
           rom[ 0+763] =8'b01000000;
           rom[ 0+764] =8'b00011110;
           rom[ 0+765] =8'b01000010;
           rom[ 0+766] =8'b10110110;
           rom[ 0+767] =8'b10100011;
           rom[ 0+768] =8'b11000011;
           rom[ 0+769] =8'b01001000;
           rom[ 0+770] =8'b01111110;
           rom[ 0+771] =8'b01101110;
           rom[ 0+772] =8'b01101011;
           rom[ 0+773] =8'b00111010;
           rom[ 0+774] =8'b00101000;
           rom[ 0+775] =8'b01010100;
           rom[ 0+776] =8'b11111010;
           rom[ 0+777] =8'b10000101;
           rom[ 0+778] =8'b10111010;
           rom[ 0+779] =8'b00111101;
           rom[ 0+780] =8'b11001010;
           rom[ 0+781] =8'b01011110;
           rom[ 0+782] =8'b10011011;
           rom[ 0+783] =8'b10011111;
           rom[ 0+784] =8'b00001010;
           rom[ 0+785] =8'b00010101;
           rom[ 0+786] =8'b01111001;
           rom[ 0+787] =8'b00101011;
           rom[ 0+788] =8'b01001110;
           rom[ 0+789] =8'b11010100;
           rom[ 0+790] =8'b11100101;
           rom[ 0+791] =8'b10101100;
           rom[ 0+792] =8'b01110011;
           rom[ 0+793] =8'b11110011;
           rom[ 0+794] =8'b10100111;
           rom[ 0+795] =8'b01010111;
           rom[ 0+796] =8'b00000111;
           rom[ 0+797] =8'b01110000;
           rom[ 0+798] =8'b11000000;
           rom[ 0+799] =8'b11110111;
           rom[ 0+800] =8'b10001100;
           rom[ 0+801] =8'b10000000;
           rom[ 0+802] =8'b01100011;
           rom[ 0+803] =8'b00001101;
           rom[ 0+804] =8'b01100111;
           rom[ 0+805] =8'b01001010;
           rom[ 0+806] =8'b11011110;
           rom[ 0+807] =8'b11101101;
           rom[ 0+808] =8'b00110001;
           rom[ 0+809] =8'b11000101;
           rom[ 0+810] =8'b11111110;
           rom[ 0+811] =8'b00011000;
           rom[ 0+812] =8'b11100011;
           rom[ 0+813] =8'b10100101;
           rom[ 0+814] =8'b10011001;
           rom[ 0+815] =8'b01110111;
           rom[ 0+816] =8'b00100110;
           rom[ 0+817] =8'b10111000;
           rom[ 0+818] =8'b10110100;
           rom[ 0+819] =8'b01111100;
           rom[ 0+820] =8'b00010001;
           rom[ 0+821] =8'b01000100;
           rom[ 0+822] =8'b10010010;
           rom[ 0+823] =8'b11011001;
           rom[ 0+824] =8'b00100011;
           rom[ 0+825] =8'b00100000;
           rom[ 0+826] =8'b10001001;
           rom[ 0+827] =8'b00101110;
           rom[ 0+828] =8'b00110111;
           rom[ 0+829] =8'b00111111;
           rom[ 0+830] =8'b11010001;
           rom[ 0+831] =8'b01011011;
           rom[ 0+832] =8'b10010101;
           rom[ 0+833] =8'b10111100;
           rom[ 0+834] =8'b11001111;
           rom[ 0+835] =8'b11001101;
           rom[ 0+836] =8'b10010000;
           rom[ 0+837] =8'b10000111;
           rom[ 0+838] =8'b10010111;
           rom[ 0+839] =8'b10110010;
           rom[ 0+840] =8'b11011100;
           rom[ 0+841] =8'b11111100;
           rom[ 0+842] =8'b10111110;
           rom[ 0+843] =8'b01100001;
           rom[ 0+844] =8'b11110010;
           rom[ 0+845] =8'b01010110;
           rom[ 0+846] =8'b11010011;
           rom[ 0+847] =8'b10101011;
           rom[ 0+848] =8'b00010100;
           rom[ 0+849] =8'b00101010;
           rom[ 0+850] =8'b01011101;
           rom[ 0+851] =8'b10011110;
           rom[ 0+852] =8'b10000100;
           rom[ 0+853] =8'b00111100;
           rom[ 0+854] =8'b00111001;
           rom[ 0+855] =8'b01010011;
           rom[ 0+856] =8'b01000111;
           rom[ 0+857] =8'b01101101;
           rom[ 0+858] =8'b01000001;
           rom[ 0+859] =8'b10100010;
           rom[ 0+860] =8'b00011111;
           rom[ 0+861] =8'b00101101;
           rom[ 0+862] =8'b01000011;
           rom[ 0+863] =8'b11011000;
           rom[ 0+864] =8'b10110111;
           rom[ 0+865] =8'b01111011;
           rom[ 0+866] =8'b10100100;
           rom[ 0+867] =8'b01110110;
           rom[ 0+868] =8'b11000100;
           rom[ 0+869] =8'b00010111;
           rom[ 0+870] =8'b01001001;
           rom[ 0+871] =8'b11101100;
           rom[ 0+872] =8'b01111111;
           rom[ 0+873] =8'b00001100;
           rom[ 0+874] =8'b01101111;
           rom[ 0+875] =8'b11110110;
           rom[ 0+876] =8'b01101100;
           rom[ 0+877] =8'b10100001;
           rom[ 0+878] =8'b00111011;
           rom[ 0+879] =8'b01010010;
           rom[ 0+880] =8'b00101001;
           rom[ 0+881] =8'b10011101;
           rom[ 0+882] =8'b01010101;
           rom[ 0+883] =8'b10101010;
           rom[ 0+884] =8'b11111011;
           rom[ 0+885] =8'b01100000;
           rom[ 0+886] =8'b10000110;
           rom[ 0+887] =8'b10110001;
           rom[ 0+888] =8'b10111011;
           rom[ 0+889] =8'b11001100;
           rom[ 0+890] =8'b00111110;
           rom[ 0+891] =8'b01011010;
           rom[ 0+892] =8'b11001011;
           rom[ 0+893] =8'b01011001;
           rom[ 0+894] =8'b01011111;
           rom[ 0+895] =8'b10110000;
           rom[ 0+896] =8'b10011100;
           rom[ 0+897] =8'b10101001;
           rom[ 0+898] =8'b10100000;
           rom[ 0+899] =8'b01010001;
           rom[ 0+900] =8'b00001011;
           rom[ 0+901] =8'b11110101;
           rom[ 0+902] =8'b00010110;
           rom[ 0+903] =8'b11101011;
           rom[ 0+904] =8'b01111010;
           rom[ 0+905] =8'b01110101;
           rom[ 0+906] =8'b00101100;
           rom[ 0+907] =8'b11010111;
           rom[ 0+908] =8'b01001111;
           rom[ 0+909] =8'b10101110;
           rom[ 0+910] =8'b11010101;
           rom[ 0+911] =8'b11101001;
           rom[ 0+912] =8'b11100110;
           rom[ 0+913] =8'b11100111;
           rom[ 0+914] =8'b10101101;
           rom[ 0+915] =8'b11101000;
           rom[ 0+916] =8'b01110100;
           rom[ 0+917] =8'b11010110;
           rom[ 0+918] =8'b11110100;
           rom[ 0+919] =8'b11101010;
           rom[ 0+920] =8'b10101000;
           rom[ 0+921] =8'b01010000;
           rom[ 0+922] =8'b01011000;
           rom[ 0+923] =8'b10101111;
           rom[ 0+924] =8'b00000001;
           rom[ 0+925] =8'b00000010;
           rom[ 0+926] =8'b00000100;
           rom[ 0+927] =8'b00001000;
           rom[ 0+928] =8'b00010000;
           rom[ 0+929] =8'b00100000;
           rom[ 0+930] =8'b01000000;
           rom[ 0+931] =8'b10000000;
           rom[ 0+932] =8'b00011101;
           rom[ 0+933] =8'b00111010;
           rom[ 0+934] =8'b01110100;
           rom[ 0+935] =8'b11101000;
           rom[ 0+936] =8'b11001101;
           rom[ 0+937] =8'b10000111;
           rom[ 0+938] =8'b00010011;
           rom[ 0+939] =8'b00100110;
           rom[ 0+940] =8'b01001100;
           rom[ 0+941] =8'b10011000;
           rom[ 0+942] =8'b00101101;
           rom[ 0+943] =8'b01011010;
           rom[ 0+944] =8'b10110100;
           rom[ 0+945] =8'b01110101;
           rom[ 0+946] =8'b11101010;
           rom[ 0+947] =8'b11001001;
           rom[ 0+948] =8'b10001111;
           rom[ 0+949] =8'b00000011;
           rom[ 0+950] =8'b00000110;
           rom[ 0+951] =8'b00001100;
           rom[ 0+952] =8'b00011000;
           rom[ 0+953] =8'b00110000;
           rom[ 0+954] =8'b01100000;
           rom[ 0+955] =8'b11000000;
           rom[ 0+956] =8'b10011101;
           rom[ 0+957] =8'b00100111;
           rom[ 0+958] =8'b01001110;
           rom[ 0+959] =8'b10011100;
           rom[ 0+960] =8'b00100101;
           rom[ 0+961] =8'b01001010;
           rom[ 0+962] =8'b10010100;
           rom[ 0+963] =8'b00110101;
           rom[ 0+964] =8'b01101010;
           rom[ 0+965] =8'b11010100;
           rom[ 0+966] =8'b10110101;
           rom[ 0+967] =8'b01110111;
           rom[ 0+968] =8'b11101110;
           rom[ 0+969] =8'b11000001;
           rom[ 0+970] =8'b10011111;
           rom[ 0+971] =8'b00100011;
           rom[ 0+972] =8'b01000110;
           rom[ 0+973] =8'b10001100;
           rom[ 0+974] =8'b00000101;
           rom[ 0+975] =8'b00001010;
           rom[ 0+976] =8'b00010100;
           rom[ 0+977] =8'b00101000;
           rom[ 0+978] =8'b01010000;
           rom[ 0+979] =8'b10100000;
           rom[ 0+980] =8'b01011101;
           rom[ 0+981] =8'b10111010;
           rom[ 0+982] =8'b01101001;
           rom[ 0+983] =8'b11010010;
           rom[ 0+984] =8'b10111001;
           rom[ 0+985] =8'b01101111;
           rom[ 0+986] =8'b11011110;
           rom[ 0+987] =8'b10100001;
           rom[ 0+988] =8'b01011111;
           rom[ 0+989] =8'b10111110;
           rom[ 0+990] =8'b01100001;
           rom[ 0+991] =8'b11000010;
           rom[ 0+992] =8'b10011001;
           rom[ 0+993] =8'b00101111;
           rom[ 0+994] =8'b01011110;
           rom[ 0+995] =8'b10111100;
           rom[ 0+996] =8'b01100101;
           rom[ 0+997] =8'b11001010;
           rom[ 0+998] =8'b10001001;
           rom[ 0+999] =8'b00001111;
           rom[ 0+1000] =8'b00011110;
           rom[ 0+1001] =8'b00111100;
           rom[ 0+1002] =8'b01111000;
           rom[ 0+1003] =8'b11110000;
           rom[ 0+1004] =8'b11111101;
           rom[ 0+1005] =8'b11100111;
           rom[ 0+1006] =8'b11010011;
           rom[ 0+1007] =8'b10111011;
           rom[ 0+1008] =8'b01101011;
           rom[ 0+1009] =8'b11010110;
           rom[ 0+1010] =8'b10110001;
           rom[ 0+1011] =8'b01111111;
           rom[ 0+1012] =8'b11111110;
           rom[ 0+1013] =8'b11100001;
           rom[ 0+1014] =8'b11011111;
           rom[ 0+1015] =8'b10100011;
           rom[ 0+1016] =8'b01011011;
           rom[ 0+1017] =8'b10110110;
           rom[ 0+1018] =8'b01110001;
           rom[ 0+1019] =8'b11100010;
           rom[ 0+1020] =8'b11011001;
           rom[ 0+1021] =8'b10101111;
           rom[ 0+1022] =8'b01000011;
           rom[ 0+1023] =8'b10000110;
           rom[ 0+1024] =8'b00010001;
           rom[ 0+1025] =8'b00100010;
           rom[ 0+1026] =8'b01000100;
           rom[ 0+1027] =8'b10001000;
           rom[ 0+1028] =8'b00001101;
           rom[ 0+1029] =8'b00011010;
           rom[ 0+1030] =8'b00110100;
           rom[ 0+1031] =8'b01101000;
           rom[ 0+1032] =8'b11010000;
           rom[ 0+1033] =8'b10111101;
           rom[ 0+1034] =8'b01100111;
           rom[ 0+1035] =8'b11001110;
           rom[ 0+1036] =8'b10000001;
           rom[ 0+1037] =8'b00011111;
           rom[ 0+1038] =8'b00111110;
           rom[ 0+1039] =8'b01111100;
           rom[ 0+1040] =8'b11111000;
           rom[ 0+1041] =8'b11101101;
           rom[ 0+1042] =8'b11000111;
           rom[ 0+1043] =8'b10010011;
           rom[ 0+1044] =8'b00111011;
           rom[ 0+1045] =8'b01110110;
           rom[ 0+1046] =8'b11101100;
           rom[ 0+1047] =8'b11000101;
           rom[ 0+1048] =8'b10010111;
           rom[ 0+1049] =8'b00110011;
           rom[ 0+1050] =8'b01100110;
           rom[ 0+1051] =8'b11001100;
           rom[ 0+1052] =8'b10000101;
           rom[ 0+1053] =8'b00010111;
           rom[ 0+1054] =8'b00101110;
           rom[ 0+1055] =8'b01011100;
           rom[ 0+1056] =8'b10111000;
           rom[ 0+1057] =8'b01101101;
           rom[ 0+1058] =8'b11011010;
           rom[ 0+1059] =8'b10101001;
           rom[ 0+1060] =8'b01001111;
           rom[ 0+1061] =8'b10011110;
           rom[ 0+1062] =8'b00100001;
           rom[ 0+1063] =8'b01000010;
           rom[ 0+1064] =8'b10000100;
           rom[ 0+1065] =8'b00010101;
           rom[ 0+1066] =8'b00101010;
           rom[ 0+1067] =8'b01010100;
           rom[ 0+1068] =8'b10101000;
           rom[ 0+1069] =8'b01001101;
           rom[ 0+1070] =8'b10011010;
           rom[ 0+1071] =8'b00101001;
           rom[ 0+1072] =8'b01010010;
           rom[ 0+1073] =8'b10100100;
           rom[ 0+1074] =8'b01010101;
           rom[ 0+1075] =8'b10101010;
           rom[ 0+1076] =8'b01001001;
           rom[ 0+1077] =8'b10010010;
           rom[ 0+1078] =8'b00111001;
           rom[ 0+1079] =8'b01110010;
           rom[ 0+1080] =8'b11100100;
           rom[ 0+1081] =8'b11010101;
           rom[ 0+1082] =8'b10110111;
           rom[ 0+1083] =8'b01110011;
           rom[ 0+1084] =8'b11100110;
           rom[ 0+1085] =8'b11010001;
           rom[ 0+1086] =8'b10111111;
           rom[ 0+1087] =8'b01100011;
           rom[ 0+1088] =8'b11000110;
           rom[ 0+1089] =8'b10010001;
           rom[ 0+1090] =8'b00111111;
           rom[ 0+1091] =8'b01111110;
           rom[ 0+1092] =8'b11111100;
           rom[ 0+1093] =8'b11100101;
           rom[ 0+1094] =8'b11010111;
           rom[ 0+1095] =8'b10110011;
           rom[ 0+1096] =8'b01111011;
           rom[ 0+1097] =8'b11110110;
           rom[ 0+1098] =8'b11110001;
           rom[ 0+1099] =8'b11111111;
           rom[ 0+1100] =8'b11100011;
           rom[ 0+1101] =8'b11011011;
           rom[ 0+1102] =8'b10101011;
           rom[ 0+1103] =8'b01001011;
           rom[ 0+1104] =8'b10010110;
           rom[ 0+1105] =8'b00110001;
           rom[ 0+1106] =8'b01100010;
           rom[ 0+1107] =8'b11000100;
           rom[ 0+1108] =8'b10010101;
           rom[ 0+1109] =8'b00110111;
           rom[ 0+1110] =8'b01101110;
           rom[ 0+1111] =8'b11011100;
           rom[ 0+1112] =8'b10100101;
           rom[ 0+1113] =8'b01010111;
           rom[ 0+1114] =8'b10101110;
           rom[ 0+1115] =8'b01000001;
           rom[ 0+1116] =8'b10000010;
           rom[ 0+1117] =8'b00011001;
           rom[ 0+1118] =8'b00110010;
           rom[ 0+1119] =8'b01100100;
           rom[ 0+1120] =8'b11001000;
           rom[ 0+1121] =8'b10001101;
           rom[ 0+1122] =8'b00000111;
           rom[ 0+1123] =8'b00001110;
           rom[ 0+1124] =8'b00011100;
           rom[ 0+1125] =8'b00111000;
           rom[ 0+1126] =8'b01110000;
           rom[ 0+1127] =8'b11100000;
           rom[ 0+1128] =8'b11011101;
           rom[ 0+1129] =8'b10100111;
           rom[ 0+1130] =8'b01010011;
           rom[ 0+1131] =8'b10100110;
           rom[ 0+1132] =8'b01010001;
           rom[ 0+1133] =8'b10100010;
           rom[ 0+1134] =8'b01011001;
           rom[ 0+1135] =8'b10110010;
           rom[ 0+1136] =8'b01111001;
           rom[ 0+1137] =8'b11110010;
           rom[ 0+1138] =8'b11111001;
           rom[ 0+1139] =8'b11101111;
           rom[ 0+1140] =8'b11000011;
           rom[ 0+1141] =8'b10011011;
           rom[ 0+1142] =8'b00101011;
           rom[ 0+1143] =8'b01010110;
           rom[ 0+1144] =8'b10101100;
           rom[ 0+1145] =8'b01000101;
           rom[ 0+1146] =8'b10001010;
           rom[ 0+1147] =8'b00001001;
           rom[ 0+1148] =8'b00010010;
           rom[ 0+1149] =8'b00100100;
           rom[ 0+1150] =8'b01001000;
           rom[ 0+1151] =8'b10010000;
           rom[ 0+1152] =8'b00111101;
           rom[ 0+1153] =8'b01111010;
           rom[ 0+1154] =8'b11110100;
           rom[ 0+1155] =8'b11110101;
           rom[ 0+1156] =8'b11110111;
           rom[ 0+1157] =8'b11110011;
           rom[ 0+1158] =8'b11111011;
           rom[ 0+1159] =8'b11101011;
           rom[ 0+1160] =8'b11001011;
           rom[ 0+1161] =8'b10001011;
           rom[ 0+1162] =8'b00001011;
           rom[ 0+1163] =8'b00010110;
           rom[ 0+1164] =8'b00101100;
           rom[ 0+1165] =8'b01011000;
           rom[ 0+1166] =8'b10110000;
           rom[ 0+1167] =8'b01111101;
           rom[ 0+1168] =8'b11111010;
           rom[ 0+1169] =8'b11101001;
           rom[ 0+1170] =8'b11001111;
           rom[ 0+1171] =8'b10000011;
           rom[ 0+1172] =8'b00011011;
           rom[ 0+1173] =8'b00110110;
           rom[ 0+1174] =8'b01101100;
           rom[ 0+1175] =8'b11011000;
           rom[ 0+1176] =8'b10101101;
           rom[ 0+1177] =8'b01000111;
           rom[ 0+1178] =8'b10001110;
           rom[ 0+1179] =8'b00000001;
           rom[ 0+1180] =8'b00000000;
           rom[ 0+1181] =8'b00000001;
           rom[ 0+1182] =8'b00000100;
           rom[ 0+1183] =8'b00000101;
           rom[ 0+1184] =8'b00010000;
           rom[ 0+1185] =8'b00010001;
           rom[ 0+1186] =8'b00010100;
           rom[ 0+1187] =8'b00010101;
           rom[ 0+1188] =8'b01000000;
           rom[ 0+1189] =8'b01000001;
           rom[ 0+1190] =8'b01000100;
           rom[ 0+1191] =8'b01000101;
           rom[ 0+1192] =8'b01010000;
           rom[ 0+1193] =8'b01010001;
           rom[ 0+1194] =8'b01010100;
           rom[ 0+1195] =8'b01010101;
           rom[ 0+1196] =8'b00011101;
           rom[ 0+1197] =8'b00011100;
           rom[ 0+1198] =8'b00011001;
           rom[ 0+1199] =8'b00011000;
           rom[ 0+1200] =8'b00001101;
           rom[ 0+1201] =8'b00001100;
           rom[ 0+1202] =8'b00001001;
           rom[ 0+1203] =8'b00001000;
           rom[ 0+1204] =8'b01011101;
           rom[ 0+1205] =8'b01011100;
           rom[ 0+1206] =8'b01011001;
           rom[ 0+1207] =8'b01011000;
           rom[ 0+1208] =8'b01001101;
           rom[ 0+1209] =8'b01001100;
           rom[ 0+1210] =8'b01001001;
           rom[ 0+1211] =8'b01001000;
           rom[ 0+1212] =8'b01110100;
           rom[ 0+1213] =8'b01110101;
           rom[ 0+1214] =8'b01110000;
           rom[ 0+1215] =8'b01110001;
           rom[ 0+1216] =8'b01100100;
           rom[ 0+1217] =8'b01100101;
           rom[ 0+1218] =8'b01100000;
           rom[ 0+1219] =8'b01100001;
           rom[ 0+1220] =8'b00110100;
           rom[ 0+1221] =8'b00110101;
           rom[ 0+1222] =8'b00110000;
           rom[ 0+1223] =8'b00110001;
           rom[ 0+1224] =8'b00100100;
           rom[ 0+1225] =8'b00100101;
           rom[ 0+1226] =8'b00100000;
           rom[ 0+1227] =8'b00100001;
           rom[ 0+1228] =8'b01101001;
           rom[ 0+1229] =8'b01101000;
           rom[ 0+1230] =8'b01101101;
           rom[ 0+1231] =8'b01101100;
           rom[ 0+1232] =8'b01111001;
           rom[ 0+1233] =8'b01111000;
           rom[ 0+1234] =8'b01111101;
           rom[ 0+1235] =8'b01111100;
           rom[ 0+1236] =8'b00101001;
           rom[ 0+1237] =8'b00101000;
           rom[ 0+1238] =8'b00101101;
           rom[ 0+1239] =8'b00101100;
           rom[ 0+1240] =8'b00111001;
           rom[ 0+1241] =8'b00111000;
           rom[ 0+1242] =8'b00111101;
           rom[ 0+1243] =8'b00111100;
           rom[ 0+1244] =8'b11001101;
           rom[ 0+1245] =8'b11001100;
           rom[ 0+1246] =8'b11001001;
           rom[ 0+1247] =8'b11001000;
           rom[ 0+1248] =8'b11011101;
           rom[ 0+1249] =8'b11011100;
           rom[ 0+1250] =8'b11011001;
           rom[ 0+1251] =8'b11011000;
           rom[ 0+1252] =8'b10001101;
           rom[ 0+1253] =8'b10001100;
           rom[ 0+1254] =8'b10001001;
           rom[ 0+1255] =8'b10001000;
           rom[ 0+1256] =8'b10011101;
           rom[ 0+1257] =8'b10011100;
           rom[ 0+1258] =8'b10011001;
           rom[ 0+1259] =8'b10011000;
           rom[ 0+1260] =8'b11010000;
           rom[ 0+1261] =8'b11010001;
           rom[ 0+1262] =8'b11010100;
           rom[ 0+1263] =8'b11010101;
           rom[ 0+1264] =8'b11000000;
           rom[ 0+1265] =8'b11000001;
           rom[ 0+1266] =8'b11000100;
           rom[ 0+1267] =8'b11000101;
           rom[ 0+1268] =8'b10010000;
           rom[ 0+1269] =8'b10010001;
           rom[ 0+1270] =8'b10010100;
           rom[ 0+1271] =8'b10010101;
           rom[ 0+1272] =8'b10000000;
           rom[ 0+1273] =8'b10000001;
           rom[ 0+1274] =8'b10000100;
           rom[ 0+1275] =8'b10000101;
           rom[ 0+1276] =8'b10111001;
           rom[ 0+1277] =8'b10111000;
           rom[ 0+1278] =8'b10111101;
           rom[ 0+1279] =8'b10111100;
           rom[ 0+1280] =8'b10101001;
           rom[ 0+1281] =8'b10101000;
           rom[ 0+1282] =8'b10101101;
           rom[ 0+1283] =8'b10101100;
           rom[ 0+1284] =8'b11111001;
           rom[ 0+1285] =8'b11111000;
           rom[ 0+1286] =8'b11111101;
           rom[ 0+1287] =8'b11111100;
           rom[ 0+1288] =8'b11101001;
           rom[ 0+1289] =8'b11101000;
           rom[ 0+1290] =8'b11101101;
           rom[ 0+1291] =8'b11101100;
           rom[ 0+1292] =8'b10100100;
           rom[ 0+1293] =8'b10100101;
           rom[ 0+1294] =8'b10100000;
           rom[ 0+1295] =8'b10100001;
           rom[ 0+1296] =8'b10110100;
           rom[ 0+1297] =8'b10110101;
           rom[ 0+1298] =8'b10110000;
           rom[ 0+1299] =8'b10110001;
           rom[ 0+1300] =8'b11100100;
           rom[ 0+1301] =8'b11100101;
           rom[ 0+1302] =8'b11100000;
           rom[ 0+1303] =8'b11100001;
           rom[ 0+1304] =8'b11110100;
           rom[ 0+1305] =8'b11110101;
           rom[ 0+1306] =8'b11110000;
           rom[ 0+1307] =8'b11110001;
           rom[ 0+1308] =8'b00010011;
           rom[ 0+1309] =8'b00010010;
           rom[ 0+1310] =8'b00010111;
           rom[ 0+1311] =8'b00010110;
           rom[ 0+1312] =8'b00000011;
           rom[ 0+1313] =8'b00000010;
           rom[ 0+1314] =8'b00000111;
           rom[ 0+1315] =8'b00000110;
           rom[ 0+1316] =8'b01010011;
           rom[ 0+1317] =8'b01010010;
           rom[ 0+1318] =8'b01010111;
           rom[ 0+1319] =8'b01010110;
           rom[ 0+1320] =8'b01000011;
           rom[ 0+1321] =8'b01000010;
           rom[ 0+1322] =8'b01000111;
           rom[ 0+1323] =8'b01000110;
           rom[ 0+1324] =8'b00001110;
           rom[ 0+1325] =8'b00001111;
           rom[ 0+1326] =8'b00001010;
           rom[ 0+1327] =8'b00001011;
           rom[ 0+1328] =8'b00011110;
           rom[ 0+1329] =8'b00011111;
           rom[ 0+1330] =8'b00011010;
           rom[ 0+1331] =8'b00011011;
           rom[ 0+1332] =8'b01001110;
           rom[ 0+1333] =8'b01001111;
           rom[ 0+1334] =8'b01001010;
           rom[ 0+1335] =8'b01001011;
           rom[ 0+1336] =8'b01011110;
           rom[ 0+1337] =8'b01011111;
           rom[ 0+1338] =8'b01011010;
           rom[ 0+1339] =8'b01011011;
           rom[ 0+1340] =8'b01100111;
           rom[ 0+1341] =8'b01100110;
           rom[ 0+1342] =8'b01100011;
           rom[ 0+1343] =8'b01100010;
           rom[ 0+1344] =8'b01110111;
           rom[ 0+1345] =8'b01110110;
           rom[ 0+1346] =8'b01110011;
           rom[ 0+1347] =8'b01110010;
           rom[ 0+1348] =8'b00100111;
           rom[ 0+1349] =8'b00100110;
           rom[ 0+1350] =8'b00100011;
           rom[ 0+1351] =8'b00100010;
           rom[ 0+1352] =8'b00110111;
           rom[ 0+1353] =8'b00110110;
           rom[ 0+1354] =8'b00110011;
           rom[ 0+1355] =8'b00110010;
           rom[ 0+1356] =8'b01111010;
           rom[ 0+1357] =8'b01111011;
           rom[ 0+1358] =8'b01111110;
           rom[ 0+1359] =8'b01111111;
           rom[ 0+1360] =8'b01101010;
           rom[ 0+1361] =8'b01101011;
           rom[ 0+1362] =8'b01101110;
           rom[ 0+1363] =8'b01101111;
           rom[ 0+1364] =8'b00111010;
           rom[ 0+1365] =8'b00111011;
           rom[ 0+1366] =8'b00111110;
           rom[ 0+1367] =8'b00111111;
           rom[ 0+1368] =8'b00101010;
           rom[ 0+1369] =8'b00101011;
           rom[ 0+1370] =8'b00101110;
           rom[ 0+1371] =8'b00101111;
           rom[ 0+1372] =8'b11011110;
           rom[ 0+1373] =8'b11011111;
           rom[ 0+1374] =8'b11011010;
           rom[ 0+1375] =8'b11011011;
           rom[ 0+1376] =8'b11001110;
           rom[ 0+1377] =8'b11001111;
           rom[ 0+1378] =8'b11001010;
           rom[ 0+1379] =8'b11001011;
           rom[ 0+1380] =8'b10011110;
           rom[ 0+1381] =8'b10011111;
           rom[ 0+1382] =8'b10011010;
           rom[ 0+1383] =8'b10011011;
           rom[ 0+1384] =8'b10001110;
           rom[ 0+1385] =8'b10001111;
           rom[ 0+1386] =8'b10001010;
           rom[ 0+1387] =8'b10001011;
           rom[ 0+1388] =8'b11000011;
           rom[ 0+1389] =8'b11000010;
           rom[ 0+1390] =8'b11000111;
           rom[ 0+1391] =8'b11000110;
           rom[ 0+1392] =8'b11010011;
           rom[ 0+1393] =8'b11010010;
           rom[ 0+1394] =8'b11010111;
           rom[ 0+1395] =8'b11010110;
           rom[ 0+1396] =8'b10000011;
           rom[ 0+1397] =8'b10000010;
           rom[ 0+1398] =8'b10000111;
           rom[ 0+1399] =8'b10000110;
           rom[ 0+1400] =8'b10010011;
           rom[ 0+1401] =8'b10010010;
           rom[ 0+1402] =8'b10010111;
           rom[ 0+1403] =8'b10010110;
           rom[ 0+1404] =8'b10101010;
           rom[ 0+1405] =8'b10101011;
           rom[ 0+1406] =8'b10101110;
           rom[ 0+1407] =8'b10101111;
           rom[ 0+1408] =8'b10111010;
           rom[ 0+1409] =8'b10111011;
           rom[ 0+1410] =8'b10111110;
           rom[ 0+1411] =8'b10111111;
           rom[ 0+1412] =8'b11101010;
           rom[ 0+1413] =8'b11101011;
           rom[ 0+1414] =8'b11101110;
           rom[ 0+1415] =8'b11101111;
           rom[ 0+1416] =8'b11111010;
           rom[ 0+1417] =8'b11111011;
           rom[ 0+1418] =8'b11111110;
           rom[ 0+1419] =8'b11111111;
           rom[ 0+1420] =8'b10110111;
           rom[ 0+1421] =8'b10110110;
           rom[ 0+1422] =8'b10110011;
           rom[ 0+1423] =8'b10110010;
           rom[ 0+1424] =8'b10100111;
           rom[ 0+1425] =8'b10100110;
           rom[ 0+1426] =8'b10100011;
           rom[ 0+1427] =8'b10100010;
           rom[ 0+1428] =8'b11110111;
           rom[ 0+1429] =8'b11110110;
           rom[ 0+1430] =8'b11110011;
           rom[ 0+1431] =8'b11110010;
           rom[ 0+1432] =8'b11100111;
           rom[ 0+1433] =8'b11100110;
           rom[ 0+1434] =8'b11100011;
           rom[ 0+1435] =8'b11100010;
           rom[ 0+1436] =8'b00000000;
           rom[ 0+1437] =8'b11010110;
           rom[ 0+1438] =8'b11101000;
           rom[ 0+1439] =8'b00111110;
           rom[ 0+1440] =8'b11101010;
           rom[ 0+1441] =8'b00111100;
           rom[ 0+1442] =8'b00000010;
           rom[ 0+1443] =8'b11010100;
           rom[ 0+1444] =8'b00101100;
           rom[ 0+1445] =8'b11111010;
           rom[ 0+1446] =8'b11000100;
           rom[ 0+1447] =8'b00010010;
           rom[ 0+1448] =8'b11000110;
           rom[ 0+1449] =8'b00010000;
           rom[ 0+1450] =8'b00101110;
           rom[ 0+1451] =8'b11111000;
           rom[ 0+1452] =8'b11101110;
           rom[ 0+1453] =8'b00111000;
           rom[ 0+1454] =8'b00000110;
           rom[ 0+1455] =8'b11010000;
           rom[ 0+1456] =8'b00000100;
           rom[ 0+1457] =8'b11010010;
           rom[ 0+1458] =8'b11101100;
           rom[ 0+1459] =8'b00111010;
           rom[ 0+1460] =8'b11000010;
           rom[ 0+1461] =8'b00010100;
           rom[ 0+1462] =8'b00101010;
           rom[ 0+1463] =8'b11111100;
           rom[ 0+1464] =8'b00101000;
           rom[ 0+1465] =8'b11111110;
           rom[ 0+1466] =8'b11000000;
           rom[ 0+1467] =8'b00010110;
           rom[ 0+1468] =8'b00000000;
           rom[ 0+1469] =8'b00000000;
           rom[ 0+1470] =8'b00000000;
           rom[ 0+1471] =8'b00000000;
           rom[ 0+1472] =8'b00000000;
           rom[ 0+1473] =8'b00000000;
           rom[ 0+1474] =8'b00000000;
           rom[ 0+1475] =8'b00000000;
           rom[ 0+1476] =8'b00000000;
           rom[ 0+1477] =8'b00000000;
           rom[ 0+1478] =8'b00000000;
           rom[ 0+1479] =8'b00000000;
           rom[ 0+1480] =8'b00000000;
           rom[ 0+1481] =8'b00000000;
           rom[ 0+1482] =8'b00000000;
           rom[ 0+1483] =8'b00000000;
           rom[ 0+1484] =8'b00000000;
           rom[ 0+1485] =8'b00000000;
           rom[ 0+1486] =8'b00000000;
           rom[ 0+1487] =8'b00000000;
           rom[ 0+1488] =8'b00000000;
           rom[ 0+1489] =8'b00000000;
           rom[ 0+1490] =8'b00000000;
           rom[ 0+1491] =8'b00000000;
           rom[ 0+1492] =8'b00000000;
           rom[ 0+1493] =8'b00000000;
           rom[ 0+1494] =8'b00000000;
           rom[ 0+1495] =8'b00000000;
           rom[ 0+1496] =8'b00000000;
           rom[ 0+1497] =8'b00000000;
           rom[ 0+1498] =8'b00000000;
           rom[ 0+1499] =8'b00000000;
           rom[ 0+1500] =8'b00100100;
           rom[ 0+1501] =8'b11110010;
           rom[ 0+1502] =8'b11001100;
           rom[ 0+1503] =8'b00011010;
           rom[ 0+1504] =8'b11001110;
           rom[ 0+1505] =8'b00011000;
           rom[ 0+1506] =8'b00100110;
           rom[ 0+1507] =8'b11110000;
           rom[ 0+1508] =8'b00001000;
           rom[ 0+1509] =8'b11011110;
           rom[ 0+1510] =8'b11100000;
           rom[ 0+1511] =8'b00110110;
           rom[ 0+1512] =8'b11100010;
           rom[ 0+1513] =8'b00110100;
           rom[ 0+1514] =8'b00001010;
           rom[ 0+1515] =8'b11011100;
           rom[ 0+1516] =8'b11001010;
           rom[ 0+1517] =8'b00011100;
           rom[ 0+1518] =8'b00100010;
           rom[ 0+1519] =8'b11110100;
           rom[ 0+1520] =8'b00100000;
           rom[ 0+1521] =8'b11110110;
           rom[ 0+1522] =8'b11001000;
           rom[ 0+1523] =8'b00011110;
           rom[ 0+1524] =8'b11100110;
           rom[ 0+1525] =8'b00110000;
           rom[ 0+1526] =8'b00001110;
           rom[ 0+1527] =8'b11011000;
           rom[ 0+1528] =8'b00001100;
           rom[ 0+1529] =8'b11011010;
           rom[ 0+1530] =8'b11100100;
           rom[ 0+1531] =8'b00110010;
           rom[ 0+1532] =8'b00000000;
           rom[ 0+1533] =8'b00000000;
           rom[ 0+1534] =8'b00000000;
           rom[ 0+1535] =8'b00000000;
           rom[ 0+1536] =8'b00000000;
           rom[ 0+1537] =8'b00000000;
           rom[ 0+1538] =8'b00000000;
           rom[ 0+1539] =8'b00000000;
           rom[ 0+1540] =8'b00000000;
           rom[ 0+1541] =8'b00000000;
           rom[ 0+1542] =8'b00000000;
           rom[ 0+1543] =8'b00000000;
           rom[ 0+1544] =8'b00000000;
           rom[ 0+1545] =8'b00000000;
           rom[ 0+1546] =8'b00000000;
           rom[ 0+1547] =8'b00000000;
           rom[ 0+1548] =8'b00000000;
           rom[ 0+1549] =8'b00000000;
           rom[ 0+1550] =8'b00000000;
           rom[ 0+1551] =8'b00000000;
           rom[ 0+1552] =8'b00000000;
           rom[ 0+1553] =8'b00000000;
           rom[ 0+1554] =8'b00000000;
           rom[ 0+1555] =8'b00000000;
           rom[ 0+1556] =8'b00000000;
           rom[ 0+1557] =8'b00000000;
           rom[ 0+1558] =8'b00000000;
           rom[ 0+1559] =8'b00000000;
           rom[ 0+1560] =8'b00000000;
           rom[ 0+1561] =8'b00000000;
           rom[ 0+1562] =8'b00000000;
           rom[ 0+1563] =8'b00000000;
           rom[ 0+1564] =8'b01010000;
           rom[ 0+1565] =8'b10000110;
           rom[ 0+1566] =8'b10111000;
           rom[ 0+1567] =8'b01101110;
           rom[ 0+1568] =8'b10111010;
           rom[ 0+1569] =8'b01101100;
           rom[ 0+1570] =8'b01010010;
           rom[ 0+1571] =8'b10000100;
           rom[ 0+1572] =8'b01111100;
           rom[ 0+1573] =8'b10101010;
           rom[ 0+1574] =8'b10010100;
           rom[ 0+1575] =8'b01000010;
           rom[ 0+1576] =8'b10010110;
           rom[ 0+1577] =8'b01000000;
           rom[ 0+1578] =8'b01111110;
           rom[ 0+1579] =8'b10101000;
           rom[ 0+1580] =8'b10111110;
           rom[ 0+1581] =8'b01101000;
           rom[ 0+1582] =8'b01010110;
           rom[ 0+1583] =8'b10000000;
           rom[ 0+1584] =8'b01010100;
           rom[ 0+1585] =8'b10000010;
           rom[ 0+1586] =8'b10111100;
           rom[ 0+1587] =8'b01101010;
           rom[ 0+1588] =8'b10010010;
           rom[ 0+1589] =8'b01000100;
           rom[ 0+1590] =8'b01111010;
           rom[ 0+1591] =8'b10101100;
           rom[ 0+1592] =8'b01111000;
           rom[ 0+1593] =8'b10101110;
           rom[ 0+1594] =8'b10010000;
           rom[ 0+1595] =8'b01000110;
           rom[ 0+1596] =8'b00000000;
           rom[ 0+1597] =8'b00000000;
           rom[ 0+1598] =8'b00000000;
           rom[ 0+1599] =8'b00000000;
           rom[ 0+1600] =8'b00000000;
           rom[ 0+1601] =8'b00000000;
           rom[ 0+1602] =8'b00000000;
           rom[ 0+1603] =8'b00000000;
           rom[ 0+1604] =8'b00000000;
           rom[ 0+1605] =8'b00000000;
           rom[ 0+1606] =8'b00000000;
           rom[ 0+1607] =8'b00000000;
           rom[ 0+1608] =8'b00000000;
           rom[ 0+1609] =8'b00000000;
           rom[ 0+1610] =8'b00000000;
           rom[ 0+1611] =8'b00000000;
           rom[ 0+1612] =8'b00000000;
           rom[ 0+1613] =8'b00000000;
           rom[ 0+1614] =8'b00000000;
           rom[ 0+1615] =8'b00000000;
           rom[ 0+1616] =8'b00000000;
           rom[ 0+1617] =8'b00000000;
           rom[ 0+1618] =8'b00000000;
           rom[ 0+1619] =8'b00000000;
           rom[ 0+1620] =8'b00000000;
           rom[ 0+1621] =8'b00000000;
           rom[ 0+1622] =8'b00000000;
           rom[ 0+1623] =8'b00000000;
           rom[ 0+1624] =8'b00000000;
           rom[ 0+1625] =8'b00000000;
           rom[ 0+1626] =8'b00000000;
           rom[ 0+1627] =8'b00000000;
           rom[ 0+1628] =8'b01110100;
           rom[ 0+1629] =8'b10100010;
           rom[ 0+1630] =8'b10011100;
           rom[ 0+1631] =8'b01001010;
           rom[ 0+1632] =8'b10011110;
           rom[ 0+1633] =8'b01001000;
           rom[ 0+1634] =8'b01110110;
           rom[ 0+1635] =8'b10100000;
           rom[ 0+1636] =8'b01011000;
           rom[ 0+1637] =8'b10001110;
           rom[ 0+1638] =8'b10110000;
           rom[ 0+1639] =8'b01100110;
           rom[ 0+1640] =8'b10110010;
           rom[ 0+1641] =8'b01100100;
           rom[ 0+1642] =8'b01011010;
           rom[ 0+1643] =8'b10001100;
           rom[ 0+1644] =8'b10011010;
           rom[ 0+1645] =8'b01001100;
           rom[ 0+1646] =8'b01110010;
           rom[ 0+1647] =8'b10100100;
           rom[ 0+1648] =8'b01110000;
           rom[ 0+1649] =8'b10100110;
           rom[ 0+1650] =8'b10011000;
           rom[ 0+1651] =8'b01001110;
           rom[ 0+1652] =8'b10110110;
           rom[ 0+1653] =8'b01100000;
           rom[ 0+1654] =8'b01011110;
           rom[ 0+1655] =8'b10001000;
           rom[ 0+1656] =8'b01011100;
           rom[ 0+1657] =8'b10001010;
           rom[ 0+1658] =8'b10110100;
           rom[ 0+1659] =8'b01100010;
           rom[ 0+1660] =8'b00000000;
           rom[ 0+1661] =8'b00000000;
           rom[ 0+1662] =8'b00000000;
           rom[ 0+1663] =8'b00000000;
           rom[ 0+1664] =8'b00000000;
           rom[ 0+1665] =8'b00000000;
           rom[ 0+1666] =8'b00000000;
           rom[ 0+1667] =8'b00000000;
           rom[ 0+1668] =8'b00000000;
           rom[ 0+1669] =8'b00000000;
           rom[ 0+1670] =8'b00000000;
           rom[ 0+1671] =8'b00000000;
           rom[ 0+1672] =8'b00000000;
           rom[ 0+1673] =8'b00000000;
           rom[ 0+1674] =8'b00000000;
           rom[ 0+1675] =8'b00000000;
           rom[ 0+1676] =8'b00000000;
           rom[ 0+1677] =8'b00000000;
           rom[ 0+1678] =8'b00000000;
           rom[ 0+1679] =8'b00000000;
           rom[ 0+1680] =8'b00000000;
           rom[ 0+1681] =8'b00000000;
           rom[ 0+1682] =8'b00000000;
           rom[ 0+1683] =8'b00000000;
           rom[ 0+1684] =8'b00000000;
           rom[ 0+1685] =8'b00000000;
           rom[ 0+1686] =8'b00000000;
           rom[ 0+1687] =8'b00000000;
           rom[ 0+1688] =8'b00000000;
           rom[ 0+1689] =8'b00000000;
           rom[ 0+1690] =8'b00000000;
           rom[ 0+1691] =8'b00000000;
           rom[ 0+1692] =8'b00000000;
           rom[ 0+1693] =8'b11010111;
           rom[ 0+1694] =8'b00000000;
           rom[ 0+1695] =8'b00000000;
           rom[ 0+1696] =8'b00000000;
           rom[ 0+1697] =8'b00000000;
           rom[ 0+1698] =8'b00000000;
           rom[ 0+1699] =8'b11001011;
           rom[ 0+1700] =8'b10110011;
           rom[ 0+1701] =8'b00000000;
           rom[ 0+1702] =8'b11011100;
           rom[ 0+1703] =8'b00000000;
           rom[ 0+1704] =8'b01110001;
           rom[ 0+1705] =8'b00000000;
           rom[ 0+1706] =8'b00000000;
           rom[ 0+1707] =8'b01100111;
           rom[ 0+1708] =8'b00000000;
           rom[ 0+1709] =8'b00000000;
           rom[ 0+1710] =8'b00000000;
           rom[ 0+1711] =8'b00000000;
           rom[ 0+1712] =8'b00000000;
           rom[ 0+1713] =8'b10111000;
           rom[ 0+1714] =8'b00000000;
           rom[ 0+1715] =8'b11110010;
           rom[ 0+1716] =8'b00000000;
           rom[ 0+1717] =8'b00000000;
           rom[ 0+1718] =8'b10100111;
           rom[ 0+1719] =8'b00000000;
           rom[ 0+1720] =8'b00000000;
           rom[ 0+1721] =8'b00000000;
           rom[ 0+1722] =8'b00000000;
           rom[ 0+1723] =8'b00000000;
           rom[ 0+1724] =8'b00000000;
           rom[ 0+1725] =8'b11000011;
           rom[ 0+1726] =8'b00000000;
           rom[ 0+1727] =8'b00000000;
           rom[ 0+1728] =8'b11101001;
           rom[ 0+1729] =8'b11001101;
           rom[ 0+1730] =8'b11111111;
           rom[ 0+1731] =8'b11101000;
           rom[ 0+1732] =8'b00000000;
           rom[ 0+1733] =8'b11011010;
           rom[ 0+1734] =8'b00000000;
           rom[ 0+1735] =8'b00000000;
           rom[ 0+1736] =8'b11111101;
           rom[ 0+1737] =8'b11100011;
           rom[ 0+1738] =8'b00000000;
           rom[ 0+1739] =8'b11010000;
           rom[ 0+1740] =8'b00000000;
           rom[ 0+1741] =8'b00000000;
           rom[ 0+1742] =8'b00000000;
           rom[ 0+1743] =8'b00000000;
           rom[ 0+1744] =8'b00000000;
           rom[ 0+1745] =8'b11000100;
           rom[ 0+1746] =8'b11111100;
           rom[ 0+1747] =8'b00000000;
           rom[ 0+1748] =8'b11000010;
           rom[ 0+1749] =8'b00000000;
           rom[ 0+1750] =8'b11111110;
           rom[ 0+1751] =8'b01101010;
           rom[ 0+1752] =8'b00000000;
           rom[ 0+1753] =8'b11010001;
           rom[ 0+1754] =8'b11000101;
           rom[ 0+1755] =8'b00000000;
           rom[ 0+1756] =8'b01111111;
           rom[ 0+1757] =8'b00000000;
           rom[ 0+1758] =8'b00000000;
           rom[ 0+1759] =8'b00000000;
           rom[ 0+1760] =8'b11011101;
           rom[ 0+1761] =8'b00000000;
           rom[ 0+1762] =8'b01101110;
           rom[ 0+1763] =8'b00000000;
           rom[ 0+1764] =8'b00000000;
           rom[ 0+1765] =8'b00000000;
           rom[ 0+1766] =8'b00000000;
           rom[ 0+1767] =8'b00000000;
           rom[ 0+1768] =8'b00000000;
           rom[ 0+1769] =8'b00000000;
           rom[ 0+1770] =8'b00000000;
           rom[ 0+1771] =8'b00000000;
           rom[ 0+1772] =8'b10100101;
           rom[ 0+1773] =8'b00000000;
           rom[ 0+1774] =8'b00000000;
           rom[ 0+1775] =8'b00000000;
           rom[ 0+1776] =8'b00000000;
           rom[ 0+1777] =8'b10101100;
           rom[ 0+1778] =8'b11001010;
           rom[ 0+1779] =8'b11110011;
           rom[ 0+1780] =8'b00000000;
           rom[ 0+1781] =8'b01110010;
           rom[ 0+1782] =8'b00000000;
           rom[ 0+1783] =8'b00000000;
           rom[ 0+1784] =8'b00000000;
           rom[ 0+1785] =8'b00000000;
           rom[ 0+1786] =8'b00000000;
           rom[ 0+1787] =8'b00000000;
           rom[ 0+1788] =8'b11100010;
           rom[ 0+1789] =8'b11101010;
           rom[ 0+1790] =8'b00000000;
           rom[ 0+1791] =8'b00000000;
           rom[ 0+1792] =8'b11101011;
           rom[ 0+1793] =8'b10111101;
           rom[ 0+1794] =8'b11001100;
           rom[ 0+1795] =8'b00000000;
           rom[ 0+1796] =8'b00000000;
           rom[ 0+1797] =8'b00000000;
           rom[ 0+1798] =8'b00000000;
           rom[ 0+1799] =8'b00000000;
           rom[ 0+1800] =8'b00000000;
           rom[ 0+1801] =8'b00000000;
           rom[ 0+1802] =8'b11110111;
           rom[ 0+1803] =8'b00000000;
           rom[ 0+1804] =8'b00000000;
           rom[ 0+1805] =8'b00000000;
           rom[ 0+1806] =8'b00000000;
           rom[ 0+1807] =8'b00000000;
           rom[ 0+1808] =8'b00000000;
           rom[ 0+1809] =8'b11011011;
           rom[ 0+1810] =8'b00000000;
           rom[ 0+1811] =8'b00000000;
           rom[ 0+1812] =8'b11001110;
           rom[ 0+1813] =8'b00000000;
           rom[ 0+1814] =8'b00000000;
           rom[ 0+1815] =8'b00000000;
           rom[ 0+1816] =8'b00000000;
           rom[ 0+1817] =8'b11100111;
           rom[ 0+1818] =8'b00000000;
           rom[ 0+1819] =8'b00000000;
           rom[ 0+1820] =8'b00000000;
           rom[ 0+1821] =8'b00000000;
           rom[ 0+1822] =8'b11111011;
           rom[ 0+1823] =8'b00000000;
           rom[ 0+1824] =8'b00000000;
           rom[ 0+1825] =8'b00000000;
           rom[ 0+1826] =8'b11100000;
           rom[ 0+1827] =8'b00000000;
           rom[ 0+1828] =8'b00000000;
           rom[ 0+1829] =8'b00000000;
           rom[ 0+1830] =8'b11111010;
           rom[ 0+1831] =8'b11110000;
           rom[ 0+1832] =8'b00000000;
           rom[ 0+1833] =8'b00000000;
           rom[ 0+1834] =8'b00000000;
           rom[ 0+1835] =8'b10110110;
           rom[ 0+1836] =8'b00000000;
           rom[ 0+1837] =8'b10100000;
           rom[ 0+1838] =8'b00000000;
           rom[ 0+1839] =8'b00000000;
           rom[ 0+1840] =8'b00000000;
           rom[ 0+1841] =8'b00000000;
           rom[ 0+1842] =8'b11110100;
           rom[ 0+1843] =8'b00000000;
           rom[ 0+1844] =8'b00000000;
           rom[ 0+1845] =8'b00000000;
           rom[ 0+1846] =8'b00000000;
           rom[ 0+1847] =8'b00000000;
           rom[ 0+1848] =8'b00000000;
           rom[ 0+1849] =8'b00000000;
           rom[ 0+1850] =8'b00000000;
           rom[ 0+1851] =8'b00000000;
           rom[ 0+1852] =8'b00000000;
           rom[ 0+1853] =8'b00000000;
           rom[ 0+1854] =8'b00000000;
           rom[ 0+1855] =8'b00000000;
           rom[ 0+1856] =8'b00000000;
           rom[ 0+1857] =8'b00000000;
           rom[ 0+1858] =8'b00000000;
           rom[ 0+1859] =8'b00000000;
           rom[ 0+1860] =8'b00000000;
           rom[ 0+1861] =8'b11101111;
           rom[ 0+1862] =8'b00000000;
           rom[ 0+1863] =8'b00000000;
           rom[ 0+1864] =8'b00000000;
           rom[ 0+1865] =8'b11100101;
           rom[ 0+1866] =8'b00000000;
           rom[ 0+1867] =8'b00000000;
           rom[ 0+1868] =8'b00000000;
           rom[ 0+1869] =8'b00000000;
           rom[ 0+1870] =8'b00000000;
           rom[ 0+1871] =8'b10111010;
           rom[ 0+1872] =8'b00000000;
           rom[ 0+1873] =8'b00000000;
           rom[ 0+1874] =8'b11111000;
           rom[ 0+1875] =8'b00000000;
           rom[ 0+1876] =8'b11111001;
           rom[ 0+1877] =8'b00000000;
           rom[ 0+1878] =8'b00000000;
           rom[ 0+1879] =8'b00000000;
           rom[ 0+1880] =8'b00000000;
           rom[ 0+1881] =8'b00000000;
           rom[ 0+1882] =8'b00000000;
           rom[ 0+1883] =8'b00000000;
           rom[ 0+1884] =8'b00000000;
           rom[ 0+1885] =8'b00000000;
           rom[ 0+1886] =8'b00000000;
           rom[ 0+1887] =8'b11010101;
           rom[ 0+1888] =8'b11110101;
           rom[ 0+1889] =8'b11010100;
           rom[ 0+1890] =8'b00000000;
           rom[ 0+1891] =8'b00000000;
           rom[ 0+1892] =8'b00000000;
           rom[ 0+1893] =8'b00000000;
           rom[ 0+1894] =8'b00000000;
           rom[ 0+1895] =8'b00000000;
           rom[ 0+1896] =8'b00000000;
           rom[ 0+1897] =8'b11110001;
           rom[ 0+1898] =8'b11101100;
           rom[ 0+1899] =8'b11010011;
           rom[ 0+1900] =8'b00000000;
           rom[ 0+1901] =8'b00000000;
           rom[ 0+1902] =8'b00000000;
           rom[ 0+1903] =8'b00000000;
           rom[ 0+1904] =8'b00000000;
           rom[ 0+1905] =8'b00000000;
           rom[ 0+1906] =8'b00000000;
           rom[ 0+1907] =8'b00000000;
           rom[ 0+1908] =8'b00000000;
           rom[ 0+1909] =8'b11101101;
           rom[ 0+1910] =8'b00000000;
           rom[ 0+1911] =8'b00000000;
           rom[ 0+1912] =8'b00000000;
           rom[ 0+1913] =8'b00000000;
           rom[ 0+1914] =8'b00000000;
           rom[ 0+1915] =8'b00000000;
           rom[ 0+1916] =8'b00000000;
           rom[ 0+1917] =8'b00000000;
           rom[ 0+1918] =8'b00000000;
           rom[ 0+1919] =8'b00000000;
           rom[ 0+1920] =8'b00000000;
           rom[ 0+1921] =8'b00000000;
           rom[ 0+1922] =8'b00000000;
           rom[ 0+1923] =8'b00000000;
           rom[ 0+1924] =8'b00000000;
           rom[ 0+1925] =8'b00000000;
           rom[ 0+1926] =8'b00000000;
           rom[ 0+1927] =8'b00000000;
           rom[ 0+1928] =8'b00000000;
           rom[ 0+1929] =8'b00000000;
           rom[ 0+1930] =8'b00000000;
           rom[ 0+1931] =8'b00000000;
           rom[ 0+1932] =8'b00000000;
           rom[ 0+1933] =8'b00000000;
           rom[ 0+1934] =8'b00000000;
           rom[ 0+1935] =8'b00000000;
           rom[ 0+1936] =8'b00000000;
           rom[ 0+1937] =8'b00000000;
           rom[ 0+1938] =8'b00000000;
           rom[ 0+1939] =8'b00000000;
           rom[ 0+1940] =8'b00000000;
           rom[ 0+1941] =8'b00000000;
           rom[ 0+1942] =8'b00000000;
           rom[ 0+1943] =8'b00000000;
           rom[ 0+1944] =8'b00000000;
           rom[ 0+1945] =8'b00000000;
           rom[ 0+1946] =8'b00000000;
           rom[ 0+1947] =8'b00000000;
           rom[ 0+1948] =8'b00000000;
           rom[ 0+1949] =8'b01110101;
           rom[ 0+1950] =8'b11101010;
           rom[ 0+1951] =8'b10011111;
           rom[ 0+1952] =8'b11001001;
           rom[ 0+1953] =8'b10111100;
           rom[ 0+1954] =8'b00100011;
           rom[ 0+1955] =8'b01010110;
           rom[ 0+1956] =8'b10001111;
           rom[ 0+1957] =8'b11111010;
           rom[ 0+1958] =8'b01100101;
           rom[ 0+1959] =8'b00010000;
           rom[ 0+1960] =8'b01000110;
           rom[ 0+1961] =8'b00110011;
           rom[ 0+1962] =8'b10101100;
           rom[ 0+1963] =8'b11011001;
           rom[ 0+1964] =8'b00000011;
           rom[ 0+1965] =8'b01110110;
           rom[ 0+1966] =8'b11101001;
           rom[ 0+1967] =8'b10011100;
           rom[ 0+1968] =8'b11001010;
           rom[ 0+1969] =8'b10111111;
           rom[ 0+1970] =8'b00100000;
           rom[ 0+1971] =8'b01010101;
           rom[ 0+1972] =8'b10001100;
           rom[ 0+1973] =8'b11111001;
           rom[ 0+1974] =8'b01100110;
           rom[ 0+1975] =8'b00010011;
           rom[ 0+1976] =8'b01000101;
           rom[ 0+1977] =8'b00110000;
           rom[ 0+1978] =8'b10101111;
           rom[ 0+1979] =8'b11011010;
           rom[ 0+1980] =8'b00000110;
           rom[ 0+1981] =8'b01110011;
           rom[ 0+1982] =8'b11101100;
           rom[ 0+1983] =8'b10011001;
           rom[ 0+1984] =8'b11001111;
           rom[ 0+1985] =8'b10111010;
           rom[ 0+1986] =8'b00100101;
           rom[ 0+1987] =8'b01010000;
           rom[ 0+1988] =8'b10001001;
           rom[ 0+1989] =8'b11111100;
           rom[ 0+1990] =8'b01100011;
           rom[ 0+1991] =8'b00010110;
           rom[ 0+1992] =8'b01000000;
           rom[ 0+1993] =8'b00110101;
           rom[ 0+1994] =8'b10101010;
           rom[ 0+1995] =8'b11011111;
           rom[ 0+1996] =8'b00000101;
           rom[ 0+1997] =8'b01110000;
           rom[ 0+1998] =8'b11101111;
           rom[ 0+1999] =8'b10011010;
           rom[ 0+2000] =8'b11001100;
           rom[ 0+2001] =8'b10111001;
           rom[ 0+2002] =8'b00100110;
           rom[ 0+2003] =8'b01010011;
           rom[ 0+2004] =8'b10001010;
           rom[ 0+2005] =8'b11111111;
           rom[ 0+2006] =8'b01100000;
           rom[ 0+2007] =8'b00010101;
           rom[ 0+2008] =8'b01000011;
           rom[ 0+2009] =8'b00110110;
           rom[ 0+2010] =8'b10101001;
           rom[ 0+2011] =8'b11011100;
           rom[ 0+2012] =8'b00001100;
           rom[ 0+2013] =8'b01111001;
           rom[ 0+2014] =8'b11100110;
           rom[ 0+2015] =8'b10010011;
           rom[ 0+2016] =8'b11000101;
           rom[ 0+2017] =8'b10110000;
           rom[ 0+2018] =8'b00101111;
           rom[ 0+2019] =8'b01011010;
           rom[ 0+2020] =8'b10000011;
           rom[ 0+2021] =8'b11110110;
           rom[ 0+2022] =8'b01101001;
           rom[ 0+2023] =8'b00011100;
           rom[ 0+2024] =8'b01001010;
           rom[ 0+2025] =8'b00111111;
           rom[ 0+2026] =8'b10100000;
           rom[ 0+2027] =8'b11010101;
           rom[ 0+2028] =8'b00001111;
           rom[ 0+2029] =8'b01111010;
           rom[ 0+2030] =8'b11100101;
           rom[ 0+2031] =8'b10010000;
           rom[ 0+2032] =8'b11000110;
           rom[ 0+2033] =8'b10110011;
           rom[ 0+2034] =8'b00101100;
           rom[ 0+2035] =8'b01011001;
           rom[ 0+2036] =8'b10000000;
           rom[ 0+2037] =8'b11110101;
           rom[ 0+2038] =8'b01101010;
           rom[ 0+2039] =8'b00011111;
           rom[ 0+2040] =8'b01001001;
           rom[ 0+2041] =8'b00111100;
           rom[ 0+2042] =8'b10100011;
           rom[ 0+2043] =8'b11010110;
           rom[ 0+2044] =8'b00001010;
           rom[ 0+2045] =8'b01111111;
           rom[ 0+2046] =8'b11100000;
           rom[ 0+2047] =8'b10010101;
           rom[ 0+2048] =8'b11000011;
           rom[ 0+2049] =8'b10110110;
           rom[ 0+2050] =8'b00101001;
           rom[ 0+2051] =8'b01011100;
           rom[ 0+2052] =8'b10000101;
           rom[ 0+2053] =8'b11110000;
           rom[ 0+2054] =8'b01101111;
           rom[ 0+2055] =8'b00011010;
           rom[ 0+2056] =8'b01001100;
           rom[ 0+2057] =8'b00111001;
           rom[ 0+2058] =8'b10100110;
           rom[ 0+2059] =8'b11010011;
           rom[ 0+2060] =8'b00001001;
           rom[ 0+2061] =8'b01111100;
           rom[ 0+2062] =8'b11100011;
           rom[ 0+2063] =8'b10010110;
           rom[ 0+2064] =8'b11000000;
           rom[ 0+2065] =8'b10110101;
           rom[ 0+2066] =8'b00101010;
           rom[ 0+2067] =8'b01011111;
           rom[ 0+2068] =8'b10000110;
           rom[ 0+2069] =8'b11110011;
           rom[ 0+2070] =8'b01101100;
           rom[ 0+2071] =8'b00011001;
           rom[ 0+2072] =8'b01001111;
           rom[ 0+2073] =8'b00111010;
           rom[ 0+2074] =8'b10100101;
           rom[ 0+2075] =8'b11010000;
           rom[ 0+2076] =8'b00011000;
           rom[ 0+2077] =8'b01101101;
           rom[ 0+2078] =8'b11110010;
           rom[ 0+2079] =8'b10000111;
           rom[ 0+2080] =8'b11010001;
           rom[ 0+2081] =8'b10100100;
           rom[ 0+2082] =8'b00111011;
           rom[ 0+2083] =8'b01001110;
           rom[ 0+2084] =8'b10010111;
           rom[ 0+2085] =8'b11100010;
           rom[ 0+2086] =8'b01111101;
           rom[ 0+2087] =8'b00001000;
           rom[ 0+2088] =8'b01011110;
           rom[ 0+2089] =8'b00101011;
           rom[ 0+2090] =8'b10110100;
           rom[ 0+2091] =8'b11000001;
           rom[ 0+2092] =8'b00011011;
           rom[ 0+2093] =8'b01101110;
           rom[ 0+2094] =8'b11110001;
           rom[ 0+2095] =8'b10000100;
           rom[ 0+2096] =8'b11010010;
           rom[ 0+2097] =8'b10100111;
           rom[ 0+2098] =8'b00111000;
           rom[ 0+2099] =8'b01001101;
           rom[ 0+2100] =8'b10010100;
           rom[ 0+2101] =8'b11100001;
           rom[ 0+2102] =8'b01111110;
           rom[ 0+2103] =8'b00001011;
           rom[ 0+2104] =8'b01011101;
           rom[ 0+2105] =8'b00101000;
           rom[ 0+2106] =8'b10110111;
           rom[ 0+2107] =8'b11000010;
           rom[ 0+2108] =8'b00011110;
           rom[ 0+2109] =8'b01101011;
           rom[ 0+2110] =8'b11110100;
           rom[ 0+2111] =8'b10000001;
           rom[ 0+2112] =8'b11010111;
           rom[ 0+2113] =8'b10100010;
           rom[ 0+2114] =8'b00111101;
           rom[ 0+2115] =8'b01001000;
           rom[ 0+2116] =8'b10010001;
           rom[ 0+2117] =8'b11100100;
           rom[ 0+2118] =8'b01111011;
           rom[ 0+2119] =8'b00001110;
           rom[ 0+2120] =8'b01011000;
           rom[ 0+2121] =8'b00101101;
           rom[ 0+2122] =8'b10110010;
           rom[ 0+2123] =8'b11000111;
           rom[ 0+2124] =8'b00011101;
           rom[ 0+2125] =8'b01101000;
           rom[ 0+2126] =8'b11110111;
           rom[ 0+2127] =8'b10000010;
           rom[ 0+2128] =8'b11010100;
           rom[ 0+2129] =8'b10100001;
           rom[ 0+2130] =8'b00111110;
           rom[ 0+2131] =8'b01001011;
           rom[ 0+2132] =8'b10010010;
           rom[ 0+2133] =8'b11100111;
           rom[ 0+2134] =8'b01111000;
           rom[ 0+2135] =8'b00001101;
           rom[ 0+2136] =8'b01011011;
           rom[ 0+2137] =8'b00101110;
           rom[ 0+2138] =8'b10110001;
           rom[ 0+2139] =8'b11000100;
           rom[ 0+2140] =8'b00010100;
           rom[ 0+2141] =8'b01100001;
           rom[ 0+2142] =8'b11111110;
           rom[ 0+2143] =8'b10001011;
           rom[ 0+2144] =8'b11011101;
           rom[ 0+2145] =8'b10101000;
           rom[ 0+2146] =8'b00110111;
           rom[ 0+2147] =8'b01000010;
           rom[ 0+2148] =8'b10011011;
           rom[ 0+2149] =8'b11101110;
           rom[ 0+2150] =8'b01110001;
           rom[ 0+2151] =8'b00000100;
           rom[ 0+2152] =8'b01010010;
           rom[ 0+2153] =8'b00100111;
           rom[ 0+2154] =8'b10111000;
           rom[ 0+2155] =8'b11001101;
           rom[ 0+2156] =8'b00010111;
           rom[ 0+2157] =8'b01100010;
           rom[ 0+2158] =8'b11111101;
           rom[ 0+2159] =8'b10001000;
           rom[ 0+2160] =8'b11011110;
           rom[ 0+2161] =8'b10101011;
           rom[ 0+2162] =8'b00110100;
           rom[ 0+2163] =8'b01000001;
           rom[ 0+2164] =8'b10011000;
           rom[ 0+2165] =8'b11101101;
           rom[ 0+2166] =8'b01110010;
           rom[ 0+2167] =8'b00000111;
           rom[ 0+2168] =8'b01010001;
           rom[ 0+2169] =8'b00100100;
           rom[ 0+2170] =8'b10111011;
           rom[ 0+2171] =8'b11001110;
           rom[ 0+2172] =8'b00010010;
           rom[ 0+2173] =8'b01100111;
           rom[ 0+2174] =8'b11111000;
           rom[ 0+2175] =8'b10001101;
           rom[ 0+2176] =8'b11011011;
           rom[ 0+2177] =8'b10101110;
           rom[ 0+2178] =8'b00110001;
           rom[ 0+2179] =8'b01000100;
           rom[ 0+2180] =8'b10011101;
           rom[ 0+2181] =8'b11101000;
           rom[ 0+2182] =8'b01110111;
           rom[ 0+2183] =8'b00000010;
           rom[ 0+2184] =8'b01010100;
           rom[ 0+2185] =8'b00100001;
           rom[ 0+2186] =8'b10111110;
           rom[ 0+2187] =8'b11001011;
           rom[ 0+2188] =8'b00010001;
           rom[ 0+2189] =8'b01100100;
           rom[ 0+2190] =8'b11111011;
           rom[ 0+2191] =8'b10001110;
           rom[ 0+2192] =8'b11011000;
           rom[ 0+2193] =8'b10101101;
           rom[ 0+2194] =8'b00110010;
           rom[ 0+2195] =8'b01000111;
           rom[ 0+2196] =8'b10011110;
           rom[ 0+2197] =8'b11101011;
           rom[ 0+2198] =8'b01110100;
           rom[ 0+2199] =8'b00000001;
           rom[ 0+2200] =8'b01010111;
           rom[ 0+2201] =8'b00100010;
           rom[ 0+2202] =8'b10111101;
           rom[ 0+2203] =8'b11001000;
           rom[ 0+2204] =8'b00000000;
           rom[ 0+2205] =8'b01000100;
           rom[ 0+2206] =8'b10001000;
           rom[ 0+2207] =8'b11001100;
           rom[ 0+2208] =8'b00001101;
           rom[ 0+2209] =8'b01001001;
           rom[ 0+2210] =8'b10000101;
           rom[ 0+2211] =8'b11000001;
           rom[ 0+2212] =8'b00011010;
           rom[ 0+2213] =8'b01011110;
           rom[ 0+2214] =8'b10010010;
           rom[ 0+2215] =8'b11010110;
           rom[ 0+2216] =8'b00010111;
           rom[ 0+2217] =8'b01010011;
           rom[ 0+2218] =8'b10011111;
           rom[ 0+2219] =8'b11011011;
           rom[ 0+2220] =8'b00110100;
           rom[ 0+2221] =8'b01110000;
           rom[ 0+2222] =8'b10111100;
           rom[ 0+2223] =8'b11111000;
           rom[ 0+2224] =8'b00111001;
           rom[ 0+2225] =8'b01111101;
           rom[ 0+2226] =8'b10110001;
           rom[ 0+2227] =8'b11110101;
           rom[ 0+2228] =8'b00101110;
           rom[ 0+2229] =8'b01101010;
           rom[ 0+2230] =8'b10100110;
           rom[ 0+2231] =8'b11100010;
           rom[ 0+2232] =8'b00100011;
           rom[ 0+2233] =8'b01100111;
           rom[ 0+2234] =8'b10101011;
           rom[ 0+2235] =8'b11101111;
           rom[ 0+2236] =8'b01101000;
           rom[ 0+2237] =8'b00101100;
           rom[ 0+2238] =8'b11100000;
           rom[ 0+2239] =8'b10100100;
           rom[ 0+2240] =8'b01100101;
           rom[ 0+2241] =8'b00100001;
           rom[ 0+2242] =8'b11101101;
           rom[ 0+2243] =8'b10101001;
           rom[ 0+2244] =8'b01110010;
           rom[ 0+2245] =8'b00110110;
           rom[ 0+2246] =8'b11111010;
           rom[ 0+2247] =8'b10111110;
           rom[ 0+2248] =8'b01111111;
           rom[ 0+2249] =8'b00111011;
           rom[ 0+2250] =8'b11110111;
           rom[ 0+2251] =8'b10110011;
           rom[ 0+2252] =8'b01011100;
           rom[ 0+2253] =8'b00011000;
           rom[ 0+2254] =8'b11010100;
           rom[ 0+2255] =8'b10010000;
           rom[ 0+2256] =8'b01010001;
           rom[ 0+2257] =8'b00010101;
           rom[ 0+2258] =8'b11011001;
           rom[ 0+2259] =8'b10011101;
           rom[ 0+2260] =8'b01000110;
           rom[ 0+2261] =8'b00000010;
           rom[ 0+2262] =8'b11001110;
           rom[ 0+2263] =8'b10001010;
           rom[ 0+2264] =8'b01001011;
           rom[ 0+2265] =8'b00001111;
           rom[ 0+2266] =8'b11000011;
           rom[ 0+2267] =8'b10000111;
           rom[ 0+2268] =8'b11010000;
           rom[ 0+2269] =8'b10010100;
           rom[ 0+2270] =8'b01011000;
           rom[ 0+2271] =8'b00011100;
           rom[ 0+2272] =8'b11011101;
           rom[ 0+2273] =8'b10011001;
           rom[ 0+2274] =8'b01010101;
           rom[ 0+2275] =8'b00010001;
           rom[ 0+2276] =8'b11001010;
           rom[ 0+2277] =8'b10001110;
           rom[ 0+2278] =8'b01000010;
           rom[ 0+2279] =8'b00000110;
           rom[ 0+2280] =8'b11000111;
           rom[ 0+2281] =8'b10000011;
           rom[ 0+2282] =8'b01001111;
           rom[ 0+2283] =8'b00001011;
           rom[ 0+2284] =8'b11100100;
           rom[ 0+2285] =8'b10100000;
           rom[ 0+2286] =8'b01101100;
           rom[ 0+2287] =8'b00101000;
           rom[ 0+2288] =8'b11101001;
           rom[ 0+2289] =8'b10101101;
           rom[ 0+2290] =8'b01100001;
           rom[ 0+2291] =8'b00100101;
           rom[ 0+2292] =8'b11111110;
           rom[ 0+2293] =8'b10111010;
           rom[ 0+2294] =8'b01110110;
           rom[ 0+2295] =8'b00110010;
           rom[ 0+2296] =8'b11110011;
           rom[ 0+2297] =8'b10110111;
           rom[ 0+2298] =8'b01111011;
           rom[ 0+2299] =8'b00111111;
           rom[ 0+2300] =8'b10111000;
           rom[ 0+2301] =8'b11111100;
           rom[ 0+2302] =8'b00110000;
           rom[ 0+2303] =8'b01110100;
           rom[ 0+2304] =8'b10110101;
           rom[ 0+2305] =8'b11110001;
           rom[ 0+2306] =8'b00111101;
           rom[ 0+2307] =8'b01111001;
           rom[ 0+2308] =8'b10100010;
           rom[ 0+2309] =8'b11100110;
           rom[ 0+2310] =8'b00101010;
           rom[ 0+2311] =8'b01101110;
           rom[ 0+2312] =8'b10101111;
           rom[ 0+2313] =8'b11101011;
           rom[ 0+2314] =8'b00100111;
           rom[ 0+2315] =8'b01100011;
           rom[ 0+2316] =8'b10001100;
           rom[ 0+2317] =8'b11001000;
           rom[ 0+2318] =8'b00000100;
           rom[ 0+2319] =8'b01000000;
           rom[ 0+2320] =8'b10000001;
           rom[ 0+2321] =8'b11000101;
           rom[ 0+2322] =8'b00001001;
           rom[ 0+2323] =8'b01001101;
           rom[ 0+2324] =8'b10010110;
           rom[ 0+2325] =8'b11010010;
           rom[ 0+2326] =8'b00011110;
           rom[ 0+2327] =8'b01011010;
           rom[ 0+2328] =8'b10011011;
           rom[ 0+2329] =8'b11011111;
           rom[ 0+2330] =8'b00010011;
           rom[ 0+2331] =8'b01010111;
           rom[ 0+2332] =8'b10111101;
           rom[ 0+2333] =8'b11111001;
           rom[ 0+2334] =8'b00110101;
           rom[ 0+2335] =8'b01110001;
           rom[ 0+2336] =8'b10110000;
           rom[ 0+2337] =8'b11110100;
           rom[ 0+2338] =8'b00111000;
           rom[ 0+2339] =8'b01111100;
           rom[ 0+2340] =8'b10100111;
           rom[ 0+2341] =8'b11100011;
           rom[ 0+2342] =8'b00101111;
           rom[ 0+2343] =8'b01101011;
           rom[ 0+2344] =8'b10101010;
           rom[ 0+2345] =8'b11101110;
           rom[ 0+2346] =8'b00100010;
           rom[ 0+2347] =8'b01100110;
           rom[ 0+2348] =8'b10001001;
           rom[ 0+2349] =8'b11001101;
           rom[ 0+2350] =8'b00000001;
           rom[ 0+2351] =8'b01000101;
           rom[ 0+2352] =8'b10000100;
           rom[ 0+2353] =8'b11000000;
           rom[ 0+2354] =8'b00001100;
           rom[ 0+2355] =8'b01001000;
           rom[ 0+2356] =8'b10010011;
           rom[ 0+2357] =8'b11010111;
           rom[ 0+2358] =8'b00011011;
           rom[ 0+2359] =8'b01011111;
           rom[ 0+2360] =8'b10011110;
           rom[ 0+2361] =8'b11011010;
           rom[ 0+2362] =8'b00010110;
           rom[ 0+2363] =8'b01010010;
           rom[ 0+2364] =8'b11010101;
           rom[ 0+2365] =8'b10010001;
           rom[ 0+2366] =8'b01011101;
           rom[ 0+2367] =8'b00011001;
           rom[ 0+2368] =8'b11011000;
           rom[ 0+2369] =8'b10011100;
           rom[ 0+2370] =8'b01010000;
           rom[ 0+2371] =8'b00010100;
           rom[ 0+2372] =8'b11001111;
           rom[ 0+2373] =8'b10001011;
           rom[ 0+2374] =8'b01000111;
           rom[ 0+2375] =8'b00000011;
           rom[ 0+2376] =8'b11000010;
           rom[ 0+2377] =8'b10000110;
           rom[ 0+2378] =8'b01001010;
           rom[ 0+2379] =8'b00001110;
           rom[ 0+2380] =8'b11100001;
           rom[ 0+2381] =8'b10100101;
           rom[ 0+2382] =8'b01101001;
           rom[ 0+2383] =8'b00101101;
           rom[ 0+2384] =8'b11101100;
           rom[ 0+2385] =8'b10101000;
           rom[ 0+2386] =8'b01100100;
           rom[ 0+2387] =8'b00100000;
           rom[ 0+2388] =8'b11111011;
           rom[ 0+2389] =8'b10111111;
           rom[ 0+2390] =8'b01110011;
           rom[ 0+2391] =8'b00110111;
           rom[ 0+2392] =8'b11110110;
           rom[ 0+2393] =8'b10110010;
           rom[ 0+2394] =8'b01111110;
           rom[ 0+2395] =8'b00111010;
           rom[ 0+2396] =8'b01101101;
           rom[ 0+2397] =8'b00101001;
           rom[ 0+2398] =8'b11100101;
           rom[ 0+2399] =8'b10100001;
           rom[ 0+2400] =8'b01100000;
           rom[ 0+2401] =8'b00100100;
           rom[ 0+2402] =8'b11101000;
           rom[ 0+2403] =8'b10101100;
           rom[ 0+2404] =8'b01110111;
           rom[ 0+2405] =8'b00110011;
           rom[ 0+2406] =8'b11111111;
           rom[ 0+2407] =8'b10111011;
           rom[ 0+2408] =8'b01111010;
           rom[ 0+2409] =8'b00111110;
           rom[ 0+2410] =8'b11110010;
           rom[ 0+2411] =8'b10110110;
           rom[ 0+2412] =8'b01011001;
           rom[ 0+2413] =8'b00011101;
           rom[ 0+2414] =8'b11010001;
           rom[ 0+2415] =8'b10010101;
           rom[ 0+2416] =8'b01010100;
           rom[ 0+2417] =8'b00010000;
           rom[ 0+2418] =8'b11011100;
           rom[ 0+2419] =8'b10011000;
           rom[ 0+2420] =8'b01000011;
           rom[ 0+2421] =8'b00000111;
           rom[ 0+2422] =8'b11001011;
           rom[ 0+2423] =8'b10001111;
           rom[ 0+2424] =8'b01001110;
           rom[ 0+2425] =8'b00001010;
           rom[ 0+2426] =8'b11000110;
           rom[ 0+2427] =8'b10000010;
           rom[ 0+2428] =8'b00000101;
           rom[ 0+2429] =8'b01000001;
           rom[ 0+2430] =8'b10001101;
           rom[ 0+2431] =8'b11001001;
           rom[ 0+2432] =8'b00001000;
           rom[ 0+2433] =8'b01001100;
           rom[ 0+2434] =8'b10000000;
           rom[ 0+2435] =8'b11000100;
           rom[ 0+2436] =8'b00011111;
           rom[ 0+2437] =8'b01011011;
           rom[ 0+2438] =8'b10010111;
           rom[ 0+2439] =8'b11010011;
           rom[ 0+2440] =8'b00010010;
           rom[ 0+2441] =8'b01010110;
           rom[ 0+2442] =8'b10011010;
           rom[ 0+2443] =8'b11011110;
           rom[ 0+2444] =8'b00110001;
           rom[ 0+2445] =8'b01110101;
           rom[ 0+2446] =8'b10111001;
           rom[ 0+2447] =8'b11111101;
           rom[ 0+2448] =8'b00111100;
           rom[ 0+2449] =8'b01111000;
           rom[ 0+2450] =8'b10110100;
           rom[ 0+2451] =8'b11110000;
           rom[ 0+2452] =8'b00101011;
           rom[ 0+2453] =8'b01101111;
           rom[ 0+2454] =8'b10100011;
           rom[ 0+2455] =8'b11100111;
           rom[ 0+2456] =8'b00100110;
           rom[ 0+2457] =8'b01100010;
           rom[ 0+2458] =8'b10101110;
           rom[ 0+2459] =8'b11101010;
           rom[ 0+2460] =8'b00000000;
           rom[ 0+2461] =8'b00001011;
           rom[ 0+2462] =8'b00010110;
           rom[ 0+2463] =8'b00011101;
           rom[ 0+2464] =8'b00101100;
           rom[ 0+2465] =8'b00100111;
           rom[ 0+2466] =8'b00111010;
           rom[ 0+2467] =8'b00110001;
           rom[ 0+2468] =8'b01011000;
           rom[ 0+2469] =8'b01010011;
           rom[ 0+2470] =8'b01001110;
           rom[ 0+2471] =8'b01000101;
           rom[ 0+2472] =8'b01110100;
           rom[ 0+2473] =8'b01111111;
           rom[ 0+2474] =8'b01100010;
           rom[ 0+2475] =8'b01101001;
           rom[ 0+2476] =8'b10110000;
           rom[ 0+2477] =8'b10111011;
           rom[ 0+2478] =8'b10100110;
           rom[ 0+2479] =8'b10101101;
           rom[ 0+2480] =8'b10011100;
           rom[ 0+2481] =8'b10010111;
           rom[ 0+2482] =8'b10001010;
           rom[ 0+2483] =8'b10000001;
           rom[ 0+2484] =8'b11101000;
           rom[ 0+2485] =8'b11100011;
           rom[ 0+2486] =8'b11111110;
           rom[ 0+2487] =8'b11110101;
           rom[ 0+2488] =8'b11000100;
           rom[ 0+2489] =8'b11001111;
           rom[ 0+2490] =8'b11010010;
           rom[ 0+2491] =8'b11011001;
           rom[ 0+2492] =8'b01111101;
           rom[ 0+2493] =8'b01110110;
           rom[ 0+2494] =8'b01101011;
           rom[ 0+2495] =8'b01100000;
           rom[ 0+2496] =8'b01010001;
           rom[ 0+2497] =8'b01011010;
           rom[ 0+2498] =8'b01000111;
           rom[ 0+2499] =8'b01001100;
           rom[ 0+2500] =8'b00100101;
           rom[ 0+2501] =8'b00101110;
           rom[ 0+2502] =8'b00110011;
           rom[ 0+2503] =8'b00111000;
           rom[ 0+2504] =8'b00001001;
           rom[ 0+2505] =8'b00000010;
           rom[ 0+2506] =8'b00011111;
           rom[ 0+2507] =8'b00010100;
           rom[ 0+2508] =8'b11001101;
           rom[ 0+2509] =8'b11000110;
           rom[ 0+2510] =8'b11011011;
           rom[ 0+2511] =8'b11010000;
           rom[ 0+2512] =8'b11100001;
           rom[ 0+2513] =8'b11101010;
           rom[ 0+2514] =8'b11110111;
           rom[ 0+2515] =8'b11111100;
           rom[ 0+2516] =8'b10010101;
           rom[ 0+2517] =8'b10011110;
           rom[ 0+2518] =8'b10000011;
           rom[ 0+2519] =8'b10001000;
           rom[ 0+2520] =8'b10111001;
           rom[ 0+2521] =8'b10110010;
           rom[ 0+2522] =8'b10101111;
           rom[ 0+2523] =8'b10100100;
           rom[ 0+2524] =8'b11111010;
           rom[ 0+2525] =8'b11110001;
           rom[ 0+2526] =8'b11101100;
           rom[ 0+2527] =8'b11100111;
           rom[ 0+2528] =8'b11010110;
           rom[ 0+2529] =8'b11011101;
           rom[ 0+2530] =8'b11000000;
           rom[ 0+2531] =8'b11001011;
           rom[ 0+2532] =8'b10100010;
           rom[ 0+2533] =8'b10101001;
           rom[ 0+2534] =8'b10110100;
           rom[ 0+2535] =8'b10111111;
           rom[ 0+2536] =8'b10001110;
           rom[ 0+2537] =8'b10000101;
           rom[ 0+2538] =8'b10011000;
           rom[ 0+2539] =8'b10010011;
           rom[ 0+2540] =8'b01001010;
           rom[ 0+2541] =8'b01000001;
           rom[ 0+2542] =8'b01011100;
           rom[ 0+2543] =8'b01010111;
           rom[ 0+2544] =8'b01100110;
           rom[ 0+2545] =8'b01101101;
           rom[ 0+2546] =8'b01110000;
           rom[ 0+2547] =8'b01111011;
           rom[ 0+2548] =8'b00010010;
           rom[ 0+2549] =8'b00011001;
           rom[ 0+2550] =8'b00000100;
           rom[ 0+2551] =8'b00001111;
           rom[ 0+2552] =8'b00111110;
           rom[ 0+2553] =8'b00110101;
           rom[ 0+2554] =8'b00101000;
           rom[ 0+2555] =8'b00100011;
           rom[ 0+2556] =8'b10000111;
           rom[ 0+2557] =8'b10001100;
           rom[ 0+2558] =8'b10010001;
           rom[ 0+2559] =8'b10011010;
           rom[ 0+2560] =8'b10101011;
           rom[ 0+2561] =8'b10100000;
           rom[ 0+2562] =8'b10111101;
           rom[ 0+2563] =8'b10110110;
           rom[ 0+2564] =8'b11011111;
           rom[ 0+2565] =8'b11010100;
           rom[ 0+2566] =8'b11001001;
           rom[ 0+2567] =8'b11000010;
           rom[ 0+2568] =8'b11110011;
           rom[ 0+2569] =8'b11111000;
           rom[ 0+2570] =8'b11100101;
           rom[ 0+2571] =8'b11101110;
           rom[ 0+2572] =8'b00110111;
           rom[ 0+2573] =8'b00111100;
           rom[ 0+2574] =8'b00100001;
           rom[ 0+2575] =8'b00101010;
           rom[ 0+2576] =8'b00011011;
           rom[ 0+2577] =8'b00010000;
           rom[ 0+2578] =8'b00001101;
           rom[ 0+2579] =8'b00000110;
           rom[ 0+2580] =8'b01101111;
           rom[ 0+2581] =8'b01100100;
           rom[ 0+2582] =8'b01111001;
           rom[ 0+2583] =8'b01110010;
           rom[ 0+2584] =8'b01000011;
           rom[ 0+2585] =8'b01001000;
           rom[ 0+2586] =8'b01010101;
           rom[ 0+2587] =8'b01011110;
           rom[ 0+2588] =8'b11101001;
           rom[ 0+2589] =8'b11100010;
           rom[ 0+2590] =8'b11111111;
           rom[ 0+2591] =8'b11110100;
           rom[ 0+2592] =8'b11000101;
           rom[ 0+2593] =8'b11001110;
           rom[ 0+2594] =8'b11010011;
           rom[ 0+2595] =8'b11011000;
           rom[ 0+2596] =8'b10110001;
           rom[ 0+2597] =8'b10111010;
           rom[ 0+2598] =8'b10100111;
           rom[ 0+2599] =8'b10101100;
           rom[ 0+2600] =8'b10011101;
           rom[ 0+2601] =8'b10010110;
           rom[ 0+2602] =8'b10001011;
           rom[ 0+2603] =8'b10000000;
           rom[ 0+2604] =8'b01011001;
           rom[ 0+2605] =8'b01010010;
           rom[ 0+2606] =8'b01001111;
           rom[ 0+2607] =8'b01000100;
           rom[ 0+2608] =8'b01110101;
           rom[ 0+2609] =8'b01111110;
           rom[ 0+2610] =8'b01100011;
           rom[ 0+2611] =8'b01101000;
           rom[ 0+2612] =8'b00000001;
           rom[ 0+2613] =8'b00001010;
           rom[ 0+2614] =8'b00010111;
           rom[ 0+2615] =8'b00011100;
           rom[ 0+2616] =8'b00101101;
           rom[ 0+2617] =8'b00100110;
           rom[ 0+2618] =8'b00111011;
           rom[ 0+2619] =8'b00110000;
           rom[ 0+2620] =8'b10010100;
           rom[ 0+2621] =8'b10011111;
           rom[ 0+2622] =8'b10000010;
           rom[ 0+2623] =8'b10001001;
           rom[ 0+2624] =8'b10111000;
           rom[ 0+2625] =8'b10110011;
           rom[ 0+2626] =8'b10101110;
           rom[ 0+2627] =8'b10100101;
           rom[ 0+2628] =8'b11001100;
           rom[ 0+2629] =8'b11000111;
           rom[ 0+2630] =8'b11011010;
           rom[ 0+2631] =8'b11010001;
           rom[ 0+2632] =8'b11100000;
           rom[ 0+2633] =8'b11101011;
           rom[ 0+2634] =8'b11110110;
           rom[ 0+2635] =8'b11111101;
           rom[ 0+2636] =8'b00100100;
           rom[ 0+2637] =8'b00101111;
           rom[ 0+2638] =8'b00110010;
           rom[ 0+2639] =8'b00111001;
           rom[ 0+2640] =8'b00001000;
           rom[ 0+2641] =8'b00000011;
           rom[ 0+2642] =8'b00011110;
           rom[ 0+2643] =8'b00010101;
           rom[ 0+2644] =8'b01111100;
           rom[ 0+2645] =8'b01110111;
           rom[ 0+2646] =8'b01101010;
           rom[ 0+2647] =8'b01100001;
           rom[ 0+2648] =8'b01010000;
           rom[ 0+2649] =8'b01011011;
           rom[ 0+2650] =8'b01000110;
           rom[ 0+2651] =8'b01001101;
           rom[ 0+2652] =8'b00010011;
           rom[ 0+2653] =8'b00011000;
           rom[ 0+2654] =8'b00000101;
           rom[ 0+2655] =8'b00001110;
           rom[ 0+2656] =8'b00111111;
           rom[ 0+2657] =8'b00110100;
           rom[ 0+2658] =8'b00101001;
           rom[ 0+2659] =8'b00100010;
           rom[ 0+2660] =8'b01001011;
           rom[ 0+2661] =8'b01000000;
           rom[ 0+2662] =8'b01011101;
           rom[ 0+2663] =8'b01010110;
           rom[ 0+2664] =8'b01100111;
           rom[ 0+2665] =8'b01101100;
           rom[ 0+2666] =8'b01110001;
           rom[ 0+2667] =8'b01111010;
           rom[ 0+2668] =8'b10100011;
           rom[ 0+2669] =8'b10101000;
           rom[ 0+2670] =8'b10110101;
           rom[ 0+2671] =8'b10111110;
           rom[ 0+2672] =8'b10001111;
           rom[ 0+2673] =8'b10000100;
           rom[ 0+2674] =8'b10011001;
           rom[ 0+2675] =8'b10010010;
           rom[ 0+2676] =8'b11111011;
           rom[ 0+2677] =8'b11110000;
           rom[ 0+2678] =8'b11101101;
           rom[ 0+2679] =8'b11100110;
           rom[ 0+2680] =8'b11010111;
           rom[ 0+2681] =8'b11011100;
           rom[ 0+2682] =8'b11000001;
           rom[ 0+2683] =8'b11001010;
           rom[ 0+2684] =8'b01101110;
           rom[ 0+2685] =8'b01100101;
           rom[ 0+2686] =8'b01111000;
           rom[ 0+2687] =8'b01110011;
           rom[ 0+2688] =8'b01000010;
           rom[ 0+2689] =8'b01001001;
           rom[ 0+2690] =8'b01010100;
           rom[ 0+2691] =8'b01011111;
           rom[ 0+2692] =8'b00110110;
           rom[ 0+2693] =8'b00111101;
           rom[ 0+2694] =8'b00100000;
           rom[ 0+2695] =8'b00101011;
           rom[ 0+2696] =8'b00011010;
           rom[ 0+2697] =8'b00010001;
           rom[ 0+2698] =8'b00001100;
           rom[ 0+2699] =8'b00000111;
           rom[ 0+2700] =8'b11011110;
           rom[ 0+2701] =8'b11010101;
           rom[ 0+2702] =8'b11001000;
           rom[ 0+2703] =8'b11000011;
           rom[ 0+2704] =8'b11110010;
           rom[ 0+2705] =8'b11111001;
           rom[ 0+2706] =8'b11100100;
           rom[ 0+2707] =8'b11101111;
           rom[ 0+2708] =8'b10000110;
           rom[ 0+2709] =8'b10001101;
           rom[ 0+2710] =8'b10010000;
           rom[ 0+2711] =8'b10011011;
           rom[ 0+2712] =8'b10101010;
           rom[ 0+2713] =8'b10100001;
           rom[ 0+2714] =8'b10111100;
           rom[ 0+2715] =8'b10110111;
           rom[ 0+2716] =8'b00000000;
           rom[ 0+2717] =8'b10100100;
           rom[ 0+2718] =8'b01010101;
           rom[ 0+2719] =8'b11110001;
           rom[ 0+2720] =8'b10101010;
           rom[ 0+2721] =8'b00001110;
           rom[ 0+2722] =8'b11111111;
           rom[ 0+2723] =8'b01011011;
           rom[ 0+2724] =8'b01001001;
           rom[ 0+2725] =8'b11101101;
           rom[ 0+2726] =8'b00011100;
           rom[ 0+2727] =8'b10111000;
           rom[ 0+2728] =8'b11100011;
           rom[ 0+2729] =8'b01000111;
           rom[ 0+2730] =8'b10110110;
           rom[ 0+2731] =8'b00010010;
           rom[ 0+2732] =8'b10010010;
           rom[ 0+2733] =8'b00110110;
           rom[ 0+2734] =8'b11000111;
           rom[ 0+2735] =8'b01100011;
           rom[ 0+2736] =8'b00111000;
           rom[ 0+2737] =8'b10011100;
           rom[ 0+2738] =8'b01101101;
           rom[ 0+2739] =8'b11001001;
           rom[ 0+2740] =8'b11011011;
           rom[ 0+2741] =8'b01111111;
           rom[ 0+2742] =8'b10001110;
           rom[ 0+2743] =8'b00101010;
           rom[ 0+2744] =8'b01110001;
           rom[ 0+2745] =8'b11010101;
           rom[ 0+2746] =8'b00100100;
           rom[ 0+2747] =8'b10000000;
           rom[ 0+2748] =8'b00111001;
           rom[ 0+2749] =8'b10011101;
           rom[ 0+2750] =8'b01101100;
           rom[ 0+2751] =8'b11001000;
           rom[ 0+2752] =8'b10010011;
           rom[ 0+2753] =8'b00110111;
           rom[ 0+2754] =8'b11000110;
           rom[ 0+2755] =8'b01100010;
           rom[ 0+2756] =8'b01110000;
           rom[ 0+2757] =8'b11010100;
           rom[ 0+2758] =8'b00100101;
           rom[ 0+2759] =8'b10000001;
           rom[ 0+2760] =8'b11011010;
           rom[ 0+2761] =8'b01111110;
           rom[ 0+2762] =8'b10001111;
           rom[ 0+2763] =8'b00101011;
           rom[ 0+2764] =8'b10101011;
           rom[ 0+2765] =8'b00001111;
           rom[ 0+2766] =8'b11111110;
           rom[ 0+2767] =8'b01011010;
           rom[ 0+2768] =8'b00000001;
           rom[ 0+2769] =8'b10100101;
           rom[ 0+2770] =8'b01010100;
           rom[ 0+2771] =8'b11110000;
           rom[ 0+2772] =8'b11100010;
           rom[ 0+2773] =8'b01000110;
           rom[ 0+2774] =8'b10110111;
           rom[ 0+2775] =8'b00010011;
           rom[ 0+2776] =8'b01001000;
           rom[ 0+2777] =8'b11101100;
           rom[ 0+2778] =8'b00011101;
           rom[ 0+2779] =8'b10111001;
           rom[ 0+2780] =8'b01110010;
           rom[ 0+2781] =8'b11010110;
           rom[ 0+2782] =8'b00100111;
           rom[ 0+2783] =8'b10000011;
           rom[ 0+2784] =8'b11011000;
           rom[ 0+2785] =8'b01111100;
           rom[ 0+2786] =8'b10001101;
           rom[ 0+2787] =8'b00101001;
           rom[ 0+2788] =8'b00111011;
           rom[ 0+2789] =8'b10011111;
           rom[ 0+2790] =8'b01101110;
           rom[ 0+2791] =8'b11001010;
           rom[ 0+2792] =8'b10010001;
           rom[ 0+2793] =8'b00110101;
           rom[ 0+2794] =8'b11000100;
           rom[ 0+2795] =8'b01100000;
           rom[ 0+2796] =8'b11100000;
           rom[ 0+2797] =8'b01000100;
           rom[ 0+2798] =8'b10110101;
           rom[ 0+2799] =8'b00010001;
           rom[ 0+2800] =8'b01001010;
           rom[ 0+2801] =8'b11101110;
           rom[ 0+2802] =8'b00011111;
           rom[ 0+2803] =8'b10111011;
           rom[ 0+2804] =8'b10101001;
           rom[ 0+2805] =8'b00001101;
           rom[ 0+2806] =8'b11111100;
           rom[ 0+2807] =8'b01011000;
           rom[ 0+2808] =8'b00000011;
           rom[ 0+2809] =8'b10100111;
           rom[ 0+2810] =8'b01010110;
           rom[ 0+2811] =8'b11110010;
           rom[ 0+2812] =8'b01001011;
           rom[ 0+2813] =8'b11101111;
           rom[ 0+2814] =8'b00011110;
           rom[ 0+2815] =8'b10111010;
           rom[ 0+2816] =8'b11100001;
           rom[ 0+2817] =8'b01000101;
           rom[ 0+2818] =8'b10110100;
           rom[ 0+2819] =8'b00010000;
           rom[ 0+2820] =8'b00000010;
           rom[ 0+2821] =8'b10100110;
           rom[ 0+2822] =8'b01010111;
           rom[ 0+2823] =8'b11110011;
           rom[ 0+2824] =8'b10101000;
           rom[ 0+2825] =8'b00001100;
           rom[ 0+2826] =8'b11111101;
           rom[ 0+2827] =8'b01011001;
           rom[ 0+2828] =8'b11011001;
           rom[ 0+2829] =8'b01111101;
           rom[ 0+2830] =8'b10001100;
           rom[ 0+2831] =8'b00101000;
           rom[ 0+2832] =8'b01110011;
           rom[ 0+2833] =8'b11010111;
           rom[ 0+2834] =8'b00100110;
           rom[ 0+2835] =8'b10000010;
           rom[ 0+2836] =8'b10010000;
           rom[ 0+2837] =8'b00110100;
           rom[ 0+2838] =8'b11000101;
           rom[ 0+2839] =8'b01100001;
           rom[ 0+2840] =8'b00111010;
           rom[ 0+2841] =8'b10011110;
           rom[ 0+2842] =8'b01101111;
           rom[ 0+2843] =8'b11001011;
           rom[ 0+2844] =8'b11100100;
           rom[ 0+2845] =8'b01000000;
           rom[ 0+2846] =8'b10110001;
           rom[ 0+2847] =8'b00010101;
           rom[ 0+2848] =8'b01001110;
           rom[ 0+2849] =8'b11101010;
           rom[ 0+2850] =8'b00011011;
           rom[ 0+2851] =8'b10111111;
           rom[ 0+2852] =8'b10101101;
           rom[ 0+2853] =8'b00001001;
           rom[ 0+2854] =8'b11111000;
           rom[ 0+2855] =8'b01011100;
           rom[ 0+2856] =8'b00000111;
           rom[ 0+2857] =8'b10100011;
           rom[ 0+2858] =8'b01010010;
           rom[ 0+2859] =8'b11110110;
           rom[ 0+2860] =8'b01110110;
           rom[ 0+2861] =8'b11010010;
           rom[ 0+2862] =8'b00100011;
           rom[ 0+2863] =8'b10000111;
           rom[ 0+2864] =8'b11011100;
           rom[ 0+2865] =8'b01111000;
           rom[ 0+2866] =8'b10001001;
           rom[ 0+2867] =8'b00101101;
           rom[ 0+2868] =8'b00111111;
           rom[ 0+2869] =8'b10011011;
           rom[ 0+2870] =8'b01101010;
           rom[ 0+2871] =8'b11001110;
           rom[ 0+2872] =8'b10010101;
           rom[ 0+2873] =8'b00110001;
           rom[ 0+2874] =8'b11000000;
           rom[ 0+2875] =8'b01100100;
           rom[ 0+2876] =8'b11011101;
           rom[ 0+2877] =8'b01111001;
           rom[ 0+2878] =8'b10001000;
           rom[ 0+2879] =8'b00101100;
           rom[ 0+2880] =8'b01110111;
           rom[ 0+2881] =8'b11010011;
           rom[ 0+2882] =8'b00100010;
           rom[ 0+2883] =8'b10000110;
           rom[ 0+2884] =8'b10010100;
           rom[ 0+2885] =8'b00110000;
           rom[ 0+2886] =8'b11000001;
           rom[ 0+2887] =8'b01100101;
           rom[ 0+2888] =8'b00111110;
           rom[ 0+2889] =8'b10011010;
           rom[ 0+2890] =8'b01101011;
           rom[ 0+2891] =8'b11001111;
           rom[ 0+2892] =8'b01001111;
           rom[ 0+2893] =8'b11101011;
           rom[ 0+2894] =8'b00011010;
           rom[ 0+2895] =8'b10111110;
           rom[ 0+2896] =8'b11100101;
           rom[ 0+2897] =8'b01000001;
           rom[ 0+2898] =8'b10110000;
           rom[ 0+2899] =8'b00010100;
           rom[ 0+2900] =8'b00000110;
           rom[ 0+2901] =8'b10100010;
           rom[ 0+2902] =8'b01010011;
           rom[ 0+2903] =8'b11110111;
           rom[ 0+2904] =8'b10101100;
           rom[ 0+2905] =8'b00001000;
           rom[ 0+2906] =8'b11111001;
           rom[ 0+2907] =8'b01011101;
           rom[ 0+2908] =8'b10010110;
           rom[ 0+2909] =8'b00110010;
           rom[ 0+2910] =8'b11000011;
           rom[ 0+2911] =8'b01100111;
           rom[ 0+2912] =8'b00111100;
           rom[ 0+2913] =8'b10011000;
           rom[ 0+2914] =8'b01101001;
           rom[ 0+2915] =8'b11001101;
           rom[ 0+2916] =8'b11011111;
           rom[ 0+2917] =8'b01111011;
           rom[ 0+2918] =8'b10001010;
           rom[ 0+2919] =8'b00101110;
           rom[ 0+2920] =8'b01110101;
           rom[ 0+2921] =8'b11010001;
           rom[ 0+2922] =8'b00100000;
           rom[ 0+2923] =8'b10000100;
           rom[ 0+2924] =8'b00000100;
           rom[ 0+2925] =8'b10100000;
           rom[ 0+2926] =8'b01010001;
           rom[ 0+2927] =8'b11110101;
           rom[ 0+2928] =8'b10101110;
           rom[ 0+2929] =8'b00001010;
           rom[ 0+2930] =8'b11111011;
           rom[ 0+2931] =8'b01011111;
           rom[ 0+2932] =8'b01001101;
           rom[ 0+2933] =8'b11101001;
           rom[ 0+2934] =8'b00011000;
           rom[ 0+2935] =8'b10111100;
           rom[ 0+2936] =8'b11100111;
           rom[ 0+2937] =8'b01000011;
           rom[ 0+2938] =8'b10110010;
           rom[ 0+2939] =8'b00010110;
           rom[ 0+2940] =8'b10101111;
           rom[ 0+2941] =8'b00001011;
           rom[ 0+2942] =8'b11111010;
           rom[ 0+2943] =8'b01011110;
           rom[ 0+2944] =8'b00000101;
           rom[ 0+2945] =8'b10100001;
           rom[ 0+2946] =8'b01010000;
           rom[ 0+2947] =8'b11110100;
           rom[ 0+2948] =8'b11100110;
           rom[ 0+2949] =8'b01000010;
           rom[ 0+2950] =8'b10110011;
           rom[ 0+2951] =8'b00010111;
           rom[ 0+2952] =8'b01001100;
           rom[ 0+2953] =8'b11101000;
           rom[ 0+2954] =8'b00011001;
           rom[ 0+2955] =8'b10111101;
           rom[ 0+2956] =8'b00111101;
           rom[ 0+2957] =8'b10011001;
           rom[ 0+2958] =8'b01101000;
           rom[ 0+2959] =8'b11001100;
           rom[ 0+2960] =8'b10010111;
           rom[ 0+2961] =8'b00110011;
           rom[ 0+2962] =8'b11000010;
           rom[ 0+2963] =8'b01100110;
           rom[ 0+2964] =8'b01110100;
           rom[ 0+2965] =8'b11010000;
           rom[ 0+2966] =8'b00100001;
           rom[ 0+2967] =8'b10000101;
           rom[ 0+2968] =8'b11011110;
           rom[ 0+2969] =8'b01111010;
           rom[ 0+2970] =8'b10001011;
           rom[ 0+2971] =8'b00101111;
           rom[ 0+2972] =8'b00000000;
           rom[ 0+2973] =8'b10011010;
           rom[ 0+2974] =8'b00101001;
           rom[ 0+2975] =8'b10110011;
           rom[ 0+2976] =8'b01010010;
           rom[ 0+2977] =8'b11001000;
           rom[ 0+2978] =8'b01111011;
           rom[ 0+2979] =8'b11100001;
           rom[ 0+2980] =8'b10100100;
           rom[ 0+2981] =8'b00111110;
           rom[ 0+2982] =8'b10001101;
           rom[ 0+2983] =8'b00010111;
           rom[ 0+2984] =8'b11110110;
           rom[ 0+2985] =8'b01101100;
           rom[ 0+2986] =8'b11011111;
           rom[ 0+2987] =8'b01000101;
           rom[ 0+2988] =8'b01010101;
           rom[ 0+2989] =8'b11001111;
           rom[ 0+2990] =8'b01111100;
           rom[ 0+2991] =8'b11100110;
           rom[ 0+2992] =8'b00000111;
           rom[ 0+2993] =8'b10011101;
           rom[ 0+2994] =8'b00101110;
           rom[ 0+2995] =8'b10110100;
           rom[ 0+2996] =8'b11110001;
           rom[ 0+2997] =8'b01101011;
           rom[ 0+2998] =8'b11011000;
           rom[ 0+2999] =8'b01000010;
           rom[ 0+3000] =8'b10100011;
           rom[ 0+3001] =8'b00111001;
           rom[ 0+3002] =8'b10001010;
           rom[ 0+3003] =8'b00010000;
           rom[ 0+3004] =8'b10101010;
           rom[ 0+3005] =8'b00110000;
           rom[ 0+3006] =8'b10000011;
           rom[ 0+3007] =8'b00011001;
           rom[ 0+3008] =8'b11111000;
           rom[ 0+3009] =8'b01100010;
           rom[ 0+3010] =8'b11010001;
           rom[ 0+3011] =8'b01001011;
           rom[ 0+3012] =8'b00001110;
           rom[ 0+3013] =8'b10010100;
           rom[ 0+3014] =8'b00100111;
           rom[ 0+3015] =8'b10111101;
           rom[ 0+3016] =8'b01011100;
           rom[ 0+3017] =8'b11000110;
           rom[ 0+3018] =8'b01110101;
           rom[ 0+3019] =8'b11101111;
           rom[ 0+3020] =8'b11111111;
           rom[ 0+3021] =8'b01100101;
           rom[ 0+3022] =8'b11010110;
           rom[ 0+3023] =8'b01001100;
           rom[ 0+3024] =8'b10101101;
           rom[ 0+3025] =8'b00110111;
           rom[ 0+3026] =8'b10000100;
           rom[ 0+3027] =8'b00011110;
           rom[ 0+3028] =8'b01011011;
           rom[ 0+3029] =8'b11000001;
           rom[ 0+3030] =8'b01110010;
           rom[ 0+3031] =8'b11101000;
           rom[ 0+3032] =8'b00001001;
           rom[ 0+3033] =8'b10010011;
           rom[ 0+3034] =8'b00100000;
           rom[ 0+3035] =8'b10111010;
           rom[ 0+3036] =8'b01001001;
           rom[ 0+3037] =8'b11010011;
           rom[ 0+3038] =8'b01100000;
           rom[ 0+3039] =8'b11111010;
           rom[ 0+3040] =8'b00011011;
           rom[ 0+3041] =8'b10000001;
           rom[ 0+3042] =8'b00110010;
           rom[ 0+3043] =8'b10101000;
           rom[ 0+3044] =8'b11101101;
           rom[ 0+3045] =8'b01110111;
           rom[ 0+3046] =8'b11000100;
           rom[ 0+3047] =8'b01011110;
           rom[ 0+3048] =8'b10111111;
           rom[ 0+3049] =8'b00100101;
           rom[ 0+3050] =8'b10010110;
           rom[ 0+3051] =8'b00001100;
           rom[ 0+3052] =8'b00011100;
           rom[ 0+3053] =8'b10000110;
           rom[ 0+3054] =8'b00110101;
           rom[ 0+3055] =8'b10101111;
           rom[ 0+3056] =8'b01001110;
           rom[ 0+3057] =8'b11010100;
           rom[ 0+3058] =8'b01100111;
           rom[ 0+3059] =8'b11111101;
           rom[ 0+3060] =8'b10111000;
           rom[ 0+3061] =8'b00100010;
           rom[ 0+3062] =8'b10010001;
           rom[ 0+3063] =8'b00001011;
           rom[ 0+3064] =8'b11101010;
           rom[ 0+3065] =8'b01110000;
           rom[ 0+3066] =8'b11000011;
           rom[ 0+3067] =8'b01011001;
           rom[ 0+3068] =8'b11100011;
           rom[ 0+3069] =8'b01111001;
           rom[ 0+3070] =8'b11001010;
           rom[ 0+3071] =8'b01010000;
           rom[ 0+3072] =8'b10110001;
           rom[ 0+3073] =8'b00101011;
           rom[ 0+3074] =8'b10011000;
           rom[ 0+3075] =8'b00000010;
           rom[ 0+3076] =8'b01000111;
           rom[ 0+3077] =8'b11011101;
           rom[ 0+3078] =8'b01101110;
           rom[ 0+3079] =8'b11110100;
           rom[ 0+3080] =8'b00010101;
           rom[ 0+3081] =8'b10001111;
           rom[ 0+3082] =8'b00111100;
           rom[ 0+3083] =8'b10100110;
           rom[ 0+3084] =8'b10110110;
           rom[ 0+3085] =8'b00101100;
           rom[ 0+3086] =8'b10011111;
           rom[ 0+3087] =8'b00000101;
           rom[ 0+3088] =8'b11100100;
           rom[ 0+3089] =8'b01111110;
           rom[ 0+3090] =8'b11001101;
           rom[ 0+3091] =8'b01010111;
           rom[ 0+3092] =8'b00010010;
           rom[ 0+3093] =8'b10001000;
           rom[ 0+3094] =8'b00111011;
           rom[ 0+3095] =8'b10100001;
           rom[ 0+3096] =8'b01000000;
           rom[ 0+3097] =8'b11011010;
           rom[ 0+3098] =8'b01101001;
           rom[ 0+3099] =8'b11110011;
           rom[ 0+3100] =8'b10010010;
           rom[ 0+3101] =8'b00001000;
           rom[ 0+3102] =8'b10111011;
           rom[ 0+3103] =8'b00100001;
           rom[ 0+3104] =8'b11000000;
           rom[ 0+3105] =8'b01011010;
           rom[ 0+3106] =8'b11101001;
           rom[ 0+3107] =8'b01110011;
           rom[ 0+3108] =8'b00110110;
           rom[ 0+3109] =8'b10101100;
           rom[ 0+3110] =8'b00011111;
           rom[ 0+3111] =8'b10000101;
           rom[ 0+3112] =8'b01100100;
           rom[ 0+3113] =8'b11111110;
           rom[ 0+3114] =8'b01001101;
           rom[ 0+3115] =8'b11010111;
           rom[ 0+3116] =8'b11000111;
           rom[ 0+3117] =8'b01011101;
           rom[ 0+3118] =8'b11101110;
           rom[ 0+3119] =8'b01110100;
           rom[ 0+3120] =8'b10010101;
           rom[ 0+3121] =8'b00001111;
           rom[ 0+3122] =8'b10111100;
           rom[ 0+3123] =8'b00100110;
           rom[ 0+3124] =8'b01100011;
           rom[ 0+3125] =8'b11111001;
           rom[ 0+3126] =8'b01001010;
           rom[ 0+3127] =8'b11010000;
           rom[ 0+3128] =8'b00110001;
           rom[ 0+3129] =8'b10101011;
           rom[ 0+3130] =8'b00011000;
           rom[ 0+3131] =8'b10000010;
           rom[ 0+3132] =8'b00111000;
           rom[ 0+3133] =8'b10100010;
           rom[ 0+3134] =8'b00010001;
           rom[ 0+3135] =8'b10001011;
           rom[ 0+3136] =8'b01101010;
           rom[ 0+3137] =8'b11110000;
           rom[ 0+3138] =8'b01000011;
           rom[ 0+3139] =8'b11011001;
           rom[ 0+3140] =8'b10011100;
           rom[ 0+3141] =8'b00000110;
           rom[ 0+3142] =8'b10110101;
           rom[ 0+3143] =8'b00101111;
           rom[ 0+3144] =8'b11001110;
           rom[ 0+3145] =8'b01010100;
           rom[ 0+3146] =8'b11100111;
           rom[ 0+3147] =8'b01111101;
           rom[ 0+3148] =8'b01101101;
           rom[ 0+3149] =8'b11110111;
           rom[ 0+3150] =8'b01000100;
           rom[ 0+3151] =8'b11011110;
           rom[ 0+3152] =8'b00111111;
           rom[ 0+3153] =8'b10100101;
           rom[ 0+3154] =8'b00010110;
           rom[ 0+3155] =8'b10001100;
           rom[ 0+3156] =8'b11001001;
           rom[ 0+3157] =8'b01010011;
           rom[ 0+3158] =8'b11100000;
           rom[ 0+3159] =8'b01111010;
           rom[ 0+3160] =8'b10011011;
           rom[ 0+3161] =8'b00000001;
           rom[ 0+3162] =8'b10110010;
           rom[ 0+3163] =8'b00101000;
           rom[ 0+3164] =8'b11011011;
           rom[ 0+3165] =8'b01000001;
           rom[ 0+3166] =8'b11110010;
           rom[ 0+3167] =8'b01101000;
           rom[ 0+3168] =8'b10001001;
           rom[ 0+3169] =8'b00010011;
           rom[ 0+3170] =8'b10100000;
           rom[ 0+3171] =8'b00111010;
           rom[ 0+3172] =8'b01111111;
           rom[ 0+3173] =8'b11100101;
           rom[ 0+3174] =8'b01010110;
           rom[ 0+3175] =8'b11001100;
           rom[ 0+3176] =8'b00101101;
           rom[ 0+3177] =8'b10110111;
           rom[ 0+3178] =8'b00000100;
           rom[ 0+3179] =8'b10011110;
           rom[ 0+3180] =8'b10001110;
           rom[ 0+3181] =8'b00010100;
           rom[ 0+3182] =8'b10100111;
           rom[ 0+3183] =8'b00111101;
           rom[ 0+3184] =8'b11011100;
           rom[ 0+3185] =8'b01000110;
           rom[ 0+3186] =8'b11110101;
           rom[ 0+3187] =8'b01101111;
           rom[ 0+3188] =8'b00101010;
           rom[ 0+3189] =8'b10110000;
           rom[ 0+3190] =8'b00000011;
           rom[ 0+3191] =8'b10011001;
           rom[ 0+3192] =8'b01111000;
           rom[ 0+3193] =8'b11100010;
           rom[ 0+3194] =8'b01010001;
           rom[ 0+3195] =8'b11001011;
           rom[ 0+3196] =8'b01110001;
           rom[ 0+3197] =8'b11101011;
           rom[ 0+3198] =8'b01011000;
           rom[ 0+3199] =8'b11000010;
           rom[ 0+3200] =8'b00100011;
           rom[ 0+3201] =8'b10111001;
           rom[ 0+3202] =8'b00001010;
           rom[ 0+3203] =8'b10010000;
           rom[ 0+3204] =8'b11010101;
           rom[ 0+3205] =8'b01001111;
           rom[ 0+3206] =8'b11111100;
           rom[ 0+3207] =8'b01100110;
           rom[ 0+3208] =8'b10000111;
           rom[ 0+3209] =8'b00011101;
           rom[ 0+3210] =8'b10101110;
           rom[ 0+3211] =8'b00110100;
           rom[ 0+3212] =8'b00100100;
           rom[ 0+3213] =8'b10111110;
           rom[ 0+3214] =8'b00001101;
           rom[ 0+3215] =8'b10010111;
           rom[ 0+3216] =8'b01110110;
           rom[ 0+3217] =8'b11101100;
           rom[ 0+3218] =8'b01011111;
           rom[ 0+3219] =8'b11000101;
           rom[ 0+3220] =8'b10000000;
           rom[ 0+3221] =8'b00011010;
           rom[ 0+3222] =8'b10101001;
           rom[ 0+3223] =8'b00110011;
           rom[ 0+3224] =8'b11010010;
           rom[ 0+3225] =8'b01001000;
           rom[ 0+3226] =8'b11111011;
           rom[ 0+3227] =8'b01100001;
           rom[ 0+3228] =8'b00000000;
           rom[ 0+3229] =8'b01111010;
           rom[ 0+3230] =8'b11110100;
           rom[ 0+3231] =8'b10001110;
           rom[ 0+3232] =8'b11110101;
           rom[ 0+3233] =8'b10001111;
           rom[ 0+3234] =8'b00000001;
           rom[ 0+3235] =8'b01111011;
           rom[ 0+3236] =8'b11110111;
           rom[ 0+3237] =8'b10001101;
           rom[ 0+3238] =8'b00000011;
           rom[ 0+3239] =8'b01111001;
           rom[ 0+3240] =8'b00000010;
           rom[ 0+3241] =8'b01111000;
           rom[ 0+3242] =8'b11110110;
           rom[ 0+3243] =8'b10001100;
           rom[ 0+3244] =8'b11110011;
           rom[ 0+3245] =8'b10001001;
           rom[ 0+3246] =8'b00000111;
           rom[ 0+3247] =8'b01111101;
           rom[ 0+3248] =8'b00000110;
           rom[ 0+3249] =8'b01111100;
           rom[ 0+3250] =8'b11110010;
           rom[ 0+3251] =8'b10001000;
           rom[ 0+3252] =8'b00000100;
           rom[ 0+3253] =8'b01111110;
           rom[ 0+3254] =8'b11110000;
           rom[ 0+3255] =8'b10001010;
           rom[ 0+3256] =8'b11110001;
           rom[ 0+3257] =8'b10001011;
           rom[ 0+3258] =8'b00000101;
           rom[ 0+3259] =8'b01111111;
           rom[ 0+3260] =8'b11111011;
           rom[ 0+3261] =8'b10000001;
           rom[ 0+3262] =8'b00001111;
           rom[ 0+3263] =8'b01110101;
           rom[ 0+3264] =8'b00001110;
           rom[ 0+3265] =8'b01110100;
           rom[ 0+3266] =8'b11111010;
           rom[ 0+3267] =8'b10000000;
           rom[ 0+3268] =8'b00001100;
           rom[ 0+3269] =8'b01110110;
           rom[ 0+3270] =8'b11111000;
           rom[ 0+3271] =8'b10000010;
           rom[ 0+3272] =8'b11111001;
           rom[ 0+3273] =8'b10000011;
           rom[ 0+3274] =8'b00001101;
           rom[ 0+3275] =8'b01110111;
           rom[ 0+3276] =8'b00001000;
           rom[ 0+3277] =8'b01110010;
           rom[ 0+3278] =8'b11111100;
           rom[ 0+3279] =8'b10000110;
           rom[ 0+3280] =8'b11111101;
           rom[ 0+3281] =8'b10000111;
           rom[ 0+3282] =8'b00001001;
           rom[ 0+3283] =8'b01110011;
           rom[ 0+3284] =8'b11111111;
           rom[ 0+3285] =8'b10000101;
           rom[ 0+3286] =8'b00001011;
           rom[ 0+3287] =8'b01110001;
           rom[ 0+3288] =8'b00001010;
           rom[ 0+3289] =8'b01110000;
           rom[ 0+3290] =8'b11111110;
           rom[ 0+3291] =8'b10000100;
           rom[ 0+3292] =8'b11101011;
           rom[ 0+3293] =8'b10010001;
           rom[ 0+3294] =8'b00011111;
           rom[ 0+3295] =8'b01100101;
           rom[ 0+3296] =8'b00011110;
           rom[ 0+3297] =8'b01100100;
           rom[ 0+3298] =8'b11101010;
           rom[ 0+3299] =8'b10010000;
           rom[ 0+3300] =8'b00011100;
           rom[ 0+3301] =8'b01100110;
           rom[ 0+3302] =8'b11101000;
           rom[ 0+3303] =8'b10010010;
           rom[ 0+3304] =8'b11101001;
           rom[ 0+3305] =8'b10010011;
           rom[ 0+3306] =8'b00011101;
           rom[ 0+3307] =8'b01100111;
           rom[ 0+3308] =8'b00011000;
           rom[ 0+3309] =8'b01100010;
           rom[ 0+3310] =8'b11101100;
           rom[ 0+3311] =8'b10010110;
           rom[ 0+3312] =8'b11101101;
           rom[ 0+3313] =8'b10010111;
           rom[ 0+3314] =8'b00011001;
           rom[ 0+3315] =8'b01100011;
           rom[ 0+3316] =8'b11101111;
           rom[ 0+3317] =8'b10010101;
           rom[ 0+3318] =8'b00011011;
           rom[ 0+3319] =8'b01100001;
           rom[ 0+3320] =8'b00011010;
           rom[ 0+3321] =8'b01100000;
           rom[ 0+3322] =8'b11101110;
           rom[ 0+3323] =8'b10010100;
           rom[ 0+3324] =8'b00010000;
           rom[ 0+3325] =8'b01101010;
           rom[ 0+3326] =8'b11100100;
           rom[ 0+3327] =8'b10011110;
           rom[ 0+3328] =8'b11100101;
           rom[ 0+3329] =8'b10011111;
           rom[ 0+3330] =8'b00010001;
           rom[ 0+3331] =8'b01101011;
           rom[ 0+3332] =8'b11100111;
           rom[ 0+3333] =8'b10011101;
           rom[ 0+3334] =8'b00010011;
           rom[ 0+3335] =8'b01101001;
           rom[ 0+3336] =8'b00010010;
           rom[ 0+3337] =8'b01101000;
           rom[ 0+3338] =8'b11100110;
           rom[ 0+3339] =8'b10011100;
           rom[ 0+3340] =8'b11100011;
           rom[ 0+3341] =8'b10011001;
           rom[ 0+3342] =8'b00010111;
           rom[ 0+3343] =8'b01101101;
           rom[ 0+3344] =8'b00010110;
           rom[ 0+3345] =8'b01101100;
           rom[ 0+3346] =8'b11100010;
           rom[ 0+3347] =8'b10011000;
           rom[ 0+3348] =8'b00010100;
           rom[ 0+3349] =8'b01101110;
           rom[ 0+3350] =8'b11100000;
           rom[ 0+3351] =8'b10011010;
           rom[ 0+3352] =8'b11100001;
           rom[ 0+3353] =8'b10011011;
           rom[ 0+3354] =8'b00010101;
           rom[ 0+3355] =8'b01101111;
           rom[ 0+3356] =8'b11001011;
           rom[ 0+3357] =8'b10110001;
           rom[ 0+3358] =8'b00111111;
           rom[ 0+3359] =8'b01000101;
           rom[ 0+3360] =8'b00111110;
           rom[ 0+3361] =8'b01000100;
           rom[ 0+3362] =8'b11001010;
           rom[ 0+3363] =8'b10110000;
           rom[ 0+3364] =8'b00111100;
           rom[ 0+3365] =8'b01000110;
           rom[ 0+3366] =8'b11001000;
           rom[ 0+3367] =8'b10110010;
           rom[ 0+3368] =8'b11001001;
           rom[ 0+3369] =8'b10110011;
           rom[ 0+3370] =8'b00111101;
           rom[ 0+3371] =8'b01000111;
           rom[ 0+3372] =8'b00111000;
           rom[ 0+3373] =8'b01000010;
           rom[ 0+3374] =8'b11001100;
           rom[ 0+3375] =8'b10110110;
           rom[ 0+3376] =8'b11001101;
           rom[ 0+3377] =8'b10110111;
           rom[ 0+3378] =8'b00111001;
           rom[ 0+3379] =8'b01000011;
           rom[ 0+3380] =8'b11001111;
           rom[ 0+3381] =8'b10110101;
           rom[ 0+3382] =8'b00111011;
           rom[ 0+3383] =8'b01000001;
           rom[ 0+3384] =8'b00111010;
           rom[ 0+3385] =8'b01000000;
           rom[ 0+3386] =8'b11001110;
           rom[ 0+3387] =8'b10110100;
           rom[ 0+3388] =8'b00110000;
           rom[ 0+3389] =8'b01001010;
           rom[ 0+3390] =8'b11000100;
           rom[ 0+3391] =8'b10111110;
           rom[ 0+3392] =8'b11000101;
           rom[ 0+3393] =8'b10111111;
           rom[ 0+3394] =8'b00110001;
           rom[ 0+3395] =8'b01001011;
           rom[ 0+3396] =8'b11000111;
           rom[ 0+3397] =8'b10111101;
           rom[ 0+3398] =8'b00110011;
           rom[ 0+3399] =8'b01001001;
           rom[ 0+3400] =8'b00110010;
           rom[ 0+3401] =8'b01001000;
           rom[ 0+3402] =8'b11000110;
           rom[ 0+3403] =8'b10111100;
           rom[ 0+3404] =8'b11000011;
           rom[ 0+3405] =8'b10111001;
           rom[ 0+3406] =8'b00110111;
           rom[ 0+3407] =8'b01001101;
           rom[ 0+3408] =8'b00110110;
           rom[ 0+3409] =8'b01001100;
           rom[ 0+3410] =8'b11000010;
           rom[ 0+3411] =8'b10111000;
           rom[ 0+3412] =8'b00110100;
           rom[ 0+3413] =8'b01001110;
           rom[ 0+3414] =8'b11000000;
           rom[ 0+3415] =8'b10111010;
           rom[ 0+3416] =8'b11000001;
           rom[ 0+3417] =8'b10111011;
           rom[ 0+3418] =8'b00110101;
           rom[ 0+3419] =8'b01001111;
           rom[ 0+3420] =8'b00100000;
           rom[ 0+3421] =8'b01011010;
           rom[ 0+3422] =8'b11010100;
           rom[ 0+3423] =8'b10101110;
           rom[ 0+3424] =8'b11010101;
           rom[ 0+3425] =8'b10101111;
           rom[ 0+3426] =8'b00100001;
           rom[ 0+3427] =8'b01011011;
           rom[ 0+3428] =8'b11010111;
           rom[ 0+3429] =8'b10101101;
           rom[ 0+3430] =8'b00100011;
           rom[ 0+3431] =8'b01011001;
           rom[ 0+3432] =8'b00100010;
           rom[ 0+3433] =8'b01011000;
           rom[ 0+3434] =8'b11010110;
           rom[ 0+3435] =8'b10101100;
           rom[ 0+3436] =8'b11010011;
           rom[ 0+3437] =8'b10101001;
           rom[ 0+3438] =8'b00100111;
           rom[ 0+3439] =8'b01011101;
           rom[ 0+3440] =8'b00100110;
           rom[ 0+3441] =8'b01011100;
           rom[ 0+3442] =8'b11010010;
           rom[ 0+3443] =8'b10101000;
           rom[ 0+3444] =8'b00100100;
           rom[ 0+3445] =8'b01011110;
           rom[ 0+3446] =8'b11010000;
           rom[ 0+3447] =8'b10101010;
           rom[ 0+3448] =8'b11010001;
           rom[ 0+3449] =8'b10101011;
           rom[ 0+3450] =8'b00100101;
           rom[ 0+3451] =8'b01011111;
           rom[ 0+3452] =8'b11011011;
           rom[ 0+3453] =8'b10100001;
           rom[ 0+3454] =8'b00101111;
           rom[ 0+3455] =8'b01010101;
           rom[ 0+3456] =8'b00101110;
           rom[ 0+3457] =8'b01010100;
           rom[ 0+3458] =8'b11011010;
           rom[ 0+3459] =8'b10100000;
           rom[ 0+3460] =8'b00101100;
           rom[ 0+3461] =8'b01010110;
           rom[ 0+3462] =8'b11011000;
           rom[ 0+3463] =8'b10100010;
           rom[ 0+3464] =8'b11011001;
           rom[ 0+3465] =8'b10100011;
           rom[ 0+3466] =8'b00101101;
           rom[ 0+3467] =8'b01010111;
           rom[ 0+3468] =8'b00101000;
           rom[ 0+3469] =8'b01010010;
           rom[ 0+3470] =8'b11011100;
           rom[ 0+3471] =8'b10100110;
           rom[ 0+3472] =8'b11011101;
           rom[ 0+3473] =8'b10100111;
           rom[ 0+3474] =8'b00101001;
           rom[ 0+3475] =8'b01010011;
           rom[ 0+3476] =8'b11011111;
           rom[ 0+3477] =8'b10100101;
           rom[ 0+3478] =8'b00101011;
           rom[ 0+3479] =8'b01010001;
           rom[ 0+3480] =8'b00101010;
           rom[ 0+3481] =8'b01010000;
           rom[ 0+3482] =8'b11011110;
           rom[ 0+3483] =8'b10100100;
           rom[ 0+3484] =8'b00000000;
           rom[ 0+3485] =8'b01111111;
           rom[ 0+3486] =8'b11111110;
           rom[ 0+3487] =8'b10000001;
           rom[ 0+3488] =8'b11100001;
           rom[ 0+3489] =8'b10011110;
           rom[ 0+3490] =8'b00011111;
           rom[ 0+3491] =8'b01100000;
           rom[ 0+3492] =8'b11011111;
           rom[ 0+3493] =8'b10100000;
           rom[ 0+3494] =8'b00100001;
           rom[ 0+3495] =8'b01011110;
           rom[ 0+3496] =8'b00111110;
           rom[ 0+3497] =8'b01000001;
           rom[ 0+3498] =8'b11000000;
           rom[ 0+3499] =8'b10111111;
           rom[ 0+3500] =8'b10100011;
           rom[ 0+3501] =8'b11011100;
           rom[ 0+3502] =8'b01011101;
           rom[ 0+3503] =8'b00100010;
           rom[ 0+3504] =8'b01000010;
           rom[ 0+3505] =8'b00111101;
           rom[ 0+3506] =8'b10111100;
           rom[ 0+3507] =8'b11000011;
           rom[ 0+3508] =8'b01111100;
           rom[ 0+3509] =8'b00000011;
           rom[ 0+3510] =8'b10000010;
           rom[ 0+3511] =8'b11111101;
           rom[ 0+3512] =8'b10011101;
           rom[ 0+3513] =8'b11100010;
           rom[ 0+3514] =8'b01100011;
           rom[ 0+3515] =8'b00011100;
           rom[ 0+3516] =8'b01011011;
           rom[ 0+3517] =8'b00100100;
           rom[ 0+3518] =8'b10100101;
           rom[ 0+3519] =8'b11011010;
           rom[ 0+3520] =8'b10111010;
           rom[ 0+3521] =8'b11000101;
           rom[ 0+3522] =8'b01000100;
           rom[ 0+3523] =8'b00111011;
           rom[ 0+3524] =8'b10000100;
           rom[ 0+3525] =8'b11111011;
           rom[ 0+3526] =8'b01111010;
           rom[ 0+3527] =8'b00000101;
           rom[ 0+3528] =8'b01100101;
           rom[ 0+3529] =8'b00011010;
           rom[ 0+3530] =8'b10011011;
           rom[ 0+3531] =8'b11100100;
           rom[ 0+3532] =8'b11111000;
           rom[ 0+3533] =8'b10000111;
           rom[ 0+3534] =8'b00000110;
           rom[ 0+3535] =8'b01111001;
           rom[ 0+3536] =8'b00011001;
           rom[ 0+3537] =8'b01100110;
           rom[ 0+3538] =8'b11100111;
           rom[ 0+3539] =8'b10011000;
           rom[ 0+3540] =8'b00100111;
           rom[ 0+3541] =8'b01011000;
           rom[ 0+3542] =8'b11011001;
           rom[ 0+3543] =8'b10100110;
           rom[ 0+3544] =8'b11000110;
           rom[ 0+3545] =8'b10111001;
           rom[ 0+3546] =8'b00111000;
           rom[ 0+3547] =8'b01000111;
           rom[ 0+3548] =8'b10110110;
           rom[ 0+3549] =8'b11001001;
           rom[ 0+3550] =8'b01001000;
           rom[ 0+3551] =8'b00110111;
           rom[ 0+3552] =8'b01010111;
           rom[ 0+3553] =8'b00101000;
           rom[ 0+3554] =8'b10101001;
           rom[ 0+3555] =8'b11010110;
           rom[ 0+3556] =8'b01101001;
           rom[ 0+3557] =8'b00010110;
           rom[ 0+3558] =8'b10010111;
           rom[ 0+3559] =8'b11101000;
           rom[ 0+3560] =8'b10001000;
           rom[ 0+3561] =8'b11110111;
           rom[ 0+3562] =8'b01110110;
           rom[ 0+3563] =8'b00001001;
           rom[ 0+3564] =8'b00010101;
           rom[ 0+3565] =8'b01101010;
           rom[ 0+3566] =8'b11101011;
           rom[ 0+3567] =8'b10010100;
           rom[ 0+3568] =8'b11110100;
           rom[ 0+3569] =8'b10001011;
           rom[ 0+3570] =8'b00001010;
           rom[ 0+3571] =8'b01110101;
           rom[ 0+3572] =8'b11001010;
           rom[ 0+3573] =8'b10110101;
           rom[ 0+3574] =8'b00110100;
           rom[ 0+3575] =8'b01001011;
           rom[ 0+3576] =8'b00101011;
           rom[ 0+3577] =8'b01010100;
           rom[ 0+3578] =8'b11010101;
           rom[ 0+3579] =8'b10101010;
           rom[ 0+3580] =8'b11101101;
           rom[ 0+3581] =8'b10010010;
           rom[ 0+3582] =8'b00010011;
           rom[ 0+3583] =8'b01101100;
           rom[ 0+3584] =8'b00001100;
           rom[ 0+3585] =8'b01110011;
           rom[ 0+3586] =8'b11110010;
           rom[ 0+3587] =8'b10001101;
           rom[ 0+3588] =8'b00110010;
           rom[ 0+3589] =8'b01001101;
           rom[ 0+3590] =8'b11001100;
           rom[ 0+3591] =8'b10110011;
           rom[ 0+3592] =8'b11010011;
           rom[ 0+3593] =8'b10101100;
           rom[ 0+3594] =8'b00101101;
           rom[ 0+3595] =8'b01010010;
           rom[ 0+3596] =8'b01001110;
           rom[ 0+3597] =8'b00110001;
           rom[ 0+3598] =8'b10110000;
           rom[ 0+3599] =8'b11001111;
           rom[ 0+3600] =8'b10101111;
           rom[ 0+3601] =8'b11010000;
           rom[ 0+3602] =8'b01010001;
           rom[ 0+3603] =8'b00101110;
           rom[ 0+3604] =8'b10010001;
           rom[ 0+3605] =8'b11101110;
           rom[ 0+3606] =8'b01101111;
           rom[ 0+3607] =8'b00010000;
           rom[ 0+3608] =8'b01110000;
           rom[ 0+3609] =8'b00001111;
           rom[ 0+3610] =8'b10001110;
           rom[ 0+3611] =8'b11110001;
           rom[ 0+3612] =8'b01110001;
           rom[ 0+3613] =8'b00001110;
           rom[ 0+3614] =8'b10001111;
           rom[ 0+3615] =8'b11110000;
           rom[ 0+3616] =8'b10010000;
           rom[ 0+3617] =8'b11101111;
           rom[ 0+3618] =8'b01101110;
           rom[ 0+3619] =8'b00010001;
           rom[ 0+3620] =8'b10101110;
           rom[ 0+3621] =8'b11010001;
           rom[ 0+3622] =8'b01010000;
           rom[ 0+3623] =8'b00101111;
           rom[ 0+3624] =8'b01001111;
           rom[ 0+3625] =8'b00110000;
           rom[ 0+3626] =8'b10110001;
           rom[ 0+3627] =8'b11001110;
           rom[ 0+3628] =8'b11010010;
           rom[ 0+3629] =8'b10101101;
           rom[ 0+3630] =8'b00101100;
           rom[ 0+3631] =8'b01010011;
           rom[ 0+3632] =8'b00110011;
           rom[ 0+3633] =8'b01001100;
           rom[ 0+3634] =8'b11001101;
           rom[ 0+3635] =8'b10110010;
           rom[ 0+3636] =8'b00001101;
           rom[ 0+3637] =8'b01110010;
           rom[ 0+3638] =8'b11110011;
           rom[ 0+3639] =8'b10001100;
           rom[ 0+3640] =8'b11101100;
           rom[ 0+3641] =8'b10010011;
           rom[ 0+3642] =8'b00010010;
           rom[ 0+3643] =8'b01101101;
           rom[ 0+3644] =8'b00101010;
           rom[ 0+3645] =8'b01010101;
           rom[ 0+3646] =8'b11010100;
           rom[ 0+3647] =8'b10101011;
           rom[ 0+3648] =8'b11001011;
           rom[ 0+3649] =8'b10110100;
           rom[ 0+3650] =8'b00110101;
           rom[ 0+3651] =8'b01001010;
           rom[ 0+3652] =8'b11110101;
           rom[ 0+3653] =8'b10001010;
           rom[ 0+3654] =8'b00001011;
           rom[ 0+3655] =8'b01110100;
           rom[ 0+3656] =8'b00010100;
           rom[ 0+3657] =8'b01101011;
           rom[ 0+3658] =8'b11101010;
           rom[ 0+3659] =8'b10010101;
           rom[ 0+3660] =8'b10001001;
           rom[ 0+3661] =8'b11110110;
           rom[ 0+3662] =8'b01110111;
           rom[ 0+3663] =8'b00001000;
           rom[ 0+3664] =8'b01101000;
           rom[ 0+3665] =8'b00010111;
           rom[ 0+3666] =8'b10010110;
           rom[ 0+3667] =8'b11101001;
           rom[ 0+3668] =8'b01010110;
           rom[ 0+3669] =8'b00101001;
           rom[ 0+3670] =8'b10101000;
           rom[ 0+3671] =8'b11010111;
           rom[ 0+3672] =8'b10110111;
           rom[ 0+3673] =8'b11001000;
           rom[ 0+3674] =8'b01001001;
           rom[ 0+3675] =8'b00110110;
           rom[ 0+3676] =8'b11000111;
           rom[ 0+3677] =8'b10111000;
           rom[ 0+3678] =8'b00111001;
           rom[ 0+3679] =8'b01000110;
           rom[ 0+3680] =8'b00100110;
           rom[ 0+3681] =8'b01011001;
           rom[ 0+3682] =8'b11011000;
           rom[ 0+3683] =8'b10100111;
           rom[ 0+3684] =8'b00011000;
           rom[ 0+3685] =8'b01100111;
           rom[ 0+3686] =8'b11100110;
           rom[ 0+3687] =8'b10011001;
           rom[ 0+3688] =8'b11111001;
           rom[ 0+3689] =8'b10000110;
           rom[ 0+3690] =8'b00000111;
           rom[ 0+3691] =8'b01111000;
           rom[ 0+3692] =8'b01100100;
           rom[ 0+3693] =8'b00011011;
           rom[ 0+3694] =8'b10011010;
           rom[ 0+3695] =8'b11100101;
           rom[ 0+3696] =8'b10000101;
           rom[ 0+3697] =8'b11111010;
           rom[ 0+3698] =8'b01111011;
           rom[ 0+3699] =8'b00000100;
           rom[ 0+3700] =8'b10111011;
           rom[ 0+3701] =8'b11000100;
           rom[ 0+3702] =8'b01000101;
           rom[ 0+3703] =8'b00111010;
           rom[ 0+3704] =8'b01011010;
           rom[ 0+3705] =8'b00100101;
           rom[ 0+3706] =8'b10100100;
           rom[ 0+3707] =8'b11011011;
           rom[ 0+3708] =8'b10011100;
           rom[ 0+3709] =8'b11100011;
           rom[ 0+3710] =8'b01100010;
           rom[ 0+3711] =8'b00011101;
           rom[ 0+3712] =8'b01111101;
           rom[ 0+3713] =8'b00000010;
           rom[ 0+3714] =8'b10000011;
           rom[ 0+3715] =8'b11111100;
           rom[ 0+3716] =8'b01000011;
           rom[ 0+3717] =8'b00111100;
           rom[ 0+3718] =8'b10111101;
           rom[ 0+3719] =8'b11000010;
           rom[ 0+3720] =8'b10100010;
           rom[ 0+3721] =8'b11011101;
           rom[ 0+3722] =8'b01011100;
           rom[ 0+3723] =8'b00100011;
           rom[ 0+3724] =8'b00111111;
           rom[ 0+3725] =8'b01000000;
           rom[ 0+3726] =8'b11000001;
           rom[ 0+3727] =8'b10111110;
           rom[ 0+3728] =8'b11011110;
           rom[ 0+3729] =8'b10100001;
           rom[ 0+3730] =8'b00100000;
           rom[ 0+3731] =8'b01011111;
           rom[ 0+3732] =8'b11100000;
           rom[ 0+3733] =8'b10011111;
           rom[ 0+3734] =8'b00011110;
           rom[ 0+3735] =8'b01100001;
           rom[ 0+3736] =8'b00000001;
           rom[ 0+3737] =8'b01111110;
           rom[ 0+3738] =8'b11111111;
           rom[ 0+3739] =8'b10000000;
           rom[ 0+3740] =8'b00000000;
           rom[ 0+3741] =8'b00000010;
           rom[ 0+3742] =8'b00000100;
           rom[ 0+3743] =8'b00000110;
           rom[ 0+3744] =8'b00001000;
           rom[ 0+3745] =8'b00001010;
           rom[ 0+3746] =8'b00001100;
           rom[ 0+3747] =8'b00001110;
           rom[ 0+3748] =8'b00010000;
           rom[ 0+3749] =8'b00010010;
           rom[ 0+3750] =8'b00010100;
           rom[ 0+3751] =8'b00010110;
           rom[ 0+3752] =8'b00011000;
           rom[ 0+3753] =8'b00011010;
           rom[ 0+3754] =8'b00011100;
           rom[ 0+3755] =8'b00011110;
           rom[ 0+3756] =8'b00100000;
           rom[ 0+3757] =8'b00100010;
           rom[ 0+3758] =8'b00100100;
           rom[ 0+3759] =8'b00100110;
           rom[ 0+3760] =8'b00101000;
           rom[ 0+3761] =8'b00101010;
           rom[ 0+3762] =8'b00101100;
           rom[ 0+3763] =8'b00101110;
           rom[ 0+3764] =8'b00110000;
           rom[ 0+3765] =8'b00110010;
           rom[ 0+3766] =8'b00110100;
           rom[ 0+3767] =8'b00110110;
           rom[ 0+3768] =8'b00111000;
           rom[ 0+3769] =8'b00111010;
           rom[ 0+3770] =8'b00111100;
           rom[ 0+3771] =8'b00111110;
           rom[ 0+3772] =8'b01000000;
           rom[ 0+3773] =8'b01000010;
           rom[ 0+3774] =8'b01000100;
           rom[ 0+3775] =8'b01000110;
           rom[ 0+3776] =8'b01001000;
           rom[ 0+3777] =8'b01001010;
           rom[ 0+3778] =8'b01001100;
           rom[ 0+3779] =8'b01001110;
           rom[ 0+3780] =8'b01010000;
           rom[ 0+3781] =8'b01010010;
           rom[ 0+3782] =8'b01010100;
           rom[ 0+3783] =8'b01010110;
           rom[ 0+3784] =8'b01011000;
           rom[ 0+3785] =8'b01011010;
           rom[ 0+3786] =8'b01011100;
           rom[ 0+3787] =8'b01011110;
           rom[ 0+3788] =8'b01100000;
           rom[ 0+3789] =8'b01100010;
           rom[ 0+3790] =8'b01100100;
           rom[ 0+3791] =8'b01100110;
           rom[ 0+3792] =8'b01101000;
           rom[ 0+3793] =8'b01101010;
           rom[ 0+3794] =8'b01101100;
           rom[ 0+3795] =8'b01101110;
           rom[ 0+3796] =8'b01110000;
           rom[ 0+3797] =8'b01110010;
           rom[ 0+3798] =8'b01110100;
           rom[ 0+3799] =8'b01110110;
           rom[ 0+3800] =8'b01111000;
           rom[ 0+3801] =8'b01111010;
           rom[ 0+3802] =8'b01111100;
           rom[ 0+3803] =8'b01111110;
           rom[ 0+3804] =8'b10000000;
           rom[ 0+3805] =8'b10000010;
           rom[ 0+3806] =8'b10000100;
           rom[ 0+3807] =8'b10000110;
           rom[ 0+3808] =8'b10001000;
           rom[ 0+3809] =8'b10001010;
           rom[ 0+3810] =8'b10001100;
           rom[ 0+3811] =8'b10001110;
           rom[ 0+3812] =8'b10010000;
           rom[ 0+3813] =8'b10010010;
           rom[ 0+3814] =8'b10010100;
           rom[ 0+3815] =8'b10010110;
           rom[ 0+3816] =8'b10011000;
           rom[ 0+3817] =8'b10011010;
           rom[ 0+3818] =8'b10011100;
           rom[ 0+3819] =8'b10011110;
           rom[ 0+3820] =8'b10100000;
           rom[ 0+3821] =8'b10100010;
           rom[ 0+3822] =8'b10100100;
           rom[ 0+3823] =8'b10100110;
           rom[ 0+3824] =8'b10101000;
           rom[ 0+3825] =8'b10101010;
           rom[ 0+3826] =8'b10101100;
           rom[ 0+3827] =8'b10101110;
           rom[ 0+3828] =8'b10110000;
           rom[ 0+3829] =8'b10110010;
           rom[ 0+3830] =8'b10110100;
           rom[ 0+3831] =8'b10110110;
           rom[ 0+3832] =8'b10111000;
           rom[ 0+3833] =8'b10111010;
           rom[ 0+3834] =8'b10111100;
           rom[ 0+3835] =8'b10111110;
           rom[ 0+3836] =8'b11000000;
           rom[ 0+3837] =8'b11000010;
           rom[ 0+3838] =8'b11000100;
           rom[ 0+3839] =8'b11000110;
           rom[ 0+3840] =8'b11001000;
           rom[ 0+3841] =8'b11001010;
           rom[ 0+3842] =8'b11001100;
           rom[ 0+3843] =8'b11001110;
           rom[ 0+3844] =8'b11010000;
           rom[ 0+3845] =8'b11010010;
           rom[ 0+3846] =8'b11010100;
           rom[ 0+3847] =8'b11010110;
           rom[ 0+3848] =8'b11011000;
           rom[ 0+3849] =8'b11011010;
           rom[ 0+3850] =8'b11011100;
           rom[ 0+3851] =8'b11011110;
           rom[ 0+3852] =8'b11100000;
           rom[ 0+3853] =8'b11100010;
           rom[ 0+3854] =8'b11100100;
           rom[ 0+3855] =8'b11100110;
           rom[ 0+3856] =8'b11101000;
           rom[ 0+3857] =8'b11101010;
           rom[ 0+3858] =8'b11101100;
           rom[ 0+3859] =8'b11101110;
           rom[ 0+3860] =8'b11110000;
           rom[ 0+3861] =8'b11110010;
           rom[ 0+3862] =8'b11110100;
           rom[ 0+3863] =8'b11110110;
           rom[ 0+3864] =8'b11111000;
           rom[ 0+3865] =8'b11111010;
           rom[ 0+3866] =8'b11111100;
           rom[ 0+3867] =8'b11111110;
           rom[ 0+3868] =8'b00011101;
           rom[ 0+3869] =8'b00011111;
           rom[ 0+3870] =8'b00011001;
           rom[ 0+3871] =8'b00011011;
           rom[ 0+3872] =8'b00010101;
           rom[ 0+3873] =8'b00010111;
           rom[ 0+3874] =8'b00010001;
           rom[ 0+3875] =8'b00010011;
           rom[ 0+3876] =8'b00001101;
           rom[ 0+3877] =8'b00001111;
           rom[ 0+3878] =8'b00001001;
           rom[ 0+3879] =8'b00001011;
           rom[ 0+3880] =8'b00000101;
           rom[ 0+3881] =8'b00000111;
           rom[ 0+3882] =8'b00000001;
           rom[ 0+3883] =8'b00000011;
           rom[ 0+3884] =8'b00111101;
           rom[ 0+3885] =8'b00111111;
           rom[ 0+3886] =8'b00111001;
           rom[ 0+3887] =8'b00111011;
           rom[ 0+3888] =8'b00110101;
           rom[ 0+3889] =8'b00110111;
           rom[ 0+3890] =8'b00110001;
           rom[ 0+3891] =8'b00110011;
           rom[ 0+3892] =8'b00101101;
           rom[ 0+3893] =8'b00101111;
           rom[ 0+3894] =8'b00101001;
           rom[ 0+3895] =8'b00101011;
           rom[ 0+3896] =8'b00100101;
           rom[ 0+3897] =8'b00100111;
           rom[ 0+3898] =8'b00100001;
           rom[ 0+3899] =8'b00100011;
           rom[ 0+3900] =8'b01011101;
           rom[ 0+3901] =8'b01011111;
           rom[ 0+3902] =8'b01011001;
           rom[ 0+3903] =8'b01011011;
           rom[ 0+3904] =8'b01010101;
           rom[ 0+3905] =8'b01010111;
           rom[ 0+3906] =8'b01010001;
           rom[ 0+3907] =8'b01010011;
           rom[ 0+3908] =8'b01001101;
           rom[ 0+3909] =8'b01001111;
           rom[ 0+3910] =8'b01001001;
           rom[ 0+3911] =8'b01001011;
           rom[ 0+3912] =8'b01000101;
           rom[ 0+3913] =8'b01000111;
           rom[ 0+3914] =8'b01000001;
           rom[ 0+3915] =8'b01000011;
           rom[ 0+3916] =8'b01111101;
           rom[ 0+3917] =8'b01111111;
           rom[ 0+3918] =8'b01111001;
           rom[ 0+3919] =8'b01111011;
           rom[ 0+3920] =8'b01110101;
           rom[ 0+3921] =8'b01110111;
           rom[ 0+3922] =8'b01110001;
           rom[ 0+3923] =8'b01110011;
           rom[ 0+3924] =8'b01101101;
           rom[ 0+3925] =8'b01101111;
           rom[ 0+3926] =8'b01101001;
           rom[ 0+3927] =8'b01101011;
           rom[ 0+3928] =8'b01100101;
           rom[ 0+3929] =8'b01100111;
           rom[ 0+3930] =8'b01100001;
           rom[ 0+3931] =8'b01100011;
           rom[ 0+3932] =8'b10011101;
           rom[ 0+3933] =8'b10011111;
           rom[ 0+3934] =8'b10011001;
           rom[ 0+3935] =8'b10011011;
           rom[ 0+3936] =8'b10010101;
           rom[ 0+3937] =8'b10010111;
           rom[ 0+3938] =8'b10010001;
           rom[ 0+3939] =8'b10010011;
           rom[ 0+3940] =8'b10001101;
           rom[ 0+3941] =8'b10001111;
           rom[ 0+3942] =8'b10001001;
           rom[ 0+3943] =8'b10001011;
           rom[ 0+3944] =8'b10000101;
           rom[ 0+3945] =8'b10000111;
           rom[ 0+3946] =8'b10000001;
           rom[ 0+3947] =8'b10000011;
           rom[ 0+3948] =8'b10111101;
           rom[ 0+3949] =8'b10111111;
           rom[ 0+3950] =8'b10111001;
           rom[ 0+3951] =8'b10111011;
           rom[ 0+3952] =8'b10110101;
           rom[ 0+3953] =8'b10110111;
           rom[ 0+3954] =8'b10110001;
           rom[ 0+3955] =8'b10110011;
           rom[ 0+3956] =8'b10101101;
           rom[ 0+3957] =8'b10101111;
           rom[ 0+3958] =8'b10101001;
           rom[ 0+3959] =8'b10101011;
           rom[ 0+3960] =8'b10100101;
           rom[ 0+3961] =8'b10100111;
           rom[ 0+3962] =8'b10100001;
           rom[ 0+3963] =8'b10100011;
           rom[ 0+3964] =8'b11011101;
           rom[ 0+3965] =8'b11011111;
           rom[ 0+3966] =8'b11011001;
           rom[ 0+3967] =8'b11011011;
           rom[ 0+3968] =8'b11010101;
           rom[ 0+3969] =8'b11010111;
           rom[ 0+3970] =8'b11010001;
           rom[ 0+3971] =8'b11010011;
           rom[ 0+3972] =8'b11001101;
           rom[ 0+3973] =8'b11001111;
           rom[ 0+3974] =8'b11001001;
           rom[ 0+3975] =8'b11001011;
           rom[ 0+3976] =8'b11000101;
           rom[ 0+3977] =8'b11000111;
           rom[ 0+3978] =8'b11000001;
           rom[ 0+3979] =8'b11000011;
           rom[ 0+3980] =8'b11111101;
           rom[ 0+3981] =8'b11111111;
           rom[ 0+3982] =8'b11111001;
           rom[ 0+3983] =8'b11111011;
           rom[ 0+3984] =8'b11110101;
           rom[ 0+3985] =8'b11110111;
           rom[ 0+3986] =8'b11110001;
           rom[ 0+3987] =8'b11110011;
           rom[ 0+3988] =8'b11101101;
           rom[ 0+3989] =8'b11101111;
           rom[ 0+3990] =8'b11101001;
           rom[ 0+3991] =8'b11101011;
           rom[ 0+3992] =8'b11100101;
           rom[ 0+3993] =8'b11100111;
           rom[ 0+3994] =8'b11100001;
           rom[ 0+3995] =8'b11100011;
           rom[ 0+3996] =8'b00000000;
           rom[ 0+3997] =8'b00000100;
           rom[ 0+3998] =8'b00001000;
           rom[ 0+3999] =8'b00001100;
           rom[ 0+4000] =8'b00010000;
           rom[ 0+4001] =8'b00010100;
           rom[ 0+4002] =8'b00011000;
           rom[ 0+4003] =8'b00011100;
           rom[ 0+4004] =8'b00100000;
           rom[ 0+4005] =8'b00100100;
           rom[ 0+4006] =8'b00101000;
           rom[ 0+4007] =8'b00101100;
           rom[ 0+4008] =8'b00110000;
           rom[ 0+4009] =8'b00110100;
           rom[ 0+4010] =8'b00111000;
           rom[ 0+4011] =8'b00111100;
           rom[ 0+4012] =8'b01000000;
           rom[ 0+4013] =8'b01000100;
           rom[ 0+4014] =8'b01001000;
           rom[ 0+4015] =8'b01001100;
           rom[ 0+4016] =8'b01010000;
           rom[ 0+4017] =8'b01010100;
           rom[ 0+4018] =8'b01011000;
           rom[ 0+4019] =8'b01011100;
           rom[ 0+4020] =8'b01100000;
           rom[ 0+4021] =8'b01100100;
           rom[ 0+4022] =8'b01101000;
           rom[ 0+4023] =8'b01101100;
           rom[ 0+4024] =8'b01110000;
           rom[ 0+4025] =8'b01110100;
           rom[ 0+4026] =8'b01111000;
           rom[ 0+4027] =8'b01111100;
           rom[ 0+4028] =8'b10000000;
           rom[ 0+4029] =8'b10000100;
           rom[ 0+4030] =8'b10001000;
           rom[ 0+4031] =8'b10001100;
           rom[ 0+4032] =8'b10010000;
           rom[ 0+4033] =8'b10010100;
           rom[ 0+4034] =8'b10011000;
           rom[ 0+4035] =8'b10011100;
           rom[ 0+4036] =8'b10100000;
           rom[ 0+4037] =8'b10100100;
           rom[ 0+4038] =8'b10101000;
           rom[ 0+4039] =8'b10101100;
           rom[ 0+4040] =8'b10110000;
           rom[ 0+4041] =8'b10110100;
           rom[ 0+4042] =8'b10111000;
           rom[ 0+4043] =8'b10111100;
           rom[ 0+4044] =8'b11000000;
           rom[ 0+4045] =8'b11000100;
           rom[ 0+4046] =8'b11001000;
           rom[ 0+4047] =8'b11001100;
           rom[ 0+4048] =8'b11010000;
           rom[ 0+4049] =8'b11010100;
           rom[ 0+4050] =8'b11011000;
           rom[ 0+4051] =8'b11011100;
           rom[ 0+4052] =8'b11100000;
           rom[ 0+4053] =8'b11100100;
           rom[ 0+4054] =8'b11101000;
           rom[ 0+4055] =8'b11101100;
           rom[ 0+4056] =8'b11110000;
           rom[ 0+4057] =8'b11110100;
           rom[ 0+4058] =8'b11111000;
           rom[ 0+4059] =8'b11111100;
           rom[ 0+4060] =8'b00011101;
           rom[ 0+4061] =8'b00011001;
           rom[ 0+4062] =8'b00010101;
           rom[ 0+4063] =8'b00010001;
           rom[ 0+4064] =8'b00001101;
           rom[ 0+4065] =8'b00001001;
           rom[ 0+4066] =8'b00000101;
           rom[ 0+4067] =8'b00000001;
           rom[ 0+4068] =8'b00111101;
           rom[ 0+4069] =8'b00111001;
           rom[ 0+4070] =8'b00110101;
           rom[ 0+4071] =8'b00110001;
           rom[ 0+4072] =8'b00101101;
           rom[ 0+4073] =8'b00101001;
           rom[ 0+4074] =8'b00100101;
           rom[ 0+4075] =8'b00100001;
           rom[ 0+4076] =8'b01011101;
           rom[ 0+4077] =8'b01011001;
           rom[ 0+4078] =8'b01010101;
           rom[ 0+4079] =8'b01010001;
           rom[ 0+4080] =8'b01001101;
           rom[ 0+4081] =8'b01001001;
           rom[ 0+4082] =8'b01000101;
           rom[ 0+4083] =8'b01000001;
           rom[ 0+4084] =8'b01111101;
           rom[ 0+4085] =8'b01111001;
           rom[ 0+4086] =8'b01110101;
           rom[ 0+4087] =8'b01110001;
           rom[ 0+4088] =8'b01101101;
           rom[ 0+4089] =8'b01101001;
           rom[ 0+4090] =8'b01100101;
           rom[ 0+4091] =8'b01100001;
           rom[ 0+4092] =8'b10011101;
           rom[ 0+4093] =8'b10011001;
           rom[ 0+4094] =8'b10010101;
           rom[ 0+4095] =8'b10010001;
           rom[ 0+4096] =8'b10001101;
           rom[ 0+4097] =8'b10001001;
           rom[ 0+4098] =8'b10000101;
           rom[ 0+4099] =8'b10000001;
           rom[ 0+4100] =8'b10111101;
           rom[ 0+4101] =8'b10111001;
           rom[ 0+4102] =8'b10110101;
           rom[ 0+4103] =8'b10110001;
           rom[ 0+4104] =8'b10101101;
           rom[ 0+4105] =8'b10101001;
           rom[ 0+4106] =8'b10100101;
           rom[ 0+4107] =8'b10100001;
           rom[ 0+4108] =8'b11011101;
           rom[ 0+4109] =8'b11011001;
           rom[ 0+4110] =8'b11010101;
           rom[ 0+4111] =8'b11010001;
           rom[ 0+4112] =8'b11001101;
           rom[ 0+4113] =8'b11001001;
           rom[ 0+4114] =8'b11000101;
           rom[ 0+4115] =8'b11000001;
           rom[ 0+4116] =8'b11111101;
           rom[ 0+4117] =8'b11111001;
           rom[ 0+4118] =8'b11110101;
           rom[ 0+4119] =8'b11110001;
           rom[ 0+4120] =8'b11101101;
           rom[ 0+4121] =8'b11101001;
           rom[ 0+4122] =8'b11100101;
           rom[ 0+4123] =8'b11100001;
           rom[ 0+4124] =8'b00111010;
           rom[ 0+4125] =8'b00111110;
           rom[ 0+4126] =8'b00110010;
           rom[ 0+4127] =8'b00110110;
           rom[ 0+4128] =8'b00101010;
           rom[ 0+4129] =8'b00101110;
           rom[ 0+4130] =8'b00100010;
           rom[ 0+4131] =8'b00100110;
           rom[ 0+4132] =8'b00011010;
           rom[ 0+4133] =8'b00011110;
           rom[ 0+4134] =8'b00010010;
           rom[ 0+4135] =8'b00010110;
           rom[ 0+4136] =8'b00001010;
           rom[ 0+4137] =8'b00001110;
           rom[ 0+4138] =8'b00000010;
           rom[ 0+4139] =8'b00000110;
           rom[ 0+4140] =8'b01111010;
           rom[ 0+4141] =8'b01111110;
           rom[ 0+4142] =8'b01110010;
           rom[ 0+4143] =8'b01110110;
           rom[ 0+4144] =8'b01101010;
           rom[ 0+4145] =8'b01101110;
           rom[ 0+4146] =8'b01100010;
           rom[ 0+4147] =8'b01100110;
           rom[ 0+4148] =8'b01011010;
           rom[ 0+4149] =8'b01011110;
           rom[ 0+4150] =8'b01010010;
           rom[ 0+4151] =8'b01010110;
           rom[ 0+4152] =8'b01001010;
           rom[ 0+4153] =8'b01001110;
           rom[ 0+4154] =8'b01000010;
           rom[ 0+4155] =8'b01000110;
           rom[ 0+4156] =8'b10111010;
           rom[ 0+4157] =8'b10111110;
           rom[ 0+4158] =8'b10110010;
           rom[ 0+4159] =8'b10110110;
           rom[ 0+4160] =8'b10101010;
           rom[ 0+4161] =8'b10101110;
           rom[ 0+4162] =8'b10100010;
           rom[ 0+4163] =8'b10100110;
           rom[ 0+4164] =8'b10011010;
           rom[ 0+4165] =8'b10011110;
           rom[ 0+4166] =8'b10010010;
           rom[ 0+4167] =8'b10010110;
           rom[ 0+4168] =8'b10001010;
           rom[ 0+4169] =8'b10001110;
           rom[ 0+4170] =8'b10000010;
           rom[ 0+4171] =8'b10000110;
           rom[ 0+4172] =8'b11111010;
           rom[ 0+4173] =8'b11111110;
           rom[ 0+4174] =8'b11110010;
           rom[ 0+4175] =8'b11110110;
           rom[ 0+4176] =8'b11101010;
           rom[ 0+4177] =8'b11101110;
           rom[ 0+4178] =8'b11100010;
           rom[ 0+4179] =8'b11100110;
           rom[ 0+4180] =8'b11011010;
           rom[ 0+4181] =8'b11011110;
           rom[ 0+4182] =8'b11010010;
           rom[ 0+4183] =8'b11010110;
           rom[ 0+4184] =8'b11001010;
           rom[ 0+4185] =8'b11001110;
           rom[ 0+4186] =8'b11000010;
           rom[ 0+4187] =8'b11000110;
           rom[ 0+4188] =8'b00100111;
           rom[ 0+4189] =8'b00100011;
           rom[ 0+4190] =8'b00101111;
           rom[ 0+4191] =8'b00101011;
           rom[ 0+4192] =8'b00110111;
           rom[ 0+4193] =8'b00110011;
           rom[ 0+4194] =8'b00111111;
           rom[ 0+4195] =8'b00111011;
           rom[ 0+4196] =8'b00000111;
           rom[ 0+4197] =8'b00000011;
           rom[ 0+4198] =8'b00001111;
           rom[ 0+4199] =8'b00001011;
           rom[ 0+4200] =8'b00010111;
           rom[ 0+4201] =8'b00010011;
           rom[ 0+4202] =8'b00011111;
           rom[ 0+4203] =8'b00011011;
           rom[ 0+4204] =8'b01100111;
           rom[ 0+4205] =8'b01100011;
           rom[ 0+4206] =8'b01101111;
           rom[ 0+4207] =8'b01101011;
           rom[ 0+4208] =8'b01110111;
           rom[ 0+4209] =8'b01110011;
           rom[ 0+4210] =8'b01111111;
           rom[ 0+4211] =8'b01111011;
           rom[ 0+4212] =8'b01000111;
           rom[ 0+4213] =8'b01000011;
           rom[ 0+4214] =8'b01001111;
           rom[ 0+4215] =8'b01001011;
           rom[ 0+4216] =8'b01010111;
           rom[ 0+4217] =8'b01010011;
           rom[ 0+4218] =8'b01011111;
           rom[ 0+4219] =8'b01011011;
           rom[ 0+4220] =8'b10100111;
           rom[ 0+4221] =8'b10100011;
           rom[ 0+4222] =8'b10101111;
           rom[ 0+4223] =8'b10101011;
           rom[ 0+4224] =8'b10110111;
           rom[ 0+4225] =8'b10110011;
           rom[ 0+4226] =8'b10111111;
           rom[ 0+4227] =8'b10111011;
           rom[ 0+4228] =8'b10000111;
           rom[ 0+4229] =8'b10000011;
           rom[ 0+4230] =8'b10001111;
           rom[ 0+4231] =8'b10001011;
           rom[ 0+4232] =8'b10010111;
           rom[ 0+4233] =8'b10010011;
           rom[ 0+4234] =8'b10011111;
           rom[ 0+4235] =8'b10011011;
           rom[ 0+4236] =8'b11100111;
           rom[ 0+4237] =8'b11100011;
           rom[ 0+4238] =8'b11101111;
           rom[ 0+4239] =8'b11101011;
           rom[ 0+4240] =8'b11110111;
           rom[ 0+4241] =8'b11110011;
           rom[ 0+4242] =8'b11111111;
           rom[ 0+4243] =8'b11111011;
           rom[ 0+4244] =8'b11000111;
           rom[ 0+4245] =8'b11000011;
           rom[ 0+4246] =8'b11001111;
           rom[ 0+4247] =8'b11001011;
           rom[ 0+4248] =8'b11010111;
           rom[ 0+4249] =8'b11010011;
           rom[ 0+4250] =8'b11011111;
           rom[ 0+4251] =8'b11011011;
           rom[ 0+4252] =8'b00000000;
           rom[ 0+4253] =8'b00001000;
           rom[ 0+4254] =8'b00010000;
           rom[ 0+4255] =8'b00011000;
           rom[ 0+4256] =8'b00100000;
           rom[ 0+4257] =8'b00101000;
           rom[ 0+4258] =8'b00110000;
           rom[ 0+4259] =8'b00111000;
           rom[ 0+4260] =8'b01000000;
           rom[ 0+4261] =8'b01001000;
           rom[ 0+4262] =8'b01010000;
           rom[ 0+4263] =8'b01011000;
           rom[ 0+4264] =8'b01100000;
           rom[ 0+4265] =8'b01101000;
           rom[ 0+4266] =8'b01110000;
           rom[ 0+4267] =8'b01111000;
           rom[ 0+4268] =8'b10000000;
           rom[ 0+4269] =8'b10001000;
           rom[ 0+4270] =8'b10010000;
           rom[ 0+4271] =8'b10011000;
           rom[ 0+4272] =8'b10100000;
           rom[ 0+4273] =8'b10101000;
           rom[ 0+4274] =8'b10110000;
           rom[ 0+4275] =8'b10111000;
           rom[ 0+4276] =8'b11000000;
           rom[ 0+4277] =8'b11001000;
           rom[ 0+4278] =8'b11010000;
           rom[ 0+4279] =8'b11011000;
           rom[ 0+4280] =8'b11100000;
           rom[ 0+4281] =8'b11101000;
           rom[ 0+4282] =8'b11110000;
           rom[ 0+4283] =8'b11111000;
           rom[ 0+4284] =8'b00011101;
           rom[ 0+4285] =8'b00010101;
           rom[ 0+4286] =8'b00001101;
           rom[ 0+4287] =8'b00000101;
           rom[ 0+4288] =8'b00111101;
           rom[ 0+4289] =8'b00110101;
           rom[ 0+4290] =8'b00101101;
           rom[ 0+4291] =8'b00100101;
           rom[ 0+4292] =8'b01011101;
           rom[ 0+4293] =8'b01010101;
           rom[ 0+4294] =8'b01001101;
           rom[ 0+4295] =8'b01000101;
           rom[ 0+4296] =8'b01111101;
           rom[ 0+4297] =8'b01110101;
           rom[ 0+4298] =8'b01101101;
           rom[ 0+4299] =8'b01100101;
           rom[ 0+4300] =8'b10011101;
           rom[ 0+4301] =8'b10010101;
           rom[ 0+4302] =8'b10001101;
           rom[ 0+4303] =8'b10000101;
           rom[ 0+4304] =8'b10111101;
           rom[ 0+4305] =8'b10110101;
           rom[ 0+4306] =8'b10101101;
           rom[ 0+4307] =8'b10100101;
           rom[ 0+4308] =8'b11011101;
           rom[ 0+4309] =8'b11010101;
           rom[ 0+4310] =8'b11001101;
           rom[ 0+4311] =8'b11000101;
           rom[ 0+4312] =8'b11111101;
           rom[ 0+4313] =8'b11110101;
           rom[ 0+4314] =8'b11101101;
           rom[ 0+4315] =8'b11100101;
           rom[ 0+4316] =8'b00111010;
           rom[ 0+4317] =8'b00110010;
           rom[ 0+4318] =8'b00101010;
           rom[ 0+4319] =8'b00100010;
           rom[ 0+4320] =8'b00011010;
           rom[ 0+4321] =8'b00010010;
           rom[ 0+4322] =8'b00001010;
           rom[ 0+4323] =8'b00000010;
           rom[ 0+4324] =8'b01111010;
           rom[ 0+4325] =8'b01110010;
           rom[ 0+4326] =8'b01101010;
           rom[ 0+4327] =8'b01100010;
           rom[ 0+4328] =8'b01011010;
           rom[ 0+4329] =8'b01010010;
           rom[ 0+4330] =8'b01001010;
           rom[ 0+4331] =8'b01000010;
           rom[ 0+4332] =8'b10111010;
           rom[ 0+4333] =8'b10110010;
           rom[ 0+4334] =8'b10101010;
           rom[ 0+4335] =8'b10100010;
           rom[ 0+4336] =8'b10011010;
           rom[ 0+4337] =8'b10010010;
           rom[ 0+4338] =8'b10001010;
           rom[ 0+4339] =8'b10000010;
           rom[ 0+4340] =8'b11111010;
           rom[ 0+4341] =8'b11110010;
           rom[ 0+4342] =8'b11101010;
           rom[ 0+4343] =8'b11100010;
           rom[ 0+4344] =8'b11011010;
           rom[ 0+4345] =8'b11010010;
           rom[ 0+4346] =8'b11001010;
           rom[ 0+4347] =8'b11000010;
           rom[ 0+4348] =8'b00100111;
           rom[ 0+4349] =8'b00101111;
           rom[ 0+4350] =8'b00110111;
           rom[ 0+4351] =8'b00111111;
           rom[ 0+4352] =8'b00000111;
           rom[ 0+4353] =8'b00001111;
           rom[ 0+4354] =8'b00010111;
           rom[ 0+4355] =8'b00011111;
           rom[ 0+4356] =8'b01100111;
           rom[ 0+4357] =8'b01101111;
           rom[ 0+4358] =8'b01110111;
           rom[ 0+4359] =8'b01111111;
           rom[ 0+4360] =8'b01000111;
           rom[ 0+4361] =8'b01001111;
           rom[ 0+4362] =8'b01010111;
           rom[ 0+4363] =8'b01011111;
           rom[ 0+4364] =8'b10100111;
           rom[ 0+4365] =8'b10101111;
           rom[ 0+4366] =8'b10110111;
           rom[ 0+4367] =8'b10111111;
           rom[ 0+4368] =8'b10000111;
           rom[ 0+4369] =8'b10001111;
           rom[ 0+4370] =8'b10010111;
           rom[ 0+4371] =8'b10011111;
           rom[ 0+4372] =8'b11100111;
           rom[ 0+4373] =8'b11101111;
           rom[ 0+4374] =8'b11110111;
           rom[ 0+4375] =8'b11111111;
           rom[ 0+4376] =8'b11000111;
           rom[ 0+4377] =8'b11001111;
           rom[ 0+4378] =8'b11010111;
           rom[ 0+4379] =8'b11011111;
           rom[ 0+4380] =8'b01110100;
           rom[ 0+4381] =8'b01111100;
           rom[ 0+4382] =8'b01100100;
           rom[ 0+4383] =8'b01101100;
           rom[ 0+4384] =8'b01010100;
           rom[ 0+4385] =8'b01011100;
           rom[ 0+4386] =8'b01000100;
           rom[ 0+4387] =8'b01001100;
           rom[ 0+4388] =8'b00110100;
           rom[ 0+4389] =8'b00111100;
           rom[ 0+4390] =8'b00100100;
           rom[ 0+4391] =8'b00101100;
           rom[ 0+4392] =8'b00010100;
           rom[ 0+4393] =8'b00011100;
           rom[ 0+4394] =8'b00000100;
           rom[ 0+4395] =8'b00001100;
           rom[ 0+4396] =8'b11110100;
           rom[ 0+4397] =8'b11111100;
           rom[ 0+4398] =8'b11100100;
           rom[ 0+4399] =8'b11101100;
           rom[ 0+4400] =8'b11010100;
           rom[ 0+4401] =8'b11011100;
           rom[ 0+4402] =8'b11000100;
           rom[ 0+4403] =8'b11001100;
           rom[ 0+4404] =8'b10110100;
           rom[ 0+4405] =8'b10111100;
           rom[ 0+4406] =8'b10100100;
           rom[ 0+4407] =8'b10101100;
           rom[ 0+4408] =8'b10010100;
           rom[ 0+4409] =8'b10011100;
           rom[ 0+4410] =8'b10000100;
           rom[ 0+4411] =8'b10001100;
           rom[ 0+4412] =8'b01101001;
           rom[ 0+4413] =8'b01100001;
           rom[ 0+4414] =8'b01111001;
           rom[ 0+4415] =8'b01110001;
           rom[ 0+4416] =8'b01001001;
           rom[ 0+4417] =8'b01000001;
           rom[ 0+4418] =8'b01011001;
           rom[ 0+4419] =8'b01010001;
           rom[ 0+4420] =8'b00101001;
           rom[ 0+4421] =8'b00100001;
           rom[ 0+4422] =8'b00111001;
           rom[ 0+4423] =8'b00110001;
           rom[ 0+4424] =8'b00001001;
           rom[ 0+4425] =8'b00000001;
           rom[ 0+4426] =8'b00011001;
           rom[ 0+4427] =8'b00010001;
           rom[ 0+4428] =8'b11101001;
           rom[ 0+4429] =8'b11100001;
           rom[ 0+4430] =8'b11111001;
           rom[ 0+4431] =8'b11110001;
           rom[ 0+4432] =8'b11001001;
           rom[ 0+4433] =8'b11000001;
           rom[ 0+4434] =8'b11011001;
           rom[ 0+4435] =8'b11010001;
           rom[ 0+4436] =8'b10101001;
           rom[ 0+4437] =8'b10100001;
           rom[ 0+4438] =8'b10111001;
           rom[ 0+4439] =8'b10110001;
           rom[ 0+4440] =8'b10001001;
           rom[ 0+4441] =8'b10000001;
           rom[ 0+4442] =8'b10011001;
           rom[ 0+4443] =8'b10010001;
           rom[ 0+4444] =8'b01001110;
           rom[ 0+4445] =8'b01000110;
           rom[ 0+4446] =8'b01011110;
           rom[ 0+4447] =8'b01010110;
           rom[ 0+4448] =8'b01101110;
           rom[ 0+4449] =8'b01100110;
           rom[ 0+4450] =8'b01111110;
           rom[ 0+4451] =8'b01110110;
           rom[ 0+4452] =8'b00001110;
           rom[ 0+4453] =8'b00000110;
           rom[ 0+4454] =8'b00011110;
           rom[ 0+4455] =8'b00010110;
           rom[ 0+4456] =8'b00101110;
           rom[ 0+4457] =8'b00100110;
           rom[ 0+4458] =8'b00111110;
           rom[ 0+4459] =8'b00110110;
           rom[ 0+4460] =8'b11001110;
           rom[ 0+4461] =8'b11000110;
           rom[ 0+4462] =8'b11011110;
           rom[ 0+4463] =8'b11010110;
           rom[ 0+4464] =8'b11101110;
           rom[ 0+4465] =8'b11100110;
           rom[ 0+4466] =8'b11111110;
           rom[ 0+4467] =8'b11110110;
           rom[ 0+4468] =8'b10001110;
           rom[ 0+4469] =8'b10000110;
           rom[ 0+4470] =8'b10011110;
           rom[ 0+4471] =8'b10010110;
           rom[ 0+4472] =8'b10101110;
           rom[ 0+4473] =8'b10100110;
           rom[ 0+4474] =8'b10111110;
           rom[ 0+4475] =8'b10110110;
           rom[ 0+4476] =8'b01010011;
           rom[ 0+4477] =8'b01011011;
           rom[ 0+4478] =8'b01000011;
           rom[ 0+4479] =8'b01001011;
           rom[ 0+4480] =8'b01110011;
           rom[ 0+4481] =8'b01111011;
           rom[ 0+4482] =8'b01100011;
           rom[ 0+4483] =8'b01101011;
           rom[ 0+4484] =8'b00010011;
           rom[ 0+4485] =8'b00011011;
           rom[ 0+4486] =8'b00000011;
           rom[ 0+4487] =8'b00001011;
           rom[ 0+4488] =8'b00110011;
           rom[ 0+4489] =8'b00111011;
           rom[ 0+4490] =8'b00100011;
           rom[ 0+4491] =8'b00101011;
           rom[ 0+4492] =8'b11010011;
           rom[ 0+4493] =8'b11011011;
           rom[ 0+4494] =8'b11000011;
           rom[ 0+4495] =8'b11001011;
           rom[ 0+4496] =8'b11110011;
           rom[ 0+4497] =8'b11111011;
           rom[ 0+4498] =8'b11100011;
           rom[ 0+4499] =8'b11101011;
           rom[ 0+4500] =8'b10010011;
           rom[ 0+4501] =8'b10011011;
           rom[ 0+4502] =8'b10000011;
           rom[ 0+4503] =8'b10001011;
           rom[ 0+4504] =8'b10110011;
           rom[ 0+4505] =8'b10111011;
           rom[ 0+4506] =8'b10100011;
           rom[ 0+4507] =8'b10101011;
           rom[ 0+4508] =8'b00000000;
           rom[ 0+4509] =8'b00010000;
           rom[ 0+4510] =8'b00100000;
           rom[ 0+4511] =8'b00110000;
           rom[ 0+4512] =8'b01000000;
           rom[ 0+4513] =8'b01010000;
           rom[ 0+4514] =8'b01100000;
           rom[ 0+4515] =8'b01110000;
           rom[ 0+4516] =8'b10000000;
           rom[ 0+4517] =8'b10010000;
           rom[ 0+4518] =8'b10100000;
           rom[ 0+4519] =8'b10110000;
           rom[ 0+4520] =8'b11000000;
           rom[ 0+4521] =8'b11010000;
           rom[ 0+4522] =8'b11100000;
           rom[ 0+4523] =8'b11110000;
           rom[ 0+4524] =8'b00011101;
           rom[ 0+4525] =8'b00001101;
           rom[ 0+4526] =8'b00111101;
           rom[ 0+4527] =8'b00101101;
           rom[ 0+4528] =8'b01011101;
           rom[ 0+4529] =8'b01001101;
           rom[ 0+4530] =8'b01111101;
           rom[ 0+4531] =8'b01101101;
           rom[ 0+4532] =8'b10011101;
           rom[ 0+4533] =8'b10001101;
           rom[ 0+4534] =8'b10111101;
           rom[ 0+4535] =8'b10101101;
           rom[ 0+4536] =8'b11011101;
           rom[ 0+4537] =8'b11001101;
           rom[ 0+4538] =8'b11111101;
           rom[ 0+4539] =8'b11101101;
           rom[ 0+4540] =8'b00111010;
           rom[ 0+4541] =8'b00101010;
           rom[ 0+4542] =8'b00011010;
           rom[ 0+4543] =8'b00001010;
           rom[ 0+4544] =8'b01111010;
           rom[ 0+4545] =8'b01101010;
           rom[ 0+4546] =8'b01011010;
           rom[ 0+4547] =8'b01001010;
           rom[ 0+4548] =8'b10111010;
           rom[ 0+4549] =8'b10101010;
           rom[ 0+4550] =8'b10011010;
           rom[ 0+4551] =8'b10001010;
           rom[ 0+4552] =8'b11111010;
           rom[ 0+4553] =8'b11101010;
           rom[ 0+4554] =8'b11011010;
           rom[ 0+4555] =8'b11001010;
           rom[ 0+4556] =8'b00100111;
           rom[ 0+4557] =8'b00110111;
           rom[ 0+4558] =8'b00000111;
           rom[ 0+4559] =8'b00010111;
           rom[ 0+4560] =8'b01100111;
           rom[ 0+4561] =8'b01110111;
           rom[ 0+4562] =8'b01000111;
           rom[ 0+4563] =8'b01010111;
           rom[ 0+4564] =8'b10100111;
           rom[ 0+4565] =8'b10110111;
           rom[ 0+4566] =8'b10000111;
           rom[ 0+4567] =8'b10010111;
           rom[ 0+4568] =8'b11100111;
           rom[ 0+4569] =8'b11110111;
           rom[ 0+4570] =8'b11000111;
           rom[ 0+4571] =8'b11010111;
           rom[ 0+4572] =8'b01110100;
           rom[ 0+4573] =8'b01100100;
           rom[ 0+4574] =8'b01010100;
           rom[ 0+4575] =8'b01000100;
           rom[ 0+4576] =8'b00110100;
           rom[ 0+4577] =8'b00100100;
           rom[ 0+4578] =8'b00010100;
           rom[ 0+4579] =8'b00000100;
           rom[ 0+4580] =8'b11110100;
           rom[ 0+4581] =8'b11100100;
           rom[ 0+4582] =8'b11010100;
           rom[ 0+4583] =8'b11000100;
           rom[ 0+4584] =8'b10110100;
           rom[ 0+4585] =8'b10100100;
           rom[ 0+4586] =8'b10010100;
           rom[ 0+4587] =8'b10000100;
           rom[ 0+4588] =8'b01101001;
           rom[ 0+4589] =8'b01111001;
           rom[ 0+4590] =8'b01001001;
           rom[ 0+4591] =8'b01011001;
           rom[ 0+4592] =8'b00101001;
           rom[ 0+4593] =8'b00111001;
           rom[ 0+4594] =8'b00001001;
           rom[ 0+4595] =8'b00011001;
           rom[ 0+4596] =8'b11101001;
           rom[ 0+4597] =8'b11111001;
           rom[ 0+4598] =8'b11001001;
           rom[ 0+4599] =8'b11011001;
           rom[ 0+4600] =8'b10101001;
           rom[ 0+4601] =8'b10111001;
           rom[ 0+4602] =8'b10001001;
           rom[ 0+4603] =8'b10011001;
           rom[ 0+4604] =8'b01001110;
           rom[ 0+4605] =8'b01011110;
           rom[ 0+4606] =8'b01101110;
           rom[ 0+4607] =8'b01111110;
           rom[ 0+4608] =8'b00001110;
           rom[ 0+4609] =8'b00011110;
           rom[ 0+4610] =8'b00101110;
           rom[ 0+4611] =8'b00111110;
           rom[ 0+4612] =8'b11001110;
           rom[ 0+4613] =8'b11011110;
           rom[ 0+4614] =8'b11101110;
           rom[ 0+4615] =8'b11111110;
           rom[ 0+4616] =8'b10001110;
           rom[ 0+4617] =8'b10011110;
           rom[ 0+4618] =8'b10101110;
           rom[ 0+4619] =8'b10111110;
           rom[ 0+4620] =8'b01010011;
           rom[ 0+4621] =8'b01000011;
           rom[ 0+4622] =8'b01110011;
           rom[ 0+4623] =8'b01100011;
           rom[ 0+4624] =8'b00010011;
           rom[ 0+4625] =8'b00000011;
           rom[ 0+4626] =8'b00110011;
           rom[ 0+4627] =8'b00100011;
           rom[ 0+4628] =8'b11010011;
           rom[ 0+4629] =8'b11000011;
           rom[ 0+4630] =8'b11110011;
           rom[ 0+4631] =8'b11100011;
           rom[ 0+4632] =8'b10010011;
           rom[ 0+4633] =8'b10000011;
           rom[ 0+4634] =8'b10110011;
           rom[ 0+4635] =8'b10100011;
           rom[ 0+4636] =8'b11101000;
           rom[ 0+4637] =8'b11111000;
           rom[ 0+4638] =8'b11001000;
           rom[ 0+4639] =8'b11011000;
           rom[ 0+4640] =8'b10101000;
           rom[ 0+4641] =8'b10111000;
           rom[ 0+4642] =8'b10001000;
           rom[ 0+4643] =8'b10011000;
           rom[ 0+4644] =8'b01101000;
           rom[ 0+4645] =8'b01111000;
           rom[ 0+4646] =8'b01001000;
           rom[ 0+4647] =8'b01011000;
           rom[ 0+4648] =8'b00101000;
           rom[ 0+4649] =8'b00111000;
           rom[ 0+4650] =8'b00001000;
           rom[ 0+4651] =8'b00011000;
           rom[ 0+4652] =8'b11110101;
           rom[ 0+4653] =8'b11100101;
           rom[ 0+4654] =8'b11010101;
           rom[ 0+4655] =8'b11000101;
           rom[ 0+4656] =8'b10110101;
           rom[ 0+4657] =8'b10100101;
           rom[ 0+4658] =8'b10010101;
           rom[ 0+4659] =8'b10000101;
           rom[ 0+4660] =8'b01110101;
           rom[ 0+4661] =8'b01100101;
           rom[ 0+4662] =8'b01010101;
           rom[ 0+4663] =8'b01000101;
           rom[ 0+4664] =8'b00110101;
           rom[ 0+4665] =8'b00100101;
           rom[ 0+4666] =8'b00010101;
           rom[ 0+4667] =8'b00000101;
           rom[ 0+4668] =8'b11010010;
           rom[ 0+4669] =8'b11000010;
           rom[ 0+4670] =8'b11110010;
           rom[ 0+4671] =8'b11100010;
           rom[ 0+4672] =8'b10010010;
           rom[ 0+4673] =8'b10000010;
           rom[ 0+4674] =8'b10110010;
           rom[ 0+4675] =8'b10100010;
           rom[ 0+4676] =8'b01010010;
           rom[ 0+4677] =8'b01000010;
           rom[ 0+4678] =8'b01110010;
           rom[ 0+4679] =8'b01100010;
           rom[ 0+4680] =8'b00010010;
           rom[ 0+4681] =8'b00000010;
           rom[ 0+4682] =8'b00110010;
           rom[ 0+4683] =8'b00100010;
           rom[ 0+4684] =8'b11001111;
           rom[ 0+4685] =8'b11011111;
           rom[ 0+4686] =8'b11101111;
           rom[ 0+4687] =8'b11111111;
           rom[ 0+4688] =8'b10001111;
           rom[ 0+4689] =8'b10011111;
           rom[ 0+4690] =8'b10101111;
           rom[ 0+4691] =8'b10111111;
           rom[ 0+4692] =8'b01001111;
           rom[ 0+4693] =8'b01011111;
           rom[ 0+4694] =8'b01101111;
           rom[ 0+4695] =8'b01111111;
           rom[ 0+4696] =8'b00001111;
           rom[ 0+4697] =8'b00011111;
           rom[ 0+4698] =8'b00101111;
           rom[ 0+4699] =8'b00111111;
           rom[ 0+4700] =8'b10011100;
           rom[ 0+4701] =8'b10001100;
           rom[ 0+4702] =8'b10111100;
           rom[ 0+4703] =8'b10101100;
           rom[ 0+4704] =8'b11011100;
           rom[ 0+4705] =8'b11001100;
           rom[ 0+4706] =8'b11111100;
           rom[ 0+4707] =8'b11101100;
           rom[ 0+4708] =8'b00011100;
           rom[ 0+4709] =8'b00001100;
           rom[ 0+4710] =8'b00111100;
           rom[ 0+4711] =8'b00101100;
           rom[ 0+4712] =8'b01011100;
           rom[ 0+4713] =8'b01001100;
           rom[ 0+4714] =8'b01111100;
           rom[ 0+4715] =8'b01101100;
           rom[ 0+4716] =8'b10000001;
           rom[ 0+4717] =8'b10010001;
           rom[ 0+4718] =8'b10100001;
           rom[ 0+4719] =8'b10110001;
           rom[ 0+4720] =8'b11000001;
           rom[ 0+4721] =8'b11010001;
           rom[ 0+4722] =8'b11100001;
           rom[ 0+4723] =8'b11110001;
           rom[ 0+4724] =8'b00000001;
           rom[ 0+4725] =8'b00010001;
           rom[ 0+4726] =8'b00100001;
           rom[ 0+4727] =8'b00110001;
           rom[ 0+4728] =8'b01000001;
           rom[ 0+4729] =8'b01010001;
           rom[ 0+4730] =8'b01100001;
           rom[ 0+4731] =8'b01110001;
           rom[ 0+4732] =8'b10100110;
           rom[ 0+4733] =8'b10110110;
           rom[ 0+4734] =8'b10000110;
           rom[ 0+4735] =8'b10010110;
           rom[ 0+4736] =8'b11100110;
           rom[ 0+4737] =8'b11110110;
           rom[ 0+4738] =8'b11000110;
           rom[ 0+4739] =8'b11010110;
           rom[ 0+4740] =8'b00100110;
           rom[ 0+4741] =8'b00110110;
           rom[ 0+4742] =8'b00000110;
           rom[ 0+4743] =8'b00010110;
           rom[ 0+4744] =8'b01100110;
           rom[ 0+4745] =8'b01110110;
           rom[ 0+4746] =8'b01000110;
           rom[ 0+4747] =8'b01010110;
           rom[ 0+4748] =8'b10111011;
           rom[ 0+4749] =8'b10101011;
           rom[ 0+4750] =8'b10011011;
           rom[ 0+4751] =8'b10001011;
           rom[ 0+4752] =8'b11111011;
           rom[ 0+4753] =8'b11101011;
           rom[ 0+4754] =8'b11011011;
           rom[ 0+4755] =8'b11001011;
           rom[ 0+4756] =8'b00111011;
           rom[ 0+4757] =8'b00101011;
           rom[ 0+4758] =8'b00011011;
           rom[ 0+4759] =8'b00001011;
           rom[ 0+4760] =8'b01111011;
           rom[ 0+4761] =8'b01101011;
           rom[ 0+4762] =8'b01011011;
           rom[ 0+4763] =8'b01001011;
           rom[ 0+4764] =8'b00000000;
           rom[ 0+4765] =8'b00100000;
           rom[ 0+4766] =8'b01000000;
           rom[ 0+4767] =8'b01100000;
           rom[ 0+4768] =8'b10000000;
           rom[ 0+4769] =8'b10100000;
           rom[ 0+4770] =8'b11000000;
           rom[ 0+4771] =8'b11100000;
           rom[ 0+4772] =8'b00011101;
           rom[ 0+4773] =8'b00111101;
           rom[ 0+4774] =8'b01011101;
           rom[ 0+4775] =8'b01111101;
           rom[ 0+4776] =8'b10011101;
           rom[ 0+4777] =8'b10111101;
           rom[ 0+4778] =8'b11011101;
           rom[ 0+4779] =8'b11111101;
           rom[ 0+4780] =8'b00111010;
           rom[ 0+4781] =8'b00011010;
           rom[ 0+4782] =8'b01111010;
           rom[ 0+4783] =8'b01011010;
           rom[ 0+4784] =8'b10111010;
           rom[ 0+4785] =8'b10011010;
           rom[ 0+4786] =8'b11111010;
           rom[ 0+4787] =8'b11011010;
           rom[ 0+4788] =8'b00100111;
           rom[ 0+4789] =8'b00000111;
           rom[ 0+4790] =8'b01100111;
           rom[ 0+4791] =8'b01000111;
           rom[ 0+4792] =8'b10100111;
           rom[ 0+4793] =8'b10000111;
           rom[ 0+4794] =8'b11100111;
           rom[ 0+4795] =8'b11000111;
           rom[ 0+4796] =8'b01110100;
           rom[ 0+4797] =8'b01010100;
           rom[ 0+4798] =8'b00110100;
           rom[ 0+4799] =8'b00010100;
           rom[ 0+4800] =8'b11110100;
           rom[ 0+4801] =8'b11010100;
           rom[ 0+4802] =8'b10110100;
           rom[ 0+4803] =8'b10010100;
           rom[ 0+4804] =8'b01101001;
           rom[ 0+4805] =8'b01001001;
           rom[ 0+4806] =8'b00101001;
           rom[ 0+4807] =8'b00001001;
           rom[ 0+4808] =8'b11101001;
           rom[ 0+4809] =8'b11001001;
           rom[ 0+4810] =8'b10101001;
           rom[ 0+4811] =8'b10001001;
           rom[ 0+4812] =8'b01001110;
           rom[ 0+4813] =8'b01101110;
           rom[ 0+4814] =8'b00001110;
           rom[ 0+4815] =8'b00101110;
           rom[ 0+4816] =8'b11001110;
           rom[ 0+4817] =8'b11101110;
           rom[ 0+4818] =8'b10001110;
           rom[ 0+4819] =8'b10101110;
           rom[ 0+4820] =8'b01010011;
           rom[ 0+4821] =8'b01110011;
           rom[ 0+4822] =8'b00010011;
           rom[ 0+4823] =8'b00110011;
           rom[ 0+4824] =8'b11010011;
           rom[ 0+4825] =8'b11110011;
           rom[ 0+4826] =8'b10010011;
           rom[ 0+4827] =8'b10110011;
           rom[ 0+4828] =8'b11101000;
           rom[ 0+4829] =8'b11001000;
           rom[ 0+4830] =8'b10101000;
           rom[ 0+4831] =8'b10001000;
           rom[ 0+4832] =8'b01101000;
           rom[ 0+4833] =8'b01001000;
           rom[ 0+4834] =8'b00101000;
           rom[ 0+4835] =8'b00001000;
           rom[ 0+4836] =8'b11110101;
           rom[ 0+4837] =8'b11010101;
           rom[ 0+4838] =8'b10110101;
           rom[ 0+4839] =8'b10010101;
           rom[ 0+4840] =8'b01110101;
           rom[ 0+4841] =8'b01010101;
           rom[ 0+4842] =8'b00110101;
           rom[ 0+4843] =8'b00010101;
           rom[ 0+4844] =8'b11010010;
           rom[ 0+4845] =8'b11110010;
           rom[ 0+4846] =8'b10010010;
           rom[ 0+4847] =8'b10110010;
           rom[ 0+4848] =8'b01010010;
           rom[ 0+4849] =8'b01110010;
           rom[ 0+4850] =8'b00010010;
           rom[ 0+4851] =8'b00110010;
           rom[ 0+4852] =8'b11001111;
           rom[ 0+4853] =8'b11101111;
           rom[ 0+4854] =8'b10001111;
           rom[ 0+4855] =8'b10101111;
           rom[ 0+4856] =8'b01001111;
           rom[ 0+4857] =8'b01101111;
           rom[ 0+4858] =8'b00001111;
           rom[ 0+4859] =8'b00101111;
           rom[ 0+4860] =8'b10011100;
           rom[ 0+4861] =8'b10111100;
           rom[ 0+4862] =8'b11011100;
           rom[ 0+4863] =8'b11111100;
           rom[ 0+4864] =8'b00011100;
           rom[ 0+4865] =8'b00111100;
           rom[ 0+4866] =8'b01011100;
           rom[ 0+4867] =8'b01111100;
           rom[ 0+4868] =8'b10000001;
           rom[ 0+4869] =8'b10100001;
           rom[ 0+4870] =8'b11000001;
           rom[ 0+4871] =8'b11100001;
           rom[ 0+4872] =8'b00000001;
           rom[ 0+4873] =8'b00100001;
           rom[ 0+4874] =8'b01000001;
           rom[ 0+4875] =8'b01100001;
           rom[ 0+4876] =8'b10100110;
           rom[ 0+4877] =8'b10000110;
           rom[ 0+4878] =8'b11100110;
           rom[ 0+4879] =8'b11000110;
           rom[ 0+4880] =8'b00100110;
           rom[ 0+4881] =8'b00000110;
           rom[ 0+4882] =8'b01100110;
           rom[ 0+4883] =8'b01000110;
           rom[ 0+4884] =8'b10111011;
           rom[ 0+4885] =8'b10011011;
           rom[ 0+4886] =8'b11111011;
           rom[ 0+4887] =8'b11011011;
           rom[ 0+4888] =8'b00111011;
           rom[ 0+4889] =8'b00011011;
           rom[ 0+4890] =8'b01111011;
           rom[ 0+4891] =8'b01011011;
           rom[ 0+4892] =8'b11001101;
           rom[ 0+4893] =8'b11101101;
           rom[ 0+4894] =8'b10001101;
           rom[ 0+4895] =8'b10101101;
           rom[ 0+4896] =8'b01001101;
           rom[ 0+4897] =8'b01101101;
           rom[ 0+4898] =8'b00001101;
           rom[ 0+4899] =8'b00101101;
           rom[ 0+4900] =8'b11010000;
           rom[ 0+4901] =8'b11110000;
           rom[ 0+4902] =8'b10010000;
           rom[ 0+4903] =8'b10110000;
           rom[ 0+4904] =8'b01010000;
           rom[ 0+4905] =8'b01110000;
           rom[ 0+4906] =8'b00010000;
           rom[ 0+4907] =8'b00110000;
           rom[ 0+4908] =8'b11110111;
           rom[ 0+4909] =8'b11010111;
           rom[ 0+4910] =8'b10110111;
           rom[ 0+4911] =8'b10010111;
           rom[ 0+4912] =8'b01110111;
           rom[ 0+4913] =8'b01010111;
           rom[ 0+4914] =8'b00110111;
           rom[ 0+4915] =8'b00010111;
           rom[ 0+4916] =8'b11101010;
           rom[ 0+4917] =8'b11001010;
           rom[ 0+4918] =8'b10101010;
           rom[ 0+4919] =8'b10001010;
           rom[ 0+4920] =8'b01101010;
           rom[ 0+4921] =8'b01001010;
           rom[ 0+4922] =8'b00101010;
           rom[ 0+4923] =8'b00001010;
           rom[ 0+4924] =8'b10111001;
           rom[ 0+4925] =8'b10011001;
           rom[ 0+4926] =8'b11111001;
           rom[ 0+4927] =8'b11011001;
           rom[ 0+4928] =8'b00111001;
           rom[ 0+4929] =8'b00011001;
           rom[ 0+4930] =8'b01111001;
           rom[ 0+4931] =8'b01011001;
           rom[ 0+4932] =8'b10100100;
           rom[ 0+4933] =8'b10000100;
           rom[ 0+4934] =8'b11100100;
           rom[ 0+4935] =8'b11000100;
           rom[ 0+4936] =8'b00100100;
           rom[ 0+4937] =8'b00000100;
           rom[ 0+4938] =8'b01100100;
           rom[ 0+4939] =8'b01000100;
           rom[ 0+4940] =8'b10000011;
           rom[ 0+4941] =8'b10100011;
           rom[ 0+4942] =8'b11000011;
           rom[ 0+4943] =8'b11100011;
           rom[ 0+4944] =8'b00000011;
           rom[ 0+4945] =8'b00100011;
           rom[ 0+4946] =8'b01000011;
           rom[ 0+4947] =8'b01100011;
           rom[ 0+4948] =8'b10011110;
           rom[ 0+4949] =8'b10111110;
           rom[ 0+4950] =8'b11011110;
           rom[ 0+4951] =8'b11111110;
           rom[ 0+4952] =8'b00011110;
           rom[ 0+4953] =8'b00111110;
           rom[ 0+4954] =8'b01011110;
           rom[ 0+4955] =8'b01111110;
           rom[ 0+4956] =8'b00100101;
           rom[ 0+4957] =8'b00000101;
           rom[ 0+4958] =8'b01100101;
           rom[ 0+4959] =8'b01000101;
           rom[ 0+4960] =8'b10100101;
           rom[ 0+4961] =8'b10000101;
           rom[ 0+4962] =8'b11100101;
           rom[ 0+4963] =8'b11000101;
           rom[ 0+4964] =8'b00111000;
           rom[ 0+4965] =8'b00011000;
           rom[ 0+4966] =8'b01111000;
           rom[ 0+4967] =8'b01011000;
           rom[ 0+4968] =8'b10111000;
           rom[ 0+4969] =8'b10011000;
           rom[ 0+4970] =8'b11111000;
           rom[ 0+4971] =8'b11011000;
           rom[ 0+4972] =8'b00011111;
           rom[ 0+4973] =8'b00111111;
           rom[ 0+4974] =8'b01011111;
           rom[ 0+4975] =8'b01111111;
           rom[ 0+4976] =8'b10011111;
           rom[ 0+4977] =8'b10111111;
           rom[ 0+4978] =8'b11011111;
           rom[ 0+4979] =8'b11111111;
           rom[ 0+4980] =8'b00000010;
           rom[ 0+4981] =8'b00100010;
           rom[ 0+4982] =8'b01000010;
           rom[ 0+4983] =8'b01100010;
           rom[ 0+4984] =8'b10000010;
           rom[ 0+4985] =8'b10100010;
           rom[ 0+4986] =8'b11000010;
           rom[ 0+4987] =8'b11100010;
           rom[ 0+4988] =8'b01010001;
           rom[ 0+4989] =8'b01110001;
           rom[ 0+4990] =8'b00010001;
           rom[ 0+4991] =8'b00110001;
           rom[ 0+4992] =8'b11010001;
           rom[ 0+4993] =8'b11110001;
           rom[ 0+4994] =8'b10010001;
           rom[ 0+4995] =8'b10110001;
           rom[ 0+4996] =8'b01001100;
           rom[ 0+4997] =8'b01101100;
           rom[ 0+4998] =8'b00001100;
           rom[ 0+4999] =8'b00101100;
           rom[ 0+5000] =8'b11001100;
           rom[ 0+5001] =8'b11101100;
           rom[ 0+5002] =8'b10001100;
           rom[ 0+5003] =8'b10101100;
           rom[ 0+5004] =8'b01101011;
           rom[ 0+5005] =8'b01001011;
           rom[ 0+5006] =8'b00101011;
           rom[ 0+5007] =8'b00001011;
           rom[ 0+5008] =8'b11101011;
           rom[ 0+5009] =8'b11001011;
           rom[ 0+5010] =8'b10101011;
           rom[ 0+5011] =8'b10001011;
           rom[ 0+5012] =8'b01110110;
           rom[ 0+5013] =8'b01010110;
           rom[ 0+5014] =8'b00110110;
           rom[ 0+5015] =8'b00010110;
           rom[ 0+5016] =8'b11110110;
           rom[ 0+5017] =8'b11010110;
           rom[ 0+5018] =8'b10110110;
           rom[ 0+5019] =8'b10010110;
           rom[ 0+5020] =8'b00000000;
           rom[ 0+5021] =8'b01000000;
           rom[ 0+5022] =8'b10000000;
           rom[ 0+5023] =8'b11000000;
           rom[ 0+5024] =8'b00011101;
           rom[ 0+5025] =8'b01011101;
           rom[ 0+5026] =8'b10011101;
           rom[ 0+5027] =8'b11011101;
           rom[ 0+5028] =8'b00111010;
           rom[ 0+5029] =8'b01111010;
           rom[ 0+5030] =8'b10111010;
           rom[ 0+5031] =8'b11111010;
           rom[ 0+5032] =8'b00100111;
           rom[ 0+5033] =8'b01100111;
           rom[ 0+5034] =8'b10100111;
           rom[ 0+5035] =8'b11100111;
           rom[ 0+5036] =8'b01110100;
           rom[ 0+5037] =8'b00110100;
           rom[ 0+5038] =8'b11110100;
           rom[ 0+5039] =8'b10110100;
           rom[ 0+5040] =8'b01101001;
           rom[ 0+5041] =8'b00101001;
           rom[ 0+5042] =8'b11101001;
           rom[ 0+5043] =8'b10101001;
           rom[ 0+5044] =8'b01001110;
           rom[ 0+5045] =8'b00001110;
           rom[ 0+5046] =8'b11001110;
           rom[ 0+5047] =8'b10001110;
           rom[ 0+5048] =8'b01010011;
           rom[ 0+5049] =8'b00010011;
           rom[ 0+5050] =8'b11010011;
           rom[ 0+5051] =8'b10010011;
           rom[ 0+5052] =8'b11101000;
           rom[ 0+5053] =8'b10101000;
           rom[ 0+5054] =8'b01101000;
           rom[ 0+5055] =8'b00101000;
           rom[ 0+5056] =8'b11110101;
           rom[ 0+5057] =8'b10110101;
           rom[ 0+5058] =8'b01110101;
           rom[ 0+5059] =8'b00110101;
           rom[ 0+5060] =8'b11010010;
           rom[ 0+5061] =8'b10010010;
           rom[ 0+5062] =8'b01010010;
           rom[ 0+5063] =8'b00010010;
           rom[ 0+5064] =8'b11001111;
           rom[ 0+5065] =8'b10001111;
           rom[ 0+5066] =8'b01001111;
           rom[ 0+5067] =8'b00001111;
           rom[ 0+5068] =8'b10011100;
           rom[ 0+5069] =8'b11011100;
           rom[ 0+5070] =8'b00011100;
           rom[ 0+5071] =8'b01011100;
           rom[ 0+5072] =8'b10000001;
           rom[ 0+5073] =8'b11000001;
           rom[ 0+5074] =8'b00000001;
           rom[ 0+5075] =8'b01000001;
           rom[ 0+5076] =8'b10100110;
           rom[ 0+5077] =8'b11100110;
           rom[ 0+5078] =8'b00100110;
           rom[ 0+5079] =8'b01100110;
           rom[ 0+5080] =8'b10111011;
           rom[ 0+5081] =8'b11111011;
           rom[ 0+5082] =8'b00111011;
           rom[ 0+5083] =8'b01111011;
           rom[ 0+5084] =8'b11001101;
           rom[ 0+5085] =8'b10001101;
           rom[ 0+5086] =8'b01001101;
           rom[ 0+5087] =8'b00001101;
           rom[ 0+5088] =8'b11010000;
           rom[ 0+5089] =8'b10010000;
           rom[ 0+5090] =8'b01010000;
           rom[ 0+5091] =8'b00010000;
           rom[ 0+5092] =8'b11110111;
           rom[ 0+5093] =8'b10110111;
           rom[ 0+5094] =8'b01110111;
           rom[ 0+5095] =8'b00110111;
           rom[ 0+5096] =8'b11101010;
           rom[ 0+5097] =8'b10101010;
           rom[ 0+5098] =8'b01101010;
           rom[ 0+5099] =8'b00101010;
           rom[ 0+5100] =8'b10111001;
           rom[ 0+5101] =8'b11111001;
           rom[ 0+5102] =8'b00111001;
           rom[ 0+5103] =8'b01111001;
           rom[ 0+5104] =8'b10100100;
           rom[ 0+5105] =8'b11100100;
           rom[ 0+5106] =8'b00100100;
           rom[ 0+5107] =8'b01100100;
           rom[ 0+5108] =8'b10000011;
           rom[ 0+5109] =8'b11000011;
           rom[ 0+5110] =8'b00000011;
           rom[ 0+5111] =8'b01000011;
           rom[ 0+5112] =8'b10011110;
           rom[ 0+5113] =8'b11011110;
           rom[ 0+5114] =8'b00011110;
           rom[ 0+5115] =8'b01011110;
           rom[ 0+5116] =8'b00100101;
           rom[ 0+5117] =8'b01100101;
           rom[ 0+5118] =8'b10100101;
           rom[ 0+5119] =8'b11100101;
           rom[ 0+5120] =8'b00111000;
           rom[ 0+5121] =8'b01111000;
           rom[ 0+5122] =8'b10111000;
           rom[ 0+5123] =8'b11111000;
           rom[ 0+5124] =8'b00011111;
           rom[ 0+5125] =8'b01011111;
           rom[ 0+5126] =8'b10011111;
           rom[ 0+5127] =8'b11011111;
           rom[ 0+5128] =8'b00000010;
           rom[ 0+5129] =8'b01000010;
           rom[ 0+5130] =8'b10000010;
           rom[ 0+5131] =8'b11000010;
           rom[ 0+5132] =8'b01010001;
           rom[ 0+5133] =8'b00010001;
           rom[ 0+5134] =8'b11010001;
           rom[ 0+5135] =8'b10010001;
           rom[ 0+5136] =8'b01001100;
           rom[ 0+5137] =8'b00001100;
           rom[ 0+5138] =8'b11001100;
           rom[ 0+5139] =8'b10001100;
           rom[ 0+5140] =8'b01101011;
           rom[ 0+5141] =8'b00101011;
           rom[ 0+5142] =8'b11101011;
           rom[ 0+5143] =8'b10101011;
           rom[ 0+5144] =8'b01110110;
           rom[ 0+5145] =8'b00110110;
           rom[ 0+5146] =8'b11110110;
           rom[ 0+5147] =8'b10110110;
           rom[ 0+5148] =8'b10000111;
           rom[ 0+5149] =8'b11000111;
           rom[ 0+5150] =8'b00000111;
           rom[ 0+5151] =8'b01000111;
           rom[ 0+5152] =8'b10011010;
           rom[ 0+5153] =8'b11011010;
           rom[ 0+5154] =8'b00011010;
           rom[ 0+5155] =8'b01011010;
           rom[ 0+5156] =8'b10111101;
           rom[ 0+5157] =8'b11111101;
           rom[ 0+5158] =8'b00111101;
           rom[ 0+5159] =8'b01111101;
           rom[ 0+5160] =8'b10100000;
           rom[ 0+5161] =8'b11100000;
           rom[ 0+5162] =8'b00100000;
           rom[ 0+5163] =8'b01100000;
           rom[ 0+5164] =8'b11110011;
           rom[ 0+5165] =8'b10110011;
           rom[ 0+5166] =8'b01110011;
           rom[ 0+5167] =8'b00110011;
           rom[ 0+5168] =8'b11101110;
           rom[ 0+5169] =8'b10101110;
           rom[ 0+5170] =8'b01101110;
           rom[ 0+5171] =8'b00101110;
           rom[ 0+5172] =8'b11001001;
           rom[ 0+5173] =8'b10001001;
           rom[ 0+5174] =8'b01001001;
           rom[ 0+5175] =8'b00001001;
           rom[ 0+5176] =8'b11010100;
           rom[ 0+5177] =8'b10010100;
           rom[ 0+5178] =8'b01010100;
           rom[ 0+5179] =8'b00010100;
           rom[ 0+5180] =8'b01101111;
           rom[ 0+5181] =8'b00101111;
           rom[ 0+5182] =8'b11101111;
           rom[ 0+5183] =8'b10101111;
           rom[ 0+5184] =8'b01110010;
           rom[ 0+5185] =8'b00110010;
           rom[ 0+5186] =8'b11110010;
           rom[ 0+5187] =8'b10110010;
           rom[ 0+5188] =8'b01010101;
           rom[ 0+5189] =8'b00010101;
           rom[ 0+5190] =8'b11010101;
           rom[ 0+5191] =8'b10010101;
           rom[ 0+5192] =8'b01001000;
           rom[ 0+5193] =8'b00001000;
           rom[ 0+5194] =8'b11001000;
           rom[ 0+5195] =8'b10001000;
           rom[ 0+5196] =8'b00011011;
           rom[ 0+5197] =8'b01011011;
           rom[ 0+5198] =8'b10011011;
           rom[ 0+5199] =8'b11011011;
           rom[ 0+5200] =8'b00000110;
           rom[ 0+5201] =8'b01000110;
           rom[ 0+5202] =8'b10000110;
           rom[ 0+5203] =8'b11000110;
           rom[ 0+5204] =8'b00100001;
           rom[ 0+5205] =8'b01100001;
           rom[ 0+5206] =8'b10100001;
           rom[ 0+5207] =8'b11100001;
           rom[ 0+5208] =8'b00111100;
           rom[ 0+5209] =8'b01111100;
           rom[ 0+5210] =8'b10111100;
           rom[ 0+5211] =8'b11111100;
           rom[ 0+5212] =8'b01001010;
           rom[ 0+5213] =8'b00001010;
           rom[ 0+5214] =8'b11001010;
           rom[ 0+5215] =8'b10001010;
           rom[ 0+5216] =8'b01010111;
           rom[ 0+5217] =8'b00010111;
           rom[ 0+5218] =8'b11010111;
           rom[ 0+5219] =8'b10010111;
           rom[ 0+5220] =8'b01110000;
           rom[ 0+5221] =8'b00110000;
           rom[ 0+5222] =8'b11110000;
           rom[ 0+5223] =8'b10110000;
           rom[ 0+5224] =8'b01101101;
           rom[ 0+5225] =8'b00101101;
           rom[ 0+5226] =8'b11101101;
           rom[ 0+5227] =8'b10101101;
           rom[ 0+5228] =8'b00111110;
           rom[ 0+5229] =8'b01111110;
           rom[ 0+5230] =8'b10111110;
           rom[ 0+5231] =8'b11111110;
           rom[ 0+5232] =8'b00100011;
           rom[ 0+5233] =8'b01100011;
           rom[ 0+5234] =8'b10100011;
           rom[ 0+5235] =8'b11100011;
           rom[ 0+5236] =8'b00000100;
           rom[ 0+5237] =8'b01000100;
           rom[ 0+5238] =8'b10000100;
           rom[ 0+5239] =8'b11000100;
           rom[ 0+5240] =8'b00011001;
           rom[ 0+5241] =8'b01011001;
           rom[ 0+5242] =8'b10011001;
           rom[ 0+5243] =8'b11011001;
           rom[ 0+5244] =8'b10100010;
           rom[ 0+5245] =8'b11100010;
           rom[ 0+5246] =8'b00100010;
           rom[ 0+5247] =8'b01100010;
           rom[ 0+5248] =8'b10111111;
           rom[ 0+5249] =8'b11111111;
           rom[ 0+5250] =8'b00111111;
           rom[ 0+5251] =8'b01111111;
           rom[ 0+5252] =8'b10011000;
           rom[ 0+5253] =8'b11011000;
           rom[ 0+5254] =8'b00011000;
           rom[ 0+5255] =8'b01011000;
           rom[ 0+5256] =8'b10000101;
           rom[ 0+5257] =8'b11000101;
           rom[ 0+5258] =8'b00000101;
           rom[ 0+5259] =8'b01000101;
           rom[ 0+5260] =8'b11010110;
           rom[ 0+5261] =8'b10010110;
           rom[ 0+5262] =8'b01010110;
           rom[ 0+5263] =8'b00010110;
           rom[ 0+5264] =8'b11001011;
           rom[ 0+5265] =8'b10001011;
           rom[ 0+5266] =8'b01001011;
           rom[ 0+5267] =8'b00001011;
           rom[ 0+5268] =8'b11101100;
           rom[ 0+5269] =8'b10101100;
           rom[ 0+5270] =8'b01101100;
           rom[ 0+5271] =8'b00101100;
           rom[ 0+5272] =8'b11110001;
           rom[ 0+5273] =8'b10110001;
           rom[ 0+5274] =8'b01110001;
           rom[ 0+5275] =8'b00110001;
           rom[ 0+5276] =8'b11011101;
           rom[ 0+5277] =8'b11100101;
           rom[ 0+5278] =8'b11011101;
           rom[ 0+5279] =8'b00100001;
           rom[ 0+5280] =8'b00000000;
           rom[ 0+5281] =8'b00000000;
           rom[ 0+5282] =8'b11011101;
           rom[ 0+5283] =8'b00111001;
           rom[ 0+5284] =8'b11011101;
           rom[ 0+5285] =8'b01111110;
           rom[ 0+5286] =8'b00000100;
           rom[ 0+5287] =8'b11111101;
           rom[ 0+5288] =8'b00100001;
           rom[ 0+5289] =8'b11101001;
           rom[ 0+5290] =8'b10000011;
           rom[ 0+5291] =8'b11111101;
           rom[ 0+5292] =8'b01110111;
           rom[ 0+5293] =8'b00000000;
           rom[ 0+5294] =8'b11011101;
           rom[ 0+5295] =8'b11100001;
           rom[ 0+5296] =8'b11001001;
           rom[ 0+5297] =8'b11011101;
           rom[ 0+5298] =8'b11100101;
           rom[ 0+5299] =8'b11011101;
           rom[ 0+5300] =8'b00100001;
           rom[ 0+5301] =8'b00000000;
           rom[ 0+5302] =8'b00000000;
           rom[ 0+5303] =8'b11011101;
           rom[ 0+5304] =8'b00111001;
           rom[ 0+5305] =8'b11011101;
           rom[ 0+5306] =8'b01111110;
           rom[ 0+5307] =8'b00000100;
           rom[ 0+5308] =8'b11111101;
           rom[ 0+5309] =8'b00100001;
           rom[ 0+5310] =8'b11101010;
           rom[ 0+5311] =8'b10000011;
           rom[ 0+5312] =8'b11111101;
           rom[ 0+5313] =8'b01110111;
           rom[ 0+5314] =8'b00000000;
           rom[ 0+5315] =8'b11011101;
           rom[ 0+5316] =8'b01111110;
           rom[ 0+5317] =8'b00000101;
           rom[ 0+5318] =8'b11111101;
           rom[ 0+5319] =8'b01110111;
           rom[ 0+5320] =8'b00000001;
           rom[ 0+5321] =8'b11011101;
           rom[ 0+5322] =8'b11100001;
           rom[ 0+5323] =8'b11001001;
           rom[ 0+5324] =8'b11011101;
           rom[ 0+5325] =8'b11100101;
           rom[ 0+5326] =8'b11011101;
           rom[ 0+5327] =8'b00100001;
           rom[ 0+5328] =8'b00000000;
           rom[ 0+5329] =8'b00000000;
           rom[ 0+5330] =8'b11011101;
           rom[ 0+5331] =8'b00111001;
           rom[ 0+5332] =8'b11011101;
           rom[ 0+5333] =8'b01111110;
           rom[ 0+5334] =8'b00000100;
           rom[ 0+5335] =8'b11111101;
           rom[ 0+5336] =8'b00100001;
           rom[ 0+5337] =8'b11101100;
           rom[ 0+5338] =8'b10000011;
           rom[ 0+5339] =8'b11111101;
           rom[ 0+5340] =8'b01110111;
           rom[ 0+5341] =8'b00000000;
           rom[ 0+5342] =8'b11011101;
           rom[ 0+5343] =8'b01111110;
           rom[ 0+5344] =8'b00000101;
           rom[ 0+5345] =8'b11111101;
           rom[ 0+5346] =8'b01110111;
           rom[ 0+5347] =8'b00000001;
           rom[ 0+5348] =8'b11011101;
           rom[ 0+5349] =8'b01111110;
           rom[ 0+5350] =8'b00000110;
           rom[ 0+5351] =8'b11111101;
           rom[ 0+5352] =8'b01110111;
           rom[ 0+5353] =8'b00000010;
           rom[ 0+5354] =8'b11011101;
           rom[ 0+5355] =8'b01111110;
           rom[ 0+5356] =8'b00000111;
           rom[ 0+5357] =8'b11111101;
           rom[ 0+5358] =8'b01110111;
           rom[ 0+5359] =8'b00000011;
           rom[ 0+5360] =8'b11011101;
           rom[ 0+5361] =8'b11100001;
           rom[ 0+5362] =8'b11001001;
           rom[ 0+5363] =8'b11011101;
           rom[ 0+5364] =8'b11100101;
           rom[ 0+5365] =8'b11011101;
           rom[ 0+5366] =8'b00100001;
           rom[ 0+5367] =8'b00000000;
           rom[ 0+5368] =8'b00000000;
           rom[ 0+5369] =8'b11011101;
           rom[ 0+5370] =8'b00111001;
           rom[ 0+5371] =8'b00100001;
           rom[ 0+5372] =8'b11100110;
           rom[ 0+5373] =8'b11111111;
           rom[ 0+5374] =8'b00111001;
           rom[ 0+5375] =8'b11111001;
           rom[ 0+5376] =8'b00100001;
           rom[ 0+5377] =8'b00001110;
           rom[ 0+5378] =8'b00000000;
           rom[ 0+5379] =8'b00111001;
           rom[ 0+5380] =8'b11011101;
           rom[ 0+5381] =8'b01110101;
           rom[ 0+5382] =8'b11101010;
           rom[ 0+5383] =8'b11011101;
           rom[ 0+5384] =8'b01110100;
           rom[ 0+5385] =8'b11101011;
           rom[ 0+5386] =8'b00100001;
           rom[ 0+5387] =8'b00000110;
           rom[ 0+5388] =8'b00000000;
           rom[ 0+5389] =8'b00111001;
           rom[ 0+5390] =8'b11011101;
           rom[ 0+5391] =8'b01110101;
           rom[ 0+5392] =8'b11100110;
           rom[ 0+5393] =8'b11011101;
           rom[ 0+5394] =8'b01110100;
           rom[ 0+5395] =8'b11100111;
           rom[ 0+5396] =8'b11011101;
           rom[ 0+5397] =8'b00110110;
           rom[ 0+5398] =8'b11111110;
           rom[ 0+5399] =8'b00000000;
           rom[ 0+5400] =8'b11011101;
           rom[ 0+5401] =8'b00110110;
           rom[ 0+5402] =8'b11111111;
           rom[ 0+5403] =8'b00000000;
           rom[ 0+5404] =8'b11011101;
           rom[ 0+5405] =8'b01111110;
           rom[ 0+5406] =8'b11111110;
           rom[ 0+5407] =8'b11010110;
           rom[ 0+5408] =8'b00001000;
           rom[ 0+5409] =8'b11011101;
           rom[ 0+5410] =8'b01111110;
           rom[ 0+5411] =8'b11111111;
           rom[ 0+5412] =8'b11011110;
           rom[ 0+5413] =8'b00000000;
           rom[ 0+5414] =8'b11110010;
           rom[ 0+5415] =8'b10101100;
           rom[ 0+5416] =8'b00010101;
           rom[ 0+5417] =8'b11011101;
           rom[ 0+5418] =8'b01111110;
           rom[ 0+5419] =8'b11101010;
           rom[ 0+5420] =8'b11011101;
           rom[ 0+5421] =8'b10000110;
           rom[ 0+5422] =8'b11111110;
           rom[ 0+5423] =8'b01011111;
           rom[ 0+5424] =8'b11011101;
           rom[ 0+5425] =8'b01111110;
           rom[ 0+5426] =8'b11101011;
           rom[ 0+5427] =8'b11011101;
           rom[ 0+5428] =8'b10001110;
           rom[ 0+5429] =8'b11111111;
           rom[ 0+5430] =8'b01010111;
           rom[ 0+5431] =8'b11011101;
           rom[ 0+5432] =8'b01111110;
           rom[ 0+5433] =8'b00000100;
           rom[ 0+5434] =8'b11011101;
           rom[ 0+5435] =8'b10000110;
           rom[ 0+5436] =8'b11111110;
           rom[ 0+5437] =8'b01001111;
           rom[ 0+5438] =8'b11011101;
           rom[ 0+5439] =8'b01111110;
           rom[ 0+5440] =8'b00000101;
           rom[ 0+5441] =8'b11011101;
           rom[ 0+5442] =8'b10001110;
           rom[ 0+5443] =8'b11111111;
           rom[ 0+5444] =8'b01000111;
           rom[ 0+5445] =8'b00001010;
           rom[ 0+5446] =8'b01001111;
           rom[ 0+5447] =8'b11011101;
           rom[ 0+5448] =8'b10100110;
           rom[ 0+5449] =8'b00000110;
           rom[ 0+5450] =8'b00010010;
           rom[ 0+5451] =8'b11011101;
           rom[ 0+5452] =8'b01111110;
           rom[ 0+5453] =8'b11100110;
           rom[ 0+5454] =8'b11011101;
           rom[ 0+5455] =8'b10000110;
           rom[ 0+5456] =8'b11111110;
           rom[ 0+5457] =8'b01001111;
           rom[ 0+5458] =8'b11011101;
           rom[ 0+5459] =8'b01111110;
           rom[ 0+5460] =8'b11100111;
           rom[ 0+5461] =8'b11011101;
           rom[ 0+5462] =8'b10001110;
           rom[ 0+5463] =8'b11111111;
           rom[ 0+5464] =8'b01000111;
           rom[ 0+5465] =8'b00111110;
           rom[ 0+5466] =8'b00000000;
           rom[ 0+5467] =8'b00000010;
           rom[ 0+5468] =8'b11011101;
           rom[ 0+5469] =8'b01110011;
           rom[ 0+5470] =8'b11101000;
           rom[ 0+5471] =8'b11011101;
           rom[ 0+5472] =8'b01110010;
           rom[ 0+5473] =8'b11101001;
           rom[ 0+5474] =8'b11011101;
           rom[ 0+5475] =8'b00110110;
           rom[ 0+5476] =8'b11111100;
           rom[ 0+5477] =8'b00000000;
           rom[ 0+5478] =8'b11011101;
           rom[ 0+5479] =8'b00110110;
           rom[ 0+5480] =8'b11111101;
           rom[ 0+5481] =8'b00000000;
           rom[ 0+5482] =8'b11011101;
           rom[ 0+5483] =8'b01111110;
           rom[ 0+5484] =8'b11111100;
           rom[ 0+5485] =8'b11010110;
           rom[ 0+5486] =8'b00001000;
           rom[ 0+5487] =8'b11011101;
           rom[ 0+5488] =8'b01111110;
           rom[ 0+5489] =8'b11111101;
           rom[ 0+5490] =8'b11011110;
           rom[ 0+5491] =8'b00000000;
           rom[ 0+5492] =8'b11110010;
           rom[ 0+5493] =8'b10100000;
           rom[ 0+5494] =8'b00010101;
           rom[ 0+5495] =8'b00001010;
           rom[ 0+5496] =8'b01011111;
           rom[ 0+5497] =8'b11011101;
           rom[ 0+5498] =8'b01101110;
           rom[ 0+5499] =8'b11101000;
           rom[ 0+5500] =8'b11011101;
           rom[ 0+5501] =8'b01100110;
           rom[ 0+5502] =8'b11101001;
           rom[ 0+5503] =8'b01010110;
           rom[ 0+5504] =8'b11011101;
           rom[ 0+5505] =8'b01111110;
           rom[ 0+5506] =8'b11111100;
           rom[ 0+5507] =8'b00111100;
           rom[ 0+5508] =8'b11000011;
           rom[ 0+5509] =8'b10001001;
           rom[ 0+5510] =8'b00010101;
           rom[ 0+5511] =8'b11001011;
           rom[ 0+5512] =8'b00111010;
           rom[ 0+5513] =8'b00111101;
           rom[ 0+5514] =8'b11000010;
           rom[ 0+5515] =8'b10000111;
           rom[ 0+5516] =8'b00010101;
           rom[ 0+5517] =8'b01111010;
           rom[ 0+5518] =8'b11100110;
           rom[ 0+5519] =8'b00000001;
           rom[ 0+5520] =8'b01010111;
           rom[ 0+5521] =8'b01111011;
           rom[ 0+5522] =8'b10101010;
           rom[ 0+5523] =8'b00000010;
           rom[ 0+5524] =8'b11011101;
           rom[ 0+5525] =8'b00110100;
           rom[ 0+5526] =8'b11111100;
           rom[ 0+5527] =8'b11000010;
           rom[ 0+5528] =8'b10011101;
           rom[ 0+5529] =8'b00010101;
           rom[ 0+5530] =8'b11011101;
           rom[ 0+5531] =8'b00110100;
           rom[ 0+5532] =8'b11111101;
           rom[ 0+5533] =8'b11000011;
           rom[ 0+5534] =8'b01101010;
           rom[ 0+5535] =8'b00010101;
           rom[ 0+5536] =8'b11011101;
           rom[ 0+5537] =8'b00110100;
           rom[ 0+5538] =8'b11111110;
           rom[ 0+5539] =8'b11000010;
           rom[ 0+5540] =8'b10101001;
           rom[ 0+5541] =8'b00010101;
           rom[ 0+5542] =8'b11011101;
           rom[ 0+5543] =8'b00110100;
           rom[ 0+5544] =8'b11111111;
           rom[ 0+5545] =8'b11000011;
           rom[ 0+5546] =8'b00011100;
           rom[ 0+5547] =8'b00010101;
           rom[ 0+5548] =8'b00011110;
           rom[ 0+5549] =8'b00000000;
           rom[ 0+5550] =8'b11011101;
           rom[ 0+5551] =8'b00110110;
           rom[ 0+5552] =8'b11111110;
           rom[ 0+5553] =8'b00000000;
           rom[ 0+5554] =8'b11011101;
           rom[ 0+5555] =8'b00110110;
           rom[ 0+5556] =8'b11111111;
           rom[ 0+5557] =8'b00000000;
           rom[ 0+5558] =8'b11011101;
           rom[ 0+5559] =8'b01111110;
           rom[ 0+5560] =8'b11111110;
           rom[ 0+5561] =8'b11010110;
           rom[ 0+5562] =8'b00001000;
           rom[ 0+5563] =8'b11011101;
           rom[ 0+5564] =8'b01111110;
           rom[ 0+5565] =8'b11111111;
           rom[ 0+5566] =8'b11011110;
           rom[ 0+5567] =8'b00000000;
           rom[ 0+5568] =8'b11110010;
           rom[ 0+5569] =8'b11111010;
           rom[ 0+5570] =8'b00010101;
           rom[ 0+5571] =8'b11011101;
           rom[ 0+5572] =8'b01111110;
           rom[ 0+5573] =8'b11100110;
           rom[ 0+5574] =8'b11011101;
           rom[ 0+5575] =8'b10000110;
           rom[ 0+5576] =8'b11111110;
           rom[ 0+5577] =8'b01000111;
           rom[ 0+5578] =8'b11011101;
           rom[ 0+5579] =8'b01111110;
           rom[ 0+5580] =8'b11100111;
           rom[ 0+5581] =8'b11011101;
           rom[ 0+5582] =8'b10001110;
           rom[ 0+5583] =8'b11111111;
           rom[ 0+5584] =8'b01001111;
           rom[ 0+5585] =8'b01101000;
           rom[ 0+5586] =8'b01100001;
           rom[ 0+5587] =8'b01000110;
           rom[ 0+5588] =8'b00001110;
           rom[ 0+5589] =8'b00000000;
           rom[ 0+5590] =8'b11011101;
           rom[ 0+5591] =8'b01111110;
           rom[ 0+5592] =8'b11111110;
           rom[ 0+5593] =8'b00111100;
           rom[ 0+5594] =8'b11000011;
           rom[ 0+5595] =8'b11100001;
           rom[ 0+5596] =8'b00010101;
           rom[ 0+5597] =8'b11001011;
           rom[ 0+5598] =8'b00100000;
           rom[ 0+5599] =8'b11001011;
           rom[ 0+5600] =8'b00010001;
           rom[ 0+5601] =8'b00111101;
           rom[ 0+5602] =8'b11000010;
           rom[ 0+5603] =8'b11011101;
           rom[ 0+5604] =8'b00010101;
           rom[ 0+5605] =8'b00010110;
           rom[ 0+5606] =8'b00000000;
           rom[ 0+5607] =8'b01111000;
           rom[ 0+5608] =8'b10110011;
           rom[ 0+5609] =8'b01000111;
           rom[ 0+5610] =8'b01111001;
           rom[ 0+5611] =8'b10110010;
           rom[ 0+5612] =8'b01001111;
           rom[ 0+5613] =8'b01011000;
           rom[ 0+5614] =8'b11011101;
           rom[ 0+5615] =8'b00110100;
           rom[ 0+5616] =8'b11111110;
           rom[ 0+5617] =8'b11000010;
           rom[ 0+5618] =8'b11110111;
           rom[ 0+5619] =8'b00010101;
           rom[ 0+5620] =8'b11011101;
           rom[ 0+5621] =8'b00110100;
           rom[ 0+5622] =8'b11111111;
           rom[ 0+5623] =8'b11000011;
           rom[ 0+5624] =8'b10110110;
           rom[ 0+5625] =8'b00010101;
           rom[ 0+5626] =8'b01101011;
           rom[ 0+5627] =8'b11011101;
           rom[ 0+5628] =8'b11111001;
           rom[ 0+5629] =8'b11011101;
           rom[ 0+5630] =8'b11100001;
           rom[ 0+5631] =8'b11001001;
           rom[ 0+5632] =8'b11011101;
           rom[ 0+5633] =8'b11100101;
           rom[ 0+5634] =8'b11011101;
           rom[ 0+5635] =8'b00100001;
           rom[ 0+5636] =8'b00000000;
           rom[ 0+5637] =8'b00000000;
           rom[ 0+5638] =8'b11011101;
           rom[ 0+5639] =8'b00111001;
           rom[ 0+5640] =8'b00100001;
           rom[ 0+5641] =8'b11111110;
           rom[ 0+5642] =8'b11111111;
           rom[ 0+5643] =8'b00111001;
           rom[ 0+5644] =8'b11111001;
           rom[ 0+5645] =8'b00000001;
           rom[ 0+5646] =8'b00000101;
           rom[ 0+5647] =8'b00000000;
           rom[ 0+5648] =8'b00001011;
           rom[ 0+5649] =8'b01011001;
           rom[ 0+5650] =8'b01010000;
           rom[ 0+5651] =8'b01101011;
           rom[ 0+5652] =8'b01100010;
           rom[ 0+5653] =8'b00101001;
           rom[ 0+5654] =8'b00011001;
           rom[ 0+5655] =8'b00101001;
           rom[ 0+5656] =8'b00011001;
           rom[ 0+5657] =8'b01011101;
           rom[ 0+5658] =8'b01010100;
           rom[ 0+5659] =8'b00100001;
           rom[ 0+5660] =8'b00000110;
           rom[ 0+5661] =8'b10010000;
           rom[ 0+5662] =8'b00011001;
           rom[ 0+5663] =8'b11011101;
           rom[ 0+5664] =8'b01110101;
           rom[ 0+5665] =8'b11111110;
           rom[ 0+5666] =8'b11011101;
           rom[ 0+5667] =8'b01110100;
           rom[ 0+5668] =8'b11111111;
           rom[ 0+5669] =8'b11011101;
           rom[ 0+5670] =8'b01111110;
           rom[ 0+5671] =8'b11111110;
           rom[ 0+5672] =8'b11000110;
           rom[ 0+5673] =8'b00000110;
           rom[ 0+5674] =8'b01011111;
           rom[ 0+5675] =8'b11011101;
           rom[ 0+5676] =8'b01111110;
           rom[ 0+5677] =8'b11111111;
           rom[ 0+5678] =8'b11001110;
           rom[ 0+5679] =8'b00000000;
           rom[ 0+5680] =8'b01010111;
           rom[ 0+5681] =8'b00111110;
           rom[ 0+5682] =8'b00000000;
           rom[ 0+5683] =8'b00010010;
           rom[ 0+5684] =8'b11011101;
           rom[ 0+5685] =8'b01111110;
           rom[ 0+5686] =8'b11111110;
           rom[ 0+5687] =8'b11000110;
           rom[ 0+5688] =8'b00000101;
           rom[ 0+5689] =8'b01011111;
           rom[ 0+5690] =8'b11011101;
           rom[ 0+5691] =8'b01111110;
           rom[ 0+5692] =8'b11111111;
           rom[ 0+5693] =8'b11001110;
           rom[ 0+5694] =8'b00000000;
           rom[ 0+5695] =8'b01010111;
           rom[ 0+5696] =8'b00111110;
           rom[ 0+5697] =8'b00000000;
           rom[ 0+5698] =8'b00010010;
           rom[ 0+5699] =8'b11011101;
           rom[ 0+5700] =8'b01111110;
           rom[ 0+5701] =8'b11111110;
           rom[ 0+5702] =8'b11000110;
           rom[ 0+5703] =8'b00000100;
           rom[ 0+5704] =8'b01011111;
           rom[ 0+5705] =8'b11011101;
           rom[ 0+5706] =8'b01111110;
           rom[ 0+5707] =8'b11111111;
           rom[ 0+5708] =8'b11001110;
           rom[ 0+5709] =8'b00000000;
           rom[ 0+5710] =8'b01010111;
           rom[ 0+5711] =8'b00111110;
           rom[ 0+5712] =8'b00000000;
           rom[ 0+5713] =8'b00010010;
           rom[ 0+5714] =8'b11011101;
           rom[ 0+5715] =8'b01111110;
           rom[ 0+5716] =8'b11111110;
           rom[ 0+5717] =8'b11000110;
           rom[ 0+5718] =8'b00000011;
           rom[ 0+5719] =8'b01011111;
           rom[ 0+5720] =8'b11011101;
           rom[ 0+5721] =8'b01111110;
           rom[ 0+5722] =8'b11111111;
           rom[ 0+5723] =8'b11001110;
           rom[ 0+5724] =8'b00000000;
           rom[ 0+5725] =8'b01010111;
           rom[ 0+5726] =8'b00111110;
           rom[ 0+5727] =8'b00000000;
           rom[ 0+5728] =8'b00010010;
           rom[ 0+5729] =8'b11011101;
           rom[ 0+5730] =8'b01011110;
           rom[ 0+5731] =8'b11111110;
           rom[ 0+5732] =8'b11011101;
           rom[ 0+5733] =8'b01010110;
           rom[ 0+5734] =8'b11111111;
           rom[ 0+5735] =8'b00010011;
           rom[ 0+5736] =8'b00010011;
           rom[ 0+5737] =8'b00111110;
           rom[ 0+5738] =8'b00000000;
           rom[ 0+5739] =8'b00010010;
           rom[ 0+5740] =8'b11011101;
           rom[ 0+5741] =8'b01011110;
           rom[ 0+5742] =8'b11111110;
           rom[ 0+5743] =8'b11011101;
           rom[ 0+5744] =8'b01010110;
           rom[ 0+5745] =8'b11111111;
           rom[ 0+5746] =8'b00010011;
           rom[ 0+5747] =8'b00111110;
           rom[ 0+5748] =8'b00000000;
           rom[ 0+5749] =8'b00010010;
           rom[ 0+5750] =8'b11011101;
           rom[ 0+5751] =8'b01101110;
           rom[ 0+5752] =8'b11111110;
           rom[ 0+5753] =8'b11011101;
           rom[ 0+5754] =8'b01100110;
           rom[ 0+5755] =8'b11111111;
           rom[ 0+5756] =8'b00110110;
           rom[ 0+5757] =8'b00000000;
           rom[ 0+5758] =8'b01011001;
           rom[ 0+5759] =8'b01010000;
           rom[ 0+5760] =8'b01111001;
           rom[ 0+5761] =8'b10110000;
           rom[ 0+5762] =8'b11000010;
           rom[ 0+5763] =8'b00010000;
           rom[ 0+5764] =8'b00010110;
           rom[ 0+5765] =8'b11011101;
           rom[ 0+5766] =8'b11111001;
           rom[ 0+5767] =8'b11011101;
           rom[ 0+5768] =8'b11100001;
           rom[ 0+5769] =8'b11001001;
           rom[ 0+5770] =8'b11011101;
           rom[ 0+5771] =8'b11100101;
           rom[ 0+5772] =8'b11011101;
           rom[ 0+5773] =8'b00100001;
           rom[ 0+5774] =8'b00000000;
           rom[ 0+5775] =8'b00000000;
           rom[ 0+5776] =8'b11011101;
           rom[ 0+5777] =8'b00111001;
           rom[ 0+5778] =8'b00100001;
           rom[ 0+5779] =8'b11111100;
           rom[ 0+5780] =8'b11111111;
           rom[ 0+5781] =8'b00111001;
           rom[ 0+5782] =8'b11111001;
           rom[ 0+5783] =8'b11011101;
           rom[ 0+5784] =8'b00110110;
           rom[ 0+5785] =8'b11111110;
           rom[ 0+5786] =8'b00000000;
           rom[ 0+5787] =8'b11011101;
           rom[ 0+5788] =8'b00110110;
           rom[ 0+5789] =8'b11111111;
           rom[ 0+5790] =8'b00000000;
           rom[ 0+5791] =8'b11011101;
           rom[ 0+5792] =8'b00110110;
           rom[ 0+5793] =8'b11111100;
           rom[ 0+5794] =8'b00000000;
           rom[ 0+5795] =8'b11011101;
           rom[ 0+5796] =8'b00110110;
           rom[ 0+5797] =8'b11111101;
           rom[ 0+5798] =8'b00000000;
           rom[ 0+5799] =8'b11011101;
           rom[ 0+5800] =8'b01111110;
           rom[ 0+5801] =8'b11111100;
           rom[ 0+5802] =8'b11010110;
           rom[ 0+5803] =8'b00101111;
           rom[ 0+5804] =8'b11011101;
           rom[ 0+5805] =8'b01111110;
           rom[ 0+5806] =8'b11111101;
           rom[ 0+5807] =8'b11011110;
           rom[ 0+5808] =8'b00000000;
           rom[ 0+5809] =8'b11110010;
           rom[ 0+5810] =8'b11110010;
           rom[ 0+5811] =8'b00010110;
           rom[ 0+5812] =8'b00111110;
           rom[ 0+5813] =8'b00011110;
           rom[ 0+5814] =8'b11011101;
           rom[ 0+5815] =8'b10000110;
           rom[ 0+5816] =8'b11111100;
           rom[ 0+5817] =8'b01001111;
           rom[ 0+5818] =8'b00111110;
           rom[ 0+5819] =8'b10001100;
           rom[ 0+5820] =8'b11011101;
           rom[ 0+5821] =8'b10001110;
           rom[ 0+5822] =8'b11111101;
           rom[ 0+5823] =8'b01000111;
           rom[ 0+5824] =8'b00001010;
           rom[ 0+5825] =8'b01001111;
           rom[ 0+5826] =8'b00111110;
           rom[ 0+5827] =8'b00110110;
           rom[ 0+5828] =8'b11011101;
           rom[ 0+5829] =8'b10000110;
           rom[ 0+5830] =8'b11111100;
           rom[ 0+5831] =8'b01000111;
           rom[ 0+5832] =8'b00111110;
           rom[ 0+5833] =8'b10001000;
           rom[ 0+5834] =8'b11011101;
           rom[ 0+5835] =8'b10001110;
           rom[ 0+5836] =8'b11111101;
           rom[ 0+5837] =8'b01011111;
           rom[ 0+5838] =8'b01101000;
           rom[ 0+5839] =8'b01100011;
           rom[ 0+5840] =8'b01000110;
           rom[ 0+5841] =8'b01111001;
           rom[ 0+5842] =8'b10111000;
           rom[ 0+5843] =8'b11001010;
           rom[ 0+5844] =8'b11100110;
           rom[ 0+5845] =8'b00010110;
           rom[ 0+5846] =8'b00100001;
           rom[ 0+5847] =8'b00001000;
           rom[ 0+5848] =8'b00010111;
           rom[ 0+5849] =8'b11100101;
           rom[ 0+5850] =8'b11001101;
           rom[ 0+5851] =8'b00001010;
           rom[ 0+5852] =8'b00000010;
           rom[ 0+5853] =8'b11110001;
           rom[ 0+5854] =8'b11011101;
           rom[ 0+5855] =8'b00110110;
           rom[ 0+5856] =8'b11111110;
           rom[ 0+5857] =8'b00000001;
           rom[ 0+5858] =8'b11011101;
           rom[ 0+5859] =8'b00110110;
           rom[ 0+5860] =8'b11111111;
           rom[ 0+5861] =8'b00000000;
           rom[ 0+5862] =8'b11011101;
           rom[ 0+5863] =8'b00110100;
           rom[ 0+5864] =8'b11111100;
           rom[ 0+5865] =8'b11000010;
           rom[ 0+5866] =8'b11101111;
           rom[ 0+5867] =8'b00010110;
           rom[ 0+5868] =8'b11011101;
           rom[ 0+5869] =8'b00110100;
           rom[ 0+5870] =8'b11111101;
           rom[ 0+5871] =8'b11000011;
           rom[ 0+5872] =8'b10100111;
           rom[ 0+5873] =8'b00010110;
           rom[ 0+5874] =8'b11011101;
           rom[ 0+5875] =8'b01111110;
           rom[ 0+5876] =8'b11111110;
           rom[ 0+5877] =8'b11011101;
           rom[ 0+5878] =8'b10110110;
           rom[ 0+5879] =8'b11111111;
           rom[ 0+5880] =8'b11000010;
           rom[ 0+5881] =8'b00000011;
           rom[ 0+5882] =8'b00010111;
           rom[ 0+5883] =8'b00100001;
           rom[ 0+5884] =8'b00100001;
           rom[ 0+5885] =8'b00010111;
           rom[ 0+5886] =8'b11100101;
           rom[ 0+5887] =8'b11001101;
           rom[ 0+5888] =8'b00001010;
           rom[ 0+5889] =8'b00000010;
           rom[ 0+5890] =8'b11110001;
           rom[ 0+5891] =8'b11011101;
           rom[ 0+5892] =8'b11111001;
           rom[ 0+5893] =8'b11011101;
           rom[ 0+5894] =8'b11100001;
           rom[ 0+5895] =8'b11001001;
           rom[ 0+5896] =8'b01000011;
           rom[ 0+5897] =8'b01101111;
           rom[ 0+5898] =8'b01101101;
           rom[ 0+5899] =8'b01110000;
           rom[ 0+5900] =8'b01100001;
           rom[ 0+5901] =8'b01110010;
           rom[ 0+5902] =8'b01100101;
           rom[ 0+5903] =8'b00100000;
           rom[ 0+5904] =8'b01000101;
           rom[ 0+5905] =8'b01110010;
           rom[ 0+5906] =8'b01110010;
           rom[ 0+5907] =8'b01101111;
           rom[ 0+5908] =8'b01110010;
           rom[ 0+5909] =8'b00100000;
           rom[ 0+5910] =8'b01001111;
           rom[ 0+5911] =8'b01100011;
           rom[ 0+5912] =8'b01100011;
           rom[ 0+5913] =8'b01110101;
           rom[ 0+5914] =8'b01110010;
           rom[ 0+5915] =8'b01110010;
           rom[ 0+5916] =8'b01100101;
           rom[ 0+5917] =8'b01100100;
           rom[ 0+5918] =8'b00101110;
           rom[ 0+5919] =8'b00001010;
           rom[ 0+5920] =8'b00000000;
           rom[ 0+5921] =8'b01000011;
           rom[ 0+5922] =8'b01101111;
           rom[ 0+5923] =8'b01101101;
           rom[ 0+5924] =8'b01110000;
           rom[ 0+5925] =8'b01100001;
           rom[ 0+5926] =8'b01110010;
           rom[ 0+5927] =8'b01100101;
           rom[ 0+5928] =8'b00100000;
           rom[ 0+5929] =8'b01000100;
           rom[ 0+5930] =8'b01101111;
           rom[ 0+5931] =8'b01101110;
           rom[ 0+5932] =8'b01100101;
           rom[ 0+5933] =8'b00100000;
           rom[ 0+5934] =8'b01110011;
           rom[ 0+5935] =8'b01110101;
           rom[ 0+5936] =8'b01100011;
           rom[ 0+5937] =8'b01100011;
           rom[ 0+5938] =8'b01100101;
           rom[ 0+5939] =8'b01110011;
           rom[ 0+5940] =8'b01110011;
           rom[ 0+5941] =8'b01100110;
           rom[ 0+5942] =8'b01110101;
           rom[ 0+5943] =8'b01101100;
           rom[ 0+5944] =8'b01101100;
           rom[ 0+5945] =8'b01111001;
           rom[ 0+5946] =8'b00001010;
           rom[ 0+5947] =8'b00000000;
           rom[ 0+5948] =8'b11011101;
           rom[ 0+5949] =8'b11100101;
           rom[ 0+5950] =8'b11011101;
           rom[ 0+5951] =8'b00100001;
           rom[ 0+5952] =8'b00000000;
           rom[ 0+5953] =8'b00000000;
           rom[ 0+5954] =8'b11011101;
           rom[ 0+5955] =8'b00111001;
           rom[ 0+5956] =8'b00100001;
           rom[ 0+5957] =8'b11111001;
           rom[ 0+5958] =8'b11111111;
           rom[ 0+5959] =8'b00111001;
           rom[ 0+5960] =8'b11111001;
           rom[ 0+5961] =8'b11011101;
           rom[ 0+5962] =8'b01011110;
           rom[ 0+5963] =8'b00000100;
           rom[ 0+5964] =8'b11011101;
           rom[ 0+5965] =8'b01010110;
           rom[ 0+5966] =8'b00000101;
           rom[ 0+5967] =8'b01101011;
           rom[ 0+5968] =8'b01100010;
           rom[ 0+5969] =8'b00101001;
           rom[ 0+5970] =8'b00011001;
           rom[ 0+5971] =8'b00101001;
           rom[ 0+5972] =8'b00011001;
           rom[ 0+5973] =8'b01001101;
           rom[ 0+5974] =8'b01000100;
           rom[ 0+5975] =8'b00100001;
           rom[ 0+5976] =8'b00000110;
           rom[ 0+5977] =8'b10010000;
           rom[ 0+5978] =8'b00001001;
           rom[ 0+5979] =8'b01001101;
           rom[ 0+5980] =8'b01000100;
           rom[ 0+5981] =8'b01111001;
           rom[ 0+5982] =8'b11000110;
           rom[ 0+5983] =8'b00000110;
           rom[ 0+5984] =8'b11011101;
           rom[ 0+5985] =8'b01110111;
           rom[ 0+5986] =8'b11111101;
           rom[ 0+5987] =8'b01111000;
           rom[ 0+5988] =8'b11001110;
           rom[ 0+5989] =8'b00000000;
           rom[ 0+5990] =8'b11011101;
           rom[ 0+5991] =8'b01110111;
           rom[ 0+5992] =8'b11111110;
           rom[ 0+5993] =8'b11011101;
           rom[ 0+5994] =8'b01101110;
           rom[ 0+5995] =8'b11111101;
           rom[ 0+5996] =8'b11011101;
           rom[ 0+5997] =8'b01100110;
           rom[ 0+5998] =8'b11111110;
           rom[ 0+5999] =8'b01011110;
           rom[ 0+6000] =8'b01111011;
           rom[ 0+6001] =8'b11011101;
           rom[ 0+6002] =8'b10101110;
           rom[ 0+6003] =8'b00000110;
           rom[ 0+6004] =8'b01011111;
           rom[ 0+6005] =8'b11011101;
           rom[ 0+6006] =8'b01110011;
           rom[ 0+6007] =8'b11111111;
           rom[ 0+6008] =8'b00111110;
           rom[ 0+6009] =8'b10011100;
           rom[ 0+6010] =8'b11011101;
           rom[ 0+6011] =8'b10000110;
           rom[ 0+6012] =8'b11111111;
           rom[ 0+6013] =8'b01010111;
           rom[ 0+6014] =8'b00111110;
           rom[ 0+6015] =8'b00001101;
           rom[ 0+6016] =8'b11001110;
           rom[ 0+6017] =8'b00000000;
           rom[ 0+6018] =8'b01011111;
           rom[ 0+6019] =8'b01101010;
           rom[ 0+6020] =8'b01100011;
           rom[ 0+6021] =8'b01010110;
           rom[ 0+6022] =8'b01111001;
           rom[ 0+6023] =8'b11000110;
           rom[ 0+6024] =8'b00000101;
           rom[ 0+6025] =8'b11011101;
           rom[ 0+6026] =8'b01110111;
           rom[ 0+6027] =8'b11111011;
           rom[ 0+6028] =8'b01111000;
           rom[ 0+6029] =8'b11001110;
           rom[ 0+6030] =8'b00000000;
           rom[ 0+6031] =8'b11011101;
           rom[ 0+6032] =8'b01110111;
           rom[ 0+6033] =8'b11111100;
           rom[ 0+6034] =8'b11011101;
           rom[ 0+6035] =8'b01101110;
           rom[ 0+6036] =8'b11111011;
           rom[ 0+6037] =8'b11011101;
           rom[ 0+6038] =8'b01100110;
           rom[ 0+6039] =8'b11111100;
           rom[ 0+6040] =8'b01011110;
           rom[ 0+6041] =8'b01111010;
           rom[ 0+6042] =8'b10101011;
           rom[ 0+6043] =8'b11011101;
           rom[ 0+6044] =8'b01101110;
           rom[ 0+6045] =8'b11111101;
           rom[ 0+6046] =8'b11011101;
           rom[ 0+6047] =8'b01100110;
           rom[ 0+6048] =8'b11111110;
           rom[ 0+6049] =8'b01110111;
           rom[ 0+6050] =8'b00111110;
           rom[ 0+6051] =8'b10011100;
           rom[ 0+6052] =8'b11011101;
           rom[ 0+6053] =8'b10000110;
           rom[ 0+6054] =8'b11111111;
           rom[ 0+6055] =8'b01011111;
           rom[ 0+6056] =8'b00111110;
           rom[ 0+6057] =8'b00001100;
           rom[ 0+6058] =8'b11001110;
           rom[ 0+6059] =8'b00000000;
           rom[ 0+6060] =8'b01010111;
           rom[ 0+6061] =8'b00011010;
           rom[ 0+6062] =8'b01010111;
           rom[ 0+6063] =8'b01111001;
           rom[ 0+6064] =8'b11000110;
           rom[ 0+6065] =8'b00000100;
           rom[ 0+6066] =8'b11011101;
           rom[ 0+6067] =8'b01110111;
           rom[ 0+6068] =8'b11111101;
           rom[ 0+6069] =8'b01111000;
           rom[ 0+6070] =8'b11001110;
           rom[ 0+6071] =8'b00000000;
           rom[ 0+6072] =8'b11011101;
           rom[ 0+6073] =8'b01110111;
           rom[ 0+6074] =8'b11111110;
           rom[ 0+6075] =8'b11011101;
           rom[ 0+6076] =8'b01101110;
           rom[ 0+6077] =8'b11111101;
           rom[ 0+6078] =8'b11011101;
           rom[ 0+6079] =8'b01100110;
           rom[ 0+6080] =8'b11111110;
           rom[ 0+6081] =8'b01011110;
           rom[ 0+6082] =8'b01111010;
           rom[ 0+6083] =8'b10101011;
           rom[ 0+6084] =8'b11011101;
           rom[ 0+6085] =8'b01101110;
           rom[ 0+6086] =8'b11111011;
           rom[ 0+6087] =8'b11011101;
           rom[ 0+6088] =8'b01100110;
           rom[ 0+6089] =8'b11111100;
           rom[ 0+6090] =8'b01110111;
           rom[ 0+6091] =8'b00111110;
           rom[ 0+6092] =8'b10011100;
           rom[ 0+6093] =8'b11011101;
           rom[ 0+6094] =8'b10000110;
           rom[ 0+6095] =8'b11111111;
           rom[ 0+6096] =8'b01011111;
           rom[ 0+6097] =8'b00111110;
           rom[ 0+6098] =8'b00001011;
           rom[ 0+6099] =8'b11001110;
           rom[ 0+6100] =8'b00000000;
           rom[ 0+6101] =8'b01010111;
           rom[ 0+6102] =8'b00011010;
           rom[ 0+6103] =8'b01010111;
           rom[ 0+6104] =8'b01111001;
           rom[ 0+6105] =8'b11000110;
           rom[ 0+6106] =8'b00000011;
           rom[ 0+6107] =8'b11011101;
           rom[ 0+6108] =8'b01110111;
           rom[ 0+6109] =8'b11111001;
           rom[ 0+6110] =8'b01111000;
           rom[ 0+6111] =8'b11001110;
           rom[ 0+6112] =8'b00000000;
           rom[ 0+6113] =8'b11011101;
           rom[ 0+6114] =8'b01110111;
           rom[ 0+6115] =8'b11111010;
           rom[ 0+6116] =8'b11011101;
           rom[ 0+6117] =8'b01101110;
           rom[ 0+6118] =8'b11111001;
           rom[ 0+6119] =8'b11011101;
           rom[ 0+6120] =8'b01100110;
           rom[ 0+6121] =8'b11111010;
           rom[ 0+6122] =8'b01011110;
           rom[ 0+6123] =8'b01111010;
           rom[ 0+6124] =8'b10101011;
           rom[ 0+6125] =8'b11011101;
           rom[ 0+6126] =8'b01101110;
           rom[ 0+6127] =8'b11111101;
           rom[ 0+6128] =8'b11011101;
           rom[ 0+6129] =8'b01100110;
           rom[ 0+6130] =8'b11111110;
           rom[ 0+6131] =8'b01110111;
           rom[ 0+6132] =8'b00111110;
           rom[ 0+6133] =8'b10011100;
           rom[ 0+6134] =8'b11011101;
           rom[ 0+6135] =8'b10000110;
           rom[ 0+6136] =8'b11111111;
           rom[ 0+6137] =8'b01011111;
           rom[ 0+6138] =8'b00111110;
           rom[ 0+6139] =8'b00001010;
           rom[ 0+6140] =8'b11001110;
           rom[ 0+6141] =8'b00000000;
           rom[ 0+6142] =8'b01010111;
           rom[ 0+6143] =8'b00011010;
           rom[ 0+6144] =8'b01010111;
           rom[ 0+6145] =8'b01111001;
           rom[ 0+6146] =8'b11000110;
           rom[ 0+6147] =8'b00000010;
           rom[ 0+6148] =8'b11011101;
           rom[ 0+6149] =8'b01110111;
           rom[ 0+6150] =8'b11111101;
           rom[ 0+6151] =8'b01111000;
           rom[ 0+6152] =8'b11001110;
           rom[ 0+6153] =8'b00000000;
           rom[ 0+6154] =8'b11011101;
           rom[ 0+6155] =8'b01110111;
           rom[ 0+6156] =8'b11111110;
           rom[ 0+6157] =8'b11011101;
           rom[ 0+6158] =8'b01101110;
           rom[ 0+6159] =8'b11111101;
           rom[ 0+6160] =8'b11011101;
           rom[ 0+6161] =8'b01100110;
           rom[ 0+6162] =8'b11111110;
           rom[ 0+6163] =8'b01011110;
           rom[ 0+6164] =8'b01111010;
           rom[ 0+6165] =8'b10101011;
           rom[ 0+6166] =8'b11011101;
           rom[ 0+6167] =8'b01101110;
           rom[ 0+6168] =8'b11111001;
           rom[ 0+6169] =8'b11011101;
           rom[ 0+6170] =8'b01100110;
           rom[ 0+6171] =8'b11111010;
           rom[ 0+6172] =8'b01110111;
           rom[ 0+6173] =8'b00111110;
           rom[ 0+6174] =8'b10011100;
           rom[ 0+6175] =8'b11011101;
           rom[ 0+6176] =8'b10000110;
           rom[ 0+6177] =8'b11111111;
           rom[ 0+6178] =8'b01011111;
           rom[ 0+6179] =8'b00111110;
           rom[ 0+6180] =8'b00001001;
           rom[ 0+6181] =8'b11001110;
           rom[ 0+6182] =8'b00000000;
           rom[ 0+6183] =8'b01010111;
           rom[ 0+6184] =8'b00011010;
           rom[ 0+6185] =8'b01010111;
           rom[ 0+6186] =8'b01111001;
           rom[ 0+6187] =8'b11000110;
           rom[ 0+6188] =8'b00000001;
           rom[ 0+6189] =8'b11011101;
           rom[ 0+6190] =8'b01110111;
           rom[ 0+6191] =8'b11111011;
           rom[ 0+6192] =8'b01111000;
           rom[ 0+6193] =8'b11001110;
           rom[ 0+6194] =8'b00000000;
           rom[ 0+6195] =8'b11011101;
           rom[ 0+6196] =8'b01110111;
           rom[ 0+6197] =8'b11111100;
           rom[ 0+6198] =8'b11011101;
           rom[ 0+6199] =8'b01101110;
           rom[ 0+6200] =8'b11111011;
           rom[ 0+6201] =8'b11011101;
           rom[ 0+6202] =8'b01100110;
           rom[ 0+6203] =8'b11111100;
           rom[ 0+6204] =8'b01011110;
           rom[ 0+6205] =8'b01111010;
           rom[ 0+6206] =8'b10101011;
           rom[ 0+6207] =8'b11011101;
           rom[ 0+6208] =8'b01101110;
           rom[ 0+6209] =8'b11111101;
           rom[ 0+6210] =8'b11011101;
           rom[ 0+6211] =8'b01100110;
           rom[ 0+6212] =8'b11111110;
           rom[ 0+6213] =8'b01110111;
           rom[ 0+6214] =8'b00111110;
           rom[ 0+6215] =8'b10011100;
           rom[ 0+6216] =8'b11011101;
           rom[ 0+6217] =8'b10000110;
           rom[ 0+6218] =8'b11111111;
           rom[ 0+6219] =8'b01011111;
           rom[ 0+6220] =8'b00111110;
           rom[ 0+6221] =8'b00001000;
           rom[ 0+6222] =8'b11001110;
           rom[ 0+6223] =8'b00000000;
           rom[ 0+6224] =8'b01010111;
           rom[ 0+6225] =8'b00011010;
           rom[ 0+6226] =8'b01011111;
           rom[ 0+6227] =8'b00001010;
           rom[ 0+6228] =8'b01010111;
           rom[ 0+6229] =8'b01111011;
           rom[ 0+6230] =8'b10101010;
           rom[ 0+6231] =8'b11011101;
           rom[ 0+6232] =8'b01101110;
           rom[ 0+6233] =8'b11111011;
           rom[ 0+6234] =8'b11011101;
           rom[ 0+6235] =8'b01100110;
           rom[ 0+6236] =8'b11111100;
           rom[ 0+6237] =8'b01110111;
           rom[ 0+6238] =8'b00111110;
           rom[ 0+6239] =8'b10011100;
           rom[ 0+6240] =8'b11011101;
           rom[ 0+6241] =8'b10000110;
           rom[ 0+6242] =8'b11111111;
           rom[ 0+6243] =8'b01011111;
           rom[ 0+6244] =8'b00111110;
           rom[ 0+6245] =8'b00000111;
           rom[ 0+6246] =8'b11001110;
           rom[ 0+6247] =8'b00000000;
           rom[ 0+6248] =8'b01010111;
           rom[ 0+6249] =8'b00011010;
           rom[ 0+6250] =8'b00000010;
           rom[ 0+6251] =8'b11011101;
           rom[ 0+6252] =8'b11111001;
           rom[ 0+6253] =8'b11011101;
           rom[ 0+6254] =8'b11100001;
           rom[ 0+6255] =8'b11001001;
           rom[ 0+6256] =8'b11011101;
           rom[ 0+6257] =8'b11100101;
           rom[ 0+6258] =8'b11011101;
           rom[ 0+6259] =8'b00100001;
           rom[ 0+6260] =8'b00000000;
           rom[ 0+6261] =8'b00000000;
           rom[ 0+6262] =8'b11011101;
           rom[ 0+6263] =8'b00111001;
           rom[ 0+6264] =8'b00100001;
           rom[ 0+6265] =8'b11111110;
           rom[ 0+6266] =8'b11111111;
           rom[ 0+6267] =8'b00111001;
           rom[ 0+6268] =8'b11111001;
           rom[ 0+6269] =8'b11011101;
           rom[ 0+6270] =8'b01011110;
           rom[ 0+6271] =8'b00000100;
           rom[ 0+6272] =8'b11011101;
           rom[ 0+6273] =8'b01010110;
           rom[ 0+6274] =8'b00000101;
           rom[ 0+6275] =8'b01101011;
           rom[ 0+6276] =8'b01100010;
           rom[ 0+6277] =8'b00101001;
           rom[ 0+6278] =8'b00011001;
           rom[ 0+6279] =8'b00101001;
           rom[ 0+6280] =8'b00011001;
           rom[ 0+6281] =8'b01001101;
           rom[ 0+6282] =8'b01000100;
           rom[ 0+6283] =8'b00100001;
           rom[ 0+6284] =8'b00000110;
           rom[ 0+6285] =8'b10010000;
           rom[ 0+6286] =8'b00001001;
           rom[ 0+6287] =8'b01001101;
           rom[ 0+6288] =8'b01000100;
           rom[ 0+6289] =8'b00001010;
           rom[ 0+6290] =8'b01011111;
           rom[ 0+6291] =8'b11011101;
           rom[ 0+6292] =8'b01111110;
           rom[ 0+6293] =8'b00000110;
           rom[ 0+6294] =8'b10101011;
           rom[ 0+6295] =8'b00000010;
           rom[ 0+6296] =8'b01111001;
           rom[ 0+6297] =8'b11000110;
           rom[ 0+6298] =8'b00000001;
           rom[ 0+6299] =8'b11011101;
           rom[ 0+6300] =8'b01110111;
           rom[ 0+6301] =8'b11111110;
           rom[ 0+6302] =8'b01111000;
           rom[ 0+6303] =8'b11001110;
           rom[ 0+6304] =8'b00000000;
           rom[ 0+6305] =8'b11011101;
           rom[ 0+6306] =8'b01110111;
           rom[ 0+6307] =8'b11111111;
           rom[ 0+6308] =8'b11011101;
           rom[ 0+6309] =8'b01101110;
           rom[ 0+6310] =8'b11111110;
           rom[ 0+6311] =8'b11011101;
           rom[ 0+6312] =8'b01100110;
           rom[ 0+6313] =8'b11111111;
           rom[ 0+6314] =8'b01011110;
           rom[ 0+6315] =8'b00111110;
           rom[ 0+6316] =8'b10011100;
           rom[ 0+6317] =8'b10000011;
           rom[ 0+6318] =8'b01011111;
           rom[ 0+6319] =8'b00111110;
           rom[ 0+6320] =8'b00001110;
           rom[ 0+6321] =8'b11001110;
           rom[ 0+6322] =8'b00000000;
           rom[ 0+6323] =8'b01010111;
           rom[ 0+6324] =8'b00011010;
           rom[ 0+6325] =8'b01011111;
           rom[ 0+6326] =8'b11011101;
           rom[ 0+6327] =8'b01111110;
           rom[ 0+6328] =8'b00000110;
           rom[ 0+6329] =8'b10101011;
           rom[ 0+6330] =8'b11011101;
           rom[ 0+6331] =8'b01101110;
           rom[ 0+6332] =8'b11111110;
           rom[ 0+6333] =8'b11011101;
           rom[ 0+6334] =8'b01100110;
           rom[ 0+6335] =8'b11111111;
           rom[ 0+6336] =8'b01110111;
           rom[ 0+6337] =8'b01111001;
           rom[ 0+6338] =8'b11000110;
           rom[ 0+6339] =8'b00000010;
           rom[ 0+6340] =8'b11011101;
           rom[ 0+6341] =8'b01110111;
           rom[ 0+6342] =8'b11111110;
           rom[ 0+6343] =8'b01111000;
           rom[ 0+6344] =8'b11001110;
           rom[ 0+6345] =8'b00000000;
           rom[ 0+6346] =8'b11011101;
           rom[ 0+6347] =8'b01110111;
           rom[ 0+6348] =8'b11111111;
           rom[ 0+6349] =8'b11011101;
           rom[ 0+6350] =8'b01101110;
           rom[ 0+6351] =8'b11111110;
           rom[ 0+6352] =8'b11011101;
           rom[ 0+6353] =8'b01100110;
           rom[ 0+6354] =8'b11111111;
           rom[ 0+6355] =8'b01011110;
           rom[ 0+6356] =8'b00111110;
           rom[ 0+6357] =8'b10011100;
           rom[ 0+6358] =8'b10000011;
           rom[ 0+6359] =8'b01011111;
           rom[ 0+6360] =8'b00111110;
           rom[ 0+6361] =8'b00001111;
           rom[ 0+6362] =8'b11001110;
           rom[ 0+6363] =8'b00000000;
           rom[ 0+6364] =8'b01010111;
           rom[ 0+6365] =8'b00011010;
           rom[ 0+6366] =8'b01011111;
           rom[ 0+6367] =8'b11011101;
           rom[ 0+6368] =8'b01111110;
           rom[ 0+6369] =8'b00000110;
           rom[ 0+6370] =8'b10101011;
           rom[ 0+6371] =8'b11011101;
           rom[ 0+6372] =8'b01101110;
           rom[ 0+6373] =8'b11111110;
           rom[ 0+6374] =8'b11011101;
           rom[ 0+6375] =8'b01100110;
           rom[ 0+6376] =8'b11111111;
           rom[ 0+6377] =8'b01110111;
           rom[ 0+6378] =8'b01111001;
           rom[ 0+6379] =8'b11000110;
           rom[ 0+6380] =8'b00000011;
           rom[ 0+6381] =8'b11011101;
           rom[ 0+6382] =8'b01110111;
           rom[ 0+6383] =8'b11111110;
           rom[ 0+6384] =8'b01111000;
           rom[ 0+6385] =8'b11001110;
           rom[ 0+6386] =8'b00000000;
           rom[ 0+6387] =8'b11011101;
           rom[ 0+6388] =8'b01110111;
           rom[ 0+6389] =8'b11111111;
           rom[ 0+6390] =8'b11011101;
           rom[ 0+6391] =8'b01101110;
           rom[ 0+6392] =8'b11111110;
           rom[ 0+6393] =8'b11011101;
           rom[ 0+6394] =8'b01100110;
           rom[ 0+6395] =8'b11111111;
           rom[ 0+6396] =8'b01011110;
           rom[ 0+6397] =8'b00111110;
           rom[ 0+6398] =8'b10011100;
           rom[ 0+6399] =8'b10000011;
           rom[ 0+6400] =8'b01011111;
           rom[ 0+6401] =8'b00111110;
           rom[ 0+6402] =8'b00010000;
           rom[ 0+6403] =8'b11001110;
           rom[ 0+6404] =8'b00000000;
           rom[ 0+6405] =8'b01010111;
           rom[ 0+6406] =8'b00011010;
           rom[ 0+6407] =8'b01011111;
           rom[ 0+6408] =8'b11011101;
           rom[ 0+6409] =8'b01111110;
           rom[ 0+6410] =8'b00000110;
           rom[ 0+6411] =8'b10101011;
           rom[ 0+6412] =8'b11011101;
           rom[ 0+6413] =8'b01101110;
           rom[ 0+6414] =8'b11111110;
           rom[ 0+6415] =8'b11011101;
           rom[ 0+6416] =8'b01100110;
           rom[ 0+6417] =8'b11111111;
           rom[ 0+6418] =8'b01110111;
           rom[ 0+6419] =8'b01111001;
           rom[ 0+6420] =8'b11000110;
           rom[ 0+6421] =8'b00000100;
           rom[ 0+6422] =8'b11011101;
           rom[ 0+6423] =8'b01110111;
           rom[ 0+6424] =8'b11111110;
           rom[ 0+6425] =8'b01111000;
           rom[ 0+6426] =8'b11001110;
           rom[ 0+6427] =8'b00000000;
           rom[ 0+6428] =8'b11011101;
           rom[ 0+6429] =8'b01110111;
           rom[ 0+6430] =8'b11111111;
           rom[ 0+6431] =8'b11011101;
           rom[ 0+6432] =8'b01101110;
           rom[ 0+6433] =8'b11111110;
           rom[ 0+6434] =8'b11011101;
           rom[ 0+6435] =8'b01100110;
           rom[ 0+6436] =8'b11111111;
           rom[ 0+6437] =8'b01011110;
           rom[ 0+6438] =8'b00111110;
           rom[ 0+6439] =8'b10011100;
           rom[ 0+6440] =8'b10000011;
           rom[ 0+6441] =8'b01011111;
           rom[ 0+6442] =8'b00111110;
           rom[ 0+6443] =8'b00010001;
           rom[ 0+6444] =8'b11001110;
           rom[ 0+6445] =8'b00000000;
           rom[ 0+6446] =8'b01010111;
           rom[ 0+6447] =8'b00011010;
           rom[ 0+6448] =8'b01011111;
           rom[ 0+6449] =8'b11011101;
           rom[ 0+6450] =8'b01111110;
           rom[ 0+6451] =8'b00000110;
           rom[ 0+6452] =8'b10101011;
           rom[ 0+6453] =8'b11011101;
           rom[ 0+6454] =8'b01101110;
           rom[ 0+6455] =8'b11111110;
           rom[ 0+6456] =8'b11011101;
           rom[ 0+6457] =8'b01100110;
           rom[ 0+6458] =8'b11111111;
           rom[ 0+6459] =8'b01110111;
           rom[ 0+6460] =8'b01111001;
           rom[ 0+6461] =8'b11000110;
           rom[ 0+6462] =8'b00000101;
           rom[ 0+6463] =8'b11011101;
           rom[ 0+6464] =8'b01110111;
           rom[ 0+6465] =8'b11111110;
           rom[ 0+6466] =8'b01111000;
           rom[ 0+6467] =8'b11001110;
           rom[ 0+6468] =8'b00000000;
           rom[ 0+6469] =8'b11011101;
           rom[ 0+6470] =8'b01110111;
           rom[ 0+6471] =8'b11111111;
           rom[ 0+6472] =8'b11011101;
           rom[ 0+6473] =8'b01101110;
           rom[ 0+6474] =8'b11111110;
           rom[ 0+6475] =8'b11011101;
           rom[ 0+6476] =8'b01100110;
           rom[ 0+6477] =8'b11111111;
           rom[ 0+6478] =8'b01011110;
           rom[ 0+6479] =8'b00111110;
           rom[ 0+6480] =8'b10011100;
           rom[ 0+6481] =8'b10000011;
           rom[ 0+6482] =8'b01011111;
           rom[ 0+6483] =8'b00111110;
           rom[ 0+6484] =8'b00010010;
           rom[ 0+6485] =8'b11001110;
           rom[ 0+6486] =8'b00000000;
           rom[ 0+6487] =8'b01010111;
           rom[ 0+6488] =8'b00011010;
           rom[ 0+6489] =8'b01011111;
           rom[ 0+6490] =8'b11011101;
           rom[ 0+6491] =8'b01111110;
           rom[ 0+6492] =8'b00000110;
           rom[ 0+6493] =8'b10101011;
           rom[ 0+6494] =8'b11011101;
           rom[ 0+6495] =8'b01101110;
           rom[ 0+6496] =8'b11111110;
           rom[ 0+6497] =8'b11011101;
           rom[ 0+6498] =8'b01100110;
           rom[ 0+6499] =8'b11111111;
           rom[ 0+6500] =8'b01110111;
           rom[ 0+6501] =8'b01111001;
           rom[ 0+6502] =8'b11000110;
           rom[ 0+6503] =8'b00000110;
           rom[ 0+6504] =8'b01001111;
           rom[ 0+6505] =8'b01111000;
           rom[ 0+6506] =8'b11001110;
           rom[ 0+6507] =8'b00000000;
           rom[ 0+6508] =8'b01000111;
           rom[ 0+6509] =8'b00001010;
           rom[ 0+6510] =8'b01011111;
           rom[ 0+6511] =8'b00111110;
           rom[ 0+6512] =8'b10011100;
           rom[ 0+6513] =8'b10000011;
           rom[ 0+6514] =8'b01011111;
           rom[ 0+6515] =8'b00111110;
           rom[ 0+6516] =8'b00010011;
           rom[ 0+6517] =8'b11001110;
           rom[ 0+6518] =8'b00000000;
           rom[ 0+6519] =8'b01010111;
           rom[ 0+6520] =8'b00011010;
           rom[ 0+6521] =8'b01011111;
           rom[ 0+6522] =8'b11011101;
           rom[ 0+6523] =8'b01111110;
           rom[ 0+6524] =8'b00000110;
           rom[ 0+6525] =8'b10101011;
           rom[ 0+6526] =8'b00000010;
           rom[ 0+6527] =8'b11011101;
           rom[ 0+6528] =8'b11111001;
           rom[ 0+6529] =8'b11011101;
           rom[ 0+6530] =8'b11100001;
           rom[ 0+6531] =8'b11001001;
           rom[ 0+6532] =8'b11011101;
           rom[ 0+6533] =8'b11100101;
           rom[ 0+6534] =8'b11011101;
           rom[ 0+6535] =8'b00100001;
           rom[ 0+6536] =8'b00000000;
           rom[ 0+6537] =8'b00000000;
           rom[ 0+6538] =8'b11011101;
           rom[ 0+6539] =8'b00111001;
           rom[ 0+6540] =8'b11011101;
           rom[ 0+6541] =8'b01001110;
           rom[ 0+6542] =8'b00000110;
           rom[ 0+6543] =8'b01111001;
           rom[ 0+6544] =8'b11110101;
           rom[ 0+6545] =8'b00110011;
           rom[ 0+6546] =8'b01111001;
           rom[ 0+6547] =8'b11110101;
           rom[ 0+6548] =8'b00110011;
           rom[ 0+6549] =8'b11001101;
           rom[ 0+6550] =8'b10111100;
           rom[ 0+6551] =8'b00011001;
           rom[ 0+6552] =8'b01001101;
           rom[ 0+6553] =8'b11110001;
           rom[ 0+6554] =8'b11011101;
           rom[ 0+6555] =8'b01111110;
           rom[ 0+6556] =8'b00000100;
           rom[ 0+6557] =8'b11011101;
           rom[ 0+6558] =8'b10111110;
           rom[ 0+6559] =8'b00000110;
           rom[ 0+6560] =8'b11000010;
           rom[ 0+6561] =8'b10110001;
           rom[ 0+6562] =8'b00011001;
           rom[ 0+6563] =8'b11011101;
           rom[ 0+6564] =8'b01111110;
           rom[ 0+6565] =8'b00000101;
           rom[ 0+6566] =8'b11011101;
           rom[ 0+6567] =8'b10111110;
           rom[ 0+6568] =8'b00000111;
           rom[ 0+6569] =8'b11000010;
           rom[ 0+6570] =8'b10110001;
           rom[ 0+6571] =8'b00011001;
           rom[ 0+6572] =8'b00111110;
           rom[ 0+6573] =8'b00000001;
           rom[ 0+6574] =8'b11000011;
           rom[ 0+6575] =8'b10110010;
           rom[ 0+6576] =8'b00011001;
           rom[ 0+6577] =8'b10101111;
           rom[ 0+6578] =8'b01000111;
           rom[ 0+6579] =8'b01111001;
           rom[ 0+6580] =8'b10101000;
           rom[ 0+6581] =8'b01001111;
           rom[ 0+6582] =8'b01101001;
           rom[ 0+6583] =8'b00100110;
           rom[ 0+6584] =8'b00000000;
           rom[ 0+6585] =8'b11011101;
           rom[ 0+6586] =8'b11100001;
           rom[ 0+6587] =8'b11001001;
           rom[ 0+6588] =8'b11011101;
           rom[ 0+6589] =8'b11100101;
           rom[ 0+6590] =8'b11011101;
           rom[ 0+6591] =8'b00100001;
           rom[ 0+6592] =8'b00000000;
           rom[ 0+6593] =8'b00000000;
           rom[ 0+6594] =8'b11011101;
           rom[ 0+6595] =8'b00111001;
           rom[ 0+6596] =8'b00100001;
           rom[ 0+6597] =8'b11001111;
           rom[ 0+6598] =8'b11111111;
           rom[ 0+6599] =8'b00111001;
           rom[ 0+6600] =8'b11111001;
           rom[ 0+6601] =8'b11011101;
           rom[ 0+6602] =8'b01111110;
           rom[ 0+6603] =8'b00000100;
           rom[ 0+6604] =8'b11100110;
           rom[ 0+6605] =8'b00000001;
           rom[ 0+6606] =8'b11011101;
           rom[ 0+6607] =8'b01110111;
           rom[ 0+6608] =8'b11111111;
           rom[ 0+6609] =8'b11011101;
           rom[ 0+6610] =8'b01000110;
           rom[ 0+6611] =8'b00000100;
           rom[ 0+6612] =8'b11001011;
           rom[ 0+6613] =8'b00111000;
           rom[ 0+6614] =8'b01111000;
           rom[ 0+6615] =8'b11100110;
           rom[ 0+6616] =8'b00000001;
           rom[ 0+6617] =8'b11011101;
           rom[ 0+6618] =8'b01110111;
           rom[ 0+6619] =8'b11111110;
           rom[ 0+6620] =8'b11011101;
           rom[ 0+6621] =8'b01011110;
           rom[ 0+6622] =8'b00000100;
           rom[ 0+6623] =8'b11001011;
           rom[ 0+6624] =8'b00111011;
           rom[ 0+6625] =8'b11001011;
           rom[ 0+6626] =8'b00111011;
           rom[ 0+6627] =8'b01111011;
           rom[ 0+6628] =8'b11100110;
           rom[ 0+6629] =8'b00000001;
           rom[ 0+6630] =8'b11011101;
           rom[ 0+6631] =8'b01110111;
           rom[ 0+6632] =8'b11111101;
           rom[ 0+6633] =8'b11011101;
           rom[ 0+6634] =8'b01010110;
           rom[ 0+6635] =8'b00000100;
           rom[ 0+6636] =8'b11001011;
           rom[ 0+6637] =8'b00111010;
           rom[ 0+6638] =8'b11001011;
           rom[ 0+6639] =8'b00111010;
           rom[ 0+6640] =8'b11001011;
           rom[ 0+6641] =8'b00111010;
           rom[ 0+6642] =8'b01111010;
           rom[ 0+6643] =8'b11100110;
           rom[ 0+6644] =8'b00000001;
           rom[ 0+6645] =8'b11011101;
           rom[ 0+6646] =8'b01110111;
           rom[ 0+6647] =8'b11111100;
           rom[ 0+6648] =8'b11011101;
           rom[ 0+6649] =8'b01010110;
           rom[ 0+6650] =8'b00000100;
           rom[ 0+6651] =8'b11001011;
           rom[ 0+6652] =8'b00111010;
           rom[ 0+6653] =8'b11001011;
           rom[ 0+6654] =8'b00111010;
           rom[ 0+6655] =8'b11001011;
           rom[ 0+6656] =8'b00111010;
           rom[ 0+6657] =8'b11001011;
           rom[ 0+6658] =8'b00111010;
           rom[ 0+6659] =8'b01111010;
           rom[ 0+6660] =8'b11100110;
           rom[ 0+6661] =8'b00000001;
           rom[ 0+6662] =8'b11011101;
           rom[ 0+6663] =8'b01110111;
           rom[ 0+6664] =8'b11111011;
           rom[ 0+6665] =8'b11011101;
           rom[ 0+6666] =8'b01010110;
           rom[ 0+6667] =8'b00000100;
           rom[ 0+6668] =8'b11001011;
           rom[ 0+6669] =8'b00111010;
           rom[ 0+6670] =8'b11001011;
           rom[ 0+6671] =8'b00111010;
           rom[ 0+6672] =8'b11001011;
           rom[ 0+6673] =8'b00111010;
           rom[ 0+6674] =8'b11001011;
           rom[ 0+6675] =8'b00111010;
           rom[ 0+6676] =8'b11001011;
           rom[ 0+6677] =8'b00111010;
           rom[ 0+6678] =8'b01111010;
           rom[ 0+6679] =8'b11100110;
           rom[ 0+6680] =8'b00000001;
           rom[ 0+6681] =8'b11011101;
           rom[ 0+6682] =8'b01110111;
           rom[ 0+6683] =8'b11111010;
           rom[ 0+6684] =8'b11011101;
           rom[ 0+6685] =8'b01010110;
           rom[ 0+6686] =8'b00000100;
           rom[ 0+6687] =8'b11001011;
           rom[ 0+6688] =8'b00111010;
           rom[ 0+6689] =8'b11001011;
           rom[ 0+6690] =8'b00111010;
           rom[ 0+6691] =8'b11001011;
           rom[ 0+6692] =8'b00111010;
           rom[ 0+6693] =8'b11001011;
           rom[ 0+6694] =8'b00111010;
           rom[ 0+6695] =8'b11001011;
           rom[ 0+6696] =8'b00111010;
           rom[ 0+6697] =8'b11001011;
           rom[ 0+6698] =8'b00111010;
           rom[ 0+6699] =8'b01111010;
           rom[ 0+6700] =8'b11100110;
           rom[ 0+6701] =8'b00000001;
           rom[ 0+6702] =8'b11011101;
           rom[ 0+6703] =8'b01110111;
           rom[ 0+6704] =8'b11111001;
           rom[ 0+6705] =8'b11011101;
           rom[ 0+6706] =8'b01111110;
           rom[ 0+6707] =8'b00000100;
           rom[ 0+6708] =8'b11001011;
           rom[ 0+6709] =8'b00000111;
           rom[ 0+6710] =8'b11100110;
           rom[ 0+6711] =8'b00000001;
           rom[ 0+6712] =8'b01001111;
           rom[ 0+6713] =8'b11011101;
           rom[ 0+6714] =8'b01110001;
           rom[ 0+6715] =8'b11111000;
           rom[ 0+6716] =8'b11011101;
           rom[ 0+6717] =8'b01111110;
           rom[ 0+6718] =8'b00000101;
           rom[ 0+6719] =8'b11100110;
           rom[ 0+6720] =8'b00000001;
           rom[ 0+6721] =8'b11011101;
           rom[ 0+6722] =8'b01110111;
           rom[ 0+6723] =8'b11110111;
           rom[ 0+6724] =8'b11011101;
           rom[ 0+6725] =8'b01010110;
           rom[ 0+6726] =8'b00000101;
           rom[ 0+6727] =8'b11001011;
           rom[ 0+6728] =8'b00111010;
           rom[ 0+6729] =8'b01111010;
           rom[ 0+6730] =8'b11100110;
           rom[ 0+6731] =8'b00000001;
           rom[ 0+6732] =8'b11011101;
           rom[ 0+6733] =8'b01110111;
           rom[ 0+6734] =8'b11110110;
           rom[ 0+6735] =8'b11011101;
           rom[ 0+6736] =8'b01010110;
           rom[ 0+6737] =8'b00000101;
           rom[ 0+6738] =8'b11001011;
           rom[ 0+6739] =8'b00111010;
           rom[ 0+6740] =8'b11001011;
           rom[ 0+6741] =8'b00111010;
           rom[ 0+6742] =8'b01111010;
           rom[ 0+6743] =8'b11100110;
           rom[ 0+6744] =8'b00000001;
           rom[ 0+6745] =8'b11011101;
           rom[ 0+6746] =8'b01110111;
           rom[ 0+6747] =8'b11110101;
           rom[ 0+6748] =8'b11011101;
           rom[ 0+6749] =8'b01010110;
           rom[ 0+6750] =8'b00000101;
           rom[ 0+6751] =8'b11001011;
           rom[ 0+6752] =8'b00111010;
           rom[ 0+6753] =8'b11001011;
           rom[ 0+6754] =8'b00111010;
           rom[ 0+6755] =8'b11001011;
           rom[ 0+6756] =8'b00111010;
           rom[ 0+6757] =8'b01111010;
           rom[ 0+6758] =8'b11100110;
           rom[ 0+6759] =8'b00000001;
           rom[ 0+6760] =8'b11011101;
           rom[ 0+6761] =8'b01110111;
           rom[ 0+6762] =8'b11110100;
           rom[ 0+6763] =8'b11011101;
           rom[ 0+6764] =8'b01010110;
           rom[ 0+6765] =8'b00000101;
           rom[ 0+6766] =8'b11001011;
           rom[ 0+6767] =8'b00111010;
           rom[ 0+6768] =8'b11001011;
           rom[ 0+6769] =8'b00111010;
           rom[ 0+6770] =8'b11001011;
           rom[ 0+6771] =8'b00111010;
           rom[ 0+6772] =8'b11001011;
           rom[ 0+6773] =8'b00111010;
           rom[ 0+6774] =8'b01111010;
           rom[ 0+6775] =8'b11100110;
           rom[ 0+6776] =8'b00000001;
           rom[ 0+6777] =8'b11011101;
           rom[ 0+6778] =8'b01110111;
           rom[ 0+6779] =8'b11110011;
           rom[ 0+6780] =8'b11011101;
           rom[ 0+6781] =8'b01010110;
           rom[ 0+6782] =8'b00000101;
           rom[ 0+6783] =8'b11001011;
           rom[ 0+6784] =8'b00111010;
           rom[ 0+6785] =8'b11001011;
           rom[ 0+6786] =8'b00111010;
           rom[ 0+6787] =8'b11001011;
           rom[ 0+6788] =8'b00111010;
           rom[ 0+6789] =8'b11001011;
           rom[ 0+6790] =8'b00111010;
           rom[ 0+6791] =8'b11001011;
           rom[ 0+6792] =8'b00111010;
           rom[ 0+6793] =8'b01111010;
           rom[ 0+6794] =8'b11100110;
           rom[ 0+6795] =8'b00000001;
           rom[ 0+6796] =8'b11011101;
           rom[ 0+6797] =8'b01110111;
           rom[ 0+6798] =8'b11110010;
           rom[ 0+6799] =8'b11011101;
           rom[ 0+6800] =8'b01010110;
           rom[ 0+6801] =8'b00000101;
           rom[ 0+6802] =8'b11001011;
           rom[ 0+6803] =8'b00111010;
           rom[ 0+6804] =8'b11001011;
           rom[ 0+6805] =8'b00111010;
           rom[ 0+6806] =8'b11001011;
           rom[ 0+6807] =8'b00111010;
           rom[ 0+6808] =8'b11001011;
           rom[ 0+6809] =8'b00111010;
           rom[ 0+6810] =8'b11001011;
           rom[ 0+6811] =8'b00111010;
           rom[ 0+6812] =8'b11001011;
           rom[ 0+6813] =8'b00111010;
           rom[ 0+6814] =8'b01111010;
           rom[ 0+6815] =8'b11100110;
           rom[ 0+6816] =8'b00000001;
           rom[ 0+6817] =8'b11011101;
           rom[ 0+6818] =8'b01110111;
           rom[ 0+6819] =8'b11110001;
           rom[ 0+6820] =8'b11011101;
           rom[ 0+6821] =8'b01111110;
           rom[ 0+6822] =8'b00000101;
           rom[ 0+6823] =8'b11001011;
           rom[ 0+6824] =8'b00000111;
           rom[ 0+6825] =8'b11100110;
           rom[ 0+6826] =8'b00000001;
           rom[ 0+6827] =8'b01001111;
           rom[ 0+6828] =8'b11011101;
           rom[ 0+6829] =8'b01110001;
           rom[ 0+6830] =8'b11110000;
           rom[ 0+6831] =8'b11011101;
           rom[ 0+6832] =8'b01111110;
           rom[ 0+6833] =8'b11111111;
           rom[ 0+6834] =8'b11011101;
           rom[ 0+6835] =8'b10100110;
           rom[ 0+6836] =8'b11110111;
           rom[ 0+6837] =8'b01010111;
           rom[ 0+6838] =8'b11011101;
           rom[ 0+6839] =8'b01111110;
           rom[ 0+6840] =8'b11111000;
           rom[ 0+6841] =8'b11011101;
           rom[ 0+6842] =8'b10100110;
           rom[ 0+6843] =8'b11110110;
           rom[ 0+6844] =8'b11011101;
           rom[ 0+6845] =8'b01110111;
           rom[ 0+6846] =8'b11100001;
           rom[ 0+6847] =8'b01111010;
           rom[ 0+6848] =8'b11011101;
           rom[ 0+6849] =8'b10000110;
           rom[ 0+6850] =8'b11100001;
           rom[ 0+6851] =8'b01010111;
           rom[ 0+6852] =8'b11011101;
           rom[ 0+6853] =8'b01111110;
           rom[ 0+6854] =8'b11111001;
           rom[ 0+6855] =8'b11011101;
           rom[ 0+6856] =8'b10100110;
           rom[ 0+6857] =8'b11110101;
           rom[ 0+6858] =8'b11011101;
           rom[ 0+6859] =8'b01110111;
           rom[ 0+6860] =8'b11100100;
           rom[ 0+6861] =8'b01111010;
           rom[ 0+6862] =8'b11011101;
           rom[ 0+6863] =8'b10000110;
           rom[ 0+6864] =8'b11100100;
           rom[ 0+6865] =8'b01010111;
           rom[ 0+6866] =8'b11011101;
           rom[ 0+6867] =8'b01111110;
           rom[ 0+6868] =8'b11111010;
           rom[ 0+6869] =8'b11011101;
           rom[ 0+6870] =8'b10100110;
           rom[ 0+6871] =8'b11110100;
           rom[ 0+6872] =8'b11011101;
           rom[ 0+6873] =8'b01110111;
           rom[ 0+6874] =8'b11100110;
           rom[ 0+6875] =8'b01111010;
           rom[ 0+6876] =8'b11011101;
           rom[ 0+6877] =8'b10000110;
           rom[ 0+6878] =8'b11100110;
           rom[ 0+6879] =8'b01001111;
           rom[ 0+6880] =8'b11011101;
           rom[ 0+6881] =8'b01111110;
           rom[ 0+6882] =8'b11111011;
           rom[ 0+6883] =8'b11011101;
           rom[ 0+6884] =8'b10100110;
           rom[ 0+6885] =8'b11110011;
           rom[ 0+6886] =8'b11011101;
           rom[ 0+6887] =8'b01110111;
           rom[ 0+6888] =8'b11101000;
           rom[ 0+6889] =8'b01111001;
           rom[ 0+6890] =8'b11011101;
           rom[ 0+6891] =8'b10000110;
           rom[ 0+6892] =8'b11101000;
           rom[ 0+6893] =8'b01001111;
           rom[ 0+6894] =8'b11011101;
           rom[ 0+6895] =8'b01111110;
           rom[ 0+6896] =8'b11111100;
           rom[ 0+6897] =8'b11011101;
           rom[ 0+6898] =8'b10100110;
           rom[ 0+6899] =8'b11110010;
           rom[ 0+6900] =8'b11011101;
           rom[ 0+6901] =8'b01110111;
           rom[ 0+6902] =8'b11100111;
           rom[ 0+6903] =8'b01111001;
           rom[ 0+6904] =8'b11011101;
           rom[ 0+6905] =8'b10000110;
           rom[ 0+6906] =8'b11100111;
           rom[ 0+6907] =8'b01001111;
           rom[ 0+6908] =8'b11011101;
           rom[ 0+6909] =8'b01111110;
           rom[ 0+6910] =8'b11111000;
           rom[ 0+6911] =8'b11011101;
           rom[ 0+6912] =8'b10100110;
           rom[ 0+6913] =8'b11110010;
           rom[ 0+6914] =8'b01010111;
           rom[ 0+6915] =8'b01111001;
           rom[ 0+6916] =8'b10000010;
           rom[ 0+6917] =8'b01001111;
           rom[ 0+6918] =8'b11011101;
           rom[ 0+6919] =8'b01111110;
           rom[ 0+6920] =8'b11111101;
           rom[ 0+6921] =8'b11011101;
           rom[ 0+6922] =8'b10100110;
           rom[ 0+6923] =8'b11110001;
           rom[ 0+6924] =8'b11011101;
           rom[ 0+6925] =8'b01110111;
           rom[ 0+6926] =8'b11100101;
           rom[ 0+6927] =8'b01111001;
           rom[ 0+6928] =8'b11011101;
           rom[ 0+6929] =8'b10000110;
           rom[ 0+6930] =8'b11100101;
           rom[ 0+6931] =8'b01000111;
           rom[ 0+6932] =8'b11011101;
           rom[ 0+6933] =8'b01111110;
           rom[ 0+6934] =8'b11111001;
           rom[ 0+6935] =8'b11011101;
           rom[ 0+6936] =8'b10100110;
           rom[ 0+6937] =8'b11110001;
           rom[ 0+6938] =8'b01001111;
           rom[ 0+6939] =8'b01111000;
           rom[ 0+6940] =8'b10000001;
           rom[ 0+6941] =8'b01000111;
           rom[ 0+6942] =8'b11011101;
           rom[ 0+6943] =8'b01111110;
           rom[ 0+6944] =8'b11111000;
           rom[ 0+6945] =8'b11011101;
           rom[ 0+6946] =8'b10100110;
           rom[ 0+6947] =8'b11110001;
           rom[ 0+6948] =8'b11011101;
           rom[ 0+6949] =8'b01110111;
           rom[ 0+6950] =8'b11100011;
           rom[ 0+6951] =8'b01111000;
           rom[ 0+6952] =8'b11011101;
           rom[ 0+6953] =8'b10000110;
           rom[ 0+6954] =8'b11100011;
           rom[ 0+6955] =8'b01000111;
           rom[ 0+6956] =8'b11011101;
           rom[ 0+6957] =8'b01111110;
           rom[ 0+6958] =8'b11111110;
           rom[ 0+6959] =8'b11011101;
           rom[ 0+6960] =8'b10100110;
           rom[ 0+6961] =8'b11110000;
           rom[ 0+6962] =8'b11011101;
           rom[ 0+6963] =8'b01110111;
           rom[ 0+6964] =8'b11100010;
           rom[ 0+6965] =8'b01111000;
           rom[ 0+6966] =8'b11011101;
           rom[ 0+6967] =8'b10000110;
           rom[ 0+6968] =8'b11100010;
           rom[ 0+6969] =8'b01000111;
           rom[ 0+6970] =8'b11011101;
           rom[ 0+6971] =8'b01111110;
           rom[ 0+6972] =8'b11111010;
           rom[ 0+6973] =8'b11011101;
           rom[ 0+6974] =8'b10100110;
           rom[ 0+6975] =8'b11110000;
           rom[ 0+6976] =8'b11011101;
           rom[ 0+6977] =8'b01110111;
           rom[ 0+6978] =8'b11011110;
           rom[ 0+6979] =8'b01111000;
           rom[ 0+6980] =8'b11011101;
           rom[ 0+6981] =8'b10000110;
           rom[ 0+6982] =8'b11011110;
           rom[ 0+6983] =8'b01000111;
           rom[ 0+6984] =8'b11011101;
           rom[ 0+6985] =8'b01111110;
           rom[ 0+6986] =8'b11111001;
           rom[ 0+6987] =8'b11011101;
           rom[ 0+6988] =8'b10100110;
           rom[ 0+6989] =8'b11110000;
           rom[ 0+6990] =8'b11011101;
           rom[ 0+6991] =8'b01110111;
           rom[ 0+6992] =8'b11100000;
           rom[ 0+6993] =8'b01111000;
           rom[ 0+6994] =8'b11011101;
           rom[ 0+6995] =8'b10000110;
           rom[ 0+6996] =8'b11100000;
           rom[ 0+6997] =8'b01000111;
           rom[ 0+6998] =8'b11011101;
           rom[ 0+6999] =8'b01111110;
           rom[ 0+7000] =8'b11111000;
           rom[ 0+7001] =8'b11011101;
           rom[ 0+7002] =8'b10100110;
           rom[ 0+7003] =8'b11110000;
           rom[ 0+7004] =8'b11011101;
           rom[ 0+7005] =8'b01110111;
           rom[ 0+7006] =8'b11011111;
           rom[ 0+7007] =8'b01111000;
           rom[ 0+7008] =8'b11011101;
           rom[ 0+7009] =8'b10000110;
           rom[ 0+7010] =8'b11011111;
           rom[ 0+7011] =8'b01011111;
           rom[ 0+7012] =8'b00000110;
           rom[ 0+7013] =8'b00000000;
           rom[ 0+7014] =8'b01111011;
           rom[ 0+7015] =8'b11100110;
           rom[ 0+7016] =8'b00000001;
           rom[ 0+7017] =8'b01011111;
           rom[ 0+7018] =8'b00000110;
           rom[ 0+7019] =8'b00000000;
           rom[ 0+7020] =8'b11011101;
           rom[ 0+7021] =8'b01110011;
           rom[ 0+7022] =8'b11101111;
           rom[ 0+7023] =8'b11011101;
           rom[ 0+7024] =8'b01111110;
           rom[ 0+7025] =8'b11111110;
           rom[ 0+7026] =8'b11011101;
           rom[ 0+7027] =8'b10100110;
           rom[ 0+7028] =8'b11110111;
           rom[ 0+7029] =8'b01000111;
           rom[ 0+7030] =8'b11011101;
           rom[ 0+7031] =8'b01111110;
           rom[ 0+7032] =8'b11111111;
           rom[ 0+7033] =8'b11011101;
           rom[ 0+7034] =8'b10100110;
           rom[ 0+7035] =8'b11110110;
           rom[ 0+7036] =8'b01011111;
           rom[ 0+7037] =8'b01111000;
           rom[ 0+7038] =8'b10000011;
           rom[ 0+7039] =8'b01000111;
           rom[ 0+7040] =8'b11011101;
           rom[ 0+7041] =8'b01111110;
           rom[ 0+7042] =8'b11111000;
           rom[ 0+7043] =8'b11011101;
           rom[ 0+7044] =8'b10100110;
           rom[ 0+7045] =8'b11110101;
           rom[ 0+7046] =8'b11011101;
           rom[ 0+7047] =8'b01110111;
           rom[ 0+7048] =8'b11011000;
           rom[ 0+7049] =8'b01111000;
           rom[ 0+7050] =8'b11011101;
           rom[ 0+7051] =8'b10000110;
           rom[ 0+7052] =8'b11011000;
           rom[ 0+7053] =8'b01000111;
           rom[ 0+7054] =8'b11011101;
           rom[ 0+7055] =8'b01111110;
           rom[ 0+7056] =8'b11111001;
           rom[ 0+7057] =8'b11011101;
           rom[ 0+7058] =8'b10100110;
           rom[ 0+7059] =8'b11110100;
           rom[ 0+7060] =8'b11011101;
           rom[ 0+7061] =8'b01110111;
           rom[ 0+7062] =8'b11011101;
           rom[ 0+7063] =8'b01111000;
           rom[ 0+7064] =8'b11011101;
           rom[ 0+7065] =8'b10000110;
           rom[ 0+7066] =8'b11011101;
           rom[ 0+7067] =8'b01000111;
           rom[ 0+7068] =8'b11011101;
           rom[ 0+7069] =8'b01111110;
           rom[ 0+7070] =8'b11111010;
           rom[ 0+7071] =8'b11011101;
           rom[ 0+7072] =8'b10100110;
           rom[ 0+7073] =8'b11110011;
           rom[ 0+7074] =8'b11011101;
           rom[ 0+7075] =8'b01110111;
           rom[ 0+7076] =8'b11011100;
           rom[ 0+7077] =8'b01111000;
           rom[ 0+7078] =8'b11011101;
           rom[ 0+7079] =8'b10000110;
           rom[ 0+7080] =8'b11011100;
           rom[ 0+7081] =8'b01000111;
           rom[ 0+7082] =8'b11011101;
           rom[ 0+7083] =8'b01111110;
           rom[ 0+7084] =8'b11111011;
           rom[ 0+7085] =8'b11011101;
           rom[ 0+7086] =8'b10100110;
           rom[ 0+7087] =8'b11110010;
           rom[ 0+7088] =8'b11011101;
           rom[ 0+7089] =8'b01110111;
           rom[ 0+7090] =8'b11011011;
           rom[ 0+7091] =8'b01111000;
           rom[ 0+7092] =8'b11011101;
           rom[ 0+7093] =8'b10000110;
           rom[ 0+7094] =8'b11011011;
           rom[ 0+7095] =8'b01000111;
           rom[ 0+7096] =8'b11011101;
           rom[ 0+7097] =8'b01111110;
           rom[ 0+7098] =8'b11111100;
           rom[ 0+7099] =8'b11011101;
           rom[ 0+7100] =8'b10100110;
           rom[ 0+7101] =8'b11110001;
           rom[ 0+7102] =8'b11011101;
           rom[ 0+7103] =8'b01110111;
           rom[ 0+7104] =8'b11011010;
           rom[ 0+7105] =8'b01111000;
           rom[ 0+7106] =8'b11011101;
           rom[ 0+7107] =8'b10000110;
           rom[ 0+7108] =8'b11011010;
           rom[ 0+7109] =8'b01000111;
           rom[ 0+7110] =8'b11011101;
           rom[ 0+7111] =8'b10000110;
           rom[ 0+7112] =8'b11100011;
           rom[ 0+7113] =8'b01000111;
           rom[ 0+7114] =8'b11011101;
           rom[ 0+7115] =8'b01111110;
           rom[ 0+7116] =8'b11111101;
           rom[ 0+7117] =8'b11011101;
           rom[ 0+7118] =8'b10100110;
           rom[ 0+7119] =8'b11110000;
           rom[ 0+7120] =8'b11011101;
           rom[ 0+7121] =8'b01110111;
           rom[ 0+7122] =8'b11011001;
           rom[ 0+7123] =8'b01111000;
           rom[ 0+7124] =8'b11011101;
           rom[ 0+7125] =8'b10000110;
           rom[ 0+7126] =8'b11011001;
           rom[ 0+7127] =8'b01000111;
           rom[ 0+7128] =8'b11011101;
           rom[ 0+7129] =8'b10000110;
           rom[ 0+7130] =8'b11100000;
           rom[ 0+7131] =8'b01000111;
           rom[ 0+7132] =8'b11011101;
           rom[ 0+7133] =8'b10000110;
           rom[ 0+7134] =8'b11011111;
           rom[ 0+7135] =8'b01000111;
           rom[ 0+7136] =8'b00011110;
           rom[ 0+7137] =8'b00000000;
           rom[ 0+7138] =8'b01111000;
           rom[ 0+7139] =8'b11100110;
           rom[ 0+7140] =8'b00000001;
           rom[ 0+7141] =8'b01000111;
           rom[ 0+7142] =8'b00011110;
           rom[ 0+7143] =8'b00000000;
           rom[ 0+7144] =8'b11011101;
           rom[ 0+7145] =8'b01110000;
           rom[ 0+7146] =8'b11101110;
           rom[ 0+7147] =8'b11011101;
           rom[ 0+7148] =8'b01111110;
           rom[ 0+7149] =8'b11111101;
           rom[ 0+7150] =8'b11011101;
           rom[ 0+7151] =8'b10100110;
           rom[ 0+7152] =8'b11110111;
           rom[ 0+7153] =8'b01011111;
           rom[ 0+7154] =8'b11011101;
           rom[ 0+7155] =8'b01111110;
           rom[ 0+7156] =8'b11111110;
           rom[ 0+7157] =8'b11011101;
           rom[ 0+7158] =8'b10100110;
           rom[ 0+7159] =8'b11110110;
           rom[ 0+7160] =8'b01000111;
           rom[ 0+7161] =8'b01111011;
           rom[ 0+7162] =8'b10000000;
           rom[ 0+7163] =8'b01011111;
           rom[ 0+7164] =8'b11011101;
           rom[ 0+7165] =8'b10000110;
           rom[ 0+7166] =8'b11100001;
           rom[ 0+7167] =8'b01011111;
           rom[ 0+7168] =8'b11011101;
           rom[ 0+7169] =8'b01111110;
           rom[ 0+7170] =8'b11111111;
           rom[ 0+7171] =8'b11011101;
           rom[ 0+7172] =8'b10100110;
           rom[ 0+7173] =8'b11110101;
           rom[ 0+7174] =8'b01000111;
           rom[ 0+7175] =8'b01111011;
           rom[ 0+7176] =8'b10000000;
           rom[ 0+7177] =8'b01011111;
           rom[ 0+7178] =8'b11011101;
           rom[ 0+7179] =8'b10000110;
           rom[ 0+7180] =8'b11100100;
           rom[ 0+7181] =8'b01011111;
           rom[ 0+7182] =8'b11011101;
           rom[ 0+7183] =8'b10000110;
           rom[ 0+7184] =8'b11100110;
           rom[ 0+7185] =8'b01011111;
           rom[ 0+7186] =8'b11011101;
           rom[ 0+7187] =8'b01111110;
           rom[ 0+7188] =8'b11111000;
           rom[ 0+7189] =8'b11011101;
           rom[ 0+7190] =8'b10100110;
           rom[ 0+7191] =8'b11110100;
           rom[ 0+7192] =8'b11011101;
           rom[ 0+7193] =8'b01110111;
           rom[ 0+7194] =8'b11010011;
           rom[ 0+7195] =8'b01111011;
           rom[ 0+7196] =8'b11011101;
           rom[ 0+7197] =8'b10000110;
           rom[ 0+7198] =8'b11010011;
           rom[ 0+7199] =8'b01011111;
           rom[ 0+7200] =8'b11011101;
           rom[ 0+7201] =8'b10000110;
           rom[ 0+7202] =8'b11101000;
           rom[ 0+7203] =8'b01000111;
           rom[ 0+7204] =8'b11011101;
           rom[ 0+7205] =8'b01111110;
           rom[ 0+7206] =8'b11111001;
           rom[ 0+7207] =8'b11011101;
           rom[ 0+7208] =8'b10100110;
           rom[ 0+7209] =8'b11110011;
           rom[ 0+7210] =8'b11011101;
           rom[ 0+7211] =8'b01110111;
           rom[ 0+7212] =8'b11010111;
           rom[ 0+7213] =8'b01111000;
           rom[ 0+7214] =8'b11011101;
           rom[ 0+7215] =8'b10000110;
           rom[ 0+7216] =8'b11010111;
           rom[ 0+7217] =8'b01011111;
           rom[ 0+7218] =8'b11011101;
           rom[ 0+7219] =8'b10000110;
           rom[ 0+7220] =8'b11100111;
           rom[ 0+7221] =8'b01000111;
           rom[ 0+7222] =8'b11011101;
           rom[ 0+7223] =8'b01111110;
           rom[ 0+7224] =8'b11111010;
           rom[ 0+7225] =8'b11011101;
           rom[ 0+7226] =8'b10100110;
           rom[ 0+7227] =8'b11110010;
           rom[ 0+7228] =8'b11011101;
           rom[ 0+7229] =8'b01110111;
           rom[ 0+7230] =8'b11010110;
           rom[ 0+7231] =8'b01111000;
           rom[ 0+7232] =8'b11011101;
           rom[ 0+7233] =8'b10000110;
           rom[ 0+7234] =8'b11010110;
           rom[ 0+7235] =8'b01011111;
           rom[ 0+7236] =8'b10000010;
           rom[ 0+7237] =8'b01011111;
           rom[ 0+7238] =8'b11011101;
           rom[ 0+7239] =8'b10000110;
           rom[ 0+7240] =8'b11100101;
           rom[ 0+7241] =8'b01000111;
           rom[ 0+7242] =8'b11011101;
           rom[ 0+7243] =8'b01111110;
           rom[ 0+7244] =8'b11111011;
           rom[ 0+7245] =8'b11011101;
           rom[ 0+7246] =8'b10100110;
           rom[ 0+7247] =8'b11110001;
           rom[ 0+7248] =8'b11011101;
           rom[ 0+7249] =8'b01110111;
           rom[ 0+7250] =8'b11010101;
           rom[ 0+7251] =8'b01111000;
           rom[ 0+7252] =8'b11011101;
           rom[ 0+7253] =8'b10000110;
           rom[ 0+7254] =8'b11010101;
           rom[ 0+7255] =8'b01011111;
           rom[ 0+7256] =8'b10000001;
           rom[ 0+7257] =8'b01011111;
           rom[ 0+7258] =8'b11011101;
           rom[ 0+7259] =8'b10000110;
           rom[ 0+7260] =8'b11100011;
           rom[ 0+7261] =8'b01011111;
           rom[ 0+7262] =8'b11011101;
           rom[ 0+7263] =8'b10000110;
           rom[ 0+7264] =8'b11100010;
           rom[ 0+7265] =8'b01000111;
           rom[ 0+7266] =8'b11011101;
           rom[ 0+7267] =8'b01111110;
           rom[ 0+7268] =8'b11111100;
           rom[ 0+7269] =8'b11011101;
           rom[ 0+7270] =8'b10100110;
           rom[ 0+7271] =8'b11110000;
           rom[ 0+7272] =8'b11011101;
           rom[ 0+7273] =8'b01110111;
           rom[ 0+7274] =8'b11010100;
           rom[ 0+7275] =8'b01111000;
           rom[ 0+7276] =8'b11011101;
           rom[ 0+7277] =8'b10000110;
           rom[ 0+7278] =8'b11010100;
           rom[ 0+7279] =8'b01011111;
           rom[ 0+7280] =8'b11011101;
           rom[ 0+7281] =8'b10000110;
           rom[ 0+7282] =8'b11011110;
           rom[ 0+7283] =8'b01011111;
           rom[ 0+7284] =8'b11011101;
           rom[ 0+7285] =8'b10000110;
           rom[ 0+7286] =8'b11100000;
           rom[ 0+7287] =8'b01011111;
           rom[ 0+7288] =8'b00000110;
           rom[ 0+7289] =8'b00000000;
           rom[ 0+7290] =8'b01111011;
           rom[ 0+7291] =8'b11100110;
           rom[ 0+7292] =8'b00000001;
           rom[ 0+7293] =8'b01011111;
           rom[ 0+7294] =8'b00000110;
           rom[ 0+7295] =8'b00000000;
           rom[ 0+7296] =8'b11011101;
           rom[ 0+7297] =8'b01110011;
           rom[ 0+7298] =8'b11101101;
           rom[ 0+7299] =8'b11011101;
           rom[ 0+7300] =8'b01111110;
           rom[ 0+7301] =8'b11111100;
           rom[ 0+7302] =8'b11011101;
           rom[ 0+7303] =8'b10100110;
           rom[ 0+7304] =8'b11110111;
           rom[ 0+7305] =8'b01000111;
           rom[ 0+7306] =8'b11011101;
           rom[ 0+7307] =8'b01111110;
           rom[ 0+7308] =8'b11111101;
           rom[ 0+7309] =8'b11011101;
           rom[ 0+7310] =8'b10100110;
           rom[ 0+7311] =8'b11110110;
           rom[ 0+7312] =8'b01011111;
           rom[ 0+7313] =8'b01111000;
           rom[ 0+7314] =8'b10000011;
           rom[ 0+7315] =8'b01000111;
           rom[ 0+7316] =8'b11011101;
           rom[ 0+7317] =8'b10000110;
           rom[ 0+7318] =8'b11100001;
           rom[ 0+7319] =8'b01000111;
           rom[ 0+7320] =8'b11011101;
           rom[ 0+7321] =8'b01111110;
           rom[ 0+7322] =8'b11111110;
           rom[ 0+7323] =8'b11011101;
           rom[ 0+7324] =8'b10100110;
           rom[ 0+7325] =8'b11110101;
           rom[ 0+7326] =8'b01011111;
           rom[ 0+7327] =8'b01111000;
           rom[ 0+7328] =8'b10000011;
           rom[ 0+7329] =8'b01000111;
           rom[ 0+7330] =8'b11011101;
           rom[ 0+7331] =8'b10000110;
           rom[ 0+7332] =8'b11100100;
           rom[ 0+7333] =8'b01000111;
           rom[ 0+7334] =8'b11011101;
           rom[ 0+7335] =8'b10000110;
           rom[ 0+7336] =8'b11011000;
           rom[ 0+7337] =8'b01000111;
           rom[ 0+7338] =8'b11011101;
           rom[ 0+7339] =8'b01111110;
           rom[ 0+7340] =8'b11111111;
           rom[ 0+7341] =8'b11011101;
           rom[ 0+7342] =8'b10100110;
           rom[ 0+7343] =8'b11110100;
           rom[ 0+7344] =8'b01011111;
           rom[ 0+7345] =8'b01111000;
           rom[ 0+7346] =8'b10000011;
           rom[ 0+7347] =8'b01000111;
           rom[ 0+7348] =8'b11011101;
           rom[ 0+7349] =8'b10000110;
           rom[ 0+7350] =8'b11100110;
           rom[ 0+7351] =8'b01000111;
           rom[ 0+7352] =8'b11011101;
           rom[ 0+7353] =8'b10000110;
           rom[ 0+7354] =8'b11011101;
           rom[ 0+7355] =8'b01000111;
           rom[ 0+7356] =8'b11011101;
           rom[ 0+7357] =8'b10000110;
           rom[ 0+7358] =8'b11101000;
           rom[ 0+7359] =8'b01000111;
           rom[ 0+7360] =8'b11011101;
           rom[ 0+7361] =8'b10000110;
           rom[ 0+7362] =8'b11011100;
           rom[ 0+7363] =8'b01000111;
           rom[ 0+7364] =8'b11011101;
           rom[ 0+7365] =8'b01111110;
           rom[ 0+7366] =8'b11111000;
           rom[ 0+7367] =8'b11011101;
           rom[ 0+7368] =8'b10100110;
           rom[ 0+7369] =8'b11110011;
           rom[ 0+7370] =8'b11011101;
           rom[ 0+7371] =8'b01110111;
           rom[ 0+7372] =8'b11001111;
           rom[ 0+7373] =8'b01111000;
           rom[ 0+7374] =8'b11011101;
           rom[ 0+7375] =8'b10000110;
           rom[ 0+7376] =8'b11001111;
           rom[ 0+7377] =8'b01000111;
           rom[ 0+7378] =8'b11011101;
           rom[ 0+7379] =8'b10000110;
           rom[ 0+7380] =8'b11100111;
           rom[ 0+7381] =8'b01000111;
           rom[ 0+7382] =8'b11011101;
           rom[ 0+7383] =8'b10000110;
           rom[ 0+7384] =8'b11011011;
           rom[ 0+7385] =8'b01000111;
           rom[ 0+7386] =8'b11011101;
           rom[ 0+7387] =8'b01111110;
           rom[ 0+7388] =8'b11111001;
           rom[ 0+7389] =8'b11011101;
           rom[ 0+7390] =8'b10100110;
           rom[ 0+7391] =8'b11110010;
           rom[ 0+7392] =8'b11011101;
           rom[ 0+7393] =8'b01110111;
           rom[ 0+7394] =8'b11010010;
           rom[ 0+7395] =8'b01111000;
           rom[ 0+7396] =8'b11011101;
           rom[ 0+7397] =8'b10000110;
           rom[ 0+7398] =8'b11010010;
           rom[ 0+7399] =8'b01000111;
           rom[ 0+7400] =8'b10000010;
           rom[ 0+7401] =8'b01000111;
           rom[ 0+7402] =8'b11011101;
           rom[ 0+7403] =8'b10000110;
           rom[ 0+7404] =8'b11100101;
           rom[ 0+7405] =8'b01000111;
           rom[ 0+7406] =8'b11011101;
           rom[ 0+7407] =8'b10000110;
           rom[ 0+7408] =8'b11011010;
           rom[ 0+7409] =8'b01000111;
           rom[ 0+7410] =8'b11011101;
           rom[ 0+7411] =8'b01111110;
           rom[ 0+7412] =8'b11111010;
           rom[ 0+7413] =8'b11011101;
           rom[ 0+7414] =8'b10100110;
           rom[ 0+7415] =8'b11110001;
           rom[ 0+7416] =8'b11011101;
           rom[ 0+7417] =8'b01110111;
           rom[ 0+7418] =8'b11010001;
           rom[ 0+7419] =8'b01111000;
           rom[ 0+7420] =8'b11011101;
           rom[ 0+7421] =8'b10000110;
           rom[ 0+7422] =8'b11010001;
           rom[ 0+7423] =8'b01000111;
           rom[ 0+7424] =8'b10000001;
           rom[ 0+7425] =8'b01000111;
           rom[ 0+7426] =8'b11011101;
           rom[ 0+7427] =8'b10000110;
           rom[ 0+7428] =8'b11100010;
           rom[ 0+7429] =8'b01000111;
           rom[ 0+7430] =8'b11011101;
           rom[ 0+7431] =8'b10000110;
           rom[ 0+7432] =8'b11011001;
           rom[ 0+7433] =8'b01000111;
           rom[ 0+7434] =8'b11011101;
           rom[ 0+7435] =8'b01111110;
           rom[ 0+7436] =8'b11111011;
           rom[ 0+7437] =8'b11011101;
           rom[ 0+7438] =8'b10100110;
           rom[ 0+7439] =8'b11110000;
           rom[ 0+7440] =8'b11011101;
           rom[ 0+7441] =8'b01110111;
           rom[ 0+7442] =8'b11010000;
           rom[ 0+7443] =8'b01111000;
           rom[ 0+7444] =8'b11011101;
           rom[ 0+7445] =8'b10000110;
           rom[ 0+7446] =8'b11010000;
           rom[ 0+7447] =8'b01000111;
           rom[ 0+7448] =8'b11011101;
           rom[ 0+7449] =8'b10000110;
           rom[ 0+7450] =8'b11011110;
           rom[ 0+7451] =8'b01000111;
           rom[ 0+7452] =8'b00011110;
           rom[ 0+7453] =8'b00000000;
           rom[ 0+7454] =8'b01111000;
           rom[ 0+7455] =8'b11100110;
           rom[ 0+7456] =8'b00000001;
           rom[ 0+7457] =8'b01000111;
           rom[ 0+7458] =8'b00011110;
           rom[ 0+7459] =8'b00000000;
           rom[ 0+7460] =8'b11011101;
           rom[ 0+7461] =8'b01110000;
           rom[ 0+7462] =8'b11101100;
           rom[ 0+7463] =8'b11011101;
           rom[ 0+7464] =8'b01111110;
           rom[ 0+7465] =8'b11111011;
           rom[ 0+7466] =8'b11011101;
           rom[ 0+7467] =8'b10100110;
           rom[ 0+7468] =8'b11110111;
           rom[ 0+7469] =8'b01011111;
           rom[ 0+7470] =8'b11011101;
           rom[ 0+7471] =8'b01111110;
           rom[ 0+7472] =8'b11111100;
           rom[ 0+7473] =8'b11011101;
           rom[ 0+7474] =8'b10100110;
           rom[ 0+7475] =8'b11110110;
           rom[ 0+7476] =8'b01000111;
           rom[ 0+7477] =8'b01111011;
           rom[ 0+7478] =8'b10000000;
           rom[ 0+7479] =8'b01011111;
           rom[ 0+7480] =8'b11011101;
           rom[ 0+7481] =8'b10000110;
           rom[ 0+7482] =8'b11100001;
           rom[ 0+7483] =8'b01011111;
           rom[ 0+7484] =8'b11011101;
           rom[ 0+7485] =8'b01111110;
           rom[ 0+7486] =8'b11111101;
           rom[ 0+7487] =8'b11011101;
           rom[ 0+7488] =8'b10100110;
           rom[ 0+7489] =8'b11110101;
           rom[ 0+7490] =8'b01000111;
           rom[ 0+7491] =8'b01111011;
           rom[ 0+7492] =8'b10000000;
           rom[ 0+7493] =8'b01011111;
           rom[ 0+7494] =8'b11011101;
           rom[ 0+7495] =8'b10000110;
           rom[ 0+7496] =8'b11100100;
           rom[ 0+7497] =8'b01011111;
           rom[ 0+7498] =8'b11011101;
           rom[ 0+7499] =8'b10000110;
           rom[ 0+7500] =8'b11011000;
           rom[ 0+7501] =8'b01011111;
           rom[ 0+7502] =8'b11011101;
           rom[ 0+7503] =8'b01111110;
           rom[ 0+7504] =8'b11111110;
           rom[ 0+7505] =8'b11011101;
           rom[ 0+7506] =8'b10100110;
           rom[ 0+7507] =8'b11110100;
           rom[ 0+7508] =8'b01000111;
           rom[ 0+7509] =8'b01111011;
           rom[ 0+7510] =8'b10000000;
           rom[ 0+7511] =8'b01011111;
           rom[ 0+7512] =8'b11011101;
           rom[ 0+7513] =8'b10000110;
           rom[ 0+7514] =8'b11100110;
           rom[ 0+7515] =8'b01011111;
           rom[ 0+7516] =8'b11011101;
           rom[ 0+7517] =8'b10000110;
           rom[ 0+7518] =8'b11011101;
           rom[ 0+7519] =8'b01011111;
           rom[ 0+7520] =8'b11011101;
           rom[ 0+7521] =8'b10000110;
           rom[ 0+7522] =8'b11010011;
           rom[ 0+7523] =8'b01011111;
           rom[ 0+7524] =8'b11011101;
           rom[ 0+7525] =8'b01111110;
           rom[ 0+7526] =8'b11111111;
           rom[ 0+7527] =8'b11011101;
           rom[ 0+7528] =8'b10100110;
           rom[ 0+7529] =8'b11110011;
           rom[ 0+7530] =8'b01000111;
           rom[ 0+7531] =8'b01111011;
           rom[ 0+7532] =8'b10000000;
           rom[ 0+7533] =8'b01011111;
           rom[ 0+7534] =8'b11011101;
           rom[ 0+7535] =8'b10000110;
           rom[ 0+7536] =8'b11101000;
           rom[ 0+7537] =8'b01011111;
           rom[ 0+7538] =8'b11011101;
           rom[ 0+7539] =8'b10000110;
           rom[ 0+7540] =8'b11011100;
           rom[ 0+7541] =8'b01011111;
           rom[ 0+7542] =8'b11011101;
           rom[ 0+7543] =8'b10000110;
           rom[ 0+7544] =8'b11010111;
           rom[ 0+7545] =8'b01011111;
           rom[ 0+7546] =8'b11011101;
           rom[ 0+7547] =8'b10000110;
           rom[ 0+7548] =8'b11100111;
           rom[ 0+7549] =8'b01011111;
           rom[ 0+7550] =8'b11011101;
           rom[ 0+7551] =8'b10000110;
           rom[ 0+7552] =8'b11011011;
           rom[ 0+7553] =8'b01011111;
           rom[ 0+7554] =8'b11011101;
           rom[ 0+7555] =8'b10000110;
           rom[ 0+7556] =8'b11010110;
           rom[ 0+7557] =8'b01011111;
           rom[ 0+7558] =8'b11011101;
           rom[ 0+7559] =8'b10000110;
           rom[ 0+7560] =8'b11100101;
           rom[ 0+7561] =8'b01011111;
           rom[ 0+7562] =8'b11011101;
           rom[ 0+7563] =8'b10000110;
           rom[ 0+7564] =8'b11011010;
           rom[ 0+7565] =8'b01011111;
           rom[ 0+7566] =8'b11011101;
           rom[ 0+7567] =8'b10000110;
           rom[ 0+7568] =8'b11010101;
           rom[ 0+7569] =8'b01011111;
           rom[ 0+7570] =8'b11011101;
           rom[ 0+7571] =8'b10000110;
           rom[ 0+7572] =8'b11100010;
           rom[ 0+7573] =8'b01011111;
           rom[ 0+7574] =8'b11011101;
           rom[ 0+7575] =8'b10000110;
           rom[ 0+7576] =8'b11011001;
           rom[ 0+7577] =8'b01011111;
           rom[ 0+7578] =8'b11011101;
           rom[ 0+7579] =8'b10000110;
           rom[ 0+7580] =8'b11010100;
           rom[ 0+7581] =8'b01011111;
           rom[ 0+7582] =8'b11011101;
           rom[ 0+7583] =8'b10000110;
           rom[ 0+7584] =8'b11011111;
           rom[ 0+7585] =8'b01011111;
           rom[ 0+7586] =8'b00000110;
           rom[ 0+7587] =8'b00000000;
           rom[ 0+7588] =8'b01111011;
           rom[ 0+7589] =8'b11100110;
           rom[ 0+7590] =8'b00000001;
           rom[ 0+7591] =8'b01011111;
           rom[ 0+7592] =8'b00000110;
           rom[ 0+7593] =8'b00000000;
           rom[ 0+7594] =8'b11011101;
           rom[ 0+7595] =8'b01110011;
           rom[ 0+7596] =8'b11101011;
           rom[ 0+7597] =8'b11011101;
           rom[ 0+7598] =8'b01111110;
           rom[ 0+7599] =8'b11111010;
           rom[ 0+7600] =8'b11011101;
           rom[ 0+7601] =8'b10100110;
           rom[ 0+7602] =8'b11110111;
           rom[ 0+7603] =8'b01000111;
           rom[ 0+7604] =8'b11011101;
           rom[ 0+7605] =8'b01111110;
           rom[ 0+7606] =8'b11111011;
           rom[ 0+7607] =8'b11011101;
           rom[ 0+7608] =8'b10100110;
           rom[ 0+7609] =8'b11110110;
           rom[ 0+7610] =8'b01011111;
           rom[ 0+7611] =8'b01111000;
           rom[ 0+7612] =8'b10000011;
           rom[ 0+7613] =8'b01000111;
           rom[ 0+7614] =8'b11011101;
           rom[ 0+7615] =8'b01111110;
           rom[ 0+7616] =8'b11111100;
           rom[ 0+7617] =8'b11011101;
           rom[ 0+7618] =8'b10100110;
           rom[ 0+7619] =8'b11110101;
           rom[ 0+7620] =8'b01011111;
           rom[ 0+7621] =8'b01111000;
           rom[ 0+7622] =8'b10000011;
           rom[ 0+7623] =8'b01000111;
           rom[ 0+7624] =8'b11011101;
           rom[ 0+7625] =8'b10000110;
           rom[ 0+7626] =8'b11011000;
           rom[ 0+7627] =8'b01000111;
           rom[ 0+7628] =8'b11011101;
           rom[ 0+7629] =8'b01111110;
           rom[ 0+7630] =8'b11111101;
           rom[ 0+7631] =8'b11011101;
           rom[ 0+7632] =8'b10100110;
           rom[ 0+7633] =8'b11110100;
           rom[ 0+7634] =8'b01011111;
           rom[ 0+7635] =8'b01111000;
           rom[ 0+7636] =8'b10000011;
           rom[ 0+7637] =8'b01000111;
           rom[ 0+7638] =8'b11011101;
           rom[ 0+7639] =8'b10000110;
           rom[ 0+7640] =8'b11011101;
           rom[ 0+7641] =8'b01000111;
           rom[ 0+7642] =8'b11011101;
           rom[ 0+7643] =8'b10000110;
           rom[ 0+7644] =8'b11010011;
           rom[ 0+7645] =8'b01000111;
           rom[ 0+7646] =8'b11011101;
           rom[ 0+7647] =8'b01111110;
           rom[ 0+7648] =8'b11111110;
           rom[ 0+7649] =8'b11011101;
           rom[ 0+7650] =8'b10100110;
           rom[ 0+7651] =8'b11110011;
           rom[ 0+7652] =8'b01011111;
           rom[ 0+7653] =8'b01111000;
           rom[ 0+7654] =8'b10000011;
           rom[ 0+7655] =8'b01000111;
           rom[ 0+7656] =8'b11011101;
           rom[ 0+7657] =8'b10000110;
           rom[ 0+7658] =8'b11011100;
           rom[ 0+7659] =8'b01000111;
           rom[ 0+7660] =8'b11011101;
           rom[ 0+7661] =8'b10000110;
           rom[ 0+7662] =8'b11010111;
           rom[ 0+7663] =8'b01000111;
           rom[ 0+7664] =8'b11011101;
           rom[ 0+7665] =8'b10000110;
           rom[ 0+7666] =8'b11001111;
           rom[ 0+7667] =8'b01000111;
           rom[ 0+7668] =8'b11011101;
           rom[ 0+7669] =8'b01111110;
           rom[ 0+7670] =8'b11111111;
           rom[ 0+7671] =8'b11011101;
           rom[ 0+7672] =8'b10100110;
           rom[ 0+7673] =8'b11110010;
           rom[ 0+7674] =8'b01011111;
           rom[ 0+7675] =8'b01111000;
           rom[ 0+7676] =8'b10000011;
           rom[ 0+7677] =8'b01000111;
           rom[ 0+7678] =8'b11011101;
           rom[ 0+7679] =8'b10000110;
           rom[ 0+7680] =8'b11011011;
           rom[ 0+7681] =8'b01000111;
           rom[ 0+7682] =8'b11011101;
           rom[ 0+7683] =8'b10000110;
           rom[ 0+7684] =8'b11010110;
           rom[ 0+7685] =8'b01000111;
           rom[ 0+7686] =8'b11011101;
           rom[ 0+7687] =8'b10000110;
           rom[ 0+7688] =8'b11010010;
           rom[ 0+7689] =8'b01000111;
           rom[ 0+7690] =8'b11011101;
           rom[ 0+7691] =8'b10000110;
           rom[ 0+7692] =8'b11011010;
           rom[ 0+7693] =8'b01000111;
           rom[ 0+7694] =8'b11011101;
           rom[ 0+7695] =8'b10000110;
           rom[ 0+7696] =8'b11010101;
           rom[ 0+7697] =8'b01000111;
           rom[ 0+7698] =8'b11011101;
           rom[ 0+7699] =8'b10000110;
           rom[ 0+7700] =8'b11010001;
           rom[ 0+7701] =8'b01000111;
           rom[ 0+7702] =8'b11011101;
           rom[ 0+7703] =8'b10000110;
           rom[ 0+7704] =8'b11011001;
           rom[ 0+7705] =8'b01000111;
           rom[ 0+7706] =8'b11011101;
           rom[ 0+7707] =8'b10000110;
           rom[ 0+7708] =8'b11010100;
           rom[ 0+7709] =8'b01000111;
           rom[ 0+7710] =8'b11011101;
           rom[ 0+7711] =8'b10000110;
           rom[ 0+7712] =8'b11010000;
           rom[ 0+7713] =8'b01000111;
           rom[ 0+7714] =8'b00011110;
           rom[ 0+7715] =8'b00000000;
           rom[ 0+7716] =8'b01111000;
           rom[ 0+7717] =8'b11100110;
           rom[ 0+7718] =8'b00000001;
           rom[ 0+7719] =8'b01000111;
           rom[ 0+7720] =8'b00011110;
           rom[ 0+7721] =8'b00000000;
           rom[ 0+7722] =8'b11011101;
           rom[ 0+7723] =8'b01110000;
           rom[ 0+7724] =8'b11101010;
           rom[ 0+7725] =8'b11011101;
           rom[ 0+7726] =8'b01111110;
           rom[ 0+7727] =8'b11111001;
           rom[ 0+7728] =8'b11011101;
           rom[ 0+7729] =8'b10100110;
           rom[ 0+7730] =8'b11110111;
           rom[ 0+7731] =8'b01011111;
           rom[ 0+7732] =8'b11011101;
           rom[ 0+7733] =8'b01111110;
           rom[ 0+7734] =8'b11111010;
           rom[ 0+7735] =8'b11011101;
           rom[ 0+7736] =8'b10100110;
           rom[ 0+7737] =8'b11110110;
           rom[ 0+7738] =8'b01000111;
           rom[ 0+7739] =8'b01111011;
           rom[ 0+7740] =8'b10000000;
           rom[ 0+7741] =8'b01011111;
           rom[ 0+7742] =8'b11011101;
           rom[ 0+7743] =8'b01111110;
           rom[ 0+7744] =8'b11111011;
           rom[ 0+7745] =8'b11011101;
           rom[ 0+7746] =8'b10100110;
           rom[ 0+7747] =8'b11110101;
           rom[ 0+7748] =8'b01000111;
           rom[ 0+7749] =8'b01111011;
           rom[ 0+7750] =8'b10000000;
           rom[ 0+7751] =8'b01011111;
           rom[ 0+7752] =8'b11011101;
           rom[ 0+7753] =8'b01111110;
           rom[ 0+7754] =8'b11111100;
           rom[ 0+7755] =8'b11011101;
           rom[ 0+7756] =8'b10100110;
           rom[ 0+7757] =8'b11110100;
           rom[ 0+7758] =8'b01000111;
           rom[ 0+7759] =8'b01111011;
           rom[ 0+7760] =8'b10000000;
           rom[ 0+7761] =8'b01011111;
           rom[ 0+7762] =8'b11011101;
           rom[ 0+7763] =8'b10000110;
           rom[ 0+7764] =8'b11010011;
           rom[ 0+7765] =8'b01011111;
           rom[ 0+7766] =8'b11011101;
           rom[ 0+7767] =8'b01111110;
           rom[ 0+7768] =8'b11111101;
           rom[ 0+7769] =8'b11011101;
           rom[ 0+7770] =8'b10100110;
           rom[ 0+7771] =8'b11110011;
           rom[ 0+7772] =8'b01000111;
           rom[ 0+7773] =8'b01111011;
           rom[ 0+7774] =8'b10000000;
           rom[ 0+7775] =8'b01011111;
           rom[ 0+7776] =8'b11011101;
           rom[ 0+7777] =8'b10000110;
           rom[ 0+7778] =8'b11010111;
           rom[ 0+7779] =8'b01011111;
           rom[ 0+7780] =8'b11011101;
           rom[ 0+7781] =8'b10000110;
           rom[ 0+7782] =8'b11001111;
           rom[ 0+7783] =8'b01011111;
           rom[ 0+7784] =8'b11011101;
           rom[ 0+7785] =8'b01111110;
           rom[ 0+7786] =8'b11111110;
           rom[ 0+7787] =8'b11011101;
           rom[ 0+7788] =8'b10100110;
           rom[ 0+7789] =8'b11110010;
           rom[ 0+7790] =8'b01000111;
           rom[ 0+7791] =8'b01111011;
           rom[ 0+7792] =8'b10000000;
           rom[ 0+7793] =8'b01011111;
           rom[ 0+7794] =8'b11011101;
           rom[ 0+7795] =8'b10000110;
           rom[ 0+7796] =8'b11010110;
           rom[ 0+7797] =8'b01011111;
           rom[ 0+7798] =8'b11011101;
           rom[ 0+7799] =8'b10000110;
           rom[ 0+7800] =8'b11010010;
           rom[ 0+7801] =8'b01011111;
           rom[ 0+7802] =8'b10000010;
           rom[ 0+7803] =8'b01011111;
           rom[ 0+7804] =8'b11011101;
           rom[ 0+7805] =8'b01111110;
           rom[ 0+7806] =8'b11111111;
           rom[ 0+7807] =8'b11011101;
           rom[ 0+7808] =8'b10100110;
           rom[ 0+7809] =8'b11110001;
           rom[ 0+7810] =8'b01000111;
           rom[ 0+7811] =8'b01111011;
           rom[ 0+7812] =8'b10000000;
           rom[ 0+7813] =8'b01011111;
           rom[ 0+7814] =8'b11011101;
           rom[ 0+7815] =8'b10000110;
           rom[ 0+7816] =8'b11010101;
           rom[ 0+7817] =8'b01011111;
           rom[ 0+7818] =8'b11011101;
           rom[ 0+7819] =8'b10000110;
           rom[ 0+7820] =8'b11010001;
           rom[ 0+7821] =8'b01011111;
           rom[ 0+7822] =8'b10000001;
           rom[ 0+7823] =8'b01011111;
           rom[ 0+7824] =8'b11011101;
           rom[ 0+7825] =8'b10000110;
           rom[ 0+7826] =8'b11010100;
           rom[ 0+7827] =8'b01011111;
           rom[ 0+7828] =8'b11011101;
           rom[ 0+7829] =8'b10000110;
           rom[ 0+7830] =8'b11010000;
           rom[ 0+7831] =8'b01011111;
           rom[ 0+7832] =8'b11011101;
           rom[ 0+7833] =8'b10000110;
           rom[ 0+7834] =8'b11011110;
           rom[ 0+7835] =8'b01011111;
           rom[ 0+7836] =8'b00000110;
           rom[ 0+7837] =8'b00000000;
           rom[ 0+7838] =8'b01111011;
           rom[ 0+7839] =8'b11100110;
           rom[ 0+7840] =8'b00000001;
           rom[ 0+7841] =8'b01011111;
           rom[ 0+7842] =8'b00000110;
           rom[ 0+7843] =8'b00000000;
           rom[ 0+7844] =8'b11011101;
           rom[ 0+7845] =8'b01110011;
           rom[ 0+7846] =8'b11101001;
           rom[ 0+7847] =8'b11011101;
           rom[ 0+7848] =8'b01111110;
           rom[ 0+7849] =8'b11111000;
           rom[ 0+7850] =8'b11011101;
           rom[ 0+7851] =8'b10100110;
           rom[ 0+7852] =8'b11110111;
           rom[ 0+7853] =8'b01000111;
           rom[ 0+7854] =8'b11011101;
           rom[ 0+7855] =8'b01111110;
           rom[ 0+7856] =8'b11111001;
           rom[ 0+7857] =8'b11011101;
           rom[ 0+7858] =8'b10100110;
           rom[ 0+7859] =8'b11110110;
           rom[ 0+7860] =8'b01011111;
           rom[ 0+7861] =8'b01111000;
           rom[ 0+7862] =8'b10000011;
           rom[ 0+7863] =8'b01000111;
           rom[ 0+7864] =8'b11011101;
           rom[ 0+7865] =8'b01111110;
           rom[ 0+7866] =8'b11111010;
           rom[ 0+7867] =8'b11011101;
           rom[ 0+7868] =8'b10100110;
           rom[ 0+7869] =8'b11110101;
           rom[ 0+7870] =8'b01011111;
           rom[ 0+7871] =8'b01111000;
           rom[ 0+7872] =8'b10000011;
           rom[ 0+7873] =8'b01000111;
           rom[ 0+7874] =8'b11011101;
           rom[ 0+7875] =8'b01111110;
           rom[ 0+7876] =8'b11111011;
           rom[ 0+7877] =8'b11011101;
           rom[ 0+7878] =8'b10100110;
           rom[ 0+7879] =8'b11110100;
           rom[ 0+7880] =8'b01011111;
           rom[ 0+7881] =8'b01111000;
           rom[ 0+7882] =8'b10000011;
           rom[ 0+7883] =8'b01000111;
           rom[ 0+7884] =8'b11011101;
           rom[ 0+7885] =8'b01111110;
           rom[ 0+7886] =8'b11111100;
           rom[ 0+7887] =8'b11011101;
           rom[ 0+7888] =8'b10100110;
           rom[ 0+7889] =8'b11110011;
           rom[ 0+7890] =8'b01011111;
           rom[ 0+7891] =8'b01111000;
           rom[ 0+7892] =8'b10000011;
           rom[ 0+7893] =8'b01000111;
           rom[ 0+7894] =8'b11011101;
           rom[ 0+7895] =8'b10000110;
           rom[ 0+7896] =8'b11001111;
           rom[ 0+7897] =8'b01000111;
           rom[ 0+7898] =8'b11011101;
           rom[ 0+7899] =8'b01111110;
           rom[ 0+7900] =8'b11111101;
           rom[ 0+7901] =8'b11011101;
           rom[ 0+7902] =8'b10100110;
           rom[ 0+7903] =8'b11110010;
           rom[ 0+7904] =8'b01011111;
           rom[ 0+7905] =8'b01111000;
           rom[ 0+7906] =8'b10000011;
           rom[ 0+7907] =8'b01000111;
           rom[ 0+7908] =8'b11011101;
           rom[ 0+7909] =8'b10000110;
           rom[ 0+7910] =8'b11010010;
           rom[ 0+7911] =8'b01000111;
           rom[ 0+7912] =8'b10000010;
           rom[ 0+7913] =8'b01010111;
           rom[ 0+7914] =8'b11011101;
           rom[ 0+7915] =8'b01111110;
           rom[ 0+7916] =8'b11111110;
           rom[ 0+7917] =8'b11011101;
           rom[ 0+7918] =8'b10100110;
           rom[ 0+7919] =8'b11110001;
           rom[ 0+7920] =8'b01000111;
           rom[ 0+7921] =8'b01111010;
           rom[ 0+7922] =8'b10000000;
           rom[ 0+7923] =8'b01010111;
           rom[ 0+7924] =8'b11011101;
           rom[ 0+7925] =8'b10000110;
           rom[ 0+7926] =8'b11010001;
           rom[ 0+7927] =8'b01010111;
           rom[ 0+7928] =8'b10000001;
           rom[ 0+7929] =8'b01001111;
           rom[ 0+7930] =8'b11011101;
           rom[ 0+7931] =8'b10000110;
           rom[ 0+7932] =8'b11100011;
           rom[ 0+7933] =8'b01001111;
           rom[ 0+7934] =8'b11011101;
           rom[ 0+7935] =8'b01111110;
           rom[ 0+7936] =8'b11111111;
           rom[ 0+7937] =8'b11011101;
           rom[ 0+7938] =8'b10100110;
           rom[ 0+7939] =8'b11110000;
           rom[ 0+7940] =8'b01000111;
           rom[ 0+7941] =8'b01111001;
           rom[ 0+7942] =8'b10000000;
           rom[ 0+7943] =8'b01001111;
           rom[ 0+7944] =8'b11011101;
           rom[ 0+7945] =8'b10000110;
           rom[ 0+7946] =8'b11010000;
           rom[ 0+7947] =8'b01001111;
           rom[ 0+7948] =8'b11011101;
           rom[ 0+7949] =8'b10000110;
           rom[ 0+7950] =8'b11011110;
           rom[ 0+7951] =8'b01001111;
           rom[ 0+7952] =8'b11011101;
           rom[ 0+7953] =8'b10000110;
           rom[ 0+7954] =8'b11100000;
           rom[ 0+7955] =8'b01001111;
           rom[ 0+7956] =8'b00000110;
           rom[ 0+7957] =8'b00000000;
           rom[ 0+7958] =8'b01111001;
           rom[ 0+7959] =8'b11100110;
           rom[ 0+7960] =8'b00000001;
           rom[ 0+7961] =8'b01001111;
           rom[ 0+7962] =8'b00000110;
           rom[ 0+7963] =8'b00000000;
           rom[ 0+7964] =8'b00000110;
           rom[ 0+7965] =8'b00000000;
           rom[ 0+7966] =8'b11001011;
           rom[ 0+7967] =8'b00100001;
           rom[ 0+7968] =8'b11001011;
           rom[ 0+7969] =8'b00010000;
           rom[ 0+7970] =8'b11001011;
           rom[ 0+7971] =8'b00100001;
           rom[ 0+7972] =8'b11001011;
           rom[ 0+7973] =8'b00010000;
           rom[ 0+7974] =8'b11001011;
           rom[ 0+7975] =8'b00100001;
           rom[ 0+7976] =8'b11001011;
           rom[ 0+7977] =8'b00010000;
           rom[ 0+7978] =8'b11001011;
           rom[ 0+7979] =8'b00100001;
           rom[ 0+7980] =8'b11001011;
           rom[ 0+7981] =8'b00010000;
           rom[ 0+7982] =8'b11001011;
           rom[ 0+7983] =8'b00100001;
           rom[ 0+7984] =8'b11001011;
           rom[ 0+7985] =8'b00010000;
           rom[ 0+7986] =8'b11001011;
           rom[ 0+7987] =8'b00100001;
           rom[ 0+7988] =8'b11001011;
           rom[ 0+7989] =8'b00010000;
           rom[ 0+7990] =8'b11001011;
           rom[ 0+7991] =8'b00100001;
           rom[ 0+7992] =8'b11001011;
           rom[ 0+7993] =8'b00010000;
           rom[ 0+7994] =8'b01111001;
           rom[ 0+7995] =8'b11100110;
           rom[ 0+7996] =8'b10000000;
           rom[ 0+7997] =8'b01001111;
           rom[ 0+7998] =8'b00000110;
           rom[ 0+7999] =8'b00000000;
           rom[ 0+8000] =8'b11011101;
           rom[ 0+8001] =8'b01011110;
           rom[ 0+8002] =8'b11101001;
           rom[ 0+8003] =8'b00010110;
           rom[ 0+8004] =8'b00000000;
           rom[ 0+8005] =8'b11001011;
           rom[ 0+8006] =8'b00100011;
           rom[ 0+8007] =8'b11001011;
           rom[ 0+8008] =8'b00010010;
           rom[ 0+8009] =8'b11001011;
           rom[ 0+8010] =8'b00100011;
           rom[ 0+8011] =8'b11001011;
           rom[ 0+8012] =8'b00010010;
           rom[ 0+8013] =8'b11001011;
           rom[ 0+8014] =8'b00100011;
           rom[ 0+8015] =8'b11001011;
           rom[ 0+8016] =8'b00010010;
           rom[ 0+8017] =8'b11001011;
           rom[ 0+8018] =8'b00100011;
           rom[ 0+8019] =8'b11001011;
           rom[ 0+8020] =8'b00010010;
           rom[ 0+8021] =8'b11001011;
           rom[ 0+8022] =8'b00100011;
           rom[ 0+8023] =8'b11001011;
           rom[ 0+8024] =8'b00010010;
           rom[ 0+8025] =8'b11001011;
           rom[ 0+8026] =8'b00100011;
           rom[ 0+8027] =8'b11001011;
           rom[ 0+8028] =8'b00010010;
           rom[ 0+8029] =8'b01111011;
           rom[ 0+8030] =8'b11100110;
           rom[ 0+8031] =8'b01000000;
           rom[ 0+8032] =8'b01011111;
           rom[ 0+8033] =8'b00010110;
           rom[ 0+8034] =8'b00000000;
           rom[ 0+8035] =8'b01111001;
           rom[ 0+8036] =8'b10110011;
           rom[ 0+8037] =8'b01001111;
           rom[ 0+8038] =8'b01111000;
           rom[ 0+8039] =8'b10110010;
           rom[ 0+8040] =8'b01000111;
           rom[ 0+8041] =8'b11011101;
           rom[ 0+8042] =8'b01011110;
           rom[ 0+8043] =8'b11101010;
           rom[ 0+8044] =8'b00010110;
           rom[ 0+8045] =8'b00000000;
           rom[ 0+8046] =8'b11001011;
           rom[ 0+8047] =8'b00100011;
           rom[ 0+8048] =8'b11001011;
           rom[ 0+8049] =8'b00010010;
           rom[ 0+8050] =8'b11001011;
           rom[ 0+8051] =8'b00100011;
           rom[ 0+8052] =8'b11001011;
           rom[ 0+8053] =8'b00010010;
           rom[ 0+8054] =8'b11001011;
           rom[ 0+8055] =8'b00100011;
           rom[ 0+8056] =8'b11001011;
           rom[ 0+8057] =8'b00010010;
           rom[ 0+8058] =8'b11001011;
           rom[ 0+8059] =8'b00100011;
           rom[ 0+8060] =8'b11001011;
           rom[ 0+8061] =8'b00010010;
           rom[ 0+8062] =8'b11001011;
           rom[ 0+8063] =8'b00100011;
           rom[ 0+8064] =8'b11001011;
           rom[ 0+8065] =8'b00010010;
           rom[ 0+8066] =8'b01111011;
           rom[ 0+8067] =8'b11100110;
           rom[ 0+8068] =8'b00100000;
           rom[ 0+8069] =8'b01011111;
           rom[ 0+8070] =8'b00010110;
           rom[ 0+8071] =8'b00000000;
           rom[ 0+8072] =8'b01111001;
           rom[ 0+8073] =8'b10110011;
           rom[ 0+8074] =8'b01001111;
           rom[ 0+8075] =8'b01111000;
           rom[ 0+8076] =8'b10110010;
           rom[ 0+8077] =8'b01000111;
           rom[ 0+8078] =8'b11011101;
           rom[ 0+8079] =8'b01011110;
           rom[ 0+8080] =8'b11101011;
           rom[ 0+8081] =8'b00010110;
           rom[ 0+8082] =8'b00000000;
           rom[ 0+8083] =8'b11001011;
           rom[ 0+8084] =8'b00100011;
           rom[ 0+8085] =8'b11001011;
           rom[ 0+8086] =8'b00010010;
           rom[ 0+8087] =8'b11001011;
           rom[ 0+8088] =8'b00100011;
           rom[ 0+8089] =8'b11001011;
           rom[ 0+8090] =8'b00010010;
           rom[ 0+8091] =8'b11001011;
           rom[ 0+8092] =8'b00100011;
           rom[ 0+8093] =8'b11001011;
           rom[ 0+8094] =8'b00010010;
           rom[ 0+8095] =8'b11001011;
           rom[ 0+8096] =8'b00100011;
           rom[ 0+8097] =8'b11001011;
           rom[ 0+8098] =8'b00010010;
           rom[ 0+8099] =8'b01111011;
           rom[ 0+8100] =8'b11100110;
           rom[ 0+8101] =8'b00010000;
           rom[ 0+8102] =8'b01011111;
           rom[ 0+8103] =8'b00010110;
           rom[ 0+8104] =8'b00000000;
           rom[ 0+8105] =8'b01111001;
           rom[ 0+8106] =8'b10110011;
           rom[ 0+8107] =8'b01001111;
           rom[ 0+8108] =8'b01111000;
           rom[ 0+8109] =8'b10110010;
           rom[ 0+8110] =8'b01000111;
           rom[ 0+8111] =8'b11011101;
           rom[ 0+8112] =8'b01011110;
           rom[ 0+8113] =8'b11101100;
           rom[ 0+8114] =8'b00010110;
           rom[ 0+8115] =8'b00000000;
           rom[ 0+8116] =8'b11001011;
           rom[ 0+8117] =8'b00100011;
           rom[ 0+8118] =8'b11001011;
           rom[ 0+8119] =8'b00010010;
           rom[ 0+8120] =8'b11001011;
           rom[ 0+8121] =8'b00100011;
           rom[ 0+8122] =8'b11001011;
           rom[ 0+8123] =8'b00010010;
           rom[ 0+8124] =8'b11001011;
           rom[ 0+8125] =8'b00100011;
           rom[ 0+8126] =8'b11001011;
           rom[ 0+8127] =8'b00010010;
           rom[ 0+8128] =8'b01111011;
           rom[ 0+8129] =8'b11100110;
           rom[ 0+8130] =8'b00001000;
           rom[ 0+8131] =8'b01011111;
           rom[ 0+8132] =8'b00010110;
           rom[ 0+8133] =8'b00000000;
           rom[ 0+8134] =8'b01111001;
           rom[ 0+8135] =8'b10110011;
           rom[ 0+8136] =8'b01001111;
           rom[ 0+8137] =8'b01111000;
           rom[ 0+8138] =8'b10110010;
           rom[ 0+8139] =8'b01000111;
           rom[ 0+8140] =8'b11011101;
           rom[ 0+8141] =8'b01011110;
           rom[ 0+8142] =8'b11101101;
           rom[ 0+8143] =8'b00010110;
           rom[ 0+8144] =8'b00000000;
           rom[ 0+8145] =8'b11001011;
           rom[ 0+8146] =8'b00100011;
           rom[ 0+8147] =8'b11001011;
           rom[ 0+8148] =8'b00010010;
           rom[ 0+8149] =8'b11001011;
           rom[ 0+8150] =8'b00100011;
           rom[ 0+8151] =8'b11001011;
           rom[ 0+8152] =8'b00010010;
           rom[ 0+8153] =8'b01111011;
           rom[ 0+8154] =8'b11100110;
           rom[ 0+8155] =8'b00000100;
           rom[ 0+8156] =8'b01011111;
           rom[ 0+8157] =8'b00010110;
           rom[ 0+8158] =8'b00000000;
           rom[ 0+8159] =8'b01111001;
           rom[ 0+8160] =8'b10110011;
           rom[ 0+8161] =8'b01001111;
           rom[ 0+8162] =8'b01111000;
           rom[ 0+8163] =8'b10110010;
           rom[ 0+8164] =8'b01000111;
           rom[ 0+8165] =8'b11011101;
           rom[ 0+8166] =8'b01011110;
           rom[ 0+8167] =8'b11101110;
           rom[ 0+8168] =8'b00010110;
           rom[ 0+8169] =8'b00000000;
           rom[ 0+8170] =8'b11001011;
           rom[ 0+8171] =8'b00100011;
           rom[ 0+8172] =8'b11001011;
           rom[ 0+8173] =8'b00010010;
           rom[ 0+8174] =8'b01111011;
           rom[ 0+8175] =8'b11100110;
           rom[ 0+8176] =8'b00000010;
           rom[ 0+8177] =8'b01011111;
           rom[ 0+8178] =8'b00010110;
           rom[ 0+8179] =8'b00000000;
           rom[ 0+8180] =8'b01111001;
           rom[ 0+8181] =8'b10110011;
           rom[ 0+8182] =8'b01001111;
           rom[ 0+8183] =8'b01111000;
           rom[ 0+8184] =8'b10110010;
           rom[ 0+8185] =8'b01000111;
           rom[ 0+8186] =8'b11011101;
           rom[ 0+8187] =8'b01111110;
           rom[ 0+8188] =8'b11101111;
           rom[ 0+8189] =8'b11100110;
           rom[ 0+8190] =8'b00000001;
           rom[ 0+8191] =8'b01011111;
           rom[ 0+8192] =8'b00010110;
           rom[ 0+8193] =8'b00000000;
           rom[ 0+8194] =8'b01111001;
           rom[ 0+8195] =8'b10110011;
           rom[ 0+8196] =8'b01001111;
           rom[ 0+8197] =8'b01111000;
           rom[ 0+8198] =8'b10110010;
           rom[ 0+8199] =8'b01000111;
           rom[ 0+8200] =8'b01101001;
           rom[ 0+8201] =8'b11011101;
           rom[ 0+8202] =8'b11111001;
           rom[ 0+8203] =8'b11011101;
           rom[ 0+8204] =8'b11100001;
           rom[ 0+8205] =8'b11001001;
           rom[ 0+8206] =8'b11011101;
           rom[ 0+8207] =8'b11100101;
           rom[ 0+8208] =8'b11011101;
           rom[ 0+8209] =8'b00100001;
           rom[ 0+8210] =8'b00000000;
           rom[ 0+8211] =8'b00000000;
           rom[ 0+8212] =8'b11011101;
           rom[ 0+8213] =8'b00111001;
           rom[ 0+8214] =8'b11011101;
           rom[ 0+8215] =8'b01111110;
           rom[ 0+8216] =8'b00000100;
           rom[ 0+8217] =8'b10110111;
           rom[ 0+8218] =8'b11001010;
           rom[ 0+8219] =8'b00100111;
           rom[ 0+8220] =8'b00100000;
           rom[ 0+8221] =8'b11011101;
           rom[ 0+8222] =8'b01111110;
           rom[ 0+8223] =8'b00000101;
           rom[ 0+8224] =8'b10110111;
           rom[ 0+8225] =8'b11001010;
           rom[ 0+8226] =8'b00100111;
           rom[ 0+8227] =8'b00100000;
           rom[ 0+8228] =8'b11000011;
           rom[ 0+8229] =8'b00101100;
           rom[ 0+8230] =8'b00100000;
           rom[ 0+8231] =8'b00101110;
           rom[ 0+8232] =8'b00000000;
           rom[ 0+8233] =8'b11000011;
           rom[ 0+8234] =8'b01101100;
           rom[ 0+8235] =8'b00100000;
           rom[ 0+8236] =8'b00111110;
           rom[ 0+8237] =8'b10011100;
           rom[ 0+8238] =8'b11011101;
           rom[ 0+8239] =8'b10000110;
           rom[ 0+8240] =8'b00000100;
           rom[ 0+8241] =8'b01001111;
           rom[ 0+8242] =8'b00111110;
           rom[ 0+8243] =8'b00000010;
           rom[ 0+8244] =8'b11001110;
           rom[ 0+8245] =8'b00000000;
           rom[ 0+8246] =8'b01000111;
           rom[ 0+8247] =8'b00001010;
           rom[ 0+8248] =8'b01001111;
           rom[ 0+8249] =8'b00000110;
           rom[ 0+8250] =8'b00000000;
           rom[ 0+8251] =8'b00111110;
           rom[ 0+8252] =8'b10011100;
           rom[ 0+8253] =8'b11011101;
           rom[ 0+8254] =8'b10000110;
           rom[ 0+8255] =8'b00000101;
           rom[ 0+8256] =8'b01011111;
           rom[ 0+8257] =8'b00111110;
           rom[ 0+8258] =8'b00000010;
           rom[ 0+8259] =8'b11001110;
           rom[ 0+8260] =8'b00000000;
           rom[ 0+8261] =8'b01010111;
           rom[ 0+8262] =8'b00011010;
           rom[ 0+8263] =8'b01011111;
           rom[ 0+8264] =8'b00010110;
           rom[ 0+8265] =8'b00000000;
           rom[ 0+8266] =8'b01111001;
           rom[ 0+8267] =8'b10000011;
           rom[ 0+8268] =8'b01001111;
           rom[ 0+8269] =8'b01111000;
           rom[ 0+8270] =8'b10001010;
           rom[ 0+8271] =8'b01000111;
           rom[ 0+8272] =8'b11000101;
           rom[ 0+8273] =8'b11111101;
           rom[ 0+8274] =8'b11100001;
           rom[ 0+8275] =8'b00100001;
           rom[ 0+8276] =8'b11111111;
           rom[ 0+8277] =8'b00000000;
           rom[ 0+8278] =8'b11100101;
           rom[ 0+8279] =8'b11111101;
           rom[ 0+8280] =8'b11100101;
           rom[ 0+8281] =8'b11001101;
           rom[ 0+8282] =8'b01010011;
           rom[ 0+8283] =8'b00111110;
           rom[ 0+8284] =8'b01000100;
           rom[ 0+8285] =8'b01001101;
           rom[ 0+8286] =8'b11110001;
           rom[ 0+8287] =8'b11110001;
           rom[ 0+8288] =8'b00111110;
           rom[ 0+8289] =8'b10011100;
           rom[ 0+8290] =8'b10000001;
           rom[ 0+8291] =8'b01001111;
           rom[ 0+8292] =8'b00111110;
           rom[ 0+8293] =8'b00000011;
           rom[ 0+8294] =8'b11001110;
           rom[ 0+8295] =8'b00000000;
           rom[ 0+8296] =8'b01000111;
           rom[ 0+8297] =8'b00001010;
           rom[ 0+8298] =8'b01001111;
           rom[ 0+8299] =8'b01101001;
           rom[ 0+8300] =8'b11011101;
           rom[ 0+8301] =8'b11100001;
           rom[ 0+8302] =8'b11001001;
           rom[ 0+8303] =8'b11011101;
           rom[ 0+8304] =8'b11100101;
           rom[ 0+8305] =8'b11011101;
           rom[ 0+8306] =8'b00100001;
           rom[ 0+8307] =8'b00000000;
           rom[ 0+8308] =8'b00000000;
           rom[ 0+8309] =8'b11011101;
           rom[ 0+8310] =8'b00111001;
           rom[ 0+8311] =8'b11011101;
           rom[ 0+8312] =8'b01111110;
           rom[ 0+8313] =8'b00000100;
           rom[ 0+8314] =8'b10110111;
           rom[ 0+8315] =8'b11001010;
           rom[ 0+8316] =8'b10001000;
           rom[ 0+8317] =8'b00100000;
           rom[ 0+8318] =8'b11011101;
           rom[ 0+8319] =8'b01111110;
           rom[ 0+8320] =8'b00000101;
           rom[ 0+8321] =8'b10110111;
           rom[ 0+8322] =8'b11001010;
           rom[ 0+8323] =8'b10001000;
           rom[ 0+8324] =8'b00100000;
           rom[ 0+8325] =8'b11000011;
           rom[ 0+8326] =8'b10001101;
           rom[ 0+8327] =8'b00100000;
           rom[ 0+8328] =8'b00101110;
           rom[ 0+8329] =8'b00000000;
           rom[ 0+8330] =8'b11000011;
           rom[ 0+8331] =8'b11011010;
           rom[ 0+8332] =8'b00100000;
           rom[ 0+8333] =8'b00111110;
           rom[ 0+8334] =8'b10011100;
           rom[ 0+8335] =8'b11011101;
           rom[ 0+8336] =8'b10000110;
           rom[ 0+8337] =8'b00000100;
           rom[ 0+8338] =8'b01001111;
           rom[ 0+8339] =8'b00111110;
           rom[ 0+8340] =8'b00000010;
           rom[ 0+8341] =8'b11001110;
           rom[ 0+8342] =8'b00000000;
           rom[ 0+8343] =8'b01000111;
           rom[ 0+8344] =8'b00001010;
           rom[ 0+8345] =8'b01001111;
           rom[ 0+8346] =8'b00000110;
           rom[ 0+8347] =8'b00000000;
           rom[ 0+8348] =8'b00111110;
           rom[ 0+8349] =8'b10011100;
           rom[ 0+8350] =8'b11011101;
           rom[ 0+8351] =8'b10000110;
           rom[ 0+8352] =8'b00000101;
           rom[ 0+8353] =8'b01011111;
           rom[ 0+8354] =8'b00111110;
           rom[ 0+8355] =8'b00000010;
           rom[ 0+8356] =8'b11001110;
           rom[ 0+8357] =8'b00000000;
           rom[ 0+8358] =8'b01010111;
           rom[ 0+8359] =8'b00011010;
           rom[ 0+8360] =8'b01011111;
           rom[ 0+8361] =8'b00010110;
           rom[ 0+8362] =8'b00000000;
           rom[ 0+8363] =8'b01111001;
           rom[ 0+8364] =8'b10010011;
           rom[ 0+8365] =8'b01001111;
           rom[ 0+8366] =8'b01111000;
           rom[ 0+8367] =8'b10011010;
           rom[ 0+8368] =8'b01000111;
           rom[ 0+8369] =8'b00111110;
           rom[ 0+8370] =8'b00000000;
           rom[ 0+8371] =8'b10010001;
           rom[ 0+8372] =8'b00111110;
           rom[ 0+8373] =8'b00000000;
           rom[ 0+8374] =8'b10011000;
           rom[ 0+8375] =8'b11111010;
           rom[ 0+8376] =8'b11000010;
           rom[ 0+8377] =8'b00100000;
           rom[ 0+8378] =8'b01111001;
           rom[ 0+8379] =8'b11000110;
           rom[ 0+8380] =8'b11111111;
           rom[ 0+8381] =8'b01001111;
           rom[ 0+8382] =8'b01111000;
           rom[ 0+8383] =8'b11001110;
           rom[ 0+8384] =8'b00000000;
           rom[ 0+8385] =8'b01000111;
           rom[ 0+8386] =8'b00100001;
           rom[ 0+8387] =8'b11111111;
           rom[ 0+8388] =8'b00000000;
           rom[ 0+8389] =8'b11100101;
           rom[ 0+8390] =8'b11000101;
           rom[ 0+8391] =8'b11001101;
           rom[ 0+8392] =8'b01010011;
           rom[ 0+8393] =8'b00111110;
           rom[ 0+8394] =8'b01000100;
           rom[ 0+8395] =8'b01001101;
           rom[ 0+8396] =8'b11110001;
           rom[ 0+8397] =8'b11110001;
           rom[ 0+8398] =8'b00111110;
           rom[ 0+8399] =8'b10011100;
           rom[ 0+8400] =8'b10000001;
           rom[ 0+8401] =8'b01001111;
           rom[ 0+8402] =8'b00111110;
           rom[ 0+8403] =8'b00000011;
           rom[ 0+8404] =8'b11001110;
           rom[ 0+8405] =8'b00000000;
           rom[ 0+8406] =8'b01000111;
           rom[ 0+8407] =8'b00001010;
           rom[ 0+8408] =8'b01001111;
           rom[ 0+8409] =8'b01101001;
           rom[ 0+8410] =8'b11011101;
           rom[ 0+8411] =8'b11100001;
           rom[ 0+8412] =8'b11001001;
           rom[ 0+8413] =8'b00000001;
           rom[ 0+8414] =8'b00000000;
           rom[ 0+8415] =8'b00000000;
           rom[ 0+8416] =8'b01111001;
           rom[ 0+8417] =8'b11010110;
           rom[ 0+8418] =8'b00001000;
           rom[ 0+8419] =8'b01111000;
           rom[ 0+8420] =8'b11011110;
           rom[ 0+8421] =8'b00000000;
           rom[ 0+8422] =8'b11110010;
           rom[ 0+8423] =8'b11110110;
           rom[ 0+8424] =8'b00100000;
           rom[ 0+8425] =8'b00100001;
           rom[ 0+8426] =8'b11110100;
           rom[ 0+8427] =8'b10000011;
           rom[ 0+8428] =8'b00001001;
           rom[ 0+8429] =8'b01011101;
           rom[ 0+8430] =8'b01010100;
           rom[ 0+8431] =8'b00111110;
           rom[ 0+8432] =8'b00000000;
           rom[ 0+8433] =8'b00010010;
           rom[ 0+8434] =8'b00000011;
           rom[ 0+8435] =8'b11000011;
           rom[ 0+8436] =8'b11100000;
           rom[ 0+8437] =8'b00100000;
           rom[ 0+8438] =8'b11001001;
           rom[ 0+8439] =8'b11001101;
           rom[ 0+8440] =8'b11010111;
           rom[ 0+8441] =8'b00110001;
           rom[ 0+8442] =8'b00100001;
           rom[ 0+8443] =8'b00000011;
           rom[ 0+8444] =8'b00100001;
           rom[ 0+8445] =8'b11100101;
           rom[ 0+8446] =8'b11001101;
           rom[ 0+8447] =8'b00001010;
           rom[ 0+8448] =8'b00000010;
           rom[ 0+8449] =8'b11110001;
           rom[ 0+8450] =8'b11001001;
           rom[ 0+8451] =8'b00100100;
           rom[ 0+8452] =8'b01100110;
           rom[ 0+8453] =8'b01101001;
           rom[ 0+8454] =8'b01101110;
           rom[ 0+8455] =8'b01101001;
           rom[ 0+8456] =8'b01110011;
           rom[ 0+8457] =8'b01101000;
           rom[ 0+8458] =8'b00000000;
           rom[ 0+8459] =8'b11011101;
           rom[ 0+8460] =8'b11100101;
           rom[ 0+8461] =8'b11011101;
           rom[ 0+8462] =8'b00100001;
           rom[ 0+8463] =8'b00000000;
           rom[ 0+8464] =8'b00000000;
           rom[ 0+8465] =8'b11011101;
           rom[ 0+8466] =8'b00111001;
           rom[ 0+8467] =8'b11011101;
           rom[ 0+8468] =8'b01101110;
           rom[ 0+8469] =8'b00000100;
           rom[ 0+8470] =8'b11011101;
           rom[ 0+8471] =8'b01100110;
           rom[ 0+8472] =8'b00000101;
           rom[ 0+8473] =8'b00101001;
           rom[ 0+8474] =8'b11011101;
           rom[ 0+8475] =8'b11100001;
           rom[ 0+8476] =8'b11001001;
           rom[ 0+8477] =8'b11011101;
           rom[ 0+8478] =8'b11100101;
           rom[ 0+8479] =8'b11011101;
           rom[ 0+8480] =8'b00100001;
           rom[ 0+8481] =8'b00000000;
           rom[ 0+8482] =8'b00000000;
           rom[ 0+8483] =8'b11011101;
           rom[ 0+8484] =8'b00111001;
           rom[ 0+8485] =8'b00100001;
           rom[ 0+8486] =8'b11111101;
           rom[ 0+8487] =8'b11111111;
           rom[ 0+8488] =8'b00111001;
           rom[ 0+8489] =8'b11111001;
           rom[ 0+8490] =8'b11011101;
           rom[ 0+8491] =8'b00110110;
           rom[ 0+8492] =8'b11111110;
           rom[ 0+8493] =8'b00000000;
           rom[ 0+8494] =8'b11011101;
           rom[ 0+8495] =8'b00110110;
           rom[ 0+8496] =8'b11111111;
           rom[ 0+8497] =8'b00000000;
           rom[ 0+8498] =8'b00111110;
           rom[ 0+8499] =8'b00000111;
           rom[ 0+8500] =8'b11011101;
           rom[ 0+8501] =8'b10010110;
           rom[ 0+8502] =8'b11111110;
           rom[ 0+8503] =8'b00111110;
           rom[ 0+8504] =8'b00000000;
           rom[ 0+8505] =8'b11011101;
           rom[ 0+8506] =8'b10011110;
           rom[ 0+8507] =8'b11111111;
           rom[ 0+8508] =8'b11111010;
           rom[ 0+8509] =8'b11101000;
           rom[ 0+8510] =8'b00100001;
           rom[ 0+8511] =8'b11011101;
           rom[ 0+8512] =8'b01011110;
           rom[ 0+8513] =8'b00000100;
           rom[ 0+8514] =8'b00010110;
           rom[ 0+8515] =8'b00000000;
           rom[ 0+8516] =8'b11011101;
           rom[ 0+8517] =8'b01111110;
           rom[ 0+8518] =8'b11111110;
           rom[ 0+8519] =8'b00111100;
           rom[ 0+8520] =8'b11000011;
           rom[ 0+8521] =8'b01001111;
           rom[ 0+8522] =8'b00100001;
           rom[ 0+8523] =8'b11001011;
           rom[ 0+8524] =8'b00100011;
           rom[ 0+8525] =8'b11001011;
           rom[ 0+8526] =8'b00010010;
           rom[ 0+8527] =8'b00111101;
           rom[ 0+8528] =8'b11000010;
           rom[ 0+8529] =8'b01001011;
           rom[ 0+8530] =8'b00100001;
           rom[ 0+8531] =8'b01111011;
           rom[ 0+8532] =8'b11100110;
           rom[ 0+8533] =8'b10000000;
           rom[ 0+8534] =8'b01011111;
           rom[ 0+8535] =8'b00010110;
           rom[ 0+8536] =8'b00000000;
           rom[ 0+8537] =8'b11011101;
           rom[ 0+8538] =8'b01110011;
           rom[ 0+8539] =8'b11111101;
           rom[ 0+8540] =8'b00111110;
           rom[ 0+8541] =8'b00010000;
           rom[ 0+8542] =8'b11110101;
           rom[ 0+8543] =8'b00110011;
           rom[ 0+8544] =8'b00101010;
           rom[ 0+8545] =8'b00110000;
           rom[ 0+8546] =8'b10010000;
           rom[ 0+8547] =8'b11100101;
           rom[ 0+8548] =8'b00101010;
           rom[ 0+8549] =8'b00101110;
           rom[ 0+8550] =8'b10010000;
           rom[ 0+8551] =8'b11100101;
           rom[ 0+8552] =8'b11001101;
           rom[ 0+8553] =8'b00101000;
           rom[ 0+8554] =8'b00111111;
           rom[ 0+8555] =8'b01000010;
           rom[ 0+8556] =8'b01001011;
           rom[ 0+8557] =8'b01011100;
           rom[ 0+8558] =8'b01010101;
           rom[ 0+8559] =8'b11110001;
           rom[ 0+8560] =8'b11110001;
           rom[ 0+8561] =8'b00110011;
           rom[ 0+8562] =8'b01111010;
           rom[ 0+8563] =8'b11100110;
           rom[ 0+8564] =8'b10000000;
           rom[ 0+8565] =8'b01010111;
           rom[ 0+8566] =8'b00011110;
           rom[ 0+8567] =8'b00000000;
           rom[ 0+8568] =8'b00000001;
           rom[ 0+8569] =8'b00000000;
           rom[ 0+8570] =8'b00000000;
           rom[ 0+8571] =8'b11011101;
           rom[ 0+8572] =8'b01111110;
           rom[ 0+8573] =8'b11111101;
           rom[ 0+8574] =8'b10101010;
           rom[ 0+8575] =8'b10110111;
           rom[ 0+8576] =8'b11001010;
           rom[ 0+8577] =8'b10110111;
           rom[ 0+8578] =8'b00100001;
           rom[ 0+8579] =8'b00111110;
           rom[ 0+8580] =8'b00000001;
           rom[ 0+8581] =8'b11110101;
           rom[ 0+8582] =8'b00110011;
           rom[ 0+8583] =8'b00101010;
           rom[ 0+8584] =8'b00110000;
           rom[ 0+8585] =8'b10010000;
           rom[ 0+8586] =8'b11100101;
           rom[ 0+8587] =8'b00101010;
           rom[ 0+8588] =8'b00101110;
           rom[ 0+8589] =8'b10010000;
           rom[ 0+8590] =8'b11100101;
           rom[ 0+8591] =8'b11001101;
           rom[ 0+8592] =8'b01100010;
           rom[ 0+8593] =8'b00111111;
           rom[ 0+8594] =8'b01000100;
           rom[ 0+8595] =8'b01001101;
           rom[ 0+8596] =8'b11110001;
           rom[ 0+8597] =8'b11110001;
           rom[ 0+8598] =8'b00110011;
           rom[ 0+8599] =8'b01111001;
           rom[ 0+8600] =8'b11101110;
           rom[ 0+8601] =8'b11001101;
           rom[ 0+8602] =8'b01001111;
           rom[ 0+8603] =8'b01111000;
           rom[ 0+8604] =8'b11101110;
           rom[ 0+8605] =8'b00101000;
           rom[ 0+8606] =8'b01000111;
           rom[ 0+8607] =8'b01111011;
           rom[ 0+8608] =8'b11101110;
           rom[ 0+8609] =8'b01101001;
           rom[ 0+8610] =8'b01011111;
           rom[ 0+8611] =8'b11111101;
           rom[ 0+8612] =8'b00100001;
           rom[ 0+8613] =8'b00101110;
           rom[ 0+8614] =8'b10010000;
           rom[ 0+8615] =8'b11111101;
           rom[ 0+8616] =8'b01110001;
           rom[ 0+8617] =8'b00000000;
           rom[ 0+8618] =8'b11111101;
           rom[ 0+8619] =8'b01110000;
           rom[ 0+8620] =8'b00000001;
           rom[ 0+8621] =8'b11111101;
           rom[ 0+8622] =8'b01110011;
           rom[ 0+8623] =8'b00000010;
           rom[ 0+8624] =8'b11111101;
           rom[ 0+8625] =8'b00110110;
           rom[ 0+8626] =8'b00000011;
           rom[ 0+8627] =8'b00000000;
           rom[ 0+8628] =8'b11000011;
           rom[ 0+8629] =8'b11011100;
           rom[ 0+8630] =8'b00100001;
           rom[ 0+8631] =8'b00111110;
           rom[ 0+8632] =8'b00000001;
           rom[ 0+8633] =8'b11110101;
           rom[ 0+8634] =8'b00110011;
           rom[ 0+8635] =8'b00101010;
           rom[ 0+8636] =8'b00110000;
           rom[ 0+8637] =8'b10010000;
           rom[ 0+8638] =8'b11100101;
           rom[ 0+8639] =8'b00101010;
           rom[ 0+8640] =8'b00101110;
           rom[ 0+8641] =8'b10010000;
           rom[ 0+8642] =8'b11100101;
           rom[ 0+8643] =8'b11001101;
           rom[ 0+8644] =8'b01100010;
           rom[ 0+8645] =8'b00111111;
           rom[ 0+8646] =8'b01000100;
           rom[ 0+8647] =8'b01001101;
           rom[ 0+8648] =8'b11110001;
           rom[ 0+8649] =8'b11110001;
           rom[ 0+8650] =8'b00110011;
           rom[ 0+8651] =8'b11111101;
           rom[ 0+8652] =8'b00100001;
           rom[ 0+8653] =8'b00101110;
           rom[ 0+8654] =8'b10010000;
           rom[ 0+8655] =8'b11111101;
           rom[ 0+8656] =8'b01110001;
           rom[ 0+8657] =8'b00000000;
           rom[ 0+8658] =8'b11111101;
           rom[ 0+8659] =8'b01110000;
           rom[ 0+8660] =8'b00000001;
           rom[ 0+8661] =8'b11111101;
           rom[ 0+8662] =8'b01110011;
           rom[ 0+8663] =8'b00000010;
           rom[ 0+8664] =8'b11111101;
           rom[ 0+8665] =8'b00110110;
           rom[ 0+8666] =8'b00000011;
           rom[ 0+8667] =8'b00000000;
           rom[ 0+8668] =8'b11011101;
           rom[ 0+8669] =8'b00110100;
           rom[ 0+8670] =8'b11111110;
           rom[ 0+8671] =8'b11000010;
           rom[ 0+8672] =8'b11100101;
           rom[ 0+8673] =8'b00100001;
           rom[ 0+8674] =8'b11011101;
           rom[ 0+8675] =8'b00110100;
           rom[ 0+8676] =8'b11111111;
           rom[ 0+8677] =8'b11000011;
           rom[ 0+8678] =8'b00110010;
           rom[ 0+8679] =8'b00100001;
           rom[ 0+8680] =8'b11011101;
           rom[ 0+8681] =8'b11111001;
           rom[ 0+8682] =8'b11011101;
           rom[ 0+8683] =8'b11100001;
           rom[ 0+8684] =8'b11001001;
           rom[ 0+8685] =8'b11011101;
           rom[ 0+8686] =8'b11100101;
           rom[ 0+8687] =8'b11011101;
           rom[ 0+8688] =8'b00100001;
           rom[ 0+8689] =8'b00000000;
           rom[ 0+8690] =8'b00000000;
           rom[ 0+8691] =8'b11011101;
           rom[ 0+8692] =8'b00111001;
           rom[ 0+8693] =8'b00100001;
           rom[ 0+8694] =8'b11111100;
           rom[ 0+8695] =8'b11111111;
           rom[ 0+8696] =8'b00111001;
           rom[ 0+8697] =8'b11111001;
           rom[ 0+8698] =8'b11011101;
           rom[ 0+8699] =8'b01011110;
           rom[ 0+8700] =8'b00000111;
           rom[ 0+8701] =8'b11011101;
           rom[ 0+8702] =8'b01010110;
           rom[ 0+8703] =8'b00001000;
           rom[ 0+8704] =8'b01101011;
           rom[ 0+8705] =8'b01100010;
           rom[ 0+8706] =8'b00101001;
           rom[ 0+8707] =8'b00011001;
           rom[ 0+8708] =8'b00101001;
           rom[ 0+8709] =8'b00101001;
           rom[ 0+8710] =8'b00011001;
           rom[ 0+8711] =8'b01001101;
           rom[ 0+8712] =8'b01000100;
           rom[ 0+8713] =8'b00100001;
           rom[ 0+8714] =8'b00000011;
           rom[ 0+8715] =8'b10000100;
           rom[ 0+8716] =8'b00001001;
           rom[ 0+8717] =8'b01001101;
           rom[ 0+8718] =8'b01000100;
           rom[ 0+8719] =8'b01111001;
           rom[ 0+8720] =8'b11000110;
           rom[ 0+8721] =8'b00000100;
           rom[ 0+8722] =8'b11011101;
           rom[ 0+8723] =8'b01110111;
           rom[ 0+8724] =8'b11111110;
           rom[ 0+8725] =8'b01111000;
           rom[ 0+8726] =8'b11001110;
           rom[ 0+8727] =8'b00000000;
           rom[ 0+8728] =8'b11011101;
           rom[ 0+8729] =8'b01110111;
           rom[ 0+8730] =8'b11111111;
           rom[ 0+8731] =8'b11011101;
           rom[ 0+8732] =8'b01111110;
           rom[ 0+8733] =8'b00000101;
           rom[ 0+8734] =8'b11000110;
           rom[ 0+8735] =8'b11111111;
           rom[ 0+8736] =8'b11011101;
           rom[ 0+8737] =8'b01110111;
           rom[ 0+8738] =8'b11111100;
           rom[ 0+8739] =8'b11011101;
           rom[ 0+8740] =8'b01111110;
           rom[ 0+8741] =8'b00000110;
           rom[ 0+8742] =8'b11001110;
           rom[ 0+8743] =8'b11111111;
           rom[ 0+8744] =8'b11011101;
           rom[ 0+8745] =8'b01110111;
           rom[ 0+8746] =8'b11111101;
           rom[ 0+8747] =8'b11011101;
           rom[ 0+8748] =8'b01011110;
           rom[ 0+8749] =8'b00000100;
           rom[ 0+8750] =8'b00010110;
           rom[ 0+8751] =8'b00000000;
           rom[ 0+8752] =8'b11011101;
           rom[ 0+8753] =8'b01111110;
           rom[ 0+8754] =8'b11111100;
           rom[ 0+8755] =8'b10010011;
           rom[ 0+8756] =8'b01011111;
           rom[ 0+8757] =8'b11011101;
           rom[ 0+8758] =8'b01111110;
           rom[ 0+8759] =8'b11111101;
           rom[ 0+8760] =8'b10011010;
           rom[ 0+8761] =8'b01010111;
           rom[ 0+8762] =8'b11011101;
           rom[ 0+8763] =8'b01101110;
           rom[ 0+8764] =8'b11111110;
           rom[ 0+8765] =8'b11011101;
           rom[ 0+8766] =8'b01100110;
           rom[ 0+8767] =8'b11111111;
           rom[ 0+8768] =8'b01110011;
           rom[ 0+8769] =8'b00100011;
           rom[ 0+8770] =8'b01110010;
           rom[ 0+8771] =8'b01111001;
           rom[ 0+8772] =8'b11000110;
           rom[ 0+8773] =8'b00001010;
           rom[ 0+8774] =8'b01001111;
           rom[ 0+8775] =8'b01111000;
           rom[ 0+8776] =8'b11001110;
           rom[ 0+8777] =8'b00000000;
           rom[ 0+8778] =8'b01000111;
           rom[ 0+8779] =8'b11011101;
           rom[ 0+8780] =8'b01011110;
           rom[ 0+8781] =8'b00000111;
           rom[ 0+8782] =8'b11011101;
           rom[ 0+8783] =8'b01010110;
           rom[ 0+8784] =8'b00001000;
           rom[ 0+8785] =8'b01101011;
           rom[ 0+8786] =8'b01100010;
           rom[ 0+8787] =8'b00101001;
           rom[ 0+8788] =8'b00011001;
           rom[ 0+8789] =8'b00101001;
           rom[ 0+8790] =8'b00011001;
           rom[ 0+8791] =8'b01011101;
           rom[ 0+8792] =8'b01010100;
           rom[ 0+8793] =8'b00100001;
           rom[ 0+8794] =8'b00000110;
           rom[ 0+8795] =8'b10010000;
           rom[ 0+8796] =8'b00011001;
           rom[ 0+8797] =8'b01011101;
           rom[ 0+8798] =8'b01010100;
           rom[ 0+8799] =8'b00011010;
           rom[ 0+8800] =8'b00000010;
           rom[ 0+8801] =8'b11011101;
           rom[ 0+8802] =8'b11111001;
           rom[ 0+8803] =8'b11011101;
           rom[ 0+8804] =8'b11100001;
           rom[ 0+8805] =8'b11001001;
           rom[ 0+8806] =8'b11011101;
           rom[ 0+8807] =8'b11100101;
           rom[ 0+8808] =8'b11011101;
           rom[ 0+8809] =8'b00100001;
           rom[ 0+8810] =8'b00000000;
           rom[ 0+8811] =8'b00000000;
           rom[ 0+8812] =8'b11011101;
           rom[ 0+8813] =8'b00111001;
           rom[ 0+8814] =8'b00100001;
           rom[ 0+8815] =8'b11100110;
           rom[ 0+8816] =8'b11111111;
           rom[ 0+8817] =8'b00111001;
           rom[ 0+8818] =8'b11111001;
           rom[ 0+8819] =8'b11011101;
           rom[ 0+8820] =8'b01011110;
           rom[ 0+8821] =8'b00000110;
           rom[ 0+8822] =8'b11011101;
           rom[ 0+8823] =8'b01010110;
           rom[ 0+8824] =8'b00000111;
           rom[ 0+8825] =8'b01101011;
           rom[ 0+8826] =8'b01100010;
           rom[ 0+8827] =8'b00101001;
           rom[ 0+8828] =8'b00011001;
           rom[ 0+8829] =8'b00101001;
           rom[ 0+8830] =8'b00011001;
           rom[ 0+8831] =8'b11011101;
           rom[ 0+8832] =8'b01110101;
           rom[ 0+8833] =8'b11100110;
           rom[ 0+8834] =8'b11011101;
           rom[ 0+8835] =8'b01110100;
           rom[ 0+8836] =8'b11100111;
           rom[ 0+8837] =8'b00111110;
           rom[ 0+8838] =8'b00000110;
           rom[ 0+8839] =8'b11011101;
           rom[ 0+8840] =8'b10000110;
           rom[ 0+8841] =8'b11100110;
           rom[ 0+8842] =8'b01001111;
           rom[ 0+8843] =8'b00111110;
           rom[ 0+8844] =8'b10010000;
           rom[ 0+8845] =8'b11011101;
           rom[ 0+8846] =8'b10001110;
           rom[ 0+8847] =8'b11100111;
           rom[ 0+8848] =8'b01000111;
           rom[ 0+8849] =8'b01111001;
           rom[ 0+8850] =8'b11000110;
           rom[ 0+8851] =8'b00000011;
           rom[ 0+8852] =8'b01011111;
           rom[ 0+8853] =8'b01111000;
           rom[ 0+8854] =8'b11001110;
           rom[ 0+8855] =8'b00000000;
           rom[ 0+8856] =8'b01010111;
           rom[ 0+8857] =8'b00011010;
           rom[ 0+8858] =8'b01011111;
           rom[ 0+8859] =8'b00001010;
           rom[ 0+8860] =8'b01010111;
           rom[ 0+8861] =8'b01111011;
           rom[ 0+8862] =8'b11110101;
           rom[ 0+8863] =8'b00110011;
           rom[ 0+8864] =8'b11010101;
           rom[ 0+8865] =8'b00110011;
           rom[ 0+8866] =8'b11001101;
           rom[ 0+8867] =8'b00001110;
           rom[ 0+8868] =8'b00100000;
           rom[ 0+8869] =8'b01011101;
           rom[ 0+8870] =8'b11110001;
           rom[ 0+8871] =8'b01001011;
           rom[ 0+8872] =8'b00111110;
           rom[ 0+8873] =8'b00000110;
           rom[ 0+8874] =8'b11011101;
           rom[ 0+8875] =8'b10000110;
           rom[ 0+8876] =8'b11100110;
           rom[ 0+8877] =8'b11011101;
           rom[ 0+8878] =8'b01110111;
           rom[ 0+8879] =8'b11101001;
           rom[ 0+8880] =8'b00111110;
           rom[ 0+8881] =8'b10010000;
           rom[ 0+8882] =8'b11011101;
           rom[ 0+8883] =8'b10001110;
           rom[ 0+8884] =8'b11100111;
           rom[ 0+8885] =8'b11011101;
           rom[ 0+8886] =8'b01110111;
           rom[ 0+8887] =8'b11101010;
           rom[ 0+8888] =8'b11011101;
           rom[ 0+8889] =8'b01011110;
           rom[ 0+8890] =8'b11101001;
           rom[ 0+8891] =8'b11011101;
           rom[ 0+8892] =8'b01010110;
           rom[ 0+8893] =8'b11101010;
           rom[ 0+8894] =8'b00010011;
           rom[ 0+8895] =8'b00010011;
           rom[ 0+8896] =8'b00011010;
           rom[ 0+8897] =8'b01011111;
           rom[ 0+8898] =8'b11011101;
           rom[ 0+8899] =8'b01101110;
           rom[ 0+8900] =8'b11101001;
           rom[ 0+8901] =8'b11011101;
           rom[ 0+8902] =8'b01100110;
           rom[ 0+8903] =8'b11101010;
           rom[ 0+8904] =8'b01010110;
           rom[ 0+8905] =8'b11000101;
           rom[ 0+8906] =8'b01111011;
           rom[ 0+8907] =8'b11110101;
           rom[ 0+8908] =8'b00110011;
           rom[ 0+8909] =8'b11010101;
           rom[ 0+8910] =8'b00110011;
           rom[ 0+8911] =8'b11001101;
           rom[ 0+8912] =8'b00001110;
           rom[ 0+8913] =8'b00100000;
           rom[ 0+8914] =8'b01011101;
           rom[ 0+8915] =8'b11110001;
           rom[ 0+8916] =8'b11000001;
           rom[ 0+8917] =8'b01000011;
           rom[ 0+8918] =8'b00111110;
           rom[ 0+8919] =8'b00000110;
           rom[ 0+8920] =8'b11011101;
           rom[ 0+8921] =8'b10000110;
           rom[ 0+8922] =8'b11100110;
           rom[ 0+8923] =8'b01010111;
           rom[ 0+8924] =8'b00111110;
           rom[ 0+8925] =8'b10010000;
           rom[ 0+8926] =8'b11011101;
           rom[ 0+8927] =8'b10001110;
           rom[ 0+8928] =8'b11100111;
           rom[ 0+8929] =8'b01011111;
           rom[ 0+8930] =8'b00010100;
           rom[ 0+8931] =8'b11000010;
           rom[ 0+8932] =8'b11100111;
           rom[ 0+8933] =8'b00100010;
           rom[ 0+8934] =8'b00011100;
           rom[ 0+8935] =8'b01101010;
           rom[ 0+8936] =8'b01100011;
           rom[ 0+8937] =8'b01010110;
           rom[ 0+8938] =8'b11000101;
           rom[ 0+8939] =8'b11010101;
           rom[ 0+8940] =8'b00110011;
           rom[ 0+8941] =8'b11010101;
           rom[ 0+8942] =8'b00110011;
           rom[ 0+8943] =8'b11001101;
           rom[ 0+8944] =8'b00001110;
           rom[ 0+8945] =8'b00100000;
           rom[ 0+8946] =8'b01011101;
           rom[ 0+8947] =8'b11110001;
           rom[ 0+8948] =8'b11000001;
           rom[ 0+8949] =8'b11011101;
           rom[ 0+8950] =8'b01110011;
           rom[ 0+8951] =8'b11111111;
           rom[ 0+8952] =8'b00111110;
           rom[ 0+8953] =8'b00000110;
           rom[ 0+8954] =8'b11011101;
           rom[ 0+8955] =8'b10000110;
           rom[ 0+8956] =8'b11100110;
           rom[ 0+8957] =8'b11011101;
           rom[ 0+8958] =8'b01110111;
           rom[ 0+8959] =8'b11101001;
           rom[ 0+8960] =8'b00111110;
           rom[ 0+8961] =8'b10010000;
           rom[ 0+8962] =8'b11011101;
           rom[ 0+8963] =8'b10001110;
           rom[ 0+8964] =8'b11100111;
           rom[ 0+8965] =8'b11011101;
           rom[ 0+8966] =8'b01110111;
           rom[ 0+8967] =8'b11101010;
           rom[ 0+8968] =8'b11011101;
           rom[ 0+8969] =8'b01111110;
           rom[ 0+8970] =8'b11101001;
           rom[ 0+8971] =8'b11000110;
           rom[ 0+8972] =8'b00000011;
           rom[ 0+8973] =8'b01011111;
           rom[ 0+8974] =8'b11011101;
           rom[ 0+8975] =8'b01111110;
           rom[ 0+8976] =8'b11101010;
           rom[ 0+8977] =8'b11001110;
           rom[ 0+8978] =8'b00000000;
           rom[ 0+8979] =8'b01010111;
           rom[ 0+8980] =8'b00011010;
           rom[ 0+8981] =8'b11011101;
           rom[ 0+8982] =8'b01110111;
           rom[ 0+8983] =8'b11101000;
           rom[ 0+8984] =8'b11011101;
           rom[ 0+8985] =8'b01111110;
           rom[ 0+8986] =8'b11101001;
           rom[ 0+8987] =8'b11000110;
           rom[ 0+8988] =8'b00000001;
           rom[ 0+8989] =8'b01010111;
           rom[ 0+8990] =8'b11011101;
           rom[ 0+8991] =8'b01111110;
           rom[ 0+8992] =8'b11101010;
           rom[ 0+8993] =8'b11001110;
           rom[ 0+8994] =8'b00000000;
           rom[ 0+8995] =8'b01011111;
           rom[ 0+8996] =8'b01101010;
           rom[ 0+8997] =8'b01100011;
           rom[ 0+8998] =8'b01010110;
           rom[ 0+8999] =8'b11000101;
           rom[ 0+9000] =8'b11011101;
           rom[ 0+9001] =8'b01111110;
           rom[ 0+9002] =8'b11101000;
           rom[ 0+9003] =8'b11110101;
           rom[ 0+9004] =8'b00110011;
           rom[ 0+9005] =8'b11010101;
           rom[ 0+9006] =8'b00110011;
           rom[ 0+9007] =8'b11001101;
           rom[ 0+9008] =8'b00001110;
           rom[ 0+9009] =8'b00100000;
           rom[ 0+9010] =8'b01011101;
           rom[ 0+9011] =8'b11110001;
           rom[ 0+9012] =8'b11000001;
           rom[ 0+9013] =8'b11011101;
           rom[ 0+9014] =8'b01110011;
           rom[ 0+9015] =8'b11111110;
           rom[ 0+9016] =8'b00111110;
           rom[ 0+9017] =8'b00000110;
           rom[ 0+9018] =8'b11011101;
           rom[ 0+9019] =8'b10000110;
           rom[ 0+9020] =8'b11100110;
           rom[ 0+9021] =8'b11011101;
           rom[ 0+9022] =8'b01110111;
           rom[ 0+9023] =8'b11101001;
           rom[ 0+9024] =8'b00111110;
           rom[ 0+9025] =8'b10010000;
           rom[ 0+9026] =8'b11011101;
           rom[ 0+9027] =8'b10001110;
           rom[ 0+9028] =8'b11100111;
           rom[ 0+9029] =8'b11011101;
           rom[ 0+9030] =8'b01110111;
           rom[ 0+9031] =8'b11101010;
           rom[ 0+9032] =8'b11011101;
           rom[ 0+9033] =8'b01011110;
           rom[ 0+9034] =8'b11101001;
           rom[ 0+9035] =8'b11011101;
           rom[ 0+9036] =8'b01010110;
           rom[ 0+9037] =8'b11101010;
           rom[ 0+9038] =8'b00010011;
           rom[ 0+9039] =8'b00010011;
           rom[ 0+9040] =8'b00011010;
           rom[ 0+9041] =8'b11011101;
           rom[ 0+9042] =8'b01110111;
           rom[ 0+9043] =8'b11101000;
           rom[ 0+9044] =8'b11011101;
           rom[ 0+9045] =8'b01111110;
           rom[ 0+9046] =8'b11101001;
           rom[ 0+9047] =8'b11000110;
           rom[ 0+9048] =8'b00000001;
           rom[ 0+9049] =8'b01010111;
           rom[ 0+9050] =8'b11011101;
           rom[ 0+9051] =8'b01111110;
           rom[ 0+9052] =8'b11101010;
           rom[ 0+9053] =8'b11001110;
           rom[ 0+9054] =8'b00000000;
           rom[ 0+9055] =8'b01011111;
           rom[ 0+9056] =8'b01101010;
           rom[ 0+9057] =8'b01100011;
           rom[ 0+9058] =8'b01010110;
           rom[ 0+9059] =8'b11000101;
           rom[ 0+9060] =8'b11011101;
           rom[ 0+9061] =8'b01111110;
           rom[ 0+9062] =8'b11101000;
           rom[ 0+9063] =8'b11110101;
           rom[ 0+9064] =8'b00110011;
           rom[ 0+9065] =8'b11010101;
           rom[ 0+9066] =8'b00110011;
           rom[ 0+9067] =8'b11001101;
           rom[ 0+9068] =8'b00001110;
           rom[ 0+9069] =8'b00100000;
           rom[ 0+9070] =8'b01011101;
           rom[ 0+9071] =8'b11110001;
           rom[ 0+9072] =8'b11000001;
           rom[ 0+9073] =8'b11011101;
           rom[ 0+9074] =8'b01110011;
           rom[ 0+9075] =8'b11111101;
           rom[ 0+9076] =8'b00111110;
           rom[ 0+9077] =8'b00000110;
           rom[ 0+9078] =8'b11011101;
           rom[ 0+9079] =8'b10000110;
           rom[ 0+9080] =8'b11100110;
           rom[ 0+9081] =8'b01010111;
           rom[ 0+9082] =8'b00111110;
           rom[ 0+9083] =8'b10010000;
           rom[ 0+9084] =8'b11011101;
           rom[ 0+9085] =8'b10001110;
           rom[ 0+9086] =8'b11100111;
           rom[ 0+9087] =8'b01011111;
           rom[ 0+9088] =8'b01111010;
           rom[ 0+9089] =8'b11000110;
           rom[ 0+9090] =8'b00000010;
           rom[ 0+9091] =8'b01010111;
           rom[ 0+9092] =8'b01111011;
           rom[ 0+9093] =8'b11001110;
           rom[ 0+9094] =8'b00000000;
           rom[ 0+9095] =8'b01011111;
           rom[ 0+9096] =8'b01101010;
           rom[ 0+9097] =8'b01100011;
           rom[ 0+9098] =8'b01010110;
           rom[ 0+9099] =8'b11000101;
           rom[ 0+9100] =8'b11010101;
           rom[ 0+9101] =8'b00110011;
           rom[ 0+9102] =8'b11010101;
           rom[ 0+9103] =8'b00110011;
           rom[ 0+9104] =8'b11001101;
           rom[ 0+9105] =8'b00001110;
           rom[ 0+9106] =8'b00100000;
           rom[ 0+9107] =8'b01011101;
           rom[ 0+9108] =8'b11110001;
           rom[ 0+9109] =8'b11000001;
           rom[ 0+9110] =8'b01111001;
           rom[ 0+9111] =8'b11011101;
           rom[ 0+9112] =8'b10101110;
           rom[ 0+9113] =8'b11111101;
           rom[ 0+9114] =8'b01010111;
           rom[ 0+9115] =8'b01111011;
           rom[ 0+9116] =8'b11011101;
           rom[ 0+9117] =8'b10101110;
           rom[ 0+9118] =8'b11111110;
           rom[ 0+9119] =8'b01011111;
           rom[ 0+9120] =8'b11011101;
           rom[ 0+9121] =8'b01110011;
           rom[ 0+9122] =8'b11111001;
           rom[ 0+9123] =8'b01111000;
           rom[ 0+9124] =8'b11011101;
           rom[ 0+9125] =8'b10101110;
           rom[ 0+9126] =8'b11111111;
           rom[ 0+9127] =8'b01001111;
           rom[ 0+9128] =8'b11011101;
           rom[ 0+9129] =8'b01110001;
           rom[ 0+9130] =8'b11111010;
           rom[ 0+9131] =8'b01111010;
           rom[ 0+9132] =8'b10110111;
           rom[ 0+9133] =8'b11001010;
           rom[ 0+9134] =8'b10110011;
           rom[ 0+9135] =8'b00100011;
           rom[ 0+9136] =8'b11000011;
           rom[ 0+9137] =8'b11010100;
           rom[ 0+9138] =8'b00100011;
           rom[ 0+9139] =8'b11011101;
           rom[ 0+9140] =8'b01011110;
           rom[ 0+9141] =8'b00000110;
           rom[ 0+9142] =8'b11011101;
           rom[ 0+9143] =8'b01010110;
           rom[ 0+9144] =8'b00000111;
           rom[ 0+9145] =8'b01101011;
           rom[ 0+9146] =8'b01100010;
           rom[ 0+9147] =8'b00101001;
           rom[ 0+9148] =8'b00011001;
           rom[ 0+9149] =8'b00101001;
           rom[ 0+9150] =8'b00101001;
           rom[ 0+9151] =8'b00011001;
           rom[ 0+9152] =8'b01001101;
           rom[ 0+9153] =8'b01000100;
           rom[ 0+9154] =8'b00100001;
           rom[ 0+9155] =8'b00000011;
           rom[ 0+9156] =8'b10000100;
           rom[ 0+9157] =8'b00001001;
           rom[ 0+9158] =8'b11011101;
           rom[ 0+9159] =8'b01110101;
           rom[ 0+9160] =8'b11101001;
           rom[ 0+9161] =8'b11011101;
           rom[ 0+9162] =8'b01110100;
           rom[ 0+9163] =8'b11101010;
           rom[ 0+9164] =8'b00110110;
           rom[ 0+9165] =8'b00000011;
           rom[ 0+9166] =8'b00100011;
           rom[ 0+9167] =8'b00110110;
           rom[ 0+9168] =8'b00000000;
           rom[ 0+9169] =8'b11000011;
           rom[ 0+9170] =8'b10100011;
           rom[ 0+9171] =8'b00100111;
           rom[ 0+9172] =8'b11011101;
           rom[ 0+9173] =8'b01111110;
           rom[ 0+9174] =8'b11111001;
           rom[ 0+9175] =8'b10110111;
           rom[ 0+9176] =8'b11001010;
           rom[ 0+9177] =8'b11011110;
           rom[ 0+9178] =8'b00100011;
           rom[ 0+9179] =8'b11000011;
           rom[ 0+9180] =8'b11111111;
           rom[ 0+9181] =8'b00100011;
           rom[ 0+9182] =8'b11011101;
           rom[ 0+9183] =8'b01011110;
           rom[ 0+9184] =8'b00000110;
           rom[ 0+9185] =8'b11011101;
           rom[ 0+9186] =8'b01010110;
           rom[ 0+9187] =8'b00000111;
           rom[ 0+9188] =8'b01101011;
           rom[ 0+9189] =8'b01100010;
           rom[ 0+9190] =8'b00101001;
           rom[ 0+9191] =8'b00011001;
           rom[ 0+9192] =8'b00101001;
           rom[ 0+9193] =8'b00101001;
           rom[ 0+9194] =8'b00011001;
           rom[ 0+9195] =8'b01001101;
           rom[ 0+9196] =8'b01000100;
           rom[ 0+9197] =8'b00100001;
           rom[ 0+9198] =8'b00000011;
           rom[ 0+9199] =8'b10000100;
           rom[ 0+9200] =8'b00001001;
           rom[ 0+9201] =8'b11011101;
           rom[ 0+9202] =8'b01110101;
           rom[ 0+9203] =8'b11101001;
           rom[ 0+9204] =8'b11011101;
           rom[ 0+9205] =8'b01110100;
           rom[ 0+9206] =8'b11101010;
           rom[ 0+9207] =8'b00110110;
           rom[ 0+9208] =8'b00000011;
           rom[ 0+9209] =8'b00100011;
           rom[ 0+9210] =8'b00110110;
           rom[ 0+9211] =8'b00000000;
           rom[ 0+9212] =8'b11000011;
           rom[ 0+9213] =8'b10100011;
           rom[ 0+9214] =8'b00100111;
           rom[ 0+9215] =8'b11011101;
           rom[ 0+9216] =8'b01111110;
           rom[ 0+9217] =8'b11111010;
           rom[ 0+9218] =8'b10110111;
           rom[ 0+9219] =8'b11001010;
           rom[ 0+9220] =8'b00001001;
           rom[ 0+9221] =8'b00100100;
           rom[ 0+9222] =8'b11000011;
           rom[ 0+9223] =8'b00101010;
           rom[ 0+9224] =8'b00100100;
           rom[ 0+9225] =8'b11011101;
           rom[ 0+9226] =8'b01011110;
           rom[ 0+9227] =8'b00000110;
           rom[ 0+9228] =8'b11011101;
           rom[ 0+9229] =8'b01010110;
           rom[ 0+9230] =8'b00000111;
           rom[ 0+9231] =8'b01101011;
           rom[ 0+9232] =8'b01100010;
           rom[ 0+9233] =8'b00101001;
           rom[ 0+9234] =8'b00011001;
           rom[ 0+9235] =8'b00101001;
           rom[ 0+9236] =8'b00101001;
           rom[ 0+9237] =8'b00011001;
           rom[ 0+9238] =8'b01001101;
           rom[ 0+9239] =8'b01000100;
           rom[ 0+9240] =8'b00100001;
           rom[ 0+9241] =8'b00000011;
           rom[ 0+9242] =8'b10000100;
           rom[ 0+9243] =8'b00001001;
           rom[ 0+9244] =8'b11011101;
           rom[ 0+9245] =8'b01110101;
           rom[ 0+9246] =8'b11101001;
           rom[ 0+9247] =8'b11011101;
           rom[ 0+9248] =8'b01110100;
           rom[ 0+9249] =8'b11101010;
           rom[ 0+9250] =8'b00110110;
           rom[ 0+9251] =8'b00000011;
           rom[ 0+9252] =8'b00100011;
           rom[ 0+9253] =8'b00110110;
           rom[ 0+9254] =8'b00000000;
           rom[ 0+9255] =8'b11000011;
           rom[ 0+9256] =8'b10100011;
           rom[ 0+9257] =8'b00100111;
           rom[ 0+9258] =8'b11011101;
           rom[ 0+9259] =8'b01111110;
           rom[ 0+9260] =8'b11111010;
           rom[ 0+9261] =8'b11110101;
           rom[ 0+9262] =8'b00110011;
           rom[ 0+9263] =8'b11010101;
           rom[ 0+9264] =8'b00110011;
           rom[ 0+9265] =8'b11001101;
           rom[ 0+9266] =8'b01101111;
           rom[ 0+9267] =8'b00100000;
           rom[ 0+9268] =8'b01001101;
           rom[ 0+9269] =8'b11110001;
           rom[ 0+9270] =8'b11011101;
           rom[ 0+9271] =8'b01110001;
           rom[ 0+9272] =8'b11111100;
           rom[ 0+9273] =8'b11011101;
           rom[ 0+9274] =8'b01111110;
           rom[ 0+9275] =8'b11111010;
           rom[ 0+9276] =8'b11110101;
           rom[ 0+9277] =8'b00110011;
           rom[ 0+9278] =8'b11011101;
           rom[ 0+9279] =8'b01111110;
           rom[ 0+9280] =8'b11111001;
           rom[ 0+9281] =8'b11110101;
           rom[ 0+9282] =8'b00110011;
           rom[ 0+9283] =8'b11001101;
           rom[ 0+9284] =8'b01101111;
           rom[ 0+9285] =8'b00100000;
           rom[ 0+9286] =8'b01001101;
           rom[ 0+9287] =8'b11110001;
           rom[ 0+9288] =8'b11011101;
           rom[ 0+9289] =8'b01110001;
           rom[ 0+9290] =8'b11111011;
           rom[ 0+9291] =8'b00111110;
           rom[ 0+9292] =8'b00000110;
           rom[ 0+9293] =8'b11011101;
           rom[ 0+9294] =8'b10000110;
           rom[ 0+9295] =8'b11100110;
           rom[ 0+9296] =8'b01011111;
           rom[ 0+9297] =8'b00111110;
           rom[ 0+9298] =8'b10010000;
           rom[ 0+9299] =8'b11011101;
           rom[ 0+9300] =8'b10001110;
           rom[ 0+9301] =8'b11100111;
           rom[ 0+9302] =8'b01001111;
           rom[ 0+9303] =8'b01111011;
           rom[ 0+9304] =8'b11000110;
           rom[ 0+9305] =8'b00000010;
           rom[ 0+9306] =8'b01011111;
           rom[ 0+9307] =8'b01111001;
           rom[ 0+9308] =8'b11001110;
           rom[ 0+9309] =8'b00000000;
           rom[ 0+9310] =8'b01001111;
           rom[ 0+9311] =8'b01101011;
           rom[ 0+9312] =8'b01100001;
           rom[ 0+9313] =8'b01011110;
           rom[ 0+9314] =8'b01111011;
           rom[ 0+9315] =8'b11110101;
           rom[ 0+9316] =8'b00110011;
           rom[ 0+9317] =8'b11011101;
           rom[ 0+9318] =8'b01111110;
           rom[ 0+9319] =8'b11111011;
           rom[ 0+9320] =8'b11110101;
           rom[ 0+9321] =8'b00110011;
           rom[ 0+9322] =8'b11001101;
           rom[ 0+9323] =8'b00001110;
           rom[ 0+9324] =8'b00100000;
           rom[ 0+9325] =8'b01001101;
           rom[ 0+9326] =8'b11110001;
           rom[ 0+9327] =8'b01010001;
           rom[ 0+9328] =8'b00111110;
           rom[ 0+9329] =8'b00000110;
           rom[ 0+9330] =8'b11011101;
           rom[ 0+9331] =8'b10000110;
           rom[ 0+9332] =8'b11100110;
           rom[ 0+9333] =8'b01001111;
           rom[ 0+9334] =8'b00111110;
           rom[ 0+9335] =8'b10010000;
           rom[ 0+9336] =8'b11011101;
           rom[ 0+9337] =8'b10001110;
           rom[ 0+9338] =8'b11100111;
           rom[ 0+9339] =8'b01000111;
           rom[ 0+9340] =8'b00000011;
           rom[ 0+9341] =8'b00000011;
           rom[ 0+9342] =8'b00000011;
           rom[ 0+9343] =8'b00001010;
           rom[ 0+9344] =8'b01001111;
           rom[ 0+9345] =8'b11010101;
           rom[ 0+9346] =8'b01111001;
           rom[ 0+9347] =8'b11110101;
           rom[ 0+9348] =8'b00110011;
           rom[ 0+9349] =8'b11011101;
           rom[ 0+9350] =8'b01111110;
           rom[ 0+9351] =8'b11111100;
           rom[ 0+9352] =8'b11110101;
           rom[ 0+9353] =8'b00110011;
           rom[ 0+9354] =8'b11001101;
           rom[ 0+9355] =8'b00001110;
           rom[ 0+9356] =8'b00100000;
           rom[ 0+9357] =8'b01001101;
           rom[ 0+9358] =8'b11110001;
           rom[ 0+9359] =8'b11010001;
           rom[ 0+9360] =8'b11011101;
           rom[ 0+9361] =8'b01110001;
           rom[ 0+9362] =8'b11111001;
           rom[ 0+9363] =8'b00111110;
           rom[ 0+9364] =8'b00000110;
           rom[ 0+9365] =8'b11011101;
           rom[ 0+9366] =8'b10000110;
           rom[ 0+9367] =8'b11100110;
           rom[ 0+9368] =8'b01001111;
           rom[ 0+9369] =8'b00111110;
           rom[ 0+9370] =8'b10010000;
           rom[ 0+9371] =8'b11011101;
           rom[ 0+9372] =8'b10001110;
           rom[ 0+9373] =8'b11100111;
           rom[ 0+9374] =8'b01000111;
           rom[ 0+9375] =8'b00000011;
           rom[ 0+9376] =8'b00000011;
           rom[ 0+9377] =8'b00000011;
           rom[ 0+9378] =8'b00001010;
           rom[ 0+9379] =8'b01001111;
           rom[ 0+9380] =8'b11010101;
           rom[ 0+9381] =8'b01111001;
           rom[ 0+9382] =8'b11110101;
           rom[ 0+9383] =8'b00110011;
           rom[ 0+9384] =8'b11011101;
           rom[ 0+9385] =8'b01111110;
           rom[ 0+9386] =8'b11111011;
           rom[ 0+9387] =8'b11110101;
           rom[ 0+9388] =8'b00110011;
           rom[ 0+9389] =8'b11001101;
           rom[ 0+9390] =8'b00001110;
           rom[ 0+9391] =8'b00100000;
           rom[ 0+9392] =8'b01001101;
           rom[ 0+9393] =8'b11110001;
           rom[ 0+9394] =8'b11010001;
           rom[ 0+9395] =8'b11011101;
           rom[ 0+9396] =8'b01110001;
           rom[ 0+9397] =8'b11111010;
           rom[ 0+9398] =8'b00111110;
           rom[ 0+9399] =8'b00000110;
           rom[ 0+9400] =8'b11011101;
           rom[ 0+9401] =8'b10000110;
           rom[ 0+9402] =8'b11100110;
           rom[ 0+9403] =8'b01001111;
           rom[ 0+9404] =8'b00111110;
           rom[ 0+9405] =8'b10010000;
           rom[ 0+9406] =8'b11011101;
           rom[ 0+9407] =8'b10001110;
           rom[ 0+9408] =8'b11100111;
           rom[ 0+9409] =8'b01000111;
           rom[ 0+9410] =8'b00000011;
           rom[ 0+9411] =8'b00000011;
           rom[ 0+9412] =8'b00000011;
           rom[ 0+9413] =8'b00000011;
           rom[ 0+9414] =8'b00001010;
           rom[ 0+9415] =8'b01001111;
           rom[ 0+9416] =8'b11010101;
           rom[ 0+9417] =8'b01111001;
           rom[ 0+9418] =8'b11110101;
           rom[ 0+9419] =8'b00110011;
           rom[ 0+9420] =8'b11011101;
           rom[ 0+9421] =8'b01111110;
           rom[ 0+9422] =8'b11111100;
           rom[ 0+9423] =8'b11110101;
           rom[ 0+9424] =8'b00110011;
           rom[ 0+9425] =8'b11001101;
           rom[ 0+9426] =8'b00001110;
           rom[ 0+9427] =8'b00100000;
           rom[ 0+9428] =8'b01001101;
           rom[ 0+9429] =8'b11110001;
           rom[ 0+9430] =8'b11010001;
           rom[ 0+9431] =8'b00111110;
           rom[ 0+9432] =8'b00000110;
           rom[ 0+9433] =8'b11011101;
           rom[ 0+9434] =8'b10000110;
           rom[ 0+9435] =8'b11100110;
           rom[ 0+9436] =8'b01000111;
           rom[ 0+9437] =8'b00111110;
           rom[ 0+9438] =8'b10010000;
           rom[ 0+9439] =8'b11011101;
           rom[ 0+9440] =8'b10001110;
           rom[ 0+9441] =8'b11100111;
           rom[ 0+9442] =8'b01011111;
           rom[ 0+9443] =8'b01111000;
           rom[ 0+9444] =8'b11000110;
           rom[ 0+9445] =8'b00000100;
           rom[ 0+9446] =8'b01000111;
           rom[ 0+9447] =8'b01111011;
           rom[ 0+9448] =8'b11001110;
           rom[ 0+9449] =8'b00000000;
           rom[ 0+9450] =8'b01011111;
           rom[ 0+9451] =8'b01101000;
           rom[ 0+9452] =8'b01100011;
           rom[ 0+9453] =8'b01000110;
           rom[ 0+9454] =8'b11000101;
           rom[ 0+9455] =8'b11010101;
           rom[ 0+9456] =8'b11000101;
           rom[ 0+9457] =8'b00110011;
           rom[ 0+9458] =8'b11011101;
           rom[ 0+9459] =8'b01111110;
           rom[ 0+9460] =8'b11111011;
           rom[ 0+9461] =8'b11110101;
           rom[ 0+9462] =8'b00110011;
           rom[ 0+9463] =8'b11001101;
           rom[ 0+9464] =8'b00001110;
           rom[ 0+9465] =8'b00100000;
           rom[ 0+9466] =8'b01000101;
           rom[ 0+9467] =8'b11110001;
           rom[ 0+9468] =8'b11010001;
           rom[ 0+9469] =8'b01111000;
           rom[ 0+9470] =8'b11000001;
           rom[ 0+9471] =8'b01000111;
           rom[ 0+9472] =8'b11011101;
           rom[ 0+9473] =8'b01110000;
           rom[ 0+9474] =8'b11111000;
           rom[ 0+9475] =8'b00111110;
           rom[ 0+9476] =8'b00000110;
           rom[ 0+9477] =8'b11011101;
           rom[ 0+9478] =8'b10000110;
           rom[ 0+9479] =8'b11100110;
           rom[ 0+9480] =8'b01011111;
           rom[ 0+9481] =8'b00111110;
           rom[ 0+9482] =8'b10010000;
           rom[ 0+9483] =8'b11011101;
           rom[ 0+9484] =8'b10001110;
           rom[ 0+9485] =8'b11100111;
           rom[ 0+9486] =8'b01000111;
           rom[ 0+9487] =8'b01111011;
           rom[ 0+9488] =8'b11000110;
           rom[ 0+9489] =8'b00000101;
           rom[ 0+9490] =8'b01011111;
           rom[ 0+9491] =8'b01111000;
           rom[ 0+9492] =8'b11001110;
           rom[ 0+9493] =8'b00000000;
           rom[ 0+9494] =8'b01000111;
           rom[ 0+9495] =8'b01101011;
           rom[ 0+9496] =8'b01100000;
           rom[ 0+9497] =8'b01011110;
           rom[ 0+9498] =8'b11000101;
           rom[ 0+9499] =8'b11010101;
           rom[ 0+9500] =8'b01111011;
           rom[ 0+9501] =8'b11110101;
           rom[ 0+9502] =8'b00110011;
           rom[ 0+9503] =8'b11011101;
           rom[ 0+9504] =8'b01111110;
           rom[ 0+9505] =8'b11111100;
           rom[ 0+9506] =8'b11110101;
           rom[ 0+9507] =8'b00110011;
           rom[ 0+9508] =8'b11001101;
           rom[ 0+9509] =8'b00001110;
           rom[ 0+9510] =8'b00100000;
           rom[ 0+9511] =8'b01000101;
           rom[ 0+9512] =8'b11110001;
           rom[ 0+9513] =8'b11010001;
           rom[ 0+9514] =8'b01111000;
           rom[ 0+9515] =8'b11000001;
           rom[ 0+9516] =8'b01000111;
           rom[ 0+9517] =8'b11011101;
           rom[ 0+9518] =8'b01110000;
           rom[ 0+9519] =8'b11110111;
           rom[ 0+9520] =8'b01111010;
           rom[ 0+9521] =8'b11011101;
           rom[ 0+9522] =8'b10101110;
           rom[ 0+9523] =8'b11111001;
           rom[ 0+9524] =8'b01010111;
           rom[ 0+9525] =8'b00111110;
           rom[ 0+9526] =8'b00000110;
           rom[ 0+9527] =8'b11011101;
           rom[ 0+9528] =8'b10000110;
           rom[ 0+9529] =8'b11100110;
           rom[ 0+9530] =8'b11011101;
           rom[ 0+9531] =8'b01110111;
           rom[ 0+9532] =8'b11101001;
           rom[ 0+9533] =8'b00111110;
           rom[ 0+9534] =8'b10010000;
           rom[ 0+9535] =8'b11011101;
           rom[ 0+9536] =8'b10001110;
           rom[ 0+9537] =8'b11100111;
           rom[ 0+9538] =8'b11011101;
           rom[ 0+9539] =8'b01110111;
           rom[ 0+9540] =8'b11101010;
           rom[ 0+9541] =8'b11011101;
           rom[ 0+9542] =8'b01111110;
           rom[ 0+9543] =8'b11101001;
           rom[ 0+9544] =8'b11000110;
           rom[ 0+9545] =8'b00000100;
           rom[ 0+9546] =8'b01011111;
           rom[ 0+9547] =8'b11011101;
           rom[ 0+9548] =8'b01111110;
           rom[ 0+9549] =8'b11101010;
           rom[ 0+9550] =8'b11001110;
           rom[ 0+9551] =8'b00000000;
           rom[ 0+9552] =8'b01000111;
           rom[ 0+9553] =8'b01101011;
           rom[ 0+9554] =8'b01100000;
           rom[ 0+9555] =8'b01011110;
           rom[ 0+9556] =8'b01111010;
           rom[ 0+9557] =8'b10111011;
           rom[ 0+9558] =8'b11001010;
           rom[ 0+9559] =8'b01011100;
           rom[ 0+9560] =8'b00100101;
           rom[ 0+9561] =8'b11000011;
           rom[ 0+9562] =8'b11101110;
           rom[ 0+9563] =8'b00100101;
           rom[ 0+9564] =8'b01111001;
           rom[ 0+9565] =8'b11011101;
           rom[ 0+9566] =8'b10101110;
           rom[ 0+9567] =8'b11111010;
           rom[ 0+9568] =8'b01001111;
           rom[ 0+9569] =8'b11011101;
           rom[ 0+9570] =8'b01111110;
           rom[ 0+9571] =8'b11101001;
           rom[ 0+9572] =8'b11000110;
           rom[ 0+9573] =8'b00000101;
           rom[ 0+9574] =8'b01011111;
           rom[ 0+9575] =8'b11011101;
           rom[ 0+9576] =8'b01111110;
           rom[ 0+9577] =8'b11101010;
           rom[ 0+9578] =8'b11001110;
           rom[ 0+9579] =8'b00000000;
           rom[ 0+9580] =8'b01010111;
           rom[ 0+9581] =8'b00011010;
           rom[ 0+9582] =8'b01000111;
           rom[ 0+9583] =8'b01111001;
           rom[ 0+9584] =8'b10111000;
           rom[ 0+9585] =8'b11001010;
           rom[ 0+9586] =8'b10100100;
           rom[ 0+9587] =8'b00100101;
           rom[ 0+9588] =8'b11011101;
           rom[ 0+9589] =8'b01011110;
           rom[ 0+9590] =8'b00000110;
           rom[ 0+9591] =8'b11011101;
           rom[ 0+9592] =8'b01010110;
           rom[ 0+9593] =8'b00000111;
           rom[ 0+9594] =8'b01101011;
           rom[ 0+9595] =8'b01100010;
           rom[ 0+9596] =8'b00101001;
           rom[ 0+9597] =8'b00011001;
           rom[ 0+9598] =8'b00101001;
           rom[ 0+9599] =8'b00101001;
           rom[ 0+9600] =8'b00011001;
           rom[ 0+9601] =8'b01001101;
           rom[ 0+9602] =8'b01000100;
           rom[ 0+9603] =8'b00100001;
           rom[ 0+9604] =8'b00000011;
           rom[ 0+9605] =8'b10000100;
           rom[ 0+9606] =8'b00001001;
           rom[ 0+9607] =8'b01001101;
           rom[ 0+9608] =8'b01000100;
           rom[ 0+9609] =8'b00110110;
           rom[ 0+9610] =8'b00000100;
           rom[ 0+9611] =8'b00100011;
           rom[ 0+9612] =8'b00110110;
           rom[ 0+9613] =8'b00000000;
           rom[ 0+9614] =8'b11011101;
           rom[ 0+9615] =8'b01101110;
           rom[ 0+9616] =8'b00000110;
           rom[ 0+9617] =8'b11011101;
           rom[ 0+9618] =8'b01100110;
           rom[ 0+9619] =8'b00000111;
           rom[ 0+9620] =8'b11100101;
           rom[ 0+9621] =8'b11011101;
           rom[ 0+9622] =8'b01101110;
           rom[ 0+9623] =8'b00000100;
           rom[ 0+9624] =8'b11011101;
           rom[ 0+9625] =8'b01100110;
           rom[ 0+9626] =8'b00000101;
           rom[ 0+9627] =8'b11100101;
           rom[ 0+9628] =8'b11001101;
           rom[ 0+9629] =8'b10101000;
           rom[ 0+9630] =8'b00100111;
           rom[ 0+9631] =8'b11110001;
           rom[ 0+9632] =8'b11110001;
           rom[ 0+9633] =8'b11000011;
           rom[ 0+9634] =8'b10100011;
           rom[ 0+9635] =8'b00100111;
           rom[ 0+9636] =8'b11011101;
           rom[ 0+9637] =8'b01111110;
           rom[ 0+9638] =8'b11111000;
           rom[ 0+9639] =8'b11011101;
           rom[ 0+9640] =8'b10101110;
           rom[ 0+9641] =8'b11110111;
           rom[ 0+9642] =8'b01001111;
           rom[ 0+9643] =8'b11011101;
           rom[ 0+9644] =8'b01111110;
           rom[ 0+9645] =8'b11101001;
           rom[ 0+9646] =8'b11000110;
           rom[ 0+9647] =8'b00000110;
           rom[ 0+9648] =8'b01011111;
           rom[ 0+9649] =8'b11011101;
           rom[ 0+9650] =8'b01111110;
           rom[ 0+9651] =8'b11101010;
           rom[ 0+9652] =8'b11001110;
           rom[ 0+9653] =8'b00000000;
           rom[ 0+9654] =8'b01010111;
           rom[ 0+9655] =8'b00011010;
           rom[ 0+9656] =8'b01000111;
           rom[ 0+9657] =8'b01111001;
           rom[ 0+9658] =8'b10111000;
           rom[ 0+9659] =8'b11001010;
           rom[ 0+9660] =8'b00011110;
           rom[ 0+9661] =8'b00100110;
           rom[ 0+9662] =8'b11011101;
           rom[ 0+9663] =8'b01011110;
           rom[ 0+9664] =8'b00000110;
           rom[ 0+9665] =8'b11011101;
           rom[ 0+9666] =8'b01010110;
           rom[ 0+9667] =8'b00000111;
           rom[ 0+9668] =8'b01101011;
           rom[ 0+9669] =8'b01100010;
           rom[ 0+9670] =8'b00101001;
           rom[ 0+9671] =8'b00011001;
           rom[ 0+9672] =8'b00101001;
           rom[ 0+9673] =8'b00101001;
           rom[ 0+9674] =8'b00011001;
           rom[ 0+9675] =8'b01001101;
           rom[ 0+9676] =8'b01000100;
           rom[ 0+9677] =8'b00100001;
           rom[ 0+9678] =8'b00000011;
           rom[ 0+9679] =8'b10000100;
           rom[ 0+9680] =8'b00001001;
           rom[ 0+9681] =8'b01001101;
           rom[ 0+9682] =8'b01000100;
           rom[ 0+9683] =8'b00110110;
           rom[ 0+9684] =8'b00000100;
           rom[ 0+9685] =8'b00100011;
           rom[ 0+9686] =8'b00110110;
           rom[ 0+9687] =8'b00000000;
           rom[ 0+9688] =8'b11011101;
           rom[ 0+9689] =8'b01101110;
           rom[ 0+9690] =8'b00000110;
           rom[ 0+9691] =8'b11011101;
           rom[ 0+9692] =8'b01100110;
           rom[ 0+9693] =8'b00000111;
           rom[ 0+9694] =8'b11100101;
           rom[ 0+9695] =8'b11011101;
           rom[ 0+9696] =8'b01101110;
           rom[ 0+9697] =8'b00000100;
           rom[ 0+9698] =8'b11011101;
           rom[ 0+9699] =8'b01100110;
           rom[ 0+9700] =8'b00000101;
           rom[ 0+9701] =8'b11100101;
           rom[ 0+9702] =8'b11001101;
           rom[ 0+9703] =8'b10101000;
           rom[ 0+9704] =8'b00100111;
           rom[ 0+9705] =8'b11110001;
           rom[ 0+9706] =8'b11110001;
           rom[ 0+9707] =8'b11000011;
           rom[ 0+9708] =8'b10100011;
           rom[ 0+9709] =8'b00100111;
           rom[ 0+9710] =8'b11011101;
           rom[ 0+9711] =8'b01011110;
           rom[ 0+9712] =8'b00000110;
           rom[ 0+9713] =8'b11011101;
           rom[ 0+9714] =8'b01010110;
           rom[ 0+9715] =8'b00000111;
           rom[ 0+9716] =8'b01101011;
           rom[ 0+9717] =8'b01100010;
           rom[ 0+9718] =8'b00101001;
           rom[ 0+9719] =8'b00011001;
           rom[ 0+9720] =8'b00101001;
           rom[ 0+9721] =8'b00101001;
           rom[ 0+9722] =8'b00011001;
           rom[ 0+9723] =8'b01001101;
           rom[ 0+9724] =8'b01000100;
           rom[ 0+9725] =8'b00100001;
           rom[ 0+9726] =8'b00000011;
           rom[ 0+9727] =8'b10000100;
           rom[ 0+9728] =8'b00001001;
           rom[ 0+9729] =8'b01001101;
           rom[ 0+9730] =8'b01000100;
           rom[ 0+9731] =8'b00110110;
           rom[ 0+9732] =8'b00000100;
           rom[ 0+9733] =8'b00100011;
           rom[ 0+9734] =8'b00110110;
           rom[ 0+9735] =8'b00000000;
           rom[ 0+9736] =8'b11011101;
           rom[ 0+9737] =8'b01101110;
           rom[ 0+9738] =8'b00000110;
           rom[ 0+9739] =8'b11011101;
           rom[ 0+9740] =8'b01100110;
           rom[ 0+9741] =8'b00000111;
           rom[ 0+9742] =8'b11100101;
           rom[ 0+9743] =8'b11011101;
           rom[ 0+9744] =8'b01101110;
           rom[ 0+9745] =8'b00000100;
           rom[ 0+9746] =8'b11011101;
           rom[ 0+9747] =8'b01100110;
           rom[ 0+9748] =8'b00000101;
           rom[ 0+9749] =8'b11100101;
           rom[ 0+9750] =8'b11001101;
           rom[ 0+9751] =8'b10101000;
           rom[ 0+9752] =8'b00100111;
           rom[ 0+9753] =8'b11110001;
           rom[ 0+9754] =8'b11110001;
           rom[ 0+9755] =8'b11000011;
           rom[ 0+9756] =8'b10100011;
           rom[ 0+9757] =8'b00100111;
           rom[ 0+9758] =8'b11011101;
           rom[ 0+9759] =8'b01111110;
           rom[ 0+9760] =8'b11111100;
           rom[ 0+9761] =8'b11110101;
           rom[ 0+9762] =8'b00110011;
           rom[ 0+9763] =8'b11011101;
           rom[ 0+9764] =8'b01111110;
           rom[ 0+9765] =8'b11111100;
           rom[ 0+9766] =8'b11110101;
           rom[ 0+9767] =8'b00110011;
           rom[ 0+9768] =8'b11001101;
           rom[ 0+9769] =8'b00001110;
           rom[ 0+9770] =8'b00100000;
           rom[ 0+9771] =8'b01001101;
           rom[ 0+9772] =8'b11110001;
           rom[ 0+9773] =8'b01111001;
           rom[ 0+9774] =8'b11110101;
           rom[ 0+9775] =8'b00110011;
           rom[ 0+9776] =8'b11011101;
           rom[ 0+9777] =8'b01111110;
           rom[ 0+9778] =8'b11111011;
           rom[ 0+9779] =8'b11110101;
           rom[ 0+9780] =8'b00110011;
           rom[ 0+9781] =8'b11001101;
           rom[ 0+9782] =8'b01101111;
           rom[ 0+9783] =8'b00100000;
           rom[ 0+9784] =8'b01001101;
           rom[ 0+9785] =8'b11110001;
           rom[ 0+9786] =8'b11011101;
           rom[ 0+9787] =8'b01110001;
           rom[ 0+9788] =8'b11111010;
           rom[ 0+9789] =8'b00111110;
           rom[ 0+9790] =8'b10011100;
           rom[ 0+9791] =8'b11011101;
           rom[ 0+9792] =8'b10000110;
           rom[ 0+9793] =8'b11111010;
           rom[ 0+9794] =8'b01001111;
           rom[ 0+9795] =8'b00111110;
           rom[ 0+9796] =8'b00000101;
           rom[ 0+9797] =8'b11001110;
           rom[ 0+9798] =8'b00000000;
           rom[ 0+9799] =8'b01000111;
           rom[ 0+9800] =8'b00001010;
           rom[ 0+9801] =8'b01001111;
           rom[ 0+9802] =8'b11110101;
           rom[ 0+9803] =8'b00110011;
           rom[ 0+9804] =8'b11011101;
           rom[ 0+9805] =8'b01111110;
           rom[ 0+9806] =8'b11111100;
           rom[ 0+9807] =8'b11110101;
           rom[ 0+9808] =8'b00110011;
           rom[ 0+9809] =8'b11001101;
           rom[ 0+9810] =8'b00001110;
           rom[ 0+9811] =8'b00100000;
           rom[ 0+9812] =8'b01001101;
           rom[ 0+9813] =8'b11110001;
           rom[ 0+9814] =8'b11011101;
           rom[ 0+9815] =8'b01110001;
           rom[ 0+9816] =8'b11110101;
           rom[ 0+9817] =8'b11011101;
           rom[ 0+9818] =8'b00110110;
           rom[ 0+9819] =8'b11110110;
           rom[ 0+9820] =8'b00000000;
           rom[ 0+9821] =8'b00111110;
           rom[ 0+9822] =8'b10011100;
           rom[ 0+9823] =8'b11011101;
           rom[ 0+9824] =8'b10000110;
           rom[ 0+9825] =8'b11111010;
           rom[ 0+9826] =8'b01011111;
           rom[ 0+9827] =8'b00111110;
           rom[ 0+9828] =8'b00000101;
           rom[ 0+9829] =8'b11001110;
           rom[ 0+9830] =8'b00000000;
           rom[ 0+9831] =8'b01010111;
           rom[ 0+9832] =8'b00011010;
           rom[ 0+9833] =8'b01011111;
           rom[ 0+9834] =8'b11101110;
           rom[ 0+9835] =8'b00000001;
           rom[ 0+9836] =8'b01011111;
           rom[ 0+9837] =8'b11110101;
           rom[ 0+9838] =8'b00110011;
           rom[ 0+9839] =8'b11011101;
           rom[ 0+9840] =8'b01111110;
           rom[ 0+9841] =8'b11111100;
           rom[ 0+9842] =8'b11110101;
           rom[ 0+9843] =8'b00110011;
           rom[ 0+9844] =8'b11001101;
           rom[ 0+9845] =8'b00001110;
           rom[ 0+9846] =8'b00100000;
           rom[ 0+9847] =8'b01011101;
           rom[ 0+9848] =8'b11110001;
           rom[ 0+9849] =8'b11011101;
           rom[ 0+9850] =8'b01110011;
           rom[ 0+9851] =8'b11110011;
           rom[ 0+9852] =8'b11011101;
           rom[ 0+9853] =8'b00110110;
           rom[ 0+9854] =8'b11110100;
           rom[ 0+9855] =8'b00000000;
           rom[ 0+9856] =8'b00111110;
           rom[ 0+9857] =8'b10011100;
           rom[ 0+9858] =8'b11011101;
           rom[ 0+9859] =8'b10000110;
           rom[ 0+9860] =8'b11110011;
           rom[ 0+9861] =8'b01001111;
           rom[ 0+9862] =8'b00111110;
           rom[ 0+9863] =8'b00000010;
           rom[ 0+9864] =8'b11011101;
           rom[ 0+9865] =8'b10001110;
           rom[ 0+9866] =8'b11110100;
           rom[ 0+9867] =8'b01000111;
           rom[ 0+9868] =8'b00001010;
           rom[ 0+9869] =8'b01001111;
           rom[ 0+9870] =8'b11011101;
           rom[ 0+9871] =8'b01110001;
           rom[ 0+9872] =8'b11101111;
           rom[ 0+9873] =8'b11011101;
           rom[ 0+9874] =8'b00110110;
           rom[ 0+9875] =8'b11110000;
           rom[ 0+9876] =8'b00000000;
           rom[ 0+9877] =8'b00111110;
           rom[ 0+9878] =8'b10011100;
           rom[ 0+9879] =8'b11011101;
           rom[ 0+9880] =8'b10000110;
           rom[ 0+9881] =8'b11110101;
           rom[ 0+9882] =8'b01001111;
           rom[ 0+9883] =8'b00111110;
           rom[ 0+9884] =8'b00000010;
           rom[ 0+9885] =8'b11011101;
           rom[ 0+9886] =8'b10001110;
           rom[ 0+9887] =8'b11110110;
           rom[ 0+9888] =8'b01000111;
           rom[ 0+9889] =8'b00001010;
           rom[ 0+9890] =8'b01001111;
           rom[ 0+9891] =8'b11011101;
           rom[ 0+9892] =8'b01110001;
           rom[ 0+9893] =8'b11110001;
           rom[ 0+9894] =8'b11011101;
           rom[ 0+9895] =8'b00110110;
           rom[ 0+9896] =8'b11110010;
           rom[ 0+9897] =8'b00000000;
           rom[ 0+9898] =8'b11011101;
           rom[ 0+9899] =8'b01111110;
           rom[ 0+9900] =8'b11110101;
           rom[ 0+9901] =8'b11011101;
           rom[ 0+9902] =8'b10101110;
           rom[ 0+9903] =8'b11110011;
           rom[ 0+9904] =8'b01001111;
           rom[ 0+9905] =8'b11011101;
           rom[ 0+9906] =8'b01111110;
           rom[ 0+9907] =8'b11110110;
           rom[ 0+9908] =8'b11011101;
           rom[ 0+9909] =8'b10101110;
           rom[ 0+9910] =8'b11110100;
           rom[ 0+9911] =8'b01000111;
           rom[ 0+9912] =8'b00111110;
           rom[ 0+9913] =8'b00000110;
           rom[ 0+9914] =8'b11011101;
           rom[ 0+9915] =8'b10000110;
           rom[ 0+9916] =8'b11100110;
           rom[ 0+9917] =8'b01000111;
           rom[ 0+9918] =8'b00111110;
           rom[ 0+9919] =8'b10010000;
           rom[ 0+9920] =8'b11011101;
           rom[ 0+9921] =8'b10001110;
           rom[ 0+9922] =8'b11100111;
           rom[ 0+9923] =8'b01011111;
           rom[ 0+9924] =8'b01101000;
           rom[ 0+9925] =8'b01100011;
           rom[ 0+9926] =8'b01000110;
           rom[ 0+9927] =8'b11011101;
           rom[ 0+9928] =8'b01011110;
           rom[ 0+9929] =8'b11110011;
           rom[ 0+9930] =8'b11000101;
           rom[ 0+9931] =8'b11000101;
           rom[ 0+9932] =8'b00110011;
           rom[ 0+9933] =8'b01111011;
           rom[ 0+9934] =8'b11110101;
           rom[ 0+9935] =8'b00110011;
           rom[ 0+9936] =8'b11001101;
           rom[ 0+9937] =8'b00001110;
           rom[ 0+9938] =8'b00100000;
           rom[ 0+9939] =8'b01000101;
           rom[ 0+9940] =8'b11110001;
           rom[ 0+9941] =8'b01111000;
           rom[ 0+9942] =8'b11000001;
           rom[ 0+9943] =8'b01000111;
           rom[ 0+9944] =8'b00111110;
           rom[ 0+9945] =8'b00000110;
           rom[ 0+9946] =8'b11011101;
           rom[ 0+9947] =8'b10000110;
           rom[ 0+9948] =8'b11100110;
           rom[ 0+9949] =8'b01011111;
           rom[ 0+9950] =8'b00111110;
           rom[ 0+9951] =8'b10010000;
           rom[ 0+9952] =8'b11011101;
           rom[ 0+9953] =8'b10001110;
           rom[ 0+9954] =8'b11100111;
           rom[ 0+9955] =8'b01010111;
           rom[ 0+9956] =8'b00010011;
           rom[ 0+9957] =8'b00011010;
           rom[ 0+9958] =8'b01011111;
           rom[ 0+9959] =8'b01111000;
           rom[ 0+9960] =8'b10101011;
           rom[ 0+9961] =8'b01000111;
           rom[ 0+9962] =8'b01111001;
           rom[ 0+9963] =8'b11110101;
           rom[ 0+9964] =8'b00110011;
           rom[ 0+9965] =8'b11000101;
           rom[ 0+9966] =8'b00110011;
           rom[ 0+9967] =8'b11001101;
           rom[ 0+9968] =8'b01101111;
           rom[ 0+9969] =8'b00100000;
           rom[ 0+9970] =8'b01001101;
           rom[ 0+9971] =8'b11110001;
           rom[ 0+9972] =8'b11011101;
           rom[ 0+9973] =8'b01110001;
           rom[ 0+9974] =8'b11101101;
           rom[ 0+9975] =8'b11011101;
           rom[ 0+9976] =8'b00110110;
           rom[ 0+9977] =8'b11101110;
           rom[ 0+9978] =8'b00000000;
           rom[ 0+9979] =8'b00111110;
           rom[ 0+9980] =8'b00000110;
           rom[ 0+9981] =8'b11011101;
           rom[ 0+9982] =8'b10000110;
           rom[ 0+9983] =8'b11100110;
           rom[ 0+9984] =8'b01011111;
           rom[ 0+9985] =8'b00111110;
           rom[ 0+9986] =8'b10010000;
           rom[ 0+9987] =8'b11011101;
           rom[ 0+9988] =8'b10001110;
           rom[ 0+9989] =8'b11100111;
           rom[ 0+9990] =8'b01010111;
           rom[ 0+9991] =8'b00011010;
           rom[ 0+9992] =8'b01011111;
           rom[ 0+9993] =8'b00010110;
           rom[ 0+9994] =8'b00000000;
           rom[ 0+9995] =8'b01111011;
           rom[ 0+9996] =8'b11011101;
           rom[ 0+9997] =8'b10101110;
           rom[ 0+9998] =8'b11101101;
           rom[ 0+9999] =8'b01011111;
           rom[ 0+10000] =8'b01111010;
           rom[ 0+10001] =8'b11011101;
           rom[ 0+10002] =8'b10101110;
           rom[ 0+10003] =8'b11101110;
           rom[ 0+10004] =8'b01010111;
           rom[ 0+10005] =8'b11011101;
           rom[ 0+10006] =8'b01110011;
           rom[ 0+10007] =8'b11101011;
           rom[ 0+10008] =8'b11011101;
           rom[ 0+10009] =8'b01110010;
           rom[ 0+10010] =8'b11101100;
           rom[ 0+10011] =8'b11011101;
           rom[ 0+10012] =8'b01011110;
           rom[ 0+10013] =8'b00000110;
           rom[ 0+10014] =8'b11011101;
           rom[ 0+10015] =8'b01010110;
           rom[ 0+10016] =8'b00000111;
           rom[ 0+10017] =8'b01101011;
           rom[ 0+10018] =8'b01100010;
           rom[ 0+10019] =8'b00101001;
           rom[ 0+10020] =8'b00011001;
           rom[ 0+10021] =8'b00101001;
           rom[ 0+10022] =8'b00101001;
           rom[ 0+10023] =8'b00011001;
           rom[ 0+10024] =8'b01011101;
           rom[ 0+10025] =8'b01010100;
           rom[ 0+10026] =8'b00100001;
           rom[ 0+10027] =8'b00000011;
           rom[ 0+10028] =8'b10000100;
           rom[ 0+10029] =8'b00011001;
           rom[ 0+10030] =8'b01011101;
           rom[ 0+10031] =8'b01010100;
           rom[ 0+10032] =8'b00110110;
           rom[ 0+10033] =8'b00000010;
           rom[ 0+10034] =8'b00100011;
           rom[ 0+10035] =8'b00110110;
           rom[ 0+10036] =8'b00000000;
           rom[ 0+10037] =8'b01111011;
           rom[ 0+10038] =8'b11000110;
           rom[ 0+10039] =8'b00000100;
           rom[ 0+10040] =8'b11011101;
           rom[ 0+10041] =8'b01110111;
           rom[ 0+10042] =8'b11100110;
           rom[ 0+10043] =8'b01111010;
           rom[ 0+10044] =8'b11001110;
           rom[ 0+10045] =8'b00000000;
           rom[ 0+10046] =8'b11011101;
           rom[ 0+10047] =8'b01110111;
           rom[ 0+10048] =8'b11100111;
           rom[ 0+10049] =8'b11011101;
           rom[ 0+10050] =8'b01111110;
           rom[ 0+10051] =8'b00000100;
           rom[ 0+10052] =8'b11000110;
           rom[ 0+10053] =8'b11111111;
           rom[ 0+10054] =8'b11011101;
           rom[ 0+10055] =8'b01110111;
           rom[ 0+10056] =8'b11101001;
           rom[ 0+10057] =8'b11011101;
           rom[ 0+10058] =8'b01111110;
           rom[ 0+10059] =8'b00000101;
           rom[ 0+10060] =8'b11001110;
           rom[ 0+10061] =8'b11111111;
           rom[ 0+10062] =8'b11011101;
           rom[ 0+10063] =8'b01110111;
           rom[ 0+10064] =8'b11101010;
           rom[ 0+10065] =8'b11011101;
           rom[ 0+10066] =8'b01111110;
           rom[ 0+10067] =8'b11101001;
           rom[ 0+10068] =8'b11011101;
           rom[ 0+10069] =8'b10010110;
           rom[ 0+10070] =8'b11110001;
           rom[ 0+10071] =8'b01001111;
           rom[ 0+10072] =8'b11011101;
           rom[ 0+10073] =8'b01111110;
           rom[ 0+10074] =8'b11101010;
           rom[ 0+10075] =8'b11011101;
           rom[ 0+10076] =8'b10011110;
           rom[ 0+10077] =8'b11110010;
           rom[ 0+10078] =8'b01000111;
           rom[ 0+10079] =8'b11011101;
           rom[ 0+10080] =8'b01101110;
           rom[ 0+10081] =8'b11100110;
           rom[ 0+10082] =8'b11011101;
           rom[ 0+10083] =8'b01100110;
           rom[ 0+10084] =8'b11100111;
           rom[ 0+10085] =8'b01110001;
           rom[ 0+10086] =8'b00100011;
           rom[ 0+10087] =8'b01110000;
           rom[ 0+10088] =8'b01111011;
           rom[ 0+10089] =8'b11000110;
           rom[ 0+10090] =8'b00001010;
           rom[ 0+10091] =8'b01001111;
           rom[ 0+10092] =8'b01111010;
           rom[ 0+10093] =8'b11001110;
           rom[ 0+10094] =8'b00000000;
           rom[ 0+10095] =8'b01000111;
           rom[ 0+10096] =8'b11011101;
           rom[ 0+10097] =8'b01111110;
           rom[ 0+10098] =8'b11101101;
           rom[ 0+10099] =8'b00000010;
           rom[ 0+10100] =8'b01111011;
           rom[ 0+10101] =8'b11000110;
           rom[ 0+10102] =8'b00000110;
           rom[ 0+10103] =8'b11011101;
           rom[ 0+10104] =8'b01110111;
           rom[ 0+10105] =8'b11100110;
           rom[ 0+10106] =8'b01111010;
           rom[ 0+10107] =8'b11001110;
           rom[ 0+10108] =8'b00000000;
           rom[ 0+10109] =8'b11011101;
           rom[ 0+10110] =8'b01110111;
           rom[ 0+10111] =8'b11100111;
           rom[ 0+10112] =8'b11011101;
           rom[ 0+10113] =8'b01111110;
           rom[ 0+10114] =8'b11101001;
           rom[ 0+10115] =8'b11011101;
           rom[ 0+10116] =8'b10010110;
           rom[ 0+10117] =8'b11101111;
           rom[ 0+10118] =8'b01001111;
           rom[ 0+10119] =8'b11011101;
           rom[ 0+10120] =8'b01111110;
           rom[ 0+10121] =8'b11101010;
           rom[ 0+10122] =8'b11011101;
           rom[ 0+10123] =8'b10011110;
           rom[ 0+10124] =8'b11110000;
           rom[ 0+10125] =8'b01000111;
           rom[ 0+10126] =8'b11011101;
           rom[ 0+10127] =8'b01101110;
           rom[ 0+10128] =8'b11100110;
           rom[ 0+10129] =8'b11011101;
           rom[ 0+10130] =8'b01100110;
           rom[ 0+10131] =8'b11100111;
           rom[ 0+10132] =8'b01110001;
           rom[ 0+10133] =8'b00100011;
           rom[ 0+10134] =8'b01110000;
           rom[ 0+10135] =8'b01111011;
           rom[ 0+10136] =8'b11000110;
           rom[ 0+10137] =8'b00001011;
           rom[ 0+10138] =8'b01011111;
           rom[ 0+10139] =8'b01111010;
           rom[ 0+10140] =8'b11001110;
           rom[ 0+10141] =8'b00000000;
           rom[ 0+10142] =8'b01010111;
           rom[ 0+10143] =8'b11011101;
           rom[ 0+10144] =8'b01111110;
           rom[ 0+10145] =8'b11101011;
           rom[ 0+10146] =8'b00010010;
           rom[ 0+10147] =8'b11011101;
           rom[ 0+10148] =8'b11111001;
           rom[ 0+10149] =8'b11011101;
           rom[ 0+10150] =8'b11100001;
           rom[ 0+10151] =8'b11001001;
           rom[ 0+10152] =8'b11011101;
           rom[ 0+10153] =8'b11100101;
           rom[ 0+10154] =8'b11011101;
           rom[ 0+10155] =8'b00100001;
           rom[ 0+10156] =8'b00000000;
           rom[ 0+10157] =8'b00000000;
           rom[ 0+10158] =8'b11011101;
           rom[ 0+10159] =8'b00111001;
           rom[ 0+10160] =8'b00100001;
           rom[ 0+10161] =8'b11001011;
           rom[ 0+10162] =8'b11111111;
           rom[ 0+10163] =8'b00111001;
           rom[ 0+10164] =8'b11111001;
           rom[ 0+10165] =8'b11011101;
           rom[ 0+10166] =8'b01011110;
           rom[ 0+10167] =8'b00000110;
           rom[ 0+10168] =8'b11011101;
           rom[ 0+10169] =8'b01010110;
           rom[ 0+10170] =8'b00000111;
           rom[ 0+10171] =8'b01101011;
           rom[ 0+10172] =8'b01100010;
           rom[ 0+10173] =8'b00101001;
           rom[ 0+10174] =8'b00011001;
           rom[ 0+10175] =8'b00101001;
           rom[ 0+10176] =8'b00011001;
           rom[ 0+10177] =8'b01001101;
           rom[ 0+10178] =8'b01000100;
           rom[ 0+10179] =8'b00100001;
           rom[ 0+10180] =8'b00000110;
           rom[ 0+10181] =8'b10010000;
           rom[ 0+10182] =8'b00001001;
           rom[ 0+10183] =8'b11011101;
           rom[ 0+10184] =8'b01110101;
           rom[ 0+10185] =8'b11010001;
           rom[ 0+10186] =8'b11011101;
           rom[ 0+10187] =8'b01110100;
           rom[ 0+10188] =8'b11010010;
           rom[ 0+10189] =8'b11011101;
           rom[ 0+10190] =8'b01111110;
           rom[ 0+10191] =8'b11010001;
           rom[ 0+10192] =8'b11000110;
           rom[ 0+10193] =8'b00000011;
           rom[ 0+10194] =8'b01011111;
           rom[ 0+10195] =8'b11011101;
           rom[ 0+10196] =8'b01111110;
           rom[ 0+10197] =8'b11010010;
           rom[ 0+10198] =8'b11001110;
           rom[ 0+10199] =8'b00000000;
           rom[ 0+10200] =8'b01010111;
           rom[ 0+10201] =8'b00011010;
           rom[ 0+10202] =8'b01011111;
           rom[ 0+10203] =8'b11011101;
           rom[ 0+10204] =8'b01101110;
           rom[ 0+10205] =8'b11010001;
           rom[ 0+10206] =8'b11011101;
           rom[ 0+10207] =8'b01100110;
           rom[ 0+10208] =8'b11010010;
           rom[ 0+10209] =8'b01010110;
           rom[ 0+10210] =8'b11000101;
           rom[ 0+10211] =8'b01111011;
           rom[ 0+10212] =8'b11110101;
           rom[ 0+10213] =8'b00110011;
           rom[ 0+10214] =8'b11010101;
           rom[ 0+10215] =8'b00110011;
           rom[ 0+10216] =8'b11001101;
           rom[ 0+10217] =8'b00001110;
           rom[ 0+10218] =8'b00100000;
           rom[ 0+10219] =8'b01011101;
           rom[ 0+10220] =8'b11110001;
           rom[ 0+10221] =8'b11000001;
           rom[ 0+10222] =8'b11011101;
           rom[ 0+10223] =8'b01110011;
           rom[ 0+10224] =8'b11111111;
           rom[ 0+10225] =8'b00100001;
           rom[ 0+10226] =8'b00000110;
           rom[ 0+10227] =8'b10010000;
           rom[ 0+10228] =8'b00001001;
           rom[ 0+10229] =8'b11011101;
           rom[ 0+10230] =8'b01110101;
           rom[ 0+10231] =8'b11010001;
           rom[ 0+10232] =8'b11011101;
           rom[ 0+10233] =8'b01110100;
           rom[ 0+10234] =8'b11010010;
           rom[ 0+10235] =8'b11011101;
           rom[ 0+10236] =8'b01011110;
           rom[ 0+10237] =8'b11010001;
           rom[ 0+10238] =8'b11011101;
           rom[ 0+10239] =8'b01010110;
           rom[ 0+10240] =8'b11010010;
           rom[ 0+10241] =8'b00010011;
           rom[ 0+10242] =8'b00010011;
           rom[ 0+10243] =8'b00011010;
           rom[ 0+10244] =8'b01011111;
           rom[ 0+10245] =8'b11011101;
           rom[ 0+10246] =8'b01101110;
           rom[ 0+10247] =8'b11010001;
           rom[ 0+10248] =8'b11011101;
           rom[ 0+10249] =8'b01100110;
           rom[ 0+10250] =8'b11010010;
           rom[ 0+10251] =8'b01010110;
           rom[ 0+10252] =8'b11000101;
           rom[ 0+10253] =8'b01111011;
           rom[ 0+10254] =8'b11110101;
           rom[ 0+10255] =8'b00110011;
           rom[ 0+10256] =8'b11010101;
           rom[ 0+10257] =8'b00110011;
           rom[ 0+10258] =8'b11001101;
           rom[ 0+10259] =8'b00001110;
           rom[ 0+10260] =8'b00100000;
           rom[ 0+10261] =8'b01011101;
           rom[ 0+10262] =8'b11110001;
           rom[ 0+10263] =8'b11000001;
           rom[ 0+10264] =8'b11011101;
           rom[ 0+10265] =8'b01110011;
           rom[ 0+10266] =8'b11111110;
           rom[ 0+10267] =8'b00100001;
           rom[ 0+10268] =8'b00000110;
           rom[ 0+10269] =8'b10010000;
           rom[ 0+10270] =8'b00001001;
           rom[ 0+10271] =8'b01010101;
           rom[ 0+10272] =8'b01011100;
           rom[ 0+10273] =8'b00010100;
           rom[ 0+10274] =8'b11000010;
           rom[ 0+10275] =8'b00100110;
           rom[ 0+10276] =8'b00101000;
           rom[ 0+10277] =8'b00011100;
           rom[ 0+10278] =8'b01101010;
           rom[ 0+10279] =8'b01100011;
           rom[ 0+10280] =8'b01010110;
           rom[ 0+10281] =8'b11000101;
           rom[ 0+10282] =8'b11010101;
           rom[ 0+10283] =8'b00110011;
           rom[ 0+10284] =8'b11010101;
           rom[ 0+10285] =8'b00110011;
           rom[ 0+10286] =8'b11001101;
           rom[ 0+10287] =8'b00001110;
           rom[ 0+10288] =8'b00100000;
           rom[ 0+10289] =8'b01011101;
           rom[ 0+10290] =8'b11110001;
           rom[ 0+10291] =8'b11000001;
           rom[ 0+10292] =8'b11011101;
           rom[ 0+10293] =8'b01110011;
           rom[ 0+10294] =8'b11111101;
           rom[ 0+10295] =8'b00100001;
           rom[ 0+10296] =8'b00000110;
           rom[ 0+10297] =8'b10010000;
           rom[ 0+10298] =8'b00001001;
           rom[ 0+10299] =8'b11011101;
           rom[ 0+10300] =8'b01110101;
           rom[ 0+10301] =8'b11010001;
           rom[ 0+10302] =8'b11011101;
           rom[ 0+10303] =8'b01110100;
           rom[ 0+10304] =8'b11010010;
           rom[ 0+10305] =8'b11011101;
           rom[ 0+10306] =8'b01111110;
           rom[ 0+10307] =8'b11010001;
           rom[ 0+10308] =8'b11000110;
           rom[ 0+10309] =8'b00000011;
           rom[ 0+10310] =8'b01011111;
           rom[ 0+10311] =8'b11011101;
           rom[ 0+10312] =8'b01111110;
           rom[ 0+10313] =8'b11010010;
           rom[ 0+10314] =8'b11001110;
           rom[ 0+10315] =8'b00000000;
           rom[ 0+10316] =8'b01010111;
           rom[ 0+10317] =8'b00011010;
           rom[ 0+10318] =8'b11011101;
           rom[ 0+10319] =8'b01110111;
           rom[ 0+10320] =8'b11010000;
           rom[ 0+10321] =8'b11011101;
           rom[ 0+10322] =8'b01111110;
           rom[ 0+10323] =8'b11010001;
           rom[ 0+10324] =8'b11000110;
           rom[ 0+10325] =8'b00000001;
           rom[ 0+10326] =8'b01010111;
           rom[ 0+10327] =8'b11011101;
           rom[ 0+10328] =8'b01111110;
           rom[ 0+10329] =8'b11010010;
           rom[ 0+10330] =8'b11001110;
           rom[ 0+10331] =8'b00000000;
           rom[ 0+10332] =8'b01011111;
           rom[ 0+10333] =8'b01101010;
           rom[ 0+10334] =8'b01100011;
           rom[ 0+10335] =8'b01010110;
           rom[ 0+10336] =8'b11000101;
           rom[ 0+10337] =8'b11011101;
           rom[ 0+10338] =8'b01111110;
           rom[ 0+10339] =8'b11010000;
           rom[ 0+10340] =8'b11110101;
           rom[ 0+10341] =8'b00110011;
           rom[ 0+10342] =8'b11010101;
           rom[ 0+10343] =8'b00110011;
           rom[ 0+10344] =8'b11001101;
           rom[ 0+10345] =8'b00001110;
           rom[ 0+10346] =8'b00100000;
           rom[ 0+10347] =8'b01011101;
           rom[ 0+10348] =8'b11110001;
           rom[ 0+10349] =8'b11000001;
           rom[ 0+10350] =8'b11011101;
           rom[ 0+10351] =8'b01110011;
           rom[ 0+10352] =8'b11111100;
           rom[ 0+10353] =8'b00100001;
           rom[ 0+10354] =8'b00000110;
           rom[ 0+10355] =8'b10010000;
           rom[ 0+10356] =8'b00001001;
           rom[ 0+10357] =8'b11011101;
           rom[ 0+10358] =8'b01110101;
           rom[ 0+10359] =8'b11010001;
           rom[ 0+10360] =8'b11011101;
           rom[ 0+10361] =8'b01110100;
           rom[ 0+10362] =8'b11010010;
           rom[ 0+10363] =8'b11011101;
           rom[ 0+10364] =8'b01011110;
           rom[ 0+10365] =8'b11010001;
           rom[ 0+10366] =8'b11011101;
           rom[ 0+10367] =8'b01010110;
           rom[ 0+10368] =8'b11010010;
           rom[ 0+10369] =8'b00010011;
           rom[ 0+10370] =8'b00010011;
           rom[ 0+10371] =8'b00011010;
           rom[ 0+10372] =8'b11011101;
           rom[ 0+10373] =8'b01110111;
           rom[ 0+10374] =8'b11010000;
           rom[ 0+10375] =8'b11011101;
           rom[ 0+10376] =8'b01111110;
           rom[ 0+10377] =8'b11010001;
           rom[ 0+10378] =8'b11000110;
           rom[ 0+10379] =8'b00000001;
           rom[ 0+10380] =8'b01010111;
           rom[ 0+10381] =8'b11011101;
           rom[ 0+10382] =8'b01111110;
           rom[ 0+10383] =8'b11010010;
           rom[ 0+10384] =8'b11001110;
           rom[ 0+10385] =8'b00000000;
           rom[ 0+10386] =8'b01011111;
           rom[ 0+10387] =8'b01101010;
           rom[ 0+10388] =8'b01100011;
           rom[ 0+10389] =8'b01010110;
           rom[ 0+10390] =8'b11000101;
           rom[ 0+10391] =8'b11011101;
           rom[ 0+10392] =8'b01111110;
           rom[ 0+10393] =8'b11010000;
           rom[ 0+10394] =8'b11110101;
           rom[ 0+10395] =8'b00110011;
           rom[ 0+10396] =8'b11010101;
           rom[ 0+10397] =8'b00110011;
           rom[ 0+10398] =8'b11001101;
           rom[ 0+10399] =8'b00001110;
           rom[ 0+10400] =8'b00100000;
           rom[ 0+10401] =8'b01011101;
           rom[ 0+10402] =8'b11110001;
           rom[ 0+10403] =8'b11000001;
           rom[ 0+10404] =8'b11011101;
           rom[ 0+10405] =8'b01110011;
           rom[ 0+10406] =8'b11111011;
           rom[ 0+10407] =8'b00100001;
           rom[ 0+10408] =8'b00000110;
           rom[ 0+10409] =8'b10010000;
           rom[ 0+10410] =8'b00001001;
           rom[ 0+10411] =8'b01010101;
           rom[ 0+10412] =8'b01011100;
           rom[ 0+10413] =8'b01111010;
           rom[ 0+10414] =8'b11000110;
           rom[ 0+10415] =8'b00000010;
           rom[ 0+10416] =8'b01010111;
           rom[ 0+10417] =8'b01111011;
           rom[ 0+10418] =8'b11001110;
           rom[ 0+10419] =8'b00000000;
           rom[ 0+10420] =8'b01011111;
           rom[ 0+10421] =8'b01101010;
           rom[ 0+10422] =8'b01100011;
           rom[ 0+10423] =8'b01010110;
           rom[ 0+10424] =8'b11000101;
           rom[ 0+10425] =8'b11010101;
           rom[ 0+10426] =8'b00110011;
           rom[ 0+10427] =8'b11010101;
           rom[ 0+10428] =8'b00110011;
           rom[ 0+10429] =8'b11001101;
           rom[ 0+10430] =8'b00001110;
           rom[ 0+10431] =8'b00100000;
           rom[ 0+10432] =8'b01011101;
           rom[ 0+10433] =8'b11110001;
           rom[ 0+10434] =8'b11000001;
           rom[ 0+10435] =8'b11011101;
           rom[ 0+10436] =8'b01110011;
           rom[ 0+10437] =8'b11111010;
           rom[ 0+10438] =8'b00100001;
           rom[ 0+10439] =8'b00000110;
           rom[ 0+10440] =8'b10010000;
           rom[ 0+10441] =8'b00001001;
           rom[ 0+10442] =8'b11011101;
           rom[ 0+10443] =8'b01110101;
           rom[ 0+10444] =8'b11010001;
           rom[ 0+10445] =8'b11011101;
           rom[ 0+10446] =8'b01110100;
           rom[ 0+10447] =8'b11010010;
           rom[ 0+10448] =8'b11011101;
           rom[ 0+10449] =8'b01111110;
           rom[ 0+10450] =8'b11010001;
           rom[ 0+10451] =8'b11000110;
           rom[ 0+10452] =8'b00000100;
           rom[ 0+10453] =8'b01011111;
           rom[ 0+10454] =8'b11011101;
           rom[ 0+10455] =8'b01111110;
           rom[ 0+10456] =8'b11010010;
           rom[ 0+10457] =8'b11001110;
           rom[ 0+10458] =8'b00000000;
           rom[ 0+10459] =8'b01010111;
           rom[ 0+10460] =8'b00011010;
           rom[ 0+10461] =8'b01011111;
           rom[ 0+10462] =8'b11011101;
           rom[ 0+10463] =8'b01101110;
           rom[ 0+10464] =8'b11010001;
           rom[ 0+10465] =8'b11011101;
           rom[ 0+10466] =8'b01100110;
           rom[ 0+10467] =8'b11010010;
           rom[ 0+10468] =8'b01010110;
           rom[ 0+10469] =8'b11000101;
           rom[ 0+10470] =8'b01111011;
           rom[ 0+10471] =8'b11110101;
           rom[ 0+10472] =8'b00110011;
           rom[ 0+10473] =8'b11010101;
           rom[ 0+10474] =8'b00110011;
           rom[ 0+10475] =8'b11001101;
           rom[ 0+10476] =8'b00001110;
           rom[ 0+10477] =8'b00100000;
           rom[ 0+10478] =8'b01011101;
           rom[ 0+10479] =8'b11110001;
           rom[ 0+10480] =8'b11000001;
           rom[ 0+10481] =8'b11011101;
           rom[ 0+10482] =8'b01110011;
           rom[ 0+10483] =8'b11111001;
           rom[ 0+10484] =8'b00100001;
           rom[ 0+10485] =8'b00000110;
           rom[ 0+10486] =8'b10010000;
           rom[ 0+10487] =8'b00001001;
           rom[ 0+10488] =8'b11011101;
           rom[ 0+10489] =8'b01110101;
           rom[ 0+10490] =8'b11010001;
           rom[ 0+10491] =8'b11011101;
           rom[ 0+10492] =8'b01110100;
           rom[ 0+10493] =8'b11010010;
           rom[ 0+10494] =8'b11011101;
           rom[ 0+10495] =8'b01111110;
           rom[ 0+10496] =8'b11010001;
           rom[ 0+10497] =8'b11000110;
           rom[ 0+10498] =8'b00000101;
           rom[ 0+10499] =8'b01011111;
           rom[ 0+10500] =8'b11011101;
           rom[ 0+10501] =8'b01111110;
           rom[ 0+10502] =8'b11010010;
           rom[ 0+10503] =8'b11001110;
           rom[ 0+10504] =8'b00000000;
           rom[ 0+10505] =8'b01010111;
           rom[ 0+10506] =8'b00011010;
           rom[ 0+10507] =8'b01011111;
           rom[ 0+10508] =8'b11011101;
           rom[ 0+10509] =8'b01101110;
           rom[ 0+10510] =8'b11010001;
           rom[ 0+10511] =8'b11011101;
           rom[ 0+10512] =8'b01100110;
           rom[ 0+10513] =8'b11010010;
           rom[ 0+10514] =8'b01010110;
           rom[ 0+10515] =8'b11000101;
           rom[ 0+10516] =8'b01111011;
           rom[ 0+10517] =8'b11110101;
           rom[ 0+10518] =8'b00110011;
           rom[ 0+10519] =8'b11010101;
           rom[ 0+10520] =8'b00110011;
           rom[ 0+10521] =8'b11001101;
           rom[ 0+10522] =8'b00001110;
           rom[ 0+10523] =8'b00100000;
           rom[ 0+10524] =8'b01011101;
           rom[ 0+10525] =8'b11110001;
           rom[ 0+10526] =8'b11000001;
           rom[ 0+10527] =8'b11011101;
           rom[ 0+10528] =8'b01110011;
           rom[ 0+10529] =8'b11111000;
           rom[ 0+10530] =8'b00100001;
           rom[ 0+10531] =8'b00000110;
           rom[ 0+10532] =8'b10010000;
           rom[ 0+10533] =8'b00001001;
           rom[ 0+10534] =8'b11011101;
           rom[ 0+10535] =8'b01110101;
           rom[ 0+10536] =8'b11010001;
           rom[ 0+10537] =8'b11011101;
           rom[ 0+10538] =8'b01110100;
           rom[ 0+10539] =8'b11010010;
           rom[ 0+10540] =8'b11011101;
           rom[ 0+10541] =8'b01111110;
           rom[ 0+10542] =8'b11010001;
           rom[ 0+10543] =8'b11000110;
           rom[ 0+10544] =8'b00000011;
           rom[ 0+10545] =8'b01011111;
           rom[ 0+10546] =8'b11011101;
           rom[ 0+10547] =8'b01111110;
           rom[ 0+10548] =8'b11010010;
           rom[ 0+10549] =8'b11001110;
           rom[ 0+10550] =8'b00000000;
           rom[ 0+10551] =8'b01010111;
           rom[ 0+10552] =8'b00011010;
           rom[ 0+10553] =8'b11011101;
           rom[ 0+10554] =8'b01110111;
           rom[ 0+10555] =8'b11010000;
           rom[ 0+10556] =8'b11011101;
           rom[ 0+10557] =8'b01111110;
           rom[ 0+10558] =8'b11010001;
           rom[ 0+10559] =8'b11000110;
           rom[ 0+10560] =8'b00000010;
           rom[ 0+10561] =8'b01010111;
           rom[ 0+10562] =8'b11011101;
           rom[ 0+10563] =8'b01111110;
           rom[ 0+10564] =8'b11010010;
           rom[ 0+10565] =8'b11001110;
           rom[ 0+10566] =8'b00000000;
           rom[ 0+10567] =8'b01011111;
           rom[ 0+10568] =8'b01101010;
           rom[ 0+10569] =8'b01100011;
           rom[ 0+10570] =8'b01010110;
           rom[ 0+10571] =8'b11000101;
           rom[ 0+10572] =8'b11011101;
           rom[ 0+10573] =8'b01111110;
           rom[ 0+10574] =8'b11010000;
           rom[ 0+10575] =8'b11110101;
           rom[ 0+10576] =8'b00110011;
           rom[ 0+10577] =8'b11010101;
           rom[ 0+10578] =8'b00110011;
           rom[ 0+10579] =8'b11001101;
           rom[ 0+10580] =8'b00001110;
           rom[ 0+10581] =8'b00100000;
           rom[ 0+10582] =8'b01011101;
           rom[ 0+10583] =8'b11110001;
           rom[ 0+10584] =8'b11000001;
           rom[ 0+10585] =8'b11011101;
           rom[ 0+10586] =8'b01110011;
           rom[ 0+10587] =8'b11110110;
           rom[ 0+10588] =8'b11011101;
           rom[ 0+10589] =8'b01111110;
           rom[ 0+10590] =8'b11111111;
           rom[ 0+10591] =8'b11011101;
           rom[ 0+10592] =8'b10101110;
           rom[ 0+10593] =8'b11111011;
           rom[ 0+10594] =8'b01010111;
           rom[ 0+10595] =8'b11011101;
           rom[ 0+10596] =8'b01110010;
           rom[ 0+10597] =8'b11101111;
           rom[ 0+10598] =8'b11011101;
           rom[ 0+10599] =8'b01111110;
           rom[ 0+10600] =8'b11111010;
           rom[ 0+10601] =8'b11011101;
           rom[ 0+10602] =8'b10101110;
           rom[ 0+10603] =8'b11111100;
           rom[ 0+10604] =8'b01011111;
           rom[ 0+10605] =8'b11011101;
           rom[ 0+10606] =8'b01110011;
           rom[ 0+10607] =8'b11101110;
           rom[ 0+10608] =8'b11011101;
           rom[ 0+10609] =8'b01111110;
           rom[ 0+10610] =8'b11111110;
           rom[ 0+10611] =8'b11011101;
           rom[ 0+10612] =8'b10101110;
           rom[ 0+10613] =8'b11111101;
           rom[ 0+10614] =8'b01011111;
           rom[ 0+10615] =8'b11011101;
           rom[ 0+10616] =8'b01110011;
           rom[ 0+10617] =8'b11110000;
           rom[ 0+10618] =8'b11011101;
           rom[ 0+10619] =8'b01111110;
           rom[ 0+10620] =8'b11111100;
           rom[ 0+10621] =8'b11011101;
           rom[ 0+10622] =8'b10101110;
           rom[ 0+10623] =8'b11111001;
           rom[ 0+10624] =8'b01011111;
           rom[ 0+10625] =8'b11000101;
           rom[ 0+10626] =8'b01111011;
           rom[ 0+10627] =8'b11110101;
           rom[ 0+10628] =8'b00110011;
           rom[ 0+10629] =8'b11011101;
           rom[ 0+10630] =8'b01111110;
           rom[ 0+10631] =8'b11101111;
           rom[ 0+10632] =8'b11110101;
           rom[ 0+10633] =8'b00110011;
           rom[ 0+10634] =8'b11001101;
           rom[ 0+10635] =8'b00001110;
           rom[ 0+10636] =8'b00100000;
           rom[ 0+10637] =8'b01011101;
           rom[ 0+10638] =8'b11110001;
           rom[ 0+10639] =8'b11000001;
           rom[ 0+10640] =8'b11011101;
           rom[ 0+10641] =8'b01111110;
           rom[ 0+10642] =8'b11110110;
           rom[ 0+10643] =8'b11011101;
           rom[ 0+10644] =8'b10101110;
           rom[ 0+10645] =8'b11111000;
           rom[ 0+10646] =8'b01010111;
           rom[ 0+10647] =8'b11000101;
           rom[ 0+10648] =8'b11010101;
           rom[ 0+10649] =8'b11010101;
           rom[ 0+10650] =8'b00110011;
           rom[ 0+10651] =8'b11011101;
           rom[ 0+10652] =8'b01111110;
           rom[ 0+10653] =8'b11110000;
           rom[ 0+10654] =8'b11110101;
           rom[ 0+10655] =8'b00110011;
           rom[ 0+10656] =8'b11001101;
           rom[ 0+10657] =8'b00001110;
           rom[ 0+10658] =8'b00100000;
           rom[ 0+10659] =8'b01010101;
           rom[ 0+10660] =8'b11110001;
           rom[ 0+10661] =8'b01111010;
           rom[ 0+10662] =8'b11010001;
           rom[ 0+10663] =8'b01010111;
           rom[ 0+10664] =8'b11000001;
           rom[ 0+10665] =8'b01111011;
           rom[ 0+10666] =8'b10101010;
           rom[ 0+10667] =8'b01011111;
           rom[ 0+10668] =8'b11011101;
           rom[ 0+10669] =8'b01110011;
           rom[ 0+10670] =8'b11110100;
           rom[ 0+10671] =8'b11000101;
           rom[ 0+10672] =8'b11011101;
           rom[ 0+10673] =8'b01111110;
           rom[ 0+10674] =8'b11101111;
           rom[ 0+10675] =8'b11110101;
           rom[ 0+10676] =8'b00110011;
           rom[ 0+10677] =8'b11011101;
           rom[ 0+10678] =8'b01111110;
           rom[ 0+10679] =8'b11101111;
           rom[ 0+10680] =8'b11110101;
           rom[ 0+10681] =8'b00110011;
           rom[ 0+10682] =8'b11001101;
           rom[ 0+10683] =8'b00001110;
           rom[ 0+10684] =8'b00100000;
           rom[ 0+10685] =8'b01010101;
           rom[ 0+10686] =8'b11110001;
           rom[ 0+10687] =8'b11000001;
           rom[ 0+10688] =8'b11011101;
           rom[ 0+10689] =8'b01111110;
           rom[ 0+10690] =8'b11111010;
           rom[ 0+10691] =8'b11011101;
           rom[ 0+10692] =8'b10101110;
           rom[ 0+10693] =8'b11111001;
           rom[ 0+10694] =8'b01011111;
           rom[ 0+10695] =8'b11000101;
           rom[ 0+10696] =8'b11010101;
           rom[ 0+10697] =8'b01111011;
           rom[ 0+10698] =8'b11110101;
           rom[ 0+10699] =8'b00110011;
           rom[ 0+10700] =8'b11011101;
           rom[ 0+10701] =8'b01111110;
           rom[ 0+10702] =8'b11110000;
           rom[ 0+10703] =8'b11110101;
           rom[ 0+10704] =8'b00110011;
           rom[ 0+10705] =8'b11001101;
           rom[ 0+10706] =8'b00001110;
           rom[ 0+10707] =8'b00100000;
           rom[ 0+10708] =8'b01011101;
           rom[ 0+10709] =8'b11110001;
           rom[ 0+10710] =8'b11110001;
           rom[ 0+10711] =8'b01010111;
           rom[ 0+10712] =8'b11000001;
           rom[ 0+10713] =8'b01111010;
           rom[ 0+10714] =8'b10101011;
           rom[ 0+10715] =8'b01010111;
           rom[ 0+10716] =8'b11000101;
           rom[ 0+10717] =8'b11010101;
           rom[ 0+10718] =8'b00110011;
           rom[ 0+10719] =8'b11011101;
           rom[ 0+10720] =8'b01111110;
           rom[ 0+10721] =8'b11110100;
           rom[ 0+10722] =8'b11110101;
           rom[ 0+10723] =8'b00110011;
           rom[ 0+10724] =8'b11001101;
           rom[ 0+10725] =8'b01101111;
           rom[ 0+10726] =8'b00100000;
           rom[ 0+10727] =8'b01011101;
           rom[ 0+10728] =8'b11110001;
           rom[ 0+10729] =8'b11000001;
           rom[ 0+10730] =8'b11011101;
           rom[ 0+10731] =8'b01110011;
           rom[ 0+10732] =8'b11110010;
           rom[ 0+10733] =8'b00100001;
           rom[ 0+10734] =8'b00000110;
           rom[ 0+10735] =8'b10010000;
           rom[ 0+10736] =8'b00001001;
           rom[ 0+10737] =8'b11011101;
           rom[ 0+10738] =8'b01110101;
           rom[ 0+10739] =8'b11010001;
           rom[ 0+10740] =8'b11011101;
           rom[ 0+10741] =8'b01110100;
           rom[ 0+10742] =8'b11010010;
           rom[ 0+10743] =8'b11011101;
           rom[ 0+10744] =8'b01111110;
           rom[ 0+10745] =8'b11010001;
           rom[ 0+10746] =8'b11000110;
           rom[ 0+10747] =8'b00000100;
           rom[ 0+10748] =8'b01011111;
           rom[ 0+10749] =8'b11011101;
           rom[ 0+10750] =8'b01111110;
           rom[ 0+10751] =8'b11010010;
           rom[ 0+10752] =8'b11001110;
           rom[ 0+10753] =8'b00000000;
           rom[ 0+10754] =8'b01010111;
           rom[ 0+10755] =8'b00011010;
           rom[ 0+10756] =8'b11011101;
           rom[ 0+10757] =8'b01110111;
           rom[ 0+10758] =8'b11010000;
           rom[ 0+10759] =8'b11011101;
           rom[ 0+10760] =8'b01111110;
           rom[ 0+10761] =8'b11010001;
           rom[ 0+10762] =8'b11000110;
           rom[ 0+10763] =8'b00000010;
           rom[ 0+10764] =8'b01010111;
           rom[ 0+10765] =8'b11011101;
           rom[ 0+10766] =8'b01111110;
           rom[ 0+10767] =8'b11010010;
           rom[ 0+10768] =8'b11001110;
           rom[ 0+10769] =8'b00000000;
           rom[ 0+10770] =8'b01011111;
           rom[ 0+10771] =8'b01101010;
           rom[ 0+10772] =8'b01100011;
           rom[ 0+10773] =8'b01010110;
           rom[ 0+10774] =8'b11000101;
           rom[ 0+10775] =8'b11011101;
           rom[ 0+10776] =8'b01111110;
           rom[ 0+10777] =8'b11010000;
           rom[ 0+10778] =8'b11110101;
           rom[ 0+10779] =8'b00110011;
           rom[ 0+10780] =8'b11010101;
           rom[ 0+10781] =8'b00110011;
           rom[ 0+10782] =8'b11001101;
           rom[ 0+10783] =8'b00001110;
           rom[ 0+10784] =8'b00100000;
           rom[ 0+10785] =8'b01011101;
           rom[ 0+10786] =8'b11110001;
           rom[ 0+10787] =8'b11000001;
           rom[ 0+10788] =8'b11011101;
           rom[ 0+10789] =8'b01110011;
           rom[ 0+10790] =8'b11110101;
           rom[ 0+10791] =8'b00100001;
           rom[ 0+10792] =8'b00000110;
           rom[ 0+10793] =8'b10010000;
           rom[ 0+10794] =8'b00001001;
           rom[ 0+10795] =8'b11011101;
           rom[ 0+10796] =8'b01110101;
           rom[ 0+10797] =8'b11010001;
           rom[ 0+10798] =8'b11011101;
           rom[ 0+10799] =8'b01110100;
           rom[ 0+10800] =8'b11010010;
           rom[ 0+10801] =8'b11011101;
           rom[ 0+10802] =8'b01111110;
           rom[ 0+10803] =8'b11010001;
           rom[ 0+10804] =8'b11000110;
           rom[ 0+10805] =8'b00000100;
           rom[ 0+10806] =8'b01011111;
           rom[ 0+10807] =8'b11011101;
           rom[ 0+10808] =8'b01111110;
           rom[ 0+10809] =8'b11010010;
           rom[ 0+10810] =8'b11001110;
           rom[ 0+10811] =8'b00000000;
           rom[ 0+10812] =8'b01010111;
           rom[ 0+10813] =8'b00011010;
           rom[ 0+10814] =8'b11011101;
           rom[ 0+10815] =8'b01110111;
           rom[ 0+10816] =8'b11010000;
           rom[ 0+10817] =8'b11011101;
           rom[ 0+10818] =8'b01111110;
           rom[ 0+10819] =8'b11010001;
           rom[ 0+10820] =8'b11000110;
           rom[ 0+10821] =8'b00000001;
           rom[ 0+10822] =8'b01010111;
           rom[ 0+10823] =8'b11011101;
           rom[ 0+10824] =8'b01111110;
           rom[ 0+10825] =8'b11010010;
           rom[ 0+10826] =8'b11001110;
           rom[ 0+10827] =8'b00000000;
           rom[ 0+10828] =8'b01011111;
           rom[ 0+10829] =8'b01101010;
           rom[ 0+10830] =8'b01100011;
           rom[ 0+10831] =8'b01010110;
           rom[ 0+10832] =8'b11000101;
           rom[ 0+10833] =8'b11011101;
           rom[ 0+10834] =8'b01111110;
           rom[ 0+10835] =8'b11010000;
           rom[ 0+10836] =8'b11110101;
           rom[ 0+10837] =8'b00110011;
           rom[ 0+10838] =8'b11010101;
           rom[ 0+10839] =8'b00110011;
           rom[ 0+10840] =8'b11001101;
           rom[ 0+10841] =8'b00001110;
           rom[ 0+10842] =8'b00100000;
           rom[ 0+10843] =8'b01011101;
           rom[ 0+10844] =8'b11110001;
           rom[ 0+10845] =8'b11000001;
           rom[ 0+10846] =8'b11011101;
           rom[ 0+10847] =8'b01110011;
           rom[ 0+10848] =8'b11110111;
           rom[ 0+10849] =8'b00100001;
           rom[ 0+10850] =8'b00000110;
           rom[ 0+10851] =8'b10010000;
           rom[ 0+10852] =8'b00001001;
           rom[ 0+10853] =8'b11011101;
           rom[ 0+10854] =8'b01110101;
           rom[ 0+10855] =8'b11010001;
           rom[ 0+10856] =8'b11011101;
           rom[ 0+10857] =8'b01110100;
           rom[ 0+10858] =8'b11010010;
           rom[ 0+10859] =8'b11011101;
           rom[ 0+10860] =8'b01111110;
           rom[ 0+10861] =8'b11010001;
           rom[ 0+10862] =8'b11000110;
           rom[ 0+10863] =8'b00000101;
           rom[ 0+10864] =8'b01011111;
           rom[ 0+10865] =8'b11011101;
           rom[ 0+10866] =8'b01111110;
           rom[ 0+10867] =8'b11010010;
           rom[ 0+10868] =8'b11001110;
           rom[ 0+10869] =8'b00000000;
           rom[ 0+10870] =8'b01010111;
           rom[ 0+10871] =8'b00011010;
           rom[ 0+10872] =8'b11011101;
           rom[ 0+10873] =8'b01110111;
           rom[ 0+10874] =8'b11010000;
           rom[ 0+10875] =8'b11011101;
           rom[ 0+10876] =8'b01111110;
           rom[ 0+10877] =8'b11010001;
           rom[ 0+10878] =8'b11000110;
           rom[ 0+10879] =8'b00000001;
           rom[ 0+10880] =8'b01010111;
           rom[ 0+10881] =8'b11011101;
           rom[ 0+10882] =8'b01111110;
           rom[ 0+10883] =8'b11010010;
           rom[ 0+10884] =8'b11001110;
           rom[ 0+10885] =8'b00000000;
           rom[ 0+10886] =8'b01011111;
           rom[ 0+10887] =8'b01101010;
           rom[ 0+10888] =8'b01100011;
           rom[ 0+10889] =8'b01010110;
           rom[ 0+10890] =8'b11000101;
           rom[ 0+10891] =8'b11011101;
           rom[ 0+10892] =8'b01111110;
           rom[ 0+10893] =8'b11010000;
           rom[ 0+10894] =8'b11110101;
           rom[ 0+10895] =8'b00110011;
           rom[ 0+10896] =8'b11010101;
           rom[ 0+10897] =8'b00110011;
           rom[ 0+10898] =8'b11001101;
           rom[ 0+10899] =8'b00001110;
           rom[ 0+10900] =8'b00100000;
           rom[ 0+10901] =8'b01011101;
           rom[ 0+10902] =8'b11110001;
           rom[ 0+10903] =8'b11000001;
           rom[ 0+10904] =8'b01111011;
           rom[ 0+10905] =8'b11011101;
           rom[ 0+10906] =8'b10101110;
           rom[ 0+10907] =8'b11110101;
           rom[ 0+10908] =8'b01011111;
           rom[ 0+10909] =8'b11011101;
           rom[ 0+10910] =8'b01111110;
           rom[ 0+10911] =8'b11110110;
           rom[ 0+10912] =8'b11011101;
           rom[ 0+10913] =8'b10101110;
           rom[ 0+10914] =8'b11110111;
           rom[ 0+10915] =8'b01010111;
           rom[ 0+10916] =8'b11000101;
           rom[ 0+10917] =8'b11010101;
           rom[ 0+10918] =8'b11011101;
           rom[ 0+10919] =8'b01111110;
           rom[ 0+10920] =8'b11110010;
           rom[ 0+10921] =8'b11110101;
           rom[ 0+10922] =8'b00110011;
           rom[ 0+10923] =8'b11010101;
           rom[ 0+10924] =8'b00110011;
           rom[ 0+10925] =8'b11001101;
           rom[ 0+10926] =8'b00001110;
           rom[ 0+10927] =8'b00100000;
           rom[ 0+10928] =8'b01010101;
           rom[ 0+10929] =8'b11110001;
           rom[ 0+10930] =8'b01111010;
           rom[ 0+10931] =8'b11010001;
           rom[ 0+10932] =8'b01010111;
           rom[ 0+10933] =8'b11000001;
           rom[ 0+10934] =8'b01111011;
           rom[ 0+10935] =8'b10101010;
           rom[ 0+10936] =8'b01011111;
           rom[ 0+10937] =8'b11000101;
           rom[ 0+10938] =8'b11011101;
           rom[ 0+10939] =8'b01111110;
           rom[ 0+10940] =8'b11101110;
           rom[ 0+10941] =8'b11110101;
           rom[ 0+10942] =8'b00110011;
           rom[ 0+10943] =8'b01111011;
           rom[ 0+10944] =8'b11110101;
           rom[ 0+10945] =8'b00110011;
           rom[ 0+10946] =8'b11001101;
           rom[ 0+10947] =8'b01101111;
           rom[ 0+10948] =8'b00100000;
           rom[ 0+10949] =8'b01011101;
           rom[ 0+10950] =8'b11110001;
           rom[ 0+10951] =8'b11000001;
           rom[ 0+10952] =8'b11011101;
           rom[ 0+10953] =8'b01110011;
           rom[ 0+10954] =8'b11110001;
           rom[ 0+10955] =8'b00100001;
           rom[ 0+10956] =8'b00000110;
           rom[ 0+10957] =8'b10010000;
           rom[ 0+10958] =8'b00001001;
           rom[ 0+10959] =8'b11011101;
           rom[ 0+10960] =8'b01110101;
           rom[ 0+10961] =8'b11010001;
           rom[ 0+10962] =8'b11011101;
           rom[ 0+10963] =8'b01110100;
           rom[ 0+10964] =8'b11010010;
           rom[ 0+10965] =8'b11011101;
           rom[ 0+10966] =8'b01111110;
           rom[ 0+10967] =8'b11010001;
           rom[ 0+10968] =8'b11000110;
           rom[ 0+10969] =8'b00000011;
           rom[ 0+10970] =8'b01011111;
           rom[ 0+10971] =8'b11011101;
           rom[ 0+10972] =8'b01111110;
           rom[ 0+10973] =8'b11010010;
           rom[ 0+10974] =8'b11001110;
           rom[ 0+10975] =8'b00000000;
           rom[ 0+10976] =8'b01010111;
           rom[ 0+10977] =8'b00011010;
           rom[ 0+10978] =8'b11011101;
           rom[ 0+10979] =8'b01110111;
           rom[ 0+10980] =8'b11010000;
           rom[ 0+10981] =8'b11011101;
           rom[ 0+10982] =8'b01111110;
           rom[ 0+10983] =8'b11010001;
           rom[ 0+10984] =8'b11000110;
           rom[ 0+10985] =8'b00000001;
           rom[ 0+10986] =8'b01010111;
           rom[ 0+10987] =8'b11011101;
           rom[ 0+10988] =8'b01111110;
           rom[ 0+10989] =8'b11010010;
           rom[ 0+10990] =8'b11001110;
           rom[ 0+10991] =8'b00000000;
           rom[ 0+10992] =8'b01011111;
           rom[ 0+10993] =8'b01101010;
           rom[ 0+10994] =8'b01100011;
           rom[ 0+10995] =8'b01010110;
           rom[ 0+10996] =8'b11000101;
           rom[ 0+10997] =8'b11011101;
           rom[ 0+10998] =8'b01111110;
           rom[ 0+10999] =8'b11110001;
           rom[ 0+11000] =8'b11110101;
           rom[ 0+11001] =8'b00110011;
           rom[ 0+11002] =8'b11010101;
           rom[ 0+11003] =8'b00110011;
           rom[ 0+11004] =8'b11001101;
           rom[ 0+11005] =8'b00001110;
           rom[ 0+11006] =8'b00100000;
           rom[ 0+11007] =8'b01011101;
           rom[ 0+11008] =8'b11110001;
           rom[ 0+11009] =8'b11000001;
           rom[ 0+11010] =8'b11011101;
           rom[ 0+11011] =8'b01111110;
           rom[ 0+11012] =8'b11010000;
           rom[ 0+11013] =8'b10101011;
           rom[ 0+11014] =8'b11011101;
           rom[ 0+11015] =8'b01110111;
           rom[ 0+11016] =8'b11010000;
           rom[ 0+11017] =8'b00100001;
           rom[ 0+11018] =8'b00000110;
           rom[ 0+11019] =8'b10010000;
           rom[ 0+11020] =8'b00001001;
           rom[ 0+11021] =8'b01010101;
           rom[ 0+11022] =8'b01011100;
           rom[ 0+11023] =8'b01111010;
           rom[ 0+11024] =8'b11000110;
           rom[ 0+11025] =8'b00000010;
           rom[ 0+11026] =8'b01010111;
           rom[ 0+11027] =8'b01111011;
           rom[ 0+11028] =8'b11001110;
           rom[ 0+11029] =8'b00000000;
           rom[ 0+11030] =8'b01011111;
           rom[ 0+11031] =8'b01101010;
           rom[ 0+11032] =8'b01100011;
           rom[ 0+11033] =8'b01010110;
           rom[ 0+11034] =8'b11000101;
           rom[ 0+11035] =8'b11011101;
           rom[ 0+11036] =8'b01111110;
           rom[ 0+11037] =8'b11110010;
           rom[ 0+11038] =8'b11110101;
           rom[ 0+11039] =8'b00110011;
           rom[ 0+11040] =8'b11010101;
           rom[ 0+11041] =8'b00110011;
           rom[ 0+11042] =8'b11001101;
           rom[ 0+11043] =8'b00001110;
           rom[ 0+11044] =8'b00100000;
           rom[ 0+11045] =8'b01011101;
           rom[ 0+11046] =8'b11110001;
           rom[ 0+11047] =8'b11000001;
           rom[ 0+11048] =8'b01111011;
           rom[ 0+11049] =8'b11011101;
           rom[ 0+11050] =8'b10101110;
           rom[ 0+11051] =8'b11010000;
           rom[ 0+11052] =8'b01011111;
           rom[ 0+11053] =8'b11011101;
           rom[ 0+11054] =8'b01110011;
           rom[ 0+11055] =8'b11110011;
           rom[ 0+11056] =8'b00100001;
           rom[ 0+11057] =8'b00000110;
           rom[ 0+11058] =8'b10010000;
           rom[ 0+11059] =8'b00001001;
           rom[ 0+11060] =8'b01010101;
           rom[ 0+11061] =8'b01011100;
           rom[ 0+11062] =8'b01010110;
           rom[ 0+11063] =8'b11000101;
           rom[ 0+11064] =8'b11010101;
           rom[ 0+11065] =8'b00110011;
           rom[ 0+11066] =8'b11011101;
           rom[ 0+11067] =8'b01111110;
           rom[ 0+11068] =8'b11110011;
           rom[ 0+11069] =8'b11110101;
           rom[ 0+11070] =8'b00110011;
           rom[ 0+11071] =8'b11001101;
           rom[ 0+11072] =8'b01101111;
           rom[ 0+11073] =8'b00100000;
           rom[ 0+11074] =8'b01011101;
           rom[ 0+11075] =8'b11110001;
           rom[ 0+11076] =8'b11000001;
           rom[ 0+11077] =8'b11011101;
           rom[ 0+11078] =8'b01110011;
           rom[ 0+11079] =8'b11101101;
           rom[ 0+11080] =8'b11000101;
           rom[ 0+11081] =8'b11011101;
           rom[ 0+11082] =8'b01111110;
           rom[ 0+11083] =8'b11110010;
           rom[ 0+11084] =8'b11110101;
           rom[ 0+11085] =8'b00110011;
           rom[ 0+11086] =8'b11011101;
           rom[ 0+11087] =8'b01111110;
           rom[ 0+11088] =8'b11110010;
           rom[ 0+11089] =8'b11110101;
           rom[ 0+11090] =8'b00110011;
           rom[ 0+11091] =8'b11001101;
           rom[ 0+11092] =8'b00001110;
           rom[ 0+11093] =8'b00100000;
           rom[ 0+11094] =8'b01010101;
           rom[ 0+11095] =8'b11110001;
           rom[ 0+11096] =8'b11000001;
           rom[ 0+11097] =8'b01111010;
           rom[ 0+11098] =8'b11011101;
           rom[ 0+11099] =8'b10101110;
           rom[ 0+11100] =8'b11110001;
           rom[ 0+11101] =8'b01010111;
           rom[ 0+11102] =8'b00011110;
           rom[ 0+11103] =8'b00000000;
           rom[ 0+11104] =8'b11011101;
           rom[ 0+11105] =8'b01110010;
           rom[ 0+11106] =8'b11001111;
           rom[ 0+11107] =8'b11000101;
           rom[ 0+11108] =8'b11011101;
           rom[ 0+11109] =8'b01111110;
           rom[ 0+11110] =8'b11001111;
           rom[ 0+11111] =8'b11110101;
           rom[ 0+11112] =8'b00110011;
           rom[ 0+11113] =8'b11011101;
           rom[ 0+11114] =8'b01111110;
           rom[ 0+11115] =8'b11001111;
           rom[ 0+11116] =8'b11110101;
           rom[ 0+11117] =8'b00110011;
           rom[ 0+11118] =8'b11001101;
           rom[ 0+11119] =8'b00001110;
           rom[ 0+11120] =8'b00100000;
           rom[ 0+11121] =8'b01011101;
           rom[ 0+11122] =8'b11110001;
           rom[ 0+11123] =8'b11000001;
           rom[ 0+11124] =8'b11000101;
           rom[ 0+11125] =8'b11011101;
           rom[ 0+11126] =8'b01111110;
           rom[ 0+11127] =8'b11001111;
           rom[ 0+11128] =8'b11110101;
           rom[ 0+11129] =8'b00110011;
           rom[ 0+11130] =8'b01111011;
           rom[ 0+11131] =8'b11110101;
           rom[ 0+11132] =8'b00110011;
           rom[ 0+11133] =8'b11001101;
           rom[ 0+11134] =8'b00001110;
           rom[ 0+11135] =8'b00100000;
           rom[ 0+11136] =8'b01011101;
           rom[ 0+11137] =8'b11110001;
           rom[ 0+11138] =8'b11000001;
           rom[ 0+11139] =8'b11011101;
           rom[ 0+11140] =8'b01110011;
           rom[ 0+11141] =8'b11100101;
           rom[ 0+11142] =8'b11011101;
           rom[ 0+11143] =8'b00110110;
           rom[ 0+11144] =8'b11100110;
           rom[ 0+11145] =8'b00000000;
           rom[ 0+11146] =8'b11000101;
           rom[ 0+11147] =8'b11011101;
           rom[ 0+11148] =8'b01111110;
           rom[ 0+11149] =8'b11110001;
           rom[ 0+11150] =8'b11110101;
           rom[ 0+11151] =8'b00110011;
           rom[ 0+11152] =8'b11011101;
           rom[ 0+11153] =8'b01111110;
           rom[ 0+11154] =8'b11110010;
           rom[ 0+11155] =8'b11110101;
           rom[ 0+11156] =8'b00110011;
           rom[ 0+11157] =8'b11001101;
           rom[ 0+11158] =8'b00001110;
           rom[ 0+11159] =8'b00100000;
           rom[ 0+11160] =8'b01011101;
           rom[ 0+11161] =8'b11110001;
           rom[ 0+11162] =8'b11000001;
           rom[ 0+11163] =8'b01111011;
           rom[ 0+11164] =8'b11011101;
           rom[ 0+11165] =8'b10101110;
           rom[ 0+11166] =8'b11101101;
           rom[ 0+11167] =8'b01011111;
           rom[ 0+11168] =8'b00010110;
           rom[ 0+11169] =8'b00000000;
           rom[ 0+11170] =8'b11011101;
           rom[ 0+11171] =8'b01110011;
           rom[ 0+11172] =8'b11010000;
           rom[ 0+11173] =8'b11000101;
           rom[ 0+11174] =8'b11011101;
           rom[ 0+11175] =8'b01111110;
           rom[ 0+11176] =8'b11010000;
           rom[ 0+11177] =8'b11110101;
           rom[ 0+11178] =8'b00110011;
           rom[ 0+11179] =8'b11011101;
           rom[ 0+11180] =8'b01111110;
           rom[ 0+11181] =8'b11010000;
           rom[ 0+11182] =8'b11110101;
           rom[ 0+11183] =8'b00110011;
           rom[ 0+11184] =8'b11001101;
           rom[ 0+11185] =8'b00001110;
           rom[ 0+11186] =8'b00100000;
           rom[ 0+11187] =8'b01011101;
           rom[ 0+11188] =8'b11110001;
           rom[ 0+11189] =8'b11000001;
           rom[ 0+11190] =8'b00010110;
           rom[ 0+11191] =8'b00000000;
           rom[ 0+11192] =8'b01010011;
           rom[ 0+11193] =8'b11011101;
           rom[ 0+11194] =8'b01011110;
           rom[ 0+11195] =8'b11100101;
           rom[ 0+11196] =8'b11000101;
           rom[ 0+11197] =8'b11010101;
           rom[ 0+11198] =8'b00110011;
           rom[ 0+11199] =8'b01111011;
           rom[ 0+11200] =8'b11110101;
           rom[ 0+11201] =8'b00110011;
           rom[ 0+11202] =8'b11001101;
           rom[ 0+11203] =8'b01101111;
           rom[ 0+11204] =8'b00100000;
           rom[ 0+11205] =8'b01011101;
           rom[ 0+11206] =8'b11110001;
           rom[ 0+11207] =8'b11000001;
           rom[ 0+11208] =8'b11011101;
           rom[ 0+11209] =8'b01110011;
           rom[ 0+11210] =8'b11110000;
           rom[ 0+11211] =8'b00111110;
           rom[ 0+11212] =8'b10011100;
           rom[ 0+11213] =8'b11011101;
           rom[ 0+11214] =8'b10000110;
           rom[ 0+11215] =8'b11110000;
           rom[ 0+11216] =8'b01011111;
           rom[ 0+11217] =8'b00111110;
           rom[ 0+11218] =8'b00000101;
           rom[ 0+11219] =8'b11001110;
           rom[ 0+11220] =8'b00000000;
           rom[ 0+11221] =8'b01010111;
           rom[ 0+11222] =8'b00011010;
           rom[ 0+11223] =8'b01011111;
           rom[ 0+11224] =8'b00010110;
           rom[ 0+11225] =8'b00000000;
           rom[ 0+11226] =8'b11000101;
           rom[ 0+11227] =8'b11011101;
           rom[ 0+11228] =8'b01111110;
           rom[ 0+11229] =8'b11010000;
           rom[ 0+11230] =8'b11110101;
           rom[ 0+11231] =8'b00110011;
           rom[ 0+11232] =8'b01111011;
           rom[ 0+11233] =8'b11110101;
           rom[ 0+11234] =8'b00110011;
           rom[ 0+11235] =8'b11001101;
           rom[ 0+11236] =8'b00001110;
           rom[ 0+11237] =8'b00100000;
           rom[ 0+11238] =8'b01011101;
           rom[ 0+11239] =8'b11110001;
           rom[ 0+11240] =8'b11000001;
           rom[ 0+11241] =8'b00010110;
           rom[ 0+11242] =8'b00000000;
           rom[ 0+11243] =8'b00100001;
           rom[ 0+11244] =8'b10011100;
           rom[ 0+11245] =8'b00000110;
           rom[ 0+11246] =8'b00011001;
           rom[ 0+11247] =8'b01011101;
           rom[ 0+11248] =8'b01010100;
           rom[ 0+11249] =8'b00011010;
           rom[ 0+11250] =8'b01011111;
           rom[ 0+11251] =8'b11011101;
           rom[ 0+11252] =8'b01110011;
           rom[ 0+11253] =8'b11100011;
           rom[ 0+11254] =8'b11011101;
           rom[ 0+11255] =8'b00110110;
           rom[ 0+11256] =8'b11100100;
           rom[ 0+11257] =8'b00000000;
           rom[ 0+11258] =8'b11011101;
           rom[ 0+11259] =8'b01111110;
           rom[ 0+11260] =8'b11110010;
           rom[ 0+11261] =8'b11011101;
           rom[ 0+11262] =8'b01110111;
           rom[ 0+11263] =8'b11010001;
           rom[ 0+11264] =8'b11011101;
           rom[ 0+11265] =8'b00110110;
           rom[ 0+11266] =8'b11010010;
           rom[ 0+11267] =8'b00000000;
           rom[ 0+11268] =8'b11011101;
           rom[ 0+11269] =8'b01111110;
           rom[ 0+11270] =8'b11010001;
           rom[ 0+11271] =8'b11011101;
           rom[ 0+11272] =8'b10101110;
           rom[ 0+11273] =8'b11100011;
           rom[ 0+11274] =8'b11011101;
           rom[ 0+11275] =8'b01110111;
           rom[ 0+11276] =8'b11001101;
           rom[ 0+11277] =8'b11011101;
           rom[ 0+11278] =8'b01111110;
           rom[ 0+11279] =8'b11010010;
           rom[ 0+11280] =8'b11011101;
           rom[ 0+11281] =8'b10101110;
           rom[ 0+11282] =8'b11100100;
           rom[ 0+11283] =8'b11011101;
           rom[ 0+11284] =8'b01110111;
           rom[ 0+11285] =8'b11001110;
           rom[ 0+11286] =8'b11011101;
           rom[ 0+11287] =8'b01011110;
           rom[ 0+11288] =8'b11100011;
           rom[ 0+11289] =8'b11000101;
           rom[ 0+11290] =8'b01111011;
           rom[ 0+11291] =8'b11110101;
           rom[ 0+11292] =8'b00110011;
           rom[ 0+11293] =8'b11011101;
           rom[ 0+11294] =8'b01111110;
           rom[ 0+11295] =8'b11001111;
           rom[ 0+11296] =8'b11110101;
           rom[ 0+11297] =8'b00110011;
           rom[ 0+11298] =8'b11001101;
           rom[ 0+11299] =8'b01101111;
           rom[ 0+11300] =8'b00100000;
           rom[ 0+11301] =8'b01011101;
           rom[ 0+11302] =8'b11110001;
           rom[ 0+11303] =8'b11000001;
           rom[ 0+11304] =8'b00010110;
           rom[ 0+11305] =8'b00000000;
           rom[ 0+11306] =8'b01111011;
           rom[ 0+11307] =8'b11011101;
           rom[ 0+11308] =8'b10101110;
           rom[ 0+11309] =8'b11001101;
           rom[ 0+11310] =8'b01011111;
           rom[ 0+11311] =8'b01111010;
           rom[ 0+11312] =8'b11011101;
           rom[ 0+11313] =8'b10101110;
           rom[ 0+11314] =8'b11001110;
           rom[ 0+11315] =8'b01010111;
           rom[ 0+11316] =8'b11011101;
           rom[ 0+11317] =8'b01110011;
           rom[ 0+11318] =8'b11011101;
           rom[ 0+11319] =8'b11011101;
           rom[ 0+11320] =8'b01110010;
           rom[ 0+11321] =8'b11011110;
           rom[ 0+11322] =8'b00111110;
           rom[ 0+11323] =8'b10011100;
           rom[ 0+11324] =8'b11011101;
           rom[ 0+11325] =8'b10000110;
           rom[ 0+11326] =8'b11011101;
           rom[ 0+11327] =8'b01011111;
           rom[ 0+11328] =8'b00111110;
           rom[ 0+11329] =8'b00000010;
           rom[ 0+11330] =8'b11011101;
           rom[ 0+11331] =8'b10001110;
           rom[ 0+11332] =8'b11011110;
           rom[ 0+11333] =8'b01010111;
           rom[ 0+11334] =8'b00011010;
           rom[ 0+11335] =8'b01011111;
           rom[ 0+11336] =8'b11011101;
           rom[ 0+11337] =8'b01110011;
           rom[ 0+11338] =8'b11010111;
           rom[ 0+11339] =8'b11011101;
           rom[ 0+11340] =8'b00110110;
           rom[ 0+11341] =8'b11011000;
           rom[ 0+11342] =8'b00000000;
           rom[ 0+11343] =8'b00010001;
           rom[ 0+11344] =8'b11110001;
           rom[ 0+11345] =8'b00000011;
           rom[ 0+11346] =8'b00011010;
           rom[ 0+11347] =8'b01011111;
           rom[ 0+11348] =8'b11011101;
           rom[ 0+11349] =8'b01010110;
           rom[ 0+11350] =8'b11100011;
           rom[ 0+11351] =8'b11000101;
           rom[ 0+11352] =8'b11010101;
           rom[ 0+11353] =8'b01111011;
           rom[ 0+11354] =8'b11110101;
           rom[ 0+11355] =8'b00110011;
           rom[ 0+11356] =8'b11010101;
           rom[ 0+11357] =8'b00110011;
           rom[ 0+11358] =8'b11001101;
           rom[ 0+11359] =8'b00001110;
           rom[ 0+11360] =8'b00100000;
           rom[ 0+11361] =8'b01010101;
           rom[ 0+11362] =8'b11110001;
           rom[ 0+11363] =8'b01111010;
           rom[ 0+11364] =8'b11010001;
           rom[ 0+11365] =8'b01010111;
           rom[ 0+11366] =8'b11000001;
           rom[ 0+11367] =8'b11011101;
           rom[ 0+11368] =8'b01110010;
           rom[ 0+11369] =8'b11100001;
           rom[ 0+11370] =8'b11011101;
           rom[ 0+11371] =8'b00110110;
           rom[ 0+11372] =8'b11100010;
           rom[ 0+11373] =8'b00000000;
           rom[ 0+11374] =8'b11011101;
           rom[ 0+11375] =8'b01111110;
           rom[ 0+11376] =8'b11100001;
           rom[ 0+11377] =8'b11011101;
           rom[ 0+11378] =8'b01110111;
           rom[ 0+11379] =8'b11001101;
           rom[ 0+11380] =8'b11000101;
           rom[ 0+11381] =8'b01111011;
           rom[ 0+11382] =8'b11110101;
           rom[ 0+11383] =8'b00110011;
           rom[ 0+11384] =8'b11011101;
           rom[ 0+11385] =8'b01111110;
           rom[ 0+11386] =8'b11001101;
           rom[ 0+11387] =8'b11110101;
           rom[ 0+11388] =8'b00110011;
           rom[ 0+11389] =8'b11001101;
           rom[ 0+11390] =8'b00001110;
           rom[ 0+11391] =8'b00100000;
           rom[ 0+11392] =8'b01010101;
           rom[ 0+11393] =8'b11110001;
           rom[ 0+11394] =8'b11000001;
           rom[ 0+11395] =8'b11011101;
           rom[ 0+11396] =8'b01110010;
           rom[ 0+11397] =8'b11011111;
           rom[ 0+11398] =8'b11011101;
           rom[ 0+11399] =8'b00110110;
           rom[ 0+11400] =8'b11100000;
           rom[ 0+11401] =8'b00000000;
           rom[ 0+11402] =8'b11011101;
           rom[ 0+11403] =8'b01111110;
           rom[ 0+11404] =8'b11010001;
           rom[ 0+11405] =8'b11011101;
           rom[ 0+11406] =8'b10101110;
           rom[ 0+11407] =8'b11100001;
           rom[ 0+11408] =8'b11011101;
           rom[ 0+11409] =8'b01110111;
           rom[ 0+11410] =8'b11001011;
           rom[ 0+11411] =8'b11011101;
           rom[ 0+11412] =8'b01111110;
           rom[ 0+11413] =8'b11010010;
           rom[ 0+11414] =8'b11011101;
           rom[ 0+11415] =8'b10101110;
           rom[ 0+11416] =8'b11100010;
           rom[ 0+11417] =8'b11011101;
           rom[ 0+11418] =8'b01110111;
           rom[ 0+11419] =8'b11001100;
           rom[ 0+11420] =8'b11000101;
           rom[ 0+11421] =8'b11011101;
           rom[ 0+11422] =8'b01111110;
           rom[ 0+11423] =8'b11001101;
           rom[ 0+11424] =8'b11110101;
           rom[ 0+11425] =8'b00110011;
           rom[ 0+11426] =8'b11011101;
           rom[ 0+11427] =8'b01111110;
           rom[ 0+11428] =8'b11001111;
           rom[ 0+11429] =8'b11110101;
           rom[ 0+11430] =8'b00110011;
           rom[ 0+11431] =8'b11001101;
           rom[ 0+11432] =8'b01101111;
           rom[ 0+11433] =8'b00100000;
           rom[ 0+11434] =8'b01011101;
           rom[ 0+11435] =8'b11110001;
           rom[ 0+11436] =8'b11000001;
           rom[ 0+11437] =8'b00010110;
           rom[ 0+11438] =8'b00000000;
           rom[ 0+11439] =8'b01111011;
           rom[ 0+11440] =8'b11011101;
           rom[ 0+11441] =8'b10101110;
           rom[ 0+11442] =8'b11001011;
           rom[ 0+11443] =8'b01011111;
           rom[ 0+11444] =8'b01111010;
           rom[ 0+11445] =8'b11011101;
           rom[ 0+11446] =8'b10101110;
           rom[ 0+11447] =8'b11001100;
           rom[ 0+11448] =8'b01010111;
           rom[ 0+11449] =8'b11011101;
           rom[ 0+11450] =8'b01110011;
           rom[ 0+11451] =8'b11011011;
           rom[ 0+11452] =8'b11011101;
           rom[ 0+11453] =8'b01110010;
           rom[ 0+11454] =8'b11011100;
           rom[ 0+11455] =8'b11011101;
           rom[ 0+11456] =8'b01111110;
           rom[ 0+11457] =8'b11010001;
           rom[ 0+11458] =8'b11011101;
           rom[ 0+11459] =8'b10101110;
           rom[ 0+11460] =8'b11011111;
           rom[ 0+11461] =8'b11011101;
           rom[ 0+11462] =8'b01110111;
           rom[ 0+11463] =8'b11001011;
           rom[ 0+11464] =8'b11011101;
           rom[ 0+11465] =8'b01111110;
           rom[ 0+11466] =8'b11010010;
           rom[ 0+11467] =8'b11011101;
           rom[ 0+11468] =8'b10101110;
           rom[ 0+11469] =8'b11100000;
           rom[ 0+11470] =8'b11011101;
           rom[ 0+11471] =8'b01110111;
           rom[ 0+11472] =8'b11001100;
           rom[ 0+11473] =8'b11011101;
           rom[ 0+11474] =8'b01011110;
           rom[ 0+11475] =8'b11011111;
           rom[ 0+11476] =8'b11000101;
           rom[ 0+11477] =8'b01111011;
           rom[ 0+11478] =8'b11110101;
           rom[ 0+11479] =8'b00110011;
           rom[ 0+11480] =8'b11011101;
           rom[ 0+11481] =8'b01111110;
           rom[ 0+11482] =8'b11001111;
           rom[ 0+11483] =8'b11110101;
           rom[ 0+11484] =8'b00110011;
           rom[ 0+11485] =8'b11001101;
           rom[ 0+11486] =8'b01101111;
           rom[ 0+11487] =8'b00100000;
           rom[ 0+11488] =8'b01011101;
           rom[ 0+11489] =8'b11110001;
           rom[ 0+11490] =8'b11000001;
           rom[ 0+11491] =8'b00010110;
           rom[ 0+11492] =8'b00000000;
           rom[ 0+11493] =8'b01111011;
           rom[ 0+11494] =8'b11011101;
           rom[ 0+11495] =8'b10101110;
           rom[ 0+11496] =8'b11001011;
           rom[ 0+11497] =8'b01011111;
           rom[ 0+11498] =8'b01111010;
           rom[ 0+11499] =8'b11011101;
           rom[ 0+11500] =8'b10101110;
           rom[ 0+11501] =8'b11001100;
           rom[ 0+11502] =8'b01010111;
           rom[ 0+11503] =8'b11011101;
           rom[ 0+11504] =8'b01110011;
           rom[ 0+11505] =8'b11011001;
           rom[ 0+11506] =8'b11011101;
           rom[ 0+11507] =8'b01110010;
           rom[ 0+11508] =8'b11011010;
           rom[ 0+11509] =8'b00111110;
           rom[ 0+11510] =8'b10011100;
           rom[ 0+11511] =8'b11011101;
           rom[ 0+11512] =8'b10000110;
           rom[ 0+11513] =8'b11011011;
           rom[ 0+11514] =8'b01011111;
           rom[ 0+11515] =8'b00111110;
           rom[ 0+11516] =8'b00000010;
           rom[ 0+11517] =8'b11011101;
           rom[ 0+11518] =8'b10001110;
           rom[ 0+11519] =8'b11011100;
           rom[ 0+11520] =8'b01010111;
           rom[ 0+11521] =8'b00011010;
           rom[ 0+11522] =8'b01011111;
           rom[ 0+11523] =8'b11011101;
           rom[ 0+11524] =8'b01110011;
           rom[ 0+11525] =8'b11010101;
           rom[ 0+11526] =8'b11011101;
           rom[ 0+11527] =8'b00110110;
           rom[ 0+11528] =8'b11010110;
           rom[ 0+11529] =8'b00000000;
           rom[ 0+11530] =8'b00111110;
           rom[ 0+11531] =8'b10011100;
           rom[ 0+11532] =8'b11011101;
           rom[ 0+11533] =8'b10000110;
           rom[ 0+11534] =8'b11011001;
           rom[ 0+11535] =8'b01011111;
           rom[ 0+11536] =8'b00111110;
           rom[ 0+11537] =8'b00000010;
           rom[ 0+11538] =8'b11011101;
           rom[ 0+11539] =8'b10001110;
           rom[ 0+11540] =8'b11011010;
           rom[ 0+11541] =8'b01010111;
           rom[ 0+11542] =8'b00011010;
           rom[ 0+11543] =8'b01011111;
           rom[ 0+11544] =8'b11011101;
           rom[ 0+11545] =8'b01110011;
           rom[ 0+11546] =8'b11010011;
           rom[ 0+11547] =8'b11011101;
           rom[ 0+11548] =8'b00110110;
           rom[ 0+11549] =8'b11010100;
           rom[ 0+11550] =8'b00000000;
           rom[ 0+11551] =8'b11011101;
           rom[ 0+11552] =8'b01111110;
           rom[ 0+11553] =8'b11011011;
           rom[ 0+11554] =8'b11011101;
           rom[ 0+11555] =8'b10101110;
           rom[ 0+11556] =8'b11011001;
           rom[ 0+11557] =8'b01011111;
           rom[ 0+11558] =8'b11011101;
           rom[ 0+11559] =8'b01111110;
           rom[ 0+11560] =8'b11011100;
           rom[ 0+11561] =8'b11011101;
           rom[ 0+11562] =8'b10101110;
           rom[ 0+11563] =8'b11011010;
           rom[ 0+11564] =8'b01010111;
           rom[ 0+11565] =8'b11011101;
           rom[ 0+11566] =8'b01110011;
           rom[ 0+11567] =8'b11001011;
           rom[ 0+11568] =8'b11011101;
           rom[ 0+11569] =8'b01111110;
           rom[ 0+11570] =8'b11011101;
           rom[ 0+11571] =8'b11011101;
           rom[ 0+11572] =8'b10101110;
           rom[ 0+11573] =8'b11011001;
           rom[ 0+11574] =8'b01010111;
           rom[ 0+11575] =8'b11011101;
           rom[ 0+11576] =8'b01111110;
           rom[ 0+11577] =8'b11011110;
           rom[ 0+11578] =8'b11011101;
           rom[ 0+11579] =8'b10101110;
           rom[ 0+11580] =8'b11011010;
           rom[ 0+11581] =8'b01011111;
           rom[ 0+11582] =8'b11000101;
           rom[ 0+11583] =8'b11011101;
           rom[ 0+11584] =8'b01111110;
           rom[ 0+11585] =8'b11001011;
           rom[ 0+11586] =8'b11110101;
           rom[ 0+11587] =8'b00110011;
           rom[ 0+11588] =8'b11010101;
           rom[ 0+11589] =8'b00110011;
           rom[ 0+11590] =8'b11001101;
           rom[ 0+11591] =8'b00001110;
           rom[ 0+11592] =8'b00100000;
           rom[ 0+11593] =8'b11011101;
           rom[ 0+11594] =8'b01110101;
           rom[ 0+11595] =8'b11001011;
           rom[ 0+11596] =8'b11110001;
           rom[ 0+11597] =8'b11000001;
           rom[ 0+11598] =8'b00100001;
           rom[ 0+11599] =8'b00000110;
           rom[ 0+11600] =8'b10010000;
           rom[ 0+11601] =8'b00001001;
           rom[ 0+11602] =8'b01010101;
           rom[ 0+11603] =8'b01011100;
           rom[ 0+11604] =8'b01011110;
           rom[ 0+11605] =8'b11011101;
           rom[ 0+11606] =8'b01010110;
           rom[ 0+11607] =8'b11011011;
           rom[ 0+11608] =8'b11011101;
           rom[ 0+11609] =8'b01111110;
           rom[ 0+11610] =8'b11011101;
           rom[ 0+11611] =8'b11011101;
           rom[ 0+11612] =8'b01110111;
           rom[ 0+11613] =8'b11010000;
           rom[ 0+11614] =8'b11000101;
           rom[ 0+11615] =8'b11010101;
           rom[ 0+11616] =8'b11010101;
           rom[ 0+11617] =8'b00110011;
           rom[ 0+11618] =8'b11011101;
           rom[ 0+11619] =8'b01111110;
           rom[ 0+11620] =8'b11010000;
           rom[ 0+11621] =8'b11110101;
           rom[ 0+11622] =8'b00110011;
           rom[ 0+11623] =8'b11001101;
           rom[ 0+11624] =8'b00001110;
           rom[ 0+11625] =8'b00100000;
           rom[ 0+11626] =8'b01010101;
           rom[ 0+11627] =8'b11110001;
           rom[ 0+11628] =8'b01111010;
           rom[ 0+11629] =8'b11010001;
           rom[ 0+11630] =8'b01010111;
           rom[ 0+11631] =8'b11000001;
           rom[ 0+11632] =8'b11000101;
           rom[ 0+11633] =8'b01111011;
           rom[ 0+11634] =8'b11110101;
           rom[ 0+11635] =8'b00110011;
           rom[ 0+11636] =8'b11010101;
           rom[ 0+11637] =8'b00110011;
           rom[ 0+11638] =8'b11001101;
           rom[ 0+11639] =8'b00001110;
           rom[ 0+11640] =8'b00100000;
           rom[ 0+11641] =8'b11011101;
           rom[ 0+11642] =8'b01110101;
           rom[ 0+11643] =8'b11001101;
           rom[ 0+11644] =8'b11110001;
           rom[ 0+11645] =8'b11000001;
           rom[ 0+11646] =8'b00100001;
           rom[ 0+11647] =8'b00000110;
           rom[ 0+11648] =8'b10010000;
           rom[ 0+11649] =8'b00001001;
           rom[ 0+11650] =8'b01010101;
           rom[ 0+11651] =8'b01011100;
           rom[ 0+11652] =8'b00010100;
           rom[ 0+11653] =8'b11000010;
           rom[ 0+11654] =8'b10001001;
           rom[ 0+11655] =8'b00101101;
           rom[ 0+11656] =8'b00011100;
           rom[ 0+11657] =8'b01101010;
           rom[ 0+11658] =8'b01100011;
           rom[ 0+11659] =8'b01111110;
           rom[ 0+11660] =8'b11011101;
           rom[ 0+11661] =8'b01110111;
           rom[ 0+11662] =8'b11001111;
           rom[ 0+11663] =8'b11011101;
           rom[ 0+11664] =8'b01111110;
           rom[ 0+11665] =8'b11011101;
           rom[ 0+11666] =8'b11011101;
           rom[ 0+11667] =8'b10101110;
           rom[ 0+11668] =8'b11011011;
           rom[ 0+11669] =8'b01011111;
           rom[ 0+11670] =8'b11011101;
           rom[ 0+11671] =8'b01111110;
           rom[ 0+11672] =8'b11011110;
           rom[ 0+11673] =8'b11011101;
           rom[ 0+11674] =8'b10101110;
           rom[ 0+11675] =8'b11011100;
           rom[ 0+11676] =8'b01010111;
           rom[ 0+11677] =8'b11011101;
           rom[ 0+11678] =8'b01110011;
           rom[ 0+11679] =8'b11010001;
           rom[ 0+11680] =8'b11000101;
           rom[ 0+11681] =8'b11011101;
           rom[ 0+11682] =8'b01111110;
           rom[ 0+11683] =8'b11001111;
           rom[ 0+11684] =8'b11110101;
           rom[ 0+11685] =8'b00110011;
           rom[ 0+11686] =8'b11011101;
           rom[ 0+11687] =8'b01111110;
           rom[ 0+11688] =8'b11010001;
           rom[ 0+11689] =8'b11110101;
           rom[ 0+11690] =8'b00110011;
           rom[ 0+11691] =8'b11001101;
           rom[ 0+11692] =8'b00001110;
           rom[ 0+11693] =8'b00100000;
           rom[ 0+11694] =8'b01010101;
           rom[ 0+11695] =8'b11110001;
           rom[ 0+11696] =8'b11000001;
           rom[ 0+11697] =8'b11011101;
           rom[ 0+11698] =8'b01111110;
           rom[ 0+11699] =8'b11001101;
           rom[ 0+11700] =8'b10101010;
           rom[ 0+11701] =8'b11011101;
           rom[ 0+11702] =8'b01110111;
           rom[ 0+11703] =8'b11001101;
           rom[ 0+11704] =8'b00100001;
           rom[ 0+11705] =8'b00000110;
           rom[ 0+11706] =8'b10010000;
           rom[ 0+11707] =8'b00001001;
           rom[ 0+11708] =8'b01010101;
           rom[ 0+11709] =8'b01011100;
           rom[ 0+11710] =8'b01111010;
           rom[ 0+11711] =8'b11000110;
           rom[ 0+11712] =8'b00000010;
           rom[ 0+11713] =8'b01010111;
           rom[ 0+11714] =8'b01111011;
           rom[ 0+11715] =8'b11001110;
           rom[ 0+11716] =8'b00000000;
           rom[ 0+11717] =8'b01011111;
           rom[ 0+11718] =8'b01101010;
           rom[ 0+11719] =8'b01100011;
           rom[ 0+11720] =8'b01010110;
           rom[ 0+11721] =8'b01111010;
           rom[ 0+11722] =8'b11011101;
           rom[ 0+11723] =8'b10101110;
           rom[ 0+11724] =8'b11001101;
           rom[ 0+11725] =8'b01010111;
           rom[ 0+11726] =8'b11000101;
           rom[ 0+11727] =8'b11011101;
           rom[ 0+11728] =8'b01111110;
           rom[ 0+11729] =8'b11001011;
           rom[ 0+11730] =8'b11110101;
           rom[ 0+11731] =8'b00110011;
           rom[ 0+11732] =8'b11010101;
           rom[ 0+11733] =8'b00110011;
           rom[ 0+11734] =8'b11001101;
           rom[ 0+11735] =8'b01101111;
           rom[ 0+11736] =8'b00100000;
           rom[ 0+11737] =8'b01011101;
           rom[ 0+11738] =8'b11110001;
           rom[ 0+11739] =8'b11000001;
           rom[ 0+11740] =8'b11011101;
           rom[ 0+11741] =8'b01110011;
           rom[ 0+11742] =8'b11100111;
           rom[ 0+11743] =8'b11011101;
           rom[ 0+11744] =8'b00110110;
           rom[ 0+11745] =8'b11101000;
           rom[ 0+11746] =8'b00000000;
           rom[ 0+11747] =8'b11011101;
           rom[ 0+11748] =8'b01111110;
           rom[ 0+11749] =8'b11100111;
           rom[ 0+11750] =8'b11011101;
           rom[ 0+11751] =8'b01110111;
           rom[ 0+11752] =8'b11001101;
           rom[ 0+11753] =8'b11011101;
           rom[ 0+11754] =8'b01010110;
           rom[ 0+11755] =8'b11011001;
           rom[ 0+11756] =8'b11000101;
           rom[ 0+11757] =8'b11011101;
           rom[ 0+11758] =8'b01111110;
           rom[ 0+11759] =8'b11001101;
           rom[ 0+11760] =8'b11110101;
           rom[ 0+11761] =8'b00110011;
           rom[ 0+11762] =8'b11010101;
           rom[ 0+11763] =8'b00110011;
           rom[ 0+11764] =8'b11001101;
           rom[ 0+11765] =8'b00001110;
           rom[ 0+11766] =8'b00100000;
           rom[ 0+11767] =8'b11011101;
           rom[ 0+11768] =8'b01110101;
           rom[ 0+11769] =8'b11001011;
           rom[ 0+11770] =8'b11110001;
           rom[ 0+11771] =8'b11000001;
           rom[ 0+11772] =8'b00100001;
           rom[ 0+11773] =8'b00000110;
           rom[ 0+11774] =8'b10010000;
           rom[ 0+11775] =8'b00001001;
           rom[ 0+11776] =8'b01010101;
           rom[ 0+11777] =8'b01011100;
           rom[ 0+11778] =8'b01010110;
           rom[ 0+11779] =8'b00011110;
           rom[ 0+11780] =8'b00000000;
           rom[ 0+11781] =8'b01111010;
           rom[ 0+11782] =8'b11011101;
           rom[ 0+11783] =8'b10101110;
           rom[ 0+11784] =8'b11100111;
           rom[ 0+11785] =8'b01010111;
           rom[ 0+11786] =8'b01111011;
           rom[ 0+11787] =8'b11011101;
           rom[ 0+11788] =8'b10101110;
           rom[ 0+11789] =8'b11101000;
           rom[ 0+11790] =8'b01011111;
           rom[ 0+11791] =8'b11000101;
           rom[ 0+11792] =8'b11010101;
           rom[ 0+11793] =8'b00110011;
           rom[ 0+11794] =8'b11011101;
           rom[ 0+11795] =8'b01111110;
           rom[ 0+11796] =8'b11010000;
           rom[ 0+11797] =8'b11110101;
           rom[ 0+11798] =8'b00110011;
           rom[ 0+11799] =8'b11001101;
           rom[ 0+11800] =8'b00001110;
           rom[ 0+11801] =8'b00100000;
           rom[ 0+11802] =8'b01011101;
           rom[ 0+11803] =8'b11110001;
           rom[ 0+11804] =8'b11000001;
           rom[ 0+11805] =8'b11011101;
           rom[ 0+11806] =8'b01111110;
           rom[ 0+11807] =8'b11001011;
           rom[ 0+11808] =8'b10101011;
           rom[ 0+11809] =8'b11011101;
           rom[ 0+11810] =8'b01110111;
           rom[ 0+11811] =8'b11001011;
           rom[ 0+11812] =8'b00100001;
           rom[ 0+11813] =8'b00000110;
           rom[ 0+11814] =8'b10010000;
           rom[ 0+11815] =8'b00001001;
           rom[ 0+11816] =8'b01010101;
           rom[ 0+11817] =8'b01011100;
           rom[ 0+11818] =8'b00010100;
           rom[ 0+11819] =8'b11000010;
           rom[ 0+11820] =8'b00101111;
           rom[ 0+11821] =8'b00101110;
           rom[ 0+11822] =8'b00011100;
           rom[ 0+11823] =8'b01101010;
           rom[ 0+11824] =8'b01100011;
           rom[ 0+11825] =8'b01010110;
           rom[ 0+11826] =8'b01111010;
           rom[ 0+11827] =8'b11011101;
           rom[ 0+11828] =8'b10101110;
           rom[ 0+11829] =8'b11001011;
           rom[ 0+11830] =8'b01010111;
           rom[ 0+11831] =8'b11000101;
           rom[ 0+11832] =8'b11011101;
           rom[ 0+11833] =8'b01111110;
           rom[ 0+11834] =8'b11010001;
           rom[ 0+11835] =8'b11110101;
           rom[ 0+11836] =8'b00110011;
           rom[ 0+11837] =8'b11010101;
           rom[ 0+11838] =8'b00110011;
           rom[ 0+11839] =8'b11001101;
           rom[ 0+11840] =8'b01101111;
           rom[ 0+11841] =8'b00100000;
           rom[ 0+11842] =8'b01011101;
           rom[ 0+11843] =8'b11110001;
           rom[ 0+11844] =8'b11000001;
           rom[ 0+11845] =8'b11011101;
           rom[ 0+11846] =8'b01110011;
           rom[ 0+11847] =8'b11101001;
           rom[ 0+11848] =8'b11011101;
           rom[ 0+11849] =8'b00110110;
           rom[ 0+11850] =8'b11101010;
           rom[ 0+11851] =8'b00000000;
           rom[ 0+11852] =8'b11011101;
           rom[ 0+11853] =8'b01111110;
           rom[ 0+11854] =8'b11101001;
           rom[ 0+11855] =8'b11011101;
           rom[ 0+11856] =8'b10101110;
           rom[ 0+11857] =8'b11100111;
           rom[ 0+11858] =8'b01011111;
           rom[ 0+11859] =8'b11011101;
           rom[ 0+11860] =8'b01111110;
           rom[ 0+11861] =8'b11101010;
           rom[ 0+11862] =8'b11011101;
           rom[ 0+11863] =8'b10101110;
           rom[ 0+11864] =8'b11101000;
           rom[ 0+11865] =8'b01010111;
           rom[ 0+11866] =8'b00100001;
           rom[ 0+11867] =8'b00000110;
           rom[ 0+11868] =8'b10010000;
           rom[ 0+11869] =8'b00001001;
           rom[ 0+11870] =8'b01001101;
           rom[ 0+11871] =8'b01000100;
           rom[ 0+11872] =8'b00001010;
           rom[ 0+11873] =8'b01001111;
           rom[ 0+11874] =8'b00000110;
           rom[ 0+11875] =8'b00000000;
           rom[ 0+11876] =8'b01111011;
           rom[ 0+11877] =8'b10101001;
           rom[ 0+11878] =8'b01011111;
           rom[ 0+11879] =8'b01111010;
           rom[ 0+11880] =8'b10101000;
           rom[ 0+11881] =8'b01010111;
           rom[ 0+11882] =8'b11011101;
           rom[ 0+11883] =8'b01110011;
           rom[ 0+11884] =8'b11101011;
           rom[ 0+11885] =8'b11011101;
           rom[ 0+11886] =8'b01110010;
           rom[ 0+11887] =8'b11101100;
           rom[ 0+11888] =8'b11011101;
           rom[ 0+11889] =8'b01011110;
           rom[ 0+11890] =8'b00000110;
           rom[ 0+11891] =8'b11011101;
           rom[ 0+11892] =8'b01010110;
           rom[ 0+11893] =8'b00000111;
           rom[ 0+11894] =8'b01101011;
           rom[ 0+11895] =8'b01100010;
           rom[ 0+11896] =8'b00101001;
           rom[ 0+11897] =8'b00011001;
           rom[ 0+11898] =8'b00101001;
           rom[ 0+11899] =8'b00101001;
           rom[ 0+11900] =8'b00011001;
           rom[ 0+11901] =8'b01001101;
           rom[ 0+11902] =8'b01000100;
           rom[ 0+11903] =8'b00100001;
           rom[ 0+11904] =8'b00000011;
           rom[ 0+11905] =8'b10000100;
           rom[ 0+11906] =8'b00001001;
           rom[ 0+11907] =8'b01001101;
           rom[ 0+11908] =8'b01000100;
           rom[ 0+11909] =8'b00110110;
           rom[ 0+11910] =8'b00000100;
           rom[ 0+11911] =8'b00100011;
           rom[ 0+11912] =8'b00110110;
           rom[ 0+11913] =8'b00000000;
           rom[ 0+11914] =8'b01111001;
           rom[ 0+11915] =8'b11000110;
           rom[ 0+11916] =8'b00000100;
           rom[ 0+11917] =8'b11011101;
           rom[ 0+11918] =8'b01110111;
           rom[ 0+11919] =8'b11001011;
           rom[ 0+11920] =8'b01111000;
           rom[ 0+11921] =8'b11001110;
           rom[ 0+11922] =8'b00000000;
           rom[ 0+11923] =8'b11011101;
           rom[ 0+11924] =8'b01110111;
           rom[ 0+11925] =8'b11001100;
           rom[ 0+11926] =8'b11011101;
           rom[ 0+11927] =8'b01111110;
           rom[ 0+11928] =8'b00000100;
           rom[ 0+11929] =8'b11000110;
           rom[ 0+11930] =8'b11111111;
           rom[ 0+11931] =8'b11011101;
           rom[ 0+11932] =8'b01110111;
           rom[ 0+11933] =8'b11010001;
           rom[ 0+11934] =8'b11011101;
           rom[ 0+11935] =8'b01111110;
           rom[ 0+11936] =8'b00000101;
           rom[ 0+11937] =8'b11001110;
           rom[ 0+11938] =8'b11111111;
           rom[ 0+11939] =8'b11011101;
           rom[ 0+11940] =8'b01110111;
           rom[ 0+11941] =8'b11010010;
           rom[ 0+11942] =8'b11011101;
           rom[ 0+11943] =8'b01111110;
           rom[ 0+11944] =8'b11010001;
           rom[ 0+11945] =8'b11011101;
           rom[ 0+11946] =8'b10010110;
           rom[ 0+11947] =8'b11010111;
           rom[ 0+11948] =8'b01011111;
           rom[ 0+11949] =8'b11011101;
           rom[ 0+11950] =8'b01111110;
           rom[ 0+11951] =8'b11010010;
           rom[ 0+11952] =8'b11011101;
           rom[ 0+11953] =8'b10011110;
           rom[ 0+11954] =8'b11011000;
           rom[ 0+11955] =8'b01010111;
           rom[ 0+11956] =8'b11011101;
           rom[ 0+11957] =8'b01101110;
           rom[ 0+11958] =8'b11001011;
           rom[ 0+11959] =8'b11011101;
           rom[ 0+11960] =8'b01100110;
           rom[ 0+11961] =8'b11001100;
           rom[ 0+11962] =8'b01110011;
           rom[ 0+11963] =8'b00100011;
           rom[ 0+11964] =8'b01110010;
           rom[ 0+11965] =8'b01111001;
           rom[ 0+11966] =8'b11000110;
           rom[ 0+11967] =8'b00001010;
           rom[ 0+11968] =8'b01011111;
           rom[ 0+11969] =8'b01111000;
           rom[ 0+11970] =8'b11001110;
           rom[ 0+11971] =8'b00000000;
           rom[ 0+11972] =8'b01010111;
           rom[ 0+11973] =8'b11011101;
           rom[ 0+11974] =8'b01111110;
           rom[ 0+11975] =8'b11101011;
           rom[ 0+11976] =8'b00010010;
           rom[ 0+11977] =8'b01111001;
           rom[ 0+11978] =8'b11000110;
           rom[ 0+11979] =8'b00000110;
           rom[ 0+11980] =8'b11011101;
           rom[ 0+11981] =8'b01110111;
           rom[ 0+11982] =8'b11001011;
           rom[ 0+11983] =8'b01111000;
           rom[ 0+11984] =8'b11001110;
           rom[ 0+11985] =8'b00000000;
           rom[ 0+11986] =8'b11011101;
           rom[ 0+11987] =8'b01110111;
           rom[ 0+11988] =8'b11001100;
           rom[ 0+11989] =8'b11011101;
           rom[ 0+11990] =8'b01111110;
           rom[ 0+11991] =8'b11010001;
           rom[ 0+11992] =8'b11011101;
           rom[ 0+11993] =8'b10010110;
           rom[ 0+11994] =8'b11010101;
           rom[ 0+11995] =8'b01011111;
           rom[ 0+11996] =8'b11011101;
           rom[ 0+11997] =8'b01111110;
           rom[ 0+11998] =8'b11010010;
           rom[ 0+11999] =8'b11011101;
           rom[ 0+12000] =8'b10011110;
           rom[ 0+12001] =8'b11010110;
           rom[ 0+12002] =8'b01010111;
           rom[ 0+12003] =8'b11011101;
           rom[ 0+12004] =8'b01101110;
           rom[ 0+12005] =8'b11001011;
           rom[ 0+12006] =8'b11011101;
           rom[ 0+12007] =8'b01100110;
           rom[ 0+12008] =8'b11001100;
           rom[ 0+12009] =8'b01110011;
           rom[ 0+12010] =8'b00100011;
           rom[ 0+12011] =8'b01110010;
           rom[ 0+12012] =8'b01111001;
           rom[ 0+12013] =8'b11000110;
           rom[ 0+12014] =8'b00001011;
           rom[ 0+12015] =8'b01011111;
           rom[ 0+12016] =8'b01111000;
           rom[ 0+12017] =8'b11001110;
           rom[ 0+12018] =8'b00000000;
           rom[ 0+12019] =8'b01010111;
           rom[ 0+12020] =8'b11011101;
           rom[ 0+12021] =8'b01111110;
           rom[ 0+12022] =8'b11101001;
           rom[ 0+12023] =8'b00010010;
           rom[ 0+12024] =8'b01111001;
           rom[ 0+12025] =8'b11000110;
           rom[ 0+12026] =8'b00001000;
           rom[ 0+12027] =8'b11011101;
           rom[ 0+12028] =8'b01110111;
           rom[ 0+12029] =8'b11001011;
           rom[ 0+12030] =8'b01111000;
           rom[ 0+12031] =8'b11001110;
           rom[ 0+12032] =8'b00000000;
           rom[ 0+12033] =8'b11011101;
           rom[ 0+12034] =8'b01110111;
           rom[ 0+12035] =8'b11001100;
           rom[ 0+12036] =8'b11011101;
           rom[ 0+12037] =8'b01111110;
           rom[ 0+12038] =8'b11010001;
           rom[ 0+12039] =8'b11011101;
           rom[ 0+12040] =8'b10010110;
           rom[ 0+12041] =8'b11010011;
           rom[ 0+12042] =8'b01011111;
           rom[ 0+12043] =8'b11011101;
           rom[ 0+12044] =8'b01111110;
           rom[ 0+12045] =8'b11010010;
           rom[ 0+12046] =8'b11011101;
           rom[ 0+12047] =8'b10011110;
           rom[ 0+12048] =8'b11010100;
           rom[ 0+12049] =8'b01010111;
           rom[ 0+12050] =8'b11011101;
           rom[ 0+12051] =8'b01101110;
           rom[ 0+12052] =8'b11001011;
           rom[ 0+12053] =8'b11011101;
           rom[ 0+12054] =8'b01100110;
           rom[ 0+12055] =8'b11001100;
           rom[ 0+12056] =8'b01110011;
           rom[ 0+12057] =8'b00100011;
           rom[ 0+12058] =8'b01110010;
           rom[ 0+12059] =8'b01111001;
           rom[ 0+12060] =8'b11000110;
           rom[ 0+12061] =8'b00001100;
           rom[ 0+12062] =8'b01001111;
           rom[ 0+12063] =8'b01111000;
           rom[ 0+12064] =8'b11001110;
           rom[ 0+12065] =8'b00000000;
           rom[ 0+12066] =8'b01000111;
           rom[ 0+12067] =8'b11011101;
           rom[ 0+12068] =8'b01111110;
           rom[ 0+12069] =8'b11001101;
           rom[ 0+12070] =8'b00000010;
           rom[ 0+12071] =8'b11011101;
           rom[ 0+12072] =8'b11111001;
           rom[ 0+12073] =8'b11011101;
           rom[ 0+12074] =8'b11100001;
           rom[ 0+12075] =8'b11001001;
           rom[ 0+12076] =8'b11011101;
           rom[ 0+12077] =8'b11100101;
           rom[ 0+12078] =8'b11011101;
           rom[ 0+12079] =8'b00100001;
           rom[ 0+12080] =8'b00000000;
           rom[ 0+12081] =8'b00000000;
           rom[ 0+12082] =8'b11011101;
           rom[ 0+12083] =8'b00111001;
           rom[ 0+12084] =8'b00100001;
           rom[ 0+12085] =8'b11111100;
           rom[ 0+12086] =8'b11111111;
           rom[ 0+12087] =8'b00111001;
           rom[ 0+12088] =8'b11111001;
           rom[ 0+12089] =8'b11011101;
           rom[ 0+12090] =8'b01011110;
           rom[ 0+12091] =8'b00001000;
           rom[ 0+12092] =8'b11011101;
           rom[ 0+12093] =8'b01010110;
           rom[ 0+12094] =8'b00001001;
           rom[ 0+12095] =8'b01101011;
           rom[ 0+12096] =8'b01100010;
           rom[ 0+12097] =8'b00101001;
           rom[ 0+12098] =8'b00011001;
           rom[ 0+12099] =8'b00101001;
           rom[ 0+12100] =8'b00011001;
           rom[ 0+12101] =8'b11011101;
           rom[ 0+12102] =8'b01110101;
           rom[ 0+12103] =8'b11111100;
           rom[ 0+12104] =8'b11011101;
           rom[ 0+12105] =8'b01110100;
           rom[ 0+12106] =8'b11111101;
           rom[ 0+12107] =8'b00111110;
           rom[ 0+12108] =8'b00000110;
           rom[ 0+12109] =8'b11011101;
           rom[ 0+12110] =8'b10000110;
           rom[ 0+12111] =8'b11111100;
           rom[ 0+12112] =8'b01011111;
           rom[ 0+12113] =8'b00111110;
           rom[ 0+12114] =8'b10010000;
           rom[ 0+12115] =8'b11011101;
           rom[ 0+12116] =8'b10001110;
           rom[ 0+12117] =8'b11111101;
           rom[ 0+12118] =8'b01010111;
           rom[ 0+12119] =8'b00011010;
           rom[ 0+12120] =8'b11011101;
           rom[ 0+12121] =8'b01110111;
           rom[ 0+12122] =8'b11111111;
           rom[ 0+12123] =8'b11011101;
           rom[ 0+12124] =8'b01111110;
           rom[ 0+12125] =8'b11111111;
           rom[ 0+12126] =8'b10110111;
           rom[ 0+12127] =8'b11000010;
           rom[ 0+12128] =8'b01100111;
           rom[ 0+12129] =8'b00101111;
           rom[ 0+12130] =8'b00111110;
           rom[ 0+12131] =8'b00000001;
           rom[ 0+12132] =8'b11000011;
           rom[ 0+12133] =8'b01101000;
           rom[ 0+12134] =8'b00101111;
           rom[ 0+12135] =8'b10101111;
           rom[ 0+12136] =8'b11011101;
           rom[ 0+12137] =8'b01110111;
           rom[ 0+12138] =8'b11111110;
           rom[ 0+12139] =8'b10110111;
           rom[ 0+12140] =8'b11001010;
           rom[ 0+12141] =8'b11101001;
           rom[ 0+12142] =8'b00101111;
           rom[ 0+12143] =8'b01001011;
           rom[ 0+12144] =8'b01000010;
           rom[ 0+12145] =8'b00000011;
           rom[ 0+12146] =8'b00001010;
           rom[ 0+12147] =8'b01001111;
           rom[ 0+12148] =8'b10110111;
           rom[ 0+12149] =8'b11001010;
           rom[ 0+12150] =8'b01111011;
           rom[ 0+12151] =8'b00101111;
           rom[ 0+12152] =8'b11000011;
           rom[ 0+12153] =8'b11101001;
           rom[ 0+12154] =8'b00101111;
           rom[ 0+12155] =8'b01001011;
           rom[ 0+12156] =8'b01000010;
           rom[ 0+12157] =8'b00000011;
           rom[ 0+12158] =8'b00000011;
           rom[ 0+12159] =8'b00001010;
           rom[ 0+12160] =8'b01001111;
           rom[ 0+12161] =8'b10110111;
           rom[ 0+12162] =8'b11001010;
           rom[ 0+12163] =8'b10001000;
           rom[ 0+12164] =8'b00101111;
           rom[ 0+12165] =8'b11000011;
           rom[ 0+12166] =8'b11101001;
           rom[ 0+12167] =8'b00101111;
           rom[ 0+12168] =8'b01111011;
           rom[ 0+12169] =8'b11000110;
           rom[ 0+12170] =8'b00000011;
           rom[ 0+12171] =8'b01001111;
           rom[ 0+12172] =8'b01111010;
           rom[ 0+12173] =8'b11001110;
           rom[ 0+12174] =8'b00000000;
           rom[ 0+12175] =8'b01000111;
           rom[ 0+12176] =8'b00001010;
           rom[ 0+12177] =8'b01001111;
           rom[ 0+12178] =8'b10110111;
           rom[ 0+12179] =8'b11001010;
           rom[ 0+12180] =8'b10011001;
           rom[ 0+12181] =8'b00101111;
           rom[ 0+12182] =8'b11000011;
           rom[ 0+12183] =8'b11101001;
           rom[ 0+12184] =8'b00101111;
           rom[ 0+12185] =8'b01111011;
           rom[ 0+12186] =8'b11000110;
           rom[ 0+12187] =8'b00000100;
           rom[ 0+12188] =8'b01001111;
           rom[ 0+12189] =8'b01111010;
           rom[ 0+12190] =8'b11001110;
           rom[ 0+12191] =8'b00000000;
           rom[ 0+12192] =8'b01000111;
           rom[ 0+12193] =8'b00001010;
           rom[ 0+12194] =8'b01001111;
           rom[ 0+12195] =8'b10110111;
           rom[ 0+12196] =8'b11001010;
           rom[ 0+12197] =8'b10101010;
           rom[ 0+12198] =8'b00101111;
           rom[ 0+12199] =8'b11000011;
           rom[ 0+12200] =8'b11101001;
           rom[ 0+12201] =8'b00101111;
           rom[ 0+12202] =8'b01111011;
           rom[ 0+12203] =8'b11000110;
           rom[ 0+12204] =8'b00000101;
           rom[ 0+12205] =8'b01001111;
           rom[ 0+12206] =8'b01111010;
           rom[ 0+12207] =8'b11001110;
           rom[ 0+12208] =8'b00000000;
           rom[ 0+12209] =8'b01000111;
           rom[ 0+12210] =8'b00001010;
           rom[ 0+12211] =8'b01001111;
           rom[ 0+12212] =8'b10110111;
           rom[ 0+12213] =8'b11001010;
           rom[ 0+12214] =8'b10111011;
           rom[ 0+12215] =8'b00101111;
           rom[ 0+12216] =8'b11000011;
           rom[ 0+12217] =8'b11101001;
           rom[ 0+12218] =8'b00101111;
           rom[ 0+12219] =8'b01111011;
           rom[ 0+12220] =8'b11000110;
           rom[ 0+12221] =8'b00000110;
           rom[ 0+12222] =8'b01001111;
           rom[ 0+12223] =8'b01111010;
           rom[ 0+12224] =8'b11001110;
           rom[ 0+12225] =8'b00000000;
           rom[ 0+12226] =8'b01000111;
           rom[ 0+12227] =8'b00001010;
           rom[ 0+12228] =8'b01001111;
           rom[ 0+12229] =8'b10110111;
           rom[ 0+12230] =8'b11001010;
           rom[ 0+12231] =8'b11001100;
           rom[ 0+12232] =8'b00101111;
           rom[ 0+12233] =8'b11000011;
           rom[ 0+12234] =8'b11101001;
           rom[ 0+12235] =8'b00101111;
           rom[ 0+12236] =8'b11011101;
           rom[ 0+12237] =8'b01011110;
           rom[ 0+12238] =8'b00001000;
           rom[ 0+12239] =8'b11011101;
           rom[ 0+12240] =8'b01010110;
           rom[ 0+12241] =8'b00001001;
           rom[ 0+12242] =8'b01101011;
           rom[ 0+12243] =8'b01100010;
           rom[ 0+12244] =8'b00101001;
           rom[ 0+12245] =8'b00011001;
           rom[ 0+12246] =8'b00101001;
           rom[ 0+12247] =8'b00101001;
           rom[ 0+12248] =8'b00011001;
           rom[ 0+12249] =8'b01001101;
           rom[ 0+12250] =8'b01000100;
           rom[ 0+12251] =8'b00100001;
           rom[ 0+12252] =8'b00000011;
           rom[ 0+12253] =8'b10000100;
           rom[ 0+12254] =8'b00001001;
           rom[ 0+12255] =8'b01001101;
           rom[ 0+12256] =8'b01000100;
           rom[ 0+12257] =8'b00110110;
           rom[ 0+12258] =8'b00000000;
           rom[ 0+12259] =8'b00100011;
           rom[ 0+12260] =8'b00110110;
           rom[ 0+12261] =8'b00000000;
           rom[ 0+12262] =8'b11000011;
           rom[ 0+12263] =8'b01100100;
           rom[ 0+12264] =8'b00110001;
           rom[ 0+12265] =8'b10101111;
           rom[ 0+12266] =8'b11011101;
           rom[ 0+12267] =8'b10110110;
           rom[ 0+12268] =8'b11111110;
           rom[ 0+12269] =8'b11000010;
           rom[ 0+12270] =8'b11111100;
           rom[ 0+12271] =8'b00101111;
           rom[ 0+12272] =8'b01001011;
           rom[ 0+12273] =8'b01000010;
           rom[ 0+12274] =8'b00000011;
           rom[ 0+12275] =8'b00001010;
           rom[ 0+12276] =8'b01001111;
           rom[ 0+12277] =8'b10110111;
           rom[ 0+12278] =8'b11001010;
           rom[ 0+12279] =8'b11111100;
           rom[ 0+12280] =8'b00101111;
           rom[ 0+12281] =8'b11000011;
           rom[ 0+12282] =8'b00011001;
           rom[ 0+12283] =8'b00110000;
           rom[ 0+12284] =8'b11011101;
           rom[ 0+12285] =8'b01011110;
           rom[ 0+12286] =8'b00001000;
           rom[ 0+12287] =8'b11011101;
           rom[ 0+12288] =8'b01010110;
           rom[ 0+12289] =8'b00001001;
           rom[ 0+12290] =8'b01101011;
           rom[ 0+12291] =8'b01100010;
           rom[ 0+12292] =8'b00101001;
           rom[ 0+12293] =8'b00011001;
           rom[ 0+12294] =8'b00101001;
           rom[ 0+12295] =8'b00101001;
           rom[ 0+12296] =8'b00011001;
           rom[ 0+12297] =8'b01011101;
           rom[ 0+12298] =8'b01010100;
           rom[ 0+12299] =8'b00100001;
           rom[ 0+12300] =8'b00000011;
           rom[ 0+12301] =8'b10000100;
           rom[ 0+12302] =8'b00011001;
           rom[ 0+12303] =8'b01011101;
           rom[ 0+12304] =8'b01010100;
           rom[ 0+12305] =8'b00110110;
           rom[ 0+12306] =8'b00000010;
           rom[ 0+12307] =8'b00100011;
           rom[ 0+12308] =8'b00110110;
           rom[ 0+12309] =8'b00000000;
           rom[ 0+12310] =8'b11000011;
           rom[ 0+12311] =8'b01100100;
           rom[ 0+12312] =8'b00110001;
           rom[ 0+12313] =8'b11011101;
           rom[ 0+12314] =8'b01111110;
           rom[ 0+12315] =8'b11111111;
           rom[ 0+12316] =8'b11110101;
           rom[ 0+12317] =8'b00110011;
           rom[ 0+12318] =8'b01111001;
           rom[ 0+12319] =8'b11110101;
           rom[ 0+12320] =8'b00110011;
           rom[ 0+12321] =8'b11001101;
           rom[ 0+12322] =8'b01101111;
           rom[ 0+12323] =8'b00100000;
           rom[ 0+12324] =8'b01001101;
           rom[ 0+12325] =8'b11110001;
           rom[ 0+12326] =8'b00111110;
           rom[ 0+12327] =8'b00000110;
           rom[ 0+12328] =8'b11011101;
           rom[ 0+12329] =8'b10000110;
           rom[ 0+12330] =8'b11111100;
           rom[ 0+12331] =8'b01011111;
           rom[ 0+12332] =8'b00111110;
           rom[ 0+12333] =8'b10010000;
           rom[ 0+12334] =8'b11011101;
           rom[ 0+12335] =8'b10001110;
           rom[ 0+12336] =8'b11111101;
           rom[ 0+12337] =8'b01010111;
           rom[ 0+12338] =8'b00010011;
           rom[ 0+12339] =8'b00011010;
           rom[ 0+12340] =8'b01000111;
           rom[ 0+12341] =8'b11000101;
           rom[ 0+12342] =8'b11000101;
           rom[ 0+12343] =8'b00110011;
           rom[ 0+12344] =8'b01111001;
           rom[ 0+12345] =8'b11110101;
           rom[ 0+12346] =8'b00110011;
           rom[ 0+12347] =8'b11001101;
           rom[ 0+12348] =8'b00001110;
           rom[ 0+12349] =8'b00100000;
           rom[ 0+12350] =8'b01000101;
           rom[ 0+12351] =8'b11110001;
           rom[ 0+12352] =8'b01111000;
           rom[ 0+12353] =8'b11000001;
           rom[ 0+12354] =8'b01000111;
           rom[ 0+12355] =8'b00111110;
           rom[ 0+12356] =8'b00000110;
           rom[ 0+12357] =8'b11011101;
           rom[ 0+12358] =8'b10000110;
           rom[ 0+12359] =8'b11111100;
           rom[ 0+12360] =8'b01011111;
           rom[ 0+12361] =8'b00111110;
           rom[ 0+12362] =8'b10010000;
           rom[ 0+12363] =8'b11011101;
           rom[ 0+12364] =8'b10001110;
           rom[ 0+12365] =8'b11111101;
           rom[ 0+12366] =8'b01010111;
           rom[ 0+12367] =8'b00010011;
           rom[ 0+12368] =8'b00010011;
           rom[ 0+12369] =8'b00011010;
           rom[ 0+12370] =8'b01011111;
           rom[ 0+12371] =8'b01111000;
           rom[ 0+12372] =8'b10111011;
           rom[ 0+12373] =8'b11001010;
           rom[ 0+12374] =8'b01111001;
           rom[ 0+12375] =8'b00110000;
           rom[ 0+12376] =8'b11011101;
           rom[ 0+12377] =8'b01011110;
           rom[ 0+12378] =8'b00001000;
           rom[ 0+12379] =8'b11011101;
           rom[ 0+12380] =8'b01010110;
           rom[ 0+12381] =8'b00001001;
           rom[ 0+12382] =8'b01101011;
           rom[ 0+12383] =8'b01100010;
           rom[ 0+12384] =8'b00101001;
           rom[ 0+12385] =8'b00011001;
           rom[ 0+12386] =8'b00101001;
           rom[ 0+12387] =8'b00101001;
           rom[ 0+12388] =8'b00011001;
           rom[ 0+12389] =8'b01000101;
           rom[ 0+12390] =8'b01010100;
           rom[ 0+12391] =8'b00111110;
           rom[ 0+12392] =8'b00000011;
           rom[ 0+12393] =8'b10000000;
           rom[ 0+12394] =8'b01000111;
           rom[ 0+12395] =8'b00111110;
           rom[ 0+12396] =8'b10000100;
           rom[ 0+12397] =8'b10001010;
           rom[ 0+12398] =8'b01010111;
           rom[ 0+12399] =8'b01101000;
           rom[ 0+12400] =8'b01100010;
           rom[ 0+12401] =8'b00110110;
           rom[ 0+12402] =8'b00000010;
           rom[ 0+12403] =8'b00100011;
           rom[ 0+12404] =8'b00110110;
           rom[ 0+12405] =8'b00000000;
           rom[ 0+12406] =8'b11000011;
           rom[ 0+12407] =8'b01100100;
           rom[ 0+12408] =8'b00110001;
           rom[ 0+12409] =8'b11000101;
           rom[ 0+12410] =8'b01111011;
           rom[ 0+12411] =8'b11110101;
           rom[ 0+12412] =8'b00110011;
           rom[ 0+12413] =8'b01111001;
           rom[ 0+12414] =8'b11110101;
           rom[ 0+12415] =8'b00110011;
           rom[ 0+12416] =8'b11001101;
           rom[ 0+12417] =8'b00001110;
           rom[ 0+12418] =8'b00100000;
           rom[ 0+12419] =8'b01000101;
           rom[ 0+12420] =8'b11110001;
           rom[ 0+12421] =8'b01111000;
           rom[ 0+12422] =8'b11000001;
           rom[ 0+12423] =8'b01000111;
           rom[ 0+12424] =8'b00111110;
           rom[ 0+12425] =8'b00000110;
           rom[ 0+12426] =8'b11011101;
           rom[ 0+12427] =8'b10000110;
           rom[ 0+12428] =8'b11111100;
           rom[ 0+12429] =8'b01011111;
           rom[ 0+12430] =8'b00111110;
           rom[ 0+12431] =8'b10010000;
           rom[ 0+12432] =8'b11011101;
           rom[ 0+12433] =8'b10001110;
           rom[ 0+12434] =8'b11111101;
           rom[ 0+12435] =8'b01010111;
           rom[ 0+12436] =8'b00010011;
           rom[ 0+12437] =8'b00010011;
           rom[ 0+12438] =8'b00010011;
           rom[ 0+12439] =8'b00011010;
           rom[ 0+12440] =8'b01011111;
           rom[ 0+12441] =8'b01111000;
           rom[ 0+12442] =8'b10111011;
           rom[ 0+12443] =8'b11001010;
           rom[ 0+12444] =8'b10111111;
           rom[ 0+12445] =8'b00110000;
           rom[ 0+12446] =8'b11011101;
           rom[ 0+12447] =8'b01011110;
           rom[ 0+12448] =8'b00001000;
           rom[ 0+12449] =8'b11011101;
           rom[ 0+12450] =8'b01010110;
           rom[ 0+12451] =8'b00001001;
           rom[ 0+12452] =8'b01101011;
           rom[ 0+12453] =8'b01100010;
           rom[ 0+12454] =8'b00101001;
           rom[ 0+12455] =8'b00011001;
           rom[ 0+12456] =8'b00101001;
           rom[ 0+12457] =8'b00101001;
           rom[ 0+12458] =8'b00011001;
           rom[ 0+12459] =8'b01000101;
           rom[ 0+12460] =8'b01010100;
           rom[ 0+12461] =8'b00111110;
           rom[ 0+12462] =8'b00000011;
           rom[ 0+12463] =8'b10000000;
           rom[ 0+12464] =8'b01000111;
           rom[ 0+12465] =8'b00111110;
           rom[ 0+12466] =8'b10000100;
           rom[ 0+12467] =8'b10001010;
           rom[ 0+12468] =8'b01010111;
           rom[ 0+12469] =8'b01101000;
           rom[ 0+12470] =8'b01100010;
           rom[ 0+12471] =8'b00110110;
           rom[ 0+12472] =8'b00000010;
           rom[ 0+12473] =8'b00100011;
           rom[ 0+12474] =8'b00110110;
           rom[ 0+12475] =8'b00000000;
           rom[ 0+12476] =8'b11000011;
           rom[ 0+12477] =8'b01100100;
           rom[ 0+12478] =8'b00110001;
           rom[ 0+12479] =8'b11000101;
           rom[ 0+12480] =8'b01111011;
           rom[ 0+12481] =8'b11110101;
           rom[ 0+12482] =8'b00110011;
           rom[ 0+12483] =8'b01111001;
           rom[ 0+12484] =8'b11110101;
           rom[ 0+12485] =8'b00110011;
           rom[ 0+12486] =8'b11001101;
           rom[ 0+12487] =8'b00001110;
           rom[ 0+12488] =8'b00100000;
           rom[ 0+12489] =8'b01000101;
           rom[ 0+12490] =8'b11110001;
           rom[ 0+12491] =8'b01111000;
           rom[ 0+12492] =8'b11000001;
           rom[ 0+12493] =8'b01000111;
           rom[ 0+12494] =8'b00111110;
           rom[ 0+12495] =8'b00000110;
           rom[ 0+12496] =8'b11011101;
           rom[ 0+12497] =8'b10000110;
           rom[ 0+12498] =8'b11111100;
           rom[ 0+12499] =8'b01011111;
           rom[ 0+12500] =8'b00111110;
           rom[ 0+12501] =8'b10010000;
           rom[ 0+12502] =8'b11011101;
           rom[ 0+12503] =8'b10001110;
           rom[ 0+12504] =8'b11111101;
           rom[ 0+12505] =8'b01010111;
           rom[ 0+12506] =8'b00010011;
           rom[ 0+12507] =8'b00010011;
           rom[ 0+12508] =8'b00010011;
           rom[ 0+12509] =8'b00010011;
           rom[ 0+12510] =8'b00011010;
           rom[ 0+12511] =8'b01011111;
           rom[ 0+12512] =8'b01111000;
           rom[ 0+12513] =8'b10111011;
           rom[ 0+12514] =8'b11001010;
           rom[ 0+12515] =8'b00000110;
           rom[ 0+12516] =8'b00110001;
           rom[ 0+12517] =8'b11011101;
           rom[ 0+12518] =8'b01011110;
           rom[ 0+12519] =8'b00001000;
           rom[ 0+12520] =8'b11011101;
           rom[ 0+12521] =8'b01010110;
           rom[ 0+12522] =8'b00001001;
           rom[ 0+12523] =8'b01101011;
           rom[ 0+12524] =8'b01100010;
           rom[ 0+12525] =8'b00101001;
           rom[ 0+12526] =8'b00011001;
           rom[ 0+12527] =8'b00101001;
           rom[ 0+12528] =8'b00101001;
           rom[ 0+12529] =8'b00011001;
           rom[ 0+12530] =8'b01000101;
           rom[ 0+12531] =8'b01010100;
           rom[ 0+12532] =8'b00111110;
           rom[ 0+12533] =8'b00000011;
           rom[ 0+12534] =8'b10000000;
           rom[ 0+12535] =8'b01000111;
           rom[ 0+12536] =8'b00111110;
           rom[ 0+12537] =8'b10000100;
           rom[ 0+12538] =8'b10001010;
           rom[ 0+12539] =8'b01010111;
           rom[ 0+12540] =8'b01101000;
           rom[ 0+12541] =8'b01100010;
           rom[ 0+12542] =8'b00110110;
           rom[ 0+12543] =8'b00000010;
           rom[ 0+12544] =8'b00100011;
           rom[ 0+12545] =8'b00110110;
           rom[ 0+12546] =8'b00000000;
           rom[ 0+12547] =8'b11000011;
           rom[ 0+12548] =8'b01100100;
           rom[ 0+12549] =8'b00110001;
           rom[ 0+12550] =8'b11000101;
           rom[ 0+12551] =8'b01111011;
           rom[ 0+12552] =8'b11110101;
           rom[ 0+12553] =8'b00110011;
           rom[ 0+12554] =8'b01111001;
           rom[ 0+12555] =8'b11110101;
           rom[ 0+12556] =8'b00110011;
           rom[ 0+12557] =8'b11001101;
           rom[ 0+12558] =8'b00001110;
           rom[ 0+12559] =8'b00100000;
           rom[ 0+12560] =8'b01000101;
           rom[ 0+12561] =8'b11110001;
           rom[ 0+12562] =8'b01111000;
           rom[ 0+12563] =8'b11000001;
           rom[ 0+12564] =8'b01000111;
           rom[ 0+12565] =8'b00111110;
           rom[ 0+12566] =8'b00000110;
           rom[ 0+12567] =8'b11011101;
           rom[ 0+12568] =8'b10000110;
           rom[ 0+12569] =8'b11111100;
           rom[ 0+12570] =8'b01011111;
           rom[ 0+12571] =8'b00111110;
           rom[ 0+12572] =8'b10010000;
           rom[ 0+12573] =8'b11011101;
           rom[ 0+12574] =8'b10001110;
           rom[ 0+12575] =8'b11111101;
           rom[ 0+12576] =8'b01010111;
           rom[ 0+12577] =8'b00010011;
           rom[ 0+12578] =8'b00010011;
           rom[ 0+12579] =8'b00010011;
           rom[ 0+12580] =8'b00010011;
           rom[ 0+12581] =8'b00010011;
           rom[ 0+12582] =8'b00011010;
           rom[ 0+12583] =8'b01011111;
           rom[ 0+12584] =8'b01111000;
           rom[ 0+12585] =8'b10111011;
           rom[ 0+12586] =8'b11001010;
           rom[ 0+12587] =8'b01001010;
           rom[ 0+12588] =8'b00110001;
           rom[ 0+12589] =8'b11011101;
           rom[ 0+12590] =8'b01011110;
           rom[ 0+12591] =8'b00001000;
           rom[ 0+12592] =8'b11011101;
           rom[ 0+12593] =8'b01010110;
           rom[ 0+12594] =8'b00001001;
           rom[ 0+12595] =8'b01101011;
           rom[ 0+12596] =8'b01100010;
           rom[ 0+12597] =8'b00101001;
           rom[ 0+12598] =8'b00011001;
           rom[ 0+12599] =8'b00101001;
           rom[ 0+12600] =8'b00101001;
           rom[ 0+12601] =8'b00011001;
           rom[ 0+12602] =8'b01011101;
           rom[ 0+12603] =8'b01010100;
           rom[ 0+12604] =8'b00100001;
           rom[ 0+12605] =8'b00000011;
           rom[ 0+12606] =8'b10000100;
           rom[ 0+12607] =8'b00011001;
           rom[ 0+12608] =8'b01011101;
           rom[ 0+12609] =8'b01010100;
           rom[ 0+12610] =8'b00110110;
           rom[ 0+12611] =8'b00000010;
           rom[ 0+12612] =8'b00100011;
           rom[ 0+12613] =8'b00110110;
           rom[ 0+12614] =8'b00000000;
           rom[ 0+12615] =8'b11000011;
           rom[ 0+12616] =8'b01100100;
           rom[ 0+12617] =8'b00110001;
           rom[ 0+12618] =8'b11011101;
           rom[ 0+12619] =8'b01011110;
           rom[ 0+12620] =8'b00001000;
           rom[ 0+12621] =8'b11011101;
           rom[ 0+12622] =8'b01010110;
           rom[ 0+12623] =8'b00001001;
           rom[ 0+12624] =8'b01101011;
           rom[ 0+12625] =8'b01100010;
           rom[ 0+12626] =8'b00101001;
           rom[ 0+12627] =8'b00011001;
           rom[ 0+12628] =8'b00101001;
           rom[ 0+12629] =8'b00101001;
           rom[ 0+12630] =8'b00011001;
           rom[ 0+12631] =8'b01011101;
           rom[ 0+12632] =8'b01010100;
           rom[ 0+12633] =8'b00100001;
           rom[ 0+12634] =8'b00000011;
           rom[ 0+12635] =8'b10000100;
           rom[ 0+12636] =8'b00011001;
           rom[ 0+12637] =8'b01011101;
           rom[ 0+12638] =8'b01010100;
           rom[ 0+12639] =8'b00110110;
           rom[ 0+12640] =8'b00000001;
           rom[ 0+12641] =8'b00100011;
           rom[ 0+12642] =8'b00110110;
           rom[ 0+12643] =8'b00000000;
           rom[ 0+12644] =8'b11011101;
           rom[ 0+12645] =8'b01011110;
           rom[ 0+12646] =8'b00001000;
           rom[ 0+12647] =8'b11011101;
           rom[ 0+12648] =8'b01010110;
           rom[ 0+12649] =8'b00001001;
           rom[ 0+12650] =8'b01101011;
           rom[ 0+12651] =8'b01100010;
           rom[ 0+12652] =8'b00101001;
           rom[ 0+12653] =8'b00011001;
           rom[ 0+12654] =8'b00101001;
           rom[ 0+12655] =8'b00101001;
           rom[ 0+12656] =8'b00011001;
           rom[ 0+12657] =8'b01011101;
           rom[ 0+12658] =8'b01010100;
           rom[ 0+12659] =8'b00100001;
           rom[ 0+12660] =8'b00000011;
           rom[ 0+12661] =8'b10000100;
           rom[ 0+12662] =8'b00011001;
           rom[ 0+12663] =8'b01011101;
           rom[ 0+12664] =8'b01010100;
           rom[ 0+12665] =8'b01011110;
           rom[ 0+12666] =8'b00100011;
           rom[ 0+12667] =8'b01010110;
           rom[ 0+12668] =8'b01111011;
           rom[ 0+12669] =8'b10110010;
           rom[ 0+12670] =8'b11001010;
           rom[ 0+12671] =8'b11010010;
           rom[ 0+12672] =8'b00110001;
           rom[ 0+12673] =8'b01111011;
           rom[ 0+12674] =8'b11111110;
           rom[ 0+12675] =8'b00000001;
           rom[ 0+12676] =8'b11000010;
           rom[ 0+12677] =8'b10001100;
           rom[ 0+12678] =8'b00110001;
           rom[ 0+12679] =8'b01111010;
           rom[ 0+12680] =8'b10110111;
           rom[ 0+12681] =8'b11001010;
           rom[ 0+12682] =8'b10011010;
           rom[ 0+12683] =8'b00110001;
           rom[ 0+12684] =8'b01111011;
           rom[ 0+12685] =8'b11111110;
           rom[ 0+12686] =8'b00000010;
           rom[ 0+12687] =8'b11000010;
           rom[ 0+12688] =8'b10010111;
           rom[ 0+12689] =8'b00110001;
           rom[ 0+12690] =8'b01111010;
           rom[ 0+12691] =8'b10110111;
           rom[ 0+12692] =8'b11001010;
           rom[ 0+12693] =8'b10111111;
           rom[ 0+12694] =8'b00110001;
           rom[ 0+12695] =8'b11000011;
           rom[ 0+12696] =8'b11010010;
           rom[ 0+12697] =8'b00110001;
           rom[ 0+12698] =8'b00111110;
           rom[ 0+12699] =8'b10011100;
           rom[ 0+12700] =8'b10000001;
           rom[ 0+12701] =8'b01001111;
           rom[ 0+12702] =8'b00111110;
           rom[ 0+12703] =8'b00000010;
           rom[ 0+12704] =8'b11001110;
           rom[ 0+12705] =8'b00000000;
           rom[ 0+12706] =8'b01000111;
           rom[ 0+12707] =8'b00001010;
           rom[ 0+12708] =8'b01001111;
           rom[ 0+12709] =8'b11011101;
           rom[ 0+12710] =8'b01101110;
           rom[ 0+12711] =8'b00001000;
           rom[ 0+12712] =8'b11011101;
           rom[ 0+12713] =8'b01100110;
           rom[ 0+12714] =8'b00001001;
           rom[ 0+12715] =8'b11100101;
           rom[ 0+12716] =8'b11011101;
           rom[ 0+12717] =8'b01101110;
           rom[ 0+12718] =8'b00000100;
           rom[ 0+12719] =8'b11011101;
           rom[ 0+12720] =8'b01100110;
           rom[ 0+12721] =8'b00000101;
           rom[ 0+12722] =8'b11100101;
           rom[ 0+12723] =8'b01111001;
           rom[ 0+12724] =8'b11110101;
           rom[ 0+12725] =8'b00110011;
           rom[ 0+12726] =8'b11001101;
           rom[ 0+12727] =8'b11101101;
           rom[ 0+12728] =8'b00100001;
           rom[ 0+12729] =8'b11110001;
           rom[ 0+12730] =8'b11110001;
           rom[ 0+12731] =8'b00110011;
           rom[ 0+12732] =8'b11000011;
           rom[ 0+12733] =8'b11010010;
           rom[ 0+12734] =8'b00110001;
           rom[ 0+12735] =8'b11011101;
           rom[ 0+12736] =8'b01101110;
           rom[ 0+12737] =8'b00001000;
           rom[ 0+12738] =8'b11011101;
           rom[ 0+12739] =8'b01100110;
           rom[ 0+12740] =8'b00001001;
           rom[ 0+12741] =8'b11100101;
           rom[ 0+12742] =8'b11011101;
           rom[ 0+12743] =8'b01101110;
           rom[ 0+12744] =8'b00000100;
           rom[ 0+12745] =8'b11011101;
           rom[ 0+12746] =8'b01100110;
           rom[ 0+12747] =8'b00000101;
           rom[ 0+12748] =8'b11100101;
           rom[ 0+12749] =8'b11001101;
           rom[ 0+12750] =8'b01100110;
           rom[ 0+12751] =8'b00100010;
           rom[ 0+12752] =8'b11110001;
           rom[ 0+12753] =8'b11110001;
           rom[ 0+12754] =8'b11011101;
           rom[ 0+12755] =8'b11111001;
           rom[ 0+12756] =8'b11011101;
           rom[ 0+12757] =8'b11100001;
           rom[ 0+12758] =8'b11001001;
           rom[ 0+12759] =8'b11011101;
           rom[ 0+12760] =8'b11100101;
           rom[ 0+12761] =8'b11011101;
           rom[ 0+12762] =8'b00100001;
           rom[ 0+12763] =8'b00000000;
           rom[ 0+12764] =8'b00000000;
           rom[ 0+12765] =8'b11011101;
           rom[ 0+12766] =8'b00111001;
           rom[ 0+12767] =8'b00100001;
           rom[ 0+12768] =8'b11110010;
           rom[ 0+12769] =8'b11111111;
           rom[ 0+12770] =8'b00111001;
           rom[ 0+12771] =8'b11111001;
           rom[ 0+12772] =8'b00100001;
           rom[ 0+12773] =8'b01011100;
           rom[ 0+12774] =8'b00111100;
           rom[ 0+12775] =8'b11100101;
           rom[ 0+12776] =8'b11001101;
           rom[ 0+12777] =8'b00001010;
           rom[ 0+12778] =8'b00000010;
           rom[ 0+12779] =8'b11110001;
           rom[ 0+12780] =8'b00100001;
           rom[ 0+12781] =8'b10001001;
           rom[ 0+12782] =8'b00111100;
           rom[ 0+12783] =8'b11100101;
           rom[ 0+12784] =8'b11001101;
           rom[ 0+12785] =8'b00001010;
           rom[ 0+12786] =8'b00000010;
           rom[ 0+12787] =8'b11110001;
           rom[ 0+12788] =8'b00100001;
           rom[ 0+12789] =8'b10101000;
           rom[ 0+12790] =8'b00111100;
           rom[ 0+12791] =8'b11100101;
           rom[ 0+12792] =8'b11001101;
           rom[ 0+12793] =8'b00001010;
           rom[ 0+12794] =8'b00000010;
           rom[ 0+12795] =8'b11110001;
           rom[ 0+12796] =8'b00100001;
           rom[ 0+12797] =8'b10111101;
           rom[ 0+12798] =8'b00111100;
           rom[ 0+12799] =8'b11100101;
           rom[ 0+12800] =8'b11001101;
           rom[ 0+12801] =8'b00001010;
           rom[ 0+12802] =8'b00000010;
           rom[ 0+12803] =8'b11110001;
           rom[ 0+12804] =8'b00100001;
           rom[ 0+12805] =8'b00101001;
           rom[ 0+12806] =8'b10010000;
           rom[ 0+12807] =8'b00110110;
           rom[ 0+12808] =8'b00000000;
           rom[ 0+12809] =8'b00000001;
           rom[ 0+12810] =8'b00101010;
           rom[ 0+12811] =8'b10010000;
           rom[ 0+12812] =8'b00111110;
           rom[ 0+12813] =8'b00000000;
           rom[ 0+12814] =8'b00000010;
           rom[ 0+12815] =8'b00000001;
           rom[ 0+12816] =8'b00101011;
           rom[ 0+12817] =8'b10010000;
           rom[ 0+12818] =8'b00111110;
           rom[ 0+12819] =8'b00000000;
           rom[ 0+12820] =8'b00000010;
           rom[ 0+12821] =8'b00000001;
           rom[ 0+12822] =8'b00101100;
           rom[ 0+12823] =8'b10010000;
           rom[ 0+12824] =8'b00111110;
           rom[ 0+12825] =8'b00000000;
           rom[ 0+12826] =8'b00000010;
           rom[ 0+12827] =8'b00000001;
           rom[ 0+12828] =8'b00101101;
           rom[ 0+12829] =8'b10010000;
           rom[ 0+12830] =8'b00111110;
           rom[ 0+12831] =8'b00000000;
           rom[ 0+12832] =8'b00000010;
           rom[ 0+12833] =8'b11011101;
           rom[ 0+12834] =8'b00110110;
           rom[ 0+12835] =8'b11111110;
           rom[ 0+12836] =8'b00000000;
           rom[ 0+12837] =8'b11011101;
           rom[ 0+12838] =8'b00110110;
           rom[ 0+12839] =8'b11111111;
           rom[ 0+12840] =8'b00000000;
           rom[ 0+12841] =8'b11011101;
           rom[ 0+12842] =8'b01111110;
           rom[ 0+12843] =8'b11111110;
           rom[ 0+12844] =8'b11010110;
           rom[ 0+12845] =8'b00101111;
           rom[ 0+12846] =8'b11011101;
           rom[ 0+12847] =8'b01111110;
           rom[ 0+12848] =8'b11111111;
           rom[ 0+12849] =8'b11011110;
           rom[ 0+12850] =8'b00000000;
           rom[ 0+12851] =8'b11110010;
           rom[ 0+12852] =8'b01010111;
           rom[ 0+12853] =8'b00110010;
           rom[ 0+12854] =8'b00111110;
           rom[ 0+12855] =8'b01001110;
           rom[ 0+12856] =8'b11011101;
           rom[ 0+12857] =8'b10000110;
           rom[ 0+12858] =8'b11111110;
           rom[ 0+12859] =8'b01011111;
           rom[ 0+12860] =8'b00111110;
           rom[ 0+12861] =8'b10000100;
           rom[ 0+12862] =8'b11011101;
           rom[ 0+12863] =8'b10001110;
           rom[ 0+12864] =8'b11111111;
           rom[ 0+12865] =8'b01010111;
           rom[ 0+12866] =8'b11011101;
           rom[ 0+12867] =8'b01001110;
           rom[ 0+12868] =8'b11111110;
           rom[ 0+12869] =8'b00000110;
           rom[ 0+12870] =8'b00000000;
           rom[ 0+12871] =8'b00000110;
           rom[ 0+12872] =8'b00000000;
           rom[ 0+12873] =8'b01111001;
           rom[ 0+12874] =8'b00010010;
           rom[ 0+12875] =8'b11011101;
           rom[ 0+12876] =8'b00110100;
           rom[ 0+12877] =8'b11111110;
           rom[ 0+12878] =8'b11000010;
           rom[ 0+12879] =8'b01010100;
           rom[ 0+12880] =8'b00110010;
           rom[ 0+12881] =8'b11011101;
           rom[ 0+12882] =8'b00110100;
           rom[ 0+12883] =8'b11111111;
           rom[ 0+12884] =8'b11000011;
           rom[ 0+12885] =8'b00101001;
           rom[ 0+12886] =8'b00110010;
           rom[ 0+12887] =8'b11001101;
           rom[ 0+12888] =8'b00000000;
           rom[ 0+12889] =8'b00010110;
           rom[ 0+12890] =8'b10101111;
           rom[ 0+12891] =8'b11111101;
           rom[ 0+12892] =8'b00100001;
           rom[ 0+12893] =8'b00101110;
           rom[ 0+12894] =8'b10010000;
           rom[ 0+12895] =8'b11111101;
           rom[ 0+12896] =8'b01110111;
           rom[ 0+12897] =8'b00000000;
           rom[ 0+12898] =8'b11111101;
           rom[ 0+12899] =8'b01110111;
           rom[ 0+12900] =8'b00000001;
           rom[ 0+12901] =8'b11111101;
           rom[ 0+12902] =8'b01110111;
           rom[ 0+12903] =8'b00000010;
           rom[ 0+12904] =8'b11111101;
           rom[ 0+12905] =8'b01110111;
           rom[ 0+12906] =8'b00000011;
           rom[ 0+12907] =8'b00100001;
           rom[ 0+12908] =8'b00101110;
           rom[ 0+12909] =8'b10010000;
           rom[ 0+12910] =8'b00100010;
           rom[ 0+12911] =8'b00110010;
           rom[ 0+12912] =8'b10010000;
           rom[ 0+12913] =8'b00100001;
           rom[ 0+12914] =8'b00110010;
           rom[ 0+12915] =8'b10010000;
           rom[ 0+12916] =8'b01111110;
           rom[ 0+12917] =8'b11000110;
           rom[ 0+12918] =8'b00000010;
           rom[ 0+12919] =8'b01110111;
           rom[ 0+12920] =8'b00100011;
           rom[ 0+12921] =8'b01111110;
           rom[ 0+12922] =8'b11001110;
           rom[ 0+12923] =8'b00000000;
           rom[ 0+12924] =8'b01110111;
           rom[ 0+12925] =8'b11011101;
           rom[ 0+12926] =8'b00110110;
           rom[ 0+12927] =8'b11111110;
           rom[ 0+12928] =8'b00000000;
           rom[ 0+12929] =8'b11011101;
           rom[ 0+12930] =8'b00110110;
           rom[ 0+12931] =8'b11111111;
           rom[ 0+12932] =8'b00000000;
           rom[ 0+12933] =8'b11011101;
           rom[ 0+12934] =8'b01111110;
           rom[ 0+12935] =8'b11111110;
           rom[ 0+12936] =8'b11010110;
           rom[ 0+12937] =8'b00000101;
           rom[ 0+12938] =8'b11011101;
           rom[ 0+12939] =8'b01111110;
           rom[ 0+12940] =8'b11111111;
           rom[ 0+12941] =8'b11011110;
           rom[ 0+12942] =8'b00000000;
           rom[ 0+12943] =8'b11110010;
           rom[ 0+12944] =8'b11011101;
           rom[ 0+12945] =8'b00110010;
           rom[ 0+12946] =8'b00111110;
           rom[ 0+12947] =8'b00101001;
           rom[ 0+12948] =8'b11011101;
           rom[ 0+12949] =8'b10000110;
           rom[ 0+12950] =8'b11111110;
           rom[ 0+12951] =8'b01011111;
           rom[ 0+12952] =8'b00111110;
           rom[ 0+12953] =8'b10010000;
           rom[ 0+12954] =8'b11011101;
           rom[ 0+12955] =8'b10001110;
           rom[ 0+12956] =8'b11111111;
           rom[ 0+12957] =8'b01010111;
           rom[ 0+12958] =8'b00011010;
           rom[ 0+12959] =8'b01011111;
           rom[ 0+12960] =8'b11010101;
           rom[ 0+12961] =8'b00100001;
           rom[ 0+12962] =8'b00000101;
           rom[ 0+12963] =8'b00000000;
           rom[ 0+12964] =8'b11100101;
           rom[ 0+12965] =8'b11011101;
           rom[ 0+12966] =8'b01101110;
           rom[ 0+12967] =8'b11111110;
           rom[ 0+12968] =8'b11011101;
           rom[ 0+12969] =8'b01100110;
           rom[ 0+12970] =8'b11111111;
           rom[ 0+12971] =8'b11100101;
           rom[ 0+12972] =8'b11001101;
           rom[ 0+12973] =8'b01010011;
           rom[ 0+12974] =8'b00111110;
           rom[ 0+12975] =8'b01001100;
           rom[ 0+12976] =8'b01010101;
           rom[ 0+12977] =8'b11110001;
           rom[ 0+12978] =8'b11110001;
           rom[ 0+12979] =8'b01111010;
           rom[ 0+12980] =8'b11010001;
           rom[ 0+12981] =8'b01010111;
           rom[ 0+12982] =8'b00111110;
           rom[ 0+12983] =8'b00000100;
           rom[ 0+12984] =8'b10010010;
           rom[ 0+12985] =8'b11011101;
           rom[ 0+12986] =8'b01110111;
           rom[ 0+12987] =8'b11111100;
           rom[ 0+12988] =8'b00111110;
           rom[ 0+12989] =8'b00000000;
           rom[ 0+12990] =8'b10011001;
           rom[ 0+12991] =8'b11011101;
           rom[ 0+12992] =8'b01110111;
           rom[ 0+12993] =8'b11111101;
           rom[ 0+12994] =8'b01111011;
           rom[ 0+12995] =8'b11110101;
           rom[ 0+12996] =8'b00110011;
           rom[ 0+12997] =8'b11011101;
           rom[ 0+12998] =8'b01101110;
           rom[ 0+12999] =8'b11111100;
           rom[ 0+13000] =8'b11011101;
           rom[ 0+13001] =8'b01100110;
           rom[ 0+13002] =8'b11111101;
           rom[ 0+13003] =8'b11100101;
           rom[ 0+13004] =8'b11001101;
           rom[ 0+13005] =8'b00111100;
           rom[ 0+13006] =8'b00010111;
           rom[ 0+13007] =8'b11110001;
           rom[ 0+13008] =8'b00110011;
           rom[ 0+13009] =8'b11011101;
           rom[ 0+13010] =8'b00110100;
           rom[ 0+13011] =8'b11111110;
           rom[ 0+13012] =8'b11000010;
           rom[ 0+13013] =8'b11011010;
           rom[ 0+13014] =8'b00110010;
           rom[ 0+13015] =8'b11011101;
           rom[ 0+13016] =8'b00110100;
           rom[ 0+13017] =8'b11111111;
           rom[ 0+13018] =8'b11000011;
           rom[ 0+13019] =8'b10000101;
           rom[ 0+13020] =8'b00110010;
           rom[ 0+13021] =8'b00100001;
           rom[ 0+13022] =8'b11000011;
           rom[ 0+13023] =8'b00111100;
           rom[ 0+13024] =8'b11100101;
           rom[ 0+13025] =8'b11001101;
           rom[ 0+13026] =8'b00001010;
           rom[ 0+13027] =8'b00000010;
           rom[ 0+13028] =8'b11110001;
           rom[ 0+13029] =8'b00100001;
           rom[ 0+13030] =8'b11011000;
           rom[ 0+13031] =8'b00111100;
           rom[ 0+13032] =8'b11100101;
           rom[ 0+13033] =8'b11001101;
           rom[ 0+13034] =8'b00001010;
           rom[ 0+13035] =8'b00000010;
           rom[ 0+13036] =8'b11110001;
           rom[ 0+13037] =8'b11011101;
           rom[ 0+13038] =8'b00110110;
           rom[ 0+13039] =8'b11111010;
           rom[ 0+13040] =8'b00000000;
           rom[ 0+13041] =8'b11011101;
           rom[ 0+13042] =8'b00110110;
           rom[ 0+13043] =8'b11111011;
           rom[ 0+13044] =8'b00000000;
           rom[ 0+13045] =8'b11011101;
           rom[ 0+13046] =8'b00110110;
           rom[ 0+13047] =8'b11111110;
           rom[ 0+13048] =8'b00000000;
           rom[ 0+13049] =8'b11011101;
           rom[ 0+13050] =8'b00110110;
           rom[ 0+13051] =8'b11111111;
           rom[ 0+13052] =8'b00000000;
           rom[ 0+13053] =8'b11011101;
           rom[ 0+13054] =8'b01111110;
           rom[ 0+13055] =8'b11111110;
           rom[ 0+13056] =8'b11010110;
           rom[ 0+13057] =8'b00110010;
           rom[ 0+13058] =8'b11011101;
           rom[ 0+13059] =8'b01111110;
           rom[ 0+13060] =8'b11111111;
           rom[ 0+13061] =8'b11011110;
           rom[ 0+13062] =8'b00000000;
           rom[ 0+13063] =8'b11110010;
           rom[ 0+13064] =8'b10011111;
           rom[ 0+13065] =8'b00110011;
           rom[ 0+13066] =8'b00100001;
           rom[ 0+13067] =8'b00000101;
           rom[ 0+13068] =8'b00000000;
           rom[ 0+13069] =8'b11100101;
           rom[ 0+13070] =8'b11011101;
           rom[ 0+13071] =8'b01101110;
           rom[ 0+13072] =8'b11111110;
           rom[ 0+13073] =8'b11011101;
           rom[ 0+13074] =8'b01100110;
           rom[ 0+13075] =8'b11111111;
           rom[ 0+13076] =8'b11100101;
           rom[ 0+13077] =8'b11001101;
           rom[ 0+13078] =8'b01010011;
           rom[ 0+13079] =8'b00111110;
           rom[ 0+13080] =8'b01000100;
           rom[ 0+13081] =8'b01001101;
           rom[ 0+13082] =8'b11110001;
           rom[ 0+13083] =8'b11110001;
           rom[ 0+13084] =8'b00111110;
           rom[ 0+13085] =8'b00000100;
           rom[ 0+13086] =8'b10010001;
           rom[ 0+13087] =8'b11011101;
           rom[ 0+13088] =8'b01110111;
           rom[ 0+13089] =8'b11111100;
           rom[ 0+13090] =8'b00111110;
           rom[ 0+13091] =8'b00000000;
           rom[ 0+13092] =8'b10011000;
           rom[ 0+13093] =8'b11011101;
           rom[ 0+13094] =8'b01110111;
           rom[ 0+13095] =8'b11111101;
           rom[ 0+13096] =8'b11011101;
           rom[ 0+13097] =8'b01111110;
           rom[ 0+13098] =8'b11111110;
           rom[ 0+13099] =8'b11010110;
           rom[ 0+13100] =8'b00101111;
           rom[ 0+13101] =8'b11011101;
           rom[ 0+13102] =8'b01111110;
           rom[ 0+13103] =8'b11111111;
           rom[ 0+13104] =8'b11011110;
           rom[ 0+13105] =8'b00000000;
           rom[ 0+13106] =8'b11110010;
           rom[ 0+13107] =8'b01001000;
           rom[ 0+13108] =8'b00110011;
           rom[ 0+13109] =8'b00111110;
           rom[ 0+13110] =8'b01001110;
           rom[ 0+13111] =8'b11011101;
           rom[ 0+13112] =8'b10000110;
           rom[ 0+13113] =8'b11111110;
           rom[ 0+13114] =8'b01010111;
           rom[ 0+13115] =8'b00111110;
           rom[ 0+13116] =8'b10000100;
           rom[ 0+13117] =8'b11011101;
           rom[ 0+13118] =8'b10001110;
           rom[ 0+13119] =8'b11111111;
           rom[ 0+13120] =8'b01001111;
           rom[ 0+13121] =8'b01101010;
           rom[ 0+13122] =8'b01100001;
           rom[ 0+13123] =8'b01010110;
           rom[ 0+13124] =8'b01011010;
           rom[ 0+13125] =8'b11000011;
           rom[ 0+13126] =8'b01010110;
           rom[ 0+13127] =8'b00110011;
           rom[ 0+13128] =8'b11101101;
           rom[ 0+13129] =8'b01001011;
           rom[ 0+13130] =8'b00110010;
           rom[ 0+13131] =8'b10010000;
           rom[ 0+13132] =8'b00001010;
           rom[ 0+13133] =8'b01001111;
           rom[ 0+13134] =8'b00101010;
           rom[ 0+13135] =8'b00110010;
           rom[ 0+13136] =8'b10010000;
           rom[ 0+13137] =8'b00101011;
           rom[ 0+13138] =8'b00100010;
           rom[ 0+13139] =8'b00110010;
           rom[ 0+13140] =8'b10010000;
           rom[ 0+13141] =8'b01011001;
           rom[ 0+13142] =8'b11010101;
           rom[ 0+13143] =8'b01111011;
           rom[ 0+13144] =8'b11110101;
           rom[ 0+13145] =8'b00110011;
           rom[ 0+13146] =8'b11011101;
           rom[ 0+13147] =8'b01101110;
           rom[ 0+13148] =8'b11111100;
           rom[ 0+13149] =8'b11011101;
           rom[ 0+13150] =8'b01100110;
           rom[ 0+13151] =8'b11111101;
           rom[ 0+13152] =8'b11100101;
           rom[ 0+13153] =8'b11001101;
           rom[ 0+13154] =8'b00111100;
           rom[ 0+13155] =8'b00010111;
           rom[ 0+13156] =8'b11110001;
           rom[ 0+13157] =8'b00110011;
           rom[ 0+13158] =8'b11010001;
           rom[ 0+13159] =8'b00111110;
           rom[ 0+13160] =8'b00011110;
           rom[ 0+13161] =8'b11011101;
           rom[ 0+13162] =8'b10000110;
           rom[ 0+13163] =8'b11111010;
           rom[ 0+13164] =8'b01001111;
           rom[ 0+13165] =8'b00111110;
           rom[ 0+13166] =8'b10001100;
           rom[ 0+13167] =8'b11011101;
           rom[ 0+13168] =8'b10001110;
           rom[ 0+13169] =8'b11111011;
           rom[ 0+13170] =8'b01000111;
           rom[ 0+13171] =8'b01111011;
           rom[ 0+13172] =8'b00000010;
           rom[ 0+13173] =8'b11011101;
           rom[ 0+13174] =8'b01001110;
           rom[ 0+13175] =8'b11111010;
           rom[ 0+13176] =8'b11011101;
           rom[ 0+13177] =8'b01000110;
           rom[ 0+13178] =8'b11111011;
           rom[ 0+13179] =8'b11011101;
           rom[ 0+13180] =8'b00110100;
           rom[ 0+13181] =8'b11111010;
           rom[ 0+13182] =8'b11000010;
           rom[ 0+13183] =8'b10000100;
           rom[ 0+13184] =8'b00110011;
           rom[ 0+13185] =8'b11011101;
           rom[ 0+13186] =8'b00110100;
           rom[ 0+13187] =8'b11111011;
           rom[ 0+13188] =8'b00100001;
           rom[ 0+13189] =8'b00110110;
           rom[ 0+13190] =8'b10001000;
           rom[ 0+13191] =8'b00001001;
           rom[ 0+13192] =8'b01001101;
           rom[ 0+13193] =8'b01000100;
           rom[ 0+13194] =8'b01111011;
           rom[ 0+13195] =8'b00000010;
           rom[ 0+13196] =8'b01111011;
           rom[ 0+13197] =8'b11110101;
           rom[ 0+13198] =8'b00110011;
           rom[ 0+13199] =8'b11001101;
           rom[ 0+13200] =8'b10011100;
           rom[ 0+13201] =8'b00010100;
           rom[ 0+13202] =8'b00110011;
           rom[ 0+13203] =8'b11011101;
           rom[ 0+13204] =8'b00110100;
           rom[ 0+13205] =8'b11111110;
           rom[ 0+13206] =8'b11000010;
           rom[ 0+13207] =8'b10011100;
           rom[ 0+13208] =8'b00110011;
           rom[ 0+13209] =8'b11011101;
           rom[ 0+13210] =8'b00110100;
           rom[ 0+13211] =8'b11111111;
           rom[ 0+13212] =8'b11000011;
           rom[ 0+13213] =8'b11111101;
           rom[ 0+13214] =8'b00110010;
           rom[ 0+13215] =8'b00100001;
           rom[ 0+13216] =8'b00000100;
           rom[ 0+13217] =8'b00111101;
           rom[ 0+13218] =8'b11100101;
           rom[ 0+13219] =8'b11001101;
           rom[ 0+13220] =8'b00001010;
           rom[ 0+13221] =8'b00000010;
           rom[ 0+13222] =8'b11110001;
           rom[ 0+13223] =8'b11011101;
           rom[ 0+13224] =8'b00110110;
           rom[ 0+13225] =8'b11111110;
           rom[ 0+13226] =8'b00000000;
           rom[ 0+13227] =8'b11011101;
           rom[ 0+13228] =8'b00110110;
           rom[ 0+13229] =8'b11111111;
           rom[ 0+13230] =8'b00000000;
           rom[ 0+13231] =8'b11011101;
           rom[ 0+13232] =8'b01111110;
           rom[ 0+13233] =8'b11111110;
           rom[ 0+13234] =8'b11010110;
           rom[ 0+13235] =8'b00000101;
           rom[ 0+13236] =8'b11011101;
           rom[ 0+13237] =8'b01111110;
           rom[ 0+13238] =8'b11111111;
           rom[ 0+13239] =8'b11011110;
           rom[ 0+13240] =8'b00000000;
           rom[ 0+13241] =8'b11110010;
           rom[ 0+13242] =8'b00010001;
           rom[ 0+13243] =8'b00110100;
           rom[ 0+13244] =8'b11011101;
           rom[ 0+13245] =8'b01001110;
           rom[ 0+13246] =8'b11111010;
           rom[ 0+13247] =8'b11011101;
           rom[ 0+13248] =8'b01000110;
           rom[ 0+13249] =8'b11111011;
           rom[ 0+13250] =8'b11011101;
           rom[ 0+13251] =8'b00110100;
           rom[ 0+13252] =8'b11111010;
           rom[ 0+13253] =8'b11000010;
           rom[ 0+13254] =8'b11001011;
           rom[ 0+13255] =8'b00110011;
           rom[ 0+13256] =8'b11011101;
           rom[ 0+13257] =8'b00110100;
           rom[ 0+13258] =8'b11111011;
           rom[ 0+13259] =8'b00100001;
           rom[ 0+13260] =8'b00110110;
           rom[ 0+13261] =8'b10001000;
           rom[ 0+13262] =8'b00001001;
           rom[ 0+13263] =8'b01001101;
           rom[ 0+13264] =8'b01000100;
           rom[ 0+13265] =8'b11000101;
           rom[ 0+13266] =8'b00100001;
           rom[ 0+13267] =8'b00000101;
           rom[ 0+13268] =8'b00000000;
           rom[ 0+13269] =8'b11100101;
           rom[ 0+13270] =8'b11011101;
           rom[ 0+13271] =8'b01101110;
           rom[ 0+13272] =8'b11111110;
           rom[ 0+13273] =8'b11011101;
           rom[ 0+13274] =8'b01100110;
           rom[ 0+13275] =8'b11111111;
           rom[ 0+13276] =8'b11100101;
           rom[ 0+13277] =8'b11001101;
           rom[ 0+13278] =8'b01010011;
           rom[ 0+13279] =8'b00111110;
           rom[ 0+13280] =8'b01010100;
           rom[ 0+13281] =8'b01011101;
           rom[ 0+13282] =8'b11110001;
           rom[ 0+13283] =8'b11110001;
           rom[ 0+13284] =8'b11000001;
           rom[ 0+13285] =8'b00111110;
           rom[ 0+13286] =8'b00000100;
           rom[ 0+13287] =8'b10010011;
           rom[ 0+13288] =8'b01011111;
           rom[ 0+13289] =8'b00111110;
           rom[ 0+13290] =8'b00000000;
           rom[ 0+13291] =8'b10011010;
           rom[ 0+13292] =8'b01010111;
           rom[ 0+13293] =8'b01101011;
           rom[ 0+13294] =8'b01100010;
           rom[ 0+13295] =8'b00101001;
           rom[ 0+13296] =8'b00011001;
           rom[ 0+13297] =8'b00101001;
           rom[ 0+13298] =8'b00011001;
           rom[ 0+13299] =8'b01011101;
           rom[ 0+13300] =8'b01010100;
           rom[ 0+13301] =8'b00100001;
           rom[ 0+13302] =8'b00000110;
           rom[ 0+13303] =8'b10010000;
           rom[ 0+13304] =8'b00011001;
           rom[ 0+13305] =8'b01011101;
           rom[ 0+13306] =8'b01010100;
           rom[ 0+13307] =8'b01111011;
           rom[ 0+13308] =8'b11000110;
           rom[ 0+13309] =8'b00000110;
           rom[ 0+13310] =8'b01011111;
           rom[ 0+13311] =8'b01111010;
           rom[ 0+13312] =8'b11001110;
           rom[ 0+13313] =8'b00000000;
           rom[ 0+13314] =8'b01010111;
           rom[ 0+13315] =8'b00011010;
           rom[ 0+13316] =8'b00000010;
           rom[ 0+13317] =8'b11011101;
           rom[ 0+13318] =8'b00110100;
           rom[ 0+13319] =8'b11111110;
           rom[ 0+13320] =8'b11000010;
           rom[ 0+13321] =8'b00001110;
           rom[ 0+13322] =8'b00110100;
           rom[ 0+13323] =8'b11011101;
           rom[ 0+13324] =8'b00110100;
           rom[ 0+13325] =8'b11111111;
           rom[ 0+13326] =8'b11000011;
           rom[ 0+13327] =8'b10101111;
           rom[ 0+13328] =8'b00110011;
           rom[ 0+13329] =8'b11011101;
           rom[ 0+13330] =8'b00110110;
           rom[ 0+13331] =8'b11111110;
           rom[ 0+13332] =8'b00000000;
           rom[ 0+13333] =8'b11011101;
           rom[ 0+13334] =8'b00110110;
           rom[ 0+13335] =8'b11111111;
           rom[ 0+13336] =8'b00000000;
           rom[ 0+13337] =8'b11011101;
           rom[ 0+13338] =8'b01111110;
           rom[ 0+13339] =8'b11111110;
           rom[ 0+13340] =8'b11010110;
           rom[ 0+13341] =8'b00000101;
           rom[ 0+13342] =8'b11011101;
           rom[ 0+13343] =8'b01111110;
           rom[ 0+13344] =8'b11111111;
           rom[ 0+13345] =8'b11011110;
           rom[ 0+13346] =8'b00000000;
           rom[ 0+13347] =8'b11110010;
           rom[ 0+13348] =8'b01111000;
           rom[ 0+13349] =8'b00110100;
           rom[ 0+13350] =8'b11011101;
           rom[ 0+13351] =8'b01001110;
           rom[ 0+13352] =8'b11111010;
           rom[ 0+13353] =8'b11011101;
           rom[ 0+13354] =8'b01000110;
           rom[ 0+13355] =8'b11111011;
           rom[ 0+13356] =8'b11011101;
           rom[ 0+13357] =8'b00110100;
           rom[ 0+13358] =8'b11111010;
           rom[ 0+13359] =8'b11000010;
           rom[ 0+13360] =8'b00110101;
           rom[ 0+13361] =8'b00110100;
           rom[ 0+13362] =8'b11011101;
           rom[ 0+13363] =8'b00110100;
           rom[ 0+13364] =8'b11111011;
           rom[ 0+13365] =8'b00100001;
           rom[ 0+13366] =8'b00110110;
           rom[ 0+13367] =8'b10001000;
           rom[ 0+13368] =8'b00001001;
           rom[ 0+13369] =8'b01001101;
           rom[ 0+13370] =8'b01000100;
           rom[ 0+13371] =8'b11000101;
           rom[ 0+13372] =8'b00100001;
           rom[ 0+13373] =8'b00000101;
           rom[ 0+13374] =8'b00000000;
           rom[ 0+13375] =8'b11100101;
           rom[ 0+13376] =8'b11011101;
           rom[ 0+13377] =8'b01101110;
           rom[ 0+13378] =8'b11111110;
           rom[ 0+13379] =8'b11011101;
           rom[ 0+13380] =8'b01100110;
           rom[ 0+13381] =8'b11111111;
           rom[ 0+13382] =8'b11100101;
           rom[ 0+13383] =8'b11001101;
           rom[ 0+13384] =8'b01010011;
           rom[ 0+13385] =8'b00111110;
           rom[ 0+13386] =8'b01010100;
           rom[ 0+13387] =8'b01011101;
           rom[ 0+13388] =8'b11110001;
           rom[ 0+13389] =8'b11110001;
           rom[ 0+13390] =8'b11000001;
           rom[ 0+13391] =8'b00111110;
           rom[ 0+13392] =8'b00000100;
           rom[ 0+13393] =8'b10010011;
           rom[ 0+13394] =8'b01011111;
           rom[ 0+13395] =8'b00111110;
           rom[ 0+13396] =8'b00000000;
           rom[ 0+13397] =8'b10011010;
           rom[ 0+13398] =8'b01010111;
           rom[ 0+13399] =8'b01101011;
           rom[ 0+13400] =8'b01100010;
           rom[ 0+13401] =8'b00101001;
           rom[ 0+13402] =8'b00011001;
           rom[ 0+13403] =8'b00101001;
           rom[ 0+13404] =8'b00011001;
           rom[ 0+13405] =8'b01011101;
           rom[ 0+13406] =8'b01010100;
           rom[ 0+13407] =8'b00100001;
           rom[ 0+13408] =8'b00000110;
           rom[ 0+13409] =8'b10010000;
           rom[ 0+13410] =8'b00011001;
           rom[ 0+13411] =8'b01011101;
           rom[ 0+13412] =8'b01010100;
           rom[ 0+13413] =8'b00010011;
           rom[ 0+13414] =8'b00010011;
           rom[ 0+13415] =8'b00010011;
           rom[ 0+13416] =8'b00010011;
           rom[ 0+13417] =8'b00010011;
           rom[ 0+13418] =8'b00011010;
           rom[ 0+13419] =8'b00000010;
           rom[ 0+13420] =8'b11011101;
           rom[ 0+13421] =8'b00110100;
           rom[ 0+13422] =8'b11111110;
           rom[ 0+13423] =8'b11000010;
           rom[ 0+13424] =8'b01110101;
           rom[ 0+13425] =8'b00110100;
           rom[ 0+13426] =8'b11011101;
           rom[ 0+13427] =8'b00110100;
           rom[ 0+13428] =8'b11111111;
           rom[ 0+13429] =8'b11000011;
           rom[ 0+13430] =8'b00011001;
           rom[ 0+13431] =8'b00110100;
           rom[ 0+13432] =8'b11011101;
           rom[ 0+13433] =8'b00110110;
           rom[ 0+13434] =8'b11111110;
           rom[ 0+13435] =8'b00000000;
           rom[ 0+13436] =8'b11011101;
           rom[ 0+13437] =8'b00110110;
           rom[ 0+13438] =8'b11111111;
           rom[ 0+13439] =8'b00000000;
           rom[ 0+13440] =8'b11011101;
           rom[ 0+13441] =8'b01111110;
           rom[ 0+13442] =8'b11111110;
           rom[ 0+13443] =8'b11010110;
           rom[ 0+13444] =8'b00000101;
           rom[ 0+13445] =8'b11011101;
           rom[ 0+13446] =8'b01111110;
           rom[ 0+13447] =8'b11111111;
           rom[ 0+13448] =8'b11011110;
           rom[ 0+13449] =8'b00000000;
           rom[ 0+13450] =8'b11110010;
           rom[ 0+13451] =8'b11011110;
           rom[ 0+13452] =8'b00110100;
           rom[ 0+13453] =8'b11011101;
           rom[ 0+13454] =8'b01001110;
           rom[ 0+13455] =8'b11111010;
           rom[ 0+13456] =8'b11011101;
           rom[ 0+13457] =8'b01000110;
           rom[ 0+13458] =8'b11111011;
           rom[ 0+13459] =8'b11011101;
           rom[ 0+13460] =8'b00110100;
           rom[ 0+13461] =8'b11111010;
           rom[ 0+13462] =8'b11000010;
           rom[ 0+13463] =8'b10011100;
           rom[ 0+13464] =8'b00110100;
           rom[ 0+13465] =8'b11011101;
           rom[ 0+13466] =8'b00110100;
           rom[ 0+13467] =8'b11111011;
           rom[ 0+13468] =8'b00100001;
           rom[ 0+13469] =8'b00110110;
           rom[ 0+13470] =8'b10001000;
           rom[ 0+13471] =8'b00001001;
           rom[ 0+13472] =8'b01001101;
           rom[ 0+13473] =8'b01000100;
           rom[ 0+13474] =8'b11000101;
           rom[ 0+13475] =8'b00100001;
           rom[ 0+13476] =8'b00000101;
           rom[ 0+13477] =8'b00000000;
           rom[ 0+13478] =8'b11100101;
           rom[ 0+13479] =8'b11011101;
           rom[ 0+13480] =8'b01101110;
           rom[ 0+13481] =8'b11111110;
           rom[ 0+13482] =8'b11011101;
           rom[ 0+13483] =8'b01100110;
           rom[ 0+13484] =8'b11111111;
           rom[ 0+13485] =8'b11100101;
           rom[ 0+13486] =8'b11001101;
           rom[ 0+13487] =8'b01010011;
           rom[ 0+13488] =8'b00111110;
           rom[ 0+13489] =8'b01010100;
           rom[ 0+13490] =8'b01011101;
           rom[ 0+13491] =8'b11110001;
           rom[ 0+13492] =8'b11110001;
           rom[ 0+13493] =8'b11000001;
           rom[ 0+13494] =8'b00111110;
           rom[ 0+13495] =8'b00000100;
           rom[ 0+13496] =8'b10010011;
           rom[ 0+13497] =8'b01011111;
           rom[ 0+13498] =8'b00111110;
           rom[ 0+13499] =8'b00000000;
           rom[ 0+13500] =8'b10011010;
           rom[ 0+13501] =8'b01010111;
           rom[ 0+13502] =8'b01101011;
           rom[ 0+13503] =8'b01100010;
           rom[ 0+13504] =8'b00101001;
           rom[ 0+13505] =8'b00011001;
           rom[ 0+13506] =8'b00101001;
           rom[ 0+13507] =8'b00011001;
           rom[ 0+13508] =8'b01011101;
           rom[ 0+13509] =8'b01010100;
           rom[ 0+13510] =8'b00100001;
           rom[ 0+13511] =8'b00000110;
           rom[ 0+13512] =8'b10010000;
           rom[ 0+13513] =8'b00011001;
           rom[ 0+13514] =8'b01011101;
           rom[ 0+13515] =8'b01010100;
           rom[ 0+13516] =8'b00010011;
           rom[ 0+13517] =8'b00010011;
           rom[ 0+13518] =8'b00010011;
           rom[ 0+13519] =8'b00010011;
           rom[ 0+13520] =8'b00011010;
           rom[ 0+13521] =8'b00000010;
           rom[ 0+13522] =8'b11011101;
           rom[ 0+13523] =8'b00110100;
           rom[ 0+13524] =8'b11111110;
           rom[ 0+13525] =8'b11000010;
           rom[ 0+13526] =8'b11011011;
           rom[ 0+13527] =8'b00110100;
           rom[ 0+13528] =8'b11011101;
           rom[ 0+13529] =8'b00110100;
           rom[ 0+13530] =8'b11111111;
           rom[ 0+13531] =8'b11000011;
           rom[ 0+13532] =8'b10000000;
           rom[ 0+13533] =8'b00110100;
           rom[ 0+13534] =8'b11011101;
           rom[ 0+13535] =8'b00110110;
           rom[ 0+13536] =8'b11111110;
           rom[ 0+13537] =8'b00000000;
           rom[ 0+13538] =8'b11011101;
           rom[ 0+13539] =8'b00110110;
           rom[ 0+13540] =8'b11111111;
           rom[ 0+13541] =8'b00000000;
           rom[ 0+13542] =8'b11011101;
           rom[ 0+13543] =8'b01111110;
           rom[ 0+13544] =8'b11111110;
           rom[ 0+13545] =8'b11010110;
           rom[ 0+13546] =8'b00000101;
           rom[ 0+13547] =8'b11011101;
           rom[ 0+13548] =8'b01111110;
           rom[ 0+13549] =8'b11111111;
           rom[ 0+13550] =8'b11011110;
           rom[ 0+13551] =8'b00000000;
           rom[ 0+13552] =8'b11110010;
           rom[ 0+13553] =8'b01000011;
           rom[ 0+13554] =8'b00110101;
           rom[ 0+13555] =8'b11011101;
           rom[ 0+13556] =8'b01001110;
           rom[ 0+13557] =8'b11111010;
           rom[ 0+13558] =8'b11011101;
           rom[ 0+13559] =8'b01000110;
           rom[ 0+13560] =8'b11111011;
           rom[ 0+13561] =8'b11011101;
           rom[ 0+13562] =8'b00110100;
           rom[ 0+13563] =8'b11111010;
           rom[ 0+13564] =8'b11000010;
           rom[ 0+13565] =8'b00000010;
           rom[ 0+13566] =8'b00110101;
           rom[ 0+13567] =8'b11011101;
           rom[ 0+13568] =8'b00110100;
           rom[ 0+13569] =8'b11111011;
           rom[ 0+13570] =8'b00100001;
           rom[ 0+13571] =8'b00110110;
           rom[ 0+13572] =8'b10001000;
           rom[ 0+13573] =8'b00001001;
           rom[ 0+13574] =8'b01001101;
           rom[ 0+13575] =8'b01000100;
           rom[ 0+13576] =8'b11000101;
           rom[ 0+13577] =8'b00100001;
           rom[ 0+13578] =8'b00000101;
           rom[ 0+13579] =8'b00000000;
           rom[ 0+13580] =8'b11100101;
           rom[ 0+13581] =8'b11011101;
           rom[ 0+13582] =8'b01101110;
           rom[ 0+13583] =8'b11111110;
           rom[ 0+13584] =8'b11011101;
           rom[ 0+13585] =8'b01100110;
           rom[ 0+13586] =8'b11111111;
           rom[ 0+13587] =8'b11100101;
           rom[ 0+13588] =8'b11001101;
           rom[ 0+13589] =8'b01010011;
           rom[ 0+13590] =8'b00111110;
           rom[ 0+13591] =8'b01010100;
           rom[ 0+13592] =8'b01011101;
           rom[ 0+13593] =8'b11110001;
           rom[ 0+13594] =8'b11110001;
           rom[ 0+13595] =8'b11000001;
           rom[ 0+13596] =8'b00111110;
           rom[ 0+13597] =8'b00000100;
           rom[ 0+13598] =8'b10010011;
           rom[ 0+13599] =8'b01011111;
           rom[ 0+13600] =8'b00111110;
           rom[ 0+13601] =8'b00000000;
           rom[ 0+13602] =8'b10011010;
           rom[ 0+13603] =8'b01010111;
           rom[ 0+13604] =8'b01101011;
           rom[ 0+13605] =8'b01100010;
           rom[ 0+13606] =8'b00101001;
           rom[ 0+13607] =8'b00011001;
           rom[ 0+13608] =8'b00101001;
           rom[ 0+13609] =8'b00011001;
           rom[ 0+13610] =8'b01011101;
           rom[ 0+13611] =8'b01010100;
           rom[ 0+13612] =8'b00100001;
           rom[ 0+13613] =8'b00000110;
           rom[ 0+13614] =8'b10010000;
           rom[ 0+13615] =8'b00011001;
           rom[ 0+13616] =8'b01011101;
           rom[ 0+13617] =8'b01010100;
           rom[ 0+13618] =8'b00010011;
           rom[ 0+13619] =8'b00010011;
           rom[ 0+13620] =8'b00010011;
           rom[ 0+13621] =8'b00011010;
           rom[ 0+13622] =8'b00000010;
           rom[ 0+13623] =8'b11011101;
           rom[ 0+13624] =8'b00110100;
           rom[ 0+13625] =8'b11111110;
           rom[ 0+13626] =8'b11000010;
           rom[ 0+13627] =8'b01000000;
           rom[ 0+13628] =8'b00110101;
           rom[ 0+13629] =8'b11011101;
           rom[ 0+13630] =8'b00110100;
           rom[ 0+13631] =8'b11111111;
           rom[ 0+13632] =8'b11000011;
           rom[ 0+13633] =8'b11100110;
           rom[ 0+13634] =8'b00110100;
           rom[ 0+13635] =8'b11011101;
           rom[ 0+13636] =8'b00110110;
           rom[ 0+13637] =8'b11111110;
           rom[ 0+13638] =8'b00000000;
           rom[ 0+13639] =8'b11011101;
           rom[ 0+13640] =8'b00110110;
           rom[ 0+13641] =8'b11111111;
           rom[ 0+13642] =8'b00000000;
           rom[ 0+13643] =8'b11011101;
           rom[ 0+13644] =8'b01111110;
           rom[ 0+13645] =8'b11111110;
           rom[ 0+13646] =8'b11010110;
           rom[ 0+13647] =8'b00000101;
           rom[ 0+13648] =8'b11011101;
           rom[ 0+13649] =8'b01111110;
           rom[ 0+13650] =8'b11111111;
           rom[ 0+13651] =8'b11011110;
           rom[ 0+13652] =8'b00000000;
           rom[ 0+13653] =8'b11110010;
           rom[ 0+13654] =8'b10100111;
           rom[ 0+13655] =8'b00110101;
           rom[ 0+13656] =8'b11011101;
           rom[ 0+13657] =8'b01001110;
           rom[ 0+13658] =8'b11111010;
           rom[ 0+13659] =8'b11011101;
           rom[ 0+13660] =8'b01000110;
           rom[ 0+13661] =8'b11111011;
           rom[ 0+13662] =8'b11011101;
           rom[ 0+13663] =8'b00110100;
           rom[ 0+13664] =8'b11111010;
           rom[ 0+13665] =8'b11000010;
           rom[ 0+13666] =8'b01100111;
           rom[ 0+13667] =8'b00110101;
           rom[ 0+13668] =8'b11011101;
           rom[ 0+13669] =8'b00110100;
           rom[ 0+13670] =8'b11111011;
           rom[ 0+13671] =8'b00100001;
           rom[ 0+13672] =8'b00110110;
           rom[ 0+13673] =8'b10001000;
           rom[ 0+13674] =8'b00001001;
           rom[ 0+13675] =8'b01001101;
           rom[ 0+13676] =8'b01000100;
           rom[ 0+13677] =8'b11000101;
           rom[ 0+13678] =8'b00100001;
           rom[ 0+13679] =8'b00000101;
           rom[ 0+13680] =8'b00000000;
           rom[ 0+13681] =8'b11100101;
           rom[ 0+13682] =8'b11011101;
           rom[ 0+13683] =8'b01101110;
           rom[ 0+13684] =8'b11111110;
           rom[ 0+13685] =8'b11011101;
           rom[ 0+13686] =8'b01100110;
           rom[ 0+13687] =8'b11111111;
           rom[ 0+13688] =8'b11100101;
           rom[ 0+13689] =8'b11001101;
           rom[ 0+13690] =8'b01010011;
           rom[ 0+13691] =8'b00111110;
           rom[ 0+13692] =8'b01010100;
           rom[ 0+13693] =8'b01011101;
           rom[ 0+13694] =8'b11110001;
           rom[ 0+13695] =8'b11110001;
           rom[ 0+13696] =8'b11000001;
           rom[ 0+13697] =8'b00111110;
           rom[ 0+13698] =8'b00000100;
           rom[ 0+13699] =8'b10010011;
           rom[ 0+13700] =8'b01011111;
           rom[ 0+13701] =8'b00111110;
           rom[ 0+13702] =8'b00000000;
           rom[ 0+13703] =8'b10011010;
           rom[ 0+13704] =8'b01010111;
           rom[ 0+13705] =8'b01101011;
           rom[ 0+13706] =8'b01100010;
           rom[ 0+13707] =8'b00101001;
           rom[ 0+13708] =8'b00011001;
           rom[ 0+13709] =8'b00101001;
           rom[ 0+13710] =8'b00011001;
           rom[ 0+13711] =8'b01011101;
           rom[ 0+13712] =8'b01010100;
           rom[ 0+13713] =8'b00100001;
           rom[ 0+13714] =8'b00000110;
           rom[ 0+13715] =8'b10010000;
           rom[ 0+13716] =8'b00011001;
           rom[ 0+13717] =8'b01011101;
           rom[ 0+13718] =8'b01010100;
           rom[ 0+13719] =8'b00010011;
           rom[ 0+13720] =8'b00010011;
           rom[ 0+13721] =8'b00011010;
           rom[ 0+13722] =8'b00000010;
           rom[ 0+13723] =8'b11011101;
           rom[ 0+13724] =8'b00110100;
           rom[ 0+13725] =8'b11111110;
           rom[ 0+13726] =8'b11000010;
           rom[ 0+13727] =8'b10100100;
           rom[ 0+13728] =8'b00110101;
           rom[ 0+13729] =8'b11011101;
           rom[ 0+13730] =8'b00110100;
           rom[ 0+13731] =8'b11111111;
           rom[ 0+13732] =8'b11000011;
           rom[ 0+13733] =8'b01001011;
           rom[ 0+13734] =8'b00110101;
           rom[ 0+13735] =8'b11011101;
           rom[ 0+13736] =8'b00110110;
           rom[ 0+13737] =8'b11111110;
           rom[ 0+13738] =8'b00000000;
           rom[ 0+13739] =8'b11011101;
           rom[ 0+13740] =8'b00110110;
           rom[ 0+13741] =8'b11111111;
           rom[ 0+13742] =8'b00000000;
           rom[ 0+13743] =8'b11011101;
           rom[ 0+13744] =8'b01111110;
           rom[ 0+13745] =8'b11111110;
           rom[ 0+13746] =8'b11010110;
           rom[ 0+13747] =8'b00000101;
           rom[ 0+13748] =8'b11011101;
           rom[ 0+13749] =8'b01111110;
           rom[ 0+13750] =8'b11111111;
           rom[ 0+13751] =8'b11011110;
           rom[ 0+13752] =8'b00000000;
           rom[ 0+13753] =8'b11110010;
           rom[ 0+13754] =8'b00001010;
           rom[ 0+13755] =8'b00110110;
           rom[ 0+13756] =8'b11011101;
           rom[ 0+13757] =8'b01001110;
           rom[ 0+13758] =8'b11111010;
           rom[ 0+13759] =8'b11011101;
           rom[ 0+13760] =8'b01000110;
           rom[ 0+13761] =8'b11111011;
           rom[ 0+13762] =8'b11011101;
           rom[ 0+13763] =8'b00110100;
           rom[ 0+13764] =8'b11111010;
           rom[ 0+13765] =8'b11000010;
           rom[ 0+13766] =8'b11001011;
           rom[ 0+13767] =8'b00110101;
           rom[ 0+13768] =8'b11011101;
           rom[ 0+13769] =8'b00110100;
           rom[ 0+13770] =8'b11111011;
           rom[ 0+13771] =8'b00100001;
           rom[ 0+13772] =8'b00110110;
           rom[ 0+13773] =8'b10001000;
           rom[ 0+13774] =8'b00001001;
           rom[ 0+13775] =8'b01001101;
           rom[ 0+13776] =8'b01000100;
           rom[ 0+13777] =8'b11000101;
           rom[ 0+13778] =8'b00100001;
           rom[ 0+13779] =8'b00000101;
           rom[ 0+13780] =8'b00000000;
           rom[ 0+13781] =8'b11100101;
           rom[ 0+13782] =8'b11011101;
           rom[ 0+13783] =8'b01101110;
           rom[ 0+13784] =8'b11111110;
           rom[ 0+13785] =8'b11011101;
           rom[ 0+13786] =8'b01100110;
           rom[ 0+13787] =8'b11111111;
           rom[ 0+13788] =8'b11100101;
           rom[ 0+13789] =8'b11001101;
           rom[ 0+13790] =8'b01010011;
           rom[ 0+13791] =8'b00111110;
           rom[ 0+13792] =8'b01010100;
           rom[ 0+13793] =8'b01011101;
           rom[ 0+13794] =8'b11110001;
           rom[ 0+13795] =8'b11110001;
           rom[ 0+13796] =8'b11000001;
           rom[ 0+13797] =8'b00111110;
           rom[ 0+13798] =8'b00000100;
           rom[ 0+13799] =8'b10010011;
           rom[ 0+13800] =8'b01011111;
           rom[ 0+13801] =8'b00111110;
           rom[ 0+13802] =8'b00000000;
           rom[ 0+13803] =8'b10011010;
           rom[ 0+13804] =8'b01010111;
           rom[ 0+13805] =8'b01101011;
           rom[ 0+13806] =8'b01100010;
           rom[ 0+13807] =8'b00101001;
           rom[ 0+13808] =8'b00011001;
           rom[ 0+13809] =8'b00101001;
           rom[ 0+13810] =8'b00011001;
           rom[ 0+13811] =8'b01011101;
           rom[ 0+13812] =8'b01010100;
           rom[ 0+13813] =8'b00100001;
           rom[ 0+13814] =8'b00000110;
           rom[ 0+13815] =8'b10010000;
           rom[ 0+13816] =8'b00011001;
           rom[ 0+13817] =8'b01011101;
           rom[ 0+13818] =8'b01010100;
           rom[ 0+13819] =8'b00010011;
           rom[ 0+13820] =8'b00011010;
           rom[ 0+13821] =8'b00000010;
           rom[ 0+13822] =8'b11011101;
           rom[ 0+13823] =8'b00110100;
           rom[ 0+13824] =8'b11111110;
           rom[ 0+13825] =8'b11000010;
           rom[ 0+13826] =8'b00000111;
           rom[ 0+13827] =8'b00110110;
           rom[ 0+13828] =8'b11011101;
           rom[ 0+13829] =8'b00110100;
           rom[ 0+13830] =8'b11111111;
           rom[ 0+13831] =8'b11000011;
           rom[ 0+13832] =8'b10101111;
           rom[ 0+13833] =8'b00110101;
           rom[ 0+13834] =8'b11011101;
           rom[ 0+13835] =8'b00110110;
           rom[ 0+13836] =8'b11111110;
           rom[ 0+13837] =8'b00000000;
           rom[ 0+13838] =8'b11011101;
           rom[ 0+13839] =8'b00110110;
           rom[ 0+13840] =8'b11111111;
           rom[ 0+13841] =8'b00000000;
           rom[ 0+13842] =8'b11011101;
           rom[ 0+13843] =8'b01111110;
           rom[ 0+13844] =8'b11111110;
           rom[ 0+13845] =8'b11010110;
           rom[ 0+13846] =8'b00000101;
           rom[ 0+13847] =8'b11011101;
           rom[ 0+13848] =8'b01111110;
           rom[ 0+13849] =8'b11111111;
           rom[ 0+13850] =8'b11011110;
           rom[ 0+13851] =8'b00000000;
           rom[ 0+13852] =8'b11110010;
           rom[ 0+13853] =8'b01101100;
           rom[ 0+13854] =8'b00110110;
           rom[ 0+13855] =8'b11011101;
           rom[ 0+13856] =8'b01001110;
           rom[ 0+13857] =8'b11111010;
           rom[ 0+13858] =8'b11011101;
           rom[ 0+13859] =8'b01000110;
           rom[ 0+13860] =8'b11111011;
           rom[ 0+13861] =8'b11011101;
           rom[ 0+13862] =8'b00110100;
           rom[ 0+13863] =8'b11111010;
           rom[ 0+13864] =8'b11000010;
           rom[ 0+13865] =8'b00101110;
           rom[ 0+13866] =8'b00110110;
           rom[ 0+13867] =8'b11011101;
           rom[ 0+13868] =8'b00110100;
           rom[ 0+13869] =8'b11111011;
           rom[ 0+13870] =8'b00100001;
           rom[ 0+13871] =8'b00110110;
           rom[ 0+13872] =8'b10001000;
           rom[ 0+13873] =8'b00001001;
           rom[ 0+13874] =8'b01001101;
           rom[ 0+13875] =8'b01000100;
           rom[ 0+13876] =8'b11000101;
           rom[ 0+13877] =8'b00100001;
           rom[ 0+13878] =8'b00000101;
           rom[ 0+13879] =8'b00000000;
           rom[ 0+13880] =8'b11100101;
           rom[ 0+13881] =8'b11011101;
           rom[ 0+13882] =8'b01101110;
           rom[ 0+13883] =8'b11111110;
           rom[ 0+13884] =8'b11011101;
           rom[ 0+13885] =8'b01100110;
           rom[ 0+13886] =8'b11111111;
           rom[ 0+13887] =8'b11100101;
           rom[ 0+13888] =8'b11001101;
           rom[ 0+13889] =8'b01010011;
           rom[ 0+13890] =8'b00111110;
           rom[ 0+13891] =8'b01010100;
           rom[ 0+13892] =8'b01011101;
           rom[ 0+13893] =8'b11110001;
           rom[ 0+13894] =8'b11110001;
           rom[ 0+13895] =8'b11000001;
           rom[ 0+13896] =8'b00111110;
           rom[ 0+13897] =8'b00000100;
           rom[ 0+13898] =8'b10010011;
           rom[ 0+13899] =8'b01011111;
           rom[ 0+13900] =8'b00111110;
           rom[ 0+13901] =8'b00000000;
           rom[ 0+13902] =8'b10011010;
           rom[ 0+13903] =8'b01010111;
           rom[ 0+13904] =8'b01101011;
           rom[ 0+13905] =8'b01100010;
           rom[ 0+13906] =8'b00101001;
           rom[ 0+13907] =8'b00011001;
           rom[ 0+13908] =8'b00101001;
           rom[ 0+13909] =8'b00011001;
           rom[ 0+13910] =8'b01011101;
           rom[ 0+13911] =8'b01010100;
           rom[ 0+13912] =8'b00100001;
           rom[ 0+13913] =8'b00000110;
           rom[ 0+13914] =8'b10010000;
           rom[ 0+13915] =8'b00011001;
           rom[ 0+13916] =8'b01011101;
           rom[ 0+13917] =8'b01010100;
           rom[ 0+13918] =8'b00011010;
           rom[ 0+13919] =8'b00000010;
           rom[ 0+13920] =8'b11011101;
           rom[ 0+13921] =8'b00110100;
           rom[ 0+13922] =8'b11111110;
           rom[ 0+13923] =8'b11000010;
           rom[ 0+13924] =8'b01101001;
           rom[ 0+13925] =8'b00110110;
           rom[ 0+13926] =8'b11011101;
           rom[ 0+13927] =8'b00110100;
           rom[ 0+13928] =8'b11111111;
           rom[ 0+13929] =8'b11000011;
           rom[ 0+13930] =8'b00010010;
           rom[ 0+13931] =8'b00110110;
           rom[ 0+13932] =8'b11001101;
           rom[ 0+13933] =8'b00000000;
           rom[ 0+13934] =8'b00010110;
           rom[ 0+13935] =8'b10101111;
           rom[ 0+13936] =8'b11111101;
           rom[ 0+13937] =8'b00100001;
           rom[ 0+13938] =8'b00101110;
           rom[ 0+13939] =8'b10010000;
           rom[ 0+13940] =8'b11111101;
           rom[ 0+13941] =8'b01110111;
           rom[ 0+13942] =8'b00000000;
           rom[ 0+13943] =8'b11111101;
           rom[ 0+13944] =8'b01110111;
           rom[ 0+13945] =8'b00000001;
           rom[ 0+13946] =8'b11111101;
           rom[ 0+13947] =8'b01110111;
           rom[ 0+13948] =8'b00000010;
           rom[ 0+13949] =8'b11111101;
           rom[ 0+13950] =8'b01110111;
           rom[ 0+13951] =8'b00000011;
           rom[ 0+13952] =8'b00000001;
           rom[ 0+13953] =8'b00000000;
           rom[ 0+13954] =8'b00000000;
           rom[ 0+13955] =8'b01111001;
           rom[ 0+13956] =8'b11010110;
           rom[ 0+13957] =8'b00000101;
           rom[ 0+13958] =8'b01111000;
           rom[ 0+13959] =8'b11011110;
           rom[ 0+13960] =8'b00000000;
           rom[ 0+13961] =8'b11110010;
           rom[ 0+13962] =8'b11000000;
           rom[ 0+13963] =8'b00110110;
           rom[ 0+13964] =8'b00100001;
           rom[ 0+13965] =8'b00101001;
           rom[ 0+13966] =8'b10010000;
           rom[ 0+13967] =8'b00001001;
           rom[ 0+13968] =8'b01011101;
           rom[ 0+13969] =8'b01010100;
           rom[ 0+13970] =8'b00011010;
           rom[ 0+13971] =8'b01011111;
           rom[ 0+13972] =8'b11011101;
           rom[ 0+13973] =8'b01110011;
           rom[ 0+13974] =8'b11111001;
           rom[ 0+13975] =8'b11000101;
           rom[ 0+13976] =8'b00100001;
           rom[ 0+13977] =8'b00000101;
           rom[ 0+13978] =8'b00000000;
           rom[ 0+13979] =8'b11100101;
           rom[ 0+13980] =8'b11000101;
           rom[ 0+13981] =8'b11001101;
           rom[ 0+13982] =8'b01010011;
           rom[ 0+13983] =8'b00111110;
           rom[ 0+13984] =8'b01011100;
           rom[ 0+13985] =8'b01010101;
           rom[ 0+13986] =8'b11110001;
           rom[ 0+13987] =8'b11110001;
           rom[ 0+13988] =8'b11000001;
           rom[ 0+13989] =8'b00111110;
           rom[ 0+13990] =8'b00000100;
           rom[ 0+13991] =8'b10010010;
           rom[ 0+13992] =8'b01010111;
           rom[ 0+13993] =8'b00111110;
           rom[ 0+13994] =8'b00000000;
           rom[ 0+13995] =8'b10011011;
           rom[ 0+13996] =8'b01011111;
           rom[ 0+13997] =8'b11000101;
           rom[ 0+13998] =8'b11011101;
           rom[ 0+13999] =8'b01111110;
           rom[ 0+14000] =8'b11111001;
           rom[ 0+14001] =8'b11110101;
           rom[ 0+14002] =8'b00110011;
           rom[ 0+14003] =8'b01101010;
           rom[ 0+14004] =8'b01100011;
           rom[ 0+14005] =8'b11100101;
           rom[ 0+14006] =8'b11001101;
           rom[ 0+14007] =8'b01110000;
           rom[ 0+14008] =8'b00011000;
           rom[ 0+14009] =8'b11110001;
           rom[ 0+14010] =8'b00110011;
           rom[ 0+14011] =8'b11000001;
           rom[ 0+14012] =8'b00000011;
           rom[ 0+14013] =8'b11000011;
           rom[ 0+14014] =8'b10000011;
           rom[ 0+14015] =8'b00110110;
           rom[ 0+14016] =8'b00000001;
           rom[ 0+14017] =8'b00110111;
           rom[ 0+14018] =8'b10001000;
           rom[ 0+14019] =8'b00001010;
           rom[ 0+14020] =8'b01011111;
           rom[ 0+14021] =8'b11101110;
           rom[ 0+14022] =8'b11111111;
           rom[ 0+14023] =8'b00000010;
           rom[ 0+14024] =8'b00000001;
           rom[ 0+14025] =8'b00111100;
           rom[ 0+14026] =8'b10001000;
           rom[ 0+14027] =8'b00001010;
           rom[ 0+14028] =8'b01011111;
           rom[ 0+14029] =8'b11101110;
           rom[ 0+14030] =8'b10101010;
           rom[ 0+14031] =8'b00000010;
           rom[ 0+14032] =8'b00000001;
           rom[ 0+14033] =8'b01000001;
           rom[ 0+14034] =8'b10001000;
           rom[ 0+14035] =8'b00001010;
           rom[ 0+14036] =8'b01011111;
           rom[ 0+14037] =8'b11101110;
           rom[ 0+14038] =8'b11001100;
           rom[ 0+14039] =8'b00000010;
           rom[ 0+14040] =8'b00000001;
           rom[ 0+14041] =8'b00111000;
           rom[ 0+14042] =8'b10001000;
           rom[ 0+14043] =8'b00001010;
           rom[ 0+14044] =8'b01011111;
           rom[ 0+14045] =8'b11101110;
           rom[ 0+14046] =8'b10111011;
           rom[ 0+14047] =8'b00000010;
           rom[ 0+14048] =8'b00000001;
           rom[ 0+14049] =8'b00111101;
           rom[ 0+14050] =8'b10001000;
           rom[ 0+14051] =8'b00001010;
           rom[ 0+14052] =8'b01011111;
           rom[ 0+14053] =8'b11101110;
           rom[ 0+14054] =8'b11011101;
           rom[ 0+14055] =8'b00000010;
           rom[ 0+14056] =8'b00000001;
           rom[ 0+14057] =8'b00111001;
           rom[ 0+14058] =8'b10001000;
           rom[ 0+14059] =8'b00001010;
           rom[ 0+14060] =8'b01011111;
           rom[ 0+14061] =8'b11101110;
           rom[ 0+14062] =8'b11101110;
           rom[ 0+14063] =8'b00000010;
           rom[ 0+14064] =8'b00100001;
           rom[ 0+14065] =8'b00000110;
           rom[ 0+14066] =8'b00111101;
           rom[ 0+14067] =8'b11100101;
           rom[ 0+14068] =8'b11001101;
           rom[ 0+14069] =8'b00001010;
           rom[ 0+14070] =8'b00000010;
           rom[ 0+14071] =8'b11110001;
           rom[ 0+14072] =8'b00000001;
           rom[ 0+14073] =8'b00000000;
           rom[ 0+14074] =8'b00000000;
           rom[ 0+14075] =8'b01111001;
           rom[ 0+14076] =8'b11010110;
           rom[ 0+14077] =8'b01010101;
           rom[ 0+14078] =8'b01111000;
           rom[ 0+14079] =8'b11011110;
           rom[ 0+14080] =8'b00000000;
           rom[ 0+14081] =8'b11110010;
           rom[ 0+14082] =8'b01000001;
           rom[ 0+14083] =8'b00110111;
           rom[ 0+14084] =8'b00100001;
           rom[ 0+14085] =8'b00110110;
           rom[ 0+14086] =8'b10001000;
           rom[ 0+14087] =8'b00001001;
           rom[ 0+14088] =8'b01011101;
           rom[ 0+14089] =8'b01010100;
           rom[ 0+14090] =8'b00011010;
           rom[ 0+14091] =8'b01011111;
           rom[ 0+14092] =8'b11011101;
           rom[ 0+14093] =8'b01110011;
           rom[ 0+14094] =8'b11111001;
           rom[ 0+14095] =8'b11000101;
           rom[ 0+14096] =8'b00100001;
           rom[ 0+14097] =8'b00000101;
           rom[ 0+14098] =8'b00000000;
           rom[ 0+14099] =8'b11100101;
           rom[ 0+14100] =8'b11000101;
           rom[ 0+14101] =8'b11001101;
           rom[ 0+14102] =8'b01010011;
           rom[ 0+14103] =8'b00111110;
           rom[ 0+14104] =8'b01010100;
           rom[ 0+14105] =8'b01011101;
           rom[ 0+14106] =8'b11110001;
           rom[ 0+14107] =8'b11110001;
           rom[ 0+14108] =8'b11000001;
           rom[ 0+14109] =8'b00111110;
           rom[ 0+14110] =8'b00000100;
           rom[ 0+14111] =8'b10010011;
           rom[ 0+14112] =8'b01011111;
           rom[ 0+14113] =8'b00111110;
           rom[ 0+14114] =8'b00000000;
           rom[ 0+14115] =8'b10011010;
           rom[ 0+14116] =8'b01010111;
           rom[ 0+14117] =8'b11000101;
           rom[ 0+14118] =8'b11011101;
           rom[ 0+14119] =8'b01111110;
           rom[ 0+14120] =8'b11111001;
           rom[ 0+14121] =8'b11110101;
           rom[ 0+14122] =8'b00110011;
           rom[ 0+14123] =8'b11010101;
           rom[ 0+14124] =8'b11001101;
           rom[ 0+14125] =8'b01110000;
           rom[ 0+14126] =8'b00011000;
           rom[ 0+14127] =8'b11110001;
           rom[ 0+14128] =8'b00110011;
           rom[ 0+14129] =8'b11000001;
           rom[ 0+14130] =8'b11000101;
           rom[ 0+14131] =8'b11011101;
           rom[ 0+14132] =8'b01111110;
           rom[ 0+14133] =8'b11111001;
           rom[ 0+14134] =8'b11110101;
           rom[ 0+14135] =8'b00110011;
           rom[ 0+14136] =8'b11001101;
           rom[ 0+14137] =8'b10011100;
           rom[ 0+14138] =8'b00010100;
           rom[ 0+14139] =8'b00110011;
           rom[ 0+14140] =8'b11000001;
           rom[ 0+14141] =8'b00000011;
           rom[ 0+14142] =8'b11000011;
           rom[ 0+14143] =8'b11111011;
           rom[ 0+14144] =8'b00110110;
           rom[ 0+14145] =8'b00100001;
           rom[ 0+14146] =8'b00010001;
           rom[ 0+14147] =8'b00111101;
           rom[ 0+14148] =8'b11100101;
           rom[ 0+14149] =8'b11001101;
           rom[ 0+14150] =8'b00001010;
           rom[ 0+14151] =8'b00000010;
           rom[ 0+14152] =8'b11110001;
           rom[ 0+14153] =8'b00000001;
           rom[ 0+14154] =8'b00000000;
           rom[ 0+14155] =8'b00000000;
           rom[ 0+14156] =8'b01111001;
           rom[ 0+14157] =8'b11010110;
           rom[ 0+14158] =8'b00000101;
           rom[ 0+14159] =8'b01111000;
           rom[ 0+14160] =8'b11011110;
           rom[ 0+14161] =8'b00000000;
           rom[ 0+14162] =8'b11110010;
           rom[ 0+14163] =8'b01101010;
           rom[ 0+14164] =8'b00110111;
           rom[ 0+14165] =8'b11000101;
           rom[ 0+14166] =8'b11000101;
           rom[ 0+14167] =8'b00100001;
           rom[ 0+14168] =8'b00000111;
           rom[ 0+14169] =8'b00000000;
           rom[ 0+14170] =8'b11100101;
           rom[ 0+14171] =8'b00100001;
           rom[ 0+14172] =8'b00010010;
           rom[ 0+14173] =8'b00000000;
           rom[ 0+14174] =8'b11100101;
           rom[ 0+14175] =8'b11001101;
           rom[ 0+14176] =8'b00101100;
           rom[ 0+14177] =8'b00101111;
           rom[ 0+14178] =8'b11110001;
           rom[ 0+14179] =8'b11110001;
           rom[ 0+14180] =8'b11110001;
           rom[ 0+14181] =8'b11000001;
           rom[ 0+14182] =8'b00000011;
           rom[ 0+14183] =8'b11000011;
           rom[ 0+14184] =8'b01001100;
           rom[ 0+14185] =8'b00110111;
           rom[ 0+14186] =8'b00100001;
           rom[ 0+14187] =8'b00101110;
           rom[ 0+14188] =8'b00111101;
           rom[ 0+14189] =8'b11100101;
           rom[ 0+14190] =8'b11001101;
           rom[ 0+14191] =8'b00001010;
           rom[ 0+14192] =8'b00000010;
           rom[ 0+14193] =8'b11110001;
           rom[ 0+14194] =8'b11011101;
           rom[ 0+14195] =8'b00110110;
           rom[ 0+14196] =8'b11111100;
           rom[ 0+14197] =8'b00000000;
           rom[ 0+14198] =8'b11011101;
           rom[ 0+14199] =8'b00110110;
           rom[ 0+14200] =8'b11111101;
           rom[ 0+14201] =8'b00000000;
           rom[ 0+14202] =8'b00010001;
           rom[ 0+14203] =8'b11110011;
           rom[ 0+14204] =8'b11111111;
           rom[ 0+14205] =8'b11011101;
           rom[ 0+14206] =8'b01111110;
           rom[ 0+14207] =8'b11111100;
           rom[ 0+14208] =8'b11010110;
           rom[ 0+14209] =8'b00000101;
           rom[ 0+14210] =8'b11011101;
           rom[ 0+14211] =8'b01111110;
           rom[ 0+14212] =8'b11111101;
           rom[ 0+14213] =8'b11011110;
           rom[ 0+14214] =8'b00000000;
           rom[ 0+14215] =8'b11110010;
           rom[ 0+14216] =8'b00010011;
           rom[ 0+14217] =8'b00111100;
           rom[ 0+14218] =8'b11010101;
           rom[ 0+14219] =8'b00100001;
           rom[ 0+14220] =8'b01000100;
           rom[ 0+14221] =8'b00111101;
           rom[ 0+14222] =8'b11100101;
           rom[ 0+14223] =8'b11001101;
           rom[ 0+14224] =8'b00001010;
           rom[ 0+14225] =8'b00000010;
           rom[ 0+14226] =8'b11110001;
           rom[ 0+14227] =8'b11010001;
           rom[ 0+14228] =8'b11010101;
           rom[ 0+14229] =8'b11011101;
           rom[ 0+14230] =8'b01101110;
           rom[ 0+14231] =8'b11111100;
           rom[ 0+14232] =8'b11011101;
           rom[ 0+14233] =8'b01100110;
           rom[ 0+14234] =8'b11111101;
           rom[ 0+14235] =8'b11100101;
           rom[ 0+14236] =8'b11001101;
           rom[ 0+14237] =8'b10110001;
           rom[ 0+14238] =8'b00010100;
           rom[ 0+14239] =8'b11110001;
           rom[ 0+14240] =8'b11010001;
           rom[ 0+14241] =8'b11010101;
           rom[ 0+14242] =8'b00100001;
           rom[ 0+14243] =8'b01010100;
           rom[ 0+14244] =8'b00111101;
           rom[ 0+14245] =8'b11100101;
           rom[ 0+14246] =8'b11001101;
           rom[ 0+14247] =8'b00001010;
           rom[ 0+14248] =8'b00000010;
           rom[ 0+14249] =8'b11110001;
           rom[ 0+14250] =8'b11010001;
           rom[ 0+14251] =8'b01111011;
           rom[ 0+14252] =8'b11000110;
           rom[ 0+14253] =8'b00001101;
           rom[ 0+14254] =8'b01011111;
           rom[ 0+14255] =8'b01111010;
           rom[ 0+14256] =8'b11001110;
           rom[ 0+14257] =8'b00000000;
           rom[ 0+14258] =8'b01010111;
           rom[ 0+14259] =8'b00100001;
           rom[ 0+14260] =8'b00000011;
           rom[ 0+14261] =8'b10000100;
           rom[ 0+14262] =8'b00011001;
           rom[ 0+14263] =8'b01001101;
           rom[ 0+14264] =8'b01000100;
           rom[ 0+14265] =8'b01001110;
           rom[ 0+14266] =8'b00100011;
           rom[ 0+14267] =8'b01000110;
           rom[ 0+14268] =8'b01111001;
           rom[ 0+14269] =8'b10110000;
           rom[ 0+14270] =8'b11001010;
           rom[ 0+14271] =8'b11100101;
           rom[ 0+14272] =8'b00110111;
           rom[ 0+14273] =8'b01111001;
           rom[ 0+14274] =8'b11111110;
           rom[ 0+14275] =8'b00000001;
           rom[ 0+14276] =8'b11000010;
           rom[ 0+14277] =8'b11001100;
           rom[ 0+14278] =8'b00110111;
           rom[ 0+14279] =8'b01111000;
           rom[ 0+14280] =8'b10110111;
           rom[ 0+14281] =8'b11001010;
           rom[ 0+14282] =8'b11110010;
           rom[ 0+14283] =8'b00110111;
           rom[ 0+14284] =8'b01111001;
           rom[ 0+14285] =8'b11111110;
           rom[ 0+14286] =8'b00000010;
           rom[ 0+14287] =8'b11000010;
           rom[ 0+14288] =8'b11010111;
           rom[ 0+14289] =8'b00110111;
           rom[ 0+14290] =8'b01111000;
           rom[ 0+14291] =8'b10110111;
           rom[ 0+14292] =8'b11001010;
           rom[ 0+14293] =8'b10110101;
           rom[ 0+14294] =8'b00111000;
           rom[ 0+14295] =8'b01111001;
           rom[ 0+14296] =8'b11111110;
           rom[ 0+14297] =8'b00000100;
           rom[ 0+14298] =8'b11000010;
           rom[ 0+14299] =8'b11100010;
           rom[ 0+14300] =8'b00110111;
           rom[ 0+14301] =8'b01111000;
           rom[ 0+14302] =8'b10110111;
           rom[ 0+14303] =8'b11001010;
           rom[ 0+14304] =8'b00001110;
           rom[ 0+14305] =8'b00111010;
           rom[ 0+14306] =8'b11000011;
           rom[ 0+14307] =8'b11111101;
           rom[ 0+14308] =8'b00111011;
           rom[ 0+14309] =8'b11010101;
           rom[ 0+14310] =8'b00100001;
           rom[ 0+14311] =8'b01010110;
           rom[ 0+14312] =8'b00111101;
           rom[ 0+14313] =8'b11100101;
           rom[ 0+14314] =8'b11001101;
           rom[ 0+14315] =8'b00001010;
           rom[ 0+14316] =8'b00000010;
           rom[ 0+14317] =8'b11110001;
           rom[ 0+14318] =8'b11010001;
           rom[ 0+14319] =8'b11000011;
           rom[ 0+14320] =8'b00000111;
           rom[ 0+14321] =8'b00111100;
           rom[ 0+14322] =8'b11010101;
           rom[ 0+14323] =8'b00100001;
           rom[ 0+14324] =8'b01101010;
           rom[ 0+14325] =8'b00111101;
           rom[ 0+14326] =8'b11100101;
           rom[ 0+14327] =8'b11001101;
           rom[ 0+14328] =8'b00001010;
           rom[ 0+14329] =8'b00000010;
           rom[ 0+14330] =8'b11110001;
           rom[ 0+14331] =8'b11010001;
           rom[ 0+14332] =8'b11010101;
           rom[ 0+14333] =8'b00100001;
           rom[ 0+14334] =8'b10000010;
           rom[ 0+14335] =8'b00111101;
           rom[ 0+14336] =8'b11100101;
           rom[ 0+14337] =8'b11001101;
           rom[ 0+14338] =8'b00001010;
           rom[ 0+14339] =8'b00000010;
           rom[ 0+14340] =8'b11110001;
           rom[ 0+14341] =8'b11010001;
           rom[ 0+14342] =8'b00100001;
           rom[ 0+14343] =8'b00000011;
           rom[ 0+14344] =8'b10000100;
           rom[ 0+14345] =8'b00011001;
           rom[ 0+14346] =8'b01001101;
           rom[ 0+14347] =8'b01000100;
           rom[ 0+14348] =8'b00000011;
           rom[ 0+14349] =8'b00000011;
           rom[ 0+14350] =8'b00000011;
           rom[ 0+14351] =8'b00000011;
           rom[ 0+14352] =8'b01101001;
           rom[ 0+14353] =8'b01100000;
           rom[ 0+14354] =8'b01001110;
           rom[ 0+14355] =8'b00100011;
           rom[ 0+14356] =8'b01000110;
           rom[ 0+14357] =8'b11010101;
           rom[ 0+14358] =8'b11000101;
           rom[ 0+14359] =8'b11001101;
           rom[ 0+14360] =8'b10110001;
           rom[ 0+14361] =8'b00010100;
           rom[ 0+14362] =8'b11110001;
           rom[ 0+14363] =8'b11010001;
           rom[ 0+14364] =8'b11010101;
           rom[ 0+14365] =8'b00100001;
           rom[ 0+14366] =8'b10010101;
           rom[ 0+14367] =8'b00111101;
           rom[ 0+14368] =8'b11100101;
           rom[ 0+14369] =8'b11001101;
           rom[ 0+14370] =8'b00001010;
           rom[ 0+14371] =8'b00000010;
           rom[ 0+14372] =8'b11110001;
           rom[ 0+14373] =8'b11010001;
           rom[ 0+14374] =8'b00100001;
           rom[ 0+14375] =8'b00000011;
           rom[ 0+14376] =8'b10000100;
           rom[ 0+14377] =8'b00011001;
           rom[ 0+14378] =8'b01001101;
           rom[ 0+14379] =8'b01000100;
           rom[ 0+14380] =8'b01111001;
           rom[ 0+14381] =8'b11000110;
           rom[ 0+14382] =8'b00001010;
           rom[ 0+14383] =8'b01001111;
           rom[ 0+14384] =8'b01111000;
           rom[ 0+14385] =8'b11001110;
           rom[ 0+14386] =8'b00000000;
           rom[ 0+14387] =8'b01000111;
           rom[ 0+14388] =8'b00001010;
           rom[ 0+14389] =8'b01001111;
           rom[ 0+14390] =8'b11010101;
           rom[ 0+14391] =8'b01111001;
           rom[ 0+14392] =8'b11110101;
           rom[ 0+14393] =8'b00110011;
           rom[ 0+14394] =8'b11001101;
           rom[ 0+14395] =8'b10011100;
           rom[ 0+14396] =8'b00010100;
           rom[ 0+14397] =8'b00110011;
           rom[ 0+14398] =8'b11010001;
           rom[ 0+14399] =8'b11010101;
           rom[ 0+14400] =8'b00100001;
           rom[ 0+14401] =8'b00000100;
           rom[ 0+14402] =8'b00111101;
           rom[ 0+14403] =8'b11100101;
           rom[ 0+14404] =8'b11001101;
           rom[ 0+14405] =8'b00001010;
           rom[ 0+14406] =8'b00000010;
           rom[ 0+14407] =8'b11110001;
           rom[ 0+14408] =8'b11010001;
           rom[ 0+14409] =8'b00100001;
           rom[ 0+14410] =8'b00000011;
           rom[ 0+14411] =8'b10000100;
           rom[ 0+14412] =8'b00011001;
           rom[ 0+14413] =8'b11011101;
           rom[ 0+14414] =8'b01110101;
           rom[ 0+14415] =8'b11110111;
           rom[ 0+14416] =8'b11011101;
           rom[ 0+14417] =8'b01110100;
           rom[ 0+14418] =8'b11111000;
           rom[ 0+14419] =8'b11011101;
           rom[ 0+14420] =8'b01111110;
           rom[ 0+14421] =8'b11110111;
           rom[ 0+14422] =8'b11000110;
           rom[ 0+14423] =8'b00000100;
           rom[ 0+14424] =8'b01001111;
           rom[ 0+14425] =8'b11011101;
           rom[ 0+14426] =8'b01111110;
           rom[ 0+14427] =8'b11111000;
           rom[ 0+14428] =8'b11001110;
           rom[ 0+14429] =8'b00000000;
           rom[ 0+14430] =8'b01000111;
           rom[ 0+14431] =8'b01101001;
           rom[ 0+14432] =8'b01100000;
           rom[ 0+14433] =8'b01001110;
           rom[ 0+14434] =8'b00100011;
           rom[ 0+14435] =8'b01000110;
           rom[ 0+14436] =8'b00001011;
           rom[ 0+14437] =8'b11010101;
           rom[ 0+14438] =8'b01011001;
           rom[ 0+14439] =8'b01010000;
           rom[ 0+14440] =8'b01101011;
           rom[ 0+14441] =8'b01100010;
           rom[ 0+14442] =8'b00101001;
           rom[ 0+14443] =8'b00101001;
           rom[ 0+14444] =8'b00011001;
           rom[ 0+14445] =8'b11010001;
           rom[ 0+14446] =8'b11011101;
           rom[ 0+14447] =8'b01110101;
           rom[ 0+14448] =8'b11110101;
           rom[ 0+14449] =8'b11011101;
           rom[ 0+14450] =8'b01110100;
           rom[ 0+14451] =8'b11110110;
           rom[ 0+14452] =8'b00111110;
           rom[ 0+14453] =8'b00000100;
           rom[ 0+14454] =8'b11011101;
           rom[ 0+14455] =8'b10010110;
           rom[ 0+14456] =8'b11111100;
           rom[ 0+14457] =8'b01001111;
           rom[ 0+14458] =8'b00111110;
           rom[ 0+14459] =8'b00000000;
           rom[ 0+14460] =8'b11011101;
           rom[ 0+14461] =8'b10011110;
           rom[ 0+14462] =8'b11111101;
           rom[ 0+14463] =8'b01000111;
           rom[ 0+14464] =8'b11011101;
           rom[ 0+14465] =8'b01111110;
           rom[ 0+14466] =8'b11110101;
           rom[ 0+14467] =8'b10000001;
           rom[ 0+14468] =8'b01001111;
           rom[ 0+14469] =8'b11011101;
           rom[ 0+14470] =8'b01111110;
           rom[ 0+14471] =8'b11110110;
           rom[ 0+14472] =8'b10001000;
           rom[ 0+14473] =8'b01000111;
           rom[ 0+14474] =8'b00100001;
           rom[ 0+14475] =8'b00110110;
           rom[ 0+14476] =8'b10001000;
           rom[ 0+14477] =8'b00001001;
           rom[ 0+14478] =8'b11011101;
           rom[ 0+14479] =8'b01110101;
           rom[ 0+14480] =8'b11110101;
           rom[ 0+14481] =8'b11011101;
           rom[ 0+14482] =8'b01110100;
           rom[ 0+14483] =8'b11110110;
           rom[ 0+14484] =8'b01111110;
           rom[ 0+14485] =8'b11011101;
           rom[ 0+14486] =8'b01110111;
           rom[ 0+14487] =8'b11110100;
           rom[ 0+14488] =8'b11011101;
           rom[ 0+14489] =8'b01111110;
           rom[ 0+14490] =8'b11110111;
           rom[ 0+14491] =8'b11000110;
           rom[ 0+14492] =8'b00001010;
           rom[ 0+14493] =8'b01000111;
           rom[ 0+14494] =8'b11011101;
           rom[ 0+14495] =8'b01111110;
           rom[ 0+14496] =8'b11111000;
           rom[ 0+14497] =8'b11001110;
           rom[ 0+14498] =8'b00000000;
           rom[ 0+14499] =8'b01001111;
           rom[ 0+14500] =8'b01101000;
           rom[ 0+14501] =8'b01100001;
           rom[ 0+14502] =8'b01000110;
           rom[ 0+14503] =8'b11011101;
           rom[ 0+14504] =8'b01111110;
           rom[ 0+14505] =8'b11110100;
           rom[ 0+14506] =8'b10101000;
           rom[ 0+14507] =8'b11011101;
           rom[ 0+14508] =8'b01101110;
           rom[ 0+14509] =8'b11110101;
           rom[ 0+14510] =8'b11011101;
           rom[ 0+14511] =8'b01100110;
           rom[ 0+14512] =8'b11110110;
           rom[ 0+14513] =8'b01110111;
           rom[ 0+14514] =8'b11000011;
           rom[ 0+14515] =8'b00000111;
           rom[ 0+14516] =8'b00111100;
           rom[ 0+14517] =8'b11010101;
           rom[ 0+14518] =8'b00100001;
           rom[ 0+14519] =8'b10101001;
           rom[ 0+14520] =8'b00111101;
           rom[ 0+14521] =8'b11100101;
           rom[ 0+14522] =8'b11001101;
           rom[ 0+14523] =8'b00001010;
           rom[ 0+14524] =8'b00000010;
           rom[ 0+14525] =8'b11110001;
           rom[ 0+14526] =8'b11010001;
           rom[ 0+14527] =8'b11010101;
           rom[ 0+14528] =8'b00100001;
           rom[ 0+14529] =8'b10000010;
           rom[ 0+14530] =8'b00111101;
           rom[ 0+14531] =8'b11100101;
           rom[ 0+14532] =8'b11001101;
           rom[ 0+14533] =8'b00001010;
           rom[ 0+14534] =8'b00000010;
           rom[ 0+14535] =8'b11110001;
           rom[ 0+14536] =8'b11010001;
           rom[ 0+14537] =8'b00100001;
           rom[ 0+14538] =8'b00000011;
           rom[ 0+14539] =8'b10000100;
           rom[ 0+14540] =8'b00011001;
           rom[ 0+14541] =8'b01001101;
           rom[ 0+14542] =8'b01000100;
           rom[ 0+14543] =8'b00000011;
           rom[ 0+14544] =8'b00000011;
           rom[ 0+14545] =8'b00000011;
           rom[ 0+14546] =8'b00000011;
           rom[ 0+14547] =8'b01101001;
           rom[ 0+14548] =8'b01100000;
           rom[ 0+14549] =8'b01001110;
           rom[ 0+14550] =8'b00100011;
           rom[ 0+14551] =8'b01000110;
           rom[ 0+14552] =8'b11010101;
           rom[ 0+14553] =8'b11000101;
           rom[ 0+14554] =8'b11001101;
           rom[ 0+14555] =8'b10110001;
           rom[ 0+14556] =8'b00010100;
           rom[ 0+14557] =8'b11110001;
           rom[ 0+14558] =8'b11010001;
           rom[ 0+14559] =8'b11010101;
           rom[ 0+14560] =8'b00100001;
           rom[ 0+14561] =8'b10010101;
           rom[ 0+14562] =8'b00111101;
           rom[ 0+14563] =8'b11100101;
           rom[ 0+14564] =8'b11001101;
           rom[ 0+14565] =8'b00001010;
           rom[ 0+14566] =8'b00000010;
           rom[ 0+14567] =8'b11110001;
           rom[ 0+14568] =8'b11010001;
           rom[ 0+14569] =8'b00100001;
           rom[ 0+14570] =8'b00000011;
           rom[ 0+14571] =8'b10000100;
           rom[ 0+14572] =8'b00011001;
           rom[ 0+14573] =8'b01001101;
           rom[ 0+14574] =8'b01000100;
           rom[ 0+14575] =8'b01111001;
           rom[ 0+14576] =8'b11000110;
           rom[ 0+14577] =8'b00001010;
           rom[ 0+14578] =8'b01001111;
           rom[ 0+14579] =8'b01111000;
           rom[ 0+14580] =8'b11001110;
           rom[ 0+14581] =8'b00000000;
           rom[ 0+14582] =8'b01000111;
           rom[ 0+14583] =8'b00001010;
           rom[ 0+14584] =8'b01001111;
           rom[ 0+14585] =8'b11010101;
           rom[ 0+14586] =8'b01111001;
           rom[ 0+14587] =8'b11110101;
           rom[ 0+14588] =8'b00110011;
           rom[ 0+14589] =8'b11001101;
           rom[ 0+14590] =8'b10011100;
           rom[ 0+14591] =8'b00010100;
           rom[ 0+14592] =8'b00110011;
           rom[ 0+14593] =8'b11010001;
           rom[ 0+14594] =8'b11010101;
           rom[ 0+14595] =8'b00100001;
           rom[ 0+14596] =8'b11000001;
           rom[ 0+14597] =8'b00111101;
           rom[ 0+14598] =8'b11100101;
           rom[ 0+14599] =8'b11001101;
           rom[ 0+14600] =8'b00001010;
           rom[ 0+14601] =8'b00000010;
           rom[ 0+14602] =8'b11110001;
           rom[ 0+14603] =8'b11010001;
           rom[ 0+14604] =8'b00100001;
           rom[ 0+14605] =8'b00000011;
           rom[ 0+14606] =8'b10000100;
           rom[ 0+14607] =8'b00011001;
           rom[ 0+14608] =8'b01001101;
           rom[ 0+14609] =8'b01000100;
           rom[ 0+14610] =8'b01111001;
           rom[ 0+14611] =8'b11000110;
           rom[ 0+14612] =8'b00000110;
           rom[ 0+14613] =8'b01001111;
           rom[ 0+14614] =8'b01111000;
           rom[ 0+14615] =8'b11001110;
           rom[ 0+14616] =8'b00000000;
           rom[ 0+14617] =8'b01000111;
           rom[ 0+14618] =8'b01101001;
           rom[ 0+14619] =8'b01100000;
           rom[ 0+14620] =8'b01001110;
           rom[ 0+14621] =8'b00100011;
           rom[ 0+14622] =8'b01000110;
           rom[ 0+14623] =8'b11010101;
           rom[ 0+14624] =8'b11000101;
           rom[ 0+14625] =8'b11001101;
           rom[ 0+14626] =8'b10110001;
           rom[ 0+14627] =8'b00010100;
           rom[ 0+14628] =8'b11110001;
           rom[ 0+14629] =8'b11010001;
           rom[ 0+14630] =8'b11010101;
           rom[ 0+14631] =8'b00100001;
           rom[ 0+14632] =8'b10010101;
           rom[ 0+14633] =8'b00111101;
           rom[ 0+14634] =8'b11100101;
           rom[ 0+14635] =8'b11001101;
           rom[ 0+14636] =8'b00001010;
           rom[ 0+14637] =8'b00000010;
           rom[ 0+14638] =8'b11110001;
           rom[ 0+14639] =8'b11010001;
           rom[ 0+14640] =8'b00100001;
           rom[ 0+14641] =8'b00000011;
           rom[ 0+14642] =8'b10000100;
           rom[ 0+14643] =8'b00011001;
           rom[ 0+14644] =8'b01001101;
           rom[ 0+14645] =8'b01000100;
           rom[ 0+14646] =8'b01111001;
           rom[ 0+14647] =8'b11000110;
           rom[ 0+14648] =8'b00001011;
           rom[ 0+14649] =8'b01001111;
           rom[ 0+14650] =8'b01111000;
           rom[ 0+14651] =8'b11001110;
           rom[ 0+14652] =8'b00000000;
           rom[ 0+14653] =8'b01000111;
           rom[ 0+14654] =8'b00001010;
           rom[ 0+14655] =8'b01001111;
           rom[ 0+14656] =8'b11010101;
           rom[ 0+14657] =8'b01111001;
           rom[ 0+14658] =8'b11110101;
           rom[ 0+14659] =8'b00110011;
           rom[ 0+14660] =8'b11001101;
           rom[ 0+14661] =8'b10011100;
           rom[ 0+14662] =8'b00010100;
           rom[ 0+14663] =8'b00110011;
           rom[ 0+14664] =8'b11010001;
           rom[ 0+14665] =8'b11010101;
           rom[ 0+14666] =8'b00100001;
           rom[ 0+14667] =8'b00000100;
           rom[ 0+14668] =8'b00111101;
           rom[ 0+14669] =8'b11100101;
           rom[ 0+14670] =8'b11001101;
           rom[ 0+14671] =8'b00001010;
           rom[ 0+14672] =8'b00000010;
           rom[ 0+14673] =8'b11110001;
           rom[ 0+14674] =8'b11010001;
           rom[ 0+14675] =8'b00100001;
           rom[ 0+14676] =8'b00000011;
           rom[ 0+14677] =8'b10000100;
           rom[ 0+14678] =8'b00011001;
           rom[ 0+14679] =8'b11011101;
           rom[ 0+14680] =8'b01110101;
           rom[ 0+14681] =8'b11110101;
           rom[ 0+14682] =8'b11011101;
           rom[ 0+14683] =8'b01110100;
           rom[ 0+14684] =8'b11110110;
           rom[ 0+14685] =8'b11011101;
           rom[ 0+14686] =8'b01111110;
           rom[ 0+14687] =8'b11110101;
           rom[ 0+14688] =8'b11000110;
           rom[ 0+14689] =8'b00000100;
           rom[ 0+14690] =8'b01001111;
           rom[ 0+14691] =8'b11011101;
           rom[ 0+14692] =8'b01111110;
           rom[ 0+14693] =8'b11110110;
           rom[ 0+14694] =8'b11001110;
           rom[ 0+14695] =8'b00000000;
           rom[ 0+14696] =8'b01000111;
           rom[ 0+14697] =8'b01101001;
           rom[ 0+14698] =8'b01100000;
           rom[ 0+14699] =8'b01001110;
           rom[ 0+14700] =8'b00100011;
           rom[ 0+14701] =8'b01000110;
           rom[ 0+14702] =8'b00001011;
           rom[ 0+14703] =8'b11010101;
           rom[ 0+14704] =8'b01011001;
           rom[ 0+14705] =8'b01010000;
           rom[ 0+14706] =8'b01101011;
           rom[ 0+14707] =8'b01100010;
           rom[ 0+14708] =8'b00101001;
           rom[ 0+14709] =8'b00101001;
           rom[ 0+14710] =8'b00011001;
           rom[ 0+14711] =8'b11010001;
           rom[ 0+14712] =8'b01001101;
           rom[ 0+14713] =8'b01000100;
           rom[ 0+14714] =8'b00111110;
           rom[ 0+14715] =8'b00000100;
           rom[ 0+14716] =8'b11011101;
           rom[ 0+14717] =8'b10010110;
           rom[ 0+14718] =8'b11111100;
           rom[ 0+14719] =8'b11011101;
           rom[ 0+14720] =8'b01110111;
           rom[ 0+14721] =8'b11110010;
           rom[ 0+14722] =8'b00111110;
           rom[ 0+14723] =8'b00000000;
           rom[ 0+14724] =8'b11011101;
           rom[ 0+14725] =8'b10011110;
           rom[ 0+14726] =8'b11111101;
           rom[ 0+14727] =8'b11011101;
           rom[ 0+14728] =8'b01110111;
           rom[ 0+14729] =8'b11110011;
           rom[ 0+14730] =8'b01111001;
           rom[ 0+14731] =8'b11011101;
           rom[ 0+14732] =8'b10000110;
           rom[ 0+14733] =8'b11110010;
           rom[ 0+14734] =8'b01001111;
           rom[ 0+14735] =8'b01111000;
           rom[ 0+14736] =8'b11011101;
           rom[ 0+14737] =8'b10001110;
           rom[ 0+14738] =8'b11110011;
           rom[ 0+14739] =8'b01000111;
           rom[ 0+14740] =8'b00100001;
           rom[ 0+14741] =8'b00110110;
           rom[ 0+14742] =8'b10001000;
           rom[ 0+14743] =8'b00001001;
           rom[ 0+14744] =8'b11011101;
           rom[ 0+14745] =8'b01110101;
           rom[ 0+14746] =8'b11110111;
           rom[ 0+14747] =8'b11011101;
           rom[ 0+14748] =8'b01110100;
           rom[ 0+14749] =8'b11111000;
           rom[ 0+14750] =8'b01111110;
           rom[ 0+14751] =8'b11011101;
           rom[ 0+14752] =8'b01110111;
           rom[ 0+14753] =8'b11110100;
           rom[ 0+14754] =8'b11011101;
           rom[ 0+14755] =8'b01111110;
           rom[ 0+14756] =8'b11110101;
           rom[ 0+14757] =8'b11000110;
           rom[ 0+14758] =8'b00001010;
           rom[ 0+14759] =8'b01000111;
           rom[ 0+14760] =8'b11011101;
           rom[ 0+14761] =8'b01111110;
           rom[ 0+14762] =8'b11110110;
           rom[ 0+14763] =8'b11001110;
           rom[ 0+14764] =8'b00000000;
           rom[ 0+14765] =8'b01001111;
           rom[ 0+14766] =8'b01101000;
           rom[ 0+14767] =8'b01100001;
           rom[ 0+14768] =8'b01000110;
           rom[ 0+14769] =8'b11011101;
           rom[ 0+14770] =8'b01111110;
           rom[ 0+14771] =8'b11110100;
           rom[ 0+14772] =8'b10101000;
           rom[ 0+14773] =8'b11011101;
           rom[ 0+14774] =8'b01101110;
           rom[ 0+14775] =8'b11110111;
           rom[ 0+14776] =8'b11011101;
           rom[ 0+14777] =8'b01100110;
           rom[ 0+14778] =8'b11111000;
           rom[ 0+14779] =8'b01110111;
           rom[ 0+14780] =8'b11011101;
           rom[ 0+14781] =8'b01111110;
           rom[ 0+14782] =8'b11110101;
           rom[ 0+14783] =8'b11000110;
           rom[ 0+14784] =8'b00000110;
           rom[ 0+14785] =8'b01001111;
           rom[ 0+14786] =8'b11011101;
           rom[ 0+14787] =8'b01111110;
           rom[ 0+14788] =8'b11110110;
           rom[ 0+14789] =8'b11001110;
           rom[ 0+14790] =8'b00000000;
           rom[ 0+14791] =8'b01000111;
           rom[ 0+14792] =8'b01101001;
           rom[ 0+14793] =8'b01100000;
           rom[ 0+14794] =8'b01001110;
           rom[ 0+14795] =8'b00100011;
           rom[ 0+14796] =8'b01000110;
           rom[ 0+14797] =8'b00001011;
           rom[ 0+14798] =8'b11010101;
           rom[ 0+14799] =8'b01011001;
           rom[ 0+14800] =8'b01010000;
           rom[ 0+14801] =8'b01101011;
           rom[ 0+14802] =8'b01100010;
           rom[ 0+14803] =8'b00101001;
           rom[ 0+14804] =8'b00101001;
           rom[ 0+14805] =8'b00011001;
           rom[ 0+14806] =8'b11010001;
           rom[ 0+14807] =8'b01001101;
           rom[ 0+14808] =8'b01000100;
           rom[ 0+14809] =8'b01111001;
           rom[ 0+14810] =8'b11011101;
           rom[ 0+14811] =8'b10000110;
           rom[ 0+14812] =8'b11110010;
           rom[ 0+14813] =8'b01001111;
           rom[ 0+14814] =8'b01111000;
           rom[ 0+14815] =8'b11011101;
           rom[ 0+14816] =8'b10001110;
           rom[ 0+14817] =8'b11110011;
           rom[ 0+14818] =8'b01000111;
           rom[ 0+14819] =8'b00100001;
           rom[ 0+14820] =8'b00110110;
           rom[ 0+14821] =8'b10001000;
           rom[ 0+14822] =8'b00001001;
           rom[ 0+14823] =8'b11011101;
           rom[ 0+14824] =8'b01110101;
           rom[ 0+14825] =8'b11110010;
           rom[ 0+14826] =8'b11011101;
           rom[ 0+14827] =8'b01110100;
           rom[ 0+14828] =8'b11110011;
           rom[ 0+14829] =8'b01111110;
           rom[ 0+14830] =8'b11011101;
           rom[ 0+14831] =8'b01110111;
           rom[ 0+14832] =8'b11110100;
           rom[ 0+14833] =8'b11011101;
           rom[ 0+14834] =8'b01111110;
           rom[ 0+14835] =8'b11110101;
           rom[ 0+14836] =8'b11000110;
           rom[ 0+14837] =8'b00001011;
           rom[ 0+14838] =8'b01000111;
           rom[ 0+14839] =8'b11011101;
           rom[ 0+14840] =8'b01111110;
           rom[ 0+14841] =8'b11110110;
           rom[ 0+14842] =8'b11001110;
           rom[ 0+14843] =8'b00000000;
           rom[ 0+14844] =8'b01001111;
           rom[ 0+14845] =8'b01101000;
           rom[ 0+14846] =8'b01100001;
           rom[ 0+14847] =8'b01000110;
           rom[ 0+14848] =8'b11011101;
           rom[ 0+14849] =8'b01111110;
           rom[ 0+14850] =8'b11110100;
           rom[ 0+14851] =8'b10101000;
           rom[ 0+14852] =8'b11011101;
           rom[ 0+14853] =8'b01101110;
           rom[ 0+14854] =8'b11110010;
           rom[ 0+14855] =8'b11011101;
           rom[ 0+14856] =8'b01100110;
           rom[ 0+14857] =8'b11110011;
           rom[ 0+14858] =8'b01110111;
           rom[ 0+14859] =8'b11000011;
           rom[ 0+14860] =8'b00000111;
           rom[ 0+14861] =8'b00111100;
           rom[ 0+14862] =8'b11010101;
           rom[ 0+14863] =8'b00100001;
           rom[ 0+14864] =8'b11010101;
           rom[ 0+14865] =8'b00111101;
           rom[ 0+14866] =8'b11100101;
           rom[ 0+14867] =8'b11001101;
           rom[ 0+14868] =8'b00001010;
           rom[ 0+14869] =8'b00000010;
           rom[ 0+14870] =8'b11110001;
           rom[ 0+14871] =8'b11010001;
           rom[ 0+14872] =8'b11010101;
           rom[ 0+14873] =8'b00100001;
           rom[ 0+14874] =8'b10000010;
           rom[ 0+14875] =8'b00111101;
           rom[ 0+14876] =8'b11100101;
           rom[ 0+14877] =8'b11001101;
           rom[ 0+14878] =8'b00001010;
           rom[ 0+14879] =8'b00000010;
           rom[ 0+14880] =8'b11110001;
           rom[ 0+14881] =8'b11010001;
           rom[ 0+14882] =8'b00100001;
           rom[ 0+14883] =8'b00000011;
           rom[ 0+14884] =8'b10000100;
           rom[ 0+14885] =8'b00011001;
           rom[ 0+14886] =8'b01001101;
           rom[ 0+14887] =8'b01000100;
           rom[ 0+14888] =8'b00000011;
           rom[ 0+14889] =8'b00000011;
           rom[ 0+14890] =8'b00000011;
           rom[ 0+14891] =8'b00000011;
           rom[ 0+14892] =8'b01101001;
           rom[ 0+14893] =8'b01100000;
           rom[ 0+14894] =8'b01001110;
           rom[ 0+14895] =8'b00100011;
           rom[ 0+14896] =8'b01000110;
           rom[ 0+14897] =8'b11010101;
           rom[ 0+14898] =8'b11000101;
           rom[ 0+14899] =8'b11001101;
           rom[ 0+14900] =8'b10110001;
           rom[ 0+14901] =8'b00010100;
           rom[ 0+14902] =8'b11110001;
           rom[ 0+14903] =8'b11010001;
           rom[ 0+14904] =8'b11010101;
           rom[ 0+14905] =8'b00100001;
           rom[ 0+14906] =8'b10010101;
           rom[ 0+14907] =8'b00111101;
           rom[ 0+14908] =8'b11100101;
           rom[ 0+14909] =8'b11001101;
           rom[ 0+14910] =8'b00001010;
           rom[ 0+14911] =8'b00000010;
           rom[ 0+14912] =8'b11110001;
           rom[ 0+14913] =8'b11010001;
           rom[ 0+14914] =8'b00100001;
           rom[ 0+14915] =8'b00000011;
           rom[ 0+14916] =8'b10000100;
           rom[ 0+14917] =8'b00011001;
           rom[ 0+14918] =8'b01001101;
           rom[ 0+14919] =8'b01000100;
           rom[ 0+14920] =8'b01111001;
           rom[ 0+14921] =8'b11000110;
           rom[ 0+14922] =8'b00001010;
           rom[ 0+14923] =8'b01001111;
           rom[ 0+14924] =8'b01111000;
           rom[ 0+14925] =8'b11001110;
           rom[ 0+14926] =8'b00000000;
           rom[ 0+14927] =8'b01000111;
           rom[ 0+14928] =8'b00001010;
           rom[ 0+14929] =8'b01001111;
           rom[ 0+14930] =8'b11010101;
           rom[ 0+14931] =8'b01111001;
           rom[ 0+14932] =8'b11110101;
           rom[ 0+14933] =8'b00110011;
           rom[ 0+14934] =8'b11001101;
           rom[ 0+14935] =8'b10011100;
           rom[ 0+14936] =8'b00010100;
           rom[ 0+14937] =8'b00110011;
           rom[ 0+14938] =8'b11010001;
           rom[ 0+14939] =8'b11010101;
           rom[ 0+14940] =8'b00100001;
           rom[ 0+14941] =8'b11000001;
           rom[ 0+14942] =8'b00111101;
           rom[ 0+14943] =8'b11100101;
           rom[ 0+14944] =8'b11001101;
           rom[ 0+14945] =8'b00001010;
           rom[ 0+14946] =8'b00000010;
           rom[ 0+14947] =8'b11110001;
           rom[ 0+14948] =8'b11010001;
           rom[ 0+14949] =8'b00100001;
           rom[ 0+14950] =8'b00000011;
           rom[ 0+14951] =8'b10000100;
           rom[ 0+14952] =8'b00011001;
           rom[ 0+14953] =8'b01001101;
           rom[ 0+14954] =8'b01000100;
           rom[ 0+14955] =8'b01111001;
           rom[ 0+14956] =8'b11000110;
           rom[ 0+14957] =8'b00000110;
           rom[ 0+14958] =8'b01001111;
           rom[ 0+14959] =8'b01111000;
           rom[ 0+14960] =8'b11001110;
           rom[ 0+14961] =8'b00000000;
           rom[ 0+14962] =8'b01000111;
           rom[ 0+14963] =8'b01101001;
           rom[ 0+14964] =8'b01100000;
           rom[ 0+14965] =8'b01001110;
           rom[ 0+14966] =8'b00100011;
           rom[ 0+14967] =8'b01000110;
           rom[ 0+14968] =8'b11010101;
           rom[ 0+14969] =8'b11000101;
           rom[ 0+14970] =8'b11001101;
           rom[ 0+14971] =8'b10110001;
           rom[ 0+14972] =8'b00010100;
           rom[ 0+14973] =8'b11110001;
           rom[ 0+14974] =8'b11010001;
           rom[ 0+14975] =8'b11010101;
           rom[ 0+14976] =8'b00100001;
           rom[ 0+14977] =8'b10010101;
           rom[ 0+14978] =8'b00111101;
           rom[ 0+14979] =8'b11100101;
           rom[ 0+14980] =8'b11001101;
           rom[ 0+14981] =8'b00001010;
           rom[ 0+14982] =8'b00000010;
           rom[ 0+14983] =8'b11110001;
           rom[ 0+14984] =8'b11010001;
           rom[ 0+14985] =8'b00100001;
           rom[ 0+14986] =8'b00000011;
           rom[ 0+14987] =8'b10000100;
           rom[ 0+14988] =8'b00011001;
           rom[ 0+14989] =8'b01001101;
           rom[ 0+14990] =8'b01000100;
           rom[ 0+14991] =8'b01111001;
           rom[ 0+14992] =8'b11000110;
           rom[ 0+14993] =8'b00001011;
           rom[ 0+14994] =8'b01001111;
           rom[ 0+14995] =8'b01111000;
           rom[ 0+14996] =8'b11001110;
           rom[ 0+14997] =8'b00000000;
           rom[ 0+14998] =8'b01000111;
           rom[ 0+14999] =8'b00001010;
           rom[ 0+15000] =8'b01001111;
           rom[ 0+15001] =8'b11010101;
           rom[ 0+15002] =8'b01111001;
           rom[ 0+15003] =8'b11110101;
           rom[ 0+15004] =8'b00110011;
           rom[ 0+15005] =8'b11001101;
           rom[ 0+15006] =8'b10011100;
           rom[ 0+15007] =8'b00010100;
           rom[ 0+15008] =8'b00110011;
           rom[ 0+15009] =8'b11010001;
           rom[ 0+15010] =8'b11010101;
           rom[ 0+15011] =8'b00100001;
           rom[ 0+15012] =8'b11000001;
           rom[ 0+15013] =8'b00111101;
           rom[ 0+15014] =8'b11100101;
           rom[ 0+15015] =8'b11001101;
           rom[ 0+15016] =8'b00001010;
           rom[ 0+15017] =8'b00000010;
           rom[ 0+15018] =8'b11110001;
           rom[ 0+15019] =8'b11010001;
           rom[ 0+15020] =8'b00100001;
           rom[ 0+15021] =8'b00000011;
           rom[ 0+15022] =8'b10000100;
           rom[ 0+15023] =8'b00011001;
           rom[ 0+15024] =8'b01001101;
           rom[ 0+15025] =8'b01000100;
           rom[ 0+15026] =8'b01111001;
           rom[ 0+15027] =8'b11000110;
           rom[ 0+15028] =8'b00001000;
           rom[ 0+15029] =8'b01001111;
           rom[ 0+15030] =8'b01111000;
           rom[ 0+15031] =8'b11001110;
           rom[ 0+15032] =8'b00000000;
           rom[ 0+15033] =8'b01000111;
           rom[ 0+15034] =8'b01101001;
           rom[ 0+15035] =8'b01100000;
           rom[ 0+15036] =8'b01001110;
           rom[ 0+15037] =8'b00100011;
           rom[ 0+15038] =8'b01000110;
           rom[ 0+15039] =8'b11010101;
           rom[ 0+15040] =8'b11000101;
           rom[ 0+15041] =8'b11001101;
           rom[ 0+15042] =8'b10110001;
           rom[ 0+15043] =8'b00010100;
           rom[ 0+15044] =8'b11110001;
           rom[ 0+15045] =8'b11010001;
           rom[ 0+15046] =8'b11010101;
           rom[ 0+15047] =8'b00100001;
           rom[ 0+15048] =8'b10010101;
           rom[ 0+15049] =8'b00111101;
           rom[ 0+15050] =8'b11100101;
           rom[ 0+15051] =8'b11001101;
           rom[ 0+15052] =8'b00001010;
           rom[ 0+15053] =8'b00000010;
           rom[ 0+15054] =8'b11110001;
           rom[ 0+15055] =8'b11010001;
           rom[ 0+15056] =8'b00100001;
           rom[ 0+15057] =8'b00000011;
           rom[ 0+15058] =8'b10000100;
           rom[ 0+15059] =8'b00011001;
           rom[ 0+15060] =8'b01001101;
           rom[ 0+15061] =8'b01000100;
           rom[ 0+15062] =8'b01111001;
           rom[ 0+15063] =8'b11000110;
           rom[ 0+15064] =8'b00001100;
           rom[ 0+15065] =8'b01001111;
           rom[ 0+15066] =8'b01111000;
           rom[ 0+15067] =8'b11001110;
           rom[ 0+15068] =8'b00000000;
           rom[ 0+15069] =8'b01000111;
           rom[ 0+15070] =8'b00001010;
           rom[ 0+15071] =8'b01001111;
           rom[ 0+15072] =8'b11010101;
           rom[ 0+15073] =8'b01111001;
           rom[ 0+15074] =8'b11110101;
           rom[ 0+15075] =8'b00110011;
           rom[ 0+15076] =8'b11001101;
           rom[ 0+15077] =8'b10011100;
           rom[ 0+15078] =8'b00010100;
           rom[ 0+15079] =8'b00110011;
           rom[ 0+15080] =8'b11010001;
           rom[ 0+15081] =8'b11010101;
           rom[ 0+15082] =8'b00100001;
           rom[ 0+15083] =8'b00000100;
           rom[ 0+15084] =8'b00111101;
           rom[ 0+15085] =8'b11100101;
           rom[ 0+15086] =8'b11001101;
           rom[ 0+15087] =8'b00001010;
           rom[ 0+15088] =8'b00000010;
           rom[ 0+15089] =8'b11110001;
           rom[ 0+15090] =8'b11010001;
           rom[ 0+15091] =8'b00100001;
           rom[ 0+15092] =8'b00000011;
           rom[ 0+15093] =8'b10000100;
           rom[ 0+15094] =8'b00011001;
           rom[ 0+15095] =8'b11011101;
           rom[ 0+15096] =8'b01110101;
           rom[ 0+15097] =8'b11110010;
           rom[ 0+15098] =8'b11011101;
           rom[ 0+15099] =8'b01110100;
           rom[ 0+15100] =8'b11110011;
           rom[ 0+15101] =8'b11011101;
           rom[ 0+15102] =8'b01111110;
           rom[ 0+15103] =8'b11110010;
           rom[ 0+15104] =8'b11000110;
           rom[ 0+15105] =8'b00000100;
           rom[ 0+15106] =8'b01001111;
           rom[ 0+15107] =8'b11011101;
           rom[ 0+15108] =8'b01111110;
           rom[ 0+15109] =8'b11110011;
           rom[ 0+15110] =8'b11001110;
           rom[ 0+15111] =8'b00000000;
           rom[ 0+15112] =8'b01000111;
           rom[ 0+15113] =8'b01101001;
           rom[ 0+15114] =8'b01100000;
           rom[ 0+15115] =8'b01001110;
           rom[ 0+15116] =8'b00100011;
           rom[ 0+15117] =8'b01000110;
           rom[ 0+15118] =8'b00001011;
           rom[ 0+15119] =8'b11010101;
           rom[ 0+15120] =8'b01011001;
           rom[ 0+15121] =8'b01010000;
           rom[ 0+15122] =8'b01101011;
           rom[ 0+15123] =8'b01100010;
           rom[ 0+15124] =8'b00101001;
           rom[ 0+15125] =8'b00101001;
           rom[ 0+15126] =8'b00011001;
           rom[ 0+15127] =8'b11010001;
           rom[ 0+15128] =8'b01001101;
           rom[ 0+15129] =8'b01000100;
           rom[ 0+15130] =8'b00111110;
           rom[ 0+15131] =8'b00000100;
           rom[ 0+15132] =8'b11011101;
           rom[ 0+15133] =8'b10010110;
           rom[ 0+15134] =8'b11111100;
           rom[ 0+15135] =8'b11011101;
           rom[ 0+15136] =8'b01110111;
           rom[ 0+15137] =8'b11110111;
           rom[ 0+15138] =8'b00111110;
           rom[ 0+15139] =8'b00000000;
           rom[ 0+15140] =8'b11011101;
           rom[ 0+15141] =8'b10011110;
           rom[ 0+15142] =8'b11111101;
           rom[ 0+15143] =8'b11011101;
           rom[ 0+15144] =8'b01110111;
           rom[ 0+15145] =8'b11111000;
           rom[ 0+15146] =8'b01111001;
           rom[ 0+15147] =8'b11011101;
           rom[ 0+15148] =8'b10000110;
           rom[ 0+15149] =8'b11110111;
           rom[ 0+15150] =8'b01001111;
           rom[ 0+15151] =8'b01111000;
           rom[ 0+15152] =8'b11011101;
           rom[ 0+15153] =8'b10001110;
           rom[ 0+15154] =8'b11111000;
           rom[ 0+15155] =8'b01000111;
           rom[ 0+15156] =8'b00100001;
           rom[ 0+15157] =8'b00110110;
           rom[ 0+15158] =8'b10001000;
           rom[ 0+15159] =8'b00001001;
           rom[ 0+15160] =8'b11011101;
           rom[ 0+15161] =8'b01110101;
           rom[ 0+15162] =8'b11110101;
           rom[ 0+15163] =8'b11011101;
           rom[ 0+15164] =8'b01110100;
           rom[ 0+15165] =8'b11110110;
           rom[ 0+15166] =8'b01111110;
           rom[ 0+15167] =8'b11011101;
           rom[ 0+15168] =8'b01110111;
           rom[ 0+15169] =8'b11110100;
           rom[ 0+15170] =8'b11011101;
           rom[ 0+15171] =8'b01111110;
           rom[ 0+15172] =8'b11110010;
           rom[ 0+15173] =8'b11000110;
           rom[ 0+15174] =8'b00001010;
           rom[ 0+15175] =8'b01000111;
           rom[ 0+15176] =8'b11011101;
           rom[ 0+15177] =8'b01111110;
           rom[ 0+15178] =8'b11110011;
           rom[ 0+15179] =8'b11001110;
           rom[ 0+15180] =8'b00000000;
           rom[ 0+15181] =8'b01001111;
           rom[ 0+15182] =8'b01101000;
           rom[ 0+15183] =8'b01100001;
           rom[ 0+15184] =8'b01000110;
           rom[ 0+15185] =8'b11011101;
           rom[ 0+15186] =8'b01111110;
           rom[ 0+15187] =8'b11110100;
           rom[ 0+15188] =8'b10101000;
           rom[ 0+15189] =8'b11011101;
           rom[ 0+15190] =8'b01101110;
           rom[ 0+15191] =8'b11110101;
           rom[ 0+15192] =8'b11011101;
           rom[ 0+15193] =8'b01100110;
           rom[ 0+15194] =8'b11110110;
           rom[ 0+15195] =8'b01110111;
           rom[ 0+15196] =8'b11011101;
           rom[ 0+15197] =8'b01111110;
           rom[ 0+15198] =8'b11110010;
           rom[ 0+15199] =8'b11000110;
           rom[ 0+15200] =8'b00000110;
           rom[ 0+15201] =8'b01001111;
           rom[ 0+15202] =8'b11011101;
           rom[ 0+15203] =8'b01111110;
           rom[ 0+15204] =8'b11110011;
           rom[ 0+15205] =8'b11001110;
           rom[ 0+15206] =8'b00000000;
           rom[ 0+15207] =8'b01000111;
           rom[ 0+15208] =8'b01101001;
           rom[ 0+15209] =8'b01100000;
           rom[ 0+15210] =8'b01001110;
           rom[ 0+15211] =8'b00100011;
           rom[ 0+15212] =8'b01000110;
           rom[ 0+15213] =8'b00001011;
           rom[ 0+15214] =8'b11010101;
           rom[ 0+15215] =8'b01011001;
           rom[ 0+15216] =8'b01010000;
           rom[ 0+15217] =8'b01101011;
           rom[ 0+15218] =8'b01100010;
           rom[ 0+15219] =8'b00101001;
           rom[ 0+15220] =8'b00101001;
           rom[ 0+15221] =8'b00011001;
           rom[ 0+15222] =8'b11010001;
           rom[ 0+15223] =8'b01001101;
           rom[ 0+15224] =8'b01000100;
           rom[ 0+15225] =8'b01111001;
           rom[ 0+15226] =8'b11011101;
           rom[ 0+15227] =8'b10000110;
           rom[ 0+15228] =8'b11110111;
           rom[ 0+15229] =8'b01001111;
           rom[ 0+15230] =8'b01111000;
           rom[ 0+15231] =8'b11011101;
           rom[ 0+15232] =8'b10001110;
           rom[ 0+15233] =8'b11111000;
           rom[ 0+15234] =8'b01000111;
           rom[ 0+15235] =8'b00100001;
           rom[ 0+15236] =8'b00110110;
           rom[ 0+15237] =8'b10001000;
           rom[ 0+15238] =8'b00001001;
           rom[ 0+15239] =8'b11011101;
           rom[ 0+15240] =8'b01110101;
           rom[ 0+15241] =8'b11110101;
           rom[ 0+15242] =8'b11011101;
           rom[ 0+15243] =8'b01110100;
           rom[ 0+15244] =8'b11110110;
           rom[ 0+15245] =8'b01111110;
           rom[ 0+15246] =8'b11011101;
           rom[ 0+15247] =8'b01110111;
           rom[ 0+15248] =8'b11110100;
           rom[ 0+15249] =8'b11011101;
           rom[ 0+15250] =8'b01111110;
           rom[ 0+15251] =8'b11110010;
           rom[ 0+15252] =8'b11000110;
           rom[ 0+15253] =8'b00001011;
           rom[ 0+15254] =8'b01000111;
           rom[ 0+15255] =8'b11011101;
           rom[ 0+15256] =8'b01111110;
           rom[ 0+15257] =8'b11110011;
           rom[ 0+15258] =8'b11001110;
           rom[ 0+15259] =8'b00000000;
           rom[ 0+15260] =8'b01001111;
           rom[ 0+15261] =8'b01101000;
           rom[ 0+15262] =8'b01100001;
           rom[ 0+15263] =8'b01000110;
           rom[ 0+15264] =8'b11011101;
           rom[ 0+15265] =8'b01111110;
           rom[ 0+15266] =8'b11110100;
           rom[ 0+15267] =8'b10101000;
           rom[ 0+15268] =8'b11011101;
           rom[ 0+15269] =8'b01101110;
           rom[ 0+15270] =8'b11110101;
           rom[ 0+15271] =8'b11011101;
           rom[ 0+15272] =8'b01100110;
           rom[ 0+15273] =8'b11110110;
           rom[ 0+15274] =8'b01110111;
           rom[ 0+15275] =8'b11011101;
           rom[ 0+15276] =8'b01111110;
           rom[ 0+15277] =8'b11110010;
           rom[ 0+15278] =8'b11000110;
           rom[ 0+15279] =8'b00001000;
           rom[ 0+15280] =8'b01001111;
           rom[ 0+15281] =8'b11011101;
           rom[ 0+15282] =8'b01111110;
           rom[ 0+15283] =8'b11110011;
           rom[ 0+15284] =8'b11001110;
           rom[ 0+15285] =8'b00000000;
           rom[ 0+15286] =8'b01000111;
           rom[ 0+15287] =8'b01101001;
           rom[ 0+15288] =8'b01100000;
           rom[ 0+15289] =8'b01001110;
           rom[ 0+15290] =8'b00100011;
           rom[ 0+15291] =8'b01000110;
           rom[ 0+15292] =8'b00001011;
           rom[ 0+15293] =8'b11010101;
           rom[ 0+15294] =8'b01011001;
           rom[ 0+15295] =8'b01010000;
           rom[ 0+15296] =8'b01101011;
           rom[ 0+15297] =8'b01100010;
           rom[ 0+15298] =8'b00101001;
           rom[ 0+15299] =8'b00101001;
           rom[ 0+15300] =8'b00011001;
           rom[ 0+15301] =8'b11010001;
           rom[ 0+15302] =8'b01001101;
           rom[ 0+15303] =8'b01000100;
           rom[ 0+15304] =8'b01111001;
           rom[ 0+15305] =8'b11011101;
           rom[ 0+15306] =8'b10000110;
           rom[ 0+15307] =8'b11110111;
           rom[ 0+15308] =8'b01001111;
           rom[ 0+15309] =8'b01111000;
           rom[ 0+15310] =8'b11011101;
           rom[ 0+15311] =8'b10001110;
           rom[ 0+15312] =8'b11111000;
           rom[ 0+15313] =8'b01000111;
           rom[ 0+15314] =8'b00100001;
           rom[ 0+15315] =8'b00110110;
           rom[ 0+15316] =8'b10001000;
           rom[ 0+15317] =8'b00001001;
           rom[ 0+15318] =8'b11011101;
           rom[ 0+15319] =8'b01110101;
           rom[ 0+15320] =8'b11110101;
           rom[ 0+15321] =8'b11011101;
           rom[ 0+15322] =8'b01110100;
           rom[ 0+15323] =8'b11110110;
           rom[ 0+15324] =8'b01111110;
           rom[ 0+15325] =8'b11011101;
           rom[ 0+15326] =8'b01110111;
           rom[ 0+15327] =8'b11110100;
           rom[ 0+15328] =8'b11011101;
           rom[ 0+15329] =8'b01111110;
           rom[ 0+15330] =8'b11110010;
           rom[ 0+15331] =8'b11000110;
           rom[ 0+15332] =8'b00001100;
           rom[ 0+15333] =8'b01000111;
           rom[ 0+15334] =8'b11011101;
           rom[ 0+15335] =8'b01111110;
           rom[ 0+15336] =8'b11110011;
           rom[ 0+15337] =8'b11001110;
           rom[ 0+15338] =8'b00000000;
           rom[ 0+15339] =8'b01001111;
           rom[ 0+15340] =8'b01101000;
           rom[ 0+15341] =8'b01100001;
           rom[ 0+15342] =8'b01000110;
           rom[ 0+15343] =8'b11011101;
           rom[ 0+15344] =8'b01111110;
           rom[ 0+15345] =8'b11110100;
           rom[ 0+15346] =8'b10101000;
           rom[ 0+15347] =8'b11011101;
           rom[ 0+15348] =8'b01101110;
           rom[ 0+15349] =8'b11110101;
           rom[ 0+15350] =8'b11011101;
           rom[ 0+15351] =8'b01100110;
           rom[ 0+15352] =8'b11110110;
           rom[ 0+15353] =8'b01110111;
           rom[ 0+15354] =8'b11000011;
           rom[ 0+15355] =8'b00000111;
           rom[ 0+15356] =8'b00111100;
           rom[ 0+15357] =8'b11010101;
           rom[ 0+15358] =8'b00100001;
           rom[ 0+15359] =8'b11101110;
           rom[ 0+15360] =8'b00111101;
           rom[ 0+15361] =8'b11100101;
           rom[ 0+15362] =8'b11001101;
           rom[ 0+15363] =8'b00001010;
           rom[ 0+15364] =8'b00000010;
           rom[ 0+15365] =8'b11110001;
           rom[ 0+15366] =8'b11010001;
           rom[ 0+15367] =8'b11011101;
           rom[ 0+15368] =8'b00110100;
           rom[ 0+15369] =8'b11111100;
           rom[ 0+15370] =8'b11000010;
           rom[ 0+15371] =8'b00010000;
           rom[ 0+15372] =8'b00111100;
           rom[ 0+15373] =8'b11011101;
           rom[ 0+15374] =8'b00110100;
           rom[ 0+15375] =8'b11111101;
           rom[ 0+15376] =8'b11000011;
           rom[ 0+15377] =8'b01111101;
           rom[ 0+15378] =8'b00110111;
           rom[ 0+15379] =8'b00100001;
           rom[ 0+15380] =8'b00000010;
           rom[ 0+15381] =8'b00111110;
           rom[ 0+15382] =8'b11100101;
           rom[ 0+15383] =8'b11001101;
           rom[ 0+15384] =8'b00001010;
           rom[ 0+15385] =8'b00000010;
           rom[ 0+15386] =8'b11110001;
           rom[ 0+15387] =8'b00000001;
           rom[ 0+15388] =8'b00000000;
           rom[ 0+15389] =8'b00000000;
           rom[ 0+15390] =8'b01111001;
           rom[ 0+15391] =8'b11010110;
           rom[ 0+15392] =8'b00101111;
           rom[ 0+15393] =8'b01111000;
           rom[ 0+15394] =8'b11011110;
           rom[ 0+15395] =8'b00000000;
           rom[ 0+15396] =8'b11110010;
           rom[ 0+15397] =8'b00111100;
           rom[ 0+15398] =8'b00111100;
           rom[ 0+15399] =8'b00100001;
           rom[ 0+15400] =8'b00110110;
           rom[ 0+15401] =8'b10001000;
           rom[ 0+15402] =8'b00001001;
           rom[ 0+15403] =8'b01011101;
           rom[ 0+15404] =8'b01010100;
           rom[ 0+15405] =8'b00011010;
           rom[ 0+15406] =8'b01011111;
           rom[ 0+15407] =8'b11000101;
           rom[ 0+15408] =8'b01111011;
           rom[ 0+15409] =8'b11110101;
           rom[ 0+15410] =8'b00110011;
           rom[ 0+15411] =8'b11001101;
           rom[ 0+15412] =8'b10011100;
           rom[ 0+15413] =8'b00010100;
           rom[ 0+15414] =8'b00110011;
           rom[ 0+15415] =8'b11000001;
           rom[ 0+15416] =8'b00000011;
           rom[ 0+15417] =8'b11000011;
           rom[ 0+15418] =8'b00011110;
           rom[ 0+15419] =8'b00111100;
           rom[ 0+15420] =8'b00100001;
           rom[ 0+15421] =8'b00000100;
           rom[ 0+15422] =8'b00111101;
           rom[ 0+15423] =8'b11100101;
           rom[ 0+15424] =8'b11001101;
           rom[ 0+15425] =8'b00001010;
           rom[ 0+15426] =8'b00000010;
           rom[ 0+15427] =8'b11110001;
           rom[ 0+15428] =8'b11001101;
           rom[ 0+15429] =8'b10001010;
           rom[ 0+15430] =8'b00010110;
           rom[ 0+15431] =8'b00100001;
           rom[ 0+15432] =8'b10111101;
           rom[ 0+15433] =8'b00111100;
           rom[ 0+15434] =8'b11100101;
           rom[ 0+15435] =8'b11001101;
           rom[ 0+15436] =8'b00001010;
           rom[ 0+15437] =8'b00000010;
           rom[ 0+15438] =8'b11110001;
           rom[ 0+15439] =8'b00100001;
           rom[ 0+15440] =8'b00011011;
           rom[ 0+15441] =8'b00111110;
           rom[ 0+15442] =8'b11100101;
           rom[ 0+15443] =8'b11001101;
           rom[ 0+15444] =8'b00001010;
           rom[ 0+15445] =8'b00000010;
           rom[ 0+15446] =8'b11110001;
           rom[ 0+15447] =8'b11011101;
           rom[ 0+15448] =8'b11111001;
           rom[ 0+15449] =8'b11011101;
           rom[ 0+15450] =8'b11100001;
           rom[ 0+15451] =8'b11001001;
           rom[ 0+15452] =8'b01010011;
           rom[ 0+15453] =8'b01110100;
           rom[ 0+15454] =8'b01100001;
           rom[ 0+15455] =8'b01110010;
           rom[ 0+15456] =8'b01110100;
           rom[ 0+15457] =8'b00100000;
           rom[ 0+15458] =8'b01010011;
           rom[ 0+15459] =8'b01101001;
           rom[ 0+15460] =8'b01101101;
           rom[ 0+15461] =8'b01110000;
           rom[ 0+15462] =8'b01101100;
           rom[ 0+15463] =8'b01100101;
           rom[ 0+15464] =8'b00100000;
           rom[ 0+15465] =8'b01010010;
           rom[ 0+15466] =8'b01100101;
           rom[ 0+15467] =8'b01100101;
           rom[ 0+15468] =8'b01100100;
           rom[ 0+15469] =8'b00100000;
           rom[ 0+15470] =8'b01010011;
           rom[ 0+15471] =8'b01101111;
           rom[ 0+15472] =8'b01101100;
           rom[ 0+15473] =8'b01101111;
           rom[ 0+15474] =8'b01101101;
           rom[ 0+15475] =8'b01101111;
           rom[ 0+15476] =8'b01101110;
           rom[ 0+15477] =8'b00100000;
           rom[ 0+15478] =8'b01010100;
           rom[ 0+15479] =8'b01100101;
           rom[ 0+15480] =8'b01110011;
           rom[ 0+15481] =8'b01110100;
           rom[ 0+15482] =8'b00100000;
           rom[ 0+15483] =8'b01000010;
           rom[ 0+15484] =8'b01100101;
           rom[ 0+15485] =8'b01101110;
           rom[ 0+15486] =8'b01100011;
           rom[ 0+15487] =8'b01101000;
           rom[ 0+15488] =8'b00100000;
           rom[ 0+15489] =8'b01101111;
           rom[ 0+15490] =8'b01101110;
           rom[ 0+15491] =8'b00100000;
           rom[ 0+15492] =8'b01111010;
           rom[ 0+15493] =8'b00111000;
           rom[ 0+15494] =8'b00110000;
           rom[ 0+15495] =8'b00101110;
           rom[ 0+15496] =8'b00000000;
           rom[ 0+15497] =8'b00100000;
           rom[ 0+15498] =8'b00101000;
           rom[ 0+15499] =8'b01000011;
           rom[ 0+15500] =8'b00101001;
           rom[ 0+15501] =8'b00100000;
           rom[ 0+15502] =8'b01110111;
           rom[ 0+15503] =8'b01110111;
           rom[ 0+15504] =8'b01110111;
           rom[ 0+15505] =8'b00101110;
           rom[ 0+15506] =8'b01110011;
           rom[ 0+15507] =8'b01110101;
           rom[ 0+15508] =8'b01100111;
           rom[ 0+15509] =8'b01100001;
           rom[ 0+15510] =8'b01110111;
           rom[ 0+15511] =8'b01100001;
           rom[ 0+15512] =8'b01110010;
           rom[ 0+15513] =8'b01100001;
           rom[ 0+15514] =8'b00101101;
           rom[ 0+15515] =8'b01110011;
           rom[ 0+15516] =8'b01111001;
           rom[ 0+15517] =8'b01110011;
           rom[ 0+15518] =8'b01110100;
           rom[ 0+15519] =8'b01100101;
           rom[ 0+15520] =8'b01101101;
           rom[ 0+15521] =8'b01110011;
           rom[ 0+15522] =8'b00101110;
           rom[ 0+15523] =8'b01100011;
           rom[ 0+15524] =8'b01101111;
           rom[ 0+15525] =8'b01101101;
           rom[ 0+15526] =8'b00001010;
           rom[ 0+15527] =8'b00000000;
           rom[ 0+15528] =8'b00100000;
           rom[ 0+15529] =8'b01000010;
           rom[ 0+15530] =8'b01110101;
           rom[ 0+15531] =8'b01101001;
           rom[ 0+15532] =8'b01101100;
           rom[ 0+15533] =8'b01100100;
           rom[ 0+15534] =8'b00100000;
           rom[ 0+15535] =8'b01001010;
           rom[ 0+15536] =8'b01100001;
           rom[ 0+15537] =8'b01101110;
           rom[ 0+15538] =8'b00101110;
           rom[ 0+15539] =8'b00110010;
           rom[ 0+15540] =8'b00110011;
           rom[ 0+15541] =8'b00101110;
           rom[ 0+15542] =8'b00110010;
           rom[ 0+15543] =8'b00110000;
           rom[ 0+15544] =8'b00110000;
           rom[ 0+15545] =8'b00110100;
           rom[ 0+15546] =8'b00100000;
           rom[ 0+15547] =8'b00001010;
           rom[ 0+15548] =8'b00000000;
           rom[ 0+15549] =8'b00100100;
           rom[ 0+15550] =8'b01110100;
           rom[ 0+15551] =8'b01101001;
           rom[ 0+15552] =8'b01101101;
           rom[ 0+15553] =8'b01100101;
           rom[ 0+15554] =8'b00000000;
           rom[ 0+15555] =8'b01010011;
           rom[ 0+15556] =8'b01100101;
           rom[ 0+15557] =8'b01100101;
           rom[ 0+15558] =8'b01100100;
           rom[ 0+15559] =8'b00100000;
           rom[ 0+15560] =8'b01000010;
           rom[ 0+15561] =8'b01111001;
           rom[ 0+15562] =8'b01110100;
           rom[ 0+15563] =8'b01100101;
           rom[ 0+15564] =8'b01110011;
           rom[ 0+15565] =8'b00100000;
           rom[ 0+15566] =8'b01001111;
           rom[ 0+15567] =8'b01110101;
           rom[ 0+15568] =8'b01110100;
           rom[ 0+15569] =8'b00100000;
           rom[ 0+15570] =8'b01000100;
           rom[ 0+15571] =8'b01101111;
           rom[ 0+15572] =8'b01101110;
           rom[ 0+15573] =8'b01100101;
           rom[ 0+15574] =8'b00001010;
           rom[ 0+15575] =8'b00000000;
           rom[ 0+15576] =8'b01001111;
           rom[ 0+15577] =8'b01110010;
           rom[ 0+15578] =8'b01101001;
           rom[ 0+15579] =8'b01100111;
           rom[ 0+15580] =8'b01101001;
           rom[ 0+15581] =8'b01101110;
           rom[ 0+15582] =8'b01100001;
           rom[ 0+15583] =8'b01101100;
           rom[ 0+15584] =8'b00100000;
           rom[ 0+15585] =8'b01000100;
           rom[ 0+15586] =8'b01100001;
           rom[ 0+15587] =8'b01110100;
           rom[ 0+15588] =8'b01100001;
           rom[ 0+15589] =8'b00100000;
           rom[ 0+15590] =8'b01100010;
           rom[ 0+15591] =8'b01100101;
           rom[ 0+15592] =8'b01100110;
           rom[ 0+15593] =8'b01101111;
           rom[ 0+15594] =8'b01110010;
           rom[ 0+15595] =8'b01100101;
           rom[ 0+15596] =8'b00100000;
           rom[ 0+15597] =8'b01000101;
           rom[ 0+15598] =8'b01110010;
           rom[ 0+15599] =8'b01110010;
           rom[ 0+15600] =8'b01101111;
           rom[ 0+15601] =8'b01110010;
           rom[ 0+15602] =8'b00100000;
           rom[ 0+15603] =8'b01100101;
           rom[ 0+15604] =8'b01110010;
           rom[ 0+15605] =8'b01110010;
           rom[ 0+15606] =8'b01101111;
           rom[ 0+15607] =8'b01110010;
           rom[ 0+15608] =8'b00100000;
           rom[ 0+15609] =8'b01100001;
           rom[ 0+15610] =8'b01100100;
           rom[ 0+15611] =8'b01100100;
           rom[ 0+15612] =8'b01101001;
           rom[ 0+15613] =8'b01110100;
           rom[ 0+15614] =8'b01101001;
           rom[ 0+15615] =8'b01101111;
           rom[ 0+15616] =8'b01101110;
           rom[ 0+15617] =8'b00100000;
           rom[ 0+15618] =8'b00001010;
           rom[ 0+15619] =8'b00000000;
           rom[ 0+15620] =8'b00001010;
           rom[ 0+15621] =8'b00000000;
           rom[ 0+15622] =8'b01000100;
           rom[ 0+15623] =8'b01100101;
           rom[ 0+15624] =8'b01100011;
           rom[ 0+15625] =8'b01101111;
           rom[ 0+15626] =8'b01100100;
           rom[ 0+15627] =8'b01101001;
           rom[ 0+15628] =8'b01101110;
           rom[ 0+15629] =8'b01100111;
           rom[ 0+15630] =8'b00100000;
           rom[ 0+15631] =8'b00001010;
           rom[ 0+15632] =8'b00000000;
           rom[ 0+15633] =8'b00001010;
           rom[ 0+15634] =8'b00100000;
           rom[ 0+15635] =8'b01010011;
           rom[ 0+15636] =8'b01111001;
           rom[ 0+15637] =8'b01101110;
           rom[ 0+15638] =8'b01100100;
           rom[ 0+15639] =8'b01110010;
           rom[ 0+15640] =8'b01101111;
           rom[ 0+15641] =8'b01101101;
           rom[ 0+15642] =8'b01100101;
           rom[ 0+15643] =8'b00100000;
           rom[ 0+15644] =8'b01000001;
           rom[ 0+15645] =8'b01101110;
           rom[ 0+15646] =8'b01100001;
           rom[ 0+15647] =8'b01101100;
           rom[ 0+15648] =8'b01111001;
           rom[ 0+15649] =8'b01110011;
           rom[ 0+15650] =8'b01101001;
           rom[ 0+15651] =8'b01110011;
           rom[ 0+15652] =8'b00100000;
           rom[ 0+15653] =8'b01100010;
           rom[ 0+15654] =8'b01100101;
           rom[ 0+15655] =8'b01100111;
           rom[ 0+15656] =8'b01101001;
           rom[ 0+15657] =8'b01101110;
           rom[ 0+15658] =8'b01110011;
           rom[ 0+15659] =8'b00101110;
           rom[ 0+15660] =8'b00101110;
           rom[ 0+15661] =8'b00000000;
           rom[ 0+15662] =8'b01000011;
           rom[ 0+15663] =8'b00110001;
           rom[ 0+15664] =8'b00100000;
           rom[ 0+15665] =8'b01000011;
           rom[ 0+15666] =8'b01101111;
           rom[ 0+15667] =8'b01110010;
           rom[ 0+15668] =8'b01110010;
           rom[ 0+15669] =8'b01100101;
           rom[ 0+15670] =8'b01100011;
           rom[ 0+15671] =8'b01110100;
           rom[ 0+15672] =8'b01101001;
           rom[ 0+15673] =8'b01101111;
           rom[ 0+15674] =8'b01101110;
           rom[ 0+15675] =8'b00100000;
           rom[ 0+15676] =8'b01010010;
           rom[ 0+15677] =8'b01100101;
           rom[ 0+15678] =8'b01110011;
           rom[ 0+15679] =8'b01110101;
           rom[ 0+15680] =8'b01101100;
           rom[ 0+15681] =8'b01110100;
           rom[ 0+15682] =8'b00001010;
           rom[ 0+15683] =8'b00000000;
           rom[ 0+15684] =8'b01001001;
           rom[ 0+15685] =8'b01101110;
           rom[ 0+15686] =8'b01110100;
           rom[ 0+15687] =8'b01100101;
           rom[ 0+15688] =8'b01110010;
           rom[ 0+15689] =8'b01101100;
           rom[ 0+15690] =8'b01100101;
           rom[ 0+15691] =8'b01100001;
           rom[ 0+15692] =8'b01110110;
           rom[ 0+15693] =8'b01100101;
           rom[ 0+15694] =8'b00111101;
           rom[ 0+15695] =8'b00100000;
           rom[ 0+15696] =8'b00111010;
           rom[ 0+15697] =8'b00100000;
           rom[ 0+15698] =8'b00100000;
           rom[ 0+15699] =8'b00000000;
           rom[ 0+15700] =8'b00001001;
           rom[ 0+15701] =8'b00000000;
           rom[ 0+15702] =8'b01001110;
           rom[ 0+15703] =8'b01101111;
           rom[ 0+15704] =8'b00100000;
           rom[ 0+15705] =8'b01000101;
           rom[ 0+15706] =8'b01110010;
           rom[ 0+15707] =8'b01110010;
           rom[ 0+15708] =8'b01101111;
           rom[ 0+15709] =8'b01110010;
           rom[ 0+15710] =8'b00100000;
           rom[ 0+15711] =8'b01000100;
           rom[ 0+15712] =8'b01100101;
           rom[ 0+15713] =8'b01110100;
           rom[ 0+15714] =8'b01100101;
           rom[ 0+15715] =8'b01100011;
           rom[ 0+15716] =8'b01110100;
           rom[ 0+15717] =8'b01100101;
           rom[ 0+15718] =8'b01100100;
           rom[ 0+15719] =8'b00101110;
           rom[ 0+15720] =8'b00001010;
           rom[ 0+15721] =8'b00000000;
           rom[ 0+15722] =8'b01010011;
           rom[ 0+15723] =8'b01101001;
           rom[ 0+15724] =8'b01101110;
           rom[ 0+15725] =8'b01100111;
           rom[ 0+15726] =8'b01101100;
           rom[ 0+15727] =8'b01100101;
           rom[ 0+15728] =8'b00100000;
           rom[ 0+15729] =8'b01000101;
           rom[ 0+15730] =8'b01110010;
           rom[ 0+15731] =8'b01110010;
           rom[ 0+15732] =8'b01101111;
           rom[ 0+15733] =8'b01110010;
           rom[ 0+15734] =8'b00100000;
           rom[ 0+15735] =8'b01000100;
           rom[ 0+15736] =8'b01100101;
           rom[ 0+15737] =8'b01110100;
           rom[ 0+15738] =8'b01100101;
           rom[ 0+15739] =8'b01100011;
           rom[ 0+15740] =8'b01110100;
           rom[ 0+15741] =8'b01100101;
           rom[ 0+15742] =8'b01100100;
           rom[ 0+15743] =8'b00101110;
           rom[ 0+15744] =8'b00001010;
           rom[ 0+15745] =8'b00000000;
           rom[ 0+15746] =8'b00001001;
           rom[ 0+15747] =8'b00001001;
           rom[ 0+15748] =8'b00001001;
           rom[ 0+15749] =8'b01000101;
           rom[ 0+15750] =8'b01110010;
           rom[ 0+15751] =8'b01110010;
           rom[ 0+15752] =8'b01101111;
           rom[ 0+15753] =8'b01110010;
           rom[ 0+15754] =8'b00100000;
           rom[ 0+15755] =8'b01010000;
           rom[ 0+15756] =8'b01101111;
           rom[ 0+15757] =8'b01110011;
           rom[ 0+15758] =8'b01101001;
           rom[ 0+15759] =8'b01110100;
           rom[ 0+15760] =8'b01101001;
           rom[ 0+15761] =8'b01101111;
           rom[ 0+15762] =8'b01101110;
           rom[ 0+15763] =8'b00111101;
           rom[ 0+15764] =8'b00000000;
           rom[ 0+15765] =8'b00001010;
           rom[ 0+15766] =8'b00001001;
           rom[ 0+15767] =8'b00001001;
           rom[ 0+15768] =8'b00001001;
           rom[ 0+15769] =8'b01000101;
           rom[ 0+15770] =8'b01110010;
           rom[ 0+15771] =8'b01110010;
           rom[ 0+15772] =8'b01101111;
           rom[ 0+15773] =8'b01110010;
           rom[ 0+15774] =8'b00100000;
           rom[ 0+15775] =8'b01010110;
           rom[ 0+15776] =8'b01100001;
           rom[ 0+15777] =8'b01101100;
           rom[ 0+15778] =8'b01110101;
           rom[ 0+15779] =8'b01100101;
           rom[ 0+15780] =8'b00100000;
           rom[ 0+15781] =8'b00100000;
           rom[ 0+15782] =8'b00100000;
           rom[ 0+15783] =8'b00111101;
           rom[ 0+15784] =8'b00000000;
           rom[ 0+15785] =8'b01000100;
           rom[ 0+15786] =8'b01101111;
           rom[ 0+15787] =8'b01110101;
           rom[ 0+15788] =8'b01100010;
           rom[ 0+15789] =8'b01101100;
           rom[ 0+15790] =8'b01100101;
           rom[ 0+15791] =8'b00100000;
           rom[ 0+15792] =8'b01000101;
           rom[ 0+15793] =8'b01110010;
           rom[ 0+15794] =8'b01110010;
           rom[ 0+15795] =8'b01101111;
           rom[ 0+15796] =8'b01110010;
           rom[ 0+15797] =8'b00100000;
           rom[ 0+15798] =8'b01000100;
           rom[ 0+15799] =8'b01100101;
           rom[ 0+15800] =8'b01110100;
           rom[ 0+15801] =8'b01100101;
           rom[ 0+15802] =8'b01100011;
           rom[ 0+15803] =8'b01110100;
           rom[ 0+15804] =8'b01100101;
           rom[ 0+15805] =8'b01100100;
           rom[ 0+15806] =8'b00101110;
           rom[ 0+15807] =8'b00001010;
           rom[ 0+15808] =8'b00000000;
           rom[ 0+15809] =8'b00001010;
           rom[ 0+15810] =8'b00001001;
           rom[ 0+15811] =8'b00001001;
           rom[ 0+15812] =8'b00001001;
           rom[ 0+15813] =8'b01000101;
           rom[ 0+15814] =8'b01110010;
           rom[ 0+15815] =8'b01110010;
           rom[ 0+15816] =8'b01101111;
           rom[ 0+15817] =8'b01110010;
           rom[ 0+15818] =8'b00100000;
           rom[ 0+15819] =8'b01010000;
           rom[ 0+15820] =8'b01101111;
           rom[ 0+15821] =8'b01110011;
           rom[ 0+15822] =8'b01101001;
           rom[ 0+15823] =8'b01110100;
           rom[ 0+15824] =8'b01101001;
           rom[ 0+15825] =8'b01101111;
           rom[ 0+15826] =8'b01101110;
           rom[ 0+15827] =8'b00111101;
           rom[ 0+15828] =8'b00000000;
           rom[ 0+15829] =8'b01010100;
           rom[ 0+15830] =8'b01110010;
           rom[ 0+15831] =8'b01101001;
           rom[ 0+15832] =8'b01110000;
           rom[ 0+15833] =8'b01110000;
           rom[ 0+15834] =8'b01101100;
           rom[ 0+15835] =8'b01100101;
           rom[ 0+15836] =8'b00100000;
           rom[ 0+15837] =8'b01000101;
           rom[ 0+15838] =8'b01110010;
           rom[ 0+15839] =8'b01110010;
           rom[ 0+15840] =8'b01101111;
           rom[ 0+15841] =8'b01110010;
           rom[ 0+15842] =8'b00100000;
           rom[ 0+15843] =8'b01000100;
           rom[ 0+15844] =8'b01100101;
           rom[ 0+15845] =8'b01110100;
           rom[ 0+15846] =8'b01100101;
           rom[ 0+15847] =8'b01100011;
           rom[ 0+15848] =8'b01110100;
           rom[ 0+15849] =8'b01100101;
           rom[ 0+15850] =8'b01100100;
           rom[ 0+15851] =8'b00101110;
           rom[ 0+15852] =8'b00001010;
           rom[ 0+15853] =8'b00000000;
           rom[ 0+15854] =8'b01010101;
           rom[ 0+15855] =8'b01101110;
           rom[ 0+15856] =8'b01100011;
           rom[ 0+15857] =8'b01101111;
           rom[ 0+15858] =8'b01110010;
           rom[ 0+15859] =8'b01110010;
           rom[ 0+15860] =8'b01100101;
           rom[ 0+15861] =8'b01100011;
           rom[ 0+15862] =8'b01110100;
           rom[ 0+15863] =8'b01100001;
           rom[ 0+15864] =8'b01100010;
           rom[ 0+15865] =8'b01101100;
           rom[ 0+15866] =8'b01100101;
           rom[ 0+15867] =8'b00100000;
           rom[ 0+15868] =8'b01000101;
           rom[ 0+15869] =8'b01110010;
           rom[ 0+15870] =8'b01110010;
           rom[ 0+15871] =8'b01101111;
           rom[ 0+15872] =8'b01110010;
           rom[ 0+15873] =8'b00000000;
           rom[ 0+15874] =8'b01000001;
           rom[ 0+15875] =8'b01100110;
           rom[ 0+15876] =8'b01110100;
           rom[ 0+15877] =8'b01100101;
           rom[ 0+15878] =8'b01110010;
           rom[ 0+15879] =8'b00100000;
           rom[ 0+15880] =8'b01000011;
           rom[ 0+15881] =8'b01101111;
           rom[ 0+15882] =8'b01110010;
           rom[ 0+15883] =8'b01110010;
           rom[ 0+15884] =8'b01100101;
           rom[ 0+15885] =8'b01100011;
           rom[ 0+15886] =8'b01110100;
           rom[ 0+15887] =8'b01101001;
           rom[ 0+15888] =8'b01101110;
           rom[ 0+15889] =8'b01100111;
           rom[ 0+15890] =8'b00100000;
           rom[ 0+15891] =8'b01000101;
           rom[ 0+15892] =8'b01110010;
           rom[ 0+15893] =8'b01110010;
           rom[ 0+15894] =8'b01101111;
           rom[ 0+15895] =8'b01110010;
           rom[ 0+15896] =8'b01110011;
           rom[ 0+15897] =8'b00001010;
           rom[ 0+15898] =8'b00000000;
           rom[ 0+15899] =8'b00100100;
           rom[ 0+15900] =8'b01100110;
           rom[ 0+15901] =8'b01101001;
           rom[ 0+15902] =8'b01101110;
           rom[ 0+15903] =8'b01101001;
           rom[ 0+15904] =8'b01110011;
           rom[ 0+15905] =8'b01101000;
           rom[ 0+15906] =8'b00000000;
           rom[ 0+15907] =8'b00100001;
           rom[ 0+15908] =8'b00000011;
           rom[ 0+15909] =8'b00000000;
           rom[ 0+15910] =8'b00111001;
           rom[ 0+15911] =8'b01011110;
           rom[ 0+15912] =8'b00101011;
           rom[ 0+15913] =8'b01101110;
           rom[ 0+15914] =8'b01001101;
           rom[ 0+15915] =8'b11001101;
           rom[ 0+15916] =8'b10101011;
           rom[ 0+15917] =8'b00111110;
           rom[ 0+15918] =8'b01101001;
           rom[ 0+15919] =8'b01100000;
           rom[ 0+15920] =8'b11001001;
           rom[ 0+15921] =8'b00100001;
           rom[ 0+15922] =8'b00000011;
           rom[ 0+15923] =8'b00000000;
           rom[ 0+15924] =8'b00111001;
           rom[ 0+15925] =8'b01011110;
           rom[ 0+15926] =8'b00101011;
           rom[ 0+15927] =8'b01101110;
           rom[ 0+15928] =8'b01001101;
           rom[ 0+15929] =8'b11001101;
           rom[ 0+15930] =8'b10101011;
           rom[ 0+15931] =8'b00111110;
           rom[ 0+15932] =8'b01101011;
           rom[ 0+15933] =8'b01100010;
           rom[ 0+15934] =8'b11001001;
           rom[ 0+15935] =8'b00100001;
           rom[ 0+15936] =8'b00000101;
           rom[ 0+15937] =8'b00000000;
           rom[ 0+15938] =8'b00111001;
           rom[ 0+15939] =8'b01010110;
           rom[ 0+15940] =8'b00101011;
           rom[ 0+15941] =8'b01011110;
           rom[ 0+15942] =8'b00101011;
           rom[ 0+15943] =8'b01111110;
           rom[ 0+15944] =8'b00101011;
           rom[ 0+15945] =8'b01101110;
           rom[ 0+15946] =8'b01100111;
           rom[ 0+15947] =8'b01000100;
           rom[ 0+15948] =8'b01001101;
           rom[ 0+15949] =8'b11001101;
           rom[ 0+15950] =8'b10110011;
           rom[ 0+15951] =8'b00111110;
           rom[ 0+15952] =8'b01101001;
           rom[ 0+15953] =8'b01100000;
           rom[ 0+15954] =8'b11001001;
           rom[ 0+15955] =8'b00100001;
           rom[ 0+15956] =8'b00000101;
           rom[ 0+15957] =8'b00000000;
           rom[ 0+15958] =8'b00111001;
           rom[ 0+15959] =8'b01010110;
           rom[ 0+15960] =8'b00101011;
           rom[ 0+15961] =8'b01011110;
           rom[ 0+15962] =8'b00101011;
           rom[ 0+15963] =8'b01111110;
           rom[ 0+15964] =8'b00101011;
           rom[ 0+15965] =8'b01101110;
           rom[ 0+15966] =8'b01100111;
           rom[ 0+15967] =8'b01000100;
           rom[ 0+15968] =8'b01001101;
           rom[ 0+15969] =8'b11001101;
           rom[ 0+15970] =8'b10110011;
           rom[ 0+15971] =8'b00111110;
           rom[ 0+15972] =8'b01101011;
           rom[ 0+15973] =8'b01100010;
           rom[ 0+15974] =8'b11001001;
           rom[ 0+15975] =8'b00100001;
           rom[ 0+15976] =8'b00000011;
           rom[ 0+15977] =8'b00000000;
           rom[ 0+15978] =8'b00111001;
           rom[ 0+15979] =8'b01011110;
           rom[ 0+15980] =8'b00101011;
           rom[ 0+15981] =8'b01101110;
           rom[ 0+15982] =8'b01001101;
           rom[ 0+15983] =8'b11001101;
           rom[ 0+15984] =8'b11110000;
           rom[ 0+15985] =8'b00111110;
           rom[ 0+15986] =8'b01101001;
           rom[ 0+15987] =8'b01100000;
           rom[ 0+15988] =8'b11001001;
           rom[ 0+15989] =8'b00100001;
           rom[ 0+15990] =8'b00000011;
           rom[ 0+15991] =8'b00000000;
           rom[ 0+15992] =8'b00111001;
           rom[ 0+15993] =8'b01011110;
           rom[ 0+15994] =8'b00101011;
           rom[ 0+15995] =8'b01101110;
           rom[ 0+15996] =8'b01001101;
           rom[ 0+15997] =8'b11001101;
           rom[ 0+15998] =8'b11110000;
           rom[ 0+15999] =8'b00111110;
           rom[ 0+16000] =8'b01101011;
           rom[ 0+16001] =8'b01100010;
           rom[ 0+16002] =8'b11001001;
           rom[ 0+16003] =8'b00100001;
           rom[ 0+16004] =8'b00000101;
           rom[ 0+16005] =8'b00000000;
           rom[ 0+16006] =8'b00111001;
           rom[ 0+16007] =8'b01010110;
           rom[ 0+16008] =8'b00101011;
           rom[ 0+16009] =8'b01011110;
           rom[ 0+16010] =8'b00101011;
           rom[ 0+16011] =8'b01111110;
           rom[ 0+16012] =8'b00101011;
           rom[ 0+16013] =8'b01101110;
           rom[ 0+16014] =8'b01100111;
           rom[ 0+16015] =8'b01000100;
           rom[ 0+16016] =8'b01001101;
           rom[ 0+16017] =8'b11001101;
           rom[ 0+16018] =8'b11110011;
           rom[ 0+16019] =8'b00111110;
           rom[ 0+16020] =8'b01101001;
           rom[ 0+16021] =8'b01100000;
           rom[ 0+16022] =8'b11001001;
           rom[ 0+16023] =8'b00100001;
           rom[ 0+16024] =8'b00000101;
           rom[ 0+16025] =8'b00000000;
           rom[ 0+16026] =8'b00111001;
           rom[ 0+16027] =8'b01010110;
           rom[ 0+16028] =8'b00101011;
           rom[ 0+16029] =8'b01011110;
           rom[ 0+16030] =8'b00101011;
           rom[ 0+16031] =8'b01111110;
           rom[ 0+16032] =8'b00101011;
           rom[ 0+16033] =8'b01101110;
           rom[ 0+16034] =8'b01100111;
           rom[ 0+16035] =8'b01000100;
           rom[ 0+16036] =8'b01001101;
           rom[ 0+16037] =8'b11001101;
           rom[ 0+16038] =8'b11110011;
           rom[ 0+16039] =8'b00111110;
           rom[ 0+16040] =8'b01101011;
           rom[ 0+16041] =8'b01100010;
           rom[ 0+16042] =8'b11001001;
           rom[ 0+16043] =8'b01111001;
           rom[ 0+16044] =8'b00000111;
           rom[ 0+16045] =8'b10011111;
           rom[ 0+16046] =8'b01000111;
           rom[ 0+16047] =8'b01111011;
           rom[ 0+16048] =8'b00000111;
           rom[ 0+16049] =8'b10011111;
           rom[ 0+16050] =8'b01010111;
           rom[ 0+16051] =8'b01111000;
           rom[ 0+16052] =8'b00110010;
           rom[ 0+16053] =8'b00110100;
           rom[ 0+16054] =8'b10010000;
           rom[ 0+16055] =8'b10101010;
           rom[ 0+16056] =8'b00110010;
           rom[ 0+16057] =8'b00110101;
           rom[ 0+16058] =8'b10010000;
           rom[ 0+16059] =8'b11001011;
           rom[ 0+16060] =8'b01111010;
           rom[ 0+16061] =8'b11001010;
           rom[ 0+16062] =8'b11000110;
           rom[ 0+16063] =8'b00111110;
           rom[ 0+16064] =8'b10010111;
           rom[ 0+16065] =8'b10010011;
           rom[ 0+16066] =8'b01011111;
           rom[ 0+16067] =8'b10011111;
           rom[ 0+16068] =8'b10010010;
           rom[ 0+16069] =8'b01010111;
           rom[ 0+16070] =8'b11001011;
           rom[ 0+16071] =8'b01111000;
           rom[ 0+16072] =8'b11001010;
           rom[ 0+16073] =8'b11010001;
           rom[ 0+16074] =8'b00111110;
           rom[ 0+16075] =8'b10010111;
           rom[ 0+16076] =8'b10010001;
           rom[ 0+16077] =8'b01001111;
           rom[ 0+16078] =8'b10011111;
           rom[ 0+16079] =8'b10010000;
           rom[ 0+16080] =8'b01000111;
           rom[ 0+16081] =8'b11001101;
           rom[ 0+16082] =8'b11110011;
           rom[ 0+16083] =8'b00111110;
           rom[ 0+16084] =8'b11011000;
           rom[ 0+16085] =8'b00111010;
           rom[ 0+16086] =8'b00110101;
           rom[ 0+16087] =8'b10010000;
           rom[ 0+16088] =8'b11100110;
           rom[ 0+16089] =8'b10000000;
           rom[ 0+16090] =8'b11001010;
           rom[ 0+16091] =8'b11100011;
           rom[ 0+16092] =8'b00111110;
           rom[ 0+16093] =8'b10010111;
           rom[ 0+16094] =8'b10010001;
           rom[ 0+16095] =8'b01001111;
           rom[ 0+16096] =8'b10011111;
           rom[ 0+16097] =8'b10010000;
           rom[ 0+16098] =8'b01000111;
           rom[ 0+16099] =8'b00111010;
           rom[ 0+16100] =8'b00110100;
           rom[ 0+16101] =8'b10010000;
           rom[ 0+16102] =8'b11100110;
           rom[ 0+16103] =8'b10000000;
           rom[ 0+16104] =8'b11001000;
           rom[ 0+16105] =8'b10010111;
           rom[ 0+16106] =8'b10010011;
           rom[ 0+16107] =8'b01011111;
           rom[ 0+16108] =8'b10011111;
           rom[ 0+16109] =8'b10010010;
           rom[ 0+16110] =8'b01010111;
           rom[ 0+16111] =8'b11001001;
           rom[ 0+16112] =8'b00000110;
           rom[ 0+16113] =8'b00000000;
           rom[ 0+16114] =8'b01010000;
           rom[ 0+16115] =8'b01111011;
           rom[ 0+16116] =8'b10110010;
           rom[ 0+16117] =8'b11000010;
           rom[ 0+16118] =8'b11111111;
           rom[ 0+16119] =8'b00111110;
           rom[ 0+16120] =8'b00000001;
           rom[ 0+16121] =8'b00000000;
           rom[ 0+16122] =8'b00000000;
           rom[ 0+16123] =8'b01010000;
           rom[ 0+16124] =8'b01011001;
           rom[ 0+16125] =8'b00110111;
           rom[ 0+16126] =8'b11001001;
           rom[ 0+16127] =8'b00100001;
           rom[ 0+16128] =8'b00000000;
           rom[ 0+16129] =8'b00000000;
           rom[ 0+16130] =8'b10110111;
           rom[ 0+16131] =8'b00001000;
           rom[ 0+16132] =8'b00111110;
           rom[ 0+16133] =8'b00010000;
           rom[ 0+16134] =8'b00001000;
           rom[ 0+16135] =8'b11001011;
           rom[ 0+16136] =8'b00010001;
           rom[ 0+16137] =8'b11001011;
           rom[ 0+16138] =8'b00010000;
           rom[ 0+16139] =8'b11101101;
           rom[ 0+16140] =8'b01101010;
           rom[ 0+16141] =8'b11100101;
           rom[ 0+16142] =8'b11101101;
           rom[ 0+16143] =8'b01010010;
           rom[ 0+16144] =8'b00111111;
           rom[ 0+16145] =8'b11011010;
           rom[ 0+16146] =8'b00011000;
           rom[ 0+16147] =8'b00111111;
           rom[ 0+16148] =8'b11100001;
           rom[ 0+16149] =8'b11000011;
           rom[ 0+16150] =8'b00011010;
           rom[ 0+16151] =8'b00111111;
           rom[ 0+16152] =8'b00110011;
           rom[ 0+16153] =8'b00110011;
           rom[ 0+16154] =8'b00001000;
           rom[ 0+16155] =8'b00111101;
           rom[ 0+16156] =8'b11000010;
           rom[ 0+16157] =8'b00000110;
           rom[ 0+16158] =8'b00111111;
           rom[ 0+16159] =8'b00001000;
           rom[ 0+16160] =8'b01010100;
           rom[ 0+16161] =8'b01011101;
           rom[ 0+16162] =8'b11001011;
           rom[ 0+16163] =8'b00010001;
           rom[ 0+16164] =8'b11001011;
           rom[ 0+16165] =8'b00010000;
           rom[ 0+16166] =8'b10110111;
           rom[ 0+16167] =8'b11001001;
           rom[ 0+16168] =8'b00100001;
           rom[ 0+16169] =8'b00000110;
           rom[ 0+16170] =8'b00000000;
           rom[ 0+16171] =8'b00111001;
           rom[ 0+16172] =8'b01001110;
           rom[ 0+16173] =8'b00101011;
           rom[ 0+16174] =8'b01010110;
           rom[ 0+16175] =8'b00101011;
           rom[ 0+16176] =8'b01011110;
           rom[ 0+16177] =8'b00101011;
           rom[ 0+16178] =8'b01111110;
           rom[ 0+16179] =8'b00101011;
           rom[ 0+16180] =8'b01101110;
           rom[ 0+16181] =8'b01100111;
           rom[ 0+16182] =8'b01111001;
           rom[ 0+16183] =8'b10110111;
           rom[ 0+16184] =8'b11001000;
           rom[ 0+16185] =8'b11001011;
           rom[ 0+16186] =8'b00011010;
           rom[ 0+16187] =8'b11001011;
           rom[ 0+16188] =8'b00011011;
           rom[ 0+16189] =8'b11001011;
           rom[ 0+16190] =8'b00011100;
           rom[ 0+16191] =8'b11001011;
           rom[ 0+16192] =8'b00011101;
           rom[ 0+16193] =8'b00111101;
           rom[ 0+16194] =8'b11000011;
           rom[ 0+16195] =8'b00110111;
           rom[ 0+16196] =8'b00111111;
           rom[ 0+16197] =8'b00100001;
           rom[ 0+16198] =8'b00000110;
           rom[ 0+16199] =8'b00000000;
           rom[ 0+16200] =8'b00111001;
           rom[ 0+16201] =8'b01001110;
           rom[ 0+16202] =8'b00101011;
           rom[ 0+16203] =8'b01010110;
           rom[ 0+16204] =8'b00101011;
           rom[ 0+16205] =8'b01011110;
           rom[ 0+16206] =8'b00101011;
           rom[ 0+16207] =8'b01111110;
           rom[ 0+16208] =8'b00101011;
           rom[ 0+16209] =8'b01101110;
           rom[ 0+16210] =8'b01100111;
           rom[ 0+16211] =8'b01111001;
           rom[ 0+16212] =8'b10110111;
           rom[ 0+16213] =8'b11001000;
           rom[ 0+16214] =8'b11001011;
           rom[ 0+16215] =8'b00101010;
           rom[ 0+16216] =8'b11001011;
           rom[ 0+16217] =8'b00011011;
           rom[ 0+16218] =8'b11001011;
           rom[ 0+16219] =8'b00011100;
           rom[ 0+16220] =8'b11001011;
           rom[ 0+16221] =8'b00011101;
           rom[ 0+16222] =8'b00111101;
           rom[ 0+16223] =8'b11000011;
           rom[ 0+16224] =8'b01010100;
           rom[ 0+16225] =8'b00111111;
           rom[ 0+16226] =8'b00100001;
           rom[ 0+16227] =8'b00000110;
           rom[ 0+16228] =8'b00000000;
           rom[ 0+16229] =8'b00111001;
           rom[ 0+16230] =8'b01001110;
           rom[ 0+16231] =8'b00101011;
           rom[ 0+16232] =8'b01010110;
           rom[ 0+16233] =8'b00101011;
           rom[ 0+16234] =8'b01011110;
           rom[ 0+16235] =8'b00101011;
           rom[ 0+16236] =8'b01111110;
           rom[ 0+16237] =8'b00101011;
           rom[ 0+16238] =8'b01101110;
           rom[ 0+16239] =8'b01100111;
           rom[ 0+16240] =8'b01111001;
           rom[ 0+16241] =8'b10110111;
           rom[ 0+16242] =8'b11001000;
           rom[ 0+16243] =8'b11001011;
           rom[ 0+16244] =8'b00010101;
           rom[ 0+16245] =8'b11001011;
           rom[ 0+16246] =8'b00010100;
           rom[ 0+16247] =8'b11001011;
           rom[ 0+16248] =8'b00010011;
           rom[ 0+16249] =8'b11001011;
           rom[ 0+16250] =8'b00010010;
           rom[ 0+16251] =8'b00111101;
           rom[ 0+16252] =8'b11000011;
           rom[ 0+16253] =8'b01110001;
           rom[ 0+16254] =8'b00111111;
           rom[ 0+16255] =8'b10101111;
           rom[ 0+16256] =8'b11111101;
           rom[ 0+16257] =8'b00100001;
           rom[ 0+16258] =8'b00101110;
           rom[ 0+16259] =8'b10010000;
           rom[ 0+16260] =8'b11111101;
           rom[ 0+16261] =8'b01110111;
           rom[ 0+16262] =8'b00000000;
           rom[ 0+16263] =8'b11111101;
           rom[ 0+16264] =8'b01110111;
           rom[ 0+16265] =8'b00000001;
           rom[ 0+16266] =8'b11111101;
           rom[ 0+16267] =8'b01110111;
           rom[ 0+16268] =8'b00000010;
           rom[ 0+16269] =8'b11111101;
           rom[ 0+16270] =8'b01110111;
           rom[ 0+16271] =8'b00000011;
           rom[ 0+16272] =8'b11001001;
           rom[ 0+16273] =8'bxxxxxxxx;
           rom[ 0+16274] =8'bxxxxxxxx;
           rom[ 0+16275] =8'bxxxxxxxx;
           rom[ 0+16276] =8'bxxxxxxxx;
           rom[ 0+16277] =8'bxxxxxxxx;
           rom[ 0+16278] =8'bxxxxxxxx;
           rom[ 0+16279] =8'bxxxxxxxx;
           rom[ 0+16280] =8'bxxxxxxxx;
           rom[ 0+16281] =8'bxxxxxxxx;
           rom[ 0+16282] =8'bxxxxxxxx;
           rom[ 0+16283] =8'bxxxxxxxx;
           rom[ 0+16284] =8'bxxxxxxxx;
           rom[ 0+16285] =8'bxxxxxxxx;
           rom[ 0+16286] =8'bxxxxxxxx;
           rom[ 0+16287] =8'bxxxxxxxx;
           rom[ 0+16288] =8'bxxxxxxxx;
           rom[ 0+16289] =8'bxxxxxxxx;
           rom[ 0+16290] =8'bxxxxxxxx;
           rom[ 0+16291] =8'bxxxxxxxx;
           rom[ 0+16292] =8'bxxxxxxxx;
           rom[ 0+16293] =8'bxxxxxxxx;
           rom[ 0+16294] =8'bxxxxxxxx;
           rom[ 0+16295] =8'bxxxxxxxx;
           rom[ 0+16296] =8'bxxxxxxxx;
           rom[ 0+16297] =8'bxxxxxxxx;
           rom[ 0+16298] =8'bxxxxxxxx;
           rom[ 0+16299] =8'bxxxxxxxx;
           rom[ 0+16300] =8'bxxxxxxxx;
           rom[ 0+16301] =8'bxxxxxxxx;
           rom[ 0+16302] =8'bxxxxxxxx;
           rom[ 0+16303] =8'bxxxxxxxx;
           rom[ 0+16304] =8'bxxxxxxxx;
           rom[ 0+16305] =8'bxxxxxxxx;
           rom[ 0+16306] =8'bxxxxxxxx;
           rom[ 0+16307] =8'bxxxxxxxx;
           rom[ 0+16308] =8'bxxxxxxxx;
           rom[ 0+16309] =8'bxxxxxxxx;
           rom[ 0+16310] =8'bxxxxxxxx;
           rom[ 0+16311] =8'bxxxxxxxx;
           rom[ 0+16312] =8'bxxxxxxxx;
           rom[ 0+16313] =8'bxxxxxxxx;
           rom[ 0+16314] =8'bxxxxxxxx;
           rom[ 0+16315] =8'bxxxxxxxx;
           rom[ 0+16316] =8'bxxxxxxxx;
           rom[ 0+16317] =8'bxxxxxxxx;
           rom[ 0+16318] =8'bxxxxxxxx;
           rom[ 0+16319] =8'bxxxxxxxx;
           rom[ 0+16320] =8'bxxxxxxxx;
           rom[ 0+16321] =8'bxxxxxxxx;
           rom[ 0+16322] =8'bxxxxxxxx;
           rom[ 0+16323] =8'bxxxxxxxx;
           rom[ 0+16324] =8'bxxxxxxxx;
           rom[ 0+16325] =8'bxxxxxxxx;
           rom[ 0+16326] =8'bxxxxxxxx;
           rom[ 0+16327] =8'bxxxxxxxx;
           rom[ 0+16328] =8'bxxxxxxxx;
           rom[ 0+16329] =8'bxxxxxxxx;
           rom[ 0+16330] =8'bxxxxxxxx;
           rom[ 0+16331] =8'bxxxxxxxx;
           rom[ 0+16332] =8'bxxxxxxxx;
           rom[ 0+16333] =8'bxxxxxxxx;
           rom[ 0+16334] =8'bxxxxxxxx;
           rom[ 0+16335] =8'bxxxxxxxx;
           rom[ 0+16336] =8'bxxxxxxxx;
           rom[ 0+16337] =8'bxxxxxxxx;
           rom[ 0+16338] =8'bxxxxxxxx;
           rom[ 0+16339] =8'bxxxxxxxx;
           rom[ 0+16340] =8'bxxxxxxxx;
           rom[ 0+16341] =8'bxxxxxxxx;
           rom[ 0+16342] =8'bxxxxxxxx;
           rom[ 0+16343] =8'bxxxxxxxx;
           rom[ 0+16344] =8'bxxxxxxxx;
           rom[ 0+16345] =8'bxxxxxxxx;
           rom[ 0+16346] =8'bxxxxxxxx;
           rom[ 0+16347] =8'bxxxxxxxx;
           rom[ 0+16348] =8'bxxxxxxxx;
           rom[ 0+16349] =8'bxxxxxxxx;
           rom[ 0+16350] =8'bxxxxxxxx;
           rom[ 0+16351] =8'bxxxxxxxx;
           rom[ 0+16352] =8'bxxxxxxxx;
           rom[ 0+16353] =8'bxxxxxxxx;
           rom[ 0+16354] =8'bxxxxxxxx;
           rom[ 0+16355] =8'bxxxxxxxx;
           rom[ 0+16356] =8'bxxxxxxxx;
           rom[ 0+16357] =8'bxxxxxxxx;
           rom[ 0+16358] =8'bxxxxxxxx;
           rom[ 0+16359] =8'bxxxxxxxx;
           rom[ 0+16360] =8'bxxxxxxxx;
           rom[ 0+16361] =8'bxxxxxxxx;
           rom[ 0+16362] =8'bxxxxxxxx;
           rom[ 0+16363] =8'bxxxxxxxx;
           rom[ 0+16364] =8'bxxxxxxxx;
           rom[ 0+16365] =8'bxxxxxxxx;
           rom[ 0+16366] =8'bxxxxxxxx;
           rom[ 0+16367] =8'bxxxxxxxx;
           rom[ 0+16368] =8'bxxxxxxxx;
           rom[ 0+16369] =8'bxxxxxxxx;
           rom[ 0+16370] =8'bxxxxxxxx;
           rom[ 0+16371] =8'bxxxxxxxx;
           rom[ 0+16372] =8'bxxxxxxxx;
           rom[ 0+16373] =8'bxxxxxxxx;
           rom[ 0+16374] =8'bxxxxxxxx;
           rom[ 0+16375] =8'bxxxxxxxx;
           rom[ 0+16376] =8'bxxxxxxxx;
           rom[ 0+16377] =8'bxxxxxxxx;
           rom[ 0+16378] =8'bxxxxxxxx;
           rom[ 0+16379] =8'bxxxxxxxx;
           rom[ 0+16380] =8'bxxxxxxxx;
           rom[ 0+16381] =8'bxxxxxxxx;
           rom[ 0+16382] =8'bxxxxxxxx;
           rom[ 0+16383] =8'bxxxxxxxx;

   end//initial

   
    wire [7:0] d;


    
   assign {d}=((ce_n === 1'b0) & (oe_n === 1'b0)) ? 
                  rom[$unsigned(a)]
               :  {(7-0+1- 0){1'bz}};
    

endmodule
//
// Asynchronous serial generator with input from binary file
//
// Version : 0146
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//


module  asyncstim ( txd );
    parameter filename=0;
    parameter  [31:0]  baud =0;
    parameter interchardelay=0* `ns;
    parameter  [31:0]  bits =8;
    parameter  parity =1'b0;
    parameter  p_odd_even_n =1'b0;
    
    output txd;


integer Process1__infile;
   initial begin
           Process1__infile=$fopen(filename,"r+");
   end
reg [0:0] Process2__inited = 1'b0;
reg [7:0] Process3__chartmp;
    integer Process4__inttmp;
    reg [(bits - 1):0] tx_shiftreg;
    integer tx_bit_cnt = 0;
reg [0:0] partmp;
    reg txd;


    
   always begin
       begin 
           if (~ (Process2__inited)) 
               begin 
                   Process2__inited = 1'b1;
                   txd <= 1'b1;
               end

           #((1000000000* `ns / baud));
           tx_bit_cnt <= (tx_bit_cnt + 1);
           case (tx_bit_cnt)
               0 : begin 
                       txd <= 1'b1;
                       #(interchardelay);
                   end
               1 : begin 
                       
                       Process4__inttmp = Process3__chartmp;
                       tx_shiftreg[(bits - 1):0] <= $conv_unsigned(Process4__inttmp,bits);
                       txd <= 1'b0;
                       partmp <= p_odd_even_n;
                   end
               default : 
                   begin 
                       txd <= tx_shiftreg[0];
                       partmp <= (partmp ^ (tx_shiftreg[0] === 1'b1));
                       tx_shiftreg[(bits - 2):0] <= tx_shiftreg[(bits - 1):1];
                       if ((((tx_bit_cnt === (bits + 1)) & ~ (parity)) | ((tx_bit_cnt === (bits + 2)) & parity))) 
                               tx_bit_cnt <= 0;

                       if ((parity & (tx_bit_cnt === (bits + 2)))) 
                           begin 
                                   if (partmp) 
                                           txd <= 1'b1;
                                   else 
                                           txd <= 1'b0;

                                   
                           end 

                       
                   end
           endcase
       end
   end
                           
                       
endmodule
//
// Asynchronous serial input with binary file log
//
// Version : 0146
//
// Copyright (c) 2001 Daniel Wallner (jesus@opencores.org)
//
// All rights reserved
//
// Redistribution and use in source and synthezised forms, with or without
// modification, are permitted provided that the following conditions are met:
//
// Redistributions of source code must retain the above copyright notice,
// this list of conditions and the following disclaimer.
//
// Redistributions in synthesized form must reproduce the above copyright
// notice, this list of conditions and the following disclaimer in the
// documentation and/or other materials provided with the distribution.
//
// Neither the name of the author nor the names of other contributors may
// be used to endorse or promote products derived from this software without
// specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
// LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
// CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
// SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
// INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
// CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
// ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
// POSSIBILITY OF SUCH DAMAGE.
//
// Please report bugs to the author, but before you do so, please
// make sure that this is not a derivative work and that
// you have the latest version of this file.
//
// The latest version of this file can be found at:
//	http://www.opencores.org/cvsweb.shtml/t51/
//
// Limitations :
//
// File history :
//


module  asynclog ( rxd );
    parameter filename=0;
    parameter  [31:0]  baud =0;
    parameter  [31:0]  bits =8;
    parameter  parity =1'b0;
    parameter  p_odd_even_n =1'b0;
    
    input rxd;


integer Process1__outfile;
   initial begin
           Process1__outfile=$fopen(filename,"w");
   end
    reg baud16;
   initial baud16 = 1'b0;
    reg [3:0] bit_phase = 4'b0000;
    reg [(bits - 1):0] rx_shiftreg = {((bits - 1)-0+1- 0){1'b0}};
    integer rx_bit_cnt = 0;
reg [0:0] partmp;


       
   always #(((1000000000* `ns / 32) / baud)) {baud16}<=~ (baud16);
   
       
   always @ (posedge baud16 ) begin
               begin 
                   begin 
                       if (((rx_bit_cnt === 0) & ((rxd === 1'b1) | (bit_phase === 4'b0111)))) 
                           bit_phase <= 4'b0000;
                           
                       else 
                           bit_phase <= (bit_phase + 1);
                           
                       
                       if ((rx_bit_cnt === 0)) 
                           begin 
                               begin 
                                   if ((bit_phase === 4'b0111)) 
                                           rx_bit_cnt <= (rx_bit_cnt + 1);

                                   partmp <= 1'b0;
                               end
                           end 
                       else if ((bit_phase === 4'b1111)) 
                           begin 
                               rx_bit_cnt <= (rx_bit_cnt + 1);
                               if ((((rx_bit_cnt === (bits + 1)) & ~ (parity)) | ((rx_bit_cnt === (bits + 2)) & parity))) 
                                   begin 
                                       rx_bit_cnt <= 0;
                                       begin 
                                            if (!((rxd === 1'b1)) ) $display(" Framing error time=%d",$time);
                                       end 
                                       $fdisplay(Process1__outfile,"%b ",to_char__0(rx_shiftreg[7:0]));
                                       
                                   end
                                   
                               else if (((rx_bit_cnt === (bits + 1)) & parity)) 
                                   begin 
                                        if (!((partmp ^ ((rxd === 1'b1) === p_odd_even_n))) ) $display(" Parity error time=%d",$time);
                                   end 
                                   
                               else 
                                   begin 
                                       partmp <= (partmp ^ (rxd === 1'b1));
                                       rx_shiftreg[(bits - 2):0] <= rx_shiftreg[(bits - 1):1];
                                       rx_shiftreg[(bits - 1)] <= rxd;
                                   end
                                   
                               
                               
                           end
                           
                       
                       
                   end
                   
               end 
           
   end //always
                                           
                                           function [7:0] to_char__0;
                                               input [7:0]  byte ;
                                               begin : Function
                                                       begin 
                                                           to_char__0=$unsigned(byte);
                                                           disable Function;
                                                       end
                                               end // Function
                                           endfunction

                                           
                                       
endmodule
// 16 MHz clock
//TAK Jan.23.2004 31.25 ns;


module  testbench; // Null Port List
    

    wire m1_n;
    wire mreq_n;
    wire iorq_n;
    wire rd_n;
    wire wr_n;
    wire rfsh_n;
    wire halt_n;
    reg wait_n;
   initial wait_n = 1'b1;
    reg /* conflict */int_n_=1'bz;
    wire /* conflict */int_n;//Veritak Note: Ignored default expression.
    reg /* conflict */nmi_n_=1'bz;
    wire /* conflict */nmi_n;//Veritak Note: Ignored default expression.
    reg reset_n;
    reg busrq_n;
   initial busrq_n = 1'b1;
    wire busak_n;
    reg clk_n;
   initial clk_n = 1'b0;
    wire [15:0] a;
    wire [7:0] d;
    wire [7:0] uart_d;
    wire baudout;
    wire txd;
    wire rxd;
    reg cts;
   initial cts = 1'b0;
    reg dsr;
   initial dsr = 1'b0;
    reg ri;
   initial ri = 1'b1;
    reg dcd;
   initial dcd = 1'b0;
    wire iowr_n;
    wire romcs_n;
    wire ramcs_n;
    wire uartcs_n;

       
       initial begin 
                   {reset_n}<=1'b0;
        #(1* `us) {reset_n}<=1'b1;
       end//end initial
   
   always #(10* `ns) {clk_n}<=~ (clk_n);
   
   assign {iowr_n}=(wr_n | iorq_n);
   
   assign {romcs_n}=(a[15] | mreq_n);
   
   assign {ramcs_n}=(~ (a[15]) | mreq_n);
   
   assign {uartcs_n}=((iorq_n === 1'b0) & (a[7:3] === 5'b00000)) ? 
                         1'b0
                      :  1'b1;
   
   assign {nmi_n}=1'b1;
   
   assign {int_n}=1'b1;
   
   asynclog  #("RX_Log.txt",1000000,8,1'b0,1'b0) al(.rxd(txd));
   //Parameter Order: filename,baud,bits,parity,p_odd_even_n 

   t80a  #(/*open */) u0(.reset_n(reset_n), .clk_n(clk_n), .wait_n(wait_n), .int_n(int_n), .nmi_n(nmi_n), .busrq_n(busrq_n), .m1_n(m1_n), .mreq_n(mreq_n), .iorq_n(iorq_n), .rd_n(rd_n), .wr_n(wr_n), .rfsh_n(rfsh_n), .halt_n(halt_n), .busak_n(busak_n), .a(a), .d(d));
   //Parameter Order: mode 

   rom80 u1(.ce_n(romcs_n), .oe_n(rd_n), .a(a[14:0]), .d(d));
   
   sram  #(15,/*open */) u2(.ce_n(ramcs_n), .oe_n(rd_n), .we_n(wr_n), .a(a[14:0]), .d(d));
   //Parameter Order: addrwidth,datawidth 

   assign {d}=((uartcs_n === 1'b0) & (rd_n === 1'b0)) ? 
                  uart_d
               :  8'bZZZZZZZZ;
   
   t16450 u3(.mr_n(reset_n), .xin(clk_n), .rclk(baudout), .cs_n(uartcs_n), .rd_n(rd_n), .wr_n(iowr_n), .a(a[2:0]), .d_in(d), .d_out(uart_d), .sin(rxd), .cts_n(cts), .dsr_n(dsr), .ri_n(ri), .dcd_n(dcd), .sout(txd), .rts_n(/*open */), .dtr_n(/*open */), .out1_n(/*open */), .out2_n(/*open */), .baudout(baudout), .intr(/*open */));
           assign int_n = int_n_;//Added for Conflict reslover.
    assign nmi_n = nmi_n_;//Added for Conflict reslover.
       
   
endmodule
